#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2634
#define LARGE_STATE_COUNT 431
#define SYMBOL_COUNT 322
#define ALIAS_COUNT 16
#define TOKEN_COUNT 145
#define EXTERNAL_TOKEN_COUNT 83
#define FIELD_COUNT 21
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 60

enum ts_symbol_identifiers {
  anon_sym_LBRACK = 1,
  anon_sym_x = 2,
  anon_sym_X = 3,
  anon_sym_RBRACK = 4,
  anon_sym_SPACE = 5,
  aux_sym__table_cell_alignment_token1 = 6,
  anon_sym_NULL = 7,
  anon_sym_RBRACK_COLON = 8,
  anon_sym_EQ = 9,
  sym_language = 10,
  aux_sym__line_token1 = 11,
  anon_sym_COLON = 12,
  sym_link_destination = 13,
  anon_sym_RBRACE = 14,
  anon_sym_DOT = 15,
  sym_identifier = 16,
  anon_sym_DQUOTE = 17,
  aux_sym_value_token1 = 18,
  aux_sym_value_token2 = 19,
  sym__whitespace = 20,
  sym__whitespace1 = 21,
  sym_quotation_marks = 22,
  sym_ellipsis = 23,
  sym_em_dash = 24,
  sym_en_dash = 25,
  sym_backslash_escape = 26,
  anon_sym_LT = 27,
  aux_sym_autolink_token1 = 28,
  anon_sym_GT = 29,
  sym_symbol = 30,
  anon_sym_LBRACE_ = 31,
  anon_sym__ = 32,
  anon_sym_LBRACE_STAR = 33,
  anon_sym_STAR = 34,
  anon_sym_LBRACE_CARET = 35,
  anon_sym_CARET = 36,
  anon_sym_LBRACE_TILDE = 37,
  anon_sym_TILDE = 38,
  anon_sym_LBRACE_EQ = 39,
  anon_sym_LBRACE_PLUS = 40,
  anon_sym_LBRACE_DASH = 41,
  anon_sym_LBRACK_CARET = 42,
  sym__id = 43,
  anon_sym_LBRACK_RBRACK = 44,
  anon_sym_BANG_LBRACK = 45,
  anon_sym_LBRACK_RBRACK2 = 46,
  anon_sym_LBRACE = 47,
  anon_sym_RBRACK2 = 48,
  aux_sym__inline_link_url_token1 = 49,
  anon_sym_LPAREN = 50,
  anon_sym_PERCENT = 51,
  aux_sym__comment_token1 = 52,
  anon_sym_LBRACE_EQ2 = 53,
  anon_sym_DOLLAR = 54,
  anon_sym_TODO = 55,
  anon_sym_WIP = 56,
  anon_sym_NOTE = 57,
  anon_sym_INFO = 58,
  anon_sym_XXX = 59,
  sym_fixme = 60,
  aux_sym__text_token1 = 61,
  sym__ignored = 62,
  sym__block_close = 63,
  sym__eof_or_newline = 64,
  sym__newline = 65,
  sym__newline_inline = 66,
  sym__non_whitespace_check = 67,
  sym_hard_line_break = 68,
  sym_frontmatter_marker = 69,
  sym__heading_begin = 70,
  sym__heading_continuation = 71,
  sym__div_begin = 72,
  sym__div_end = 73,
  sym__code_block_begin = 74,
  sym__code_block_end = 75,
  sym_list_marker_dash = 76,
  sym_list_marker_star = 77,
  sym_list_marker_plus = 78,
  sym__list_marker_task_begin = 79,
  sym_list_marker_definition = 80,
  sym_list_marker_decimal_period = 81,
  sym_list_marker_lower_alpha_period = 82,
  sym_list_marker_upper_alpha_period = 83,
  sym_list_marker_lower_roman_period = 84,
  sym_list_marker_upper_roman_period = 85,
  sym_list_marker_decimal_paren = 86,
  sym_list_marker_lower_alpha_paren = 87,
  sym_list_marker_upper_alpha_paren = 88,
  sym_list_marker_lower_roman_paren = 89,
  sym_list_marker_upper_roman_paren = 90,
  sym_list_marker_decimal_parens = 91,
  sym_list_marker_lower_alpha_parens = 92,
  sym_list_marker_upper_alpha_parens = 93,
  sym_list_marker_lower_roman_parens = 94,
  sym_list_marker_upper_roman_parens = 95,
  sym__list_item_continuation = 96,
  sym__list_item_end = 97,
  sym__indented_content_spacer = 98,
  sym__close_paragraph = 99,
  sym__block_quote_begin = 100,
  sym__block_quote_continuation = 101,
  sym__thematic_break_dash = 102,
  sym__thematic_break_star = 103,
  sym__footnote_mark_begin = 104,
  sym__footnote_continuation = 105,
  sym__footnote_end = 106,
  sym__link_ref_def_mark_begin = 107,
  sym__link_ref_def_label_end = 108,
  sym__table_header_begin = 109,
  sym__table_separator_begin = 110,
  sym__table_row_begin = 111,
  sym__table_row_end_newline = 112,
  sym__table_cell_end = 113,
  sym__table_caption_begin = 114,
  sym__table_caption_end = 115,
  sym__block_attribute_begin = 116,
  sym__comment_end_marker = 117,
  sym__comment_close = 118,
  sym__inline_comment_begin = 119,
  sym__verbatim_begin = 120,
  sym__verbatim_end = 121,
  sym__verbatim_content = 122,
  sym__emphasis_mark_begin = 123,
  sym_emphasis_end = 124,
  sym__strong_mark_begin = 125,
  sym_strong_end = 126,
  sym__superscript_mark_begin = 127,
  sym_superscript_end = 128,
  sym__subscript_mark_begin = 129,
  sym_subscript_end = 130,
  sym__highlighted_mark_begin = 131,
  sym_highlighted_end = 132,
  sym__insert_mark_begin = 133,
  sym_insert_end = 134,
  sym__delete_mark_begin = 135,
  sym_delete_end = 136,
  sym__parens_span_mark_begin = 137,
  sym__parens_span_end = 138,
  sym__curly_bracket_span_mark_begin = 139,
  sym__curly_bracket_span_end = 140,
  sym__square_bracket_span_mark_begin = 141,
  sym__square_bracket_span_end = 142,
  sym__in_fallback = 143,
  sym__error = 144,
  sym_document = 145,
  sym_frontmatter = 146,
  sym_frontmatter_content = 147,
  sym__block_with_section = 148,
  sym__block_with_heading = 149,
  sym__block_element = 150,
  sym_section = 151,
  sym_heading = 152,
  sym__heading_content = 153,
  sym_list = 154,
  sym__list_dash = 155,
  sym__list_item_dash = 156,
  sym__list_plus = 157,
  sym__list_item_plus = 158,
  sym__list_star = 159,
  sym__list_item_star = 160,
  sym__list_task = 161,
  sym__list_item_task = 162,
  sym_list_marker_task = 163,
  sym_checked = 164,
  sym_unchecked = 165,
  sym__list_definition = 166,
  sym__list_item_definition = 167,
  sym__list_decimal_period = 168,
  sym__list_item_decimal_period = 169,
  sym__list_decimal_paren = 170,
  sym__list_item_decimal_paren = 171,
  sym__list_decimal_parens = 172,
  sym__list_item_decimal_parens = 173,
  sym__list_lower_alpha_period = 174,
  sym__list_item_lower_alpha_period = 175,
  sym__list_lower_alpha_paren = 176,
  sym__list_item_lower_alpha_paren = 177,
  sym__list_lower_alpha_parens = 178,
  sym__list_item_lower_alpha_parens = 179,
  sym__list_upper_alpha_period = 180,
  sym__list_item_upper_alpha_period = 181,
  sym__list_upper_alpha_paren = 182,
  sym__list_item_upper_alpha_paren = 183,
  sym__list_upper_alpha_parens = 184,
  sym__list_item_upper_alpha_parens = 185,
  sym__list_lower_roman_period = 186,
  sym__list_item_lower_roman_period = 187,
  sym__list_lower_roman_paren = 188,
  sym__list_item_lower_roman_paren = 189,
  sym__list_lower_roman_parens = 190,
  sym__list_item_lower_roman_parens = 191,
  sym__list_upper_roman_period = 192,
  sym__list_item_upper_roman_period = 193,
  sym__list_upper_roman_paren = 194,
  sym__list_item_upper_roman_paren = 195,
  sym__list_upper_roman_parens = 196,
  sym__list_item_upper_roman_parens = 197,
  sym_list_item_content = 198,
  sym_table = 199,
  sym__table_row = 200,
  sym_table_header = 201,
  sym_table_separator = 202,
  sym_table_row = 203,
  sym__table_cell = 204,
  sym__table_cell_alignment = 205,
  sym_table_caption = 206,
  sym_footnote = 207,
  sym_footnote_content = 208,
  sym_div = 209,
  sym__div_marker_begin = 210,
  sym_class_name = 211,
  sym_code_block = 212,
  sym_raw_block = 213,
  sym_raw_block_info = 214,
  sym_code = 215,
  sym__line = 216,
  sym_thematic_break = 217,
  sym_block_quote = 218,
  sym__block_quote_content = 219,
  sym__block_quote_prefix = 220,
  sym_link_reference_definition = 221,
  sym_block_attribute = 222,
  sym_class = 223,
  sym_key_value = 224,
  sym_key = 225,
  sym_value = 226,
  sym__paragraph = 227,
  sym__paragraph_content = 228,
  sym__inline = 229,
  sym__inline_without_trailing_space = 230,
  sym__inline_element = 231,
  sym__inline_line = 232,
  sym__smart_punctuation = 233,
  sym_autolink = 234,
  sym_emphasis = 235,
  sym_emphasis_begin = 236,
  sym_strong = 237,
  sym_strong_begin = 238,
  sym_superscript = 239,
  sym_superscript_begin = 240,
  sym_subscript = 241,
  sym_subscript_begin = 242,
  sym_highlighted = 243,
  sym_highlighted_begin = 244,
  sym_insert = 245,
  sym_insert_begin = 246,
  sym_delete = 247,
  sym_delete_begin = 248,
  sym_footnote_reference = 249,
  sym_footnote_marker_begin = 250,
  sym_reference_label = 251,
  sym__image = 252,
  sym_full_reference_image = 253,
  sym_collapsed_reference_image = 254,
  sym_inline_image = 255,
  sym_image_description = 256,
  sym__image_description_begin = 257,
  sym__link = 258,
  sym_full_reference_link = 259,
  sym_collapsed_reference_link = 260,
  sym_inline_link = 261,
  sym_link_text = 262,
  sym_span = 263,
  sym__bracketed_text_begin = 264,
  sym_inline_attribute = 265,
  sym__curly_bracket_span_begin = 266,
  sym__link_label = 267,
  sym_inline_link_destination = 268,
  aux_sym__inline_link_url = 269,
  sym__parens_span_begin = 270,
  sym__comment = 271,
  sym_inline_comment = 272,
  sym_raw_inline = 273,
  sym_raw_inline_attribute = 274,
  sym_math = 275,
  sym_verbatim = 276,
  sym__todo_highlights = 277,
  sym_todo = 278,
  sym_note = 279,
  sym__symbol_fallback = 280,
  sym__curly_bracket_span_fallback = 281,
  aux_sym__text = 282,
  aux_sym_document_repeat1 = 283,
  aux_sym_frontmatter_content_repeat1 = 284,
  aux_sym__heading_content_repeat1 = 285,
  aux_sym__list_dash_repeat1 = 286,
  aux_sym__list_plus_repeat1 = 287,
  aux_sym__list_star_repeat1 = 288,
  aux_sym__list_task_repeat1 = 289,
  aux_sym__list_definition_repeat1 = 290,
  aux_sym__list_item_definition_repeat1 = 291,
  aux_sym__list_decimal_period_repeat1 = 292,
  aux_sym__list_decimal_paren_repeat1 = 293,
  aux_sym__list_decimal_parens_repeat1 = 294,
  aux_sym__list_lower_alpha_period_repeat1 = 295,
  aux_sym__list_lower_alpha_paren_repeat1 = 296,
  aux_sym__list_lower_alpha_parens_repeat1 = 297,
  aux_sym__list_upper_alpha_period_repeat1 = 298,
  aux_sym__list_upper_alpha_paren_repeat1 = 299,
  aux_sym__list_upper_alpha_parens_repeat1 = 300,
  aux_sym__list_lower_roman_period_repeat1 = 301,
  aux_sym__list_lower_roman_paren_repeat1 = 302,
  aux_sym__list_lower_roman_parens_repeat1 = 303,
  aux_sym__list_upper_roman_period_repeat1 = 304,
  aux_sym__list_upper_roman_paren_repeat1 = 305,
  aux_sym__list_upper_roman_parens_repeat1 = 306,
  aux_sym_list_item_content_repeat1 = 307,
  aux_sym_table_repeat1 = 308,
  aux_sym_table_header_repeat1 = 309,
  aux_sym_table_separator_repeat1 = 310,
  aux_sym_table_caption_repeat1 = 311,
  aux_sym_footnote_content_repeat1 = 312,
  aux_sym_div_repeat1 = 313,
  aux_sym_code_repeat1 = 314,
  aux_sym__block_quote_content_repeat1 = 315,
  aux_sym__block_quote_prefix_repeat1 = 316,
  aux_sym_block_attribute_repeat1 = 317,
  aux_sym__paragraph_content_repeat1 = 318,
  aux_sym__inline_repeat1 = 319,
  aux_sym_inline_attribute_repeat1 = 320,
  aux_sym__comment_repeat1 = 321,
  alias_sym_args = 322,
  anon_alias_sym_class = 323,
  alias_sym_comment = 324,
  alias_sym_definition = 325,
  alias_sym_language_marker = 326,
  alias_sym_link_label = 327,
  alias_sym_math_marker = 328,
  alias_sym_math_marker_begin = 329,
  alias_sym_math_marker_end = 330,
  alias_sym_paragraph = 331,
  alias_sym_raw_block_marker_begin = 332,
  alias_sym_raw_block_marker_end = 333,
  alias_sym_section_content = 334,
  alias_sym_table_cell = 335,
  alias_sym_verbatim_marker_begin = 336,
  alias_sym_verbatim_marker_end = 337,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_LBRACK] = "[",
  [anon_sym_x] = "x",
  [anon_sym_X] = "X",
  [anon_sym_RBRACK] = "]",
  [anon_sym_SPACE] = " ",
  [aux_sym__table_cell_alignment_token1] = "table_cell_alignment",
  [anon_sym_NULL] = "\0",
  [anon_sym_RBRACK_COLON] = "footnote_marker_end",
  [anon_sym_EQ] = "=",
  [sym_language] = "language",
  [aux_sym__line_token1] = "_line_token1",
  [anon_sym_COLON] = ":",
  [sym_link_destination] = "link_destination",
  [anon_sym_RBRACE] = "}",
  [anon_sym_DOT] = ".",
  [sym_identifier] = "identifier",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_value_token1] = "value_token1",
  [aux_sym_value_token2] = "value_token2",
  [sym__whitespace] = "_whitespace",
  [sym__whitespace1] = "_whitespace1",
  [sym_quotation_marks] = "quotation_marks",
  [sym_ellipsis] = "ellipsis",
  [sym_em_dash] = "em_dash",
  [sym_en_dash] = "en_dash",
  [sym_backslash_escape] = "backslash_escape",
  [anon_sym_LT] = "<",
  [aux_sym_autolink_token1] = "autolink_token1",
  [anon_sym_GT] = ">",
  [sym_symbol] = "symbol",
  [anon_sym_LBRACE_] = "{_",
  [anon_sym__] = "_",
  [anon_sym_LBRACE_STAR] = "{*",
  [anon_sym_STAR] = "*",
  [anon_sym_LBRACE_CARET] = "{^",
  [anon_sym_CARET] = "^",
  [anon_sym_LBRACE_TILDE] = "{~",
  [anon_sym_TILDE] = "~",
  [anon_sym_LBRACE_EQ] = "{=",
  [anon_sym_LBRACE_PLUS] = "{+",
  [anon_sym_LBRACE_DASH] = "{-",
  [anon_sym_LBRACK_CARET] = "[^",
  [sym__id] = "_id",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_BANG_LBRACK] = "![",
  [anon_sym_LBRACK_RBRACK2] = "[]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACK2] = "]",
  [aux_sym__inline_link_url_token1] = "_inline_link_url_token1",
  [anon_sym_LPAREN] = "(",
  [anon_sym_PERCENT] = "%",
  [aux_sym__comment_token1] = "_comment_token1",
  [anon_sym_LBRACE_EQ2] = "{=",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_TODO] = "TODO",
  [anon_sym_WIP] = "WIP",
  [anon_sym_NOTE] = "NOTE",
  [anon_sym_INFO] = "INFO",
  [anon_sym_XXX] = "XXX",
  [sym_fixme] = "fixme",
  [aux_sym__text_token1] = "_text_token1",
  [sym__ignored] = "_ignored",
  [sym__block_close] = "_block_close",
  [sym__eof_or_newline] = "_eof_or_newline",
  [sym__newline] = "_newline",
  [sym__newline_inline] = "_newline_inline",
  [sym__non_whitespace_check] = "_non_whitespace_check",
  [sym_hard_line_break] = "hard_line_break",
  [sym_frontmatter_marker] = "frontmatter_marker",
  [sym__heading_begin] = "marker",
  [sym__heading_continuation] = "marker",
  [sym__div_begin] = "div_marker_begin",
  [sym__div_end] = "div_marker_end",
  [sym__code_block_begin] = "code_block_marker_begin",
  [sym__code_block_end] = "code_block_marker_end",
  [sym_list_marker_dash] = "list_marker_dash",
  [sym_list_marker_star] = "list_marker_star",
  [sym_list_marker_plus] = "list_marker_plus",
  [sym__list_marker_task_begin] = "_list_marker_task_begin",
  [sym_list_marker_definition] = "list_marker_definition",
  [sym_list_marker_decimal_period] = "list_marker_decimal_period",
  [sym_list_marker_lower_alpha_period] = "list_marker_lower_alpha_period",
  [sym_list_marker_upper_alpha_period] = "list_marker_upper_alpha_period",
  [sym_list_marker_lower_roman_period] = "list_marker_lower_roman_period",
  [sym_list_marker_upper_roman_period] = "list_marker_upper_roman_period",
  [sym_list_marker_decimal_paren] = "list_marker_decimal_paren",
  [sym_list_marker_lower_alpha_paren] = "list_marker_lower_alpha_paren",
  [sym_list_marker_upper_alpha_paren] = "list_marker_upper_alpha_paren",
  [sym_list_marker_lower_roman_paren] = "list_marker_lower_roman_paren",
  [sym_list_marker_upper_roman_paren] = "list_marker_upper_roman_paren",
  [sym_list_marker_decimal_parens] = "list_marker_decimal_parens",
  [sym_list_marker_lower_alpha_parens] = "list_marker_lower_alpha_parens",
  [sym_list_marker_upper_alpha_parens] = "list_marker_upper_alpha_parens",
  [sym_list_marker_lower_roman_parens] = "list_marker_lower_roman_parens",
  [sym_list_marker_upper_roman_parens] = "list_marker_upper_roman_parens",
  [sym__list_item_continuation] = "_list_item_continuation",
  [sym__list_item_end] = "_list_item_end",
  [sym__indented_content_spacer] = "_indented_content_spacer",
  [sym__close_paragraph] = "_close_paragraph",
  [sym__block_quote_begin] = "block_quote_marker",
  [sym__block_quote_continuation] = "_block_quote_continuation",
  [sym__thematic_break_dash] = "_thematic_break_dash",
  [sym__thematic_break_star] = "_thematic_break_star",
  [sym__footnote_mark_begin] = "_footnote_mark_begin",
  [sym__footnote_continuation] = "_footnote_continuation",
  [sym__footnote_end] = "_footnote_end",
  [sym__link_ref_def_mark_begin] = "_link_ref_def_mark_begin",
  [sym__link_ref_def_label_end] = "_link_ref_def_label_end",
  [sym__table_header_begin] = "|",
  [sym__table_separator_begin] = "|",
  [sym__table_row_begin] = "|",
  [sym__table_row_end_newline] = "_table_row_end_newline",
  [sym__table_cell_end] = "|",
  [sym__table_caption_begin] = "marker",
  [sym__table_caption_end] = "_table_caption_end",
  [sym__block_attribute_begin] = "{",
  [sym__comment_end_marker] = "%",
  [sym__comment_close] = "_comment_close",
  [sym__inline_comment_begin] = "_inline_comment_begin",
  [sym__verbatim_begin] = "raw_inline_marker_begin",
  [sym__verbatim_end] = "raw_inline_marker_end",
  [sym__verbatim_content] = "content",
  [sym__emphasis_mark_begin] = "_emphasis_mark_begin",
  [sym_emphasis_end] = "emphasis_end",
  [sym__strong_mark_begin] = "_strong_mark_begin",
  [sym_strong_end] = "strong_end",
  [sym__superscript_mark_begin] = "_superscript_mark_begin",
  [sym_superscript_end] = "superscript_end",
  [sym__subscript_mark_begin] = "_subscript_mark_begin",
  [sym_subscript_end] = "subscript_end",
  [sym__highlighted_mark_begin] = "_highlighted_mark_begin",
  [sym_highlighted_end] = "highlighted_end",
  [sym__insert_mark_begin] = "_insert_mark_begin",
  [sym_insert_end] = "insert_end",
  [sym__delete_mark_begin] = "_delete_mark_begin",
  [sym_delete_end] = "delete_end",
  [sym__parens_span_mark_begin] = "_parens_span_mark_begin",
  [sym__parens_span_end] = ")",
  [sym__curly_bracket_span_mark_begin] = "_curly_bracket_span_mark_begin",
  [sym__curly_bracket_span_end] = "}",
  [sym__square_bracket_span_mark_begin] = "_square_bracket_span_mark_begin",
  [sym__square_bracket_span_end] = "]",
  [sym__in_fallback] = "_in_fallback",
  [sym__error] = "_error",
  [sym_document] = "document",
  [sym_frontmatter] = "frontmatter",
  [sym_frontmatter_content] = "frontmatter_content",
  [sym__block_with_section] = "_block_with_section",
  [sym__block_with_heading] = "_block_with_heading",
  [sym__block_element] = "_block_element",
  [sym_section] = "section",
  [sym_heading] = "heading",
  [sym__heading_content] = "content",
  [sym_list] = "list",
  [sym__list_dash] = "_list_dash",
  [sym__list_item_dash] = "list_item",
  [sym__list_plus] = "_list_plus",
  [sym__list_item_plus] = "list_item",
  [sym__list_star] = "_list_star",
  [sym__list_item_star] = "list_item",
  [sym__list_task] = "_list_task",
  [sym__list_item_task] = "list_item",
  [sym_list_marker_task] = "list_marker_task",
  [sym_checked] = "checked",
  [sym_unchecked] = "unchecked",
  [sym__list_definition] = "_list_definition",
  [sym__list_item_definition] = "list_item",
  [sym__list_decimal_period] = "_list_decimal_period",
  [sym__list_item_decimal_period] = "list_item",
  [sym__list_decimal_paren] = "_list_decimal_paren",
  [sym__list_item_decimal_paren] = "list_item",
  [sym__list_decimal_parens] = "_list_decimal_parens",
  [sym__list_item_decimal_parens] = "list_item",
  [sym__list_lower_alpha_period] = "_list_lower_alpha_period",
  [sym__list_item_lower_alpha_period] = "list_item",
  [sym__list_lower_alpha_paren] = "_list_lower_alpha_paren",
  [sym__list_item_lower_alpha_paren] = "list_item",
  [sym__list_lower_alpha_parens] = "_list_lower_alpha_parens",
  [sym__list_item_lower_alpha_parens] = "list_item",
  [sym__list_upper_alpha_period] = "_list_upper_alpha_period",
  [sym__list_item_upper_alpha_period] = "list_item",
  [sym__list_upper_alpha_paren] = "_list_upper_alpha_paren",
  [sym__list_item_upper_alpha_paren] = "list_item",
  [sym__list_upper_alpha_parens] = "_list_upper_alpha_parens",
  [sym__list_item_upper_alpha_parens] = "list_item",
  [sym__list_lower_roman_period] = "_list_lower_roman_period",
  [sym__list_item_lower_roman_period] = "list_item",
  [sym__list_lower_roman_paren] = "_list_lower_roman_paren",
  [sym__list_item_lower_roman_paren] = "list_item",
  [sym__list_lower_roman_parens] = "_list_lower_roman_parens",
  [sym__list_item_lower_roman_parens] = "list_item",
  [sym__list_upper_roman_period] = "_list_upper_roman_period",
  [sym__list_item_upper_roman_period] = "list_item",
  [sym__list_upper_roman_paren] = "_list_upper_roman_paren",
  [sym__list_item_upper_roman_paren] = "list_item",
  [sym__list_upper_roman_parens] = "_list_upper_roman_parens",
  [sym__list_item_upper_roman_parens] = "list_item",
  [sym_list_item_content] = "list_item_content",
  [sym_table] = "table",
  [sym__table_row] = "_table_row",
  [sym_table_header] = "table_header",
  [sym_table_separator] = "table_separator",
  [sym_table_row] = "table_row",
  [sym__table_cell] = "_table_cell",
  [sym__table_cell_alignment] = "_table_cell_alignment",
  [sym_table_caption] = "table_caption",
  [sym_footnote] = "footnote",
  [sym_footnote_content] = "footnote_content",
  [sym_div] = "div",
  [sym__div_marker_begin] = "_div_marker_begin",
  [sym_class_name] = "class_name",
  [sym_code_block] = "code_block",
  [sym_raw_block] = "raw_block",
  [sym_raw_block_info] = "raw_block_info",
  [sym_code] = "code",
  [sym__line] = "_line",
  [sym_thematic_break] = "thematic_break",
  [sym_block_quote] = "block_quote",
  [sym__block_quote_content] = "content",
  [sym__block_quote_prefix] = "_block_quote_prefix",
  [sym_link_reference_definition] = "link_reference_definition",
  [sym_block_attribute] = "block_attribute",
  [sym_class] = "class",
  [sym_key_value] = "key_value",
  [sym_key] = "key",
  [sym_value] = "value",
  [sym__paragraph] = "_paragraph",
  [sym__paragraph_content] = "term",
  [sym__inline] = "_inline",
  [sym__inline_without_trailing_space] = "content",
  [sym__inline_element] = "_inline_element",
  [sym__inline_line] = "_inline_line",
  [sym__smart_punctuation] = "_smart_punctuation",
  [sym_autolink] = "autolink",
  [sym_emphasis] = "emphasis",
  [sym_emphasis_begin] = "emphasis_begin",
  [sym_strong] = "strong",
  [sym_strong_begin] = "strong_begin",
  [sym_superscript] = "superscript",
  [sym_superscript_begin] = "superscript_begin",
  [sym_subscript] = "subscript",
  [sym_subscript_begin] = "subscript_begin",
  [sym_highlighted] = "highlighted",
  [sym_highlighted_begin] = "highlighted_begin",
  [sym_insert] = "insert",
  [sym_insert_begin] = "insert_begin",
  [sym_delete] = "delete",
  [sym_delete_begin] = "delete_begin",
  [sym_footnote_reference] = "footnote_reference",
  [sym_footnote_marker_begin] = "footnote_marker_begin",
  [sym_reference_label] = "reference_label",
  [sym__image] = "_image",
  [sym_full_reference_image] = "full_reference_image",
  [sym_collapsed_reference_image] = "collapsed_reference_image",
  [sym_inline_image] = "inline_image",
  [sym_image_description] = "image_description",
  [sym__image_description_begin] = "_image_description_begin",
  [sym__link] = "_link",
  [sym_full_reference_link] = "full_reference_link",
  [sym_collapsed_reference_link] = "collapsed_reference_link",
  [sym_inline_link] = "inline_link",
  [sym_link_text] = "link_text",
  [sym_span] = "span",
  [sym__bracketed_text_begin] = "_bracketed_text_begin",
  [sym_inline_attribute] = "inline_attribute",
  [sym__curly_bracket_span_begin] = "_curly_bracket_span_begin",
  [sym__link_label] = "_link_label",
  [sym_inline_link_destination] = "inline_link_destination",
  [aux_sym__inline_link_url] = "_inline_link_url",
  [sym__parens_span_begin] = "_parens_span_begin",
  [sym__comment] = "_comment",
  [sym_inline_comment] = "inline_comment",
  [sym_raw_inline] = "raw_inline",
  [sym_raw_inline_attribute] = "raw_inline_attribute",
  [sym_math] = "math",
  [sym_verbatim] = "verbatim",
  [sym__todo_highlights] = "_todo_highlights",
  [sym_todo] = "todo",
  [sym_note] = "note",
  [sym__symbol_fallback] = "_symbol_fallback",
  [sym__curly_bracket_span_fallback] = "_curly_bracket_span_fallback",
  [aux_sym__text] = "_text",
  [aux_sym_document_repeat1] = "document_repeat1",
  [aux_sym_frontmatter_content_repeat1] = "frontmatter_content_repeat1",
  [aux_sym__heading_content_repeat1] = "_heading_content_repeat1",
  [aux_sym__list_dash_repeat1] = "_list_dash_repeat1",
  [aux_sym__list_plus_repeat1] = "_list_plus_repeat1",
  [aux_sym__list_star_repeat1] = "_list_star_repeat1",
  [aux_sym__list_task_repeat1] = "_list_task_repeat1",
  [aux_sym__list_definition_repeat1] = "_list_definition_repeat1",
  [aux_sym__list_item_definition_repeat1] = "_list_item_definition_repeat1",
  [aux_sym__list_decimal_period_repeat1] = "_list_decimal_period_repeat1",
  [aux_sym__list_decimal_paren_repeat1] = "_list_decimal_paren_repeat1",
  [aux_sym__list_decimal_parens_repeat1] = "_list_decimal_parens_repeat1",
  [aux_sym__list_lower_alpha_period_repeat1] = "_list_lower_alpha_period_repeat1",
  [aux_sym__list_lower_alpha_paren_repeat1] = "_list_lower_alpha_paren_repeat1",
  [aux_sym__list_lower_alpha_parens_repeat1] = "_list_lower_alpha_parens_repeat1",
  [aux_sym__list_upper_alpha_period_repeat1] = "_list_upper_alpha_period_repeat1",
  [aux_sym__list_upper_alpha_paren_repeat1] = "_list_upper_alpha_paren_repeat1",
  [aux_sym__list_upper_alpha_parens_repeat1] = "_list_upper_alpha_parens_repeat1",
  [aux_sym__list_lower_roman_period_repeat1] = "_list_lower_roman_period_repeat1",
  [aux_sym__list_lower_roman_paren_repeat1] = "_list_lower_roman_paren_repeat1",
  [aux_sym__list_lower_roman_parens_repeat1] = "_list_lower_roman_parens_repeat1",
  [aux_sym__list_upper_roman_period_repeat1] = "_list_upper_roman_period_repeat1",
  [aux_sym__list_upper_roman_paren_repeat1] = "_list_upper_roman_paren_repeat1",
  [aux_sym__list_upper_roman_parens_repeat1] = "_list_upper_roman_parens_repeat1",
  [aux_sym_list_item_content_repeat1] = "list_item_content_repeat1",
  [aux_sym_table_repeat1] = "table_repeat1",
  [aux_sym_table_header_repeat1] = "table_header_repeat1",
  [aux_sym_table_separator_repeat1] = "table_separator_repeat1",
  [aux_sym_table_caption_repeat1] = "table_caption_repeat1",
  [aux_sym_footnote_content_repeat1] = "footnote_content_repeat1",
  [aux_sym_div_repeat1] = "div_repeat1",
  [aux_sym_code_repeat1] = "code_repeat1",
  [aux_sym__block_quote_content_repeat1] = "_block_quote_content_repeat1",
  [aux_sym__block_quote_prefix_repeat1] = "_block_quote_prefix_repeat1",
  [aux_sym_block_attribute_repeat1] = "block_attribute_repeat1",
  [aux_sym__paragraph_content_repeat1] = "_paragraph_content_repeat1",
  [aux_sym__inline_repeat1] = "_inline_repeat1",
  [aux_sym_inline_attribute_repeat1] = "inline_attribute_repeat1",
  [aux_sym__comment_repeat1] = "_comment_repeat1",
  [alias_sym_args] = "args",
  [anon_alias_sym_class] = "class",
  [alias_sym_comment] = "comment",
  [alias_sym_definition] = "definition",
  [alias_sym_language_marker] = "language_marker",
  [alias_sym_link_label] = "link_label",
  [alias_sym_math_marker] = "math_marker",
  [alias_sym_math_marker_begin] = "math_marker_begin",
  [alias_sym_math_marker_end] = "math_marker_end",
  [alias_sym_paragraph] = "paragraph",
  [alias_sym_raw_block_marker_begin] = "raw_block_marker_begin",
  [alias_sym_raw_block_marker_end] = "raw_block_marker_end",
  [alias_sym_section_content] = "section_content",
  [alias_sym_table_cell] = "table_cell",
  [alias_sym_verbatim_marker_begin] = "verbatim_marker_begin",
  [alias_sym_verbatim_marker_end] = "verbatim_marker_end",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_x] = anon_sym_x,
  [anon_sym_X] = anon_sym_X,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_SPACE] = anon_sym_SPACE,
  [aux_sym__table_cell_alignment_token1] = aux_sym__table_cell_alignment_token1,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_RBRACK_COLON] = anon_sym_RBRACK_COLON,
  [anon_sym_EQ] = anon_sym_EQ,
  [sym_language] = sym_language,
  [aux_sym__line_token1] = aux_sym__line_token1,
  [anon_sym_COLON] = anon_sym_COLON,
  [sym_link_destination] = sym_link_destination,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_DOT] = anon_sym_DOT,
  [sym_identifier] = sym_identifier,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_value_token1] = aux_sym_value_token1,
  [aux_sym_value_token2] = aux_sym_value_token2,
  [sym__whitespace] = sym__whitespace,
  [sym__whitespace1] = sym__whitespace1,
  [sym_quotation_marks] = sym_quotation_marks,
  [sym_ellipsis] = sym_ellipsis,
  [sym_em_dash] = sym_em_dash,
  [sym_en_dash] = sym_en_dash,
  [sym_backslash_escape] = sym_backslash_escape,
  [anon_sym_LT] = anon_sym_LT,
  [aux_sym_autolink_token1] = aux_sym_autolink_token1,
  [anon_sym_GT] = anon_sym_GT,
  [sym_symbol] = sym_symbol,
  [anon_sym_LBRACE_] = anon_sym_LBRACE_,
  [anon_sym__] = anon_sym__,
  [anon_sym_LBRACE_STAR] = anon_sym_LBRACE_STAR,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_LBRACE_CARET] = anon_sym_LBRACE_CARET,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_LBRACE_TILDE] = anon_sym_LBRACE_TILDE,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_LBRACE_EQ] = anon_sym_LBRACE_EQ,
  [anon_sym_LBRACE_PLUS] = anon_sym_LBRACE_PLUS,
  [anon_sym_LBRACE_DASH] = anon_sym_LBRACE_DASH,
  [anon_sym_LBRACK_CARET] = anon_sym_LBRACK_CARET,
  [sym__id] = sym__id,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_BANG_LBRACK] = anon_sym_BANG_LBRACK,
  [anon_sym_LBRACK_RBRACK2] = anon_sym_LBRACK_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACK2] = anon_sym_RBRACK,
  [aux_sym__inline_link_url_token1] = aux_sym__inline_link_url_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [aux_sym__comment_token1] = aux_sym__comment_token1,
  [anon_sym_LBRACE_EQ2] = anon_sym_LBRACE_EQ,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_TODO] = anon_sym_TODO,
  [anon_sym_WIP] = anon_sym_WIP,
  [anon_sym_NOTE] = anon_sym_NOTE,
  [anon_sym_INFO] = anon_sym_INFO,
  [anon_sym_XXX] = anon_sym_XXX,
  [sym_fixme] = sym_fixme,
  [aux_sym__text_token1] = aux_sym__text_token1,
  [sym__ignored] = sym__ignored,
  [sym__block_close] = sym__block_close,
  [sym__eof_or_newline] = sym__eof_or_newline,
  [sym__newline] = sym__newline,
  [sym__newline_inline] = sym__newline_inline,
  [sym__non_whitespace_check] = sym__non_whitespace_check,
  [sym_hard_line_break] = sym_hard_line_break,
  [sym_frontmatter_marker] = sym_frontmatter_marker,
  [sym__heading_begin] = sym__heading_begin,
  [sym__heading_continuation] = sym__heading_begin,
  [sym__div_begin] = sym__div_begin,
  [sym__div_end] = sym__div_end,
  [sym__code_block_begin] = sym__code_block_begin,
  [sym__code_block_end] = sym__code_block_end,
  [sym_list_marker_dash] = sym_list_marker_dash,
  [sym_list_marker_star] = sym_list_marker_star,
  [sym_list_marker_plus] = sym_list_marker_plus,
  [sym__list_marker_task_begin] = sym__list_marker_task_begin,
  [sym_list_marker_definition] = sym_list_marker_definition,
  [sym_list_marker_decimal_period] = sym_list_marker_decimal_period,
  [sym_list_marker_lower_alpha_period] = sym_list_marker_lower_alpha_period,
  [sym_list_marker_upper_alpha_period] = sym_list_marker_upper_alpha_period,
  [sym_list_marker_lower_roman_period] = sym_list_marker_lower_roman_period,
  [sym_list_marker_upper_roman_period] = sym_list_marker_upper_roman_period,
  [sym_list_marker_decimal_paren] = sym_list_marker_decimal_paren,
  [sym_list_marker_lower_alpha_paren] = sym_list_marker_lower_alpha_paren,
  [sym_list_marker_upper_alpha_paren] = sym_list_marker_upper_alpha_paren,
  [sym_list_marker_lower_roman_paren] = sym_list_marker_lower_roman_paren,
  [sym_list_marker_upper_roman_paren] = sym_list_marker_upper_roman_paren,
  [sym_list_marker_decimal_parens] = sym_list_marker_decimal_parens,
  [sym_list_marker_lower_alpha_parens] = sym_list_marker_lower_alpha_parens,
  [sym_list_marker_upper_alpha_parens] = sym_list_marker_upper_alpha_parens,
  [sym_list_marker_lower_roman_parens] = sym_list_marker_lower_roman_parens,
  [sym_list_marker_upper_roman_parens] = sym_list_marker_upper_roman_parens,
  [sym__list_item_continuation] = sym__list_item_continuation,
  [sym__list_item_end] = sym__list_item_end,
  [sym__indented_content_spacer] = sym__indented_content_spacer,
  [sym__close_paragraph] = sym__close_paragraph,
  [sym__block_quote_begin] = sym__block_quote_begin,
  [sym__block_quote_continuation] = sym__block_quote_continuation,
  [sym__thematic_break_dash] = sym__thematic_break_dash,
  [sym__thematic_break_star] = sym__thematic_break_star,
  [sym__footnote_mark_begin] = sym__footnote_mark_begin,
  [sym__footnote_continuation] = sym__footnote_continuation,
  [sym__footnote_end] = sym__footnote_end,
  [sym__link_ref_def_mark_begin] = sym__link_ref_def_mark_begin,
  [sym__link_ref_def_label_end] = sym__link_ref_def_label_end,
  [sym__table_header_begin] = sym__table_header_begin,
  [sym__table_separator_begin] = sym__table_header_begin,
  [sym__table_row_begin] = sym__table_header_begin,
  [sym__table_row_end_newline] = sym__table_row_end_newline,
  [sym__table_cell_end] = sym__table_header_begin,
  [sym__table_caption_begin] = sym__heading_begin,
  [sym__table_caption_end] = sym__table_caption_end,
  [sym__block_attribute_begin] = anon_sym_LBRACE,
  [sym__comment_end_marker] = anon_sym_PERCENT,
  [sym__comment_close] = sym__comment_close,
  [sym__inline_comment_begin] = sym__inline_comment_begin,
  [sym__verbatim_begin] = sym__verbatim_begin,
  [sym__verbatim_end] = sym__verbatim_end,
  [sym__verbatim_content] = sym__verbatim_content,
  [sym__emphasis_mark_begin] = sym__emphasis_mark_begin,
  [sym_emphasis_end] = sym_emphasis_end,
  [sym__strong_mark_begin] = sym__strong_mark_begin,
  [sym_strong_end] = sym_strong_end,
  [sym__superscript_mark_begin] = sym__superscript_mark_begin,
  [sym_superscript_end] = sym_superscript_end,
  [sym__subscript_mark_begin] = sym__subscript_mark_begin,
  [sym_subscript_end] = sym_subscript_end,
  [sym__highlighted_mark_begin] = sym__highlighted_mark_begin,
  [sym_highlighted_end] = sym_highlighted_end,
  [sym__insert_mark_begin] = sym__insert_mark_begin,
  [sym_insert_end] = sym_insert_end,
  [sym__delete_mark_begin] = sym__delete_mark_begin,
  [sym_delete_end] = sym_delete_end,
  [sym__parens_span_mark_begin] = sym__parens_span_mark_begin,
  [sym__parens_span_end] = sym__parens_span_end,
  [sym__curly_bracket_span_mark_begin] = sym__curly_bracket_span_mark_begin,
  [sym__curly_bracket_span_end] = anon_sym_RBRACE,
  [sym__square_bracket_span_mark_begin] = sym__square_bracket_span_mark_begin,
  [sym__square_bracket_span_end] = anon_sym_RBRACK,
  [sym__in_fallback] = sym__in_fallback,
  [sym__error] = sym__error,
  [sym_document] = sym_document,
  [sym_frontmatter] = sym_frontmatter,
  [sym_frontmatter_content] = sym_frontmatter_content,
  [sym__block_with_section] = sym__block_with_section,
  [sym__block_with_heading] = sym__block_with_heading,
  [sym__block_element] = sym__block_element,
  [sym_section] = sym_section,
  [sym_heading] = sym_heading,
  [sym__heading_content] = sym__verbatim_content,
  [sym_list] = sym_list,
  [sym__list_dash] = sym__list_dash,
  [sym__list_item_dash] = sym__list_item_dash,
  [sym__list_plus] = sym__list_plus,
  [sym__list_item_plus] = sym__list_item_dash,
  [sym__list_star] = sym__list_star,
  [sym__list_item_star] = sym__list_item_dash,
  [sym__list_task] = sym__list_task,
  [sym__list_item_task] = sym__list_item_dash,
  [sym_list_marker_task] = sym_list_marker_task,
  [sym_checked] = sym_checked,
  [sym_unchecked] = sym_unchecked,
  [sym__list_definition] = sym__list_definition,
  [sym__list_item_definition] = sym__list_item_dash,
  [sym__list_decimal_period] = sym__list_decimal_period,
  [sym__list_item_decimal_period] = sym__list_item_dash,
  [sym__list_decimal_paren] = sym__list_decimal_paren,
  [sym__list_item_decimal_paren] = sym__list_item_dash,
  [sym__list_decimal_parens] = sym__list_decimal_parens,
  [sym__list_item_decimal_parens] = sym__list_item_dash,
  [sym__list_lower_alpha_period] = sym__list_lower_alpha_period,
  [sym__list_item_lower_alpha_period] = sym__list_item_dash,
  [sym__list_lower_alpha_paren] = sym__list_lower_alpha_paren,
  [sym__list_item_lower_alpha_paren] = sym__list_item_dash,
  [sym__list_lower_alpha_parens] = sym__list_lower_alpha_parens,
  [sym__list_item_lower_alpha_parens] = sym__list_item_dash,
  [sym__list_upper_alpha_period] = sym__list_upper_alpha_period,
  [sym__list_item_upper_alpha_period] = sym__list_item_dash,
  [sym__list_upper_alpha_paren] = sym__list_upper_alpha_paren,
  [sym__list_item_upper_alpha_paren] = sym__list_item_dash,
  [sym__list_upper_alpha_parens] = sym__list_upper_alpha_parens,
  [sym__list_item_upper_alpha_parens] = sym__list_item_dash,
  [sym__list_lower_roman_period] = sym__list_lower_roman_period,
  [sym__list_item_lower_roman_period] = sym__list_item_dash,
  [sym__list_lower_roman_paren] = sym__list_lower_roman_paren,
  [sym__list_item_lower_roman_paren] = sym__list_item_dash,
  [sym__list_lower_roman_parens] = sym__list_lower_roman_parens,
  [sym__list_item_lower_roman_parens] = sym__list_item_dash,
  [sym__list_upper_roman_period] = sym__list_upper_roman_period,
  [sym__list_item_upper_roman_period] = sym__list_item_dash,
  [sym__list_upper_roman_paren] = sym__list_upper_roman_paren,
  [sym__list_item_upper_roman_paren] = sym__list_item_dash,
  [sym__list_upper_roman_parens] = sym__list_upper_roman_parens,
  [sym__list_item_upper_roman_parens] = sym__list_item_dash,
  [sym_list_item_content] = sym_list_item_content,
  [sym_table] = sym_table,
  [sym__table_row] = sym__table_row,
  [sym_table_header] = sym_table_header,
  [sym_table_separator] = sym_table_separator,
  [sym_table_row] = sym_table_row,
  [sym__table_cell] = sym__table_cell,
  [sym__table_cell_alignment] = sym__table_cell_alignment,
  [sym_table_caption] = sym_table_caption,
  [sym_footnote] = sym_footnote,
  [sym_footnote_content] = sym_footnote_content,
  [sym_div] = sym_div,
  [sym__div_marker_begin] = sym__div_marker_begin,
  [sym_class_name] = sym_class_name,
  [sym_code_block] = sym_code_block,
  [sym_raw_block] = sym_raw_block,
  [sym_raw_block_info] = sym_raw_block_info,
  [sym_code] = sym_code,
  [sym__line] = sym__line,
  [sym_thematic_break] = sym_thematic_break,
  [sym_block_quote] = sym_block_quote,
  [sym__block_quote_content] = sym__verbatim_content,
  [sym__block_quote_prefix] = sym__block_quote_prefix,
  [sym_link_reference_definition] = sym_link_reference_definition,
  [sym_block_attribute] = sym_block_attribute,
  [sym_class] = sym_class,
  [sym_key_value] = sym_key_value,
  [sym_key] = sym_key,
  [sym_value] = sym_value,
  [sym__paragraph] = sym__paragraph,
  [sym__paragraph_content] = sym__paragraph_content,
  [sym__inline] = sym__inline,
  [sym__inline_without_trailing_space] = sym__verbatim_content,
  [sym__inline_element] = sym__inline_element,
  [sym__inline_line] = sym__inline_line,
  [sym__smart_punctuation] = sym__smart_punctuation,
  [sym_autolink] = sym_autolink,
  [sym_emphasis] = sym_emphasis,
  [sym_emphasis_begin] = sym_emphasis_begin,
  [sym_strong] = sym_strong,
  [sym_strong_begin] = sym_strong_begin,
  [sym_superscript] = sym_superscript,
  [sym_superscript_begin] = sym_superscript_begin,
  [sym_subscript] = sym_subscript,
  [sym_subscript_begin] = sym_subscript_begin,
  [sym_highlighted] = sym_highlighted,
  [sym_highlighted_begin] = sym_highlighted_begin,
  [sym_insert] = sym_insert,
  [sym_insert_begin] = sym_insert_begin,
  [sym_delete] = sym_delete,
  [sym_delete_begin] = sym_delete_begin,
  [sym_footnote_reference] = sym_footnote_reference,
  [sym_footnote_marker_begin] = sym_footnote_marker_begin,
  [sym_reference_label] = sym_reference_label,
  [sym__image] = sym__image,
  [sym_full_reference_image] = sym_full_reference_image,
  [sym_collapsed_reference_image] = sym_collapsed_reference_image,
  [sym_inline_image] = sym_inline_image,
  [sym_image_description] = sym_image_description,
  [sym__image_description_begin] = sym__image_description_begin,
  [sym__link] = sym__link,
  [sym_full_reference_link] = sym_full_reference_link,
  [sym_collapsed_reference_link] = sym_collapsed_reference_link,
  [sym_inline_link] = sym_inline_link,
  [sym_link_text] = sym_link_text,
  [sym_span] = sym_span,
  [sym__bracketed_text_begin] = sym__bracketed_text_begin,
  [sym_inline_attribute] = sym_inline_attribute,
  [sym__curly_bracket_span_begin] = sym__curly_bracket_span_begin,
  [sym__link_label] = sym__link_label,
  [sym_inline_link_destination] = sym_inline_link_destination,
  [aux_sym__inline_link_url] = aux_sym__inline_link_url,
  [sym__parens_span_begin] = sym__parens_span_begin,
  [sym__comment] = sym__comment,
  [sym_inline_comment] = sym_inline_comment,
  [sym_raw_inline] = sym_raw_inline,
  [sym_raw_inline_attribute] = sym_raw_inline_attribute,
  [sym_math] = sym_math,
  [sym_verbatim] = sym_verbatim,
  [sym__todo_highlights] = sym__todo_highlights,
  [sym_todo] = sym_todo,
  [sym_note] = sym_note,
  [sym__symbol_fallback] = sym__symbol_fallback,
  [sym__curly_bracket_span_fallback] = sym__curly_bracket_span_fallback,
  [aux_sym__text] = aux_sym__text,
  [aux_sym_document_repeat1] = aux_sym_document_repeat1,
  [aux_sym_frontmatter_content_repeat1] = aux_sym_frontmatter_content_repeat1,
  [aux_sym__heading_content_repeat1] = aux_sym__heading_content_repeat1,
  [aux_sym__list_dash_repeat1] = aux_sym__list_dash_repeat1,
  [aux_sym__list_plus_repeat1] = aux_sym__list_plus_repeat1,
  [aux_sym__list_star_repeat1] = aux_sym__list_star_repeat1,
  [aux_sym__list_task_repeat1] = aux_sym__list_task_repeat1,
  [aux_sym__list_definition_repeat1] = aux_sym__list_definition_repeat1,
  [aux_sym__list_item_definition_repeat1] = aux_sym__list_item_definition_repeat1,
  [aux_sym__list_decimal_period_repeat1] = aux_sym__list_decimal_period_repeat1,
  [aux_sym__list_decimal_paren_repeat1] = aux_sym__list_decimal_paren_repeat1,
  [aux_sym__list_decimal_parens_repeat1] = aux_sym__list_decimal_parens_repeat1,
  [aux_sym__list_lower_alpha_period_repeat1] = aux_sym__list_lower_alpha_period_repeat1,
  [aux_sym__list_lower_alpha_paren_repeat1] = aux_sym__list_lower_alpha_paren_repeat1,
  [aux_sym__list_lower_alpha_parens_repeat1] = aux_sym__list_lower_alpha_parens_repeat1,
  [aux_sym__list_upper_alpha_period_repeat1] = aux_sym__list_upper_alpha_period_repeat1,
  [aux_sym__list_upper_alpha_paren_repeat1] = aux_sym__list_upper_alpha_paren_repeat1,
  [aux_sym__list_upper_alpha_parens_repeat1] = aux_sym__list_upper_alpha_parens_repeat1,
  [aux_sym__list_lower_roman_period_repeat1] = aux_sym__list_lower_roman_period_repeat1,
  [aux_sym__list_lower_roman_paren_repeat1] = aux_sym__list_lower_roman_paren_repeat1,
  [aux_sym__list_lower_roman_parens_repeat1] = aux_sym__list_lower_roman_parens_repeat1,
  [aux_sym__list_upper_roman_period_repeat1] = aux_sym__list_upper_roman_period_repeat1,
  [aux_sym__list_upper_roman_paren_repeat1] = aux_sym__list_upper_roman_paren_repeat1,
  [aux_sym__list_upper_roman_parens_repeat1] = aux_sym__list_upper_roman_parens_repeat1,
  [aux_sym_list_item_content_repeat1] = aux_sym_list_item_content_repeat1,
  [aux_sym_table_repeat1] = aux_sym_table_repeat1,
  [aux_sym_table_header_repeat1] = aux_sym_table_header_repeat1,
  [aux_sym_table_separator_repeat1] = aux_sym_table_separator_repeat1,
  [aux_sym_table_caption_repeat1] = aux_sym_table_caption_repeat1,
  [aux_sym_footnote_content_repeat1] = aux_sym_footnote_content_repeat1,
  [aux_sym_div_repeat1] = aux_sym_div_repeat1,
  [aux_sym_code_repeat1] = aux_sym_code_repeat1,
  [aux_sym__block_quote_content_repeat1] = aux_sym__block_quote_content_repeat1,
  [aux_sym__block_quote_prefix_repeat1] = aux_sym__block_quote_prefix_repeat1,
  [aux_sym_block_attribute_repeat1] = aux_sym_block_attribute_repeat1,
  [aux_sym__paragraph_content_repeat1] = aux_sym__paragraph_content_repeat1,
  [aux_sym__inline_repeat1] = aux_sym__inline_repeat1,
  [aux_sym_inline_attribute_repeat1] = aux_sym_inline_attribute_repeat1,
  [aux_sym__comment_repeat1] = aux_sym__comment_repeat1,
  [alias_sym_args] = alias_sym_args,
  [anon_alias_sym_class] = anon_alias_sym_class,
  [alias_sym_comment] = alias_sym_comment,
  [alias_sym_definition] = alias_sym_definition,
  [alias_sym_language_marker] = alias_sym_language_marker,
  [alias_sym_link_label] = alias_sym_link_label,
  [alias_sym_math_marker] = alias_sym_math_marker,
  [alias_sym_math_marker_begin] = alias_sym_math_marker_begin,
  [alias_sym_math_marker_end] = alias_sym_math_marker_end,
  [alias_sym_paragraph] = alias_sym_paragraph,
  [alias_sym_raw_block_marker_begin] = alias_sym_raw_block_marker_begin,
  [alias_sym_raw_block_marker_end] = alias_sym_raw_block_marker_end,
  [alias_sym_section_content] = alias_sym_section_content,
  [alias_sym_table_cell] = alias_sym_table_cell,
  [alias_sym_verbatim_marker_begin] = alias_sym_verbatim_marker_begin,
  [alias_sym_verbatim_marker_end] = alias_sym_verbatim_marker_end,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_x] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_X] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SPACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__table_cell_alignment_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_COLON] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym_language] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__line_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_link_destination] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_value_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_value_token2] = {
    .visible = false,
    .named = false,
  },
  [sym__whitespace] = {
    .visible = false,
    .named = true,
  },
  [sym__whitespace1] = {
    .visible = false,
    .named = true,
  },
  [sym_quotation_marks] = {
    .visible = true,
    .named = true,
  },
  [sym_ellipsis] = {
    .visible = true,
    .named = true,
  },
  [sym_em_dash] = {
    .visible = true,
    .named = true,
  },
  [sym_en_dash] = {
    .visible = true,
    .named = true,
  },
  [sym_backslash_escape] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_autolink_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_symbol] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_CARET] = {
    .visible = true,
    .named = false,
  },
  [sym__id] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__inline_link_url_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__comment_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LBRACE_EQ2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TODO] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_WIP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_INFO] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_XXX] = {
    .visible = true,
    .named = false,
  },
  [sym_fixme] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__text_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__ignored] = {
    .visible = false,
    .named = true,
  },
  [sym__block_close] = {
    .visible = false,
    .named = true,
  },
  [sym__eof_or_newline] = {
    .visible = false,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__newline_inline] = {
    .visible = false,
    .named = true,
  },
  [sym__non_whitespace_check] = {
    .visible = false,
    .named = true,
  },
  [sym_hard_line_break] = {
    .visible = true,
    .named = true,
  },
  [sym_frontmatter_marker] = {
    .visible = true,
    .named = true,
  },
  [sym__heading_begin] = {
    .visible = true,
    .named = true,
  },
  [sym__heading_continuation] = {
    .visible = true,
    .named = true,
  },
  [sym__div_begin] = {
    .visible = true,
    .named = true,
  },
  [sym__div_end] = {
    .visible = true,
    .named = true,
  },
  [sym__code_block_begin] = {
    .visible = true,
    .named = true,
  },
  [sym__code_block_end] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_dash] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_star] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_plus] = {
    .visible = true,
    .named = true,
  },
  [sym__list_marker_task_begin] = {
    .visible = false,
    .named = true,
  },
  [sym_list_marker_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_decimal_period] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_lower_alpha_period] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_upper_alpha_period] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_lower_roman_period] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_upper_roman_period] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_decimal_paren] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_lower_alpha_paren] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_upper_alpha_paren] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_lower_roman_paren] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_upper_roman_paren] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_decimal_parens] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_lower_alpha_parens] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_upper_alpha_parens] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_lower_roman_parens] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_upper_roman_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__list_item_continuation] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_end] = {
    .visible = false,
    .named = true,
  },
  [sym__indented_content_spacer] = {
    .visible = false,
    .named = true,
  },
  [sym__close_paragraph] = {
    .visible = false,
    .named = true,
  },
  [sym__block_quote_begin] = {
    .visible = true,
    .named = true,
  },
  [sym__block_quote_continuation] = {
    .visible = false,
    .named = true,
  },
  [sym__thematic_break_dash] = {
    .visible = false,
    .named = true,
  },
  [sym__thematic_break_star] = {
    .visible = false,
    .named = true,
  },
  [sym__footnote_mark_begin] = {
    .visible = false,
    .named = true,
  },
  [sym__footnote_continuation] = {
    .visible = false,
    .named = true,
  },
  [sym__footnote_end] = {
    .visible = false,
    .named = true,
  },
  [sym__link_ref_def_mark_begin] = {
    .visible = false,
    .named = true,
  },
  [sym__link_ref_def_label_end] = {
    .visible = false,
    .named = true,
  },
  [sym__table_header_begin] = {
    .visible = true,
    .named = false,
  },
  [sym__table_separator_begin] = {
    .visible = true,
    .named = false,
  },
  [sym__table_row_begin] = {
    .visible = true,
    .named = false,
  },
  [sym__table_row_end_newline] = {
    .visible = false,
    .named = true,
  },
  [sym__table_cell_end] = {
    .visible = true,
    .named = false,
  },
  [sym__table_caption_begin] = {
    .visible = true,
    .named = true,
  },
  [sym__table_caption_end] = {
    .visible = false,
    .named = true,
  },
  [sym__block_attribute_begin] = {
    .visible = true,
    .named = false,
  },
  [sym__comment_end_marker] = {
    .visible = true,
    .named = false,
  },
  [sym__comment_close] = {
    .visible = false,
    .named = true,
  },
  [sym__inline_comment_begin] = {
    .visible = false,
    .named = true,
  },
  [sym__verbatim_begin] = {
    .visible = true,
    .named = true,
  },
  [sym__verbatim_end] = {
    .visible = true,
    .named = true,
  },
  [sym__verbatim_content] = {
    .visible = true,
    .named = true,
  },
  [sym__emphasis_mark_begin] = {
    .visible = false,
    .named = true,
  },
  [sym_emphasis_end] = {
    .visible = true,
    .named = true,
  },
  [sym__strong_mark_begin] = {
    .visible = false,
    .named = true,
  },
  [sym_strong_end] = {
    .visible = true,
    .named = true,
  },
  [sym__superscript_mark_begin] = {
    .visible = false,
    .named = true,
  },
  [sym_superscript_end] = {
    .visible = true,
    .named = true,
  },
  [sym__subscript_mark_begin] = {
    .visible = false,
    .named = true,
  },
  [sym_subscript_end] = {
    .visible = true,
    .named = true,
  },
  [sym__highlighted_mark_begin] = {
    .visible = false,
    .named = true,
  },
  [sym_highlighted_end] = {
    .visible = true,
    .named = true,
  },
  [sym__insert_mark_begin] = {
    .visible = false,
    .named = true,
  },
  [sym_insert_end] = {
    .visible = true,
    .named = true,
  },
  [sym__delete_mark_begin] = {
    .visible = false,
    .named = true,
  },
  [sym_delete_end] = {
    .visible = true,
    .named = true,
  },
  [sym__parens_span_mark_begin] = {
    .visible = false,
    .named = true,
  },
  [sym__parens_span_end] = {
    .visible = true,
    .named = false,
  },
  [sym__curly_bracket_span_mark_begin] = {
    .visible = false,
    .named = true,
  },
  [sym__curly_bracket_span_end] = {
    .visible = true,
    .named = false,
  },
  [sym__square_bracket_span_mark_begin] = {
    .visible = false,
    .named = true,
  },
  [sym__square_bracket_span_end] = {
    .visible = true,
    .named = false,
  },
  [sym__in_fallback] = {
    .visible = false,
    .named = true,
  },
  [sym__error] = {
    .visible = false,
    .named = true,
  },
  [sym_document] = {
    .visible = true,
    .named = true,
  },
  [sym_frontmatter] = {
    .visible = true,
    .named = true,
  },
  [sym_frontmatter_content] = {
    .visible = true,
    .named = true,
  },
  [sym__block_with_section] = {
    .visible = false,
    .named = true,
  },
  [sym__block_with_heading] = {
    .visible = false,
    .named = true,
  },
  [sym__block_element] = {
    .visible = false,
    .named = true,
  },
  [sym_section] = {
    .visible = true,
    .named = true,
  },
  [sym_heading] = {
    .visible = true,
    .named = true,
  },
  [sym__heading_content] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym__list_dash] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_dash] = {
    .visible = true,
    .named = true,
  },
  [sym__list_plus] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_plus] = {
    .visible = true,
    .named = true,
  },
  [sym__list_star] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_star] = {
    .visible = true,
    .named = true,
  },
  [sym__list_task] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_task] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_task] = {
    .visible = true,
    .named = true,
  },
  [sym_checked] = {
    .visible = true,
    .named = true,
  },
  [sym_unchecked] = {
    .visible = true,
    .named = true,
  },
  [sym__list_definition] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__list_decimal_period] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_decimal_period] = {
    .visible = true,
    .named = true,
  },
  [sym__list_decimal_paren] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_decimal_paren] = {
    .visible = true,
    .named = true,
  },
  [sym__list_decimal_parens] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_decimal_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__list_lower_alpha_period] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_lower_alpha_period] = {
    .visible = true,
    .named = true,
  },
  [sym__list_lower_alpha_paren] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_lower_alpha_paren] = {
    .visible = true,
    .named = true,
  },
  [sym__list_lower_alpha_parens] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_lower_alpha_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__list_upper_alpha_period] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_upper_alpha_period] = {
    .visible = true,
    .named = true,
  },
  [sym__list_upper_alpha_paren] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_upper_alpha_paren] = {
    .visible = true,
    .named = true,
  },
  [sym__list_upper_alpha_parens] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_upper_alpha_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__list_lower_roman_period] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_lower_roman_period] = {
    .visible = true,
    .named = true,
  },
  [sym__list_lower_roman_paren] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_lower_roman_paren] = {
    .visible = true,
    .named = true,
  },
  [sym__list_lower_roman_parens] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_lower_roman_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__list_upper_roman_period] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_upper_roman_period] = {
    .visible = true,
    .named = true,
  },
  [sym__list_upper_roman_paren] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_upper_roman_paren] = {
    .visible = true,
    .named = true,
  },
  [sym__list_upper_roman_parens] = {
    .visible = false,
    .named = true,
  },
  [sym__list_item_upper_roman_parens] = {
    .visible = true,
    .named = true,
  },
  [sym_list_item_content] = {
    .visible = true,
    .named = true,
  },
  [sym_table] = {
    .visible = true,
    .named = true,
  },
  [sym__table_row] = {
    .visible = false,
    .named = true,
  },
  [sym_table_header] = {
    .visible = true,
    .named = true,
  },
  [sym_table_separator] = {
    .visible = true,
    .named = true,
  },
  [sym_table_row] = {
    .visible = true,
    .named = true,
  },
  [sym__table_cell] = {
    .visible = false,
    .named = true,
  },
  [sym__table_cell_alignment] = {
    .visible = false,
    .named = true,
  },
  [sym_table_caption] = {
    .visible = true,
    .named = true,
  },
  [sym_footnote] = {
    .visible = true,
    .named = true,
  },
  [sym_footnote_content] = {
    .visible = true,
    .named = true,
  },
  [sym_div] = {
    .visible = true,
    .named = true,
  },
  [sym__div_marker_begin] = {
    .visible = false,
    .named = true,
  },
  [sym_class_name] = {
    .visible = true,
    .named = true,
  },
  [sym_code_block] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_block] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_block_info] = {
    .visible = true,
    .named = true,
  },
  [sym_code] = {
    .visible = true,
    .named = true,
  },
  [sym__line] = {
    .visible = false,
    .named = true,
  },
  [sym_thematic_break] = {
    .visible = true,
    .named = true,
  },
  [sym_block_quote] = {
    .visible = true,
    .named = true,
  },
  [sym__block_quote_content] = {
    .visible = true,
    .named = true,
  },
  [sym__block_quote_prefix] = {
    .visible = false,
    .named = true,
  },
  [sym_link_reference_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_block_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_key_value] = {
    .visible = true,
    .named = true,
  },
  [sym_key] = {
    .visible = true,
    .named = true,
  },
  [sym_value] = {
    .visible = true,
    .named = true,
  },
  [sym__paragraph] = {
    .visible = false,
    .named = true,
  },
  [sym__paragraph_content] = {
    .visible = true,
    .named = true,
  },
  [sym__inline] = {
    .visible = false,
    .named = true,
  },
  [sym__inline_without_trailing_space] = {
    .visible = true,
    .named = true,
  },
  [sym__inline_element] = {
    .visible = false,
    .named = true,
  },
  [sym__inline_line] = {
    .visible = false,
    .named = true,
  },
  [sym__smart_punctuation] = {
    .visible = false,
    .named = true,
  },
  [sym_autolink] = {
    .visible = true,
    .named = true,
  },
  [sym_emphasis] = {
    .visible = true,
    .named = true,
  },
  [sym_emphasis_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_strong] = {
    .visible = true,
    .named = true,
  },
  [sym_strong_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_superscript] = {
    .visible = true,
    .named = true,
  },
  [sym_superscript_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_highlighted] = {
    .visible = true,
    .named = true,
  },
  [sym_highlighted_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_insert] = {
    .visible = true,
    .named = true,
  },
  [sym_insert_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_delete] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_footnote_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_footnote_marker_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_label] = {
    .visible = true,
    .named = true,
  },
  [sym__image] = {
    .visible = false,
    .named = true,
  },
  [sym_full_reference_image] = {
    .visible = true,
    .named = true,
  },
  [sym_collapsed_reference_image] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_image] = {
    .visible = true,
    .named = true,
  },
  [sym_image_description] = {
    .visible = true,
    .named = true,
  },
  [sym__image_description_begin] = {
    .visible = false,
    .named = true,
  },
  [sym__link] = {
    .visible = false,
    .named = true,
  },
  [sym_full_reference_link] = {
    .visible = true,
    .named = true,
  },
  [sym_collapsed_reference_link] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_link] = {
    .visible = true,
    .named = true,
  },
  [sym_link_text] = {
    .visible = true,
    .named = true,
  },
  [sym_span] = {
    .visible = true,
    .named = true,
  },
  [sym__bracketed_text_begin] = {
    .visible = false,
    .named = true,
  },
  [sym_inline_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__curly_bracket_span_begin] = {
    .visible = false,
    .named = true,
  },
  [sym__link_label] = {
    .visible = false,
    .named = true,
  },
  [sym_inline_link_destination] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__inline_link_url] = {
    .visible = false,
    .named = false,
  },
  [sym__parens_span_begin] = {
    .visible = false,
    .named = true,
  },
  [sym__comment] = {
    .visible = false,
    .named = true,
  },
  [sym_inline_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_inline] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_inline_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_math] = {
    .visible = true,
    .named = true,
  },
  [sym_verbatim] = {
    .visible = true,
    .named = true,
  },
  [sym__todo_highlights] = {
    .visible = false,
    .named = true,
  },
  [sym_todo] = {
    .visible = true,
    .named = true,
  },
  [sym_note] = {
    .visible = true,
    .named = true,
  },
  [sym__symbol_fallback] = {
    .visible = false,
    .named = true,
  },
  [sym__curly_bracket_span_fallback] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__text] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_document_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_frontmatter_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__heading_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_dash_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_plus_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_star_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_task_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_item_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_decimal_period_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_decimal_paren_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_decimal_parens_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_lower_alpha_period_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_lower_alpha_paren_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_lower_alpha_parens_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_upper_alpha_period_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_upper_alpha_paren_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_upper_alpha_parens_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_lower_roman_period_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_lower_roman_paren_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_lower_roman_parens_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_upper_roman_period_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_upper_roman_paren_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_upper_roman_parens_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_item_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_table_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_table_header_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_table_separator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_table_caption_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_footnote_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_div_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_code_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__block_quote_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__block_quote_prefix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_attribute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__paragraph_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__inline_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_inline_attribute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_args] = {
    .visible = true,
    .named = true,
  },
  [anon_alias_sym_class] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_comment] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_definition] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_language_marker] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_link_label] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_math_marker] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_math_marker_begin] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_math_marker_end] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_paragraph] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_raw_block_marker_begin] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_raw_block_marker_end] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_section_content] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_table_cell] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_verbatim_marker_begin] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_verbatim_marker_end] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_args = 1,
  field_attribute = 2,
  field_begin_marker = 3,
  field_checkmark = 4,
  field_class = 5,
  field_code = 6,
  field_content = 7,
  field_definition = 8,
  field_description = 9,
  field_destination = 10,
  field_end_marker = 11,
  field_heading = 12,
  field_info = 13,
  field_key = 14,
  field_label = 15,
  field_language = 16,
  field_marker = 17,
  field_math_marker = 18,
  field_term = 19,
  field_text = 20,
  field_value = 21,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_args] = "args",
  [field_attribute] = "attribute",
  [field_begin_marker] = "begin_marker",
  [field_checkmark] = "checkmark",
  [field_class] = "class",
  [field_code] = "code",
  [field_content] = "content",
  [field_definition] = "definition",
  [field_description] = "description",
  [field_destination] = "destination",
  [field_end_marker] = "end_marker",
  [field_heading] = "heading",
  [field_info] = "info",
  [field_key] = "key",
  [field_label] = "label",
  [field_language] = "language",
  [field_marker] = "marker",
  [field_math_marker] = "math_marker",
  [field_term] = "term",
  [field_text] = "text",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 2},
  [3] = {.index = 2, .length = 3},
  [4] = {.index = 5, .length = 1},
  [5] = {.index = 6, .length = 1},
  [6] = {.index = 7, .length = 2},
  [7] = {.index = 9, .length = 1},
  [8] = {.index = 10, .length = 1},
  [9] = {.index = 5, .length = 1},
  [10] = {.index = 11, .length = 1},
  [11] = {.index = 12, .length = 2},
  [12] = {.index = 14, .length = 2},
  [13] = {.index = 16, .length = 1},
  [14] = {.index = 17, .length = 2},
  [15] = {.index = 19, .length = 2},
  [16] = {.index = 21, .length = 2},
  [17] = {.index = 23, .length = 3},
  [18] = {.index = 26, .length = 1},
  [19] = {.index = 27, .length = 1},
  [20] = {.index = 28, .length = 1},
  [21] = {.index = 5, .length = 1},
  [23] = {.index = 29, .length = 3},
  [24] = {.index = 32, .length = 2},
  [25] = {.index = 34, .length = 1},
  [26] = {.index = 35, .length = 2},
  [27] = {.index = 37, .length = 1},
  [28] = {.index = 38, .length = 2},
  [29] = {.index = 40, .length = 3},
  [30] = {.index = 28, .length = 1},
  [31] = {.index = 43, .length = 2},
  [32] = {.index = 45, .length = 1},
  [33] = {.index = 46, .length = 4},
  [34] = {.index = 50, .length = 4},
  [35] = {.index = 54, .length = 2},
  [36] = {.index = 56, .length = 2},
  [37] = {.index = 58, .length = 1},
  [38] = {.index = 59, .length = 4},
  [39] = {.index = 59, .length = 4},
  [41] = {.index = 63, .length = 2},
  [42] = {.index = 23, .length = 3},
  [44] = {.index = 65, .length = 1},
  [45] = {.index = 66, .length = 1},
  [46] = {.index = 67, .length = 1},
  [47] = {.index = 68, .length = 4},
  [48] = {.index = 72, .length = 1},
  [49] = {.index = 73, .length = 3},
  [50] = {.index = 76, .length = 1},
  [51] = {.index = 77, .length = 2},
  [52] = {.index = 79, .length = 2},
  [53] = {.index = 81, .length = 2},
  [54] = {.index = 83, .length = 1},
  [55] = {.index = 84, .length = 2},
  [56] = {.index = 67, .length = 1},
  [57] = {.index = 86, .length = 2},
  [58] = {.index = 79, .length = 2},
  [59] = {.index = 88, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_content, 0, .inherited = true},
    {field_marker, 0, .inherited = true},
  [2] =
    {field_definition, 0, .inherited = true},
    {field_marker, 0, .inherited = true},
    {field_term, 0, .inherited = true},
  [5] =
    {field_attribute, 0, .inherited = true},
  [6] =
    {field_attribute, 1},
  [7] =
    {field_content, 1},
    {field_marker, 0},
  [9] =
    {field_content, 0, .inherited = true},
  [10] =
    {field_heading, 0},
  [11] =
    {field_description, 0},
  [12] =
    {field_description, 0},
    {field_label, 1, .inherited = true},
  [14] =
    {field_description, 0},
    {field_destination, 1},
  [16] =
    {field_text, 0},
  [17] =
    {field_label, 1, .inherited = true},
    {field_text, 0},
  [19] =
    {field_destination, 1},
    {field_text, 0},
  [21] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
  [23] =
    {field_attribute, 1, .inherited = true},
    {field_content, 1},
    {field_marker, 0},
  [26] =
    {field_class, 2},
  [27] =
    {field_checkmark, 1},
  [28] =
    {field_content, 1},
  [29] =
    {field_begin_marker, 0},
    {field_content, 1},
    {field_end_marker, 2},
  [32] =
    {field_content, 1},
    {field_heading, 0},
  [34] =
    {field_class, 0, .inherited = true},
  [35] =
    {field_content, 2},
    {field_marker, 1},
  [37] =
    {field_attribute, 1, .inherited = true},
  [38] =
    {field_language, 1},
    {field_marker, 0},
  [40] =
    {field_attribute, 1, .inherited = true},
    {field_marker, 0},
    {field_term, 1},
  [43] =
    {field_key, 0},
    {field_value, 2},
  [45] =
    {field_args, 1},
  [46] =
    {field_attribute, 3},
    {field_begin_marker, 0},
    {field_content, 1},
    {field_end_marker, 2},
  [50] =
    {field_begin_marker, 1},
    {field_content, 2},
    {field_end_marker, 3},
    {field_math_marker, 0},
  [54] =
    {field_class, 0, .inherited = true},
    {field_content, 2},
  [56] =
    {field_attribute, 1, .inherited = true},
    {field_attribute, 2, .inherited = true},
  [58] =
    {field_attribute, 2, .inherited = true},
  [59] =
    {field_attribute, 2, .inherited = true},
    {field_begin_marker, 0},
    {field_content, 2},
    {field_end_marker, 3},
  [63] =
    {field_attribute, 1, .inherited = true},
    {field_label, 1},
  [65] =
    {field_code, 3},
  [66] =
    {field_language, 2},
  [67] =
    {field_info, 2},
  [68] =
    {field_attribute, 1, .inherited = true},
    {field_definition, 3},
    {field_marker, 0},
    {field_term, 1},
  [72] =
    {field_content, 3, .inherited = true},
  [73] =
    {field_attribute, 2, .inherited = true},
    {field_attribute, 4},
    {field_content, 2},
  [76] =
    {field_content, 3},
  [77] =
    {field_code, 4},
    {field_language, 2},
  [79] =
    {field_content, 4},
    {field_info, 2},
  [81] =
    {field_content, 5},
    {field_label, 2},
  [83] =
    {field_language, 1},
  [84] =
    {field_content, 4},
    {field_language, 2},
  [86] =
    {field_attribute, 2, .inherited = true},
    {field_label, 2},
  [88] =
    {field_attribute, 2, .inherited = true},
    {field_destination, 7},
    {field_label, 2},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym__block_quote_begin,
  },
  [7] = {
    [0] = alias_sym_comment,
  },
  [9] = {
    [0] = alias_sym_paragraph,
  },
  [21] = {
    [0] = alias_sym_table_cell,
  },
  [22] = {
    [1] = anon_alias_sym_class,
  },
  [23] = {
    [0] = alias_sym_verbatim_marker_begin,
    [2] = alias_sym_verbatim_marker_end,
  },
  [24] = {
    [1] = alias_sym_section_content,
  },
  [28] = {
    [0] = alias_sym_language_marker,
  },
  [30] = {
    [1] = sym__verbatim_content,
  },
  [32] = {
    [1] = alias_sym_args,
  },
  [34] = {
    [0] = alias_sym_math_marker,
    [1] = alias_sym_math_marker_begin,
    [3] = alias_sym_math_marker_end,
  },
  [35] = {
    [2] = sym__verbatim_content,
  },
  [39] = {
    [2] = sym__verbatim_content,
  },
  [40] = {
    [3] = anon_sym_RBRACK_COLON,
  },
  [41] = {
    [1] = alias_sym_link_label,
  },
  [42] = {
    [1] = sym__verbatim_content,
  },
  [43] = {
    [2] = alias_sym_args,
  },
  [46] = {
    [0] = alias_sym_raw_block_marker_begin,
  },
  [47] = {
    [3] = alias_sym_definition,
  },
  [49] = {
    [2] = sym__verbatim_content,
  },
  [52] = {
    [0] = alias_sym_raw_block_marker_begin,
    [4] = sym__verbatim_content,
  },
  [56] = {
    [0] = alias_sym_raw_block_marker_begin,
    [5] = alias_sym_raw_block_marker_end,
  },
  [57] = {
    [2] = alias_sym_link_label,
  },
  [58] = {
    [0] = alias_sym_raw_block_marker_begin,
    [4] = sym__verbatim_content,
    [6] = alias_sym_raw_block_marker_end,
  },
  [59] = {
    [2] = alias_sym_link_label,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_class_name, 2,
    sym_class_name,
    anon_alias_sym_class,
  sym_code, 2,
    sym_code,
    sym__verbatim_content,
  sym__paragraph_content, 2,
    sym__paragraph_content,
    alias_sym_paragraph,
  sym__inline, 4,
    sym__inline,
    alias_sym_link_label,
    alias_sym_table_cell,
    sym__verbatim_content,
  sym__comment, 2,
    sym__comment,
    alias_sym_comment,
  aux_sym_document_repeat1, 2,
    aux_sym_document_repeat1,
    alias_sym_section_content,
  aux_sym__list_item_definition_repeat1, 2,
    aux_sym__list_item_definition_repeat1,
    alias_sym_definition,
  aux_sym_table_caption_repeat1, 2,
    aux_sym_table_caption_repeat1,
    sym__verbatim_content,
  aux_sym_div_repeat1, 2,
    aux_sym_div_repeat1,
    sym__verbatim_content,
  aux_sym_block_attribute_repeat1, 2,
    aux_sym_block_attribute_repeat1,
    alias_sym_args,
  aux_sym_inline_attribute_repeat1, 2,
    aux_sym_inline_attribute_repeat1,
    alias_sym_args,
  aux_sym__comment_repeat1, 2,
    aux_sym__comment_repeat1,
    sym__verbatim_content,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 7,
  [9] = 4,
  [10] = 5,
  [11] = 11,
  [12] = 12,
  [13] = 11,
  [14] = 14,
  [15] = 12,
  [16] = 11,
  [17] = 12,
  [18] = 11,
  [19] = 12,
  [20] = 11,
  [21] = 12,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 46,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 46,
  [58] = 58,
  [59] = 59,
  [60] = 46,
  [61] = 61,
  [62] = 62,
  [63] = 46,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 70,
  [73] = 73,
  [74] = 73,
  [75] = 70,
  [76] = 70,
  [77] = 73,
  [78] = 73,
  [79] = 73,
  [80] = 80,
  [81] = 81,
  [82] = 81,
  [83] = 83,
  [84] = 83,
  [85] = 81,
  [86] = 81,
  [87] = 83,
  [88] = 83,
  [89] = 81,
  [90] = 83,
  [91] = 91,
  [92] = 91,
  [93] = 91,
  [94] = 91,
  [95] = 91,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 98,
  [100] = 98,
  [101] = 98,
  [102] = 98,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 105,
  [107] = 103,
  [108] = 108,
  [109] = 109,
  [110] = 103,
  [111] = 108,
  [112] = 104,
  [113] = 104,
  [114] = 105,
  [115] = 103,
  [116] = 103,
  [117] = 108,
  [118] = 105,
  [119] = 108,
  [120] = 104,
  [121] = 105,
  [122] = 122,
  [123] = 104,
  [124] = 108,
  [125] = 125,
  [126] = 125,
  [127] = 127,
  [128] = 125,
  [129] = 125,
  [130] = 127,
  [131] = 127,
  [132] = 125,
  [133] = 127,
  [134] = 134,
  [135] = 135,
  [136] = 134,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 140,
  [143] = 141,
  [144] = 140,
  [145] = 145,
  [146] = 140,
  [147] = 141,
  [148] = 140,
  [149] = 141,
  [150] = 140,
  [151] = 141,
  [152] = 140,
  [153] = 141,
  [154] = 154,
  [155] = 140,
  [156] = 141,
  [157] = 140,
  [158] = 141,
  [159] = 140,
  [160] = 141,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 138,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 145,
  [170] = 141,
  [171] = 140,
  [172] = 172,
  [173] = 154,
  [174] = 161,
  [175] = 162,
  [176] = 163,
  [177] = 164,
  [178] = 138,
  [179] = 166,
  [180] = 167,
  [181] = 139,
  [182] = 182,
  [183] = 154,
  [184] = 161,
  [185] = 162,
  [186] = 163,
  [187] = 164,
  [188] = 138,
  [189] = 166,
  [190] = 167,
  [191] = 154,
  [192] = 161,
  [193] = 162,
  [194] = 163,
  [195] = 164,
  [196] = 138,
  [197] = 166,
  [198] = 167,
  [199] = 139,
  [200] = 161,
  [201] = 162,
  [202] = 163,
  [203] = 164,
  [204] = 138,
  [205] = 166,
  [206] = 167,
  [207] = 154,
  [208] = 161,
  [209] = 162,
  [210] = 163,
  [211] = 164,
  [212] = 138,
  [213] = 166,
  [214] = 167,
  [215] = 154,
  [216] = 161,
  [217] = 162,
  [218] = 163,
  [219] = 164,
  [220] = 138,
  [221] = 166,
  [222] = 167,
  [223] = 154,
  [224] = 161,
  [225] = 162,
  [226] = 163,
  [227] = 164,
  [228] = 138,
  [229] = 166,
  [230] = 167,
  [231] = 154,
  [232] = 161,
  [233] = 162,
  [234] = 163,
  [235] = 164,
  [236] = 138,
  [237] = 166,
  [238] = 167,
  [239] = 154,
  [240] = 161,
  [241] = 162,
  [242] = 163,
  [243] = 164,
  [244] = 138,
  [245] = 166,
  [246] = 167,
  [247] = 154,
  [248] = 161,
  [249] = 162,
  [250] = 163,
  [251] = 164,
  [252] = 166,
  [253] = 167,
  [254] = 154,
  [255] = 161,
  [256] = 162,
  [257] = 163,
  [258] = 164,
  [259] = 138,
  [260] = 166,
  [261] = 167,
  [262] = 154,
  [263] = 161,
  [264] = 162,
  [265] = 163,
  [266] = 164,
  [267] = 138,
  [268] = 166,
  [269] = 167,
  [270] = 168,
  [271] = 168,
  [272] = 168,
  [273] = 168,
  [274] = 168,
  [275] = 168,
  [276] = 168,
  [277] = 168,
  [278] = 168,
  [279] = 168,
  [280] = 168,
  [281] = 168,
  [282] = 139,
  [283] = 139,
  [284] = 154,
  [285] = 141,
  [286] = 286,
  [287] = 286,
  [288] = 288,
  [289] = 288,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 292,
  [300] = 294,
  [301] = 291,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 306,
  [310] = 302,
  [311] = 311,
  [312] = 312,
  [313] = 293,
  [314] = 304,
  [315] = 311,
  [316] = 305,
  [317] = 295,
  [318] = 296,
  [319] = 312,
  [320] = 297,
  [321] = 307,
  [322] = 303,
  [323] = 308,
  [324] = 298,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 326,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 325,
  [356] = 356,
  [357] = 357,
  [358] = 332,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 360,
  [365] = 362,
  [366] = 366,
  [367] = 367,
  [368] = 327,
  [369] = 330,
  [370] = 333,
  [371] = 334,
  [372] = 335,
  [373] = 337,
  [374] = 374,
  [375] = 338,
  [376] = 339,
  [377] = 340,
  [378] = 341,
  [379] = 342,
  [380] = 343,
  [381] = 344,
  [382] = 345,
  [383] = 346,
  [384] = 384,
  [385] = 347,
  [386] = 348,
  [387] = 349,
  [388] = 350,
  [389] = 351,
  [390] = 352,
  [391] = 391,
  [392] = 354,
  [393] = 393,
  [394] = 394,
  [395] = 356,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 357,
  [400] = 400,
  [401] = 374,
  [402] = 402,
  [403] = 328,
  [404] = 404,
  [405] = 405,
  [406] = 366,
  [407] = 407,
  [408] = 408,
  [409] = 407,
  [410] = 353,
  [411] = 411,
  [412] = 363,
  [413] = 413,
  [414] = 367,
  [415] = 391,
  [416] = 393,
  [417] = 396,
  [418] = 397,
  [419] = 398,
  [420] = 400,
  [421] = 402,
  [422] = 404,
  [423] = 405,
  [424] = 408,
  [425] = 411,
  [426] = 413,
  [427] = 336,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 429,
  [432] = 432,
  [433] = 429,
  [434] = 432,
  [435] = 430,
  [436] = 430,
  [437] = 437,
  [438] = 437,
  [439] = 437,
  [440] = 437,
  [441] = 437,
  [442] = 437,
  [443] = 437,
  [444] = 437,
  [445] = 437,
  [446] = 437,
  [447] = 437,
  [448] = 437,
  [449] = 449,
  [450] = 449,
  [451] = 451,
  [452] = 451,
  [453] = 449,
  [454] = 451,
  [455] = 449,
  [456] = 451,
  [457] = 449,
  [458] = 451,
  [459] = 449,
  [460] = 451,
  [461] = 451,
  [462] = 449,
  [463] = 449,
  [464] = 451,
  [465] = 449,
  [466] = 437,
  [467] = 451,
  [468] = 451,
  [469] = 449,
  [470] = 451,
  [471] = 449,
  [472] = 449,
  [473] = 451,
  [474] = 474,
  [475] = 474,
  [476] = 474,
  [477] = 474,
  [478] = 474,
  [479] = 474,
  [480] = 474,
  [481] = 474,
  [482] = 474,
  [483] = 451,
  [484] = 449,
  [485] = 474,
  [486] = 474,
  [487] = 474,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 490,
  [492] = 492,
  [493] = 492,
  [494] = 490,
  [495] = 492,
  [496] = 492,
  [497] = 497,
  [498] = 498,
  [499] = 489,
  [500] = 497,
  [501] = 497,
  [502] = 498,
  [503] = 498,
  [504] = 489,
  [505] = 490,
  [506] = 489,
  [507] = 488,
  [508] = 488,
  [509] = 488,
  [510] = 490,
  [511] = 497,
  [512] = 492,
  [513] = 492,
  [514] = 492,
  [515] = 490,
  [516] = 492,
  [517] = 497,
  [518] = 498,
  [519] = 489,
  [520] = 488,
  [521] = 497,
  [522] = 498,
  [523] = 497,
  [524] = 490,
  [525] = 489,
  [526] = 492,
  [527] = 498,
  [528] = 490,
  [529] = 497,
  [530] = 497,
  [531] = 498,
  [532] = 489,
  [533] = 488,
  [534] = 498,
  [535] = 474,
  [536] = 489,
  [537] = 490,
  [538] = 492,
  [539] = 488,
  [540] = 489,
  [541] = 488,
  [542] = 497,
  [543] = 498,
  [544] = 489,
  [545] = 488,
  [546] = 488,
  [547] = 490,
  [548] = 498,
  [549] = 490,
  [550] = 492,
  [551] = 498,
  [552] = 489,
  [553] = 488,
  [554] = 497,
  [555] = 498,
  [556] = 489,
  [557] = 488,
  [558] = 490,
  [559] = 492,
  [560] = 497,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 566,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 569,
  [572] = 570,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 561,
  [589] = 568,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 575,
  [594] = 562,
  [595] = 563,
  [596] = 564,
  [597] = 565,
  [598] = 566,
  [599] = 567,
  [600] = 569,
  [601] = 570,
  [602] = 573,
  [603] = 574,
  [604] = 576,
  [605] = 577,
  [606] = 578,
  [607] = 579,
  [608] = 580,
  [609] = 581,
  [610] = 582,
  [611] = 583,
  [612] = 584,
  [613] = 585,
  [614] = 586,
  [615] = 587,
  [616] = 561,
  [617] = 568,
  [618] = 590,
  [619] = 591,
  [620] = 575,
  [621] = 562,
  [622] = 563,
  [623] = 564,
  [624] = 565,
  [625] = 566,
  [626] = 567,
  [627] = 569,
  [628] = 570,
  [629] = 573,
  [630] = 574,
  [631] = 576,
  [632] = 577,
  [633] = 578,
  [634] = 579,
  [635] = 580,
  [636] = 581,
  [637] = 582,
  [638] = 583,
  [639] = 584,
  [640] = 585,
  [641] = 586,
  [642] = 587,
  [643] = 561,
  [644] = 568,
  [645] = 590,
  [646] = 591,
  [647] = 575,
  [648] = 573,
  [649] = 562,
  [650] = 563,
  [651] = 564,
  [652] = 565,
  [653] = 566,
  [654] = 567,
  [655] = 574,
  [656] = 590,
  [657] = 569,
  [658] = 570,
  [659] = 573,
  [660] = 574,
  [661] = 576,
  [662] = 577,
  [663] = 578,
  [664] = 579,
  [665] = 580,
  [666] = 581,
  [667] = 582,
  [668] = 583,
  [669] = 584,
  [670] = 585,
  [671] = 586,
  [672] = 587,
  [673] = 561,
  [674] = 591,
  [675] = 576,
  [676] = 577,
  [677] = 568,
  [678] = 590,
  [679] = 591,
  [680] = 578,
  [681] = 579,
  [682] = 580,
  [683] = 575,
  [684] = 581,
  [685] = 562,
  [686] = 563,
  [687] = 564,
  [688] = 565,
  [689] = 566,
  [690] = 567,
  [691] = 582,
  [692] = 583,
  [693] = 584,
  [694] = 569,
  [695] = 570,
  [696] = 573,
  [697] = 574,
  [698] = 576,
  [699] = 577,
  [700] = 578,
  [701] = 579,
  [702] = 580,
  [703] = 581,
  [704] = 582,
  [705] = 583,
  [706] = 584,
  [707] = 585,
  [708] = 586,
  [709] = 587,
  [710] = 568,
  [711] = 590,
  [712] = 591,
  [713] = 575,
  [714] = 562,
  [715] = 563,
  [716] = 564,
  [717] = 565,
  [718] = 566,
  [719] = 567,
  [720] = 569,
  [721] = 570,
  [722] = 573,
  [723] = 574,
  [724] = 576,
  [725] = 577,
  [726] = 578,
  [727] = 579,
  [728] = 580,
  [729] = 581,
  [730] = 582,
  [731] = 583,
  [732] = 584,
  [733] = 585,
  [734] = 586,
  [735] = 587,
  [736] = 561,
  [737] = 568,
  [738] = 590,
  [739] = 591,
  [740] = 575,
  [741] = 585,
  [742] = 562,
  [743] = 563,
  [744] = 564,
  [745] = 575,
  [746] = 566,
  [747] = 567,
  [748] = 586,
  [749] = 569,
  [750] = 570,
  [751] = 573,
  [752] = 574,
  [753] = 576,
  [754] = 577,
  [755] = 578,
  [756] = 579,
  [757] = 580,
  [758] = 581,
  [759] = 582,
  [760] = 583,
  [761] = 584,
  [762] = 585,
  [763] = 586,
  [764] = 587,
  [765] = 561,
  [766] = 568,
  [767] = 590,
  [768] = 591,
  [769] = 575,
  [770] = 562,
  [771] = 563,
  [772] = 564,
  [773] = 565,
  [774] = 566,
  [775] = 567,
  [776] = 587,
  [777] = 569,
  [778] = 570,
  [779] = 573,
  [780] = 574,
  [781] = 576,
  [782] = 577,
  [783] = 578,
  [784] = 579,
  [785] = 580,
  [786] = 581,
  [787] = 582,
  [788] = 583,
  [789] = 584,
  [790] = 585,
  [791] = 586,
  [792] = 587,
  [793] = 568,
  [794] = 590,
  [795] = 591,
  [796] = 575,
  [797] = 562,
  [798] = 563,
  [799] = 564,
  [800] = 565,
  [801] = 566,
  [802] = 567,
  [803] = 569,
  [804] = 570,
  [805] = 573,
  [806] = 574,
  [807] = 576,
  [808] = 577,
  [809] = 578,
  [810] = 579,
  [811] = 580,
  [812] = 581,
  [813] = 582,
  [814] = 583,
  [815] = 584,
  [816] = 585,
  [817] = 586,
  [818] = 587,
  [819] = 562,
  [820] = 497,
  [821] = 498,
  [822] = 489,
  [823] = 488,
  [824] = 563,
  [825] = 564,
  [826] = 490,
  [827] = 492,
  [828] = 565,
  [829] = 566,
  [830] = 567,
  [831] = 561,
  [832] = 561,
  [833] = 568,
  [834] = 590,
  [835] = 591,
  [836] = 432,
  [837] = 575,
  [838] = 562,
  [839] = 563,
  [840] = 564,
  [841] = 565,
  [842] = 566,
  [843] = 567,
  [844] = 429,
  [845] = 845,
  [846] = 569,
  [847] = 570,
  [848] = 573,
  [849] = 574,
  [850] = 576,
  [851] = 577,
  [852] = 578,
  [853] = 579,
  [854] = 580,
  [855] = 581,
  [856] = 582,
  [857] = 583,
  [858] = 584,
  [859] = 585,
  [860] = 586,
  [861] = 587,
  [862] = 561,
  [863] = 568,
  [864] = 590,
  [865] = 591,
  [866] = 575,
  [867] = 562,
  [868] = 563,
  [869] = 564,
  [870] = 565,
  [871] = 566,
  [872] = 567,
  [873] = 569,
  [874] = 570,
  [875] = 573,
  [876] = 574,
  [877] = 576,
  [878] = 577,
  [879] = 578,
  [880] = 579,
  [881] = 580,
  [882] = 581,
  [883] = 582,
  [884] = 583,
  [885] = 584,
  [886] = 585,
  [887] = 586,
  [888] = 587,
  [889] = 568,
  [890] = 590,
  [891] = 591,
  [892] = 565,
  [893] = 893,
  [894] = 894,
  [895] = 895,
  [896] = 896,
  [897] = 897,
  [898] = 893,
  [899] = 893,
  [900] = 900,
  [901] = 895,
  [902] = 568,
  [903] = 590,
  [904] = 591,
  [905] = 896,
  [906] = 906,
  [907] = 575,
  [908] = 895,
  [909] = 562,
  [910] = 563,
  [911] = 564,
  [912] = 565,
  [913] = 566,
  [914] = 567,
  [915] = 900,
  [916] = 569,
  [917] = 570,
  [918] = 573,
  [919] = 574,
  [920] = 576,
  [921] = 577,
  [922] = 578,
  [923] = 579,
  [924] = 580,
  [925] = 581,
  [926] = 582,
  [927] = 583,
  [928] = 584,
  [929] = 585,
  [930] = 586,
  [931] = 587,
  [932] = 932,
  [933] = 906,
  [934] = 430,
  [935] = 932,
  [936] = 894,
  [937] = 894,
  [938] = 897,
  [939] = 895,
  [940] = 900,
  [941] = 932,
  [942] = 896,
  [943] = 894,
  [944] = 932,
  [945] = 894,
  [946] = 896,
  [947] = 897,
  [948] = 897,
  [949] = 896,
  [950] = 906,
  [951] = 932,
  [952] = 906,
  [953] = 897,
  [954] = 894,
  [955] = 906,
  [956] = 896,
  [957] = 896,
  [958] = 895,
  [959] = 959,
  [960] = 896,
  [961] = 932,
  [962] = 932,
  [963] = 906,
  [964] = 964,
  [965] = 893,
  [966] = 894,
  [967] = 893,
  [968] = 895,
  [969] = 897,
  [970] = 896,
  [971] = 897,
  [972] = 893,
  [973] = 893,
  [974] = 895,
  [975] = 906,
  [976] = 895,
  [977] = 895,
  [978] = 900,
  [979] = 932,
  [980] = 894,
  [981] = 906,
  [982] = 900,
  [983] = 932,
  [984] = 894,
  [985] = 932,
  [986] = 897,
  [987] = 894,
  [988] = 959,
  [989] = 897,
  [990] = 897,
  [991] = 893,
  [992] = 897,
  [993] = 906,
  [994] = 893,
  [995] = 895,
  [996] = 896,
  [997] = 900,
  [998] = 906,
  [999] = 900,
  [1000] = 906,
  [1001] = 896,
  [1002] = 893,
  [1003] = 932,
  [1004] = 894,
  [1005] = 896,
  [1006] = 895,
  [1007] = 1007,
  [1008] = 894,
  [1009] = 964,
  [1010] = 906,
  [1011] = 895,
  [1012] = 897,
  [1013] = 561,
  [1014] = 900,
  [1015] = 893,
  [1016] = 893,
  [1017] = 900,
  [1018] = 561,
  [1019] = 561,
  [1020] = 932,
  [1021] = 900,
  [1022] = 900,
  [1023] = 893,
  [1024] = 906,
  [1025] = 894,
  [1026] = 895,
  [1027] = 897,
  [1028] = 896,
  [1029] = 932,
  [1030] = 134,
  [1031] = 134,
  [1032] = 145,
  [1033] = 134,
  [1034] = 145,
  [1035] = 145,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 1038,
  [1039] = 1037,
  [1040] = 1040,
  [1041] = 1041,
  [1042] = 1036,
  [1043] = 1038,
  [1044] = 1036,
  [1045] = 1038,
  [1046] = 1036,
  [1047] = 1038,
  [1048] = 1048,
  [1049] = 1038,
  [1050] = 1036,
  [1051] = 1038,
  [1052] = 1036,
  [1053] = 1038,
  [1054] = 1036,
  [1055] = 1038,
  [1056] = 1036,
  [1057] = 1038,
  [1058] = 1036,
  [1059] = 1038,
  [1060] = 1036,
  [1061] = 1038,
  [1062] = 1036,
  [1063] = 1038,
  [1064] = 1036,
  [1065] = 1038,
  [1066] = 1041,
  [1067] = 1037,
  [1068] = 1041,
  [1069] = 1037,
  [1070] = 1041,
  [1071] = 1037,
  [1072] = 1041,
  [1073] = 1036,
  [1074] = 294,
  [1075] = 1075,
  [1076] = 291,
  [1077] = 1077,
  [1078] = 306,
  [1079] = 1079,
  [1080] = 1077,
  [1081] = 1081,
  [1082] = 1075,
  [1083] = 1083,
  [1084] = 1077,
  [1085] = 307,
  [1086] = 1079,
  [1087] = 308,
  [1088] = 1081,
  [1089] = 1075,
  [1090] = 1079,
  [1091] = 1077,
  [1092] = 298,
  [1093] = 1079,
  [1094] = 1081,
  [1095] = 1075,
  [1096] = 1079,
  [1097] = 1081,
  [1098] = 1075,
  [1099] = 1081,
  [1100] = 1077,
  [1101] = 292,
  [1102] = 1102,
  [1103] = 1103,
  [1104] = 1104,
  [1105] = 1105,
  [1106] = 1102,
  [1107] = 1107,
  [1108] = 1108,
  [1109] = 1109,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 1112,
  [1113] = 1113,
  [1114] = 1114,
  [1115] = 1115,
  [1116] = 1116,
  [1117] = 1117,
  [1118] = 1103,
  [1119] = 1105,
  [1120] = 1102,
  [1121] = 1107,
  [1122] = 1109,
  [1123] = 1113,
  [1124] = 1124,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 1128,
  [1129] = 1129,
  [1130] = 298,
  [1131] = 292,
  [1132] = 1124,
  [1133] = 294,
  [1134] = 1125,
  [1135] = 1126,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 291,
  [1139] = 1139,
  [1140] = 1110,
  [1141] = 1111,
  [1142] = 1112,
  [1143] = 1143,
  [1144] = 1114,
  [1145] = 1115,
  [1146] = 1116,
  [1147] = 1117,
  [1148] = 1103,
  [1149] = 1105,
  [1150] = 1102,
  [1151] = 1107,
  [1152] = 1109,
  [1153] = 1113,
  [1154] = 1124,
  [1155] = 1125,
  [1156] = 1126,
  [1157] = 1127,
  [1158] = 1128,
  [1159] = 1110,
  [1160] = 1160,
  [1161] = 1161,
  [1162] = 1162,
  [1163] = 1116,
  [1164] = 1164,
  [1165] = 1117,
  [1166] = 1110,
  [1167] = 1111,
  [1168] = 1112,
  [1169] = 1169,
  [1170] = 1114,
  [1171] = 1115,
  [1172] = 1116,
  [1173] = 1117,
  [1174] = 1103,
  [1175] = 1105,
  [1176] = 1176,
  [1177] = 1107,
  [1178] = 1178,
  [1179] = 1113,
  [1180] = 1124,
  [1181] = 1125,
  [1182] = 1126,
  [1183] = 1127,
  [1184] = 1128,
  [1185] = 1169,
  [1186] = 1186,
  [1187] = 307,
  [1188] = 308,
  [1189] = 306,
  [1190] = 1136,
  [1191] = 1162,
  [1192] = 1127,
  [1193] = 1193,
  [1194] = 1110,
  [1195] = 1111,
  [1196] = 1112,
  [1197] = 1197,
  [1198] = 1114,
  [1199] = 1115,
  [1200] = 1116,
  [1201] = 1117,
  [1202] = 1103,
  [1203] = 1105,
  [1204] = 1204,
  [1205] = 1205,
  [1206] = 1143,
  [1207] = 1160,
  [1208] = 1102,
  [1209] = 1107,
  [1210] = 1210,
  [1211] = 1109,
  [1212] = 1111,
  [1213] = 1113,
  [1214] = 1124,
  [1215] = 1125,
  [1216] = 1112,
  [1217] = 1161,
  [1218] = 1218,
  [1219] = 1126,
  [1220] = 1127,
  [1221] = 1221,
  [1222] = 1128,
  [1223] = 1223,
  [1224] = 1128,
  [1225] = 1225,
  [1226] = 298,
  [1227] = 292,
  [1228] = 294,
  [1229] = 291,
  [1230] = 1230,
  [1231] = 1205,
  [1232] = 307,
  [1233] = 308,
  [1234] = 306,
  [1235] = 1235,
  [1236] = 1114,
  [1237] = 1115,
  [1238] = 1238,
  [1239] = 1239,
  [1240] = 1240,
  [1241] = 1241,
  [1242] = 1242,
  [1243] = 1109,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 1247,
  [1248] = 1244,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1250,
  [1253] = 1246,
  [1254] = 1251,
  [1255] = 1244,
  [1256] = 1249,
  [1257] = 1250,
  [1258] = 1251,
  [1259] = 1259,
  [1260] = 1246,
  [1261] = 1247,
  [1262] = 1244,
  [1263] = 1249,
  [1264] = 1250,
  [1265] = 1251,
  [1266] = 1246,
  [1267] = 1246,
  [1268] = 1250,
  [1269] = 1244,
  [1270] = 1249,
  [1271] = 1250,
  [1272] = 1251,
  [1273] = 1251,
  [1274] = 1246,
  [1275] = 1275,
  [1276] = 1244,
  [1277] = 1249,
  [1278] = 1250,
  [1279] = 1251,
  [1280] = 1259,
  [1281] = 1246,
  [1282] = 1250,
  [1283] = 1244,
  [1284] = 1249,
  [1285] = 1246,
  [1286] = 1244,
  [1287] = 1246,
  [1288] = 1244,
  [1289] = 1246,
  [1290] = 1244,
  [1291] = 1246,
  [1292] = 1244,
  [1293] = 1246,
  [1294] = 1244,
  [1295] = 1246,
  [1296] = 1275,
  [1297] = 1275,
  [1298] = 1246,
  [1299] = 1251,
  [1300] = 1246,
  [1301] = 1244,
  [1302] = 1249,
  [1303] = 1275,
  [1304] = 1244,
  [1305] = 1249,
  [1306] = 1244,
  [1307] = 1275,
  [1308] = 1308,
  [1309] = 1246,
  [1310] = 1246,
  [1311] = 1259,
  [1312] = 1312,
  [1313] = 1247,
  [1314] = 1250,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1247,
  [1318] = 1244,
  [1319] = 1251,
  [1320] = 1249,
  [1321] = 1259,
  [1322] = 1322,
  [1323] = 1259,
  [1324] = 1247,
  [1325] = 1250,
  [1326] = 1251,
  [1327] = 1249,
  [1328] = 1246,
  [1329] = 1250,
  [1330] = 1330,
  [1331] = 1249,
  [1332] = 1250,
  [1333] = 1244,
  [1334] = 1251,
  [1335] = 1251,
  [1336] = 1246,
  [1337] = 1249,
  [1338] = 1244,
  [1339] = 1249,
  [1340] = 1250,
  [1341] = 1251,
  [1342] = 1244,
  [1343] = 1343,
  [1344] = 1344,
  [1345] = 432,
  [1346] = 429,
  [1347] = 1347,
  [1348] = 1344,
  [1349] = 1343,
  [1350] = 288,
  [1351] = 1351,
  [1352] = 1344,
  [1353] = 1353,
  [1354] = 1343,
  [1355] = 1355,
  [1356] = 311,
  [1357] = 1357,
  [1358] = 1358,
  [1359] = 1359,
  [1360] = 1357,
  [1361] = 1357,
  [1362] = 1362,
  [1363] = 304,
  [1364] = 1357,
  [1365] = 1357,
  [1366] = 305,
  [1367] = 1357,
  [1368] = 1368,
  [1369] = 1369,
  [1370] = 1357,
  [1371] = 1357,
  [1372] = 1357,
  [1373] = 1359,
  [1374] = 1368,
  [1375] = 1357,
  [1376] = 1376,
  [1377] = 1359,
  [1378] = 1357,
  [1379] = 430,
  [1380] = 303,
  [1381] = 1381,
  [1382] = 1368,
  [1383] = 1383,
  [1384] = 1384,
  [1385] = 1385,
  [1386] = 1362,
  [1387] = 1362,
  [1388] = 1383,
  [1389] = 1383,
  [1390] = 290,
  [1391] = 312,
  [1392] = 293,
  [1393] = 1362,
  [1394] = 1383,
  [1395] = 1383,
  [1396] = 1362,
  [1397] = 1357,
  [1398] = 1368,
  [1399] = 1359,
  [1400] = 288,
  [1401] = 1368,
  [1402] = 295,
  [1403] = 1359,
  [1404] = 296,
  [1405] = 297,
  [1406] = 1406,
  [1407] = 1357,
  [1408] = 1408,
  [1409] = 302,
  [1410] = 1410,
  [1411] = 1411,
  [1412] = 384,
  [1413] = 405,
  [1414] = 432,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 432,
  [1418] = 1418,
  [1419] = 1419,
  [1420] = 333,
  [1421] = 334,
  [1422] = 335,
  [1423] = 1423,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 432,
  [1427] = 336,
  [1428] = 337,
  [1429] = 338,
  [1430] = 360,
  [1431] = 339,
  [1432] = 1432,
  [1433] = 340,
  [1434] = 341,
  [1435] = 1432,
  [1436] = 342,
  [1437] = 343,
  [1438] = 432,
  [1439] = 429,
  [1440] = 288,
  [1441] = 432,
  [1442] = 1442,
  [1443] = 1424,
  [1444] = 344,
  [1445] = 429,
  [1446] = 429,
  [1447] = 345,
  [1448] = 1432,
  [1449] = 432,
  [1450] = 1450,
  [1451] = 1451,
  [1452] = 367,
  [1453] = 429,
  [1454] = 1454,
  [1455] = 346,
  [1456] = 1424,
  [1457] = 347,
  [1458] = 348,
  [1459] = 1424,
  [1460] = 391,
  [1461] = 429,
  [1462] = 349,
  [1463] = 350,
  [1464] = 1464,
  [1465] = 351,
  [1466] = 352,
  [1467] = 408,
  [1468] = 1424,
  [1469] = 393,
  [1470] = 396,
  [1471] = 397,
  [1472] = 1432,
  [1473] = 354,
  [1474] = 432,
  [1475] = 429,
  [1476] = 362,
  [1477] = 432,
  [1478] = 1478,
  [1479] = 429,
  [1480] = 1424,
  [1481] = 356,
  [1482] = 1432,
  [1483] = 432,
  [1484] = 1484,
  [1485] = 1424,
  [1486] = 357,
  [1487] = 1432,
  [1488] = 1424,
  [1489] = 1489,
  [1490] = 353,
  [1491] = 374,
  [1492] = 432,
  [1493] = 429,
  [1494] = 1494,
  [1495] = 413,
  [1496] = 429,
  [1497] = 1424,
  [1498] = 1424,
  [1499] = 1432,
  [1500] = 398,
  [1501] = 1501,
  [1502] = 432,
  [1503] = 1424,
  [1504] = 328,
  [1505] = 429,
  [1506] = 432,
  [1507] = 1507,
  [1508] = 1508,
  [1509] = 1509,
  [1510] = 1510,
  [1511] = 432,
  [1512] = 429,
  [1513] = 402,
  [1514] = 1514,
  [1515] = 1432,
  [1516] = 1516,
  [1517] = 1432,
  [1518] = 1518,
  [1519] = 404,
  [1520] = 1424,
  [1521] = 432,
  [1522] = 1432,
  [1523] = 1508,
  [1524] = 1424,
  [1525] = 1525,
  [1526] = 1526,
  [1527] = 1424,
  [1528] = 1528,
  [1529] = 1432,
  [1530] = 1530,
  [1531] = 1432,
  [1532] = 1532,
  [1533] = 1533,
  [1534] = 1534,
  [1535] = 1535,
  [1536] = 1536,
  [1537] = 327,
  [1538] = 1432,
  [1539] = 1539,
  [1540] = 330,
  [1541] = 1541,
  [1542] = 429,
  [1543] = 1543,
  [1544] = 1544,
  [1545] = 1545,
  [1546] = 411,
  [1547] = 1547,
  [1548] = 1432,
  [1549] = 1450,
  [1550] = 1550,
  [1551] = 429,
  [1552] = 1508,
  [1553] = 432,
  [1554] = 1554,
  [1555] = 1555,
  [1556] = 432,
  [1557] = 429,
  [1558] = 432,
  [1559] = 1559,
  [1560] = 429,
  [1561] = 1508,
  [1562] = 1562,
  [1563] = 400,
  [1564] = 1564,
  [1565] = 1565,
  [1566] = 1566,
  [1567] = 1567,
  [1568] = 1568,
  [1569] = 1569,
  [1570] = 1508,
  [1571] = 1571,
  [1572] = 366,
  [1573] = 1573,
  [1574] = 407,
  [1575] = 429,
  [1576] = 1576,
  [1577] = 1424,
  [1578] = 290,
  [1579] = 1508,
  [1580] = 331,
  [1581] = 1424,
  [1582] = 432,
  [1583] = 1432,
  [1584] = 429,
  [1585] = 429,
  [1586] = 432,
  [1587] = 302,
  [1588] = 1508,
  [1589] = 1589,
  [1590] = 311,
  [1591] = 1424,
  [1592] = 429,
  [1593] = 429,
  [1594] = 312,
  [1595] = 293,
  [1596] = 1596,
  [1597] = 1508,
  [1598] = 1598,
  [1599] = 1599,
  [1600] = 1600,
  [1601] = 1601,
  [1602] = 1424,
  [1603] = 1424,
  [1604] = 1604,
  [1605] = 1605,
  [1606] = 1508,
  [1607] = 1607,
  [1608] = 295,
  [1609] = 296,
  [1610] = 297,
  [1611] = 1432,
  [1612] = 1612,
  [1613] = 303,
  [1614] = 1614,
  [1615] = 1508,
  [1616] = 1616,
  [1617] = 304,
  [1618] = 305,
  [1619] = 1619,
  [1620] = 1620,
  [1621] = 432,
  [1622] = 1432,
  [1623] = 1623,
  [1624] = 1508,
  [1625] = 432,
  [1626] = 1626,
  [1627] = 1627,
  [1628] = 1628,
  [1629] = 1508,
  [1630] = 1630,
  [1631] = 1631,
  [1632] = 1632,
  [1633] = 1633,
  [1634] = 1634,
  [1635] = 432,
  [1636] = 1636,
  [1637] = 1432,
  [1638] = 1432,
  [1639] = 429,
  [1640] = 429,
  [1641] = 1641,
  [1642] = 363,
  [1643] = 1508,
  [1644] = 1644,
  [1645] = 374,
  [1646] = 1646,
  [1647] = 1647,
  [1648] = 384,
  [1649] = 1649,
  [1650] = 1650,
  [1651] = 1651,
  [1652] = 328,
  [1653] = 430,
  [1654] = 1654,
  [1655] = 1655,
  [1656] = 1656,
  [1657] = 1657,
  [1658] = 1658,
  [1659] = 430,
  [1660] = 366,
  [1661] = 1649,
  [1662] = 407,
  [1663] = 1663,
  [1664] = 1664,
  [1665] = 1665,
  [1666] = 1654,
  [1667] = 1656,
  [1668] = 1668,
  [1669] = 1669,
  [1670] = 1644,
  [1671] = 1671,
  [1672] = 1672,
  [1673] = 1673,
  [1674] = 1674,
  [1675] = 1675,
  [1676] = 1668,
  [1677] = 1658,
  [1678] = 353,
  [1679] = 1669,
  [1680] = 363,
  [1681] = 367,
  [1682] = 391,
  [1683] = 393,
  [1684] = 396,
  [1685] = 397,
  [1686] = 398,
  [1687] = 400,
  [1688] = 402,
  [1689] = 404,
  [1690] = 405,
  [1691] = 408,
  [1692] = 411,
  [1693] = 413,
  [1694] = 1646,
  [1695] = 430,
  [1696] = 1650,
  [1697] = 1651,
  [1698] = 430,
  [1699] = 1699,
  [1700] = 1644,
  [1701] = 1649,
  [1702] = 1702,
  [1703] = 430,
  [1704] = 1665,
  [1705] = 1654,
  [1706] = 1656,
  [1707] = 1668,
  [1708] = 1669,
  [1709] = 1644,
  [1710] = 1671,
  [1711] = 1672,
  [1712] = 1673,
  [1713] = 1674,
  [1714] = 1675,
  [1715] = 1658,
  [1716] = 1716,
  [1717] = 1717,
  [1718] = 1718,
  [1719] = 1646,
  [1720] = 1646,
  [1721] = 1721,
  [1722] = 1650,
  [1723] = 1651,
  [1724] = 430,
  [1725] = 1649,
  [1726] = 1665,
  [1727] = 1654,
  [1728] = 1656,
  [1729] = 1668,
  [1730] = 1669,
  [1731] = 1644,
  [1732] = 1671,
  [1733] = 1672,
  [1734] = 1673,
  [1735] = 1674,
  [1736] = 1675,
  [1737] = 1646,
  [1738] = 1650,
  [1739] = 1651,
  [1740] = 1740,
  [1741] = 845,
  [1742] = 1742,
  [1743] = 290,
  [1744] = 1665,
  [1745] = 1654,
  [1746] = 1656,
  [1747] = 1668,
  [1748] = 1669,
  [1749] = 1644,
  [1750] = 1671,
  [1751] = 1672,
  [1752] = 1673,
  [1753] = 1674,
  [1754] = 1675,
  [1755] = 430,
  [1756] = 1756,
  [1757] = 1646,
  [1758] = 1650,
  [1759] = 1651,
  [1760] = 1665,
  [1761] = 1654,
  [1762] = 1656,
  [1763] = 1668,
  [1764] = 1669,
  [1765] = 1644,
  [1766] = 1671,
  [1767] = 1672,
  [1768] = 1673,
  [1769] = 1674,
  [1770] = 1675,
  [1771] = 1646,
  [1772] = 1650,
  [1773] = 1651,
  [1774] = 1665,
  [1775] = 1654,
  [1776] = 1656,
  [1777] = 1668,
  [1778] = 1669,
  [1779] = 1644,
  [1780] = 1671,
  [1781] = 1672,
  [1782] = 1673,
  [1783] = 1674,
  [1784] = 1675,
  [1785] = 302,
  [1786] = 1646,
  [1787] = 1650,
  [1788] = 1651,
  [1789] = 311,
  [1790] = 1790,
  [1791] = 1665,
  [1792] = 1654,
  [1793] = 1656,
  [1794] = 1668,
  [1795] = 1669,
  [1796] = 1644,
  [1797] = 1671,
  [1798] = 1672,
  [1799] = 1673,
  [1800] = 1674,
  [1801] = 1675,
  [1802] = 1646,
  [1803] = 1650,
  [1804] = 1651,
  [1805] = 430,
  [1806] = 1806,
  [1807] = 1807,
  [1808] = 312,
  [1809] = 293,
  [1810] = 1665,
  [1811] = 1654,
  [1812] = 1656,
  [1813] = 1668,
  [1814] = 1669,
  [1815] = 1644,
  [1816] = 1671,
  [1817] = 1672,
  [1818] = 1673,
  [1819] = 1674,
  [1820] = 1675,
  [1821] = 430,
  [1822] = 1646,
  [1823] = 1650,
  [1824] = 1651,
  [1825] = 430,
  [1826] = 1665,
  [1827] = 1654,
  [1828] = 357,
  [1829] = 1668,
  [1830] = 1669,
  [1831] = 1644,
  [1832] = 1671,
  [1833] = 1672,
  [1834] = 1673,
  [1835] = 1674,
  [1836] = 1675,
  [1837] = 1646,
  [1838] = 1650,
  [1839] = 1651,
  [1840] = 430,
  [1841] = 430,
  [1842] = 1665,
  [1843] = 1654,
  [1844] = 1656,
  [1845] = 1668,
  [1846] = 1669,
  [1847] = 1644,
  [1848] = 1671,
  [1849] = 1672,
  [1850] = 1673,
  [1851] = 1674,
  [1852] = 1675,
  [1853] = 1650,
  [1854] = 1651,
  [1855] = 1646,
  [1856] = 1650,
  [1857] = 1651,
  [1858] = 295,
  [1859] = 296,
  [1860] = 430,
  [1861] = 297,
  [1862] = 1862,
  [1863] = 430,
  [1864] = 430,
  [1865] = 430,
  [1866] = 430,
  [1867] = 303,
  [1868] = 1868,
  [1869] = 304,
  [1870] = 305,
  [1871] = 430,
  [1872] = 1872,
  [1873] = 1873,
  [1874] = 430,
  [1875] = 430,
  [1876] = 1718,
  [1877] = 1877,
  [1878] = 1665,
  [1879] = 1654,
  [1880] = 1656,
  [1881] = 1668,
  [1882] = 1669,
  [1883] = 1644,
  [1884] = 1671,
  [1885] = 1672,
  [1886] = 1673,
  [1887] = 1674,
  [1888] = 1675,
  [1889] = 1718,
  [1890] = 1877,
  [1891] = 1658,
  [1892] = 1525,
  [1893] = 430,
  [1894] = 1671,
  [1895] = 360,
  [1896] = 1718,
  [1897] = 1877,
  [1898] = 1672,
  [1899] = 1877,
  [1900] = 1673,
  [1901] = 362,
  [1902] = 1902,
  [1903] = 1646,
  [1904] = 1718,
  [1905] = 1905,
  [1906] = 1877,
  [1907] = 1756,
  [1908] = 327,
  [1909] = 1650,
  [1910] = 1651,
  [1911] = 1718,
  [1912] = 330,
  [1913] = 1877,
  [1914] = 430,
  [1915] = 1674,
  [1916] = 1916,
  [1917] = 1718,
  [1918] = 1877,
  [1919] = 333,
  [1920] = 1718,
  [1921] = 1877,
  [1922] = 334,
  [1923] = 335,
  [1924] = 336,
  [1925] = 1718,
  [1926] = 337,
  [1927] = 1877,
  [1928] = 338,
  [1929] = 339,
  [1930] = 340,
  [1931] = 341,
  [1932] = 1718,
  [1933] = 1877,
  [1934] = 342,
  [1935] = 1718,
  [1936] = 1649,
  [1937] = 1877,
  [1938] = 343,
  [1939] = 344,
  [1940] = 345,
  [1941] = 1718,
  [1942] = 346,
  [1943] = 1877,
  [1944] = 347,
  [1945] = 1665,
  [1946] = 1654,
  [1947] = 1656,
  [1948] = 1668,
  [1949] = 1669,
  [1950] = 348,
  [1951] = 1671,
  [1952] = 1718,
  [1953] = 1672,
  [1954] = 1877,
  [1955] = 1673,
  [1956] = 1674,
  [1957] = 1675,
  [1958] = 349,
  [1959] = 1658,
  [1960] = 350,
  [1961] = 351,
  [1962] = 352,
  [1963] = 1675,
  [1964] = 354,
  [1965] = 1665,
  [1966] = 1702,
  [1967] = 1702,
  [1968] = 1702,
  [1969] = 1702,
  [1970] = 1647,
  [1971] = 1647,
  [1972] = 356,
  [1973] = 1647,
  [1974] = 1647,
  [1975] = 1656,
  [1976] = 1976,
  [1977] = 1977,
  [1978] = 1978,
  [1979] = 1979,
  [1980] = 1980,
  [1981] = 1981,
  [1982] = 357,
  [1983] = 1983,
  [1984] = 1984,
  [1985] = 1985,
  [1986] = 1986,
  [1987] = 1987,
  [1988] = 1988,
  [1989] = 1989,
  [1990] = 1978,
  [1991] = 1979,
  [1992] = 1980,
  [1993] = 1983,
  [1994] = 1985,
  [1995] = 1986,
  [1996] = 1996,
  [1997] = 1997,
  [1998] = 1977,
  [1999] = 1999,
  [2000] = 2000,
  [2001] = 2001,
  [2002] = 2002,
  [2003] = 2001,
  [2004] = 2004,
  [2005] = 1996,
  [2006] = 1997,
  [2007] = 1977,
  [2008] = 2008,
  [2009] = 2009,
  [2010] = 2010,
  [2011] = 2011,
  [2012] = 2012,
  [2013] = 2013,
  [2014] = 2001,
  [2015] = 2015,
  [2016] = 2016,
  [2017] = 2017,
  [2018] = 2018,
  [2019] = 1984,
  [2020] = 2020,
  [2021] = 2021,
  [2022] = 374,
  [2023] = 2015,
  [2024] = 1989,
  [2025] = 1978,
  [2026] = 1979,
  [2027] = 1980,
  [2028] = 1983,
  [2029] = 1985,
  [2030] = 1986,
  [2031] = 1996,
  [2032] = 1997,
  [2033] = 1977,
  [2034] = 384,
  [2035] = 2035,
  [2036] = 2001,
  [2037] = 331,
  [2038] = 2038,
  [2039] = 2004,
  [2040] = 360,
  [2041] = 2004,
  [2042] = 2042,
  [2043] = 2009,
  [2044] = 2016,
  [2045] = 2045,
  [2046] = 2046,
  [2047] = 2045,
  [2048] = 2048,
  [2049] = 2049,
  [2050] = 2050,
  [2051] = 2051,
  [2052] = 2052,
  [2053] = 2046,
  [2054] = 1984,
  [2055] = 2055,
  [2056] = 2056,
  [2057] = 328,
  [2058] = 2058,
  [2059] = 1989,
  [2060] = 1978,
  [2061] = 1979,
  [2062] = 1980,
  [2063] = 1983,
  [2064] = 1985,
  [2065] = 1986,
  [2066] = 1996,
  [2067] = 1997,
  [2068] = 1977,
  [2069] = 2069,
  [2070] = 2070,
  [2071] = 2001,
  [2072] = 1162,
  [2073] = 2048,
  [2074] = 2004,
  [2075] = 2049,
  [2076] = 2050,
  [2077] = 2077,
  [2078] = 2078,
  [2079] = 2056,
  [2080] = 2058,
  [2081] = 2081,
  [2082] = 2082,
  [2083] = 2083,
  [2084] = 2084,
  [2085] = 2085,
  [2086] = 2008,
  [2087] = 2082,
  [2088] = 2088,
  [2089] = 1984,
  [2090] = 2090,
  [2091] = 2091,
  [2092] = 1984,
  [2093] = 2093,
  [2094] = 1989,
  [2095] = 1978,
  [2096] = 1979,
  [2097] = 1980,
  [2098] = 1983,
  [2099] = 1985,
  [2100] = 1986,
  [2101] = 1996,
  [2102] = 1997,
  [2103] = 1977,
  [2104] = 2104,
  [2105] = 2105,
  [2106] = 2001,
  [2107] = 2107,
  [2108] = 2108,
  [2109] = 2004,
  [2110] = 362,
  [2111] = 2111,
  [2112] = 2112,
  [2113] = 2010,
  [2114] = 2048,
  [2115] = 2115,
  [2116] = 2116,
  [2117] = 2117,
  [2118] = 327,
  [2119] = 330,
  [2120] = 1989,
  [2121] = 2121,
  [2122] = 2122,
  [2123] = 2123,
  [2124] = 1984,
  [2125] = 2125,
  [2126] = 2126,
  [2127] = 2127,
  [2128] = 2128,
  [2129] = 1989,
  [2130] = 1978,
  [2131] = 1979,
  [2132] = 1980,
  [2133] = 1983,
  [2134] = 1985,
  [2135] = 1986,
  [2136] = 1996,
  [2137] = 1997,
  [2138] = 1977,
  [2139] = 2139,
  [2140] = 366,
  [2141] = 2001,
  [2142] = 407,
  [2143] = 2143,
  [2144] = 2004,
  [2145] = 2145,
  [2146] = 2146,
  [2147] = 2147,
  [2148] = 2008,
  [2149] = 2149,
  [2150] = 333,
  [2151] = 334,
  [2152] = 2127,
  [2153] = 1984,
  [2154] = 1978,
  [2155] = 1979,
  [2156] = 335,
  [2157] = 336,
  [2158] = 337,
  [2159] = 1984,
  [2160] = 338,
  [2161] = 339,
  [2162] = 2117,
  [2163] = 1989,
  [2164] = 1989,
  [2165] = 1978,
  [2166] = 1979,
  [2167] = 1980,
  [2168] = 1983,
  [2169] = 1985,
  [2170] = 1986,
  [2171] = 1996,
  [2172] = 1997,
  [2173] = 1977,
  [2174] = 340,
  [2175] = 1980,
  [2176] = 2001,
  [2177] = 1978,
  [2178] = 1979,
  [2179] = 2004,
  [2180] = 2180,
  [2181] = 1980,
  [2182] = 353,
  [2183] = 1983,
  [2184] = 1985,
  [2185] = 1986,
  [2186] = 2186,
  [2187] = 1996,
  [2188] = 363,
  [2189] = 1997,
  [2190] = 1977,
  [2191] = 367,
  [2192] = 341,
  [2193] = 342,
  [2194] = 2010,
  [2195] = 2195,
  [2196] = 2196,
  [2197] = 2125,
  [2198] = 343,
  [2199] = 2199,
  [2200] = 1988,
  [2201] = 391,
  [2202] = 2186,
  [2203] = 393,
  [2204] = 396,
  [2205] = 397,
  [2206] = 398,
  [2207] = 344,
  [2208] = 400,
  [2209] = 402,
  [2210] = 345,
  [2211] = 2058,
  [2212] = 404,
  [2213] = 2002,
  [2214] = 2017,
  [2215] = 2001,
  [2216] = 405,
  [2217] = 2012,
  [2218] = 2218,
  [2219] = 1981,
  [2220] = 2000,
  [2221] = 2221,
  [2222] = 2149,
  [2223] = 2078,
  [2224] = 408,
  [2225] = 2015,
  [2226] = 346,
  [2227] = 2195,
  [2228] = 2196,
  [2229] = 2125,
  [2230] = 347,
  [2231] = 2199,
  [2232] = 348,
  [2233] = 2186,
  [2234] = 2021,
  [2235] = 2035,
  [2236] = 2038,
  [2237] = 349,
  [2238] = 2004,
  [2239] = 2042,
  [2240] = 2009,
  [2241] = 2016,
  [2242] = 411,
  [2243] = 413,
  [2244] = 2002,
  [2245] = 2017,
  [2246] = 2045,
  [2247] = 2046,
  [2248] = 2012,
  [2249] = 2218,
  [2250] = 2000,
  [2251] = 2221,
  [2252] = 2149,
  [2253] = 2078,
  [2254] = 1983,
  [2255] = 2048,
  [2256] = 2256,
  [2257] = 2195,
  [2258] = 2196,
  [2259] = 2125,
  [2260] = 2260,
  [2261] = 2199,
  [2262] = 2262,
  [2263] = 2186,
  [2264] = 2021,
  [2265] = 2199,
  [2266] = 2049,
  [2267] = 2267,
  [2268] = 2117,
  [2269] = 2050,
  [2270] = 2035,
  [2271] = 350,
  [2272] = 2272,
  [2273] = 2038,
  [2274] = 2002,
  [2275] = 2017,
  [2276] = 351,
  [2277] = 2277,
  [2278] = 2012,
  [2279] = 2218,
  [2280] = 2000,
  [2281] = 2221,
  [2282] = 2149,
  [2283] = 2078,
  [2284] = 2056,
  [2285] = 1985,
  [2286] = 2195,
  [2287] = 2196,
  [2288] = 2125,
  [2289] = 2289,
  [2290] = 2199,
  [2291] = 1978,
  [2292] = 2186,
  [2293] = 1986,
  [2294] = 1989,
  [2295] = 2295,
  [2296] = 1996,
  [2297] = 2082,
  [2298] = 2093,
  [2299] = 2299,
  [2300] = 2056,
  [2301] = 2008,
  [2302] = 1997,
  [2303] = 2002,
  [2304] = 2017,
  [2305] = 2305,
  [2306] = 2306,
  [2307] = 2012,
  [2308] = 2218,
  [2309] = 2000,
  [2310] = 2221,
  [2311] = 2149,
  [2312] = 2078,
  [2313] = 2195,
  [2314] = 2125,
  [2315] = 2199,
  [2316] = 2186,
  [2317] = 2221,
  [2318] = 2127,
  [2319] = 2319,
  [2320] = 1977,
  [2321] = 1984,
  [2322] = 1979,
  [2323] = 352,
  [2324] = 2324,
  [2325] = 2196,
  [2326] = 1984,
  [2327] = 2327,
  [2328] = 2012,
  [2329] = 2000,
  [2330] = 2195,
  [2331] = 2125,
  [2332] = 2199,
  [2333] = 2186,
  [2334] = 2004,
  [2335] = 2049,
  [2336] = 2010,
  [2337] = 354,
  [2338] = 2042,
  [2339] = 2009,
  [2340] = 2117,
  [2341] = 2341,
  [2342] = 1989,
  [2343] = 1989,
  [2344] = 2344,
  [2345] = 2012,
  [2346] = 2000,
  [2347] = 2195,
  [2348] = 2042,
  [2349] = 2199,
  [2350] = 2186,
  [2351] = 2351,
  [2352] = 1978,
  [2353] = 1978,
  [2354] = 1979,
  [2355] = 1980,
  [2356] = 1983,
  [2357] = 1985,
  [2358] = 1979,
  [2359] = 1986,
  [2360] = 1980,
  [2361] = 1996,
  [2362] = 2012,
  [2363] = 2000,
  [2364] = 2195,
  [2365] = 2125,
  [2366] = 2199,
  [2367] = 2186,
  [2368] = 1997,
  [2369] = 1977,
  [2370] = 1983,
  [2371] = 1985,
  [2372] = 2070,
  [2373] = 2010,
  [2374] = 1986,
  [2375] = 1996,
  [2376] = 1997,
  [2377] = 1977,
  [2378] = 2378,
  [2379] = 2012,
  [2380] = 2000,
  [2381] = 2195,
  [2382] = 2125,
  [2383] = 2199,
  [2384] = 2186,
  [2385] = 2001,
  [2386] = 2015,
  [2387] = 2050,
  [2388] = 2001,
  [2389] = 2389,
  [2390] = 2021,
  [2391] = 2035,
  [2392] = 2001,
  [2393] = 2038,
  [2394] = 2004,
  [2395] = 2015,
  [2396] = 2012,
  [2397] = 2000,
  [2398] = 2195,
  [2399] = 2125,
  [2400] = 2199,
  [2401] = 2186,
  [2402] = 2327,
  [2403] = 2004,
  [2404] = 2042,
  [2405] = 2009,
  [2406] = 2016,
  [2407] = 2045,
  [2408] = 2046,
  [2409] = 2409,
  [2410] = 2127,
  [2411] = 1205,
  [2412] = 2048,
  [2413] = 2012,
  [2414] = 2000,
  [2415] = 2195,
  [2416] = 2125,
  [2417] = 2199,
  [2418] = 2186,
  [2419] = 2049,
  [2420] = 2050,
  [2421] = 2021,
  [2422] = 2035,
  [2423] = 2056,
  [2424] = 2058,
  [2425] = 2082,
  [2426] = 2008,
  [2427] = 1980,
  [2428] = 2038,
  [2429] = 1983,
  [2430] = 2012,
  [2431] = 2000,
  [2432] = 2195,
  [2433] = 2125,
  [2434] = 2199,
  [2435] = 2186,
  [2436] = 2127,
  [2437] = 1984,
  [2438] = 1984,
  [2439] = 1984,
  [2440] = 2004,
  [2441] = 1985,
  [2442] = 2218,
  [2443] = 2443,
  [2444] = 1989,
  [2445] = 1978,
  [2446] = 1979,
  [2447] = 2012,
  [2448] = 2000,
  [2449] = 2199,
  [2450] = 2199,
  [2451] = 2199,
  [2452] = 2199,
  [2453] = 2199,
  [2454] = 2199,
  [2455] = 2389,
  [2456] = 2055,
  [2457] = 2088,
  [2458] = 2091,
  [2459] = 2111,
  [2460] = 2115,
  [2461] = 2123,
  [2462] = 1976,
  [2463] = 2108,
  [2464] = 2107,
  [2465] = 2341,
  [2466] = 1980,
  [2467] = 2122,
  [2468] = 2443,
  [2469] = 2389,
  [2470] = 2055,
  [2471] = 2088,
  [2472] = 2091,
  [2473] = 2111,
  [2474] = 2115,
  [2475] = 2123,
  [2476] = 1976,
  [2477] = 2108,
  [2478] = 2107,
  [2479] = 2341,
  [2480] = 1983,
  [2481] = 2122,
  [2482] = 2443,
  [2483] = 2389,
  [2484] = 2055,
  [2485] = 2088,
  [2486] = 2091,
  [2487] = 2111,
  [2488] = 2115,
  [2489] = 2123,
  [2490] = 1976,
  [2491] = 2108,
  [2492] = 2107,
  [2493] = 2341,
  [2494] = 1985,
  [2495] = 2122,
  [2496] = 2443,
  [2497] = 2389,
  [2498] = 2055,
  [2499] = 2088,
  [2500] = 2091,
  [2501] = 2111,
  [2502] = 2115,
  [2503] = 2123,
  [2504] = 1976,
  [2505] = 2108,
  [2506] = 2107,
  [2507] = 2341,
  [2508] = 1986,
  [2509] = 2122,
  [2510] = 2443,
  [2511] = 2055,
  [2512] = 2088,
  [2513] = 2091,
  [2514] = 2111,
  [2515] = 2115,
  [2516] = 2123,
  [2517] = 1976,
  [2518] = 2108,
  [2519] = 2107,
  [2520] = 2341,
  [2521] = 1996,
  [2522] = 2055,
  [2523] = 2088,
  [2524] = 2091,
  [2525] = 2111,
  [2526] = 2115,
  [2527] = 2123,
  [2528] = 1976,
  [2529] = 2108,
  [2530] = 2107,
  [2531] = 2341,
  [2532] = 1997,
  [2533] = 2055,
  [2534] = 2088,
  [2535] = 2091,
  [2536] = 2111,
  [2537] = 2115,
  [2538] = 2123,
  [2539] = 1976,
  [2540] = 2108,
  [2541] = 2107,
  [2542] = 2341,
  [2543] = 1977,
  [2544] = 2055,
  [2545] = 2088,
  [2546] = 2091,
  [2547] = 2111,
  [2548] = 2115,
  [2549] = 2123,
  [2550] = 1976,
  [2551] = 2108,
  [2552] = 2107,
  [2553] = 2341,
  [2554] = 356,
  [2555] = 2055,
  [2556] = 2088,
  [2557] = 2091,
  [2558] = 2111,
  [2559] = 2115,
  [2560] = 2123,
  [2561] = 1976,
  [2562] = 2108,
  [2563] = 2107,
  [2564] = 2341,
  [2565] = 2121,
  [2566] = 2055,
  [2567] = 2088,
  [2568] = 2091,
  [2569] = 2111,
  [2570] = 2115,
  [2571] = 2123,
  [2572] = 2001,
  [2573] = 2108,
  [2574] = 2107,
  [2575] = 2341,
  [2576] = 2576,
  [2577] = 2055,
  [2578] = 2088,
  [2579] = 2091,
  [2580] = 2111,
  [2581] = 2115,
  [2582] = 2123,
  [2583] = 1976,
  [2584] = 2108,
  [2585] = 2107,
  [2586] = 2341,
  [2587] = 2058,
  [2588] = 2055,
  [2589] = 2088,
  [2590] = 2091,
  [2591] = 2111,
  [2592] = 2115,
  [2593] = 2123,
  [2594] = 1976,
  [2595] = 2108,
  [2596] = 2107,
  [2597] = 2341,
  [2598] = 2598,
  [2599] = 2272,
  [2600] = 2600,
  [2601] = 2128,
  [2602] = 2195,
  [2603] = 2272,
  [2604] = 1976,
  [2605] = 2128,
  [2606] = 2016,
  [2607] = 2272,
  [2608] = 2004,
  [2609] = 2128,
  [2610] = 2272,
  [2611] = 2611,
  [2612] = 2128,
  [2613] = 2272,
  [2614] = 2272,
  [2615] = 2272,
  [2616] = 2272,
  [2617] = 2272,
  [2618] = 2272,
  [2619] = 2272,
  [2620] = 2272,
  [2621] = 1986,
  [2622] = 2045,
  [2623] = 1996,
  [2624] = 1997,
  [2625] = 2117,
  [2626] = 2626,
  [2627] = 1989,
  [2628] = 2046,
  [2629] = 2409,
  [2630] = 2409,
  [2631] = 2409,
  [2632] = 2409,
  [2633] = 2125,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(46);
      if ((!eof && lookahead == 00)) ADVANCE(59);
      if (lookahead == '\t') ADVANCE(78);
      if (lookahead == '\r') SKIP(43);
      if (lookahead == ' ') ADVANCE(57);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(73);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '%') ADVANCE(162);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(71);
      if (lookahead == ':') ADVANCE(67);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == '=') ADVANCE(61);
      if (lookahead == '>') ADVANCE(117);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(54);
      if (lookahead == '[') ADVANCE(49);
      if (lookahead == '\\') ADVANCE(195);
      if (lookahead == ']') ADVANCE(55);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == 'x') ADVANCE(52);
      if (lookahead == '{') ADVANCE(150);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(181);
      END_STATE();
    case 1:
      if ((!eof && lookahead == 00)) ADVANCE(59);
      if (lookahead == '\r') SKIP(2);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(192);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(192);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(190);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') ADVANCE(193);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == '{') ADVANCE(182);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(181);
      END_STATE();
    case 2:
      if ((!eof && lookahead == 00)) ADVANCE(59);
      if (lookahead == '\r') SKIP(2);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(192);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(192);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(190);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') ADVANCE(193);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == '{') ADVANCE(182);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead)) ADVANCE(181);
      END_STATE();
    case 3:
      if (lookahead == '\r') SKIP(4);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(192);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(192);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(190);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') ADVANCE(193);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == '{') ADVANCE(182);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(181);
      END_STATE();
    case 4:
      if (lookahead == '\r') SKIP(4);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(192);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(192);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(190);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') ADVANCE(193);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == '{') ADVANCE(182);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead)) ADVANCE(181);
      END_STATE();
    case 5:
      if (lookahead == '\r') SKIP(7);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(192);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(192);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == '>') ADVANCE(117);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(190);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') ADVANCE(193);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == '{') ADVANCE(153);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(181);
      END_STATE();
    case 6:
      if (lookahead == '\r') SKIP(7);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(192);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(192);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == '>') ADVANCE(117);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(190);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') ADVANCE(193);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == '{') ADVANCE(153);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(181);
      END_STATE();
    case 7:
      if (lookahead == '\r') SKIP(7);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(192);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(192);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == '>') ADVANCE(117);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(190);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') ADVANCE(193);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == '{') ADVANCE(153);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead)) ADVANCE(181);
      END_STATE();
    case 8:
      if (lookahead == '\r') SKIP(9);
      if (lookahead == '"') ADVANCE(73);
      if (lookahead == '#') ADVANCE(41);
      if (lookahead == '%') ADVANCE(162);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '.') ADVANCE(70);
      if (lookahead == ':') ADVANCE(66);
      if (lookahead == '=') ADVANCE(61);
      if (lookahead == '[') ADVANCE(48);
      if (lookahead == ']') ADVANCE(55);
      if (lookahead == '{') ADVANCE(149);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(143);
      END_STATE();
    case 9:
      if (lookahead == '\r') SKIP(9);
      if (lookahead == '"') ADVANCE(73);
      if (lookahead == '#') ADVANCE(41);
      if (lookahead == '%') ADVANCE(162);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '.') ADVANCE(70);
      if (lookahead == ':') ADVANCE(66);
      if (lookahead == '=') ADVANCE(61);
      if (lookahead == '[') ADVANCE(47);
      if (lookahead == ']') ADVANCE(55);
      if (lookahead == '{') ADVANCE(149);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(143);
      END_STATE();
    case 10:
      if (lookahead == '\r') ADVANCE(164);
      if (lookahead == '\\') ADVANCE(165);
      if (lookahead != 0 &&
          lookahead != '%' &&
          lookahead != '}') ADVANCE(163);
      END_STATE();
    case 11:
      if (lookahead == '\r') ADVANCE(157);
      if (lookahead == '\\') ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != ')') ADVANCE(158);
      END_STATE();
    case 12:
      if (lookahead == '\r') ADVANCE(62);
      if (lookahead == '=') ADVANCE(61);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != ' ' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(63);
      END_STATE();
    case 13:
      if (lookahead == '\r') SKIP(13);
      if (lookahead == '"') ADVANCE(73);
      if (lookahead == '[') ADVANCE(47);
      if (lookahead == ']') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(76);
      END_STATE();
    case 14:
      if (lookahead == '\r') SKIP(14);
      if (lookahead == ' ') ADVANCE(56);
      if (lookahead == 'X') ADVANCE(53);
      if (lookahead == 'x') ADVANCE(52);
      END_STATE();
    case 15:
      if (lookahead == '\r') ADVANCE(74);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"') ADVANCE(75);
      END_STATE();
    case 16:
      if (lookahead == '\r') SKIP(16);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(68);
      END_STATE();
    case 17:
      if (lookahead == '\r') SKIP(22);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(192);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(192);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(190);
      if (lookahead == '[') ADVANCE(49);
      if (lookahead == '\\') ADVANCE(193);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == '{') ADVANCE(153);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(181);
      END_STATE();
    case 18:
      if (lookahead == '\r') SKIP(22);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(192);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(192);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(190);
      if (lookahead == '[') ADVANCE(49);
      if (lookahead == '\\') ADVANCE(193);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == '{') ADVANCE(153);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(181);
      END_STATE();
    case 19:
      if (lookahead == '\r') SKIP(22);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(192);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(192);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(190);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') ADVANCE(193);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == '{') ADVANCE(153);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(181);
      END_STATE();
    case 20:
      if (lookahead == '\r') SKIP(22);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(192);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(192);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(190);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') ADVANCE(193);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == '{') ADVANCE(151);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(181);
      END_STATE();
    case 21:
      if (lookahead == '\r') SKIP(22);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(192);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(192);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(190);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') ADVANCE(193);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == '{') ADVANCE(153);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(181);
      END_STATE();
    case 22:
      if (lookahead == '\r') SKIP(22);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(192);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(192);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(190);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') ADVANCE(193);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == '{') ADVANCE(153);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead)) ADVANCE(181);
      END_STATE();
    case 23:
      if (lookahead == '\r') SKIP(22);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(192);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(192);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(190);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') ADVANCE(193);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == '{') ADVANCE(151);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(181);
      END_STATE();
    case 24:
      if (lookahead == '\r') SKIP(26);
      if (lookahead == '!') ADVANCE(112);
      if (lookahead == '"') ADVANCE(113);
      if (lookahead == '$') ADVANCE(168);
      if (lookahead == '\'') ADVANCE(113);
      if (lookahead == '(') ADVANCE(161);
      if (lookahead == '*') ADVANCE(126);
      if (lookahead == '-') ADVANCE(91);
      if (lookahead == '.') ADVANCE(93);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == '<') ADVANCE(90);
      if (lookahead == '>') ADVANCE(181);
      if (lookahead == 'F') ADVANCE(100);
      if (lookahead == 'I') ADVANCE(102);
      if (lookahead == 'N') ADVANCE(103);
      if (lookahead == 'T') ADVANCE(104);
      if (lookahead == 'W') ADVANCE(99);
      if (lookahead == 'X') ADVANCE(111);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == '\\') ADVANCE(114);
      if (lookahead == ']') ADVANCE(156);
      if (lookahead == '^') ADVANCE(130);
      if (lookahead == '_') ADVANCE(122);
      if (lookahead == '{') ADVANCE(154);
      if (lookahead == '~') ADVANCE(134);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(116);
      END_STATE();
    case 25:
      if (lookahead == '\r') SKIP(26);
      if (lookahead == '!') ADVANCE(112);
      if (lookahead == '"') ADVANCE(113);
      if (lookahead == '$') ADVANCE(168);
      if (lookahead == '\'') ADVANCE(113);
      if (lookahead == '(') ADVANCE(161);
      if (lookahead == '*') ADVANCE(126);
      if (lookahead == '-') ADVANCE(91);
      if (lookahead == '.') ADVANCE(93);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == '<') ADVANCE(90);
      if (lookahead == '>') ADVANCE(181);
      if (lookahead == 'F') ADVANCE(100);
      if (lookahead == 'I') ADVANCE(102);
      if (lookahead == 'N') ADVANCE(103);
      if (lookahead == 'T') ADVANCE(104);
      if (lookahead == 'W') ADVANCE(99);
      if (lookahead == 'X') ADVANCE(111);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == '\\') ADVANCE(114);
      if (lookahead == '^') ADVANCE(130);
      if (lookahead == '_') ADVANCE(122);
      if (lookahead == '{') ADVANCE(154);
      if (lookahead == '~') ADVANCE(134);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(116);
      END_STATE();
    case 26:
      if (lookahead == '\r') SKIP(26);
      if (lookahead == '!') ADVANCE(112);
      if (lookahead == '"') ADVANCE(113);
      if (lookahead == '$') ADVANCE(168);
      if (lookahead == '\'') ADVANCE(113);
      if (lookahead == '(') ADVANCE(161);
      if (lookahead == '*') ADVANCE(126);
      if (lookahead == '-') ADVANCE(91);
      if (lookahead == '.') ADVANCE(93);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == '<') ADVANCE(90);
      if (lookahead == '>') ADVANCE(181);
      if (lookahead == 'F') ADVANCE(100);
      if (lookahead == 'I') ADVANCE(102);
      if (lookahead == 'N') ADVANCE(103);
      if (lookahead == 'T') ADVANCE(104);
      if (lookahead == 'W') ADVANCE(99);
      if (lookahead == 'X') ADVANCE(111);
      if (lookahead == '[') ADVANCE(51);
      if (lookahead == '\\') ADVANCE(114);
      if (lookahead == '^') ADVANCE(130);
      if (lookahead == '_') ADVANCE(122);
      if (lookahead == '{') ADVANCE(154);
      if (lookahead == '~') ADVANCE(134);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead)) ADVANCE(116);
      END_STATE();
    case 27:
      if (lookahead == '.') ADVANCE(81);
      END_STATE();
    case 28:
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 29:
      if (lookahead == ':') ADVANCE(60);
      END_STATE();
    case 30:
      if (lookahead == 'D') ADVANCE(36);
      END_STATE();
    case 31:
      if (lookahead == 'E') ADVANCE(173);
      END_STATE();
    case 32:
      if (lookahead == 'E') ADVANCE(179);
      END_STATE();
    case 33:
      if (lookahead == 'F') ADVANCE(35);
      END_STATE();
    case 34:
      if (lookahead == 'M') ADVANCE(32);
      END_STATE();
    case 35:
      if (lookahead == 'O') ADVANCE(175);
      END_STATE();
    case 36:
      if (lookahead == 'O') ADVANCE(169);
      END_STATE();
    case 37:
      if (lookahead == 'P') ADVANCE(171);
      END_STATE();
    case 38:
      if (lookahead == 'T') ADVANCE(31);
      END_STATE();
    case 39:
      if (lookahead == 'X') ADVANCE(34);
      END_STATE();
    case 40:
      if (lookahead == 'X') ADVANCE(177);
      END_STATE();
    case 41:
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '}') ADVANCE(72);
      END_STATE();
    case 42:
      if (lookahead != 0 &&
          lookahead != '|') ADVANCE(58);
      END_STATE();
    case 43:
      if (eof) ADVANCE(46);
      if ((!eof && lookahead == 00)) ADVANCE(59);
      if (lookahead == '\r') SKIP(43);
      if (lookahead == ' ') ADVANCE(56);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(73);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '%') ADVANCE(162);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(71);
      if (lookahead == ':') ADVANCE(67);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == '=') ADVANCE(61);
      if (lookahead == '>') ADVANCE(117);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(54);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') ADVANCE(195);
      if (lookahead == ']') ADVANCE(55);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == 'x') ADVANCE(52);
      if (lookahead == '{') ADVANCE(152);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(181);
      END_STATE();
    case 44:
      if (eof) ADVANCE(46);
      if (lookahead == '\r') SKIP(45);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(192);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(192);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(190);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') ADVANCE(193);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == '{') ADVANCE(182);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(181);
      END_STATE();
    case 45:
      if (eof) ADVANCE(46);
      if (lookahead == '\r') SKIP(45);
      if (lookahead == '!') ADVANCE(191);
      if (lookahead == '"') ADVANCE(192);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(192);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '-') ADVANCE(183);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == 'F') ADVANCE(185);
      if (lookahead == 'I') ADVANCE(187);
      if (lookahead == 'N') ADVANCE(188);
      if (lookahead == 'T') ADVANCE(189);
      if (lookahead == 'W') ADVANCE(186);
      if (lookahead == 'X') ADVANCE(190);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') ADVANCE(193);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '_') ADVANCE(121);
      if (lookahead == '{') ADVANCE(182);
      if (lookahead == '~') ADVANCE(133);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead)) ADVANCE(181);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(144);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(144);
      if (lookahead == '^') ADVANCE(141);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(147);
      if (lookahead == '^') ADVANCE(141);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(148);
      if (lookahead == '^') ADVANCE(142);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_x);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_X);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_X);
      if (lookahead == 'X') ADVANCE(40);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_SPACE);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_SPACE);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(aux_sym__table_cell_alignment_token1);
      if (lookahead != 0 &&
          lookahead != '|') ADVANCE(58);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_RBRACK_COLON);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_language);
      if (lookahead == '\r') ADVANCE(62);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != ' ' &&
          lookahead != '=' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(63);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_language);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != ' ' &&
          lookahead != '=' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(63);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(aux_sym__line_token1);
      if (lookahead == '\r') ADVANCE(64);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(65);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(aux_sym__line_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(65);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_link_destination);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(68);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(27);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '}') ADVANCE(72);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(aux_sym_value_token1);
      if (lookahead == '\r') ADVANCE(74);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"') ADVANCE(75);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(aux_sym_value_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"') ADVANCE(75);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(aux_sym_value_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(76);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym__whitespace);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(77);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym__whitespace1);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_quotation_marks);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_quotation_marks);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_ellipsis);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_ellipsis);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_em_dash);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_em_dash);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_en_dash);
      if (lookahead == '-') ADVANCE(83);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_en_dash);
      if (lookahead == '-') ADVANCE(84);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_backslash_escape);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_backslash_escape);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == '.') ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == ':') ADVANCE(116);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(94);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'D') ADVANCE(106);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'E') ADVANCE(174);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'E') ADVANCE(180);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'F') ADVANCE(105);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'I') ADVANCE(107);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'I') ADVANCE(109);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'M') ADVANCE(97);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'N') ADVANCE(98);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'O') ADVANCE(108);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'O') ADVANCE(95);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'O') ADVANCE(176);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'O') ADVANCE(170);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'P') ADVANCE(172);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'T') ADVANCE(96);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'X') ADVANCE(101);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'X') ADVANCE(178);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == 'X') ADVANCE(110);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == '[') ADVANCE(146);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == '"' ||
          lookahead == '\'') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == 0x0b ||
          lookahead == '\f' ||
          lookahead == ' ' ||
          lookahead == '>') ADVANCE(87);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(88);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(94);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(aux_sym_autolink_token1);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_symbol);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_LBRACE_);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_LBRACE_);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_LBRACE_STAR);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_LBRACE_STAR);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LBRACE_CARET);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LBRACE_CARET);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_LBRACE_TILDE);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_LBRACE_TILDE);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_LBRACE_EQ);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_LBRACE_EQ);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_LBRACE_PLUS);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_LBRACE_PLUS);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_LBRACE_DASH);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_LBRACE_DASH);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_LBRACK_CARET);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_LBRACK_CARET);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym__id);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(143);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_BANG_LBRACK);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_BANG_LBRACK);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK2);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK2);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '*') ADVANCE(123);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '=') ADVANCE(166);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '_') ADVANCE(119);
      if (lookahead == '~') ADVANCE(131);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      ADVANCE_MAP(
        '*', 123,
        '+', 137,
        '-', 139,
        '=', 166,
        '^', 127,
        '_', 119,
        '~', 131,
        '"', 79,
        '\'', 79,
      );
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '*') ADVANCE(123);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '=') ADVANCE(135);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '_') ADVANCE(119);
      if (lookahead == '~') ADVANCE(131);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      ADVANCE_MAP(
        '*', 123,
        '+', 137,
        '-', 139,
        '=', 135,
        '^', 127,
        '_', 119,
        '~', 131,
        '"', 79,
        '\'', 79,
      );
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      ADVANCE_MAP(
        '*', 124,
        '+', 138,
        '-', 140,
        '=', 136,
        '^', 128,
        '_', 120,
        '~', 132,
        '"', 80,
        '\'', 80,
      );
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '=' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_RBRACK2);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_RBRACK2);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym__inline_link_url_token1);
      if (lookahead == '\r') ADVANCE(157);
      if (lookahead == '\\') ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != ')') ADVANCE(158);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym__inline_link_url_token1);
      if (lookahead == '\\') ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != ')') ADVANCE(158);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym__inline_link_url_token1);
      if (lookahead == '\\') ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(158);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym__comment_token1);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym__comment_token1);
      if (lookahead == '\r') ADVANCE(164);
      if (lookahead == '\\') ADVANCE(165);
      if (lookahead != 0 &&
          lookahead != '%' &&
          lookahead != '}') ADVANCE(163);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym__comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(87);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_LBRACE_EQ2);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_TODO);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_TODO);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_WIP);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_WIP);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_NOTE);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_NOTE);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_INFO);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_INFO);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_XXX);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_XXX);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_fixme);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_fixme);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '>') ADVANCE(116);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(aux_sym__text_token1);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(aux_sym__text_token1);
      ADVANCE_MAP(
        '*', 123,
        '+', 137,
        '-', 139,
        '=', 135,
        '^', 127,
        '_', 119,
        '~', 131,
        '"', 79,
        '\'', 79,
      );
      END_STATE();
    case 183:
      ACCEPT_TOKEN(aux_sym__text_token1);
      if (lookahead == '-') ADVANCE(85);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(aux_sym__text_token1);
      if (lookahead == '.') ADVANCE(27);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(aux_sym__text_token1);
      if (lookahead == 'I') ADVANCE(39);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(aux_sym__text_token1);
      if (lookahead == 'I') ADVANCE(37);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(aux_sym__text_token1);
      if (lookahead == 'N') ADVANCE(33);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(aux_sym__text_token1);
      if (lookahead == 'O') ADVANCE(38);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(aux_sym__text_token1);
      if (lookahead == 'O') ADVANCE(30);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(aux_sym__text_token1);
      if (lookahead == 'X') ADVANCE(40);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(aux_sym__text_token1);
      if (lookahead == '[') ADVANCE(145);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(aux_sym__text_token1);
      if (lookahead == '}') ADVANCE(79);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(aux_sym__text_token1);
      if (lookahead == '"' ||
          lookahead == '\'') ADVANCE(79);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(87);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(aux_sym__text_token1);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(aux_sym__text_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(87);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 44, .external_lex_state = 2},
  [2] = {.lex_state = 44, .external_lex_state = 3},
  [3] = {.lex_state = 44, .external_lex_state = 3},
  [4] = {.lex_state = 44, .external_lex_state = 4},
  [5] = {.lex_state = 44, .external_lex_state = 4},
  [6] = {.lex_state = 44, .external_lex_state = 3},
  [7] = {.lex_state = 44, .external_lex_state = 3},
  [8] = {.lex_state = 44, .external_lex_state = 4},
  [9] = {.lex_state = 44, .external_lex_state = 4},
  [10] = {.lex_state = 44, .external_lex_state = 4},
  [11] = {.lex_state = 44, .external_lex_state = 4},
  [12] = {.lex_state = 44, .external_lex_state = 4},
  [13] = {.lex_state = 44, .external_lex_state = 4},
  [14] = {.lex_state = 44, .external_lex_state = 4},
  [15] = {.lex_state = 44, .external_lex_state = 4},
  [16] = {.lex_state = 44, .external_lex_state = 4},
  [17] = {.lex_state = 44, .external_lex_state = 4},
  [18] = {.lex_state = 44, .external_lex_state = 4},
  [19] = {.lex_state = 44, .external_lex_state = 4},
  [20] = {.lex_state = 44, .external_lex_state = 4},
  [21] = {.lex_state = 44, .external_lex_state = 4},
  [22] = {.lex_state = 44, .external_lex_state = 3},
  [23] = {.lex_state = 44, .external_lex_state = 3},
  [24] = {.lex_state = 44, .external_lex_state = 3},
  [25] = {.lex_state = 44, .external_lex_state = 3},
  [26] = {.lex_state = 44, .external_lex_state = 3},
  [27] = {.lex_state = 44, .external_lex_state = 3},
  [28] = {.lex_state = 44, .external_lex_state = 3},
  [29] = {.lex_state = 44, .external_lex_state = 3},
  [30] = {.lex_state = 44, .external_lex_state = 3},
  [31] = {.lex_state = 44, .external_lex_state = 3},
  [32] = {.lex_state = 44, .external_lex_state = 3},
  [33] = {.lex_state = 44, .external_lex_state = 3},
  [34] = {.lex_state = 44, .external_lex_state = 3},
  [35] = {.lex_state = 44, .external_lex_state = 3},
  [36] = {.lex_state = 44, .external_lex_state = 3},
  [37] = {.lex_state = 44, .external_lex_state = 3},
  [38] = {.lex_state = 44, .external_lex_state = 3},
  [39] = {.lex_state = 44, .external_lex_state = 3},
  [40] = {.lex_state = 44, .external_lex_state = 3},
  [41] = {.lex_state = 44, .external_lex_state = 3},
  [42] = {.lex_state = 44, .external_lex_state = 3},
  [43] = {.lex_state = 44, .external_lex_state = 3},
  [44] = {.lex_state = 44, .external_lex_state = 3},
  [45] = {.lex_state = 44, .external_lex_state = 3},
  [46] = {.lex_state = 44, .external_lex_state = 3},
  [47] = {.lex_state = 44, .external_lex_state = 3},
  [48] = {.lex_state = 44, .external_lex_state = 3},
  [49] = {.lex_state = 44, .external_lex_state = 3},
  [50] = {.lex_state = 44, .external_lex_state = 3},
  [51] = {.lex_state = 44, .external_lex_state = 3},
  [52] = {.lex_state = 44, .external_lex_state = 3},
  [53] = {.lex_state = 44, .external_lex_state = 3},
  [54] = {.lex_state = 44, .external_lex_state = 3},
  [55] = {.lex_state = 44, .external_lex_state = 3},
  [56] = {.lex_state = 44, .external_lex_state = 3},
  [57] = {.lex_state = 44, .external_lex_state = 3},
  [58] = {.lex_state = 44, .external_lex_state = 3},
  [59] = {.lex_state = 44, .external_lex_state = 3},
  [60] = {.lex_state = 44, .external_lex_state = 3},
  [61] = {.lex_state = 44, .external_lex_state = 3},
  [62] = {.lex_state = 44, .external_lex_state = 3},
  [63] = {.lex_state = 44, .external_lex_state = 3},
  [64] = {.lex_state = 44, .external_lex_state = 3},
  [65] = {.lex_state = 44, .external_lex_state = 3},
  [66] = {.lex_state = 44, .external_lex_state = 3},
  [67] = {.lex_state = 44, .external_lex_state = 3},
  [68] = {.lex_state = 44, .external_lex_state = 3},
  [69] = {.lex_state = 44, .external_lex_state = 3},
  [70] = {.lex_state = 44, .external_lex_state = 4},
  [71] = {.lex_state = 44, .external_lex_state = 3},
  [72] = {.lex_state = 44, .external_lex_state = 3},
  [73] = {.lex_state = 44, .external_lex_state = 5},
  [74] = {.lex_state = 44, .external_lex_state = 5},
  [75] = {.lex_state = 44, .external_lex_state = 3},
  [76] = {.lex_state = 44, .external_lex_state = 3},
  [77] = {.lex_state = 44, .external_lex_state = 5},
  [78] = {.lex_state = 44, .external_lex_state = 5},
  [79] = {.lex_state = 44, .external_lex_state = 5},
  [80] = {.lex_state = 44, .external_lex_state = 6},
  [81] = {.lex_state = 44, .external_lex_state = 7},
  [82] = {.lex_state = 44, .external_lex_state = 7},
  [83] = {.lex_state = 44, .external_lex_state = 7},
  [84] = {.lex_state = 44, .external_lex_state = 7},
  [85] = {.lex_state = 44, .external_lex_state = 7},
  [86] = {.lex_state = 44, .external_lex_state = 7},
  [87] = {.lex_state = 44, .external_lex_state = 7},
  [88] = {.lex_state = 44, .external_lex_state = 7},
  [89] = {.lex_state = 44, .external_lex_state = 7},
  [90] = {.lex_state = 44, .external_lex_state = 7},
  [91] = {.lex_state = 44, .external_lex_state = 8},
  [92] = {.lex_state = 44, .external_lex_state = 8},
  [93] = {.lex_state = 44, .external_lex_state = 8},
  [94] = {.lex_state = 44, .external_lex_state = 8},
  [95] = {.lex_state = 44, .external_lex_state = 8},
  [96] = {.lex_state = 1, .external_lex_state = 9},
  [97] = {.lex_state = 44, .external_lex_state = 10},
  [98] = {.lex_state = 1, .external_lex_state = 9},
  [99] = {.lex_state = 1, .external_lex_state = 9},
  [100] = {.lex_state = 1, .external_lex_state = 9},
  [101] = {.lex_state = 1, .external_lex_state = 9},
  [102] = {.lex_state = 1, .external_lex_state = 9},
  [103] = {.lex_state = 44, .external_lex_state = 11},
  [104] = {.lex_state = 44, .external_lex_state = 11},
  [105] = {.lex_state = 44, .external_lex_state = 11},
  [106] = {.lex_state = 44, .external_lex_state = 11},
  [107] = {.lex_state = 44, .external_lex_state = 11},
  [108] = {.lex_state = 44, .external_lex_state = 11},
  [109] = {.lex_state = 44, .external_lex_state = 10},
  [110] = {.lex_state = 44, .external_lex_state = 11},
  [111] = {.lex_state = 44, .external_lex_state = 11},
  [112] = {.lex_state = 44, .external_lex_state = 11},
  [113] = {.lex_state = 44, .external_lex_state = 11},
  [114] = {.lex_state = 44, .external_lex_state = 11},
  [115] = {.lex_state = 44, .external_lex_state = 11},
  [116] = {.lex_state = 44, .external_lex_state = 11},
  [117] = {.lex_state = 44, .external_lex_state = 11},
  [118] = {.lex_state = 44, .external_lex_state = 11},
  [119] = {.lex_state = 44, .external_lex_state = 11},
  [120] = {.lex_state = 44, .external_lex_state = 11},
  [121] = {.lex_state = 44, .external_lex_state = 11},
  [122] = {.lex_state = 44, .external_lex_state = 11},
  [123] = {.lex_state = 44, .external_lex_state = 11},
  [124] = {.lex_state = 44, .external_lex_state = 11},
  [125] = {.lex_state = 44, .external_lex_state = 12},
  [126] = {.lex_state = 44, .external_lex_state = 12},
  [127] = {.lex_state = 44, .external_lex_state = 12},
  [128] = {.lex_state = 44, .external_lex_state = 12},
  [129] = {.lex_state = 44, .external_lex_state = 12},
  [130] = {.lex_state = 44, .external_lex_state = 12},
  [131] = {.lex_state = 44, .external_lex_state = 12},
  [132] = {.lex_state = 44, .external_lex_state = 12},
  [133] = {.lex_state = 44, .external_lex_state = 12},
  [134] = {.lex_state = 44, .external_lex_state = 13},
  [135] = {.lex_state = 44, .external_lex_state = 12},
  [136] = {.lex_state = 44, .external_lex_state = 14},
  [137] = {.lex_state = 44, .external_lex_state = 15},
  [138] = {.lex_state = 44, .external_lex_state = 12},
  [139] = {.lex_state = 44, .external_lex_state = 12},
  [140] = {.lex_state = 44, .external_lex_state = 16},
  [141] = {.lex_state = 44, .external_lex_state = 17},
  [142] = {.lex_state = 44, .external_lex_state = 17},
  [143] = {.lex_state = 44, .external_lex_state = 18},
  [144] = {.lex_state = 44, .external_lex_state = 18},
  [145] = {.lex_state = 44, .external_lex_state = 14},
  [146] = {.lex_state = 44, .external_lex_state = 19},
  [147] = {.lex_state = 44, .external_lex_state = 19},
  [148] = {.lex_state = 44, .external_lex_state = 20},
  [149] = {.lex_state = 44, .external_lex_state = 20},
  [150] = {.lex_state = 44, .external_lex_state = 21},
  [151] = {.lex_state = 44, .external_lex_state = 21},
  [152] = {.lex_state = 44, .external_lex_state = 22},
  [153] = {.lex_state = 44, .external_lex_state = 22},
  [154] = {.lex_state = 44, .external_lex_state = 12},
  [155] = {.lex_state = 44, .external_lex_state = 23},
  [156] = {.lex_state = 44, .external_lex_state = 23},
  [157] = {.lex_state = 3, .external_lex_state = 12},
  [158] = {.lex_state = 3, .external_lex_state = 12},
  [159] = {.lex_state = 44, .external_lex_state = 15},
  [160] = {.lex_state = 44, .external_lex_state = 15},
  [161] = {.lex_state = 44, .external_lex_state = 12},
  [162] = {.lex_state = 44, .external_lex_state = 12},
  [163] = {.lex_state = 44, .external_lex_state = 12},
  [164] = {.lex_state = 44, .external_lex_state = 12},
  [165] = {.lex_state = 44, .external_lex_state = 12},
  [166] = {.lex_state = 44, .external_lex_state = 12},
  [167] = {.lex_state = 44, .external_lex_state = 12},
  [168] = {.lex_state = 44, .external_lex_state = 12},
  [169] = {.lex_state = 44, .external_lex_state = 13},
  [170] = {.lex_state = 44, .external_lex_state = 16},
  [171] = {.lex_state = 44, .external_lex_state = 16},
  [172] = {.lex_state = 44, .external_lex_state = 12},
  [173] = {.lex_state = 44, .external_lex_state = 12},
  [174] = {.lex_state = 44, .external_lex_state = 12},
  [175] = {.lex_state = 44, .external_lex_state = 12},
  [176] = {.lex_state = 44, .external_lex_state = 12},
  [177] = {.lex_state = 44, .external_lex_state = 12},
  [178] = {.lex_state = 44, .external_lex_state = 12},
  [179] = {.lex_state = 44, .external_lex_state = 12},
  [180] = {.lex_state = 44, .external_lex_state = 12},
  [181] = {.lex_state = 44, .external_lex_state = 12},
  [182] = {.lex_state = 44, .external_lex_state = 12},
  [183] = {.lex_state = 44, .external_lex_state = 12},
  [184] = {.lex_state = 44, .external_lex_state = 12},
  [185] = {.lex_state = 44, .external_lex_state = 12},
  [186] = {.lex_state = 44, .external_lex_state = 12},
  [187] = {.lex_state = 44, .external_lex_state = 12},
  [188] = {.lex_state = 44, .external_lex_state = 12},
  [189] = {.lex_state = 44, .external_lex_state = 12},
  [190] = {.lex_state = 44, .external_lex_state = 12},
  [191] = {.lex_state = 44, .external_lex_state = 12},
  [192] = {.lex_state = 44, .external_lex_state = 12},
  [193] = {.lex_state = 44, .external_lex_state = 12},
  [194] = {.lex_state = 44, .external_lex_state = 12},
  [195] = {.lex_state = 44, .external_lex_state = 12},
  [196] = {.lex_state = 44, .external_lex_state = 12},
  [197] = {.lex_state = 44, .external_lex_state = 12},
  [198] = {.lex_state = 44, .external_lex_state = 12},
  [199] = {.lex_state = 44, .external_lex_state = 12},
  [200] = {.lex_state = 44, .external_lex_state = 12},
  [201] = {.lex_state = 44, .external_lex_state = 12},
  [202] = {.lex_state = 44, .external_lex_state = 12},
  [203] = {.lex_state = 44, .external_lex_state = 12},
  [204] = {.lex_state = 44, .external_lex_state = 12},
  [205] = {.lex_state = 44, .external_lex_state = 12},
  [206] = {.lex_state = 44, .external_lex_state = 12},
  [207] = {.lex_state = 44, .external_lex_state = 12},
  [208] = {.lex_state = 44, .external_lex_state = 12},
  [209] = {.lex_state = 44, .external_lex_state = 12},
  [210] = {.lex_state = 44, .external_lex_state = 12},
  [211] = {.lex_state = 44, .external_lex_state = 12},
  [212] = {.lex_state = 44, .external_lex_state = 12},
  [213] = {.lex_state = 44, .external_lex_state = 12},
  [214] = {.lex_state = 44, .external_lex_state = 12},
  [215] = {.lex_state = 44, .external_lex_state = 12},
  [216] = {.lex_state = 44, .external_lex_state = 12},
  [217] = {.lex_state = 44, .external_lex_state = 12},
  [218] = {.lex_state = 44, .external_lex_state = 12},
  [219] = {.lex_state = 44, .external_lex_state = 12},
  [220] = {.lex_state = 44, .external_lex_state = 12},
  [221] = {.lex_state = 44, .external_lex_state = 12},
  [222] = {.lex_state = 44, .external_lex_state = 12},
  [223] = {.lex_state = 44, .external_lex_state = 12},
  [224] = {.lex_state = 44, .external_lex_state = 12},
  [225] = {.lex_state = 44, .external_lex_state = 12},
  [226] = {.lex_state = 44, .external_lex_state = 12},
  [227] = {.lex_state = 44, .external_lex_state = 12},
  [228] = {.lex_state = 44, .external_lex_state = 12},
  [229] = {.lex_state = 44, .external_lex_state = 12},
  [230] = {.lex_state = 44, .external_lex_state = 12},
  [231] = {.lex_state = 44, .external_lex_state = 12},
  [232] = {.lex_state = 44, .external_lex_state = 12},
  [233] = {.lex_state = 44, .external_lex_state = 12},
  [234] = {.lex_state = 44, .external_lex_state = 12},
  [235] = {.lex_state = 44, .external_lex_state = 12},
  [236] = {.lex_state = 44, .external_lex_state = 12},
  [237] = {.lex_state = 44, .external_lex_state = 12},
  [238] = {.lex_state = 44, .external_lex_state = 12},
  [239] = {.lex_state = 44, .external_lex_state = 12},
  [240] = {.lex_state = 44, .external_lex_state = 12},
  [241] = {.lex_state = 44, .external_lex_state = 12},
  [242] = {.lex_state = 44, .external_lex_state = 12},
  [243] = {.lex_state = 44, .external_lex_state = 12},
  [244] = {.lex_state = 44, .external_lex_state = 12},
  [245] = {.lex_state = 44, .external_lex_state = 12},
  [246] = {.lex_state = 44, .external_lex_state = 12},
  [247] = {.lex_state = 44, .external_lex_state = 12},
  [248] = {.lex_state = 44, .external_lex_state = 12},
  [249] = {.lex_state = 44, .external_lex_state = 12},
  [250] = {.lex_state = 44, .external_lex_state = 12},
  [251] = {.lex_state = 44, .external_lex_state = 12},
  [252] = {.lex_state = 44, .external_lex_state = 12},
  [253] = {.lex_state = 44, .external_lex_state = 12},
  [254] = {.lex_state = 44, .external_lex_state = 12},
  [255] = {.lex_state = 44, .external_lex_state = 12},
  [256] = {.lex_state = 44, .external_lex_state = 12},
  [257] = {.lex_state = 44, .external_lex_state = 12},
  [258] = {.lex_state = 44, .external_lex_state = 12},
  [259] = {.lex_state = 44, .external_lex_state = 12},
  [260] = {.lex_state = 44, .external_lex_state = 12},
  [261] = {.lex_state = 44, .external_lex_state = 12},
  [262] = {.lex_state = 44, .external_lex_state = 12},
  [263] = {.lex_state = 44, .external_lex_state = 12},
  [264] = {.lex_state = 44, .external_lex_state = 12},
  [265] = {.lex_state = 44, .external_lex_state = 12},
  [266] = {.lex_state = 44, .external_lex_state = 12},
  [267] = {.lex_state = 44, .external_lex_state = 12},
  [268] = {.lex_state = 44, .external_lex_state = 12},
  [269] = {.lex_state = 44, .external_lex_state = 12},
  [270] = {.lex_state = 44, .external_lex_state = 12},
  [271] = {.lex_state = 44, .external_lex_state = 12},
  [272] = {.lex_state = 44, .external_lex_state = 12},
  [273] = {.lex_state = 44, .external_lex_state = 12},
  [274] = {.lex_state = 44, .external_lex_state = 12},
  [275] = {.lex_state = 44, .external_lex_state = 12},
  [276] = {.lex_state = 44, .external_lex_state = 12},
  [277] = {.lex_state = 44, .external_lex_state = 12},
  [278] = {.lex_state = 44, .external_lex_state = 12},
  [279] = {.lex_state = 44, .external_lex_state = 12},
  [280] = {.lex_state = 44, .external_lex_state = 12},
  [281] = {.lex_state = 44, .external_lex_state = 12},
  [282] = {.lex_state = 44, .external_lex_state = 12},
  [283] = {.lex_state = 44, .external_lex_state = 12},
  [284] = {.lex_state = 44, .external_lex_state = 12},
  [285] = {.lex_state = 44, .external_lex_state = 12},
  [286] = {.lex_state = 44, .external_lex_state = 12},
  [287] = {.lex_state = 44, .external_lex_state = 12},
  [288] = {.lex_state = 44, .external_lex_state = 13},
  [289] = {.lex_state = 44, .external_lex_state = 14},
  [290] = {.lex_state = 44, .external_lex_state = 24},
  [291] = {.lex_state = 44, .external_lex_state = 13},
  [292] = {.lex_state = 44, .external_lex_state = 13},
  [293] = {.lex_state = 44, .external_lex_state = 25},
  [294] = {.lex_state = 44, .external_lex_state = 13},
  [295] = {.lex_state = 44, .external_lex_state = 26},
  [296] = {.lex_state = 44, .external_lex_state = 26},
  [297] = {.lex_state = 44, .external_lex_state = 26},
  [298] = {.lex_state = 44, .external_lex_state = 14},
  [299] = {.lex_state = 44, .external_lex_state = 14},
  [300] = {.lex_state = 44, .external_lex_state = 14},
  [301] = {.lex_state = 44, .external_lex_state = 14},
  [302] = {.lex_state = 44, .external_lex_state = 25},
  [303] = {.lex_state = 44, .external_lex_state = 25},
  [304] = {.lex_state = 44, .external_lex_state = 27},
  [305] = {.lex_state = 44, .external_lex_state = 27},
  [306] = {.lex_state = 44, .external_lex_state = 13},
  [307] = {.lex_state = 44, .external_lex_state = 14},
  [308] = {.lex_state = 44, .external_lex_state = 14},
  [309] = {.lex_state = 44, .external_lex_state = 14},
  [310] = {.lex_state = 44, .external_lex_state = 28},
  [311] = {.lex_state = 44, .external_lex_state = 27},
  [312] = {.lex_state = 44, .external_lex_state = 28},
  [313] = {.lex_state = 44, .external_lex_state = 28},
  [314] = {.lex_state = 44, .external_lex_state = 26},
  [315] = {.lex_state = 44, .external_lex_state = 26},
  [316] = {.lex_state = 44, .external_lex_state = 26},
  [317] = {.lex_state = 44, .external_lex_state = 27},
  [318] = {.lex_state = 44, .external_lex_state = 27},
  [319] = {.lex_state = 44, .external_lex_state = 25},
  [320] = {.lex_state = 44, .external_lex_state = 27},
  [321] = {.lex_state = 44, .external_lex_state = 13},
  [322] = {.lex_state = 44, .external_lex_state = 28},
  [323] = {.lex_state = 44, .external_lex_state = 13},
  [324] = {.lex_state = 44, .external_lex_state = 13},
  [325] = {.lex_state = 44, .external_lex_state = 4},
  [326] = {.lex_state = 44, .external_lex_state = 3},
  [327] = {.lex_state = 44, .external_lex_state = 3},
  [328] = {.lex_state = 44, .external_lex_state = 3},
  [329] = {.lex_state = 44, .external_lex_state = 4},
  [330] = {.lex_state = 44, .external_lex_state = 3},
  [331] = {.lex_state = 44, .external_lex_state = 4},
  [332] = {.lex_state = 44, .external_lex_state = 4},
  [333] = {.lex_state = 44, .external_lex_state = 3},
  [334] = {.lex_state = 44, .external_lex_state = 3},
  [335] = {.lex_state = 44, .external_lex_state = 3},
  [336] = {.lex_state = 44, .external_lex_state = 3},
  [337] = {.lex_state = 44, .external_lex_state = 3},
  [338] = {.lex_state = 44, .external_lex_state = 3},
  [339] = {.lex_state = 44, .external_lex_state = 3},
  [340] = {.lex_state = 44, .external_lex_state = 3},
  [341] = {.lex_state = 44, .external_lex_state = 3},
  [342] = {.lex_state = 44, .external_lex_state = 3},
  [343] = {.lex_state = 44, .external_lex_state = 3},
  [344] = {.lex_state = 44, .external_lex_state = 3},
  [345] = {.lex_state = 44, .external_lex_state = 3},
  [346] = {.lex_state = 44, .external_lex_state = 3},
  [347] = {.lex_state = 44, .external_lex_state = 3},
  [348] = {.lex_state = 44, .external_lex_state = 3},
  [349] = {.lex_state = 44, .external_lex_state = 3},
  [350] = {.lex_state = 44, .external_lex_state = 3},
  [351] = {.lex_state = 44, .external_lex_state = 3},
  [352] = {.lex_state = 44, .external_lex_state = 3},
  [353] = {.lex_state = 44, .external_lex_state = 3},
  [354] = {.lex_state = 44, .external_lex_state = 3},
  [355] = {.lex_state = 44, .external_lex_state = 3},
  [356] = {.lex_state = 44, .external_lex_state = 3},
  [357] = {.lex_state = 44, .external_lex_state = 3},
  [358] = {.lex_state = 44, .external_lex_state = 3},
  [359] = {.lex_state = 44, .external_lex_state = 4},
  [360] = {.lex_state = 44, .external_lex_state = 4},
  [361] = {.lex_state = 44, .external_lex_state = 3},
  [362] = {.lex_state = 44, .external_lex_state = 4},
  [363] = {.lex_state = 44, .external_lex_state = 3},
  [364] = {.lex_state = 44, .external_lex_state = 3},
  [365] = {.lex_state = 44, .external_lex_state = 3},
  [366] = {.lex_state = 44, .external_lex_state = 3},
  [367] = {.lex_state = 44, .external_lex_state = 3},
  [368] = {.lex_state = 44, .external_lex_state = 4},
  [369] = {.lex_state = 44, .external_lex_state = 4},
  [370] = {.lex_state = 44, .external_lex_state = 4},
  [371] = {.lex_state = 44, .external_lex_state = 4},
  [372] = {.lex_state = 44, .external_lex_state = 4},
  [373] = {.lex_state = 44, .external_lex_state = 4},
  [374] = {.lex_state = 44, .external_lex_state = 3},
  [375] = {.lex_state = 44, .external_lex_state = 4},
  [376] = {.lex_state = 44, .external_lex_state = 4},
  [377] = {.lex_state = 44, .external_lex_state = 4},
  [378] = {.lex_state = 44, .external_lex_state = 4},
  [379] = {.lex_state = 44, .external_lex_state = 4},
  [380] = {.lex_state = 44, .external_lex_state = 4},
  [381] = {.lex_state = 44, .external_lex_state = 4},
  [382] = {.lex_state = 44, .external_lex_state = 4},
  [383] = {.lex_state = 44, .external_lex_state = 4},
  [384] = {.lex_state = 44, .external_lex_state = 4},
  [385] = {.lex_state = 44, .external_lex_state = 4},
  [386] = {.lex_state = 44, .external_lex_state = 4},
  [387] = {.lex_state = 44, .external_lex_state = 4},
  [388] = {.lex_state = 44, .external_lex_state = 4},
  [389] = {.lex_state = 44, .external_lex_state = 4},
  [390] = {.lex_state = 44, .external_lex_state = 4},
  [391] = {.lex_state = 44, .external_lex_state = 3},
  [392] = {.lex_state = 44, .external_lex_state = 4},
  [393] = {.lex_state = 44, .external_lex_state = 3},
  [394] = {.lex_state = 44, .external_lex_state = 3},
  [395] = {.lex_state = 44, .external_lex_state = 4},
  [396] = {.lex_state = 44, .external_lex_state = 3},
  [397] = {.lex_state = 44, .external_lex_state = 3},
  [398] = {.lex_state = 44, .external_lex_state = 3},
  [399] = {.lex_state = 44, .external_lex_state = 4},
  [400] = {.lex_state = 44, .external_lex_state = 3},
  [401] = {.lex_state = 44, .external_lex_state = 4},
  [402] = {.lex_state = 44, .external_lex_state = 3},
  [403] = {.lex_state = 44, .external_lex_state = 4},
  [404] = {.lex_state = 44, .external_lex_state = 3},
  [405] = {.lex_state = 44, .external_lex_state = 3},
  [406] = {.lex_state = 44, .external_lex_state = 4},
  [407] = {.lex_state = 44, .external_lex_state = 4},
  [408] = {.lex_state = 44, .external_lex_state = 3},
  [409] = {.lex_state = 44, .external_lex_state = 3},
  [410] = {.lex_state = 44, .external_lex_state = 4},
  [411] = {.lex_state = 44, .external_lex_state = 3},
  [412] = {.lex_state = 44, .external_lex_state = 4},
  [413] = {.lex_state = 44, .external_lex_state = 3},
  [414] = {.lex_state = 44, .external_lex_state = 4},
  [415] = {.lex_state = 44, .external_lex_state = 4},
  [416] = {.lex_state = 44, .external_lex_state = 4},
  [417] = {.lex_state = 44, .external_lex_state = 4},
  [418] = {.lex_state = 44, .external_lex_state = 4},
  [419] = {.lex_state = 44, .external_lex_state = 4},
  [420] = {.lex_state = 44, .external_lex_state = 4},
  [421] = {.lex_state = 44, .external_lex_state = 4},
  [422] = {.lex_state = 44, .external_lex_state = 4},
  [423] = {.lex_state = 44, .external_lex_state = 4},
  [424] = {.lex_state = 44, .external_lex_state = 4},
  [425] = {.lex_state = 44, .external_lex_state = 4},
  [426] = {.lex_state = 44, .external_lex_state = 4},
  [427] = {.lex_state = 44, .external_lex_state = 4},
  [428] = {.lex_state = 44, .external_lex_state = 3},
  [429] = {.lex_state = 44, .external_lex_state = 6},
  [430] = {.lex_state = 44, .external_lex_state = 6},
  [431] = {.lex_state = 44, .external_lex_state = 29},
  [432] = {.lex_state = 44, .external_lex_state = 29},
  [433] = {.lex_state = 44, .external_lex_state = 30},
  [434] = {.lex_state = 44, .external_lex_state = 30},
  [435] = {.lex_state = 44, .external_lex_state = 29},
  [436] = {.lex_state = 44, .external_lex_state = 30},
  [437] = {.lex_state = 21, .external_lex_state = 18},
  [438] = {.lex_state = 21, .external_lex_state = 16},
  [439] = {.lex_state = 21, .external_lex_state = 22},
  [440] = {.lex_state = 19, .external_lex_state = 12},
  [441] = {.lex_state = 21, .external_lex_state = 23},
  [442] = {.lex_state = 21, .external_lex_state = 15},
  [443] = {.lex_state = 21, .external_lex_state = 17},
  [444] = {.lex_state = 21, .external_lex_state = 31},
  [445] = {.lex_state = 21, .external_lex_state = 32},
  [446] = {.lex_state = 21, .external_lex_state = 19},
  [447] = {.lex_state = 21, .external_lex_state = 20},
  [448] = {.lex_state = 21, .external_lex_state = 21},
  [449] = {.lex_state = 21, .external_lex_state = 22},
  [450] = {.lex_state = 21, .external_lex_state = 21},
  [451] = {.lex_state = 21, .external_lex_state = 22},
  [452] = {.lex_state = 21, .external_lex_state = 18},
  [453] = {.lex_state = 21, .external_lex_state = 18},
  [454] = {.lex_state = 21, .external_lex_state = 23},
  [455] = {.lex_state = 21, .external_lex_state = 23},
  [456] = {.lex_state = 19, .external_lex_state = 12},
  [457] = {.lex_state = 19, .external_lex_state = 12},
  [458] = {.lex_state = 21, .external_lex_state = 15},
  [459] = {.lex_state = 21, .external_lex_state = 16},
  [460] = {.lex_state = 21, .external_lex_state = 31},
  [461] = {.lex_state = 21, .external_lex_state = 17},
  [462] = {.lex_state = 21, .external_lex_state = 15},
  [463] = {.lex_state = 21, .external_lex_state = 31},
  [464] = {.lex_state = 21, .external_lex_state = 32},
  [465] = {.lex_state = 21, .external_lex_state = 32},
  [466] = {.lex_state = 21, .external_lex_state = 12},
  [467] = {.lex_state = 21, .external_lex_state = 16},
  [468] = {.lex_state = 21, .external_lex_state = 19},
  [469] = {.lex_state = 21, .external_lex_state = 19},
  [470] = {.lex_state = 21, .external_lex_state = 20},
  [471] = {.lex_state = 21, .external_lex_state = 20},
  [472] = {.lex_state = 21, .external_lex_state = 17},
  [473] = {.lex_state = 21, .external_lex_state = 21},
  [474] = {.lex_state = 23, .external_lex_state = 32},
  [475] = {.lex_state = 23, .external_lex_state = 17},
  [476] = {.lex_state = 20, .external_lex_state = 12},
  [477] = {.lex_state = 23, .external_lex_state = 16},
  [478] = {.lex_state = 23, .external_lex_state = 21},
  [479] = {.lex_state = 23, .external_lex_state = 22},
  [480] = {.lex_state = 23, .external_lex_state = 23},
  [481] = {.lex_state = 23, .external_lex_state = 19},
  [482] = {.lex_state = 23, .external_lex_state = 15},
  [483] = {.lex_state = 21, .external_lex_state = 12},
  [484] = {.lex_state = 21, .external_lex_state = 12},
  [485] = {.lex_state = 23, .external_lex_state = 20},
  [486] = {.lex_state = 23, .external_lex_state = 18},
  [487] = {.lex_state = 23, .external_lex_state = 31},
  [488] = {.lex_state = 18, .external_lex_state = 15},
  [489] = {.lex_state = 21, .external_lex_state = 33},
  [490] = {.lex_state = 6, .external_lex_state = 22},
  [491] = {.lex_state = 6, .external_lex_state = 18},
  [492] = {.lex_state = 21, .external_lex_state = 16},
  [493] = {.lex_state = 21, .external_lex_state = 18},
  [494] = {.lex_state = 6, .external_lex_state = 16},
  [495] = {.lex_state = 21, .external_lex_state = 22},
  [496] = {.lex_state = 21, .external_lex_state = 31},
  [497] = {.lex_state = 25, .external_lex_state = 15},
  [498] = {.lex_state = 21, .external_lex_state = 34},
  [499] = {.lex_state = 21, .external_lex_state = 34},
  [500] = {.lex_state = 25, .external_lex_state = 23},
  [501] = {.lex_state = 25, .external_lex_state = 31},
  [502] = {.lex_state = 21, .external_lex_state = 35},
  [503] = {.lex_state = 21, .external_lex_state = 36},
  [504] = {.lex_state = 21, .external_lex_state = 36},
  [505] = {.lex_state = 6, .external_lex_state = 31},
  [506] = {.lex_state = 21, .external_lex_state = 35},
  [507] = {.lex_state = 18, .external_lex_state = 23},
  [508] = {.lex_state = 18, .external_lex_state = 31},
  [509] = {.lex_state = 18, .external_lex_state = 22},
  [510] = {.lex_state = 6, .external_lex_state = 15},
  [511] = {.lex_state = 25, .external_lex_state = 18},
  [512] = {.lex_state = 21, .external_lex_state = 15},
  [513] = {.lex_state = 21, .external_lex_state = 21},
  [514] = {.lex_state = 21, .external_lex_state = 17},
  [515] = {.lex_state = 6, .external_lex_state = 23},
  [516] = {.lex_state = 21, .external_lex_state = 23},
  [517] = {.lex_state = 25, .external_lex_state = 32},
  [518] = {.lex_state = 21, .external_lex_state = 37},
  [519] = {.lex_state = 21, .external_lex_state = 37},
  [520] = {.lex_state = 18, .external_lex_state = 32},
  [521] = {.lex_state = 25, .external_lex_state = 22},
  [522] = {.lex_state = 21, .external_lex_state = 38},
  [523] = {.lex_state = 25, .external_lex_state = 17},
  [524] = {.lex_state = 6, .external_lex_state = 32},
  [525] = {.lex_state = 21, .external_lex_state = 38},
  [526] = {.lex_state = 21, .external_lex_state = 32},
  [527] = {.lex_state = 21, .external_lex_state = 39},
  [528] = {.lex_state = 6, .external_lex_state = 17},
  [529] = {.lex_state = 25, .external_lex_state = 16},
  [530] = {.lex_state = 25, .external_lex_state = 19},
  [531] = {.lex_state = 21, .external_lex_state = 40},
  [532] = {.lex_state = 21, .external_lex_state = 40},
  [533] = {.lex_state = 18, .external_lex_state = 19},
  [534] = {.lex_state = 19, .external_lex_state = 41},
  [535] = {.lex_state = 23, .external_lex_state = 12},
  [536] = {.lex_state = 21, .external_lex_state = 39},
  [537] = {.lex_state = 6, .external_lex_state = 19},
  [538] = {.lex_state = 21, .external_lex_state = 19},
  [539] = {.lex_state = 18, .external_lex_state = 17},
  [540] = {.lex_state = 19, .external_lex_state = 41},
  [541] = {.lex_state = 17, .external_lex_state = 12},
  [542] = {.lex_state = 25, .external_lex_state = 20},
  [543] = {.lex_state = 21, .external_lex_state = 42},
  [544] = {.lex_state = 21, .external_lex_state = 42},
  [545] = {.lex_state = 18, .external_lex_state = 20},
  [546] = {.lex_state = 18, .external_lex_state = 18},
  [547] = {.lex_state = 6, .external_lex_state = 21},
  [548] = {.lex_state = 21, .external_lex_state = 43},
  [549] = {.lex_state = 6, .external_lex_state = 20},
  [550] = {.lex_state = 21, .external_lex_state = 20},
  [551] = {.lex_state = 21, .external_lex_state = 33},
  [552] = {.lex_state = 21, .external_lex_state = 43},
  [553] = {.lex_state = 18, .external_lex_state = 16},
  [554] = {.lex_state = 25, .external_lex_state = 21},
  [555] = {.lex_state = 21, .external_lex_state = 44},
  [556] = {.lex_state = 21, .external_lex_state = 44},
  [557] = {.lex_state = 18, .external_lex_state = 21},
  [558] = {.lex_state = 5, .external_lex_state = 12},
  [559] = {.lex_state = 19, .external_lex_state = 12},
  [560] = {.lex_state = 24, .external_lex_state = 12},
  [561] = {.lex_state = 44, .external_lex_state = 45},
  [562] = {.lex_state = 21, .external_lex_state = 31},
  [563] = {.lex_state = 21, .external_lex_state = 31},
  [564] = {.lex_state = 21, .external_lex_state = 31},
  [565] = {.lex_state = 21, .external_lex_state = 31},
  [566] = {.lex_state = 21, .external_lex_state = 31},
  [567] = {.lex_state = 21, .external_lex_state = 31},
  [568] = {.lex_state = 21, .external_lex_state = 16},
  [569] = {.lex_state = 21, .external_lex_state = 31},
  [570] = {.lex_state = 21, .external_lex_state = 31},
  [571] = {.lex_state = 21, .external_lex_state = 16},
  [572] = {.lex_state = 21, .external_lex_state = 16},
  [573] = {.lex_state = 21, .external_lex_state = 31},
  [574] = {.lex_state = 21, .external_lex_state = 31},
  [575] = {.lex_state = 21, .external_lex_state = 16},
  [576] = {.lex_state = 21, .external_lex_state = 31},
  [577] = {.lex_state = 21, .external_lex_state = 31},
  [578] = {.lex_state = 21, .external_lex_state = 31},
  [579] = {.lex_state = 21, .external_lex_state = 31},
  [580] = {.lex_state = 21, .external_lex_state = 31},
  [581] = {.lex_state = 21, .external_lex_state = 31},
  [582] = {.lex_state = 21, .external_lex_state = 31},
  [583] = {.lex_state = 21, .external_lex_state = 31},
  [584] = {.lex_state = 21, .external_lex_state = 31},
  [585] = {.lex_state = 21, .external_lex_state = 31},
  [586] = {.lex_state = 21, .external_lex_state = 31},
  [587] = {.lex_state = 21, .external_lex_state = 31},
  [588] = {.lex_state = 44, .external_lex_state = 46},
  [589] = {.lex_state = 21, .external_lex_state = 32},
  [590] = {.lex_state = 21, .external_lex_state = 32},
  [591] = {.lex_state = 21, .external_lex_state = 32},
  [592] = {.lex_state = 1, .external_lex_state = 9},
  [593] = {.lex_state = 21, .external_lex_state = 32},
  [594] = {.lex_state = 21, .external_lex_state = 32},
  [595] = {.lex_state = 21, .external_lex_state = 32},
  [596] = {.lex_state = 21, .external_lex_state = 32},
  [597] = {.lex_state = 21, .external_lex_state = 32},
  [598] = {.lex_state = 21, .external_lex_state = 32},
  [599] = {.lex_state = 21, .external_lex_state = 32},
  [600] = {.lex_state = 21, .external_lex_state = 32},
  [601] = {.lex_state = 21, .external_lex_state = 32},
  [602] = {.lex_state = 21, .external_lex_state = 32},
  [603] = {.lex_state = 21, .external_lex_state = 32},
  [604] = {.lex_state = 21, .external_lex_state = 32},
  [605] = {.lex_state = 21, .external_lex_state = 32},
  [606] = {.lex_state = 21, .external_lex_state = 32},
  [607] = {.lex_state = 21, .external_lex_state = 32},
  [608] = {.lex_state = 21, .external_lex_state = 32},
  [609] = {.lex_state = 21, .external_lex_state = 32},
  [610] = {.lex_state = 21, .external_lex_state = 32},
  [611] = {.lex_state = 21, .external_lex_state = 32},
  [612] = {.lex_state = 21, .external_lex_state = 32},
  [613] = {.lex_state = 21, .external_lex_state = 32},
  [614] = {.lex_state = 21, .external_lex_state = 32},
  [615] = {.lex_state = 21, .external_lex_state = 32},
  [616] = {.lex_state = 44, .external_lex_state = 47},
  [617] = {.lex_state = 21, .external_lex_state = 19},
  [618] = {.lex_state = 21, .external_lex_state = 19},
  [619] = {.lex_state = 21, .external_lex_state = 19},
  [620] = {.lex_state = 21, .external_lex_state = 19},
  [621] = {.lex_state = 21, .external_lex_state = 19},
  [622] = {.lex_state = 21, .external_lex_state = 19},
  [623] = {.lex_state = 21, .external_lex_state = 19},
  [624] = {.lex_state = 21, .external_lex_state = 19},
  [625] = {.lex_state = 21, .external_lex_state = 19},
  [626] = {.lex_state = 21, .external_lex_state = 19},
  [627] = {.lex_state = 21, .external_lex_state = 19},
  [628] = {.lex_state = 21, .external_lex_state = 19},
  [629] = {.lex_state = 21, .external_lex_state = 19},
  [630] = {.lex_state = 21, .external_lex_state = 19},
  [631] = {.lex_state = 21, .external_lex_state = 19},
  [632] = {.lex_state = 21, .external_lex_state = 19},
  [633] = {.lex_state = 21, .external_lex_state = 19},
  [634] = {.lex_state = 21, .external_lex_state = 19},
  [635] = {.lex_state = 21, .external_lex_state = 19},
  [636] = {.lex_state = 21, .external_lex_state = 19},
  [637] = {.lex_state = 21, .external_lex_state = 19},
  [638] = {.lex_state = 21, .external_lex_state = 19},
  [639] = {.lex_state = 21, .external_lex_state = 19},
  [640] = {.lex_state = 21, .external_lex_state = 19},
  [641] = {.lex_state = 21, .external_lex_state = 19},
  [642] = {.lex_state = 21, .external_lex_state = 19},
  [643] = {.lex_state = 44, .external_lex_state = 48},
  [644] = {.lex_state = 21, .external_lex_state = 20},
  [645] = {.lex_state = 21, .external_lex_state = 20},
  [646] = {.lex_state = 21, .external_lex_state = 20},
  [647] = {.lex_state = 21, .external_lex_state = 20},
  [648] = {.lex_state = 21, .external_lex_state = 16},
  [649] = {.lex_state = 21, .external_lex_state = 20},
  [650] = {.lex_state = 21, .external_lex_state = 20},
  [651] = {.lex_state = 21, .external_lex_state = 20},
  [652] = {.lex_state = 21, .external_lex_state = 20},
  [653] = {.lex_state = 21, .external_lex_state = 20},
  [654] = {.lex_state = 21, .external_lex_state = 20},
  [655] = {.lex_state = 21, .external_lex_state = 16},
  [656] = {.lex_state = 21, .external_lex_state = 16},
  [657] = {.lex_state = 21, .external_lex_state = 20},
  [658] = {.lex_state = 21, .external_lex_state = 20},
  [659] = {.lex_state = 21, .external_lex_state = 20},
  [660] = {.lex_state = 21, .external_lex_state = 20},
  [661] = {.lex_state = 21, .external_lex_state = 20},
  [662] = {.lex_state = 21, .external_lex_state = 20},
  [663] = {.lex_state = 21, .external_lex_state = 20},
  [664] = {.lex_state = 21, .external_lex_state = 20},
  [665] = {.lex_state = 21, .external_lex_state = 20},
  [666] = {.lex_state = 21, .external_lex_state = 20},
  [667] = {.lex_state = 21, .external_lex_state = 20},
  [668] = {.lex_state = 21, .external_lex_state = 20},
  [669] = {.lex_state = 21, .external_lex_state = 20},
  [670] = {.lex_state = 21, .external_lex_state = 20},
  [671] = {.lex_state = 21, .external_lex_state = 20},
  [672] = {.lex_state = 21, .external_lex_state = 20},
  [673] = {.lex_state = 44, .external_lex_state = 49},
  [674] = {.lex_state = 21, .external_lex_state = 16},
  [675] = {.lex_state = 21, .external_lex_state = 16},
  [676] = {.lex_state = 21, .external_lex_state = 16},
  [677] = {.lex_state = 21, .external_lex_state = 21},
  [678] = {.lex_state = 21, .external_lex_state = 21},
  [679] = {.lex_state = 21, .external_lex_state = 21},
  [680] = {.lex_state = 21, .external_lex_state = 16},
  [681] = {.lex_state = 21, .external_lex_state = 16},
  [682] = {.lex_state = 21, .external_lex_state = 16},
  [683] = {.lex_state = 21, .external_lex_state = 21},
  [684] = {.lex_state = 21, .external_lex_state = 16},
  [685] = {.lex_state = 21, .external_lex_state = 21},
  [686] = {.lex_state = 21, .external_lex_state = 21},
  [687] = {.lex_state = 21, .external_lex_state = 21},
  [688] = {.lex_state = 21, .external_lex_state = 21},
  [689] = {.lex_state = 21, .external_lex_state = 21},
  [690] = {.lex_state = 21, .external_lex_state = 21},
  [691] = {.lex_state = 21, .external_lex_state = 16},
  [692] = {.lex_state = 21, .external_lex_state = 16},
  [693] = {.lex_state = 21, .external_lex_state = 16},
  [694] = {.lex_state = 21, .external_lex_state = 21},
  [695] = {.lex_state = 21, .external_lex_state = 21},
  [696] = {.lex_state = 21, .external_lex_state = 21},
  [697] = {.lex_state = 21, .external_lex_state = 21},
  [698] = {.lex_state = 21, .external_lex_state = 21},
  [699] = {.lex_state = 21, .external_lex_state = 21},
  [700] = {.lex_state = 21, .external_lex_state = 21},
  [701] = {.lex_state = 21, .external_lex_state = 21},
  [702] = {.lex_state = 21, .external_lex_state = 21},
  [703] = {.lex_state = 21, .external_lex_state = 21},
  [704] = {.lex_state = 21, .external_lex_state = 21},
  [705] = {.lex_state = 21, .external_lex_state = 21},
  [706] = {.lex_state = 21, .external_lex_state = 21},
  [707] = {.lex_state = 21, .external_lex_state = 21},
  [708] = {.lex_state = 21, .external_lex_state = 21},
  [709] = {.lex_state = 21, .external_lex_state = 21},
  [710] = {.lex_state = 21, .external_lex_state = 22},
  [711] = {.lex_state = 21, .external_lex_state = 22},
  [712] = {.lex_state = 21, .external_lex_state = 22},
  [713] = {.lex_state = 21, .external_lex_state = 22},
  [714] = {.lex_state = 21, .external_lex_state = 22},
  [715] = {.lex_state = 21, .external_lex_state = 22},
  [716] = {.lex_state = 21, .external_lex_state = 22},
  [717] = {.lex_state = 21, .external_lex_state = 22},
  [718] = {.lex_state = 21, .external_lex_state = 22},
  [719] = {.lex_state = 21, .external_lex_state = 22},
  [720] = {.lex_state = 21, .external_lex_state = 22},
  [721] = {.lex_state = 21, .external_lex_state = 22},
  [722] = {.lex_state = 21, .external_lex_state = 22},
  [723] = {.lex_state = 21, .external_lex_state = 22},
  [724] = {.lex_state = 21, .external_lex_state = 22},
  [725] = {.lex_state = 21, .external_lex_state = 22},
  [726] = {.lex_state = 21, .external_lex_state = 22},
  [727] = {.lex_state = 21, .external_lex_state = 22},
  [728] = {.lex_state = 21, .external_lex_state = 22},
  [729] = {.lex_state = 21, .external_lex_state = 22},
  [730] = {.lex_state = 21, .external_lex_state = 22},
  [731] = {.lex_state = 21, .external_lex_state = 22},
  [732] = {.lex_state = 21, .external_lex_state = 22},
  [733] = {.lex_state = 21, .external_lex_state = 22},
  [734] = {.lex_state = 21, .external_lex_state = 22},
  [735] = {.lex_state = 21, .external_lex_state = 22},
  [736] = {.lex_state = 3, .external_lex_state = 50},
  [737] = {.lex_state = 21, .external_lex_state = 23},
  [738] = {.lex_state = 21, .external_lex_state = 23},
  [739] = {.lex_state = 21, .external_lex_state = 23},
  [740] = {.lex_state = 21, .external_lex_state = 23},
  [741] = {.lex_state = 21, .external_lex_state = 16},
  [742] = {.lex_state = 21, .external_lex_state = 23},
  [743] = {.lex_state = 21, .external_lex_state = 23},
  [744] = {.lex_state = 21, .external_lex_state = 23},
  [745] = {.lex_state = 21, .external_lex_state = 31},
  [746] = {.lex_state = 21, .external_lex_state = 23},
  [747] = {.lex_state = 21, .external_lex_state = 23},
  [748] = {.lex_state = 21, .external_lex_state = 16},
  [749] = {.lex_state = 21, .external_lex_state = 23},
  [750] = {.lex_state = 21, .external_lex_state = 23},
  [751] = {.lex_state = 21, .external_lex_state = 23},
  [752] = {.lex_state = 21, .external_lex_state = 23},
  [753] = {.lex_state = 21, .external_lex_state = 23},
  [754] = {.lex_state = 21, .external_lex_state = 23},
  [755] = {.lex_state = 21, .external_lex_state = 23},
  [756] = {.lex_state = 21, .external_lex_state = 23},
  [757] = {.lex_state = 21, .external_lex_state = 23},
  [758] = {.lex_state = 21, .external_lex_state = 23},
  [759] = {.lex_state = 21, .external_lex_state = 23},
  [760] = {.lex_state = 21, .external_lex_state = 23},
  [761] = {.lex_state = 21, .external_lex_state = 23},
  [762] = {.lex_state = 21, .external_lex_state = 23},
  [763] = {.lex_state = 21, .external_lex_state = 23},
  [764] = {.lex_state = 21, .external_lex_state = 23},
  [765] = {.lex_state = 44, .external_lex_state = 51},
  [766] = {.lex_state = 19, .external_lex_state = 12},
  [767] = {.lex_state = 19, .external_lex_state = 12},
  [768] = {.lex_state = 19, .external_lex_state = 12},
  [769] = {.lex_state = 19, .external_lex_state = 12},
  [770] = {.lex_state = 19, .external_lex_state = 12},
  [771] = {.lex_state = 19, .external_lex_state = 12},
  [772] = {.lex_state = 19, .external_lex_state = 12},
  [773] = {.lex_state = 19, .external_lex_state = 12},
  [774] = {.lex_state = 19, .external_lex_state = 12},
  [775] = {.lex_state = 19, .external_lex_state = 12},
  [776] = {.lex_state = 21, .external_lex_state = 16},
  [777] = {.lex_state = 19, .external_lex_state = 12},
  [778] = {.lex_state = 19, .external_lex_state = 12},
  [779] = {.lex_state = 19, .external_lex_state = 12},
  [780] = {.lex_state = 19, .external_lex_state = 12},
  [781] = {.lex_state = 19, .external_lex_state = 12},
  [782] = {.lex_state = 19, .external_lex_state = 12},
  [783] = {.lex_state = 19, .external_lex_state = 12},
  [784] = {.lex_state = 19, .external_lex_state = 12},
  [785] = {.lex_state = 19, .external_lex_state = 12},
  [786] = {.lex_state = 19, .external_lex_state = 12},
  [787] = {.lex_state = 19, .external_lex_state = 12},
  [788] = {.lex_state = 19, .external_lex_state = 12},
  [789] = {.lex_state = 19, .external_lex_state = 12},
  [790] = {.lex_state = 19, .external_lex_state = 12},
  [791] = {.lex_state = 19, .external_lex_state = 12},
  [792] = {.lex_state = 19, .external_lex_state = 12},
  [793] = {.lex_state = 21, .external_lex_state = 15},
  [794] = {.lex_state = 21, .external_lex_state = 15},
  [795] = {.lex_state = 21, .external_lex_state = 15},
  [796] = {.lex_state = 21, .external_lex_state = 15},
  [797] = {.lex_state = 21, .external_lex_state = 15},
  [798] = {.lex_state = 21, .external_lex_state = 15},
  [799] = {.lex_state = 21, .external_lex_state = 15},
  [800] = {.lex_state = 21, .external_lex_state = 15},
  [801] = {.lex_state = 21, .external_lex_state = 15},
  [802] = {.lex_state = 21, .external_lex_state = 15},
  [803] = {.lex_state = 21, .external_lex_state = 15},
  [804] = {.lex_state = 21, .external_lex_state = 15},
  [805] = {.lex_state = 21, .external_lex_state = 15},
  [806] = {.lex_state = 21, .external_lex_state = 15},
  [807] = {.lex_state = 21, .external_lex_state = 15},
  [808] = {.lex_state = 21, .external_lex_state = 15},
  [809] = {.lex_state = 21, .external_lex_state = 15},
  [810] = {.lex_state = 21, .external_lex_state = 15},
  [811] = {.lex_state = 21, .external_lex_state = 15},
  [812] = {.lex_state = 21, .external_lex_state = 15},
  [813] = {.lex_state = 21, .external_lex_state = 15},
  [814] = {.lex_state = 21, .external_lex_state = 15},
  [815] = {.lex_state = 21, .external_lex_state = 15},
  [816] = {.lex_state = 21, .external_lex_state = 15},
  [817] = {.lex_state = 21, .external_lex_state = 15},
  [818] = {.lex_state = 21, .external_lex_state = 15},
  [819] = {.lex_state = 21, .external_lex_state = 16},
  [820] = {.lex_state = 25, .external_lex_state = 12},
  [821] = {.lex_state = 21, .external_lex_state = 41},
  [822] = {.lex_state = 21, .external_lex_state = 41},
  [823] = {.lex_state = 18, .external_lex_state = 12},
  [824] = {.lex_state = 21, .external_lex_state = 16},
  [825] = {.lex_state = 21, .external_lex_state = 16},
  [826] = {.lex_state = 6, .external_lex_state = 12},
  [827] = {.lex_state = 21, .external_lex_state = 12},
  [828] = {.lex_state = 21, .external_lex_state = 16},
  [829] = {.lex_state = 21, .external_lex_state = 16},
  [830] = {.lex_state = 21, .external_lex_state = 16},
  [831] = {.lex_state = 44, .external_lex_state = 52},
  [832] = {.lex_state = 44, .external_lex_state = 53},
  [833] = {.lex_state = 21, .external_lex_state = 17},
  [834] = {.lex_state = 21, .external_lex_state = 17},
  [835] = {.lex_state = 21, .external_lex_state = 17},
  [836] = {.lex_state = 44, .external_lex_state = 10},
  [837] = {.lex_state = 21, .external_lex_state = 17},
  [838] = {.lex_state = 21, .external_lex_state = 17},
  [839] = {.lex_state = 21, .external_lex_state = 17},
  [840] = {.lex_state = 21, .external_lex_state = 17},
  [841] = {.lex_state = 21, .external_lex_state = 17},
  [842] = {.lex_state = 21, .external_lex_state = 17},
  [843] = {.lex_state = 21, .external_lex_state = 17},
  [844] = {.lex_state = 44, .external_lex_state = 10},
  [845] = {.lex_state = 1, .external_lex_state = 9},
  [846] = {.lex_state = 21, .external_lex_state = 17},
  [847] = {.lex_state = 21, .external_lex_state = 17},
  [848] = {.lex_state = 21, .external_lex_state = 17},
  [849] = {.lex_state = 21, .external_lex_state = 17},
  [850] = {.lex_state = 21, .external_lex_state = 17},
  [851] = {.lex_state = 21, .external_lex_state = 17},
  [852] = {.lex_state = 21, .external_lex_state = 17},
  [853] = {.lex_state = 21, .external_lex_state = 17},
  [854] = {.lex_state = 21, .external_lex_state = 17},
  [855] = {.lex_state = 21, .external_lex_state = 17},
  [856] = {.lex_state = 21, .external_lex_state = 17},
  [857] = {.lex_state = 21, .external_lex_state = 17},
  [858] = {.lex_state = 21, .external_lex_state = 17},
  [859] = {.lex_state = 21, .external_lex_state = 17},
  [860] = {.lex_state = 21, .external_lex_state = 17},
  [861] = {.lex_state = 21, .external_lex_state = 17},
  [862] = {.lex_state = 44, .external_lex_state = 54},
  [863] = {.lex_state = 21, .external_lex_state = 18},
  [864] = {.lex_state = 21, .external_lex_state = 18},
  [865] = {.lex_state = 21, .external_lex_state = 18},
  [866] = {.lex_state = 21, .external_lex_state = 18},
  [867] = {.lex_state = 21, .external_lex_state = 18},
  [868] = {.lex_state = 21, .external_lex_state = 18},
  [869] = {.lex_state = 21, .external_lex_state = 18},
  [870] = {.lex_state = 21, .external_lex_state = 18},
  [871] = {.lex_state = 21, .external_lex_state = 18},
  [872] = {.lex_state = 21, .external_lex_state = 18},
  [873] = {.lex_state = 21, .external_lex_state = 18},
  [874] = {.lex_state = 21, .external_lex_state = 18},
  [875] = {.lex_state = 21, .external_lex_state = 18},
  [876] = {.lex_state = 21, .external_lex_state = 18},
  [877] = {.lex_state = 21, .external_lex_state = 18},
  [878] = {.lex_state = 21, .external_lex_state = 18},
  [879] = {.lex_state = 21, .external_lex_state = 18},
  [880] = {.lex_state = 21, .external_lex_state = 18},
  [881] = {.lex_state = 21, .external_lex_state = 18},
  [882] = {.lex_state = 21, .external_lex_state = 18},
  [883] = {.lex_state = 21, .external_lex_state = 18},
  [884] = {.lex_state = 21, .external_lex_state = 18},
  [885] = {.lex_state = 21, .external_lex_state = 18},
  [886] = {.lex_state = 21, .external_lex_state = 18},
  [887] = {.lex_state = 21, .external_lex_state = 18},
  [888] = {.lex_state = 21, .external_lex_state = 18},
  [889] = {.lex_state = 21, .external_lex_state = 31},
  [890] = {.lex_state = 21, .external_lex_state = 31},
  [891] = {.lex_state = 21, .external_lex_state = 31},
  [892] = {.lex_state = 21, .external_lex_state = 23},
  [893] = {.lex_state = 44, .external_lex_state = 18},
  [894] = {.lex_state = 44, .external_lex_state = 22},
  [895] = {.lex_state = 44, .external_lex_state = 15},
  [896] = {.lex_state = 44, .external_lex_state = 16},
  [897] = {.lex_state = 44, .external_lex_state = 22},
  [898] = {.lex_state = 44, .external_lex_state = 23},
  [899] = {.lex_state = 44, .external_lex_state = 32},
  [900] = {.lex_state = 44, .external_lex_state = 23},
  [901] = {.lex_state = 44, .external_lex_state = 23},
  [902] = {.lex_state = 21, .external_lex_state = 12},
  [903] = {.lex_state = 21, .external_lex_state = 12},
  [904] = {.lex_state = 21, .external_lex_state = 12},
  [905] = {.lex_state = 44, .external_lex_state = 19},
  [906] = {.lex_state = 44, .external_lex_state = 32},
  [907] = {.lex_state = 21, .external_lex_state = 12},
  [908] = {.lex_state = 44, .external_lex_state = 16},
  [909] = {.lex_state = 21, .external_lex_state = 12},
  [910] = {.lex_state = 21, .external_lex_state = 12},
  [911] = {.lex_state = 21, .external_lex_state = 12},
  [912] = {.lex_state = 21, .external_lex_state = 12},
  [913] = {.lex_state = 21, .external_lex_state = 12},
  [914] = {.lex_state = 21, .external_lex_state = 12},
  [915] = {.lex_state = 44, .external_lex_state = 20},
  [916] = {.lex_state = 21, .external_lex_state = 12},
  [917] = {.lex_state = 21, .external_lex_state = 12},
  [918] = {.lex_state = 21, .external_lex_state = 12},
  [919] = {.lex_state = 21, .external_lex_state = 12},
  [920] = {.lex_state = 21, .external_lex_state = 12},
  [921] = {.lex_state = 21, .external_lex_state = 12},
  [922] = {.lex_state = 21, .external_lex_state = 12},
  [923] = {.lex_state = 21, .external_lex_state = 12},
  [924] = {.lex_state = 21, .external_lex_state = 12},
  [925] = {.lex_state = 21, .external_lex_state = 12},
  [926] = {.lex_state = 21, .external_lex_state = 12},
  [927] = {.lex_state = 21, .external_lex_state = 12},
  [928] = {.lex_state = 21, .external_lex_state = 12},
  [929] = {.lex_state = 21, .external_lex_state = 12},
  [930] = {.lex_state = 21, .external_lex_state = 12},
  [931] = {.lex_state = 21, .external_lex_state = 12},
  [932] = {.lex_state = 44, .external_lex_state = 21},
  [933] = {.lex_state = 44, .external_lex_state = 22},
  [934] = {.lex_state = 44, .external_lex_state = 10},
  [935] = {.lex_state = 3, .external_lex_state = 12},
  [936] = {.lex_state = 3, .external_lex_state = 12},
  [937] = {.lex_state = 44, .external_lex_state = 21},
  [938] = {.lex_state = 3, .external_lex_state = 12},
  [939] = {.lex_state = 44, .external_lex_state = 32},
  [940] = {.lex_state = 44, .external_lex_state = 17},
  [941] = {.lex_state = 44, .external_lex_state = 16},
  [942] = {.lex_state = 44, .external_lex_state = 22},
  [943] = {.lex_state = 44, .external_lex_state = 16},
  [944] = {.lex_state = 44, .external_lex_state = 17},
  [945] = {.lex_state = 44, .external_lex_state = 17},
  [946] = {.lex_state = 44, .external_lex_state = 31},
  [947] = {.lex_state = 44, .external_lex_state = 17},
  [948] = {.lex_state = 44, .external_lex_state = 21},
  [949] = {.lex_state = 44, .external_lex_state = 32},
  [950] = {.lex_state = 44, .external_lex_state = 20},
  [951] = {.lex_state = 44, .external_lex_state = 32},
  [952] = {.lex_state = 3, .external_lex_state = 12},
  [953] = {.lex_state = 44, .external_lex_state = 16},
  [954] = {.lex_state = 44, .external_lex_state = 32},
  [955] = {.lex_state = 44, .external_lex_state = 17},
  [956] = {.lex_state = 44, .external_lex_state = 20},
  [957] = {.lex_state = 3, .external_lex_state = 12},
  [958] = {.lex_state = 44, .external_lex_state = 31},
  [959] = {.lex_state = 44, .external_lex_state = 32},
  [960] = {.lex_state = 44, .external_lex_state = 17},
  [961] = {.lex_state = 44, .external_lex_state = 22},
  [962] = {.lex_state = 44, .external_lex_state = 19},
  [963] = {.lex_state = 44, .external_lex_state = 21},
  [964] = {.lex_state = 44, .external_lex_state = 32},
  [965] = {.lex_state = 44, .external_lex_state = 22},
  [966] = {.lex_state = 44, .external_lex_state = 19},
  [967] = {.lex_state = 44, .external_lex_state = 19},
  [968] = {.lex_state = 44, .external_lex_state = 22},
  [969] = {.lex_state = 44, .external_lex_state = 32},
  [970] = {.lex_state = 44, .external_lex_state = 21},
  [971] = {.lex_state = 44, .external_lex_state = 19},
  [972] = {.lex_state = 3, .external_lex_state = 12},
  [973] = {.lex_state = 44, .external_lex_state = 17},
  [974] = {.lex_state = 44, .external_lex_state = 19},
  [975] = {.lex_state = 44, .external_lex_state = 31},
  [976] = {.lex_state = 44, .external_lex_state = 17},
  [977] = {.lex_state = 3, .external_lex_state = 12},
  [978] = {.lex_state = 44, .external_lex_state = 15},
  [979] = {.lex_state = 44, .external_lex_state = 23},
  [980] = {.lex_state = 44, .external_lex_state = 23},
  [981] = {.lex_state = 44, .external_lex_state = 16},
  [982] = {.lex_state = 44, .external_lex_state = 18},
  [983] = {.lex_state = 44, .external_lex_state = 18},
  [984] = {.lex_state = 44, .external_lex_state = 18},
  [985] = {.lex_state = 44, .external_lex_state = 15},
  [986] = {.lex_state = 44, .external_lex_state = 18},
  [987] = {.lex_state = 44, .external_lex_state = 15},
  [988] = {.lex_state = 44, .external_lex_state = 31},
  [989] = {.lex_state = 44, .external_lex_state = 15},
  [990] = {.lex_state = 44, .external_lex_state = 23},
  [991] = {.lex_state = 44, .external_lex_state = 20},
  [992] = {.lex_state = 44, .external_lex_state = 31},
  [993] = {.lex_state = 44, .external_lex_state = 18},
  [994] = {.lex_state = 44, .external_lex_state = 31},
  [995] = {.lex_state = 44, .external_lex_state = 20},
  [996] = {.lex_state = 44, .external_lex_state = 18},
  [997] = {.lex_state = 44, .external_lex_state = 22},
  [998] = {.lex_state = 44, .external_lex_state = 15},
  [999] = {.lex_state = 44, .external_lex_state = 16},
  [1000] = {.lex_state = 44, .external_lex_state = 23},
  [1001] = {.lex_state = 44, .external_lex_state = 15},
  [1002] = {.lex_state = 44, .external_lex_state = 21},
  [1003] = {.lex_state = 44, .external_lex_state = 20},
  [1004] = {.lex_state = 44, .external_lex_state = 20},
  [1005] = {.lex_state = 44, .external_lex_state = 23},
  [1006] = {.lex_state = 44, .external_lex_state = 21},
  [1007] = {.lex_state = 44, .external_lex_state = 11},
  [1008] = {.lex_state = 44, .external_lex_state = 31},
  [1009] = {.lex_state = 44, .external_lex_state = 31},
  [1010] = {.lex_state = 44, .external_lex_state = 19},
  [1011] = {.lex_state = 44, .external_lex_state = 18},
  [1012] = {.lex_state = 44, .external_lex_state = 20},
  [1013] = {.lex_state = 44, .external_lex_state = 50},
  [1014] = {.lex_state = 3, .external_lex_state = 12},
  [1015] = {.lex_state = 44, .external_lex_state = 16},
  [1016] = {.lex_state = 44, .external_lex_state = 15},
  [1017] = {.lex_state = 44, .external_lex_state = 19},
  [1018] = {.lex_state = 44, .external_lex_state = 50},
  [1019] = {.lex_state = 44, .external_lex_state = 50},
  [1020] = {.lex_state = 44, .external_lex_state = 31},
  [1021] = {.lex_state = 44, .external_lex_state = 21},
  [1022] = {.lex_state = 44, .external_lex_state = 12},
  [1023] = {.lex_state = 44, .external_lex_state = 12},
  [1024] = {.lex_state = 44, .external_lex_state = 12},
  [1025] = {.lex_state = 44, .external_lex_state = 12},
  [1026] = {.lex_state = 44, .external_lex_state = 12},
  [1027] = {.lex_state = 44, .external_lex_state = 12},
  [1028] = {.lex_state = 44, .external_lex_state = 12},
  [1029] = {.lex_state = 44, .external_lex_state = 12},
  [1030] = {.lex_state = 0, .external_lex_state = 55},
  [1031] = {.lex_state = 0, .external_lex_state = 56},
  [1032] = {.lex_state = 0, .external_lex_state = 55},
  [1033] = {.lex_state = 0, .external_lex_state = 57},
  [1034] = {.lex_state = 0, .external_lex_state = 56},
  [1035] = {.lex_state = 0, .external_lex_state = 57},
  [1036] = {.lex_state = 8, .external_lex_state = 58},
  [1037] = {.lex_state = 8, .external_lex_state = 59},
  [1038] = {.lex_state = 8, .external_lex_state = 58},
  [1039] = {.lex_state = 8, .external_lex_state = 59},
  [1040] = {.lex_state = 8, .external_lex_state = 58},
  [1041] = {.lex_state = 8, .external_lex_state = 59},
  [1042] = {.lex_state = 8, .external_lex_state = 58},
  [1043] = {.lex_state = 8, .external_lex_state = 58},
  [1044] = {.lex_state = 8, .external_lex_state = 58},
  [1045] = {.lex_state = 8, .external_lex_state = 58},
  [1046] = {.lex_state = 8, .external_lex_state = 58},
  [1047] = {.lex_state = 8, .external_lex_state = 58},
  [1048] = {.lex_state = 8, .external_lex_state = 59},
  [1049] = {.lex_state = 8, .external_lex_state = 58},
  [1050] = {.lex_state = 8, .external_lex_state = 58},
  [1051] = {.lex_state = 8, .external_lex_state = 58},
  [1052] = {.lex_state = 8, .external_lex_state = 58},
  [1053] = {.lex_state = 8, .external_lex_state = 58},
  [1054] = {.lex_state = 8, .external_lex_state = 58},
  [1055] = {.lex_state = 8, .external_lex_state = 58},
  [1056] = {.lex_state = 8, .external_lex_state = 58},
  [1057] = {.lex_state = 8, .external_lex_state = 58},
  [1058] = {.lex_state = 8, .external_lex_state = 58},
  [1059] = {.lex_state = 8, .external_lex_state = 58},
  [1060] = {.lex_state = 8, .external_lex_state = 58},
  [1061] = {.lex_state = 8, .external_lex_state = 58},
  [1062] = {.lex_state = 8, .external_lex_state = 58},
  [1063] = {.lex_state = 8, .external_lex_state = 58},
  [1064] = {.lex_state = 8, .external_lex_state = 58},
  [1065] = {.lex_state = 8, .external_lex_state = 58},
  [1066] = {.lex_state = 8, .external_lex_state = 59},
  [1067] = {.lex_state = 8, .external_lex_state = 59},
  [1068] = {.lex_state = 8, .external_lex_state = 59},
  [1069] = {.lex_state = 8, .external_lex_state = 59},
  [1070] = {.lex_state = 8, .external_lex_state = 59},
  [1071] = {.lex_state = 8, .external_lex_state = 59},
  [1072] = {.lex_state = 8, .external_lex_state = 59},
  [1073] = {.lex_state = 8, .external_lex_state = 58},
  [1074] = {.lex_state = 0, .external_lex_state = 55},
  [1075] = {.lex_state = 64, .external_lex_state = 60},
  [1076] = {.lex_state = 0, .external_lex_state = 55},
  [1077] = {.lex_state = 0, .external_lex_state = 61},
  [1078] = {.lex_state = 0, .external_lex_state = 55},
  [1079] = {.lex_state = 64, .external_lex_state = 60},
  [1080] = {.lex_state = 0, .external_lex_state = 61},
  [1081] = {.lex_state = 64, .external_lex_state = 60},
  [1082] = {.lex_state = 64, .external_lex_state = 60},
  [1083] = {.lex_state = 0, .external_lex_state = 61},
  [1084] = {.lex_state = 0, .external_lex_state = 61},
  [1085] = {.lex_state = 0, .external_lex_state = 55},
  [1086] = {.lex_state = 64, .external_lex_state = 60},
  [1087] = {.lex_state = 0, .external_lex_state = 55},
  [1088] = {.lex_state = 64, .external_lex_state = 60},
  [1089] = {.lex_state = 64, .external_lex_state = 60},
  [1090] = {.lex_state = 64, .external_lex_state = 60},
  [1091] = {.lex_state = 0, .external_lex_state = 61},
  [1092] = {.lex_state = 0, .external_lex_state = 55},
  [1093] = {.lex_state = 64, .external_lex_state = 60},
  [1094] = {.lex_state = 64, .external_lex_state = 60},
  [1095] = {.lex_state = 64, .external_lex_state = 60},
  [1096] = {.lex_state = 64, .external_lex_state = 60},
  [1097] = {.lex_state = 64, .external_lex_state = 60},
  [1098] = {.lex_state = 64, .external_lex_state = 60},
  [1099] = {.lex_state = 64, .external_lex_state = 60},
  [1100] = {.lex_state = 0, .external_lex_state = 61},
  [1101] = {.lex_state = 0, .external_lex_state = 55},
  [1102] = {.lex_state = 0, .external_lex_state = 62},
  [1103] = {.lex_state = 0, .external_lex_state = 63},
  [1104] = {.lex_state = 0, .external_lex_state = 64},
  [1105] = {.lex_state = 0, .external_lex_state = 65},
  [1106] = {.lex_state = 0, .external_lex_state = 62},
  [1107] = {.lex_state = 0, .external_lex_state = 66},
  [1108] = {.lex_state = 0, .external_lex_state = 67},
  [1109] = {.lex_state = 0, .external_lex_state = 68},
  [1110] = {.lex_state = 0, .external_lex_state = 64},
  [1111] = {.lex_state = 0, .external_lex_state = 67},
  [1112] = {.lex_state = 0, .external_lex_state = 69},
  [1113] = {.lex_state = 0, .external_lex_state = 70},
  [1114] = {.lex_state = 0, .external_lex_state = 71},
  [1115] = {.lex_state = 0, .external_lex_state = 72},
  [1116] = {.lex_state = 0, .external_lex_state = 73},
  [1117] = {.lex_state = 0, .external_lex_state = 74},
  [1118] = {.lex_state = 0, .external_lex_state = 63},
  [1119] = {.lex_state = 0, .external_lex_state = 65},
  [1120] = {.lex_state = 0, .external_lex_state = 62},
  [1121] = {.lex_state = 0, .external_lex_state = 66},
  [1122] = {.lex_state = 0, .external_lex_state = 68},
  [1123] = {.lex_state = 0, .external_lex_state = 70},
  [1124] = {.lex_state = 0, .external_lex_state = 75},
  [1125] = {.lex_state = 0, .external_lex_state = 76},
  [1126] = {.lex_state = 0, .external_lex_state = 77},
  [1127] = {.lex_state = 0, .external_lex_state = 78},
  [1128] = {.lex_state = 0, .external_lex_state = 79},
  [1129] = {.lex_state = 0, .external_lex_state = 69},
  [1130] = {.lex_state = 0, .external_lex_state = 57},
  [1131] = {.lex_state = 0, .external_lex_state = 57},
  [1132] = {.lex_state = 0, .external_lex_state = 75},
  [1133] = {.lex_state = 0, .external_lex_state = 57},
  [1134] = {.lex_state = 0, .external_lex_state = 76},
  [1135] = {.lex_state = 0, .external_lex_state = 77},
  [1136] = {.lex_state = 8, .external_lex_state = 59},
  [1137] = {.lex_state = 8, .external_lex_state = 58},
  [1138] = {.lex_state = 0, .external_lex_state = 57},
  [1139] = {.lex_state = 64, .external_lex_state = 60},
  [1140] = {.lex_state = 0, .external_lex_state = 64},
  [1141] = {.lex_state = 0, .external_lex_state = 67},
  [1142] = {.lex_state = 0, .external_lex_state = 69},
  [1143] = {.lex_state = 8, .external_lex_state = 59},
  [1144] = {.lex_state = 0, .external_lex_state = 71},
  [1145] = {.lex_state = 0, .external_lex_state = 72},
  [1146] = {.lex_state = 0, .external_lex_state = 73},
  [1147] = {.lex_state = 0, .external_lex_state = 74},
  [1148] = {.lex_state = 0, .external_lex_state = 63},
  [1149] = {.lex_state = 0, .external_lex_state = 65},
  [1150] = {.lex_state = 0, .external_lex_state = 62},
  [1151] = {.lex_state = 0, .external_lex_state = 66},
  [1152] = {.lex_state = 0, .external_lex_state = 68},
  [1153] = {.lex_state = 0, .external_lex_state = 70},
  [1154] = {.lex_state = 0, .external_lex_state = 75},
  [1155] = {.lex_state = 0, .external_lex_state = 76},
  [1156] = {.lex_state = 0, .external_lex_state = 77},
  [1157] = {.lex_state = 0, .external_lex_state = 78},
  [1158] = {.lex_state = 0, .external_lex_state = 79},
  [1159] = {.lex_state = 0, .external_lex_state = 64},
  [1160] = {.lex_state = 8, .external_lex_state = 59},
  [1161] = {.lex_state = 8, .external_lex_state = 59},
  [1162] = {.lex_state = 8, .external_lex_state = 59},
  [1163] = {.lex_state = 0, .external_lex_state = 73},
  [1164] = {.lex_state = 8, .external_lex_state = 59},
  [1165] = {.lex_state = 0, .external_lex_state = 74},
  [1166] = {.lex_state = 0, .external_lex_state = 64},
  [1167] = {.lex_state = 0, .external_lex_state = 67},
  [1168] = {.lex_state = 0, .external_lex_state = 69},
  [1169] = {.lex_state = 8, .external_lex_state = 59},
  [1170] = {.lex_state = 0, .external_lex_state = 71},
  [1171] = {.lex_state = 0, .external_lex_state = 72},
  [1172] = {.lex_state = 0, .external_lex_state = 73},
  [1173] = {.lex_state = 0, .external_lex_state = 74},
  [1174] = {.lex_state = 0, .external_lex_state = 63},
  [1175] = {.lex_state = 0, .external_lex_state = 65},
  [1176] = {.lex_state = 0, .external_lex_state = 78},
  [1177] = {.lex_state = 0, .external_lex_state = 66},
  [1178] = {.lex_state = 8, .external_lex_state = 59},
  [1179] = {.lex_state = 0, .external_lex_state = 70},
  [1180] = {.lex_state = 0, .external_lex_state = 75},
  [1181] = {.lex_state = 0, .external_lex_state = 76},
  [1182] = {.lex_state = 0, .external_lex_state = 77},
  [1183] = {.lex_state = 0, .external_lex_state = 78},
  [1184] = {.lex_state = 0, .external_lex_state = 79},
  [1185] = {.lex_state = 8, .external_lex_state = 58},
  [1186] = {.lex_state = 0, .external_lex_state = 71},
  [1187] = {.lex_state = 0, .external_lex_state = 57},
  [1188] = {.lex_state = 0, .external_lex_state = 57},
  [1189] = {.lex_state = 0, .external_lex_state = 57},
  [1190] = {.lex_state = 8, .external_lex_state = 58},
  [1191] = {.lex_state = 8, .external_lex_state = 58},
  [1192] = {.lex_state = 0, .external_lex_state = 78},
  [1193] = {.lex_state = 0, .external_lex_state = 79},
  [1194] = {.lex_state = 0, .external_lex_state = 64},
  [1195] = {.lex_state = 0, .external_lex_state = 67},
  [1196] = {.lex_state = 0, .external_lex_state = 69},
  [1197] = {.lex_state = 8, .external_lex_state = 58},
  [1198] = {.lex_state = 0, .external_lex_state = 71},
  [1199] = {.lex_state = 0, .external_lex_state = 72},
  [1200] = {.lex_state = 0, .external_lex_state = 73},
  [1201] = {.lex_state = 0, .external_lex_state = 74},
  [1202] = {.lex_state = 0, .external_lex_state = 63},
  [1203] = {.lex_state = 0, .external_lex_state = 65},
  [1204] = {.lex_state = 0, .external_lex_state = 72},
  [1205] = {.lex_state = 8, .external_lex_state = 58},
  [1206] = {.lex_state = 8, .external_lex_state = 58},
  [1207] = {.lex_state = 8, .external_lex_state = 58},
  [1208] = {.lex_state = 0, .external_lex_state = 62},
  [1209] = {.lex_state = 0, .external_lex_state = 66},
  [1210] = {.lex_state = 64, .external_lex_state = 60},
  [1211] = {.lex_state = 0, .external_lex_state = 68},
  [1212] = {.lex_state = 0, .external_lex_state = 67},
  [1213] = {.lex_state = 0, .external_lex_state = 70},
  [1214] = {.lex_state = 0, .external_lex_state = 75},
  [1215] = {.lex_state = 0, .external_lex_state = 76},
  [1216] = {.lex_state = 0, .external_lex_state = 69},
  [1217] = {.lex_state = 8, .external_lex_state = 58},
  [1218] = {.lex_state = 0, .external_lex_state = 73},
  [1219] = {.lex_state = 0, .external_lex_state = 77},
  [1220] = {.lex_state = 0, .external_lex_state = 78},
  [1221] = {.lex_state = 0, .external_lex_state = 74},
  [1222] = {.lex_state = 0, .external_lex_state = 79},
  [1223] = {.lex_state = 0, .external_lex_state = 63},
  [1224] = {.lex_state = 0, .external_lex_state = 79},
  [1225] = {.lex_state = 0, .external_lex_state = 65},
  [1226] = {.lex_state = 0, .external_lex_state = 56},
  [1227] = {.lex_state = 0, .external_lex_state = 56},
  [1228] = {.lex_state = 0, .external_lex_state = 56},
  [1229] = {.lex_state = 0, .external_lex_state = 56},
  [1230] = {.lex_state = 0, .external_lex_state = 62},
  [1231] = {.lex_state = 8, .external_lex_state = 59},
  [1232] = {.lex_state = 0, .external_lex_state = 56},
  [1233] = {.lex_state = 0, .external_lex_state = 56},
  [1234] = {.lex_state = 0, .external_lex_state = 56},
  [1235] = {.lex_state = 0, .external_lex_state = 66},
  [1236] = {.lex_state = 0, .external_lex_state = 71},
  [1237] = {.lex_state = 0, .external_lex_state = 72},
  [1238] = {.lex_state = 0, .external_lex_state = 68},
  [1239] = {.lex_state = 0, .external_lex_state = 70},
  [1240] = {.lex_state = 0, .external_lex_state = 75},
  [1241] = {.lex_state = 0, .external_lex_state = 76},
  [1242] = {.lex_state = 0, .external_lex_state = 77},
  [1243] = {.lex_state = 0, .external_lex_state = 68},
  [1244] = {.lex_state = 0, .external_lex_state = 80},
  [1245] = {.lex_state = 0, .external_lex_state = 81},
  [1246] = {.lex_state = 0, .external_lex_state = 80},
  [1247] = {.lex_state = 0, .external_lex_state = 81},
  [1248] = {.lex_state = 0, .external_lex_state = 80},
  [1249] = {.lex_state = 8},
  [1250] = {.lex_state = 8},
  [1251] = {.lex_state = 8},
  [1252] = {.lex_state = 8},
  [1253] = {.lex_state = 0, .external_lex_state = 80},
  [1254] = {.lex_state = 8},
  [1255] = {.lex_state = 0, .external_lex_state = 80},
  [1256] = {.lex_state = 8},
  [1257] = {.lex_state = 8},
  [1258] = {.lex_state = 8},
  [1259] = {.lex_state = 0, .external_lex_state = 81},
  [1260] = {.lex_state = 0, .external_lex_state = 80},
  [1261] = {.lex_state = 0, .external_lex_state = 81},
  [1262] = {.lex_state = 0, .external_lex_state = 80},
  [1263] = {.lex_state = 8},
  [1264] = {.lex_state = 8},
  [1265] = {.lex_state = 8},
  [1266] = {.lex_state = 0, .external_lex_state = 80},
  [1267] = {.lex_state = 0, .external_lex_state = 80},
  [1268] = {.lex_state = 8},
  [1269] = {.lex_state = 0, .external_lex_state = 80},
  [1270] = {.lex_state = 8},
  [1271] = {.lex_state = 8},
  [1272] = {.lex_state = 8},
  [1273] = {.lex_state = 8},
  [1274] = {.lex_state = 0, .external_lex_state = 80},
  [1275] = {.lex_state = 0, .external_lex_state = 82},
  [1276] = {.lex_state = 0, .external_lex_state = 80},
  [1277] = {.lex_state = 8},
  [1278] = {.lex_state = 8},
  [1279] = {.lex_state = 8},
  [1280] = {.lex_state = 0, .external_lex_state = 81},
  [1281] = {.lex_state = 0, .external_lex_state = 80},
  [1282] = {.lex_state = 8},
  [1283] = {.lex_state = 0, .external_lex_state = 80},
  [1284] = {.lex_state = 8},
  [1285] = {.lex_state = 0, .external_lex_state = 80},
  [1286] = {.lex_state = 0, .external_lex_state = 80},
  [1287] = {.lex_state = 0, .external_lex_state = 80},
  [1288] = {.lex_state = 0, .external_lex_state = 80},
  [1289] = {.lex_state = 0, .external_lex_state = 80},
  [1290] = {.lex_state = 0, .external_lex_state = 80},
  [1291] = {.lex_state = 0, .external_lex_state = 80},
  [1292] = {.lex_state = 0, .external_lex_state = 80},
  [1293] = {.lex_state = 0, .external_lex_state = 80},
  [1294] = {.lex_state = 0, .external_lex_state = 80},
  [1295] = {.lex_state = 0, .external_lex_state = 80},
  [1296] = {.lex_state = 0, .external_lex_state = 82},
  [1297] = {.lex_state = 0, .external_lex_state = 82},
  [1298] = {.lex_state = 0, .external_lex_state = 80},
  [1299] = {.lex_state = 8},
  [1300] = {.lex_state = 0, .external_lex_state = 80},
  [1301] = {.lex_state = 0, .external_lex_state = 80},
  [1302] = {.lex_state = 8},
  [1303] = {.lex_state = 0, .external_lex_state = 82},
  [1304] = {.lex_state = 0, .external_lex_state = 80},
  [1305] = {.lex_state = 8},
  [1306] = {.lex_state = 0, .external_lex_state = 80},
  [1307] = {.lex_state = 0, .external_lex_state = 82},
  [1308] = {.lex_state = 0, .external_lex_state = 80},
  [1309] = {.lex_state = 0, .external_lex_state = 80},
  [1310] = {.lex_state = 0, .external_lex_state = 80},
  [1311] = {.lex_state = 0, .external_lex_state = 81},
  [1312] = {.lex_state = 0, .external_lex_state = 80},
  [1313] = {.lex_state = 0, .external_lex_state = 81},
  [1314] = {.lex_state = 8},
  [1315] = {.lex_state = 0, .external_lex_state = 80},
  [1316] = {.lex_state = 0, .external_lex_state = 80},
  [1317] = {.lex_state = 0, .external_lex_state = 81},
  [1318] = {.lex_state = 0, .external_lex_state = 80},
  [1319] = {.lex_state = 8},
  [1320] = {.lex_state = 8},
  [1321] = {.lex_state = 0, .external_lex_state = 81},
  [1322] = {.lex_state = 0, .external_lex_state = 80},
  [1323] = {.lex_state = 0, .external_lex_state = 81},
  [1324] = {.lex_state = 0, .external_lex_state = 81},
  [1325] = {.lex_state = 8},
  [1326] = {.lex_state = 8},
  [1327] = {.lex_state = 8},
  [1328] = {.lex_state = 0, .external_lex_state = 80},
  [1329] = {.lex_state = 8},
  [1330] = {.lex_state = 0, .external_lex_state = 80},
  [1331] = {.lex_state = 8},
  [1332] = {.lex_state = 8},
  [1333] = {.lex_state = 0, .external_lex_state = 80},
  [1334] = {.lex_state = 8},
  [1335] = {.lex_state = 8},
  [1336] = {.lex_state = 0, .external_lex_state = 80},
  [1337] = {.lex_state = 8},
  [1338] = {.lex_state = 0, .external_lex_state = 80},
  [1339] = {.lex_state = 8},
  [1340] = {.lex_state = 8},
  [1341] = {.lex_state = 8},
  [1342] = {.lex_state = 0, .external_lex_state = 80},
  [1343] = {.lex_state = 10, .external_lex_state = 83},
  [1344] = {.lex_state = 10, .external_lex_state = 83},
  [1345] = {.lex_state = 0, .external_lex_state = 84},
  [1346] = {.lex_state = 0, .external_lex_state = 84},
  [1347] = {.lex_state = 0, .external_lex_state = 60},
  [1348] = {.lex_state = 10, .external_lex_state = 83},
  [1349] = {.lex_state = 10, .external_lex_state = 83},
  [1350] = {.lex_state = 0, .external_lex_state = 85},
  [1351] = {.lex_state = 10, .external_lex_state = 83},
  [1352] = {.lex_state = 10, .external_lex_state = 83},
  [1353] = {.lex_state = 0, .external_lex_state = 60},
  [1354] = {.lex_state = 10, .external_lex_state = 83},
  [1355] = {.lex_state = 0, .external_lex_state = 60},
  [1356] = {.lex_state = 0, .external_lex_state = 86},
  [1357] = {.lex_state = 11, .external_lex_state = 87},
  [1358] = {.lex_state = 0, .external_lex_state = 88},
  [1359] = {.lex_state = 0, .external_lex_state = 88},
  [1360] = {.lex_state = 11, .external_lex_state = 87},
  [1361] = {.lex_state = 11, .external_lex_state = 87},
  [1362] = {.lex_state = 42, .external_lex_state = 89},
  [1363] = {.lex_state = 0, .external_lex_state = 86},
  [1364] = {.lex_state = 11, .external_lex_state = 87},
  [1365] = {.lex_state = 11, .external_lex_state = 87},
  [1366] = {.lex_state = 0, .external_lex_state = 86},
  [1367] = {.lex_state = 11, .external_lex_state = 87},
  [1368] = {.lex_state = 42, .external_lex_state = 89},
  [1369] = {.lex_state = 11, .external_lex_state = 87},
  [1370] = {.lex_state = 11, .external_lex_state = 87},
  [1371] = {.lex_state = 11, .external_lex_state = 87},
  [1372] = {.lex_state = 11, .external_lex_state = 87},
  [1373] = {.lex_state = 0, .external_lex_state = 88},
  [1374] = {.lex_state = 42, .external_lex_state = 89},
  [1375] = {.lex_state = 11, .external_lex_state = 87},
  [1376] = {.lex_state = 10, .external_lex_state = 83},
  [1377] = {.lex_state = 0, .external_lex_state = 88},
  [1378] = {.lex_state = 11, .external_lex_state = 87},
  [1379] = {.lex_state = 0, .external_lex_state = 84},
  [1380] = {.lex_state = 0, .external_lex_state = 90},
  [1381] = {.lex_state = 64},
  [1382] = {.lex_state = 42, .external_lex_state = 89},
  [1383] = {.lex_state = 12, .external_lex_state = 59},
  [1384] = {.lex_state = 64, .external_lex_state = 91},
  [1385] = {.lex_state = 64},
  [1386] = {.lex_state = 42, .external_lex_state = 89},
  [1387] = {.lex_state = 42, .external_lex_state = 89},
  [1388] = {.lex_state = 12, .external_lex_state = 59},
  [1389] = {.lex_state = 12, .external_lex_state = 59},
  [1390] = {.lex_state = 0, .external_lex_state = 92},
  [1391] = {.lex_state = 0, .external_lex_state = 90},
  [1392] = {.lex_state = 0, .external_lex_state = 90},
  [1393] = {.lex_state = 42, .external_lex_state = 89},
  [1394] = {.lex_state = 12, .external_lex_state = 59},
  [1395] = {.lex_state = 12, .external_lex_state = 59},
  [1396] = {.lex_state = 42, .external_lex_state = 89},
  [1397] = {.lex_state = 11, .external_lex_state = 87},
  [1398] = {.lex_state = 42, .external_lex_state = 89},
  [1399] = {.lex_state = 0, .external_lex_state = 88},
  [1400] = {.lex_state = 0, .external_lex_state = 93},
  [1401] = {.lex_state = 42, .external_lex_state = 89},
  [1402] = {.lex_state = 0, .external_lex_state = 86},
  [1403] = {.lex_state = 0, .external_lex_state = 88},
  [1404] = {.lex_state = 0, .external_lex_state = 86},
  [1405] = {.lex_state = 0, .external_lex_state = 86},
  [1406] = {.lex_state = 42, .external_lex_state = 89},
  [1407] = {.lex_state = 11, .external_lex_state = 87},
  [1408] = {.lex_state = 64, .external_lex_state = 91},
  [1409] = {.lex_state = 0, .external_lex_state = 90},
  [1410] = {.lex_state = 0, .external_lex_state = 75},
  [1411] = {.lex_state = 0, .external_lex_state = 75},
  [1412] = {.lex_state = 0, .external_lex_state = 80},
  [1413] = {.lex_state = 0, .external_lex_state = 80},
  [1414] = {.lex_state = 0, .external_lex_state = 94},
  [1415] = {.lex_state = 0, .external_lex_state = 95},
  [1416] = {.lex_state = 0, .external_lex_state = 65},
  [1417] = {.lex_state = 0, .external_lex_state = 96},
  [1418] = {.lex_state = 0, .external_lex_state = 62},
  [1419] = {.lex_state = 0, .external_lex_state = 79},
  [1420] = {.lex_state = 0, .external_lex_state = 80},
  [1421] = {.lex_state = 0, .external_lex_state = 80},
  [1422] = {.lex_state = 0, .external_lex_state = 80},
  [1423] = {.lex_state = 0, .external_lex_state = 80},
  [1424] = {.lex_state = 0, .external_lex_state = 65},
  [1425] = {.lex_state = 0, .external_lex_state = 70},
  [1426] = {.lex_state = 0, .external_lex_state = 97},
  [1427] = {.lex_state = 0, .external_lex_state = 80},
  [1428] = {.lex_state = 0, .external_lex_state = 80},
  [1429] = {.lex_state = 0, .external_lex_state = 80},
  [1430] = {.lex_state = 0, .external_lex_state = 80},
  [1431] = {.lex_state = 0, .external_lex_state = 80},
  [1432] = {.lex_state = 0, .external_lex_state = 65},
  [1433] = {.lex_state = 0, .external_lex_state = 80},
  [1434] = {.lex_state = 0, .external_lex_state = 80},
  [1435] = {.lex_state = 0, .external_lex_state = 70},
  [1436] = {.lex_state = 0, .external_lex_state = 80},
  [1437] = {.lex_state = 0, .external_lex_state = 80},
  [1438] = {.lex_state = 0, .external_lex_state = 98},
  [1439] = {.lex_state = 0, .external_lex_state = 98},
  [1440] = {.lex_state = 0, .external_lex_state = 99},
  [1441] = {.lex_state = 0, .external_lex_state = 100},
  [1442] = {.lex_state = 0, .external_lex_state = 64},
  [1443] = {.lex_state = 0, .external_lex_state = 68},
  [1444] = {.lex_state = 0, .external_lex_state = 80},
  [1445] = {.lex_state = 0, .external_lex_state = 101},
  [1446] = {.lex_state = 0, .external_lex_state = 97},
  [1447] = {.lex_state = 0, .external_lex_state = 80},
  [1448] = {.lex_state = 0, .external_lex_state = 68},
  [1449] = {.lex_state = 0, .external_lex_state = 102},
  [1450] = {.lex_state = 13},
  [1451] = {.lex_state = 13},
  [1452] = {.lex_state = 0, .external_lex_state = 80},
  [1453] = {.lex_state = 0, .external_lex_state = 102},
  [1454] = {.lex_state = 0, .external_lex_state = 64},
  [1455] = {.lex_state = 0, .external_lex_state = 80},
  [1456] = {.lex_state = 0, .external_lex_state = 72},
  [1457] = {.lex_state = 0, .external_lex_state = 80},
  [1458] = {.lex_state = 0, .external_lex_state = 80},
  [1459] = {.lex_state = 0, .external_lex_state = 75},
  [1460] = {.lex_state = 0, .external_lex_state = 80},
  [1461] = {.lex_state = 0, .external_lex_state = 100},
  [1462] = {.lex_state = 0, .external_lex_state = 80},
  [1463] = {.lex_state = 0, .external_lex_state = 80},
  [1464] = {.lex_state = 0, .external_lex_state = 67},
  [1465] = {.lex_state = 0, .external_lex_state = 80},
  [1466] = {.lex_state = 0, .external_lex_state = 80},
  [1467] = {.lex_state = 0, .external_lex_state = 80},
  [1468] = {.lex_state = 0, .external_lex_state = 76},
  [1469] = {.lex_state = 0, .external_lex_state = 80},
  [1470] = {.lex_state = 0, .external_lex_state = 80},
  [1471] = {.lex_state = 0, .external_lex_state = 80},
  [1472] = {.lex_state = 0, .external_lex_state = 76},
  [1473] = {.lex_state = 0, .external_lex_state = 80},
  [1474] = {.lex_state = 0, .external_lex_state = 103},
  [1475] = {.lex_state = 0, .external_lex_state = 94},
  [1476] = {.lex_state = 0, .external_lex_state = 80},
  [1477] = {.lex_state = 0, .external_lex_state = 104},
  [1478] = {.lex_state = 0, .external_lex_state = 80},
  [1479] = {.lex_state = 0, .external_lex_state = 103},
  [1480] = {.lex_state = 0, .external_lex_state = 79},
  [1481] = {.lex_state = 0, .external_lex_state = 80},
  [1482] = {.lex_state = 0, .external_lex_state = 75},
  [1483] = {.lex_state = 0, .external_lex_state = 101},
  [1484] = {.lex_state = 0, .external_lex_state = 80},
  [1485] = {.lex_state = 0, .external_lex_state = 66},
  [1486] = {.lex_state = 0, .external_lex_state = 80},
  [1487] = {.lex_state = 0, .external_lex_state = 79},
  [1488] = {.lex_state = 0, .external_lex_state = 71},
  [1489] = {.lex_state = 0, .external_lex_state = 61},
  [1490] = {.lex_state = 0, .external_lex_state = 80},
  [1491] = {.lex_state = 0, .external_lex_state = 80},
  [1492] = {.lex_state = 0, .external_lex_state = 105},
  [1493] = {.lex_state = 0, .external_lex_state = 105},
  [1494] = {.lex_state = 0, .external_lex_state = 64},
  [1495] = {.lex_state = 0, .external_lex_state = 80},
  [1496] = {.lex_state = 0, .external_lex_state = 104},
  [1497] = {.lex_state = 0, .external_lex_state = 61},
  [1498] = {.lex_state = 0, .external_lex_state = 74},
  [1499] = {.lex_state = 0, .external_lex_state = 61},
  [1500] = {.lex_state = 0, .external_lex_state = 80},
  [1501] = {.lex_state = 0, .external_lex_state = 69},
  [1502] = {.lex_state = 0, .external_lex_state = 106},
  [1503] = {.lex_state = 0, .external_lex_state = 69},
  [1504] = {.lex_state = 0, .external_lex_state = 80},
  [1505] = {.lex_state = 0, .external_lex_state = 106},
  [1506] = {.lex_state = 0, .external_lex_state = 107},
  [1507] = {.lex_state = 0, .external_lex_state = 65},
  [1508] = {.lex_state = 11, .external_lex_state = 108},
  [1509] = {.lex_state = 0, .external_lex_state = 109},
  [1510] = {.lex_state = 0, .external_lex_state = 76},
  [1511] = {.lex_state = 0, .external_lex_state = 110},
  [1512] = {.lex_state = 0, .external_lex_state = 110},
  [1513] = {.lex_state = 0, .external_lex_state = 80},
  [1514] = {.lex_state = 0, .external_lex_state = 67},
  [1515] = {.lex_state = 0, .external_lex_state = 71},
  [1516] = {.lex_state = 0, .external_lex_state = 73},
  [1517] = {.lex_state = 0, .external_lex_state = 72},
  [1518] = {.lex_state = 0, .external_lex_state = 71},
  [1519] = {.lex_state = 0, .external_lex_state = 80},
  [1520] = {.lex_state = 0, .external_lex_state = 73},
  [1521] = {.lex_state = 0, .external_lex_state = 111},
  [1522] = {.lex_state = 0, .external_lex_state = 66},
  [1523] = {.lex_state = 11, .external_lex_state = 108},
  [1524] = {.lex_state = 0, .external_lex_state = 77},
  [1525] = {.lex_state = 64, .external_lex_state = 60},
  [1526] = {.lex_state = 0, .external_lex_state = 72},
  [1527] = {.lex_state = 0, .external_lex_state = 70},
  [1528] = {.lex_state = 0, .external_lex_state = 61},
  [1529] = {.lex_state = 0, .external_lex_state = 69},
  [1530] = {.lex_state = 64, .external_lex_state = 60},
  [1531] = {.lex_state = 0, .external_lex_state = 64},
  [1532] = {.lex_state = 0, .external_lex_state = 109},
  [1533] = {.lex_state = 0, .external_lex_state = 109},
  [1534] = {.lex_state = 0, .external_lex_state = 80},
  [1535] = {.lex_state = 0, .external_lex_state = 69},
  [1536] = {.lex_state = 0, .external_lex_state = 74},
  [1537] = {.lex_state = 0, .external_lex_state = 80},
  [1538] = {.lex_state = 0, .external_lex_state = 78},
  [1539] = {.lex_state = 0, .external_lex_state = 67},
  [1540] = {.lex_state = 0, .external_lex_state = 80},
  [1541] = {.lex_state = 0, .external_lex_state = 79},
  [1542] = {.lex_state = 0, .external_lex_state = 96},
  [1543] = {.lex_state = 0, .external_lex_state = 78},
  [1544] = {.lex_state = 14},
  [1545] = {.lex_state = 0, .external_lex_state = 73},
  [1546] = {.lex_state = 0, .external_lex_state = 80},
  [1547] = {.lex_state = 0, .external_lex_state = 77},
  [1548] = {.lex_state = 0, .external_lex_state = 73},
  [1549] = {.lex_state = 13},
  [1550] = {.lex_state = 0, .external_lex_state = 69},
  [1551] = {.lex_state = 0, .external_lex_state = 107},
  [1552] = {.lex_state = 11, .external_lex_state = 108},
  [1553] = {.lex_state = 0, .external_lex_state = 112},
  [1554] = {.lex_state = 0, .external_lex_state = 95},
  [1555] = {.lex_state = 0, .external_lex_state = 95},
  [1556] = {.lex_state = 0, .external_lex_state = 113},
  [1557] = {.lex_state = 0, .external_lex_state = 114},
  [1558] = {.lex_state = 64, .external_lex_state = 115},
  [1559] = {.lex_state = 0, .external_lex_state = 71},
  [1560] = {.lex_state = 64, .external_lex_state = 115},
  [1561] = {.lex_state = 11, .external_lex_state = 108},
  [1562] = {.lex_state = 0, .external_lex_state = 71},
  [1563] = {.lex_state = 0, .external_lex_state = 80},
  [1564] = {.lex_state = 0, .external_lex_state = 62},
  [1565] = {.lex_state = 0, .external_lex_state = 70},
  [1566] = {.lex_state = 0, .external_lex_state = 77},
  [1567] = {.lex_state = 0, .external_lex_state = 72},
  [1568] = {.lex_state = 0, .external_lex_state = 74},
  [1569] = {.lex_state = 0, .external_lex_state = 63},
  [1570] = {.lex_state = 11, .external_lex_state = 108},
  [1571] = {.lex_state = 0, .external_lex_state = 66},
  [1572] = {.lex_state = 0, .external_lex_state = 80},
  [1573] = {.lex_state = 0, .external_lex_state = 81},
  [1574] = {.lex_state = 0, .external_lex_state = 80},
  [1575] = {.lex_state = 0, .external_lex_state = 112},
  [1576] = {.lex_state = 0, .external_lex_state = 74},
  [1577] = {.lex_state = 0, .external_lex_state = 64},
  [1578] = {.lex_state = 0, .external_lex_state = 116},
  [1579] = {.lex_state = 11, .external_lex_state = 108},
  [1580] = {.lex_state = 0, .external_lex_state = 80},
  [1581] = {.lex_state = 0, .external_lex_state = 78},
  [1582] = {.lex_state = 0, .external_lex_state = 117},
  [1583] = {.lex_state = 0, .external_lex_state = 77},
  [1584] = {.lex_state = 0, .external_lex_state = 117},
  [1585] = {.lex_state = 0, .external_lex_state = 111},
  [1586] = {.lex_state = 0, .external_lex_state = 118},
  [1587] = {.lex_state = 0, .external_lex_state = 119},
  [1588] = {.lex_state = 11, .external_lex_state = 108},
  [1589] = {.lex_state = 0, .external_lex_state = 75},
  [1590] = {.lex_state = 0, .external_lex_state = 120},
  [1591] = {.lex_state = 0, .external_lex_state = 67},
  [1592] = {.lex_state = 0, .external_lex_state = 118},
  [1593] = {.lex_state = 0, .external_lex_state = 113},
  [1594] = {.lex_state = 0, .external_lex_state = 119},
  [1595] = {.lex_state = 0, .external_lex_state = 119},
  [1596] = {.lex_state = 0, .external_lex_state = 81},
  [1597] = {.lex_state = 11, .external_lex_state = 108},
  [1598] = {.lex_state = 0, .external_lex_state = 78},
  [1599] = {.lex_state = 0, .external_lex_state = 78},
  [1600] = {.lex_state = 0, .external_lex_state = 73},
  [1601] = {.lex_state = 0, .external_lex_state = 65},
  [1602] = {.lex_state = 0, .external_lex_state = 62},
  [1603] = {.lex_state = 0, .external_lex_state = 63},
  [1604] = {.lex_state = 0, .external_lex_state = 68},
  [1605] = {.lex_state = 0, .external_lex_state = 76},
  [1606] = {.lex_state = 11, .external_lex_state = 108},
  [1607] = {.lex_state = 0, .external_lex_state = 79},
  [1608] = {.lex_state = 0, .external_lex_state = 120},
  [1609] = {.lex_state = 0, .external_lex_state = 120},
  [1610] = {.lex_state = 0, .external_lex_state = 120},
  [1611] = {.lex_state = 0, .external_lex_state = 67},
  [1612] = {.lex_state = 0, .external_lex_state = 61},
  [1613] = {.lex_state = 0, .external_lex_state = 119},
  [1614] = {.lex_state = 0, .external_lex_state = 95},
  [1615] = {.lex_state = 11, .external_lex_state = 108},
  [1616] = {.lex_state = 0, .external_lex_state = 66},
  [1617] = {.lex_state = 0, .external_lex_state = 120},
  [1618] = {.lex_state = 0, .external_lex_state = 120},
  [1619] = {.lex_state = 0, .external_lex_state = 95},
  [1620] = {.lex_state = 0, .external_lex_state = 62},
  [1621] = {.lex_state = 0, .external_lex_state = 121},
  [1622] = {.lex_state = 0, .external_lex_state = 74},
  [1623] = {.lex_state = 0, .external_lex_state = 70},
  [1624] = {.lex_state = 11, .external_lex_state = 108},
  [1625] = {.lex_state = 0, .external_lex_state = 114},
  [1626] = {.lex_state = 0, .external_lex_state = 77},
  [1627] = {.lex_state = 0, .external_lex_state = 63},
  [1628] = {.lex_state = 0, .external_lex_state = 68},
  [1629] = {.lex_state = 11, .external_lex_state = 108},
  [1630] = {.lex_state = 8},
  [1631] = {.lex_state = 8},
  [1632] = {.lex_state = 0, .external_lex_state = 72},
  [1633] = {.lex_state = 0, .external_lex_state = 68},
  [1634] = {.lex_state = 0, .external_lex_state = 63},
  [1635] = {.lex_state = 0, .external_lex_state = 122},
  [1636] = {.lex_state = 0, .external_lex_state = 76},
  [1637] = {.lex_state = 0, .external_lex_state = 63},
  [1638] = {.lex_state = 0, .external_lex_state = 62},
  [1639] = {.lex_state = 0, .external_lex_state = 122},
  [1640] = {.lex_state = 0, .external_lex_state = 121},
  [1641] = {.lex_state = 0, .external_lex_state = 66},
  [1642] = {.lex_state = 0, .external_lex_state = 80},
  [1643] = {.lex_state = 11, .external_lex_state = 108},
  [1644] = {.lex_state = 0, .external_lex_state = 123},
  [1645] = {.lex_state = 0, .external_lex_state = 60},
  [1646] = {.lex_state = 0, .external_lex_state = 124},
  [1647] = {.lex_state = 0},
  [1648] = {.lex_state = 0, .external_lex_state = 60},
  [1649] = {.lex_state = 44, .external_lex_state = 59},
  [1650] = {.lex_state = 0, .external_lex_state = 125},
  [1651] = {.lex_state = 0, .external_lex_state = 126},
  [1652] = {.lex_state = 0, .external_lex_state = 60},
  [1653] = {.lex_state = 0, .external_lex_state = 101},
  [1654] = {.lex_state = 0, .external_lex_state = 125},
  [1655] = {.lex_state = 44, .external_lex_state = 59},
  [1656] = {.lex_state = 0, .external_lex_state = 126},
  [1657] = {.lex_state = 0, .external_lex_state = 127},
  [1658] = {.lex_state = 0, .external_lex_state = 127},
  [1659] = {.lex_state = 0, .external_lex_state = 111},
  [1660] = {.lex_state = 0, .external_lex_state = 60},
  [1661] = {.lex_state = 44, .external_lex_state = 59},
  [1662] = {.lex_state = 0, .external_lex_state = 60},
  [1663] = {.lex_state = 0, .external_lex_state = 95},
  [1664] = {.lex_state = 0, .external_lex_state = 127},
  [1665] = {.lex_state = 0, .external_lex_state = 128},
  [1666] = {.lex_state = 0, .external_lex_state = 125},
  [1667] = {.lex_state = 0, .external_lex_state = 126},
  [1668] = {.lex_state = 0, .external_lex_state = 129},
  [1669] = {.lex_state = 0, .external_lex_state = 130},
  [1670] = {.lex_state = 0, .external_lex_state = 123},
  [1671] = {.lex_state = 0, .external_lex_state = 131},
  [1672] = {.lex_state = 0, .external_lex_state = 132},
  [1673] = {.lex_state = 0, .external_lex_state = 128},
  [1674] = {.lex_state = 0, .external_lex_state = 128},
  [1675] = {.lex_state = 0, .external_lex_state = 133},
  [1676] = {.lex_state = 0, .external_lex_state = 129},
  [1677] = {.lex_state = 0, .external_lex_state = 127},
  [1678] = {.lex_state = 0, .external_lex_state = 60},
  [1679] = {.lex_state = 0, .external_lex_state = 130},
  [1680] = {.lex_state = 0, .external_lex_state = 60},
  [1681] = {.lex_state = 0, .external_lex_state = 60},
  [1682] = {.lex_state = 0, .external_lex_state = 60},
  [1683] = {.lex_state = 0, .external_lex_state = 60},
  [1684] = {.lex_state = 0, .external_lex_state = 60},
  [1685] = {.lex_state = 0, .external_lex_state = 60},
  [1686] = {.lex_state = 0, .external_lex_state = 60},
  [1687] = {.lex_state = 0, .external_lex_state = 60},
  [1688] = {.lex_state = 0, .external_lex_state = 60},
  [1689] = {.lex_state = 0, .external_lex_state = 60},
  [1690] = {.lex_state = 0, .external_lex_state = 60},
  [1691] = {.lex_state = 0, .external_lex_state = 60},
  [1692] = {.lex_state = 0, .external_lex_state = 60},
  [1693] = {.lex_state = 0, .external_lex_state = 60},
  [1694] = {.lex_state = 0, .external_lex_state = 124},
  [1695] = {.lex_state = 0, .external_lex_state = 122},
  [1696] = {.lex_state = 0, .external_lex_state = 125},
  [1697] = {.lex_state = 0, .external_lex_state = 126},
  [1698] = {.lex_state = 0, .external_lex_state = 97},
  [1699] = {.lex_state = 0, .external_lex_state = 127},
  [1700] = {.lex_state = 0, .external_lex_state = 123},
  [1701] = {.lex_state = 44, .external_lex_state = 59},
  [1702] = {.lex_state = 8},
  [1703] = {.lex_state = 0, .external_lex_state = 96},
  [1704] = {.lex_state = 0, .external_lex_state = 128},
  [1705] = {.lex_state = 0, .external_lex_state = 125},
  [1706] = {.lex_state = 0, .external_lex_state = 126},
  [1707] = {.lex_state = 0, .external_lex_state = 129},
  [1708] = {.lex_state = 0, .external_lex_state = 130},
  [1709] = {.lex_state = 0, .external_lex_state = 123},
  [1710] = {.lex_state = 0, .external_lex_state = 131},
  [1711] = {.lex_state = 0, .external_lex_state = 132},
  [1712] = {.lex_state = 0, .external_lex_state = 128},
  [1713] = {.lex_state = 0, .external_lex_state = 128},
  [1714] = {.lex_state = 0, .external_lex_state = 133},
  [1715] = {.lex_state = 0, .external_lex_state = 127},
  [1716] = {.lex_state = 0, .external_lex_state = 109},
  [1717] = {.lex_state = 64},
  [1718] = {.lex_state = 8},
  [1719] = {.lex_state = 0, .external_lex_state = 124},
  [1720] = {.lex_state = 0, .external_lex_state = 124},
  [1721] = {.lex_state = 0, .external_lex_state = 88},
  [1722] = {.lex_state = 0, .external_lex_state = 125},
  [1723] = {.lex_state = 0, .external_lex_state = 126},
  [1724] = {.lex_state = 0, .external_lex_state = 107},
  [1725] = {.lex_state = 44, .external_lex_state = 59},
  [1726] = {.lex_state = 0, .external_lex_state = 128},
  [1727] = {.lex_state = 0, .external_lex_state = 125},
  [1728] = {.lex_state = 0, .external_lex_state = 126},
  [1729] = {.lex_state = 0, .external_lex_state = 129},
  [1730] = {.lex_state = 0, .external_lex_state = 130},
  [1731] = {.lex_state = 0, .external_lex_state = 123},
  [1732] = {.lex_state = 0, .external_lex_state = 131},
  [1733] = {.lex_state = 0, .external_lex_state = 132},
  [1734] = {.lex_state = 0, .external_lex_state = 128},
  [1735] = {.lex_state = 0, .external_lex_state = 128},
  [1736] = {.lex_state = 0, .external_lex_state = 133},
  [1737] = {.lex_state = 0, .external_lex_state = 124},
  [1738] = {.lex_state = 0, .external_lex_state = 125},
  [1739] = {.lex_state = 0, .external_lex_state = 126},
  [1740] = {.lex_state = 0, .external_lex_state = 88},
  [1741] = {.lex_state = 0, .external_lex_state = 109},
  [1742] = {.lex_state = 0, .external_lex_state = 60},
  [1743] = {.lex_state = 0, .external_lex_state = 134},
  [1744] = {.lex_state = 0, .external_lex_state = 128},
  [1745] = {.lex_state = 0, .external_lex_state = 125},
  [1746] = {.lex_state = 0, .external_lex_state = 126},
  [1747] = {.lex_state = 0, .external_lex_state = 129},
  [1748] = {.lex_state = 0, .external_lex_state = 130},
  [1749] = {.lex_state = 0, .external_lex_state = 123},
  [1750] = {.lex_state = 0, .external_lex_state = 131},
  [1751] = {.lex_state = 0, .external_lex_state = 132},
  [1752] = {.lex_state = 0, .external_lex_state = 128},
  [1753] = {.lex_state = 0, .external_lex_state = 128},
  [1754] = {.lex_state = 0, .external_lex_state = 133},
  [1755] = {.lex_state = 0, .external_lex_state = 104},
  [1756] = {.lex_state = 8},
  [1757] = {.lex_state = 0, .external_lex_state = 124},
  [1758] = {.lex_state = 0, .external_lex_state = 125},
  [1759] = {.lex_state = 0, .external_lex_state = 126},
  [1760] = {.lex_state = 0, .external_lex_state = 128},
  [1761] = {.lex_state = 0, .external_lex_state = 125},
  [1762] = {.lex_state = 0, .external_lex_state = 126},
  [1763] = {.lex_state = 0, .external_lex_state = 129},
  [1764] = {.lex_state = 0, .external_lex_state = 130},
  [1765] = {.lex_state = 0, .external_lex_state = 123},
  [1766] = {.lex_state = 0, .external_lex_state = 131},
  [1767] = {.lex_state = 0, .external_lex_state = 132},
  [1768] = {.lex_state = 0, .external_lex_state = 128},
  [1769] = {.lex_state = 0, .external_lex_state = 128},
  [1770] = {.lex_state = 0, .external_lex_state = 133},
  [1771] = {.lex_state = 0, .external_lex_state = 124},
  [1772] = {.lex_state = 0, .external_lex_state = 125},
  [1773] = {.lex_state = 0, .external_lex_state = 126},
  [1774] = {.lex_state = 0, .external_lex_state = 128},
  [1775] = {.lex_state = 0, .external_lex_state = 125},
  [1776] = {.lex_state = 0, .external_lex_state = 126},
  [1777] = {.lex_state = 0, .external_lex_state = 129},
  [1778] = {.lex_state = 0, .external_lex_state = 130},
  [1779] = {.lex_state = 0, .external_lex_state = 123},
  [1780] = {.lex_state = 0, .external_lex_state = 131},
  [1781] = {.lex_state = 0, .external_lex_state = 132},
  [1782] = {.lex_state = 0, .external_lex_state = 128},
  [1783] = {.lex_state = 0, .external_lex_state = 128},
  [1784] = {.lex_state = 0, .external_lex_state = 133},
  [1785] = {.lex_state = 0, .external_lex_state = 135},
  [1786] = {.lex_state = 0, .external_lex_state = 124},
  [1787] = {.lex_state = 0, .external_lex_state = 125},
  [1788] = {.lex_state = 0, .external_lex_state = 126},
  [1789] = {.lex_state = 0, .external_lex_state = 136},
  [1790] = {.lex_state = 12, .external_lex_state = 59},
  [1791] = {.lex_state = 0, .external_lex_state = 128},
  [1792] = {.lex_state = 0, .external_lex_state = 125},
  [1793] = {.lex_state = 0, .external_lex_state = 126},
  [1794] = {.lex_state = 0, .external_lex_state = 129},
  [1795] = {.lex_state = 0, .external_lex_state = 130},
  [1796] = {.lex_state = 0, .external_lex_state = 123},
  [1797] = {.lex_state = 0, .external_lex_state = 131},
  [1798] = {.lex_state = 0, .external_lex_state = 132},
  [1799] = {.lex_state = 0, .external_lex_state = 128},
  [1800] = {.lex_state = 0, .external_lex_state = 128},
  [1801] = {.lex_state = 0, .external_lex_state = 133},
  [1802] = {.lex_state = 0, .external_lex_state = 124},
  [1803] = {.lex_state = 0, .external_lex_state = 125},
  [1804] = {.lex_state = 0, .external_lex_state = 126},
  [1805] = {.lex_state = 0, .external_lex_state = 100},
  [1806] = {.lex_state = 0, .external_lex_state = 127},
  [1807] = {.lex_state = 0, .external_lex_state = 95},
  [1808] = {.lex_state = 0, .external_lex_state = 135},
  [1809] = {.lex_state = 0, .external_lex_state = 135},
  [1810] = {.lex_state = 0, .external_lex_state = 128},
  [1811] = {.lex_state = 0, .external_lex_state = 125},
  [1812] = {.lex_state = 0, .external_lex_state = 126},
  [1813] = {.lex_state = 0, .external_lex_state = 129},
  [1814] = {.lex_state = 0, .external_lex_state = 130},
  [1815] = {.lex_state = 0, .external_lex_state = 123},
  [1816] = {.lex_state = 0, .external_lex_state = 131},
  [1817] = {.lex_state = 0, .external_lex_state = 132},
  [1818] = {.lex_state = 0, .external_lex_state = 128},
  [1819] = {.lex_state = 0, .external_lex_state = 128},
  [1820] = {.lex_state = 0, .external_lex_state = 133},
  [1821] = {.lex_state = 0, .external_lex_state = 121},
  [1822] = {.lex_state = 0, .external_lex_state = 124},
  [1823] = {.lex_state = 0, .external_lex_state = 125},
  [1824] = {.lex_state = 0, .external_lex_state = 126},
  [1825] = {.lex_state = 0, .external_lex_state = 98},
  [1826] = {.lex_state = 0, .external_lex_state = 128},
  [1827] = {.lex_state = 0, .external_lex_state = 125},
  [1828] = {.lex_state = 0, .external_lex_state = 60},
  [1829] = {.lex_state = 0, .external_lex_state = 129},
  [1830] = {.lex_state = 0, .external_lex_state = 130},
  [1831] = {.lex_state = 0, .external_lex_state = 123},
  [1832] = {.lex_state = 0, .external_lex_state = 131},
  [1833] = {.lex_state = 0, .external_lex_state = 132},
  [1834] = {.lex_state = 0, .external_lex_state = 128},
  [1835] = {.lex_state = 0, .external_lex_state = 128},
  [1836] = {.lex_state = 0, .external_lex_state = 133},
  [1837] = {.lex_state = 0, .external_lex_state = 124},
  [1838] = {.lex_state = 0, .external_lex_state = 125},
  [1839] = {.lex_state = 0, .external_lex_state = 126},
  [1840] = {.lex_state = 0, .external_lex_state = 102},
  [1841] = {.lex_state = 0, .external_lex_state = 103},
  [1842] = {.lex_state = 0, .external_lex_state = 128},
  [1843] = {.lex_state = 0, .external_lex_state = 125},
  [1844] = {.lex_state = 0, .external_lex_state = 126},
  [1845] = {.lex_state = 0, .external_lex_state = 129},
  [1846] = {.lex_state = 0, .external_lex_state = 130},
  [1847] = {.lex_state = 0, .external_lex_state = 123},
  [1848] = {.lex_state = 0, .external_lex_state = 131},
  [1849] = {.lex_state = 0, .external_lex_state = 132},
  [1850] = {.lex_state = 0, .external_lex_state = 128},
  [1851] = {.lex_state = 0, .external_lex_state = 128},
  [1852] = {.lex_state = 0, .external_lex_state = 133},
  [1853] = {.lex_state = 0, .external_lex_state = 125},
  [1854] = {.lex_state = 0, .external_lex_state = 126},
  [1855] = {.lex_state = 0, .external_lex_state = 124},
  [1856] = {.lex_state = 0, .external_lex_state = 125},
  [1857] = {.lex_state = 0, .external_lex_state = 126},
  [1858] = {.lex_state = 0, .external_lex_state = 136},
  [1859] = {.lex_state = 0, .external_lex_state = 136},
  [1860] = {.lex_state = 0, .external_lex_state = 105},
  [1861] = {.lex_state = 0, .external_lex_state = 136},
  [1862] = {.lex_state = 42, .external_lex_state = 89},
  [1863] = {.lex_state = 0, .external_lex_state = 94},
  [1864] = {.lex_state = 0, .external_lex_state = 106},
  [1865] = {.lex_state = 0, .external_lex_state = 114},
  [1866] = {.lex_state = 0, .external_lex_state = 110},
  [1867] = {.lex_state = 0, .external_lex_state = 135},
  [1868] = {.lex_state = 8},
  [1869] = {.lex_state = 0, .external_lex_state = 136},
  [1870] = {.lex_state = 0, .external_lex_state = 136},
  [1871] = {.lex_state = 64, .external_lex_state = 115},
  [1872] = {.lex_state = 0, .external_lex_state = 137},
  [1873] = {.lex_state = 0, .external_lex_state = 88},
  [1874] = {.lex_state = 0, .external_lex_state = 117},
  [1875] = {.lex_state = 0, .external_lex_state = 118},
  [1876] = {.lex_state = 8},
  [1877] = {.lex_state = 8},
  [1878] = {.lex_state = 0, .external_lex_state = 128},
  [1879] = {.lex_state = 0, .external_lex_state = 125},
  [1880] = {.lex_state = 0, .external_lex_state = 126},
  [1881] = {.lex_state = 0, .external_lex_state = 129},
  [1882] = {.lex_state = 0, .external_lex_state = 130},
  [1883] = {.lex_state = 0, .external_lex_state = 123},
  [1884] = {.lex_state = 0, .external_lex_state = 131},
  [1885] = {.lex_state = 0, .external_lex_state = 132},
  [1886] = {.lex_state = 0, .external_lex_state = 128},
  [1887] = {.lex_state = 0, .external_lex_state = 128},
  [1888] = {.lex_state = 0, .external_lex_state = 133},
  [1889] = {.lex_state = 8},
  [1890] = {.lex_state = 8},
  [1891] = {.lex_state = 0, .external_lex_state = 127},
  [1892] = {.lex_state = 64, .external_lex_state = 91},
  [1893] = {.lex_state = 0, .external_lex_state = 112},
  [1894] = {.lex_state = 0, .external_lex_state = 131},
  [1895] = {.lex_state = 0, .external_lex_state = 60},
  [1896] = {.lex_state = 8},
  [1897] = {.lex_state = 8},
  [1898] = {.lex_state = 0, .external_lex_state = 132},
  [1899] = {.lex_state = 8},
  [1900] = {.lex_state = 0, .external_lex_state = 128},
  [1901] = {.lex_state = 0, .external_lex_state = 60},
  [1902] = {.lex_state = 0, .external_lex_state = 88},
  [1903] = {.lex_state = 0, .external_lex_state = 124},
  [1904] = {.lex_state = 8},
  [1905] = {.lex_state = 0, .external_lex_state = 88},
  [1906] = {.lex_state = 8},
  [1907] = {.lex_state = 8},
  [1908] = {.lex_state = 0, .external_lex_state = 60},
  [1909] = {.lex_state = 0, .external_lex_state = 125},
  [1910] = {.lex_state = 0, .external_lex_state = 126},
  [1911] = {.lex_state = 8},
  [1912] = {.lex_state = 0, .external_lex_state = 60},
  [1913] = {.lex_state = 8},
  [1914] = {.lex_state = 0, .external_lex_state = 113},
  [1915] = {.lex_state = 0, .external_lex_state = 128},
  [1916] = {.lex_state = 0, .external_lex_state = 127},
  [1917] = {.lex_state = 8},
  [1918] = {.lex_state = 8},
  [1919] = {.lex_state = 0, .external_lex_state = 60},
  [1920] = {.lex_state = 8},
  [1921] = {.lex_state = 8},
  [1922] = {.lex_state = 0, .external_lex_state = 60},
  [1923] = {.lex_state = 0, .external_lex_state = 60},
  [1924] = {.lex_state = 0, .external_lex_state = 60},
  [1925] = {.lex_state = 8},
  [1926] = {.lex_state = 0, .external_lex_state = 60},
  [1927] = {.lex_state = 8},
  [1928] = {.lex_state = 0, .external_lex_state = 60},
  [1929] = {.lex_state = 0, .external_lex_state = 60},
  [1930] = {.lex_state = 0, .external_lex_state = 60},
  [1931] = {.lex_state = 0, .external_lex_state = 60},
  [1932] = {.lex_state = 8},
  [1933] = {.lex_state = 8},
  [1934] = {.lex_state = 0, .external_lex_state = 60},
  [1935] = {.lex_state = 8},
  [1936] = {.lex_state = 44, .external_lex_state = 59},
  [1937] = {.lex_state = 8},
  [1938] = {.lex_state = 0, .external_lex_state = 60},
  [1939] = {.lex_state = 0, .external_lex_state = 60},
  [1940] = {.lex_state = 0, .external_lex_state = 60},
  [1941] = {.lex_state = 8},
  [1942] = {.lex_state = 0, .external_lex_state = 60},
  [1943] = {.lex_state = 8},
  [1944] = {.lex_state = 0, .external_lex_state = 60},
  [1945] = {.lex_state = 0, .external_lex_state = 128},
  [1946] = {.lex_state = 0, .external_lex_state = 125},
  [1947] = {.lex_state = 0, .external_lex_state = 126},
  [1948] = {.lex_state = 0, .external_lex_state = 129},
  [1949] = {.lex_state = 0, .external_lex_state = 130},
  [1950] = {.lex_state = 0, .external_lex_state = 60},
  [1951] = {.lex_state = 0, .external_lex_state = 131},
  [1952] = {.lex_state = 8},
  [1953] = {.lex_state = 0, .external_lex_state = 132},
  [1954] = {.lex_state = 8},
  [1955] = {.lex_state = 0, .external_lex_state = 128},
  [1956] = {.lex_state = 0, .external_lex_state = 128},
  [1957] = {.lex_state = 0, .external_lex_state = 133},
  [1958] = {.lex_state = 0, .external_lex_state = 60},
  [1959] = {.lex_state = 0, .external_lex_state = 127},
  [1960] = {.lex_state = 0, .external_lex_state = 60},
  [1961] = {.lex_state = 0, .external_lex_state = 60},
  [1962] = {.lex_state = 0, .external_lex_state = 60},
  [1963] = {.lex_state = 0, .external_lex_state = 133},
  [1964] = {.lex_state = 0, .external_lex_state = 60},
  [1965] = {.lex_state = 0, .external_lex_state = 128},
  [1966] = {.lex_state = 8},
  [1967] = {.lex_state = 8},
  [1968] = {.lex_state = 8},
  [1969] = {.lex_state = 8},
  [1970] = {.lex_state = 0},
  [1971] = {.lex_state = 0},
  [1972] = {.lex_state = 0, .external_lex_state = 60},
  [1973] = {.lex_state = 0},
  [1974] = {.lex_state = 0},
  [1975] = {.lex_state = 0, .external_lex_state = 126},
  [1976] = {.lex_state = 0, .external_lex_state = 138},
  [1977] = {.lex_state = 3},
  [1978] = {.lex_state = 0, .external_lex_state = 139},
  [1979] = {.lex_state = 0, .external_lex_state = 140},
  [1980] = {.lex_state = 0, .external_lex_state = 141},
  [1981] = {.lex_state = 15},
  [1982] = {.lex_state = 0, .external_lex_state = 142},
  [1983] = {.lex_state = 0, .external_lex_state = 143},
  [1984] = {.lex_state = 0, .external_lex_state = 144},
  [1985] = {.lex_state = 0, .external_lex_state = 145},
  [1986] = {.lex_state = 0, .external_lex_state = 146},
  [1987] = {.lex_state = 0, .external_lex_state = 59},
  [1988] = {.lex_state = 8},
  [1989] = {.lex_state = 0, .external_lex_state = 144},
  [1990] = {.lex_state = 0, .external_lex_state = 139},
  [1991] = {.lex_state = 0, .external_lex_state = 140},
  [1992] = {.lex_state = 0, .external_lex_state = 141},
  [1993] = {.lex_state = 0, .external_lex_state = 143},
  [1994] = {.lex_state = 0, .external_lex_state = 145},
  [1995] = {.lex_state = 0, .external_lex_state = 146},
  [1996] = {.lex_state = 0, .external_lex_state = 147},
  [1997] = {.lex_state = 0, .external_lex_state = 148},
  [1998] = {.lex_state = 3},
  [1999] = {.lex_state = 12},
  [2000] = {.lex_state = 12},
  [2001] = {.lex_state = 0, .external_lex_state = 149},
  [2002] = {.lex_state = 0, .external_lex_state = 59},
  [2003] = {.lex_state = 0, .external_lex_state = 149},
  [2004] = {.lex_state = 8},
  [2005] = {.lex_state = 0, .external_lex_state = 147},
  [2006] = {.lex_state = 0, .external_lex_state = 148},
  [2007] = {.lex_state = 3},
  [2008] = {.lex_state = 0, .external_lex_state = 150},
  [2009] = {.lex_state = 0, .external_lex_state = 59},
  [2010] = {.lex_state = 0, .external_lex_state = 150},
  [2011] = {.lex_state = 0, .external_lex_state = 148},
  [2012] = {.lex_state = 0, .external_lex_state = 148},
  [2013] = {.lex_state = 0, .external_lex_state = 151},
  [2014] = {.lex_state = 0, .external_lex_state = 149},
  [2015] = {.lex_state = 0, .external_lex_state = 59},
  [2016] = {.lex_state = 0, .external_lex_state = 59},
  [2017] = {.lex_state = 0, .external_lex_state = 59},
  [2018] = {.lex_state = 8},
  [2019] = {.lex_state = 0, .external_lex_state = 144},
  [2020] = {.lex_state = 0, .external_lex_state = 152},
  [2021] = {.lex_state = 0, .external_lex_state = 59},
  [2022] = {.lex_state = 0, .external_lex_state = 142},
  [2023] = {.lex_state = 0, .external_lex_state = 59},
  [2024] = {.lex_state = 0, .external_lex_state = 144},
  [2025] = {.lex_state = 0, .external_lex_state = 139},
  [2026] = {.lex_state = 0, .external_lex_state = 140},
  [2027] = {.lex_state = 0, .external_lex_state = 141},
  [2028] = {.lex_state = 0, .external_lex_state = 143},
  [2029] = {.lex_state = 0, .external_lex_state = 145},
  [2030] = {.lex_state = 0, .external_lex_state = 146},
  [2031] = {.lex_state = 0, .external_lex_state = 147},
  [2032] = {.lex_state = 0, .external_lex_state = 148},
  [2033] = {.lex_state = 3},
  [2034] = {.lex_state = 0, .external_lex_state = 142},
  [2035] = {.lex_state = 0, .external_lex_state = 150},
  [2036] = {.lex_state = 0, .external_lex_state = 149},
  [2037] = {.lex_state = 0, .external_lex_state = 142},
  [2038] = {.lex_state = 0, .external_lex_state = 150},
  [2039] = {.lex_state = 8},
  [2040] = {.lex_state = 0, .external_lex_state = 142},
  [2041] = {.lex_state = 8},
  [2042] = {.lex_state = 0, .external_lex_state = 59},
  [2043] = {.lex_state = 0, .external_lex_state = 59},
  [2044] = {.lex_state = 0, .external_lex_state = 59},
  [2045] = {.lex_state = 0, .external_lex_state = 59},
  [2046] = {.lex_state = 0, .external_lex_state = 59},
  [2047] = {.lex_state = 0, .external_lex_state = 59},
  [2048] = {.lex_state = 0, .external_lex_state = 59},
  [2049] = {.lex_state = 0, .external_lex_state = 59},
  [2050] = {.lex_state = 0, .external_lex_state = 59},
  [2051] = {.lex_state = 8},
  [2052] = {.lex_state = 8},
  [2053] = {.lex_state = 0, .external_lex_state = 59},
  [2054] = {.lex_state = 0, .external_lex_state = 144},
  [2055] = {.lex_state = 0, .external_lex_state = 153},
  [2056] = {.lex_state = 0, .external_lex_state = 59},
  [2057] = {.lex_state = 0, .external_lex_state = 142},
  [2058] = {.lex_state = 0, .external_lex_state = 59},
  [2059] = {.lex_state = 0, .external_lex_state = 144},
  [2060] = {.lex_state = 0, .external_lex_state = 139},
  [2061] = {.lex_state = 0, .external_lex_state = 140},
  [2062] = {.lex_state = 0, .external_lex_state = 141},
  [2063] = {.lex_state = 0, .external_lex_state = 143},
  [2064] = {.lex_state = 0, .external_lex_state = 145},
  [2065] = {.lex_state = 0, .external_lex_state = 146},
  [2066] = {.lex_state = 0, .external_lex_state = 147},
  [2067] = {.lex_state = 0, .external_lex_state = 148},
  [2068] = {.lex_state = 3},
  [2069] = {.lex_state = 0, .external_lex_state = 154},
  [2070] = {.lex_state = 0, .external_lex_state = 59},
  [2071] = {.lex_state = 0, .external_lex_state = 149},
  [2072] = {.lex_state = 0, .external_lex_state = 149},
  [2073] = {.lex_state = 0, .external_lex_state = 59},
  [2074] = {.lex_state = 8},
  [2075] = {.lex_state = 0, .external_lex_state = 59},
  [2076] = {.lex_state = 0, .external_lex_state = 59},
  [2077] = {.lex_state = 0},
  [2078] = {.lex_state = 16},
  [2079] = {.lex_state = 0, .external_lex_state = 59},
  [2080] = {.lex_state = 0, .external_lex_state = 59},
  [2081] = {.lex_state = 0, .external_lex_state = 155},
  [2082] = {.lex_state = 0, .external_lex_state = 150},
  [2083] = {.lex_state = 0, .external_lex_state = 142},
  [2084] = {.lex_state = 0, .external_lex_state = 156},
  [2085] = {.lex_state = 0, .external_lex_state = 91},
  [2086] = {.lex_state = 0, .external_lex_state = 150},
  [2087] = {.lex_state = 0, .external_lex_state = 150},
  [2088] = {.lex_state = 0, .external_lex_state = 157},
  [2089] = {.lex_state = 0, .external_lex_state = 144},
  [2090] = {.lex_state = 0, .external_lex_state = 158},
  [2091] = {.lex_state = 0, .external_lex_state = 159},
  [2092] = {.lex_state = 0, .external_lex_state = 144},
  [2093] = {.lex_state = 0, .external_lex_state = 160},
  [2094] = {.lex_state = 0, .external_lex_state = 144},
  [2095] = {.lex_state = 0, .external_lex_state = 139},
  [2096] = {.lex_state = 0, .external_lex_state = 140},
  [2097] = {.lex_state = 0, .external_lex_state = 141},
  [2098] = {.lex_state = 0, .external_lex_state = 143},
  [2099] = {.lex_state = 0, .external_lex_state = 145},
  [2100] = {.lex_state = 0, .external_lex_state = 146},
  [2101] = {.lex_state = 0, .external_lex_state = 147},
  [2102] = {.lex_state = 0, .external_lex_state = 148},
  [2103] = {.lex_state = 3},
  [2104] = {.lex_state = 0, .external_lex_state = 161},
  [2105] = {.lex_state = 0, .external_lex_state = 162},
  [2106] = {.lex_state = 0, .external_lex_state = 149},
  [2107] = {.lex_state = 0, .external_lex_state = 163},
  [2108] = {.lex_state = 0, .external_lex_state = 164},
  [2109] = {.lex_state = 8},
  [2110] = {.lex_state = 0, .external_lex_state = 142},
  [2111] = {.lex_state = 0, .external_lex_state = 165},
  [2112] = {.lex_state = 0, .external_lex_state = 158},
  [2113] = {.lex_state = 0, .external_lex_state = 150},
  [2114] = {.lex_state = 0, .external_lex_state = 59},
  [2115] = {.lex_state = 0, .external_lex_state = 166},
  [2116] = {.lex_state = 0, .external_lex_state = 59},
  [2117] = {.lex_state = 0, .external_lex_state = 59},
  [2118] = {.lex_state = 0, .external_lex_state = 142},
  [2119] = {.lex_state = 0, .external_lex_state = 142},
  [2120] = {.lex_state = 0, .external_lex_state = 144},
  [2121] = {.lex_state = 13},
  [2122] = {.lex_state = 13},
  [2123] = {.lex_state = 0, .external_lex_state = 167},
  [2124] = {.lex_state = 0, .external_lex_state = 144},
  [2125] = {.lex_state = 0, .external_lex_state = 163},
  [2126] = {.lex_state = 0, .external_lex_state = 168},
  [2127] = {.lex_state = 0, .external_lex_state = 59},
  [2128] = {.lex_state = 0, .external_lex_state = 169},
  [2129] = {.lex_state = 0, .external_lex_state = 144},
  [2130] = {.lex_state = 0, .external_lex_state = 139},
  [2131] = {.lex_state = 0, .external_lex_state = 140},
  [2132] = {.lex_state = 0, .external_lex_state = 141},
  [2133] = {.lex_state = 0, .external_lex_state = 143},
  [2134] = {.lex_state = 0, .external_lex_state = 145},
  [2135] = {.lex_state = 0, .external_lex_state = 146},
  [2136] = {.lex_state = 0, .external_lex_state = 147},
  [2137] = {.lex_state = 0, .external_lex_state = 148},
  [2138] = {.lex_state = 3},
  [2139] = {.lex_state = 0, .external_lex_state = 170},
  [2140] = {.lex_state = 0, .external_lex_state = 142},
  [2141] = {.lex_state = 0, .external_lex_state = 149},
  [2142] = {.lex_state = 0, .external_lex_state = 142},
  [2143] = {.lex_state = 44},
  [2144] = {.lex_state = 8},
  [2145] = {.lex_state = 44},
  [2146] = {.lex_state = 0, .external_lex_state = 59},
  [2147] = {.lex_state = 0, .external_lex_state = 171},
  [2148] = {.lex_state = 0, .external_lex_state = 150},
  [2149] = {.lex_state = 0, .external_lex_state = 142},
  [2150] = {.lex_state = 0, .external_lex_state = 142},
  [2151] = {.lex_state = 0, .external_lex_state = 142},
  [2152] = {.lex_state = 0, .external_lex_state = 59},
  [2153] = {.lex_state = 0, .external_lex_state = 144},
  [2154] = {.lex_state = 0, .external_lex_state = 139},
  [2155] = {.lex_state = 0, .external_lex_state = 140},
  [2156] = {.lex_state = 0, .external_lex_state = 142},
  [2157] = {.lex_state = 0, .external_lex_state = 142},
  [2158] = {.lex_state = 0, .external_lex_state = 142},
  [2159] = {.lex_state = 0, .external_lex_state = 144},
  [2160] = {.lex_state = 0, .external_lex_state = 142},
  [2161] = {.lex_state = 0, .external_lex_state = 142},
  [2162] = {.lex_state = 0, .external_lex_state = 59},
  [2163] = {.lex_state = 0, .external_lex_state = 144},
  [2164] = {.lex_state = 0, .external_lex_state = 144},
  [2165] = {.lex_state = 0, .external_lex_state = 139},
  [2166] = {.lex_state = 0, .external_lex_state = 140},
  [2167] = {.lex_state = 0, .external_lex_state = 141},
  [2168] = {.lex_state = 0, .external_lex_state = 143},
  [2169] = {.lex_state = 0, .external_lex_state = 145},
  [2170] = {.lex_state = 0, .external_lex_state = 146},
  [2171] = {.lex_state = 0, .external_lex_state = 147},
  [2172] = {.lex_state = 0, .external_lex_state = 148},
  [2173] = {.lex_state = 3},
  [2174] = {.lex_state = 0, .external_lex_state = 142},
  [2175] = {.lex_state = 0, .external_lex_state = 141},
  [2176] = {.lex_state = 0, .external_lex_state = 149},
  [2177] = {.lex_state = 0, .external_lex_state = 139},
  [2178] = {.lex_state = 0, .external_lex_state = 140},
  [2179] = {.lex_state = 8},
  [2180] = {.lex_state = 0, .external_lex_state = 172},
  [2181] = {.lex_state = 0, .external_lex_state = 141},
  [2182] = {.lex_state = 0, .external_lex_state = 142},
  [2183] = {.lex_state = 0, .external_lex_state = 143},
  [2184] = {.lex_state = 0, .external_lex_state = 145},
  [2185] = {.lex_state = 0, .external_lex_state = 146},
  [2186] = {.lex_state = 0, .external_lex_state = 173},
  [2187] = {.lex_state = 0, .external_lex_state = 147},
  [2188] = {.lex_state = 0, .external_lex_state = 142},
  [2189] = {.lex_state = 0, .external_lex_state = 148},
  [2190] = {.lex_state = 3},
  [2191] = {.lex_state = 0, .external_lex_state = 142},
  [2192] = {.lex_state = 0, .external_lex_state = 142},
  [2193] = {.lex_state = 0, .external_lex_state = 142},
  [2194] = {.lex_state = 0, .external_lex_state = 150},
  [2195] = {.lex_state = 0, .external_lex_state = 173},
  [2196] = {.lex_state = 0, .external_lex_state = 59},
  [2197] = {.lex_state = 0, .external_lex_state = 163},
  [2198] = {.lex_state = 0, .external_lex_state = 142},
  [2199] = {.lex_state = 0, .external_lex_state = 142},
  [2200] = {.lex_state = 8},
  [2201] = {.lex_state = 0, .external_lex_state = 142},
  [2202] = {.lex_state = 0, .external_lex_state = 173},
  [2203] = {.lex_state = 0, .external_lex_state = 142},
  [2204] = {.lex_state = 0, .external_lex_state = 142},
  [2205] = {.lex_state = 0, .external_lex_state = 142},
  [2206] = {.lex_state = 0, .external_lex_state = 142},
  [2207] = {.lex_state = 0, .external_lex_state = 142},
  [2208] = {.lex_state = 0, .external_lex_state = 142},
  [2209] = {.lex_state = 0, .external_lex_state = 142},
  [2210] = {.lex_state = 0, .external_lex_state = 142},
  [2211] = {.lex_state = 0, .external_lex_state = 59},
  [2212] = {.lex_state = 0, .external_lex_state = 142},
  [2213] = {.lex_state = 0, .external_lex_state = 59},
  [2214] = {.lex_state = 0, .external_lex_state = 59},
  [2215] = {.lex_state = 0, .external_lex_state = 149},
  [2216] = {.lex_state = 0, .external_lex_state = 142},
  [2217] = {.lex_state = 0, .external_lex_state = 148},
  [2218] = {.lex_state = 44},
  [2219] = {.lex_state = 15},
  [2220] = {.lex_state = 12},
  [2221] = {.lex_state = 8},
  [2222] = {.lex_state = 0, .external_lex_state = 142},
  [2223] = {.lex_state = 16},
  [2224] = {.lex_state = 0, .external_lex_state = 142},
  [2225] = {.lex_state = 0, .external_lex_state = 59},
  [2226] = {.lex_state = 0, .external_lex_state = 142},
  [2227] = {.lex_state = 0, .external_lex_state = 173},
  [2228] = {.lex_state = 0, .external_lex_state = 59},
  [2229] = {.lex_state = 0, .external_lex_state = 163},
  [2230] = {.lex_state = 0, .external_lex_state = 142},
  [2231] = {.lex_state = 0, .external_lex_state = 142},
  [2232] = {.lex_state = 0, .external_lex_state = 142},
  [2233] = {.lex_state = 0, .external_lex_state = 173},
  [2234] = {.lex_state = 0, .external_lex_state = 59},
  [2235] = {.lex_state = 0, .external_lex_state = 150},
  [2236] = {.lex_state = 0, .external_lex_state = 150},
  [2237] = {.lex_state = 0, .external_lex_state = 142},
  [2238] = {.lex_state = 8},
  [2239] = {.lex_state = 0, .external_lex_state = 59},
  [2240] = {.lex_state = 0, .external_lex_state = 59},
  [2241] = {.lex_state = 0, .external_lex_state = 59},
  [2242] = {.lex_state = 0, .external_lex_state = 142},
  [2243] = {.lex_state = 0, .external_lex_state = 142},
  [2244] = {.lex_state = 0, .external_lex_state = 59},
  [2245] = {.lex_state = 0, .external_lex_state = 59},
  [2246] = {.lex_state = 0, .external_lex_state = 59},
  [2247] = {.lex_state = 0, .external_lex_state = 59},
  [2248] = {.lex_state = 0, .external_lex_state = 148},
  [2249] = {.lex_state = 44},
  [2250] = {.lex_state = 12},
  [2251] = {.lex_state = 8},
  [2252] = {.lex_state = 0, .external_lex_state = 142},
  [2253] = {.lex_state = 16},
  [2254] = {.lex_state = 0, .external_lex_state = 143},
  [2255] = {.lex_state = 0, .external_lex_state = 59},
  [2256] = {.lex_state = 0, .external_lex_state = 59},
  [2257] = {.lex_state = 0, .external_lex_state = 173},
  [2258] = {.lex_state = 0, .external_lex_state = 59},
  [2259] = {.lex_state = 0, .external_lex_state = 163},
  [2260] = {.lex_state = 0, .external_lex_state = 164},
  [2261] = {.lex_state = 0, .external_lex_state = 142},
  [2262] = {.lex_state = 0, .external_lex_state = 91},
  [2263] = {.lex_state = 0, .external_lex_state = 173},
  [2264] = {.lex_state = 0, .external_lex_state = 59},
  [2265] = {.lex_state = 0, .external_lex_state = 142},
  [2266] = {.lex_state = 0, .external_lex_state = 59},
  [2267] = {.lex_state = 0, .external_lex_state = 174},
  [2268] = {.lex_state = 0, .external_lex_state = 59},
  [2269] = {.lex_state = 0, .external_lex_state = 59},
  [2270] = {.lex_state = 0, .external_lex_state = 150},
  [2271] = {.lex_state = 0, .external_lex_state = 142},
  [2272] = {.lex_state = 0, .external_lex_state = 164},
  [2273] = {.lex_state = 0, .external_lex_state = 150},
  [2274] = {.lex_state = 0, .external_lex_state = 59},
  [2275] = {.lex_state = 0, .external_lex_state = 59},
  [2276] = {.lex_state = 0, .external_lex_state = 142},
  [2277] = {.lex_state = 0, .external_lex_state = 142},
  [2278] = {.lex_state = 0, .external_lex_state = 148},
  [2279] = {.lex_state = 44},
  [2280] = {.lex_state = 12},
  [2281] = {.lex_state = 8},
  [2282] = {.lex_state = 0, .external_lex_state = 142},
  [2283] = {.lex_state = 16},
  [2284] = {.lex_state = 0, .external_lex_state = 59},
  [2285] = {.lex_state = 0, .external_lex_state = 145},
  [2286] = {.lex_state = 0, .external_lex_state = 173},
  [2287] = {.lex_state = 0, .external_lex_state = 59},
  [2288] = {.lex_state = 0, .external_lex_state = 163},
  [2289] = {.lex_state = 0, .external_lex_state = 175},
  [2290] = {.lex_state = 0, .external_lex_state = 142},
  [2291] = {.lex_state = 0, .external_lex_state = 139},
  [2292] = {.lex_state = 0, .external_lex_state = 173},
  [2293] = {.lex_state = 0, .external_lex_state = 146},
  [2294] = {.lex_state = 0, .external_lex_state = 144},
  [2295] = {.lex_state = 0, .external_lex_state = 176},
  [2296] = {.lex_state = 0, .external_lex_state = 147},
  [2297] = {.lex_state = 0, .external_lex_state = 150},
  [2298] = {.lex_state = 0, .external_lex_state = 160},
  [2299] = {.lex_state = 44},
  [2300] = {.lex_state = 0, .external_lex_state = 59},
  [2301] = {.lex_state = 0, .external_lex_state = 150},
  [2302] = {.lex_state = 0, .external_lex_state = 148},
  [2303] = {.lex_state = 0, .external_lex_state = 59},
  [2304] = {.lex_state = 0, .external_lex_state = 59},
  [2305] = {.lex_state = 0, .external_lex_state = 142},
  [2306] = {.lex_state = 0, .external_lex_state = 177},
  [2307] = {.lex_state = 0, .external_lex_state = 148},
  [2308] = {.lex_state = 44},
  [2309] = {.lex_state = 12},
  [2310] = {.lex_state = 8},
  [2311] = {.lex_state = 0, .external_lex_state = 142},
  [2312] = {.lex_state = 16},
  [2313] = {.lex_state = 0, .external_lex_state = 173},
  [2314] = {.lex_state = 0, .external_lex_state = 163},
  [2315] = {.lex_state = 0, .external_lex_state = 142},
  [2316] = {.lex_state = 0, .external_lex_state = 173},
  [2317] = {.lex_state = 8},
  [2318] = {.lex_state = 0, .external_lex_state = 59},
  [2319] = {.lex_state = 0, .external_lex_state = 178},
  [2320] = {.lex_state = 3},
  [2321] = {.lex_state = 0, .external_lex_state = 144},
  [2322] = {.lex_state = 0, .external_lex_state = 140},
  [2323] = {.lex_state = 0, .external_lex_state = 142},
  [2324] = {.lex_state = 0, .external_lex_state = 168},
  [2325] = {.lex_state = 0, .external_lex_state = 59},
  [2326] = {.lex_state = 0, .external_lex_state = 144},
  [2327] = {.lex_state = 8},
  [2328] = {.lex_state = 0, .external_lex_state = 148},
  [2329] = {.lex_state = 12},
  [2330] = {.lex_state = 0, .external_lex_state = 173},
  [2331] = {.lex_state = 0, .external_lex_state = 163},
  [2332] = {.lex_state = 0, .external_lex_state = 142},
  [2333] = {.lex_state = 0, .external_lex_state = 173},
  [2334] = {.lex_state = 8},
  [2335] = {.lex_state = 0, .external_lex_state = 59},
  [2336] = {.lex_state = 0, .external_lex_state = 150},
  [2337] = {.lex_state = 0, .external_lex_state = 142},
  [2338] = {.lex_state = 0, .external_lex_state = 59},
  [2339] = {.lex_state = 0, .external_lex_state = 59},
  [2340] = {.lex_state = 0, .external_lex_state = 59},
  [2341] = {.lex_state = 0, .external_lex_state = 179},
  [2342] = {.lex_state = 0, .external_lex_state = 144},
  [2343] = {.lex_state = 0, .external_lex_state = 144},
  [2344] = {.lex_state = 0, .external_lex_state = 180},
  [2345] = {.lex_state = 0, .external_lex_state = 148},
  [2346] = {.lex_state = 12},
  [2347] = {.lex_state = 0, .external_lex_state = 173},
  [2348] = {.lex_state = 0, .external_lex_state = 59},
  [2349] = {.lex_state = 0, .external_lex_state = 142},
  [2350] = {.lex_state = 0, .external_lex_state = 173},
  [2351] = {.lex_state = 77},
  [2352] = {.lex_state = 0, .external_lex_state = 139},
  [2353] = {.lex_state = 0, .external_lex_state = 139},
  [2354] = {.lex_state = 0, .external_lex_state = 140},
  [2355] = {.lex_state = 0, .external_lex_state = 141},
  [2356] = {.lex_state = 0, .external_lex_state = 143},
  [2357] = {.lex_state = 0, .external_lex_state = 145},
  [2358] = {.lex_state = 0, .external_lex_state = 140},
  [2359] = {.lex_state = 0, .external_lex_state = 146},
  [2360] = {.lex_state = 0, .external_lex_state = 141},
  [2361] = {.lex_state = 0, .external_lex_state = 147},
  [2362] = {.lex_state = 0, .external_lex_state = 148},
  [2363] = {.lex_state = 12},
  [2364] = {.lex_state = 0, .external_lex_state = 173},
  [2365] = {.lex_state = 0, .external_lex_state = 163},
  [2366] = {.lex_state = 0, .external_lex_state = 142},
  [2367] = {.lex_state = 0, .external_lex_state = 173},
  [2368] = {.lex_state = 0, .external_lex_state = 148},
  [2369] = {.lex_state = 3},
  [2370] = {.lex_state = 0, .external_lex_state = 143},
  [2371] = {.lex_state = 0, .external_lex_state = 145},
  [2372] = {.lex_state = 0, .external_lex_state = 59},
  [2373] = {.lex_state = 0, .external_lex_state = 150},
  [2374] = {.lex_state = 0, .external_lex_state = 146},
  [2375] = {.lex_state = 0, .external_lex_state = 147},
  [2376] = {.lex_state = 0, .external_lex_state = 148},
  [2377] = {.lex_state = 3},
  [2378] = {.lex_state = 0, .external_lex_state = 181},
  [2379] = {.lex_state = 0, .external_lex_state = 148},
  [2380] = {.lex_state = 12},
  [2381] = {.lex_state = 0, .external_lex_state = 173},
  [2382] = {.lex_state = 0, .external_lex_state = 163},
  [2383] = {.lex_state = 0, .external_lex_state = 142},
  [2384] = {.lex_state = 0, .external_lex_state = 173},
  [2385] = {.lex_state = 0, .external_lex_state = 149},
  [2386] = {.lex_state = 0, .external_lex_state = 59},
  [2387] = {.lex_state = 0, .external_lex_state = 59},
  [2388] = {.lex_state = 0, .external_lex_state = 149},
  [2389] = {.lex_state = 77},
  [2390] = {.lex_state = 0, .external_lex_state = 59},
  [2391] = {.lex_state = 0, .external_lex_state = 150},
  [2392] = {.lex_state = 0, .external_lex_state = 149},
  [2393] = {.lex_state = 0, .external_lex_state = 150},
  [2394] = {.lex_state = 8},
  [2395] = {.lex_state = 0, .external_lex_state = 59},
  [2396] = {.lex_state = 0, .external_lex_state = 148},
  [2397] = {.lex_state = 12},
  [2398] = {.lex_state = 0, .external_lex_state = 173},
  [2399] = {.lex_state = 0, .external_lex_state = 163},
  [2400] = {.lex_state = 0, .external_lex_state = 142},
  [2401] = {.lex_state = 0, .external_lex_state = 173},
  [2402] = {.lex_state = 8},
  [2403] = {.lex_state = 8},
  [2404] = {.lex_state = 0, .external_lex_state = 59},
  [2405] = {.lex_state = 0, .external_lex_state = 59},
  [2406] = {.lex_state = 0, .external_lex_state = 59},
  [2407] = {.lex_state = 0, .external_lex_state = 59},
  [2408] = {.lex_state = 0, .external_lex_state = 59},
  [2409] = {.lex_state = 13},
  [2410] = {.lex_state = 0, .external_lex_state = 59},
  [2411] = {.lex_state = 0, .external_lex_state = 149},
  [2412] = {.lex_state = 0, .external_lex_state = 59},
  [2413] = {.lex_state = 0, .external_lex_state = 148},
  [2414] = {.lex_state = 12},
  [2415] = {.lex_state = 0, .external_lex_state = 173},
  [2416] = {.lex_state = 0, .external_lex_state = 163},
  [2417] = {.lex_state = 0, .external_lex_state = 142},
  [2418] = {.lex_state = 0, .external_lex_state = 173},
  [2419] = {.lex_state = 0, .external_lex_state = 59},
  [2420] = {.lex_state = 0, .external_lex_state = 59},
  [2421] = {.lex_state = 0, .external_lex_state = 59},
  [2422] = {.lex_state = 0, .external_lex_state = 150},
  [2423] = {.lex_state = 0, .external_lex_state = 59},
  [2424] = {.lex_state = 0, .external_lex_state = 59},
  [2425] = {.lex_state = 0, .external_lex_state = 150},
  [2426] = {.lex_state = 0, .external_lex_state = 150},
  [2427] = {.lex_state = 0, .external_lex_state = 141},
  [2428] = {.lex_state = 0, .external_lex_state = 150},
  [2429] = {.lex_state = 0, .external_lex_state = 143},
  [2430] = {.lex_state = 0, .external_lex_state = 148},
  [2431] = {.lex_state = 12},
  [2432] = {.lex_state = 0, .external_lex_state = 173},
  [2433] = {.lex_state = 0, .external_lex_state = 163},
  [2434] = {.lex_state = 0, .external_lex_state = 142},
  [2435] = {.lex_state = 0, .external_lex_state = 173},
  [2436] = {.lex_state = 0, .external_lex_state = 59},
  [2437] = {.lex_state = 0, .external_lex_state = 144},
  [2438] = {.lex_state = 0, .external_lex_state = 144},
  [2439] = {.lex_state = 0, .external_lex_state = 144},
  [2440] = {.lex_state = 8},
  [2441] = {.lex_state = 0, .external_lex_state = 145},
  [2442] = {.lex_state = 44},
  [2443] = {.lex_state = 8},
  [2444] = {.lex_state = 0, .external_lex_state = 144},
  [2445] = {.lex_state = 0, .external_lex_state = 139},
  [2446] = {.lex_state = 0, .external_lex_state = 140},
  [2447] = {.lex_state = 0, .external_lex_state = 148},
  [2448] = {.lex_state = 12},
  [2449] = {.lex_state = 0, .external_lex_state = 142},
  [2450] = {.lex_state = 0, .external_lex_state = 142},
  [2451] = {.lex_state = 0, .external_lex_state = 142},
  [2452] = {.lex_state = 0, .external_lex_state = 142},
  [2453] = {.lex_state = 0, .external_lex_state = 142},
  [2454] = {.lex_state = 0, .external_lex_state = 142},
  [2455] = {.lex_state = 77},
  [2456] = {.lex_state = 0, .external_lex_state = 153},
  [2457] = {.lex_state = 0, .external_lex_state = 157},
  [2458] = {.lex_state = 0, .external_lex_state = 159},
  [2459] = {.lex_state = 0, .external_lex_state = 165},
  [2460] = {.lex_state = 0, .external_lex_state = 166},
  [2461] = {.lex_state = 0, .external_lex_state = 167},
  [2462] = {.lex_state = 0, .external_lex_state = 138},
  [2463] = {.lex_state = 0, .external_lex_state = 164},
  [2464] = {.lex_state = 0, .external_lex_state = 163},
  [2465] = {.lex_state = 0, .external_lex_state = 179},
  [2466] = {.lex_state = 0, .external_lex_state = 141},
  [2467] = {.lex_state = 13},
  [2468] = {.lex_state = 8},
  [2469] = {.lex_state = 77},
  [2470] = {.lex_state = 0, .external_lex_state = 153},
  [2471] = {.lex_state = 0, .external_lex_state = 157},
  [2472] = {.lex_state = 0, .external_lex_state = 159},
  [2473] = {.lex_state = 0, .external_lex_state = 165},
  [2474] = {.lex_state = 0, .external_lex_state = 166},
  [2475] = {.lex_state = 0, .external_lex_state = 167},
  [2476] = {.lex_state = 0, .external_lex_state = 138},
  [2477] = {.lex_state = 0, .external_lex_state = 164},
  [2478] = {.lex_state = 0, .external_lex_state = 163},
  [2479] = {.lex_state = 0, .external_lex_state = 179},
  [2480] = {.lex_state = 0, .external_lex_state = 143},
  [2481] = {.lex_state = 13},
  [2482] = {.lex_state = 8},
  [2483] = {.lex_state = 77},
  [2484] = {.lex_state = 0, .external_lex_state = 153},
  [2485] = {.lex_state = 0, .external_lex_state = 157},
  [2486] = {.lex_state = 0, .external_lex_state = 159},
  [2487] = {.lex_state = 0, .external_lex_state = 165},
  [2488] = {.lex_state = 0, .external_lex_state = 166},
  [2489] = {.lex_state = 0, .external_lex_state = 167},
  [2490] = {.lex_state = 0, .external_lex_state = 138},
  [2491] = {.lex_state = 0, .external_lex_state = 164},
  [2492] = {.lex_state = 0, .external_lex_state = 163},
  [2493] = {.lex_state = 0, .external_lex_state = 179},
  [2494] = {.lex_state = 0, .external_lex_state = 145},
  [2495] = {.lex_state = 13},
  [2496] = {.lex_state = 8},
  [2497] = {.lex_state = 77},
  [2498] = {.lex_state = 0, .external_lex_state = 153},
  [2499] = {.lex_state = 0, .external_lex_state = 157},
  [2500] = {.lex_state = 0, .external_lex_state = 159},
  [2501] = {.lex_state = 0, .external_lex_state = 165},
  [2502] = {.lex_state = 0, .external_lex_state = 166},
  [2503] = {.lex_state = 0, .external_lex_state = 167},
  [2504] = {.lex_state = 0, .external_lex_state = 138},
  [2505] = {.lex_state = 0, .external_lex_state = 164},
  [2506] = {.lex_state = 0, .external_lex_state = 163},
  [2507] = {.lex_state = 0, .external_lex_state = 179},
  [2508] = {.lex_state = 0, .external_lex_state = 146},
  [2509] = {.lex_state = 13},
  [2510] = {.lex_state = 8},
  [2511] = {.lex_state = 0, .external_lex_state = 153},
  [2512] = {.lex_state = 0, .external_lex_state = 157},
  [2513] = {.lex_state = 0, .external_lex_state = 159},
  [2514] = {.lex_state = 0, .external_lex_state = 165},
  [2515] = {.lex_state = 0, .external_lex_state = 166},
  [2516] = {.lex_state = 0, .external_lex_state = 167},
  [2517] = {.lex_state = 0, .external_lex_state = 138},
  [2518] = {.lex_state = 0, .external_lex_state = 164},
  [2519] = {.lex_state = 0, .external_lex_state = 163},
  [2520] = {.lex_state = 0, .external_lex_state = 179},
  [2521] = {.lex_state = 0, .external_lex_state = 147},
  [2522] = {.lex_state = 0, .external_lex_state = 153},
  [2523] = {.lex_state = 0, .external_lex_state = 157},
  [2524] = {.lex_state = 0, .external_lex_state = 159},
  [2525] = {.lex_state = 0, .external_lex_state = 165},
  [2526] = {.lex_state = 0, .external_lex_state = 166},
  [2527] = {.lex_state = 0, .external_lex_state = 167},
  [2528] = {.lex_state = 0, .external_lex_state = 138},
  [2529] = {.lex_state = 0, .external_lex_state = 164},
  [2530] = {.lex_state = 0, .external_lex_state = 163},
  [2531] = {.lex_state = 0, .external_lex_state = 179},
  [2532] = {.lex_state = 0, .external_lex_state = 148},
  [2533] = {.lex_state = 0, .external_lex_state = 153},
  [2534] = {.lex_state = 0, .external_lex_state = 157},
  [2535] = {.lex_state = 0, .external_lex_state = 159},
  [2536] = {.lex_state = 0, .external_lex_state = 165},
  [2537] = {.lex_state = 0, .external_lex_state = 166},
  [2538] = {.lex_state = 0, .external_lex_state = 167},
  [2539] = {.lex_state = 0, .external_lex_state = 138},
  [2540] = {.lex_state = 0, .external_lex_state = 164},
  [2541] = {.lex_state = 0, .external_lex_state = 163},
  [2542] = {.lex_state = 0, .external_lex_state = 179},
  [2543] = {.lex_state = 3},
  [2544] = {.lex_state = 0, .external_lex_state = 153},
  [2545] = {.lex_state = 0, .external_lex_state = 157},
  [2546] = {.lex_state = 0, .external_lex_state = 159},
  [2547] = {.lex_state = 0, .external_lex_state = 165},
  [2548] = {.lex_state = 0, .external_lex_state = 166},
  [2549] = {.lex_state = 0, .external_lex_state = 167},
  [2550] = {.lex_state = 0, .external_lex_state = 138},
  [2551] = {.lex_state = 0, .external_lex_state = 164},
  [2552] = {.lex_state = 0, .external_lex_state = 163},
  [2553] = {.lex_state = 0, .external_lex_state = 179},
  [2554] = {.lex_state = 0, .external_lex_state = 142},
  [2555] = {.lex_state = 0, .external_lex_state = 153},
  [2556] = {.lex_state = 0, .external_lex_state = 157},
  [2557] = {.lex_state = 0, .external_lex_state = 159},
  [2558] = {.lex_state = 0, .external_lex_state = 165},
  [2559] = {.lex_state = 0, .external_lex_state = 166},
  [2560] = {.lex_state = 0, .external_lex_state = 167},
  [2561] = {.lex_state = 0, .external_lex_state = 138},
  [2562] = {.lex_state = 0, .external_lex_state = 164},
  [2563] = {.lex_state = 0, .external_lex_state = 163},
  [2564] = {.lex_state = 0, .external_lex_state = 179},
  [2565] = {.lex_state = 0, .external_lex_state = 148},
  [2566] = {.lex_state = 0, .external_lex_state = 153},
  [2567] = {.lex_state = 0, .external_lex_state = 157},
  [2568] = {.lex_state = 0, .external_lex_state = 159},
  [2569] = {.lex_state = 0, .external_lex_state = 165},
  [2570] = {.lex_state = 0, .external_lex_state = 166},
  [2571] = {.lex_state = 0, .external_lex_state = 167},
  [2572] = {.lex_state = 0, .external_lex_state = 149},
  [2573] = {.lex_state = 0, .external_lex_state = 164},
  [2574] = {.lex_state = 0, .external_lex_state = 163},
  [2575] = {.lex_state = 0, .external_lex_state = 179},
  [2576] = {.lex_state = 0, .external_lex_state = 182},
  [2577] = {.lex_state = 0, .external_lex_state = 153},
  [2578] = {.lex_state = 0, .external_lex_state = 157},
  [2579] = {.lex_state = 0, .external_lex_state = 159},
  [2580] = {.lex_state = 0, .external_lex_state = 165},
  [2581] = {.lex_state = 0, .external_lex_state = 166},
  [2582] = {.lex_state = 0, .external_lex_state = 167},
  [2583] = {.lex_state = 0, .external_lex_state = 138},
  [2584] = {.lex_state = 0, .external_lex_state = 164},
  [2585] = {.lex_state = 0, .external_lex_state = 163},
  [2586] = {.lex_state = 0, .external_lex_state = 179},
  [2587] = {.lex_state = 0, .external_lex_state = 59},
  [2588] = {.lex_state = 0, .external_lex_state = 153},
  [2589] = {.lex_state = 0, .external_lex_state = 157},
  [2590] = {.lex_state = 0, .external_lex_state = 159},
  [2591] = {.lex_state = 0, .external_lex_state = 165},
  [2592] = {.lex_state = 0, .external_lex_state = 166},
  [2593] = {.lex_state = 0, .external_lex_state = 167},
  [2594] = {.lex_state = 0, .external_lex_state = 138},
  [2595] = {.lex_state = 0, .external_lex_state = 164},
  [2596] = {.lex_state = 0, .external_lex_state = 163},
  [2597] = {.lex_state = 0, .external_lex_state = 179},
  [2598] = {.lex_state = 0, .external_lex_state = 59},
  [2599] = {.lex_state = 0, .external_lex_state = 164},
  [2600] = {.lex_state = 8},
  [2601] = {.lex_state = 0, .external_lex_state = 169},
  [2602] = {.lex_state = 0, .external_lex_state = 173},
  [2603] = {.lex_state = 0, .external_lex_state = 164},
  [2604] = {.lex_state = 0, .external_lex_state = 138},
  [2605] = {.lex_state = 0, .external_lex_state = 169},
  [2606] = {.lex_state = 0, .external_lex_state = 59},
  [2607] = {.lex_state = 0, .external_lex_state = 164},
  [2608] = {.lex_state = 8},
  [2609] = {.lex_state = 0, .external_lex_state = 169},
  [2610] = {.lex_state = 0, .external_lex_state = 164},
  [2611] = {.lex_state = 0, .external_lex_state = 142},
  [2612] = {.lex_state = 0, .external_lex_state = 169},
  [2613] = {.lex_state = 0, .external_lex_state = 164},
  [2614] = {.lex_state = 0, .external_lex_state = 164},
  [2615] = {.lex_state = 0, .external_lex_state = 164},
  [2616] = {.lex_state = 0, .external_lex_state = 164},
  [2617] = {.lex_state = 0, .external_lex_state = 164},
  [2618] = {.lex_state = 0, .external_lex_state = 164},
  [2619] = {.lex_state = 0, .external_lex_state = 164},
  [2620] = {.lex_state = 0, .external_lex_state = 164},
  [2621] = {.lex_state = 0, .external_lex_state = 146},
  [2622] = {.lex_state = 0, .external_lex_state = 59},
  [2623] = {.lex_state = 0, .external_lex_state = 147},
  [2624] = {.lex_state = 0, .external_lex_state = 148},
  [2625] = {.lex_state = 0, .external_lex_state = 59},
  [2626] = {.lex_state = 0, .external_lex_state = 183},
  [2627] = {.lex_state = 0, .external_lex_state = 144},
  [2628] = {.lex_state = 0, .external_lex_state = 59},
  [2629] = {.lex_state = 13},
  [2630] = {.lex_state = 13},
  [2631] = {.lex_state = 13},
  [2632] = {.lex_state = 13},
  [2633] = {.lex_state = 0, .external_lex_state = 163},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_x] = ACTIONS(1),
    [anon_sym_X] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_SPACE] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym__whitespace1] = ACTIONS(1),
    [sym_ellipsis] = ACTIONS(1),
    [sym_em_dash] = ACTIONS(1),
    [sym_en_dash] = ACTIONS(1),
    [sym_backslash_escape] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [sym_symbol] = ACTIONS(1),
    [anon_sym_LBRACE_] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_LBRACE_STAR] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_LBRACE_CARET] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LBRACE_EQ] = ACTIONS(1),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1),
    [anon_sym_LBRACE_DASH] = ACTIONS(1),
    [anon_sym_LBRACK_CARET] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_BANG_LBRACK] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LBRACE_EQ2] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_TODO] = ACTIONS(1),
    [anon_sym_WIP] = ACTIONS(1),
    [anon_sym_NOTE] = ACTIONS(1),
    [anon_sym_INFO] = ACTIONS(1),
    [anon_sym_XXX] = ACTIONS(1),
    [sym_fixme] = ACTIONS(1),
    [aux_sym__text_token1] = ACTIONS(1),
    [sym__ignored] = ACTIONS(1),
    [sym__block_close] = ACTIONS(1),
    [sym__eof_or_newline] = ACTIONS(1),
    [sym__newline] = ACTIONS(1),
    [sym__newline_inline] = ACTIONS(1),
    [sym__non_whitespace_check] = ACTIONS(1),
    [sym_hard_line_break] = ACTIONS(1),
    [sym_frontmatter_marker] = ACTIONS(1),
    [sym__heading_begin] = ACTIONS(1),
    [sym__heading_continuation] = ACTIONS(1),
    [sym__div_begin] = ACTIONS(1),
    [sym__div_end] = ACTIONS(1),
    [sym__code_block_begin] = ACTIONS(1),
    [sym__code_block_end] = ACTIONS(1),
    [sym_list_marker_dash] = ACTIONS(1),
    [sym_list_marker_star] = ACTIONS(1),
    [sym_list_marker_plus] = ACTIONS(1),
    [sym__list_marker_task_begin] = ACTIONS(1),
    [sym_list_marker_definition] = ACTIONS(1),
    [sym_list_marker_decimal_period] = ACTIONS(1),
    [sym_list_marker_lower_alpha_period] = ACTIONS(1),
    [sym_list_marker_upper_alpha_period] = ACTIONS(1),
    [sym_list_marker_lower_roman_period] = ACTIONS(1),
    [sym_list_marker_upper_roman_period] = ACTIONS(1),
    [sym_list_marker_decimal_paren] = ACTIONS(1),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(1),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(1),
    [sym_list_marker_lower_roman_paren] = ACTIONS(1),
    [sym_list_marker_upper_roman_paren] = ACTIONS(1),
    [sym_list_marker_decimal_parens] = ACTIONS(1),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(1),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(1),
    [sym_list_marker_lower_roman_parens] = ACTIONS(1),
    [sym_list_marker_upper_roman_parens] = ACTIONS(1),
    [sym__list_item_continuation] = ACTIONS(1),
    [sym__list_item_end] = ACTIONS(1),
    [sym__indented_content_spacer] = ACTIONS(1),
    [sym__close_paragraph] = ACTIONS(1),
    [sym__block_quote_begin] = ACTIONS(1),
    [sym__block_quote_continuation] = ACTIONS(1),
    [sym__thematic_break_dash] = ACTIONS(1),
    [sym__thematic_break_star] = ACTIONS(1),
    [sym__footnote_mark_begin] = ACTIONS(1),
    [sym__footnote_continuation] = ACTIONS(1),
    [sym__footnote_end] = ACTIONS(1),
    [sym__link_ref_def_mark_begin] = ACTIONS(1),
    [sym__link_ref_def_label_end] = ACTIONS(1),
    [sym__table_header_begin] = ACTIONS(1),
    [sym__table_separator_begin] = ACTIONS(1),
    [sym__table_row_begin] = ACTIONS(1),
    [sym__table_row_end_newline] = ACTIONS(1),
    [sym__table_cell_end] = ACTIONS(1),
    [sym__table_caption_begin] = ACTIONS(1),
    [sym__table_caption_end] = ACTIONS(1),
    [sym__block_attribute_begin] = ACTIONS(1),
    [sym__comment_end_marker] = ACTIONS(1),
    [sym__comment_close] = ACTIONS(1),
    [sym__inline_comment_begin] = ACTIONS(1),
    [sym__verbatim_begin] = ACTIONS(1),
    [sym__verbatim_end] = ACTIONS(1),
    [sym__verbatim_content] = ACTIONS(1),
    [sym__emphasis_mark_begin] = ACTIONS(1),
    [sym_emphasis_end] = ACTIONS(1),
    [sym__strong_mark_begin] = ACTIONS(1),
    [sym_strong_end] = ACTIONS(1),
    [sym__superscript_mark_begin] = ACTIONS(1),
    [sym_superscript_end] = ACTIONS(1),
    [sym__subscript_mark_begin] = ACTIONS(1),
    [sym_subscript_end] = ACTIONS(1),
    [sym__highlighted_mark_begin] = ACTIONS(1),
    [sym_highlighted_end] = ACTIONS(1),
    [sym__insert_mark_begin] = ACTIONS(1),
    [sym_insert_end] = ACTIONS(1),
    [sym__delete_mark_begin] = ACTIONS(1),
    [sym_delete_end] = ACTIONS(1),
    [sym__parens_span_mark_begin] = ACTIONS(1),
    [sym__parens_span_end] = ACTIONS(1),
    [sym__curly_bracket_span_mark_begin] = ACTIONS(1),
    [sym__curly_bracket_span_end] = ACTIONS(1),
    [sym__square_bracket_span_mark_begin] = ACTIONS(1),
    [sym__square_bracket_span_end] = ACTIONS(1),
    [sym__in_fallback] = ACTIONS(1),
    [sym__error] = ACTIONS(1),
  },
  [1] = {
    [sym_document] = STATE(2077),
    [sym_frontmatter] = STATE(3),
    [sym__block_with_section] = STATE(355),
    [sym__block_element] = STATE(355),
    [sym_section] = STATE(355),
    [sym_heading] = STATE(4),
    [sym_list] = STATE(355),
    [sym__list_dash] = STATE(364),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(364),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(364),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(364),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(364),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(364),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(364),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(364),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(364),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(364),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(364),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(364),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(364),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(364),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(364),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(364),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(364),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(364),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(364),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(364),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(355),
    [sym__table_row] = STATE(134),
    [sym_table_header] = STATE(134),
    [sym_table_separator] = STATE(134),
    [sym_table_row] = STATE(134),
    [sym_footnote] = STATE(355),
    [sym_div] = STATE(355),
    [sym__div_marker_begin] = STATE(2325),
    [sym_code_block] = STATE(355),
    [sym_raw_block] = STATE(355),
    [sym_thematic_break] = STATE(355),
    [sym_block_quote] = STATE(355),
    [sym__block_quote_prefix] = STATE(92),
    [sym_link_reference_definition] = STATE(355),
    [sym_block_attribute] = STATE(355),
    [sym__paragraph] = STATE(355),
    [sym__paragraph_content] = STATE(1658),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_document_repeat1] = STATE(2),
    [aux_sym__list_dash_repeat1] = STATE(1159),
    [aux_sym__list_plus_repeat1] = STATE(1212),
    [aux_sym__list_star_repeat1] = STATE(1216),
    [aux_sym__list_task_repeat1] = STATE(1100),
    [aux_sym__list_definition_repeat1] = STATE(1399),
    [aux_sym__list_decimal_period_repeat1] = STATE(1236),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1237),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1163),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1165),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1103),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1105),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1106),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1107),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1109),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1113),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1132),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1134),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1135),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1192),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1224),
    [aux_sym_table_repeat1] = STATE(134),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [ts_builtin_sym_end] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(49),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym_frontmatter_marker] = ACTIONS(53),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(59),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(101),
    [sym__block_quote_continuation] = ACTIONS(103),
    [sym__thematic_break_dash] = ACTIONS(105),
    [sym__thematic_break_star] = ACTIONS(105),
    [sym__footnote_mark_begin] = ACTIONS(107),
    [sym__link_ref_def_mark_begin] = ACTIONS(109),
    [sym__table_header_begin] = ACTIONS(111),
    [sym__table_separator_begin] = ACTIONS(113),
    [sym__table_row_begin] = ACTIONS(115),
    [sym__block_attribute_begin] = ACTIONS(117),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [2] = {
    [sym__block_with_section] = STATE(355),
    [sym__block_element] = STATE(355),
    [sym_section] = STATE(355),
    [sym_heading] = STATE(4),
    [sym_list] = STATE(355),
    [sym__list_dash] = STATE(364),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(364),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(364),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(364),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(364),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(364),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(364),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(364),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(364),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(364),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(364),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(364),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(364),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(364),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(364),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(364),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(364),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(364),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(364),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(364),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(355),
    [sym__table_row] = STATE(134),
    [sym_table_header] = STATE(134),
    [sym_table_separator] = STATE(134),
    [sym_table_row] = STATE(134),
    [sym_footnote] = STATE(355),
    [sym_div] = STATE(355),
    [sym__div_marker_begin] = STATE(2325),
    [sym_code_block] = STATE(355),
    [sym_raw_block] = STATE(355),
    [sym_thematic_break] = STATE(355),
    [sym_block_quote] = STATE(355),
    [sym__block_quote_prefix] = STATE(92),
    [sym_link_reference_definition] = STATE(355),
    [sym_block_attribute] = STATE(355),
    [sym__paragraph] = STATE(355),
    [sym__paragraph_content] = STATE(1658),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_document_repeat1] = STATE(7),
    [aux_sym__list_dash_repeat1] = STATE(1159),
    [aux_sym__list_plus_repeat1] = STATE(1212),
    [aux_sym__list_star_repeat1] = STATE(1216),
    [aux_sym__list_task_repeat1] = STATE(1100),
    [aux_sym__list_definition_repeat1] = STATE(1399),
    [aux_sym__list_decimal_period_repeat1] = STATE(1236),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1237),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1163),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1165),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1103),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1105),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1106),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1107),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1109),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1113),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1132),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1134),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1135),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1192),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1224),
    [aux_sym_table_repeat1] = STATE(134),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [ts_builtin_sym_end] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(49),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(59),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(101),
    [sym__block_quote_continuation] = ACTIONS(103),
    [sym__thematic_break_dash] = ACTIONS(105),
    [sym__thematic_break_star] = ACTIONS(105),
    [sym__footnote_mark_begin] = ACTIONS(107),
    [sym__link_ref_def_mark_begin] = ACTIONS(109),
    [sym__table_header_begin] = ACTIONS(111),
    [sym__table_separator_begin] = ACTIONS(113),
    [sym__table_row_begin] = ACTIONS(115),
    [sym__block_attribute_begin] = ACTIONS(117),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [3] = {
    [sym__block_with_section] = STATE(355),
    [sym__block_element] = STATE(355),
    [sym_section] = STATE(355),
    [sym_heading] = STATE(4),
    [sym_list] = STATE(355),
    [sym__list_dash] = STATE(364),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(364),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(364),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(364),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(364),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(364),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(364),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(364),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(364),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(364),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(364),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(364),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(364),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(364),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(364),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(364),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(364),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(364),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(364),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(364),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(355),
    [sym__table_row] = STATE(134),
    [sym_table_header] = STATE(134),
    [sym_table_separator] = STATE(134),
    [sym_table_row] = STATE(134),
    [sym_footnote] = STATE(355),
    [sym_div] = STATE(355),
    [sym__div_marker_begin] = STATE(2325),
    [sym_code_block] = STATE(355),
    [sym_raw_block] = STATE(355),
    [sym_thematic_break] = STATE(355),
    [sym_block_quote] = STATE(355),
    [sym__block_quote_prefix] = STATE(92),
    [sym_link_reference_definition] = STATE(355),
    [sym_block_attribute] = STATE(355),
    [sym__paragraph] = STATE(355),
    [sym__paragraph_content] = STATE(1658),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_document_repeat1] = STATE(6),
    [aux_sym__list_dash_repeat1] = STATE(1159),
    [aux_sym__list_plus_repeat1] = STATE(1212),
    [aux_sym__list_star_repeat1] = STATE(1216),
    [aux_sym__list_task_repeat1] = STATE(1100),
    [aux_sym__list_definition_repeat1] = STATE(1399),
    [aux_sym__list_decimal_period_repeat1] = STATE(1236),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1237),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1163),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1165),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1103),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1105),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1106),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1107),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1109),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1113),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1132),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1134),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1135),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1192),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1224),
    [aux_sym_table_repeat1] = STATE(134),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [ts_builtin_sym_end] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(49),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(59),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(101),
    [sym__block_quote_continuation] = ACTIONS(103),
    [sym__thematic_break_dash] = ACTIONS(105),
    [sym__thematic_break_star] = ACTIONS(105),
    [sym__footnote_mark_begin] = ACTIONS(107),
    [sym__link_ref_def_mark_begin] = ACTIONS(109),
    [sym__table_header_begin] = ACTIONS(111),
    [sym__table_separator_begin] = ACTIONS(113),
    [sym__table_row_begin] = ACTIONS(115),
    [sym__block_attribute_begin] = ACTIONS(117),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [4] = {
    [sym__block_with_section] = STATE(325),
    [sym__block_element] = STATE(325),
    [sym_section] = STATE(325),
    [sym_heading] = STATE(9),
    [sym_list] = STATE(325),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(325),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(325),
    [sym_div] = STATE(325),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(325),
    [sym_raw_block] = STATE(325),
    [sym_thematic_break] = STATE(325),
    [sym_block_quote] = STATE(325),
    [sym__block_quote_prefix] = STATE(93),
    [sym_link_reference_definition] = STATE(325),
    [sym_block_attribute] = STATE(325),
    [sym__paragraph] = STATE(325),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_document_repeat1] = STATE(5),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(123),
    [sym__newline] = ACTIONS(125),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(127),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(129),
    [sym__block_quote_continuation] = ACTIONS(103),
    [sym__thematic_break_dash] = ACTIONS(131),
    [sym__thematic_break_star] = ACTIONS(131),
    [sym__footnote_mark_begin] = ACTIONS(133),
    [sym__link_ref_def_mark_begin] = ACTIONS(135),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__block_attribute_begin] = ACTIONS(143),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [5] = {
    [sym__block_with_section] = STATE(325),
    [sym__block_element] = STATE(325),
    [sym_section] = STATE(325),
    [sym_heading] = STATE(9),
    [sym_list] = STATE(325),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(325),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(325),
    [sym_div] = STATE(325),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(325),
    [sym_raw_block] = STATE(325),
    [sym_thematic_break] = STATE(325),
    [sym_block_quote] = STATE(325),
    [sym__block_quote_prefix] = STATE(93),
    [sym_link_reference_definition] = STATE(325),
    [sym_block_attribute] = STATE(325),
    [sym__paragraph] = STATE(325),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_document_repeat1] = STATE(8),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(145),
    [sym__newline] = ACTIONS(125),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(127),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(129),
    [sym__block_quote_continuation] = ACTIONS(103),
    [sym__thematic_break_dash] = ACTIONS(131),
    [sym__thematic_break_star] = ACTIONS(131),
    [sym__footnote_mark_begin] = ACTIONS(133),
    [sym__link_ref_def_mark_begin] = ACTIONS(135),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__block_attribute_begin] = ACTIONS(143),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [6] = {
    [sym__block_with_section] = STATE(355),
    [sym__block_element] = STATE(355),
    [sym_section] = STATE(355),
    [sym_heading] = STATE(4),
    [sym_list] = STATE(355),
    [sym__list_dash] = STATE(364),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(364),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(364),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(364),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(364),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(364),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(364),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(364),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(364),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(364),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(364),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(364),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(364),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(364),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(364),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(364),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(364),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(364),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(364),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(364),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(355),
    [sym__table_row] = STATE(134),
    [sym_table_header] = STATE(134),
    [sym_table_separator] = STATE(134),
    [sym_table_row] = STATE(134),
    [sym_footnote] = STATE(355),
    [sym_div] = STATE(355),
    [sym__div_marker_begin] = STATE(2325),
    [sym_code_block] = STATE(355),
    [sym_raw_block] = STATE(355),
    [sym_thematic_break] = STATE(355),
    [sym_block_quote] = STATE(355),
    [sym__block_quote_prefix] = STATE(92),
    [sym_link_reference_definition] = STATE(355),
    [sym_block_attribute] = STATE(355),
    [sym__paragraph] = STATE(355),
    [sym__paragraph_content] = STATE(1658),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_document_repeat1] = STATE(7),
    [aux_sym__list_dash_repeat1] = STATE(1159),
    [aux_sym__list_plus_repeat1] = STATE(1212),
    [aux_sym__list_star_repeat1] = STATE(1216),
    [aux_sym__list_task_repeat1] = STATE(1100),
    [aux_sym__list_definition_repeat1] = STATE(1399),
    [aux_sym__list_decimal_period_repeat1] = STATE(1236),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1237),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1163),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1165),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1103),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1105),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1106),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1107),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1109),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1113),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1132),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1134),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1135),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1192),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1224),
    [aux_sym_table_repeat1] = STATE(134),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [ts_builtin_sym_end] = ACTIONS(147),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(49),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(59),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(101),
    [sym__block_quote_continuation] = ACTIONS(103),
    [sym__thematic_break_dash] = ACTIONS(105),
    [sym__thematic_break_star] = ACTIONS(105),
    [sym__footnote_mark_begin] = ACTIONS(107),
    [sym__link_ref_def_mark_begin] = ACTIONS(109),
    [sym__table_header_begin] = ACTIONS(111),
    [sym__table_separator_begin] = ACTIONS(113),
    [sym__table_row_begin] = ACTIONS(115),
    [sym__block_attribute_begin] = ACTIONS(117),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [7] = {
    [sym__block_with_section] = STATE(355),
    [sym__block_element] = STATE(355),
    [sym_section] = STATE(355),
    [sym_heading] = STATE(4),
    [sym_list] = STATE(355),
    [sym__list_dash] = STATE(364),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(364),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(364),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(364),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(364),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(364),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(364),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(364),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(364),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(364),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(364),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(364),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(364),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(364),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(364),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(364),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(364),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(364),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(364),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(364),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(355),
    [sym__table_row] = STATE(134),
    [sym_table_header] = STATE(134),
    [sym_table_separator] = STATE(134),
    [sym_table_row] = STATE(134),
    [sym_footnote] = STATE(355),
    [sym_div] = STATE(355),
    [sym__div_marker_begin] = STATE(2325),
    [sym_code_block] = STATE(355),
    [sym_raw_block] = STATE(355),
    [sym_thematic_break] = STATE(355),
    [sym_block_quote] = STATE(355),
    [sym__block_quote_prefix] = STATE(92),
    [sym_link_reference_definition] = STATE(355),
    [sym_block_attribute] = STATE(355),
    [sym__paragraph] = STATE(355),
    [sym__paragraph_content] = STATE(1658),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_document_repeat1] = STATE(7),
    [aux_sym__list_dash_repeat1] = STATE(1159),
    [aux_sym__list_plus_repeat1] = STATE(1212),
    [aux_sym__list_star_repeat1] = STATE(1216),
    [aux_sym__list_task_repeat1] = STATE(1100),
    [aux_sym__list_definition_repeat1] = STATE(1399),
    [aux_sym__list_decimal_period_repeat1] = STATE(1236),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1237),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1163),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1165),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1103),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1105),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1106),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1107),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1109),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1113),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1132),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1134),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1135),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1192),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1224),
    [aux_sym_table_repeat1] = STATE(134),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [ts_builtin_sym_end] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [sym__whitespace1] = ACTIONS(154),
    [sym_quotation_marks] = ACTIONS(157),
    [sym_ellipsis] = ACTIONS(157),
    [sym_em_dash] = ACTIONS(157),
    [sym_en_dash] = ACTIONS(160),
    [sym_backslash_escape] = ACTIONS(160),
    [anon_sym_LT] = ACTIONS(163),
    [sym_symbol] = ACTIONS(157),
    [anon_sym_LBRACE_] = ACTIONS(166),
    [anon_sym__] = ACTIONS(169),
    [anon_sym_LBRACE_STAR] = ACTIONS(172),
    [anon_sym_STAR] = ACTIONS(175),
    [anon_sym_LBRACE_CARET] = ACTIONS(178),
    [anon_sym_CARET] = ACTIONS(178),
    [anon_sym_LBRACE_TILDE] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(181),
    [anon_sym_LBRACE_EQ] = ACTIONS(184),
    [anon_sym_LBRACE_PLUS] = ACTIONS(187),
    [anon_sym_LBRACE_DASH] = ACTIONS(190),
    [anon_sym_LBRACK_CARET] = ACTIONS(193),
    [anon_sym_BANG_LBRACK] = ACTIONS(196),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(199),
    [anon_sym_LPAREN] = ACTIONS(202),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [anon_sym_TODO] = ACTIONS(208),
    [anon_sym_WIP] = ACTIONS(208),
    [anon_sym_NOTE] = ACTIONS(211),
    [anon_sym_INFO] = ACTIONS(211),
    [anon_sym_XXX] = ACTIONS(211),
    [sym_fixme] = ACTIONS(157),
    [aux_sym__text_token1] = ACTIONS(214),
    [sym__newline] = ACTIONS(217),
    [sym__newline_inline] = ACTIONS(220),
    [sym_hard_line_break] = ACTIONS(157),
    [sym__heading_begin] = ACTIONS(223),
    [sym__div_begin] = ACTIONS(226),
    [sym__code_block_begin] = ACTIONS(229),
    [sym_list_marker_dash] = ACTIONS(232),
    [sym_list_marker_star] = ACTIONS(235),
    [sym_list_marker_plus] = ACTIONS(238),
    [sym__list_marker_task_begin] = ACTIONS(241),
    [sym_list_marker_definition] = ACTIONS(244),
    [sym_list_marker_decimal_period] = ACTIONS(247),
    [sym_list_marker_lower_alpha_period] = ACTIONS(250),
    [sym_list_marker_upper_alpha_period] = ACTIONS(253),
    [sym_list_marker_lower_roman_period] = ACTIONS(256),
    [sym_list_marker_upper_roman_period] = ACTIONS(259),
    [sym_list_marker_decimal_paren] = ACTIONS(262),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(265),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(268),
    [sym_list_marker_lower_roman_paren] = ACTIONS(271),
    [sym_list_marker_upper_roman_paren] = ACTIONS(274),
    [sym_list_marker_decimal_parens] = ACTIONS(277),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(280),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(283),
    [sym_list_marker_lower_roman_parens] = ACTIONS(286),
    [sym_list_marker_upper_roman_parens] = ACTIONS(289),
    [sym__block_quote_begin] = ACTIONS(292),
    [sym__block_quote_continuation] = ACTIONS(295),
    [sym__thematic_break_dash] = ACTIONS(298),
    [sym__thematic_break_star] = ACTIONS(298),
    [sym__footnote_mark_begin] = ACTIONS(301),
    [sym__link_ref_def_mark_begin] = ACTIONS(304),
    [sym__table_header_begin] = ACTIONS(307),
    [sym__table_separator_begin] = ACTIONS(310),
    [sym__table_row_begin] = ACTIONS(313),
    [sym__block_attribute_begin] = ACTIONS(316),
    [sym__verbatim_begin] = ACTIONS(319),
  },
  [8] = {
    [sym__block_with_section] = STATE(325),
    [sym__block_element] = STATE(325),
    [sym_section] = STATE(325),
    [sym_heading] = STATE(9),
    [sym_list] = STATE(325),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(325),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(325),
    [sym_div] = STATE(325),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(325),
    [sym_raw_block] = STATE(325),
    [sym_thematic_break] = STATE(325),
    [sym_block_quote] = STATE(325),
    [sym__block_quote_prefix] = STATE(93),
    [sym_link_reference_definition] = STATE(325),
    [sym_block_attribute] = STATE(325),
    [sym__paragraph] = STATE(325),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_document_repeat1] = STATE(8),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(151),
    [sym__whitespace1] = ACTIONS(154),
    [sym_quotation_marks] = ACTIONS(157),
    [sym_ellipsis] = ACTIONS(157),
    [sym_em_dash] = ACTIONS(157),
    [sym_en_dash] = ACTIONS(160),
    [sym_backslash_escape] = ACTIONS(160),
    [anon_sym_LT] = ACTIONS(163),
    [sym_symbol] = ACTIONS(157),
    [anon_sym_LBRACE_] = ACTIONS(166),
    [anon_sym__] = ACTIONS(169),
    [anon_sym_LBRACE_STAR] = ACTIONS(172),
    [anon_sym_STAR] = ACTIONS(175),
    [anon_sym_LBRACE_CARET] = ACTIONS(178),
    [anon_sym_CARET] = ACTIONS(178),
    [anon_sym_LBRACE_TILDE] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(181),
    [anon_sym_LBRACE_EQ] = ACTIONS(184),
    [anon_sym_LBRACE_PLUS] = ACTIONS(187),
    [anon_sym_LBRACE_DASH] = ACTIONS(190),
    [anon_sym_LBRACK_CARET] = ACTIONS(193),
    [anon_sym_BANG_LBRACK] = ACTIONS(196),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(199),
    [anon_sym_LPAREN] = ACTIONS(202),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [anon_sym_TODO] = ACTIONS(208),
    [anon_sym_WIP] = ACTIONS(208),
    [anon_sym_NOTE] = ACTIONS(211),
    [anon_sym_INFO] = ACTIONS(211),
    [anon_sym_XXX] = ACTIONS(211),
    [sym_fixme] = ACTIONS(157),
    [aux_sym__text_token1] = ACTIONS(214),
    [sym__block_close] = ACTIONS(149),
    [sym__newline] = ACTIONS(322),
    [sym__newline_inline] = ACTIONS(220),
    [sym_hard_line_break] = ACTIONS(157),
    [sym__heading_begin] = ACTIONS(223),
    [sym__div_begin] = ACTIONS(226),
    [sym__code_block_begin] = ACTIONS(325),
    [sym_list_marker_dash] = ACTIONS(232),
    [sym_list_marker_star] = ACTIONS(235),
    [sym_list_marker_plus] = ACTIONS(238),
    [sym__list_marker_task_begin] = ACTIONS(241),
    [sym_list_marker_definition] = ACTIONS(244),
    [sym_list_marker_decimal_period] = ACTIONS(247),
    [sym_list_marker_lower_alpha_period] = ACTIONS(250),
    [sym_list_marker_upper_alpha_period] = ACTIONS(253),
    [sym_list_marker_lower_roman_period] = ACTIONS(256),
    [sym_list_marker_upper_roman_period] = ACTIONS(259),
    [sym_list_marker_decimal_paren] = ACTIONS(262),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(265),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(268),
    [sym_list_marker_lower_roman_paren] = ACTIONS(271),
    [sym_list_marker_upper_roman_paren] = ACTIONS(274),
    [sym_list_marker_decimal_parens] = ACTIONS(277),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(280),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(283),
    [sym_list_marker_lower_roman_parens] = ACTIONS(286),
    [sym_list_marker_upper_roman_parens] = ACTIONS(289),
    [sym__block_quote_begin] = ACTIONS(328),
    [sym__block_quote_continuation] = ACTIONS(295),
    [sym__thematic_break_dash] = ACTIONS(331),
    [sym__thematic_break_star] = ACTIONS(331),
    [sym__footnote_mark_begin] = ACTIONS(334),
    [sym__link_ref_def_mark_begin] = ACTIONS(337),
    [sym__table_header_begin] = ACTIONS(340),
    [sym__table_separator_begin] = ACTIONS(343),
    [sym__table_row_begin] = ACTIONS(346),
    [sym__block_attribute_begin] = ACTIONS(349),
    [sym__verbatim_begin] = ACTIONS(319),
  },
  [9] = {
    [sym__block_with_section] = STATE(325),
    [sym__block_element] = STATE(325),
    [sym_section] = STATE(325),
    [sym_heading] = STATE(9),
    [sym_list] = STATE(325),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(325),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(325),
    [sym_div] = STATE(325),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(325),
    [sym_raw_block] = STATE(325),
    [sym_thematic_break] = STATE(325),
    [sym_block_quote] = STATE(325),
    [sym__block_quote_prefix] = STATE(93),
    [sym_link_reference_definition] = STATE(325),
    [sym_block_attribute] = STATE(325),
    [sym__paragraph] = STATE(325),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_document_repeat1] = STATE(10),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(352),
    [sym__newline] = ACTIONS(125),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(127),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(129),
    [sym__block_quote_continuation] = ACTIONS(103),
    [sym__thematic_break_dash] = ACTIONS(131),
    [sym__thematic_break_star] = ACTIONS(131),
    [sym__footnote_mark_begin] = ACTIONS(133),
    [sym__link_ref_def_mark_begin] = ACTIONS(135),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__block_attribute_begin] = ACTIONS(143),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [10] = {
    [sym__block_with_section] = STATE(325),
    [sym__block_element] = STATE(325),
    [sym_section] = STATE(325),
    [sym_heading] = STATE(9),
    [sym_list] = STATE(325),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(325),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(325),
    [sym_div] = STATE(325),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(325),
    [sym_raw_block] = STATE(325),
    [sym_thematic_break] = STATE(325),
    [sym_block_quote] = STATE(325),
    [sym__block_quote_prefix] = STATE(93),
    [sym_link_reference_definition] = STATE(325),
    [sym_block_attribute] = STATE(325),
    [sym__paragraph] = STATE(325),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_document_repeat1] = STATE(8),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(354),
    [sym__newline] = ACTIONS(125),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(127),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(129),
    [sym__block_quote_continuation] = ACTIONS(103),
    [sym__thematic_break_dash] = ACTIONS(131),
    [sym__thematic_break_star] = ACTIONS(131),
    [sym__footnote_mark_begin] = ACTIONS(133),
    [sym__link_ref_def_mark_begin] = ACTIONS(135),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__block_attribute_begin] = ACTIONS(143),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [11] = {
    [sym__block_with_heading] = STATE(359),
    [sym__block_element] = STATE(359),
    [sym_heading] = STATE(359),
    [sym_list] = STATE(359),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(359),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(359),
    [sym_div] = STATE(359),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(359),
    [sym_raw_block] = STATE(359),
    [sym_thematic_break] = STATE(359),
    [sym_block_quote] = STATE(359),
    [sym__block_quote_prefix] = STATE(89),
    [sym_link_reference_definition] = STATE(359),
    [sym_block_attribute] = STATE(359),
    [sym__paragraph] = STATE(359),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym_div_repeat1] = STATE(14),
    [aux_sym__block_quote_prefix_repeat1] = STATE(432),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(356),
    [sym__newline] = ACTIONS(358),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(127),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(129),
    [sym__block_quote_continuation] = ACTIONS(360),
    [sym__thematic_break_dash] = ACTIONS(131),
    [sym__thematic_break_star] = ACTIONS(131),
    [sym__footnote_mark_begin] = ACTIONS(133),
    [sym__link_ref_def_mark_begin] = ACTIONS(135),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__block_attribute_begin] = ACTIONS(143),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [12] = {
    [sym__block_with_heading] = STATE(359),
    [sym__block_element] = STATE(359),
    [sym_heading] = STATE(359),
    [sym_list] = STATE(359),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(359),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(359),
    [sym_div] = STATE(359),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(359),
    [sym_raw_block] = STATE(359),
    [sym_thematic_break] = STATE(359),
    [sym_block_quote] = STATE(359),
    [sym__block_quote_prefix] = STATE(87),
    [sym_link_reference_definition] = STATE(359),
    [sym_block_attribute] = STATE(359),
    [sym__paragraph] = STATE(359),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym_div_repeat1] = STATE(13),
    [aux_sym__block_quote_prefix_repeat1] = STATE(432),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(362),
    [sym__newline] = ACTIONS(358),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(127),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(129),
    [sym__block_quote_continuation] = ACTIONS(360),
    [sym__thematic_break_dash] = ACTIONS(131),
    [sym__thematic_break_star] = ACTIONS(131),
    [sym__footnote_mark_begin] = ACTIONS(133),
    [sym__link_ref_def_mark_begin] = ACTIONS(135),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__block_attribute_begin] = ACTIONS(143),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [13] = {
    [sym__block_with_heading] = STATE(359),
    [sym__block_element] = STATE(359),
    [sym_heading] = STATE(359),
    [sym_list] = STATE(359),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(359),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(359),
    [sym_div] = STATE(359),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(359),
    [sym_raw_block] = STATE(359),
    [sym_thematic_break] = STATE(359),
    [sym_block_quote] = STATE(359),
    [sym__block_quote_prefix] = STATE(81),
    [sym_link_reference_definition] = STATE(359),
    [sym_block_attribute] = STATE(359),
    [sym__paragraph] = STATE(359),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym_div_repeat1] = STATE(14),
    [aux_sym__block_quote_prefix_repeat1] = STATE(432),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(364),
    [sym__newline] = ACTIONS(358),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(127),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(129),
    [sym__block_quote_continuation] = ACTIONS(360),
    [sym__thematic_break_dash] = ACTIONS(131),
    [sym__thematic_break_star] = ACTIONS(131),
    [sym__footnote_mark_begin] = ACTIONS(133),
    [sym__link_ref_def_mark_begin] = ACTIONS(135),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__block_attribute_begin] = ACTIONS(143),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [14] = {
    [sym__block_with_heading] = STATE(359),
    [sym__block_element] = STATE(359),
    [sym_heading] = STATE(359),
    [sym_list] = STATE(359),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(359),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(359),
    [sym_div] = STATE(359),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(359),
    [sym_raw_block] = STATE(359),
    [sym_thematic_break] = STATE(359),
    [sym_block_quote] = STATE(359),
    [sym__block_quote_prefix] = STATE(93),
    [sym_link_reference_definition] = STATE(359),
    [sym_block_attribute] = STATE(359),
    [sym__paragraph] = STATE(359),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym_div_repeat1] = STATE(14),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(366),
    [sym__whitespace1] = ACTIONS(369),
    [sym_quotation_marks] = ACTIONS(372),
    [sym_ellipsis] = ACTIONS(372),
    [sym_em_dash] = ACTIONS(372),
    [sym_en_dash] = ACTIONS(375),
    [sym_backslash_escape] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(378),
    [sym_symbol] = ACTIONS(372),
    [anon_sym_LBRACE_] = ACTIONS(381),
    [anon_sym__] = ACTIONS(384),
    [anon_sym_LBRACE_STAR] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(390),
    [anon_sym_LBRACE_CARET] = ACTIONS(393),
    [anon_sym_CARET] = ACTIONS(393),
    [anon_sym_LBRACE_TILDE] = ACTIONS(396),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_LBRACE_EQ] = ACTIONS(399),
    [anon_sym_LBRACE_PLUS] = ACTIONS(402),
    [anon_sym_LBRACE_DASH] = ACTIONS(405),
    [anon_sym_LBRACK_CARET] = ACTIONS(408),
    [anon_sym_BANG_LBRACK] = ACTIONS(411),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(414),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_DOLLAR] = ACTIONS(420),
    [anon_sym_TODO] = ACTIONS(423),
    [anon_sym_WIP] = ACTIONS(423),
    [anon_sym_NOTE] = ACTIONS(426),
    [anon_sym_INFO] = ACTIONS(426),
    [anon_sym_XXX] = ACTIONS(426),
    [sym_fixme] = ACTIONS(372),
    [aux_sym__text_token1] = ACTIONS(429),
    [sym__block_close] = ACTIONS(432),
    [sym__newline] = ACTIONS(434),
    [sym__newline_inline] = ACTIONS(437),
    [sym_hard_line_break] = ACTIONS(372),
    [sym__heading_begin] = ACTIONS(440),
    [sym__div_begin] = ACTIONS(443),
    [sym__code_block_begin] = ACTIONS(446),
    [sym_list_marker_dash] = ACTIONS(449),
    [sym_list_marker_star] = ACTIONS(452),
    [sym_list_marker_plus] = ACTIONS(455),
    [sym__list_marker_task_begin] = ACTIONS(458),
    [sym_list_marker_definition] = ACTIONS(461),
    [sym_list_marker_decimal_period] = ACTIONS(464),
    [sym_list_marker_lower_alpha_period] = ACTIONS(467),
    [sym_list_marker_upper_alpha_period] = ACTIONS(470),
    [sym_list_marker_lower_roman_period] = ACTIONS(473),
    [sym_list_marker_upper_roman_period] = ACTIONS(476),
    [sym_list_marker_decimal_paren] = ACTIONS(479),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(482),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(485),
    [sym_list_marker_lower_roman_paren] = ACTIONS(488),
    [sym_list_marker_upper_roman_paren] = ACTIONS(491),
    [sym_list_marker_decimal_parens] = ACTIONS(494),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(497),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(500),
    [sym_list_marker_lower_roman_parens] = ACTIONS(503),
    [sym_list_marker_upper_roman_parens] = ACTIONS(506),
    [sym__block_quote_begin] = ACTIONS(509),
    [sym__block_quote_continuation] = ACTIONS(512),
    [sym__thematic_break_dash] = ACTIONS(515),
    [sym__thematic_break_star] = ACTIONS(515),
    [sym__footnote_mark_begin] = ACTIONS(518),
    [sym__link_ref_def_mark_begin] = ACTIONS(521),
    [sym__table_header_begin] = ACTIONS(524),
    [sym__table_separator_begin] = ACTIONS(527),
    [sym__table_row_begin] = ACTIONS(530),
    [sym__block_attribute_begin] = ACTIONS(533),
    [sym__verbatim_begin] = ACTIONS(536),
  },
  [15] = {
    [sym__block_with_heading] = STATE(359),
    [sym__block_element] = STATE(359),
    [sym_heading] = STATE(359),
    [sym_list] = STATE(359),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(359),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(359),
    [sym_div] = STATE(359),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(359),
    [sym_raw_block] = STATE(359),
    [sym_thematic_break] = STATE(359),
    [sym_block_quote] = STATE(359),
    [sym__block_quote_prefix] = STATE(83),
    [sym_link_reference_definition] = STATE(359),
    [sym_block_attribute] = STATE(359),
    [sym__paragraph] = STATE(359),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym_div_repeat1] = STATE(16),
    [aux_sym__block_quote_prefix_repeat1] = STATE(432),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(539),
    [sym__newline] = ACTIONS(358),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(127),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(129),
    [sym__block_quote_continuation] = ACTIONS(360),
    [sym__thematic_break_dash] = ACTIONS(131),
    [sym__thematic_break_star] = ACTIONS(131),
    [sym__footnote_mark_begin] = ACTIONS(133),
    [sym__link_ref_def_mark_begin] = ACTIONS(135),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__block_attribute_begin] = ACTIONS(143),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [16] = {
    [sym__block_with_heading] = STATE(359),
    [sym__block_element] = STATE(359),
    [sym_heading] = STATE(359),
    [sym_list] = STATE(359),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(359),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(359),
    [sym_div] = STATE(359),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(359),
    [sym_raw_block] = STATE(359),
    [sym_thematic_break] = STATE(359),
    [sym_block_quote] = STATE(359),
    [sym__block_quote_prefix] = STATE(85),
    [sym_link_reference_definition] = STATE(359),
    [sym_block_attribute] = STATE(359),
    [sym__paragraph] = STATE(359),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym_div_repeat1] = STATE(14),
    [aux_sym__block_quote_prefix_repeat1] = STATE(432),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(541),
    [sym__newline] = ACTIONS(358),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(127),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(129),
    [sym__block_quote_continuation] = ACTIONS(360),
    [sym__thematic_break_dash] = ACTIONS(131),
    [sym__thematic_break_star] = ACTIONS(131),
    [sym__footnote_mark_begin] = ACTIONS(133),
    [sym__link_ref_def_mark_begin] = ACTIONS(135),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__block_attribute_begin] = ACTIONS(143),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [17] = {
    [sym__block_with_heading] = STATE(359),
    [sym__block_element] = STATE(359),
    [sym_heading] = STATE(359),
    [sym_list] = STATE(359),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(359),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(359),
    [sym_div] = STATE(359),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(359),
    [sym_raw_block] = STATE(359),
    [sym_thematic_break] = STATE(359),
    [sym_block_quote] = STATE(359),
    [sym__block_quote_prefix] = STATE(84),
    [sym_link_reference_definition] = STATE(359),
    [sym_block_attribute] = STATE(359),
    [sym__paragraph] = STATE(359),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym_div_repeat1] = STATE(18),
    [aux_sym__block_quote_prefix_repeat1] = STATE(432),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(543),
    [sym__newline] = ACTIONS(358),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(127),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(129),
    [sym__block_quote_continuation] = ACTIONS(360),
    [sym__thematic_break_dash] = ACTIONS(131),
    [sym__thematic_break_star] = ACTIONS(131),
    [sym__footnote_mark_begin] = ACTIONS(133),
    [sym__link_ref_def_mark_begin] = ACTIONS(135),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__block_attribute_begin] = ACTIONS(143),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [18] = {
    [sym__block_with_heading] = STATE(359),
    [sym__block_element] = STATE(359),
    [sym_heading] = STATE(359),
    [sym_list] = STATE(359),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(359),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(359),
    [sym_div] = STATE(359),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(359),
    [sym_raw_block] = STATE(359),
    [sym_thematic_break] = STATE(359),
    [sym_block_quote] = STATE(359),
    [sym__block_quote_prefix] = STATE(82),
    [sym_link_reference_definition] = STATE(359),
    [sym_block_attribute] = STATE(359),
    [sym__paragraph] = STATE(359),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym_div_repeat1] = STATE(14),
    [aux_sym__block_quote_prefix_repeat1] = STATE(432),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(545),
    [sym__newline] = ACTIONS(358),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(127),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(129),
    [sym__block_quote_continuation] = ACTIONS(360),
    [sym__thematic_break_dash] = ACTIONS(131),
    [sym__thematic_break_star] = ACTIONS(131),
    [sym__footnote_mark_begin] = ACTIONS(133),
    [sym__link_ref_def_mark_begin] = ACTIONS(135),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__block_attribute_begin] = ACTIONS(143),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [19] = {
    [sym__block_with_heading] = STATE(359),
    [sym__block_element] = STATE(359),
    [sym_heading] = STATE(359),
    [sym_list] = STATE(359),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(359),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(359),
    [sym_div] = STATE(359),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(359),
    [sym_raw_block] = STATE(359),
    [sym_thematic_break] = STATE(359),
    [sym_block_quote] = STATE(359),
    [sym__block_quote_prefix] = STATE(90),
    [sym_link_reference_definition] = STATE(359),
    [sym_block_attribute] = STATE(359),
    [sym__paragraph] = STATE(359),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym_div_repeat1] = STATE(20),
    [aux_sym__block_quote_prefix_repeat1] = STATE(432),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(547),
    [sym__newline] = ACTIONS(358),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(127),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(129),
    [sym__block_quote_continuation] = ACTIONS(360),
    [sym__thematic_break_dash] = ACTIONS(131),
    [sym__thematic_break_star] = ACTIONS(131),
    [sym__footnote_mark_begin] = ACTIONS(133),
    [sym__link_ref_def_mark_begin] = ACTIONS(135),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__block_attribute_begin] = ACTIONS(143),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [20] = {
    [sym__block_with_heading] = STATE(359),
    [sym__block_element] = STATE(359),
    [sym_heading] = STATE(359),
    [sym_list] = STATE(359),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(359),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(359),
    [sym_div] = STATE(359),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(359),
    [sym_raw_block] = STATE(359),
    [sym_thematic_break] = STATE(359),
    [sym_block_quote] = STATE(359),
    [sym__block_quote_prefix] = STATE(86),
    [sym_link_reference_definition] = STATE(359),
    [sym_block_attribute] = STATE(359),
    [sym__paragraph] = STATE(359),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym_div_repeat1] = STATE(14),
    [aux_sym__block_quote_prefix_repeat1] = STATE(432),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(549),
    [sym__newline] = ACTIONS(358),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(127),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(129),
    [sym__block_quote_continuation] = ACTIONS(360),
    [sym__thematic_break_dash] = ACTIONS(131),
    [sym__thematic_break_star] = ACTIONS(131),
    [sym__footnote_mark_begin] = ACTIONS(133),
    [sym__link_ref_def_mark_begin] = ACTIONS(135),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__block_attribute_begin] = ACTIONS(143),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [21] = {
    [sym__block_with_heading] = STATE(359),
    [sym__block_element] = STATE(359),
    [sym_heading] = STATE(359),
    [sym_list] = STATE(359),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(359),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(359),
    [sym_div] = STATE(359),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(359),
    [sym_raw_block] = STATE(359),
    [sym_thematic_break] = STATE(359),
    [sym_block_quote] = STATE(359),
    [sym__block_quote_prefix] = STATE(88),
    [sym_link_reference_definition] = STATE(359),
    [sym_block_attribute] = STATE(359),
    [sym__paragraph] = STATE(359),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym_div_repeat1] = STATE(11),
    [aux_sym__block_quote_prefix_repeat1] = STATE(432),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(551),
    [sym__newline] = ACTIONS(358),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(127),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(129),
    [sym__block_quote_continuation] = ACTIONS(360),
    [sym__thematic_break_dash] = ACTIONS(131),
    [sym__thematic_break_star] = ACTIONS(131),
    [sym__footnote_mark_begin] = ACTIONS(133),
    [sym__link_ref_def_mark_begin] = ACTIONS(135),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__block_attribute_begin] = ACTIONS(143),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [22] = {
    [sym__block_with_heading] = STATE(2434),
    [sym__block_element] = STATE(2434),
    [sym_heading] = STATE(2434),
    [sym_list] = STATE(2434),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1599),
    [sym_table] = STATE(2434),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2434),
    [sym_div] = STATE(2434),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2434),
    [sym_raw_block] = STATE(2434),
    [sym_thematic_break] = STATE(2434),
    [sym_block_quote] = STATE(2434),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2434),
    [sym_block_attribute] = STATE(2434),
    [sym__paragraph] = STATE(2434),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(553),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [23] = {
    [sym__block_with_heading] = STATE(2265),
    [sym__block_element] = STATE(2265),
    [sym_heading] = STATE(2265),
    [sym_list] = STATE(2265),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1454),
    [sym_table] = STATE(2265),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2265),
    [sym_div] = STATE(2265),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2265),
    [sym_raw_block] = STATE(2265),
    [sym_thematic_break] = STATE(2265),
    [sym_block_quote] = STATE(2265),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2265),
    [sym_block_attribute] = STATE(2265),
    [sym__paragraph] = STATE(2265),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(577),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [24] = {
    [sym__block_with_heading] = STATE(2199),
    [sym__block_element] = STATE(2199),
    [sym_heading] = STATE(2199),
    [sym_list] = STATE(2199),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1501),
    [sym_table] = STATE(2199),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2199),
    [sym_div] = STATE(2199),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2199),
    [sym_raw_block] = STATE(2199),
    [sym_thematic_break] = STATE(2199),
    [sym_block_quote] = STATE(2199),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2199),
    [sym_block_attribute] = STATE(2199),
    [sym__paragraph] = STATE(2199),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(579),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [25] = {
    [sym__block_with_heading] = STATE(2231),
    [sym__block_element] = STATE(2231),
    [sym_heading] = STATE(2231),
    [sym_list] = STATE(2231),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1514),
    [sym_table] = STATE(2231),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2231),
    [sym_div] = STATE(2231),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2231),
    [sym_raw_block] = STATE(2231),
    [sym_thematic_break] = STATE(2231),
    [sym_block_quote] = STATE(2231),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2231),
    [sym_block_attribute] = STATE(2231),
    [sym__paragraph] = STATE(2231),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(581),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [26] = {
    [sym__block_with_heading] = STATE(2261),
    [sym__block_element] = STATE(2261),
    [sym_heading] = STATE(2261),
    [sym_list] = STATE(2261),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1518),
    [sym_table] = STATE(2261),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2261),
    [sym_div] = STATE(2261),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2261),
    [sym_raw_block] = STATE(2261),
    [sym_thematic_break] = STATE(2261),
    [sym_block_quote] = STATE(2261),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2261),
    [sym_block_attribute] = STATE(2261),
    [sym__paragraph] = STATE(2261),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(583),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [27] = {
    [sym__block_with_heading] = STATE(2290),
    [sym__block_element] = STATE(2290),
    [sym_heading] = STATE(2290),
    [sym_list] = STATE(2290),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1536),
    [sym_table] = STATE(2290),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2290),
    [sym_div] = STATE(2290),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2290),
    [sym_raw_block] = STATE(2290),
    [sym_thematic_break] = STATE(2290),
    [sym_block_quote] = STATE(2290),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2290),
    [sym_block_attribute] = STATE(2290),
    [sym__paragraph] = STATE(2290),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(585),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [28] = {
    [sym__block_with_heading] = STATE(2315),
    [sym__block_element] = STATE(2315),
    [sym_heading] = STATE(2315),
    [sym_list] = STATE(2315),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1564),
    [sym_table] = STATE(2315),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2315),
    [sym_div] = STATE(2315),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2315),
    [sym_raw_block] = STATE(2315),
    [sym_thematic_break] = STATE(2315),
    [sym_block_quote] = STATE(2315),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2315),
    [sym_block_attribute] = STATE(2315),
    [sym__paragraph] = STATE(2315),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(587),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [29] = {
    [sym__block_with_heading] = STATE(2332),
    [sym__block_element] = STATE(2332),
    [sym_heading] = STATE(2332),
    [sym_list] = STATE(2332),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1565),
    [sym_table] = STATE(2332),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2332),
    [sym_div] = STATE(2332),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2332),
    [sym_raw_block] = STATE(2332),
    [sym_thematic_break] = STATE(2332),
    [sym_block_quote] = STATE(2332),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2332),
    [sym_block_attribute] = STATE(2332),
    [sym__paragraph] = STATE(2332),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(589),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [30] = {
    [sym__block_with_heading] = STATE(2349),
    [sym__block_element] = STATE(2349),
    [sym_heading] = STATE(2349),
    [sym_list] = STATE(2349),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1566),
    [sym_table] = STATE(2349),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2349),
    [sym_div] = STATE(2349),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2349),
    [sym_raw_block] = STATE(2349),
    [sym_thematic_break] = STATE(2349),
    [sym_block_quote] = STATE(2349),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2349),
    [sym_block_attribute] = STATE(2349),
    [sym__paragraph] = STATE(2349),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(591),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [31] = {
    [sym__block_with_heading] = STATE(2366),
    [sym__block_element] = STATE(2366),
    [sym_heading] = STATE(2366),
    [sym_list] = STATE(2366),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1567),
    [sym_table] = STATE(2366),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2366),
    [sym_div] = STATE(2366),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2366),
    [sym_raw_block] = STATE(2366),
    [sym_thematic_break] = STATE(2366),
    [sym_block_quote] = STATE(2366),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2366),
    [sym_block_attribute] = STATE(2366),
    [sym__paragraph] = STATE(2366),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(593),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [32] = {
    [sym__block_with_heading] = STATE(2383),
    [sym__block_element] = STATE(2383),
    [sym_heading] = STATE(2383),
    [sym_list] = STATE(2383),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1569),
    [sym_table] = STATE(2383),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2383),
    [sym_div] = STATE(2383),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2383),
    [sym_raw_block] = STATE(2383),
    [sym_thematic_break] = STATE(2383),
    [sym_block_quote] = STATE(2383),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2383),
    [sym_block_attribute] = STATE(2383),
    [sym__paragraph] = STATE(2383),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(595),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [33] = {
    [sym__block_with_heading] = STATE(2400),
    [sym__block_element] = STATE(2400),
    [sym_heading] = STATE(2400),
    [sym_list] = STATE(2400),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1571),
    [sym_table] = STATE(2400),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2400),
    [sym_div] = STATE(2400),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2400),
    [sym_raw_block] = STATE(2400),
    [sym_thematic_break] = STATE(2400),
    [sym_block_quote] = STATE(2400),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2400),
    [sym_block_attribute] = STATE(2400),
    [sym__paragraph] = STATE(2400),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(597),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [34] = {
    [sym__block_with_heading] = STATE(2417),
    [sym__block_element] = STATE(2417),
    [sym_heading] = STATE(2417),
    [sym_list] = STATE(2417),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1589),
    [sym_table] = STATE(2417),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2417),
    [sym_div] = STATE(2417),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2417),
    [sym_raw_block] = STATE(2417),
    [sym_thematic_break] = STATE(2417),
    [sym_block_quote] = STATE(2417),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2417),
    [sym_block_attribute] = STATE(2417),
    [sym__paragraph] = STATE(2417),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(599),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [35] = {
    [sym__block_with_heading] = STATE(2199),
    [sym__block_element] = STATE(2199),
    [sym_heading] = STATE(2199),
    [sym_list] = STATE(2199),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1535),
    [sym_table] = STATE(2199),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2199),
    [sym_div] = STATE(2199),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2199),
    [sym_raw_block] = STATE(2199),
    [sym_thematic_break] = STATE(2199),
    [sym_block_quote] = STATE(2199),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2199),
    [sym_block_attribute] = STATE(2199),
    [sym__paragraph] = STATE(2199),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(579),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [36] = {
    [sym__block_with_heading] = STATE(2449),
    [sym__block_element] = STATE(2449),
    [sym_heading] = STATE(2449),
    [sym_list] = STATE(2449),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1600),
    [sym_table] = STATE(2449),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2449),
    [sym_div] = STATE(2449),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2449),
    [sym_raw_block] = STATE(2449),
    [sym_thematic_break] = STATE(2449),
    [sym_block_quote] = STATE(2449),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2449),
    [sym_block_attribute] = STATE(2449),
    [sym__paragraph] = STATE(2449),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(601),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [37] = {
    [sym__block_with_heading] = STATE(2450),
    [sym__block_element] = STATE(2450),
    [sym_heading] = STATE(2450),
    [sym_list] = STATE(2450),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1601),
    [sym_table] = STATE(2450),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2450),
    [sym_div] = STATE(2450),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2450),
    [sym_raw_block] = STATE(2450),
    [sym_thematic_break] = STATE(2450),
    [sym_block_quote] = STATE(2450),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2450),
    [sym_block_attribute] = STATE(2450),
    [sym__paragraph] = STATE(2450),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(603),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [38] = {
    [sym__block_with_heading] = STATE(2451),
    [sym__block_element] = STATE(2451),
    [sym_heading] = STATE(2451),
    [sym_list] = STATE(2451),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1604),
    [sym_table] = STATE(2451),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2451),
    [sym_div] = STATE(2451),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2451),
    [sym_raw_block] = STATE(2451),
    [sym_thematic_break] = STATE(2451),
    [sym_block_quote] = STATE(2451),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2451),
    [sym_block_attribute] = STATE(2451),
    [sym__paragraph] = STATE(2451),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(605),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [39] = {
    [sym__block_with_heading] = STATE(2452),
    [sym__block_element] = STATE(2452),
    [sym_heading] = STATE(2452),
    [sym_list] = STATE(2452),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1605),
    [sym_table] = STATE(2452),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2452),
    [sym_div] = STATE(2452),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2452),
    [sym_raw_block] = STATE(2452),
    [sym_thematic_break] = STATE(2452),
    [sym_block_quote] = STATE(2452),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2452),
    [sym_block_attribute] = STATE(2452),
    [sym__paragraph] = STATE(2452),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(607),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [40] = {
    [sym__block_with_heading] = STATE(2453),
    [sym__block_element] = STATE(2453),
    [sym_heading] = STATE(2453),
    [sym_list] = STATE(2453),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1607),
    [sym_table] = STATE(2453),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2453),
    [sym_div] = STATE(2453),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2453),
    [sym_raw_block] = STATE(2453),
    [sym_thematic_break] = STATE(2453),
    [sym_block_quote] = STATE(2453),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2453),
    [sym_block_attribute] = STATE(2453),
    [sym__paragraph] = STATE(2453),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(609),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [41] = {
    [sym__block_with_heading] = STATE(2454),
    [sym__block_element] = STATE(2454),
    [sym_heading] = STATE(2454),
    [sym_list] = STATE(2454),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1612),
    [sym_table] = STATE(2454),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2454),
    [sym_div] = STATE(2454),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2454),
    [sym_raw_block] = STATE(2454),
    [sym_thematic_break] = STATE(2454),
    [sym_block_quote] = STATE(2454),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2454),
    [sym_block_attribute] = STATE(2454),
    [sym__paragraph] = STATE(2454),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(611),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [42] = {
    [sym__block_with_heading] = STATE(2231),
    [sym__block_element] = STATE(2231),
    [sym_heading] = STATE(2231),
    [sym_list] = STATE(2231),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1539),
    [sym_table] = STATE(2231),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2231),
    [sym_div] = STATE(2231),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2231),
    [sym_raw_block] = STATE(2231),
    [sym_thematic_break] = STATE(2231),
    [sym_block_quote] = STATE(2231),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2231),
    [sym_block_attribute] = STATE(2231),
    [sym__paragraph] = STATE(2231),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(581),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [43] = {
    [sym__block_with_heading] = STATE(2400),
    [sym__block_element] = STATE(2400),
    [sym_heading] = STATE(2400),
    [sym_list] = STATE(2400),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1641),
    [sym_table] = STATE(2400),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2400),
    [sym_div] = STATE(2400),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2400),
    [sym_raw_block] = STATE(2400),
    [sym_thematic_break] = STATE(2400),
    [sym_block_quote] = STATE(2400),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2400),
    [sym_block_attribute] = STATE(2400),
    [sym__paragraph] = STATE(2400),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(597),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [44] = {
    [sym__block_with_heading] = STATE(2265),
    [sym__block_element] = STATE(2265),
    [sym_heading] = STATE(2265),
    [sym_list] = STATE(2265),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1494),
    [sym_table] = STATE(2265),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2265),
    [sym_div] = STATE(2265),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2265),
    [sym_raw_block] = STATE(2265),
    [sym_thematic_break] = STATE(2265),
    [sym_block_quote] = STATE(2265),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2265),
    [sym_block_attribute] = STATE(2265),
    [sym__paragraph] = STATE(2265),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(577),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [45] = {
    [sym__block_with_heading] = STATE(2417),
    [sym__block_element] = STATE(2417),
    [sym_heading] = STATE(2417),
    [sym_list] = STATE(2417),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1411),
    [sym_table] = STATE(2417),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2417),
    [sym_div] = STATE(2417),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2417),
    [sym_raw_block] = STATE(2417),
    [sym_thematic_break] = STATE(2417),
    [sym_block_quote] = STATE(2417),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2417),
    [sym_block_attribute] = STATE(2417),
    [sym__paragraph] = STATE(2417),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(599),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [46] = {
    [sym__block_with_heading] = STATE(2149),
    [sym__block_element] = STATE(2149),
    [sym_heading] = STATE(2149),
    [sym_list] = STATE(2149),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(2149),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2149),
    [sym_footnote_content] = STATE(367),
    [sym_div] = STATE(2149),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2149),
    [sym_raw_block] = STATE(2149),
    [sym_thematic_break] = STATE(2149),
    [sym_block_quote] = STATE(2149),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2149),
    [sym_block_attribute] = STATE(2149),
    [sym__paragraph] = STATE(2149),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(613),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [47] = {
    [sym__block_with_heading] = STATE(2434),
    [sym__block_element] = STATE(2434),
    [sym_heading] = STATE(2434),
    [sym_list] = STATE(2434),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1543),
    [sym_table] = STATE(2434),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2434),
    [sym_div] = STATE(2434),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2434),
    [sym_raw_block] = STATE(2434),
    [sym_thematic_break] = STATE(2434),
    [sym_block_quote] = STATE(2434),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2434),
    [sym_block_attribute] = STATE(2434),
    [sym__paragraph] = STATE(2434),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(553),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [48] = {
    [sym__block_with_heading] = STATE(2449),
    [sym__block_element] = STATE(2449),
    [sym_heading] = STATE(2449),
    [sym_list] = STATE(2449),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1516),
    [sym_table] = STATE(2449),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2449),
    [sym_div] = STATE(2449),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2449),
    [sym_raw_block] = STATE(2449),
    [sym_thematic_break] = STATE(2449),
    [sym_block_quote] = STATE(2449),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2449),
    [sym_block_attribute] = STATE(2449),
    [sym__paragraph] = STATE(2449),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(601),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [49] = {
    [sym__block_with_heading] = STATE(2450),
    [sym__block_element] = STATE(2450),
    [sym_heading] = STATE(2450),
    [sym_list] = STATE(2450),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1507),
    [sym_table] = STATE(2450),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2450),
    [sym_div] = STATE(2450),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2450),
    [sym_raw_block] = STATE(2450),
    [sym_thematic_break] = STATE(2450),
    [sym_block_quote] = STATE(2450),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2450),
    [sym_block_attribute] = STATE(2450),
    [sym__paragraph] = STATE(2450),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(603),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [50] = {
    [sym__block_with_heading] = STATE(2451),
    [sym__block_element] = STATE(2451),
    [sym_heading] = STATE(2451),
    [sym_list] = STATE(2451),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1633),
    [sym_table] = STATE(2451),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2451),
    [sym_div] = STATE(2451),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2451),
    [sym_raw_block] = STATE(2451),
    [sym_thematic_break] = STATE(2451),
    [sym_block_quote] = STATE(2451),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2451),
    [sym_block_attribute] = STATE(2451),
    [sym__paragraph] = STATE(2451),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(605),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [51] = {
    [sym__block_with_heading] = STATE(2452),
    [sym__block_element] = STATE(2452),
    [sym_heading] = STATE(2452),
    [sym_list] = STATE(2452),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1636),
    [sym_table] = STATE(2452),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2452),
    [sym_div] = STATE(2452),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2452),
    [sym_raw_block] = STATE(2452),
    [sym_thematic_break] = STATE(2452),
    [sym_block_quote] = STATE(2452),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2452),
    [sym_block_attribute] = STATE(2452),
    [sym__paragraph] = STATE(2452),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(607),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [52] = {
    [sym__block_with_heading] = STATE(2453),
    [sym__block_element] = STATE(2453),
    [sym_heading] = STATE(2453),
    [sym_list] = STATE(2453),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1541),
    [sym_table] = STATE(2453),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2453),
    [sym_div] = STATE(2453),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2453),
    [sym_raw_block] = STATE(2453),
    [sym_thematic_break] = STATE(2453),
    [sym_block_quote] = STATE(2453),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2453),
    [sym_block_attribute] = STATE(2453),
    [sym__paragraph] = STATE(2453),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(609),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [53] = {
    [sym__block_with_heading] = STATE(2222),
    [sym__block_element] = STATE(2222),
    [sym_heading] = STATE(2222),
    [sym_list] = STATE(2222),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(2222),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2222),
    [sym_footnote_content] = STATE(2191),
    [sym_div] = STATE(2222),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2222),
    [sym_raw_block] = STATE(2222),
    [sym_thematic_break] = STATE(2222),
    [sym_block_quote] = STATE(2222),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2222),
    [sym_block_attribute] = STATE(2222),
    [sym__paragraph] = STATE(2222),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(615),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [54] = {
    [sym__block_with_heading] = STATE(2261),
    [sym__block_element] = STATE(2261),
    [sym_heading] = STATE(2261),
    [sym_list] = STATE(2261),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1562),
    [sym_table] = STATE(2261),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2261),
    [sym_div] = STATE(2261),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2261),
    [sym_raw_block] = STATE(2261),
    [sym_thematic_break] = STATE(2261),
    [sym_block_quote] = STATE(2261),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2261),
    [sym_block_attribute] = STATE(2261),
    [sym__paragraph] = STATE(2261),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(583),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [55] = {
    [sym__block_with_heading] = STATE(2290),
    [sym__block_element] = STATE(2290),
    [sym_heading] = STATE(2290),
    [sym_list] = STATE(2290),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1576),
    [sym_table] = STATE(2290),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2290),
    [sym_div] = STATE(2290),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2290),
    [sym_raw_block] = STATE(2290),
    [sym_thematic_break] = STATE(2290),
    [sym_block_quote] = STATE(2290),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2290),
    [sym_block_attribute] = STATE(2290),
    [sym__paragraph] = STATE(2290),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(585),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [56] = {
    [sym__block_with_heading] = STATE(2454),
    [sym__block_element] = STATE(2454),
    [sym_heading] = STATE(2454),
    [sym_list] = STATE(2454),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1489),
    [sym_table] = STATE(2454),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2454),
    [sym_div] = STATE(2454),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2454),
    [sym_raw_block] = STATE(2454),
    [sym_thematic_break] = STATE(2454),
    [sym_block_quote] = STATE(2454),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2454),
    [sym_block_attribute] = STATE(2454),
    [sym__paragraph] = STATE(2454),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(611),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [57] = {
    [sym__block_with_heading] = STATE(2252),
    [sym__block_element] = STATE(2252),
    [sym_heading] = STATE(2252),
    [sym_list] = STATE(2252),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(2252),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2252),
    [sym_footnote_content] = STATE(1681),
    [sym_div] = STATE(2252),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2252),
    [sym_raw_block] = STATE(2252),
    [sym_thematic_break] = STATE(2252),
    [sym_block_quote] = STATE(2252),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2252),
    [sym_block_attribute] = STATE(2252),
    [sym__paragraph] = STATE(2252),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(617),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [58] = {
    [sym__block_with_heading] = STATE(2315),
    [sym__block_element] = STATE(2315),
    [sym_heading] = STATE(2315),
    [sym_list] = STATE(2315),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1620),
    [sym_table] = STATE(2315),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2315),
    [sym_div] = STATE(2315),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2315),
    [sym_raw_block] = STATE(2315),
    [sym_thematic_break] = STATE(2315),
    [sym_block_quote] = STATE(2315),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2315),
    [sym_block_attribute] = STATE(2315),
    [sym__paragraph] = STATE(2315),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(587),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [59] = {
    [sym__block_with_heading] = STATE(2332),
    [sym__block_element] = STATE(2332),
    [sym_heading] = STATE(2332),
    [sym_list] = STATE(2332),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1623),
    [sym_table] = STATE(2332),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2332),
    [sym_div] = STATE(2332),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2332),
    [sym_raw_block] = STATE(2332),
    [sym_thematic_break] = STATE(2332),
    [sym_block_quote] = STATE(2332),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2332),
    [sym_block_attribute] = STATE(2332),
    [sym__paragraph] = STATE(2332),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(589),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [60] = {
    [sym__block_with_heading] = STATE(2282),
    [sym__block_element] = STATE(2282),
    [sym_heading] = STATE(2282),
    [sym_list] = STATE(2282),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(2282),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2282),
    [sym_footnote_content] = STATE(414),
    [sym_div] = STATE(2282),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2282),
    [sym_raw_block] = STATE(2282),
    [sym_thematic_break] = STATE(2282),
    [sym_block_quote] = STATE(2282),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2282),
    [sym_block_attribute] = STATE(2282),
    [sym__paragraph] = STATE(2282),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(619),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [61] = {
    [sym__block_with_heading] = STATE(2349),
    [sym__block_element] = STATE(2349),
    [sym_heading] = STATE(2349),
    [sym_list] = STATE(2349),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1626),
    [sym_table] = STATE(2349),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2349),
    [sym_div] = STATE(2349),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2349),
    [sym_raw_block] = STATE(2349),
    [sym_thematic_break] = STATE(2349),
    [sym_block_quote] = STATE(2349),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2349),
    [sym_block_attribute] = STATE(2349),
    [sym__paragraph] = STATE(2349),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(591),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [62] = {
    [sym__block_with_heading] = STATE(2366),
    [sym__block_element] = STATE(2366),
    [sym_heading] = STATE(2366),
    [sym_list] = STATE(2366),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1632),
    [sym_table] = STATE(2366),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2366),
    [sym_div] = STATE(2366),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2366),
    [sym_raw_block] = STATE(2366),
    [sym_thematic_break] = STATE(2366),
    [sym_block_quote] = STATE(2366),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2366),
    [sym_block_attribute] = STATE(2366),
    [sym__paragraph] = STATE(2366),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(593),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [63] = {
    [sym__block_with_heading] = STATE(2311),
    [sym__block_element] = STATE(2311),
    [sym_heading] = STATE(2311),
    [sym_list] = STATE(2311),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(2311),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2311),
    [sym_footnote_content] = STATE(1452),
    [sym_div] = STATE(2311),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2311),
    [sym_raw_block] = STATE(2311),
    [sym_thematic_break] = STATE(2311),
    [sym_block_quote] = STATE(2311),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2311),
    [sym_block_attribute] = STATE(2311),
    [sym__paragraph] = STATE(2311),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(621),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [64] = {
    [sym__block_with_heading] = STATE(2383),
    [sym__block_element] = STATE(2383),
    [sym_heading] = STATE(2383),
    [sym_list] = STATE(2383),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_list_item_content] = STATE(1634),
    [sym_table] = STATE(2383),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2383),
    [sym_div] = STATE(2383),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2383),
    [sym_raw_block] = STATE(2383),
    [sym_thematic_break] = STATE(2383),
    [sym_block_quote] = STATE(2383),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2383),
    [sym_block_attribute] = STATE(2383),
    [sym__paragraph] = STATE(2383),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(595),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [65] = {
    [sym__block_with_heading] = STATE(1534),
    [sym__block_element] = STATE(1534),
    [sym_heading] = STATE(1534),
    [sym_list] = STATE(1534),
    [sym__list_dash] = STATE(1430),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(1430),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(1430),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(1430),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(1430),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(1430),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(1430),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(1430),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(1430),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(1430),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(1430),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(1430),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(1430),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(1430),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(1430),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(1430),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(1430),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(1430),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(1430),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(1430),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(1534),
    [sym__table_row] = STATE(1030),
    [sym_table_header] = STATE(1030),
    [sym_table_separator] = STATE(1030),
    [sym_table_row] = STATE(1030),
    [sym_footnote] = STATE(1534),
    [sym_div] = STATE(1534),
    [sym__div_marker_begin] = STATE(2287),
    [sym_code_block] = STATE(1534),
    [sym_raw_block] = STATE(1534),
    [sym_thematic_break] = STATE(1534),
    [sym_block_quote] = STATE(1534),
    [sym__block_quote_prefix] = STATE(95),
    [sym_link_reference_definition] = STATE(1534),
    [sym_block_attribute] = STATE(1534),
    [sym__paragraph] = STATE(1534),
    [sym__paragraph_content] = STATE(1715),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1166),
    [aux_sym__list_plus_repeat1] = STATE(1167),
    [aux_sym__list_star_repeat1] = STATE(1168),
    [aux_sym__list_task_repeat1] = STATE(1091),
    [aux_sym__list_definition_repeat1] = STATE(1373),
    [aux_sym__list_decimal_period_repeat1] = STATE(1170),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1171),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1172),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1173),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1174),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1175),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1102),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1177),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1243),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1179),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1180),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1181),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1182),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1183),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1184),
    [aux_sym_table_repeat1] = STATE(1030),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(623),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(625),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(627),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(629),
    [sym__block_quote_continuation] = ACTIONS(631),
    [sym__thematic_break_dash] = ACTIONS(633),
    [sym__thematic_break_star] = ACTIONS(633),
    [sym__footnote_mark_begin] = ACTIONS(635),
    [sym__link_ref_def_mark_begin] = ACTIONS(637),
    [sym__table_header_begin] = ACTIONS(639),
    [sym__table_separator_begin] = ACTIONS(641),
    [sym__table_row_begin] = ACTIONS(643),
    [sym__block_attribute_begin] = ACTIONS(645),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [66] = {
    [sym__block_with_heading] = STATE(2305),
    [sym__block_element] = STATE(2305),
    [sym_heading] = STATE(2305),
    [sym_list] = STATE(2305),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(2305),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2305),
    [sym_div] = STATE(2305),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2305),
    [sym_raw_block] = STATE(2305),
    [sym_thematic_break] = STATE(2305),
    [sym_block_quote] = STATE(2305),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2305),
    [sym_block_attribute] = STATE(2305),
    [sym__paragraph] = STATE(2305),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(647),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [67] = {
    [sym__block_with_heading] = STATE(1484),
    [sym__block_element] = STATE(1484),
    [sym_heading] = STATE(1484),
    [sym_list] = STATE(1484),
    [sym__list_dash] = STATE(1430),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(1430),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(1430),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(1430),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(1430),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(1430),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(1430),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(1430),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(1430),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(1430),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(1430),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(1430),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(1430),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(1430),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(1430),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(1430),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(1430),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(1430),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(1430),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(1430),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(1484),
    [sym__table_row] = STATE(1030),
    [sym_table_header] = STATE(1030),
    [sym_table_separator] = STATE(1030),
    [sym_table_row] = STATE(1030),
    [sym_footnote] = STATE(1484),
    [sym_div] = STATE(1484),
    [sym__div_marker_begin] = STATE(2287),
    [sym_code_block] = STATE(1484),
    [sym_raw_block] = STATE(1484),
    [sym_thematic_break] = STATE(1484),
    [sym_block_quote] = STATE(1484),
    [sym__block_quote_prefix] = STATE(95),
    [sym_link_reference_definition] = STATE(1484),
    [sym_block_attribute] = STATE(1484),
    [sym__paragraph] = STATE(1484),
    [sym__paragraph_content] = STATE(1715),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1166),
    [aux_sym__list_plus_repeat1] = STATE(1167),
    [aux_sym__list_star_repeat1] = STATE(1168),
    [aux_sym__list_task_repeat1] = STATE(1091),
    [aux_sym__list_definition_repeat1] = STATE(1373),
    [aux_sym__list_decimal_period_repeat1] = STATE(1170),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1171),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1172),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1173),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1174),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1175),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1102),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1177),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1243),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1179),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1180),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1181),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1182),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1183),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1184),
    [aux_sym_table_repeat1] = STATE(1030),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(649),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(625),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(627),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(629),
    [sym__block_quote_continuation] = ACTIONS(631),
    [sym__thematic_break_dash] = ACTIONS(633),
    [sym__thematic_break_star] = ACTIONS(633),
    [sym__footnote_mark_begin] = ACTIONS(635),
    [sym__link_ref_def_mark_begin] = ACTIONS(637),
    [sym__table_header_begin] = ACTIONS(639),
    [sym__table_separator_begin] = ACTIONS(641),
    [sym__table_row_begin] = ACTIONS(643),
    [sym__block_attribute_begin] = ACTIONS(645),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [68] = {
    [sym__block_with_heading] = STATE(2083),
    [sym__block_element] = STATE(2083),
    [sym_heading] = STATE(2083),
    [sym_list] = STATE(2083),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(2083),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2083),
    [sym_div] = STATE(2083),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2083),
    [sym_raw_block] = STATE(2083),
    [sym_thematic_break] = STATE(2083),
    [sym_block_quote] = STATE(2083),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2083),
    [sym_block_attribute] = STATE(2083),
    [sym__paragraph] = STATE(2083),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(651),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [69] = {
    [sym__block_with_heading] = STATE(2611),
    [sym__block_element] = STATE(2611),
    [sym_heading] = STATE(2611),
    [sym_list] = STATE(2611),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(2611),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2611),
    [sym_div] = STATE(2611),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2611),
    [sym_raw_block] = STATE(2611),
    [sym_thematic_break] = STATE(2611),
    [sym_block_quote] = STATE(2611),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2611),
    [sym_block_attribute] = STATE(2611),
    [sym__paragraph] = STATE(2611),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(653),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [70] = {
    [sym__block_element] = STATE(331),
    [sym_heading] = STATE(331),
    [sym_list] = STATE(331),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(331),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(331),
    [sym_div] = STATE(331),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(331),
    [sym_raw_block] = STATE(331),
    [sym_thematic_break] = STATE(331),
    [sym_block_quote] = STATE(331),
    [sym__block_quote_prefix] = STATE(93),
    [sym_link_reference_definition] = STATE(331),
    [sym_block_attribute] = STATE(331),
    [sym__paragraph] = STATE(331),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(655),
    [sym__whitespace1] = ACTIONS(657),
    [sym_quotation_marks] = ACTIONS(657),
    [sym_ellipsis] = ACTIONS(657),
    [sym_em_dash] = ACTIONS(657),
    [sym_en_dash] = ACTIONS(655),
    [sym_backslash_escape] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(657),
    [sym_symbol] = ACTIONS(657),
    [anon_sym_LBRACE_] = ACTIONS(657),
    [anon_sym__] = ACTIONS(657),
    [anon_sym_LBRACE_STAR] = ACTIONS(657),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_LBRACE_CARET] = ACTIONS(657),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_LBRACE_TILDE] = ACTIONS(657),
    [anon_sym_TILDE] = ACTIONS(657),
    [anon_sym_LBRACE_EQ] = ACTIONS(657),
    [anon_sym_LBRACE_PLUS] = ACTIONS(657),
    [anon_sym_LBRACE_DASH] = ACTIONS(657),
    [anon_sym_LBRACK_CARET] = ACTIONS(657),
    [anon_sym_BANG_LBRACK] = ACTIONS(657),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(657),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_DOLLAR] = ACTIONS(657),
    [anon_sym_TODO] = ACTIONS(657),
    [anon_sym_WIP] = ACTIONS(657),
    [anon_sym_NOTE] = ACTIONS(657),
    [anon_sym_INFO] = ACTIONS(657),
    [anon_sym_XXX] = ACTIONS(657),
    [sym_fixme] = ACTIONS(657),
    [aux_sym__text_token1] = ACTIONS(655),
    [sym__block_close] = ACTIONS(657),
    [sym__newline] = ACTIONS(659),
    [sym__newline_inline] = ACTIONS(657),
    [sym_hard_line_break] = ACTIONS(657),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(127),
    [sym_list_marker_dash] = ACTIONS(657),
    [sym_list_marker_star] = ACTIONS(657),
    [sym_list_marker_plus] = ACTIONS(657),
    [sym__list_marker_task_begin] = ACTIONS(657),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(657),
    [sym_list_marker_lower_alpha_period] = ACTIONS(657),
    [sym_list_marker_upper_alpha_period] = ACTIONS(657),
    [sym_list_marker_lower_roman_period] = ACTIONS(657),
    [sym_list_marker_upper_roman_period] = ACTIONS(657),
    [sym_list_marker_decimal_paren] = ACTIONS(657),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(657),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(657),
    [sym_list_marker_lower_roman_paren] = ACTIONS(657),
    [sym_list_marker_upper_roman_paren] = ACTIONS(657),
    [sym_list_marker_decimal_parens] = ACTIONS(657),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(657),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(657),
    [sym_list_marker_lower_roman_parens] = ACTIONS(657),
    [sym_list_marker_upper_roman_parens] = ACTIONS(657),
    [sym__block_quote_begin] = ACTIONS(129),
    [sym__block_quote_continuation] = ACTIONS(657),
    [sym__thematic_break_dash] = ACTIONS(131),
    [sym__thematic_break_star] = ACTIONS(131),
    [sym__footnote_mark_begin] = ACTIONS(133),
    [sym__link_ref_def_mark_begin] = ACTIONS(135),
    [sym__table_header_begin] = ACTIONS(657),
    [sym__table_separator_begin] = ACTIONS(657),
    [sym__table_row_begin] = ACTIONS(657),
    [sym__block_attribute_begin] = ACTIONS(143),
    [sym__verbatim_begin] = ACTIONS(657),
  },
  [71] = {
    [sym__block_with_heading] = STATE(2277),
    [sym__block_element] = STATE(2277),
    [sym_heading] = STATE(2277),
    [sym_list] = STATE(2277),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(2277),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2277),
    [sym_div] = STATE(2277),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2277),
    [sym_raw_block] = STATE(2277),
    [sym_thematic_break] = STATE(2277),
    [sym_block_quote] = STATE(2277),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2277),
    [sym_block_attribute] = STATE(2277),
    [sym__paragraph] = STATE(2277),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline] = ACTIONS(661),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(561),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [72] = {
    [sym__block_element] = STATE(331),
    [sym_heading] = STATE(331),
    [sym_list] = STATE(331),
    [sym__list_dash] = STATE(360),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(360),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(360),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(360),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(360),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(360),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(360),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(360),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(360),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(360),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(360),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(360),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(360),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(360),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(360),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(360),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(360),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(360),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(360),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(360),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(331),
    [sym__table_row] = STATE(136),
    [sym_table_header] = STATE(136),
    [sym_table_separator] = STATE(136),
    [sym_table_row] = STATE(136),
    [sym_footnote] = STATE(331),
    [sym_div] = STATE(331),
    [sym__div_marker_begin] = STATE(2258),
    [sym_code_block] = STATE(331),
    [sym_raw_block] = STATE(331),
    [sym_thematic_break] = STATE(331),
    [sym_block_quote] = STATE(331),
    [sym__block_quote_prefix] = STATE(93),
    [sym_link_reference_definition] = STATE(331),
    [sym_block_attribute] = STATE(331),
    [sym__paragraph] = STATE(331),
    [sym__paragraph_content] = STATE(1677),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1140),
    [aux_sym__list_plus_repeat1] = STATE(1141),
    [aux_sym__list_star_repeat1] = STATE(1142),
    [aux_sym__list_task_repeat1] = STATE(1084),
    [aux_sym__list_definition_repeat1] = STATE(1403),
    [aux_sym__list_decimal_period_repeat1] = STATE(1144),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1145),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1146),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1147),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1148),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1149),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1150),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1151),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1152),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1153),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1154),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1155),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1156),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1157),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1158),
    [aux_sym_table_repeat1] = STATE(136),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(655),
    [sym__whitespace1] = ACTIONS(657),
    [sym_quotation_marks] = ACTIONS(657),
    [sym_ellipsis] = ACTIONS(657),
    [sym_em_dash] = ACTIONS(657),
    [sym_en_dash] = ACTIONS(655),
    [sym_backslash_escape] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(657),
    [sym_symbol] = ACTIONS(657),
    [anon_sym_LBRACE_] = ACTIONS(657),
    [anon_sym__] = ACTIONS(657),
    [anon_sym_LBRACE_STAR] = ACTIONS(657),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_LBRACE_CARET] = ACTIONS(657),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_LBRACE_TILDE] = ACTIONS(657),
    [anon_sym_TILDE] = ACTIONS(657),
    [anon_sym_LBRACE_EQ] = ACTIONS(657),
    [anon_sym_LBRACE_PLUS] = ACTIONS(657),
    [anon_sym_LBRACE_DASH] = ACTIONS(657),
    [anon_sym_LBRACK_CARET] = ACTIONS(657),
    [anon_sym_BANG_LBRACK] = ACTIONS(657),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(657),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_DOLLAR] = ACTIONS(657),
    [anon_sym_TODO] = ACTIONS(657),
    [anon_sym_WIP] = ACTIONS(657),
    [anon_sym_NOTE] = ACTIONS(657),
    [anon_sym_INFO] = ACTIONS(657),
    [anon_sym_XXX] = ACTIONS(657),
    [sym_fixme] = ACTIONS(657),
    [aux_sym__text_token1] = ACTIONS(655),
    [sym__newline] = ACTIONS(659),
    [sym__newline_inline] = ACTIONS(657),
    [sym_hard_line_break] = ACTIONS(657),
    [sym__heading_begin] = ACTIONS(55),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(127),
    [sym_list_marker_dash] = ACTIONS(657),
    [sym_list_marker_star] = ACTIONS(657),
    [sym_list_marker_plus] = ACTIONS(657),
    [sym__list_marker_task_begin] = ACTIONS(657),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(657),
    [sym_list_marker_lower_alpha_period] = ACTIONS(657),
    [sym_list_marker_upper_alpha_period] = ACTIONS(657),
    [sym_list_marker_lower_roman_period] = ACTIONS(657),
    [sym_list_marker_upper_roman_period] = ACTIONS(657),
    [sym_list_marker_decimal_paren] = ACTIONS(657),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(657),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(657),
    [sym_list_marker_lower_roman_paren] = ACTIONS(657),
    [sym_list_marker_upper_roman_paren] = ACTIONS(657),
    [sym_list_marker_decimal_parens] = ACTIONS(657),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(657),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(657),
    [sym_list_marker_lower_roman_parens] = ACTIONS(657),
    [sym_list_marker_upper_roman_parens] = ACTIONS(657),
    [sym__block_quote_begin] = ACTIONS(129),
    [sym__block_quote_continuation] = ACTIONS(657),
    [sym__thematic_break_dash] = ACTIONS(131),
    [sym__thematic_break_star] = ACTIONS(131),
    [sym__footnote_mark_begin] = ACTIONS(133),
    [sym__link_ref_def_mark_begin] = ACTIONS(135),
    [sym__table_header_begin] = ACTIONS(657),
    [sym__table_separator_begin] = ACTIONS(657),
    [sym__table_row_begin] = ACTIONS(657),
    [sym__block_attribute_begin] = ACTIONS(143),
    [sym__verbatim_begin] = ACTIONS(657),
  },
  [73] = {
    [sym__block_element] = STATE(1353),
    [sym_heading] = STATE(1353),
    [sym_list] = STATE(1353),
    [sym__list_dash] = STATE(1895),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(1895),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(1895),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(1895),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(1895),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(1895),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(1895),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(1895),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(1895),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(1895),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(1895),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(1895),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(1895),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(1895),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(1895),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(1895),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(1895),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(1895),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(1895),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(1895),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(1353),
    [sym__table_row] = STATE(1031),
    [sym_table_header] = STATE(1031),
    [sym_table_separator] = STATE(1031),
    [sym_table_row] = STATE(1031),
    [sym_footnote] = STATE(1353),
    [sym_div] = STATE(1353),
    [sym__div_marker_begin] = STATE(2228),
    [sym_code_block] = STATE(1353),
    [sym_raw_block] = STATE(1353),
    [sym_thematic_break] = STATE(1353),
    [sym_block_quote] = STATE(1353),
    [sym__block_quote_content] = STATE(2008),
    [sym__block_quote_prefix] = STATE(91),
    [sym_link_reference_definition] = STATE(1353),
    [sym_block_attribute] = STATE(1353),
    [sym__paragraph] = STATE(1353),
    [sym__paragraph_content] = STATE(1959),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1110),
    [aux_sym__list_plus_repeat1] = STATE(1111),
    [aux_sym__list_star_repeat1] = STATE(1112),
    [aux_sym__list_task_repeat1] = STATE(1077),
    [aux_sym__list_definition_repeat1] = STATE(1377),
    [aux_sym__list_decimal_period_repeat1] = STATE(1114),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1115),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1116),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1117),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1118),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1119),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1120),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1121),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1122),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1123),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1124),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1125),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1126),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1127),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1128),
    [aux_sym_table_repeat1] = STATE(1031),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(663),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(665),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(667),
    [sym__block_quote_continuation] = ACTIONS(103),
    [sym__thematic_break_dash] = ACTIONS(669),
    [sym__thematic_break_star] = ACTIONS(669),
    [sym__footnote_mark_begin] = ACTIONS(671),
    [sym__link_ref_def_mark_begin] = ACTIONS(673),
    [sym__table_header_begin] = ACTIONS(675),
    [sym__table_separator_begin] = ACTIONS(677),
    [sym__table_row_begin] = ACTIONS(679),
    [sym__block_attribute_begin] = ACTIONS(681),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [74] = {
    [sym__block_element] = STATE(1353),
    [sym_heading] = STATE(1353),
    [sym_list] = STATE(1353),
    [sym__list_dash] = STATE(1895),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(1895),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(1895),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(1895),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(1895),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(1895),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(1895),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(1895),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(1895),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(1895),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(1895),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(1895),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(1895),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(1895),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(1895),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(1895),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(1895),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(1895),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(1895),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(1895),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(1353),
    [sym__table_row] = STATE(1031),
    [sym_table_header] = STATE(1031),
    [sym_table_separator] = STATE(1031),
    [sym_table_row] = STATE(1031),
    [sym_footnote] = STATE(1353),
    [sym_div] = STATE(1353),
    [sym__div_marker_begin] = STATE(2228),
    [sym_code_block] = STATE(1353),
    [sym_raw_block] = STATE(1353),
    [sym_thematic_break] = STATE(1353),
    [sym_block_quote] = STATE(1353),
    [sym__block_quote_content] = STATE(2301),
    [sym__block_quote_prefix] = STATE(91),
    [sym_link_reference_definition] = STATE(1353),
    [sym_block_attribute] = STATE(1353),
    [sym__paragraph] = STATE(1353),
    [sym__paragraph_content] = STATE(1959),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1110),
    [aux_sym__list_plus_repeat1] = STATE(1111),
    [aux_sym__list_star_repeat1] = STATE(1112),
    [aux_sym__list_task_repeat1] = STATE(1077),
    [aux_sym__list_definition_repeat1] = STATE(1377),
    [aux_sym__list_decimal_period_repeat1] = STATE(1114),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1115),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1116),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1117),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1118),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1119),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1120),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1121),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1122),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1123),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1124),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1125),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1126),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1127),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1128),
    [aux_sym_table_repeat1] = STATE(1031),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(663),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(665),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(667),
    [sym__block_quote_continuation] = ACTIONS(103),
    [sym__thematic_break_dash] = ACTIONS(669),
    [sym__thematic_break_star] = ACTIONS(669),
    [sym__footnote_mark_begin] = ACTIONS(671),
    [sym__link_ref_def_mark_begin] = ACTIONS(673),
    [sym__table_header_begin] = ACTIONS(675),
    [sym__table_separator_begin] = ACTIONS(677),
    [sym__table_row_begin] = ACTIONS(679),
    [sym__block_attribute_begin] = ACTIONS(681),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [75] = {
    [sym__block_element] = STATE(1580),
    [sym_heading] = STATE(1580),
    [sym_list] = STATE(1580),
    [sym__list_dash] = STATE(1430),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(1430),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(1430),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(1430),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(1430),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(1430),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(1430),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(1430),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(1430),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(1430),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(1430),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(1430),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(1430),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(1430),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(1430),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(1430),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(1430),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(1430),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(1430),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(1430),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(1580),
    [sym__table_row] = STATE(1030),
    [sym_table_header] = STATE(1030),
    [sym_table_separator] = STATE(1030),
    [sym_table_row] = STATE(1030),
    [sym_footnote] = STATE(1580),
    [sym_div] = STATE(1580),
    [sym__div_marker_begin] = STATE(2287),
    [sym_code_block] = STATE(1580),
    [sym_raw_block] = STATE(1580),
    [sym_thematic_break] = STATE(1580),
    [sym_block_quote] = STATE(1580),
    [sym__block_quote_prefix] = STATE(95),
    [sym_link_reference_definition] = STATE(1580),
    [sym_block_attribute] = STATE(1580),
    [sym__paragraph] = STATE(1580),
    [sym__paragraph_content] = STATE(1715),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1166),
    [aux_sym__list_plus_repeat1] = STATE(1167),
    [aux_sym__list_star_repeat1] = STATE(1168),
    [aux_sym__list_task_repeat1] = STATE(1091),
    [aux_sym__list_definition_repeat1] = STATE(1373),
    [aux_sym__list_decimal_period_repeat1] = STATE(1170),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1171),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1172),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1173),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1174),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1175),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1102),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1177),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1243),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1179),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1180),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1181),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1182),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1183),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1184),
    [aux_sym_table_repeat1] = STATE(1030),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(655),
    [sym__whitespace1] = ACTIONS(657),
    [sym_quotation_marks] = ACTIONS(657),
    [sym_ellipsis] = ACTIONS(657),
    [sym_em_dash] = ACTIONS(657),
    [sym_en_dash] = ACTIONS(655),
    [sym_backslash_escape] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(657),
    [sym_symbol] = ACTIONS(657),
    [anon_sym_LBRACE_] = ACTIONS(657),
    [anon_sym__] = ACTIONS(657),
    [anon_sym_LBRACE_STAR] = ACTIONS(657),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_LBRACE_CARET] = ACTIONS(657),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_LBRACE_TILDE] = ACTIONS(657),
    [anon_sym_TILDE] = ACTIONS(657),
    [anon_sym_LBRACE_EQ] = ACTIONS(657),
    [anon_sym_LBRACE_PLUS] = ACTIONS(657),
    [anon_sym_LBRACE_DASH] = ACTIONS(657),
    [anon_sym_LBRACK_CARET] = ACTIONS(657),
    [anon_sym_BANG_LBRACK] = ACTIONS(657),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(657),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_DOLLAR] = ACTIONS(657),
    [anon_sym_TODO] = ACTIONS(657),
    [anon_sym_WIP] = ACTIONS(657),
    [anon_sym_NOTE] = ACTIONS(657),
    [anon_sym_INFO] = ACTIONS(657),
    [anon_sym_XXX] = ACTIONS(657),
    [sym_fixme] = ACTIONS(657),
    [aux_sym__text_token1] = ACTIONS(655),
    [sym__newline] = ACTIONS(683),
    [sym__newline_inline] = ACTIONS(657),
    [sym_hard_line_break] = ACTIONS(657),
    [sym__heading_begin] = ACTIONS(625),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(627),
    [sym_list_marker_dash] = ACTIONS(657),
    [sym_list_marker_star] = ACTIONS(657),
    [sym_list_marker_plus] = ACTIONS(657),
    [sym__list_marker_task_begin] = ACTIONS(657),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(657),
    [sym_list_marker_lower_alpha_period] = ACTIONS(657),
    [sym_list_marker_upper_alpha_period] = ACTIONS(657),
    [sym_list_marker_lower_roman_period] = ACTIONS(657),
    [sym_list_marker_upper_roman_period] = ACTIONS(657),
    [sym_list_marker_decimal_paren] = ACTIONS(657),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(657),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(657),
    [sym_list_marker_lower_roman_paren] = ACTIONS(657),
    [sym_list_marker_upper_roman_paren] = ACTIONS(657),
    [sym_list_marker_decimal_parens] = ACTIONS(657),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(657),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(657),
    [sym_list_marker_lower_roman_parens] = ACTIONS(657),
    [sym_list_marker_upper_roman_parens] = ACTIONS(657),
    [sym__block_quote_begin] = ACTIONS(629),
    [sym__block_quote_continuation] = ACTIONS(657),
    [sym__thematic_break_dash] = ACTIONS(633),
    [sym__thematic_break_star] = ACTIONS(633),
    [sym__footnote_mark_begin] = ACTIONS(635),
    [sym__link_ref_def_mark_begin] = ACTIONS(637),
    [sym__table_header_begin] = ACTIONS(657),
    [sym__table_separator_begin] = ACTIONS(657),
    [sym__table_row_begin] = ACTIONS(657),
    [sym__block_attribute_begin] = ACTIONS(645),
    [sym__verbatim_begin] = ACTIONS(657),
  },
  [76] = {
    [sym__block_element] = STATE(2037),
    [sym_heading] = STATE(2037),
    [sym_list] = STATE(2037),
    [sym__list_dash] = STATE(2040),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(2040),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(2040),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(2040),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(2040),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(2040),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(2040),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(2040),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(2040),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(2040),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(2040),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(2040),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(2040),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(2040),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(2040),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(2040),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(2040),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(2040),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(2040),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(2040),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(2037),
    [sym__table_row] = STATE(1033),
    [sym_table_header] = STATE(1033),
    [sym_table_separator] = STATE(1033),
    [sym_table_row] = STATE(1033),
    [sym_footnote] = STATE(2037),
    [sym_div] = STATE(2037),
    [sym__div_marker_begin] = STATE(2196),
    [sym_code_block] = STATE(2037),
    [sym_raw_block] = STATE(2037),
    [sym_thematic_break] = STATE(2037),
    [sym_block_quote] = STATE(2037),
    [sym__block_quote_prefix] = STATE(94),
    [sym_link_reference_definition] = STATE(2037),
    [sym_block_attribute] = STATE(2037),
    [sym__paragraph] = STATE(2037),
    [sym__paragraph_content] = STATE(1891),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1194),
    [aux_sym__list_plus_repeat1] = STATE(1195),
    [aux_sym__list_star_repeat1] = STATE(1196),
    [aux_sym__list_task_repeat1] = STATE(1080),
    [aux_sym__list_definition_repeat1] = STATE(1359),
    [aux_sym__list_decimal_period_repeat1] = STATE(1198),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1199),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1200),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1201),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1202),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1203),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1208),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1209),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1211),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1213),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1214),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1215),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1219),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1220),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1222),
    [aux_sym_table_repeat1] = STATE(1033),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(655),
    [sym__whitespace1] = ACTIONS(657),
    [sym_quotation_marks] = ACTIONS(657),
    [sym_ellipsis] = ACTIONS(657),
    [sym_em_dash] = ACTIONS(657),
    [sym_en_dash] = ACTIONS(655),
    [sym_backslash_escape] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(657),
    [sym_symbol] = ACTIONS(657),
    [anon_sym_LBRACE_] = ACTIONS(657),
    [anon_sym__] = ACTIONS(657),
    [anon_sym_LBRACE_STAR] = ACTIONS(657),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_LBRACE_CARET] = ACTIONS(657),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_LBRACE_TILDE] = ACTIONS(657),
    [anon_sym_TILDE] = ACTIONS(657),
    [anon_sym_LBRACE_EQ] = ACTIONS(657),
    [anon_sym_LBRACE_PLUS] = ACTIONS(657),
    [anon_sym_LBRACE_DASH] = ACTIONS(657),
    [anon_sym_LBRACK_CARET] = ACTIONS(657),
    [anon_sym_BANG_LBRACK] = ACTIONS(657),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(657),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_DOLLAR] = ACTIONS(657),
    [anon_sym_TODO] = ACTIONS(657),
    [anon_sym_WIP] = ACTIONS(657),
    [anon_sym_NOTE] = ACTIONS(657),
    [anon_sym_INFO] = ACTIONS(657),
    [anon_sym_XXX] = ACTIONS(657),
    [sym_fixme] = ACTIONS(657),
    [aux_sym__text_token1] = ACTIONS(655),
    [sym__newline] = ACTIONS(685),
    [sym__newline_inline] = ACTIONS(657),
    [sym_hard_line_break] = ACTIONS(657),
    [sym__heading_begin] = ACTIONS(555),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(557),
    [sym_list_marker_dash] = ACTIONS(657),
    [sym_list_marker_star] = ACTIONS(657),
    [sym_list_marker_plus] = ACTIONS(657),
    [sym__list_marker_task_begin] = ACTIONS(657),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(657),
    [sym_list_marker_lower_alpha_period] = ACTIONS(657),
    [sym_list_marker_upper_alpha_period] = ACTIONS(657),
    [sym_list_marker_lower_roman_period] = ACTIONS(657),
    [sym_list_marker_upper_roman_period] = ACTIONS(657),
    [sym_list_marker_decimal_paren] = ACTIONS(657),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(657),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(657),
    [sym_list_marker_lower_roman_paren] = ACTIONS(657),
    [sym_list_marker_upper_roman_paren] = ACTIONS(657),
    [sym_list_marker_decimal_parens] = ACTIONS(657),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(657),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(657),
    [sym_list_marker_lower_roman_parens] = ACTIONS(657),
    [sym_list_marker_upper_roman_parens] = ACTIONS(657),
    [sym__block_quote_begin] = ACTIONS(559),
    [sym__block_quote_continuation] = ACTIONS(657),
    [sym__thematic_break_dash] = ACTIONS(563),
    [sym__thematic_break_star] = ACTIONS(563),
    [sym__footnote_mark_begin] = ACTIONS(565),
    [sym__link_ref_def_mark_begin] = ACTIONS(567),
    [sym__table_header_begin] = ACTIONS(657),
    [sym__table_separator_begin] = ACTIONS(657),
    [sym__table_row_begin] = ACTIONS(657),
    [sym__block_attribute_begin] = ACTIONS(575),
    [sym__verbatim_begin] = ACTIONS(657),
  },
  [77] = {
    [sym__block_element] = STATE(1353),
    [sym_heading] = STATE(1353),
    [sym_list] = STATE(1353),
    [sym__list_dash] = STATE(1895),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(1895),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(1895),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(1895),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(1895),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(1895),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(1895),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(1895),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(1895),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(1895),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(1895),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(1895),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(1895),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(1895),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(1895),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(1895),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(1895),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(1895),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(1895),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(1895),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(1353),
    [sym__table_row] = STATE(1031),
    [sym_table_header] = STATE(1031),
    [sym_table_separator] = STATE(1031),
    [sym_table_row] = STATE(1031),
    [sym_footnote] = STATE(1353),
    [sym_div] = STATE(1353),
    [sym__div_marker_begin] = STATE(2228),
    [sym_code_block] = STATE(1353),
    [sym_raw_block] = STATE(1353),
    [sym_thematic_break] = STATE(1353),
    [sym_block_quote] = STATE(1353),
    [sym__block_quote_content] = STATE(2086),
    [sym__block_quote_prefix] = STATE(91),
    [sym_link_reference_definition] = STATE(1353),
    [sym_block_attribute] = STATE(1353),
    [sym__paragraph] = STATE(1353),
    [sym__paragraph_content] = STATE(1959),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1110),
    [aux_sym__list_plus_repeat1] = STATE(1111),
    [aux_sym__list_star_repeat1] = STATE(1112),
    [aux_sym__list_task_repeat1] = STATE(1077),
    [aux_sym__list_definition_repeat1] = STATE(1377),
    [aux_sym__list_decimal_period_repeat1] = STATE(1114),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1115),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1116),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1117),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1118),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1119),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1120),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1121),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1122),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1123),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1124),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1125),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1126),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1127),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1128),
    [aux_sym_table_repeat1] = STATE(1031),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(663),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(665),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(667),
    [sym__block_quote_continuation] = ACTIONS(103),
    [sym__thematic_break_dash] = ACTIONS(669),
    [sym__thematic_break_star] = ACTIONS(669),
    [sym__footnote_mark_begin] = ACTIONS(671),
    [sym__link_ref_def_mark_begin] = ACTIONS(673),
    [sym__table_header_begin] = ACTIONS(675),
    [sym__table_separator_begin] = ACTIONS(677),
    [sym__table_row_begin] = ACTIONS(679),
    [sym__block_attribute_begin] = ACTIONS(681),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [78] = {
    [sym__block_element] = STATE(1353),
    [sym_heading] = STATE(1353),
    [sym_list] = STATE(1353),
    [sym__list_dash] = STATE(1895),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(1895),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(1895),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(1895),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(1895),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(1895),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(1895),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(1895),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(1895),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(1895),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(1895),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(1895),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(1895),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(1895),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(1895),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(1895),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(1895),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(1895),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(1895),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(1895),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(1353),
    [sym__table_row] = STATE(1031),
    [sym_table_header] = STATE(1031),
    [sym_table_separator] = STATE(1031),
    [sym_table_row] = STATE(1031),
    [sym_footnote] = STATE(1353),
    [sym_div] = STATE(1353),
    [sym__div_marker_begin] = STATE(2228),
    [sym_code_block] = STATE(1353),
    [sym_raw_block] = STATE(1353),
    [sym_thematic_break] = STATE(1353),
    [sym_block_quote] = STATE(1353),
    [sym__block_quote_content] = STATE(2426),
    [sym__block_quote_prefix] = STATE(91),
    [sym_link_reference_definition] = STATE(1353),
    [sym_block_attribute] = STATE(1353),
    [sym__paragraph] = STATE(1353),
    [sym__paragraph_content] = STATE(1959),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1110),
    [aux_sym__list_plus_repeat1] = STATE(1111),
    [aux_sym__list_star_repeat1] = STATE(1112),
    [aux_sym__list_task_repeat1] = STATE(1077),
    [aux_sym__list_definition_repeat1] = STATE(1377),
    [aux_sym__list_decimal_period_repeat1] = STATE(1114),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1115),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1116),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1117),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1118),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1119),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1120),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1121),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1122),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1123),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1124),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1125),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1126),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1127),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1128),
    [aux_sym_table_repeat1] = STATE(1031),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(663),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(665),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(667),
    [sym__block_quote_continuation] = ACTIONS(103),
    [sym__thematic_break_dash] = ACTIONS(669),
    [sym__thematic_break_star] = ACTIONS(669),
    [sym__footnote_mark_begin] = ACTIONS(671),
    [sym__link_ref_def_mark_begin] = ACTIONS(673),
    [sym__table_header_begin] = ACTIONS(675),
    [sym__table_separator_begin] = ACTIONS(677),
    [sym__table_row_begin] = ACTIONS(679),
    [sym__block_attribute_begin] = ACTIONS(681),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [79] = {
    [sym__block_element] = STATE(1353),
    [sym_heading] = STATE(1353),
    [sym_list] = STATE(1353),
    [sym__list_dash] = STATE(1895),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(1895),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(1895),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(1895),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(1895),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(1895),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(1895),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(1895),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(1895),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(1895),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(1895),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(1895),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(1895),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(1895),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(1895),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(1895),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(1895),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(1895),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(1895),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(1895),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(1353),
    [sym__table_row] = STATE(1031),
    [sym_table_header] = STATE(1031),
    [sym_table_separator] = STATE(1031),
    [sym_table_row] = STATE(1031),
    [sym_footnote] = STATE(1353),
    [sym_div] = STATE(1353),
    [sym__div_marker_begin] = STATE(2228),
    [sym_code_block] = STATE(1353),
    [sym_raw_block] = STATE(1353),
    [sym_thematic_break] = STATE(1353),
    [sym_block_quote] = STATE(1353),
    [sym__block_quote_content] = STATE(2148),
    [sym__block_quote_prefix] = STATE(91),
    [sym_link_reference_definition] = STATE(1353),
    [sym_block_attribute] = STATE(1353),
    [sym__paragraph] = STATE(1353),
    [sym__paragraph_content] = STATE(1959),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1110),
    [aux_sym__list_plus_repeat1] = STATE(1111),
    [aux_sym__list_star_repeat1] = STATE(1112),
    [aux_sym__list_task_repeat1] = STATE(1077),
    [aux_sym__list_definition_repeat1] = STATE(1377),
    [aux_sym__list_decimal_period_repeat1] = STATE(1114),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1115),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1116),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1117),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1118),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1119),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1120),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1121),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1122),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1123),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1124),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1125),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1126),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1127),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1128),
    [aux_sym_table_repeat1] = STATE(1031),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__heading_begin] = ACTIONS(663),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(665),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(667),
    [sym__block_quote_continuation] = ACTIONS(103),
    [sym__thematic_break_dash] = ACTIONS(669),
    [sym__thematic_break_star] = ACTIONS(669),
    [sym__footnote_mark_begin] = ACTIONS(671),
    [sym__link_ref_def_mark_begin] = ACTIONS(673),
    [sym__table_header_begin] = ACTIONS(675),
    [sym__table_separator_begin] = ACTIONS(677),
    [sym__table_row_begin] = ACTIONS(679),
    [sym__block_attribute_begin] = ACTIONS(681),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [80] = {
    [sym__block_element] = STATE(1742),
    [sym_list] = STATE(1742),
    [sym__list_dash] = STATE(1895),
    [sym__list_item_dash] = STATE(1442),
    [sym__list_plus] = STATE(1895),
    [sym__list_item_plus] = STATE(1464),
    [sym__list_star] = STATE(1895),
    [sym__list_item_star] = STATE(1550),
    [sym__list_task] = STATE(1895),
    [sym__list_item_task] = STATE(1528),
    [sym_list_marker_task] = STATE(56),
    [sym__list_definition] = STATE(1895),
    [sym__list_item_definition] = STATE(1873),
    [sym__list_decimal_period] = STATE(1895),
    [sym__list_item_decimal_period] = STATE(1559),
    [sym__list_decimal_paren] = STATE(1895),
    [sym__list_item_decimal_paren] = STATE(1526),
    [sym__list_decimal_parens] = STATE(1895),
    [sym__list_item_decimal_parens] = STATE(1545),
    [sym__list_lower_alpha_period] = STATE(1895),
    [sym__list_item_lower_alpha_period] = STATE(1568),
    [sym__list_lower_alpha_paren] = STATE(1895),
    [sym__list_item_lower_alpha_paren] = STATE(1627),
    [sym__list_lower_alpha_parens] = STATE(1895),
    [sym__list_item_lower_alpha_parens] = STATE(1416),
    [sym__list_upper_alpha_period] = STATE(1895),
    [sym__list_item_upper_alpha_period] = STATE(1418),
    [sym__list_upper_alpha_paren] = STATE(1895),
    [sym__list_item_upper_alpha_paren] = STATE(1616),
    [sym__list_upper_alpha_parens] = STATE(1895),
    [sym__list_item_upper_alpha_parens] = STATE(1628),
    [sym__list_lower_roman_period] = STATE(1895),
    [sym__list_item_lower_roman_period] = STATE(1425),
    [sym__list_lower_roman_paren] = STATE(1895),
    [sym__list_item_lower_roman_paren] = STATE(1410),
    [sym__list_lower_roman_parens] = STATE(1895),
    [sym__list_item_lower_roman_parens] = STATE(1510),
    [sym__list_upper_roman_period] = STATE(1895),
    [sym__list_item_upper_roman_period] = STATE(1547),
    [sym__list_upper_roman_paren] = STATE(1895),
    [sym__list_item_upper_roman_paren] = STATE(1598),
    [sym__list_upper_roman_parens] = STATE(1895),
    [sym__list_item_upper_roman_parens] = STATE(1419),
    [sym_table] = STATE(1742),
    [sym__table_row] = STATE(1031),
    [sym_table_header] = STATE(1031),
    [sym_table_separator] = STATE(1031),
    [sym_table_row] = STATE(1031),
    [sym_footnote] = STATE(1742),
    [sym_div] = STATE(1742),
    [sym__div_marker_begin] = STATE(2228),
    [sym_code_block] = STATE(1742),
    [sym_raw_block] = STATE(1742),
    [sym_thematic_break] = STATE(1742),
    [sym_block_quote] = STATE(1742),
    [sym__block_quote_prefix] = STATE(91),
    [sym_link_reference_definition] = STATE(1742),
    [sym_block_attribute] = STATE(1742),
    [sym__paragraph] = STATE(1742),
    [sym__paragraph_content] = STATE(1959),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__list_dash_repeat1] = STATE(1110),
    [aux_sym__list_plus_repeat1] = STATE(1111),
    [aux_sym__list_star_repeat1] = STATE(1112),
    [aux_sym__list_task_repeat1] = STATE(1077),
    [aux_sym__list_definition_repeat1] = STATE(1377),
    [aux_sym__list_decimal_period_repeat1] = STATE(1114),
    [aux_sym__list_decimal_paren_repeat1] = STATE(1115),
    [aux_sym__list_decimal_parens_repeat1] = STATE(1116),
    [aux_sym__list_lower_alpha_period_repeat1] = STATE(1117),
    [aux_sym__list_lower_alpha_paren_repeat1] = STATE(1118),
    [aux_sym__list_lower_alpha_parens_repeat1] = STATE(1119),
    [aux_sym__list_upper_alpha_period_repeat1] = STATE(1120),
    [aux_sym__list_upper_alpha_paren_repeat1] = STATE(1121),
    [aux_sym__list_upper_alpha_parens_repeat1] = STATE(1122),
    [aux_sym__list_lower_roman_period_repeat1] = STATE(1123),
    [aux_sym__list_lower_roman_paren_repeat1] = STATE(1124),
    [aux_sym__list_lower_roman_parens_repeat1] = STATE(1125),
    [aux_sym__list_upper_roman_period_repeat1] = STATE(1126),
    [aux_sym__list_upper_roman_paren_repeat1] = STATE(1127),
    [aux_sym__list_upper_roman_parens_repeat1] = STATE(1128),
    [aux_sym_table_repeat1] = STATE(1031),
    [aux_sym__block_quote_prefix_repeat1] = STATE(434),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(687),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__div_begin] = ACTIONS(57),
    [sym__code_block_begin] = ACTIONS(665),
    [sym_list_marker_dash] = ACTIONS(61),
    [sym_list_marker_star] = ACTIONS(63),
    [sym_list_marker_plus] = ACTIONS(65),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_definition] = ACTIONS(69),
    [sym_list_marker_decimal_period] = ACTIONS(71),
    [sym_list_marker_lower_alpha_period] = ACTIONS(73),
    [sym_list_marker_upper_alpha_period] = ACTIONS(75),
    [sym_list_marker_lower_roman_period] = ACTIONS(77),
    [sym_list_marker_upper_roman_period] = ACTIONS(79),
    [sym_list_marker_decimal_paren] = ACTIONS(81),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(83),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(85),
    [sym_list_marker_lower_roman_paren] = ACTIONS(87),
    [sym_list_marker_upper_roman_paren] = ACTIONS(89),
    [sym_list_marker_decimal_parens] = ACTIONS(91),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(93),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(95),
    [sym_list_marker_lower_roman_parens] = ACTIONS(97),
    [sym_list_marker_upper_roman_parens] = ACTIONS(99),
    [sym__block_quote_begin] = ACTIONS(667),
    [sym__block_quote_continuation] = ACTIONS(689),
    [sym__thematic_break_dash] = ACTIONS(669),
    [sym__thematic_break_star] = ACTIONS(669),
    [sym__footnote_mark_begin] = ACTIONS(671),
    [sym__link_ref_def_mark_begin] = ACTIONS(673),
    [sym__table_header_begin] = ACTIONS(675),
    [sym__table_separator_begin] = ACTIONS(677),
    [sym__table_row_begin] = ACTIONS(679),
    [sym__block_attribute_begin] = ACTIONS(681),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [81] = {
    [sym_list_marker_task] = STATE(41),
    [sym_table_header] = STATE(301),
    [sym_table_separator] = STATE(301),
    [sym_table_row] = STATE(301),
    [sym__inline] = STATE(1415),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(692),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym_list_marker_dash] = ACTIONS(694),
    [sym_list_marker_star] = ACTIONS(696),
    [sym_list_marker_plus] = ACTIONS(698),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_decimal_period] = ACTIONS(700),
    [sym_list_marker_lower_alpha_period] = ACTIONS(702),
    [sym_list_marker_upper_alpha_period] = ACTIONS(704),
    [sym_list_marker_lower_roman_period] = ACTIONS(706),
    [sym_list_marker_upper_roman_period] = ACTIONS(708),
    [sym_list_marker_decimal_paren] = ACTIONS(710),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(712),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(714),
    [sym_list_marker_lower_roman_paren] = ACTIONS(716),
    [sym_list_marker_upper_roman_paren] = ACTIONS(718),
    [sym_list_marker_decimal_parens] = ACTIONS(720),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(722),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(724),
    [sym_list_marker_lower_roman_parens] = ACTIONS(726),
    [sym_list_marker_upper_roman_parens] = ACTIONS(728),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [82] = {
    [sym_list_marker_task] = STATE(41),
    [sym_table_header] = STATE(301),
    [sym_table_separator] = STATE(301),
    [sym_table_row] = STATE(301),
    [sym__inline] = STATE(1415),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(730),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym_list_marker_dash] = ACTIONS(694),
    [sym_list_marker_star] = ACTIONS(696),
    [sym_list_marker_plus] = ACTIONS(698),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_decimal_period] = ACTIONS(700),
    [sym_list_marker_lower_alpha_period] = ACTIONS(702),
    [sym_list_marker_upper_alpha_period] = ACTIONS(704),
    [sym_list_marker_lower_roman_period] = ACTIONS(706),
    [sym_list_marker_upper_roman_period] = ACTIONS(708),
    [sym_list_marker_decimal_paren] = ACTIONS(710),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(712),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(714),
    [sym_list_marker_lower_roman_paren] = ACTIONS(716),
    [sym_list_marker_upper_roman_paren] = ACTIONS(718),
    [sym_list_marker_decimal_parens] = ACTIONS(720),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(722),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(724),
    [sym_list_marker_lower_roman_parens] = ACTIONS(726),
    [sym_list_marker_upper_roman_parens] = ACTIONS(728),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [83] = {
    [sym_list_marker_task] = STATE(41),
    [sym_table_header] = STATE(301),
    [sym_table_separator] = STATE(301),
    [sym_table_row] = STATE(301),
    [sym__inline] = STATE(1415),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(732),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym_list_marker_dash] = ACTIONS(694),
    [sym_list_marker_star] = ACTIONS(696),
    [sym_list_marker_plus] = ACTIONS(698),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_decimal_period] = ACTIONS(700),
    [sym_list_marker_lower_alpha_period] = ACTIONS(702),
    [sym_list_marker_upper_alpha_period] = ACTIONS(704),
    [sym_list_marker_lower_roman_period] = ACTIONS(706),
    [sym_list_marker_upper_roman_period] = ACTIONS(708),
    [sym_list_marker_decimal_paren] = ACTIONS(710),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(712),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(714),
    [sym_list_marker_lower_roman_paren] = ACTIONS(716),
    [sym_list_marker_upper_roman_paren] = ACTIONS(718),
    [sym_list_marker_decimal_parens] = ACTIONS(720),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(722),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(724),
    [sym_list_marker_lower_roman_parens] = ACTIONS(726),
    [sym_list_marker_upper_roman_parens] = ACTIONS(728),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [84] = {
    [sym_list_marker_task] = STATE(41),
    [sym_table_header] = STATE(301),
    [sym_table_separator] = STATE(301),
    [sym_table_row] = STATE(301),
    [sym__inline] = STATE(1415),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(734),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym_list_marker_dash] = ACTIONS(694),
    [sym_list_marker_star] = ACTIONS(696),
    [sym_list_marker_plus] = ACTIONS(698),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_decimal_period] = ACTIONS(700),
    [sym_list_marker_lower_alpha_period] = ACTIONS(702),
    [sym_list_marker_upper_alpha_period] = ACTIONS(704),
    [sym_list_marker_lower_roman_period] = ACTIONS(706),
    [sym_list_marker_upper_roman_period] = ACTIONS(708),
    [sym_list_marker_decimal_paren] = ACTIONS(710),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(712),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(714),
    [sym_list_marker_lower_roman_paren] = ACTIONS(716),
    [sym_list_marker_upper_roman_paren] = ACTIONS(718),
    [sym_list_marker_decimal_parens] = ACTIONS(720),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(722),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(724),
    [sym_list_marker_lower_roman_parens] = ACTIONS(726),
    [sym_list_marker_upper_roman_parens] = ACTIONS(728),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [85] = {
    [sym_list_marker_task] = STATE(41),
    [sym_table_header] = STATE(301),
    [sym_table_separator] = STATE(301),
    [sym_table_row] = STATE(301),
    [sym__inline] = STATE(1415),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(736),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym_list_marker_dash] = ACTIONS(694),
    [sym_list_marker_star] = ACTIONS(696),
    [sym_list_marker_plus] = ACTIONS(698),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_decimal_period] = ACTIONS(700),
    [sym_list_marker_lower_alpha_period] = ACTIONS(702),
    [sym_list_marker_upper_alpha_period] = ACTIONS(704),
    [sym_list_marker_lower_roman_period] = ACTIONS(706),
    [sym_list_marker_upper_roman_period] = ACTIONS(708),
    [sym_list_marker_decimal_paren] = ACTIONS(710),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(712),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(714),
    [sym_list_marker_lower_roman_paren] = ACTIONS(716),
    [sym_list_marker_upper_roman_paren] = ACTIONS(718),
    [sym_list_marker_decimal_parens] = ACTIONS(720),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(722),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(724),
    [sym_list_marker_lower_roman_parens] = ACTIONS(726),
    [sym_list_marker_upper_roman_parens] = ACTIONS(728),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [86] = {
    [sym_list_marker_task] = STATE(41),
    [sym_table_header] = STATE(301),
    [sym_table_separator] = STATE(301),
    [sym_table_row] = STATE(301),
    [sym__inline] = STATE(1415),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(738),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym_list_marker_dash] = ACTIONS(694),
    [sym_list_marker_star] = ACTIONS(696),
    [sym_list_marker_plus] = ACTIONS(698),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_decimal_period] = ACTIONS(700),
    [sym_list_marker_lower_alpha_period] = ACTIONS(702),
    [sym_list_marker_upper_alpha_period] = ACTIONS(704),
    [sym_list_marker_lower_roman_period] = ACTIONS(706),
    [sym_list_marker_upper_roman_period] = ACTIONS(708),
    [sym_list_marker_decimal_paren] = ACTIONS(710),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(712),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(714),
    [sym_list_marker_lower_roman_paren] = ACTIONS(716),
    [sym_list_marker_upper_roman_paren] = ACTIONS(718),
    [sym_list_marker_decimal_parens] = ACTIONS(720),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(722),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(724),
    [sym_list_marker_lower_roman_parens] = ACTIONS(726),
    [sym_list_marker_upper_roman_parens] = ACTIONS(728),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [87] = {
    [sym_list_marker_task] = STATE(41),
    [sym_table_header] = STATE(301),
    [sym_table_separator] = STATE(301),
    [sym_table_row] = STATE(301),
    [sym__inline] = STATE(1415),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(740),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym_list_marker_dash] = ACTIONS(694),
    [sym_list_marker_star] = ACTIONS(696),
    [sym_list_marker_plus] = ACTIONS(698),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_decimal_period] = ACTIONS(700),
    [sym_list_marker_lower_alpha_period] = ACTIONS(702),
    [sym_list_marker_upper_alpha_period] = ACTIONS(704),
    [sym_list_marker_lower_roman_period] = ACTIONS(706),
    [sym_list_marker_upper_roman_period] = ACTIONS(708),
    [sym_list_marker_decimal_paren] = ACTIONS(710),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(712),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(714),
    [sym_list_marker_lower_roman_paren] = ACTIONS(716),
    [sym_list_marker_upper_roman_paren] = ACTIONS(718),
    [sym_list_marker_decimal_parens] = ACTIONS(720),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(722),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(724),
    [sym_list_marker_lower_roman_parens] = ACTIONS(726),
    [sym_list_marker_upper_roman_parens] = ACTIONS(728),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [88] = {
    [sym_list_marker_task] = STATE(41),
    [sym_table_header] = STATE(301),
    [sym_table_separator] = STATE(301),
    [sym_table_row] = STATE(301),
    [sym__inline] = STATE(1415),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(742),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym_list_marker_dash] = ACTIONS(694),
    [sym_list_marker_star] = ACTIONS(696),
    [sym_list_marker_plus] = ACTIONS(698),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_decimal_period] = ACTIONS(700),
    [sym_list_marker_lower_alpha_period] = ACTIONS(702),
    [sym_list_marker_upper_alpha_period] = ACTIONS(704),
    [sym_list_marker_lower_roman_period] = ACTIONS(706),
    [sym_list_marker_upper_roman_period] = ACTIONS(708),
    [sym_list_marker_decimal_paren] = ACTIONS(710),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(712),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(714),
    [sym_list_marker_lower_roman_paren] = ACTIONS(716),
    [sym_list_marker_upper_roman_paren] = ACTIONS(718),
    [sym_list_marker_decimal_parens] = ACTIONS(720),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(722),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(724),
    [sym_list_marker_lower_roman_parens] = ACTIONS(726),
    [sym_list_marker_upper_roman_parens] = ACTIONS(728),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [89] = {
    [sym_list_marker_task] = STATE(41),
    [sym_table_header] = STATE(301),
    [sym_table_separator] = STATE(301),
    [sym_table_row] = STATE(301),
    [sym__inline] = STATE(1415),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(744),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym_list_marker_dash] = ACTIONS(694),
    [sym_list_marker_star] = ACTIONS(696),
    [sym_list_marker_plus] = ACTIONS(698),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_decimal_period] = ACTIONS(700),
    [sym_list_marker_lower_alpha_period] = ACTIONS(702),
    [sym_list_marker_upper_alpha_period] = ACTIONS(704),
    [sym_list_marker_lower_roman_period] = ACTIONS(706),
    [sym_list_marker_upper_roman_period] = ACTIONS(708),
    [sym_list_marker_decimal_paren] = ACTIONS(710),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(712),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(714),
    [sym_list_marker_lower_roman_paren] = ACTIONS(716),
    [sym_list_marker_upper_roman_paren] = ACTIONS(718),
    [sym_list_marker_decimal_parens] = ACTIONS(720),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(722),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(724),
    [sym_list_marker_lower_roman_parens] = ACTIONS(726),
    [sym_list_marker_upper_roman_parens] = ACTIONS(728),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [90] = {
    [sym_list_marker_task] = STATE(41),
    [sym_table_header] = STATE(301),
    [sym_table_separator] = STATE(301),
    [sym_table_row] = STATE(301),
    [sym__inline] = STATE(1415),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__block_close] = ACTIONS(746),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym_list_marker_dash] = ACTIONS(694),
    [sym_list_marker_star] = ACTIONS(696),
    [sym_list_marker_plus] = ACTIONS(698),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_decimal_period] = ACTIONS(700),
    [sym_list_marker_lower_alpha_period] = ACTIONS(702),
    [sym_list_marker_upper_alpha_period] = ACTIONS(704),
    [sym_list_marker_lower_roman_period] = ACTIONS(706),
    [sym_list_marker_upper_roman_period] = ACTIONS(708),
    [sym_list_marker_decimal_paren] = ACTIONS(710),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(712),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(714),
    [sym_list_marker_lower_roman_paren] = ACTIONS(716),
    [sym_list_marker_upper_roman_paren] = ACTIONS(718),
    [sym_list_marker_decimal_parens] = ACTIONS(720),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(722),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(724),
    [sym_list_marker_lower_roman_parens] = ACTIONS(726),
    [sym_list_marker_upper_roman_parens] = ACTIONS(728),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [91] = {
    [sym_list_marker_task] = STATE(41),
    [sym_table_header] = STATE(1229),
    [sym_table_separator] = STATE(1229),
    [sym_table_row] = STATE(1229),
    [sym__inline] = STATE(1415),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym_list_marker_dash] = ACTIONS(694),
    [sym_list_marker_star] = ACTIONS(696),
    [sym_list_marker_plus] = ACTIONS(698),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_decimal_period] = ACTIONS(700),
    [sym_list_marker_lower_alpha_period] = ACTIONS(702),
    [sym_list_marker_upper_alpha_period] = ACTIONS(704),
    [sym_list_marker_lower_roman_period] = ACTIONS(706),
    [sym_list_marker_upper_roman_period] = ACTIONS(708),
    [sym_list_marker_decimal_paren] = ACTIONS(710),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(712),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(714),
    [sym_list_marker_lower_roman_paren] = ACTIONS(716),
    [sym_list_marker_upper_roman_paren] = ACTIONS(718),
    [sym_list_marker_decimal_parens] = ACTIONS(720),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(722),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(724),
    [sym_list_marker_lower_roman_parens] = ACTIONS(726),
    [sym_list_marker_upper_roman_parens] = ACTIONS(728),
    [sym__table_header_begin] = ACTIONS(675),
    [sym__table_separator_begin] = ACTIONS(677),
    [sym__table_row_begin] = ACTIONS(679),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [92] = {
    [sym_list_marker_task] = STATE(41),
    [sym_table_header] = STATE(291),
    [sym_table_separator] = STATE(291),
    [sym_table_row] = STATE(291),
    [sym__inline] = STATE(1415),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym_list_marker_dash] = ACTIONS(694),
    [sym_list_marker_star] = ACTIONS(696),
    [sym_list_marker_plus] = ACTIONS(698),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_decimal_period] = ACTIONS(700),
    [sym_list_marker_lower_alpha_period] = ACTIONS(702),
    [sym_list_marker_upper_alpha_period] = ACTIONS(704),
    [sym_list_marker_lower_roman_period] = ACTIONS(706),
    [sym_list_marker_upper_roman_period] = ACTIONS(708),
    [sym_list_marker_decimal_paren] = ACTIONS(710),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(712),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(714),
    [sym_list_marker_lower_roman_paren] = ACTIONS(716),
    [sym_list_marker_upper_roman_paren] = ACTIONS(718),
    [sym_list_marker_decimal_parens] = ACTIONS(720),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(722),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(724),
    [sym_list_marker_lower_roman_parens] = ACTIONS(726),
    [sym_list_marker_upper_roman_parens] = ACTIONS(728),
    [sym__table_header_begin] = ACTIONS(111),
    [sym__table_separator_begin] = ACTIONS(113),
    [sym__table_row_begin] = ACTIONS(115),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [93] = {
    [sym_list_marker_task] = STATE(41),
    [sym_table_header] = STATE(301),
    [sym_table_separator] = STATE(301),
    [sym_table_row] = STATE(301),
    [sym__inline] = STATE(1415),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym_list_marker_dash] = ACTIONS(694),
    [sym_list_marker_star] = ACTIONS(696),
    [sym_list_marker_plus] = ACTIONS(698),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_decimal_period] = ACTIONS(700),
    [sym_list_marker_lower_alpha_period] = ACTIONS(702),
    [sym_list_marker_upper_alpha_period] = ACTIONS(704),
    [sym_list_marker_lower_roman_period] = ACTIONS(706),
    [sym_list_marker_upper_roman_period] = ACTIONS(708),
    [sym_list_marker_decimal_paren] = ACTIONS(710),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(712),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(714),
    [sym_list_marker_lower_roman_paren] = ACTIONS(716),
    [sym_list_marker_upper_roman_paren] = ACTIONS(718),
    [sym_list_marker_decimal_parens] = ACTIONS(720),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(722),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(724),
    [sym_list_marker_lower_roman_parens] = ACTIONS(726),
    [sym_list_marker_upper_roman_parens] = ACTIONS(728),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [94] = {
    [sym_list_marker_task] = STATE(41),
    [sym_table_header] = STATE(1138),
    [sym_table_separator] = STATE(1138),
    [sym_table_row] = STATE(1138),
    [sym__inline] = STATE(1415),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym_list_marker_dash] = ACTIONS(694),
    [sym_list_marker_star] = ACTIONS(696),
    [sym_list_marker_plus] = ACTIONS(698),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_decimal_period] = ACTIONS(700),
    [sym_list_marker_lower_alpha_period] = ACTIONS(702),
    [sym_list_marker_upper_alpha_period] = ACTIONS(704),
    [sym_list_marker_lower_roman_period] = ACTIONS(706),
    [sym_list_marker_upper_roman_period] = ACTIONS(708),
    [sym_list_marker_decimal_paren] = ACTIONS(710),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(712),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(714),
    [sym_list_marker_lower_roman_paren] = ACTIONS(716),
    [sym_list_marker_upper_roman_paren] = ACTIONS(718),
    [sym_list_marker_decimal_parens] = ACTIONS(720),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(722),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(724),
    [sym_list_marker_lower_roman_parens] = ACTIONS(726),
    [sym_list_marker_upper_roman_parens] = ACTIONS(728),
    [sym__table_header_begin] = ACTIONS(569),
    [sym__table_separator_begin] = ACTIONS(571),
    [sym__table_row_begin] = ACTIONS(573),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [95] = {
    [sym_list_marker_task] = STATE(41),
    [sym_table_header] = STATE(1076),
    [sym_table_separator] = STATE(1076),
    [sym_table_row] = STATE(1076),
    [sym__inline] = STATE(1415),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym_list_marker_dash] = ACTIONS(694),
    [sym_list_marker_star] = ACTIONS(696),
    [sym_list_marker_plus] = ACTIONS(698),
    [sym__list_marker_task_begin] = ACTIONS(67),
    [sym_list_marker_decimal_period] = ACTIONS(700),
    [sym_list_marker_lower_alpha_period] = ACTIONS(702),
    [sym_list_marker_upper_alpha_period] = ACTIONS(704),
    [sym_list_marker_lower_roman_period] = ACTIONS(706),
    [sym_list_marker_upper_roman_period] = ACTIONS(708),
    [sym_list_marker_decimal_paren] = ACTIONS(710),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(712),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(714),
    [sym_list_marker_lower_roman_paren] = ACTIONS(716),
    [sym_list_marker_upper_roman_paren] = ACTIONS(718),
    [sym_list_marker_decimal_parens] = ACTIONS(720),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(722),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(724),
    [sym_list_marker_lower_roman_parens] = ACTIONS(726),
    [sym_list_marker_upper_roman_parens] = ACTIONS(728),
    [sym__table_header_begin] = ACTIONS(639),
    [sym__table_separator_begin] = ACTIONS(641),
    [sym__table_row_begin] = ACTIONS(643),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [96] = {
    [sym__inline] = STATE(2298),
    [sym__inline_element] = STATE(999),
    [sym__inline_line] = STATE(592),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_table_caption_repeat1] = STATE(96),
    [aux_sym__inline_repeat1] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(748),
    [anon_sym_NULL] = ACTIONS(751),
    [sym__whitespace1] = ACTIONS(753),
    [sym_quotation_marks] = ACTIONS(756),
    [sym_ellipsis] = ACTIONS(756),
    [sym_em_dash] = ACTIONS(756),
    [sym_en_dash] = ACTIONS(759),
    [sym_backslash_escape] = ACTIONS(759),
    [anon_sym_LT] = ACTIONS(762),
    [sym_symbol] = ACTIONS(756),
    [anon_sym_LBRACE_] = ACTIONS(765),
    [anon_sym__] = ACTIONS(768),
    [anon_sym_LBRACE_STAR] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(774),
    [anon_sym_LBRACE_CARET] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [anon_sym_LBRACE_TILDE] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_LBRACE_EQ] = ACTIONS(783),
    [anon_sym_LBRACE_PLUS] = ACTIONS(786),
    [anon_sym_LBRACE_DASH] = ACTIONS(789),
    [anon_sym_LBRACK_CARET] = ACTIONS(792),
    [anon_sym_BANG_LBRACK] = ACTIONS(795),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(798),
    [anon_sym_LPAREN] = ACTIONS(801),
    [anon_sym_DOLLAR] = ACTIONS(804),
    [anon_sym_TODO] = ACTIONS(807),
    [anon_sym_WIP] = ACTIONS(807),
    [anon_sym_NOTE] = ACTIONS(810),
    [anon_sym_INFO] = ACTIONS(810),
    [anon_sym_XXX] = ACTIONS(810),
    [sym_fixme] = ACTIONS(756),
    [aux_sym__text_token1] = ACTIONS(813),
    [sym__newline_inline] = ACTIONS(816),
    [sym_hard_line_break] = ACTIONS(756),
    [sym__table_caption_end] = ACTIONS(751),
    [sym__verbatim_begin] = ACTIONS(819),
  },
  [97] = {
    [sym__block_quote_prefix] = STATE(172),
    [sym__paragraph_content] = STATE(1916),
    [sym__inline] = STATE(1555),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__block_quote_prefix_repeat1] = STATE(836),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__block_quote_continuation] = ACTIONS(822),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [98] = {
    [sym__inline] = STATE(2298),
    [sym__inline_element] = STATE(999),
    [sym__inline_line] = STATE(592),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_table_caption_repeat1] = STATE(96),
    [aux_sym__inline_repeat1] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_NULL] = ACTIONS(824),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(826),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__table_caption_end] = ACTIONS(828),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [99] = {
    [sym__inline] = STATE(2298),
    [sym__inline_element] = STATE(999),
    [sym__inline_line] = STATE(592),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_table_caption_repeat1] = STATE(96),
    [aux_sym__inline_repeat1] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_NULL] = ACTIONS(830),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(826),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__table_caption_end] = ACTIONS(832),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [100] = {
    [sym__inline] = STATE(2298),
    [sym__inline_element] = STATE(999),
    [sym__inline_line] = STATE(592),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_table_caption_repeat1] = STATE(96),
    [aux_sym__inline_repeat1] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_NULL] = ACTIONS(834),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(826),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__table_caption_end] = ACTIONS(836),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [101] = {
    [sym__inline] = STATE(2298),
    [sym__inline_element] = STATE(999),
    [sym__inline_line] = STATE(592),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_table_caption_repeat1] = STATE(96),
    [aux_sym__inline_repeat1] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_NULL] = ACTIONS(838),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(826),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__table_caption_end] = ACTIONS(840),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [102] = {
    [sym__inline] = STATE(2298),
    [sym__inline_element] = STATE(999),
    [sym__inline_line] = STATE(592),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_table_caption_repeat1] = STATE(96),
    [aux_sym__inline_repeat1] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_NULL] = ACTIONS(842),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(826),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__table_caption_end] = ACTIONS(844),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [103] = {
    [sym__table_cell] = STATE(122),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(122),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(892),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [104] = {
    [sym__table_cell] = STATE(107),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(107),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(896),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [105] = {
    [sym__table_cell] = STATE(108),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(108),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(898),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [106] = {
    [sym__table_cell] = STATE(119),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(119),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(900),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [107] = {
    [sym__table_cell] = STATE(122),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(122),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(902),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [108] = {
    [sym__table_cell] = STATE(122),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(122),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(904),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [109] = {
    [sym__block_quote_prefix] = STATE(182),
    [sym__inline] = STATE(1663),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__block_quote_prefix_repeat1] = STATE(836),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__block_quote_continuation] = ACTIONS(822),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [110] = {
    [sym__table_cell] = STATE(122),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(122),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(906),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [111] = {
    [sym__table_cell] = STATE(122),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(122),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(908),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [112] = {
    [sym__table_cell] = STATE(110),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(110),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(910),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [113] = {
    [sym__table_cell] = STATE(116),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(116),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(912),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [114] = {
    [sym__table_cell] = STATE(117),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(117),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(914),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [115] = {
    [sym__table_cell] = STATE(122),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(122),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(916),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [116] = {
    [sym__table_cell] = STATE(122),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(122),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(918),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [117] = {
    [sym__table_cell] = STATE(122),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(122),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(920),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [118] = {
    [sym__table_cell] = STATE(111),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(111),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(922),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [119] = {
    [sym__table_cell] = STATE(122),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(122),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(924),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [120] = {
    [sym__table_cell] = STATE(103),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(103),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(926),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [121] = {
    [sym__table_cell] = STATE(124),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(124),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(928),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [122] = {
    [sym__table_cell] = STATE(122),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(122),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(930),
    [sym__whitespace1] = ACTIONS(933),
    [sym_quotation_marks] = ACTIONS(936),
    [sym_ellipsis] = ACTIONS(936),
    [sym_em_dash] = ACTIONS(936),
    [sym_en_dash] = ACTIONS(939),
    [sym_backslash_escape] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(942),
    [sym_symbol] = ACTIONS(936),
    [anon_sym_LBRACE_] = ACTIONS(945),
    [anon_sym__] = ACTIONS(948),
    [anon_sym_LBRACE_STAR] = ACTIONS(951),
    [anon_sym_STAR] = ACTIONS(954),
    [anon_sym_LBRACE_CARET] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_LBRACE_TILDE] = ACTIONS(960),
    [anon_sym_TILDE] = ACTIONS(960),
    [anon_sym_LBRACE_EQ] = ACTIONS(963),
    [anon_sym_LBRACE_PLUS] = ACTIONS(966),
    [anon_sym_LBRACE_DASH] = ACTIONS(969),
    [anon_sym_LBRACK_CARET] = ACTIONS(972),
    [anon_sym_BANG_LBRACK] = ACTIONS(975),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(978),
    [anon_sym_LPAREN] = ACTIONS(981),
    [anon_sym_DOLLAR] = ACTIONS(984),
    [anon_sym_TODO] = ACTIONS(987),
    [anon_sym_WIP] = ACTIONS(987),
    [anon_sym_NOTE] = ACTIONS(990),
    [anon_sym_INFO] = ACTIONS(990),
    [anon_sym_XXX] = ACTIONS(990),
    [sym_fixme] = ACTIONS(936),
    [aux_sym__text_token1] = ACTIONS(993),
    [sym__newline_inline] = ACTIONS(996),
    [sym_hard_line_break] = ACTIONS(936),
    [sym__table_row_end_newline] = ACTIONS(999),
    [sym__verbatim_begin] = ACTIONS(1001),
  },
  [123] = {
    [sym__table_cell] = STATE(115),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(115),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(1004),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [124] = {
    [sym__table_cell] = STATE(122),
    [sym__inline] = STATE(2090),
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym_table_header_repeat1] = STATE(122),
    [aux_sym__inline_repeat1] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(890),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_row_end_newline] = ACTIONS(1006),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [125] = {
    [sym__inline] = STATE(2298),
    [sym__inline_element] = STATE(999),
    [sym__inline_line] = STATE(592),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_table_caption_repeat1] = STATE(102),
    [aux_sym__inline_repeat1] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(826),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [126] = {
    [sym__inline] = STATE(2298),
    [sym__inline_element] = STATE(999),
    [sym__inline_line] = STATE(592),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_table_caption_repeat1] = STATE(98),
    [aux_sym__inline_repeat1] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(826),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [127] = {
    [sym__heading_content] = STATE(2297),
    [sym__inline] = STATE(2093),
    [sym__inline_element] = STATE(999),
    [sym__inline_line] = STATE(1532),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(826),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [128] = {
    [sym__inline] = STATE(2298),
    [sym__inline_element] = STATE(999),
    [sym__inline_line] = STATE(592),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_table_caption_repeat1] = STATE(99),
    [aux_sym__inline_repeat1] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(826),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [129] = {
    [sym__inline] = STATE(2298),
    [sym__inline_element] = STATE(999),
    [sym__inline_line] = STATE(592),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_table_caption_repeat1] = STATE(101),
    [aux_sym__inline_repeat1] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(826),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [130] = {
    [sym__heading_content] = STATE(2082),
    [sym__inline] = STATE(2093),
    [sym__inline_element] = STATE(999),
    [sym__inline_line] = STATE(1532),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(826),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [131] = {
    [sym__heading_content] = STATE(2425),
    [sym__inline] = STATE(2093),
    [sym__inline_element] = STATE(999),
    [sym__inline_line] = STATE(1532),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(826),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [132] = {
    [sym__inline] = STATE(2298),
    [sym__inline_element] = STATE(999),
    [sym__inline_line] = STATE(592),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym_table_caption_repeat1] = STATE(100),
    [aux_sym__inline_repeat1] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(826),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [133] = {
    [sym__heading_content] = STATE(2087),
    [sym__inline] = STATE(2093),
    [sym__inline_element] = STATE(999),
    [sym__inline_line] = STATE(1532),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(826),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [134] = {
    [sym__table_row] = STATE(169),
    [sym_table_header] = STATE(169),
    [sym_table_separator] = STATE(169),
    [sym_table_row] = STATE(169),
    [sym_table_caption] = STATE(354),
    [sym__block_quote_prefix] = STATE(1303),
    [aux_sym_table_repeat1] = STATE(169),
    [aux_sym__block_quote_prefix_repeat1] = STATE(1345),
    [ts_builtin_sym_end] = ACTIONS(1008),
    [anon_sym_LBRACK] = ACTIONS(1010),
    [sym__whitespace1] = ACTIONS(1008),
    [sym_quotation_marks] = ACTIONS(1008),
    [sym_ellipsis] = ACTIONS(1008),
    [sym_em_dash] = ACTIONS(1008),
    [sym_en_dash] = ACTIONS(1010),
    [sym_backslash_escape] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1008),
    [sym_symbol] = ACTIONS(1008),
    [anon_sym_LBRACE_] = ACTIONS(1008),
    [anon_sym__] = ACTIONS(1008),
    [anon_sym_LBRACE_STAR] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1008),
    [anon_sym_LBRACE_CARET] = ACTIONS(1008),
    [anon_sym_CARET] = ACTIONS(1008),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1008),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_LBRACE_EQ] = ACTIONS(1008),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1008),
    [anon_sym_LBRACE_DASH] = ACTIONS(1008),
    [anon_sym_LBRACK_CARET] = ACTIONS(1008),
    [anon_sym_BANG_LBRACK] = ACTIONS(1008),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(1008),
    [anon_sym_DOLLAR] = ACTIONS(1008),
    [anon_sym_TODO] = ACTIONS(1008),
    [anon_sym_WIP] = ACTIONS(1008),
    [anon_sym_NOTE] = ACTIONS(1008),
    [anon_sym_INFO] = ACTIONS(1008),
    [anon_sym_XXX] = ACTIONS(1008),
    [sym_fixme] = ACTIONS(1008),
    [aux_sym__text_token1] = ACTIONS(1010),
    [sym__newline] = ACTIONS(1012),
    [sym__newline_inline] = ACTIONS(1008),
    [sym_hard_line_break] = ACTIONS(1008),
    [sym__heading_begin] = ACTIONS(1008),
    [sym__div_begin] = ACTIONS(1008),
    [sym__code_block_begin] = ACTIONS(1008),
    [sym_list_marker_dash] = ACTIONS(1008),
    [sym_list_marker_star] = ACTIONS(1008),
    [sym_list_marker_plus] = ACTIONS(1008),
    [sym__list_marker_task_begin] = ACTIONS(1008),
    [sym_list_marker_definition] = ACTIONS(1008),
    [sym_list_marker_decimal_period] = ACTIONS(1008),
    [sym_list_marker_lower_alpha_period] = ACTIONS(1008),
    [sym_list_marker_upper_alpha_period] = ACTIONS(1008),
    [sym_list_marker_lower_roman_period] = ACTIONS(1008),
    [sym_list_marker_upper_roman_period] = ACTIONS(1008),
    [sym_list_marker_decimal_paren] = ACTIONS(1008),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(1008),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(1008),
    [sym_list_marker_lower_roman_paren] = ACTIONS(1008),
    [sym_list_marker_upper_roman_paren] = ACTIONS(1008),
    [sym_list_marker_decimal_parens] = ACTIONS(1008),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(1008),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(1008),
    [sym_list_marker_lower_roman_parens] = ACTIONS(1008),
    [sym_list_marker_upper_roman_parens] = ACTIONS(1008),
    [sym__block_quote_begin] = ACTIONS(1008),
    [sym__block_quote_continuation] = ACTIONS(1014),
    [sym__thematic_break_dash] = ACTIONS(1008),
    [sym__thematic_break_star] = ACTIONS(1008),
    [sym__footnote_mark_begin] = ACTIONS(1008),
    [sym__link_ref_def_mark_begin] = ACTIONS(1008),
    [sym__table_header_begin] = ACTIONS(111),
    [sym__table_separator_begin] = ACTIONS(113),
    [sym__table_row_begin] = ACTIONS(115),
    [sym__table_caption_begin] = ACTIONS(1016),
    [sym__block_attribute_begin] = ACTIONS(1008),
    [sym__verbatim_begin] = ACTIONS(1008),
  },
  [135] = {
    [sym__inline] = STATE(2093),
    [sym__inline_element] = STATE(999),
    [sym__inline_line] = STATE(1716),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(826),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [136] = {
    [sym__table_row] = STATE(145),
    [sym_table_header] = STATE(145),
    [sym_table_separator] = STATE(145),
    [sym_table_row] = STATE(145),
    [sym_table_caption] = STATE(392),
    [sym__block_quote_prefix] = STATE(1297),
    [aux_sym_table_repeat1] = STATE(145),
    [aux_sym__block_quote_prefix_repeat1] = STATE(1345),
    [anon_sym_LBRACK] = ACTIONS(1010),
    [sym__whitespace1] = ACTIONS(1008),
    [sym_quotation_marks] = ACTIONS(1008),
    [sym_ellipsis] = ACTIONS(1008),
    [sym_em_dash] = ACTIONS(1008),
    [sym_en_dash] = ACTIONS(1010),
    [sym_backslash_escape] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1008),
    [sym_symbol] = ACTIONS(1008),
    [anon_sym_LBRACE_] = ACTIONS(1008),
    [anon_sym__] = ACTIONS(1008),
    [anon_sym_LBRACE_STAR] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1008),
    [anon_sym_LBRACE_CARET] = ACTIONS(1008),
    [anon_sym_CARET] = ACTIONS(1008),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1008),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_LBRACE_EQ] = ACTIONS(1008),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1008),
    [anon_sym_LBRACE_DASH] = ACTIONS(1008),
    [anon_sym_LBRACK_CARET] = ACTIONS(1008),
    [anon_sym_BANG_LBRACK] = ACTIONS(1008),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(1008),
    [anon_sym_DOLLAR] = ACTIONS(1008),
    [anon_sym_TODO] = ACTIONS(1008),
    [anon_sym_WIP] = ACTIONS(1008),
    [anon_sym_NOTE] = ACTIONS(1008),
    [anon_sym_INFO] = ACTIONS(1008),
    [anon_sym_XXX] = ACTIONS(1008),
    [sym_fixme] = ACTIONS(1008),
    [aux_sym__text_token1] = ACTIONS(1010),
    [sym__block_close] = ACTIONS(1008),
    [sym__newline] = ACTIONS(1018),
    [sym__newline_inline] = ACTIONS(1008),
    [sym_hard_line_break] = ACTIONS(1008),
    [sym__heading_begin] = ACTIONS(1008),
    [sym__div_begin] = ACTIONS(1008),
    [sym__code_block_begin] = ACTIONS(1008),
    [sym_list_marker_dash] = ACTIONS(1008),
    [sym_list_marker_star] = ACTIONS(1008),
    [sym_list_marker_plus] = ACTIONS(1008),
    [sym__list_marker_task_begin] = ACTIONS(1008),
    [sym_list_marker_definition] = ACTIONS(1008),
    [sym_list_marker_decimal_period] = ACTIONS(1008),
    [sym_list_marker_lower_alpha_period] = ACTIONS(1008),
    [sym_list_marker_upper_alpha_period] = ACTIONS(1008),
    [sym_list_marker_lower_roman_period] = ACTIONS(1008),
    [sym_list_marker_upper_roman_period] = ACTIONS(1008),
    [sym_list_marker_decimal_paren] = ACTIONS(1008),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(1008),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(1008),
    [sym_list_marker_lower_roman_paren] = ACTIONS(1008),
    [sym_list_marker_upper_roman_paren] = ACTIONS(1008),
    [sym_list_marker_decimal_parens] = ACTIONS(1008),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(1008),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(1008),
    [sym_list_marker_lower_roman_parens] = ACTIONS(1008),
    [sym_list_marker_upper_roman_parens] = ACTIONS(1008),
    [sym__block_quote_begin] = ACTIONS(1008),
    [sym__block_quote_continuation] = ACTIONS(1014),
    [sym__thematic_break_dash] = ACTIONS(1008),
    [sym__thematic_break_star] = ACTIONS(1008),
    [sym__footnote_mark_begin] = ACTIONS(1008),
    [sym__link_ref_def_mark_begin] = ACTIONS(1008),
    [sym__table_header_begin] = ACTIONS(137),
    [sym__table_separator_begin] = ACTIONS(139),
    [sym__table_row_begin] = ACTIONS(141),
    [sym__table_caption_begin] = ACTIONS(1020),
    [sym__block_attribute_begin] = ACTIONS(1008),
    [sym__verbatim_begin] = ACTIONS(1008),
  },
  [137] = {
    [sym__inline] = STATE(2011),
    [sym__inline_element] = STATE(978),
    [sym__smart_punctuation] = STATE(458),
    [sym_autolink] = STATE(458),
    [sym_emphasis] = STATE(462),
    [sym_emphasis_begin] = STATE(2577),
    [sym_strong] = STATE(462),
    [sym_strong_begin] = STATE(2578),
    [sym_superscript] = STATE(462),
    [sym_superscript_begin] = STATE(2579),
    [sym_subscript] = STATE(462),
    [sym_subscript_begin] = STATE(2580),
    [sym_highlighted] = STATE(462),
    [sym_highlighted_begin] = STATE(2581),
    [sym_insert] = STATE(462),
    [sym_insert_begin] = STATE(2582),
    [sym_delete] = STATE(462),
    [sym_delete_begin] = STATE(2583),
    [sym_footnote_reference] = STATE(462),
    [sym_footnote_marker_begin] = STATE(2584),
    [sym__image] = STATE(462),
    [sym_full_reference_image] = STATE(462),
    [sym_collapsed_reference_image] = STATE(462),
    [sym_inline_image] = STATE(462),
    [sym_image_description] = STATE(1271),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(462),
    [sym_full_reference_link] = STATE(462),
    [sym_collapsed_reference_link] = STATE(462),
    [sym_inline_link] = STATE(462),
    [sym_link_text] = STATE(1272),
    [sym_span] = STATE(978),
    [sym__bracketed_text_begin] = STATE(2619),
    [sym_inline_comment] = STATE(458),
    [sym_raw_inline] = STATE(458),
    [sym_math] = STATE(458),
    [sym_verbatim] = STATE(458),
    [sym__todo_highlights] = STATE(458),
    [sym_todo] = STATE(458),
    [sym_note] = STATE(458),
    [sym__symbol_fallback] = STATE(458),
    [aux_sym__text] = STATE(442),
    [aux_sym__inline_repeat1] = STATE(159),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [sym__whitespace1] = ACTIONS(1024),
    [sym_quotation_marks] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1026),
    [sym_em_dash] = ACTIONS(1026),
    [sym_en_dash] = ACTIONS(1028),
    [sym_backslash_escape] = ACTIONS(1028),
    [anon_sym_LT] = ACTIONS(1030),
    [sym_symbol] = ACTIONS(1026),
    [anon_sym_LBRACE_] = ACTIONS(1032),
    [anon_sym__] = ACTIONS(1034),
    [anon_sym_LBRACE_STAR] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_LBRACE_CARET] = ACTIONS(1040),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_LBRACE_EQ] = ACTIONS(1044),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1046),
    [anon_sym_LBRACE_DASH] = ACTIONS(1048),
    [anon_sym_LBRACK_CARET] = ACTIONS(1050),
    [anon_sym_BANG_LBRACK] = ACTIONS(1052),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1058),
    [anon_sym_TODO] = ACTIONS(1060),
    [anon_sym_WIP] = ACTIONS(1060),
    [anon_sym_NOTE] = ACTIONS(1062),
    [anon_sym_INFO] = ACTIONS(1062),
    [anon_sym_XXX] = ACTIONS(1062),
    [sym_fixme] = ACTIONS(1026),
    [aux_sym__text_token1] = ACTIONS(1064),
    [sym__newline_inline] = ACTIONS(1066),
    [sym_hard_line_break] = ACTIONS(1026),
    [sym__verbatim_begin] = ACTIONS(1068),
    [sym__square_bracket_span_end] = ACTIONS(1070),
  },
  [138] = {
    [sym__inline] = STATE(2100),
    [sym__inline_element] = STATE(997),
    [sym__smart_punctuation] = STATE(451),
    [sym_autolink] = STATE(451),
    [sym_emphasis] = STATE(449),
    [sym_emphasis_begin] = STATE(2544),
    [sym_strong] = STATE(449),
    [sym_strong_begin] = STATE(2545),
    [sym_superscript] = STATE(449),
    [sym_superscript_begin] = STATE(2546),
    [sym_subscript] = STATE(449),
    [sym_subscript_begin] = STATE(2547),
    [sym_highlighted] = STATE(449),
    [sym_highlighted_begin] = STATE(2548),
    [sym_insert] = STATE(449),
    [sym_insert_begin] = STATE(2549),
    [sym_delete] = STATE(449),
    [sym_delete_begin] = STATE(2550),
    [sym_footnote_reference] = STATE(449),
    [sym_footnote_marker_begin] = STATE(2551),
    [sym__image] = STATE(449),
    [sym_full_reference_image] = STATE(449),
    [sym_collapsed_reference_image] = STATE(449),
    [sym_inline_image] = STATE(449),
    [sym_image_description] = STATE(1250),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(449),
    [sym_full_reference_link] = STATE(449),
    [sym_collapsed_reference_link] = STATE(449),
    [sym_inline_link] = STATE(449),
    [sym_link_text] = STATE(1251),
    [sym_span] = STATE(997),
    [sym__bracketed_text_begin] = STATE(2616),
    [sym_inline_comment] = STATE(451),
    [sym_raw_inline] = STATE(451),
    [sym_math] = STATE(451),
    [sym_verbatim] = STATE(451),
    [sym__todo_highlights] = STATE(451),
    [sym_todo] = STATE(451),
    [sym_note] = STATE(451),
    [sym__symbol_fallback] = STATE(451),
    [aux_sym__text] = STATE(439),
    [aux_sym__inline_repeat1] = STATE(152),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [sym__whitespace1] = ACTIONS(1074),
    [sym_quotation_marks] = ACTIONS(1076),
    [sym_ellipsis] = ACTIONS(1076),
    [sym_em_dash] = ACTIONS(1076),
    [sym_en_dash] = ACTIONS(1078),
    [sym_backslash_escape] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(1080),
    [sym_symbol] = ACTIONS(1076),
    [anon_sym_LBRACE_] = ACTIONS(1082),
    [anon_sym__] = ACTIONS(1084),
    [anon_sym_LBRACE_STAR] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_LBRACE_CARET] = ACTIONS(1090),
    [anon_sym_CARET] = ACTIONS(1090),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_LBRACE_EQ] = ACTIONS(1094),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1096),
    [anon_sym_LBRACE_DASH] = ACTIONS(1098),
    [anon_sym_LBRACK_CARET] = ACTIONS(1100),
    [anon_sym_BANG_LBRACK] = ACTIONS(1102),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [anon_sym_TODO] = ACTIONS(1110),
    [anon_sym_WIP] = ACTIONS(1110),
    [anon_sym_NOTE] = ACTIONS(1112),
    [anon_sym_INFO] = ACTIONS(1112),
    [anon_sym_XXX] = ACTIONS(1112),
    [sym_fixme] = ACTIONS(1076),
    [aux_sym__text_token1] = ACTIONS(1114),
    [sym__newline_inline] = ACTIONS(1116),
    [sym_hard_line_break] = ACTIONS(1076),
    [sym__verbatim_begin] = ACTIONS(1118),
  },
  [139] = {
    [sym__inline] = STATE(2609),
    [sym__inline_element] = STATE(982),
    [sym__smart_punctuation] = STATE(452),
    [sym_autolink] = STATE(452),
    [sym_emphasis] = STATE(453),
    [sym_emphasis_begin] = STATE(2470),
    [sym_strong] = STATE(453),
    [sym_strong_begin] = STATE(2471),
    [sym_superscript] = STATE(453),
    [sym_superscript_begin] = STATE(2472),
    [sym_subscript] = STATE(453),
    [sym_subscript_begin] = STATE(2473),
    [sym_highlighted] = STATE(453),
    [sym_highlighted_begin] = STATE(2474),
    [sym_insert] = STATE(453),
    [sym_insert_begin] = STATE(2475),
    [sym_delete] = STATE(453),
    [sym_delete_begin] = STATE(2476),
    [sym_footnote_reference] = STATE(453),
    [sym_footnote_marker_begin] = STATE(2477),
    [sym__image] = STATE(453),
    [sym_full_reference_image] = STATE(453),
    [sym_collapsed_reference_image] = STATE(453),
    [sym_inline_image] = STATE(453),
    [sym_image_description] = STATE(1282),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(453),
    [sym_full_reference_link] = STATE(453),
    [sym_collapsed_reference_link] = STATE(453),
    [sym_inline_link] = STATE(453),
    [sym_link_text] = STATE(1299),
    [sym_span] = STATE(982),
    [sym__bracketed_text_begin] = STATE(2603),
    [sym_inline_comment] = STATE(452),
    [sym_raw_inline] = STATE(452),
    [sym_math] = STATE(452),
    [sym_verbatim] = STATE(452),
    [sym__todo_highlights] = STATE(452),
    [sym_todo] = STATE(452),
    [sym_note] = STATE(452),
    [sym__symbol_fallback] = STATE(452),
    [aux_sym__text] = STATE(437),
    [aux_sym__inline_repeat1] = STATE(144),
    [anon_sym_LBRACK] = ACTIONS(1120),
    [sym__whitespace1] = ACTIONS(1122),
    [sym_quotation_marks] = ACTIONS(1124),
    [sym_ellipsis] = ACTIONS(1124),
    [sym_em_dash] = ACTIONS(1124),
    [sym_en_dash] = ACTIONS(1126),
    [sym_backslash_escape] = ACTIONS(1126),
    [anon_sym_LT] = ACTIONS(1128),
    [sym_symbol] = ACTIONS(1124),
    [anon_sym_LBRACE_] = ACTIONS(1130),
    [anon_sym__] = ACTIONS(1132),
    [anon_sym_LBRACE_STAR] = ACTIONS(1134),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACE_CARET] = ACTIONS(1138),
    [anon_sym_CARET] = ACTIONS(1138),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_LBRACE_EQ] = ACTIONS(1142),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1144),
    [anon_sym_LBRACE_DASH] = ACTIONS(1146),
    [anon_sym_LBRACK_CARET] = ACTIONS(1148),
    [anon_sym_BANG_LBRACK] = ACTIONS(1150),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1152),
    [anon_sym_LPAREN] = ACTIONS(1154),
    [anon_sym_DOLLAR] = ACTIONS(1156),
    [anon_sym_TODO] = ACTIONS(1158),
    [anon_sym_WIP] = ACTIONS(1158),
    [anon_sym_NOTE] = ACTIONS(1160),
    [anon_sym_INFO] = ACTIONS(1160),
    [anon_sym_XXX] = ACTIONS(1160),
    [sym_fixme] = ACTIONS(1124),
    [aux_sym__text_token1] = ACTIONS(1162),
    [sym__newline_inline] = ACTIONS(1164),
    [sym_hard_line_break] = ACTIONS(1124),
    [sym__verbatim_begin] = ACTIONS(1166),
  },
  [140] = {
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(170),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__eof_or_newline] = ACTIONS(1168),
    [sym__newline_inline] = ACTIONS(1170),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [141] = {
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym__inline_repeat1] = STATE(141),
    [anon_sym_LBRACK] = ACTIONS(1172),
    [sym__whitespace1] = ACTIONS(1175),
    [sym_quotation_marks] = ACTIONS(1178),
    [sym_ellipsis] = ACTIONS(1178),
    [sym_em_dash] = ACTIONS(1178),
    [sym_en_dash] = ACTIONS(1181),
    [sym_backslash_escape] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(1184),
    [sym_symbol] = ACTIONS(1178),
    [anon_sym_LBRACE_] = ACTIONS(1187),
    [anon_sym__] = ACTIONS(1190),
    [anon_sym_LBRACE_STAR] = ACTIONS(1193),
    [anon_sym_STAR] = ACTIONS(1196),
    [anon_sym_LBRACE_CARET] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1199),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1202),
    [anon_sym_TILDE] = ACTIONS(1202),
    [anon_sym_LBRACE_EQ] = ACTIONS(1205),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1208),
    [anon_sym_LBRACE_DASH] = ACTIONS(1211),
    [anon_sym_LBRACK_CARET] = ACTIONS(1214),
    [anon_sym_BANG_LBRACK] = ACTIONS(1217),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_DOLLAR] = ACTIONS(1226),
    [anon_sym_TODO] = ACTIONS(1229),
    [anon_sym_WIP] = ACTIONS(1229),
    [anon_sym_NOTE] = ACTIONS(1232),
    [anon_sym_INFO] = ACTIONS(1232),
    [anon_sym_XXX] = ACTIONS(1232),
    [sym_fixme] = ACTIONS(1178),
    [aux_sym__text_token1] = ACTIONS(1235),
    [sym__newline_inline] = ACTIONS(1238),
    [sym_hard_line_break] = ACTIONS(1178),
    [sym__table_cell_end] = ACTIONS(1241),
    [sym__verbatim_begin] = ACTIONS(1243),
  },
  [142] = {
    [sym__inline_element] = STATE(940),
    [sym__smart_punctuation] = STATE(461),
    [sym_autolink] = STATE(461),
    [sym_emphasis] = STATE(472),
    [sym_emphasis_begin] = STATE(2456),
    [sym_strong] = STATE(472),
    [sym_strong_begin] = STATE(2457),
    [sym_superscript] = STATE(472),
    [sym_superscript_begin] = STATE(2458),
    [sym_subscript] = STATE(472),
    [sym_subscript_begin] = STATE(2459),
    [sym_highlighted] = STATE(472),
    [sym_highlighted_begin] = STATE(2460),
    [sym_insert] = STATE(472),
    [sym_insert_begin] = STATE(2461),
    [sym_delete] = STATE(472),
    [sym_delete_begin] = STATE(2462),
    [sym_footnote_reference] = STATE(472),
    [sym_footnote_marker_begin] = STATE(2463),
    [sym__image] = STATE(472),
    [sym_full_reference_image] = STATE(472),
    [sym_collapsed_reference_image] = STATE(472),
    [sym_inline_image] = STATE(472),
    [sym_image_description] = STATE(1252),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(472),
    [sym_full_reference_link] = STATE(472),
    [sym_collapsed_reference_link] = STATE(472),
    [sym_inline_link] = STATE(472),
    [sym_link_text] = STATE(1254),
    [sym_span] = STATE(940),
    [sym__bracketed_text_begin] = STATE(2599),
    [sym_inline_comment] = STATE(461),
    [sym_raw_inline] = STATE(461),
    [sym_math] = STATE(461),
    [sym_verbatim] = STATE(461),
    [sym__todo_highlights] = STATE(461),
    [sym_todo] = STATE(461),
    [sym_note] = STATE(461),
    [sym__symbol_fallback] = STATE(461),
    [aux_sym__text] = STATE(443),
    [aux_sym__inline_repeat1] = STATE(141),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym__whitespace1] = ACTIONS(848),
    [sym_quotation_marks] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [sym_em_dash] = ACTIONS(850),
    [sym_en_dash] = ACTIONS(852),
    [sym_backslash_escape] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(854),
    [sym_symbol] = ACTIONS(850),
    [anon_sym_LBRACE_] = ACTIONS(856),
    [anon_sym__] = ACTIONS(858),
    [anon_sym_LBRACE_STAR] = ACTIONS(860),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_LBRACE_CARET] = ACTIONS(864),
    [anon_sym_CARET] = ACTIONS(864),
    [anon_sym_LBRACE_TILDE] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_LBRACE_EQ] = ACTIONS(868),
    [anon_sym_LBRACE_PLUS] = ACTIONS(870),
    [anon_sym_LBRACE_DASH] = ACTIONS(872),
    [anon_sym_LBRACK_CARET] = ACTIONS(874),
    [anon_sym_BANG_LBRACK] = ACTIONS(876),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_TODO] = ACTIONS(884),
    [anon_sym_WIP] = ACTIONS(884),
    [anon_sym_NOTE] = ACTIONS(886),
    [anon_sym_INFO] = ACTIONS(886),
    [anon_sym_XXX] = ACTIONS(886),
    [sym_fixme] = ACTIONS(850),
    [aux_sym__text_token1] = ACTIONS(888),
    [sym__newline_inline] = ACTIONS(1246),
    [sym_hard_line_break] = ACTIONS(850),
    [sym__table_cell_end] = ACTIONS(1168),
    [sym__verbatim_begin] = ACTIONS(894),
  },
  [143] = {
    [sym__inline_element] = STATE(982),
    [sym__smart_punctuation] = STATE(452),
    [sym_autolink] = STATE(452),
    [sym_emphasis] = STATE(453),
    [sym_emphasis_begin] = STATE(2470),
    [sym_strong] = STATE(453),
    [sym_strong_begin] = STATE(2471),
    [sym_superscript] = STATE(453),
    [sym_superscript_begin] = STATE(2472),
    [sym_subscript] = STATE(453),
    [sym_subscript_begin] = STATE(2473),
    [sym_highlighted] = STATE(453),
    [sym_highlighted_begin] = STATE(2474),
    [sym_insert] = STATE(453),
    [sym_insert_begin] = STATE(2475),
    [sym_delete] = STATE(453),
    [sym_delete_begin] = STATE(2476),
    [sym_footnote_reference] = STATE(453),
    [sym_footnote_marker_begin] = STATE(2477),
    [sym__image] = STATE(453),
    [sym_full_reference_image] = STATE(453),
    [sym_collapsed_reference_image] = STATE(453),
    [sym_inline_image] = STATE(453),
    [sym_image_description] = STATE(1282),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(453),
    [sym_full_reference_link] = STATE(453),
    [sym_collapsed_reference_link] = STATE(453),
    [sym_inline_link] = STATE(453),
    [sym_link_text] = STATE(1299),
    [sym_span] = STATE(982),
    [sym__bracketed_text_begin] = STATE(2603),
    [sym_inline_comment] = STATE(452),
    [sym_raw_inline] = STATE(452),
    [sym_math] = STATE(452),
    [sym_verbatim] = STATE(452),
    [sym__todo_highlights] = STATE(452),
    [sym_todo] = STATE(452),
    [sym_note] = STATE(452),
    [sym__symbol_fallback] = STATE(452),
    [aux_sym__text] = STATE(437),
    [aux_sym__inline_repeat1] = STATE(143),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [sym__whitespace1] = ACTIONS(1251),
    [sym_quotation_marks] = ACTIONS(1254),
    [sym_ellipsis] = ACTIONS(1254),
    [sym_em_dash] = ACTIONS(1254),
    [sym_en_dash] = ACTIONS(1257),
    [sym_backslash_escape] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1260),
    [sym_symbol] = ACTIONS(1254),
    [anon_sym_LBRACE_] = ACTIONS(1263),
    [anon_sym__] = ACTIONS(1266),
    [anon_sym_LBRACE_STAR] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_LBRACE_CARET] = ACTIONS(1275),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1278),
    [anon_sym_TILDE] = ACTIONS(1278),
    [anon_sym_LBRACE_EQ] = ACTIONS(1281),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1284),
    [anon_sym_LBRACE_DASH] = ACTIONS(1287),
    [anon_sym_LBRACK_CARET] = ACTIONS(1290),
    [anon_sym_BANG_LBRACK] = ACTIONS(1293),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1296),
    [anon_sym_LPAREN] = ACTIONS(1299),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [anon_sym_TODO] = ACTIONS(1305),
    [anon_sym_WIP] = ACTIONS(1305),
    [anon_sym_NOTE] = ACTIONS(1308),
    [anon_sym_INFO] = ACTIONS(1308),
    [anon_sym_XXX] = ACTIONS(1308),
    [sym_fixme] = ACTIONS(1254),
    [aux_sym__text_token1] = ACTIONS(1311),
    [sym__newline_inline] = ACTIONS(1314),
    [sym_hard_line_break] = ACTIONS(1254),
    [sym__link_ref_def_label_end] = ACTIONS(1241),
    [sym__verbatim_begin] = ACTIONS(1317),
  },
  [144] = {
    [sym__inline_element] = STATE(982),
    [sym__smart_punctuation] = STATE(452),
    [sym_autolink] = STATE(452),
    [sym_emphasis] = STATE(453),
    [sym_emphasis_begin] = STATE(2470),
    [sym_strong] = STATE(453),
    [sym_strong_begin] = STATE(2471),
    [sym_superscript] = STATE(453),
    [sym_superscript_begin] = STATE(2472),
    [sym_subscript] = STATE(453),
    [sym_subscript_begin] = STATE(2473),
    [sym_highlighted] = STATE(453),
    [sym_highlighted_begin] = STATE(2474),
    [sym_insert] = STATE(453),
    [sym_insert_begin] = STATE(2475),
    [sym_delete] = STATE(453),
    [sym_delete_begin] = STATE(2476),
    [sym_footnote_reference] = STATE(453),
    [sym_footnote_marker_begin] = STATE(2477),
    [sym__image] = STATE(453),
    [sym_full_reference_image] = STATE(453),
    [sym_collapsed_reference_image] = STATE(453),
    [sym_inline_image] = STATE(453),
    [sym_image_description] = STATE(1282),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(453),
    [sym_full_reference_link] = STATE(453),
    [sym_collapsed_reference_link] = STATE(453),
    [sym_inline_link] = STATE(453),
    [sym_link_text] = STATE(1299),
    [sym_span] = STATE(982),
    [sym__bracketed_text_begin] = STATE(2603),
    [sym_inline_comment] = STATE(452),
    [sym_raw_inline] = STATE(452),
    [sym_math] = STATE(452),
    [sym_verbatim] = STATE(452),
    [sym__todo_highlights] = STATE(452),
    [sym_todo] = STATE(452),
    [sym_note] = STATE(452),
    [sym__symbol_fallback] = STATE(452),
    [aux_sym__text] = STATE(437),
    [aux_sym__inline_repeat1] = STATE(143),
    [anon_sym_LBRACK] = ACTIONS(1120),
    [sym__whitespace1] = ACTIONS(1122),
    [sym_quotation_marks] = ACTIONS(1124),
    [sym_ellipsis] = ACTIONS(1124),
    [sym_em_dash] = ACTIONS(1124),
    [sym_en_dash] = ACTIONS(1126),
    [sym_backslash_escape] = ACTIONS(1126),
    [anon_sym_LT] = ACTIONS(1128),
    [sym_symbol] = ACTIONS(1124),
    [anon_sym_LBRACE_] = ACTIONS(1130),
    [anon_sym__] = ACTIONS(1132),
    [anon_sym_LBRACE_STAR] = ACTIONS(1134),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACE_CARET] = ACTIONS(1138),
    [anon_sym_CARET] = ACTIONS(1138),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_LBRACE_EQ] = ACTIONS(1142),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1144),
    [anon_sym_LBRACE_DASH] = ACTIONS(1146),
    [anon_sym_LBRACK_CARET] = ACTIONS(1148),
    [anon_sym_BANG_LBRACK] = ACTIONS(1150),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1152),
    [anon_sym_LPAREN] = ACTIONS(1154),
    [anon_sym_DOLLAR] = ACTIONS(1156),
    [anon_sym_TODO] = ACTIONS(1158),
    [anon_sym_WIP] = ACTIONS(1158),
    [anon_sym_NOTE] = ACTIONS(1160),
    [anon_sym_INFO] = ACTIONS(1160),
    [anon_sym_XXX] = ACTIONS(1160),
    [sym_fixme] = ACTIONS(1124),
    [aux_sym__text_token1] = ACTIONS(1162),
    [sym__newline_inline] = ACTIONS(1320),
    [sym_hard_line_break] = ACTIONS(1124),
    [sym__link_ref_def_label_end] = ACTIONS(1168),
    [sym__verbatim_begin] = ACTIONS(1166),
  },
  [145] = {
    [sym__table_row] = STATE(145),
    [sym_table_header] = STATE(145),
    [sym_table_separator] = STATE(145),
    [sym_table_row] = STATE(145),
    [sym__block_quote_prefix] = STATE(1297),
    [aux_sym_table_repeat1] = STATE(145),
    [aux_sym__block_quote_prefix_repeat1] = STATE(1345),
    [anon_sym_LBRACK] = ACTIONS(1322),
    [sym__whitespace1] = ACTIONS(1324),
    [sym_quotation_marks] = ACTIONS(1324),
    [sym_ellipsis] = ACTIONS(1324),
    [sym_em_dash] = ACTIONS(1324),
    [sym_en_dash] = ACTIONS(1322),
    [sym_backslash_escape] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [sym_symbol] = ACTIONS(1324),
    [anon_sym_LBRACE_] = ACTIONS(1324),
    [anon_sym__] = ACTIONS(1324),
    [anon_sym_LBRACE_STAR] = ACTIONS(1324),
    [anon_sym_STAR] = ACTIONS(1324),
    [anon_sym_LBRACE_CARET] = ACTIONS(1324),
    [anon_sym_CARET] = ACTIONS(1324),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1324),
    [anon_sym_TILDE] = ACTIONS(1324),
    [anon_sym_LBRACE_EQ] = ACTIONS(1324),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1324),
    [anon_sym_LBRACE_DASH] = ACTIONS(1324),
    [anon_sym_LBRACK_CARET] = ACTIONS(1324),
    [anon_sym_BANG_LBRACK] = ACTIONS(1324),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(1324),
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [anon_sym_TODO] = ACTIONS(1324),
    [anon_sym_WIP] = ACTIONS(1324),
    [anon_sym_NOTE] = ACTIONS(1324),
    [anon_sym_INFO] = ACTIONS(1324),
    [anon_sym_XXX] = ACTIONS(1324),
    [sym_fixme] = ACTIONS(1324),
    [aux_sym__text_token1] = ACTIONS(1322),
    [sym__block_close] = ACTIONS(1324),
    [sym__newline] = ACTIONS(1324),
    [sym__newline_inline] = ACTIONS(1324),
    [sym_hard_line_break] = ACTIONS(1324),
    [sym__heading_begin] = ACTIONS(1324),
    [sym__div_begin] = ACTIONS(1324),
    [sym__code_block_begin] = ACTIONS(1324),
    [sym_list_marker_dash] = ACTIONS(1324),
    [sym_list_marker_star] = ACTIONS(1324),
    [sym_list_marker_plus] = ACTIONS(1324),
    [sym__list_marker_task_begin] = ACTIONS(1324),
    [sym_list_marker_definition] = ACTIONS(1324),
    [sym_list_marker_decimal_period] = ACTIONS(1324),
    [sym_list_marker_lower_alpha_period] = ACTIONS(1324),
    [sym_list_marker_upper_alpha_period] = ACTIONS(1324),
    [sym_list_marker_lower_roman_period] = ACTIONS(1324),
    [sym_list_marker_upper_roman_period] = ACTIONS(1324),
    [sym_list_marker_decimal_paren] = ACTIONS(1324),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(1324),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(1324),
    [sym_list_marker_lower_roman_paren] = ACTIONS(1324),
    [sym_list_marker_upper_roman_paren] = ACTIONS(1324),
    [sym_list_marker_decimal_parens] = ACTIONS(1324),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(1324),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(1324),
    [sym_list_marker_lower_roman_parens] = ACTIONS(1324),
    [sym_list_marker_upper_roman_parens] = ACTIONS(1324),
    [sym__block_quote_begin] = ACTIONS(1324),
    [sym__block_quote_continuation] = ACTIONS(1326),
    [sym__thematic_break_dash] = ACTIONS(1324),
    [sym__thematic_break_star] = ACTIONS(1324),
    [sym__footnote_mark_begin] = ACTIONS(1324),
    [sym__link_ref_def_mark_begin] = ACTIONS(1324),
    [sym__table_header_begin] = ACTIONS(1329),
    [sym__table_separator_begin] = ACTIONS(1332),
    [sym__table_row_begin] = ACTIONS(1335),
    [sym__table_caption_begin] = ACTIONS(1324),
    [sym__block_attribute_begin] = ACTIONS(1324),
    [sym__verbatim_begin] = ACTIONS(1324),
  },
  [146] = {
    [sym__inline_element] = STATE(1017),
    [sym__smart_punctuation] = STATE(468),
    [sym_autolink] = STATE(468),
    [sym_emphasis] = STATE(469),
    [sym_emphasis_begin] = STATE(2511),
    [sym_strong] = STATE(469),
    [sym_strong_begin] = STATE(2512),
    [sym_superscript] = STATE(469),
    [sym_superscript_begin] = STATE(2513),
    [sym_subscript] = STATE(469),
    [sym_subscript_begin] = STATE(2514),
    [sym_highlighted] = STATE(469),
    [sym_highlighted_begin] = STATE(2515),
    [sym_insert] = STATE(469),
    [sym_insert_begin] = STATE(2516),
    [sym_delete] = STATE(469),
    [sym_delete_begin] = STATE(2517),
    [sym_footnote_reference] = STATE(469),
    [sym_footnote_marker_begin] = STATE(2518),
    [sym__image] = STATE(469),
    [sym_full_reference_image] = STATE(469),
    [sym_collapsed_reference_image] = STATE(469),
    [sym_inline_image] = STATE(469),
    [sym_image_description] = STATE(1325),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(469),
    [sym_full_reference_link] = STATE(469),
    [sym_collapsed_reference_link] = STATE(469),
    [sym_inline_link] = STATE(469),
    [sym_link_text] = STATE(1326),
    [sym_span] = STATE(1017),
    [sym__bracketed_text_begin] = STATE(2613),
    [sym_inline_comment] = STATE(468),
    [sym_raw_inline] = STATE(468),
    [sym_math] = STATE(468),
    [sym_verbatim] = STATE(468),
    [sym__todo_highlights] = STATE(468),
    [sym_todo] = STATE(468),
    [sym_note] = STATE(468),
    [sym__symbol_fallback] = STATE(468),
    [aux_sym__text] = STATE(446),
    [aux_sym__inline_repeat1] = STATE(147),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [sym__whitespace1] = ACTIONS(1340),
    [sym_quotation_marks] = ACTIONS(1342),
    [sym_ellipsis] = ACTIONS(1342),
    [sym_em_dash] = ACTIONS(1342),
    [sym_en_dash] = ACTIONS(1344),
    [sym_backslash_escape] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [sym_symbol] = ACTIONS(1342),
    [anon_sym_LBRACE_] = ACTIONS(1348),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_LBRACE_STAR] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_LBRACE_CARET] = ACTIONS(1356),
    [anon_sym_CARET] = ACTIONS(1356),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_LBRACE_EQ] = ACTIONS(1360),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1362),
    [anon_sym_LBRACE_DASH] = ACTIONS(1364),
    [anon_sym_LBRACK_CARET] = ACTIONS(1366),
    [anon_sym_BANG_LBRACK] = ACTIONS(1368),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1374),
    [anon_sym_TODO] = ACTIONS(1376),
    [anon_sym_WIP] = ACTIONS(1376),
    [anon_sym_NOTE] = ACTIONS(1378),
    [anon_sym_INFO] = ACTIONS(1378),
    [anon_sym_XXX] = ACTIONS(1378),
    [sym_fixme] = ACTIONS(1342),
    [aux_sym__text_token1] = ACTIONS(1380),
    [sym__newline_inline] = ACTIONS(1382),
    [sym_hard_line_break] = ACTIONS(1342),
    [sym__verbatim_begin] = ACTIONS(1384),
    [sym_superscript_end] = ACTIONS(1168),
  },
  [147] = {
    [sym__inline_element] = STATE(1017),
    [sym__smart_punctuation] = STATE(468),
    [sym_autolink] = STATE(468),
    [sym_emphasis] = STATE(469),
    [sym_emphasis_begin] = STATE(2511),
    [sym_strong] = STATE(469),
    [sym_strong_begin] = STATE(2512),
    [sym_superscript] = STATE(469),
    [sym_superscript_begin] = STATE(2513),
    [sym_subscript] = STATE(469),
    [sym_subscript_begin] = STATE(2514),
    [sym_highlighted] = STATE(469),
    [sym_highlighted_begin] = STATE(2515),
    [sym_insert] = STATE(469),
    [sym_insert_begin] = STATE(2516),
    [sym_delete] = STATE(469),
    [sym_delete_begin] = STATE(2517),
    [sym_footnote_reference] = STATE(469),
    [sym_footnote_marker_begin] = STATE(2518),
    [sym__image] = STATE(469),
    [sym_full_reference_image] = STATE(469),
    [sym_collapsed_reference_image] = STATE(469),
    [sym_inline_image] = STATE(469),
    [sym_image_description] = STATE(1325),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(469),
    [sym_full_reference_link] = STATE(469),
    [sym_collapsed_reference_link] = STATE(469),
    [sym_inline_link] = STATE(469),
    [sym_link_text] = STATE(1326),
    [sym_span] = STATE(1017),
    [sym__bracketed_text_begin] = STATE(2613),
    [sym_inline_comment] = STATE(468),
    [sym_raw_inline] = STATE(468),
    [sym_math] = STATE(468),
    [sym_verbatim] = STATE(468),
    [sym__todo_highlights] = STATE(468),
    [sym_todo] = STATE(468),
    [sym_note] = STATE(468),
    [sym__symbol_fallback] = STATE(468),
    [aux_sym__text] = STATE(446),
    [aux_sym__inline_repeat1] = STATE(147),
    [anon_sym_LBRACK] = ACTIONS(1386),
    [sym__whitespace1] = ACTIONS(1389),
    [sym_quotation_marks] = ACTIONS(1392),
    [sym_ellipsis] = ACTIONS(1392),
    [sym_em_dash] = ACTIONS(1392),
    [sym_en_dash] = ACTIONS(1395),
    [sym_backslash_escape] = ACTIONS(1395),
    [anon_sym_LT] = ACTIONS(1398),
    [sym_symbol] = ACTIONS(1392),
    [anon_sym_LBRACE_] = ACTIONS(1401),
    [anon_sym__] = ACTIONS(1404),
    [anon_sym_LBRACE_STAR] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1410),
    [anon_sym_LBRACE_CARET] = ACTIONS(1413),
    [anon_sym_CARET] = ACTIONS(1413),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1416),
    [anon_sym_TILDE] = ACTIONS(1416),
    [anon_sym_LBRACE_EQ] = ACTIONS(1419),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1422),
    [anon_sym_LBRACE_DASH] = ACTIONS(1425),
    [anon_sym_LBRACK_CARET] = ACTIONS(1428),
    [anon_sym_BANG_LBRACK] = ACTIONS(1431),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_TODO] = ACTIONS(1443),
    [anon_sym_WIP] = ACTIONS(1443),
    [anon_sym_NOTE] = ACTIONS(1446),
    [anon_sym_INFO] = ACTIONS(1446),
    [anon_sym_XXX] = ACTIONS(1446),
    [sym_fixme] = ACTIONS(1392),
    [aux_sym__text_token1] = ACTIONS(1449),
    [sym__newline_inline] = ACTIONS(1452),
    [sym_hard_line_break] = ACTIONS(1392),
    [sym__verbatim_begin] = ACTIONS(1455),
    [sym_superscript_end] = ACTIONS(1241),
  },
  [148] = {
    [sym__inline_element] = STATE(915),
    [sym__smart_punctuation] = STATE(470),
    [sym_autolink] = STATE(470),
    [sym_emphasis] = STATE(471),
    [sym_emphasis_begin] = STATE(2522),
    [sym_strong] = STATE(471),
    [sym_strong_begin] = STATE(2523),
    [sym_superscript] = STATE(471),
    [sym_superscript_begin] = STATE(2524),
    [sym_subscript] = STATE(471),
    [sym_subscript_begin] = STATE(2525),
    [sym_highlighted] = STATE(471),
    [sym_highlighted_begin] = STATE(2526),
    [sym_insert] = STATE(471),
    [sym_insert_begin] = STATE(2527),
    [sym_delete] = STATE(471),
    [sym_delete_begin] = STATE(2528),
    [sym_footnote_reference] = STATE(471),
    [sym_footnote_marker_begin] = STATE(2529),
    [sym__image] = STATE(471),
    [sym_full_reference_image] = STATE(471),
    [sym_collapsed_reference_image] = STATE(471),
    [sym_inline_image] = STATE(471),
    [sym_image_description] = STATE(1332),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(471),
    [sym_full_reference_link] = STATE(471),
    [sym_collapsed_reference_link] = STATE(471),
    [sym_inline_link] = STATE(471),
    [sym_link_text] = STATE(1334),
    [sym_span] = STATE(915),
    [sym__bracketed_text_begin] = STATE(2614),
    [sym_inline_comment] = STATE(470),
    [sym_raw_inline] = STATE(470),
    [sym_math] = STATE(470),
    [sym_verbatim] = STATE(470),
    [sym__todo_highlights] = STATE(470),
    [sym_todo] = STATE(470),
    [sym_note] = STATE(470),
    [sym__symbol_fallback] = STATE(470),
    [aux_sym__text] = STATE(447),
    [aux_sym__inline_repeat1] = STATE(149),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [sym__whitespace1] = ACTIONS(1460),
    [sym_quotation_marks] = ACTIONS(1462),
    [sym_ellipsis] = ACTIONS(1462),
    [sym_em_dash] = ACTIONS(1462),
    [sym_en_dash] = ACTIONS(1464),
    [sym_backslash_escape] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [sym_symbol] = ACTIONS(1462),
    [anon_sym_LBRACE_] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(1470),
    [anon_sym_LBRACE_STAR] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACE_CARET] = ACTIONS(1476),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_LBRACE_EQ] = ACTIONS(1480),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1482),
    [anon_sym_LBRACE_DASH] = ACTIONS(1484),
    [anon_sym_LBRACK_CARET] = ACTIONS(1486),
    [anon_sym_BANG_LBRACK] = ACTIONS(1488),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_TODO] = ACTIONS(1496),
    [anon_sym_WIP] = ACTIONS(1496),
    [anon_sym_NOTE] = ACTIONS(1498),
    [anon_sym_INFO] = ACTIONS(1498),
    [anon_sym_XXX] = ACTIONS(1498),
    [sym_fixme] = ACTIONS(1462),
    [aux_sym__text_token1] = ACTIONS(1500),
    [sym__newline_inline] = ACTIONS(1502),
    [sym_hard_line_break] = ACTIONS(1462),
    [sym__verbatim_begin] = ACTIONS(1504),
    [sym_subscript_end] = ACTIONS(1168),
  },
  [149] = {
    [sym__inline_element] = STATE(915),
    [sym__smart_punctuation] = STATE(470),
    [sym_autolink] = STATE(470),
    [sym_emphasis] = STATE(471),
    [sym_emphasis_begin] = STATE(2522),
    [sym_strong] = STATE(471),
    [sym_strong_begin] = STATE(2523),
    [sym_superscript] = STATE(471),
    [sym_superscript_begin] = STATE(2524),
    [sym_subscript] = STATE(471),
    [sym_subscript_begin] = STATE(2525),
    [sym_highlighted] = STATE(471),
    [sym_highlighted_begin] = STATE(2526),
    [sym_insert] = STATE(471),
    [sym_insert_begin] = STATE(2527),
    [sym_delete] = STATE(471),
    [sym_delete_begin] = STATE(2528),
    [sym_footnote_reference] = STATE(471),
    [sym_footnote_marker_begin] = STATE(2529),
    [sym__image] = STATE(471),
    [sym_full_reference_image] = STATE(471),
    [sym_collapsed_reference_image] = STATE(471),
    [sym_inline_image] = STATE(471),
    [sym_image_description] = STATE(1332),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(471),
    [sym_full_reference_link] = STATE(471),
    [sym_collapsed_reference_link] = STATE(471),
    [sym_inline_link] = STATE(471),
    [sym_link_text] = STATE(1334),
    [sym_span] = STATE(915),
    [sym__bracketed_text_begin] = STATE(2614),
    [sym_inline_comment] = STATE(470),
    [sym_raw_inline] = STATE(470),
    [sym_math] = STATE(470),
    [sym_verbatim] = STATE(470),
    [sym__todo_highlights] = STATE(470),
    [sym_todo] = STATE(470),
    [sym_note] = STATE(470),
    [sym__symbol_fallback] = STATE(470),
    [aux_sym__text] = STATE(447),
    [aux_sym__inline_repeat1] = STATE(149),
    [anon_sym_LBRACK] = ACTIONS(1506),
    [sym__whitespace1] = ACTIONS(1509),
    [sym_quotation_marks] = ACTIONS(1512),
    [sym_ellipsis] = ACTIONS(1512),
    [sym_em_dash] = ACTIONS(1512),
    [sym_en_dash] = ACTIONS(1515),
    [sym_backslash_escape] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(1518),
    [sym_symbol] = ACTIONS(1512),
    [anon_sym_LBRACE_] = ACTIONS(1521),
    [anon_sym__] = ACTIONS(1524),
    [anon_sym_LBRACE_STAR] = ACTIONS(1527),
    [anon_sym_STAR] = ACTIONS(1530),
    [anon_sym_LBRACE_CARET] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1533),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1536),
    [anon_sym_TILDE] = ACTIONS(1536),
    [anon_sym_LBRACE_EQ] = ACTIONS(1539),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1542),
    [anon_sym_LBRACE_DASH] = ACTIONS(1545),
    [anon_sym_LBRACK_CARET] = ACTIONS(1548),
    [anon_sym_BANG_LBRACK] = ACTIONS(1551),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1554),
    [anon_sym_LPAREN] = ACTIONS(1557),
    [anon_sym_DOLLAR] = ACTIONS(1560),
    [anon_sym_TODO] = ACTIONS(1563),
    [anon_sym_WIP] = ACTIONS(1563),
    [anon_sym_NOTE] = ACTIONS(1566),
    [anon_sym_INFO] = ACTIONS(1566),
    [anon_sym_XXX] = ACTIONS(1566),
    [sym_fixme] = ACTIONS(1512),
    [aux_sym__text_token1] = ACTIONS(1569),
    [sym__newline_inline] = ACTIONS(1572),
    [sym_hard_line_break] = ACTIONS(1512),
    [sym__verbatim_begin] = ACTIONS(1575),
    [sym_subscript_end] = ACTIONS(1241),
  },
  [150] = {
    [sym__inline_element] = STATE(1021),
    [sym__smart_punctuation] = STATE(473),
    [sym_autolink] = STATE(473),
    [sym_emphasis] = STATE(450),
    [sym_emphasis_begin] = STATE(2533),
    [sym_strong] = STATE(450),
    [sym_strong_begin] = STATE(2534),
    [sym_superscript] = STATE(450),
    [sym_superscript_begin] = STATE(2535),
    [sym_subscript] = STATE(450),
    [sym_subscript_begin] = STATE(2536),
    [sym_highlighted] = STATE(450),
    [sym_highlighted_begin] = STATE(2537),
    [sym_insert] = STATE(450),
    [sym_insert_begin] = STATE(2538),
    [sym_delete] = STATE(450),
    [sym_delete_begin] = STATE(2539),
    [sym_footnote_reference] = STATE(450),
    [sym_footnote_marker_begin] = STATE(2540),
    [sym__image] = STATE(450),
    [sym_full_reference_image] = STATE(450),
    [sym_collapsed_reference_image] = STATE(450),
    [sym_inline_image] = STATE(450),
    [sym_image_description] = STATE(1340),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(450),
    [sym_full_reference_link] = STATE(450),
    [sym_collapsed_reference_link] = STATE(450),
    [sym_inline_link] = STATE(450),
    [sym_link_text] = STATE(1341),
    [sym_span] = STATE(1021),
    [sym__bracketed_text_begin] = STATE(2615),
    [sym_inline_comment] = STATE(473),
    [sym_raw_inline] = STATE(473),
    [sym_math] = STATE(473),
    [sym_verbatim] = STATE(473),
    [sym__todo_highlights] = STATE(473),
    [sym_todo] = STATE(473),
    [sym_note] = STATE(473),
    [sym__symbol_fallback] = STATE(473),
    [aux_sym__text] = STATE(448),
    [aux_sym__inline_repeat1] = STATE(151),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [sym__whitespace1] = ACTIONS(1580),
    [sym_quotation_marks] = ACTIONS(1582),
    [sym_ellipsis] = ACTIONS(1582),
    [sym_em_dash] = ACTIONS(1582),
    [sym_en_dash] = ACTIONS(1584),
    [sym_backslash_escape] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1586),
    [sym_symbol] = ACTIONS(1582),
    [anon_sym_LBRACE_] = ACTIONS(1588),
    [anon_sym__] = ACTIONS(1590),
    [anon_sym_LBRACE_STAR] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_LBRACE_CARET] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_LBRACE_EQ] = ACTIONS(1600),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1602),
    [anon_sym_LBRACE_DASH] = ACTIONS(1604),
    [anon_sym_LBRACK_CARET] = ACTIONS(1606),
    [anon_sym_BANG_LBRACK] = ACTIONS(1608),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_DOLLAR] = ACTIONS(1614),
    [anon_sym_TODO] = ACTIONS(1616),
    [anon_sym_WIP] = ACTIONS(1616),
    [anon_sym_NOTE] = ACTIONS(1618),
    [anon_sym_INFO] = ACTIONS(1618),
    [anon_sym_XXX] = ACTIONS(1618),
    [sym_fixme] = ACTIONS(1582),
    [aux_sym__text_token1] = ACTIONS(1620),
    [sym__newline_inline] = ACTIONS(1622),
    [sym_hard_line_break] = ACTIONS(1582),
    [sym__verbatim_begin] = ACTIONS(1624),
    [sym_highlighted_end] = ACTIONS(1168),
  },
  [151] = {
    [sym__inline_element] = STATE(1021),
    [sym__smart_punctuation] = STATE(473),
    [sym_autolink] = STATE(473),
    [sym_emphasis] = STATE(450),
    [sym_emphasis_begin] = STATE(2533),
    [sym_strong] = STATE(450),
    [sym_strong_begin] = STATE(2534),
    [sym_superscript] = STATE(450),
    [sym_superscript_begin] = STATE(2535),
    [sym_subscript] = STATE(450),
    [sym_subscript_begin] = STATE(2536),
    [sym_highlighted] = STATE(450),
    [sym_highlighted_begin] = STATE(2537),
    [sym_insert] = STATE(450),
    [sym_insert_begin] = STATE(2538),
    [sym_delete] = STATE(450),
    [sym_delete_begin] = STATE(2539),
    [sym_footnote_reference] = STATE(450),
    [sym_footnote_marker_begin] = STATE(2540),
    [sym__image] = STATE(450),
    [sym_full_reference_image] = STATE(450),
    [sym_collapsed_reference_image] = STATE(450),
    [sym_inline_image] = STATE(450),
    [sym_image_description] = STATE(1340),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(450),
    [sym_full_reference_link] = STATE(450),
    [sym_collapsed_reference_link] = STATE(450),
    [sym_inline_link] = STATE(450),
    [sym_link_text] = STATE(1341),
    [sym_span] = STATE(1021),
    [sym__bracketed_text_begin] = STATE(2615),
    [sym_inline_comment] = STATE(473),
    [sym_raw_inline] = STATE(473),
    [sym_math] = STATE(473),
    [sym_verbatim] = STATE(473),
    [sym__todo_highlights] = STATE(473),
    [sym_todo] = STATE(473),
    [sym_note] = STATE(473),
    [sym__symbol_fallback] = STATE(473),
    [aux_sym__text] = STATE(448),
    [aux_sym__inline_repeat1] = STATE(151),
    [anon_sym_LBRACK] = ACTIONS(1626),
    [sym__whitespace1] = ACTIONS(1629),
    [sym_quotation_marks] = ACTIONS(1632),
    [sym_ellipsis] = ACTIONS(1632),
    [sym_em_dash] = ACTIONS(1632),
    [sym_en_dash] = ACTIONS(1635),
    [sym_backslash_escape] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1638),
    [sym_symbol] = ACTIONS(1632),
    [anon_sym_LBRACE_] = ACTIONS(1641),
    [anon_sym__] = ACTIONS(1644),
    [anon_sym_LBRACE_STAR] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(1650),
    [anon_sym_LBRACE_CARET] = ACTIONS(1653),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [anon_sym_LBRACE_EQ] = ACTIONS(1659),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1662),
    [anon_sym_LBRACE_DASH] = ACTIONS(1665),
    [anon_sym_LBRACK_CARET] = ACTIONS(1668),
    [anon_sym_BANG_LBRACK] = ACTIONS(1671),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1674),
    [anon_sym_LPAREN] = ACTIONS(1677),
    [anon_sym_DOLLAR] = ACTIONS(1680),
    [anon_sym_TODO] = ACTIONS(1683),
    [anon_sym_WIP] = ACTIONS(1683),
    [anon_sym_NOTE] = ACTIONS(1686),
    [anon_sym_INFO] = ACTIONS(1686),
    [anon_sym_XXX] = ACTIONS(1686),
    [sym_fixme] = ACTIONS(1632),
    [aux_sym__text_token1] = ACTIONS(1689),
    [sym__newline_inline] = ACTIONS(1692),
    [sym_hard_line_break] = ACTIONS(1632),
    [sym__verbatim_begin] = ACTIONS(1695),
    [sym_highlighted_end] = ACTIONS(1241),
  },
  [152] = {
    [sym__inline_element] = STATE(997),
    [sym__smart_punctuation] = STATE(451),
    [sym_autolink] = STATE(451),
    [sym_emphasis] = STATE(449),
    [sym_emphasis_begin] = STATE(2544),
    [sym_strong] = STATE(449),
    [sym_strong_begin] = STATE(2545),
    [sym_superscript] = STATE(449),
    [sym_superscript_begin] = STATE(2546),
    [sym_subscript] = STATE(449),
    [sym_subscript_begin] = STATE(2547),
    [sym_highlighted] = STATE(449),
    [sym_highlighted_begin] = STATE(2548),
    [sym_insert] = STATE(449),
    [sym_insert_begin] = STATE(2549),
    [sym_delete] = STATE(449),
    [sym_delete_begin] = STATE(2550),
    [sym_footnote_reference] = STATE(449),
    [sym_footnote_marker_begin] = STATE(2551),
    [sym__image] = STATE(449),
    [sym_full_reference_image] = STATE(449),
    [sym_collapsed_reference_image] = STATE(449),
    [sym_inline_image] = STATE(449),
    [sym_image_description] = STATE(1250),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(449),
    [sym_full_reference_link] = STATE(449),
    [sym_collapsed_reference_link] = STATE(449),
    [sym_inline_link] = STATE(449),
    [sym_link_text] = STATE(1251),
    [sym_span] = STATE(997),
    [sym__bracketed_text_begin] = STATE(2616),
    [sym_inline_comment] = STATE(451),
    [sym_raw_inline] = STATE(451),
    [sym_math] = STATE(451),
    [sym_verbatim] = STATE(451),
    [sym__todo_highlights] = STATE(451),
    [sym_todo] = STATE(451),
    [sym_note] = STATE(451),
    [sym__symbol_fallback] = STATE(451),
    [aux_sym__text] = STATE(439),
    [aux_sym__inline_repeat1] = STATE(153),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [sym__whitespace1] = ACTIONS(1074),
    [sym_quotation_marks] = ACTIONS(1076),
    [sym_ellipsis] = ACTIONS(1076),
    [sym_em_dash] = ACTIONS(1076),
    [sym_en_dash] = ACTIONS(1078),
    [sym_backslash_escape] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(1080),
    [sym_symbol] = ACTIONS(1076),
    [anon_sym_LBRACE_] = ACTIONS(1082),
    [anon_sym__] = ACTIONS(1084),
    [anon_sym_LBRACE_STAR] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_LBRACE_CARET] = ACTIONS(1090),
    [anon_sym_CARET] = ACTIONS(1090),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_LBRACE_EQ] = ACTIONS(1094),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1096),
    [anon_sym_LBRACE_DASH] = ACTIONS(1098),
    [anon_sym_LBRACK_CARET] = ACTIONS(1100),
    [anon_sym_BANG_LBRACK] = ACTIONS(1102),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [anon_sym_TODO] = ACTIONS(1110),
    [anon_sym_WIP] = ACTIONS(1110),
    [anon_sym_NOTE] = ACTIONS(1112),
    [anon_sym_INFO] = ACTIONS(1112),
    [anon_sym_XXX] = ACTIONS(1112),
    [sym_fixme] = ACTIONS(1076),
    [aux_sym__text_token1] = ACTIONS(1114),
    [sym__newline_inline] = ACTIONS(1698),
    [sym_hard_line_break] = ACTIONS(1076),
    [sym__verbatim_begin] = ACTIONS(1118),
    [sym_insert_end] = ACTIONS(1168),
  },
  [153] = {
    [sym__inline_element] = STATE(997),
    [sym__smart_punctuation] = STATE(451),
    [sym_autolink] = STATE(451),
    [sym_emphasis] = STATE(449),
    [sym_emphasis_begin] = STATE(2544),
    [sym_strong] = STATE(449),
    [sym_strong_begin] = STATE(2545),
    [sym_superscript] = STATE(449),
    [sym_superscript_begin] = STATE(2546),
    [sym_subscript] = STATE(449),
    [sym_subscript_begin] = STATE(2547),
    [sym_highlighted] = STATE(449),
    [sym_highlighted_begin] = STATE(2548),
    [sym_insert] = STATE(449),
    [sym_insert_begin] = STATE(2549),
    [sym_delete] = STATE(449),
    [sym_delete_begin] = STATE(2550),
    [sym_footnote_reference] = STATE(449),
    [sym_footnote_marker_begin] = STATE(2551),
    [sym__image] = STATE(449),
    [sym_full_reference_image] = STATE(449),
    [sym_collapsed_reference_image] = STATE(449),
    [sym_inline_image] = STATE(449),
    [sym_image_description] = STATE(1250),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(449),
    [sym_full_reference_link] = STATE(449),
    [sym_collapsed_reference_link] = STATE(449),
    [sym_inline_link] = STATE(449),
    [sym_link_text] = STATE(1251),
    [sym_span] = STATE(997),
    [sym__bracketed_text_begin] = STATE(2616),
    [sym_inline_comment] = STATE(451),
    [sym_raw_inline] = STATE(451),
    [sym_math] = STATE(451),
    [sym_verbatim] = STATE(451),
    [sym__todo_highlights] = STATE(451),
    [sym_todo] = STATE(451),
    [sym_note] = STATE(451),
    [sym__symbol_fallback] = STATE(451),
    [aux_sym__text] = STATE(439),
    [aux_sym__inline_repeat1] = STATE(153),
    [anon_sym_LBRACK] = ACTIONS(1700),
    [sym__whitespace1] = ACTIONS(1703),
    [sym_quotation_marks] = ACTIONS(1706),
    [sym_ellipsis] = ACTIONS(1706),
    [sym_em_dash] = ACTIONS(1706),
    [sym_en_dash] = ACTIONS(1709),
    [sym_backslash_escape] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1712),
    [sym_symbol] = ACTIONS(1706),
    [anon_sym_LBRACE_] = ACTIONS(1715),
    [anon_sym__] = ACTIONS(1718),
    [anon_sym_LBRACE_STAR] = ACTIONS(1721),
    [anon_sym_STAR] = ACTIONS(1724),
    [anon_sym_LBRACE_CARET] = ACTIONS(1727),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1730),
    [anon_sym_TILDE] = ACTIONS(1730),
    [anon_sym_LBRACE_EQ] = ACTIONS(1733),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1736),
    [anon_sym_LBRACE_DASH] = ACTIONS(1739),
    [anon_sym_LBRACK_CARET] = ACTIONS(1742),
    [anon_sym_BANG_LBRACK] = ACTIONS(1745),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1748),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_DOLLAR] = ACTIONS(1754),
    [anon_sym_TODO] = ACTIONS(1757),
    [anon_sym_WIP] = ACTIONS(1757),
    [anon_sym_NOTE] = ACTIONS(1760),
    [anon_sym_INFO] = ACTIONS(1760),
    [anon_sym_XXX] = ACTIONS(1760),
    [sym_fixme] = ACTIONS(1706),
    [aux_sym__text_token1] = ACTIONS(1763),
    [sym__newline_inline] = ACTIONS(1766),
    [sym_hard_line_break] = ACTIONS(1706),
    [sym__verbatim_begin] = ACTIONS(1769),
    [sym_insert_end] = ACTIONS(1241),
  },
  [154] = {
    [sym__inline_without_trailing_space] = STATE(2291),
    [sym__inline_element] = STATE(988),
    [sym__smart_punctuation] = STATE(460),
    [sym_autolink] = STATE(460),
    [sym_emphasis] = STATE(463),
    [sym_emphasis_begin] = STATE(2484),
    [sym_strong] = STATE(463),
    [sym_strong_begin] = STATE(2485),
    [sym_superscript] = STATE(463),
    [sym_superscript_begin] = STATE(2486),
    [sym_subscript] = STATE(463),
    [sym_subscript_begin] = STATE(2487),
    [sym_highlighted] = STATE(463),
    [sym_highlighted_begin] = STATE(2488),
    [sym_insert] = STATE(463),
    [sym_insert_begin] = STATE(2489),
    [sym_delete] = STATE(463),
    [sym_delete_begin] = STATE(2490),
    [sym_footnote_reference] = STATE(463),
    [sym_footnote_marker_begin] = STATE(2491),
    [sym__image] = STATE(463),
    [sym_full_reference_image] = STATE(463),
    [sym_collapsed_reference_image] = STATE(463),
    [sym_inline_image] = STATE(463),
    [sym_image_description] = STATE(1268),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(463),
    [sym_full_reference_link] = STATE(463),
    [sym_collapsed_reference_link] = STATE(463),
    [sym_inline_link] = STATE(463),
    [sym_link_text] = STATE(1273),
    [sym_span] = STATE(988),
    [sym__bracketed_text_begin] = STATE(2607),
    [sym_inline_comment] = STATE(460),
    [sym_raw_inline] = STATE(460),
    [sym_math] = STATE(460),
    [sym_verbatim] = STATE(460),
    [sym__todo_highlights] = STATE(460),
    [sym_todo] = STATE(460),
    [sym_note] = STATE(460),
    [sym__symbol_fallback] = STATE(460),
    [aux_sym__text] = STATE(444),
    [aux_sym__inline_repeat1] = STATE(286),
    [anon_sym_LBRACK] = ACTIONS(1772),
    [sym__whitespace1] = ACTIONS(1774),
    [sym_quotation_marks] = ACTIONS(1776),
    [sym_ellipsis] = ACTIONS(1776),
    [sym_em_dash] = ACTIONS(1776),
    [sym_en_dash] = ACTIONS(1778),
    [sym_backslash_escape] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1780),
    [sym_symbol] = ACTIONS(1776),
    [anon_sym_LBRACE_] = ACTIONS(1782),
    [anon_sym__] = ACTIONS(1784),
    [anon_sym_LBRACE_STAR] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_LBRACE_CARET] = ACTIONS(1790),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1792),
    [anon_sym_LBRACE_EQ] = ACTIONS(1794),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1796),
    [anon_sym_LBRACE_DASH] = ACTIONS(1798),
    [anon_sym_LBRACK_CARET] = ACTIONS(1800),
    [anon_sym_BANG_LBRACK] = ACTIONS(1802),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1804),
    [anon_sym_LPAREN] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [anon_sym_TODO] = ACTIONS(1810),
    [anon_sym_WIP] = ACTIONS(1810),
    [anon_sym_NOTE] = ACTIONS(1812),
    [anon_sym_INFO] = ACTIONS(1812),
    [anon_sym_XXX] = ACTIONS(1812),
    [sym_fixme] = ACTIONS(1776),
    [aux_sym__text_token1] = ACTIONS(1814),
    [sym__newline_inline] = ACTIONS(1816),
    [sym_hard_line_break] = ACTIONS(1776),
    [sym__verbatim_begin] = ACTIONS(1818),
  },
  [155] = {
    [sym__inline_element] = STATE(900),
    [sym__smart_punctuation] = STATE(454),
    [sym_autolink] = STATE(454),
    [sym_emphasis] = STATE(455),
    [sym_emphasis_begin] = STATE(2555),
    [sym_strong] = STATE(455),
    [sym_strong_begin] = STATE(2556),
    [sym_superscript] = STATE(455),
    [sym_superscript_begin] = STATE(2557),
    [sym_subscript] = STATE(455),
    [sym_subscript_begin] = STATE(2558),
    [sym_highlighted] = STATE(455),
    [sym_highlighted_begin] = STATE(2559),
    [sym_insert] = STATE(455),
    [sym_insert_begin] = STATE(2560),
    [sym_delete] = STATE(455),
    [sym_delete_begin] = STATE(2561),
    [sym_footnote_reference] = STATE(455),
    [sym_footnote_marker_begin] = STATE(2562),
    [sym__image] = STATE(455),
    [sym_full_reference_image] = STATE(455),
    [sym_collapsed_reference_image] = STATE(455),
    [sym_inline_image] = STATE(455),
    [sym_image_description] = STATE(1257),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(455),
    [sym_full_reference_link] = STATE(455),
    [sym_collapsed_reference_link] = STATE(455),
    [sym_inline_link] = STATE(455),
    [sym_link_text] = STATE(1258),
    [sym_span] = STATE(900),
    [sym__bracketed_text_begin] = STATE(2617),
    [sym_inline_comment] = STATE(454),
    [sym_raw_inline] = STATE(454),
    [sym_math] = STATE(454),
    [sym_verbatim] = STATE(454),
    [sym__todo_highlights] = STATE(454),
    [sym_todo] = STATE(454),
    [sym_note] = STATE(454),
    [sym__symbol_fallback] = STATE(454),
    [aux_sym__text] = STATE(441),
    [aux_sym__inline_repeat1] = STATE(156),
    [anon_sym_LBRACK] = ACTIONS(1820),
    [sym__whitespace1] = ACTIONS(1822),
    [sym_quotation_marks] = ACTIONS(1824),
    [sym_ellipsis] = ACTIONS(1824),
    [sym_em_dash] = ACTIONS(1824),
    [sym_en_dash] = ACTIONS(1826),
    [sym_backslash_escape] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1828),
    [sym_symbol] = ACTIONS(1824),
    [anon_sym_LBRACE_] = ACTIONS(1830),
    [anon_sym__] = ACTIONS(1832),
    [anon_sym_LBRACE_STAR] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_LBRACE_CARET] = ACTIONS(1838),
    [anon_sym_CARET] = ACTIONS(1838),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1840),
    [anon_sym_TILDE] = ACTIONS(1840),
    [anon_sym_LBRACE_EQ] = ACTIONS(1842),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1844),
    [anon_sym_LBRACE_DASH] = ACTIONS(1846),
    [anon_sym_LBRACK_CARET] = ACTIONS(1848),
    [anon_sym_BANG_LBRACK] = ACTIONS(1850),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1856),
    [anon_sym_TODO] = ACTIONS(1858),
    [anon_sym_WIP] = ACTIONS(1858),
    [anon_sym_NOTE] = ACTIONS(1860),
    [anon_sym_INFO] = ACTIONS(1860),
    [anon_sym_XXX] = ACTIONS(1860),
    [sym_fixme] = ACTIONS(1824),
    [aux_sym__text_token1] = ACTIONS(1862),
    [sym__newline_inline] = ACTIONS(1864),
    [sym_hard_line_break] = ACTIONS(1824),
    [sym__verbatim_begin] = ACTIONS(1866),
    [sym_delete_end] = ACTIONS(1168),
  },
  [156] = {
    [sym__inline_element] = STATE(900),
    [sym__smart_punctuation] = STATE(454),
    [sym_autolink] = STATE(454),
    [sym_emphasis] = STATE(455),
    [sym_emphasis_begin] = STATE(2555),
    [sym_strong] = STATE(455),
    [sym_strong_begin] = STATE(2556),
    [sym_superscript] = STATE(455),
    [sym_superscript_begin] = STATE(2557),
    [sym_subscript] = STATE(455),
    [sym_subscript_begin] = STATE(2558),
    [sym_highlighted] = STATE(455),
    [sym_highlighted_begin] = STATE(2559),
    [sym_insert] = STATE(455),
    [sym_insert_begin] = STATE(2560),
    [sym_delete] = STATE(455),
    [sym_delete_begin] = STATE(2561),
    [sym_footnote_reference] = STATE(455),
    [sym_footnote_marker_begin] = STATE(2562),
    [sym__image] = STATE(455),
    [sym_full_reference_image] = STATE(455),
    [sym_collapsed_reference_image] = STATE(455),
    [sym_inline_image] = STATE(455),
    [sym_image_description] = STATE(1257),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(455),
    [sym_full_reference_link] = STATE(455),
    [sym_collapsed_reference_link] = STATE(455),
    [sym_inline_link] = STATE(455),
    [sym_link_text] = STATE(1258),
    [sym_span] = STATE(900),
    [sym__bracketed_text_begin] = STATE(2617),
    [sym_inline_comment] = STATE(454),
    [sym_raw_inline] = STATE(454),
    [sym_math] = STATE(454),
    [sym_verbatim] = STATE(454),
    [sym__todo_highlights] = STATE(454),
    [sym_todo] = STATE(454),
    [sym_note] = STATE(454),
    [sym__symbol_fallback] = STATE(454),
    [aux_sym__text] = STATE(441),
    [aux_sym__inline_repeat1] = STATE(156),
    [anon_sym_LBRACK] = ACTIONS(1868),
    [sym__whitespace1] = ACTIONS(1871),
    [sym_quotation_marks] = ACTIONS(1874),
    [sym_ellipsis] = ACTIONS(1874),
    [sym_em_dash] = ACTIONS(1874),
    [sym_en_dash] = ACTIONS(1877),
    [sym_backslash_escape] = ACTIONS(1877),
    [anon_sym_LT] = ACTIONS(1880),
    [sym_symbol] = ACTIONS(1874),
    [anon_sym_LBRACE_] = ACTIONS(1883),
    [anon_sym__] = ACTIONS(1886),
    [anon_sym_LBRACE_STAR] = ACTIONS(1889),
    [anon_sym_STAR] = ACTIONS(1892),
    [anon_sym_LBRACE_CARET] = ACTIONS(1895),
    [anon_sym_CARET] = ACTIONS(1895),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1898),
    [anon_sym_TILDE] = ACTIONS(1898),
    [anon_sym_LBRACE_EQ] = ACTIONS(1901),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1904),
    [anon_sym_LBRACE_DASH] = ACTIONS(1907),
    [anon_sym_LBRACK_CARET] = ACTIONS(1910),
    [anon_sym_BANG_LBRACK] = ACTIONS(1913),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1916),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_DOLLAR] = ACTIONS(1922),
    [anon_sym_TODO] = ACTIONS(1925),
    [anon_sym_WIP] = ACTIONS(1925),
    [anon_sym_NOTE] = ACTIONS(1928),
    [anon_sym_INFO] = ACTIONS(1928),
    [anon_sym_XXX] = ACTIONS(1928),
    [sym_fixme] = ACTIONS(1874),
    [aux_sym__text_token1] = ACTIONS(1931),
    [sym__newline_inline] = ACTIONS(1934),
    [sym_hard_line_break] = ACTIONS(1874),
    [sym__verbatim_begin] = ACTIONS(1937),
    [sym_delete_end] = ACTIONS(1241),
  },
  [157] = {
    [sym__inline_element] = STATE(1014),
    [sym__smart_punctuation] = STATE(456),
    [sym_autolink] = STATE(456),
    [sym_emphasis] = STATE(457),
    [sym_emphasis_begin] = STATE(2566),
    [sym_strong] = STATE(457),
    [sym_strong_begin] = STATE(2567),
    [sym_superscript] = STATE(457),
    [sym_superscript_begin] = STATE(2568),
    [sym_subscript] = STATE(457),
    [sym_subscript_begin] = STATE(2569),
    [sym_highlighted] = STATE(457),
    [sym_highlighted_begin] = STATE(2570),
    [sym_insert] = STATE(457),
    [sym_insert_begin] = STATE(2571),
    [sym_delete] = STATE(457),
    [sym_delete_begin] = STATE(1976),
    [sym_footnote_reference] = STATE(457),
    [sym_footnote_marker_begin] = STATE(2573),
    [sym__image] = STATE(457),
    [sym_full_reference_image] = STATE(457),
    [sym_collapsed_reference_image] = STATE(457),
    [sym_inline_image] = STATE(457),
    [sym_image_description] = STATE(1264),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(457),
    [sym_full_reference_link] = STATE(457),
    [sym_collapsed_reference_link] = STATE(457),
    [sym_inline_link] = STATE(457),
    [sym_link_text] = STATE(1265),
    [sym_span] = STATE(1014),
    [sym__bracketed_text_begin] = STATE(2618),
    [sym_inline_comment] = STATE(456),
    [sym_raw_inline] = STATE(456),
    [sym_math] = STATE(456),
    [sym_verbatim] = STATE(456),
    [sym__todo_highlights] = STATE(456),
    [sym_todo] = STATE(456),
    [sym_note] = STATE(456),
    [sym__symbol_fallback] = STATE(456),
    [aux_sym__text] = STATE(440),
    [aux_sym__inline_repeat1] = STATE(158),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [sym__whitespace1] = ACTIONS(1942),
    [sym_quotation_marks] = ACTIONS(1944),
    [sym_ellipsis] = ACTIONS(1944),
    [sym_em_dash] = ACTIONS(1944),
    [sym_en_dash] = ACTIONS(1946),
    [sym_backslash_escape] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1948),
    [sym_symbol] = ACTIONS(1944),
    [anon_sym_LBRACE_] = ACTIONS(1950),
    [anon_sym__] = ACTIONS(1952),
    [anon_sym_LBRACE_STAR] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_LBRACE_CARET] = ACTIONS(1958),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_LBRACE_EQ] = ACTIONS(1962),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1964),
    [anon_sym_LBRACE_DASH] = ACTIONS(1966),
    [anon_sym_LBRACK_CARET] = ACTIONS(1968),
    [anon_sym_BANG_LBRACK] = ACTIONS(1970),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1972),
    [anon_sym_RBRACK2] = ACTIONS(1168),
    [anon_sym_LPAREN] = ACTIONS(1974),
    [anon_sym_DOLLAR] = ACTIONS(1976),
    [anon_sym_TODO] = ACTIONS(1978),
    [anon_sym_WIP] = ACTIONS(1978),
    [anon_sym_NOTE] = ACTIONS(1980),
    [anon_sym_INFO] = ACTIONS(1980),
    [anon_sym_XXX] = ACTIONS(1980),
    [sym_fixme] = ACTIONS(1944),
    [aux_sym__text_token1] = ACTIONS(1982),
    [sym__newline_inline] = ACTIONS(1984),
    [sym_hard_line_break] = ACTIONS(1944),
    [sym__verbatim_begin] = ACTIONS(1986),
  },
  [158] = {
    [sym__inline_element] = STATE(1014),
    [sym__smart_punctuation] = STATE(456),
    [sym_autolink] = STATE(456),
    [sym_emphasis] = STATE(457),
    [sym_emphasis_begin] = STATE(2566),
    [sym_strong] = STATE(457),
    [sym_strong_begin] = STATE(2567),
    [sym_superscript] = STATE(457),
    [sym_superscript_begin] = STATE(2568),
    [sym_subscript] = STATE(457),
    [sym_subscript_begin] = STATE(2569),
    [sym_highlighted] = STATE(457),
    [sym_highlighted_begin] = STATE(2570),
    [sym_insert] = STATE(457),
    [sym_insert_begin] = STATE(2571),
    [sym_delete] = STATE(457),
    [sym_delete_begin] = STATE(1976),
    [sym_footnote_reference] = STATE(457),
    [sym_footnote_marker_begin] = STATE(2573),
    [sym__image] = STATE(457),
    [sym_full_reference_image] = STATE(457),
    [sym_collapsed_reference_image] = STATE(457),
    [sym_inline_image] = STATE(457),
    [sym_image_description] = STATE(1264),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(457),
    [sym_full_reference_link] = STATE(457),
    [sym_collapsed_reference_link] = STATE(457),
    [sym_inline_link] = STATE(457),
    [sym_link_text] = STATE(1265),
    [sym_span] = STATE(1014),
    [sym__bracketed_text_begin] = STATE(2618),
    [sym_inline_comment] = STATE(456),
    [sym_raw_inline] = STATE(456),
    [sym_math] = STATE(456),
    [sym_verbatim] = STATE(456),
    [sym__todo_highlights] = STATE(456),
    [sym_todo] = STATE(456),
    [sym_note] = STATE(456),
    [sym__symbol_fallback] = STATE(456),
    [aux_sym__text] = STATE(440),
    [aux_sym__inline_repeat1] = STATE(158),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [sym__whitespace1] = ACTIONS(1991),
    [sym_quotation_marks] = ACTIONS(1994),
    [sym_ellipsis] = ACTIONS(1994),
    [sym_em_dash] = ACTIONS(1994),
    [sym_en_dash] = ACTIONS(1997),
    [sym_backslash_escape] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(2000),
    [sym_symbol] = ACTIONS(1994),
    [anon_sym_LBRACE_] = ACTIONS(2003),
    [anon_sym__] = ACTIONS(2006),
    [anon_sym_LBRACE_STAR] = ACTIONS(2009),
    [anon_sym_STAR] = ACTIONS(2012),
    [anon_sym_LBRACE_CARET] = ACTIONS(2015),
    [anon_sym_CARET] = ACTIONS(2015),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2018),
    [anon_sym_TILDE] = ACTIONS(2018),
    [anon_sym_LBRACE_EQ] = ACTIONS(2021),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2024),
    [anon_sym_LBRACE_DASH] = ACTIONS(2027),
    [anon_sym_LBRACK_CARET] = ACTIONS(2030),
    [anon_sym_BANG_LBRACK] = ACTIONS(2033),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2036),
    [anon_sym_RBRACK2] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_DOLLAR] = ACTIONS(2042),
    [anon_sym_TODO] = ACTIONS(2045),
    [anon_sym_WIP] = ACTIONS(2045),
    [anon_sym_NOTE] = ACTIONS(2048),
    [anon_sym_INFO] = ACTIONS(2048),
    [anon_sym_XXX] = ACTIONS(2048),
    [sym_fixme] = ACTIONS(1994),
    [aux_sym__text_token1] = ACTIONS(2051),
    [sym__newline_inline] = ACTIONS(2054),
    [sym_hard_line_break] = ACTIONS(1994),
    [sym__verbatim_begin] = ACTIONS(2057),
  },
  [159] = {
    [sym__inline_element] = STATE(978),
    [sym__smart_punctuation] = STATE(458),
    [sym_autolink] = STATE(458),
    [sym_emphasis] = STATE(462),
    [sym_emphasis_begin] = STATE(2577),
    [sym_strong] = STATE(462),
    [sym_strong_begin] = STATE(2578),
    [sym_superscript] = STATE(462),
    [sym_superscript_begin] = STATE(2579),
    [sym_subscript] = STATE(462),
    [sym_subscript_begin] = STATE(2580),
    [sym_highlighted] = STATE(462),
    [sym_highlighted_begin] = STATE(2581),
    [sym_insert] = STATE(462),
    [sym_insert_begin] = STATE(2582),
    [sym_delete] = STATE(462),
    [sym_delete_begin] = STATE(2583),
    [sym_footnote_reference] = STATE(462),
    [sym_footnote_marker_begin] = STATE(2584),
    [sym__image] = STATE(462),
    [sym_full_reference_image] = STATE(462),
    [sym_collapsed_reference_image] = STATE(462),
    [sym_inline_image] = STATE(462),
    [sym_image_description] = STATE(1271),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(462),
    [sym_full_reference_link] = STATE(462),
    [sym_collapsed_reference_link] = STATE(462),
    [sym_inline_link] = STATE(462),
    [sym_link_text] = STATE(1272),
    [sym_span] = STATE(978),
    [sym__bracketed_text_begin] = STATE(2619),
    [sym_inline_comment] = STATE(458),
    [sym_raw_inline] = STATE(458),
    [sym_math] = STATE(458),
    [sym_verbatim] = STATE(458),
    [sym__todo_highlights] = STATE(458),
    [sym_todo] = STATE(458),
    [sym_note] = STATE(458),
    [sym__symbol_fallback] = STATE(458),
    [aux_sym__text] = STATE(442),
    [aux_sym__inline_repeat1] = STATE(160),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [sym__whitespace1] = ACTIONS(1024),
    [sym_quotation_marks] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1026),
    [sym_em_dash] = ACTIONS(1026),
    [sym_en_dash] = ACTIONS(1028),
    [sym_backslash_escape] = ACTIONS(1028),
    [anon_sym_LT] = ACTIONS(1030),
    [sym_symbol] = ACTIONS(1026),
    [anon_sym_LBRACE_] = ACTIONS(1032),
    [anon_sym__] = ACTIONS(1034),
    [anon_sym_LBRACE_STAR] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_LBRACE_CARET] = ACTIONS(1040),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_LBRACE_EQ] = ACTIONS(1044),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1046),
    [anon_sym_LBRACE_DASH] = ACTIONS(1048),
    [anon_sym_LBRACK_CARET] = ACTIONS(1050),
    [anon_sym_BANG_LBRACK] = ACTIONS(1052),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1058),
    [anon_sym_TODO] = ACTIONS(1060),
    [anon_sym_WIP] = ACTIONS(1060),
    [anon_sym_NOTE] = ACTIONS(1062),
    [anon_sym_INFO] = ACTIONS(1062),
    [anon_sym_XXX] = ACTIONS(1062),
    [sym_fixme] = ACTIONS(1026),
    [aux_sym__text_token1] = ACTIONS(1064),
    [sym__newline_inline] = ACTIONS(2060),
    [sym_hard_line_break] = ACTIONS(1026),
    [sym__verbatim_begin] = ACTIONS(1068),
    [sym__square_bracket_span_end] = ACTIONS(1168),
  },
  [160] = {
    [sym__inline_element] = STATE(978),
    [sym__smart_punctuation] = STATE(458),
    [sym_autolink] = STATE(458),
    [sym_emphasis] = STATE(462),
    [sym_emphasis_begin] = STATE(2577),
    [sym_strong] = STATE(462),
    [sym_strong_begin] = STATE(2578),
    [sym_superscript] = STATE(462),
    [sym_superscript_begin] = STATE(2579),
    [sym_subscript] = STATE(462),
    [sym_subscript_begin] = STATE(2580),
    [sym_highlighted] = STATE(462),
    [sym_highlighted_begin] = STATE(2581),
    [sym_insert] = STATE(462),
    [sym_insert_begin] = STATE(2582),
    [sym_delete] = STATE(462),
    [sym_delete_begin] = STATE(2583),
    [sym_footnote_reference] = STATE(462),
    [sym_footnote_marker_begin] = STATE(2584),
    [sym__image] = STATE(462),
    [sym_full_reference_image] = STATE(462),
    [sym_collapsed_reference_image] = STATE(462),
    [sym_inline_image] = STATE(462),
    [sym_image_description] = STATE(1271),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(462),
    [sym_full_reference_link] = STATE(462),
    [sym_collapsed_reference_link] = STATE(462),
    [sym_inline_link] = STATE(462),
    [sym_link_text] = STATE(1272),
    [sym_span] = STATE(978),
    [sym__bracketed_text_begin] = STATE(2619),
    [sym_inline_comment] = STATE(458),
    [sym_raw_inline] = STATE(458),
    [sym_math] = STATE(458),
    [sym_verbatim] = STATE(458),
    [sym__todo_highlights] = STATE(458),
    [sym_todo] = STATE(458),
    [sym_note] = STATE(458),
    [sym__symbol_fallback] = STATE(458),
    [aux_sym__text] = STATE(442),
    [aux_sym__inline_repeat1] = STATE(160),
    [anon_sym_LBRACK] = ACTIONS(2062),
    [sym__whitespace1] = ACTIONS(2065),
    [sym_quotation_marks] = ACTIONS(2068),
    [sym_ellipsis] = ACTIONS(2068),
    [sym_em_dash] = ACTIONS(2068),
    [sym_en_dash] = ACTIONS(2071),
    [sym_backslash_escape] = ACTIONS(2071),
    [anon_sym_LT] = ACTIONS(2074),
    [sym_symbol] = ACTIONS(2068),
    [anon_sym_LBRACE_] = ACTIONS(2077),
    [anon_sym__] = ACTIONS(2080),
    [anon_sym_LBRACE_STAR] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2086),
    [anon_sym_LBRACE_CARET] = ACTIONS(2089),
    [anon_sym_CARET] = ACTIONS(2089),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2092),
    [anon_sym_TILDE] = ACTIONS(2092),
    [anon_sym_LBRACE_EQ] = ACTIONS(2095),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2098),
    [anon_sym_LBRACE_DASH] = ACTIONS(2101),
    [anon_sym_LBRACK_CARET] = ACTIONS(2104),
    [anon_sym_BANG_LBRACK] = ACTIONS(2107),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2110),
    [anon_sym_LPAREN] = ACTIONS(2113),
    [anon_sym_DOLLAR] = ACTIONS(2116),
    [anon_sym_TODO] = ACTIONS(2119),
    [anon_sym_WIP] = ACTIONS(2119),
    [anon_sym_NOTE] = ACTIONS(2122),
    [anon_sym_INFO] = ACTIONS(2122),
    [anon_sym_XXX] = ACTIONS(2122),
    [sym_fixme] = ACTIONS(2068),
    [aux_sym__text_token1] = ACTIONS(2125),
    [sym__newline_inline] = ACTIONS(2128),
    [sym_hard_line_break] = ACTIONS(2068),
    [sym__verbatim_begin] = ACTIONS(2131),
    [sym__square_bracket_span_end] = ACTIONS(1241),
  },
  [161] = {
    [sym__inline_without_trailing_space] = STATE(2322),
    [sym__inline_element] = STATE(959),
    [sym__smart_punctuation] = STATE(464),
    [sym_autolink] = STATE(464),
    [sym_emphasis] = STATE(465),
    [sym_emphasis_begin] = STATE(2498),
    [sym_strong] = STATE(465),
    [sym_strong_begin] = STATE(2499),
    [sym_superscript] = STATE(465),
    [sym_superscript_begin] = STATE(2500),
    [sym_subscript] = STATE(465),
    [sym_subscript_begin] = STATE(2501),
    [sym_highlighted] = STATE(465),
    [sym_highlighted_begin] = STATE(2502),
    [sym_insert] = STATE(465),
    [sym_insert_begin] = STATE(2503),
    [sym_delete] = STATE(465),
    [sym_delete_begin] = STATE(2504),
    [sym_footnote_reference] = STATE(465),
    [sym_footnote_marker_begin] = STATE(2505),
    [sym__image] = STATE(465),
    [sym_full_reference_image] = STATE(465),
    [sym_collapsed_reference_image] = STATE(465),
    [sym_inline_image] = STATE(465),
    [sym_image_description] = STATE(1314),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(465),
    [sym_full_reference_link] = STATE(465),
    [sym_collapsed_reference_link] = STATE(465),
    [sym_inline_link] = STATE(465),
    [sym_link_text] = STATE(1319),
    [sym_span] = STATE(959),
    [sym__bracketed_text_begin] = STATE(2610),
    [sym_inline_comment] = STATE(464),
    [sym_raw_inline] = STATE(464),
    [sym_math] = STATE(464),
    [sym_verbatim] = STATE(464),
    [sym__todo_highlights] = STATE(464),
    [sym_todo] = STATE(464),
    [sym_note] = STATE(464),
    [sym__symbol_fallback] = STATE(464),
    [aux_sym__text] = STATE(445),
    [aux_sym__inline_repeat1] = STATE(287),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [sym__whitespace1] = ACTIONS(2136),
    [sym_quotation_marks] = ACTIONS(2138),
    [sym_ellipsis] = ACTIONS(2138),
    [sym_em_dash] = ACTIONS(2138),
    [sym_en_dash] = ACTIONS(2140),
    [sym_backslash_escape] = ACTIONS(2140),
    [anon_sym_LT] = ACTIONS(2142),
    [sym_symbol] = ACTIONS(2138),
    [anon_sym_LBRACE_] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_LBRACE_STAR] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_LBRACE_CARET] = ACTIONS(2152),
    [anon_sym_CARET] = ACTIONS(2152),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACE_EQ] = ACTIONS(2156),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2158),
    [anon_sym_LBRACE_DASH] = ACTIONS(2160),
    [anon_sym_LBRACK_CARET] = ACTIONS(2162),
    [anon_sym_BANG_LBRACK] = ACTIONS(2164),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_TODO] = ACTIONS(2172),
    [anon_sym_WIP] = ACTIONS(2172),
    [anon_sym_NOTE] = ACTIONS(2174),
    [anon_sym_INFO] = ACTIONS(2174),
    [anon_sym_XXX] = ACTIONS(2174),
    [sym_fixme] = ACTIONS(2138),
    [aux_sym__text_token1] = ACTIONS(2176),
    [sym__newline_inline] = ACTIONS(2178),
    [sym_hard_line_break] = ACTIONS(2138),
    [sym__verbatim_begin] = ACTIONS(2180),
  },
  [162] = {
    [sym__inline] = STATE(2427),
    [sym__inline_element] = STATE(1017),
    [sym__smart_punctuation] = STATE(468),
    [sym_autolink] = STATE(468),
    [sym_emphasis] = STATE(469),
    [sym_emphasis_begin] = STATE(2511),
    [sym_strong] = STATE(469),
    [sym_strong_begin] = STATE(2512),
    [sym_superscript] = STATE(469),
    [sym_superscript_begin] = STATE(2513),
    [sym_subscript] = STATE(469),
    [sym_subscript_begin] = STATE(2514),
    [sym_highlighted] = STATE(469),
    [sym_highlighted_begin] = STATE(2515),
    [sym_insert] = STATE(469),
    [sym_insert_begin] = STATE(2516),
    [sym_delete] = STATE(469),
    [sym_delete_begin] = STATE(2517),
    [sym_footnote_reference] = STATE(469),
    [sym_footnote_marker_begin] = STATE(2518),
    [sym__image] = STATE(469),
    [sym_full_reference_image] = STATE(469),
    [sym_collapsed_reference_image] = STATE(469),
    [sym_inline_image] = STATE(469),
    [sym_image_description] = STATE(1325),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(469),
    [sym_full_reference_link] = STATE(469),
    [sym_collapsed_reference_link] = STATE(469),
    [sym_inline_link] = STATE(469),
    [sym_link_text] = STATE(1326),
    [sym_span] = STATE(1017),
    [sym__bracketed_text_begin] = STATE(2613),
    [sym_inline_comment] = STATE(468),
    [sym_raw_inline] = STATE(468),
    [sym_math] = STATE(468),
    [sym_verbatim] = STATE(468),
    [sym__todo_highlights] = STATE(468),
    [sym_todo] = STATE(468),
    [sym_note] = STATE(468),
    [sym__symbol_fallback] = STATE(468),
    [aux_sym__text] = STATE(446),
    [aux_sym__inline_repeat1] = STATE(146),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [sym__whitespace1] = ACTIONS(1340),
    [sym_quotation_marks] = ACTIONS(1342),
    [sym_ellipsis] = ACTIONS(1342),
    [sym_em_dash] = ACTIONS(1342),
    [sym_en_dash] = ACTIONS(1344),
    [sym_backslash_escape] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [sym_symbol] = ACTIONS(1342),
    [anon_sym_LBRACE_] = ACTIONS(1348),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_LBRACE_STAR] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_LBRACE_CARET] = ACTIONS(1356),
    [anon_sym_CARET] = ACTIONS(1356),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_LBRACE_EQ] = ACTIONS(1360),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1362),
    [anon_sym_LBRACE_DASH] = ACTIONS(1364),
    [anon_sym_LBRACK_CARET] = ACTIONS(1366),
    [anon_sym_BANG_LBRACK] = ACTIONS(1368),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1374),
    [anon_sym_TODO] = ACTIONS(1376),
    [anon_sym_WIP] = ACTIONS(1376),
    [anon_sym_NOTE] = ACTIONS(1378),
    [anon_sym_INFO] = ACTIONS(1378),
    [anon_sym_XXX] = ACTIONS(1378),
    [sym_fixme] = ACTIONS(1342),
    [aux_sym__text_token1] = ACTIONS(1380),
    [sym__newline_inline] = ACTIONS(2182),
    [sym_hard_line_break] = ACTIONS(1342),
    [sym__verbatim_begin] = ACTIONS(1384),
  },
  [163] = {
    [sym__inline] = STATE(2429),
    [sym__inline_element] = STATE(915),
    [sym__smart_punctuation] = STATE(470),
    [sym_autolink] = STATE(470),
    [sym_emphasis] = STATE(471),
    [sym_emphasis_begin] = STATE(2522),
    [sym_strong] = STATE(471),
    [sym_strong_begin] = STATE(2523),
    [sym_superscript] = STATE(471),
    [sym_superscript_begin] = STATE(2524),
    [sym_subscript] = STATE(471),
    [sym_subscript_begin] = STATE(2525),
    [sym_highlighted] = STATE(471),
    [sym_highlighted_begin] = STATE(2526),
    [sym_insert] = STATE(471),
    [sym_insert_begin] = STATE(2527),
    [sym_delete] = STATE(471),
    [sym_delete_begin] = STATE(2528),
    [sym_footnote_reference] = STATE(471),
    [sym_footnote_marker_begin] = STATE(2529),
    [sym__image] = STATE(471),
    [sym_full_reference_image] = STATE(471),
    [sym_collapsed_reference_image] = STATE(471),
    [sym_inline_image] = STATE(471),
    [sym_image_description] = STATE(1332),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(471),
    [sym_full_reference_link] = STATE(471),
    [sym_collapsed_reference_link] = STATE(471),
    [sym_inline_link] = STATE(471),
    [sym_link_text] = STATE(1334),
    [sym_span] = STATE(915),
    [sym__bracketed_text_begin] = STATE(2614),
    [sym_inline_comment] = STATE(470),
    [sym_raw_inline] = STATE(470),
    [sym_math] = STATE(470),
    [sym_verbatim] = STATE(470),
    [sym__todo_highlights] = STATE(470),
    [sym_todo] = STATE(470),
    [sym_note] = STATE(470),
    [sym__symbol_fallback] = STATE(470),
    [aux_sym__text] = STATE(447),
    [aux_sym__inline_repeat1] = STATE(148),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [sym__whitespace1] = ACTIONS(1460),
    [sym_quotation_marks] = ACTIONS(1462),
    [sym_ellipsis] = ACTIONS(1462),
    [sym_em_dash] = ACTIONS(1462),
    [sym_en_dash] = ACTIONS(1464),
    [sym_backslash_escape] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [sym_symbol] = ACTIONS(1462),
    [anon_sym_LBRACE_] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(1470),
    [anon_sym_LBRACE_STAR] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACE_CARET] = ACTIONS(1476),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_LBRACE_EQ] = ACTIONS(1480),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1482),
    [anon_sym_LBRACE_DASH] = ACTIONS(1484),
    [anon_sym_LBRACK_CARET] = ACTIONS(1486),
    [anon_sym_BANG_LBRACK] = ACTIONS(1488),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_TODO] = ACTIONS(1496),
    [anon_sym_WIP] = ACTIONS(1496),
    [anon_sym_NOTE] = ACTIONS(1498),
    [anon_sym_INFO] = ACTIONS(1498),
    [anon_sym_XXX] = ACTIONS(1498),
    [sym_fixme] = ACTIONS(1462),
    [aux_sym__text_token1] = ACTIONS(1500),
    [sym__newline_inline] = ACTIONS(2184),
    [sym_hard_line_break] = ACTIONS(1462),
    [sym__verbatim_begin] = ACTIONS(1504),
  },
  [164] = {
    [sym__inline] = STATE(2441),
    [sym__inline_element] = STATE(1021),
    [sym__smart_punctuation] = STATE(473),
    [sym_autolink] = STATE(473),
    [sym_emphasis] = STATE(450),
    [sym_emphasis_begin] = STATE(2533),
    [sym_strong] = STATE(450),
    [sym_strong_begin] = STATE(2534),
    [sym_superscript] = STATE(450),
    [sym_superscript_begin] = STATE(2535),
    [sym_subscript] = STATE(450),
    [sym_subscript_begin] = STATE(2536),
    [sym_highlighted] = STATE(450),
    [sym_highlighted_begin] = STATE(2537),
    [sym_insert] = STATE(450),
    [sym_insert_begin] = STATE(2538),
    [sym_delete] = STATE(450),
    [sym_delete_begin] = STATE(2539),
    [sym_footnote_reference] = STATE(450),
    [sym_footnote_marker_begin] = STATE(2540),
    [sym__image] = STATE(450),
    [sym_full_reference_image] = STATE(450),
    [sym_collapsed_reference_image] = STATE(450),
    [sym_inline_image] = STATE(450),
    [sym_image_description] = STATE(1340),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(450),
    [sym_full_reference_link] = STATE(450),
    [sym_collapsed_reference_link] = STATE(450),
    [sym_inline_link] = STATE(450),
    [sym_link_text] = STATE(1341),
    [sym_span] = STATE(1021),
    [sym__bracketed_text_begin] = STATE(2615),
    [sym_inline_comment] = STATE(473),
    [sym_raw_inline] = STATE(473),
    [sym_math] = STATE(473),
    [sym_verbatim] = STATE(473),
    [sym__todo_highlights] = STATE(473),
    [sym_todo] = STATE(473),
    [sym_note] = STATE(473),
    [sym__symbol_fallback] = STATE(473),
    [aux_sym__text] = STATE(448),
    [aux_sym__inline_repeat1] = STATE(150),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [sym__whitespace1] = ACTIONS(1580),
    [sym_quotation_marks] = ACTIONS(1582),
    [sym_ellipsis] = ACTIONS(1582),
    [sym_em_dash] = ACTIONS(1582),
    [sym_en_dash] = ACTIONS(1584),
    [sym_backslash_escape] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1586),
    [sym_symbol] = ACTIONS(1582),
    [anon_sym_LBRACE_] = ACTIONS(1588),
    [anon_sym__] = ACTIONS(1590),
    [anon_sym_LBRACE_STAR] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_LBRACE_CARET] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_LBRACE_EQ] = ACTIONS(1600),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1602),
    [anon_sym_LBRACE_DASH] = ACTIONS(1604),
    [anon_sym_LBRACK_CARET] = ACTIONS(1606),
    [anon_sym_BANG_LBRACK] = ACTIONS(1608),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_DOLLAR] = ACTIONS(1614),
    [anon_sym_TODO] = ACTIONS(1616),
    [anon_sym_WIP] = ACTIONS(1616),
    [anon_sym_NOTE] = ACTIONS(1618),
    [anon_sym_INFO] = ACTIONS(1618),
    [anon_sym_XXX] = ACTIONS(1618),
    [sym_fixme] = ACTIONS(1582),
    [aux_sym__text_token1] = ACTIONS(1620),
    [sym__newline_inline] = ACTIONS(2186),
    [sym_hard_line_break] = ACTIONS(1582),
    [sym__verbatim_begin] = ACTIONS(1624),
  },
  [165] = {
    [sym__inline] = STATE(2621),
    [sym__inline_element] = STATE(997),
    [sym__smart_punctuation] = STATE(451),
    [sym_autolink] = STATE(451),
    [sym_emphasis] = STATE(449),
    [sym_emphasis_begin] = STATE(2544),
    [sym_strong] = STATE(449),
    [sym_strong_begin] = STATE(2545),
    [sym_superscript] = STATE(449),
    [sym_superscript_begin] = STATE(2546),
    [sym_subscript] = STATE(449),
    [sym_subscript_begin] = STATE(2547),
    [sym_highlighted] = STATE(449),
    [sym_highlighted_begin] = STATE(2548),
    [sym_insert] = STATE(449),
    [sym_insert_begin] = STATE(2549),
    [sym_delete] = STATE(449),
    [sym_delete_begin] = STATE(2550),
    [sym_footnote_reference] = STATE(449),
    [sym_footnote_marker_begin] = STATE(2551),
    [sym__image] = STATE(449),
    [sym_full_reference_image] = STATE(449),
    [sym_collapsed_reference_image] = STATE(449),
    [sym_inline_image] = STATE(449),
    [sym_image_description] = STATE(1250),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(449),
    [sym_full_reference_link] = STATE(449),
    [sym_collapsed_reference_link] = STATE(449),
    [sym_inline_link] = STATE(449),
    [sym_link_text] = STATE(1251),
    [sym_span] = STATE(997),
    [sym__bracketed_text_begin] = STATE(2616),
    [sym_inline_comment] = STATE(451),
    [sym_raw_inline] = STATE(451),
    [sym_math] = STATE(451),
    [sym_verbatim] = STATE(451),
    [sym__todo_highlights] = STATE(451),
    [sym_todo] = STATE(451),
    [sym_note] = STATE(451),
    [sym__symbol_fallback] = STATE(451),
    [aux_sym__text] = STATE(439),
    [aux_sym__inline_repeat1] = STATE(152),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [sym__whitespace1] = ACTIONS(1074),
    [sym_quotation_marks] = ACTIONS(1076),
    [sym_ellipsis] = ACTIONS(1076),
    [sym_em_dash] = ACTIONS(1076),
    [sym_en_dash] = ACTIONS(1078),
    [sym_backslash_escape] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(1080),
    [sym_symbol] = ACTIONS(1076),
    [anon_sym_LBRACE_] = ACTIONS(1082),
    [anon_sym__] = ACTIONS(1084),
    [anon_sym_LBRACE_STAR] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_LBRACE_CARET] = ACTIONS(1090),
    [anon_sym_CARET] = ACTIONS(1090),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_LBRACE_EQ] = ACTIONS(1094),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1096),
    [anon_sym_LBRACE_DASH] = ACTIONS(1098),
    [anon_sym_LBRACK_CARET] = ACTIONS(1100),
    [anon_sym_BANG_LBRACK] = ACTIONS(1102),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [anon_sym_TODO] = ACTIONS(1110),
    [anon_sym_WIP] = ACTIONS(1110),
    [anon_sym_NOTE] = ACTIONS(1112),
    [anon_sym_INFO] = ACTIONS(1112),
    [anon_sym_XXX] = ACTIONS(1112),
    [sym_fixme] = ACTIONS(1076),
    [aux_sym__text_token1] = ACTIONS(1114),
    [sym__newline_inline] = ACTIONS(1116),
    [sym_hard_line_break] = ACTIONS(1076),
    [sym__verbatim_begin] = ACTIONS(1118),
  },
  [166] = {
    [sym__inline] = STATE(2623),
    [sym__inline_element] = STATE(900),
    [sym__smart_punctuation] = STATE(454),
    [sym_autolink] = STATE(454),
    [sym_emphasis] = STATE(455),
    [sym_emphasis_begin] = STATE(2555),
    [sym_strong] = STATE(455),
    [sym_strong_begin] = STATE(2556),
    [sym_superscript] = STATE(455),
    [sym_superscript_begin] = STATE(2557),
    [sym_subscript] = STATE(455),
    [sym_subscript_begin] = STATE(2558),
    [sym_highlighted] = STATE(455),
    [sym_highlighted_begin] = STATE(2559),
    [sym_insert] = STATE(455),
    [sym_insert_begin] = STATE(2560),
    [sym_delete] = STATE(455),
    [sym_delete_begin] = STATE(2561),
    [sym_footnote_reference] = STATE(455),
    [sym_footnote_marker_begin] = STATE(2562),
    [sym__image] = STATE(455),
    [sym_full_reference_image] = STATE(455),
    [sym_collapsed_reference_image] = STATE(455),
    [sym_inline_image] = STATE(455),
    [sym_image_description] = STATE(1257),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(455),
    [sym_full_reference_link] = STATE(455),
    [sym_collapsed_reference_link] = STATE(455),
    [sym_inline_link] = STATE(455),
    [sym_link_text] = STATE(1258),
    [sym_span] = STATE(900),
    [sym__bracketed_text_begin] = STATE(2617),
    [sym_inline_comment] = STATE(454),
    [sym_raw_inline] = STATE(454),
    [sym_math] = STATE(454),
    [sym_verbatim] = STATE(454),
    [sym__todo_highlights] = STATE(454),
    [sym_todo] = STATE(454),
    [sym_note] = STATE(454),
    [sym__symbol_fallback] = STATE(454),
    [aux_sym__text] = STATE(441),
    [aux_sym__inline_repeat1] = STATE(155),
    [anon_sym_LBRACK] = ACTIONS(1820),
    [sym__whitespace1] = ACTIONS(1822),
    [sym_quotation_marks] = ACTIONS(1824),
    [sym_ellipsis] = ACTIONS(1824),
    [sym_em_dash] = ACTIONS(1824),
    [sym_en_dash] = ACTIONS(1826),
    [sym_backslash_escape] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1828),
    [sym_symbol] = ACTIONS(1824),
    [anon_sym_LBRACE_] = ACTIONS(1830),
    [anon_sym__] = ACTIONS(1832),
    [anon_sym_LBRACE_STAR] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_LBRACE_CARET] = ACTIONS(1838),
    [anon_sym_CARET] = ACTIONS(1838),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1840),
    [anon_sym_TILDE] = ACTIONS(1840),
    [anon_sym_LBRACE_EQ] = ACTIONS(1842),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1844),
    [anon_sym_LBRACE_DASH] = ACTIONS(1846),
    [anon_sym_LBRACK_CARET] = ACTIONS(1848),
    [anon_sym_BANG_LBRACK] = ACTIONS(1850),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1856),
    [anon_sym_TODO] = ACTIONS(1858),
    [anon_sym_WIP] = ACTIONS(1858),
    [anon_sym_NOTE] = ACTIONS(1860),
    [anon_sym_INFO] = ACTIONS(1860),
    [anon_sym_XXX] = ACTIONS(1860),
    [sym_fixme] = ACTIONS(1824),
    [aux_sym__text_token1] = ACTIONS(1862),
    [sym__newline_inline] = ACTIONS(2188),
    [sym_hard_line_break] = ACTIONS(1824),
    [sym__verbatim_begin] = ACTIONS(1866),
  },
  [167] = {
    [sym__inline] = STATE(1977),
    [sym__inline_element] = STATE(1014),
    [sym__smart_punctuation] = STATE(456),
    [sym_autolink] = STATE(456),
    [sym_emphasis] = STATE(457),
    [sym_emphasis_begin] = STATE(2566),
    [sym_strong] = STATE(457),
    [sym_strong_begin] = STATE(2567),
    [sym_superscript] = STATE(457),
    [sym_superscript_begin] = STATE(2568),
    [sym_subscript] = STATE(457),
    [sym_subscript_begin] = STATE(2569),
    [sym_highlighted] = STATE(457),
    [sym_highlighted_begin] = STATE(2570),
    [sym_insert] = STATE(457),
    [sym_insert_begin] = STATE(2571),
    [sym_delete] = STATE(457),
    [sym_delete_begin] = STATE(1976),
    [sym_footnote_reference] = STATE(457),
    [sym_footnote_marker_begin] = STATE(2573),
    [sym__image] = STATE(457),
    [sym_full_reference_image] = STATE(457),
    [sym_collapsed_reference_image] = STATE(457),
    [sym_inline_image] = STATE(457),
    [sym_image_description] = STATE(1264),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(457),
    [sym_full_reference_link] = STATE(457),
    [sym_collapsed_reference_link] = STATE(457),
    [sym_inline_link] = STATE(457),
    [sym_link_text] = STATE(1265),
    [sym_span] = STATE(1014),
    [sym__bracketed_text_begin] = STATE(2618),
    [sym_inline_comment] = STATE(456),
    [sym_raw_inline] = STATE(456),
    [sym_math] = STATE(456),
    [sym_verbatim] = STATE(456),
    [sym__todo_highlights] = STATE(456),
    [sym_todo] = STATE(456),
    [sym_note] = STATE(456),
    [sym__symbol_fallback] = STATE(456),
    [aux_sym__text] = STATE(440),
    [aux_sym__inline_repeat1] = STATE(157),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [sym__whitespace1] = ACTIONS(1942),
    [sym_quotation_marks] = ACTIONS(1944),
    [sym_ellipsis] = ACTIONS(1944),
    [sym_em_dash] = ACTIONS(1944),
    [sym_en_dash] = ACTIONS(1946),
    [sym_backslash_escape] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1948),
    [sym_symbol] = ACTIONS(1944),
    [anon_sym_LBRACE_] = ACTIONS(1950),
    [anon_sym__] = ACTIONS(1952),
    [anon_sym_LBRACE_STAR] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_LBRACE_CARET] = ACTIONS(1958),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_LBRACE_EQ] = ACTIONS(1962),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1964),
    [anon_sym_LBRACE_DASH] = ACTIONS(1966),
    [anon_sym_LBRACK_CARET] = ACTIONS(1968),
    [anon_sym_BANG_LBRACK] = ACTIONS(1970),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1974),
    [anon_sym_DOLLAR] = ACTIONS(1976),
    [anon_sym_TODO] = ACTIONS(1978),
    [anon_sym_WIP] = ACTIONS(1978),
    [anon_sym_NOTE] = ACTIONS(1980),
    [anon_sym_INFO] = ACTIONS(1980),
    [anon_sym_XXX] = ACTIONS(1980),
    [sym_fixme] = ACTIONS(1944),
    [aux_sym__text_token1] = ACTIONS(1982),
    [sym__newline_inline] = ACTIONS(2190),
    [sym_hard_line_break] = ACTIONS(1944),
    [sym__verbatim_begin] = ACTIONS(1986),
  },
  [168] = {
    [sym__inline] = STATE(2012),
    [sym__inline_element] = STATE(978),
    [sym__smart_punctuation] = STATE(458),
    [sym_autolink] = STATE(458),
    [sym_emphasis] = STATE(462),
    [sym_emphasis_begin] = STATE(2577),
    [sym_strong] = STATE(462),
    [sym_strong_begin] = STATE(2578),
    [sym_superscript] = STATE(462),
    [sym_superscript_begin] = STATE(2579),
    [sym_subscript] = STATE(462),
    [sym_subscript_begin] = STATE(2580),
    [sym_highlighted] = STATE(462),
    [sym_highlighted_begin] = STATE(2581),
    [sym_insert] = STATE(462),
    [sym_insert_begin] = STATE(2582),
    [sym_delete] = STATE(462),
    [sym_delete_begin] = STATE(2583),
    [sym_footnote_reference] = STATE(462),
    [sym_footnote_marker_begin] = STATE(2584),
    [sym__image] = STATE(462),
    [sym_full_reference_image] = STATE(462),
    [sym_collapsed_reference_image] = STATE(462),
    [sym_inline_image] = STATE(462),
    [sym_image_description] = STATE(1271),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(462),
    [sym_full_reference_link] = STATE(462),
    [sym_collapsed_reference_link] = STATE(462),
    [sym_inline_link] = STATE(462),
    [sym_link_text] = STATE(1272),
    [sym_span] = STATE(978),
    [sym__bracketed_text_begin] = STATE(2619),
    [sym_inline_comment] = STATE(458),
    [sym_raw_inline] = STATE(458),
    [sym_math] = STATE(458),
    [sym_verbatim] = STATE(458),
    [sym__todo_highlights] = STATE(458),
    [sym_todo] = STATE(458),
    [sym_note] = STATE(458),
    [sym__symbol_fallback] = STATE(458),
    [aux_sym__text] = STATE(442),
    [aux_sym__inline_repeat1] = STATE(159),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [sym__whitespace1] = ACTIONS(1024),
    [sym_quotation_marks] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1026),
    [sym_em_dash] = ACTIONS(1026),
    [sym_en_dash] = ACTIONS(1028),
    [sym_backslash_escape] = ACTIONS(1028),
    [anon_sym_LT] = ACTIONS(1030),
    [sym_symbol] = ACTIONS(1026),
    [anon_sym_LBRACE_] = ACTIONS(1032),
    [anon_sym__] = ACTIONS(1034),
    [anon_sym_LBRACE_STAR] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_LBRACE_CARET] = ACTIONS(1040),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_LBRACE_EQ] = ACTIONS(1044),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1046),
    [anon_sym_LBRACE_DASH] = ACTIONS(1048),
    [anon_sym_LBRACK_CARET] = ACTIONS(1050),
    [anon_sym_BANG_LBRACK] = ACTIONS(1052),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1058),
    [anon_sym_TODO] = ACTIONS(1060),
    [anon_sym_WIP] = ACTIONS(1060),
    [anon_sym_NOTE] = ACTIONS(1062),
    [anon_sym_INFO] = ACTIONS(1062),
    [anon_sym_XXX] = ACTIONS(1062),
    [sym_fixme] = ACTIONS(1026),
    [aux_sym__text_token1] = ACTIONS(1064),
    [sym__newline_inline] = ACTIONS(1066),
    [sym_hard_line_break] = ACTIONS(1026),
    [sym__verbatim_begin] = ACTIONS(1068),
  },
  [169] = {
    [sym__table_row] = STATE(169),
    [sym_table_header] = STATE(169),
    [sym_table_separator] = STATE(169),
    [sym_table_row] = STATE(169),
    [sym__block_quote_prefix] = STATE(1303),
    [aux_sym_table_repeat1] = STATE(169),
    [aux_sym__block_quote_prefix_repeat1] = STATE(1345),
    [ts_builtin_sym_end] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(1322),
    [sym__whitespace1] = ACTIONS(1324),
    [sym_quotation_marks] = ACTIONS(1324),
    [sym_ellipsis] = ACTIONS(1324),
    [sym_em_dash] = ACTIONS(1324),
    [sym_en_dash] = ACTIONS(1322),
    [sym_backslash_escape] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [sym_symbol] = ACTIONS(1324),
    [anon_sym_LBRACE_] = ACTIONS(1324),
    [anon_sym__] = ACTIONS(1324),
    [anon_sym_LBRACE_STAR] = ACTIONS(1324),
    [anon_sym_STAR] = ACTIONS(1324),
    [anon_sym_LBRACE_CARET] = ACTIONS(1324),
    [anon_sym_CARET] = ACTIONS(1324),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1324),
    [anon_sym_TILDE] = ACTIONS(1324),
    [anon_sym_LBRACE_EQ] = ACTIONS(1324),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1324),
    [anon_sym_LBRACE_DASH] = ACTIONS(1324),
    [anon_sym_LBRACK_CARET] = ACTIONS(1324),
    [anon_sym_BANG_LBRACK] = ACTIONS(1324),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(1324),
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [anon_sym_TODO] = ACTIONS(1324),
    [anon_sym_WIP] = ACTIONS(1324),
    [anon_sym_NOTE] = ACTIONS(1324),
    [anon_sym_INFO] = ACTIONS(1324),
    [anon_sym_XXX] = ACTIONS(1324),
    [sym_fixme] = ACTIONS(1324),
    [aux_sym__text_token1] = ACTIONS(1322),
    [sym__newline] = ACTIONS(1324),
    [sym__newline_inline] = ACTIONS(1324),
    [sym_hard_line_break] = ACTIONS(1324),
    [sym__heading_begin] = ACTIONS(1324),
    [sym__div_begin] = ACTIONS(1324),
    [sym__code_block_begin] = ACTIONS(1324),
    [sym_list_marker_dash] = ACTIONS(1324),
    [sym_list_marker_star] = ACTIONS(1324),
    [sym_list_marker_plus] = ACTIONS(1324),
    [sym__list_marker_task_begin] = ACTIONS(1324),
    [sym_list_marker_definition] = ACTIONS(1324),
    [sym_list_marker_decimal_period] = ACTIONS(1324),
    [sym_list_marker_lower_alpha_period] = ACTIONS(1324),
    [sym_list_marker_upper_alpha_period] = ACTIONS(1324),
    [sym_list_marker_lower_roman_period] = ACTIONS(1324),
    [sym_list_marker_upper_roman_period] = ACTIONS(1324),
    [sym_list_marker_decimal_paren] = ACTIONS(1324),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(1324),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(1324),
    [sym_list_marker_lower_roman_paren] = ACTIONS(1324),
    [sym_list_marker_upper_roman_paren] = ACTIONS(1324),
    [sym_list_marker_decimal_parens] = ACTIONS(1324),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(1324),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(1324),
    [sym_list_marker_lower_roman_parens] = ACTIONS(1324),
    [sym_list_marker_upper_roman_parens] = ACTIONS(1324),
    [sym__block_quote_begin] = ACTIONS(1324),
    [sym__block_quote_continuation] = ACTIONS(1326),
    [sym__thematic_break_dash] = ACTIONS(1324),
    [sym__thematic_break_star] = ACTIONS(1324),
    [sym__footnote_mark_begin] = ACTIONS(1324),
    [sym__link_ref_def_mark_begin] = ACTIONS(1324),
    [sym__table_header_begin] = ACTIONS(2192),
    [sym__table_separator_begin] = ACTIONS(2195),
    [sym__table_row_begin] = ACTIONS(2198),
    [sym__table_caption_begin] = ACTIONS(1324),
    [sym__block_attribute_begin] = ACTIONS(1324),
    [sym__verbatim_begin] = ACTIONS(1324),
  },
  [170] = {
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(170),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [sym__whitespace1] = ACTIONS(2204),
    [sym_quotation_marks] = ACTIONS(2207),
    [sym_ellipsis] = ACTIONS(2207),
    [sym_em_dash] = ACTIONS(2207),
    [sym_en_dash] = ACTIONS(2210),
    [sym_backslash_escape] = ACTIONS(2210),
    [anon_sym_LT] = ACTIONS(2213),
    [sym_symbol] = ACTIONS(2207),
    [anon_sym_LBRACE_] = ACTIONS(2216),
    [anon_sym__] = ACTIONS(2219),
    [anon_sym_LBRACE_STAR] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_LBRACE_CARET] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2228),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2231),
    [anon_sym_TILDE] = ACTIONS(2231),
    [anon_sym_LBRACE_EQ] = ACTIONS(2234),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2237),
    [anon_sym_LBRACE_DASH] = ACTIONS(2240),
    [anon_sym_LBRACK_CARET] = ACTIONS(2243),
    [anon_sym_BANG_LBRACK] = ACTIONS(2246),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2249),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_DOLLAR] = ACTIONS(2255),
    [anon_sym_TODO] = ACTIONS(2258),
    [anon_sym_WIP] = ACTIONS(2258),
    [anon_sym_NOTE] = ACTIONS(2261),
    [anon_sym_INFO] = ACTIONS(2261),
    [anon_sym_XXX] = ACTIONS(2261),
    [sym_fixme] = ACTIONS(2207),
    [aux_sym__text_token1] = ACTIONS(2264),
    [sym__eof_or_newline] = ACTIONS(1241),
    [sym__newline_inline] = ACTIONS(2267),
    [sym_hard_line_break] = ACTIONS(2207),
    [sym__verbatim_begin] = ACTIONS(2270),
  },
  [171] = {
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(170),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__eof_or_newline] = ACTIONS(1168),
    [sym__newline_inline] = ACTIONS(1168),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [172] = {
    [sym__inline] = STATE(1415),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [173] = {
    [sym__inline_without_trailing_space] = STATE(2352),
    [sym__inline_element] = STATE(988),
    [sym__smart_punctuation] = STATE(460),
    [sym_autolink] = STATE(460),
    [sym_emphasis] = STATE(463),
    [sym_emphasis_begin] = STATE(2484),
    [sym_strong] = STATE(463),
    [sym_strong_begin] = STATE(2485),
    [sym_superscript] = STATE(463),
    [sym_superscript_begin] = STATE(2486),
    [sym_subscript] = STATE(463),
    [sym_subscript_begin] = STATE(2487),
    [sym_highlighted] = STATE(463),
    [sym_highlighted_begin] = STATE(2488),
    [sym_insert] = STATE(463),
    [sym_insert_begin] = STATE(2489),
    [sym_delete] = STATE(463),
    [sym_delete_begin] = STATE(2490),
    [sym_footnote_reference] = STATE(463),
    [sym_footnote_marker_begin] = STATE(2491),
    [sym__image] = STATE(463),
    [sym_full_reference_image] = STATE(463),
    [sym_collapsed_reference_image] = STATE(463),
    [sym_inline_image] = STATE(463),
    [sym_image_description] = STATE(1268),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(463),
    [sym_full_reference_link] = STATE(463),
    [sym_collapsed_reference_link] = STATE(463),
    [sym_inline_link] = STATE(463),
    [sym_link_text] = STATE(1273),
    [sym_span] = STATE(988),
    [sym__bracketed_text_begin] = STATE(2607),
    [sym_inline_comment] = STATE(460),
    [sym_raw_inline] = STATE(460),
    [sym_math] = STATE(460),
    [sym_verbatim] = STATE(460),
    [sym__todo_highlights] = STATE(460),
    [sym_todo] = STATE(460),
    [sym_note] = STATE(460),
    [sym__symbol_fallback] = STATE(460),
    [aux_sym__text] = STATE(444),
    [aux_sym__inline_repeat1] = STATE(286),
    [anon_sym_LBRACK] = ACTIONS(1772),
    [sym__whitespace1] = ACTIONS(1774),
    [sym_quotation_marks] = ACTIONS(1776),
    [sym_ellipsis] = ACTIONS(1776),
    [sym_em_dash] = ACTIONS(1776),
    [sym_en_dash] = ACTIONS(1778),
    [sym_backslash_escape] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1780),
    [sym_symbol] = ACTIONS(1776),
    [anon_sym_LBRACE_] = ACTIONS(1782),
    [anon_sym__] = ACTIONS(1784),
    [anon_sym_LBRACE_STAR] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_LBRACE_CARET] = ACTIONS(1790),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1792),
    [anon_sym_LBRACE_EQ] = ACTIONS(1794),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1796),
    [anon_sym_LBRACE_DASH] = ACTIONS(1798),
    [anon_sym_LBRACK_CARET] = ACTIONS(1800),
    [anon_sym_BANG_LBRACK] = ACTIONS(1802),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1804),
    [anon_sym_LPAREN] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [anon_sym_TODO] = ACTIONS(1810),
    [anon_sym_WIP] = ACTIONS(1810),
    [anon_sym_NOTE] = ACTIONS(1812),
    [anon_sym_INFO] = ACTIONS(1812),
    [anon_sym_XXX] = ACTIONS(1812),
    [sym_fixme] = ACTIONS(1776),
    [aux_sym__text_token1] = ACTIONS(1814),
    [sym__newline_inline] = ACTIONS(1816),
    [sym_hard_line_break] = ACTIONS(1776),
    [sym__verbatim_begin] = ACTIONS(1818),
  },
  [174] = {
    [sym__inline_without_trailing_space] = STATE(2354),
    [sym__inline_element] = STATE(959),
    [sym__smart_punctuation] = STATE(464),
    [sym_autolink] = STATE(464),
    [sym_emphasis] = STATE(465),
    [sym_emphasis_begin] = STATE(2498),
    [sym_strong] = STATE(465),
    [sym_strong_begin] = STATE(2499),
    [sym_superscript] = STATE(465),
    [sym_superscript_begin] = STATE(2500),
    [sym_subscript] = STATE(465),
    [sym_subscript_begin] = STATE(2501),
    [sym_highlighted] = STATE(465),
    [sym_highlighted_begin] = STATE(2502),
    [sym_insert] = STATE(465),
    [sym_insert_begin] = STATE(2503),
    [sym_delete] = STATE(465),
    [sym_delete_begin] = STATE(2504),
    [sym_footnote_reference] = STATE(465),
    [sym_footnote_marker_begin] = STATE(2505),
    [sym__image] = STATE(465),
    [sym_full_reference_image] = STATE(465),
    [sym_collapsed_reference_image] = STATE(465),
    [sym_inline_image] = STATE(465),
    [sym_image_description] = STATE(1314),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(465),
    [sym_full_reference_link] = STATE(465),
    [sym_collapsed_reference_link] = STATE(465),
    [sym_inline_link] = STATE(465),
    [sym_link_text] = STATE(1319),
    [sym_span] = STATE(959),
    [sym__bracketed_text_begin] = STATE(2610),
    [sym_inline_comment] = STATE(464),
    [sym_raw_inline] = STATE(464),
    [sym_math] = STATE(464),
    [sym_verbatim] = STATE(464),
    [sym__todo_highlights] = STATE(464),
    [sym_todo] = STATE(464),
    [sym_note] = STATE(464),
    [sym__symbol_fallback] = STATE(464),
    [aux_sym__text] = STATE(445),
    [aux_sym__inline_repeat1] = STATE(287),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [sym__whitespace1] = ACTIONS(2136),
    [sym_quotation_marks] = ACTIONS(2138),
    [sym_ellipsis] = ACTIONS(2138),
    [sym_em_dash] = ACTIONS(2138),
    [sym_en_dash] = ACTIONS(2140),
    [sym_backslash_escape] = ACTIONS(2140),
    [anon_sym_LT] = ACTIONS(2142),
    [sym_symbol] = ACTIONS(2138),
    [anon_sym_LBRACE_] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_LBRACE_STAR] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_LBRACE_CARET] = ACTIONS(2152),
    [anon_sym_CARET] = ACTIONS(2152),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACE_EQ] = ACTIONS(2156),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2158),
    [anon_sym_LBRACE_DASH] = ACTIONS(2160),
    [anon_sym_LBRACK_CARET] = ACTIONS(2162),
    [anon_sym_BANG_LBRACK] = ACTIONS(2164),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_TODO] = ACTIONS(2172),
    [anon_sym_WIP] = ACTIONS(2172),
    [anon_sym_NOTE] = ACTIONS(2174),
    [anon_sym_INFO] = ACTIONS(2174),
    [anon_sym_XXX] = ACTIONS(2174),
    [sym_fixme] = ACTIONS(2138),
    [aux_sym__text_token1] = ACTIONS(2176),
    [sym__newline_inline] = ACTIONS(2178),
    [sym_hard_line_break] = ACTIONS(2138),
    [sym__verbatim_begin] = ACTIONS(2180),
  },
  [175] = {
    [sym__inline] = STATE(2355),
    [sym__inline_element] = STATE(1017),
    [sym__smart_punctuation] = STATE(468),
    [sym_autolink] = STATE(468),
    [sym_emphasis] = STATE(469),
    [sym_emphasis_begin] = STATE(2511),
    [sym_strong] = STATE(469),
    [sym_strong_begin] = STATE(2512),
    [sym_superscript] = STATE(469),
    [sym_superscript_begin] = STATE(2513),
    [sym_subscript] = STATE(469),
    [sym_subscript_begin] = STATE(2514),
    [sym_highlighted] = STATE(469),
    [sym_highlighted_begin] = STATE(2515),
    [sym_insert] = STATE(469),
    [sym_insert_begin] = STATE(2516),
    [sym_delete] = STATE(469),
    [sym_delete_begin] = STATE(2517),
    [sym_footnote_reference] = STATE(469),
    [sym_footnote_marker_begin] = STATE(2518),
    [sym__image] = STATE(469),
    [sym_full_reference_image] = STATE(469),
    [sym_collapsed_reference_image] = STATE(469),
    [sym_inline_image] = STATE(469),
    [sym_image_description] = STATE(1325),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(469),
    [sym_full_reference_link] = STATE(469),
    [sym_collapsed_reference_link] = STATE(469),
    [sym_inline_link] = STATE(469),
    [sym_link_text] = STATE(1326),
    [sym_span] = STATE(1017),
    [sym__bracketed_text_begin] = STATE(2613),
    [sym_inline_comment] = STATE(468),
    [sym_raw_inline] = STATE(468),
    [sym_math] = STATE(468),
    [sym_verbatim] = STATE(468),
    [sym__todo_highlights] = STATE(468),
    [sym_todo] = STATE(468),
    [sym_note] = STATE(468),
    [sym__symbol_fallback] = STATE(468),
    [aux_sym__text] = STATE(446),
    [aux_sym__inline_repeat1] = STATE(146),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [sym__whitespace1] = ACTIONS(1340),
    [sym_quotation_marks] = ACTIONS(1342),
    [sym_ellipsis] = ACTIONS(1342),
    [sym_em_dash] = ACTIONS(1342),
    [sym_en_dash] = ACTIONS(1344),
    [sym_backslash_escape] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [sym_symbol] = ACTIONS(1342),
    [anon_sym_LBRACE_] = ACTIONS(1348),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_LBRACE_STAR] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_LBRACE_CARET] = ACTIONS(1356),
    [anon_sym_CARET] = ACTIONS(1356),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_LBRACE_EQ] = ACTIONS(1360),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1362),
    [anon_sym_LBRACE_DASH] = ACTIONS(1364),
    [anon_sym_LBRACK_CARET] = ACTIONS(1366),
    [anon_sym_BANG_LBRACK] = ACTIONS(1368),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1374),
    [anon_sym_TODO] = ACTIONS(1376),
    [anon_sym_WIP] = ACTIONS(1376),
    [anon_sym_NOTE] = ACTIONS(1378),
    [anon_sym_INFO] = ACTIONS(1378),
    [anon_sym_XXX] = ACTIONS(1378),
    [sym_fixme] = ACTIONS(1342),
    [aux_sym__text_token1] = ACTIONS(1380),
    [sym__newline_inline] = ACTIONS(2182),
    [sym_hard_line_break] = ACTIONS(1342),
    [sym__verbatim_begin] = ACTIONS(1384),
  },
  [176] = {
    [sym__inline] = STATE(2356),
    [sym__inline_element] = STATE(915),
    [sym__smart_punctuation] = STATE(470),
    [sym_autolink] = STATE(470),
    [sym_emphasis] = STATE(471),
    [sym_emphasis_begin] = STATE(2522),
    [sym_strong] = STATE(471),
    [sym_strong_begin] = STATE(2523),
    [sym_superscript] = STATE(471),
    [sym_superscript_begin] = STATE(2524),
    [sym_subscript] = STATE(471),
    [sym_subscript_begin] = STATE(2525),
    [sym_highlighted] = STATE(471),
    [sym_highlighted_begin] = STATE(2526),
    [sym_insert] = STATE(471),
    [sym_insert_begin] = STATE(2527),
    [sym_delete] = STATE(471),
    [sym_delete_begin] = STATE(2528),
    [sym_footnote_reference] = STATE(471),
    [sym_footnote_marker_begin] = STATE(2529),
    [sym__image] = STATE(471),
    [sym_full_reference_image] = STATE(471),
    [sym_collapsed_reference_image] = STATE(471),
    [sym_inline_image] = STATE(471),
    [sym_image_description] = STATE(1332),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(471),
    [sym_full_reference_link] = STATE(471),
    [sym_collapsed_reference_link] = STATE(471),
    [sym_inline_link] = STATE(471),
    [sym_link_text] = STATE(1334),
    [sym_span] = STATE(915),
    [sym__bracketed_text_begin] = STATE(2614),
    [sym_inline_comment] = STATE(470),
    [sym_raw_inline] = STATE(470),
    [sym_math] = STATE(470),
    [sym_verbatim] = STATE(470),
    [sym__todo_highlights] = STATE(470),
    [sym_todo] = STATE(470),
    [sym_note] = STATE(470),
    [sym__symbol_fallback] = STATE(470),
    [aux_sym__text] = STATE(447),
    [aux_sym__inline_repeat1] = STATE(148),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [sym__whitespace1] = ACTIONS(1460),
    [sym_quotation_marks] = ACTIONS(1462),
    [sym_ellipsis] = ACTIONS(1462),
    [sym_em_dash] = ACTIONS(1462),
    [sym_en_dash] = ACTIONS(1464),
    [sym_backslash_escape] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [sym_symbol] = ACTIONS(1462),
    [anon_sym_LBRACE_] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(1470),
    [anon_sym_LBRACE_STAR] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACE_CARET] = ACTIONS(1476),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_LBRACE_EQ] = ACTIONS(1480),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1482),
    [anon_sym_LBRACE_DASH] = ACTIONS(1484),
    [anon_sym_LBRACK_CARET] = ACTIONS(1486),
    [anon_sym_BANG_LBRACK] = ACTIONS(1488),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_TODO] = ACTIONS(1496),
    [anon_sym_WIP] = ACTIONS(1496),
    [anon_sym_NOTE] = ACTIONS(1498),
    [anon_sym_INFO] = ACTIONS(1498),
    [anon_sym_XXX] = ACTIONS(1498),
    [sym_fixme] = ACTIONS(1462),
    [aux_sym__text_token1] = ACTIONS(1500),
    [sym__newline_inline] = ACTIONS(2184),
    [sym_hard_line_break] = ACTIONS(1462),
    [sym__verbatim_begin] = ACTIONS(1504),
  },
  [177] = {
    [sym__inline] = STATE(2357),
    [sym__inline_element] = STATE(1021),
    [sym__smart_punctuation] = STATE(473),
    [sym_autolink] = STATE(473),
    [sym_emphasis] = STATE(450),
    [sym_emphasis_begin] = STATE(2533),
    [sym_strong] = STATE(450),
    [sym_strong_begin] = STATE(2534),
    [sym_superscript] = STATE(450),
    [sym_superscript_begin] = STATE(2535),
    [sym_subscript] = STATE(450),
    [sym_subscript_begin] = STATE(2536),
    [sym_highlighted] = STATE(450),
    [sym_highlighted_begin] = STATE(2537),
    [sym_insert] = STATE(450),
    [sym_insert_begin] = STATE(2538),
    [sym_delete] = STATE(450),
    [sym_delete_begin] = STATE(2539),
    [sym_footnote_reference] = STATE(450),
    [sym_footnote_marker_begin] = STATE(2540),
    [sym__image] = STATE(450),
    [sym_full_reference_image] = STATE(450),
    [sym_collapsed_reference_image] = STATE(450),
    [sym_inline_image] = STATE(450),
    [sym_image_description] = STATE(1340),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(450),
    [sym_full_reference_link] = STATE(450),
    [sym_collapsed_reference_link] = STATE(450),
    [sym_inline_link] = STATE(450),
    [sym_link_text] = STATE(1341),
    [sym_span] = STATE(1021),
    [sym__bracketed_text_begin] = STATE(2615),
    [sym_inline_comment] = STATE(473),
    [sym_raw_inline] = STATE(473),
    [sym_math] = STATE(473),
    [sym_verbatim] = STATE(473),
    [sym__todo_highlights] = STATE(473),
    [sym_todo] = STATE(473),
    [sym_note] = STATE(473),
    [sym__symbol_fallback] = STATE(473),
    [aux_sym__text] = STATE(448),
    [aux_sym__inline_repeat1] = STATE(150),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [sym__whitespace1] = ACTIONS(1580),
    [sym_quotation_marks] = ACTIONS(1582),
    [sym_ellipsis] = ACTIONS(1582),
    [sym_em_dash] = ACTIONS(1582),
    [sym_en_dash] = ACTIONS(1584),
    [sym_backslash_escape] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1586),
    [sym_symbol] = ACTIONS(1582),
    [anon_sym_LBRACE_] = ACTIONS(1588),
    [anon_sym__] = ACTIONS(1590),
    [anon_sym_LBRACE_STAR] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_LBRACE_CARET] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_LBRACE_EQ] = ACTIONS(1600),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1602),
    [anon_sym_LBRACE_DASH] = ACTIONS(1604),
    [anon_sym_LBRACK_CARET] = ACTIONS(1606),
    [anon_sym_BANG_LBRACK] = ACTIONS(1608),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_DOLLAR] = ACTIONS(1614),
    [anon_sym_TODO] = ACTIONS(1616),
    [anon_sym_WIP] = ACTIONS(1616),
    [anon_sym_NOTE] = ACTIONS(1618),
    [anon_sym_INFO] = ACTIONS(1618),
    [anon_sym_XXX] = ACTIONS(1618),
    [sym_fixme] = ACTIONS(1582),
    [aux_sym__text_token1] = ACTIONS(1620),
    [sym__newline_inline] = ACTIONS(2186),
    [sym_hard_line_break] = ACTIONS(1582),
    [sym__verbatim_begin] = ACTIONS(1624),
  },
  [178] = {
    [sym__inline] = STATE(2359),
    [sym__inline_element] = STATE(997),
    [sym__smart_punctuation] = STATE(451),
    [sym_autolink] = STATE(451),
    [sym_emphasis] = STATE(449),
    [sym_emphasis_begin] = STATE(2544),
    [sym_strong] = STATE(449),
    [sym_strong_begin] = STATE(2545),
    [sym_superscript] = STATE(449),
    [sym_superscript_begin] = STATE(2546),
    [sym_subscript] = STATE(449),
    [sym_subscript_begin] = STATE(2547),
    [sym_highlighted] = STATE(449),
    [sym_highlighted_begin] = STATE(2548),
    [sym_insert] = STATE(449),
    [sym_insert_begin] = STATE(2549),
    [sym_delete] = STATE(449),
    [sym_delete_begin] = STATE(2550),
    [sym_footnote_reference] = STATE(449),
    [sym_footnote_marker_begin] = STATE(2551),
    [sym__image] = STATE(449),
    [sym_full_reference_image] = STATE(449),
    [sym_collapsed_reference_image] = STATE(449),
    [sym_inline_image] = STATE(449),
    [sym_image_description] = STATE(1250),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(449),
    [sym_full_reference_link] = STATE(449),
    [sym_collapsed_reference_link] = STATE(449),
    [sym_inline_link] = STATE(449),
    [sym_link_text] = STATE(1251),
    [sym_span] = STATE(997),
    [sym__bracketed_text_begin] = STATE(2616),
    [sym_inline_comment] = STATE(451),
    [sym_raw_inline] = STATE(451),
    [sym_math] = STATE(451),
    [sym_verbatim] = STATE(451),
    [sym__todo_highlights] = STATE(451),
    [sym_todo] = STATE(451),
    [sym_note] = STATE(451),
    [sym__symbol_fallback] = STATE(451),
    [aux_sym__text] = STATE(439),
    [aux_sym__inline_repeat1] = STATE(152),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [sym__whitespace1] = ACTIONS(1074),
    [sym_quotation_marks] = ACTIONS(1076),
    [sym_ellipsis] = ACTIONS(1076),
    [sym_em_dash] = ACTIONS(1076),
    [sym_en_dash] = ACTIONS(1078),
    [sym_backslash_escape] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(1080),
    [sym_symbol] = ACTIONS(1076),
    [anon_sym_LBRACE_] = ACTIONS(1082),
    [anon_sym__] = ACTIONS(1084),
    [anon_sym_LBRACE_STAR] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_LBRACE_CARET] = ACTIONS(1090),
    [anon_sym_CARET] = ACTIONS(1090),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_LBRACE_EQ] = ACTIONS(1094),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1096),
    [anon_sym_LBRACE_DASH] = ACTIONS(1098),
    [anon_sym_LBRACK_CARET] = ACTIONS(1100),
    [anon_sym_BANG_LBRACK] = ACTIONS(1102),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [anon_sym_TODO] = ACTIONS(1110),
    [anon_sym_WIP] = ACTIONS(1110),
    [anon_sym_NOTE] = ACTIONS(1112),
    [anon_sym_INFO] = ACTIONS(1112),
    [anon_sym_XXX] = ACTIONS(1112),
    [sym_fixme] = ACTIONS(1076),
    [aux_sym__text_token1] = ACTIONS(1114),
    [sym__newline_inline] = ACTIONS(1116),
    [sym_hard_line_break] = ACTIONS(1076),
    [sym__verbatim_begin] = ACTIONS(1118),
  },
  [179] = {
    [sym__inline] = STATE(2361),
    [sym__inline_element] = STATE(900),
    [sym__smart_punctuation] = STATE(454),
    [sym_autolink] = STATE(454),
    [sym_emphasis] = STATE(455),
    [sym_emphasis_begin] = STATE(2555),
    [sym_strong] = STATE(455),
    [sym_strong_begin] = STATE(2556),
    [sym_superscript] = STATE(455),
    [sym_superscript_begin] = STATE(2557),
    [sym_subscript] = STATE(455),
    [sym_subscript_begin] = STATE(2558),
    [sym_highlighted] = STATE(455),
    [sym_highlighted_begin] = STATE(2559),
    [sym_insert] = STATE(455),
    [sym_insert_begin] = STATE(2560),
    [sym_delete] = STATE(455),
    [sym_delete_begin] = STATE(2561),
    [sym_footnote_reference] = STATE(455),
    [sym_footnote_marker_begin] = STATE(2562),
    [sym__image] = STATE(455),
    [sym_full_reference_image] = STATE(455),
    [sym_collapsed_reference_image] = STATE(455),
    [sym_inline_image] = STATE(455),
    [sym_image_description] = STATE(1257),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(455),
    [sym_full_reference_link] = STATE(455),
    [sym_collapsed_reference_link] = STATE(455),
    [sym_inline_link] = STATE(455),
    [sym_link_text] = STATE(1258),
    [sym_span] = STATE(900),
    [sym__bracketed_text_begin] = STATE(2617),
    [sym_inline_comment] = STATE(454),
    [sym_raw_inline] = STATE(454),
    [sym_math] = STATE(454),
    [sym_verbatim] = STATE(454),
    [sym__todo_highlights] = STATE(454),
    [sym_todo] = STATE(454),
    [sym_note] = STATE(454),
    [sym__symbol_fallback] = STATE(454),
    [aux_sym__text] = STATE(441),
    [aux_sym__inline_repeat1] = STATE(155),
    [anon_sym_LBRACK] = ACTIONS(1820),
    [sym__whitespace1] = ACTIONS(1822),
    [sym_quotation_marks] = ACTIONS(1824),
    [sym_ellipsis] = ACTIONS(1824),
    [sym_em_dash] = ACTIONS(1824),
    [sym_en_dash] = ACTIONS(1826),
    [sym_backslash_escape] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1828),
    [sym_symbol] = ACTIONS(1824),
    [anon_sym_LBRACE_] = ACTIONS(1830),
    [anon_sym__] = ACTIONS(1832),
    [anon_sym_LBRACE_STAR] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_LBRACE_CARET] = ACTIONS(1838),
    [anon_sym_CARET] = ACTIONS(1838),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1840),
    [anon_sym_TILDE] = ACTIONS(1840),
    [anon_sym_LBRACE_EQ] = ACTIONS(1842),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1844),
    [anon_sym_LBRACE_DASH] = ACTIONS(1846),
    [anon_sym_LBRACK_CARET] = ACTIONS(1848),
    [anon_sym_BANG_LBRACK] = ACTIONS(1850),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1856),
    [anon_sym_TODO] = ACTIONS(1858),
    [anon_sym_WIP] = ACTIONS(1858),
    [anon_sym_NOTE] = ACTIONS(1860),
    [anon_sym_INFO] = ACTIONS(1860),
    [anon_sym_XXX] = ACTIONS(1860),
    [sym_fixme] = ACTIONS(1824),
    [aux_sym__text_token1] = ACTIONS(1862),
    [sym__newline_inline] = ACTIONS(2188),
    [sym_hard_line_break] = ACTIONS(1824),
    [sym__verbatim_begin] = ACTIONS(1866),
  },
  [180] = {
    [sym__inline] = STATE(2369),
    [sym__inline_element] = STATE(1014),
    [sym__smart_punctuation] = STATE(456),
    [sym_autolink] = STATE(456),
    [sym_emphasis] = STATE(457),
    [sym_emphasis_begin] = STATE(2566),
    [sym_strong] = STATE(457),
    [sym_strong_begin] = STATE(2567),
    [sym_superscript] = STATE(457),
    [sym_superscript_begin] = STATE(2568),
    [sym_subscript] = STATE(457),
    [sym_subscript_begin] = STATE(2569),
    [sym_highlighted] = STATE(457),
    [sym_highlighted_begin] = STATE(2570),
    [sym_insert] = STATE(457),
    [sym_insert_begin] = STATE(2571),
    [sym_delete] = STATE(457),
    [sym_delete_begin] = STATE(1976),
    [sym_footnote_reference] = STATE(457),
    [sym_footnote_marker_begin] = STATE(2573),
    [sym__image] = STATE(457),
    [sym_full_reference_image] = STATE(457),
    [sym_collapsed_reference_image] = STATE(457),
    [sym_inline_image] = STATE(457),
    [sym_image_description] = STATE(1264),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(457),
    [sym_full_reference_link] = STATE(457),
    [sym_collapsed_reference_link] = STATE(457),
    [sym_inline_link] = STATE(457),
    [sym_link_text] = STATE(1265),
    [sym_span] = STATE(1014),
    [sym__bracketed_text_begin] = STATE(2618),
    [sym_inline_comment] = STATE(456),
    [sym_raw_inline] = STATE(456),
    [sym_math] = STATE(456),
    [sym_verbatim] = STATE(456),
    [sym__todo_highlights] = STATE(456),
    [sym_todo] = STATE(456),
    [sym_note] = STATE(456),
    [sym__symbol_fallback] = STATE(456),
    [aux_sym__text] = STATE(440),
    [aux_sym__inline_repeat1] = STATE(157),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [sym__whitespace1] = ACTIONS(1942),
    [sym_quotation_marks] = ACTIONS(1944),
    [sym_ellipsis] = ACTIONS(1944),
    [sym_em_dash] = ACTIONS(1944),
    [sym_en_dash] = ACTIONS(1946),
    [sym_backslash_escape] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1948),
    [sym_symbol] = ACTIONS(1944),
    [anon_sym_LBRACE_] = ACTIONS(1950),
    [anon_sym__] = ACTIONS(1952),
    [anon_sym_LBRACE_STAR] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_LBRACE_CARET] = ACTIONS(1958),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_LBRACE_EQ] = ACTIONS(1962),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1964),
    [anon_sym_LBRACE_DASH] = ACTIONS(1966),
    [anon_sym_LBRACK_CARET] = ACTIONS(1968),
    [anon_sym_BANG_LBRACK] = ACTIONS(1970),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1974),
    [anon_sym_DOLLAR] = ACTIONS(1976),
    [anon_sym_TODO] = ACTIONS(1978),
    [anon_sym_WIP] = ACTIONS(1978),
    [anon_sym_NOTE] = ACTIONS(1980),
    [anon_sym_INFO] = ACTIONS(1980),
    [anon_sym_XXX] = ACTIONS(1980),
    [sym_fixme] = ACTIONS(1944),
    [aux_sym__text_token1] = ACTIONS(1982),
    [sym__newline_inline] = ACTIONS(2190),
    [sym_hard_line_break] = ACTIONS(1944),
    [sym__verbatim_begin] = ACTIONS(1986),
  },
  [181] = {
    [sym__inline] = STATE(2128),
    [sym__inline_element] = STATE(982),
    [sym__smart_punctuation] = STATE(452),
    [sym_autolink] = STATE(452),
    [sym_emphasis] = STATE(453),
    [sym_emphasis_begin] = STATE(2470),
    [sym_strong] = STATE(453),
    [sym_strong_begin] = STATE(2471),
    [sym_superscript] = STATE(453),
    [sym_superscript_begin] = STATE(2472),
    [sym_subscript] = STATE(453),
    [sym_subscript_begin] = STATE(2473),
    [sym_highlighted] = STATE(453),
    [sym_highlighted_begin] = STATE(2474),
    [sym_insert] = STATE(453),
    [sym_insert_begin] = STATE(2475),
    [sym_delete] = STATE(453),
    [sym_delete_begin] = STATE(2476),
    [sym_footnote_reference] = STATE(453),
    [sym_footnote_marker_begin] = STATE(2477),
    [sym__image] = STATE(453),
    [sym_full_reference_image] = STATE(453),
    [sym_collapsed_reference_image] = STATE(453),
    [sym_inline_image] = STATE(453),
    [sym_image_description] = STATE(1282),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(453),
    [sym_full_reference_link] = STATE(453),
    [sym_collapsed_reference_link] = STATE(453),
    [sym_inline_link] = STATE(453),
    [sym_link_text] = STATE(1299),
    [sym_span] = STATE(982),
    [sym__bracketed_text_begin] = STATE(2603),
    [sym_inline_comment] = STATE(452),
    [sym_raw_inline] = STATE(452),
    [sym_math] = STATE(452),
    [sym_verbatim] = STATE(452),
    [sym__todo_highlights] = STATE(452),
    [sym_todo] = STATE(452),
    [sym_note] = STATE(452),
    [sym__symbol_fallback] = STATE(452),
    [aux_sym__text] = STATE(437),
    [aux_sym__inline_repeat1] = STATE(144),
    [anon_sym_LBRACK] = ACTIONS(1120),
    [sym__whitespace1] = ACTIONS(1122),
    [sym_quotation_marks] = ACTIONS(1124),
    [sym_ellipsis] = ACTIONS(1124),
    [sym_em_dash] = ACTIONS(1124),
    [sym_en_dash] = ACTIONS(1126),
    [sym_backslash_escape] = ACTIONS(1126),
    [anon_sym_LT] = ACTIONS(1128),
    [sym_symbol] = ACTIONS(1124),
    [anon_sym_LBRACE_] = ACTIONS(1130),
    [anon_sym__] = ACTIONS(1132),
    [anon_sym_LBRACE_STAR] = ACTIONS(1134),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACE_CARET] = ACTIONS(1138),
    [anon_sym_CARET] = ACTIONS(1138),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_LBRACE_EQ] = ACTIONS(1142),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1144),
    [anon_sym_LBRACE_DASH] = ACTIONS(1146),
    [anon_sym_LBRACK_CARET] = ACTIONS(1148),
    [anon_sym_BANG_LBRACK] = ACTIONS(1150),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1152),
    [anon_sym_LPAREN] = ACTIONS(1154),
    [anon_sym_DOLLAR] = ACTIONS(1156),
    [anon_sym_TODO] = ACTIONS(1158),
    [anon_sym_WIP] = ACTIONS(1158),
    [anon_sym_NOTE] = ACTIONS(1160),
    [anon_sym_INFO] = ACTIONS(1160),
    [anon_sym_XXX] = ACTIONS(1160),
    [sym_fixme] = ACTIONS(1124),
    [aux_sym__text_token1] = ACTIONS(1162),
    [sym__newline_inline] = ACTIONS(1164),
    [sym_hard_line_break] = ACTIONS(1124),
    [sym__verbatim_begin] = ACTIONS(1166),
  },
  [182] = {
    [sym__inline] = STATE(1807),
    [sym__inline_element] = STATE(999),
    [sym__smart_punctuation] = STATE(467),
    [sym_autolink] = STATE(467),
    [sym_emphasis] = STATE(459),
    [sym_emphasis_begin] = STATE(2055),
    [sym_strong] = STATE(459),
    [sym_strong_begin] = STATE(2088),
    [sym_superscript] = STATE(459),
    [sym_superscript_begin] = STATE(2091),
    [sym_subscript] = STATE(459),
    [sym_subscript_begin] = STATE(2111),
    [sym_highlighted] = STATE(459),
    [sym_highlighted_begin] = STATE(2115),
    [sym_insert] = STATE(459),
    [sym_insert_begin] = STATE(2123),
    [sym_delete] = STATE(459),
    [sym_delete_begin] = STATE(2604),
    [sym_footnote_reference] = STATE(459),
    [sym_footnote_marker_begin] = STATE(2108),
    [sym__image] = STATE(459),
    [sym_full_reference_image] = STATE(459),
    [sym_collapsed_reference_image] = STATE(459),
    [sym_inline_image] = STATE(459),
    [sym_image_description] = STATE(1329),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(459),
    [sym_full_reference_link] = STATE(459),
    [sym_collapsed_reference_link] = STATE(459),
    [sym_inline_link] = STATE(459),
    [sym_link_text] = STATE(1335),
    [sym_span] = STATE(999),
    [sym__bracketed_text_begin] = STATE(2272),
    [sym_inline_comment] = STATE(467),
    [sym_raw_inline] = STATE(467),
    [sym_math] = STATE(467),
    [sym_verbatim] = STATE(467),
    [sym__todo_highlights] = STATE(467),
    [sym_todo] = STATE(467),
    [sym_note] = STATE(467),
    [sym__symbol_fallback] = STATE(467),
    [aux_sym__text] = STATE(438),
    [aux_sym__inline_repeat1] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(5),
    [sym__whitespace1] = ACTIONS(7),
    [sym_quotation_marks] = ACTIONS(9),
    [sym_ellipsis] = ACTIONS(9),
    [sym_em_dash] = ACTIONS(9),
    [sym_en_dash] = ACTIONS(11),
    [sym_backslash_escape] = ACTIONS(11),
    [anon_sym_LT] = ACTIONS(13),
    [sym_symbol] = ACTIONS(9),
    [anon_sym_LBRACE_] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_LBRACE_STAR] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_LBRACE_CARET] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(23),
    [anon_sym_LBRACE_TILDE] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_LBRACE_EQ] = ACTIONS(27),
    [anon_sym_LBRACE_PLUS] = ACTIONS(29),
    [anon_sym_LBRACE_DASH] = ACTIONS(31),
    [anon_sym_LBRACK_CARET] = ACTIONS(33),
    [anon_sym_BANG_LBRACK] = ACTIONS(35),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [anon_sym_TODO] = ACTIONS(43),
    [anon_sym_WIP] = ACTIONS(43),
    [anon_sym_NOTE] = ACTIONS(45),
    [anon_sym_INFO] = ACTIONS(45),
    [anon_sym_XXX] = ACTIONS(45),
    [sym_fixme] = ACTIONS(9),
    [aux_sym__text_token1] = ACTIONS(47),
    [sym__newline_inline] = ACTIONS(51),
    [sym_hard_line_break] = ACTIONS(9),
    [sym__verbatim_begin] = ACTIONS(119),
  },
  [183] = {
    [sym__inline_without_trailing_space] = STATE(2154),
    [sym__inline_element] = STATE(988),
    [sym__smart_punctuation] = STATE(460),
    [sym_autolink] = STATE(460),
    [sym_emphasis] = STATE(463),
    [sym_emphasis_begin] = STATE(2484),
    [sym_strong] = STATE(463),
    [sym_strong_begin] = STATE(2485),
    [sym_superscript] = STATE(463),
    [sym_superscript_begin] = STATE(2486),
    [sym_subscript] = STATE(463),
    [sym_subscript_begin] = STATE(2487),
    [sym_highlighted] = STATE(463),
    [sym_highlighted_begin] = STATE(2488),
    [sym_insert] = STATE(463),
    [sym_insert_begin] = STATE(2489),
    [sym_delete] = STATE(463),
    [sym_delete_begin] = STATE(2490),
    [sym_footnote_reference] = STATE(463),
    [sym_footnote_marker_begin] = STATE(2491),
    [sym__image] = STATE(463),
    [sym_full_reference_image] = STATE(463),
    [sym_collapsed_reference_image] = STATE(463),
    [sym_inline_image] = STATE(463),
    [sym_image_description] = STATE(1268),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(463),
    [sym_full_reference_link] = STATE(463),
    [sym_collapsed_reference_link] = STATE(463),
    [sym_inline_link] = STATE(463),
    [sym_link_text] = STATE(1273),
    [sym_span] = STATE(988),
    [sym__bracketed_text_begin] = STATE(2607),
    [sym_inline_comment] = STATE(460),
    [sym_raw_inline] = STATE(460),
    [sym_math] = STATE(460),
    [sym_verbatim] = STATE(460),
    [sym__todo_highlights] = STATE(460),
    [sym_todo] = STATE(460),
    [sym_note] = STATE(460),
    [sym__symbol_fallback] = STATE(460),
    [aux_sym__text] = STATE(444),
    [aux_sym__inline_repeat1] = STATE(286),
    [anon_sym_LBRACK] = ACTIONS(1772),
    [sym__whitespace1] = ACTIONS(1774),
    [sym_quotation_marks] = ACTIONS(1776),
    [sym_ellipsis] = ACTIONS(1776),
    [sym_em_dash] = ACTIONS(1776),
    [sym_en_dash] = ACTIONS(1778),
    [sym_backslash_escape] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1780),
    [sym_symbol] = ACTIONS(1776),
    [anon_sym_LBRACE_] = ACTIONS(1782),
    [anon_sym__] = ACTIONS(1784),
    [anon_sym_LBRACE_STAR] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_LBRACE_CARET] = ACTIONS(1790),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1792),
    [anon_sym_LBRACE_EQ] = ACTIONS(1794),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1796),
    [anon_sym_LBRACE_DASH] = ACTIONS(1798),
    [anon_sym_LBRACK_CARET] = ACTIONS(1800),
    [anon_sym_BANG_LBRACK] = ACTIONS(1802),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1804),
    [anon_sym_LPAREN] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [anon_sym_TODO] = ACTIONS(1810),
    [anon_sym_WIP] = ACTIONS(1810),
    [anon_sym_NOTE] = ACTIONS(1812),
    [anon_sym_INFO] = ACTIONS(1812),
    [anon_sym_XXX] = ACTIONS(1812),
    [sym_fixme] = ACTIONS(1776),
    [aux_sym__text_token1] = ACTIONS(1814),
    [sym__newline_inline] = ACTIONS(1816),
    [sym_hard_line_break] = ACTIONS(1776),
    [sym__verbatim_begin] = ACTIONS(1818),
  },
  [184] = {
    [sym__inline_without_trailing_space] = STATE(2155),
    [sym__inline_element] = STATE(959),
    [sym__smart_punctuation] = STATE(464),
    [sym_autolink] = STATE(464),
    [sym_emphasis] = STATE(465),
    [sym_emphasis_begin] = STATE(2498),
    [sym_strong] = STATE(465),
    [sym_strong_begin] = STATE(2499),
    [sym_superscript] = STATE(465),
    [sym_superscript_begin] = STATE(2500),
    [sym_subscript] = STATE(465),
    [sym_subscript_begin] = STATE(2501),
    [sym_highlighted] = STATE(465),
    [sym_highlighted_begin] = STATE(2502),
    [sym_insert] = STATE(465),
    [sym_insert_begin] = STATE(2503),
    [sym_delete] = STATE(465),
    [sym_delete_begin] = STATE(2504),
    [sym_footnote_reference] = STATE(465),
    [sym_footnote_marker_begin] = STATE(2505),
    [sym__image] = STATE(465),
    [sym_full_reference_image] = STATE(465),
    [sym_collapsed_reference_image] = STATE(465),
    [sym_inline_image] = STATE(465),
    [sym_image_description] = STATE(1314),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(465),
    [sym_full_reference_link] = STATE(465),
    [sym_collapsed_reference_link] = STATE(465),
    [sym_inline_link] = STATE(465),
    [sym_link_text] = STATE(1319),
    [sym_span] = STATE(959),
    [sym__bracketed_text_begin] = STATE(2610),
    [sym_inline_comment] = STATE(464),
    [sym_raw_inline] = STATE(464),
    [sym_math] = STATE(464),
    [sym_verbatim] = STATE(464),
    [sym__todo_highlights] = STATE(464),
    [sym_todo] = STATE(464),
    [sym_note] = STATE(464),
    [sym__symbol_fallback] = STATE(464),
    [aux_sym__text] = STATE(445),
    [aux_sym__inline_repeat1] = STATE(287),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [sym__whitespace1] = ACTIONS(2136),
    [sym_quotation_marks] = ACTIONS(2138),
    [sym_ellipsis] = ACTIONS(2138),
    [sym_em_dash] = ACTIONS(2138),
    [sym_en_dash] = ACTIONS(2140),
    [sym_backslash_escape] = ACTIONS(2140),
    [anon_sym_LT] = ACTIONS(2142),
    [sym_symbol] = ACTIONS(2138),
    [anon_sym_LBRACE_] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_LBRACE_STAR] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_LBRACE_CARET] = ACTIONS(2152),
    [anon_sym_CARET] = ACTIONS(2152),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACE_EQ] = ACTIONS(2156),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2158),
    [anon_sym_LBRACE_DASH] = ACTIONS(2160),
    [anon_sym_LBRACK_CARET] = ACTIONS(2162),
    [anon_sym_BANG_LBRACK] = ACTIONS(2164),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_TODO] = ACTIONS(2172),
    [anon_sym_WIP] = ACTIONS(2172),
    [anon_sym_NOTE] = ACTIONS(2174),
    [anon_sym_INFO] = ACTIONS(2174),
    [anon_sym_XXX] = ACTIONS(2174),
    [sym_fixme] = ACTIONS(2138),
    [aux_sym__text_token1] = ACTIONS(2176),
    [sym__newline_inline] = ACTIONS(2178),
    [sym_hard_line_break] = ACTIONS(2138),
    [sym__verbatim_begin] = ACTIONS(2180),
  },
  [185] = {
    [sym__inline] = STATE(2175),
    [sym__inline_element] = STATE(1017),
    [sym__smart_punctuation] = STATE(468),
    [sym_autolink] = STATE(468),
    [sym_emphasis] = STATE(469),
    [sym_emphasis_begin] = STATE(2511),
    [sym_strong] = STATE(469),
    [sym_strong_begin] = STATE(2512),
    [sym_superscript] = STATE(469),
    [sym_superscript_begin] = STATE(2513),
    [sym_subscript] = STATE(469),
    [sym_subscript_begin] = STATE(2514),
    [sym_highlighted] = STATE(469),
    [sym_highlighted_begin] = STATE(2515),
    [sym_insert] = STATE(469),
    [sym_insert_begin] = STATE(2516),
    [sym_delete] = STATE(469),
    [sym_delete_begin] = STATE(2517),
    [sym_footnote_reference] = STATE(469),
    [sym_footnote_marker_begin] = STATE(2518),
    [sym__image] = STATE(469),
    [sym_full_reference_image] = STATE(469),
    [sym_collapsed_reference_image] = STATE(469),
    [sym_inline_image] = STATE(469),
    [sym_image_description] = STATE(1325),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(469),
    [sym_full_reference_link] = STATE(469),
    [sym_collapsed_reference_link] = STATE(469),
    [sym_inline_link] = STATE(469),
    [sym_link_text] = STATE(1326),
    [sym_span] = STATE(1017),
    [sym__bracketed_text_begin] = STATE(2613),
    [sym_inline_comment] = STATE(468),
    [sym_raw_inline] = STATE(468),
    [sym_math] = STATE(468),
    [sym_verbatim] = STATE(468),
    [sym__todo_highlights] = STATE(468),
    [sym_todo] = STATE(468),
    [sym_note] = STATE(468),
    [sym__symbol_fallback] = STATE(468),
    [aux_sym__text] = STATE(446),
    [aux_sym__inline_repeat1] = STATE(146),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [sym__whitespace1] = ACTIONS(1340),
    [sym_quotation_marks] = ACTIONS(1342),
    [sym_ellipsis] = ACTIONS(1342),
    [sym_em_dash] = ACTIONS(1342),
    [sym_en_dash] = ACTIONS(1344),
    [sym_backslash_escape] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [sym_symbol] = ACTIONS(1342),
    [anon_sym_LBRACE_] = ACTIONS(1348),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_LBRACE_STAR] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_LBRACE_CARET] = ACTIONS(1356),
    [anon_sym_CARET] = ACTIONS(1356),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_LBRACE_EQ] = ACTIONS(1360),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1362),
    [anon_sym_LBRACE_DASH] = ACTIONS(1364),
    [anon_sym_LBRACK_CARET] = ACTIONS(1366),
    [anon_sym_BANG_LBRACK] = ACTIONS(1368),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1374),
    [anon_sym_TODO] = ACTIONS(1376),
    [anon_sym_WIP] = ACTIONS(1376),
    [anon_sym_NOTE] = ACTIONS(1378),
    [anon_sym_INFO] = ACTIONS(1378),
    [anon_sym_XXX] = ACTIONS(1378),
    [sym_fixme] = ACTIONS(1342),
    [aux_sym__text_token1] = ACTIONS(1380),
    [sym__newline_inline] = ACTIONS(2182),
    [sym_hard_line_break] = ACTIONS(1342),
    [sym__verbatim_begin] = ACTIONS(1384),
  },
  [186] = {
    [sym__inline] = STATE(2254),
    [sym__inline_element] = STATE(915),
    [sym__smart_punctuation] = STATE(470),
    [sym_autolink] = STATE(470),
    [sym_emphasis] = STATE(471),
    [sym_emphasis_begin] = STATE(2522),
    [sym_strong] = STATE(471),
    [sym_strong_begin] = STATE(2523),
    [sym_superscript] = STATE(471),
    [sym_superscript_begin] = STATE(2524),
    [sym_subscript] = STATE(471),
    [sym_subscript_begin] = STATE(2525),
    [sym_highlighted] = STATE(471),
    [sym_highlighted_begin] = STATE(2526),
    [sym_insert] = STATE(471),
    [sym_insert_begin] = STATE(2527),
    [sym_delete] = STATE(471),
    [sym_delete_begin] = STATE(2528),
    [sym_footnote_reference] = STATE(471),
    [sym_footnote_marker_begin] = STATE(2529),
    [sym__image] = STATE(471),
    [sym_full_reference_image] = STATE(471),
    [sym_collapsed_reference_image] = STATE(471),
    [sym_inline_image] = STATE(471),
    [sym_image_description] = STATE(1332),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(471),
    [sym_full_reference_link] = STATE(471),
    [sym_collapsed_reference_link] = STATE(471),
    [sym_inline_link] = STATE(471),
    [sym_link_text] = STATE(1334),
    [sym_span] = STATE(915),
    [sym__bracketed_text_begin] = STATE(2614),
    [sym_inline_comment] = STATE(470),
    [sym_raw_inline] = STATE(470),
    [sym_math] = STATE(470),
    [sym_verbatim] = STATE(470),
    [sym__todo_highlights] = STATE(470),
    [sym_todo] = STATE(470),
    [sym_note] = STATE(470),
    [sym__symbol_fallback] = STATE(470),
    [aux_sym__text] = STATE(447),
    [aux_sym__inline_repeat1] = STATE(148),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [sym__whitespace1] = ACTIONS(1460),
    [sym_quotation_marks] = ACTIONS(1462),
    [sym_ellipsis] = ACTIONS(1462),
    [sym_em_dash] = ACTIONS(1462),
    [sym_en_dash] = ACTIONS(1464),
    [sym_backslash_escape] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [sym_symbol] = ACTIONS(1462),
    [anon_sym_LBRACE_] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(1470),
    [anon_sym_LBRACE_STAR] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACE_CARET] = ACTIONS(1476),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_LBRACE_EQ] = ACTIONS(1480),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1482),
    [anon_sym_LBRACE_DASH] = ACTIONS(1484),
    [anon_sym_LBRACK_CARET] = ACTIONS(1486),
    [anon_sym_BANG_LBRACK] = ACTIONS(1488),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_TODO] = ACTIONS(1496),
    [anon_sym_WIP] = ACTIONS(1496),
    [anon_sym_NOTE] = ACTIONS(1498),
    [anon_sym_INFO] = ACTIONS(1498),
    [anon_sym_XXX] = ACTIONS(1498),
    [sym_fixme] = ACTIONS(1462),
    [aux_sym__text_token1] = ACTIONS(1500),
    [sym__newline_inline] = ACTIONS(2184),
    [sym_hard_line_break] = ACTIONS(1462),
    [sym__verbatim_begin] = ACTIONS(1504),
  },
  [187] = {
    [sym__inline] = STATE(2285),
    [sym__inline_element] = STATE(1021),
    [sym__smart_punctuation] = STATE(473),
    [sym_autolink] = STATE(473),
    [sym_emphasis] = STATE(450),
    [sym_emphasis_begin] = STATE(2533),
    [sym_strong] = STATE(450),
    [sym_strong_begin] = STATE(2534),
    [sym_superscript] = STATE(450),
    [sym_superscript_begin] = STATE(2535),
    [sym_subscript] = STATE(450),
    [sym_subscript_begin] = STATE(2536),
    [sym_highlighted] = STATE(450),
    [sym_highlighted_begin] = STATE(2537),
    [sym_insert] = STATE(450),
    [sym_insert_begin] = STATE(2538),
    [sym_delete] = STATE(450),
    [sym_delete_begin] = STATE(2539),
    [sym_footnote_reference] = STATE(450),
    [sym_footnote_marker_begin] = STATE(2540),
    [sym__image] = STATE(450),
    [sym_full_reference_image] = STATE(450),
    [sym_collapsed_reference_image] = STATE(450),
    [sym_inline_image] = STATE(450),
    [sym_image_description] = STATE(1340),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(450),
    [sym_full_reference_link] = STATE(450),
    [sym_collapsed_reference_link] = STATE(450),
    [sym_inline_link] = STATE(450),
    [sym_link_text] = STATE(1341),
    [sym_span] = STATE(1021),
    [sym__bracketed_text_begin] = STATE(2615),
    [sym_inline_comment] = STATE(473),
    [sym_raw_inline] = STATE(473),
    [sym_math] = STATE(473),
    [sym_verbatim] = STATE(473),
    [sym__todo_highlights] = STATE(473),
    [sym_todo] = STATE(473),
    [sym_note] = STATE(473),
    [sym__symbol_fallback] = STATE(473),
    [aux_sym__text] = STATE(448),
    [aux_sym__inline_repeat1] = STATE(150),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [sym__whitespace1] = ACTIONS(1580),
    [sym_quotation_marks] = ACTIONS(1582),
    [sym_ellipsis] = ACTIONS(1582),
    [sym_em_dash] = ACTIONS(1582),
    [sym_en_dash] = ACTIONS(1584),
    [sym_backslash_escape] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1586),
    [sym_symbol] = ACTIONS(1582),
    [anon_sym_LBRACE_] = ACTIONS(1588),
    [anon_sym__] = ACTIONS(1590),
    [anon_sym_LBRACE_STAR] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_LBRACE_CARET] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_LBRACE_EQ] = ACTIONS(1600),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1602),
    [anon_sym_LBRACE_DASH] = ACTIONS(1604),
    [anon_sym_LBRACK_CARET] = ACTIONS(1606),
    [anon_sym_BANG_LBRACK] = ACTIONS(1608),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_DOLLAR] = ACTIONS(1614),
    [anon_sym_TODO] = ACTIONS(1616),
    [anon_sym_WIP] = ACTIONS(1616),
    [anon_sym_NOTE] = ACTIONS(1618),
    [anon_sym_INFO] = ACTIONS(1618),
    [anon_sym_XXX] = ACTIONS(1618),
    [sym_fixme] = ACTIONS(1582),
    [aux_sym__text_token1] = ACTIONS(1620),
    [sym__newline_inline] = ACTIONS(2186),
    [sym_hard_line_break] = ACTIONS(1582),
    [sym__verbatim_begin] = ACTIONS(1624),
  },
  [188] = {
    [sym__inline] = STATE(2293),
    [sym__inline_element] = STATE(997),
    [sym__smart_punctuation] = STATE(451),
    [sym_autolink] = STATE(451),
    [sym_emphasis] = STATE(449),
    [sym_emphasis_begin] = STATE(2544),
    [sym_strong] = STATE(449),
    [sym_strong_begin] = STATE(2545),
    [sym_superscript] = STATE(449),
    [sym_superscript_begin] = STATE(2546),
    [sym_subscript] = STATE(449),
    [sym_subscript_begin] = STATE(2547),
    [sym_highlighted] = STATE(449),
    [sym_highlighted_begin] = STATE(2548),
    [sym_insert] = STATE(449),
    [sym_insert_begin] = STATE(2549),
    [sym_delete] = STATE(449),
    [sym_delete_begin] = STATE(2550),
    [sym_footnote_reference] = STATE(449),
    [sym_footnote_marker_begin] = STATE(2551),
    [sym__image] = STATE(449),
    [sym_full_reference_image] = STATE(449),
    [sym_collapsed_reference_image] = STATE(449),
    [sym_inline_image] = STATE(449),
    [sym_image_description] = STATE(1250),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(449),
    [sym_full_reference_link] = STATE(449),
    [sym_collapsed_reference_link] = STATE(449),
    [sym_inline_link] = STATE(449),
    [sym_link_text] = STATE(1251),
    [sym_span] = STATE(997),
    [sym__bracketed_text_begin] = STATE(2616),
    [sym_inline_comment] = STATE(451),
    [sym_raw_inline] = STATE(451),
    [sym_math] = STATE(451),
    [sym_verbatim] = STATE(451),
    [sym__todo_highlights] = STATE(451),
    [sym_todo] = STATE(451),
    [sym_note] = STATE(451),
    [sym__symbol_fallback] = STATE(451),
    [aux_sym__text] = STATE(439),
    [aux_sym__inline_repeat1] = STATE(152),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [sym__whitespace1] = ACTIONS(1074),
    [sym_quotation_marks] = ACTIONS(1076),
    [sym_ellipsis] = ACTIONS(1076),
    [sym_em_dash] = ACTIONS(1076),
    [sym_en_dash] = ACTIONS(1078),
    [sym_backslash_escape] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(1080),
    [sym_symbol] = ACTIONS(1076),
    [anon_sym_LBRACE_] = ACTIONS(1082),
    [anon_sym__] = ACTIONS(1084),
    [anon_sym_LBRACE_STAR] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_LBRACE_CARET] = ACTIONS(1090),
    [anon_sym_CARET] = ACTIONS(1090),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_LBRACE_EQ] = ACTIONS(1094),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1096),
    [anon_sym_LBRACE_DASH] = ACTIONS(1098),
    [anon_sym_LBRACK_CARET] = ACTIONS(1100),
    [anon_sym_BANG_LBRACK] = ACTIONS(1102),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [anon_sym_TODO] = ACTIONS(1110),
    [anon_sym_WIP] = ACTIONS(1110),
    [anon_sym_NOTE] = ACTIONS(1112),
    [anon_sym_INFO] = ACTIONS(1112),
    [anon_sym_XXX] = ACTIONS(1112),
    [sym_fixme] = ACTIONS(1076),
    [aux_sym__text_token1] = ACTIONS(1114),
    [sym__newline_inline] = ACTIONS(1116),
    [sym_hard_line_break] = ACTIONS(1076),
    [sym__verbatim_begin] = ACTIONS(1118),
  },
  [189] = {
    [sym__inline] = STATE(2296),
    [sym__inline_element] = STATE(900),
    [sym__smart_punctuation] = STATE(454),
    [sym_autolink] = STATE(454),
    [sym_emphasis] = STATE(455),
    [sym_emphasis_begin] = STATE(2555),
    [sym_strong] = STATE(455),
    [sym_strong_begin] = STATE(2556),
    [sym_superscript] = STATE(455),
    [sym_superscript_begin] = STATE(2557),
    [sym_subscript] = STATE(455),
    [sym_subscript_begin] = STATE(2558),
    [sym_highlighted] = STATE(455),
    [sym_highlighted_begin] = STATE(2559),
    [sym_insert] = STATE(455),
    [sym_insert_begin] = STATE(2560),
    [sym_delete] = STATE(455),
    [sym_delete_begin] = STATE(2561),
    [sym_footnote_reference] = STATE(455),
    [sym_footnote_marker_begin] = STATE(2562),
    [sym__image] = STATE(455),
    [sym_full_reference_image] = STATE(455),
    [sym_collapsed_reference_image] = STATE(455),
    [sym_inline_image] = STATE(455),
    [sym_image_description] = STATE(1257),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(455),
    [sym_full_reference_link] = STATE(455),
    [sym_collapsed_reference_link] = STATE(455),
    [sym_inline_link] = STATE(455),
    [sym_link_text] = STATE(1258),
    [sym_span] = STATE(900),
    [sym__bracketed_text_begin] = STATE(2617),
    [sym_inline_comment] = STATE(454),
    [sym_raw_inline] = STATE(454),
    [sym_math] = STATE(454),
    [sym_verbatim] = STATE(454),
    [sym__todo_highlights] = STATE(454),
    [sym_todo] = STATE(454),
    [sym_note] = STATE(454),
    [sym__symbol_fallback] = STATE(454),
    [aux_sym__text] = STATE(441),
    [aux_sym__inline_repeat1] = STATE(155),
    [anon_sym_LBRACK] = ACTIONS(1820),
    [sym__whitespace1] = ACTIONS(1822),
    [sym_quotation_marks] = ACTIONS(1824),
    [sym_ellipsis] = ACTIONS(1824),
    [sym_em_dash] = ACTIONS(1824),
    [sym_en_dash] = ACTIONS(1826),
    [sym_backslash_escape] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1828),
    [sym_symbol] = ACTIONS(1824),
    [anon_sym_LBRACE_] = ACTIONS(1830),
    [anon_sym__] = ACTIONS(1832),
    [anon_sym_LBRACE_STAR] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_LBRACE_CARET] = ACTIONS(1838),
    [anon_sym_CARET] = ACTIONS(1838),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1840),
    [anon_sym_TILDE] = ACTIONS(1840),
    [anon_sym_LBRACE_EQ] = ACTIONS(1842),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1844),
    [anon_sym_LBRACE_DASH] = ACTIONS(1846),
    [anon_sym_LBRACK_CARET] = ACTIONS(1848),
    [anon_sym_BANG_LBRACK] = ACTIONS(1850),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1856),
    [anon_sym_TODO] = ACTIONS(1858),
    [anon_sym_WIP] = ACTIONS(1858),
    [anon_sym_NOTE] = ACTIONS(1860),
    [anon_sym_INFO] = ACTIONS(1860),
    [anon_sym_XXX] = ACTIONS(1860),
    [sym_fixme] = ACTIONS(1824),
    [aux_sym__text_token1] = ACTIONS(1862),
    [sym__newline_inline] = ACTIONS(2188),
    [sym_hard_line_break] = ACTIONS(1824),
    [sym__verbatim_begin] = ACTIONS(1866),
  },
  [190] = {
    [sym__inline] = STATE(2320),
    [sym__inline_element] = STATE(1014),
    [sym__smart_punctuation] = STATE(456),
    [sym_autolink] = STATE(456),
    [sym_emphasis] = STATE(457),
    [sym_emphasis_begin] = STATE(2566),
    [sym_strong] = STATE(457),
    [sym_strong_begin] = STATE(2567),
    [sym_superscript] = STATE(457),
    [sym_superscript_begin] = STATE(2568),
    [sym_subscript] = STATE(457),
    [sym_subscript_begin] = STATE(2569),
    [sym_highlighted] = STATE(457),
    [sym_highlighted_begin] = STATE(2570),
    [sym_insert] = STATE(457),
    [sym_insert_begin] = STATE(2571),
    [sym_delete] = STATE(457),
    [sym_delete_begin] = STATE(1976),
    [sym_footnote_reference] = STATE(457),
    [sym_footnote_marker_begin] = STATE(2573),
    [sym__image] = STATE(457),
    [sym_full_reference_image] = STATE(457),
    [sym_collapsed_reference_image] = STATE(457),
    [sym_inline_image] = STATE(457),
    [sym_image_description] = STATE(1264),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(457),
    [sym_full_reference_link] = STATE(457),
    [sym_collapsed_reference_link] = STATE(457),
    [sym_inline_link] = STATE(457),
    [sym_link_text] = STATE(1265),
    [sym_span] = STATE(1014),
    [sym__bracketed_text_begin] = STATE(2618),
    [sym_inline_comment] = STATE(456),
    [sym_raw_inline] = STATE(456),
    [sym_math] = STATE(456),
    [sym_verbatim] = STATE(456),
    [sym__todo_highlights] = STATE(456),
    [sym_todo] = STATE(456),
    [sym_note] = STATE(456),
    [sym__symbol_fallback] = STATE(456),
    [aux_sym__text] = STATE(440),
    [aux_sym__inline_repeat1] = STATE(157),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [sym__whitespace1] = ACTIONS(1942),
    [sym_quotation_marks] = ACTIONS(1944),
    [sym_ellipsis] = ACTIONS(1944),
    [sym_em_dash] = ACTIONS(1944),
    [sym_en_dash] = ACTIONS(1946),
    [sym_backslash_escape] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1948),
    [sym_symbol] = ACTIONS(1944),
    [anon_sym_LBRACE_] = ACTIONS(1950),
    [anon_sym__] = ACTIONS(1952),
    [anon_sym_LBRACE_STAR] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_LBRACE_CARET] = ACTIONS(1958),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_LBRACE_EQ] = ACTIONS(1962),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1964),
    [anon_sym_LBRACE_DASH] = ACTIONS(1966),
    [anon_sym_LBRACK_CARET] = ACTIONS(1968),
    [anon_sym_BANG_LBRACK] = ACTIONS(1970),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1974),
    [anon_sym_DOLLAR] = ACTIONS(1976),
    [anon_sym_TODO] = ACTIONS(1978),
    [anon_sym_WIP] = ACTIONS(1978),
    [anon_sym_NOTE] = ACTIONS(1980),
    [anon_sym_INFO] = ACTIONS(1980),
    [anon_sym_XXX] = ACTIONS(1980),
    [sym_fixme] = ACTIONS(1944),
    [aux_sym__text_token1] = ACTIONS(1982),
    [sym__newline_inline] = ACTIONS(2190),
    [sym_hard_line_break] = ACTIONS(1944),
    [sym__verbatim_begin] = ACTIONS(1986),
  },
  [191] = {
    [sym__inline_without_trailing_space] = STATE(1978),
    [sym__inline_element] = STATE(988),
    [sym__smart_punctuation] = STATE(460),
    [sym_autolink] = STATE(460),
    [sym_emphasis] = STATE(463),
    [sym_emphasis_begin] = STATE(2484),
    [sym_strong] = STATE(463),
    [sym_strong_begin] = STATE(2485),
    [sym_superscript] = STATE(463),
    [sym_superscript_begin] = STATE(2486),
    [sym_subscript] = STATE(463),
    [sym_subscript_begin] = STATE(2487),
    [sym_highlighted] = STATE(463),
    [sym_highlighted_begin] = STATE(2488),
    [sym_insert] = STATE(463),
    [sym_insert_begin] = STATE(2489),
    [sym_delete] = STATE(463),
    [sym_delete_begin] = STATE(2490),
    [sym_footnote_reference] = STATE(463),
    [sym_footnote_marker_begin] = STATE(2491),
    [sym__image] = STATE(463),
    [sym_full_reference_image] = STATE(463),
    [sym_collapsed_reference_image] = STATE(463),
    [sym_inline_image] = STATE(463),
    [sym_image_description] = STATE(1268),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(463),
    [sym_full_reference_link] = STATE(463),
    [sym_collapsed_reference_link] = STATE(463),
    [sym_inline_link] = STATE(463),
    [sym_link_text] = STATE(1273),
    [sym_span] = STATE(988),
    [sym__bracketed_text_begin] = STATE(2607),
    [sym_inline_comment] = STATE(460),
    [sym_raw_inline] = STATE(460),
    [sym_math] = STATE(460),
    [sym_verbatim] = STATE(460),
    [sym__todo_highlights] = STATE(460),
    [sym_todo] = STATE(460),
    [sym_note] = STATE(460),
    [sym__symbol_fallback] = STATE(460),
    [aux_sym__text] = STATE(444),
    [aux_sym__inline_repeat1] = STATE(286),
    [anon_sym_LBRACK] = ACTIONS(1772),
    [sym__whitespace1] = ACTIONS(1774),
    [sym_quotation_marks] = ACTIONS(1776),
    [sym_ellipsis] = ACTIONS(1776),
    [sym_em_dash] = ACTIONS(1776),
    [sym_en_dash] = ACTIONS(1778),
    [sym_backslash_escape] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1780),
    [sym_symbol] = ACTIONS(1776),
    [anon_sym_LBRACE_] = ACTIONS(1782),
    [anon_sym__] = ACTIONS(1784),
    [anon_sym_LBRACE_STAR] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_LBRACE_CARET] = ACTIONS(1790),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1792),
    [anon_sym_LBRACE_EQ] = ACTIONS(1794),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1796),
    [anon_sym_LBRACE_DASH] = ACTIONS(1798),
    [anon_sym_LBRACK_CARET] = ACTIONS(1800),
    [anon_sym_BANG_LBRACK] = ACTIONS(1802),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1804),
    [anon_sym_LPAREN] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [anon_sym_TODO] = ACTIONS(1810),
    [anon_sym_WIP] = ACTIONS(1810),
    [anon_sym_NOTE] = ACTIONS(1812),
    [anon_sym_INFO] = ACTIONS(1812),
    [anon_sym_XXX] = ACTIONS(1812),
    [sym_fixme] = ACTIONS(1776),
    [aux_sym__text_token1] = ACTIONS(1814),
    [sym__newline_inline] = ACTIONS(1816),
    [sym_hard_line_break] = ACTIONS(1776),
    [sym__verbatim_begin] = ACTIONS(1818),
  },
  [192] = {
    [sym__inline_without_trailing_space] = STATE(1979),
    [sym__inline_element] = STATE(959),
    [sym__smart_punctuation] = STATE(464),
    [sym_autolink] = STATE(464),
    [sym_emphasis] = STATE(465),
    [sym_emphasis_begin] = STATE(2498),
    [sym_strong] = STATE(465),
    [sym_strong_begin] = STATE(2499),
    [sym_superscript] = STATE(465),
    [sym_superscript_begin] = STATE(2500),
    [sym_subscript] = STATE(465),
    [sym_subscript_begin] = STATE(2501),
    [sym_highlighted] = STATE(465),
    [sym_highlighted_begin] = STATE(2502),
    [sym_insert] = STATE(465),
    [sym_insert_begin] = STATE(2503),
    [sym_delete] = STATE(465),
    [sym_delete_begin] = STATE(2504),
    [sym_footnote_reference] = STATE(465),
    [sym_footnote_marker_begin] = STATE(2505),
    [sym__image] = STATE(465),
    [sym_full_reference_image] = STATE(465),
    [sym_collapsed_reference_image] = STATE(465),
    [sym_inline_image] = STATE(465),
    [sym_image_description] = STATE(1314),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(465),
    [sym_full_reference_link] = STATE(465),
    [sym_collapsed_reference_link] = STATE(465),
    [sym_inline_link] = STATE(465),
    [sym_link_text] = STATE(1319),
    [sym_span] = STATE(959),
    [sym__bracketed_text_begin] = STATE(2610),
    [sym_inline_comment] = STATE(464),
    [sym_raw_inline] = STATE(464),
    [sym_math] = STATE(464),
    [sym_verbatim] = STATE(464),
    [sym__todo_highlights] = STATE(464),
    [sym_todo] = STATE(464),
    [sym_note] = STATE(464),
    [sym__symbol_fallback] = STATE(464),
    [aux_sym__text] = STATE(445),
    [aux_sym__inline_repeat1] = STATE(287),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [sym__whitespace1] = ACTIONS(2136),
    [sym_quotation_marks] = ACTIONS(2138),
    [sym_ellipsis] = ACTIONS(2138),
    [sym_em_dash] = ACTIONS(2138),
    [sym_en_dash] = ACTIONS(2140),
    [sym_backslash_escape] = ACTIONS(2140),
    [anon_sym_LT] = ACTIONS(2142),
    [sym_symbol] = ACTIONS(2138),
    [anon_sym_LBRACE_] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_LBRACE_STAR] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_LBRACE_CARET] = ACTIONS(2152),
    [anon_sym_CARET] = ACTIONS(2152),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACE_EQ] = ACTIONS(2156),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2158),
    [anon_sym_LBRACE_DASH] = ACTIONS(2160),
    [anon_sym_LBRACK_CARET] = ACTIONS(2162),
    [anon_sym_BANG_LBRACK] = ACTIONS(2164),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_TODO] = ACTIONS(2172),
    [anon_sym_WIP] = ACTIONS(2172),
    [anon_sym_NOTE] = ACTIONS(2174),
    [anon_sym_INFO] = ACTIONS(2174),
    [anon_sym_XXX] = ACTIONS(2174),
    [sym_fixme] = ACTIONS(2138),
    [aux_sym__text_token1] = ACTIONS(2176),
    [sym__newline_inline] = ACTIONS(2178),
    [sym_hard_line_break] = ACTIONS(2138),
    [sym__verbatim_begin] = ACTIONS(2180),
  },
  [193] = {
    [sym__inline] = STATE(1980),
    [sym__inline_element] = STATE(1017),
    [sym__smart_punctuation] = STATE(468),
    [sym_autolink] = STATE(468),
    [sym_emphasis] = STATE(469),
    [sym_emphasis_begin] = STATE(2511),
    [sym_strong] = STATE(469),
    [sym_strong_begin] = STATE(2512),
    [sym_superscript] = STATE(469),
    [sym_superscript_begin] = STATE(2513),
    [sym_subscript] = STATE(469),
    [sym_subscript_begin] = STATE(2514),
    [sym_highlighted] = STATE(469),
    [sym_highlighted_begin] = STATE(2515),
    [sym_insert] = STATE(469),
    [sym_insert_begin] = STATE(2516),
    [sym_delete] = STATE(469),
    [sym_delete_begin] = STATE(2517),
    [sym_footnote_reference] = STATE(469),
    [sym_footnote_marker_begin] = STATE(2518),
    [sym__image] = STATE(469),
    [sym_full_reference_image] = STATE(469),
    [sym_collapsed_reference_image] = STATE(469),
    [sym_inline_image] = STATE(469),
    [sym_image_description] = STATE(1325),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(469),
    [sym_full_reference_link] = STATE(469),
    [sym_collapsed_reference_link] = STATE(469),
    [sym_inline_link] = STATE(469),
    [sym_link_text] = STATE(1326),
    [sym_span] = STATE(1017),
    [sym__bracketed_text_begin] = STATE(2613),
    [sym_inline_comment] = STATE(468),
    [sym_raw_inline] = STATE(468),
    [sym_math] = STATE(468),
    [sym_verbatim] = STATE(468),
    [sym__todo_highlights] = STATE(468),
    [sym_todo] = STATE(468),
    [sym_note] = STATE(468),
    [sym__symbol_fallback] = STATE(468),
    [aux_sym__text] = STATE(446),
    [aux_sym__inline_repeat1] = STATE(146),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [sym__whitespace1] = ACTIONS(1340),
    [sym_quotation_marks] = ACTIONS(1342),
    [sym_ellipsis] = ACTIONS(1342),
    [sym_em_dash] = ACTIONS(1342),
    [sym_en_dash] = ACTIONS(1344),
    [sym_backslash_escape] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [sym_symbol] = ACTIONS(1342),
    [anon_sym_LBRACE_] = ACTIONS(1348),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_LBRACE_STAR] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_LBRACE_CARET] = ACTIONS(1356),
    [anon_sym_CARET] = ACTIONS(1356),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_LBRACE_EQ] = ACTIONS(1360),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1362),
    [anon_sym_LBRACE_DASH] = ACTIONS(1364),
    [anon_sym_LBRACK_CARET] = ACTIONS(1366),
    [anon_sym_BANG_LBRACK] = ACTIONS(1368),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1374),
    [anon_sym_TODO] = ACTIONS(1376),
    [anon_sym_WIP] = ACTIONS(1376),
    [anon_sym_NOTE] = ACTIONS(1378),
    [anon_sym_INFO] = ACTIONS(1378),
    [anon_sym_XXX] = ACTIONS(1378),
    [sym_fixme] = ACTIONS(1342),
    [aux_sym__text_token1] = ACTIONS(1380),
    [sym__newline_inline] = ACTIONS(2182),
    [sym_hard_line_break] = ACTIONS(1342),
    [sym__verbatim_begin] = ACTIONS(1384),
  },
  [194] = {
    [sym__inline] = STATE(1983),
    [sym__inline_element] = STATE(915),
    [sym__smart_punctuation] = STATE(470),
    [sym_autolink] = STATE(470),
    [sym_emphasis] = STATE(471),
    [sym_emphasis_begin] = STATE(2522),
    [sym_strong] = STATE(471),
    [sym_strong_begin] = STATE(2523),
    [sym_superscript] = STATE(471),
    [sym_superscript_begin] = STATE(2524),
    [sym_subscript] = STATE(471),
    [sym_subscript_begin] = STATE(2525),
    [sym_highlighted] = STATE(471),
    [sym_highlighted_begin] = STATE(2526),
    [sym_insert] = STATE(471),
    [sym_insert_begin] = STATE(2527),
    [sym_delete] = STATE(471),
    [sym_delete_begin] = STATE(2528),
    [sym_footnote_reference] = STATE(471),
    [sym_footnote_marker_begin] = STATE(2529),
    [sym__image] = STATE(471),
    [sym_full_reference_image] = STATE(471),
    [sym_collapsed_reference_image] = STATE(471),
    [sym_inline_image] = STATE(471),
    [sym_image_description] = STATE(1332),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(471),
    [sym_full_reference_link] = STATE(471),
    [sym_collapsed_reference_link] = STATE(471),
    [sym_inline_link] = STATE(471),
    [sym_link_text] = STATE(1334),
    [sym_span] = STATE(915),
    [sym__bracketed_text_begin] = STATE(2614),
    [sym_inline_comment] = STATE(470),
    [sym_raw_inline] = STATE(470),
    [sym_math] = STATE(470),
    [sym_verbatim] = STATE(470),
    [sym__todo_highlights] = STATE(470),
    [sym_todo] = STATE(470),
    [sym_note] = STATE(470),
    [sym__symbol_fallback] = STATE(470),
    [aux_sym__text] = STATE(447),
    [aux_sym__inline_repeat1] = STATE(148),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [sym__whitespace1] = ACTIONS(1460),
    [sym_quotation_marks] = ACTIONS(1462),
    [sym_ellipsis] = ACTIONS(1462),
    [sym_em_dash] = ACTIONS(1462),
    [sym_en_dash] = ACTIONS(1464),
    [sym_backslash_escape] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [sym_symbol] = ACTIONS(1462),
    [anon_sym_LBRACE_] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(1470),
    [anon_sym_LBRACE_STAR] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACE_CARET] = ACTIONS(1476),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_LBRACE_EQ] = ACTIONS(1480),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1482),
    [anon_sym_LBRACE_DASH] = ACTIONS(1484),
    [anon_sym_LBRACK_CARET] = ACTIONS(1486),
    [anon_sym_BANG_LBRACK] = ACTIONS(1488),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_TODO] = ACTIONS(1496),
    [anon_sym_WIP] = ACTIONS(1496),
    [anon_sym_NOTE] = ACTIONS(1498),
    [anon_sym_INFO] = ACTIONS(1498),
    [anon_sym_XXX] = ACTIONS(1498),
    [sym_fixme] = ACTIONS(1462),
    [aux_sym__text_token1] = ACTIONS(1500),
    [sym__newline_inline] = ACTIONS(2184),
    [sym_hard_line_break] = ACTIONS(1462),
    [sym__verbatim_begin] = ACTIONS(1504),
  },
  [195] = {
    [sym__inline] = STATE(1985),
    [sym__inline_element] = STATE(1021),
    [sym__smart_punctuation] = STATE(473),
    [sym_autolink] = STATE(473),
    [sym_emphasis] = STATE(450),
    [sym_emphasis_begin] = STATE(2533),
    [sym_strong] = STATE(450),
    [sym_strong_begin] = STATE(2534),
    [sym_superscript] = STATE(450),
    [sym_superscript_begin] = STATE(2535),
    [sym_subscript] = STATE(450),
    [sym_subscript_begin] = STATE(2536),
    [sym_highlighted] = STATE(450),
    [sym_highlighted_begin] = STATE(2537),
    [sym_insert] = STATE(450),
    [sym_insert_begin] = STATE(2538),
    [sym_delete] = STATE(450),
    [sym_delete_begin] = STATE(2539),
    [sym_footnote_reference] = STATE(450),
    [sym_footnote_marker_begin] = STATE(2540),
    [sym__image] = STATE(450),
    [sym_full_reference_image] = STATE(450),
    [sym_collapsed_reference_image] = STATE(450),
    [sym_inline_image] = STATE(450),
    [sym_image_description] = STATE(1340),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(450),
    [sym_full_reference_link] = STATE(450),
    [sym_collapsed_reference_link] = STATE(450),
    [sym_inline_link] = STATE(450),
    [sym_link_text] = STATE(1341),
    [sym_span] = STATE(1021),
    [sym__bracketed_text_begin] = STATE(2615),
    [sym_inline_comment] = STATE(473),
    [sym_raw_inline] = STATE(473),
    [sym_math] = STATE(473),
    [sym_verbatim] = STATE(473),
    [sym__todo_highlights] = STATE(473),
    [sym_todo] = STATE(473),
    [sym_note] = STATE(473),
    [sym__symbol_fallback] = STATE(473),
    [aux_sym__text] = STATE(448),
    [aux_sym__inline_repeat1] = STATE(150),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [sym__whitespace1] = ACTIONS(1580),
    [sym_quotation_marks] = ACTIONS(1582),
    [sym_ellipsis] = ACTIONS(1582),
    [sym_em_dash] = ACTIONS(1582),
    [sym_en_dash] = ACTIONS(1584),
    [sym_backslash_escape] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1586),
    [sym_symbol] = ACTIONS(1582),
    [anon_sym_LBRACE_] = ACTIONS(1588),
    [anon_sym__] = ACTIONS(1590),
    [anon_sym_LBRACE_STAR] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_LBRACE_CARET] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_LBRACE_EQ] = ACTIONS(1600),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1602),
    [anon_sym_LBRACE_DASH] = ACTIONS(1604),
    [anon_sym_LBRACK_CARET] = ACTIONS(1606),
    [anon_sym_BANG_LBRACK] = ACTIONS(1608),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_DOLLAR] = ACTIONS(1614),
    [anon_sym_TODO] = ACTIONS(1616),
    [anon_sym_WIP] = ACTIONS(1616),
    [anon_sym_NOTE] = ACTIONS(1618),
    [anon_sym_INFO] = ACTIONS(1618),
    [anon_sym_XXX] = ACTIONS(1618),
    [sym_fixme] = ACTIONS(1582),
    [aux_sym__text_token1] = ACTIONS(1620),
    [sym__newline_inline] = ACTIONS(2186),
    [sym_hard_line_break] = ACTIONS(1582),
    [sym__verbatim_begin] = ACTIONS(1624),
  },
  [196] = {
    [sym__inline] = STATE(1986),
    [sym__inline_element] = STATE(997),
    [sym__smart_punctuation] = STATE(451),
    [sym_autolink] = STATE(451),
    [sym_emphasis] = STATE(449),
    [sym_emphasis_begin] = STATE(2544),
    [sym_strong] = STATE(449),
    [sym_strong_begin] = STATE(2545),
    [sym_superscript] = STATE(449),
    [sym_superscript_begin] = STATE(2546),
    [sym_subscript] = STATE(449),
    [sym_subscript_begin] = STATE(2547),
    [sym_highlighted] = STATE(449),
    [sym_highlighted_begin] = STATE(2548),
    [sym_insert] = STATE(449),
    [sym_insert_begin] = STATE(2549),
    [sym_delete] = STATE(449),
    [sym_delete_begin] = STATE(2550),
    [sym_footnote_reference] = STATE(449),
    [sym_footnote_marker_begin] = STATE(2551),
    [sym__image] = STATE(449),
    [sym_full_reference_image] = STATE(449),
    [sym_collapsed_reference_image] = STATE(449),
    [sym_inline_image] = STATE(449),
    [sym_image_description] = STATE(1250),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(449),
    [sym_full_reference_link] = STATE(449),
    [sym_collapsed_reference_link] = STATE(449),
    [sym_inline_link] = STATE(449),
    [sym_link_text] = STATE(1251),
    [sym_span] = STATE(997),
    [sym__bracketed_text_begin] = STATE(2616),
    [sym_inline_comment] = STATE(451),
    [sym_raw_inline] = STATE(451),
    [sym_math] = STATE(451),
    [sym_verbatim] = STATE(451),
    [sym__todo_highlights] = STATE(451),
    [sym_todo] = STATE(451),
    [sym_note] = STATE(451),
    [sym__symbol_fallback] = STATE(451),
    [aux_sym__text] = STATE(439),
    [aux_sym__inline_repeat1] = STATE(152),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [sym__whitespace1] = ACTIONS(1074),
    [sym_quotation_marks] = ACTIONS(1076),
    [sym_ellipsis] = ACTIONS(1076),
    [sym_em_dash] = ACTIONS(1076),
    [sym_en_dash] = ACTIONS(1078),
    [sym_backslash_escape] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(1080),
    [sym_symbol] = ACTIONS(1076),
    [anon_sym_LBRACE_] = ACTIONS(1082),
    [anon_sym__] = ACTIONS(1084),
    [anon_sym_LBRACE_STAR] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_LBRACE_CARET] = ACTIONS(1090),
    [anon_sym_CARET] = ACTIONS(1090),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_LBRACE_EQ] = ACTIONS(1094),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1096),
    [anon_sym_LBRACE_DASH] = ACTIONS(1098),
    [anon_sym_LBRACK_CARET] = ACTIONS(1100),
    [anon_sym_BANG_LBRACK] = ACTIONS(1102),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [anon_sym_TODO] = ACTIONS(1110),
    [anon_sym_WIP] = ACTIONS(1110),
    [anon_sym_NOTE] = ACTIONS(1112),
    [anon_sym_INFO] = ACTIONS(1112),
    [anon_sym_XXX] = ACTIONS(1112),
    [sym_fixme] = ACTIONS(1076),
    [aux_sym__text_token1] = ACTIONS(1114),
    [sym__newline_inline] = ACTIONS(1116),
    [sym_hard_line_break] = ACTIONS(1076),
    [sym__verbatim_begin] = ACTIONS(1118),
  },
  [197] = {
    [sym__inline] = STATE(2005),
    [sym__inline_element] = STATE(900),
    [sym__smart_punctuation] = STATE(454),
    [sym_autolink] = STATE(454),
    [sym_emphasis] = STATE(455),
    [sym_emphasis_begin] = STATE(2555),
    [sym_strong] = STATE(455),
    [sym_strong_begin] = STATE(2556),
    [sym_superscript] = STATE(455),
    [sym_superscript_begin] = STATE(2557),
    [sym_subscript] = STATE(455),
    [sym_subscript_begin] = STATE(2558),
    [sym_highlighted] = STATE(455),
    [sym_highlighted_begin] = STATE(2559),
    [sym_insert] = STATE(455),
    [sym_insert_begin] = STATE(2560),
    [sym_delete] = STATE(455),
    [sym_delete_begin] = STATE(2561),
    [sym_footnote_reference] = STATE(455),
    [sym_footnote_marker_begin] = STATE(2562),
    [sym__image] = STATE(455),
    [sym_full_reference_image] = STATE(455),
    [sym_collapsed_reference_image] = STATE(455),
    [sym_inline_image] = STATE(455),
    [sym_image_description] = STATE(1257),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(455),
    [sym_full_reference_link] = STATE(455),
    [sym_collapsed_reference_link] = STATE(455),
    [sym_inline_link] = STATE(455),
    [sym_link_text] = STATE(1258),
    [sym_span] = STATE(900),
    [sym__bracketed_text_begin] = STATE(2617),
    [sym_inline_comment] = STATE(454),
    [sym_raw_inline] = STATE(454),
    [sym_math] = STATE(454),
    [sym_verbatim] = STATE(454),
    [sym__todo_highlights] = STATE(454),
    [sym_todo] = STATE(454),
    [sym_note] = STATE(454),
    [sym__symbol_fallback] = STATE(454),
    [aux_sym__text] = STATE(441),
    [aux_sym__inline_repeat1] = STATE(155),
    [anon_sym_LBRACK] = ACTIONS(1820),
    [sym__whitespace1] = ACTIONS(1822),
    [sym_quotation_marks] = ACTIONS(1824),
    [sym_ellipsis] = ACTIONS(1824),
    [sym_em_dash] = ACTIONS(1824),
    [sym_en_dash] = ACTIONS(1826),
    [sym_backslash_escape] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1828),
    [sym_symbol] = ACTIONS(1824),
    [anon_sym_LBRACE_] = ACTIONS(1830),
    [anon_sym__] = ACTIONS(1832),
    [anon_sym_LBRACE_STAR] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_LBRACE_CARET] = ACTIONS(1838),
    [anon_sym_CARET] = ACTIONS(1838),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1840),
    [anon_sym_TILDE] = ACTIONS(1840),
    [anon_sym_LBRACE_EQ] = ACTIONS(1842),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1844),
    [anon_sym_LBRACE_DASH] = ACTIONS(1846),
    [anon_sym_LBRACK_CARET] = ACTIONS(1848),
    [anon_sym_BANG_LBRACK] = ACTIONS(1850),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1856),
    [anon_sym_TODO] = ACTIONS(1858),
    [anon_sym_WIP] = ACTIONS(1858),
    [anon_sym_NOTE] = ACTIONS(1860),
    [anon_sym_INFO] = ACTIONS(1860),
    [anon_sym_XXX] = ACTIONS(1860),
    [sym_fixme] = ACTIONS(1824),
    [aux_sym__text_token1] = ACTIONS(1862),
    [sym__newline_inline] = ACTIONS(2188),
    [sym_hard_line_break] = ACTIONS(1824),
    [sym__verbatim_begin] = ACTIONS(1866),
  },
  [198] = {
    [sym__inline] = STATE(2007),
    [sym__inline_element] = STATE(1014),
    [sym__smart_punctuation] = STATE(456),
    [sym_autolink] = STATE(456),
    [sym_emphasis] = STATE(457),
    [sym_emphasis_begin] = STATE(2566),
    [sym_strong] = STATE(457),
    [sym_strong_begin] = STATE(2567),
    [sym_superscript] = STATE(457),
    [sym_superscript_begin] = STATE(2568),
    [sym_subscript] = STATE(457),
    [sym_subscript_begin] = STATE(2569),
    [sym_highlighted] = STATE(457),
    [sym_highlighted_begin] = STATE(2570),
    [sym_insert] = STATE(457),
    [sym_insert_begin] = STATE(2571),
    [sym_delete] = STATE(457),
    [sym_delete_begin] = STATE(1976),
    [sym_footnote_reference] = STATE(457),
    [sym_footnote_marker_begin] = STATE(2573),
    [sym__image] = STATE(457),
    [sym_full_reference_image] = STATE(457),
    [sym_collapsed_reference_image] = STATE(457),
    [sym_inline_image] = STATE(457),
    [sym_image_description] = STATE(1264),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(457),
    [sym_full_reference_link] = STATE(457),
    [sym_collapsed_reference_link] = STATE(457),
    [sym_inline_link] = STATE(457),
    [sym_link_text] = STATE(1265),
    [sym_span] = STATE(1014),
    [sym__bracketed_text_begin] = STATE(2618),
    [sym_inline_comment] = STATE(456),
    [sym_raw_inline] = STATE(456),
    [sym_math] = STATE(456),
    [sym_verbatim] = STATE(456),
    [sym__todo_highlights] = STATE(456),
    [sym_todo] = STATE(456),
    [sym_note] = STATE(456),
    [sym__symbol_fallback] = STATE(456),
    [aux_sym__text] = STATE(440),
    [aux_sym__inline_repeat1] = STATE(157),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [sym__whitespace1] = ACTIONS(1942),
    [sym_quotation_marks] = ACTIONS(1944),
    [sym_ellipsis] = ACTIONS(1944),
    [sym_em_dash] = ACTIONS(1944),
    [sym_en_dash] = ACTIONS(1946),
    [sym_backslash_escape] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1948),
    [sym_symbol] = ACTIONS(1944),
    [anon_sym_LBRACE_] = ACTIONS(1950),
    [anon_sym__] = ACTIONS(1952),
    [anon_sym_LBRACE_STAR] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_LBRACE_CARET] = ACTIONS(1958),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_LBRACE_EQ] = ACTIONS(1962),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1964),
    [anon_sym_LBRACE_DASH] = ACTIONS(1966),
    [anon_sym_LBRACK_CARET] = ACTIONS(1968),
    [anon_sym_BANG_LBRACK] = ACTIONS(1970),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1974),
    [anon_sym_DOLLAR] = ACTIONS(1976),
    [anon_sym_TODO] = ACTIONS(1978),
    [anon_sym_WIP] = ACTIONS(1978),
    [anon_sym_NOTE] = ACTIONS(1980),
    [anon_sym_INFO] = ACTIONS(1980),
    [anon_sym_XXX] = ACTIONS(1980),
    [sym_fixme] = ACTIONS(1944),
    [aux_sym__text_token1] = ACTIONS(1982),
    [sym__newline_inline] = ACTIONS(2190),
    [sym_hard_line_break] = ACTIONS(1944),
    [sym__verbatim_begin] = ACTIONS(1986),
  },
  [199] = {
    [sym__inline] = STATE(2612),
    [sym__inline_element] = STATE(982),
    [sym__smart_punctuation] = STATE(452),
    [sym_autolink] = STATE(452),
    [sym_emphasis] = STATE(453),
    [sym_emphasis_begin] = STATE(2470),
    [sym_strong] = STATE(453),
    [sym_strong_begin] = STATE(2471),
    [sym_superscript] = STATE(453),
    [sym_superscript_begin] = STATE(2472),
    [sym_subscript] = STATE(453),
    [sym_subscript_begin] = STATE(2473),
    [sym_highlighted] = STATE(453),
    [sym_highlighted_begin] = STATE(2474),
    [sym_insert] = STATE(453),
    [sym_insert_begin] = STATE(2475),
    [sym_delete] = STATE(453),
    [sym_delete_begin] = STATE(2476),
    [sym_footnote_reference] = STATE(453),
    [sym_footnote_marker_begin] = STATE(2477),
    [sym__image] = STATE(453),
    [sym_full_reference_image] = STATE(453),
    [sym_collapsed_reference_image] = STATE(453),
    [sym_inline_image] = STATE(453),
    [sym_image_description] = STATE(1282),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(453),
    [sym_full_reference_link] = STATE(453),
    [sym_collapsed_reference_link] = STATE(453),
    [sym_inline_link] = STATE(453),
    [sym_link_text] = STATE(1299),
    [sym_span] = STATE(982),
    [sym__bracketed_text_begin] = STATE(2603),
    [sym_inline_comment] = STATE(452),
    [sym_raw_inline] = STATE(452),
    [sym_math] = STATE(452),
    [sym_verbatim] = STATE(452),
    [sym__todo_highlights] = STATE(452),
    [sym_todo] = STATE(452),
    [sym_note] = STATE(452),
    [sym__symbol_fallback] = STATE(452),
    [aux_sym__text] = STATE(437),
    [aux_sym__inline_repeat1] = STATE(144),
    [anon_sym_LBRACK] = ACTIONS(1120),
    [sym__whitespace1] = ACTIONS(1122),
    [sym_quotation_marks] = ACTIONS(1124),
    [sym_ellipsis] = ACTIONS(1124),
    [sym_em_dash] = ACTIONS(1124),
    [sym_en_dash] = ACTIONS(1126),
    [sym_backslash_escape] = ACTIONS(1126),
    [anon_sym_LT] = ACTIONS(1128),
    [sym_symbol] = ACTIONS(1124),
    [anon_sym_LBRACE_] = ACTIONS(1130),
    [anon_sym__] = ACTIONS(1132),
    [anon_sym_LBRACE_STAR] = ACTIONS(1134),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACE_CARET] = ACTIONS(1138),
    [anon_sym_CARET] = ACTIONS(1138),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_LBRACE_EQ] = ACTIONS(1142),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1144),
    [anon_sym_LBRACE_DASH] = ACTIONS(1146),
    [anon_sym_LBRACK_CARET] = ACTIONS(1148),
    [anon_sym_BANG_LBRACK] = ACTIONS(1150),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1152),
    [anon_sym_LPAREN] = ACTIONS(1154),
    [anon_sym_DOLLAR] = ACTIONS(1156),
    [anon_sym_TODO] = ACTIONS(1158),
    [anon_sym_WIP] = ACTIONS(1158),
    [anon_sym_NOTE] = ACTIONS(1160),
    [anon_sym_INFO] = ACTIONS(1160),
    [anon_sym_XXX] = ACTIONS(1160),
    [sym_fixme] = ACTIONS(1124),
    [aux_sym__text_token1] = ACTIONS(1162),
    [sym__newline_inline] = ACTIONS(1164),
    [sym_hard_line_break] = ACTIONS(1124),
    [sym__verbatim_begin] = ACTIONS(1166),
  },
  [200] = {
    [sym__inline_without_trailing_space] = STATE(2178),
    [sym__inline_element] = STATE(959),
    [sym__smart_punctuation] = STATE(464),
    [sym_autolink] = STATE(464),
    [sym_emphasis] = STATE(465),
    [sym_emphasis_begin] = STATE(2498),
    [sym_strong] = STATE(465),
    [sym_strong_begin] = STATE(2499),
    [sym_superscript] = STATE(465),
    [sym_superscript_begin] = STATE(2500),
    [sym_subscript] = STATE(465),
    [sym_subscript_begin] = STATE(2501),
    [sym_highlighted] = STATE(465),
    [sym_highlighted_begin] = STATE(2502),
    [sym_insert] = STATE(465),
    [sym_insert_begin] = STATE(2503),
    [sym_delete] = STATE(465),
    [sym_delete_begin] = STATE(2504),
    [sym_footnote_reference] = STATE(465),
    [sym_footnote_marker_begin] = STATE(2505),
    [sym__image] = STATE(465),
    [sym_full_reference_image] = STATE(465),
    [sym_collapsed_reference_image] = STATE(465),
    [sym_inline_image] = STATE(465),
    [sym_image_description] = STATE(1314),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(465),
    [sym_full_reference_link] = STATE(465),
    [sym_collapsed_reference_link] = STATE(465),
    [sym_inline_link] = STATE(465),
    [sym_link_text] = STATE(1319),
    [sym_span] = STATE(959),
    [sym__bracketed_text_begin] = STATE(2610),
    [sym_inline_comment] = STATE(464),
    [sym_raw_inline] = STATE(464),
    [sym_math] = STATE(464),
    [sym_verbatim] = STATE(464),
    [sym__todo_highlights] = STATE(464),
    [sym_todo] = STATE(464),
    [sym_note] = STATE(464),
    [sym__symbol_fallback] = STATE(464),
    [aux_sym__text] = STATE(445),
    [aux_sym__inline_repeat1] = STATE(287),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [sym__whitespace1] = ACTIONS(2136),
    [sym_quotation_marks] = ACTIONS(2138),
    [sym_ellipsis] = ACTIONS(2138),
    [sym_em_dash] = ACTIONS(2138),
    [sym_en_dash] = ACTIONS(2140),
    [sym_backslash_escape] = ACTIONS(2140),
    [anon_sym_LT] = ACTIONS(2142),
    [sym_symbol] = ACTIONS(2138),
    [anon_sym_LBRACE_] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_LBRACE_STAR] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_LBRACE_CARET] = ACTIONS(2152),
    [anon_sym_CARET] = ACTIONS(2152),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACE_EQ] = ACTIONS(2156),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2158),
    [anon_sym_LBRACE_DASH] = ACTIONS(2160),
    [anon_sym_LBRACK_CARET] = ACTIONS(2162),
    [anon_sym_BANG_LBRACK] = ACTIONS(2164),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_TODO] = ACTIONS(2172),
    [anon_sym_WIP] = ACTIONS(2172),
    [anon_sym_NOTE] = ACTIONS(2174),
    [anon_sym_INFO] = ACTIONS(2174),
    [anon_sym_XXX] = ACTIONS(2174),
    [sym_fixme] = ACTIONS(2138),
    [aux_sym__text_token1] = ACTIONS(2176),
    [sym__newline_inline] = ACTIONS(2178),
    [sym_hard_line_break] = ACTIONS(2138),
    [sym__verbatim_begin] = ACTIONS(2180),
  },
  [201] = {
    [sym__inline] = STATE(2181),
    [sym__inline_element] = STATE(1017),
    [sym__smart_punctuation] = STATE(468),
    [sym_autolink] = STATE(468),
    [sym_emphasis] = STATE(469),
    [sym_emphasis_begin] = STATE(2511),
    [sym_strong] = STATE(469),
    [sym_strong_begin] = STATE(2512),
    [sym_superscript] = STATE(469),
    [sym_superscript_begin] = STATE(2513),
    [sym_subscript] = STATE(469),
    [sym_subscript_begin] = STATE(2514),
    [sym_highlighted] = STATE(469),
    [sym_highlighted_begin] = STATE(2515),
    [sym_insert] = STATE(469),
    [sym_insert_begin] = STATE(2516),
    [sym_delete] = STATE(469),
    [sym_delete_begin] = STATE(2517),
    [sym_footnote_reference] = STATE(469),
    [sym_footnote_marker_begin] = STATE(2518),
    [sym__image] = STATE(469),
    [sym_full_reference_image] = STATE(469),
    [sym_collapsed_reference_image] = STATE(469),
    [sym_inline_image] = STATE(469),
    [sym_image_description] = STATE(1325),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(469),
    [sym_full_reference_link] = STATE(469),
    [sym_collapsed_reference_link] = STATE(469),
    [sym_inline_link] = STATE(469),
    [sym_link_text] = STATE(1326),
    [sym_span] = STATE(1017),
    [sym__bracketed_text_begin] = STATE(2613),
    [sym_inline_comment] = STATE(468),
    [sym_raw_inline] = STATE(468),
    [sym_math] = STATE(468),
    [sym_verbatim] = STATE(468),
    [sym__todo_highlights] = STATE(468),
    [sym_todo] = STATE(468),
    [sym_note] = STATE(468),
    [sym__symbol_fallback] = STATE(468),
    [aux_sym__text] = STATE(446),
    [aux_sym__inline_repeat1] = STATE(146),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [sym__whitespace1] = ACTIONS(1340),
    [sym_quotation_marks] = ACTIONS(1342),
    [sym_ellipsis] = ACTIONS(1342),
    [sym_em_dash] = ACTIONS(1342),
    [sym_en_dash] = ACTIONS(1344),
    [sym_backslash_escape] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [sym_symbol] = ACTIONS(1342),
    [anon_sym_LBRACE_] = ACTIONS(1348),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_LBRACE_STAR] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_LBRACE_CARET] = ACTIONS(1356),
    [anon_sym_CARET] = ACTIONS(1356),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_LBRACE_EQ] = ACTIONS(1360),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1362),
    [anon_sym_LBRACE_DASH] = ACTIONS(1364),
    [anon_sym_LBRACK_CARET] = ACTIONS(1366),
    [anon_sym_BANG_LBRACK] = ACTIONS(1368),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1374),
    [anon_sym_TODO] = ACTIONS(1376),
    [anon_sym_WIP] = ACTIONS(1376),
    [anon_sym_NOTE] = ACTIONS(1378),
    [anon_sym_INFO] = ACTIONS(1378),
    [anon_sym_XXX] = ACTIONS(1378),
    [sym_fixme] = ACTIONS(1342),
    [aux_sym__text_token1] = ACTIONS(1380),
    [sym__newline_inline] = ACTIONS(2182),
    [sym_hard_line_break] = ACTIONS(1342),
    [sym__verbatim_begin] = ACTIONS(1384),
  },
  [202] = {
    [sym__inline] = STATE(2183),
    [sym__inline_element] = STATE(915),
    [sym__smart_punctuation] = STATE(470),
    [sym_autolink] = STATE(470),
    [sym_emphasis] = STATE(471),
    [sym_emphasis_begin] = STATE(2522),
    [sym_strong] = STATE(471),
    [sym_strong_begin] = STATE(2523),
    [sym_superscript] = STATE(471),
    [sym_superscript_begin] = STATE(2524),
    [sym_subscript] = STATE(471),
    [sym_subscript_begin] = STATE(2525),
    [sym_highlighted] = STATE(471),
    [sym_highlighted_begin] = STATE(2526),
    [sym_insert] = STATE(471),
    [sym_insert_begin] = STATE(2527),
    [sym_delete] = STATE(471),
    [sym_delete_begin] = STATE(2528),
    [sym_footnote_reference] = STATE(471),
    [sym_footnote_marker_begin] = STATE(2529),
    [sym__image] = STATE(471),
    [sym_full_reference_image] = STATE(471),
    [sym_collapsed_reference_image] = STATE(471),
    [sym_inline_image] = STATE(471),
    [sym_image_description] = STATE(1332),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(471),
    [sym_full_reference_link] = STATE(471),
    [sym_collapsed_reference_link] = STATE(471),
    [sym_inline_link] = STATE(471),
    [sym_link_text] = STATE(1334),
    [sym_span] = STATE(915),
    [sym__bracketed_text_begin] = STATE(2614),
    [sym_inline_comment] = STATE(470),
    [sym_raw_inline] = STATE(470),
    [sym_math] = STATE(470),
    [sym_verbatim] = STATE(470),
    [sym__todo_highlights] = STATE(470),
    [sym_todo] = STATE(470),
    [sym_note] = STATE(470),
    [sym__symbol_fallback] = STATE(470),
    [aux_sym__text] = STATE(447),
    [aux_sym__inline_repeat1] = STATE(148),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [sym__whitespace1] = ACTIONS(1460),
    [sym_quotation_marks] = ACTIONS(1462),
    [sym_ellipsis] = ACTIONS(1462),
    [sym_em_dash] = ACTIONS(1462),
    [sym_en_dash] = ACTIONS(1464),
    [sym_backslash_escape] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [sym_symbol] = ACTIONS(1462),
    [anon_sym_LBRACE_] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(1470),
    [anon_sym_LBRACE_STAR] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACE_CARET] = ACTIONS(1476),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_LBRACE_EQ] = ACTIONS(1480),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1482),
    [anon_sym_LBRACE_DASH] = ACTIONS(1484),
    [anon_sym_LBRACK_CARET] = ACTIONS(1486),
    [anon_sym_BANG_LBRACK] = ACTIONS(1488),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_TODO] = ACTIONS(1496),
    [anon_sym_WIP] = ACTIONS(1496),
    [anon_sym_NOTE] = ACTIONS(1498),
    [anon_sym_INFO] = ACTIONS(1498),
    [anon_sym_XXX] = ACTIONS(1498),
    [sym_fixme] = ACTIONS(1462),
    [aux_sym__text_token1] = ACTIONS(1500),
    [sym__newline_inline] = ACTIONS(2184),
    [sym_hard_line_break] = ACTIONS(1462),
    [sym__verbatim_begin] = ACTIONS(1504),
  },
  [203] = {
    [sym__inline] = STATE(2184),
    [sym__inline_element] = STATE(1021),
    [sym__smart_punctuation] = STATE(473),
    [sym_autolink] = STATE(473),
    [sym_emphasis] = STATE(450),
    [sym_emphasis_begin] = STATE(2533),
    [sym_strong] = STATE(450),
    [sym_strong_begin] = STATE(2534),
    [sym_superscript] = STATE(450),
    [sym_superscript_begin] = STATE(2535),
    [sym_subscript] = STATE(450),
    [sym_subscript_begin] = STATE(2536),
    [sym_highlighted] = STATE(450),
    [sym_highlighted_begin] = STATE(2537),
    [sym_insert] = STATE(450),
    [sym_insert_begin] = STATE(2538),
    [sym_delete] = STATE(450),
    [sym_delete_begin] = STATE(2539),
    [sym_footnote_reference] = STATE(450),
    [sym_footnote_marker_begin] = STATE(2540),
    [sym__image] = STATE(450),
    [sym_full_reference_image] = STATE(450),
    [sym_collapsed_reference_image] = STATE(450),
    [sym_inline_image] = STATE(450),
    [sym_image_description] = STATE(1340),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(450),
    [sym_full_reference_link] = STATE(450),
    [sym_collapsed_reference_link] = STATE(450),
    [sym_inline_link] = STATE(450),
    [sym_link_text] = STATE(1341),
    [sym_span] = STATE(1021),
    [sym__bracketed_text_begin] = STATE(2615),
    [sym_inline_comment] = STATE(473),
    [sym_raw_inline] = STATE(473),
    [sym_math] = STATE(473),
    [sym_verbatim] = STATE(473),
    [sym__todo_highlights] = STATE(473),
    [sym_todo] = STATE(473),
    [sym_note] = STATE(473),
    [sym__symbol_fallback] = STATE(473),
    [aux_sym__text] = STATE(448),
    [aux_sym__inline_repeat1] = STATE(150),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [sym__whitespace1] = ACTIONS(1580),
    [sym_quotation_marks] = ACTIONS(1582),
    [sym_ellipsis] = ACTIONS(1582),
    [sym_em_dash] = ACTIONS(1582),
    [sym_en_dash] = ACTIONS(1584),
    [sym_backslash_escape] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1586),
    [sym_symbol] = ACTIONS(1582),
    [anon_sym_LBRACE_] = ACTIONS(1588),
    [anon_sym__] = ACTIONS(1590),
    [anon_sym_LBRACE_STAR] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_LBRACE_CARET] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_LBRACE_EQ] = ACTIONS(1600),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1602),
    [anon_sym_LBRACE_DASH] = ACTIONS(1604),
    [anon_sym_LBRACK_CARET] = ACTIONS(1606),
    [anon_sym_BANG_LBRACK] = ACTIONS(1608),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_DOLLAR] = ACTIONS(1614),
    [anon_sym_TODO] = ACTIONS(1616),
    [anon_sym_WIP] = ACTIONS(1616),
    [anon_sym_NOTE] = ACTIONS(1618),
    [anon_sym_INFO] = ACTIONS(1618),
    [anon_sym_XXX] = ACTIONS(1618),
    [sym_fixme] = ACTIONS(1582),
    [aux_sym__text_token1] = ACTIONS(1620),
    [sym__newline_inline] = ACTIONS(2186),
    [sym_hard_line_break] = ACTIONS(1582),
    [sym__verbatim_begin] = ACTIONS(1624),
  },
  [204] = {
    [sym__inline] = STATE(2185),
    [sym__inline_element] = STATE(997),
    [sym__smart_punctuation] = STATE(451),
    [sym_autolink] = STATE(451),
    [sym_emphasis] = STATE(449),
    [sym_emphasis_begin] = STATE(2544),
    [sym_strong] = STATE(449),
    [sym_strong_begin] = STATE(2545),
    [sym_superscript] = STATE(449),
    [sym_superscript_begin] = STATE(2546),
    [sym_subscript] = STATE(449),
    [sym_subscript_begin] = STATE(2547),
    [sym_highlighted] = STATE(449),
    [sym_highlighted_begin] = STATE(2548),
    [sym_insert] = STATE(449),
    [sym_insert_begin] = STATE(2549),
    [sym_delete] = STATE(449),
    [sym_delete_begin] = STATE(2550),
    [sym_footnote_reference] = STATE(449),
    [sym_footnote_marker_begin] = STATE(2551),
    [sym__image] = STATE(449),
    [sym_full_reference_image] = STATE(449),
    [sym_collapsed_reference_image] = STATE(449),
    [sym_inline_image] = STATE(449),
    [sym_image_description] = STATE(1250),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(449),
    [sym_full_reference_link] = STATE(449),
    [sym_collapsed_reference_link] = STATE(449),
    [sym_inline_link] = STATE(449),
    [sym_link_text] = STATE(1251),
    [sym_span] = STATE(997),
    [sym__bracketed_text_begin] = STATE(2616),
    [sym_inline_comment] = STATE(451),
    [sym_raw_inline] = STATE(451),
    [sym_math] = STATE(451),
    [sym_verbatim] = STATE(451),
    [sym__todo_highlights] = STATE(451),
    [sym_todo] = STATE(451),
    [sym_note] = STATE(451),
    [sym__symbol_fallback] = STATE(451),
    [aux_sym__text] = STATE(439),
    [aux_sym__inline_repeat1] = STATE(152),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [sym__whitespace1] = ACTIONS(1074),
    [sym_quotation_marks] = ACTIONS(1076),
    [sym_ellipsis] = ACTIONS(1076),
    [sym_em_dash] = ACTIONS(1076),
    [sym_en_dash] = ACTIONS(1078),
    [sym_backslash_escape] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(1080),
    [sym_symbol] = ACTIONS(1076),
    [anon_sym_LBRACE_] = ACTIONS(1082),
    [anon_sym__] = ACTIONS(1084),
    [anon_sym_LBRACE_STAR] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_LBRACE_CARET] = ACTIONS(1090),
    [anon_sym_CARET] = ACTIONS(1090),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_LBRACE_EQ] = ACTIONS(1094),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1096),
    [anon_sym_LBRACE_DASH] = ACTIONS(1098),
    [anon_sym_LBRACK_CARET] = ACTIONS(1100),
    [anon_sym_BANG_LBRACK] = ACTIONS(1102),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [anon_sym_TODO] = ACTIONS(1110),
    [anon_sym_WIP] = ACTIONS(1110),
    [anon_sym_NOTE] = ACTIONS(1112),
    [anon_sym_INFO] = ACTIONS(1112),
    [anon_sym_XXX] = ACTIONS(1112),
    [sym_fixme] = ACTIONS(1076),
    [aux_sym__text_token1] = ACTIONS(1114),
    [sym__newline_inline] = ACTIONS(1116),
    [sym_hard_line_break] = ACTIONS(1076),
    [sym__verbatim_begin] = ACTIONS(1118),
  },
  [205] = {
    [sym__inline] = STATE(2187),
    [sym__inline_element] = STATE(900),
    [sym__smart_punctuation] = STATE(454),
    [sym_autolink] = STATE(454),
    [sym_emphasis] = STATE(455),
    [sym_emphasis_begin] = STATE(2555),
    [sym_strong] = STATE(455),
    [sym_strong_begin] = STATE(2556),
    [sym_superscript] = STATE(455),
    [sym_superscript_begin] = STATE(2557),
    [sym_subscript] = STATE(455),
    [sym_subscript_begin] = STATE(2558),
    [sym_highlighted] = STATE(455),
    [sym_highlighted_begin] = STATE(2559),
    [sym_insert] = STATE(455),
    [sym_insert_begin] = STATE(2560),
    [sym_delete] = STATE(455),
    [sym_delete_begin] = STATE(2561),
    [sym_footnote_reference] = STATE(455),
    [sym_footnote_marker_begin] = STATE(2562),
    [sym__image] = STATE(455),
    [sym_full_reference_image] = STATE(455),
    [sym_collapsed_reference_image] = STATE(455),
    [sym_inline_image] = STATE(455),
    [sym_image_description] = STATE(1257),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(455),
    [sym_full_reference_link] = STATE(455),
    [sym_collapsed_reference_link] = STATE(455),
    [sym_inline_link] = STATE(455),
    [sym_link_text] = STATE(1258),
    [sym_span] = STATE(900),
    [sym__bracketed_text_begin] = STATE(2617),
    [sym_inline_comment] = STATE(454),
    [sym_raw_inline] = STATE(454),
    [sym_math] = STATE(454),
    [sym_verbatim] = STATE(454),
    [sym__todo_highlights] = STATE(454),
    [sym_todo] = STATE(454),
    [sym_note] = STATE(454),
    [sym__symbol_fallback] = STATE(454),
    [aux_sym__text] = STATE(441),
    [aux_sym__inline_repeat1] = STATE(155),
    [anon_sym_LBRACK] = ACTIONS(1820),
    [sym__whitespace1] = ACTIONS(1822),
    [sym_quotation_marks] = ACTIONS(1824),
    [sym_ellipsis] = ACTIONS(1824),
    [sym_em_dash] = ACTIONS(1824),
    [sym_en_dash] = ACTIONS(1826),
    [sym_backslash_escape] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1828),
    [sym_symbol] = ACTIONS(1824),
    [anon_sym_LBRACE_] = ACTIONS(1830),
    [anon_sym__] = ACTIONS(1832),
    [anon_sym_LBRACE_STAR] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_LBRACE_CARET] = ACTIONS(1838),
    [anon_sym_CARET] = ACTIONS(1838),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1840),
    [anon_sym_TILDE] = ACTIONS(1840),
    [anon_sym_LBRACE_EQ] = ACTIONS(1842),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1844),
    [anon_sym_LBRACE_DASH] = ACTIONS(1846),
    [anon_sym_LBRACK_CARET] = ACTIONS(1848),
    [anon_sym_BANG_LBRACK] = ACTIONS(1850),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1856),
    [anon_sym_TODO] = ACTIONS(1858),
    [anon_sym_WIP] = ACTIONS(1858),
    [anon_sym_NOTE] = ACTIONS(1860),
    [anon_sym_INFO] = ACTIONS(1860),
    [anon_sym_XXX] = ACTIONS(1860),
    [sym_fixme] = ACTIONS(1824),
    [aux_sym__text_token1] = ACTIONS(1862),
    [sym__newline_inline] = ACTIONS(2188),
    [sym_hard_line_break] = ACTIONS(1824),
    [sym__verbatim_begin] = ACTIONS(1866),
  },
  [206] = {
    [sym__inline] = STATE(2190),
    [sym__inline_element] = STATE(1014),
    [sym__smart_punctuation] = STATE(456),
    [sym_autolink] = STATE(456),
    [sym_emphasis] = STATE(457),
    [sym_emphasis_begin] = STATE(2566),
    [sym_strong] = STATE(457),
    [sym_strong_begin] = STATE(2567),
    [sym_superscript] = STATE(457),
    [sym_superscript_begin] = STATE(2568),
    [sym_subscript] = STATE(457),
    [sym_subscript_begin] = STATE(2569),
    [sym_highlighted] = STATE(457),
    [sym_highlighted_begin] = STATE(2570),
    [sym_insert] = STATE(457),
    [sym_insert_begin] = STATE(2571),
    [sym_delete] = STATE(457),
    [sym_delete_begin] = STATE(1976),
    [sym_footnote_reference] = STATE(457),
    [sym_footnote_marker_begin] = STATE(2573),
    [sym__image] = STATE(457),
    [sym_full_reference_image] = STATE(457),
    [sym_collapsed_reference_image] = STATE(457),
    [sym_inline_image] = STATE(457),
    [sym_image_description] = STATE(1264),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(457),
    [sym_full_reference_link] = STATE(457),
    [sym_collapsed_reference_link] = STATE(457),
    [sym_inline_link] = STATE(457),
    [sym_link_text] = STATE(1265),
    [sym_span] = STATE(1014),
    [sym__bracketed_text_begin] = STATE(2618),
    [sym_inline_comment] = STATE(456),
    [sym_raw_inline] = STATE(456),
    [sym_math] = STATE(456),
    [sym_verbatim] = STATE(456),
    [sym__todo_highlights] = STATE(456),
    [sym_todo] = STATE(456),
    [sym_note] = STATE(456),
    [sym__symbol_fallback] = STATE(456),
    [aux_sym__text] = STATE(440),
    [aux_sym__inline_repeat1] = STATE(157),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [sym__whitespace1] = ACTIONS(1942),
    [sym_quotation_marks] = ACTIONS(1944),
    [sym_ellipsis] = ACTIONS(1944),
    [sym_em_dash] = ACTIONS(1944),
    [sym_en_dash] = ACTIONS(1946),
    [sym_backslash_escape] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1948),
    [sym_symbol] = ACTIONS(1944),
    [anon_sym_LBRACE_] = ACTIONS(1950),
    [anon_sym__] = ACTIONS(1952),
    [anon_sym_LBRACE_STAR] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_LBRACE_CARET] = ACTIONS(1958),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_LBRACE_EQ] = ACTIONS(1962),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1964),
    [anon_sym_LBRACE_DASH] = ACTIONS(1966),
    [anon_sym_LBRACK_CARET] = ACTIONS(1968),
    [anon_sym_BANG_LBRACK] = ACTIONS(1970),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1974),
    [anon_sym_DOLLAR] = ACTIONS(1976),
    [anon_sym_TODO] = ACTIONS(1978),
    [anon_sym_WIP] = ACTIONS(1978),
    [anon_sym_NOTE] = ACTIONS(1980),
    [anon_sym_INFO] = ACTIONS(1980),
    [anon_sym_XXX] = ACTIONS(1980),
    [sym_fixme] = ACTIONS(1944),
    [aux_sym__text_token1] = ACTIONS(1982),
    [sym__newline_inline] = ACTIONS(2190),
    [sym_hard_line_break] = ACTIONS(1944),
    [sym__verbatim_begin] = ACTIONS(1986),
  },
  [207] = {
    [sym__inline_without_trailing_space] = STATE(2353),
    [sym__inline_element] = STATE(988),
    [sym__smart_punctuation] = STATE(460),
    [sym_autolink] = STATE(460),
    [sym_emphasis] = STATE(463),
    [sym_emphasis_begin] = STATE(2484),
    [sym_strong] = STATE(463),
    [sym_strong_begin] = STATE(2485),
    [sym_superscript] = STATE(463),
    [sym_superscript_begin] = STATE(2486),
    [sym_subscript] = STATE(463),
    [sym_subscript_begin] = STATE(2487),
    [sym_highlighted] = STATE(463),
    [sym_highlighted_begin] = STATE(2488),
    [sym_insert] = STATE(463),
    [sym_insert_begin] = STATE(2489),
    [sym_delete] = STATE(463),
    [sym_delete_begin] = STATE(2490),
    [sym_footnote_reference] = STATE(463),
    [sym_footnote_marker_begin] = STATE(2491),
    [sym__image] = STATE(463),
    [sym_full_reference_image] = STATE(463),
    [sym_collapsed_reference_image] = STATE(463),
    [sym_inline_image] = STATE(463),
    [sym_image_description] = STATE(1268),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(463),
    [sym_full_reference_link] = STATE(463),
    [sym_collapsed_reference_link] = STATE(463),
    [sym_inline_link] = STATE(463),
    [sym_link_text] = STATE(1273),
    [sym_span] = STATE(988),
    [sym__bracketed_text_begin] = STATE(2607),
    [sym_inline_comment] = STATE(460),
    [sym_raw_inline] = STATE(460),
    [sym_math] = STATE(460),
    [sym_verbatim] = STATE(460),
    [sym__todo_highlights] = STATE(460),
    [sym_todo] = STATE(460),
    [sym_note] = STATE(460),
    [sym__symbol_fallback] = STATE(460),
    [aux_sym__text] = STATE(444),
    [aux_sym__inline_repeat1] = STATE(286),
    [anon_sym_LBRACK] = ACTIONS(1772),
    [sym__whitespace1] = ACTIONS(1774),
    [sym_quotation_marks] = ACTIONS(1776),
    [sym_ellipsis] = ACTIONS(1776),
    [sym_em_dash] = ACTIONS(1776),
    [sym_en_dash] = ACTIONS(1778),
    [sym_backslash_escape] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1780),
    [sym_symbol] = ACTIONS(1776),
    [anon_sym_LBRACE_] = ACTIONS(1782),
    [anon_sym__] = ACTIONS(1784),
    [anon_sym_LBRACE_STAR] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_LBRACE_CARET] = ACTIONS(1790),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1792),
    [anon_sym_LBRACE_EQ] = ACTIONS(1794),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1796),
    [anon_sym_LBRACE_DASH] = ACTIONS(1798),
    [anon_sym_LBRACK_CARET] = ACTIONS(1800),
    [anon_sym_BANG_LBRACK] = ACTIONS(1802),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1804),
    [anon_sym_LPAREN] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [anon_sym_TODO] = ACTIONS(1810),
    [anon_sym_WIP] = ACTIONS(1810),
    [anon_sym_NOTE] = ACTIONS(1812),
    [anon_sym_INFO] = ACTIONS(1812),
    [anon_sym_XXX] = ACTIONS(1812),
    [sym_fixme] = ACTIONS(1776),
    [aux_sym__text_token1] = ACTIONS(1814),
    [sym__newline_inline] = ACTIONS(1816),
    [sym_hard_line_break] = ACTIONS(1776),
    [sym__verbatim_begin] = ACTIONS(1818),
  },
  [208] = {
    [sym__inline_without_trailing_space] = STATE(2358),
    [sym__inline_element] = STATE(959),
    [sym__smart_punctuation] = STATE(464),
    [sym_autolink] = STATE(464),
    [sym_emphasis] = STATE(465),
    [sym_emphasis_begin] = STATE(2498),
    [sym_strong] = STATE(465),
    [sym_strong_begin] = STATE(2499),
    [sym_superscript] = STATE(465),
    [sym_superscript_begin] = STATE(2500),
    [sym_subscript] = STATE(465),
    [sym_subscript_begin] = STATE(2501),
    [sym_highlighted] = STATE(465),
    [sym_highlighted_begin] = STATE(2502),
    [sym_insert] = STATE(465),
    [sym_insert_begin] = STATE(2503),
    [sym_delete] = STATE(465),
    [sym_delete_begin] = STATE(2504),
    [sym_footnote_reference] = STATE(465),
    [sym_footnote_marker_begin] = STATE(2505),
    [sym__image] = STATE(465),
    [sym_full_reference_image] = STATE(465),
    [sym_collapsed_reference_image] = STATE(465),
    [sym_inline_image] = STATE(465),
    [sym_image_description] = STATE(1314),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(465),
    [sym_full_reference_link] = STATE(465),
    [sym_collapsed_reference_link] = STATE(465),
    [sym_inline_link] = STATE(465),
    [sym_link_text] = STATE(1319),
    [sym_span] = STATE(959),
    [sym__bracketed_text_begin] = STATE(2610),
    [sym_inline_comment] = STATE(464),
    [sym_raw_inline] = STATE(464),
    [sym_math] = STATE(464),
    [sym_verbatim] = STATE(464),
    [sym__todo_highlights] = STATE(464),
    [sym_todo] = STATE(464),
    [sym_note] = STATE(464),
    [sym__symbol_fallback] = STATE(464),
    [aux_sym__text] = STATE(445),
    [aux_sym__inline_repeat1] = STATE(287),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [sym__whitespace1] = ACTIONS(2136),
    [sym_quotation_marks] = ACTIONS(2138),
    [sym_ellipsis] = ACTIONS(2138),
    [sym_em_dash] = ACTIONS(2138),
    [sym_en_dash] = ACTIONS(2140),
    [sym_backslash_escape] = ACTIONS(2140),
    [anon_sym_LT] = ACTIONS(2142),
    [sym_symbol] = ACTIONS(2138),
    [anon_sym_LBRACE_] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_LBRACE_STAR] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_LBRACE_CARET] = ACTIONS(2152),
    [anon_sym_CARET] = ACTIONS(2152),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACE_EQ] = ACTIONS(2156),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2158),
    [anon_sym_LBRACE_DASH] = ACTIONS(2160),
    [anon_sym_LBRACK_CARET] = ACTIONS(2162),
    [anon_sym_BANG_LBRACK] = ACTIONS(2164),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_TODO] = ACTIONS(2172),
    [anon_sym_WIP] = ACTIONS(2172),
    [anon_sym_NOTE] = ACTIONS(2174),
    [anon_sym_INFO] = ACTIONS(2174),
    [anon_sym_XXX] = ACTIONS(2174),
    [sym_fixme] = ACTIONS(2138),
    [aux_sym__text_token1] = ACTIONS(2176),
    [sym__newline_inline] = ACTIONS(2178),
    [sym_hard_line_break] = ACTIONS(2138),
    [sym__verbatim_begin] = ACTIONS(2180),
  },
  [209] = {
    [sym__inline] = STATE(2360),
    [sym__inline_element] = STATE(1017),
    [sym__smart_punctuation] = STATE(468),
    [sym_autolink] = STATE(468),
    [sym_emphasis] = STATE(469),
    [sym_emphasis_begin] = STATE(2511),
    [sym_strong] = STATE(469),
    [sym_strong_begin] = STATE(2512),
    [sym_superscript] = STATE(469),
    [sym_superscript_begin] = STATE(2513),
    [sym_subscript] = STATE(469),
    [sym_subscript_begin] = STATE(2514),
    [sym_highlighted] = STATE(469),
    [sym_highlighted_begin] = STATE(2515),
    [sym_insert] = STATE(469),
    [sym_insert_begin] = STATE(2516),
    [sym_delete] = STATE(469),
    [sym_delete_begin] = STATE(2517),
    [sym_footnote_reference] = STATE(469),
    [sym_footnote_marker_begin] = STATE(2518),
    [sym__image] = STATE(469),
    [sym_full_reference_image] = STATE(469),
    [sym_collapsed_reference_image] = STATE(469),
    [sym_inline_image] = STATE(469),
    [sym_image_description] = STATE(1325),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(469),
    [sym_full_reference_link] = STATE(469),
    [sym_collapsed_reference_link] = STATE(469),
    [sym_inline_link] = STATE(469),
    [sym_link_text] = STATE(1326),
    [sym_span] = STATE(1017),
    [sym__bracketed_text_begin] = STATE(2613),
    [sym_inline_comment] = STATE(468),
    [sym_raw_inline] = STATE(468),
    [sym_math] = STATE(468),
    [sym_verbatim] = STATE(468),
    [sym__todo_highlights] = STATE(468),
    [sym_todo] = STATE(468),
    [sym_note] = STATE(468),
    [sym__symbol_fallback] = STATE(468),
    [aux_sym__text] = STATE(446),
    [aux_sym__inline_repeat1] = STATE(146),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [sym__whitespace1] = ACTIONS(1340),
    [sym_quotation_marks] = ACTIONS(1342),
    [sym_ellipsis] = ACTIONS(1342),
    [sym_em_dash] = ACTIONS(1342),
    [sym_en_dash] = ACTIONS(1344),
    [sym_backslash_escape] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [sym_symbol] = ACTIONS(1342),
    [anon_sym_LBRACE_] = ACTIONS(1348),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_LBRACE_STAR] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_LBRACE_CARET] = ACTIONS(1356),
    [anon_sym_CARET] = ACTIONS(1356),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_LBRACE_EQ] = ACTIONS(1360),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1362),
    [anon_sym_LBRACE_DASH] = ACTIONS(1364),
    [anon_sym_LBRACK_CARET] = ACTIONS(1366),
    [anon_sym_BANG_LBRACK] = ACTIONS(1368),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1374),
    [anon_sym_TODO] = ACTIONS(1376),
    [anon_sym_WIP] = ACTIONS(1376),
    [anon_sym_NOTE] = ACTIONS(1378),
    [anon_sym_INFO] = ACTIONS(1378),
    [anon_sym_XXX] = ACTIONS(1378),
    [sym_fixme] = ACTIONS(1342),
    [aux_sym__text_token1] = ACTIONS(1380),
    [sym__newline_inline] = ACTIONS(2182),
    [sym_hard_line_break] = ACTIONS(1342),
    [sym__verbatim_begin] = ACTIONS(1384),
  },
  [210] = {
    [sym__inline] = STATE(2370),
    [sym__inline_element] = STATE(915),
    [sym__smart_punctuation] = STATE(470),
    [sym_autolink] = STATE(470),
    [sym_emphasis] = STATE(471),
    [sym_emphasis_begin] = STATE(2522),
    [sym_strong] = STATE(471),
    [sym_strong_begin] = STATE(2523),
    [sym_superscript] = STATE(471),
    [sym_superscript_begin] = STATE(2524),
    [sym_subscript] = STATE(471),
    [sym_subscript_begin] = STATE(2525),
    [sym_highlighted] = STATE(471),
    [sym_highlighted_begin] = STATE(2526),
    [sym_insert] = STATE(471),
    [sym_insert_begin] = STATE(2527),
    [sym_delete] = STATE(471),
    [sym_delete_begin] = STATE(2528),
    [sym_footnote_reference] = STATE(471),
    [sym_footnote_marker_begin] = STATE(2529),
    [sym__image] = STATE(471),
    [sym_full_reference_image] = STATE(471),
    [sym_collapsed_reference_image] = STATE(471),
    [sym_inline_image] = STATE(471),
    [sym_image_description] = STATE(1332),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(471),
    [sym_full_reference_link] = STATE(471),
    [sym_collapsed_reference_link] = STATE(471),
    [sym_inline_link] = STATE(471),
    [sym_link_text] = STATE(1334),
    [sym_span] = STATE(915),
    [sym__bracketed_text_begin] = STATE(2614),
    [sym_inline_comment] = STATE(470),
    [sym_raw_inline] = STATE(470),
    [sym_math] = STATE(470),
    [sym_verbatim] = STATE(470),
    [sym__todo_highlights] = STATE(470),
    [sym_todo] = STATE(470),
    [sym_note] = STATE(470),
    [sym__symbol_fallback] = STATE(470),
    [aux_sym__text] = STATE(447),
    [aux_sym__inline_repeat1] = STATE(148),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [sym__whitespace1] = ACTIONS(1460),
    [sym_quotation_marks] = ACTIONS(1462),
    [sym_ellipsis] = ACTIONS(1462),
    [sym_em_dash] = ACTIONS(1462),
    [sym_en_dash] = ACTIONS(1464),
    [sym_backslash_escape] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [sym_symbol] = ACTIONS(1462),
    [anon_sym_LBRACE_] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(1470),
    [anon_sym_LBRACE_STAR] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACE_CARET] = ACTIONS(1476),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_LBRACE_EQ] = ACTIONS(1480),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1482),
    [anon_sym_LBRACE_DASH] = ACTIONS(1484),
    [anon_sym_LBRACK_CARET] = ACTIONS(1486),
    [anon_sym_BANG_LBRACK] = ACTIONS(1488),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_TODO] = ACTIONS(1496),
    [anon_sym_WIP] = ACTIONS(1496),
    [anon_sym_NOTE] = ACTIONS(1498),
    [anon_sym_INFO] = ACTIONS(1498),
    [anon_sym_XXX] = ACTIONS(1498),
    [sym_fixme] = ACTIONS(1462),
    [aux_sym__text_token1] = ACTIONS(1500),
    [sym__newline_inline] = ACTIONS(2184),
    [sym_hard_line_break] = ACTIONS(1462),
    [sym__verbatim_begin] = ACTIONS(1504),
  },
  [211] = {
    [sym__inline] = STATE(2371),
    [sym__inline_element] = STATE(1021),
    [sym__smart_punctuation] = STATE(473),
    [sym_autolink] = STATE(473),
    [sym_emphasis] = STATE(450),
    [sym_emphasis_begin] = STATE(2533),
    [sym_strong] = STATE(450),
    [sym_strong_begin] = STATE(2534),
    [sym_superscript] = STATE(450),
    [sym_superscript_begin] = STATE(2535),
    [sym_subscript] = STATE(450),
    [sym_subscript_begin] = STATE(2536),
    [sym_highlighted] = STATE(450),
    [sym_highlighted_begin] = STATE(2537),
    [sym_insert] = STATE(450),
    [sym_insert_begin] = STATE(2538),
    [sym_delete] = STATE(450),
    [sym_delete_begin] = STATE(2539),
    [sym_footnote_reference] = STATE(450),
    [sym_footnote_marker_begin] = STATE(2540),
    [sym__image] = STATE(450),
    [sym_full_reference_image] = STATE(450),
    [sym_collapsed_reference_image] = STATE(450),
    [sym_inline_image] = STATE(450),
    [sym_image_description] = STATE(1340),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(450),
    [sym_full_reference_link] = STATE(450),
    [sym_collapsed_reference_link] = STATE(450),
    [sym_inline_link] = STATE(450),
    [sym_link_text] = STATE(1341),
    [sym_span] = STATE(1021),
    [sym__bracketed_text_begin] = STATE(2615),
    [sym_inline_comment] = STATE(473),
    [sym_raw_inline] = STATE(473),
    [sym_math] = STATE(473),
    [sym_verbatim] = STATE(473),
    [sym__todo_highlights] = STATE(473),
    [sym_todo] = STATE(473),
    [sym_note] = STATE(473),
    [sym__symbol_fallback] = STATE(473),
    [aux_sym__text] = STATE(448),
    [aux_sym__inline_repeat1] = STATE(150),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [sym__whitespace1] = ACTIONS(1580),
    [sym_quotation_marks] = ACTIONS(1582),
    [sym_ellipsis] = ACTIONS(1582),
    [sym_em_dash] = ACTIONS(1582),
    [sym_en_dash] = ACTIONS(1584),
    [sym_backslash_escape] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1586),
    [sym_symbol] = ACTIONS(1582),
    [anon_sym_LBRACE_] = ACTIONS(1588),
    [anon_sym__] = ACTIONS(1590),
    [anon_sym_LBRACE_STAR] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_LBRACE_CARET] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_LBRACE_EQ] = ACTIONS(1600),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1602),
    [anon_sym_LBRACE_DASH] = ACTIONS(1604),
    [anon_sym_LBRACK_CARET] = ACTIONS(1606),
    [anon_sym_BANG_LBRACK] = ACTIONS(1608),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_DOLLAR] = ACTIONS(1614),
    [anon_sym_TODO] = ACTIONS(1616),
    [anon_sym_WIP] = ACTIONS(1616),
    [anon_sym_NOTE] = ACTIONS(1618),
    [anon_sym_INFO] = ACTIONS(1618),
    [anon_sym_XXX] = ACTIONS(1618),
    [sym_fixme] = ACTIONS(1582),
    [aux_sym__text_token1] = ACTIONS(1620),
    [sym__newline_inline] = ACTIONS(2186),
    [sym_hard_line_break] = ACTIONS(1582),
    [sym__verbatim_begin] = ACTIONS(1624),
  },
  [212] = {
    [sym__inline] = STATE(2374),
    [sym__inline_element] = STATE(997),
    [sym__smart_punctuation] = STATE(451),
    [sym_autolink] = STATE(451),
    [sym_emphasis] = STATE(449),
    [sym_emphasis_begin] = STATE(2544),
    [sym_strong] = STATE(449),
    [sym_strong_begin] = STATE(2545),
    [sym_superscript] = STATE(449),
    [sym_superscript_begin] = STATE(2546),
    [sym_subscript] = STATE(449),
    [sym_subscript_begin] = STATE(2547),
    [sym_highlighted] = STATE(449),
    [sym_highlighted_begin] = STATE(2548),
    [sym_insert] = STATE(449),
    [sym_insert_begin] = STATE(2549),
    [sym_delete] = STATE(449),
    [sym_delete_begin] = STATE(2550),
    [sym_footnote_reference] = STATE(449),
    [sym_footnote_marker_begin] = STATE(2551),
    [sym__image] = STATE(449),
    [sym_full_reference_image] = STATE(449),
    [sym_collapsed_reference_image] = STATE(449),
    [sym_inline_image] = STATE(449),
    [sym_image_description] = STATE(1250),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(449),
    [sym_full_reference_link] = STATE(449),
    [sym_collapsed_reference_link] = STATE(449),
    [sym_inline_link] = STATE(449),
    [sym_link_text] = STATE(1251),
    [sym_span] = STATE(997),
    [sym__bracketed_text_begin] = STATE(2616),
    [sym_inline_comment] = STATE(451),
    [sym_raw_inline] = STATE(451),
    [sym_math] = STATE(451),
    [sym_verbatim] = STATE(451),
    [sym__todo_highlights] = STATE(451),
    [sym_todo] = STATE(451),
    [sym_note] = STATE(451),
    [sym__symbol_fallback] = STATE(451),
    [aux_sym__text] = STATE(439),
    [aux_sym__inline_repeat1] = STATE(152),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [sym__whitespace1] = ACTIONS(1074),
    [sym_quotation_marks] = ACTIONS(1076),
    [sym_ellipsis] = ACTIONS(1076),
    [sym_em_dash] = ACTIONS(1076),
    [sym_en_dash] = ACTIONS(1078),
    [sym_backslash_escape] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(1080),
    [sym_symbol] = ACTIONS(1076),
    [anon_sym_LBRACE_] = ACTIONS(1082),
    [anon_sym__] = ACTIONS(1084),
    [anon_sym_LBRACE_STAR] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_LBRACE_CARET] = ACTIONS(1090),
    [anon_sym_CARET] = ACTIONS(1090),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_LBRACE_EQ] = ACTIONS(1094),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1096),
    [anon_sym_LBRACE_DASH] = ACTIONS(1098),
    [anon_sym_LBRACK_CARET] = ACTIONS(1100),
    [anon_sym_BANG_LBRACK] = ACTIONS(1102),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [anon_sym_TODO] = ACTIONS(1110),
    [anon_sym_WIP] = ACTIONS(1110),
    [anon_sym_NOTE] = ACTIONS(1112),
    [anon_sym_INFO] = ACTIONS(1112),
    [anon_sym_XXX] = ACTIONS(1112),
    [sym_fixme] = ACTIONS(1076),
    [aux_sym__text_token1] = ACTIONS(1114),
    [sym__newline_inline] = ACTIONS(1116),
    [sym_hard_line_break] = ACTIONS(1076),
    [sym__verbatim_begin] = ACTIONS(1118),
  },
  [213] = {
    [sym__inline] = STATE(2375),
    [sym__inline_element] = STATE(900),
    [sym__smart_punctuation] = STATE(454),
    [sym_autolink] = STATE(454),
    [sym_emphasis] = STATE(455),
    [sym_emphasis_begin] = STATE(2555),
    [sym_strong] = STATE(455),
    [sym_strong_begin] = STATE(2556),
    [sym_superscript] = STATE(455),
    [sym_superscript_begin] = STATE(2557),
    [sym_subscript] = STATE(455),
    [sym_subscript_begin] = STATE(2558),
    [sym_highlighted] = STATE(455),
    [sym_highlighted_begin] = STATE(2559),
    [sym_insert] = STATE(455),
    [sym_insert_begin] = STATE(2560),
    [sym_delete] = STATE(455),
    [sym_delete_begin] = STATE(2561),
    [sym_footnote_reference] = STATE(455),
    [sym_footnote_marker_begin] = STATE(2562),
    [sym__image] = STATE(455),
    [sym_full_reference_image] = STATE(455),
    [sym_collapsed_reference_image] = STATE(455),
    [sym_inline_image] = STATE(455),
    [sym_image_description] = STATE(1257),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(455),
    [sym_full_reference_link] = STATE(455),
    [sym_collapsed_reference_link] = STATE(455),
    [sym_inline_link] = STATE(455),
    [sym_link_text] = STATE(1258),
    [sym_span] = STATE(900),
    [sym__bracketed_text_begin] = STATE(2617),
    [sym_inline_comment] = STATE(454),
    [sym_raw_inline] = STATE(454),
    [sym_math] = STATE(454),
    [sym_verbatim] = STATE(454),
    [sym__todo_highlights] = STATE(454),
    [sym_todo] = STATE(454),
    [sym_note] = STATE(454),
    [sym__symbol_fallback] = STATE(454),
    [aux_sym__text] = STATE(441),
    [aux_sym__inline_repeat1] = STATE(155),
    [anon_sym_LBRACK] = ACTIONS(1820),
    [sym__whitespace1] = ACTIONS(1822),
    [sym_quotation_marks] = ACTIONS(1824),
    [sym_ellipsis] = ACTIONS(1824),
    [sym_em_dash] = ACTIONS(1824),
    [sym_en_dash] = ACTIONS(1826),
    [sym_backslash_escape] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1828),
    [sym_symbol] = ACTIONS(1824),
    [anon_sym_LBRACE_] = ACTIONS(1830),
    [anon_sym__] = ACTIONS(1832),
    [anon_sym_LBRACE_STAR] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_LBRACE_CARET] = ACTIONS(1838),
    [anon_sym_CARET] = ACTIONS(1838),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1840),
    [anon_sym_TILDE] = ACTIONS(1840),
    [anon_sym_LBRACE_EQ] = ACTIONS(1842),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1844),
    [anon_sym_LBRACE_DASH] = ACTIONS(1846),
    [anon_sym_LBRACK_CARET] = ACTIONS(1848),
    [anon_sym_BANG_LBRACK] = ACTIONS(1850),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1856),
    [anon_sym_TODO] = ACTIONS(1858),
    [anon_sym_WIP] = ACTIONS(1858),
    [anon_sym_NOTE] = ACTIONS(1860),
    [anon_sym_INFO] = ACTIONS(1860),
    [anon_sym_XXX] = ACTIONS(1860),
    [sym_fixme] = ACTIONS(1824),
    [aux_sym__text_token1] = ACTIONS(1862),
    [sym__newline_inline] = ACTIONS(2188),
    [sym_hard_line_break] = ACTIONS(1824),
    [sym__verbatim_begin] = ACTIONS(1866),
  },
  [214] = {
    [sym__inline] = STATE(2377),
    [sym__inline_element] = STATE(1014),
    [sym__smart_punctuation] = STATE(456),
    [sym_autolink] = STATE(456),
    [sym_emphasis] = STATE(457),
    [sym_emphasis_begin] = STATE(2566),
    [sym_strong] = STATE(457),
    [sym_strong_begin] = STATE(2567),
    [sym_superscript] = STATE(457),
    [sym_superscript_begin] = STATE(2568),
    [sym_subscript] = STATE(457),
    [sym_subscript_begin] = STATE(2569),
    [sym_highlighted] = STATE(457),
    [sym_highlighted_begin] = STATE(2570),
    [sym_insert] = STATE(457),
    [sym_insert_begin] = STATE(2571),
    [sym_delete] = STATE(457),
    [sym_delete_begin] = STATE(1976),
    [sym_footnote_reference] = STATE(457),
    [sym_footnote_marker_begin] = STATE(2573),
    [sym__image] = STATE(457),
    [sym_full_reference_image] = STATE(457),
    [sym_collapsed_reference_image] = STATE(457),
    [sym_inline_image] = STATE(457),
    [sym_image_description] = STATE(1264),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(457),
    [sym_full_reference_link] = STATE(457),
    [sym_collapsed_reference_link] = STATE(457),
    [sym_inline_link] = STATE(457),
    [sym_link_text] = STATE(1265),
    [sym_span] = STATE(1014),
    [sym__bracketed_text_begin] = STATE(2618),
    [sym_inline_comment] = STATE(456),
    [sym_raw_inline] = STATE(456),
    [sym_math] = STATE(456),
    [sym_verbatim] = STATE(456),
    [sym__todo_highlights] = STATE(456),
    [sym_todo] = STATE(456),
    [sym_note] = STATE(456),
    [sym__symbol_fallback] = STATE(456),
    [aux_sym__text] = STATE(440),
    [aux_sym__inline_repeat1] = STATE(157),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [sym__whitespace1] = ACTIONS(1942),
    [sym_quotation_marks] = ACTIONS(1944),
    [sym_ellipsis] = ACTIONS(1944),
    [sym_em_dash] = ACTIONS(1944),
    [sym_en_dash] = ACTIONS(1946),
    [sym_backslash_escape] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1948),
    [sym_symbol] = ACTIONS(1944),
    [anon_sym_LBRACE_] = ACTIONS(1950),
    [anon_sym__] = ACTIONS(1952),
    [anon_sym_LBRACE_STAR] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_LBRACE_CARET] = ACTIONS(1958),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_LBRACE_EQ] = ACTIONS(1962),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1964),
    [anon_sym_LBRACE_DASH] = ACTIONS(1966),
    [anon_sym_LBRACK_CARET] = ACTIONS(1968),
    [anon_sym_BANG_LBRACK] = ACTIONS(1970),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1974),
    [anon_sym_DOLLAR] = ACTIONS(1976),
    [anon_sym_TODO] = ACTIONS(1978),
    [anon_sym_WIP] = ACTIONS(1978),
    [anon_sym_NOTE] = ACTIONS(1980),
    [anon_sym_INFO] = ACTIONS(1980),
    [anon_sym_XXX] = ACTIONS(1980),
    [sym_fixme] = ACTIONS(1944),
    [aux_sym__text_token1] = ACTIONS(1982),
    [sym__newline_inline] = ACTIONS(2190),
    [sym_hard_line_break] = ACTIONS(1944),
    [sym__verbatim_begin] = ACTIONS(1986),
  },
  [215] = {
    [sym__inline_without_trailing_space] = STATE(2445),
    [sym__inline_element] = STATE(988),
    [sym__smart_punctuation] = STATE(460),
    [sym_autolink] = STATE(460),
    [sym_emphasis] = STATE(463),
    [sym_emphasis_begin] = STATE(2484),
    [sym_strong] = STATE(463),
    [sym_strong_begin] = STATE(2485),
    [sym_superscript] = STATE(463),
    [sym_superscript_begin] = STATE(2486),
    [sym_subscript] = STATE(463),
    [sym_subscript_begin] = STATE(2487),
    [sym_highlighted] = STATE(463),
    [sym_highlighted_begin] = STATE(2488),
    [sym_insert] = STATE(463),
    [sym_insert_begin] = STATE(2489),
    [sym_delete] = STATE(463),
    [sym_delete_begin] = STATE(2490),
    [sym_footnote_reference] = STATE(463),
    [sym_footnote_marker_begin] = STATE(2491),
    [sym__image] = STATE(463),
    [sym_full_reference_image] = STATE(463),
    [sym_collapsed_reference_image] = STATE(463),
    [sym_inline_image] = STATE(463),
    [sym_image_description] = STATE(1268),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(463),
    [sym_full_reference_link] = STATE(463),
    [sym_collapsed_reference_link] = STATE(463),
    [sym_inline_link] = STATE(463),
    [sym_link_text] = STATE(1273),
    [sym_span] = STATE(988),
    [sym__bracketed_text_begin] = STATE(2607),
    [sym_inline_comment] = STATE(460),
    [sym_raw_inline] = STATE(460),
    [sym_math] = STATE(460),
    [sym_verbatim] = STATE(460),
    [sym__todo_highlights] = STATE(460),
    [sym_todo] = STATE(460),
    [sym_note] = STATE(460),
    [sym__symbol_fallback] = STATE(460),
    [aux_sym__text] = STATE(444),
    [aux_sym__inline_repeat1] = STATE(286),
    [anon_sym_LBRACK] = ACTIONS(1772),
    [sym__whitespace1] = ACTIONS(1774),
    [sym_quotation_marks] = ACTIONS(1776),
    [sym_ellipsis] = ACTIONS(1776),
    [sym_em_dash] = ACTIONS(1776),
    [sym_en_dash] = ACTIONS(1778),
    [sym_backslash_escape] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1780),
    [sym_symbol] = ACTIONS(1776),
    [anon_sym_LBRACE_] = ACTIONS(1782),
    [anon_sym__] = ACTIONS(1784),
    [anon_sym_LBRACE_STAR] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_LBRACE_CARET] = ACTIONS(1790),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1792),
    [anon_sym_LBRACE_EQ] = ACTIONS(1794),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1796),
    [anon_sym_LBRACE_DASH] = ACTIONS(1798),
    [anon_sym_LBRACK_CARET] = ACTIONS(1800),
    [anon_sym_BANG_LBRACK] = ACTIONS(1802),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1804),
    [anon_sym_LPAREN] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [anon_sym_TODO] = ACTIONS(1810),
    [anon_sym_WIP] = ACTIONS(1810),
    [anon_sym_NOTE] = ACTIONS(1812),
    [anon_sym_INFO] = ACTIONS(1812),
    [anon_sym_XXX] = ACTIONS(1812),
    [sym_fixme] = ACTIONS(1776),
    [aux_sym__text_token1] = ACTIONS(1814),
    [sym__newline_inline] = ACTIONS(1816),
    [sym_hard_line_break] = ACTIONS(1776),
    [sym__verbatim_begin] = ACTIONS(1818),
  },
  [216] = {
    [sym__inline_without_trailing_space] = STATE(2446),
    [sym__inline_element] = STATE(959),
    [sym__smart_punctuation] = STATE(464),
    [sym_autolink] = STATE(464),
    [sym_emphasis] = STATE(465),
    [sym_emphasis_begin] = STATE(2498),
    [sym_strong] = STATE(465),
    [sym_strong_begin] = STATE(2499),
    [sym_superscript] = STATE(465),
    [sym_superscript_begin] = STATE(2500),
    [sym_subscript] = STATE(465),
    [sym_subscript_begin] = STATE(2501),
    [sym_highlighted] = STATE(465),
    [sym_highlighted_begin] = STATE(2502),
    [sym_insert] = STATE(465),
    [sym_insert_begin] = STATE(2503),
    [sym_delete] = STATE(465),
    [sym_delete_begin] = STATE(2504),
    [sym_footnote_reference] = STATE(465),
    [sym_footnote_marker_begin] = STATE(2505),
    [sym__image] = STATE(465),
    [sym_full_reference_image] = STATE(465),
    [sym_collapsed_reference_image] = STATE(465),
    [sym_inline_image] = STATE(465),
    [sym_image_description] = STATE(1314),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(465),
    [sym_full_reference_link] = STATE(465),
    [sym_collapsed_reference_link] = STATE(465),
    [sym_inline_link] = STATE(465),
    [sym_link_text] = STATE(1319),
    [sym_span] = STATE(959),
    [sym__bracketed_text_begin] = STATE(2610),
    [sym_inline_comment] = STATE(464),
    [sym_raw_inline] = STATE(464),
    [sym_math] = STATE(464),
    [sym_verbatim] = STATE(464),
    [sym__todo_highlights] = STATE(464),
    [sym_todo] = STATE(464),
    [sym_note] = STATE(464),
    [sym__symbol_fallback] = STATE(464),
    [aux_sym__text] = STATE(445),
    [aux_sym__inline_repeat1] = STATE(287),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [sym__whitespace1] = ACTIONS(2136),
    [sym_quotation_marks] = ACTIONS(2138),
    [sym_ellipsis] = ACTIONS(2138),
    [sym_em_dash] = ACTIONS(2138),
    [sym_en_dash] = ACTIONS(2140),
    [sym_backslash_escape] = ACTIONS(2140),
    [anon_sym_LT] = ACTIONS(2142),
    [sym_symbol] = ACTIONS(2138),
    [anon_sym_LBRACE_] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_LBRACE_STAR] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_LBRACE_CARET] = ACTIONS(2152),
    [anon_sym_CARET] = ACTIONS(2152),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACE_EQ] = ACTIONS(2156),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2158),
    [anon_sym_LBRACE_DASH] = ACTIONS(2160),
    [anon_sym_LBRACK_CARET] = ACTIONS(2162),
    [anon_sym_BANG_LBRACK] = ACTIONS(2164),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_TODO] = ACTIONS(2172),
    [anon_sym_WIP] = ACTIONS(2172),
    [anon_sym_NOTE] = ACTIONS(2174),
    [anon_sym_INFO] = ACTIONS(2174),
    [anon_sym_XXX] = ACTIONS(2174),
    [sym_fixme] = ACTIONS(2138),
    [aux_sym__text_token1] = ACTIONS(2176),
    [sym__newline_inline] = ACTIONS(2178),
    [sym_hard_line_break] = ACTIONS(2138),
    [sym__verbatim_begin] = ACTIONS(2180),
  },
  [217] = {
    [sym__inline] = STATE(2466),
    [sym__inline_element] = STATE(1017),
    [sym__smart_punctuation] = STATE(468),
    [sym_autolink] = STATE(468),
    [sym_emphasis] = STATE(469),
    [sym_emphasis_begin] = STATE(2511),
    [sym_strong] = STATE(469),
    [sym_strong_begin] = STATE(2512),
    [sym_superscript] = STATE(469),
    [sym_superscript_begin] = STATE(2513),
    [sym_subscript] = STATE(469),
    [sym_subscript_begin] = STATE(2514),
    [sym_highlighted] = STATE(469),
    [sym_highlighted_begin] = STATE(2515),
    [sym_insert] = STATE(469),
    [sym_insert_begin] = STATE(2516),
    [sym_delete] = STATE(469),
    [sym_delete_begin] = STATE(2517),
    [sym_footnote_reference] = STATE(469),
    [sym_footnote_marker_begin] = STATE(2518),
    [sym__image] = STATE(469),
    [sym_full_reference_image] = STATE(469),
    [sym_collapsed_reference_image] = STATE(469),
    [sym_inline_image] = STATE(469),
    [sym_image_description] = STATE(1325),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(469),
    [sym_full_reference_link] = STATE(469),
    [sym_collapsed_reference_link] = STATE(469),
    [sym_inline_link] = STATE(469),
    [sym_link_text] = STATE(1326),
    [sym_span] = STATE(1017),
    [sym__bracketed_text_begin] = STATE(2613),
    [sym_inline_comment] = STATE(468),
    [sym_raw_inline] = STATE(468),
    [sym_math] = STATE(468),
    [sym_verbatim] = STATE(468),
    [sym__todo_highlights] = STATE(468),
    [sym_todo] = STATE(468),
    [sym_note] = STATE(468),
    [sym__symbol_fallback] = STATE(468),
    [aux_sym__text] = STATE(446),
    [aux_sym__inline_repeat1] = STATE(146),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [sym__whitespace1] = ACTIONS(1340),
    [sym_quotation_marks] = ACTIONS(1342),
    [sym_ellipsis] = ACTIONS(1342),
    [sym_em_dash] = ACTIONS(1342),
    [sym_en_dash] = ACTIONS(1344),
    [sym_backslash_escape] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [sym_symbol] = ACTIONS(1342),
    [anon_sym_LBRACE_] = ACTIONS(1348),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_LBRACE_STAR] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_LBRACE_CARET] = ACTIONS(1356),
    [anon_sym_CARET] = ACTIONS(1356),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_LBRACE_EQ] = ACTIONS(1360),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1362),
    [anon_sym_LBRACE_DASH] = ACTIONS(1364),
    [anon_sym_LBRACK_CARET] = ACTIONS(1366),
    [anon_sym_BANG_LBRACK] = ACTIONS(1368),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1374),
    [anon_sym_TODO] = ACTIONS(1376),
    [anon_sym_WIP] = ACTIONS(1376),
    [anon_sym_NOTE] = ACTIONS(1378),
    [anon_sym_INFO] = ACTIONS(1378),
    [anon_sym_XXX] = ACTIONS(1378),
    [sym_fixme] = ACTIONS(1342),
    [aux_sym__text_token1] = ACTIONS(1380),
    [sym__newline_inline] = ACTIONS(2182),
    [sym_hard_line_break] = ACTIONS(1342),
    [sym__verbatim_begin] = ACTIONS(1384),
  },
  [218] = {
    [sym__inline] = STATE(2480),
    [sym__inline_element] = STATE(915),
    [sym__smart_punctuation] = STATE(470),
    [sym_autolink] = STATE(470),
    [sym_emphasis] = STATE(471),
    [sym_emphasis_begin] = STATE(2522),
    [sym_strong] = STATE(471),
    [sym_strong_begin] = STATE(2523),
    [sym_superscript] = STATE(471),
    [sym_superscript_begin] = STATE(2524),
    [sym_subscript] = STATE(471),
    [sym_subscript_begin] = STATE(2525),
    [sym_highlighted] = STATE(471),
    [sym_highlighted_begin] = STATE(2526),
    [sym_insert] = STATE(471),
    [sym_insert_begin] = STATE(2527),
    [sym_delete] = STATE(471),
    [sym_delete_begin] = STATE(2528),
    [sym_footnote_reference] = STATE(471),
    [sym_footnote_marker_begin] = STATE(2529),
    [sym__image] = STATE(471),
    [sym_full_reference_image] = STATE(471),
    [sym_collapsed_reference_image] = STATE(471),
    [sym_inline_image] = STATE(471),
    [sym_image_description] = STATE(1332),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(471),
    [sym_full_reference_link] = STATE(471),
    [sym_collapsed_reference_link] = STATE(471),
    [sym_inline_link] = STATE(471),
    [sym_link_text] = STATE(1334),
    [sym_span] = STATE(915),
    [sym__bracketed_text_begin] = STATE(2614),
    [sym_inline_comment] = STATE(470),
    [sym_raw_inline] = STATE(470),
    [sym_math] = STATE(470),
    [sym_verbatim] = STATE(470),
    [sym__todo_highlights] = STATE(470),
    [sym_todo] = STATE(470),
    [sym_note] = STATE(470),
    [sym__symbol_fallback] = STATE(470),
    [aux_sym__text] = STATE(447),
    [aux_sym__inline_repeat1] = STATE(148),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [sym__whitespace1] = ACTIONS(1460),
    [sym_quotation_marks] = ACTIONS(1462),
    [sym_ellipsis] = ACTIONS(1462),
    [sym_em_dash] = ACTIONS(1462),
    [sym_en_dash] = ACTIONS(1464),
    [sym_backslash_escape] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [sym_symbol] = ACTIONS(1462),
    [anon_sym_LBRACE_] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(1470),
    [anon_sym_LBRACE_STAR] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACE_CARET] = ACTIONS(1476),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_LBRACE_EQ] = ACTIONS(1480),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1482),
    [anon_sym_LBRACE_DASH] = ACTIONS(1484),
    [anon_sym_LBRACK_CARET] = ACTIONS(1486),
    [anon_sym_BANG_LBRACK] = ACTIONS(1488),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_TODO] = ACTIONS(1496),
    [anon_sym_WIP] = ACTIONS(1496),
    [anon_sym_NOTE] = ACTIONS(1498),
    [anon_sym_INFO] = ACTIONS(1498),
    [anon_sym_XXX] = ACTIONS(1498),
    [sym_fixme] = ACTIONS(1462),
    [aux_sym__text_token1] = ACTIONS(1500),
    [sym__newline_inline] = ACTIONS(2184),
    [sym_hard_line_break] = ACTIONS(1462),
    [sym__verbatim_begin] = ACTIONS(1504),
  },
  [219] = {
    [sym__inline] = STATE(2494),
    [sym__inline_element] = STATE(1021),
    [sym__smart_punctuation] = STATE(473),
    [sym_autolink] = STATE(473),
    [sym_emphasis] = STATE(450),
    [sym_emphasis_begin] = STATE(2533),
    [sym_strong] = STATE(450),
    [sym_strong_begin] = STATE(2534),
    [sym_superscript] = STATE(450),
    [sym_superscript_begin] = STATE(2535),
    [sym_subscript] = STATE(450),
    [sym_subscript_begin] = STATE(2536),
    [sym_highlighted] = STATE(450),
    [sym_highlighted_begin] = STATE(2537),
    [sym_insert] = STATE(450),
    [sym_insert_begin] = STATE(2538),
    [sym_delete] = STATE(450),
    [sym_delete_begin] = STATE(2539),
    [sym_footnote_reference] = STATE(450),
    [sym_footnote_marker_begin] = STATE(2540),
    [sym__image] = STATE(450),
    [sym_full_reference_image] = STATE(450),
    [sym_collapsed_reference_image] = STATE(450),
    [sym_inline_image] = STATE(450),
    [sym_image_description] = STATE(1340),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(450),
    [sym_full_reference_link] = STATE(450),
    [sym_collapsed_reference_link] = STATE(450),
    [sym_inline_link] = STATE(450),
    [sym_link_text] = STATE(1341),
    [sym_span] = STATE(1021),
    [sym__bracketed_text_begin] = STATE(2615),
    [sym_inline_comment] = STATE(473),
    [sym_raw_inline] = STATE(473),
    [sym_math] = STATE(473),
    [sym_verbatim] = STATE(473),
    [sym__todo_highlights] = STATE(473),
    [sym_todo] = STATE(473),
    [sym_note] = STATE(473),
    [sym__symbol_fallback] = STATE(473),
    [aux_sym__text] = STATE(448),
    [aux_sym__inline_repeat1] = STATE(150),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [sym__whitespace1] = ACTIONS(1580),
    [sym_quotation_marks] = ACTIONS(1582),
    [sym_ellipsis] = ACTIONS(1582),
    [sym_em_dash] = ACTIONS(1582),
    [sym_en_dash] = ACTIONS(1584),
    [sym_backslash_escape] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1586),
    [sym_symbol] = ACTIONS(1582),
    [anon_sym_LBRACE_] = ACTIONS(1588),
    [anon_sym__] = ACTIONS(1590),
    [anon_sym_LBRACE_STAR] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_LBRACE_CARET] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_LBRACE_EQ] = ACTIONS(1600),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1602),
    [anon_sym_LBRACE_DASH] = ACTIONS(1604),
    [anon_sym_LBRACK_CARET] = ACTIONS(1606),
    [anon_sym_BANG_LBRACK] = ACTIONS(1608),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_DOLLAR] = ACTIONS(1614),
    [anon_sym_TODO] = ACTIONS(1616),
    [anon_sym_WIP] = ACTIONS(1616),
    [anon_sym_NOTE] = ACTIONS(1618),
    [anon_sym_INFO] = ACTIONS(1618),
    [anon_sym_XXX] = ACTIONS(1618),
    [sym_fixme] = ACTIONS(1582),
    [aux_sym__text_token1] = ACTIONS(1620),
    [sym__newline_inline] = ACTIONS(2186),
    [sym_hard_line_break] = ACTIONS(1582),
    [sym__verbatim_begin] = ACTIONS(1624),
  },
  [220] = {
    [sym__inline] = STATE(2508),
    [sym__inline_element] = STATE(997),
    [sym__smart_punctuation] = STATE(451),
    [sym_autolink] = STATE(451),
    [sym_emphasis] = STATE(449),
    [sym_emphasis_begin] = STATE(2544),
    [sym_strong] = STATE(449),
    [sym_strong_begin] = STATE(2545),
    [sym_superscript] = STATE(449),
    [sym_superscript_begin] = STATE(2546),
    [sym_subscript] = STATE(449),
    [sym_subscript_begin] = STATE(2547),
    [sym_highlighted] = STATE(449),
    [sym_highlighted_begin] = STATE(2548),
    [sym_insert] = STATE(449),
    [sym_insert_begin] = STATE(2549),
    [sym_delete] = STATE(449),
    [sym_delete_begin] = STATE(2550),
    [sym_footnote_reference] = STATE(449),
    [sym_footnote_marker_begin] = STATE(2551),
    [sym__image] = STATE(449),
    [sym_full_reference_image] = STATE(449),
    [sym_collapsed_reference_image] = STATE(449),
    [sym_inline_image] = STATE(449),
    [sym_image_description] = STATE(1250),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(449),
    [sym_full_reference_link] = STATE(449),
    [sym_collapsed_reference_link] = STATE(449),
    [sym_inline_link] = STATE(449),
    [sym_link_text] = STATE(1251),
    [sym_span] = STATE(997),
    [sym__bracketed_text_begin] = STATE(2616),
    [sym_inline_comment] = STATE(451),
    [sym_raw_inline] = STATE(451),
    [sym_math] = STATE(451),
    [sym_verbatim] = STATE(451),
    [sym__todo_highlights] = STATE(451),
    [sym_todo] = STATE(451),
    [sym_note] = STATE(451),
    [sym__symbol_fallback] = STATE(451),
    [aux_sym__text] = STATE(439),
    [aux_sym__inline_repeat1] = STATE(152),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [sym__whitespace1] = ACTIONS(1074),
    [sym_quotation_marks] = ACTIONS(1076),
    [sym_ellipsis] = ACTIONS(1076),
    [sym_em_dash] = ACTIONS(1076),
    [sym_en_dash] = ACTIONS(1078),
    [sym_backslash_escape] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(1080),
    [sym_symbol] = ACTIONS(1076),
    [anon_sym_LBRACE_] = ACTIONS(1082),
    [anon_sym__] = ACTIONS(1084),
    [anon_sym_LBRACE_STAR] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_LBRACE_CARET] = ACTIONS(1090),
    [anon_sym_CARET] = ACTIONS(1090),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_LBRACE_EQ] = ACTIONS(1094),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1096),
    [anon_sym_LBRACE_DASH] = ACTIONS(1098),
    [anon_sym_LBRACK_CARET] = ACTIONS(1100),
    [anon_sym_BANG_LBRACK] = ACTIONS(1102),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [anon_sym_TODO] = ACTIONS(1110),
    [anon_sym_WIP] = ACTIONS(1110),
    [anon_sym_NOTE] = ACTIONS(1112),
    [anon_sym_INFO] = ACTIONS(1112),
    [anon_sym_XXX] = ACTIONS(1112),
    [sym_fixme] = ACTIONS(1076),
    [aux_sym__text_token1] = ACTIONS(1114),
    [sym__newline_inline] = ACTIONS(1116),
    [sym_hard_line_break] = ACTIONS(1076),
    [sym__verbatim_begin] = ACTIONS(1118),
  },
  [221] = {
    [sym__inline] = STATE(2521),
    [sym__inline_element] = STATE(900),
    [sym__smart_punctuation] = STATE(454),
    [sym_autolink] = STATE(454),
    [sym_emphasis] = STATE(455),
    [sym_emphasis_begin] = STATE(2555),
    [sym_strong] = STATE(455),
    [sym_strong_begin] = STATE(2556),
    [sym_superscript] = STATE(455),
    [sym_superscript_begin] = STATE(2557),
    [sym_subscript] = STATE(455),
    [sym_subscript_begin] = STATE(2558),
    [sym_highlighted] = STATE(455),
    [sym_highlighted_begin] = STATE(2559),
    [sym_insert] = STATE(455),
    [sym_insert_begin] = STATE(2560),
    [sym_delete] = STATE(455),
    [sym_delete_begin] = STATE(2561),
    [sym_footnote_reference] = STATE(455),
    [sym_footnote_marker_begin] = STATE(2562),
    [sym__image] = STATE(455),
    [sym_full_reference_image] = STATE(455),
    [sym_collapsed_reference_image] = STATE(455),
    [sym_inline_image] = STATE(455),
    [sym_image_description] = STATE(1257),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(455),
    [sym_full_reference_link] = STATE(455),
    [sym_collapsed_reference_link] = STATE(455),
    [sym_inline_link] = STATE(455),
    [sym_link_text] = STATE(1258),
    [sym_span] = STATE(900),
    [sym__bracketed_text_begin] = STATE(2617),
    [sym_inline_comment] = STATE(454),
    [sym_raw_inline] = STATE(454),
    [sym_math] = STATE(454),
    [sym_verbatim] = STATE(454),
    [sym__todo_highlights] = STATE(454),
    [sym_todo] = STATE(454),
    [sym_note] = STATE(454),
    [sym__symbol_fallback] = STATE(454),
    [aux_sym__text] = STATE(441),
    [aux_sym__inline_repeat1] = STATE(155),
    [anon_sym_LBRACK] = ACTIONS(1820),
    [sym__whitespace1] = ACTIONS(1822),
    [sym_quotation_marks] = ACTIONS(1824),
    [sym_ellipsis] = ACTIONS(1824),
    [sym_em_dash] = ACTIONS(1824),
    [sym_en_dash] = ACTIONS(1826),
    [sym_backslash_escape] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1828),
    [sym_symbol] = ACTIONS(1824),
    [anon_sym_LBRACE_] = ACTIONS(1830),
    [anon_sym__] = ACTIONS(1832),
    [anon_sym_LBRACE_STAR] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_LBRACE_CARET] = ACTIONS(1838),
    [anon_sym_CARET] = ACTIONS(1838),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1840),
    [anon_sym_TILDE] = ACTIONS(1840),
    [anon_sym_LBRACE_EQ] = ACTIONS(1842),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1844),
    [anon_sym_LBRACE_DASH] = ACTIONS(1846),
    [anon_sym_LBRACK_CARET] = ACTIONS(1848),
    [anon_sym_BANG_LBRACK] = ACTIONS(1850),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1856),
    [anon_sym_TODO] = ACTIONS(1858),
    [anon_sym_WIP] = ACTIONS(1858),
    [anon_sym_NOTE] = ACTIONS(1860),
    [anon_sym_INFO] = ACTIONS(1860),
    [anon_sym_XXX] = ACTIONS(1860),
    [sym_fixme] = ACTIONS(1824),
    [aux_sym__text_token1] = ACTIONS(1862),
    [sym__newline_inline] = ACTIONS(2188),
    [sym_hard_line_break] = ACTIONS(1824),
    [sym__verbatim_begin] = ACTIONS(1866),
  },
  [222] = {
    [sym__inline] = STATE(2543),
    [sym__inline_element] = STATE(1014),
    [sym__smart_punctuation] = STATE(456),
    [sym_autolink] = STATE(456),
    [sym_emphasis] = STATE(457),
    [sym_emphasis_begin] = STATE(2566),
    [sym_strong] = STATE(457),
    [sym_strong_begin] = STATE(2567),
    [sym_superscript] = STATE(457),
    [sym_superscript_begin] = STATE(2568),
    [sym_subscript] = STATE(457),
    [sym_subscript_begin] = STATE(2569),
    [sym_highlighted] = STATE(457),
    [sym_highlighted_begin] = STATE(2570),
    [sym_insert] = STATE(457),
    [sym_insert_begin] = STATE(2571),
    [sym_delete] = STATE(457),
    [sym_delete_begin] = STATE(1976),
    [sym_footnote_reference] = STATE(457),
    [sym_footnote_marker_begin] = STATE(2573),
    [sym__image] = STATE(457),
    [sym_full_reference_image] = STATE(457),
    [sym_collapsed_reference_image] = STATE(457),
    [sym_inline_image] = STATE(457),
    [sym_image_description] = STATE(1264),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(457),
    [sym_full_reference_link] = STATE(457),
    [sym_collapsed_reference_link] = STATE(457),
    [sym_inline_link] = STATE(457),
    [sym_link_text] = STATE(1265),
    [sym_span] = STATE(1014),
    [sym__bracketed_text_begin] = STATE(2618),
    [sym_inline_comment] = STATE(456),
    [sym_raw_inline] = STATE(456),
    [sym_math] = STATE(456),
    [sym_verbatim] = STATE(456),
    [sym__todo_highlights] = STATE(456),
    [sym_todo] = STATE(456),
    [sym_note] = STATE(456),
    [sym__symbol_fallback] = STATE(456),
    [aux_sym__text] = STATE(440),
    [aux_sym__inline_repeat1] = STATE(157),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [sym__whitespace1] = ACTIONS(1942),
    [sym_quotation_marks] = ACTIONS(1944),
    [sym_ellipsis] = ACTIONS(1944),
    [sym_em_dash] = ACTIONS(1944),
    [sym_en_dash] = ACTIONS(1946),
    [sym_backslash_escape] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1948),
    [sym_symbol] = ACTIONS(1944),
    [anon_sym_LBRACE_] = ACTIONS(1950),
    [anon_sym__] = ACTIONS(1952),
    [anon_sym_LBRACE_STAR] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_LBRACE_CARET] = ACTIONS(1958),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_LBRACE_EQ] = ACTIONS(1962),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1964),
    [anon_sym_LBRACE_DASH] = ACTIONS(1966),
    [anon_sym_LBRACK_CARET] = ACTIONS(1968),
    [anon_sym_BANG_LBRACK] = ACTIONS(1970),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1974),
    [anon_sym_DOLLAR] = ACTIONS(1976),
    [anon_sym_TODO] = ACTIONS(1978),
    [anon_sym_WIP] = ACTIONS(1978),
    [anon_sym_NOTE] = ACTIONS(1980),
    [anon_sym_INFO] = ACTIONS(1980),
    [anon_sym_XXX] = ACTIONS(1980),
    [sym_fixme] = ACTIONS(1944),
    [aux_sym__text_token1] = ACTIONS(1982),
    [sym__newline_inline] = ACTIONS(2190),
    [sym_hard_line_break] = ACTIONS(1944),
    [sym__verbatim_begin] = ACTIONS(1986),
  },
  [223] = {
    [sym__inline_without_trailing_space] = STATE(1990),
    [sym__inline_element] = STATE(988),
    [sym__smart_punctuation] = STATE(460),
    [sym_autolink] = STATE(460),
    [sym_emphasis] = STATE(463),
    [sym_emphasis_begin] = STATE(2484),
    [sym_strong] = STATE(463),
    [sym_strong_begin] = STATE(2485),
    [sym_superscript] = STATE(463),
    [sym_superscript_begin] = STATE(2486),
    [sym_subscript] = STATE(463),
    [sym_subscript_begin] = STATE(2487),
    [sym_highlighted] = STATE(463),
    [sym_highlighted_begin] = STATE(2488),
    [sym_insert] = STATE(463),
    [sym_insert_begin] = STATE(2489),
    [sym_delete] = STATE(463),
    [sym_delete_begin] = STATE(2490),
    [sym_footnote_reference] = STATE(463),
    [sym_footnote_marker_begin] = STATE(2491),
    [sym__image] = STATE(463),
    [sym_full_reference_image] = STATE(463),
    [sym_collapsed_reference_image] = STATE(463),
    [sym_inline_image] = STATE(463),
    [sym_image_description] = STATE(1268),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(463),
    [sym_full_reference_link] = STATE(463),
    [sym_collapsed_reference_link] = STATE(463),
    [sym_inline_link] = STATE(463),
    [sym_link_text] = STATE(1273),
    [sym_span] = STATE(988),
    [sym__bracketed_text_begin] = STATE(2607),
    [sym_inline_comment] = STATE(460),
    [sym_raw_inline] = STATE(460),
    [sym_math] = STATE(460),
    [sym_verbatim] = STATE(460),
    [sym__todo_highlights] = STATE(460),
    [sym_todo] = STATE(460),
    [sym_note] = STATE(460),
    [sym__symbol_fallback] = STATE(460),
    [aux_sym__text] = STATE(444),
    [aux_sym__inline_repeat1] = STATE(286),
    [anon_sym_LBRACK] = ACTIONS(1772),
    [sym__whitespace1] = ACTIONS(1774),
    [sym_quotation_marks] = ACTIONS(1776),
    [sym_ellipsis] = ACTIONS(1776),
    [sym_em_dash] = ACTIONS(1776),
    [sym_en_dash] = ACTIONS(1778),
    [sym_backslash_escape] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1780),
    [sym_symbol] = ACTIONS(1776),
    [anon_sym_LBRACE_] = ACTIONS(1782),
    [anon_sym__] = ACTIONS(1784),
    [anon_sym_LBRACE_STAR] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_LBRACE_CARET] = ACTIONS(1790),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1792),
    [anon_sym_LBRACE_EQ] = ACTIONS(1794),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1796),
    [anon_sym_LBRACE_DASH] = ACTIONS(1798),
    [anon_sym_LBRACK_CARET] = ACTIONS(1800),
    [anon_sym_BANG_LBRACK] = ACTIONS(1802),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1804),
    [anon_sym_LPAREN] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [anon_sym_TODO] = ACTIONS(1810),
    [anon_sym_WIP] = ACTIONS(1810),
    [anon_sym_NOTE] = ACTIONS(1812),
    [anon_sym_INFO] = ACTIONS(1812),
    [anon_sym_XXX] = ACTIONS(1812),
    [sym_fixme] = ACTIONS(1776),
    [aux_sym__text_token1] = ACTIONS(1814),
    [sym__newline_inline] = ACTIONS(1816),
    [sym_hard_line_break] = ACTIONS(1776),
    [sym__verbatim_begin] = ACTIONS(1818),
  },
  [224] = {
    [sym__inline_without_trailing_space] = STATE(1991),
    [sym__inline_element] = STATE(959),
    [sym__smart_punctuation] = STATE(464),
    [sym_autolink] = STATE(464),
    [sym_emphasis] = STATE(465),
    [sym_emphasis_begin] = STATE(2498),
    [sym_strong] = STATE(465),
    [sym_strong_begin] = STATE(2499),
    [sym_superscript] = STATE(465),
    [sym_superscript_begin] = STATE(2500),
    [sym_subscript] = STATE(465),
    [sym_subscript_begin] = STATE(2501),
    [sym_highlighted] = STATE(465),
    [sym_highlighted_begin] = STATE(2502),
    [sym_insert] = STATE(465),
    [sym_insert_begin] = STATE(2503),
    [sym_delete] = STATE(465),
    [sym_delete_begin] = STATE(2504),
    [sym_footnote_reference] = STATE(465),
    [sym_footnote_marker_begin] = STATE(2505),
    [sym__image] = STATE(465),
    [sym_full_reference_image] = STATE(465),
    [sym_collapsed_reference_image] = STATE(465),
    [sym_inline_image] = STATE(465),
    [sym_image_description] = STATE(1314),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(465),
    [sym_full_reference_link] = STATE(465),
    [sym_collapsed_reference_link] = STATE(465),
    [sym_inline_link] = STATE(465),
    [sym_link_text] = STATE(1319),
    [sym_span] = STATE(959),
    [sym__bracketed_text_begin] = STATE(2610),
    [sym_inline_comment] = STATE(464),
    [sym_raw_inline] = STATE(464),
    [sym_math] = STATE(464),
    [sym_verbatim] = STATE(464),
    [sym__todo_highlights] = STATE(464),
    [sym_todo] = STATE(464),
    [sym_note] = STATE(464),
    [sym__symbol_fallback] = STATE(464),
    [aux_sym__text] = STATE(445),
    [aux_sym__inline_repeat1] = STATE(287),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [sym__whitespace1] = ACTIONS(2136),
    [sym_quotation_marks] = ACTIONS(2138),
    [sym_ellipsis] = ACTIONS(2138),
    [sym_em_dash] = ACTIONS(2138),
    [sym_en_dash] = ACTIONS(2140),
    [sym_backslash_escape] = ACTIONS(2140),
    [anon_sym_LT] = ACTIONS(2142),
    [sym_symbol] = ACTIONS(2138),
    [anon_sym_LBRACE_] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_LBRACE_STAR] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_LBRACE_CARET] = ACTIONS(2152),
    [anon_sym_CARET] = ACTIONS(2152),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACE_EQ] = ACTIONS(2156),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2158),
    [anon_sym_LBRACE_DASH] = ACTIONS(2160),
    [anon_sym_LBRACK_CARET] = ACTIONS(2162),
    [anon_sym_BANG_LBRACK] = ACTIONS(2164),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_TODO] = ACTIONS(2172),
    [anon_sym_WIP] = ACTIONS(2172),
    [anon_sym_NOTE] = ACTIONS(2174),
    [anon_sym_INFO] = ACTIONS(2174),
    [anon_sym_XXX] = ACTIONS(2174),
    [sym_fixme] = ACTIONS(2138),
    [aux_sym__text_token1] = ACTIONS(2176),
    [sym__newline_inline] = ACTIONS(2178),
    [sym_hard_line_break] = ACTIONS(2138),
    [sym__verbatim_begin] = ACTIONS(2180),
  },
  [225] = {
    [sym__inline] = STATE(1992),
    [sym__inline_element] = STATE(1017),
    [sym__smart_punctuation] = STATE(468),
    [sym_autolink] = STATE(468),
    [sym_emphasis] = STATE(469),
    [sym_emphasis_begin] = STATE(2511),
    [sym_strong] = STATE(469),
    [sym_strong_begin] = STATE(2512),
    [sym_superscript] = STATE(469),
    [sym_superscript_begin] = STATE(2513),
    [sym_subscript] = STATE(469),
    [sym_subscript_begin] = STATE(2514),
    [sym_highlighted] = STATE(469),
    [sym_highlighted_begin] = STATE(2515),
    [sym_insert] = STATE(469),
    [sym_insert_begin] = STATE(2516),
    [sym_delete] = STATE(469),
    [sym_delete_begin] = STATE(2517),
    [sym_footnote_reference] = STATE(469),
    [sym_footnote_marker_begin] = STATE(2518),
    [sym__image] = STATE(469),
    [sym_full_reference_image] = STATE(469),
    [sym_collapsed_reference_image] = STATE(469),
    [sym_inline_image] = STATE(469),
    [sym_image_description] = STATE(1325),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(469),
    [sym_full_reference_link] = STATE(469),
    [sym_collapsed_reference_link] = STATE(469),
    [sym_inline_link] = STATE(469),
    [sym_link_text] = STATE(1326),
    [sym_span] = STATE(1017),
    [sym__bracketed_text_begin] = STATE(2613),
    [sym_inline_comment] = STATE(468),
    [sym_raw_inline] = STATE(468),
    [sym_math] = STATE(468),
    [sym_verbatim] = STATE(468),
    [sym__todo_highlights] = STATE(468),
    [sym_todo] = STATE(468),
    [sym_note] = STATE(468),
    [sym__symbol_fallback] = STATE(468),
    [aux_sym__text] = STATE(446),
    [aux_sym__inline_repeat1] = STATE(146),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [sym__whitespace1] = ACTIONS(1340),
    [sym_quotation_marks] = ACTIONS(1342),
    [sym_ellipsis] = ACTIONS(1342),
    [sym_em_dash] = ACTIONS(1342),
    [sym_en_dash] = ACTIONS(1344),
    [sym_backslash_escape] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [sym_symbol] = ACTIONS(1342),
    [anon_sym_LBRACE_] = ACTIONS(1348),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_LBRACE_STAR] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_LBRACE_CARET] = ACTIONS(1356),
    [anon_sym_CARET] = ACTIONS(1356),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_LBRACE_EQ] = ACTIONS(1360),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1362),
    [anon_sym_LBRACE_DASH] = ACTIONS(1364),
    [anon_sym_LBRACK_CARET] = ACTIONS(1366),
    [anon_sym_BANG_LBRACK] = ACTIONS(1368),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1374),
    [anon_sym_TODO] = ACTIONS(1376),
    [anon_sym_WIP] = ACTIONS(1376),
    [anon_sym_NOTE] = ACTIONS(1378),
    [anon_sym_INFO] = ACTIONS(1378),
    [anon_sym_XXX] = ACTIONS(1378),
    [sym_fixme] = ACTIONS(1342),
    [aux_sym__text_token1] = ACTIONS(1380),
    [sym__newline_inline] = ACTIONS(2182),
    [sym_hard_line_break] = ACTIONS(1342),
    [sym__verbatim_begin] = ACTIONS(1384),
  },
  [226] = {
    [sym__inline] = STATE(1993),
    [sym__inline_element] = STATE(915),
    [sym__smart_punctuation] = STATE(470),
    [sym_autolink] = STATE(470),
    [sym_emphasis] = STATE(471),
    [sym_emphasis_begin] = STATE(2522),
    [sym_strong] = STATE(471),
    [sym_strong_begin] = STATE(2523),
    [sym_superscript] = STATE(471),
    [sym_superscript_begin] = STATE(2524),
    [sym_subscript] = STATE(471),
    [sym_subscript_begin] = STATE(2525),
    [sym_highlighted] = STATE(471),
    [sym_highlighted_begin] = STATE(2526),
    [sym_insert] = STATE(471),
    [sym_insert_begin] = STATE(2527),
    [sym_delete] = STATE(471),
    [sym_delete_begin] = STATE(2528),
    [sym_footnote_reference] = STATE(471),
    [sym_footnote_marker_begin] = STATE(2529),
    [sym__image] = STATE(471),
    [sym_full_reference_image] = STATE(471),
    [sym_collapsed_reference_image] = STATE(471),
    [sym_inline_image] = STATE(471),
    [sym_image_description] = STATE(1332),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(471),
    [sym_full_reference_link] = STATE(471),
    [sym_collapsed_reference_link] = STATE(471),
    [sym_inline_link] = STATE(471),
    [sym_link_text] = STATE(1334),
    [sym_span] = STATE(915),
    [sym__bracketed_text_begin] = STATE(2614),
    [sym_inline_comment] = STATE(470),
    [sym_raw_inline] = STATE(470),
    [sym_math] = STATE(470),
    [sym_verbatim] = STATE(470),
    [sym__todo_highlights] = STATE(470),
    [sym_todo] = STATE(470),
    [sym_note] = STATE(470),
    [sym__symbol_fallback] = STATE(470),
    [aux_sym__text] = STATE(447),
    [aux_sym__inline_repeat1] = STATE(148),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [sym__whitespace1] = ACTIONS(1460),
    [sym_quotation_marks] = ACTIONS(1462),
    [sym_ellipsis] = ACTIONS(1462),
    [sym_em_dash] = ACTIONS(1462),
    [sym_en_dash] = ACTIONS(1464),
    [sym_backslash_escape] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [sym_symbol] = ACTIONS(1462),
    [anon_sym_LBRACE_] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(1470),
    [anon_sym_LBRACE_STAR] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACE_CARET] = ACTIONS(1476),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_LBRACE_EQ] = ACTIONS(1480),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1482),
    [anon_sym_LBRACE_DASH] = ACTIONS(1484),
    [anon_sym_LBRACK_CARET] = ACTIONS(1486),
    [anon_sym_BANG_LBRACK] = ACTIONS(1488),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_TODO] = ACTIONS(1496),
    [anon_sym_WIP] = ACTIONS(1496),
    [anon_sym_NOTE] = ACTIONS(1498),
    [anon_sym_INFO] = ACTIONS(1498),
    [anon_sym_XXX] = ACTIONS(1498),
    [sym_fixme] = ACTIONS(1462),
    [aux_sym__text_token1] = ACTIONS(1500),
    [sym__newline_inline] = ACTIONS(2184),
    [sym_hard_line_break] = ACTIONS(1462),
    [sym__verbatim_begin] = ACTIONS(1504),
  },
  [227] = {
    [sym__inline] = STATE(1994),
    [sym__inline_element] = STATE(1021),
    [sym__smart_punctuation] = STATE(473),
    [sym_autolink] = STATE(473),
    [sym_emphasis] = STATE(450),
    [sym_emphasis_begin] = STATE(2533),
    [sym_strong] = STATE(450),
    [sym_strong_begin] = STATE(2534),
    [sym_superscript] = STATE(450),
    [sym_superscript_begin] = STATE(2535),
    [sym_subscript] = STATE(450),
    [sym_subscript_begin] = STATE(2536),
    [sym_highlighted] = STATE(450),
    [sym_highlighted_begin] = STATE(2537),
    [sym_insert] = STATE(450),
    [sym_insert_begin] = STATE(2538),
    [sym_delete] = STATE(450),
    [sym_delete_begin] = STATE(2539),
    [sym_footnote_reference] = STATE(450),
    [sym_footnote_marker_begin] = STATE(2540),
    [sym__image] = STATE(450),
    [sym_full_reference_image] = STATE(450),
    [sym_collapsed_reference_image] = STATE(450),
    [sym_inline_image] = STATE(450),
    [sym_image_description] = STATE(1340),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(450),
    [sym_full_reference_link] = STATE(450),
    [sym_collapsed_reference_link] = STATE(450),
    [sym_inline_link] = STATE(450),
    [sym_link_text] = STATE(1341),
    [sym_span] = STATE(1021),
    [sym__bracketed_text_begin] = STATE(2615),
    [sym_inline_comment] = STATE(473),
    [sym_raw_inline] = STATE(473),
    [sym_math] = STATE(473),
    [sym_verbatim] = STATE(473),
    [sym__todo_highlights] = STATE(473),
    [sym_todo] = STATE(473),
    [sym_note] = STATE(473),
    [sym__symbol_fallback] = STATE(473),
    [aux_sym__text] = STATE(448),
    [aux_sym__inline_repeat1] = STATE(150),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [sym__whitespace1] = ACTIONS(1580),
    [sym_quotation_marks] = ACTIONS(1582),
    [sym_ellipsis] = ACTIONS(1582),
    [sym_em_dash] = ACTIONS(1582),
    [sym_en_dash] = ACTIONS(1584),
    [sym_backslash_escape] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1586),
    [sym_symbol] = ACTIONS(1582),
    [anon_sym_LBRACE_] = ACTIONS(1588),
    [anon_sym__] = ACTIONS(1590),
    [anon_sym_LBRACE_STAR] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_LBRACE_CARET] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_LBRACE_EQ] = ACTIONS(1600),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1602),
    [anon_sym_LBRACE_DASH] = ACTIONS(1604),
    [anon_sym_LBRACK_CARET] = ACTIONS(1606),
    [anon_sym_BANG_LBRACK] = ACTIONS(1608),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_DOLLAR] = ACTIONS(1614),
    [anon_sym_TODO] = ACTIONS(1616),
    [anon_sym_WIP] = ACTIONS(1616),
    [anon_sym_NOTE] = ACTIONS(1618),
    [anon_sym_INFO] = ACTIONS(1618),
    [anon_sym_XXX] = ACTIONS(1618),
    [sym_fixme] = ACTIONS(1582),
    [aux_sym__text_token1] = ACTIONS(1620),
    [sym__newline_inline] = ACTIONS(2186),
    [sym_hard_line_break] = ACTIONS(1582),
    [sym__verbatim_begin] = ACTIONS(1624),
  },
  [228] = {
    [sym__inline] = STATE(1995),
    [sym__inline_element] = STATE(997),
    [sym__smart_punctuation] = STATE(451),
    [sym_autolink] = STATE(451),
    [sym_emphasis] = STATE(449),
    [sym_emphasis_begin] = STATE(2544),
    [sym_strong] = STATE(449),
    [sym_strong_begin] = STATE(2545),
    [sym_superscript] = STATE(449),
    [sym_superscript_begin] = STATE(2546),
    [sym_subscript] = STATE(449),
    [sym_subscript_begin] = STATE(2547),
    [sym_highlighted] = STATE(449),
    [sym_highlighted_begin] = STATE(2548),
    [sym_insert] = STATE(449),
    [sym_insert_begin] = STATE(2549),
    [sym_delete] = STATE(449),
    [sym_delete_begin] = STATE(2550),
    [sym_footnote_reference] = STATE(449),
    [sym_footnote_marker_begin] = STATE(2551),
    [sym__image] = STATE(449),
    [sym_full_reference_image] = STATE(449),
    [sym_collapsed_reference_image] = STATE(449),
    [sym_inline_image] = STATE(449),
    [sym_image_description] = STATE(1250),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(449),
    [sym_full_reference_link] = STATE(449),
    [sym_collapsed_reference_link] = STATE(449),
    [sym_inline_link] = STATE(449),
    [sym_link_text] = STATE(1251),
    [sym_span] = STATE(997),
    [sym__bracketed_text_begin] = STATE(2616),
    [sym_inline_comment] = STATE(451),
    [sym_raw_inline] = STATE(451),
    [sym_math] = STATE(451),
    [sym_verbatim] = STATE(451),
    [sym__todo_highlights] = STATE(451),
    [sym_todo] = STATE(451),
    [sym_note] = STATE(451),
    [sym__symbol_fallback] = STATE(451),
    [aux_sym__text] = STATE(439),
    [aux_sym__inline_repeat1] = STATE(152),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [sym__whitespace1] = ACTIONS(1074),
    [sym_quotation_marks] = ACTIONS(1076),
    [sym_ellipsis] = ACTIONS(1076),
    [sym_em_dash] = ACTIONS(1076),
    [sym_en_dash] = ACTIONS(1078),
    [sym_backslash_escape] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(1080),
    [sym_symbol] = ACTIONS(1076),
    [anon_sym_LBRACE_] = ACTIONS(1082),
    [anon_sym__] = ACTIONS(1084),
    [anon_sym_LBRACE_STAR] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_LBRACE_CARET] = ACTIONS(1090),
    [anon_sym_CARET] = ACTIONS(1090),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_LBRACE_EQ] = ACTIONS(1094),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1096),
    [anon_sym_LBRACE_DASH] = ACTIONS(1098),
    [anon_sym_LBRACK_CARET] = ACTIONS(1100),
    [anon_sym_BANG_LBRACK] = ACTIONS(1102),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [anon_sym_TODO] = ACTIONS(1110),
    [anon_sym_WIP] = ACTIONS(1110),
    [anon_sym_NOTE] = ACTIONS(1112),
    [anon_sym_INFO] = ACTIONS(1112),
    [anon_sym_XXX] = ACTIONS(1112),
    [sym_fixme] = ACTIONS(1076),
    [aux_sym__text_token1] = ACTIONS(1114),
    [sym__newline_inline] = ACTIONS(1116),
    [sym_hard_line_break] = ACTIONS(1076),
    [sym__verbatim_begin] = ACTIONS(1118),
  },
  [229] = {
    [sym__inline] = STATE(1996),
    [sym__inline_element] = STATE(900),
    [sym__smart_punctuation] = STATE(454),
    [sym_autolink] = STATE(454),
    [sym_emphasis] = STATE(455),
    [sym_emphasis_begin] = STATE(2555),
    [sym_strong] = STATE(455),
    [sym_strong_begin] = STATE(2556),
    [sym_superscript] = STATE(455),
    [sym_superscript_begin] = STATE(2557),
    [sym_subscript] = STATE(455),
    [sym_subscript_begin] = STATE(2558),
    [sym_highlighted] = STATE(455),
    [sym_highlighted_begin] = STATE(2559),
    [sym_insert] = STATE(455),
    [sym_insert_begin] = STATE(2560),
    [sym_delete] = STATE(455),
    [sym_delete_begin] = STATE(2561),
    [sym_footnote_reference] = STATE(455),
    [sym_footnote_marker_begin] = STATE(2562),
    [sym__image] = STATE(455),
    [sym_full_reference_image] = STATE(455),
    [sym_collapsed_reference_image] = STATE(455),
    [sym_inline_image] = STATE(455),
    [sym_image_description] = STATE(1257),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(455),
    [sym_full_reference_link] = STATE(455),
    [sym_collapsed_reference_link] = STATE(455),
    [sym_inline_link] = STATE(455),
    [sym_link_text] = STATE(1258),
    [sym_span] = STATE(900),
    [sym__bracketed_text_begin] = STATE(2617),
    [sym_inline_comment] = STATE(454),
    [sym_raw_inline] = STATE(454),
    [sym_math] = STATE(454),
    [sym_verbatim] = STATE(454),
    [sym__todo_highlights] = STATE(454),
    [sym_todo] = STATE(454),
    [sym_note] = STATE(454),
    [sym__symbol_fallback] = STATE(454),
    [aux_sym__text] = STATE(441),
    [aux_sym__inline_repeat1] = STATE(155),
    [anon_sym_LBRACK] = ACTIONS(1820),
    [sym__whitespace1] = ACTIONS(1822),
    [sym_quotation_marks] = ACTIONS(1824),
    [sym_ellipsis] = ACTIONS(1824),
    [sym_em_dash] = ACTIONS(1824),
    [sym_en_dash] = ACTIONS(1826),
    [sym_backslash_escape] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1828),
    [sym_symbol] = ACTIONS(1824),
    [anon_sym_LBRACE_] = ACTIONS(1830),
    [anon_sym__] = ACTIONS(1832),
    [anon_sym_LBRACE_STAR] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_LBRACE_CARET] = ACTIONS(1838),
    [anon_sym_CARET] = ACTIONS(1838),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1840),
    [anon_sym_TILDE] = ACTIONS(1840),
    [anon_sym_LBRACE_EQ] = ACTIONS(1842),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1844),
    [anon_sym_LBRACE_DASH] = ACTIONS(1846),
    [anon_sym_LBRACK_CARET] = ACTIONS(1848),
    [anon_sym_BANG_LBRACK] = ACTIONS(1850),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1856),
    [anon_sym_TODO] = ACTIONS(1858),
    [anon_sym_WIP] = ACTIONS(1858),
    [anon_sym_NOTE] = ACTIONS(1860),
    [anon_sym_INFO] = ACTIONS(1860),
    [anon_sym_XXX] = ACTIONS(1860),
    [sym_fixme] = ACTIONS(1824),
    [aux_sym__text_token1] = ACTIONS(1862),
    [sym__newline_inline] = ACTIONS(2188),
    [sym_hard_line_break] = ACTIONS(1824),
    [sym__verbatim_begin] = ACTIONS(1866),
  },
  [230] = {
    [sym__inline] = STATE(1998),
    [sym__inline_element] = STATE(1014),
    [sym__smart_punctuation] = STATE(456),
    [sym_autolink] = STATE(456),
    [sym_emphasis] = STATE(457),
    [sym_emphasis_begin] = STATE(2566),
    [sym_strong] = STATE(457),
    [sym_strong_begin] = STATE(2567),
    [sym_superscript] = STATE(457),
    [sym_superscript_begin] = STATE(2568),
    [sym_subscript] = STATE(457),
    [sym_subscript_begin] = STATE(2569),
    [sym_highlighted] = STATE(457),
    [sym_highlighted_begin] = STATE(2570),
    [sym_insert] = STATE(457),
    [sym_insert_begin] = STATE(2571),
    [sym_delete] = STATE(457),
    [sym_delete_begin] = STATE(1976),
    [sym_footnote_reference] = STATE(457),
    [sym_footnote_marker_begin] = STATE(2573),
    [sym__image] = STATE(457),
    [sym_full_reference_image] = STATE(457),
    [sym_collapsed_reference_image] = STATE(457),
    [sym_inline_image] = STATE(457),
    [sym_image_description] = STATE(1264),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(457),
    [sym_full_reference_link] = STATE(457),
    [sym_collapsed_reference_link] = STATE(457),
    [sym_inline_link] = STATE(457),
    [sym_link_text] = STATE(1265),
    [sym_span] = STATE(1014),
    [sym__bracketed_text_begin] = STATE(2618),
    [sym_inline_comment] = STATE(456),
    [sym_raw_inline] = STATE(456),
    [sym_math] = STATE(456),
    [sym_verbatim] = STATE(456),
    [sym__todo_highlights] = STATE(456),
    [sym_todo] = STATE(456),
    [sym_note] = STATE(456),
    [sym__symbol_fallback] = STATE(456),
    [aux_sym__text] = STATE(440),
    [aux_sym__inline_repeat1] = STATE(157),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [sym__whitespace1] = ACTIONS(1942),
    [sym_quotation_marks] = ACTIONS(1944),
    [sym_ellipsis] = ACTIONS(1944),
    [sym_em_dash] = ACTIONS(1944),
    [sym_en_dash] = ACTIONS(1946),
    [sym_backslash_escape] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1948),
    [sym_symbol] = ACTIONS(1944),
    [anon_sym_LBRACE_] = ACTIONS(1950),
    [anon_sym__] = ACTIONS(1952),
    [anon_sym_LBRACE_STAR] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_LBRACE_CARET] = ACTIONS(1958),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_LBRACE_EQ] = ACTIONS(1962),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1964),
    [anon_sym_LBRACE_DASH] = ACTIONS(1966),
    [anon_sym_LBRACK_CARET] = ACTIONS(1968),
    [anon_sym_BANG_LBRACK] = ACTIONS(1970),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1974),
    [anon_sym_DOLLAR] = ACTIONS(1976),
    [anon_sym_TODO] = ACTIONS(1978),
    [anon_sym_WIP] = ACTIONS(1978),
    [anon_sym_NOTE] = ACTIONS(1980),
    [anon_sym_INFO] = ACTIONS(1980),
    [anon_sym_XXX] = ACTIONS(1980),
    [sym_fixme] = ACTIONS(1944),
    [aux_sym__text_token1] = ACTIONS(1982),
    [sym__newline_inline] = ACTIONS(2190),
    [sym_hard_line_break] = ACTIONS(1944),
    [sym__verbatim_begin] = ACTIONS(1986),
  },
  [231] = {
    [sym__inline_without_trailing_space] = STATE(2025),
    [sym__inline_element] = STATE(988),
    [sym__smart_punctuation] = STATE(460),
    [sym_autolink] = STATE(460),
    [sym_emphasis] = STATE(463),
    [sym_emphasis_begin] = STATE(2484),
    [sym_strong] = STATE(463),
    [sym_strong_begin] = STATE(2485),
    [sym_superscript] = STATE(463),
    [sym_superscript_begin] = STATE(2486),
    [sym_subscript] = STATE(463),
    [sym_subscript_begin] = STATE(2487),
    [sym_highlighted] = STATE(463),
    [sym_highlighted_begin] = STATE(2488),
    [sym_insert] = STATE(463),
    [sym_insert_begin] = STATE(2489),
    [sym_delete] = STATE(463),
    [sym_delete_begin] = STATE(2490),
    [sym_footnote_reference] = STATE(463),
    [sym_footnote_marker_begin] = STATE(2491),
    [sym__image] = STATE(463),
    [sym_full_reference_image] = STATE(463),
    [sym_collapsed_reference_image] = STATE(463),
    [sym_inline_image] = STATE(463),
    [sym_image_description] = STATE(1268),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(463),
    [sym_full_reference_link] = STATE(463),
    [sym_collapsed_reference_link] = STATE(463),
    [sym_inline_link] = STATE(463),
    [sym_link_text] = STATE(1273),
    [sym_span] = STATE(988),
    [sym__bracketed_text_begin] = STATE(2607),
    [sym_inline_comment] = STATE(460),
    [sym_raw_inline] = STATE(460),
    [sym_math] = STATE(460),
    [sym_verbatim] = STATE(460),
    [sym__todo_highlights] = STATE(460),
    [sym_todo] = STATE(460),
    [sym_note] = STATE(460),
    [sym__symbol_fallback] = STATE(460),
    [aux_sym__text] = STATE(444),
    [aux_sym__inline_repeat1] = STATE(286),
    [anon_sym_LBRACK] = ACTIONS(1772),
    [sym__whitespace1] = ACTIONS(1774),
    [sym_quotation_marks] = ACTIONS(1776),
    [sym_ellipsis] = ACTIONS(1776),
    [sym_em_dash] = ACTIONS(1776),
    [sym_en_dash] = ACTIONS(1778),
    [sym_backslash_escape] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1780),
    [sym_symbol] = ACTIONS(1776),
    [anon_sym_LBRACE_] = ACTIONS(1782),
    [anon_sym__] = ACTIONS(1784),
    [anon_sym_LBRACE_STAR] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_LBRACE_CARET] = ACTIONS(1790),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1792),
    [anon_sym_LBRACE_EQ] = ACTIONS(1794),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1796),
    [anon_sym_LBRACE_DASH] = ACTIONS(1798),
    [anon_sym_LBRACK_CARET] = ACTIONS(1800),
    [anon_sym_BANG_LBRACK] = ACTIONS(1802),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1804),
    [anon_sym_LPAREN] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [anon_sym_TODO] = ACTIONS(1810),
    [anon_sym_WIP] = ACTIONS(1810),
    [anon_sym_NOTE] = ACTIONS(1812),
    [anon_sym_INFO] = ACTIONS(1812),
    [anon_sym_XXX] = ACTIONS(1812),
    [sym_fixme] = ACTIONS(1776),
    [aux_sym__text_token1] = ACTIONS(1814),
    [sym__newline_inline] = ACTIONS(1816),
    [sym_hard_line_break] = ACTIONS(1776),
    [sym__verbatim_begin] = ACTIONS(1818),
  },
  [232] = {
    [sym__inline_without_trailing_space] = STATE(2026),
    [sym__inline_element] = STATE(959),
    [sym__smart_punctuation] = STATE(464),
    [sym_autolink] = STATE(464),
    [sym_emphasis] = STATE(465),
    [sym_emphasis_begin] = STATE(2498),
    [sym_strong] = STATE(465),
    [sym_strong_begin] = STATE(2499),
    [sym_superscript] = STATE(465),
    [sym_superscript_begin] = STATE(2500),
    [sym_subscript] = STATE(465),
    [sym_subscript_begin] = STATE(2501),
    [sym_highlighted] = STATE(465),
    [sym_highlighted_begin] = STATE(2502),
    [sym_insert] = STATE(465),
    [sym_insert_begin] = STATE(2503),
    [sym_delete] = STATE(465),
    [sym_delete_begin] = STATE(2504),
    [sym_footnote_reference] = STATE(465),
    [sym_footnote_marker_begin] = STATE(2505),
    [sym__image] = STATE(465),
    [sym_full_reference_image] = STATE(465),
    [sym_collapsed_reference_image] = STATE(465),
    [sym_inline_image] = STATE(465),
    [sym_image_description] = STATE(1314),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(465),
    [sym_full_reference_link] = STATE(465),
    [sym_collapsed_reference_link] = STATE(465),
    [sym_inline_link] = STATE(465),
    [sym_link_text] = STATE(1319),
    [sym_span] = STATE(959),
    [sym__bracketed_text_begin] = STATE(2610),
    [sym_inline_comment] = STATE(464),
    [sym_raw_inline] = STATE(464),
    [sym_math] = STATE(464),
    [sym_verbatim] = STATE(464),
    [sym__todo_highlights] = STATE(464),
    [sym_todo] = STATE(464),
    [sym_note] = STATE(464),
    [sym__symbol_fallback] = STATE(464),
    [aux_sym__text] = STATE(445),
    [aux_sym__inline_repeat1] = STATE(287),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [sym__whitespace1] = ACTIONS(2136),
    [sym_quotation_marks] = ACTIONS(2138),
    [sym_ellipsis] = ACTIONS(2138),
    [sym_em_dash] = ACTIONS(2138),
    [sym_en_dash] = ACTIONS(2140),
    [sym_backslash_escape] = ACTIONS(2140),
    [anon_sym_LT] = ACTIONS(2142),
    [sym_symbol] = ACTIONS(2138),
    [anon_sym_LBRACE_] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_LBRACE_STAR] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_LBRACE_CARET] = ACTIONS(2152),
    [anon_sym_CARET] = ACTIONS(2152),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACE_EQ] = ACTIONS(2156),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2158),
    [anon_sym_LBRACE_DASH] = ACTIONS(2160),
    [anon_sym_LBRACK_CARET] = ACTIONS(2162),
    [anon_sym_BANG_LBRACK] = ACTIONS(2164),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_TODO] = ACTIONS(2172),
    [anon_sym_WIP] = ACTIONS(2172),
    [anon_sym_NOTE] = ACTIONS(2174),
    [anon_sym_INFO] = ACTIONS(2174),
    [anon_sym_XXX] = ACTIONS(2174),
    [sym_fixme] = ACTIONS(2138),
    [aux_sym__text_token1] = ACTIONS(2176),
    [sym__newline_inline] = ACTIONS(2178),
    [sym_hard_line_break] = ACTIONS(2138),
    [sym__verbatim_begin] = ACTIONS(2180),
  },
  [233] = {
    [sym__inline] = STATE(2027),
    [sym__inline_element] = STATE(1017),
    [sym__smart_punctuation] = STATE(468),
    [sym_autolink] = STATE(468),
    [sym_emphasis] = STATE(469),
    [sym_emphasis_begin] = STATE(2511),
    [sym_strong] = STATE(469),
    [sym_strong_begin] = STATE(2512),
    [sym_superscript] = STATE(469),
    [sym_superscript_begin] = STATE(2513),
    [sym_subscript] = STATE(469),
    [sym_subscript_begin] = STATE(2514),
    [sym_highlighted] = STATE(469),
    [sym_highlighted_begin] = STATE(2515),
    [sym_insert] = STATE(469),
    [sym_insert_begin] = STATE(2516),
    [sym_delete] = STATE(469),
    [sym_delete_begin] = STATE(2517),
    [sym_footnote_reference] = STATE(469),
    [sym_footnote_marker_begin] = STATE(2518),
    [sym__image] = STATE(469),
    [sym_full_reference_image] = STATE(469),
    [sym_collapsed_reference_image] = STATE(469),
    [sym_inline_image] = STATE(469),
    [sym_image_description] = STATE(1325),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(469),
    [sym_full_reference_link] = STATE(469),
    [sym_collapsed_reference_link] = STATE(469),
    [sym_inline_link] = STATE(469),
    [sym_link_text] = STATE(1326),
    [sym_span] = STATE(1017),
    [sym__bracketed_text_begin] = STATE(2613),
    [sym_inline_comment] = STATE(468),
    [sym_raw_inline] = STATE(468),
    [sym_math] = STATE(468),
    [sym_verbatim] = STATE(468),
    [sym__todo_highlights] = STATE(468),
    [sym_todo] = STATE(468),
    [sym_note] = STATE(468),
    [sym__symbol_fallback] = STATE(468),
    [aux_sym__text] = STATE(446),
    [aux_sym__inline_repeat1] = STATE(146),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [sym__whitespace1] = ACTIONS(1340),
    [sym_quotation_marks] = ACTIONS(1342),
    [sym_ellipsis] = ACTIONS(1342),
    [sym_em_dash] = ACTIONS(1342),
    [sym_en_dash] = ACTIONS(1344),
    [sym_backslash_escape] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [sym_symbol] = ACTIONS(1342),
    [anon_sym_LBRACE_] = ACTIONS(1348),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_LBRACE_STAR] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_LBRACE_CARET] = ACTIONS(1356),
    [anon_sym_CARET] = ACTIONS(1356),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_LBRACE_EQ] = ACTIONS(1360),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1362),
    [anon_sym_LBRACE_DASH] = ACTIONS(1364),
    [anon_sym_LBRACK_CARET] = ACTIONS(1366),
    [anon_sym_BANG_LBRACK] = ACTIONS(1368),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1374),
    [anon_sym_TODO] = ACTIONS(1376),
    [anon_sym_WIP] = ACTIONS(1376),
    [anon_sym_NOTE] = ACTIONS(1378),
    [anon_sym_INFO] = ACTIONS(1378),
    [anon_sym_XXX] = ACTIONS(1378),
    [sym_fixme] = ACTIONS(1342),
    [aux_sym__text_token1] = ACTIONS(1380),
    [sym__newline_inline] = ACTIONS(2182),
    [sym_hard_line_break] = ACTIONS(1342),
    [sym__verbatim_begin] = ACTIONS(1384),
  },
  [234] = {
    [sym__inline] = STATE(2028),
    [sym__inline_element] = STATE(915),
    [sym__smart_punctuation] = STATE(470),
    [sym_autolink] = STATE(470),
    [sym_emphasis] = STATE(471),
    [sym_emphasis_begin] = STATE(2522),
    [sym_strong] = STATE(471),
    [sym_strong_begin] = STATE(2523),
    [sym_superscript] = STATE(471),
    [sym_superscript_begin] = STATE(2524),
    [sym_subscript] = STATE(471),
    [sym_subscript_begin] = STATE(2525),
    [sym_highlighted] = STATE(471),
    [sym_highlighted_begin] = STATE(2526),
    [sym_insert] = STATE(471),
    [sym_insert_begin] = STATE(2527),
    [sym_delete] = STATE(471),
    [sym_delete_begin] = STATE(2528),
    [sym_footnote_reference] = STATE(471),
    [sym_footnote_marker_begin] = STATE(2529),
    [sym__image] = STATE(471),
    [sym_full_reference_image] = STATE(471),
    [sym_collapsed_reference_image] = STATE(471),
    [sym_inline_image] = STATE(471),
    [sym_image_description] = STATE(1332),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(471),
    [sym_full_reference_link] = STATE(471),
    [sym_collapsed_reference_link] = STATE(471),
    [sym_inline_link] = STATE(471),
    [sym_link_text] = STATE(1334),
    [sym_span] = STATE(915),
    [sym__bracketed_text_begin] = STATE(2614),
    [sym_inline_comment] = STATE(470),
    [sym_raw_inline] = STATE(470),
    [sym_math] = STATE(470),
    [sym_verbatim] = STATE(470),
    [sym__todo_highlights] = STATE(470),
    [sym_todo] = STATE(470),
    [sym_note] = STATE(470),
    [sym__symbol_fallback] = STATE(470),
    [aux_sym__text] = STATE(447),
    [aux_sym__inline_repeat1] = STATE(148),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [sym__whitespace1] = ACTIONS(1460),
    [sym_quotation_marks] = ACTIONS(1462),
    [sym_ellipsis] = ACTIONS(1462),
    [sym_em_dash] = ACTIONS(1462),
    [sym_en_dash] = ACTIONS(1464),
    [sym_backslash_escape] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [sym_symbol] = ACTIONS(1462),
    [anon_sym_LBRACE_] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(1470),
    [anon_sym_LBRACE_STAR] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACE_CARET] = ACTIONS(1476),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_LBRACE_EQ] = ACTIONS(1480),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1482),
    [anon_sym_LBRACE_DASH] = ACTIONS(1484),
    [anon_sym_LBRACK_CARET] = ACTIONS(1486),
    [anon_sym_BANG_LBRACK] = ACTIONS(1488),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_TODO] = ACTIONS(1496),
    [anon_sym_WIP] = ACTIONS(1496),
    [anon_sym_NOTE] = ACTIONS(1498),
    [anon_sym_INFO] = ACTIONS(1498),
    [anon_sym_XXX] = ACTIONS(1498),
    [sym_fixme] = ACTIONS(1462),
    [aux_sym__text_token1] = ACTIONS(1500),
    [sym__newline_inline] = ACTIONS(2184),
    [sym_hard_line_break] = ACTIONS(1462),
    [sym__verbatim_begin] = ACTIONS(1504),
  },
  [235] = {
    [sym__inline] = STATE(2029),
    [sym__inline_element] = STATE(1021),
    [sym__smart_punctuation] = STATE(473),
    [sym_autolink] = STATE(473),
    [sym_emphasis] = STATE(450),
    [sym_emphasis_begin] = STATE(2533),
    [sym_strong] = STATE(450),
    [sym_strong_begin] = STATE(2534),
    [sym_superscript] = STATE(450),
    [sym_superscript_begin] = STATE(2535),
    [sym_subscript] = STATE(450),
    [sym_subscript_begin] = STATE(2536),
    [sym_highlighted] = STATE(450),
    [sym_highlighted_begin] = STATE(2537),
    [sym_insert] = STATE(450),
    [sym_insert_begin] = STATE(2538),
    [sym_delete] = STATE(450),
    [sym_delete_begin] = STATE(2539),
    [sym_footnote_reference] = STATE(450),
    [sym_footnote_marker_begin] = STATE(2540),
    [sym__image] = STATE(450),
    [sym_full_reference_image] = STATE(450),
    [sym_collapsed_reference_image] = STATE(450),
    [sym_inline_image] = STATE(450),
    [sym_image_description] = STATE(1340),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(450),
    [sym_full_reference_link] = STATE(450),
    [sym_collapsed_reference_link] = STATE(450),
    [sym_inline_link] = STATE(450),
    [sym_link_text] = STATE(1341),
    [sym_span] = STATE(1021),
    [sym__bracketed_text_begin] = STATE(2615),
    [sym_inline_comment] = STATE(473),
    [sym_raw_inline] = STATE(473),
    [sym_math] = STATE(473),
    [sym_verbatim] = STATE(473),
    [sym__todo_highlights] = STATE(473),
    [sym_todo] = STATE(473),
    [sym_note] = STATE(473),
    [sym__symbol_fallback] = STATE(473),
    [aux_sym__text] = STATE(448),
    [aux_sym__inline_repeat1] = STATE(150),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [sym__whitespace1] = ACTIONS(1580),
    [sym_quotation_marks] = ACTIONS(1582),
    [sym_ellipsis] = ACTIONS(1582),
    [sym_em_dash] = ACTIONS(1582),
    [sym_en_dash] = ACTIONS(1584),
    [sym_backslash_escape] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1586),
    [sym_symbol] = ACTIONS(1582),
    [anon_sym_LBRACE_] = ACTIONS(1588),
    [anon_sym__] = ACTIONS(1590),
    [anon_sym_LBRACE_STAR] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_LBRACE_CARET] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_LBRACE_EQ] = ACTIONS(1600),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1602),
    [anon_sym_LBRACE_DASH] = ACTIONS(1604),
    [anon_sym_LBRACK_CARET] = ACTIONS(1606),
    [anon_sym_BANG_LBRACK] = ACTIONS(1608),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_DOLLAR] = ACTIONS(1614),
    [anon_sym_TODO] = ACTIONS(1616),
    [anon_sym_WIP] = ACTIONS(1616),
    [anon_sym_NOTE] = ACTIONS(1618),
    [anon_sym_INFO] = ACTIONS(1618),
    [anon_sym_XXX] = ACTIONS(1618),
    [sym_fixme] = ACTIONS(1582),
    [aux_sym__text_token1] = ACTIONS(1620),
    [sym__newline_inline] = ACTIONS(2186),
    [sym_hard_line_break] = ACTIONS(1582),
    [sym__verbatim_begin] = ACTIONS(1624),
  },
  [236] = {
    [sym__inline] = STATE(2030),
    [sym__inline_element] = STATE(997),
    [sym__smart_punctuation] = STATE(451),
    [sym_autolink] = STATE(451),
    [sym_emphasis] = STATE(449),
    [sym_emphasis_begin] = STATE(2544),
    [sym_strong] = STATE(449),
    [sym_strong_begin] = STATE(2545),
    [sym_superscript] = STATE(449),
    [sym_superscript_begin] = STATE(2546),
    [sym_subscript] = STATE(449),
    [sym_subscript_begin] = STATE(2547),
    [sym_highlighted] = STATE(449),
    [sym_highlighted_begin] = STATE(2548),
    [sym_insert] = STATE(449),
    [sym_insert_begin] = STATE(2549),
    [sym_delete] = STATE(449),
    [sym_delete_begin] = STATE(2550),
    [sym_footnote_reference] = STATE(449),
    [sym_footnote_marker_begin] = STATE(2551),
    [sym__image] = STATE(449),
    [sym_full_reference_image] = STATE(449),
    [sym_collapsed_reference_image] = STATE(449),
    [sym_inline_image] = STATE(449),
    [sym_image_description] = STATE(1250),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(449),
    [sym_full_reference_link] = STATE(449),
    [sym_collapsed_reference_link] = STATE(449),
    [sym_inline_link] = STATE(449),
    [sym_link_text] = STATE(1251),
    [sym_span] = STATE(997),
    [sym__bracketed_text_begin] = STATE(2616),
    [sym_inline_comment] = STATE(451),
    [sym_raw_inline] = STATE(451),
    [sym_math] = STATE(451),
    [sym_verbatim] = STATE(451),
    [sym__todo_highlights] = STATE(451),
    [sym_todo] = STATE(451),
    [sym_note] = STATE(451),
    [sym__symbol_fallback] = STATE(451),
    [aux_sym__text] = STATE(439),
    [aux_sym__inline_repeat1] = STATE(152),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [sym__whitespace1] = ACTIONS(1074),
    [sym_quotation_marks] = ACTIONS(1076),
    [sym_ellipsis] = ACTIONS(1076),
    [sym_em_dash] = ACTIONS(1076),
    [sym_en_dash] = ACTIONS(1078),
    [sym_backslash_escape] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(1080),
    [sym_symbol] = ACTIONS(1076),
    [anon_sym_LBRACE_] = ACTIONS(1082),
    [anon_sym__] = ACTIONS(1084),
    [anon_sym_LBRACE_STAR] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_LBRACE_CARET] = ACTIONS(1090),
    [anon_sym_CARET] = ACTIONS(1090),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_LBRACE_EQ] = ACTIONS(1094),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1096),
    [anon_sym_LBRACE_DASH] = ACTIONS(1098),
    [anon_sym_LBRACK_CARET] = ACTIONS(1100),
    [anon_sym_BANG_LBRACK] = ACTIONS(1102),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [anon_sym_TODO] = ACTIONS(1110),
    [anon_sym_WIP] = ACTIONS(1110),
    [anon_sym_NOTE] = ACTIONS(1112),
    [anon_sym_INFO] = ACTIONS(1112),
    [anon_sym_XXX] = ACTIONS(1112),
    [sym_fixme] = ACTIONS(1076),
    [aux_sym__text_token1] = ACTIONS(1114),
    [sym__newline_inline] = ACTIONS(1116),
    [sym_hard_line_break] = ACTIONS(1076),
    [sym__verbatim_begin] = ACTIONS(1118),
  },
  [237] = {
    [sym__inline] = STATE(2031),
    [sym__inline_element] = STATE(900),
    [sym__smart_punctuation] = STATE(454),
    [sym_autolink] = STATE(454),
    [sym_emphasis] = STATE(455),
    [sym_emphasis_begin] = STATE(2555),
    [sym_strong] = STATE(455),
    [sym_strong_begin] = STATE(2556),
    [sym_superscript] = STATE(455),
    [sym_superscript_begin] = STATE(2557),
    [sym_subscript] = STATE(455),
    [sym_subscript_begin] = STATE(2558),
    [sym_highlighted] = STATE(455),
    [sym_highlighted_begin] = STATE(2559),
    [sym_insert] = STATE(455),
    [sym_insert_begin] = STATE(2560),
    [sym_delete] = STATE(455),
    [sym_delete_begin] = STATE(2561),
    [sym_footnote_reference] = STATE(455),
    [sym_footnote_marker_begin] = STATE(2562),
    [sym__image] = STATE(455),
    [sym_full_reference_image] = STATE(455),
    [sym_collapsed_reference_image] = STATE(455),
    [sym_inline_image] = STATE(455),
    [sym_image_description] = STATE(1257),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(455),
    [sym_full_reference_link] = STATE(455),
    [sym_collapsed_reference_link] = STATE(455),
    [sym_inline_link] = STATE(455),
    [sym_link_text] = STATE(1258),
    [sym_span] = STATE(900),
    [sym__bracketed_text_begin] = STATE(2617),
    [sym_inline_comment] = STATE(454),
    [sym_raw_inline] = STATE(454),
    [sym_math] = STATE(454),
    [sym_verbatim] = STATE(454),
    [sym__todo_highlights] = STATE(454),
    [sym_todo] = STATE(454),
    [sym_note] = STATE(454),
    [sym__symbol_fallback] = STATE(454),
    [aux_sym__text] = STATE(441),
    [aux_sym__inline_repeat1] = STATE(155),
    [anon_sym_LBRACK] = ACTIONS(1820),
    [sym__whitespace1] = ACTIONS(1822),
    [sym_quotation_marks] = ACTIONS(1824),
    [sym_ellipsis] = ACTIONS(1824),
    [sym_em_dash] = ACTIONS(1824),
    [sym_en_dash] = ACTIONS(1826),
    [sym_backslash_escape] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1828),
    [sym_symbol] = ACTIONS(1824),
    [anon_sym_LBRACE_] = ACTIONS(1830),
    [anon_sym__] = ACTIONS(1832),
    [anon_sym_LBRACE_STAR] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_LBRACE_CARET] = ACTIONS(1838),
    [anon_sym_CARET] = ACTIONS(1838),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1840),
    [anon_sym_TILDE] = ACTIONS(1840),
    [anon_sym_LBRACE_EQ] = ACTIONS(1842),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1844),
    [anon_sym_LBRACE_DASH] = ACTIONS(1846),
    [anon_sym_LBRACK_CARET] = ACTIONS(1848),
    [anon_sym_BANG_LBRACK] = ACTIONS(1850),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1856),
    [anon_sym_TODO] = ACTIONS(1858),
    [anon_sym_WIP] = ACTIONS(1858),
    [anon_sym_NOTE] = ACTIONS(1860),
    [anon_sym_INFO] = ACTIONS(1860),
    [anon_sym_XXX] = ACTIONS(1860),
    [sym_fixme] = ACTIONS(1824),
    [aux_sym__text_token1] = ACTIONS(1862),
    [sym__newline_inline] = ACTIONS(2188),
    [sym_hard_line_break] = ACTIONS(1824),
    [sym__verbatim_begin] = ACTIONS(1866),
  },
  [238] = {
    [sym__inline] = STATE(2033),
    [sym__inline_element] = STATE(1014),
    [sym__smart_punctuation] = STATE(456),
    [sym_autolink] = STATE(456),
    [sym_emphasis] = STATE(457),
    [sym_emphasis_begin] = STATE(2566),
    [sym_strong] = STATE(457),
    [sym_strong_begin] = STATE(2567),
    [sym_superscript] = STATE(457),
    [sym_superscript_begin] = STATE(2568),
    [sym_subscript] = STATE(457),
    [sym_subscript_begin] = STATE(2569),
    [sym_highlighted] = STATE(457),
    [sym_highlighted_begin] = STATE(2570),
    [sym_insert] = STATE(457),
    [sym_insert_begin] = STATE(2571),
    [sym_delete] = STATE(457),
    [sym_delete_begin] = STATE(1976),
    [sym_footnote_reference] = STATE(457),
    [sym_footnote_marker_begin] = STATE(2573),
    [sym__image] = STATE(457),
    [sym_full_reference_image] = STATE(457),
    [sym_collapsed_reference_image] = STATE(457),
    [sym_inline_image] = STATE(457),
    [sym_image_description] = STATE(1264),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(457),
    [sym_full_reference_link] = STATE(457),
    [sym_collapsed_reference_link] = STATE(457),
    [sym_inline_link] = STATE(457),
    [sym_link_text] = STATE(1265),
    [sym_span] = STATE(1014),
    [sym__bracketed_text_begin] = STATE(2618),
    [sym_inline_comment] = STATE(456),
    [sym_raw_inline] = STATE(456),
    [sym_math] = STATE(456),
    [sym_verbatim] = STATE(456),
    [sym__todo_highlights] = STATE(456),
    [sym_todo] = STATE(456),
    [sym_note] = STATE(456),
    [sym__symbol_fallback] = STATE(456),
    [aux_sym__text] = STATE(440),
    [aux_sym__inline_repeat1] = STATE(157),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [sym__whitespace1] = ACTIONS(1942),
    [sym_quotation_marks] = ACTIONS(1944),
    [sym_ellipsis] = ACTIONS(1944),
    [sym_em_dash] = ACTIONS(1944),
    [sym_en_dash] = ACTIONS(1946),
    [sym_backslash_escape] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1948),
    [sym_symbol] = ACTIONS(1944),
    [anon_sym_LBRACE_] = ACTIONS(1950),
    [anon_sym__] = ACTIONS(1952),
    [anon_sym_LBRACE_STAR] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_LBRACE_CARET] = ACTIONS(1958),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_LBRACE_EQ] = ACTIONS(1962),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1964),
    [anon_sym_LBRACE_DASH] = ACTIONS(1966),
    [anon_sym_LBRACK_CARET] = ACTIONS(1968),
    [anon_sym_BANG_LBRACK] = ACTIONS(1970),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1974),
    [anon_sym_DOLLAR] = ACTIONS(1976),
    [anon_sym_TODO] = ACTIONS(1978),
    [anon_sym_WIP] = ACTIONS(1978),
    [anon_sym_NOTE] = ACTIONS(1980),
    [anon_sym_INFO] = ACTIONS(1980),
    [anon_sym_XXX] = ACTIONS(1980),
    [sym_fixme] = ACTIONS(1944),
    [aux_sym__text_token1] = ACTIONS(1982),
    [sym__newline_inline] = ACTIONS(2190),
    [sym_hard_line_break] = ACTIONS(1944),
    [sym__verbatim_begin] = ACTIONS(1986),
  },
  [239] = {
    [sym__inline_without_trailing_space] = STATE(2060),
    [sym__inline_element] = STATE(988),
    [sym__smart_punctuation] = STATE(460),
    [sym_autolink] = STATE(460),
    [sym_emphasis] = STATE(463),
    [sym_emphasis_begin] = STATE(2484),
    [sym_strong] = STATE(463),
    [sym_strong_begin] = STATE(2485),
    [sym_superscript] = STATE(463),
    [sym_superscript_begin] = STATE(2486),
    [sym_subscript] = STATE(463),
    [sym_subscript_begin] = STATE(2487),
    [sym_highlighted] = STATE(463),
    [sym_highlighted_begin] = STATE(2488),
    [sym_insert] = STATE(463),
    [sym_insert_begin] = STATE(2489),
    [sym_delete] = STATE(463),
    [sym_delete_begin] = STATE(2490),
    [sym_footnote_reference] = STATE(463),
    [sym_footnote_marker_begin] = STATE(2491),
    [sym__image] = STATE(463),
    [sym_full_reference_image] = STATE(463),
    [sym_collapsed_reference_image] = STATE(463),
    [sym_inline_image] = STATE(463),
    [sym_image_description] = STATE(1268),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(463),
    [sym_full_reference_link] = STATE(463),
    [sym_collapsed_reference_link] = STATE(463),
    [sym_inline_link] = STATE(463),
    [sym_link_text] = STATE(1273),
    [sym_span] = STATE(988),
    [sym__bracketed_text_begin] = STATE(2607),
    [sym_inline_comment] = STATE(460),
    [sym_raw_inline] = STATE(460),
    [sym_math] = STATE(460),
    [sym_verbatim] = STATE(460),
    [sym__todo_highlights] = STATE(460),
    [sym_todo] = STATE(460),
    [sym_note] = STATE(460),
    [sym__symbol_fallback] = STATE(460),
    [aux_sym__text] = STATE(444),
    [aux_sym__inline_repeat1] = STATE(286),
    [anon_sym_LBRACK] = ACTIONS(1772),
    [sym__whitespace1] = ACTIONS(1774),
    [sym_quotation_marks] = ACTIONS(1776),
    [sym_ellipsis] = ACTIONS(1776),
    [sym_em_dash] = ACTIONS(1776),
    [sym_en_dash] = ACTIONS(1778),
    [sym_backslash_escape] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1780),
    [sym_symbol] = ACTIONS(1776),
    [anon_sym_LBRACE_] = ACTIONS(1782),
    [anon_sym__] = ACTIONS(1784),
    [anon_sym_LBRACE_STAR] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_LBRACE_CARET] = ACTIONS(1790),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1792),
    [anon_sym_LBRACE_EQ] = ACTIONS(1794),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1796),
    [anon_sym_LBRACE_DASH] = ACTIONS(1798),
    [anon_sym_LBRACK_CARET] = ACTIONS(1800),
    [anon_sym_BANG_LBRACK] = ACTIONS(1802),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1804),
    [anon_sym_LPAREN] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [anon_sym_TODO] = ACTIONS(1810),
    [anon_sym_WIP] = ACTIONS(1810),
    [anon_sym_NOTE] = ACTIONS(1812),
    [anon_sym_INFO] = ACTIONS(1812),
    [anon_sym_XXX] = ACTIONS(1812),
    [sym_fixme] = ACTIONS(1776),
    [aux_sym__text_token1] = ACTIONS(1814),
    [sym__newline_inline] = ACTIONS(1816),
    [sym_hard_line_break] = ACTIONS(1776),
    [sym__verbatim_begin] = ACTIONS(1818),
  },
  [240] = {
    [sym__inline_without_trailing_space] = STATE(2061),
    [sym__inline_element] = STATE(959),
    [sym__smart_punctuation] = STATE(464),
    [sym_autolink] = STATE(464),
    [sym_emphasis] = STATE(465),
    [sym_emphasis_begin] = STATE(2498),
    [sym_strong] = STATE(465),
    [sym_strong_begin] = STATE(2499),
    [sym_superscript] = STATE(465),
    [sym_superscript_begin] = STATE(2500),
    [sym_subscript] = STATE(465),
    [sym_subscript_begin] = STATE(2501),
    [sym_highlighted] = STATE(465),
    [sym_highlighted_begin] = STATE(2502),
    [sym_insert] = STATE(465),
    [sym_insert_begin] = STATE(2503),
    [sym_delete] = STATE(465),
    [sym_delete_begin] = STATE(2504),
    [sym_footnote_reference] = STATE(465),
    [sym_footnote_marker_begin] = STATE(2505),
    [sym__image] = STATE(465),
    [sym_full_reference_image] = STATE(465),
    [sym_collapsed_reference_image] = STATE(465),
    [sym_inline_image] = STATE(465),
    [sym_image_description] = STATE(1314),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(465),
    [sym_full_reference_link] = STATE(465),
    [sym_collapsed_reference_link] = STATE(465),
    [sym_inline_link] = STATE(465),
    [sym_link_text] = STATE(1319),
    [sym_span] = STATE(959),
    [sym__bracketed_text_begin] = STATE(2610),
    [sym_inline_comment] = STATE(464),
    [sym_raw_inline] = STATE(464),
    [sym_math] = STATE(464),
    [sym_verbatim] = STATE(464),
    [sym__todo_highlights] = STATE(464),
    [sym_todo] = STATE(464),
    [sym_note] = STATE(464),
    [sym__symbol_fallback] = STATE(464),
    [aux_sym__text] = STATE(445),
    [aux_sym__inline_repeat1] = STATE(287),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [sym__whitespace1] = ACTIONS(2136),
    [sym_quotation_marks] = ACTIONS(2138),
    [sym_ellipsis] = ACTIONS(2138),
    [sym_em_dash] = ACTIONS(2138),
    [sym_en_dash] = ACTIONS(2140),
    [sym_backslash_escape] = ACTIONS(2140),
    [anon_sym_LT] = ACTIONS(2142),
    [sym_symbol] = ACTIONS(2138),
    [anon_sym_LBRACE_] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_LBRACE_STAR] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_LBRACE_CARET] = ACTIONS(2152),
    [anon_sym_CARET] = ACTIONS(2152),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACE_EQ] = ACTIONS(2156),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2158),
    [anon_sym_LBRACE_DASH] = ACTIONS(2160),
    [anon_sym_LBRACK_CARET] = ACTIONS(2162),
    [anon_sym_BANG_LBRACK] = ACTIONS(2164),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_TODO] = ACTIONS(2172),
    [anon_sym_WIP] = ACTIONS(2172),
    [anon_sym_NOTE] = ACTIONS(2174),
    [anon_sym_INFO] = ACTIONS(2174),
    [anon_sym_XXX] = ACTIONS(2174),
    [sym_fixme] = ACTIONS(2138),
    [aux_sym__text_token1] = ACTIONS(2176),
    [sym__newline_inline] = ACTIONS(2178),
    [sym_hard_line_break] = ACTIONS(2138),
    [sym__verbatim_begin] = ACTIONS(2180),
  },
  [241] = {
    [sym__inline] = STATE(2062),
    [sym__inline_element] = STATE(1017),
    [sym__smart_punctuation] = STATE(468),
    [sym_autolink] = STATE(468),
    [sym_emphasis] = STATE(469),
    [sym_emphasis_begin] = STATE(2511),
    [sym_strong] = STATE(469),
    [sym_strong_begin] = STATE(2512),
    [sym_superscript] = STATE(469),
    [sym_superscript_begin] = STATE(2513),
    [sym_subscript] = STATE(469),
    [sym_subscript_begin] = STATE(2514),
    [sym_highlighted] = STATE(469),
    [sym_highlighted_begin] = STATE(2515),
    [sym_insert] = STATE(469),
    [sym_insert_begin] = STATE(2516),
    [sym_delete] = STATE(469),
    [sym_delete_begin] = STATE(2517),
    [sym_footnote_reference] = STATE(469),
    [sym_footnote_marker_begin] = STATE(2518),
    [sym__image] = STATE(469),
    [sym_full_reference_image] = STATE(469),
    [sym_collapsed_reference_image] = STATE(469),
    [sym_inline_image] = STATE(469),
    [sym_image_description] = STATE(1325),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(469),
    [sym_full_reference_link] = STATE(469),
    [sym_collapsed_reference_link] = STATE(469),
    [sym_inline_link] = STATE(469),
    [sym_link_text] = STATE(1326),
    [sym_span] = STATE(1017),
    [sym__bracketed_text_begin] = STATE(2613),
    [sym_inline_comment] = STATE(468),
    [sym_raw_inline] = STATE(468),
    [sym_math] = STATE(468),
    [sym_verbatim] = STATE(468),
    [sym__todo_highlights] = STATE(468),
    [sym_todo] = STATE(468),
    [sym_note] = STATE(468),
    [sym__symbol_fallback] = STATE(468),
    [aux_sym__text] = STATE(446),
    [aux_sym__inline_repeat1] = STATE(146),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [sym__whitespace1] = ACTIONS(1340),
    [sym_quotation_marks] = ACTIONS(1342),
    [sym_ellipsis] = ACTIONS(1342),
    [sym_em_dash] = ACTIONS(1342),
    [sym_en_dash] = ACTIONS(1344),
    [sym_backslash_escape] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [sym_symbol] = ACTIONS(1342),
    [anon_sym_LBRACE_] = ACTIONS(1348),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_LBRACE_STAR] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_LBRACE_CARET] = ACTIONS(1356),
    [anon_sym_CARET] = ACTIONS(1356),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_LBRACE_EQ] = ACTIONS(1360),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1362),
    [anon_sym_LBRACE_DASH] = ACTIONS(1364),
    [anon_sym_LBRACK_CARET] = ACTIONS(1366),
    [anon_sym_BANG_LBRACK] = ACTIONS(1368),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1374),
    [anon_sym_TODO] = ACTIONS(1376),
    [anon_sym_WIP] = ACTIONS(1376),
    [anon_sym_NOTE] = ACTIONS(1378),
    [anon_sym_INFO] = ACTIONS(1378),
    [anon_sym_XXX] = ACTIONS(1378),
    [sym_fixme] = ACTIONS(1342),
    [aux_sym__text_token1] = ACTIONS(1380),
    [sym__newline_inline] = ACTIONS(2182),
    [sym_hard_line_break] = ACTIONS(1342),
    [sym__verbatim_begin] = ACTIONS(1384),
  },
  [242] = {
    [sym__inline] = STATE(2063),
    [sym__inline_element] = STATE(915),
    [sym__smart_punctuation] = STATE(470),
    [sym_autolink] = STATE(470),
    [sym_emphasis] = STATE(471),
    [sym_emphasis_begin] = STATE(2522),
    [sym_strong] = STATE(471),
    [sym_strong_begin] = STATE(2523),
    [sym_superscript] = STATE(471),
    [sym_superscript_begin] = STATE(2524),
    [sym_subscript] = STATE(471),
    [sym_subscript_begin] = STATE(2525),
    [sym_highlighted] = STATE(471),
    [sym_highlighted_begin] = STATE(2526),
    [sym_insert] = STATE(471),
    [sym_insert_begin] = STATE(2527),
    [sym_delete] = STATE(471),
    [sym_delete_begin] = STATE(2528),
    [sym_footnote_reference] = STATE(471),
    [sym_footnote_marker_begin] = STATE(2529),
    [sym__image] = STATE(471),
    [sym_full_reference_image] = STATE(471),
    [sym_collapsed_reference_image] = STATE(471),
    [sym_inline_image] = STATE(471),
    [sym_image_description] = STATE(1332),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(471),
    [sym_full_reference_link] = STATE(471),
    [sym_collapsed_reference_link] = STATE(471),
    [sym_inline_link] = STATE(471),
    [sym_link_text] = STATE(1334),
    [sym_span] = STATE(915),
    [sym__bracketed_text_begin] = STATE(2614),
    [sym_inline_comment] = STATE(470),
    [sym_raw_inline] = STATE(470),
    [sym_math] = STATE(470),
    [sym_verbatim] = STATE(470),
    [sym__todo_highlights] = STATE(470),
    [sym_todo] = STATE(470),
    [sym_note] = STATE(470),
    [sym__symbol_fallback] = STATE(470),
    [aux_sym__text] = STATE(447),
    [aux_sym__inline_repeat1] = STATE(148),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [sym__whitespace1] = ACTIONS(1460),
    [sym_quotation_marks] = ACTIONS(1462),
    [sym_ellipsis] = ACTIONS(1462),
    [sym_em_dash] = ACTIONS(1462),
    [sym_en_dash] = ACTIONS(1464),
    [sym_backslash_escape] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [sym_symbol] = ACTIONS(1462),
    [anon_sym_LBRACE_] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(1470),
    [anon_sym_LBRACE_STAR] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACE_CARET] = ACTIONS(1476),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_LBRACE_EQ] = ACTIONS(1480),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1482),
    [anon_sym_LBRACE_DASH] = ACTIONS(1484),
    [anon_sym_LBRACK_CARET] = ACTIONS(1486),
    [anon_sym_BANG_LBRACK] = ACTIONS(1488),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_TODO] = ACTIONS(1496),
    [anon_sym_WIP] = ACTIONS(1496),
    [anon_sym_NOTE] = ACTIONS(1498),
    [anon_sym_INFO] = ACTIONS(1498),
    [anon_sym_XXX] = ACTIONS(1498),
    [sym_fixme] = ACTIONS(1462),
    [aux_sym__text_token1] = ACTIONS(1500),
    [sym__newline_inline] = ACTIONS(2184),
    [sym_hard_line_break] = ACTIONS(1462),
    [sym__verbatim_begin] = ACTIONS(1504),
  },
  [243] = {
    [sym__inline] = STATE(2064),
    [sym__inline_element] = STATE(1021),
    [sym__smart_punctuation] = STATE(473),
    [sym_autolink] = STATE(473),
    [sym_emphasis] = STATE(450),
    [sym_emphasis_begin] = STATE(2533),
    [sym_strong] = STATE(450),
    [sym_strong_begin] = STATE(2534),
    [sym_superscript] = STATE(450),
    [sym_superscript_begin] = STATE(2535),
    [sym_subscript] = STATE(450),
    [sym_subscript_begin] = STATE(2536),
    [sym_highlighted] = STATE(450),
    [sym_highlighted_begin] = STATE(2537),
    [sym_insert] = STATE(450),
    [sym_insert_begin] = STATE(2538),
    [sym_delete] = STATE(450),
    [sym_delete_begin] = STATE(2539),
    [sym_footnote_reference] = STATE(450),
    [sym_footnote_marker_begin] = STATE(2540),
    [sym__image] = STATE(450),
    [sym_full_reference_image] = STATE(450),
    [sym_collapsed_reference_image] = STATE(450),
    [sym_inline_image] = STATE(450),
    [sym_image_description] = STATE(1340),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(450),
    [sym_full_reference_link] = STATE(450),
    [sym_collapsed_reference_link] = STATE(450),
    [sym_inline_link] = STATE(450),
    [sym_link_text] = STATE(1341),
    [sym_span] = STATE(1021),
    [sym__bracketed_text_begin] = STATE(2615),
    [sym_inline_comment] = STATE(473),
    [sym_raw_inline] = STATE(473),
    [sym_math] = STATE(473),
    [sym_verbatim] = STATE(473),
    [sym__todo_highlights] = STATE(473),
    [sym_todo] = STATE(473),
    [sym_note] = STATE(473),
    [sym__symbol_fallback] = STATE(473),
    [aux_sym__text] = STATE(448),
    [aux_sym__inline_repeat1] = STATE(150),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [sym__whitespace1] = ACTIONS(1580),
    [sym_quotation_marks] = ACTIONS(1582),
    [sym_ellipsis] = ACTIONS(1582),
    [sym_em_dash] = ACTIONS(1582),
    [sym_en_dash] = ACTIONS(1584),
    [sym_backslash_escape] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1586),
    [sym_symbol] = ACTIONS(1582),
    [anon_sym_LBRACE_] = ACTIONS(1588),
    [anon_sym__] = ACTIONS(1590),
    [anon_sym_LBRACE_STAR] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_LBRACE_CARET] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_LBRACE_EQ] = ACTIONS(1600),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1602),
    [anon_sym_LBRACE_DASH] = ACTIONS(1604),
    [anon_sym_LBRACK_CARET] = ACTIONS(1606),
    [anon_sym_BANG_LBRACK] = ACTIONS(1608),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_DOLLAR] = ACTIONS(1614),
    [anon_sym_TODO] = ACTIONS(1616),
    [anon_sym_WIP] = ACTIONS(1616),
    [anon_sym_NOTE] = ACTIONS(1618),
    [anon_sym_INFO] = ACTIONS(1618),
    [anon_sym_XXX] = ACTIONS(1618),
    [sym_fixme] = ACTIONS(1582),
    [aux_sym__text_token1] = ACTIONS(1620),
    [sym__newline_inline] = ACTIONS(2186),
    [sym_hard_line_break] = ACTIONS(1582),
    [sym__verbatim_begin] = ACTIONS(1624),
  },
  [244] = {
    [sym__inline] = STATE(2065),
    [sym__inline_element] = STATE(997),
    [sym__smart_punctuation] = STATE(451),
    [sym_autolink] = STATE(451),
    [sym_emphasis] = STATE(449),
    [sym_emphasis_begin] = STATE(2544),
    [sym_strong] = STATE(449),
    [sym_strong_begin] = STATE(2545),
    [sym_superscript] = STATE(449),
    [sym_superscript_begin] = STATE(2546),
    [sym_subscript] = STATE(449),
    [sym_subscript_begin] = STATE(2547),
    [sym_highlighted] = STATE(449),
    [sym_highlighted_begin] = STATE(2548),
    [sym_insert] = STATE(449),
    [sym_insert_begin] = STATE(2549),
    [sym_delete] = STATE(449),
    [sym_delete_begin] = STATE(2550),
    [sym_footnote_reference] = STATE(449),
    [sym_footnote_marker_begin] = STATE(2551),
    [sym__image] = STATE(449),
    [sym_full_reference_image] = STATE(449),
    [sym_collapsed_reference_image] = STATE(449),
    [sym_inline_image] = STATE(449),
    [sym_image_description] = STATE(1250),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(449),
    [sym_full_reference_link] = STATE(449),
    [sym_collapsed_reference_link] = STATE(449),
    [sym_inline_link] = STATE(449),
    [sym_link_text] = STATE(1251),
    [sym_span] = STATE(997),
    [sym__bracketed_text_begin] = STATE(2616),
    [sym_inline_comment] = STATE(451),
    [sym_raw_inline] = STATE(451),
    [sym_math] = STATE(451),
    [sym_verbatim] = STATE(451),
    [sym__todo_highlights] = STATE(451),
    [sym_todo] = STATE(451),
    [sym_note] = STATE(451),
    [sym__symbol_fallback] = STATE(451),
    [aux_sym__text] = STATE(439),
    [aux_sym__inline_repeat1] = STATE(152),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [sym__whitespace1] = ACTIONS(1074),
    [sym_quotation_marks] = ACTIONS(1076),
    [sym_ellipsis] = ACTIONS(1076),
    [sym_em_dash] = ACTIONS(1076),
    [sym_en_dash] = ACTIONS(1078),
    [sym_backslash_escape] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(1080),
    [sym_symbol] = ACTIONS(1076),
    [anon_sym_LBRACE_] = ACTIONS(1082),
    [anon_sym__] = ACTIONS(1084),
    [anon_sym_LBRACE_STAR] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_LBRACE_CARET] = ACTIONS(1090),
    [anon_sym_CARET] = ACTIONS(1090),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_LBRACE_EQ] = ACTIONS(1094),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1096),
    [anon_sym_LBRACE_DASH] = ACTIONS(1098),
    [anon_sym_LBRACK_CARET] = ACTIONS(1100),
    [anon_sym_BANG_LBRACK] = ACTIONS(1102),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [anon_sym_TODO] = ACTIONS(1110),
    [anon_sym_WIP] = ACTIONS(1110),
    [anon_sym_NOTE] = ACTIONS(1112),
    [anon_sym_INFO] = ACTIONS(1112),
    [anon_sym_XXX] = ACTIONS(1112),
    [sym_fixme] = ACTIONS(1076),
    [aux_sym__text_token1] = ACTIONS(1114),
    [sym__newline_inline] = ACTIONS(1116),
    [sym_hard_line_break] = ACTIONS(1076),
    [sym__verbatim_begin] = ACTIONS(1118),
  },
  [245] = {
    [sym__inline] = STATE(2066),
    [sym__inline_element] = STATE(900),
    [sym__smart_punctuation] = STATE(454),
    [sym_autolink] = STATE(454),
    [sym_emphasis] = STATE(455),
    [sym_emphasis_begin] = STATE(2555),
    [sym_strong] = STATE(455),
    [sym_strong_begin] = STATE(2556),
    [sym_superscript] = STATE(455),
    [sym_superscript_begin] = STATE(2557),
    [sym_subscript] = STATE(455),
    [sym_subscript_begin] = STATE(2558),
    [sym_highlighted] = STATE(455),
    [sym_highlighted_begin] = STATE(2559),
    [sym_insert] = STATE(455),
    [sym_insert_begin] = STATE(2560),
    [sym_delete] = STATE(455),
    [sym_delete_begin] = STATE(2561),
    [sym_footnote_reference] = STATE(455),
    [sym_footnote_marker_begin] = STATE(2562),
    [sym__image] = STATE(455),
    [sym_full_reference_image] = STATE(455),
    [sym_collapsed_reference_image] = STATE(455),
    [sym_inline_image] = STATE(455),
    [sym_image_description] = STATE(1257),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(455),
    [sym_full_reference_link] = STATE(455),
    [sym_collapsed_reference_link] = STATE(455),
    [sym_inline_link] = STATE(455),
    [sym_link_text] = STATE(1258),
    [sym_span] = STATE(900),
    [sym__bracketed_text_begin] = STATE(2617),
    [sym_inline_comment] = STATE(454),
    [sym_raw_inline] = STATE(454),
    [sym_math] = STATE(454),
    [sym_verbatim] = STATE(454),
    [sym__todo_highlights] = STATE(454),
    [sym_todo] = STATE(454),
    [sym_note] = STATE(454),
    [sym__symbol_fallback] = STATE(454),
    [aux_sym__text] = STATE(441),
    [aux_sym__inline_repeat1] = STATE(155),
    [anon_sym_LBRACK] = ACTIONS(1820),
    [sym__whitespace1] = ACTIONS(1822),
    [sym_quotation_marks] = ACTIONS(1824),
    [sym_ellipsis] = ACTIONS(1824),
    [sym_em_dash] = ACTIONS(1824),
    [sym_en_dash] = ACTIONS(1826),
    [sym_backslash_escape] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1828),
    [sym_symbol] = ACTIONS(1824),
    [anon_sym_LBRACE_] = ACTIONS(1830),
    [anon_sym__] = ACTIONS(1832),
    [anon_sym_LBRACE_STAR] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_LBRACE_CARET] = ACTIONS(1838),
    [anon_sym_CARET] = ACTIONS(1838),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1840),
    [anon_sym_TILDE] = ACTIONS(1840),
    [anon_sym_LBRACE_EQ] = ACTIONS(1842),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1844),
    [anon_sym_LBRACE_DASH] = ACTIONS(1846),
    [anon_sym_LBRACK_CARET] = ACTIONS(1848),
    [anon_sym_BANG_LBRACK] = ACTIONS(1850),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1856),
    [anon_sym_TODO] = ACTIONS(1858),
    [anon_sym_WIP] = ACTIONS(1858),
    [anon_sym_NOTE] = ACTIONS(1860),
    [anon_sym_INFO] = ACTIONS(1860),
    [anon_sym_XXX] = ACTIONS(1860),
    [sym_fixme] = ACTIONS(1824),
    [aux_sym__text_token1] = ACTIONS(1862),
    [sym__newline_inline] = ACTIONS(2188),
    [sym_hard_line_break] = ACTIONS(1824),
    [sym__verbatim_begin] = ACTIONS(1866),
  },
  [246] = {
    [sym__inline] = STATE(2068),
    [sym__inline_element] = STATE(1014),
    [sym__smart_punctuation] = STATE(456),
    [sym_autolink] = STATE(456),
    [sym_emphasis] = STATE(457),
    [sym_emphasis_begin] = STATE(2566),
    [sym_strong] = STATE(457),
    [sym_strong_begin] = STATE(2567),
    [sym_superscript] = STATE(457),
    [sym_superscript_begin] = STATE(2568),
    [sym_subscript] = STATE(457),
    [sym_subscript_begin] = STATE(2569),
    [sym_highlighted] = STATE(457),
    [sym_highlighted_begin] = STATE(2570),
    [sym_insert] = STATE(457),
    [sym_insert_begin] = STATE(2571),
    [sym_delete] = STATE(457),
    [sym_delete_begin] = STATE(1976),
    [sym_footnote_reference] = STATE(457),
    [sym_footnote_marker_begin] = STATE(2573),
    [sym__image] = STATE(457),
    [sym_full_reference_image] = STATE(457),
    [sym_collapsed_reference_image] = STATE(457),
    [sym_inline_image] = STATE(457),
    [sym_image_description] = STATE(1264),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(457),
    [sym_full_reference_link] = STATE(457),
    [sym_collapsed_reference_link] = STATE(457),
    [sym_inline_link] = STATE(457),
    [sym_link_text] = STATE(1265),
    [sym_span] = STATE(1014),
    [sym__bracketed_text_begin] = STATE(2618),
    [sym_inline_comment] = STATE(456),
    [sym_raw_inline] = STATE(456),
    [sym_math] = STATE(456),
    [sym_verbatim] = STATE(456),
    [sym__todo_highlights] = STATE(456),
    [sym_todo] = STATE(456),
    [sym_note] = STATE(456),
    [sym__symbol_fallback] = STATE(456),
    [aux_sym__text] = STATE(440),
    [aux_sym__inline_repeat1] = STATE(157),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [sym__whitespace1] = ACTIONS(1942),
    [sym_quotation_marks] = ACTIONS(1944),
    [sym_ellipsis] = ACTIONS(1944),
    [sym_em_dash] = ACTIONS(1944),
    [sym_en_dash] = ACTIONS(1946),
    [sym_backslash_escape] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1948),
    [sym_symbol] = ACTIONS(1944),
    [anon_sym_LBRACE_] = ACTIONS(1950),
    [anon_sym__] = ACTIONS(1952),
    [anon_sym_LBRACE_STAR] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_LBRACE_CARET] = ACTIONS(1958),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_LBRACE_EQ] = ACTIONS(1962),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1964),
    [anon_sym_LBRACE_DASH] = ACTIONS(1966),
    [anon_sym_LBRACK_CARET] = ACTIONS(1968),
    [anon_sym_BANG_LBRACK] = ACTIONS(1970),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1974),
    [anon_sym_DOLLAR] = ACTIONS(1976),
    [anon_sym_TODO] = ACTIONS(1978),
    [anon_sym_WIP] = ACTIONS(1978),
    [anon_sym_NOTE] = ACTIONS(1980),
    [anon_sym_INFO] = ACTIONS(1980),
    [anon_sym_XXX] = ACTIONS(1980),
    [sym_fixme] = ACTIONS(1944),
    [aux_sym__text_token1] = ACTIONS(1982),
    [sym__newline_inline] = ACTIONS(2190),
    [sym_hard_line_break] = ACTIONS(1944),
    [sym__verbatim_begin] = ACTIONS(1986),
  },
  [247] = {
    [sym__inline_without_trailing_space] = STATE(2095),
    [sym__inline_element] = STATE(988),
    [sym__smart_punctuation] = STATE(460),
    [sym_autolink] = STATE(460),
    [sym_emphasis] = STATE(463),
    [sym_emphasis_begin] = STATE(2484),
    [sym_strong] = STATE(463),
    [sym_strong_begin] = STATE(2485),
    [sym_superscript] = STATE(463),
    [sym_superscript_begin] = STATE(2486),
    [sym_subscript] = STATE(463),
    [sym_subscript_begin] = STATE(2487),
    [sym_highlighted] = STATE(463),
    [sym_highlighted_begin] = STATE(2488),
    [sym_insert] = STATE(463),
    [sym_insert_begin] = STATE(2489),
    [sym_delete] = STATE(463),
    [sym_delete_begin] = STATE(2490),
    [sym_footnote_reference] = STATE(463),
    [sym_footnote_marker_begin] = STATE(2491),
    [sym__image] = STATE(463),
    [sym_full_reference_image] = STATE(463),
    [sym_collapsed_reference_image] = STATE(463),
    [sym_inline_image] = STATE(463),
    [sym_image_description] = STATE(1268),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(463),
    [sym_full_reference_link] = STATE(463),
    [sym_collapsed_reference_link] = STATE(463),
    [sym_inline_link] = STATE(463),
    [sym_link_text] = STATE(1273),
    [sym_span] = STATE(988),
    [sym__bracketed_text_begin] = STATE(2607),
    [sym_inline_comment] = STATE(460),
    [sym_raw_inline] = STATE(460),
    [sym_math] = STATE(460),
    [sym_verbatim] = STATE(460),
    [sym__todo_highlights] = STATE(460),
    [sym_todo] = STATE(460),
    [sym_note] = STATE(460),
    [sym__symbol_fallback] = STATE(460),
    [aux_sym__text] = STATE(444),
    [aux_sym__inline_repeat1] = STATE(286),
    [anon_sym_LBRACK] = ACTIONS(1772),
    [sym__whitespace1] = ACTIONS(1774),
    [sym_quotation_marks] = ACTIONS(1776),
    [sym_ellipsis] = ACTIONS(1776),
    [sym_em_dash] = ACTIONS(1776),
    [sym_en_dash] = ACTIONS(1778),
    [sym_backslash_escape] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1780),
    [sym_symbol] = ACTIONS(1776),
    [anon_sym_LBRACE_] = ACTIONS(1782),
    [anon_sym__] = ACTIONS(1784),
    [anon_sym_LBRACE_STAR] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_LBRACE_CARET] = ACTIONS(1790),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1792),
    [anon_sym_LBRACE_EQ] = ACTIONS(1794),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1796),
    [anon_sym_LBRACE_DASH] = ACTIONS(1798),
    [anon_sym_LBRACK_CARET] = ACTIONS(1800),
    [anon_sym_BANG_LBRACK] = ACTIONS(1802),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1804),
    [anon_sym_LPAREN] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [anon_sym_TODO] = ACTIONS(1810),
    [anon_sym_WIP] = ACTIONS(1810),
    [anon_sym_NOTE] = ACTIONS(1812),
    [anon_sym_INFO] = ACTIONS(1812),
    [anon_sym_XXX] = ACTIONS(1812),
    [sym_fixme] = ACTIONS(1776),
    [aux_sym__text_token1] = ACTIONS(1814),
    [sym__newline_inline] = ACTIONS(1816),
    [sym_hard_line_break] = ACTIONS(1776),
    [sym__verbatim_begin] = ACTIONS(1818),
  },
  [248] = {
    [sym__inline_without_trailing_space] = STATE(2096),
    [sym__inline_element] = STATE(959),
    [sym__smart_punctuation] = STATE(464),
    [sym_autolink] = STATE(464),
    [sym_emphasis] = STATE(465),
    [sym_emphasis_begin] = STATE(2498),
    [sym_strong] = STATE(465),
    [sym_strong_begin] = STATE(2499),
    [sym_superscript] = STATE(465),
    [sym_superscript_begin] = STATE(2500),
    [sym_subscript] = STATE(465),
    [sym_subscript_begin] = STATE(2501),
    [sym_highlighted] = STATE(465),
    [sym_highlighted_begin] = STATE(2502),
    [sym_insert] = STATE(465),
    [sym_insert_begin] = STATE(2503),
    [sym_delete] = STATE(465),
    [sym_delete_begin] = STATE(2504),
    [sym_footnote_reference] = STATE(465),
    [sym_footnote_marker_begin] = STATE(2505),
    [sym__image] = STATE(465),
    [sym_full_reference_image] = STATE(465),
    [sym_collapsed_reference_image] = STATE(465),
    [sym_inline_image] = STATE(465),
    [sym_image_description] = STATE(1314),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(465),
    [sym_full_reference_link] = STATE(465),
    [sym_collapsed_reference_link] = STATE(465),
    [sym_inline_link] = STATE(465),
    [sym_link_text] = STATE(1319),
    [sym_span] = STATE(959),
    [sym__bracketed_text_begin] = STATE(2610),
    [sym_inline_comment] = STATE(464),
    [sym_raw_inline] = STATE(464),
    [sym_math] = STATE(464),
    [sym_verbatim] = STATE(464),
    [sym__todo_highlights] = STATE(464),
    [sym_todo] = STATE(464),
    [sym_note] = STATE(464),
    [sym__symbol_fallback] = STATE(464),
    [aux_sym__text] = STATE(445),
    [aux_sym__inline_repeat1] = STATE(287),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [sym__whitespace1] = ACTIONS(2136),
    [sym_quotation_marks] = ACTIONS(2138),
    [sym_ellipsis] = ACTIONS(2138),
    [sym_em_dash] = ACTIONS(2138),
    [sym_en_dash] = ACTIONS(2140),
    [sym_backslash_escape] = ACTIONS(2140),
    [anon_sym_LT] = ACTIONS(2142),
    [sym_symbol] = ACTIONS(2138),
    [anon_sym_LBRACE_] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_LBRACE_STAR] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_LBRACE_CARET] = ACTIONS(2152),
    [anon_sym_CARET] = ACTIONS(2152),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACE_EQ] = ACTIONS(2156),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2158),
    [anon_sym_LBRACE_DASH] = ACTIONS(2160),
    [anon_sym_LBRACK_CARET] = ACTIONS(2162),
    [anon_sym_BANG_LBRACK] = ACTIONS(2164),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_TODO] = ACTIONS(2172),
    [anon_sym_WIP] = ACTIONS(2172),
    [anon_sym_NOTE] = ACTIONS(2174),
    [anon_sym_INFO] = ACTIONS(2174),
    [anon_sym_XXX] = ACTIONS(2174),
    [sym_fixme] = ACTIONS(2138),
    [aux_sym__text_token1] = ACTIONS(2176),
    [sym__newline_inline] = ACTIONS(2178),
    [sym_hard_line_break] = ACTIONS(2138),
    [sym__verbatim_begin] = ACTIONS(2180),
  },
  [249] = {
    [sym__inline] = STATE(2097),
    [sym__inline_element] = STATE(1017),
    [sym__smart_punctuation] = STATE(468),
    [sym_autolink] = STATE(468),
    [sym_emphasis] = STATE(469),
    [sym_emphasis_begin] = STATE(2511),
    [sym_strong] = STATE(469),
    [sym_strong_begin] = STATE(2512),
    [sym_superscript] = STATE(469),
    [sym_superscript_begin] = STATE(2513),
    [sym_subscript] = STATE(469),
    [sym_subscript_begin] = STATE(2514),
    [sym_highlighted] = STATE(469),
    [sym_highlighted_begin] = STATE(2515),
    [sym_insert] = STATE(469),
    [sym_insert_begin] = STATE(2516),
    [sym_delete] = STATE(469),
    [sym_delete_begin] = STATE(2517),
    [sym_footnote_reference] = STATE(469),
    [sym_footnote_marker_begin] = STATE(2518),
    [sym__image] = STATE(469),
    [sym_full_reference_image] = STATE(469),
    [sym_collapsed_reference_image] = STATE(469),
    [sym_inline_image] = STATE(469),
    [sym_image_description] = STATE(1325),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(469),
    [sym_full_reference_link] = STATE(469),
    [sym_collapsed_reference_link] = STATE(469),
    [sym_inline_link] = STATE(469),
    [sym_link_text] = STATE(1326),
    [sym_span] = STATE(1017),
    [sym__bracketed_text_begin] = STATE(2613),
    [sym_inline_comment] = STATE(468),
    [sym_raw_inline] = STATE(468),
    [sym_math] = STATE(468),
    [sym_verbatim] = STATE(468),
    [sym__todo_highlights] = STATE(468),
    [sym_todo] = STATE(468),
    [sym_note] = STATE(468),
    [sym__symbol_fallback] = STATE(468),
    [aux_sym__text] = STATE(446),
    [aux_sym__inline_repeat1] = STATE(146),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [sym__whitespace1] = ACTIONS(1340),
    [sym_quotation_marks] = ACTIONS(1342),
    [sym_ellipsis] = ACTIONS(1342),
    [sym_em_dash] = ACTIONS(1342),
    [sym_en_dash] = ACTIONS(1344),
    [sym_backslash_escape] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [sym_symbol] = ACTIONS(1342),
    [anon_sym_LBRACE_] = ACTIONS(1348),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_LBRACE_STAR] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_LBRACE_CARET] = ACTIONS(1356),
    [anon_sym_CARET] = ACTIONS(1356),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_LBRACE_EQ] = ACTIONS(1360),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1362),
    [anon_sym_LBRACE_DASH] = ACTIONS(1364),
    [anon_sym_LBRACK_CARET] = ACTIONS(1366),
    [anon_sym_BANG_LBRACK] = ACTIONS(1368),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1374),
    [anon_sym_TODO] = ACTIONS(1376),
    [anon_sym_WIP] = ACTIONS(1376),
    [anon_sym_NOTE] = ACTIONS(1378),
    [anon_sym_INFO] = ACTIONS(1378),
    [anon_sym_XXX] = ACTIONS(1378),
    [sym_fixme] = ACTIONS(1342),
    [aux_sym__text_token1] = ACTIONS(1380),
    [sym__newline_inline] = ACTIONS(2182),
    [sym_hard_line_break] = ACTIONS(1342),
    [sym__verbatim_begin] = ACTIONS(1384),
  },
  [250] = {
    [sym__inline] = STATE(2098),
    [sym__inline_element] = STATE(915),
    [sym__smart_punctuation] = STATE(470),
    [sym_autolink] = STATE(470),
    [sym_emphasis] = STATE(471),
    [sym_emphasis_begin] = STATE(2522),
    [sym_strong] = STATE(471),
    [sym_strong_begin] = STATE(2523),
    [sym_superscript] = STATE(471),
    [sym_superscript_begin] = STATE(2524),
    [sym_subscript] = STATE(471),
    [sym_subscript_begin] = STATE(2525),
    [sym_highlighted] = STATE(471),
    [sym_highlighted_begin] = STATE(2526),
    [sym_insert] = STATE(471),
    [sym_insert_begin] = STATE(2527),
    [sym_delete] = STATE(471),
    [sym_delete_begin] = STATE(2528),
    [sym_footnote_reference] = STATE(471),
    [sym_footnote_marker_begin] = STATE(2529),
    [sym__image] = STATE(471),
    [sym_full_reference_image] = STATE(471),
    [sym_collapsed_reference_image] = STATE(471),
    [sym_inline_image] = STATE(471),
    [sym_image_description] = STATE(1332),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(471),
    [sym_full_reference_link] = STATE(471),
    [sym_collapsed_reference_link] = STATE(471),
    [sym_inline_link] = STATE(471),
    [sym_link_text] = STATE(1334),
    [sym_span] = STATE(915),
    [sym__bracketed_text_begin] = STATE(2614),
    [sym_inline_comment] = STATE(470),
    [sym_raw_inline] = STATE(470),
    [sym_math] = STATE(470),
    [sym_verbatim] = STATE(470),
    [sym__todo_highlights] = STATE(470),
    [sym_todo] = STATE(470),
    [sym_note] = STATE(470),
    [sym__symbol_fallback] = STATE(470),
    [aux_sym__text] = STATE(447),
    [aux_sym__inline_repeat1] = STATE(148),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [sym__whitespace1] = ACTIONS(1460),
    [sym_quotation_marks] = ACTIONS(1462),
    [sym_ellipsis] = ACTIONS(1462),
    [sym_em_dash] = ACTIONS(1462),
    [sym_en_dash] = ACTIONS(1464),
    [sym_backslash_escape] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [sym_symbol] = ACTIONS(1462),
    [anon_sym_LBRACE_] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(1470),
    [anon_sym_LBRACE_STAR] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACE_CARET] = ACTIONS(1476),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_LBRACE_EQ] = ACTIONS(1480),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1482),
    [anon_sym_LBRACE_DASH] = ACTIONS(1484),
    [anon_sym_LBRACK_CARET] = ACTIONS(1486),
    [anon_sym_BANG_LBRACK] = ACTIONS(1488),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_TODO] = ACTIONS(1496),
    [anon_sym_WIP] = ACTIONS(1496),
    [anon_sym_NOTE] = ACTIONS(1498),
    [anon_sym_INFO] = ACTIONS(1498),
    [anon_sym_XXX] = ACTIONS(1498),
    [sym_fixme] = ACTIONS(1462),
    [aux_sym__text_token1] = ACTIONS(1500),
    [sym__newline_inline] = ACTIONS(2184),
    [sym_hard_line_break] = ACTIONS(1462),
    [sym__verbatim_begin] = ACTIONS(1504),
  },
  [251] = {
    [sym__inline] = STATE(2099),
    [sym__inline_element] = STATE(1021),
    [sym__smart_punctuation] = STATE(473),
    [sym_autolink] = STATE(473),
    [sym_emphasis] = STATE(450),
    [sym_emphasis_begin] = STATE(2533),
    [sym_strong] = STATE(450),
    [sym_strong_begin] = STATE(2534),
    [sym_superscript] = STATE(450),
    [sym_superscript_begin] = STATE(2535),
    [sym_subscript] = STATE(450),
    [sym_subscript_begin] = STATE(2536),
    [sym_highlighted] = STATE(450),
    [sym_highlighted_begin] = STATE(2537),
    [sym_insert] = STATE(450),
    [sym_insert_begin] = STATE(2538),
    [sym_delete] = STATE(450),
    [sym_delete_begin] = STATE(2539),
    [sym_footnote_reference] = STATE(450),
    [sym_footnote_marker_begin] = STATE(2540),
    [sym__image] = STATE(450),
    [sym_full_reference_image] = STATE(450),
    [sym_collapsed_reference_image] = STATE(450),
    [sym_inline_image] = STATE(450),
    [sym_image_description] = STATE(1340),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(450),
    [sym_full_reference_link] = STATE(450),
    [sym_collapsed_reference_link] = STATE(450),
    [sym_inline_link] = STATE(450),
    [sym_link_text] = STATE(1341),
    [sym_span] = STATE(1021),
    [sym__bracketed_text_begin] = STATE(2615),
    [sym_inline_comment] = STATE(473),
    [sym_raw_inline] = STATE(473),
    [sym_math] = STATE(473),
    [sym_verbatim] = STATE(473),
    [sym__todo_highlights] = STATE(473),
    [sym_todo] = STATE(473),
    [sym_note] = STATE(473),
    [sym__symbol_fallback] = STATE(473),
    [aux_sym__text] = STATE(448),
    [aux_sym__inline_repeat1] = STATE(150),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [sym__whitespace1] = ACTIONS(1580),
    [sym_quotation_marks] = ACTIONS(1582),
    [sym_ellipsis] = ACTIONS(1582),
    [sym_em_dash] = ACTIONS(1582),
    [sym_en_dash] = ACTIONS(1584),
    [sym_backslash_escape] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1586),
    [sym_symbol] = ACTIONS(1582),
    [anon_sym_LBRACE_] = ACTIONS(1588),
    [anon_sym__] = ACTIONS(1590),
    [anon_sym_LBRACE_STAR] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_LBRACE_CARET] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_LBRACE_EQ] = ACTIONS(1600),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1602),
    [anon_sym_LBRACE_DASH] = ACTIONS(1604),
    [anon_sym_LBRACK_CARET] = ACTIONS(1606),
    [anon_sym_BANG_LBRACK] = ACTIONS(1608),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_DOLLAR] = ACTIONS(1614),
    [anon_sym_TODO] = ACTIONS(1616),
    [anon_sym_WIP] = ACTIONS(1616),
    [anon_sym_NOTE] = ACTIONS(1618),
    [anon_sym_INFO] = ACTIONS(1618),
    [anon_sym_XXX] = ACTIONS(1618),
    [sym_fixme] = ACTIONS(1582),
    [aux_sym__text_token1] = ACTIONS(1620),
    [sym__newline_inline] = ACTIONS(2186),
    [sym_hard_line_break] = ACTIONS(1582),
    [sym__verbatim_begin] = ACTIONS(1624),
  },
  [252] = {
    [sym__inline] = STATE(2101),
    [sym__inline_element] = STATE(900),
    [sym__smart_punctuation] = STATE(454),
    [sym_autolink] = STATE(454),
    [sym_emphasis] = STATE(455),
    [sym_emphasis_begin] = STATE(2555),
    [sym_strong] = STATE(455),
    [sym_strong_begin] = STATE(2556),
    [sym_superscript] = STATE(455),
    [sym_superscript_begin] = STATE(2557),
    [sym_subscript] = STATE(455),
    [sym_subscript_begin] = STATE(2558),
    [sym_highlighted] = STATE(455),
    [sym_highlighted_begin] = STATE(2559),
    [sym_insert] = STATE(455),
    [sym_insert_begin] = STATE(2560),
    [sym_delete] = STATE(455),
    [sym_delete_begin] = STATE(2561),
    [sym_footnote_reference] = STATE(455),
    [sym_footnote_marker_begin] = STATE(2562),
    [sym__image] = STATE(455),
    [sym_full_reference_image] = STATE(455),
    [sym_collapsed_reference_image] = STATE(455),
    [sym_inline_image] = STATE(455),
    [sym_image_description] = STATE(1257),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(455),
    [sym_full_reference_link] = STATE(455),
    [sym_collapsed_reference_link] = STATE(455),
    [sym_inline_link] = STATE(455),
    [sym_link_text] = STATE(1258),
    [sym_span] = STATE(900),
    [sym__bracketed_text_begin] = STATE(2617),
    [sym_inline_comment] = STATE(454),
    [sym_raw_inline] = STATE(454),
    [sym_math] = STATE(454),
    [sym_verbatim] = STATE(454),
    [sym__todo_highlights] = STATE(454),
    [sym_todo] = STATE(454),
    [sym_note] = STATE(454),
    [sym__symbol_fallback] = STATE(454),
    [aux_sym__text] = STATE(441),
    [aux_sym__inline_repeat1] = STATE(155),
    [anon_sym_LBRACK] = ACTIONS(1820),
    [sym__whitespace1] = ACTIONS(1822),
    [sym_quotation_marks] = ACTIONS(1824),
    [sym_ellipsis] = ACTIONS(1824),
    [sym_em_dash] = ACTIONS(1824),
    [sym_en_dash] = ACTIONS(1826),
    [sym_backslash_escape] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1828),
    [sym_symbol] = ACTIONS(1824),
    [anon_sym_LBRACE_] = ACTIONS(1830),
    [anon_sym__] = ACTIONS(1832),
    [anon_sym_LBRACE_STAR] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_LBRACE_CARET] = ACTIONS(1838),
    [anon_sym_CARET] = ACTIONS(1838),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1840),
    [anon_sym_TILDE] = ACTIONS(1840),
    [anon_sym_LBRACE_EQ] = ACTIONS(1842),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1844),
    [anon_sym_LBRACE_DASH] = ACTIONS(1846),
    [anon_sym_LBRACK_CARET] = ACTIONS(1848),
    [anon_sym_BANG_LBRACK] = ACTIONS(1850),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1856),
    [anon_sym_TODO] = ACTIONS(1858),
    [anon_sym_WIP] = ACTIONS(1858),
    [anon_sym_NOTE] = ACTIONS(1860),
    [anon_sym_INFO] = ACTIONS(1860),
    [anon_sym_XXX] = ACTIONS(1860),
    [sym_fixme] = ACTIONS(1824),
    [aux_sym__text_token1] = ACTIONS(1862),
    [sym__newline_inline] = ACTIONS(2188),
    [sym_hard_line_break] = ACTIONS(1824),
    [sym__verbatim_begin] = ACTIONS(1866),
  },
  [253] = {
    [sym__inline] = STATE(2103),
    [sym__inline_element] = STATE(1014),
    [sym__smart_punctuation] = STATE(456),
    [sym_autolink] = STATE(456),
    [sym_emphasis] = STATE(457),
    [sym_emphasis_begin] = STATE(2566),
    [sym_strong] = STATE(457),
    [sym_strong_begin] = STATE(2567),
    [sym_superscript] = STATE(457),
    [sym_superscript_begin] = STATE(2568),
    [sym_subscript] = STATE(457),
    [sym_subscript_begin] = STATE(2569),
    [sym_highlighted] = STATE(457),
    [sym_highlighted_begin] = STATE(2570),
    [sym_insert] = STATE(457),
    [sym_insert_begin] = STATE(2571),
    [sym_delete] = STATE(457),
    [sym_delete_begin] = STATE(1976),
    [sym_footnote_reference] = STATE(457),
    [sym_footnote_marker_begin] = STATE(2573),
    [sym__image] = STATE(457),
    [sym_full_reference_image] = STATE(457),
    [sym_collapsed_reference_image] = STATE(457),
    [sym_inline_image] = STATE(457),
    [sym_image_description] = STATE(1264),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(457),
    [sym_full_reference_link] = STATE(457),
    [sym_collapsed_reference_link] = STATE(457),
    [sym_inline_link] = STATE(457),
    [sym_link_text] = STATE(1265),
    [sym_span] = STATE(1014),
    [sym__bracketed_text_begin] = STATE(2618),
    [sym_inline_comment] = STATE(456),
    [sym_raw_inline] = STATE(456),
    [sym_math] = STATE(456),
    [sym_verbatim] = STATE(456),
    [sym__todo_highlights] = STATE(456),
    [sym_todo] = STATE(456),
    [sym_note] = STATE(456),
    [sym__symbol_fallback] = STATE(456),
    [aux_sym__text] = STATE(440),
    [aux_sym__inline_repeat1] = STATE(157),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [sym__whitespace1] = ACTIONS(1942),
    [sym_quotation_marks] = ACTIONS(1944),
    [sym_ellipsis] = ACTIONS(1944),
    [sym_em_dash] = ACTIONS(1944),
    [sym_en_dash] = ACTIONS(1946),
    [sym_backslash_escape] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1948),
    [sym_symbol] = ACTIONS(1944),
    [anon_sym_LBRACE_] = ACTIONS(1950),
    [anon_sym__] = ACTIONS(1952),
    [anon_sym_LBRACE_STAR] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_LBRACE_CARET] = ACTIONS(1958),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_LBRACE_EQ] = ACTIONS(1962),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1964),
    [anon_sym_LBRACE_DASH] = ACTIONS(1966),
    [anon_sym_LBRACK_CARET] = ACTIONS(1968),
    [anon_sym_BANG_LBRACK] = ACTIONS(1970),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1974),
    [anon_sym_DOLLAR] = ACTIONS(1976),
    [anon_sym_TODO] = ACTIONS(1978),
    [anon_sym_WIP] = ACTIONS(1978),
    [anon_sym_NOTE] = ACTIONS(1980),
    [anon_sym_INFO] = ACTIONS(1980),
    [anon_sym_XXX] = ACTIONS(1980),
    [sym_fixme] = ACTIONS(1944),
    [aux_sym__text_token1] = ACTIONS(1982),
    [sym__newline_inline] = ACTIONS(2190),
    [sym_hard_line_break] = ACTIONS(1944),
    [sym__verbatim_begin] = ACTIONS(1986),
  },
  [254] = {
    [sym__inline_without_trailing_space] = STATE(2130),
    [sym__inline_element] = STATE(988),
    [sym__smart_punctuation] = STATE(460),
    [sym_autolink] = STATE(460),
    [sym_emphasis] = STATE(463),
    [sym_emphasis_begin] = STATE(2484),
    [sym_strong] = STATE(463),
    [sym_strong_begin] = STATE(2485),
    [sym_superscript] = STATE(463),
    [sym_superscript_begin] = STATE(2486),
    [sym_subscript] = STATE(463),
    [sym_subscript_begin] = STATE(2487),
    [sym_highlighted] = STATE(463),
    [sym_highlighted_begin] = STATE(2488),
    [sym_insert] = STATE(463),
    [sym_insert_begin] = STATE(2489),
    [sym_delete] = STATE(463),
    [sym_delete_begin] = STATE(2490),
    [sym_footnote_reference] = STATE(463),
    [sym_footnote_marker_begin] = STATE(2491),
    [sym__image] = STATE(463),
    [sym_full_reference_image] = STATE(463),
    [sym_collapsed_reference_image] = STATE(463),
    [sym_inline_image] = STATE(463),
    [sym_image_description] = STATE(1268),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(463),
    [sym_full_reference_link] = STATE(463),
    [sym_collapsed_reference_link] = STATE(463),
    [sym_inline_link] = STATE(463),
    [sym_link_text] = STATE(1273),
    [sym_span] = STATE(988),
    [sym__bracketed_text_begin] = STATE(2607),
    [sym_inline_comment] = STATE(460),
    [sym_raw_inline] = STATE(460),
    [sym_math] = STATE(460),
    [sym_verbatim] = STATE(460),
    [sym__todo_highlights] = STATE(460),
    [sym_todo] = STATE(460),
    [sym_note] = STATE(460),
    [sym__symbol_fallback] = STATE(460),
    [aux_sym__text] = STATE(444),
    [aux_sym__inline_repeat1] = STATE(286),
    [anon_sym_LBRACK] = ACTIONS(1772),
    [sym__whitespace1] = ACTIONS(1774),
    [sym_quotation_marks] = ACTIONS(1776),
    [sym_ellipsis] = ACTIONS(1776),
    [sym_em_dash] = ACTIONS(1776),
    [sym_en_dash] = ACTIONS(1778),
    [sym_backslash_escape] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1780),
    [sym_symbol] = ACTIONS(1776),
    [anon_sym_LBRACE_] = ACTIONS(1782),
    [anon_sym__] = ACTIONS(1784),
    [anon_sym_LBRACE_STAR] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_LBRACE_CARET] = ACTIONS(1790),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1792),
    [anon_sym_LBRACE_EQ] = ACTIONS(1794),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1796),
    [anon_sym_LBRACE_DASH] = ACTIONS(1798),
    [anon_sym_LBRACK_CARET] = ACTIONS(1800),
    [anon_sym_BANG_LBRACK] = ACTIONS(1802),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1804),
    [anon_sym_LPAREN] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [anon_sym_TODO] = ACTIONS(1810),
    [anon_sym_WIP] = ACTIONS(1810),
    [anon_sym_NOTE] = ACTIONS(1812),
    [anon_sym_INFO] = ACTIONS(1812),
    [anon_sym_XXX] = ACTIONS(1812),
    [sym_fixme] = ACTIONS(1776),
    [aux_sym__text_token1] = ACTIONS(1814),
    [sym__newline_inline] = ACTIONS(1816),
    [sym_hard_line_break] = ACTIONS(1776),
    [sym__verbatim_begin] = ACTIONS(1818),
  },
  [255] = {
    [sym__inline_without_trailing_space] = STATE(2131),
    [sym__inline_element] = STATE(959),
    [sym__smart_punctuation] = STATE(464),
    [sym_autolink] = STATE(464),
    [sym_emphasis] = STATE(465),
    [sym_emphasis_begin] = STATE(2498),
    [sym_strong] = STATE(465),
    [sym_strong_begin] = STATE(2499),
    [sym_superscript] = STATE(465),
    [sym_superscript_begin] = STATE(2500),
    [sym_subscript] = STATE(465),
    [sym_subscript_begin] = STATE(2501),
    [sym_highlighted] = STATE(465),
    [sym_highlighted_begin] = STATE(2502),
    [sym_insert] = STATE(465),
    [sym_insert_begin] = STATE(2503),
    [sym_delete] = STATE(465),
    [sym_delete_begin] = STATE(2504),
    [sym_footnote_reference] = STATE(465),
    [sym_footnote_marker_begin] = STATE(2505),
    [sym__image] = STATE(465),
    [sym_full_reference_image] = STATE(465),
    [sym_collapsed_reference_image] = STATE(465),
    [sym_inline_image] = STATE(465),
    [sym_image_description] = STATE(1314),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(465),
    [sym_full_reference_link] = STATE(465),
    [sym_collapsed_reference_link] = STATE(465),
    [sym_inline_link] = STATE(465),
    [sym_link_text] = STATE(1319),
    [sym_span] = STATE(959),
    [sym__bracketed_text_begin] = STATE(2610),
    [sym_inline_comment] = STATE(464),
    [sym_raw_inline] = STATE(464),
    [sym_math] = STATE(464),
    [sym_verbatim] = STATE(464),
    [sym__todo_highlights] = STATE(464),
    [sym_todo] = STATE(464),
    [sym_note] = STATE(464),
    [sym__symbol_fallback] = STATE(464),
    [aux_sym__text] = STATE(445),
    [aux_sym__inline_repeat1] = STATE(287),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [sym__whitespace1] = ACTIONS(2136),
    [sym_quotation_marks] = ACTIONS(2138),
    [sym_ellipsis] = ACTIONS(2138),
    [sym_em_dash] = ACTIONS(2138),
    [sym_en_dash] = ACTIONS(2140),
    [sym_backslash_escape] = ACTIONS(2140),
    [anon_sym_LT] = ACTIONS(2142),
    [sym_symbol] = ACTIONS(2138),
    [anon_sym_LBRACE_] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_LBRACE_STAR] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_LBRACE_CARET] = ACTIONS(2152),
    [anon_sym_CARET] = ACTIONS(2152),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACE_EQ] = ACTIONS(2156),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2158),
    [anon_sym_LBRACE_DASH] = ACTIONS(2160),
    [anon_sym_LBRACK_CARET] = ACTIONS(2162),
    [anon_sym_BANG_LBRACK] = ACTIONS(2164),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_TODO] = ACTIONS(2172),
    [anon_sym_WIP] = ACTIONS(2172),
    [anon_sym_NOTE] = ACTIONS(2174),
    [anon_sym_INFO] = ACTIONS(2174),
    [anon_sym_XXX] = ACTIONS(2174),
    [sym_fixme] = ACTIONS(2138),
    [aux_sym__text_token1] = ACTIONS(2176),
    [sym__newline_inline] = ACTIONS(2178),
    [sym_hard_line_break] = ACTIONS(2138),
    [sym__verbatim_begin] = ACTIONS(2180),
  },
  [256] = {
    [sym__inline] = STATE(2132),
    [sym__inline_element] = STATE(1017),
    [sym__smart_punctuation] = STATE(468),
    [sym_autolink] = STATE(468),
    [sym_emphasis] = STATE(469),
    [sym_emphasis_begin] = STATE(2511),
    [sym_strong] = STATE(469),
    [sym_strong_begin] = STATE(2512),
    [sym_superscript] = STATE(469),
    [sym_superscript_begin] = STATE(2513),
    [sym_subscript] = STATE(469),
    [sym_subscript_begin] = STATE(2514),
    [sym_highlighted] = STATE(469),
    [sym_highlighted_begin] = STATE(2515),
    [sym_insert] = STATE(469),
    [sym_insert_begin] = STATE(2516),
    [sym_delete] = STATE(469),
    [sym_delete_begin] = STATE(2517),
    [sym_footnote_reference] = STATE(469),
    [sym_footnote_marker_begin] = STATE(2518),
    [sym__image] = STATE(469),
    [sym_full_reference_image] = STATE(469),
    [sym_collapsed_reference_image] = STATE(469),
    [sym_inline_image] = STATE(469),
    [sym_image_description] = STATE(1325),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(469),
    [sym_full_reference_link] = STATE(469),
    [sym_collapsed_reference_link] = STATE(469),
    [sym_inline_link] = STATE(469),
    [sym_link_text] = STATE(1326),
    [sym_span] = STATE(1017),
    [sym__bracketed_text_begin] = STATE(2613),
    [sym_inline_comment] = STATE(468),
    [sym_raw_inline] = STATE(468),
    [sym_math] = STATE(468),
    [sym_verbatim] = STATE(468),
    [sym__todo_highlights] = STATE(468),
    [sym_todo] = STATE(468),
    [sym_note] = STATE(468),
    [sym__symbol_fallback] = STATE(468),
    [aux_sym__text] = STATE(446),
    [aux_sym__inline_repeat1] = STATE(146),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [sym__whitespace1] = ACTIONS(1340),
    [sym_quotation_marks] = ACTIONS(1342),
    [sym_ellipsis] = ACTIONS(1342),
    [sym_em_dash] = ACTIONS(1342),
    [sym_en_dash] = ACTIONS(1344),
    [sym_backslash_escape] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [sym_symbol] = ACTIONS(1342),
    [anon_sym_LBRACE_] = ACTIONS(1348),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_LBRACE_STAR] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_LBRACE_CARET] = ACTIONS(1356),
    [anon_sym_CARET] = ACTIONS(1356),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_LBRACE_EQ] = ACTIONS(1360),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1362),
    [anon_sym_LBRACE_DASH] = ACTIONS(1364),
    [anon_sym_LBRACK_CARET] = ACTIONS(1366),
    [anon_sym_BANG_LBRACK] = ACTIONS(1368),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1374),
    [anon_sym_TODO] = ACTIONS(1376),
    [anon_sym_WIP] = ACTIONS(1376),
    [anon_sym_NOTE] = ACTIONS(1378),
    [anon_sym_INFO] = ACTIONS(1378),
    [anon_sym_XXX] = ACTIONS(1378),
    [sym_fixme] = ACTIONS(1342),
    [aux_sym__text_token1] = ACTIONS(1380),
    [sym__newline_inline] = ACTIONS(2182),
    [sym_hard_line_break] = ACTIONS(1342),
    [sym__verbatim_begin] = ACTIONS(1384),
  },
  [257] = {
    [sym__inline] = STATE(2133),
    [sym__inline_element] = STATE(915),
    [sym__smart_punctuation] = STATE(470),
    [sym_autolink] = STATE(470),
    [sym_emphasis] = STATE(471),
    [sym_emphasis_begin] = STATE(2522),
    [sym_strong] = STATE(471),
    [sym_strong_begin] = STATE(2523),
    [sym_superscript] = STATE(471),
    [sym_superscript_begin] = STATE(2524),
    [sym_subscript] = STATE(471),
    [sym_subscript_begin] = STATE(2525),
    [sym_highlighted] = STATE(471),
    [sym_highlighted_begin] = STATE(2526),
    [sym_insert] = STATE(471),
    [sym_insert_begin] = STATE(2527),
    [sym_delete] = STATE(471),
    [sym_delete_begin] = STATE(2528),
    [sym_footnote_reference] = STATE(471),
    [sym_footnote_marker_begin] = STATE(2529),
    [sym__image] = STATE(471),
    [sym_full_reference_image] = STATE(471),
    [sym_collapsed_reference_image] = STATE(471),
    [sym_inline_image] = STATE(471),
    [sym_image_description] = STATE(1332),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(471),
    [sym_full_reference_link] = STATE(471),
    [sym_collapsed_reference_link] = STATE(471),
    [sym_inline_link] = STATE(471),
    [sym_link_text] = STATE(1334),
    [sym_span] = STATE(915),
    [sym__bracketed_text_begin] = STATE(2614),
    [sym_inline_comment] = STATE(470),
    [sym_raw_inline] = STATE(470),
    [sym_math] = STATE(470),
    [sym_verbatim] = STATE(470),
    [sym__todo_highlights] = STATE(470),
    [sym_todo] = STATE(470),
    [sym_note] = STATE(470),
    [sym__symbol_fallback] = STATE(470),
    [aux_sym__text] = STATE(447),
    [aux_sym__inline_repeat1] = STATE(148),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [sym__whitespace1] = ACTIONS(1460),
    [sym_quotation_marks] = ACTIONS(1462),
    [sym_ellipsis] = ACTIONS(1462),
    [sym_em_dash] = ACTIONS(1462),
    [sym_en_dash] = ACTIONS(1464),
    [sym_backslash_escape] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [sym_symbol] = ACTIONS(1462),
    [anon_sym_LBRACE_] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(1470),
    [anon_sym_LBRACE_STAR] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACE_CARET] = ACTIONS(1476),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_LBRACE_EQ] = ACTIONS(1480),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1482),
    [anon_sym_LBRACE_DASH] = ACTIONS(1484),
    [anon_sym_LBRACK_CARET] = ACTIONS(1486),
    [anon_sym_BANG_LBRACK] = ACTIONS(1488),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_TODO] = ACTIONS(1496),
    [anon_sym_WIP] = ACTIONS(1496),
    [anon_sym_NOTE] = ACTIONS(1498),
    [anon_sym_INFO] = ACTIONS(1498),
    [anon_sym_XXX] = ACTIONS(1498),
    [sym_fixme] = ACTIONS(1462),
    [aux_sym__text_token1] = ACTIONS(1500),
    [sym__newline_inline] = ACTIONS(2184),
    [sym_hard_line_break] = ACTIONS(1462),
    [sym__verbatim_begin] = ACTIONS(1504),
  },
  [258] = {
    [sym__inline] = STATE(2134),
    [sym__inline_element] = STATE(1021),
    [sym__smart_punctuation] = STATE(473),
    [sym_autolink] = STATE(473),
    [sym_emphasis] = STATE(450),
    [sym_emphasis_begin] = STATE(2533),
    [sym_strong] = STATE(450),
    [sym_strong_begin] = STATE(2534),
    [sym_superscript] = STATE(450),
    [sym_superscript_begin] = STATE(2535),
    [sym_subscript] = STATE(450),
    [sym_subscript_begin] = STATE(2536),
    [sym_highlighted] = STATE(450),
    [sym_highlighted_begin] = STATE(2537),
    [sym_insert] = STATE(450),
    [sym_insert_begin] = STATE(2538),
    [sym_delete] = STATE(450),
    [sym_delete_begin] = STATE(2539),
    [sym_footnote_reference] = STATE(450),
    [sym_footnote_marker_begin] = STATE(2540),
    [sym__image] = STATE(450),
    [sym_full_reference_image] = STATE(450),
    [sym_collapsed_reference_image] = STATE(450),
    [sym_inline_image] = STATE(450),
    [sym_image_description] = STATE(1340),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(450),
    [sym_full_reference_link] = STATE(450),
    [sym_collapsed_reference_link] = STATE(450),
    [sym_inline_link] = STATE(450),
    [sym_link_text] = STATE(1341),
    [sym_span] = STATE(1021),
    [sym__bracketed_text_begin] = STATE(2615),
    [sym_inline_comment] = STATE(473),
    [sym_raw_inline] = STATE(473),
    [sym_math] = STATE(473),
    [sym_verbatim] = STATE(473),
    [sym__todo_highlights] = STATE(473),
    [sym_todo] = STATE(473),
    [sym_note] = STATE(473),
    [sym__symbol_fallback] = STATE(473),
    [aux_sym__text] = STATE(448),
    [aux_sym__inline_repeat1] = STATE(150),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [sym__whitespace1] = ACTIONS(1580),
    [sym_quotation_marks] = ACTIONS(1582),
    [sym_ellipsis] = ACTIONS(1582),
    [sym_em_dash] = ACTIONS(1582),
    [sym_en_dash] = ACTIONS(1584),
    [sym_backslash_escape] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1586),
    [sym_symbol] = ACTIONS(1582),
    [anon_sym_LBRACE_] = ACTIONS(1588),
    [anon_sym__] = ACTIONS(1590),
    [anon_sym_LBRACE_STAR] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_LBRACE_CARET] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_LBRACE_EQ] = ACTIONS(1600),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1602),
    [anon_sym_LBRACE_DASH] = ACTIONS(1604),
    [anon_sym_LBRACK_CARET] = ACTIONS(1606),
    [anon_sym_BANG_LBRACK] = ACTIONS(1608),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_DOLLAR] = ACTIONS(1614),
    [anon_sym_TODO] = ACTIONS(1616),
    [anon_sym_WIP] = ACTIONS(1616),
    [anon_sym_NOTE] = ACTIONS(1618),
    [anon_sym_INFO] = ACTIONS(1618),
    [anon_sym_XXX] = ACTIONS(1618),
    [sym_fixme] = ACTIONS(1582),
    [aux_sym__text_token1] = ACTIONS(1620),
    [sym__newline_inline] = ACTIONS(2186),
    [sym_hard_line_break] = ACTIONS(1582),
    [sym__verbatim_begin] = ACTIONS(1624),
  },
  [259] = {
    [sym__inline] = STATE(2135),
    [sym__inline_element] = STATE(997),
    [sym__smart_punctuation] = STATE(451),
    [sym_autolink] = STATE(451),
    [sym_emphasis] = STATE(449),
    [sym_emphasis_begin] = STATE(2544),
    [sym_strong] = STATE(449),
    [sym_strong_begin] = STATE(2545),
    [sym_superscript] = STATE(449),
    [sym_superscript_begin] = STATE(2546),
    [sym_subscript] = STATE(449),
    [sym_subscript_begin] = STATE(2547),
    [sym_highlighted] = STATE(449),
    [sym_highlighted_begin] = STATE(2548),
    [sym_insert] = STATE(449),
    [sym_insert_begin] = STATE(2549),
    [sym_delete] = STATE(449),
    [sym_delete_begin] = STATE(2550),
    [sym_footnote_reference] = STATE(449),
    [sym_footnote_marker_begin] = STATE(2551),
    [sym__image] = STATE(449),
    [sym_full_reference_image] = STATE(449),
    [sym_collapsed_reference_image] = STATE(449),
    [sym_inline_image] = STATE(449),
    [sym_image_description] = STATE(1250),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(449),
    [sym_full_reference_link] = STATE(449),
    [sym_collapsed_reference_link] = STATE(449),
    [sym_inline_link] = STATE(449),
    [sym_link_text] = STATE(1251),
    [sym_span] = STATE(997),
    [sym__bracketed_text_begin] = STATE(2616),
    [sym_inline_comment] = STATE(451),
    [sym_raw_inline] = STATE(451),
    [sym_math] = STATE(451),
    [sym_verbatim] = STATE(451),
    [sym__todo_highlights] = STATE(451),
    [sym_todo] = STATE(451),
    [sym_note] = STATE(451),
    [sym__symbol_fallback] = STATE(451),
    [aux_sym__text] = STATE(439),
    [aux_sym__inline_repeat1] = STATE(152),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [sym__whitespace1] = ACTIONS(1074),
    [sym_quotation_marks] = ACTIONS(1076),
    [sym_ellipsis] = ACTIONS(1076),
    [sym_em_dash] = ACTIONS(1076),
    [sym_en_dash] = ACTIONS(1078),
    [sym_backslash_escape] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(1080),
    [sym_symbol] = ACTIONS(1076),
    [anon_sym_LBRACE_] = ACTIONS(1082),
    [anon_sym__] = ACTIONS(1084),
    [anon_sym_LBRACE_STAR] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_LBRACE_CARET] = ACTIONS(1090),
    [anon_sym_CARET] = ACTIONS(1090),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_LBRACE_EQ] = ACTIONS(1094),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1096),
    [anon_sym_LBRACE_DASH] = ACTIONS(1098),
    [anon_sym_LBRACK_CARET] = ACTIONS(1100),
    [anon_sym_BANG_LBRACK] = ACTIONS(1102),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [anon_sym_TODO] = ACTIONS(1110),
    [anon_sym_WIP] = ACTIONS(1110),
    [anon_sym_NOTE] = ACTIONS(1112),
    [anon_sym_INFO] = ACTIONS(1112),
    [anon_sym_XXX] = ACTIONS(1112),
    [sym_fixme] = ACTIONS(1076),
    [aux_sym__text_token1] = ACTIONS(1114),
    [sym__newline_inline] = ACTIONS(1116),
    [sym_hard_line_break] = ACTIONS(1076),
    [sym__verbatim_begin] = ACTIONS(1118),
  },
  [260] = {
    [sym__inline] = STATE(2136),
    [sym__inline_element] = STATE(900),
    [sym__smart_punctuation] = STATE(454),
    [sym_autolink] = STATE(454),
    [sym_emphasis] = STATE(455),
    [sym_emphasis_begin] = STATE(2555),
    [sym_strong] = STATE(455),
    [sym_strong_begin] = STATE(2556),
    [sym_superscript] = STATE(455),
    [sym_superscript_begin] = STATE(2557),
    [sym_subscript] = STATE(455),
    [sym_subscript_begin] = STATE(2558),
    [sym_highlighted] = STATE(455),
    [sym_highlighted_begin] = STATE(2559),
    [sym_insert] = STATE(455),
    [sym_insert_begin] = STATE(2560),
    [sym_delete] = STATE(455),
    [sym_delete_begin] = STATE(2561),
    [sym_footnote_reference] = STATE(455),
    [sym_footnote_marker_begin] = STATE(2562),
    [sym__image] = STATE(455),
    [sym_full_reference_image] = STATE(455),
    [sym_collapsed_reference_image] = STATE(455),
    [sym_inline_image] = STATE(455),
    [sym_image_description] = STATE(1257),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(455),
    [sym_full_reference_link] = STATE(455),
    [sym_collapsed_reference_link] = STATE(455),
    [sym_inline_link] = STATE(455),
    [sym_link_text] = STATE(1258),
    [sym_span] = STATE(900),
    [sym__bracketed_text_begin] = STATE(2617),
    [sym_inline_comment] = STATE(454),
    [sym_raw_inline] = STATE(454),
    [sym_math] = STATE(454),
    [sym_verbatim] = STATE(454),
    [sym__todo_highlights] = STATE(454),
    [sym_todo] = STATE(454),
    [sym_note] = STATE(454),
    [sym__symbol_fallback] = STATE(454),
    [aux_sym__text] = STATE(441),
    [aux_sym__inline_repeat1] = STATE(155),
    [anon_sym_LBRACK] = ACTIONS(1820),
    [sym__whitespace1] = ACTIONS(1822),
    [sym_quotation_marks] = ACTIONS(1824),
    [sym_ellipsis] = ACTIONS(1824),
    [sym_em_dash] = ACTIONS(1824),
    [sym_en_dash] = ACTIONS(1826),
    [sym_backslash_escape] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1828),
    [sym_symbol] = ACTIONS(1824),
    [anon_sym_LBRACE_] = ACTIONS(1830),
    [anon_sym__] = ACTIONS(1832),
    [anon_sym_LBRACE_STAR] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_LBRACE_CARET] = ACTIONS(1838),
    [anon_sym_CARET] = ACTIONS(1838),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1840),
    [anon_sym_TILDE] = ACTIONS(1840),
    [anon_sym_LBRACE_EQ] = ACTIONS(1842),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1844),
    [anon_sym_LBRACE_DASH] = ACTIONS(1846),
    [anon_sym_LBRACK_CARET] = ACTIONS(1848),
    [anon_sym_BANG_LBRACK] = ACTIONS(1850),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1856),
    [anon_sym_TODO] = ACTIONS(1858),
    [anon_sym_WIP] = ACTIONS(1858),
    [anon_sym_NOTE] = ACTIONS(1860),
    [anon_sym_INFO] = ACTIONS(1860),
    [anon_sym_XXX] = ACTIONS(1860),
    [sym_fixme] = ACTIONS(1824),
    [aux_sym__text_token1] = ACTIONS(1862),
    [sym__newline_inline] = ACTIONS(2188),
    [sym_hard_line_break] = ACTIONS(1824),
    [sym__verbatim_begin] = ACTIONS(1866),
  },
  [261] = {
    [sym__inline] = STATE(2138),
    [sym__inline_element] = STATE(1014),
    [sym__smart_punctuation] = STATE(456),
    [sym_autolink] = STATE(456),
    [sym_emphasis] = STATE(457),
    [sym_emphasis_begin] = STATE(2566),
    [sym_strong] = STATE(457),
    [sym_strong_begin] = STATE(2567),
    [sym_superscript] = STATE(457),
    [sym_superscript_begin] = STATE(2568),
    [sym_subscript] = STATE(457),
    [sym_subscript_begin] = STATE(2569),
    [sym_highlighted] = STATE(457),
    [sym_highlighted_begin] = STATE(2570),
    [sym_insert] = STATE(457),
    [sym_insert_begin] = STATE(2571),
    [sym_delete] = STATE(457),
    [sym_delete_begin] = STATE(1976),
    [sym_footnote_reference] = STATE(457),
    [sym_footnote_marker_begin] = STATE(2573),
    [sym__image] = STATE(457),
    [sym_full_reference_image] = STATE(457),
    [sym_collapsed_reference_image] = STATE(457),
    [sym_inline_image] = STATE(457),
    [sym_image_description] = STATE(1264),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(457),
    [sym_full_reference_link] = STATE(457),
    [sym_collapsed_reference_link] = STATE(457),
    [sym_inline_link] = STATE(457),
    [sym_link_text] = STATE(1265),
    [sym_span] = STATE(1014),
    [sym__bracketed_text_begin] = STATE(2618),
    [sym_inline_comment] = STATE(456),
    [sym_raw_inline] = STATE(456),
    [sym_math] = STATE(456),
    [sym_verbatim] = STATE(456),
    [sym__todo_highlights] = STATE(456),
    [sym_todo] = STATE(456),
    [sym_note] = STATE(456),
    [sym__symbol_fallback] = STATE(456),
    [aux_sym__text] = STATE(440),
    [aux_sym__inline_repeat1] = STATE(157),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [sym__whitespace1] = ACTIONS(1942),
    [sym_quotation_marks] = ACTIONS(1944),
    [sym_ellipsis] = ACTIONS(1944),
    [sym_em_dash] = ACTIONS(1944),
    [sym_en_dash] = ACTIONS(1946),
    [sym_backslash_escape] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1948),
    [sym_symbol] = ACTIONS(1944),
    [anon_sym_LBRACE_] = ACTIONS(1950),
    [anon_sym__] = ACTIONS(1952),
    [anon_sym_LBRACE_STAR] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_LBRACE_CARET] = ACTIONS(1958),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_LBRACE_EQ] = ACTIONS(1962),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1964),
    [anon_sym_LBRACE_DASH] = ACTIONS(1966),
    [anon_sym_LBRACK_CARET] = ACTIONS(1968),
    [anon_sym_BANG_LBRACK] = ACTIONS(1970),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1974),
    [anon_sym_DOLLAR] = ACTIONS(1976),
    [anon_sym_TODO] = ACTIONS(1978),
    [anon_sym_WIP] = ACTIONS(1978),
    [anon_sym_NOTE] = ACTIONS(1980),
    [anon_sym_INFO] = ACTIONS(1980),
    [anon_sym_XXX] = ACTIONS(1980),
    [sym_fixme] = ACTIONS(1944),
    [aux_sym__text_token1] = ACTIONS(1982),
    [sym__newline_inline] = ACTIONS(2190),
    [sym_hard_line_break] = ACTIONS(1944),
    [sym__verbatim_begin] = ACTIONS(1986),
  },
  [262] = {
    [sym__inline_without_trailing_space] = STATE(2165),
    [sym__inline_element] = STATE(988),
    [sym__smart_punctuation] = STATE(460),
    [sym_autolink] = STATE(460),
    [sym_emphasis] = STATE(463),
    [sym_emphasis_begin] = STATE(2484),
    [sym_strong] = STATE(463),
    [sym_strong_begin] = STATE(2485),
    [sym_superscript] = STATE(463),
    [sym_superscript_begin] = STATE(2486),
    [sym_subscript] = STATE(463),
    [sym_subscript_begin] = STATE(2487),
    [sym_highlighted] = STATE(463),
    [sym_highlighted_begin] = STATE(2488),
    [sym_insert] = STATE(463),
    [sym_insert_begin] = STATE(2489),
    [sym_delete] = STATE(463),
    [sym_delete_begin] = STATE(2490),
    [sym_footnote_reference] = STATE(463),
    [sym_footnote_marker_begin] = STATE(2491),
    [sym__image] = STATE(463),
    [sym_full_reference_image] = STATE(463),
    [sym_collapsed_reference_image] = STATE(463),
    [sym_inline_image] = STATE(463),
    [sym_image_description] = STATE(1268),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(463),
    [sym_full_reference_link] = STATE(463),
    [sym_collapsed_reference_link] = STATE(463),
    [sym_inline_link] = STATE(463),
    [sym_link_text] = STATE(1273),
    [sym_span] = STATE(988),
    [sym__bracketed_text_begin] = STATE(2607),
    [sym_inline_comment] = STATE(460),
    [sym_raw_inline] = STATE(460),
    [sym_math] = STATE(460),
    [sym_verbatim] = STATE(460),
    [sym__todo_highlights] = STATE(460),
    [sym_todo] = STATE(460),
    [sym_note] = STATE(460),
    [sym__symbol_fallback] = STATE(460),
    [aux_sym__text] = STATE(444),
    [aux_sym__inline_repeat1] = STATE(286),
    [anon_sym_LBRACK] = ACTIONS(1772),
    [sym__whitespace1] = ACTIONS(1774),
    [sym_quotation_marks] = ACTIONS(1776),
    [sym_ellipsis] = ACTIONS(1776),
    [sym_em_dash] = ACTIONS(1776),
    [sym_en_dash] = ACTIONS(1778),
    [sym_backslash_escape] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1780),
    [sym_symbol] = ACTIONS(1776),
    [anon_sym_LBRACE_] = ACTIONS(1782),
    [anon_sym__] = ACTIONS(1784),
    [anon_sym_LBRACE_STAR] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_LBRACE_CARET] = ACTIONS(1790),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1792),
    [anon_sym_LBRACE_EQ] = ACTIONS(1794),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1796),
    [anon_sym_LBRACE_DASH] = ACTIONS(1798),
    [anon_sym_LBRACK_CARET] = ACTIONS(1800),
    [anon_sym_BANG_LBRACK] = ACTIONS(1802),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1804),
    [anon_sym_LPAREN] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [anon_sym_TODO] = ACTIONS(1810),
    [anon_sym_WIP] = ACTIONS(1810),
    [anon_sym_NOTE] = ACTIONS(1812),
    [anon_sym_INFO] = ACTIONS(1812),
    [anon_sym_XXX] = ACTIONS(1812),
    [sym_fixme] = ACTIONS(1776),
    [aux_sym__text_token1] = ACTIONS(1814),
    [sym__newline_inline] = ACTIONS(1816),
    [sym_hard_line_break] = ACTIONS(1776),
    [sym__verbatim_begin] = ACTIONS(1818),
  },
  [263] = {
    [sym__inline_without_trailing_space] = STATE(2166),
    [sym__inline_element] = STATE(959),
    [sym__smart_punctuation] = STATE(464),
    [sym_autolink] = STATE(464),
    [sym_emphasis] = STATE(465),
    [sym_emphasis_begin] = STATE(2498),
    [sym_strong] = STATE(465),
    [sym_strong_begin] = STATE(2499),
    [sym_superscript] = STATE(465),
    [sym_superscript_begin] = STATE(2500),
    [sym_subscript] = STATE(465),
    [sym_subscript_begin] = STATE(2501),
    [sym_highlighted] = STATE(465),
    [sym_highlighted_begin] = STATE(2502),
    [sym_insert] = STATE(465),
    [sym_insert_begin] = STATE(2503),
    [sym_delete] = STATE(465),
    [sym_delete_begin] = STATE(2504),
    [sym_footnote_reference] = STATE(465),
    [sym_footnote_marker_begin] = STATE(2505),
    [sym__image] = STATE(465),
    [sym_full_reference_image] = STATE(465),
    [sym_collapsed_reference_image] = STATE(465),
    [sym_inline_image] = STATE(465),
    [sym_image_description] = STATE(1314),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(465),
    [sym_full_reference_link] = STATE(465),
    [sym_collapsed_reference_link] = STATE(465),
    [sym_inline_link] = STATE(465),
    [sym_link_text] = STATE(1319),
    [sym_span] = STATE(959),
    [sym__bracketed_text_begin] = STATE(2610),
    [sym_inline_comment] = STATE(464),
    [sym_raw_inline] = STATE(464),
    [sym_math] = STATE(464),
    [sym_verbatim] = STATE(464),
    [sym__todo_highlights] = STATE(464),
    [sym_todo] = STATE(464),
    [sym_note] = STATE(464),
    [sym__symbol_fallback] = STATE(464),
    [aux_sym__text] = STATE(445),
    [aux_sym__inline_repeat1] = STATE(287),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [sym__whitespace1] = ACTIONS(2136),
    [sym_quotation_marks] = ACTIONS(2138),
    [sym_ellipsis] = ACTIONS(2138),
    [sym_em_dash] = ACTIONS(2138),
    [sym_en_dash] = ACTIONS(2140),
    [sym_backslash_escape] = ACTIONS(2140),
    [anon_sym_LT] = ACTIONS(2142),
    [sym_symbol] = ACTIONS(2138),
    [anon_sym_LBRACE_] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_LBRACE_STAR] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_LBRACE_CARET] = ACTIONS(2152),
    [anon_sym_CARET] = ACTIONS(2152),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACE_EQ] = ACTIONS(2156),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2158),
    [anon_sym_LBRACE_DASH] = ACTIONS(2160),
    [anon_sym_LBRACK_CARET] = ACTIONS(2162),
    [anon_sym_BANG_LBRACK] = ACTIONS(2164),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_TODO] = ACTIONS(2172),
    [anon_sym_WIP] = ACTIONS(2172),
    [anon_sym_NOTE] = ACTIONS(2174),
    [anon_sym_INFO] = ACTIONS(2174),
    [anon_sym_XXX] = ACTIONS(2174),
    [sym_fixme] = ACTIONS(2138),
    [aux_sym__text_token1] = ACTIONS(2176),
    [sym__newline_inline] = ACTIONS(2178),
    [sym_hard_line_break] = ACTIONS(2138),
    [sym__verbatim_begin] = ACTIONS(2180),
  },
  [264] = {
    [sym__inline] = STATE(2167),
    [sym__inline_element] = STATE(1017),
    [sym__smart_punctuation] = STATE(468),
    [sym_autolink] = STATE(468),
    [sym_emphasis] = STATE(469),
    [sym_emphasis_begin] = STATE(2511),
    [sym_strong] = STATE(469),
    [sym_strong_begin] = STATE(2512),
    [sym_superscript] = STATE(469),
    [sym_superscript_begin] = STATE(2513),
    [sym_subscript] = STATE(469),
    [sym_subscript_begin] = STATE(2514),
    [sym_highlighted] = STATE(469),
    [sym_highlighted_begin] = STATE(2515),
    [sym_insert] = STATE(469),
    [sym_insert_begin] = STATE(2516),
    [sym_delete] = STATE(469),
    [sym_delete_begin] = STATE(2517),
    [sym_footnote_reference] = STATE(469),
    [sym_footnote_marker_begin] = STATE(2518),
    [sym__image] = STATE(469),
    [sym_full_reference_image] = STATE(469),
    [sym_collapsed_reference_image] = STATE(469),
    [sym_inline_image] = STATE(469),
    [sym_image_description] = STATE(1325),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(469),
    [sym_full_reference_link] = STATE(469),
    [sym_collapsed_reference_link] = STATE(469),
    [sym_inline_link] = STATE(469),
    [sym_link_text] = STATE(1326),
    [sym_span] = STATE(1017),
    [sym__bracketed_text_begin] = STATE(2613),
    [sym_inline_comment] = STATE(468),
    [sym_raw_inline] = STATE(468),
    [sym_math] = STATE(468),
    [sym_verbatim] = STATE(468),
    [sym__todo_highlights] = STATE(468),
    [sym_todo] = STATE(468),
    [sym_note] = STATE(468),
    [sym__symbol_fallback] = STATE(468),
    [aux_sym__text] = STATE(446),
    [aux_sym__inline_repeat1] = STATE(146),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [sym__whitespace1] = ACTIONS(1340),
    [sym_quotation_marks] = ACTIONS(1342),
    [sym_ellipsis] = ACTIONS(1342),
    [sym_em_dash] = ACTIONS(1342),
    [sym_en_dash] = ACTIONS(1344),
    [sym_backslash_escape] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [sym_symbol] = ACTIONS(1342),
    [anon_sym_LBRACE_] = ACTIONS(1348),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_LBRACE_STAR] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_LBRACE_CARET] = ACTIONS(1356),
    [anon_sym_CARET] = ACTIONS(1356),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_LBRACE_EQ] = ACTIONS(1360),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1362),
    [anon_sym_LBRACE_DASH] = ACTIONS(1364),
    [anon_sym_LBRACK_CARET] = ACTIONS(1366),
    [anon_sym_BANG_LBRACK] = ACTIONS(1368),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1374),
    [anon_sym_TODO] = ACTIONS(1376),
    [anon_sym_WIP] = ACTIONS(1376),
    [anon_sym_NOTE] = ACTIONS(1378),
    [anon_sym_INFO] = ACTIONS(1378),
    [anon_sym_XXX] = ACTIONS(1378),
    [sym_fixme] = ACTIONS(1342),
    [aux_sym__text_token1] = ACTIONS(1380),
    [sym__newline_inline] = ACTIONS(2182),
    [sym_hard_line_break] = ACTIONS(1342),
    [sym__verbatim_begin] = ACTIONS(1384),
  },
  [265] = {
    [sym__inline] = STATE(2168),
    [sym__inline_element] = STATE(915),
    [sym__smart_punctuation] = STATE(470),
    [sym_autolink] = STATE(470),
    [sym_emphasis] = STATE(471),
    [sym_emphasis_begin] = STATE(2522),
    [sym_strong] = STATE(471),
    [sym_strong_begin] = STATE(2523),
    [sym_superscript] = STATE(471),
    [sym_superscript_begin] = STATE(2524),
    [sym_subscript] = STATE(471),
    [sym_subscript_begin] = STATE(2525),
    [sym_highlighted] = STATE(471),
    [sym_highlighted_begin] = STATE(2526),
    [sym_insert] = STATE(471),
    [sym_insert_begin] = STATE(2527),
    [sym_delete] = STATE(471),
    [sym_delete_begin] = STATE(2528),
    [sym_footnote_reference] = STATE(471),
    [sym_footnote_marker_begin] = STATE(2529),
    [sym__image] = STATE(471),
    [sym_full_reference_image] = STATE(471),
    [sym_collapsed_reference_image] = STATE(471),
    [sym_inline_image] = STATE(471),
    [sym_image_description] = STATE(1332),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(471),
    [sym_full_reference_link] = STATE(471),
    [sym_collapsed_reference_link] = STATE(471),
    [sym_inline_link] = STATE(471),
    [sym_link_text] = STATE(1334),
    [sym_span] = STATE(915),
    [sym__bracketed_text_begin] = STATE(2614),
    [sym_inline_comment] = STATE(470),
    [sym_raw_inline] = STATE(470),
    [sym_math] = STATE(470),
    [sym_verbatim] = STATE(470),
    [sym__todo_highlights] = STATE(470),
    [sym_todo] = STATE(470),
    [sym_note] = STATE(470),
    [sym__symbol_fallback] = STATE(470),
    [aux_sym__text] = STATE(447),
    [aux_sym__inline_repeat1] = STATE(148),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [sym__whitespace1] = ACTIONS(1460),
    [sym_quotation_marks] = ACTIONS(1462),
    [sym_ellipsis] = ACTIONS(1462),
    [sym_em_dash] = ACTIONS(1462),
    [sym_en_dash] = ACTIONS(1464),
    [sym_backslash_escape] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [sym_symbol] = ACTIONS(1462),
    [anon_sym_LBRACE_] = ACTIONS(1468),
    [anon_sym__] = ACTIONS(1470),
    [anon_sym_LBRACE_STAR] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_LBRACE_CARET] = ACTIONS(1476),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_LBRACE_EQ] = ACTIONS(1480),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1482),
    [anon_sym_LBRACE_DASH] = ACTIONS(1484),
    [anon_sym_LBRACK_CARET] = ACTIONS(1486),
    [anon_sym_BANG_LBRACK] = ACTIONS(1488),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_TODO] = ACTIONS(1496),
    [anon_sym_WIP] = ACTIONS(1496),
    [anon_sym_NOTE] = ACTIONS(1498),
    [anon_sym_INFO] = ACTIONS(1498),
    [anon_sym_XXX] = ACTIONS(1498),
    [sym_fixme] = ACTIONS(1462),
    [aux_sym__text_token1] = ACTIONS(1500),
    [sym__newline_inline] = ACTIONS(2184),
    [sym_hard_line_break] = ACTIONS(1462),
    [sym__verbatim_begin] = ACTIONS(1504),
  },
  [266] = {
    [sym__inline] = STATE(2169),
    [sym__inline_element] = STATE(1021),
    [sym__smart_punctuation] = STATE(473),
    [sym_autolink] = STATE(473),
    [sym_emphasis] = STATE(450),
    [sym_emphasis_begin] = STATE(2533),
    [sym_strong] = STATE(450),
    [sym_strong_begin] = STATE(2534),
    [sym_superscript] = STATE(450),
    [sym_superscript_begin] = STATE(2535),
    [sym_subscript] = STATE(450),
    [sym_subscript_begin] = STATE(2536),
    [sym_highlighted] = STATE(450),
    [sym_highlighted_begin] = STATE(2537),
    [sym_insert] = STATE(450),
    [sym_insert_begin] = STATE(2538),
    [sym_delete] = STATE(450),
    [sym_delete_begin] = STATE(2539),
    [sym_footnote_reference] = STATE(450),
    [sym_footnote_marker_begin] = STATE(2540),
    [sym__image] = STATE(450),
    [sym_full_reference_image] = STATE(450),
    [sym_collapsed_reference_image] = STATE(450),
    [sym_inline_image] = STATE(450),
    [sym_image_description] = STATE(1340),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(450),
    [sym_full_reference_link] = STATE(450),
    [sym_collapsed_reference_link] = STATE(450),
    [sym_inline_link] = STATE(450),
    [sym_link_text] = STATE(1341),
    [sym_span] = STATE(1021),
    [sym__bracketed_text_begin] = STATE(2615),
    [sym_inline_comment] = STATE(473),
    [sym_raw_inline] = STATE(473),
    [sym_math] = STATE(473),
    [sym_verbatim] = STATE(473),
    [sym__todo_highlights] = STATE(473),
    [sym_todo] = STATE(473),
    [sym_note] = STATE(473),
    [sym__symbol_fallback] = STATE(473),
    [aux_sym__text] = STATE(448),
    [aux_sym__inline_repeat1] = STATE(150),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [sym__whitespace1] = ACTIONS(1580),
    [sym_quotation_marks] = ACTIONS(1582),
    [sym_ellipsis] = ACTIONS(1582),
    [sym_em_dash] = ACTIONS(1582),
    [sym_en_dash] = ACTIONS(1584),
    [sym_backslash_escape] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1586),
    [sym_symbol] = ACTIONS(1582),
    [anon_sym_LBRACE_] = ACTIONS(1588),
    [anon_sym__] = ACTIONS(1590),
    [anon_sym_LBRACE_STAR] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1594),
    [anon_sym_LBRACE_CARET] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_LBRACE_EQ] = ACTIONS(1600),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1602),
    [anon_sym_LBRACE_DASH] = ACTIONS(1604),
    [anon_sym_LBRACK_CARET] = ACTIONS(1606),
    [anon_sym_BANG_LBRACK] = ACTIONS(1608),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_DOLLAR] = ACTIONS(1614),
    [anon_sym_TODO] = ACTIONS(1616),
    [anon_sym_WIP] = ACTIONS(1616),
    [anon_sym_NOTE] = ACTIONS(1618),
    [anon_sym_INFO] = ACTIONS(1618),
    [anon_sym_XXX] = ACTIONS(1618),
    [sym_fixme] = ACTIONS(1582),
    [aux_sym__text_token1] = ACTIONS(1620),
    [sym__newline_inline] = ACTIONS(2186),
    [sym_hard_line_break] = ACTIONS(1582),
    [sym__verbatim_begin] = ACTIONS(1624),
  },
  [267] = {
    [sym__inline] = STATE(2170),
    [sym__inline_element] = STATE(997),
    [sym__smart_punctuation] = STATE(451),
    [sym_autolink] = STATE(451),
    [sym_emphasis] = STATE(449),
    [sym_emphasis_begin] = STATE(2544),
    [sym_strong] = STATE(449),
    [sym_strong_begin] = STATE(2545),
    [sym_superscript] = STATE(449),
    [sym_superscript_begin] = STATE(2546),
    [sym_subscript] = STATE(449),
    [sym_subscript_begin] = STATE(2547),
    [sym_highlighted] = STATE(449),
    [sym_highlighted_begin] = STATE(2548),
    [sym_insert] = STATE(449),
    [sym_insert_begin] = STATE(2549),
    [sym_delete] = STATE(449),
    [sym_delete_begin] = STATE(2550),
    [sym_footnote_reference] = STATE(449),
    [sym_footnote_marker_begin] = STATE(2551),
    [sym__image] = STATE(449),
    [sym_full_reference_image] = STATE(449),
    [sym_collapsed_reference_image] = STATE(449),
    [sym_inline_image] = STATE(449),
    [sym_image_description] = STATE(1250),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(449),
    [sym_full_reference_link] = STATE(449),
    [sym_collapsed_reference_link] = STATE(449),
    [sym_inline_link] = STATE(449),
    [sym_link_text] = STATE(1251),
    [sym_span] = STATE(997),
    [sym__bracketed_text_begin] = STATE(2616),
    [sym_inline_comment] = STATE(451),
    [sym_raw_inline] = STATE(451),
    [sym_math] = STATE(451),
    [sym_verbatim] = STATE(451),
    [sym__todo_highlights] = STATE(451),
    [sym_todo] = STATE(451),
    [sym_note] = STATE(451),
    [sym__symbol_fallback] = STATE(451),
    [aux_sym__text] = STATE(439),
    [aux_sym__inline_repeat1] = STATE(152),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [sym__whitespace1] = ACTIONS(1074),
    [sym_quotation_marks] = ACTIONS(1076),
    [sym_ellipsis] = ACTIONS(1076),
    [sym_em_dash] = ACTIONS(1076),
    [sym_en_dash] = ACTIONS(1078),
    [sym_backslash_escape] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(1080),
    [sym_symbol] = ACTIONS(1076),
    [anon_sym_LBRACE_] = ACTIONS(1082),
    [anon_sym__] = ACTIONS(1084),
    [anon_sym_LBRACE_STAR] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_LBRACE_CARET] = ACTIONS(1090),
    [anon_sym_CARET] = ACTIONS(1090),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_LBRACE_EQ] = ACTIONS(1094),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1096),
    [anon_sym_LBRACE_DASH] = ACTIONS(1098),
    [anon_sym_LBRACK_CARET] = ACTIONS(1100),
    [anon_sym_BANG_LBRACK] = ACTIONS(1102),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [anon_sym_TODO] = ACTIONS(1110),
    [anon_sym_WIP] = ACTIONS(1110),
    [anon_sym_NOTE] = ACTIONS(1112),
    [anon_sym_INFO] = ACTIONS(1112),
    [anon_sym_XXX] = ACTIONS(1112),
    [sym_fixme] = ACTIONS(1076),
    [aux_sym__text_token1] = ACTIONS(1114),
    [sym__newline_inline] = ACTIONS(1116),
    [sym_hard_line_break] = ACTIONS(1076),
    [sym__verbatim_begin] = ACTIONS(1118),
  },
  [268] = {
    [sym__inline] = STATE(2171),
    [sym__inline_element] = STATE(900),
    [sym__smart_punctuation] = STATE(454),
    [sym_autolink] = STATE(454),
    [sym_emphasis] = STATE(455),
    [sym_emphasis_begin] = STATE(2555),
    [sym_strong] = STATE(455),
    [sym_strong_begin] = STATE(2556),
    [sym_superscript] = STATE(455),
    [sym_superscript_begin] = STATE(2557),
    [sym_subscript] = STATE(455),
    [sym_subscript_begin] = STATE(2558),
    [sym_highlighted] = STATE(455),
    [sym_highlighted_begin] = STATE(2559),
    [sym_insert] = STATE(455),
    [sym_insert_begin] = STATE(2560),
    [sym_delete] = STATE(455),
    [sym_delete_begin] = STATE(2561),
    [sym_footnote_reference] = STATE(455),
    [sym_footnote_marker_begin] = STATE(2562),
    [sym__image] = STATE(455),
    [sym_full_reference_image] = STATE(455),
    [sym_collapsed_reference_image] = STATE(455),
    [sym_inline_image] = STATE(455),
    [sym_image_description] = STATE(1257),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(455),
    [sym_full_reference_link] = STATE(455),
    [sym_collapsed_reference_link] = STATE(455),
    [sym_inline_link] = STATE(455),
    [sym_link_text] = STATE(1258),
    [sym_span] = STATE(900),
    [sym__bracketed_text_begin] = STATE(2617),
    [sym_inline_comment] = STATE(454),
    [sym_raw_inline] = STATE(454),
    [sym_math] = STATE(454),
    [sym_verbatim] = STATE(454),
    [sym__todo_highlights] = STATE(454),
    [sym_todo] = STATE(454),
    [sym_note] = STATE(454),
    [sym__symbol_fallback] = STATE(454),
    [aux_sym__text] = STATE(441),
    [aux_sym__inline_repeat1] = STATE(155),
    [anon_sym_LBRACK] = ACTIONS(1820),
    [sym__whitespace1] = ACTIONS(1822),
    [sym_quotation_marks] = ACTIONS(1824),
    [sym_ellipsis] = ACTIONS(1824),
    [sym_em_dash] = ACTIONS(1824),
    [sym_en_dash] = ACTIONS(1826),
    [sym_backslash_escape] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1828),
    [sym_symbol] = ACTIONS(1824),
    [anon_sym_LBRACE_] = ACTIONS(1830),
    [anon_sym__] = ACTIONS(1832),
    [anon_sym_LBRACE_STAR] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_LBRACE_CARET] = ACTIONS(1838),
    [anon_sym_CARET] = ACTIONS(1838),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1840),
    [anon_sym_TILDE] = ACTIONS(1840),
    [anon_sym_LBRACE_EQ] = ACTIONS(1842),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1844),
    [anon_sym_LBRACE_DASH] = ACTIONS(1846),
    [anon_sym_LBRACK_CARET] = ACTIONS(1848),
    [anon_sym_BANG_LBRACK] = ACTIONS(1850),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1856),
    [anon_sym_TODO] = ACTIONS(1858),
    [anon_sym_WIP] = ACTIONS(1858),
    [anon_sym_NOTE] = ACTIONS(1860),
    [anon_sym_INFO] = ACTIONS(1860),
    [anon_sym_XXX] = ACTIONS(1860),
    [sym_fixme] = ACTIONS(1824),
    [aux_sym__text_token1] = ACTIONS(1862),
    [sym__newline_inline] = ACTIONS(2188),
    [sym_hard_line_break] = ACTIONS(1824),
    [sym__verbatim_begin] = ACTIONS(1866),
  },
  [269] = {
    [sym__inline] = STATE(2173),
    [sym__inline_element] = STATE(1014),
    [sym__smart_punctuation] = STATE(456),
    [sym_autolink] = STATE(456),
    [sym_emphasis] = STATE(457),
    [sym_emphasis_begin] = STATE(2566),
    [sym_strong] = STATE(457),
    [sym_strong_begin] = STATE(2567),
    [sym_superscript] = STATE(457),
    [sym_superscript_begin] = STATE(2568),
    [sym_subscript] = STATE(457),
    [sym_subscript_begin] = STATE(2569),
    [sym_highlighted] = STATE(457),
    [sym_highlighted_begin] = STATE(2570),
    [sym_insert] = STATE(457),
    [sym_insert_begin] = STATE(2571),
    [sym_delete] = STATE(457),
    [sym_delete_begin] = STATE(1976),
    [sym_footnote_reference] = STATE(457),
    [sym_footnote_marker_begin] = STATE(2573),
    [sym__image] = STATE(457),
    [sym_full_reference_image] = STATE(457),
    [sym_collapsed_reference_image] = STATE(457),
    [sym_inline_image] = STATE(457),
    [sym_image_description] = STATE(1264),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(457),
    [sym_full_reference_link] = STATE(457),
    [sym_collapsed_reference_link] = STATE(457),
    [sym_inline_link] = STATE(457),
    [sym_link_text] = STATE(1265),
    [sym_span] = STATE(1014),
    [sym__bracketed_text_begin] = STATE(2618),
    [sym_inline_comment] = STATE(456),
    [sym_raw_inline] = STATE(456),
    [sym_math] = STATE(456),
    [sym_verbatim] = STATE(456),
    [sym__todo_highlights] = STATE(456),
    [sym_todo] = STATE(456),
    [sym_note] = STATE(456),
    [sym__symbol_fallback] = STATE(456),
    [aux_sym__text] = STATE(440),
    [aux_sym__inline_repeat1] = STATE(157),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [sym__whitespace1] = ACTIONS(1942),
    [sym_quotation_marks] = ACTIONS(1944),
    [sym_ellipsis] = ACTIONS(1944),
    [sym_em_dash] = ACTIONS(1944),
    [sym_en_dash] = ACTIONS(1946),
    [sym_backslash_escape] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1948),
    [sym_symbol] = ACTIONS(1944),
    [anon_sym_LBRACE_] = ACTIONS(1950),
    [anon_sym__] = ACTIONS(1952),
    [anon_sym_LBRACE_STAR] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_LBRACE_CARET] = ACTIONS(1958),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_LBRACE_EQ] = ACTIONS(1962),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1964),
    [anon_sym_LBRACE_DASH] = ACTIONS(1966),
    [anon_sym_LBRACK_CARET] = ACTIONS(1968),
    [anon_sym_BANG_LBRACK] = ACTIONS(1970),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1974),
    [anon_sym_DOLLAR] = ACTIONS(1976),
    [anon_sym_TODO] = ACTIONS(1978),
    [anon_sym_WIP] = ACTIONS(1978),
    [anon_sym_NOTE] = ACTIONS(1980),
    [anon_sym_INFO] = ACTIONS(1980),
    [anon_sym_XXX] = ACTIONS(1980),
    [sym_fixme] = ACTIONS(1944),
    [aux_sym__text_token1] = ACTIONS(1982),
    [sym__newline_inline] = ACTIONS(2190),
    [sym_hard_line_break] = ACTIONS(1944),
    [sym__verbatim_begin] = ACTIONS(1986),
  },
  [270] = {
    [sym__inline] = STATE(2217),
    [sym__inline_element] = STATE(978),
    [sym__smart_punctuation] = STATE(458),
    [sym_autolink] = STATE(458),
    [sym_emphasis] = STATE(462),
    [sym_emphasis_begin] = STATE(2577),
    [sym_strong] = STATE(462),
    [sym_strong_begin] = STATE(2578),
    [sym_superscript] = STATE(462),
    [sym_superscript_begin] = STATE(2579),
    [sym_subscript] = STATE(462),
    [sym_subscript_begin] = STATE(2580),
    [sym_highlighted] = STATE(462),
    [sym_highlighted_begin] = STATE(2581),
    [sym_insert] = STATE(462),
    [sym_insert_begin] = STATE(2582),
    [sym_delete] = STATE(462),
    [sym_delete_begin] = STATE(2583),
    [sym_footnote_reference] = STATE(462),
    [sym_footnote_marker_begin] = STATE(2584),
    [sym__image] = STATE(462),
    [sym_full_reference_image] = STATE(462),
    [sym_collapsed_reference_image] = STATE(462),
    [sym_inline_image] = STATE(462),
    [sym_image_description] = STATE(1271),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(462),
    [sym_full_reference_link] = STATE(462),
    [sym_collapsed_reference_link] = STATE(462),
    [sym_inline_link] = STATE(462),
    [sym_link_text] = STATE(1272),
    [sym_span] = STATE(978),
    [sym__bracketed_text_begin] = STATE(2619),
    [sym_inline_comment] = STATE(458),
    [sym_raw_inline] = STATE(458),
    [sym_math] = STATE(458),
    [sym_verbatim] = STATE(458),
    [sym__todo_highlights] = STATE(458),
    [sym_todo] = STATE(458),
    [sym_note] = STATE(458),
    [sym__symbol_fallback] = STATE(458),
    [aux_sym__text] = STATE(442),
    [aux_sym__inline_repeat1] = STATE(159),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [sym__whitespace1] = ACTIONS(1024),
    [sym_quotation_marks] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1026),
    [sym_em_dash] = ACTIONS(1026),
    [sym_en_dash] = ACTIONS(1028),
    [sym_backslash_escape] = ACTIONS(1028),
    [anon_sym_LT] = ACTIONS(1030),
    [sym_symbol] = ACTIONS(1026),
    [anon_sym_LBRACE_] = ACTIONS(1032),
    [anon_sym__] = ACTIONS(1034),
    [anon_sym_LBRACE_STAR] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_LBRACE_CARET] = ACTIONS(1040),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_LBRACE_EQ] = ACTIONS(1044),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1046),
    [anon_sym_LBRACE_DASH] = ACTIONS(1048),
    [anon_sym_LBRACK_CARET] = ACTIONS(1050),
    [anon_sym_BANG_LBRACK] = ACTIONS(1052),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1058),
    [anon_sym_TODO] = ACTIONS(1060),
    [anon_sym_WIP] = ACTIONS(1060),
    [anon_sym_NOTE] = ACTIONS(1062),
    [anon_sym_INFO] = ACTIONS(1062),
    [anon_sym_XXX] = ACTIONS(1062),
    [sym_fixme] = ACTIONS(1026),
    [aux_sym__text_token1] = ACTIONS(1064),
    [sym__newline_inline] = ACTIONS(1066),
    [sym_hard_line_break] = ACTIONS(1026),
    [sym__verbatim_begin] = ACTIONS(1068),
  },
  [271] = {
    [sym__inline] = STATE(2248),
    [sym__inline_element] = STATE(978),
    [sym__smart_punctuation] = STATE(458),
    [sym_autolink] = STATE(458),
    [sym_emphasis] = STATE(462),
    [sym_emphasis_begin] = STATE(2577),
    [sym_strong] = STATE(462),
    [sym_strong_begin] = STATE(2578),
    [sym_superscript] = STATE(462),
    [sym_superscript_begin] = STATE(2579),
    [sym_subscript] = STATE(462),
    [sym_subscript_begin] = STATE(2580),
    [sym_highlighted] = STATE(462),
    [sym_highlighted_begin] = STATE(2581),
    [sym_insert] = STATE(462),
    [sym_insert_begin] = STATE(2582),
    [sym_delete] = STATE(462),
    [sym_delete_begin] = STATE(2583),
    [sym_footnote_reference] = STATE(462),
    [sym_footnote_marker_begin] = STATE(2584),
    [sym__image] = STATE(462),
    [sym_full_reference_image] = STATE(462),
    [sym_collapsed_reference_image] = STATE(462),
    [sym_inline_image] = STATE(462),
    [sym_image_description] = STATE(1271),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(462),
    [sym_full_reference_link] = STATE(462),
    [sym_collapsed_reference_link] = STATE(462),
    [sym_inline_link] = STATE(462),
    [sym_link_text] = STATE(1272),
    [sym_span] = STATE(978),
    [sym__bracketed_text_begin] = STATE(2619),
    [sym_inline_comment] = STATE(458),
    [sym_raw_inline] = STATE(458),
    [sym_math] = STATE(458),
    [sym_verbatim] = STATE(458),
    [sym__todo_highlights] = STATE(458),
    [sym_todo] = STATE(458),
    [sym_note] = STATE(458),
    [sym__symbol_fallback] = STATE(458),
    [aux_sym__text] = STATE(442),
    [aux_sym__inline_repeat1] = STATE(159),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [sym__whitespace1] = ACTIONS(1024),
    [sym_quotation_marks] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1026),
    [sym_em_dash] = ACTIONS(1026),
    [sym_en_dash] = ACTIONS(1028),
    [sym_backslash_escape] = ACTIONS(1028),
    [anon_sym_LT] = ACTIONS(1030),
    [sym_symbol] = ACTIONS(1026),
    [anon_sym_LBRACE_] = ACTIONS(1032),
    [anon_sym__] = ACTIONS(1034),
    [anon_sym_LBRACE_STAR] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_LBRACE_CARET] = ACTIONS(1040),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_LBRACE_EQ] = ACTIONS(1044),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1046),
    [anon_sym_LBRACE_DASH] = ACTIONS(1048),
    [anon_sym_LBRACK_CARET] = ACTIONS(1050),
    [anon_sym_BANG_LBRACK] = ACTIONS(1052),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1058),
    [anon_sym_TODO] = ACTIONS(1060),
    [anon_sym_WIP] = ACTIONS(1060),
    [anon_sym_NOTE] = ACTIONS(1062),
    [anon_sym_INFO] = ACTIONS(1062),
    [anon_sym_XXX] = ACTIONS(1062),
    [sym_fixme] = ACTIONS(1026),
    [aux_sym__text_token1] = ACTIONS(1064),
    [sym__newline_inline] = ACTIONS(1066),
    [sym_hard_line_break] = ACTIONS(1026),
    [sym__verbatim_begin] = ACTIONS(1068),
  },
  [272] = {
    [sym__inline] = STATE(2278),
    [sym__inline_element] = STATE(978),
    [sym__smart_punctuation] = STATE(458),
    [sym_autolink] = STATE(458),
    [sym_emphasis] = STATE(462),
    [sym_emphasis_begin] = STATE(2577),
    [sym_strong] = STATE(462),
    [sym_strong_begin] = STATE(2578),
    [sym_superscript] = STATE(462),
    [sym_superscript_begin] = STATE(2579),
    [sym_subscript] = STATE(462),
    [sym_subscript_begin] = STATE(2580),
    [sym_highlighted] = STATE(462),
    [sym_highlighted_begin] = STATE(2581),
    [sym_insert] = STATE(462),
    [sym_insert_begin] = STATE(2582),
    [sym_delete] = STATE(462),
    [sym_delete_begin] = STATE(2583),
    [sym_footnote_reference] = STATE(462),
    [sym_footnote_marker_begin] = STATE(2584),
    [sym__image] = STATE(462),
    [sym_full_reference_image] = STATE(462),
    [sym_collapsed_reference_image] = STATE(462),
    [sym_inline_image] = STATE(462),
    [sym_image_description] = STATE(1271),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(462),
    [sym_full_reference_link] = STATE(462),
    [sym_collapsed_reference_link] = STATE(462),
    [sym_inline_link] = STATE(462),
    [sym_link_text] = STATE(1272),
    [sym_span] = STATE(978),
    [sym__bracketed_text_begin] = STATE(2619),
    [sym_inline_comment] = STATE(458),
    [sym_raw_inline] = STATE(458),
    [sym_math] = STATE(458),
    [sym_verbatim] = STATE(458),
    [sym__todo_highlights] = STATE(458),
    [sym_todo] = STATE(458),
    [sym_note] = STATE(458),
    [sym__symbol_fallback] = STATE(458),
    [aux_sym__text] = STATE(442),
    [aux_sym__inline_repeat1] = STATE(159),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [sym__whitespace1] = ACTIONS(1024),
    [sym_quotation_marks] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1026),
    [sym_em_dash] = ACTIONS(1026),
    [sym_en_dash] = ACTIONS(1028),
    [sym_backslash_escape] = ACTIONS(1028),
    [anon_sym_LT] = ACTIONS(1030),
    [sym_symbol] = ACTIONS(1026),
    [anon_sym_LBRACE_] = ACTIONS(1032),
    [anon_sym__] = ACTIONS(1034),
    [anon_sym_LBRACE_STAR] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_LBRACE_CARET] = ACTIONS(1040),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_LBRACE_EQ] = ACTIONS(1044),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1046),
    [anon_sym_LBRACE_DASH] = ACTIONS(1048),
    [anon_sym_LBRACK_CARET] = ACTIONS(1050),
    [anon_sym_BANG_LBRACK] = ACTIONS(1052),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1058),
    [anon_sym_TODO] = ACTIONS(1060),
    [anon_sym_WIP] = ACTIONS(1060),
    [anon_sym_NOTE] = ACTIONS(1062),
    [anon_sym_INFO] = ACTIONS(1062),
    [anon_sym_XXX] = ACTIONS(1062),
    [sym_fixme] = ACTIONS(1026),
    [aux_sym__text_token1] = ACTIONS(1064),
    [sym__newline_inline] = ACTIONS(1066),
    [sym_hard_line_break] = ACTIONS(1026),
    [sym__verbatim_begin] = ACTIONS(1068),
  },
  [273] = {
    [sym__inline] = STATE(2307),
    [sym__inline_element] = STATE(978),
    [sym__smart_punctuation] = STATE(458),
    [sym_autolink] = STATE(458),
    [sym_emphasis] = STATE(462),
    [sym_emphasis_begin] = STATE(2577),
    [sym_strong] = STATE(462),
    [sym_strong_begin] = STATE(2578),
    [sym_superscript] = STATE(462),
    [sym_superscript_begin] = STATE(2579),
    [sym_subscript] = STATE(462),
    [sym_subscript_begin] = STATE(2580),
    [sym_highlighted] = STATE(462),
    [sym_highlighted_begin] = STATE(2581),
    [sym_insert] = STATE(462),
    [sym_insert_begin] = STATE(2582),
    [sym_delete] = STATE(462),
    [sym_delete_begin] = STATE(2583),
    [sym_footnote_reference] = STATE(462),
    [sym_footnote_marker_begin] = STATE(2584),
    [sym__image] = STATE(462),
    [sym_full_reference_image] = STATE(462),
    [sym_collapsed_reference_image] = STATE(462),
    [sym_inline_image] = STATE(462),
    [sym_image_description] = STATE(1271),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(462),
    [sym_full_reference_link] = STATE(462),
    [sym_collapsed_reference_link] = STATE(462),
    [sym_inline_link] = STATE(462),
    [sym_link_text] = STATE(1272),
    [sym_span] = STATE(978),
    [sym__bracketed_text_begin] = STATE(2619),
    [sym_inline_comment] = STATE(458),
    [sym_raw_inline] = STATE(458),
    [sym_math] = STATE(458),
    [sym_verbatim] = STATE(458),
    [sym__todo_highlights] = STATE(458),
    [sym_todo] = STATE(458),
    [sym_note] = STATE(458),
    [sym__symbol_fallback] = STATE(458),
    [aux_sym__text] = STATE(442),
    [aux_sym__inline_repeat1] = STATE(159),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [sym__whitespace1] = ACTIONS(1024),
    [sym_quotation_marks] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1026),
    [sym_em_dash] = ACTIONS(1026),
    [sym_en_dash] = ACTIONS(1028),
    [sym_backslash_escape] = ACTIONS(1028),
    [anon_sym_LT] = ACTIONS(1030),
    [sym_symbol] = ACTIONS(1026),
    [anon_sym_LBRACE_] = ACTIONS(1032),
    [anon_sym__] = ACTIONS(1034),
    [anon_sym_LBRACE_STAR] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_LBRACE_CARET] = ACTIONS(1040),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_LBRACE_EQ] = ACTIONS(1044),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1046),
    [anon_sym_LBRACE_DASH] = ACTIONS(1048),
    [anon_sym_LBRACK_CARET] = ACTIONS(1050),
    [anon_sym_BANG_LBRACK] = ACTIONS(1052),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1058),
    [anon_sym_TODO] = ACTIONS(1060),
    [anon_sym_WIP] = ACTIONS(1060),
    [anon_sym_NOTE] = ACTIONS(1062),
    [anon_sym_INFO] = ACTIONS(1062),
    [anon_sym_XXX] = ACTIONS(1062),
    [sym_fixme] = ACTIONS(1026),
    [aux_sym__text_token1] = ACTIONS(1064),
    [sym__newline_inline] = ACTIONS(1066),
    [sym_hard_line_break] = ACTIONS(1026),
    [sym__verbatim_begin] = ACTIONS(1068),
  },
  [274] = {
    [sym__inline] = STATE(2328),
    [sym__inline_element] = STATE(978),
    [sym__smart_punctuation] = STATE(458),
    [sym_autolink] = STATE(458),
    [sym_emphasis] = STATE(462),
    [sym_emphasis_begin] = STATE(2577),
    [sym_strong] = STATE(462),
    [sym_strong_begin] = STATE(2578),
    [sym_superscript] = STATE(462),
    [sym_superscript_begin] = STATE(2579),
    [sym_subscript] = STATE(462),
    [sym_subscript_begin] = STATE(2580),
    [sym_highlighted] = STATE(462),
    [sym_highlighted_begin] = STATE(2581),
    [sym_insert] = STATE(462),
    [sym_insert_begin] = STATE(2582),
    [sym_delete] = STATE(462),
    [sym_delete_begin] = STATE(2583),
    [sym_footnote_reference] = STATE(462),
    [sym_footnote_marker_begin] = STATE(2584),
    [sym__image] = STATE(462),
    [sym_full_reference_image] = STATE(462),
    [sym_collapsed_reference_image] = STATE(462),
    [sym_inline_image] = STATE(462),
    [sym_image_description] = STATE(1271),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(462),
    [sym_full_reference_link] = STATE(462),
    [sym_collapsed_reference_link] = STATE(462),
    [sym_inline_link] = STATE(462),
    [sym_link_text] = STATE(1272),
    [sym_span] = STATE(978),
    [sym__bracketed_text_begin] = STATE(2619),
    [sym_inline_comment] = STATE(458),
    [sym_raw_inline] = STATE(458),
    [sym_math] = STATE(458),
    [sym_verbatim] = STATE(458),
    [sym__todo_highlights] = STATE(458),
    [sym_todo] = STATE(458),
    [sym_note] = STATE(458),
    [sym__symbol_fallback] = STATE(458),
    [aux_sym__text] = STATE(442),
    [aux_sym__inline_repeat1] = STATE(159),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [sym__whitespace1] = ACTIONS(1024),
    [sym_quotation_marks] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1026),
    [sym_em_dash] = ACTIONS(1026),
    [sym_en_dash] = ACTIONS(1028),
    [sym_backslash_escape] = ACTIONS(1028),
    [anon_sym_LT] = ACTIONS(1030),
    [sym_symbol] = ACTIONS(1026),
    [anon_sym_LBRACE_] = ACTIONS(1032),
    [anon_sym__] = ACTIONS(1034),
    [anon_sym_LBRACE_STAR] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_LBRACE_CARET] = ACTIONS(1040),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_LBRACE_EQ] = ACTIONS(1044),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1046),
    [anon_sym_LBRACE_DASH] = ACTIONS(1048),
    [anon_sym_LBRACK_CARET] = ACTIONS(1050),
    [anon_sym_BANG_LBRACK] = ACTIONS(1052),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1058),
    [anon_sym_TODO] = ACTIONS(1060),
    [anon_sym_WIP] = ACTIONS(1060),
    [anon_sym_NOTE] = ACTIONS(1062),
    [anon_sym_INFO] = ACTIONS(1062),
    [anon_sym_XXX] = ACTIONS(1062),
    [sym_fixme] = ACTIONS(1026),
    [aux_sym__text_token1] = ACTIONS(1064),
    [sym__newline_inline] = ACTIONS(1066),
    [sym_hard_line_break] = ACTIONS(1026),
    [sym__verbatim_begin] = ACTIONS(1068),
  },
  [275] = {
    [sym__inline] = STATE(2345),
    [sym__inline_element] = STATE(978),
    [sym__smart_punctuation] = STATE(458),
    [sym_autolink] = STATE(458),
    [sym_emphasis] = STATE(462),
    [sym_emphasis_begin] = STATE(2577),
    [sym_strong] = STATE(462),
    [sym_strong_begin] = STATE(2578),
    [sym_superscript] = STATE(462),
    [sym_superscript_begin] = STATE(2579),
    [sym_subscript] = STATE(462),
    [sym_subscript_begin] = STATE(2580),
    [sym_highlighted] = STATE(462),
    [sym_highlighted_begin] = STATE(2581),
    [sym_insert] = STATE(462),
    [sym_insert_begin] = STATE(2582),
    [sym_delete] = STATE(462),
    [sym_delete_begin] = STATE(2583),
    [sym_footnote_reference] = STATE(462),
    [sym_footnote_marker_begin] = STATE(2584),
    [sym__image] = STATE(462),
    [sym_full_reference_image] = STATE(462),
    [sym_collapsed_reference_image] = STATE(462),
    [sym_inline_image] = STATE(462),
    [sym_image_description] = STATE(1271),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(462),
    [sym_full_reference_link] = STATE(462),
    [sym_collapsed_reference_link] = STATE(462),
    [sym_inline_link] = STATE(462),
    [sym_link_text] = STATE(1272),
    [sym_span] = STATE(978),
    [sym__bracketed_text_begin] = STATE(2619),
    [sym_inline_comment] = STATE(458),
    [sym_raw_inline] = STATE(458),
    [sym_math] = STATE(458),
    [sym_verbatim] = STATE(458),
    [sym__todo_highlights] = STATE(458),
    [sym_todo] = STATE(458),
    [sym_note] = STATE(458),
    [sym__symbol_fallback] = STATE(458),
    [aux_sym__text] = STATE(442),
    [aux_sym__inline_repeat1] = STATE(159),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [sym__whitespace1] = ACTIONS(1024),
    [sym_quotation_marks] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1026),
    [sym_em_dash] = ACTIONS(1026),
    [sym_en_dash] = ACTIONS(1028),
    [sym_backslash_escape] = ACTIONS(1028),
    [anon_sym_LT] = ACTIONS(1030),
    [sym_symbol] = ACTIONS(1026),
    [anon_sym_LBRACE_] = ACTIONS(1032),
    [anon_sym__] = ACTIONS(1034),
    [anon_sym_LBRACE_STAR] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_LBRACE_CARET] = ACTIONS(1040),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_LBRACE_EQ] = ACTIONS(1044),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1046),
    [anon_sym_LBRACE_DASH] = ACTIONS(1048),
    [anon_sym_LBRACK_CARET] = ACTIONS(1050),
    [anon_sym_BANG_LBRACK] = ACTIONS(1052),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1058),
    [anon_sym_TODO] = ACTIONS(1060),
    [anon_sym_WIP] = ACTIONS(1060),
    [anon_sym_NOTE] = ACTIONS(1062),
    [anon_sym_INFO] = ACTIONS(1062),
    [anon_sym_XXX] = ACTIONS(1062),
    [sym_fixme] = ACTIONS(1026),
    [aux_sym__text_token1] = ACTIONS(1064),
    [sym__newline_inline] = ACTIONS(1066),
    [sym_hard_line_break] = ACTIONS(1026),
    [sym__verbatim_begin] = ACTIONS(1068),
  },
  [276] = {
    [sym__inline] = STATE(2362),
    [sym__inline_element] = STATE(978),
    [sym__smart_punctuation] = STATE(458),
    [sym_autolink] = STATE(458),
    [sym_emphasis] = STATE(462),
    [sym_emphasis_begin] = STATE(2577),
    [sym_strong] = STATE(462),
    [sym_strong_begin] = STATE(2578),
    [sym_superscript] = STATE(462),
    [sym_superscript_begin] = STATE(2579),
    [sym_subscript] = STATE(462),
    [sym_subscript_begin] = STATE(2580),
    [sym_highlighted] = STATE(462),
    [sym_highlighted_begin] = STATE(2581),
    [sym_insert] = STATE(462),
    [sym_insert_begin] = STATE(2582),
    [sym_delete] = STATE(462),
    [sym_delete_begin] = STATE(2583),
    [sym_footnote_reference] = STATE(462),
    [sym_footnote_marker_begin] = STATE(2584),
    [sym__image] = STATE(462),
    [sym_full_reference_image] = STATE(462),
    [sym_collapsed_reference_image] = STATE(462),
    [sym_inline_image] = STATE(462),
    [sym_image_description] = STATE(1271),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(462),
    [sym_full_reference_link] = STATE(462),
    [sym_collapsed_reference_link] = STATE(462),
    [sym_inline_link] = STATE(462),
    [sym_link_text] = STATE(1272),
    [sym_span] = STATE(978),
    [sym__bracketed_text_begin] = STATE(2619),
    [sym_inline_comment] = STATE(458),
    [sym_raw_inline] = STATE(458),
    [sym_math] = STATE(458),
    [sym_verbatim] = STATE(458),
    [sym__todo_highlights] = STATE(458),
    [sym_todo] = STATE(458),
    [sym_note] = STATE(458),
    [sym__symbol_fallback] = STATE(458),
    [aux_sym__text] = STATE(442),
    [aux_sym__inline_repeat1] = STATE(159),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [sym__whitespace1] = ACTIONS(1024),
    [sym_quotation_marks] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1026),
    [sym_em_dash] = ACTIONS(1026),
    [sym_en_dash] = ACTIONS(1028),
    [sym_backslash_escape] = ACTIONS(1028),
    [anon_sym_LT] = ACTIONS(1030),
    [sym_symbol] = ACTIONS(1026),
    [anon_sym_LBRACE_] = ACTIONS(1032),
    [anon_sym__] = ACTIONS(1034),
    [anon_sym_LBRACE_STAR] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_LBRACE_CARET] = ACTIONS(1040),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_LBRACE_EQ] = ACTIONS(1044),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1046),
    [anon_sym_LBRACE_DASH] = ACTIONS(1048),
    [anon_sym_LBRACK_CARET] = ACTIONS(1050),
    [anon_sym_BANG_LBRACK] = ACTIONS(1052),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1058),
    [anon_sym_TODO] = ACTIONS(1060),
    [anon_sym_WIP] = ACTIONS(1060),
    [anon_sym_NOTE] = ACTIONS(1062),
    [anon_sym_INFO] = ACTIONS(1062),
    [anon_sym_XXX] = ACTIONS(1062),
    [sym_fixme] = ACTIONS(1026),
    [aux_sym__text_token1] = ACTIONS(1064),
    [sym__newline_inline] = ACTIONS(1066),
    [sym_hard_line_break] = ACTIONS(1026),
    [sym__verbatim_begin] = ACTIONS(1068),
  },
  [277] = {
    [sym__inline] = STATE(2379),
    [sym__inline_element] = STATE(978),
    [sym__smart_punctuation] = STATE(458),
    [sym_autolink] = STATE(458),
    [sym_emphasis] = STATE(462),
    [sym_emphasis_begin] = STATE(2577),
    [sym_strong] = STATE(462),
    [sym_strong_begin] = STATE(2578),
    [sym_superscript] = STATE(462),
    [sym_superscript_begin] = STATE(2579),
    [sym_subscript] = STATE(462),
    [sym_subscript_begin] = STATE(2580),
    [sym_highlighted] = STATE(462),
    [sym_highlighted_begin] = STATE(2581),
    [sym_insert] = STATE(462),
    [sym_insert_begin] = STATE(2582),
    [sym_delete] = STATE(462),
    [sym_delete_begin] = STATE(2583),
    [sym_footnote_reference] = STATE(462),
    [sym_footnote_marker_begin] = STATE(2584),
    [sym__image] = STATE(462),
    [sym_full_reference_image] = STATE(462),
    [sym_collapsed_reference_image] = STATE(462),
    [sym_inline_image] = STATE(462),
    [sym_image_description] = STATE(1271),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(462),
    [sym_full_reference_link] = STATE(462),
    [sym_collapsed_reference_link] = STATE(462),
    [sym_inline_link] = STATE(462),
    [sym_link_text] = STATE(1272),
    [sym_span] = STATE(978),
    [sym__bracketed_text_begin] = STATE(2619),
    [sym_inline_comment] = STATE(458),
    [sym_raw_inline] = STATE(458),
    [sym_math] = STATE(458),
    [sym_verbatim] = STATE(458),
    [sym__todo_highlights] = STATE(458),
    [sym_todo] = STATE(458),
    [sym_note] = STATE(458),
    [sym__symbol_fallback] = STATE(458),
    [aux_sym__text] = STATE(442),
    [aux_sym__inline_repeat1] = STATE(159),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [sym__whitespace1] = ACTIONS(1024),
    [sym_quotation_marks] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1026),
    [sym_em_dash] = ACTIONS(1026),
    [sym_en_dash] = ACTIONS(1028),
    [sym_backslash_escape] = ACTIONS(1028),
    [anon_sym_LT] = ACTIONS(1030),
    [sym_symbol] = ACTIONS(1026),
    [anon_sym_LBRACE_] = ACTIONS(1032),
    [anon_sym__] = ACTIONS(1034),
    [anon_sym_LBRACE_STAR] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_LBRACE_CARET] = ACTIONS(1040),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_LBRACE_EQ] = ACTIONS(1044),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1046),
    [anon_sym_LBRACE_DASH] = ACTIONS(1048),
    [anon_sym_LBRACK_CARET] = ACTIONS(1050),
    [anon_sym_BANG_LBRACK] = ACTIONS(1052),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1058),
    [anon_sym_TODO] = ACTIONS(1060),
    [anon_sym_WIP] = ACTIONS(1060),
    [anon_sym_NOTE] = ACTIONS(1062),
    [anon_sym_INFO] = ACTIONS(1062),
    [anon_sym_XXX] = ACTIONS(1062),
    [sym_fixme] = ACTIONS(1026),
    [aux_sym__text_token1] = ACTIONS(1064),
    [sym__newline_inline] = ACTIONS(1066),
    [sym_hard_line_break] = ACTIONS(1026),
    [sym__verbatim_begin] = ACTIONS(1068),
  },
  [278] = {
    [sym__inline] = STATE(2396),
    [sym__inline_element] = STATE(978),
    [sym__smart_punctuation] = STATE(458),
    [sym_autolink] = STATE(458),
    [sym_emphasis] = STATE(462),
    [sym_emphasis_begin] = STATE(2577),
    [sym_strong] = STATE(462),
    [sym_strong_begin] = STATE(2578),
    [sym_superscript] = STATE(462),
    [sym_superscript_begin] = STATE(2579),
    [sym_subscript] = STATE(462),
    [sym_subscript_begin] = STATE(2580),
    [sym_highlighted] = STATE(462),
    [sym_highlighted_begin] = STATE(2581),
    [sym_insert] = STATE(462),
    [sym_insert_begin] = STATE(2582),
    [sym_delete] = STATE(462),
    [sym_delete_begin] = STATE(2583),
    [sym_footnote_reference] = STATE(462),
    [sym_footnote_marker_begin] = STATE(2584),
    [sym__image] = STATE(462),
    [sym_full_reference_image] = STATE(462),
    [sym_collapsed_reference_image] = STATE(462),
    [sym_inline_image] = STATE(462),
    [sym_image_description] = STATE(1271),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(462),
    [sym_full_reference_link] = STATE(462),
    [sym_collapsed_reference_link] = STATE(462),
    [sym_inline_link] = STATE(462),
    [sym_link_text] = STATE(1272),
    [sym_span] = STATE(978),
    [sym__bracketed_text_begin] = STATE(2619),
    [sym_inline_comment] = STATE(458),
    [sym_raw_inline] = STATE(458),
    [sym_math] = STATE(458),
    [sym_verbatim] = STATE(458),
    [sym__todo_highlights] = STATE(458),
    [sym_todo] = STATE(458),
    [sym_note] = STATE(458),
    [sym__symbol_fallback] = STATE(458),
    [aux_sym__text] = STATE(442),
    [aux_sym__inline_repeat1] = STATE(159),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [sym__whitespace1] = ACTIONS(1024),
    [sym_quotation_marks] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1026),
    [sym_em_dash] = ACTIONS(1026),
    [sym_en_dash] = ACTIONS(1028),
    [sym_backslash_escape] = ACTIONS(1028),
    [anon_sym_LT] = ACTIONS(1030),
    [sym_symbol] = ACTIONS(1026),
    [anon_sym_LBRACE_] = ACTIONS(1032),
    [anon_sym__] = ACTIONS(1034),
    [anon_sym_LBRACE_STAR] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_LBRACE_CARET] = ACTIONS(1040),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_LBRACE_EQ] = ACTIONS(1044),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1046),
    [anon_sym_LBRACE_DASH] = ACTIONS(1048),
    [anon_sym_LBRACK_CARET] = ACTIONS(1050),
    [anon_sym_BANG_LBRACK] = ACTIONS(1052),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1058),
    [anon_sym_TODO] = ACTIONS(1060),
    [anon_sym_WIP] = ACTIONS(1060),
    [anon_sym_NOTE] = ACTIONS(1062),
    [anon_sym_INFO] = ACTIONS(1062),
    [anon_sym_XXX] = ACTIONS(1062),
    [sym_fixme] = ACTIONS(1026),
    [aux_sym__text_token1] = ACTIONS(1064),
    [sym__newline_inline] = ACTIONS(1066),
    [sym_hard_line_break] = ACTIONS(1026),
    [sym__verbatim_begin] = ACTIONS(1068),
  },
  [279] = {
    [sym__inline] = STATE(2413),
    [sym__inline_element] = STATE(978),
    [sym__smart_punctuation] = STATE(458),
    [sym_autolink] = STATE(458),
    [sym_emphasis] = STATE(462),
    [sym_emphasis_begin] = STATE(2577),
    [sym_strong] = STATE(462),
    [sym_strong_begin] = STATE(2578),
    [sym_superscript] = STATE(462),
    [sym_superscript_begin] = STATE(2579),
    [sym_subscript] = STATE(462),
    [sym_subscript_begin] = STATE(2580),
    [sym_highlighted] = STATE(462),
    [sym_highlighted_begin] = STATE(2581),
    [sym_insert] = STATE(462),
    [sym_insert_begin] = STATE(2582),
    [sym_delete] = STATE(462),
    [sym_delete_begin] = STATE(2583),
    [sym_footnote_reference] = STATE(462),
    [sym_footnote_marker_begin] = STATE(2584),
    [sym__image] = STATE(462),
    [sym_full_reference_image] = STATE(462),
    [sym_collapsed_reference_image] = STATE(462),
    [sym_inline_image] = STATE(462),
    [sym_image_description] = STATE(1271),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(462),
    [sym_full_reference_link] = STATE(462),
    [sym_collapsed_reference_link] = STATE(462),
    [sym_inline_link] = STATE(462),
    [sym_link_text] = STATE(1272),
    [sym_span] = STATE(978),
    [sym__bracketed_text_begin] = STATE(2619),
    [sym_inline_comment] = STATE(458),
    [sym_raw_inline] = STATE(458),
    [sym_math] = STATE(458),
    [sym_verbatim] = STATE(458),
    [sym__todo_highlights] = STATE(458),
    [sym_todo] = STATE(458),
    [sym_note] = STATE(458),
    [sym__symbol_fallback] = STATE(458),
    [aux_sym__text] = STATE(442),
    [aux_sym__inline_repeat1] = STATE(159),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [sym__whitespace1] = ACTIONS(1024),
    [sym_quotation_marks] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1026),
    [sym_em_dash] = ACTIONS(1026),
    [sym_en_dash] = ACTIONS(1028),
    [sym_backslash_escape] = ACTIONS(1028),
    [anon_sym_LT] = ACTIONS(1030),
    [sym_symbol] = ACTIONS(1026),
    [anon_sym_LBRACE_] = ACTIONS(1032),
    [anon_sym__] = ACTIONS(1034),
    [anon_sym_LBRACE_STAR] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_LBRACE_CARET] = ACTIONS(1040),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_LBRACE_EQ] = ACTIONS(1044),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1046),
    [anon_sym_LBRACE_DASH] = ACTIONS(1048),
    [anon_sym_LBRACK_CARET] = ACTIONS(1050),
    [anon_sym_BANG_LBRACK] = ACTIONS(1052),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1058),
    [anon_sym_TODO] = ACTIONS(1060),
    [anon_sym_WIP] = ACTIONS(1060),
    [anon_sym_NOTE] = ACTIONS(1062),
    [anon_sym_INFO] = ACTIONS(1062),
    [anon_sym_XXX] = ACTIONS(1062),
    [sym_fixme] = ACTIONS(1026),
    [aux_sym__text_token1] = ACTIONS(1064),
    [sym__newline_inline] = ACTIONS(1066),
    [sym_hard_line_break] = ACTIONS(1026),
    [sym__verbatim_begin] = ACTIONS(1068),
  },
  [280] = {
    [sym__inline] = STATE(2430),
    [sym__inline_element] = STATE(978),
    [sym__smart_punctuation] = STATE(458),
    [sym_autolink] = STATE(458),
    [sym_emphasis] = STATE(462),
    [sym_emphasis_begin] = STATE(2577),
    [sym_strong] = STATE(462),
    [sym_strong_begin] = STATE(2578),
    [sym_superscript] = STATE(462),
    [sym_superscript_begin] = STATE(2579),
    [sym_subscript] = STATE(462),
    [sym_subscript_begin] = STATE(2580),
    [sym_highlighted] = STATE(462),
    [sym_highlighted_begin] = STATE(2581),
    [sym_insert] = STATE(462),
    [sym_insert_begin] = STATE(2582),
    [sym_delete] = STATE(462),
    [sym_delete_begin] = STATE(2583),
    [sym_footnote_reference] = STATE(462),
    [sym_footnote_marker_begin] = STATE(2584),
    [sym__image] = STATE(462),
    [sym_full_reference_image] = STATE(462),
    [sym_collapsed_reference_image] = STATE(462),
    [sym_inline_image] = STATE(462),
    [sym_image_description] = STATE(1271),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(462),
    [sym_full_reference_link] = STATE(462),
    [sym_collapsed_reference_link] = STATE(462),
    [sym_inline_link] = STATE(462),
    [sym_link_text] = STATE(1272),
    [sym_span] = STATE(978),
    [sym__bracketed_text_begin] = STATE(2619),
    [sym_inline_comment] = STATE(458),
    [sym_raw_inline] = STATE(458),
    [sym_math] = STATE(458),
    [sym_verbatim] = STATE(458),
    [sym__todo_highlights] = STATE(458),
    [sym_todo] = STATE(458),
    [sym_note] = STATE(458),
    [sym__symbol_fallback] = STATE(458),
    [aux_sym__text] = STATE(442),
    [aux_sym__inline_repeat1] = STATE(159),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [sym__whitespace1] = ACTIONS(1024),
    [sym_quotation_marks] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1026),
    [sym_em_dash] = ACTIONS(1026),
    [sym_en_dash] = ACTIONS(1028),
    [sym_backslash_escape] = ACTIONS(1028),
    [anon_sym_LT] = ACTIONS(1030),
    [sym_symbol] = ACTIONS(1026),
    [anon_sym_LBRACE_] = ACTIONS(1032),
    [anon_sym__] = ACTIONS(1034),
    [anon_sym_LBRACE_STAR] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_LBRACE_CARET] = ACTIONS(1040),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_LBRACE_EQ] = ACTIONS(1044),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1046),
    [anon_sym_LBRACE_DASH] = ACTIONS(1048),
    [anon_sym_LBRACK_CARET] = ACTIONS(1050),
    [anon_sym_BANG_LBRACK] = ACTIONS(1052),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1058),
    [anon_sym_TODO] = ACTIONS(1060),
    [anon_sym_WIP] = ACTIONS(1060),
    [anon_sym_NOTE] = ACTIONS(1062),
    [anon_sym_INFO] = ACTIONS(1062),
    [anon_sym_XXX] = ACTIONS(1062),
    [sym_fixme] = ACTIONS(1026),
    [aux_sym__text_token1] = ACTIONS(1064),
    [sym__newline_inline] = ACTIONS(1066),
    [sym_hard_line_break] = ACTIONS(1026),
    [sym__verbatim_begin] = ACTIONS(1068),
  },
  [281] = {
    [sym__inline] = STATE(2447),
    [sym__inline_element] = STATE(978),
    [sym__smart_punctuation] = STATE(458),
    [sym_autolink] = STATE(458),
    [sym_emphasis] = STATE(462),
    [sym_emphasis_begin] = STATE(2577),
    [sym_strong] = STATE(462),
    [sym_strong_begin] = STATE(2578),
    [sym_superscript] = STATE(462),
    [sym_superscript_begin] = STATE(2579),
    [sym_subscript] = STATE(462),
    [sym_subscript_begin] = STATE(2580),
    [sym_highlighted] = STATE(462),
    [sym_highlighted_begin] = STATE(2581),
    [sym_insert] = STATE(462),
    [sym_insert_begin] = STATE(2582),
    [sym_delete] = STATE(462),
    [sym_delete_begin] = STATE(2583),
    [sym_footnote_reference] = STATE(462),
    [sym_footnote_marker_begin] = STATE(2584),
    [sym__image] = STATE(462),
    [sym_full_reference_image] = STATE(462),
    [sym_collapsed_reference_image] = STATE(462),
    [sym_inline_image] = STATE(462),
    [sym_image_description] = STATE(1271),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(462),
    [sym_full_reference_link] = STATE(462),
    [sym_collapsed_reference_link] = STATE(462),
    [sym_inline_link] = STATE(462),
    [sym_link_text] = STATE(1272),
    [sym_span] = STATE(978),
    [sym__bracketed_text_begin] = STATE(2619),
    [sym_inline_comment] = STATE(458),
    [sym_raw_inline] = STATE(458),
    [sym_math] = STATE(458),
    [sym_verbatim] = STATE(458),
    [sym__todo_highlights] = STATE(458),
    [sym_todo] = STATE(458),
    [sym_note] = STATE(458),
    [sym__symbol_fallback] = STATE(458),
    [aux_sym__text] = STATE(442),
    [aux_sym__inline_repeat1] = STATE(159),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [sym__whitespace1] = ACTIONS(1024),
    [sym_quotation_marks] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1026),
    [sym_em_dash] = ACTIONS(1026),
    [sym_en_dash] = ACTIONS(1028),
    [sym_backslash_escape] = ACTIONS(1028),
    [anon_sym_LT] = ACTIONS(1030),
    [sym_symbol] = ACTIONS(1026),
    [anon_sym_LBRACE_] = ACTIONS(1032),
    [anon_sym__] = ACTIONS(1034),
    [anon_sym_LBRACE_STAR] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_LBRACE_CARET] = ACTIONS(1040),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_LBRACE_EQ] = ACTIONS(1044),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1046),
    [anon_sym_LBRACE_DASH] = ACTIONS(1048),
    [anon_sym_LBRACK_CARET] = ACTIONS(1050),
    [anon_sym_BANG_LBRACK] = ACTIONS(1052),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1058),
    [anon_sym_TODO] = ACTIONS(1060),
    [anon_sym_WIP] = ACTIONS(1060),
    [anon_sym_NOTE] = ACTIONS(1062),
    [anon_sym_INFO] = ACTIONS(1062),
    [anon_sym_XXX] = ACTIONS(1062),
    [sym_fixme] = ACTIONS(1026),
    [aux_sym__text_token1] = ACTIONS(1064),
    [sym__newline_inline] = ACTIONS(1066),
    [sym_hard_line_break] = ACTIONS(1026),
    [sym__verbatim_begin] = ACTIONS(1068),
  },
  [282] = {
    [sym__inline] = STATE(2601),
    [sym__inline_element] = STATE(982),
    [sym__smart_punctuation] = STATE(452),
    [sym_autolink] = STATE(452),
    [sym_emphasis] = STATE(453),
    [sym_emphasis_begin] = STATE(2470),
    [sym_strong] = STATE(453),
    [sym_strong_begin] = STATE(2471),
    [sym_superscript] = STATE(453),
    [sym_superscript_begin] = STATE(2472),
    [sym_subscript] = STATE(453),
    [sym_subscript_begin] = STATE(2473),
    [sym_highlighted] = STATE(453),
    [sym_highlighted_begin] = STATE(2474),
    [sym_insert] = STATE(453),
    [sym_insert_begin] = STATE(2475),
    [sym_delete] = STATE(453),
    [sym_delete_begin] = STATE(2476),
    [sym_footnote_reference] = STATE(453),
    [sym_footnote_marker_begin] = STATE(2477),
    [sym__image] = STATE(453),
    [sym_full_reference_image] = STATE(453),
    [sym_collapsed_reference_image] = STATE(453),
    [sym_inline_image] = STATE(453),
    [sym_image_description] = STATE(1282),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(453),
    [sym_full_reference_link] = STATE(453),
    [sym_collapsed_reference_link] = STATE(453),
    [sym_inline_link] = STATE(453),
    [sym_link_text] = STATE(1299),
    [sym_span] = STATE(982),
    [sym__bracketed_text_begin] = STATE(2603),
    [sym_inline_comment] = STATE(452),
    [sym_raw_inline] = STATE(452),
    [sym_math] = STATE(452),
    [sym_verbatim] = STATE(452),
    [sym__todo_highlights] = STATE(452),
    [sym_todo] = STATE(452),
    [sym_note] = STATE(452),
    [sym__symbol_fallback] = STATE(452),
    [aux_sym__text] = STATE(437),
    [aux_sym__inline_repeat1] = STATE(144),
    [anon_sym_LBRACK] = ACTIONS(1120),
    [sym__whitespace1] = ACTIONS(1122),
    [sym_quotation_marks] = ACTIONS(1124),
    [sym_ellipsis] = ACTIONS(1124),
    [sym_em_dash] = ACTIONS(1124),
    [sym_en_dash] = ACTIONS(1126),
    [sym_backslash_escape] = ACTIONS(1126),
    [anon_sym_LT] = ACTIONS(1128),
    [sym_symbol] = ACTIONS(1124),
    [anon_sym_LBRACE_] = ACTIONS(1130),
    [anon_sym__] = ACTIONS(1132),
    [anon_sym_LBRACE_STAR] = ACTIONS(1134),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACE_CARET] = ACTIONS(1138),
    [anon_sym_CARET] = ACTIONS(1138),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_LBRACE_EQ] = ACTIONS(1142),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1144),
    [anon_sym_LBRACE_DASH] = ACTIONS(1146),
    [anon_sym_LBRACK_CARET] = ACTIONS(1148),
    [anon_sym_BANG_LBRACK] = ACTIONS(1150),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1152),
    [anon_sym_LPAREN] = ACTIONS(1154),
    [anon_sym_DOLLAR] = ACTIONS(1156),
    [anon_sym_TODO] = ACTIONS(1158),
    [anon_sym_WIP] = ACTIONS(1158),
    [anon_sym_NOTE] = ACTIONS(1160),
    [anon_sym_INFO] = ACTIONS(1160),
    [anon_sym_XXX] = ACTIONS(1160),
    [sym_fixme] = ACTIONS(1124),
    [aux_sym__text_token1] = ACTIONS(1162),
    [sym__newline_inline] = ACTIONS(1164),
    [sym_hard_line_break] = ACTIONS(1124),
    [sym__verbatim_begin] = ACTIONS(1166),
  },
  [283] = {
    [sym__inline] = STATE(2605),
    [sym__inline_element] = STATE(982),
    [sym__smart_punctuation] = STATE(452),
    [sym_autolink] = STATE(452),
    [sym_emphasis] = STATE(453),
    [sym_emphasis_begin] = STATE(2470),
    [sym_strong] = STATE(453),
    [sym_strong_begin] = STATE(2471),
    [sym_superscript] = STATE(453),
    [sym_superscript_begin] = STATE(2472),
    [sym_subscript] = STATE(453),
    [sym_subscript_begin] = STATE(2473),
    [sym_highlighted] = STATE(453),
    [sym_highlighted_begin] = STATE(2474),
    [sym_insert] = STATE(453),
    [sym_insert_begin] = STATE(2475),
    [sym_delete] = STATE(453),
    [sym_delete_begin] = STATE(2476),
    [sym_footnote_reference] = STATE(453),
    [sym_footnote_marker_begin] = STATE(2477),
    [sym__image] = STATE(453),
    [sym_full_reference_image] = STATE(453),
    [sym_collapsed_reference_image] = STATE(453),
    [sym_inline_image] = STATE(453),
    [sym_image_description] = STATE(1282),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(453),
    [sym_full_reference_link] = STATE(453),
    [sym_collapsed_reference_link] = STATE(453),
    [sym_inline_link] = STATE(453),
    [sym_link_text] = STATE(1299),
    [sym_span] = STATE(982),
    [sym__bracketed_text_begin] = STATE(2603),
    [sym_inline_comment] = STATE(452),
    [sym_raw_inline] = STATE(452),
    [sym_math] = STATE(452),
    [sym_verbatim] = STATE(452),
    [sym__todo_highlights] = STATE(452),
    [sym_todo] = STATE(452),
    [sym_note] = STATE(452),
    [sym__symbol_fallback] = STATE(452),
    [aux_sym__text] = STATE(437),
    [aux_sym__inline_repeat1] = STATE(144),
    [anon_sym_LBRACK] = ACTIONS(1120),
    [sym__whitespace1] = ACTIONS(1122),
    [sym_quotation_marks] = ACTIONS(1124),
    [sym_ellipsis] = ACTIONS(1124),
    [sym_em_dash] = ACTIONS(1124),
    [sym_en_dash] = ACTIONS(1126),
    [sym_backslash_escape] = ACTIONS(1126),
    [anon_sym_LT] = ACTIONS(1128),
    [sym_symbol] = ACTIONS(1124),
    [anon_sym_LBRACE_] = ACTIONS(1130),
    [anon_sym__] = ACTIONS(1132),
    [anon_sym_LBRACE_STAR] = ACTIONS(1134),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_LBRACE_CARET] = ACTIONS(1138),
    [anon_sym_CARET] = ACTIONS(1138),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_LBRACE_EQ] = ACTIONS(1142),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1144),
    [anon_sym_LBRACE_DASH] = ACTIONS(1146),
    [anon_sym_LBRACK_CARET] = ACTIONS(1148),
    [anon_sym_BANG_LBRACK] = ACTIONS(1150),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1152),
    [anon_sym_LPAREN] = ACTIONS(1154),
    [anon_sym_DOLLAR] = ACTIONS(1156),
    [anon_sym_TODO] = ACTIONS(1158),
    [anon_sym_WIP] = ACTIONS(1158),
    [anon_sym_NOTE] = ACTIONS(1160),
    [anon_sym_INFO] = ACTIONS(1160),
    [anon_sym_XXX] = ACTIONS(1160),
    [sym_fixme] = ACTIONS(1124),
    [aux_sym__text_token1] = ACTIONS(1162),
    [sym__newline_inline] = ACTIONS(1164),
    [sym_hard_line_break] = ACTIONS(1124),
    [sym__verbatim_begin] = ACTIONS(1166),
  },
  [284] = {
    [sym__inline_without_trailing_space] = STATE(2177),
    [sym__inline_element] = STATE(988),
    [sym__smart_punctuation] = STATE(460),
    [sym_autolink] = STATE(460),
    [sym_emphasis] = STATE(463),
    [sym_emphasis_begin] = STATE(2484),
    [sym_strong] = STATE(463),
    [sym_strong_begin] = STATE(2485),
    [sym_superscript] = STATE(463),
    [sym_superscript_begin] = STATE(2486),
    [sym_subscript] = STATE(463),
    [sym_subscript_begin] = STATE(2487),
    [sym_highlighted] = STATE(463),
    [sym_highlighted_begin] = STATE(2488),
    [sym_insert] = STATE(463),
    [sym_insert_begin] = STATE(2489),
    [sym_delete] = STATE(463),
    [sym_delete_begin] = STATE(2490),
    [sym_footnote_reference] = STATE(463),
    [sym_footnote_marker_begin] = STATE(2491),
    [sym__image] = STATE(463),
    [sym_full_reference_image] = STATE(463),
    [sym_collapsed_reference_image] = STATE(463),
    [sym_inline_image] = STATE(463),
    [sym_image_description] = STATE(1268),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(463),
    [sym_full_reference_link] = STATE(463),
    [sym_collapsed_reference_link] = STATE(463),
    [sym_inline_link] = STATE(463),
    [sym_link_text] = STATE(1273),
    [sym_span] = STATE(988),
    [sym__bracketed_text_begin] = STATE(2607),
    [sym_inline_comment] = STATE(460),
    [sym_raw_inline] = STATE(460),
    [sym_math] = STATE(460),
    [sym_verbatim] = STATE(460),
    [sym__todo_highlights] = STATE(460),
    [sym_todo] = STATE(460),
    [sym_note] = STATE(460),
    [sym__symbol_fallback] = STATE(460),
    [aux_sym__text] = STATE(444),
    [aux_sym__inline_repeat1] = STATE(286),
    [anon_sym_LBRACK] = ACTIONS(1772),
    [sym__whitespace1] = ACTIONS(1774),
    [sym_quotation_marks] = ACTIONS(1776),
    [sym_ellipsis] = ACTIONS(1776),
    [sym_em_dash] = ACTIONS(1776),
    [sym_en_dash] = ACTIONS(1778),
    [sym_backslash_escape] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1780),
    [sym_symbol] = ACTIONS(1776),
    [anon_sym_LBRACE_] = ACTIONS(1782),
    [anon_sym__] = ACTIONS(1784),
    [anon_sym_LBRACE_STAR] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_LBRACE_CARET] = ACTIONS(1790),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1792),
    [anon_sym_LBRACE_EQ] = ACTIONS(1794),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1796),
    [anon_sym_LBRACE_DASH] = ACTIONS(1798),
    [anon_sym_LBRACK_CARET] = ACTIONS(1800),
    [anon_sym_BANG_LBRACK] = ACTIONS(1802),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1804),
    [anon_sym_LPAREN] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [anon_sym_TODO] = ACTIONS(1810),
    [anon_sym_WIP] = ACTIONS(1810),
    [anon_sym_NOTE] = ACTIONS(1812),
    [anon_sym_INFO] = ACTIONS(1812),
    [anon_sym_XXX] = ACTIONS(1812),
    [sym_fixme] = ACTIONS(1776),
    [aux_sym__text_token1] = ACTIONS(1814),
    [sym__newline_inline] = ACTIONS(1816),
    [sym_hard_line_break] = ACTIONS(1776),
    [sym__verbatim_begin] = ACTIONS(1818),
  },
  [285] = {
    [sym__inline_element] = STATE(1022),
    [sym__smart_punctuation] = STATE(483),
    [sym_autolink] = STATE(483),
    [sym_emphasis] = STATE(484),
    [sym_emphasis_begin] = STATE(2588),
    [sym_strong] = STATE(484),
    [sym_strong_begin] = STATE(2589),
    [sym_superscript] = STATE(484),
    [sym_superscript_begin] = STATE(2590),
    [sym_subscript] = STATE(484),
    [sym_subscript_begin] = STATE(2591),
    [sym_highlighted] = STATE(484),
    [sym_highlighted_begin] = STATE(2592),
    [sym_insert] = STATE(484),
    [sym_insert_begin] = STATE(2593),
    [sym_delete] = STATE(484),
    [sym_delete_begin] = STATE(2594),
    [sym_footnote_reference] = STATE(484),
    [sym_footnote_marker_begin] = STATE(2595),
    [sym__image] = STATE(484),
    [sym_full_reference_image] = STATE(484),
    [sym_collapsed_reference_image] = STATE(484),
    [sym_inline_image] = STATE(484),
    [sym_image_description] = STATE(1278),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(484),
    [sym_full_reference_link] = STATE(484),
    [sym_collapsed_reference_link] = STATE(484),
    [sym_inline_link] = STATE(484),
    [sym_link_text] = STATE(1279),
    [sym_span] = STATE(1022),
    [sym__bracketed_text_begin] = STATE(2620),
    [sym_inline_comment] = STATE(483),
    [sym_raw_inline] = STATE(483),
    [sym_math] = STATE(483),
    [sym_verbatim] = STATE(483),
    [sym__todo_highlights] = STATE(483),
    [sym_todo] = STATE(483),
    [sym_note] = STATE(483),
    [sym__symbol_fallback] = STATE(483),
    [aux_sym__text] = STATE(466),
    [aux_sym__inline_repeat1] = STATE(285),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [sym__whitespace1] = ACTIONS(2276),
    [sym_quotation_marks] = ACTIONS(2279),
    [sym_ellipsis] = ACTIONS(2279),
    [sym_em_dash] = ACTIONS(2279),
    [sym_en_dash] = ACTIONS(2282),
    [sym_backslash_escape] = ACTIONS(2282),
    [anon_sym_LT] = ACTIONS(2285),
    [sym_symbol] = ACTIONS(2279),
    [anon_sym_LBRACE_] = ACTIONS(2288),
    [anon_sym__] = ACTIONS(2291),
    [anon_sym_LBRACE_STAR] = ACTIONS(2294),
    [anon_sym_STAR] = ACTIONS(2297),
    [anon_sym_LBRACE_CARET] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2300),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [anon_sym_LBRACE_EQ] = ACTIONS(2306),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2309),
    [anon_sym_LBRACE_DASH] = ACTIONS(2312),
    [anon_sym_LBRACK_CARET] = ACTIONS(2315),
    [anon_sym_BANG_LBRACK] = ACTIONS(2318),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2324),
    [anon_sym_DOLLAR] = ACTIONS(2327),
    [anon_sym_TODO] = ACTIONS(2330),
    [anon_sym_WIP] = ACTIONS(2330),
    [anon_sym_NOTE] = ACTIONS(2333),
    [anon_sym_INFO] = ACTIONS(2333),
    [anon_sym_XXX] = ACTIONS(2333),
    [sym_fixme] = ACTIONS(2279),
    [aux_sym__text_token1] = ACTIONS(2336),
    [sym__newline_inline] = ACTIONS(2339),
    [sym_hard_line_break] = ACTIONS(2279),
    [sym__verbatim_begin] = ACTIONS(2342),
  },
  [286] = {
    [sym__inline_element] = STATE(1009),
    [sym__smart_punctuation] = STATE(460),
    [sym_autolink] = STATE(460),
    [sym_emphasis] = STATE(463),
    [sym_emphasis_begin] = STATE(2484),
    [sym_strong] = STATE(463),
    [sym_strong_begin] = STATE(2485),
    [sym_superscript] = STATE(463),
    [sym_superscript_begin] = STATE(2486),
    [sym_subscript] = STATE(463),
    [sym_subscript_begin] = STATE(2487),
    [sym_highlighted] = STATE(463),
    [sym_highlighted_begin] = STATE(2488),
    [sym_insert] = STATE(463),
    [sym_insert_begin] = STATE(2489),
    [sym_delete] = STATE(463),
    [sym_delete_begin] = STATE(2490),
    [sym_footnote_reference] = STATE(463),
    [sym_footnote_marker_begin] = STATE(2491),
    [sym__image] = STATE(463),
    [sym_full_reference_image] = STATE(463),
    [sym_collapsed_reference_image] = STATE(463),
    [sym_inline_image] = STATE(463),
    [sym_image_description] = STATE(1268),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(463),
    [sym_full_reference_link] = STATE(463),
    [sym_collapsed_reference_link] = STATE(463),
    [sym_inline_link] = STATE(463),
    [sym_link_text] = STATE(1273),
    [sym_span] = STATE(1009),
    [sym__bracketed_text_begin] = STATE(2607),
    [sym_inline_comment] = STATE(460),
    [sym_raw_inline] = STATE(460),
    [sym_math] = STATE(460),
    [sym_verbatim] = STATE(460),
    [sym__todo_highlights] = STATE(460),
    [sym_todo] = STATE(460),
    [sym_note] = STATE(460),
    [sym__symbol_fallback] = STATE(460),
    [aux_sym__text] = STATE(444),
    [aux_sym__inline_repeat1] = STATE(285),
    [anon_sym_LBRACK] = ACTIONS(1772),
    [sym__whitespace1] = ACTIONS(1774),
    [sym_quotation_marks] = ACTIONS(1776),
    [sym_ellipsis] = ACTIONS(1776),
    [sym_em_dash] = ACTIONS(1776),
    [sym_en_dash] = ACTIONS(1778),
    [sym_backslash_escape] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1780),
    [sym_symbol] = ACTIONS(1776),
    [anon_sym_LBRACE_] = ACTIONS(1782),
    [anon_sym__] = ACTIONS(1784),
    [anon_sym_LBRACE_STAR] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_LBRACE_CARET] = ACTIONS(1790),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LBRACE_TILDE] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1792),
    [anon_sym_LBRACE_EQ] = ACTIONS(1794),
    [anon_sym_LBRACE_PLUS] = ACTIONS(1796),
    [anon_sym_LBRACE_DASH] = ACTIONS(1798),
    [anon_sym_LBRACK_CARET] = ACTIONS(1800),
    [anon_sym_BANG_LBRACK] = ACTIONS(1802),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(1804),
    [anon_sym_LPAREN] = ACTIONS(1806),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [anon_sym_TODO] = ACTIONS(1810),
    [anon_sym_WIP] = ACTIONS(1810),
    [anon_sym_NOTE] = ACTIONS(1812),
    [anon_sym_INFO] = ACTIONS(1812),
    [anon_sym_XXX] = ACTIONS(1812),
    [sym_fixme] = ACTIONS(1776),
    [aux_sym__text_token1] = ACTIONS(1814),
    [sym__newline_inline] = ACTIONS(2345),
    [sym_hard_line_break] = ACTIONS(1776),
    [sym__verbatim_begin] = ACTIONS(1818),
  },
  [287] = {
    [sym__inline_element] = STATE(964),
    [sym__smart_punctuation] = STATE(464),
    [sym_autolink] = STATE(464),
    [sym_emphasis] = STATE(465),
    [sym_emphasis_begin] = STATE(2498),
    [sym_strong] = STATE(465),
    [sym_strong_begin] = STATE(2499),
    [sym_superscript] = STATE(465),
    [sym_superscript_begin] = STATE(2500),
    [sym_subscript] = STATE(465),
    [sym_subscript_begin] = STATE(2501),
    [sym_highlighted] = STATE(465),
    [sym_highlighted_begin] = STATE(2502),
    [sym_insert] = STATE(465),
    [sym_insert_begin] = STATE(2503),
    [sym_delete] = STATE(465),
    [sym_delete_begin] = STATE(2504),
    [sym_footnote_reference] = STATE(465),
    [sym_footnote_marker_begin] = STATE(2505),
    [sym__image] = STATE(465),
    [sym_full_reference_image] = STATE(465),
    [sym_collapsed_reference_image] = STATE(465),
    [sym_inline_image] = STATE(465),
    [sym_image_description] = STATE(1314),
    [sym__image_description_begin] = STATE(2260),
    [sym__link] = STATE(465),
    [sym_full_reference_link] = STATE(465),
    [sym_collapsed_reference_link] = STATE(465),
    [sym_inline_link] = STATE(465),
    [sym_link_text] = STATE(1319),
    [sym_span] = STATE(964),
    [sym__bracketed_text_begin] = STATE(2610),
    [sym_inline_comment] = STATE(464),
    [sym_raw_inline] = STATE(464),
    [sym_math] = STATE(464),
    [sym_verbatim] = STATE(464),
    [sym__todo_highlights] = STATE(464),
    [sym_todo] = STATE(464),
    [sym_note] = STATE(464),
    [sym__symbol_fallback] = STATE(464),
    [aux_sym__text] = STATE(445),
    [aux_sym__inline_repeat1] = STATE(285),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [sym__whitespace1] = ACTIONS(2136),
    [sym_quotation_marks] = ACTIONS(2138),
    [sym_ellipsis] = ACTIONS(2138),
    [sym_em_dash] = ACTIONS(2138),
    [sym_en_dash] = ACTIONS(2140),
    [sym_backslash_escape] = ACTIONS(2140),
    [anon_sym_LT] = ACTIONS(2142),
    [sym_symbol] = ACTIONS(2138),
    [anon_sym_LBRACE_] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_LBRACE_STAR] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_LBRACE_CARET] = ACTIONS(2152),
    [anon_sym_CARET] = ACTIONS(2152),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_LBRACE_EQ] = ACTIONS(2156),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2158),
    [anon_sym_LBRACE_DASH] = ACTIONS(2160),
    [anon_sym_LBRACK_CARET] = ACTIONS(2162),
    [anon_sym_BANG_LBRACK] = ACTIONS(2164),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_TODO] = ACTIONS(2172),
    [anon_sym_WIP] = ACTIONS(2172),
    [anon_sym_NOTE] = ACTIONS(2174),
    [anon_sym_INFO] = ACTIONS(2174),
    [anon_sym_XXX] = ACTIONS(2174),
    [sym_fixme] = ACTIONS(2138),
    [aux_sym__text_token1] = ACTIONS(2176),
    [sym__newline_inline] = ACTIONS(2345),
    [sym_hard_line_break] = ACTIONS(2138),
    [sym__verbatim_begin] = ACTIONS(2180),
  },
  [288] = {
    [sym_table_caption] = STATE(374),
    [ts_builtin_sym_end] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2349),
    [sym__whitespace1] = ACTIONS(2347),
    [sym_quotation_marks] = ACTIONS(2347),
    [sym_ellipsis] = ACTIONS(2347),
    [sym_em_dash] = ACTIONS(2347),
    [sym_en_dash] = ACTIONS(2349),
    [sym_backslash_escape] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(2347),
    [sym_symbol] = ACTIONS(2347),
    [anon_sym_LBRACE_] = ACTIONS(2347),
    [anon_sym__] = ACTIONS(2347),
    [anon_sym_LBRACE_STAR] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2347),
    [anon_sym_LBRACE_CARET] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2347),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_LBRACE_EQ] = ACTIONS(2347),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2347),
    [anon_sym_LBRACE_DASH] = ACTIONS(2347),
    [anon_sym_LBRACK_CARET] = ACTIONS(2347),
    [anon_sym_BANG_LBRACK] = ACTIONS(2347),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2347),
    [anon_sym_TODO] = ACTIONS(2347),
    [anon_sym_WIP] = ACTIONS(2347),
    [anon_sym_NOTE] = ACTIONS(2347),
    [anon_sym_INFO] = ACTIONS(2347),
    [anon_sym_XXX] = ACTIONS(2347),
    [sym_fixme] = ACTIONS(2347),
    [aux_sym__text_token1] = ACTIONS(2349),
    [sym__newline] = ACTIONS(2347),
    [sym__newline_inline] = ACTIONS(2347),
    [sym_hard_line_break] = ACTIONS(2347),
    [sym__heading_begin] = ACTIONS(2347),
    [sym__div_begin] = ACTIONS(2347),
    [sym__code_block_begin] = ACTIONS(2347),
    [sym_list_marker_dash] = ACTIONS(2347),
    [sym_list_marker_star] = ACTIONS(2347),
    [sym_list_marker_plus] = ACTIONS(2347),
    [sym__list_marker_task_begin] = ACTIONS(2347),
    [sym_list_marker_definition] = ACTIONS(2347),
    [sym_list_marker_decimal_period] = ACTIONS(2347),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2347),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2347),
    [sym_list_marker_lower_roman_period] = ACTIONS(2347),
    [sym_list_marker_upper_roman_period] = ACTIONS(2347),
    [sym_list_marker_decimal_paren] = ACTIONS(2347),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2347),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2347),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2347),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2347),
    [sym_list_marker_decimal_parens] = ACTIONS(2347),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2347),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2347),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2347),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2347),
    [sym__block_quote_begin] = ACTIONS(2347),
    [sym__block_quote_continuation] = ACTIONS(2347),
    [sym__thematic_break_dash] = ACTIONS(2347),
    [sym__thematic_break_star] = ACTIONS(2347),
    [sym__footnote_mark_begin] = ACTIONS(2347),
    [sym__link_ref_def_mark_begin] = ACTIONS(2347),
    [sym__table_header_begin] = ACTIONS(2347),
    [sym__table_separator_begin] = ACTIONS(2347),
    [sym__table_row_begin] = ACTIONS(2347),
    [sym__table_caption_begin] = ACTIONS(1016),
    [sym__block_attribute_begin] = ACTIONS(2347),
    [sym__verbatim_begin] = ACTIONS(2347),
  },
  [289] = {
    [sym_table_caption] = STATE(401),
    [anon_sym_LBRACK] = ACTIONS(2349),
    [sym__whitespace1] = ACTIONS(2347),
    [sym_quotation_marks] = ACTIONS(2347),
    [sym_ellipsis] = ACTIONS(2347),
    [sym_em_dash] = ACTIONS(2347),
    [sym_en_dash] = ACTIONS(2349),
    [sym_backslash_escape] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(2347),
    [sym_symbol] = ACTIONS(2347),
    [anon_sym_LBRACE_] = ACTIONS(2347),
    [anon_sym__] = ACTIONS(2347),
    [anon_sym_LBRACE_STAR] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2347),
    [anon_sym_LBRACE_CARET] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2347),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_LBRACE_EQ] = ACTIONS(2347),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2347),
    [anon_sym_LBRACE_DASH] = ACTIONS(2347),
    [anon_sym_LBRACK_CARET] = ACTIONS(2347),
    [anon_sym_BANG_LBRACK] = ACTIONS(2347),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2347),
    [anon_sym_TODO] = ACTIONS(2347),
    [anon_sym_WIP] = ACTIONS(2347),
    [anon_sym_NOTE] = ACTIONS(2347),
    [anon_sym_INFO] = ACTIONS(2347),
    [anon_sym_XXX] = ACTIONS(2347),
    [sym_fixme] = ACTIONS(2347),
    [aux_sym__text_token1] = ACTIONS(2349),
    [sym__block_close] = ACTIONS(2347),
    [sym__newline] = ACTIONS(2347),
    [sym__newline_inline] = ACTIONS(2347),
    [sym_hard_line_break] = ACTIONS(2347),
    [sym__heading_begin] = ACTIONS(2347),
    [sym__div_begin] = ACTIONS(2347),
    [sym__code_block_begin] = ACTIONS(2347),
    [sym_list_marker_dash] = ACTIONS(2347),
    [sym_list_marker_star] = ACTIONS(2347),
    [sym_list_marker_plus] = ACTIONS(2347),
    [sym__list_marker_task_begin] = ACTIONS(2347),
    [sym_list_marker_definition] = ACTIONS(2347),
    [sym_list_marker_decimal_period] = ACTIONS(2347),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2347),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2347),
    [sym_list_marker_lower_roman_period] = ACTIONS(2347),
    [sym_list_marker_upper_roman_period] = ACTIONS(2347),
    [sym_list_marker_decimal_paren] = ACTIONS(2347),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2347),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2347),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2347),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2347),
    [sym_list_marker_decimal_parens] = ACTIONS(2347),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2347),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2347),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2347),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2347),
    [sym__block_quote_begin] = ACTIONS(2347),
    [sym__block_quote_continuation] = ACTIONS(2347),
    [sym__thematic_break_dash] = ACTIONS(2347),
    [sym__thematic_break_star] = ACTIONS(2347),
    [sym__footnote_mark_begin] = ACTIONS(2347),
    [sym__link_ref_def_mark_begin] = ACTIONS(2347),
    [sym__table_header_begin] = ACTIONS(2347),
    [sym__table_separator_begin] = ACTIONS(2347),
    [sym__table_row_begin] = ACTIONS(2347),
    [sym__table_caption_begin] = ACTIONS(1020),
    [sym__block_attribute_begin] = ACTIONS(2347),
    [sym__verbatim_begin] = ACTIONS(2347),
  },
  [290] = {
    [anon_sym_LBRACK] = ACTIONS(2351),
    [sym__whitespace1] = ACTIONS(2353),
    [sym_quotation_marks] = ACTIONS(2353),
    [sym_ellipsis] = ACTIONS(2353),
    [sym_em_dash] = ACTIONS(2353),
    [sym_en_dash] = ACTIONS(2351),
    [sym_backslash_escape] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [sym_symbol] = ACTIONS(2353),
    [anon_sym_LBRACE_] = ACTIONS(2353),
    [anon_sym__] = ACTIONS(2353),
    [anon_sym_LBRACE_STAR] = ACTIONS(2353),
    [anon_sym_STAR] = ACTIONS(2353),
    [anon_sym_LBRACE_CARET] = ACTIONS(2353),
    [anon_sym_CARET] = ACTIONS(2353),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2353),
    [anon_sym_TILDE] = ACTIONS(2353),
    [anon_sym_LBRACE_EQ] = ACTIONS(2353),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2353),
    [anon_sym_LBRACE_DASH] = ACTIONS(2353),
    [anon_sym_LBRACK_CARET] = ACTIONS(2353),
    [anon_sym_BANG_LBRACK] = ACTIONS(2353),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(2353),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [anon_sym_TODO] = ACTIONS(2353),
    [anon_sym_WIP] = ACTIONS(2353),
    [anon_sym_NOTE] = ACTIONS(2353),
    [anon_sym_INFO] = ACTIONS(2353),
    [anon_sym_XXX] = ACTIONS(2353),
    [sym_fixme] = ACTIONS(2353),
    [aux_sym__text_token1] = ACTIONS(2351),
    [sym__block_close] = ACTIONS(2353),
    [sym__eof_or_newline] = ACTIONS(2355),
    [sym__newline] = ACTIONS(2353),
    [sym__newline_inline] = ACTIONS(2353),
    [sym_hard_line_break] = ACTIONS(2353),
    [sym__heading_begin] = ACTIONS(2353),
    [sym__div_begin] = ACTIONS(2353),
    [sym__code_block_begin] = ACTIONS(2353),
    [sym_list_marker_dash] = ACTIONS(2353),
    [sym_list_marker_star] = ACTIONS(2353),
    [sym_list_marker_plus] = ACTIONS(2353),
    [sym__list_marker_task_begin] = ACTIONS(2353),
    [sym_list_marker_definition] = ACTIONS(2353),
    [sym_list_marker_decimal_period] = ACTIONS(2353),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2353),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2353),
    [sym_list_marker_lower_roman_period] = ACTIONS(2353),
    [sym_list_marker_upper_roman_period] = ACTIONS(2353),
    [sym_list_marker_decimal_paren] = ACTIONS(2353),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2353),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2353),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2353),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2353),
    [sym_list_marker_decimal_parens] = ACTIONS(2353),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2353),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2353),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2353),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2353),
    [sym__block_quote_begin] = ACTIONS(2353),
    [sym__block_quote_continuation] = ACTIONS(2353),
    [sym__thematic_break_dash] = ACTIONS(2353),
    [sym__thematic_break_star] = ACTIONS(2353),
    [sym__footnote_mark_begin] = ACTIONS(2353),
    [sym__link_ref_def_mark_begin] = ACTIONS(2353),
    [sym__table_header_begin] = ACTIONS(2353),
    [sym__table_separator_begin] = ACTIONS(2353),
    [sym__table_row_begin] = ACTIONS(2353),
    [sym__block_attribute_begin] = ACTIONS(2353),
    [sym__verbatim_begin] = ACTIONS(2353),
  },
  [291] = {
    [ts_builtin_sym_end] = ACTIONS(2357),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [sym__whitespace1] = ACTIONS(2357),
    [sym_quotation_marks] = ACTIONS(2357),
    [sym_ellipsis] = ACTIONS(2357),
    [sym_em_dash] = ACTIONS(2357),
    [sym_en_dash] = ACTIONS(2359),
    [sym_backslash_escape] = ACTIONS(2359),
    [anon_sym_LT] = ACTIONS(2357),
    [sym_symbol] = ACTIONS(2357),
    [anon_sym_LBRACE_] = ACTIONS(2357),
    [anon_sym__] = ACTIONS(2357),
    [anon_sym_LBRACE_STAR] = ACTIONS(2357),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_LBRACE_CARET] = ACTIONS(2357),
    [anon_sym_CARET] = ACTIONS(2357),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2357),
    [anon_sym_LBRACE_EQ] = ACTIONS(2357),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2357),
    [anon_sym_LBRACE_DASH] = ACTIONS(2357),
    [anon_sym_LBRACK_CARET] = ACTIONS(2357),
    [anon_sym_BANG_LBRACK] = ACTIONS(2357),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2357),
    [anon_sym_LPAREN] = ACTIONS(2357),
    [anon_sym_DOLLAR] = ACTIONS(2357),
    [anon_sym_TODO] = ACTIONS(2357),
    [anon_sym_WIP] = ACTIONS(2357),
    [anon_sym_NOTE] = ACTIONS(2357),
    [anon_sym_INFO] = ACTIONS(2357),
    [anon_sym_XXX] = ACTIONS(2357),
    [sym_fixme] = ACTIONS(2357),
    [aux_sym__text_token1] = ACTIONS(2359),
    [sym__newline] = ACTIONS(2357),
    [sym__newline_inline] = ACTIONS(2357),
    [sym_hard_line_break] = ACTIONS(2357),
    [sym__heading_begin] = ACTIONS(2357),
    [sym__div_begin] = ACTIONS(2357),
    [sym__code_block_begin] = ACTIONS(2357),
    [sym_list_marker_dash] = ACTIONS(2357),
    [sym_list_marker_star] = ACTIONS(2357),
    [sym_list_marker_plus] = ACTIONS(2357),
    [sym__list_marker_task_begin] = ACTIONS(2357),
    [sym_list_marker_definition] = ACTIONS(2357),
    [sym_list_marker_decimal_period] = ACTIONS(2357),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2357),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2357),
    [sym_list_marker_lower_roman_period] = ACTIONS(2357),
    [sym_list_marker_upper_roman_period] = ACTIONS(2357),
    [sym_list_marker_decimal_paren] = ACTIONS(2357),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2357),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2357),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2357),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2357),
    [sym_list_marker_decimal_parens] = ACTIONS(2357),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2357),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2357),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2357),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2357),
    [sym__block_quote_begin] = ACTIONS(2357),
    [sym__block_quote_continuation] = ACTIONS(2357),
    [sym__thematic_break_dash] = ACTIONS(2357),
    [sym__thematic_break_star] = ACTIONS(2357),
    [sym__footnote_mark_begin] = ACTIONS(2357),
    [sym__link_ref_def_mark_begin] = ACTIONS(2357),
    [sym__table_header_begin] = ACTIONS(2357),
    [sym__table_separator_begin] = ACTIONS(2357),
    [sym__table_row_begin] = ACTIONS(2357),
    [sym__table_caption_begin] = ACTIONS(2357),
    [sym__block_attribute_begin] = ACTIONS(2357),
    [sym__verbatim_begin] = ACTIONS(2357),
  },
  [292] = {
    [ts_builtin_sym_end] = ACTIONS(2361),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [sym__whitespace1] = ACTIONS(2361),
    [sym_quotation_marks] = ACTIONS(2361),
    [sym_ellipsis] = ACTIONS(2361),
    [sym_em_dash] = ACTIONS(2361),
    [sym_en_dash] = ACTIONS(2363),
    [sym_backslash_escape] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2361),
    [sym_symbol] = ACTIONS(2361),
    [anon_sym_LBRACE_] = ACTIONS(2361),
    [anon_sym__] = ACTIONS(2361),
    [anon_sym_LBRACE_STAR] = ACTIONS(2361),
    [anon_sym_STAR] = ACTIONS(2361),
    [anon_sym_LBRACE_CARET] = ACTIONS(2361),
    [anon_sym_CARET] = ACTIONS(2361),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2361),
    [anon_sym_TILDE] = ACTIONS(2361),
    [anon_sym_LBRACE_EQ] = ACTIONS(2361),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2361),
    [anon_sym_LBRACE_DASH] = ACTIONS(2361),
    [anon_sym_LBRACK_CARET] = ACTIONS(2361),
    [anon_sym_BANG_LBRACK] = ACTIONS(2361),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2361),
    [anon_sym_DOLLAR] = ACTIONS(2361),
    [anon_sym_TODO] = ACTIONS(2361),
    [anon_sym_WIP] = ACTIONS(2361),
    [anon_sym_NOTE] = ACTIONS(2361),
    [anon_sym_INFO] = ACTIONS(2361),
    [anon_sym_XXX] = ACTIONS(2361),
    [sym_fixme] = ACTIONS(2361),
    [aux_sym__text_token1] = ACTIONS(2363),
    [sym__newline] = ACTIONS(2361),
    [sym__newline_inline] = ACTIONS(2361),
    [sym_hard_line_break] = ACTIONS(2361),
    [sym__heading_begin] = ACTIONS(2361),
    [sym__div_begin] = ACTIONS(2361),
    [sym__code_block_begin] = ACTIONS(2361),
    [sym_list_marker_dash] = ACTIONS(2361),
    [sym_list_marker_star] = ACTIONS(2361),
    [sym_list_marker_plus] = ACTIONS(2361),
    [sym__list_marker_task_begin] = ACTIONS(2361),
    [sym_list_marker_definition] = ACTIONS(2361),
    [sym_list_marker_decimal_period] = ACTIONS(2361),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2361),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2361),
    [sym_list_marker_lower_roman_period] = ACTIONS(2361),
    [sym_list_marker_upper_roman_period] = ACTIONS(2361),
    [sym_list_marker_decimal_paren] = ACTIONS(2361),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2361),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2361),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2361),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2361),
    [sym_list_marker_decimal_parens] = ACTIONS(2361),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2361),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2361),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2361),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2361),
    [sym__block_quote_begin] = ACTIONS(2361),
    [sym__block_quote_continuation] = ACTIONS(2361),
    [sym__thematic_break_dash] = ACTIONS(2361),
    [sym__thematic_break_star] = ACTIONS(2361),
    [sym__footnote_mark_begin] = ACTIONS(2361),
    [sym__link_ref_def_mark_begin] = ACTIONS(2361),
    [sym__table_header_begin] = ACTIONS(2361),
    [sym__table_separator_begin] = ACTIONS(2361),
    [sym__table_row_begin] = ACTIONS(2361),
    [sym__table_caption_begin] = ACTIONS(2361),
    [sym__block_attribute_begin] = ACTIONS(2361),
    [sym__verbatim_begin] = ACTIONS(2361),
  },
  [293] = {
    [ts_builtin_sym_end] = ACTIONS(2365),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [sym__whitespace1] = ACTIONS(2365),
    [sym_quotation_marks] = ACTIONS(2365),
    [sym_ellipsis] = ACTIONS(2365),
    [sym_em_dash] = ACTIONS(2365),
    [sym_en_dash] = ACTIONS(2367),
    [sym_backslash_escape] = ACTIONS(2367),
    [anon_sym_LT] = ACTIONS(2365),
    [sym_symbol] = ACTIONS(2365),
    [anon_sym_LBRACE_] = ACTIONS(2365),
    [anon_sym__] = ACTIONS(2365),
    [anon_sym_LBRACE_STAR] = ACTIONS(2365),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_LBRACE_CARET] = ACTIONS(2365),
    [anon_sym_CARET] = ACTIONS(2365),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2365),
    [anon_sym_TILDE] = ACTIONS(2365),
    [anon_sym_LBRACE_EQ] = ACTIONS(2365),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2365),
    [anon_sym_LBRACE_DASH] = ACTIONS(2365),
    [anon_sym_LBRACK_CARET] = ACTIONS(2365),
    [anon_sym_BANG_LBRACK] = ACTIONS(2365),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2365),
    [anon_sym_LPAREN] = ACTIONS(2365),
    [anon_sym_DOLLAR] = ACTIONS(2365),
    [anon_sym_TODO] = ACTIONS(2365),
    [anon_sym_WIP] = ACTIONS(2365),
    [anon_sym_NOTE] = ACTIONS(2365),
    [anon_sym_INFO] = ACTIONS(2365),
    [anon_sym_XXX] = ACTIONS(2365),
    [sym_fixme] = ACTIONS(2365),
    [aux_sym__text_token1] = ACTIONS(2367),
    [sym__newline] = ACTIONS(2365),
    [sym__newline_inline] = ACTIONS(2365),
    [sym_hard_line_break] = ACTIONS(2365),
    [sym__heading_begin] = ACTIONS(2365),
    [sym__div_begin] = ACTIONS(2365),
    [sym__div_end] = ACTIONS(2369),
    [sym__code_block_begin] = ACTIONS(2365),
    [sym_list_marker_dash] = ACTIONS(2365),
    [sym_list_marker_star] = ACTIONS(2365),
    [sym_list_marker_plus] = ACTIONS(2365),
    [sym__list_marker_task_begin] = ACTIONS(2365),
    [sym_list_marker_definition] = ACTIONS(2365),
    [sym_list_marker_decimal_period] = ACTIONS(2365),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2365),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2365),
    [sym_list_marker_lower_roman_period] = ACTIONS(2365),
    [sym_list_marker_upper_roman_period] = ACTIONS(2365),
    [sym_list_marker_decimal_paren] = ACTIONS(2365),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2365),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2365),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2365),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2365),
    [sym_list_marker_decimal_parens] = ACTIONS(2365),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2365),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2365),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2365),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2365),
    [sym__block_quote_begin] = ACTIONS(2365),
    [sym__block_quote_continuation] = ACTIONS(2365),
    [sym__thematic_break_dash] = ACTIONS(2365),
    [sym__thematic_break_star] = ACTIONS(2365),
    [sym__footnote_mark_begin] = ACTIONS(2365),
    [sym__link_ref_def_mark_begin] = ACTIONS(2365),
    [sym__table_header_begin] = ACTIONS(2365),
    [sym__table_separator_begin] = ACTIONS(2365),
    [sym__table_row_begin] = ACTIONS(2365),
    [sym__block_attribute_begin] = ACTIONS(2365),
    [sym__verbatim_begin] = ACTIONS(2365),
  },
  [294] = {
    [ts_builtin_sym_end] = ACTIONS(2371),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [sym__whitespace1] = ACTIONS(2371),
    [sym_quotation_marks] = ACTIONS(2371),
    [sym_ellipsis] = ACTIONS(2371),
    [sym_em_dash] = ACTIONS(2371),
    [sym_en_dash] = ACTIONS(2373),
    [sym_backslash_escape] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2371),
    [sym_symbol] = ACTIONS(2371),
    [anon_sym_LBRACE_] = ACTIONS(2371),
    [anon_sym__] = ACTIONS(2371),
    [anon_sym_LBRACE_STAR] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_LBRACE_CARET] = ACTIONS(2371),
    [anon_sym_CARET] = ACTIONS(2371),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_LBRACE_EQ] = ACTIONS(2371),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2371),
    [anon_sym_LBRACE_DASH] = ACTIONS(2371),
    [anon_sym_LBRACK_CARET] = ACTIONS(2371),
    [anon_sym_BANG_LBRACK] = ACTIONS(2371),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2371),
    [anon_sym_TODO] = ACTIONS(2371),
    [anon_sym_WIP] = ACTIONS(2371),
    [anon_sym_NOTE] = ACTIONS(2371),
    [anon_sym_INFO] = ACTIONS(2371),
    [anon_sym_XXX] = ACTIONS(2371),
    [sym_fixme] = ACTIONS(2371),
    [aux_sym__text_token1] = ACTIONS(2373),
    [sym__newline] = ACTIONS(2371),
    [sym__newline_inline] = ACTIONS(2371),
    [sym_hard_line_break] = ACTIONS(2371),
    [sym__heading_begin] = ACTIONS(2371),
    [sym__div_begin] = ACTIONS(2371),
    [sym__code_block_begin] = ACTIONS(2371),
    [sym_list_marker_dash] = ACTIONS(2371),
    [sym_list_marker_star] = ACTIONS(2371),
    [sym_list_marker_plus] = ACTIONS(2371),
    [sym__list_marker_task_begin] = ACTIONS(2371),
    [sym_list_marker_definition] = ACTIONS(2371),
    [sym_list_marker_decimal_period] = ACTIONS(2371),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2371),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2371),
    [sym_list_marker_lower_roman_period] = ACTIONS(2371),
    [sym_list_marker_upper_roman_period] = ACTIONS(2371),
    [sym_list_marker_decimal_paren] = ACTIONS(2371),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2371),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2371),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2371),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2371),
    [sym_list_marker_decimal_parens] = ACTIONS(2371),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2371),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2371),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2371),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2371),
    [sym__block_quote_begin] = ACTIONS(2371),
    [sym__block_quote_continuation] = ACTIONS(2371),
    [sym__thematic_break_dash] = ACTIONS(2371),
    [sym__thematic_break_star] = ACTIONS(2371),
    [sym__footnote_mark_begin] = ACTIONS(2371),
    [sym__link_ref_def_mark_begin] = ACTIONS(2371),
    [sym__table_header_begin] = ACTIONS(2371),
    [sym__table_separator_begin] = ACTIONS(2371),
    [sym__table_row_begin] = ACTIONS(2371),
    [sym__table_caption_begin] = ACTIONS(2371),
    [sym__block_attribute_begin] = ACTIONS(2371),
    [sym__verbatim_begin] = ACTIONS(2371),
  },
  [295] = {
    [ts_builtin_sym_end] = ACTIONS(2375),
    [anon_sym_LBRACK] = ACTIONS(2377),
    [sym__whitespace1] = ACTIONS(2375),
    [sym_quotation_marks] = ACTIONS(2375),
    [sym_ellipsis] = ACTIONS(2375),
    [sym_em_dash] = ACTIONS(2375),
    [sym_en_dash] = ACTIONS(2377),
    [sym_backslash_escape] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2375),
    [sym_symbol] = ACTIONS(2375),
    [anon_sym_LBRACE_] = ACTIONS(2375),
    [anon_sym__] = ACTIONS(2375),
    [anon_sym_LBRACE_STAR] = ACTIONS(2375),
    [anon_sym_STAR] = ACTIONS(2375),
    [anon_sym_LBRACE_CARET] = ACTIONS(2375),
    [anon_sym_CARET] = ACTIONS(2375),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2375),
    [anon_sym_TILDE] = ACTIONS(2375),
    [anon_sym_LBRACE_EQ] = ACTIONS(2375),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2375),
    [anon_sym_LBRACE_DASH] = ACTIONS(2375),
    [anon_sym_LBRACK_CARET] = ACTIONS(2375),
    [anon_sym_BANG_LBRACK] = ACTIONS(2375),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2375),
    [anon_sym_LPAREN] = ACTIONS(2375),
    [anon_sym_DOLLAR] = ACTIONS(2375),
    [anon_sym_TODO] = ACTIONS(2375),
    [anon_sym_WIP] = ACTIONS(2375),
    [anon_sym_NOTE] = ACTIONS(2375),
    [anon_sym_INFO] = ACTIONS(2375),
    [anon_sym_XXX] = ACTIONS(2375),
    [sym_fixme] = ACTIONS(2375),
    [aux_sym__text_token1] = ACTIONS(2377),
    [sym__newline] = ACTIONS(2375),
    [sym__newline_inline] = ACTIONS(2375),
    [sym_hard_line_break] = ACTIONS(2375),
    [sym__heading_begin] = ACTIONS(2375),
    [sym__div_begin] = ACTIONS(2375),
    [sym__code_block_begin] = ACTIONS(2375),
    [sym__code_block_end] = ACTIONS(2379),
    [sym_list_marker_dash] = ACTIONS(2375),
    [sym_list_marker_star] = ACTIONS(2375),
    [sym_list_marker_plus] = ACTIONS(2375),
    [sym__list_marker_task_begin] = ACTIONS(2375),
    [sym_list_marker_definition] = ACTIONS(2375),
    [sym_list_marker_decimal_period] = ACTIONS(2375),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2375),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2375),
    [sym_list_marker_lower_roman_period] = ACTIONS(2375),
    [sym_list_marker_upper_roman_period] = ACTIONS(2375),
    [sym_list_marker_decimal_paren] = ACTIONS(2375),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2375),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2375),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2375),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2375),
    [sym_list_marker_decimal_parens] = ACTIONS(2375),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2375),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2375),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2375),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2375),
    [sym__block_quote_begin] = ACTIONS(2375),
    [sym__block_quote_continuation] = ACTIONS(2375),
    [sym__thematic_break_dash] = ACTIONS(2375),
    [sym__thematic_break_star] = ACTIONS(2375),
    [sym__footnote_mark_begin] = ACTIONS(2375),
    [sym__link_ref_def_mark_begin] = ACTIONS(2375),
    [sym__table_header_begin] = ACTIONS(2375),
    [sym__table_separator_begin] = ACTIONS(2375),
    [sym__table_row_begin] = ACTIONS(2375),
    [sym__block_attribute_begin] = ACTIONS(2375),
    [sym__verbatim_begin] = ACTIONS(2375),
  },
  [296] = {
    [ts_builtin_sym_end] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [sym__whitespace1] = ACTIONS(2381),
    [sym_quotation_marks] = ACTIONS(2381),
    [sym_ellipsis] = ACTIONS(2381),
    [sym_em_dash] = ACTIONS(2381),
    [sym_en_dash] = ACTIONS(2383),
    [sym_backslash_escape] = ACTIONS(2383),
    [anon_sym_LT] = ACTIONS(2381),
    [sym_symbol] = ACTIONS(2381),
    [anon_sym_LBRACE_] = ACTIONS(2381),
    [anon_sym__] = ACTIONS(2381),
    [anon_sym_LBRACE_STAR] = ACTIONS(2381),
    [anon_sym_STAR] = ACTIONS(2381),
    [anon_sym_LBRACE_CARET] = ACTIONS(2381),
    [anon_sym_CARET] = ACTIONS(2381),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [anon_sym_LBRACE_EQ] = ACTIONS(2381),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2381),
    [anon_sym_LBRACE_DASH] = ACTIONS(2381),
    [anon_sym_LBRACK_CARET] = ACTIONS(2381),
    [anon_sym_BANG_LBRACK] = ACTIONS(2381),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2381),
    [anon_sym_LPAREN] = ACTIONS(2381),
    [anon_sym_DOLLAR] = ACTIONS(2381),
    [anon_sym_TODO] = ACTIONS(2381),
    [anon_sym_WIP] = ACTIONS(2381),
    [anon_sym_NOTE] = ACTIONS(2381),
    [anon_sym_INFO] = ACTIONS(2381),
    [anon_sym_XXX] = ACTIONS(2381),
    [sym_fixme] = ACTIONS(2381),
    [aux_sym__text_token1] = ACTIONS(2383),
    [sym__newline] = ACTIONS(2381),
    [sym__newline_inline] = ACTIONS(2381),
    [sym_hard_line_break] = ACTIONS(2381),
    [sym__heading_begin] = ACTIONS(2381),
    [sym__div_begin] = ACTIONS(2381),
    [sym__code_block_begin] = ACTIONS(2381),
    [sym__code_block_end] = ACTIONS(2385),
    [sym_list_marker_dash] = ACTIONS(2381),
    [sym_list_marker_star] = ACTIONS(2381),
    [sym_list_marker_plus] = ACTIONS(2381),
    [sym__list_marker_task_begin] = ACTIONS(2381),
    [sym_list_marker_definition] = ACTIONS(2381),
    [sym_list_marker_decimal_period] = ACTIONS(2381),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2381),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2381),
    [sym_list_marker_lower_roman_period] = ACTIONS(2381),
    [sym_list_marker_upper_roman_period] = ACTIONS(2381),
    [sym_list_marker_decimal_paren] = ACTIONS(2381),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2381),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2381),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2381),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2381),
    [sym_list_marker_decimal_parens] = ACTIONS(2381),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2381),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2381),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2381),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2381),
    [sym__block_quote_begin] = ACTIONS(2381),
    [sym__block_quote_continuation] = ACTIONS(2381),
    [sym__thematic_break_dash] = ACTIONS(2381),
    [sym__thematic_break_star] = ACTIONS(2381),
    [sym__footnote_mark_begin] = ACTIONS(2381),
    [sym__link_ref_def_mark_begin] = ACTIONS(2381),
    [sym__table_header_begin] = ACTIONS(2381),
    [sym__table_separator_begin] = ACTIONS(2381),
    [sym__table_row_begin] = ACTIONS(2381),
    [sym__block_attribute_begin] = ACTIONS(2381),
    [sym__verbatim_begin] = ACTIONS(2381),
  },
  [297] = {
    [ts_builtin_sym_end] = ACTIONS(2387),
    [anon_sym_LBRACK] = ACTIONS(2389),
    [sym__whitespace1] = ACTIONS(2387),
    [sym_quotation_marks] = ACTIONS(2387),
    [sym_ellipsis] = ACTIONS(2387),
    [sym_em_dash] = ACTIONS(2387),
    [sym_en_dash] = ACTIONS(2389),
    [sym_backslash_escape] = ACTIONS(2389),
    [anon_sym_LT] = ACTIONS(2387),
    [sym_symbol] = ACTIONS(2387),
    [anon_sym_LBRACE_] = ACTIONS(2387),
    [anon_sym__] = ACTIONS(2387),
    [anon_sym_LBRACE_STAR] = ACTIONS(2387),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_LBRACE_CARET] = ACTIONS(2387),
    [anon_sym_CARET] = ACTIONS(2387),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2387),
    [anon_sym_TILDE] = ACTIONS(2387),
    [anon_sym_LBRACE_EQ] = ACTIONS(2387),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2387),
    [anon_sym_LBRACE_DASH] = ACTIONS(2387),
    [anon_sym_LBRACK_CARET] = ACTIONS(2387),
    [anon_sym_BANG_LBRACK] = ACTIONS(2387),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2387),
    [anon_sym_LPAREN] = ACTIONS(2387),
    [anon_sym_DOLLAR] = ACTIONS(2387),
    [anon_sym_TODO] = ACTIONS(2387),
    [anon_sym_WIP] = ACTIONS(2387),
    [anon_sym_NOTE] = ACTIONS(2387),
    [anon_sym_INFO] = ACTIONS(2387),
    [anon_sym_XXX] = ACTIONS(2387),
    [sym_fixme] = ACTIONS(2387),
    [aux_sym__text_token1] = ACTIONS(2389),
    [sym__newline] = ACTIONS(2387),
    [sym__newline_inline] = ACTIONS(2387),
    [sym_hard_line_break] = ACTIONS(2387),
    [sym__heading_begin] = ACTIONS(2387),
    [sym__div_begin] = ACTIONS(2387),
    [sym__code_block_begin] = ACTIONS(2387),
    [sym__code_block_end] = ACTIONS(2391),
    [sym_list_marker_dash] = ACTIONS(2387),
    [sym_list_marker_star] = ACTIONS(2387),
    [sym_list_marker_plus] = ACTIONS(2387),
    [sym__list_marker_task_begin] = ACTIONS(2387),
    [sym_list_marker_definition] = ACTIONS(2387),
    [sym_list_marker_decimal_period] = ACTIONS(2387),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2387),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2387),
    [sym_list_marker_lower_roman_period] = ACTIONS(2387),
    [sym_list_marker_upper_roman_period] = ACTIONS(2387),
    [sym_list_marker_decimal_paren] = ACTIONS(2387),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2387),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2387),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2387),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2387),
    [sym_list_marker_decimal_parens] = ACTIONS(2387),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2387),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2387),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2387),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2387),
    [sym__block_quote_begin] = ACTIONS(2387),
    [sym__block_quote_continuation] = ACTIONS(2387),
    [sym__thematic_break_dash] = ACTIONS(2387),
    [sym__thematic_break_star] = ACTIONS(2387),
    [sym__footnote_mark_begin] = ACTIONS(2387),
    [sym__link_ref_def_mark_begin] = ACTIONS(2387),
    [sym__table_header_begin] = ACTIONS(2387),
    [sym__table_separator_begin] = ACTIONS(2387),
    [sym__table_row_begin] = ACTIONS(2387),
    [sym__block_attribute_begin] = ACTIONS(2387),
    [sym__verbatim_begin] = ACTIONS(2387),
  },
  [298] = {
    [anon_sym_LBRACK] = ACTIONS(2393),
    [sym__whitespace1] = ACTIONS(2395),
    [sym_quotation_marks] = ACTIONS(2395),
    [sym_ellipsis] = ACTIONS(2395),
    [sym_em_dash] = ACTIONS(2395),
    [sym_en_dash] = ACTIONS(2393),
    [sym_backslash_escape] = ACTIONS(2393),
    [anon_sym_LT] = ACTIONS(2395),
    [sym_symbol] = ACTIONS(2395),
    [anon_sym_LBRACE_] = ACTIONS(2395),
    [anon_sym__] = ACTIONS(2395),
    [anon_sym_LBRACE_STAR] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2395),
    [anon_sym_LBRACE_CARET] = ACTIONS(2395),
    [anon_sym_CARET] = ACTIONS(2395),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2395),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_LBRACE_EQ] = ACTIONS(2395),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2395),
    [anon_sym_LBRACE_DASH] = ACTIONS(2395),
    [anon_sym_LBRACK_CARET] = ACTIONS(2395),
    [anon_sym_BANG_LBRACK] = ACTIONS(2395),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2395),
    [anon_sym_DOLLAR] = ACTIONS(2395),
    [anon_sym_TODO] = ACTIONS(2395),
    [anon_sym_WIP] = ACTIONS(2395),
    [anon_sym_NOTE] = ACTIONS(2395),
    [anon_sym_INFO] = ACTIONS(2395),
    [anon_sym_XXX] = ACTIONS(2395),
    [sym_fixme] = ACTIONS(2395),
    [aux_sym__text_token1] = ACTIONS(2393),
    [sym__block_close] = ACTIONS(2395),
    [sym__newline] = ACTIONS(2395),
    [sym__newline_inline] = ACTIONS(2395),
    [sym_hard_line_break] = ACTIONS(2395),
    [sym__heading_begin] = ACTIONS(2395),
    [sym__div_begin] = ACTIONS(2395),
    [sym__code_block_begin] = ACTIONS(2395),
    [sym_list_marker_dash] = ACTIONS(2395),
    [sym_list_marker_star] = ACTIONS(2395),
    [sym_list_marker_plus] = ACTIONS(2395),
    [sym__list_marker_task_begin] = ACTIONS(2395),
    [sym_list_marker_definition] = ACTIONS(2395),
    [sym_list_marker_decimal_period] = ACTIONS(2395),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2395),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2395),
    [sym_list_marker_lower_roman_period] = ACTIONS(2395),
    [sym_list_marker_upper_roman_period] = ACTIONS(2395),
    [sym_list_marker_decimal_paren] = ACTIONS(2395),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2395),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2395),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2395),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2395),
    [sym_list_marker_decimal_parens] = ACTIONS(2395),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2395),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2395),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2395),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2395),
    [sym__block_quote_begin] = ACTIONS(2395),
    [sym__block_quote_continuation] = ACTIONS(2395),
    [sym__thematic_break_dash] = ACTIONS(2395),
    [sym__thematic_break_star] = ACTIONS(2395),
    [sym__footnote_mark_begin] = ACTIONS(2395),
    [sym__link_ref_def_mark_begin] = ACTIONS(2395),
    [sym__table_header_begin] = ACTIONS(2395),
    [sym__table_separator_begin] = ACTIONS(2395),
    [sym__table_row_begin] = ACTIONS(2395),
    [sym__table_caption_begin] = ACTIONS(2395),
    [sym__block_attribute_begin] = ACTIONS(2395),
    [sym__verbatim_begin] = ACTIONS(2395),
  },
  [299] = {
    [anon_sym_LBRACK] = ACTIONS(2363),
    [sym__whitespace1] = ACTIONS(2361),
    [sym_quotation_marks] = ACTIONS(2361),
    [sym_ellipsis] = ACTIONS(2361),
    [sym_em_dash] = ACTIONS(2361),
    [sym_en_dash] = ACTIONS(2363),
    [sym_backslash_escape] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2361),
    [sym_symbol] = ACTIONS(2361),
    [anon_sym_LBRACE_] = ACTIONS(2361),
    [anon_sym__] = ACTIONS(2361),
    [anon_sym_LBRACE_STAR] = ACTIONS(2361),
    [anon_sym_STAR] = ACTIONS(2361),
    [anon_sym_LBRACE_CARET] = ACTIONS(2361),
    [anon_sym_CARET] = ACTIONS(2361),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2361),
    [anon_sym_TILDE] = ACTIONS(2361),
    [anon_sym_LBRACE_EQ] = ACTIONS(2361),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2361),
    [anon_sym_LBRACE_DASH] = ACTIONS(2361),
    [anon_sym_LBRACK_CARET] = ACTIONS(2361),
    [anon_sym_BANG_LBRACK] = ACTIONS(2361),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2361),
    [anon_sym_DOLLAR] = ACTIONS(2361),
    [anon_sym_TODO] = ACTIONS(2361),
    [anon_sym_WIP] = ACTIONS(2361),
    [anon_sym_NOTE] = ACTIONS(2361),
    [anon_sym_INFO] = ACTIONS(2361),
    [anon_sym_XXX] = ACTIONS(2361),
    [sym_fixme] = ACTIONS(2361),
    [aux_sym__text_token1] = ACTIONS(2363),
    [sym__block_close] = ACTIONS(2361),
    [sym__newline] = ACTIONS(2361),
    [sym__newline_inline] = ACTIONS(2361),
    [sym_hard_line_break] = ACTIONS(2361),
    [sym__heading_begin] = ACTIONS(2361),
    [sym__div_begin] = ACTIONS(2361),
    [sym__code_block_begin] = ACTIONS(2361),
    [sym_list_marker_dash] = ACTIONS(2361),
    [sym_list_marker_star] = ACTIONS(2361),
    [sym_list_marker_plus] = ACTIONS(2361),
    [sym__list_marker_task_begin] = ACTIONS(2361),
    [sym_list_marker_definition] = ACTIONS(2361),
    [sym_list_marker_decimal_period] = ACTIONS(2361),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2361),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2361),
    [sym_list_marker_lower_roman_period] = ACTIONS(2361),
    [sym_list_marker_upper_roman_period] = ACTIONS(2361),
    [sym_list_marker_decimal_paren] = ACTIONS(2361),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2361),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2361),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2361),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2361),
    [sym_list_marker_decimal_parens] = ACTIONS(2361),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2361),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2361),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2361),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2361),
    [sym__block_quote_begin] = ACTIONS(2361),
    [sym__block_quote_continuation] = ACTIONS(2361),
    [sym__thematic_break_dash] = ACTIONS(2361),
    [sym__thematic_break_star] = ACTIONS(2361),
    [sym__footnote_mark_begin] = ACTIONS(2361),
    [sym__link_ref_def_mark_begin] = ACTIONS(2361),
    [sym__table_header_begin] = ACTIONS(2361),
    [sym__table_separator_begin] = ACTIONS(2361),
    [sym__table_row_begin] = ACTIONS(2361),
    [sym__table_caption_begin] = ACTIONS(2361),
    [sym__block_attribute_begin] = ACTIONS(2361),
    [sym__verbatim_begin] = ACTIONS(2361),
  },
  [300] = {
    [anon_sym_LBRACK] = ACTIONS(2373),
    [sym__whitespace1] = ACTIONS(2371),
    [sym_quotation_marks] = ACTIONS(2371),
    [sym_ellipsis] = ACTIONS(2371),
    [sym_em_dash] = ACTIONS(2371),
    [sym_en_dash] = ACTIONS(2373),
    [sym_backslash_escape] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2371),
    [sym_symbol] = ACTIONS(2371),
    [anon_sym_LBRACE_] = ACTIONS(2371),
    [anon_sym__] = ACTIONS(2371),
    [anon_sym_LBRACE_STAR] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2371),
    [anon_sym_LBRACE_CARET] = ACTIONS(2371),
    [anon_sym_CARET] = ACTIONS(2371),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2371),
    [anon_sym_TILDE] = ACTIONS(2371),
    [anon_sym_LBRACE_EQ] = ACTIONS(2371),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2371),
    [anon_sym_LBRACE_DASH] = ACTIONS(2371),
    [anon_sym_LBRACK_CARET] = ACTIONS(2371),
    [anon_sym_BANG_LBRACK] = ACTIONS(2371),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2371),
    [anon_sym_TODO] = ACTIONS(2371),
    [anon_sym_WIP] = ACTIONS(2371),
    [anon_sym_NOTE] = ACTIONS(2371),
    [anon_sym_INFO] = ACTIONS(2371),
    [anon_sym_XXX] = ACTIONS(2371),
    [sym_fixme] = ACTIONS(2371),
    [aux_sym__text_token1] = ACTIONS(2373),
    [sym__block_close] = ACTIONS(2371),
    [sym__newline] = ACTIONS(2371),
    [sym__newline_inline] = ACTIONS(2371),
    [sym_hard_line_break] = ACTIONS(2371),
    [sym__heading_begin] = ACTIONS(2371),
    [sym__div_begin] = ACTIONS(2371),
    [sym__code_block_begin] = ACTIONS(2371),
    [sym_list_marker_dash] = ACTIONS(2371),
    [sym_list_marker_star] = ACTIONS(2371),
    [sym_list_marker_plus] = ACTIONS(2371),
    [sym__list_marker_task_begin] = ACTIONS(2371),
    [sym_list_marker_definition] = ACTIONS(2371),
    [sym_list_marker_decimal_period] = ACTIONS(2371),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2371),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2371),
    [sym_list_marker_lower_roman_period] = ACTIONS(2371),
    [sym_list_marker_upper_roman_period] = ACTIONS(2371),
    [sym_list_marker_decimal_paren] = ACTIONS(2371),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2371),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2371),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2371),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2371),
    [sym_list_marker_decimal_parens] = ACTIONS(2371),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2371),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2371),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2371),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2371),
    [sym__block_quote_begin] = ACTIONS(2371),
    [sym__block_quote_continuation] = ACTIONS(2371),
    [sym__thematic_break_dash] = ACTIONS(2371),
    [sym__thematic_break_star] = ACTIONS(2371),
    [sym__footnote_mark_begin] = ACTIONS(2371),
    [sym__link_ref_def_mark_begin] = ACTIONS(2371),
    [sym__table_header_begin] = ACTIONS(2371),
    [sym__table_separator_begin] = ACTIONS(2371),
    [sym__table_row_begin] = ACTIONS(2371),
    [sym__table_caption_begin] = ACTIONS(2371),
    [sym__block_attribute_begin] = ACTIONS(2371),
    [sym__verbatim_begin] = ACTIONS(2371),
  },
  [301] = {
    [anon_sym_LBRACK] = ACTIONS(2359),
    [sym__whitespace1] = ACTIONS(2357),
    [sym_quotation_marks] = ACTIONS(2357),
    [sym_ellipsis] = ACTIONS(2357),
    [sym_em_dash] = ACTIONS(2357),
    [sym_en_dash] = ACTIONS(2359),
    [sym_backslash_escape] = ACTIONS(2359),
    [anon_sym_LT] = ACTIONS(2357),
    [sym_symbol] = ACTIONS(2357),
    [anon_sym_LBRACE_] = ACTIONS(2357),
    [anon_sym__] = ACTIONS(2357),
    [anon_sym_LBRACE_STAR] = ACTIONS(2357),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_LBRACE_CARET] = ACTIONS(2357),
    [anon_sym_CARET] = ACTIONS(2357),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2357),
    [anon_sym_TILDE] = ACTIONS(2357),
    [anon_sym_LBRACE_EQ] = ACTIONS(2357),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2357),
    [anon_sym_LBRACE_DASH] = ACTIONS(2357),
    [anon_sym_LBRACK_CARET] = ACTIONS(2357),
    [anon_sym_BANG_LBRACK] = ACTIONS(2357),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2357),
    [anon_sym_LPAREN] = ACTIONS(2357),
    [anon_sym_DOLLAR] = ACTIONS(2357),
    [anon_sym_TODO] = ACTIONS(2357),
    [anon_sym_WIP] = ACTIONS(2357),
    [anon_sym_NOTE] = ACTIONS(2357),
    [anon_sym_INFO] = ACTIONS(2357),
    [anon_sym_XXX] = ACTIONS(2357),
    [sym_fixme] = ACTIONS(2357),
    [aux_sym__text_token1] = ACTIONS(2359),
    [sym__block_close] = ACTIONS(2357),
    [sym__newline] = ACTIONS(2357),
    [sym__newline_inline] = ACTIONS(2357),
    [sym_hard_line_break] = ACTIONS(2357),
    [sym__heading_begin] = ACTIONS(2357),
    [sym__div_begin] = ACTIONS(2357),
    [sym__code_block_begin] = ACTIONS(2357),
    [sym_list_marker_dash] = ACTIONS(2357),
    [sym_list_marker_star] = ACTIONS(2357),
    [sym_list_marker_plus] = ACTIONS(2357),
    [sym__list_marker_task_begin] = ACTIONS(2357),
    [sym_list_marker_definition] = ACTIONS(2357),
    [sym_list_marker_decimal_period] = ACTIONS(2357),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2357),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2357),
    [sym_list_marker_lower_roman_period] = ACTIONS(2357),
    [sym_list_marker_upper_roman_period] = ACTIONS(2357),
    [sym_list_marker_decimal_paren] = ACTIONS(2357),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2357),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2357),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2357),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2357),
    [sym_list_marker_decimal_parens] = ACTIONS(2357),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2357),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2357),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2357),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2357),
    [sym__block_quote_begin] = ACTIONS(2357),
    [sym__block_quote_continuation] = ACTIONS(2357),
    [sym__thematic_break_dash] = ACTIONS(2357),
    [sym__thematic_break_star] = ACTIONS(2357),
    [sym__footnote_mark_begin] = ACTIONS(2357),
    [sym__link_ref_def_mark_begin] = ACTIONS(2357),
    [sym__table_header_begin] = ACTIONS(2357),
    [sym__table_separator_begin] = ACTIONS(2357),
    [sym__table_row_begin] = ACTIONS(2357),
    [sym__table_caption_begin] = ACTIONS(2357),
    [sym__block_attribute_begin] = ACTIONS(2357),
    [sym__verbatim_begin] = ACTIONS(2357),
  },
  [302] = {
    [ts_builtin_sym_end] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [sym__whitespace1] = ACTIONS(2397),
    [sym_quotation_marks] = ACTIONS(2397),
    [sym_ellipsis] = ACTIONS(2397),
    [sym_em_dash] = ACTIONS(2397),
    [sym_en_dash] = ACTIONS(2399),
    [sym_backslash_escape] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(2397),
    [sym_symbol] = ACTIONS(2397),
    [anon_sym_LBRACE_] = ACTIONS(2397),
    [anon_sym__] = ACTIONS(2397),
    [anon_sym_LBRACE_STAR] = ACTIONS(2397),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_LBRACE_CARET] = ACTIONS(2397),
    [anon_sym_CARET] = ACTIONS(2397),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2397),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_LBRACE_EQ] = ACTIONS(2397),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2397),
    [anon_sym_LBRACE_DASH] = ACTIONS(2397),
    [anon_sym_LBRACK_CARET] = ACTIONS(2397),
    [anon_sym_BANG_LBRACK] = ACTIONS(2397),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2397),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym_DOLLAR] = ACTIONS(2397),
    [anon_sym_TODO] = ACTIONS(2397),
    [anon_sym_WIP] = ACTIONS(2397),
    [anon_sym_NOTE] = ACTIONS(2397),
    [anon_sym_INFO] = ACTIONS(2397),
    [anon_sym_XXX] = ACTIONS(2397),
    [sym_fixme] = ACTIONS(2397),
    [aux_sym__text_token1] = ACTIONS(2399),
    [sym__newline] = ACTIONS(2397),
    [sym__newline_inline] = ACTIONS(2397),
    [sym_hard_line_break] = ACTIONS(2397),
    [sym__heading_begin] = ACTIONS(2397),
    [sym__div_begin] = ACTIONS(2397),
    [sym__div_end] = ACTIONS(2401),
    [sym__code_block_begin] = ACTIONS(2397),
    [sym_list_marker_dash] = ACTIONS(2397),
    [sym_list_marker_star] = ACTIONS(2397),
    [sym_list_marker_plus] = ACTIONS(2397),
    [sym__list_marker_task_begin] = ACTIONS(2397),
    [sym_list_marker_definition] = ACTIONS(2397),
    [sym_list_marker_decimal_period] = ACTIONS(2397),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2397),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2397),
    [sym_list_marker_lower_roman_period] = ACTIONS(2397),
    [sym_list_marker_upper_roman_period] = ACTIONS(2397),
    [sym_list_marker_decimal_paren] = ACTIONS(2397),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2397),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2397),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2397),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2397),
    [sym_list_marker_decimal_parens] = ACTIONS(2397),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2397),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2397),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2397),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2397),
    [sym__block_quote_begin] = ACTIONS(2397),
    [sym__block_quote_continuation] = ACTIONS(2397),
    [sym__thematic_break_dash] = ACTIONS(2397),
    [sym__thematic_break_star] = ACTIONS(2397),
    [sym__footnote_mark_begin] = ACTIONS(2397),
    [sym__link_ref_def_mark_begin] = ACTIONS(2397),
    [sym__table_header_begin] = ACTIONS(2397),
    [sym__table_separator_begin] = ACTIONS(2397),
    [sym__table_row_begin] = ACTIONS(2397),
    [sym__block_attribute_begin] = ACTIONS(2397),
    [sym__verbatim_begin] = ACTIONS(2397),
  },
  [303] = {
    [ts_builtin_sym_end] = ACTIONS(2403),
    [anon_sym_LBRACK] = ACTIONS(2405),
    [sym__whitespace1] = ACTIONS(2403),
    [sym_quotation_marks] = ACTIONS(2403),
    [sym_ellipsis] = ACTIONS(2403),
    [sym_em_dash] = ACTIONS(2403),
    [sym_en_dash] = ACTIONS(2405),
    [sym_backslash_escape] = ACTIONS(2405),
    [anon_sym_LT] = ACTIONS(2403),
    [sym_symbol] = ACTIONS(2403),
    [anon_sym_LBRACE_] = ACTIONS(2403),
    [anon_sym__] = ACTIONS(2403),
    [anon_sym_LBRACE_STAR] = ACTIONS(2403),
    [anon_sym_STAR] = ACTIONS(2403),
    [anon_sym_LBRACE_CARET] = ACTIONS(2403),
    [anon_sym_CARET] = ACTIONS(2403),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2403),
    [anon_sym_TILDE] = ACTIONS(2403),
    [anon_sym_LBRACE_EQ] = ACTIONS(2403),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2403),
    [anon_sym_LBRACE_DASH] = ACTIONS(2403),
    [anon_sym_LBRACK_CARET] = ACTIONS(2403),
    [anon_sym_BANG_LBRACK] = ACTIONS(2403),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2403),
    [anon_sym_LPAREN] = ACTIONS(2403),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_TODO] = ACTIONS(2403),
    [anon_sym_WIP] = ACTIONS(2403),
    [anon_sym_NOTE] = ACTIONS(2403),
    [anon_sym_INFO] = ACTIONS(2403),
    [anon_sym_XXX] = ACTIONS(2403),
    [sym_fixme] = ACTIONS(2403),
    [aux_sym__text_token1] = ACTIONS(2405),
    [sym__newline] = ACTIONS(2403),
    [sym__newline_inline] = ACTIONS(2403),
    [sym_hard_line_break] = ACTIONS(2403),
    [sym__heading_begin] = ACTIONS(2403),
    [sym__div_begin] = ACTIONS(2403),
    [sym__div_end] = ACTIONS(2407),
    [sym__code_block_begin] = ACTIONS(2403),
    [sym_list_marker_dash] = ACTIONS(2403),
    [sym_list_marker_star] = ACTIONS(2403),
    [sym_list_marker_plus] = ACTIONS(2403),
    [sym__list_marker_task_begin] = ACTIONS(2403),
    [sym_list_marker_definition] = ACTIONS(2403),
    [sym_list_marker_decimal_period] = ACTIONS(2403),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2403),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2403),
    [sym_list_marker_lower_roman_period] = ACTIONS(2403),
    [sym_list_marker_upper_roman_period] = ACTIONS(2403),
    [sym_list_marker_decimal_paren] = ACTIONS(2403),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2403),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2403),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2403),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2403),
    [sym_list_marker_decimal_parens] = ACTIONS(2403),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2403),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2403),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2403),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2403),
    [sym__block_quote_begin] = ACTIONS(2403),
    [sym__block_quote_continuation] = ACTIONS(2403),
    [sym__thematic_break_dash] = ACTIONS(2403),
    [sym__thematic_break_star] = ACTIONS(2403),
    [sym__footnote_mark_begin] = ACTIONS(2403),
    [sym__link_ref_def_mark_begin] = ACTIONS(2403),
    [sym__table_header_begin] = ACTIONS(2403),
    [sym__table_separator_begin] = ACTIONS(2403),
    [sym__table_row_begin] = ACTIONS(2403),
    [sym__block_attribute_begin] = ACTIONS(2403),
    [sym__verbatim_begin] = ACTIONS(2403),
  },
  [304] = {
    [anon_sym_LBRACK] = ACTIONS(2409),
    [sym__whitespace1] = ACTIONS(2411),
    [sym_quotation_marks] = ACTIONS(2411),
    [sym_ellipsis] = ACTIONS(2411),
    [sym_em_dash] = ACTIONS(2411),
    [sym_en_dash] = ACTIONS(2409),
    [sym_backslash_escape] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(2411),
    [sym_symbol] = ACTIONS(2411),
    [anon_sym_LBRACE_] = ACTIONS(2411),
    [anon_sym__] = ACTIONS(2411),
    [anon_sym_LBRACE_STAR] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LBRACE_CARET] = ACTIONS(2411),
    [anon_sym_CARET] = ACTIONS(2411),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_LBRACE_EQ] = ACTIONS(2411),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2411),
    [anon_sym_LBRACE_DASH] = ACTIONS(2411),
    [anon_sym_LBRACK_CARET] = ACTIONS(2411),
    [anon_sym_BANG_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2411),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_TODO] = ACTIONS(2411),
    [anon_sym_WIP] = ACTIONS(2411),
    [anon_sym_NOTE] = ACTIONS(2411),
    [anon_sym_INFO] = ACTIONS(2411),
    [anon_sym_XXX] = ACTIONS(2411),
    [sym_fixme] = ACTIONS(2411),
    [aux_sym__text_token1] = ACTIONS(2409),
    [sym__block_close] = ACTIONS(2411),
    [sym__newline] = ACTIONS(2411),
    [sym__newline_inline] = ACTIONS(2411),
    [sym_hard_line_break] = ACTIONS(2411),
    [sym__heading_begin] = ACTIONS(2411),
    [sym__div_begin] = ACTIONS(2411),
    [sym__code_block_begin] = ACTIONS(2411),
    [sym__code_block_end] = ACTIONS(2413),
    [sym_list_marker_dash] = ACTIONS(2411),
    [sym_list_marker_star] = ACTIONS(2411),
    [sym_list_marker_plus] = ACTIONS(2411),
    [sym__list_marker_task_begin] = ACTIONS(2411),
    [sym_list_marker_definition] = ACTIONS(2411),
    [sym_list_marker_decimal_period] = ACTIONS(2411),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2411),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2411),
    [sym_list_marker_lower_roman_period] = ACTIONS(2411),
    [sym_list_marker_upper_roman_period] = ACTIONS(2411),
    [sym_list_marker_decimal_paren] = ACTIONS(2411),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2411),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2411),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2411),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2411),
    [sym_list_marker_decimal_parens] = ACTIONS(2411),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2411),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2411),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2411),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2411),
    [sym__block_quote_begin] = ACTIONS(2411),
    [sym__block_quote_continuation] = ACTIONS(2411),
    [sym__thematic_break_dash] = ACTIONS(2411),
    [sym__thematic_break_star] = ACTIONS(2411),
    [sym__footnote_mark_begin] = ACTIONS(2411),
    [sym__link_ref_def_mark_begin] = ACTIONS(2411),
    [sym__table_header_begin] = ACTIONS(2411),
    [sym__table_separator_begin] = ACTIONS(2411),
    [sym__table_row_begin] = ACTIONS(2411),
    [sym__block_attribute_begin] = ACTIONS(2411),
    [sym__verbatim_begin] = ACTIONS(2411),
  },
  [305] = {
    [anon_sym_LBRACK] = ACTIONS(2415),
    [sym__whitespace1] = ACTIONS(2417),
    [sym_quotation_marks] = ACTIONS(2417),
    [sym_ellipsis] = ACTIONS(2417),
    [sym_em_dash] = ACTIONS(2417),
    [sym_en_dash] = ACTIONS(2415),
    [sym_backslash_escape] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [sym_symbol] = ACTIONS(2417),
    [anon_sym_LBRACE_] = ACTIONS(2417),
    [anon_sym__] = ACTIONS(2417),
    [anon_sym_LBRACE_STAR] = ACTIONS(2417),
    [anon_sym_STAR] = ACTIONS(2417),
    [anon_sym_LBRACE_CARET] = ACTIONS(2417),
    [anon_sym_CARET] = ACTIONS(2417),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2417),
    [anon_sym_TILDE] = ACTIONS(2417),
    [anon_sym_LBRACE_EQ] = ACTIONS(2417),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2417),
    [anon_sym_LBRACE_DASH] = ACTIONS(2417),
    [anon_sym_LBRACK_CARET] = ACTIONS(2417),
    [anon_sym_BANG_LBRACK] = ACTIONS(2417),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2417),
    [anon_sym_LPAREN] = ACTIONS(2417),
    [anon_sym_DOLLAR] = ACTIONS(2417),
    [anon_sym_TODO] = ACTIONS(2417),
    [anon_sym_WIP] = ACTIONS(2417),
    [anon_sym_NOTE] = ACTIONS(2417),
    [anon_sym_INFO] = ACTIONS(2417),
    [anon_sym_XXX] = ACTIONS(2417),
    [sym_fixme] = ACTIONS(2417),
    [aux_sym__text_token1] = ACTIONS(2415),
    [sym__block_close] = ACTIONS(2417),
    [sym__newline] = ACTIONS(2417),
    [sym__newline_inline] = ACTIONS(2417),
    [sym_hard_line_break] = ACTIONS(2417),
    [sym__heading_begin] = ACTIONS(2417),
    [sym__div_begin] = ACTIONS(2417),
    [sym__code_block_begin] = ACTIONS(2417),
    [sym__code_block_end] = ACTIONS(2419),
    [sym_list_marker_dash] = ACTIONS(2417),
    [sym_list_marker_star] = ACTIONS(2417),
    [sym_list_marker_plus] = ACTIONS(2417),
    [sym__list_marker_task_begin] = ACTIONS(2417),
    [sym_list_marker_definition] = ACTIONS(2417),
    [sym_list_marker_decimal_period] = ACTIONS(2417),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2417),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2417),
    [sym_list_marker_lower_roman_period] = ACTIONS(2417),
    [sym_list_marker_upper_roman_period] = ACTIONS(2417),
    [sym_list_marker_decimal_paren] = ACTIONS(2417),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2417),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2417),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2417),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2417),
    [sym_list_marker_decimal_parens] = ACTIONS(2417),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2417),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2417),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2417),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2417),
    [sym__block_quote_begin] = ACTIONS(2417),
    [sym__block_quote_continuation] = ACTIONS(2417),
    [sym__thematic_break_dash] = ACTIONS(2417),
    [sym__thematic_break_star] = ACTIONS(2417),
    [sym__footnote_mark_begin] = ACTIONS(2417),
    [sym__link_ref_def_mark_begin] = ACTIONS(2417),
    [sym__table_header_begin] = ACTIONS(2417),
    [sym__table_separator_begin] = ACTIONS(2417),
    [sym__table_row_begin] = ACTIONS(2417),
    [sym__block_attribute_begin] = ACTIONS(2417),
    [sym__verbatim_begin] = ACTIONS(2417),
  },
  [306] = {
    [ts_builtin_sym_end] = ACTIONS(2421),
    [anon_sym_LBRACK] = ACTIONS(2423),
    [sym__whitespace1] = ACTIONS(2421),
    [sym_quotation_marks] = ACTIONS(2421),
    [sym_ellipsis] = ACTIONS(2421),
    [sym_em_dash] = ACTIONS(2421),
    [sym_en_dash] = ACTIONS(2423),
    [sym_backslash_escape] = ACTIONS(2423),
    [anon_sym_LT] = ACTIONS(2421),
    [sym_symbol] = ACTIONS(2421),
    [anon_sym_LBRACE_] = ACTIONS(2421),
    [anon_sym__] = ACTIONS(2421),
    [anon_sym_LBRACE_STAR] = ACTIONS(2421),
    [anon_sym_STAR] = ACTIONS(2421),
    [anon_sym_LBRACE_CARET] = ACTIONS(2421),
    [anon_sym_CARET] = ACTIONS(2421),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [anon_sym_LBRACE_EQ] = ACTIONS(2421),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2421),
    [anon_sym_LBRACE_DASH] = ACTIONS(2421),
    [anon_sym_LBRACK_CARET] = ACTIONS(2421),
    [anon_sym_BANG_LBRACK] = ACTIONS(2421),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2421),
    [anon_sym_LPAREN] = ACTIONS(2421),
    [anon_sym_DOLLAR] = ACTIONS(2421),
    [anon_sym_TODO] = ACTIONS(2421),
    [anon_sym_WIP] = ACTIONS(2421),
    [anon_sym_NOTE] = ACTIONS(2421),
    [anon_sym_INFO] = ACTIONS(2421),
    [anon_sym_XXX] = ACTIONS(2421),
    [sym_fixme] = ACTIONS(2421),
    [aux_sym__text_token1] = ACTIONS(2423),
    [sym__newline] = ACTIONS(2421),
    [sym__newline_inline] = ACTIONS(2421),
    [sym_hard_line_break] = ACTIONS(2421),
    [sym__heading_begin] = ACTIONS(2421),
    [sym__div_begin] = ACTIONS(2421),
    [sym__code_block_begin] = ACTIONS(2421),
    [sym_list_marker_dash] = ACTIONS(2421),
    [sym_list_marker_star] = ACTIONS(2421),
    [sym_list_marker_plus] = ACTIONS(2421),
    [sym__list_marker_task_begin] = ACTIONS(2421),
    [sym_list_marker_definition] = ACTIONS(2421),
    [sym_list_marker_decimal_period] = ACTIONS(2421),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2421),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2421),
    [sym_list_marker_lower_roman_period] = ACTIONS(2421),
    [sym_list_marker_upper_roman_period] = ACTIONS(2421),
    [sym_list_marker_decimal_paren] = ACTIONS(2421),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2421),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2421),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2421),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2421),
    [sym_list_marker_decimal_parens] = ACTIONS(2421),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2421),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2421),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2421),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2421),
    [sym__block_quote_begin] = ACTIONS(2421),
    [sym__block_quote_continuation] = ACTIONS(2421),
    [sym__thematic_break_dash] = ACTIONS(2421),
    [sym__thematic_break_star] = ACTIONS(2421),
    [sym__footnote_mark_begin] = ACTIONS(2421),
    [sym__link_ref_def_mark_begin] = ACTIONS(2421),
    [sym__table_header_begin] = ACTIONS(2421),
    [sym__table_separator_begin] = ACTIONS(2421),
    [sym__table_row_begin] = ACTIONS(2421),
    [sym__table_caption_begin] = ACTIONS(2421),
    [sym__block_attribute_begin] = ACTIONS(2421),
    [sym__verbatim_begin] = ACTIONS(2421),
  },
  [307] = {
    [anon_sym_LBRACK] = ACTIONS(2425),
    [sym__whitespace1] = ACTIONS(2427),
    [sym_quotation_marks] = ACTIONS(2427),
    [sym_ellipsis] = ACTIONS(2427),
    [sym_em_dash] = ACTIONS(2427),
    [sym_en_dash] = ACTIONS(2425),
    [sym_backslash_escape] = ACTIONS(2425),
    [anon_sym_LT] = ACTIONS(2427),
    [sym_symbol] = ACTIONS(2427),
    [anon_sym_LBRACE_] = ACTIONS(2427),
    [anon_sym__] = ACTIONS(2427),
    [anon_sym_LBRACE_STAR] = ACTIONS(2427),
    [anon_sym_STAR] = ACTIONS(2427),
    [anon_sym_LBRACE_CARET] = ACTIONS(2427),
    [anon_sym_CARET] = ACTIONS(2427),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [anon_sym_LBRACE_EQ] = ACTIONS(2427),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2427),
    [anon_sym_LBRACE_DASH] = ACTIONS(2427),
    [anon_sym_LBRACK_CARET] = ACTIONS(2427),
    [anon_sym_BANG_LBRACK] = ACTIONS(2427),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2427),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_DOLLAR] = ACTIONS(2427),
    [anon_sym_TODO] = ACTIONS(2427),
    [anon_sym_WIP] = ACTIONS(2427),
    [anon_sym_NOTE] = ACTIONS(2427),
    [anon_sym_INFO] = ACTIONS(2427),
    [anon_sym_XXX] = ACTIONS(2427),
    [sym_fixme] = ACTIONS(2427),
    [aux_sym__text_token1] = ACTIONS(2425),
    [sym__block_close] = ACTIONS(2427),
    [sym__newline] = ACTIONS(2427),
    [sym__newline_inline] = ACTIONS(2427),
    [sym_hard_line_break] = ACTIONS(2427),
    [sym__heading_begin] = ACTIONS(2427),
    [sym__div_begin] = ACTIONS(2427),
    [sym__code_block_begin] = ACTIONS(2427),
    [sym_list_marker_dash] = ACTIONS(2427),
    [sym_list_marker_star] = ACTIONS(2427),
    [sym_list_marker_plus] = ACTIONS(2427),
    [sym__list_marker_task_begin] = ACTIONS(2427),
    [sym_list_marker_definition] = ACTIONS(2427),
    [sym_list_marker_decimal_period] = ACTIONS(2427),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2427),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2427),
    [sym_list_marker_lower_roman_period] = ACTIONS(2427),
    [sym_list_marker_upper_roman_period] = ACTIONS(2427),
    [sym_list_marker_decimal_paren] = ACTIONS(2427),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2427),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2427),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2427),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2427),
    [sym_list_marker_decimal_parens] = ACTIONS(2427),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2427),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2427),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2427),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2427),
    [sym__block_quote_begin] = ACTIONS(2427),
    [sym__block_quote_continuation] = ACTIONS(2427),
    [sym__thematic_break_dash] = ACTIONS(2427),
    [sym__thematic_break_star] = ACTIONS(2427),
    [sym__footnote_mark_begin] = ACTIONS(2427),
    [sym__link_ref_def_mark_begin] = ACTIONS(2427),
    [sym__table_header_begin] = ACTIONS(2427),
    [sym__table_separator_begin] = ACTIONS(2427),
    [sym__table_row_begin] = ACTIONS(2427),
    [sym__table_caption_begin] = ACTIONS(2427),
    [sym__block_attribute_begin] = ACTIONS(2427),
    [sym__verbatim_begin] = ACTIONS(2427),
  },
  [308] = {
    [anon_sym_LBRACK] = ACTIONS(2429),
    [sym__whitespace1] = ACTIONS(2431),
    [sym_quotation_marks] = ACTIONS(2431),
    [sym_ellipsis] = ACTIONS(2431),
    [sym_em_dash] = ACTIONS(2431),
    [sym_en_dash] = ACTIONS(2429),
    [sym_backslash_escape] = ACTIONS(2429),
    [anon_sym_LT] = ACTIONS(2431),
    [sym_symbol] = ACTIONS(2431),
    [anon_sym_LBRACE_] = ACTIONS(2431),
    [anon_sym__] = ACTIONS(2431),
    [anon_sym_LBRACE_STAR] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2431),
    [anon_sym_LBRACE_CARET] = ACTIONS(2431),
    [anon_sym_CARET] = ACTIONS(2431),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2431),
    [anon_sym_TILDE] = ACTIONS(2431),
    [anon_sym_LBRACE_EQ] = ACTIONS(2431),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2431),
    [anon_sym_LBRACE_DASH] = ACTIONS(2431),
    [anon_sym_LBRACK_CARET] = ACTIONS(2431),
    [anon_sym_BANG_LBRACK] = ACTIONS(2431),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2431),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_DOLLAR] = ACTIONS(2431),
    [anon_sym_TODO] = ACTIONS(2431),
    [anon_sym_WIP] = ACTIONS(2431),
    [anon_sym_NOTE] = ACTIONS(2431),
    [anon_sym_INFO] = ACTIONS(2431),
    [anon_sym_XXX] = ACTIONS(2431),
    [sym_fixme] = ACTIONS(2431),
    [aux_sym__text_token1] = ACTIONS(2429),
    [sym__block_close] = ACTIONS(2431),
    [sym__newline] = ACTIONS(2431),
    [sym__newline_inline] = ACTIONS(2431),
    [sym_hard_line_break] = ACTIONS(2431),
    [sym__heading_begin] = ACTIONS(2431),
    [sym__div_begin] = ACTIONS(2431),
    [sym__code_block_begin] = ACTIONS(2431),
    [sym_list_marker_dash] = ACTIONS(2431),
    [sym_list_marker_star] = ACTIONS(2431),
    [sym_list_marker_plus] = ACTIONS(2431),
    [sym__list_marker_task_begin] = ACTIONS(2431),
    [sym_list_marker_definition] = ACTIONS(2431),
    [sym_list_marker_decimal_period] = ACTIONS(2431),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2431),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2431),
    [sym_list_marker_lower_roman_period] = ACTIONS(2431),
    [sym_list_marker_upper_roman_period] = ACTIONS(2431),
    [sym_list_marker_decimal_paren] = ACTIONS(2431),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2431),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2431),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2431),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2431),
    [sym_list_marker_decimal_parens] = ACTIONS(2431),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2431),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2431),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2431),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2431),
    [sym__block_quote_begin] = ACTIONS(2431),
    [sym__block_quote_continuation] = ACTIONS(2431),
    [sym__thematic_break_dash] = ACTIONS(2431),
    [sym__thematic_break_star] = ACTIONS(2431),
    [sym__footnote_mark_begin] = ACTIONS(2431),
    [sym__link_ref_def_mark_begin] = ACTIONS(2431),
    [sym__table_header_begin] = ACTIONS(2431),
    [sym__table_separator_begin] = ACTIONS(2431),
    [sym__table_row_begin] = ACTIONS(2431),
    [sym__table_caption_begin] = ACTIONS(2431),
    [sym__block_attribute_begin] = ACTIONS(2431),
    [sym__verbatim_begin] = ACTIONS(2431),
  },
  [309] = {
    [anon_sym_LBRACK] = ACTIONS(2423),
    [sym__whitespace1] = ACTIONS(2421),
    [sym_quotation_marks] = ACTIONS(2421),
    [sym_ellipsis] = ACTIONS(2421),
    [sym_em_dash] = ACTIONS(2421),
    [sym_en_dash] = ACTIONS(2423),
    [sym_backslash_escape] = ACTIONS(2423),
    [anon_sym_LT] = ACTIONS(2421),
    [sym_symbol] = ACTIONS(2421),
    [anon_sym_LBRACE_] = ACTIONS(2421),
    [anon_sym__] = ACTIONS(2421),
    [anon_sym_LBRACE_STAR] = ACTIONS(2421),
    [anon_sym_STAR] = ACTIONS(2421),
    [anon_sym_LBRACE_CARET] = ACTIONS(2421),
    [anon_sym_CARET] = ACTIONS(2421),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [anon_sym_LBRACE_EQ] = ACTIONS(2421),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2421),
    [anon_sym_LBRACE_DASH] = ACTIONS(2421),
    [anon_sym_LBRACK_CARET] = ACTIONS(2421),
    [anon_sym_BANG_LBRACK] = ACTIONS(2421),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2421),
    [anon_sym_LPAREN] = ACTIONS(2421),
    [anon_sym_DOLLAR] = ACTIONS(2421),
    [anon_sym_TODO] = ACTIONS(2421),
    [anon_sym_WIP] = ACTIONS(2421),
    [anon_sym_NOTE] = ACTIONS(2421),
    [anon_sym_INFO] = ACTIONS(2421),
    [anon_sym_XXX] = ACTIONS(2421),
    [sym_fixme] = ACTIONS(2421),
    [aux_sym__text_token1] = ACTIONS(2423),
    [sym__block_close] = ACTIONS(2421),
    [sym__newline] = ACTIONS(2421),
    [sym__newline_inline] = ACTIONS(2421),
    [sym_hard_line_break] = ACTIONS(2421),
    [sym__heading_begin] = ACTIONS(2421),
    [sym__div_begin] = ACTIONS(2421),
    [sym__code_block_begin] = ACTIONS(2421),
    [sym_list_marker_dash] = ACTIONS(2421),
    [sym_list_marker_star] = ACTIONS(2421),
    [sym_list_marker_plus] = ACTIONS(2421),
    [sym__list_marker_task_begin] = ACTIONS(2421),
    [sym_list_marker_definition] = ACTIONS(2421),
    [sym_list_marker_decimal_period] = ACTIONS(2421),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2421),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2421),
    [sym_list_marker_lower_roman_period] = ACTIONS(2421),
    [sym_list_marker_upper_roman_period] = ACTIONS(2421),
    [sym_list_marker_decimal_paren] = ACTIONS(2421),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2421),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2421),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2421),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2421),
    [sym_list_marker_decimal_parens] = ACTIONS(2421),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2421),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2421),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2421),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2421),
    [sym__block_quote_begin] = ACTIONS(2421),
    [sym__block_quote_continuation] = ACTIONS(2421),
    [sym__thematic_break_dash] = ACTIONS(2421),
    [sym__thematic_break_star] = ACTIONS(2421),
    [sym__footnote_mark_begin] = ACTIONS(2421),
    [sym__link_ref_def_mark_begin] = ACTIONS(2421),
    [sym__table_header_begin] = ACTIONS(2421),
    [sym__table_separator_begin] = ACTIONS(2421),
    [sym__table_row_begin] = ACTIONS(2421),
    [sym__table_caption_begin] = ACTIONS(2421),
    [sym__block_attribute_begin] = ACTIONS(2421),
    [sym__verbatim_begin] = ACTIONS(2421),
  },
  [310] = {
    [anon_sym_LBRACK] = ACTIONS(2399),
    [sym__whitespace1] = ACTIONS(2397),
    [sym_quotation_marks] = ACTIONS(2397),
    [sym_ellipsis] = ACTIONS(2397),
    [sym_em_dash] = ACTIONS(2397),
    [sym_en_dash] = ACTIONS(2399),
    [sym_backslash_escape] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(2397),
    [sym_symbol] = ACTIONS(2397),
    [anon_sym_LBRACE_] = ACTIONS(2397),
    [anon_sym__] = ACTIONS(2397),
    [anon_sym_LBRACE_STAR] = ACTIONS(2397),
    [anon_sym_STAR] = ACTIONS(2397),
    [anon_sym_LBRACE_CARET] = ACTIONS(2397),
    [anon_sym_CARET] = ACTIONS(2397),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2397),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_LBRACE_EQ] = ACTIONS(2397),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2397),
    [anon_sym_LBRACE_DASH] = ACTIONS(2397),
    [anon_sym_LBRACK_CARET] = ACTIONS(2397),
    [anon_sym_BANG_LBRACK] = ACTIONS(2397),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2397),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym_DOLLAR] = ACTIONS(2397),
    [anon_sym_TODO] = ACTIONS(2397),
    [anon_sym_WIP] = ACTIONS(2397),
    [anon_sym_NOTE] = ACTIONS(2397),
    [anon_sym_INFO] = ACTIONS(2397),
    [anon_sym_XXX] = ACTIONS(2397),
    [sym_fixme] = ACTIONS(2397),
    [aux_sym__text_token1] = ACTIONS(2399),
    [sym__block_close] = ACTIONS(2397),
    [sym__newline] = ACTIONS(2397),
    [sym__newline_inline] = ACTIONS(2397),
    [sym_hard_line_break] = ACTIONS(2397),
    [sym__heading_begin] = ACTIONS(2397),
    [sym__div_begin] = ACTIONS(2397),
    [sym__div_end] = ACTIONS(2433),
    [sym__code_block_begin] = ACTIONS(2397),
    [sym_list_marker_dash] = ACTIONS(2397),
    [sym_list_marker_star] = ACTIONS(2397),
    [sym_list_marker_plus] = ACTIONS(2397),
    [sym__list_marker_task_begin] = ACTIONS(2397),
    [sym_list_marker_definition] = ACTIONS(2397),
    [sym_list_marker_decimal_period] = ACTIONS(2397),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2397),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2397),
    [sym_list_marker_lower_roman_period] = ACTIONS(2397),
    [sym_list_marker_upper_roman_period] = ACTIONS(2397),
    [sym_list_marker_decimal_paren] = ACTIONS(2397),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2397),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2397),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2397),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2397),
    [sym_list_marker_decimal_parens] = ACTIONS(2397),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2397),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2397),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2397),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2397),
    [sym__block_quote_begin] = ACTIONS(2397),
    [sym__block_quote_continuation] = ACTIONS(2397),
    [sym__thematic_break_dash] = ACTIONS(2397),
    [sym__thematic_break_star] = ACTIONS(2397),
    [sym__footnote_mark_begin] = ACTIONS(2397),
    [sym__link_ref_def_mark_begin] = ACTIONS(2397),
    [sym__table_header_begin] = ACTIONS(2397),
    [sym__table_separator_begin] = ACTIONS(2397),
    [sym__table_row_begin] = ACTIONS(2397),
    [sym__block_attribute_begin] = ACTIONS(2397),
    [sym__verbatim_begin] = ACTIONS(2397),
  },
  [311] = {
    [anon_sym_LBRACK] = ACTIONS(2435),
    [sym__whitespace1] = ACTIONS(2437),
    [sym_quotation_marks] = ACTIONS(2437),
    [sym_ellipsis] = ACTIONS(2437),
    [sym_em_dash] = ACTIONS(2437),
    [sym_en_dash] = ACTIONS(2435),
    [sym_backslash_escape] = ACTIONS(2435),
    [anon_sym_LT] = ACTIONS(2437),
    [sym_symbol] = ACTIONS(2437),
    [anon_sym_LBRACE_] = ACTIONS(2437),
    [anon_sym__] = ACTIONS(2437),
    [anon_sym_LBRACE_STAR] = ACTIONS(2437),
    [anon_sym_STAR] = ACTIONS(2437),
    [anon_sym_LBRACE_CARET] = ACTIONS(2437),
    [anon_sym_CARET] = ACTIONS(2437),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2437),
    [anon_sym_TILDE] = ACTIONS(2437),
    [anon_sym_LBRACE_EQ] = ACTIONS(2437),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2437),
    [anon_sym_LBRACE_DASH] = ACTIONS(2437),
    [anon_sym_LBRACK_CARET] = ACTIONS(2437),
    [anon_sym_BANG_LBRACK] = ACTIONS(2437),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2437),
    [anon_sym_LPAREN] = ACTIONS(2437),
    [anon_sym_DOLLAR] = ACTIONS(2437),
    [anon_sym_TODO] = ACTIONS(2437),
    [anon_sym_WIP] = ACTIONS(2437),
    [anon_sym_NOTE] = ACTIONS(2437),
    [anon_sym_INFO] = ACTIONS(2437),
    [anon_sym_XXX] = ACTIONS(2437),
    [sym_fixme] = ACTIONS(2437),
    [aux_sym__text_token1] = ACTIONS(2435),
    [sym__block_close] = ACTIONS(2437),
    [sym__newline] = ACTIONS(2437),
    [sym__newline_inline] = ACTIONS(2437),
    [sym_hard_line_break] = ACTIONS(2437),
    [sym__heading_begin] = ACTIONS(2437),
    [sym__div_begin] = ACTIONS(2437),
    [sym__code_block_begin] = ACTIONS(2437),
    [sym__code_block_end] = ACTIONS(2439),
    [sym_list_marker_dash] = ACTIONS(2437),
    [sym_list_marker_star] = ACTIONS(2437),
    [sym_list_marker_plus] = ACTIONS(2437),
    [sym__list_marker_task_begin] = ACTIONS(2437),
    [sym_list_marker_definition] = ACTIONS(2437),
    [sym_list_marker_decimal_period] = ACTIONS(2437),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2437),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2437),
    [sym_list_marker_lower_roman_period] = ACTIONS(2437),
    [sym_list_marker_upper_roman_period] = ACTIONS(2437),
    [sym_list_marker_decimal_paren] = ACTIONS(2437),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2437),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2437),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2437),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2437),
    [sym_list_marker_decimal_parens] = ACTIONS(2437),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2437),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2437),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2437),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2437),
    [sym__block_quote_begin] = ACTIONS(2437),
    [sym__block_quote_continuation] = ACTIONS(2437),
    [sym__thematic_break_dash] = ACTIONS(2437),
    [sym__thematic_break_star] = ACTIONS(2437),
    [sym__footnote_mark_begin] = ACTIONS(2437),
    [sym__link_ref_def_mark_begin] = ACTIONS(2437),
    [sym__table_header_begin] = ACTIONS(2437),
    [sym__table_separator_begin] = ACTIONS(2437),
    [sym__table_row_begin] = ACTIONS(2437),
    [sym__block_attribute_begin] = ACTIONS(2437),
    [sym__verbatim_begin] = ACTIONS(2437),
  },
  [312] = {
    [anon_sym_LBRACK] = ACTIONS(2441),
    [sym__whitespace1] = ACTIONS(2443),
    [sym_quotation_marks] = ACTIONS(2443),
    [sym_ellipsis] = ACTIONS(2443),
    [sym_em_dash] = ACTIONS(2443),
    [sym_en_dash] = ACTIONS(2441),
    [sym_backslash_escape] = ACTIONS(2441),
    [anon_sym_LT] = ACTIONS(2443),
    [sym_symbol] = ACTIONS(2443),
    [anon_sym_LBRACE_] = ACTIONS(2443),
    [anon_sym__] = ACTIONS(2443),
    [anon_sym_LBRACE_STAR] = ACTIONS(2443),
    [anon_sym_STAR] = ACTIONS(2443),
    [anon_sym_LBRACE_CARET] = ACTIONS(2443),
    [anon_sym_CARET] = ACTIONS(2443),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2443),
    [anon_sym_TILDE] = ACTIONS(2443),
    [anon_sym_LBRACE_EQ] = ACTIONS(2443),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2443),
    [anon_sym_LBRACE_DASH] = ACTIONS(2443),
    [anon_sym_LBRACK_CARET] = ACTIONS(2443),
    [anon_sym_BANG_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2443),
    [anon_sym_LPAREN] = ACTIONS(2443),
    [anon_sym_DOLLAR] = ACTIONS(2443),
    [anon_sym_TODO] = ACTIONS(2443),
    [anon_sym_WIP] = ACTIONS(2443),
    [anon_sym_NOTE] = ACTIONS(2443),
    [anon_sym_INFO] = ACTIONS(2443),
    [anon_sym_XXX] = ACTIONS(2443),
    [sym_fixme] = ACTIONS(2443),
    [aux_sym__text_token1] = ACTIONS(2441),
    [sym__block_close] = ACTIONS(2443),
    [sym__newline] = ACTIONS(2443),
    [sym__newline_inline] = ACTIONS(2443),
    [sym_hard_line_break] = ACTIONS(2443),
    [sym__heading_begin] = ACTIONS(2443),
    [sym__div_begin] = ACTIONS(2443),
    [sym__div_end] = ACTIONS(2445),
    [sym__code_block_begin] = ACTIONS(2443),
    [sym_list_marker_dash] = ACTIONS(2443),
    [sym_list_marker_star] = ACTIONS(2443),
    [sym_list_marker_plus] = ACTIONS(2443),
    [sym__list_marker_task_begin] = ACTIONS(2443),
    [sym_list_marker_definition] = ACTIONS(2443),
    [sym_list_marker_decimal_period] = ACTIONS(2443),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2443),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2443),
    [sym_list_marker_lower_roman_period] = ACTIONS(2443),
    [sym_list_marker_upper_roman_period] = ACTIONS(2443),
    [sym_list_marker_decimal_paren] = ACTIONS(2443),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2443),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2443),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2443),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2443),
    [sym_list_marker_decimal_parens] = ACTIONS(2443),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2443),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2443),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2443),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2443),
    [sym__block_quote_begin] = ACTIONS(2443),
    [sym__block_quote_continuation] = ACTIONS(2443),
    [sym__thematic_break_dash] = ACTIONS(2443),
    [sym__thematic_break_star] = ACTIONS(2443),
    [sym__footnote_mark_begin] = ACTIONS(2443),
    [sym__link_ref_def_mark_begin] = ACTIONS(2443),
    [sym__table_header_begin] = ACTIONS(2443),
    [sym__table_separator_begin] = ACTIONS(2443),
    [sym__table_row_begin] = ACTIONS(2443),
    [sym__block_attribute_begin] = ACTIONS(2443),
    [sym__verbatim_begin] = ACTIONS(2443),
  },
  [313] = {
    [anon_sym_LBRACK] = ACTIONS(2367),
    [sym__whitespace1] = ACTIONS(2365),
    [sym_quotation_marks] = ACTIONS(2365),
    [sym_ellipsis] = ACTIONS(2365),
    [sym_em_dash] = ACTIONS(2365),
    [sym_en_dash] = ACTIONS(2367),
    [sym_backslash_escape] = ACTIONS(2367),
    [anon_sym_LT] = ACTIONS(2365),
    [sym_symbol] = ACTIONS(2365),
    [anon_sym_LBRACE_] = ACTIONS(2365),
    [anon_sym__] = ACTIONS(2365),
    [anon_sym_LBRACE_STAR] = ACTIONS(2365),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_LBRACE_CARET] = ACTIONS(2365),
    [anon_sym_CARET] = ACTIONS(2365),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2365),
    [anon_sym_TILDE] = ACTIONS(2365),
    [anon_sym_LBRACE_EQ] = ACTIONS(2365),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2365),
    [anon_sym_LBRACE_DASH] = ACTIONS(2365),
    [anon_sym_LBRACK_CARET] = ACTIONS(2365),
    [anon_sym_BANG_LBRACK] = ACTIONS(2365),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2365),
    [anon_sym_LPAREN] = ACTIONS(2365),
    [anon_sym_DOLLAR] = ACTIONS(2365),
    [anon_sym_TODO] = ACTIONS(2365),
    [anon_sym_WIP] = ACTIONS(2365),
    [anon_sym_NOTE] = ACTIONS(2365),
    [anon_sym_INFO] = ACTIONS(2365),
    [anon_sym_XXX] = ACTIONS(2365),
    [sym_fixme] = ACTIONS(2365),
    [aux_sym__text_token1] = ACTIONS(2367),
    [sym__block_close] = ACTIONS(2365),
    [sym__newline] = ACTIONS(2365),
    [sym__newline_inline] = ACTIONS(2365),
    [sym_hard_line_break] = ACTIONS(2365),
    [sym__heading_begin] = ACTIONS(2365),
    [sym__div_begin] = ACTIONS(2365),
    [sym__div_end] = ACTIONS(2447),
    [sym__code_block_begin] = ACTIONS(2365),
    [sym_list_marker_dash] = ACTIONS(2365),
    [sym_list_marker_star] = ACTIONS(2365),
    [sym_list_marker_plus] = ACTIONS(2365),
    [sym__list_marker_task_begin] = ACTIONS(2365),
    [sym_list_marker_definition] = ACTIONS(2365),
    [sym_list_marker_decimal_period] = ACTIONS(2365),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2365),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2365),
    [sym_list_marker_lower_roman_period] = ACTIONS(2365),
    [sym_list_marker_upper_roman_period] = ACTIONS(2365),
    [sym_list_marker_decimal_paren] = ACTIONS(2365),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2365),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2365),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2365),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2365),
    [sym_list_marker_decimal_parens] = ACTIONS(2365),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2365),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2365),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2365),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2365),
    [sym__block_quote_begin] = ACTIONS(2365),
    [sym__block_quote_continuation] = ACTIONS(2365),
    [sym__thematic_break_dash] = ACTIONS(2365),
    [sym__thematic_break_star] = ACTIONS(2365),
    [sym__footnote_mark_begin] = ACTIONS(2365),
    [sym__link_ref_def_mark_begin] = ACTIONS(2365),
    [sym__table_header_begin] = ACTIONS(2365),
    [sym__table_separator_begin] = ACTIONS(2365),
    [sym__table_row_begin] = ACTIONS(2365),
    [sym__block_attribute_begin] = ACTIONS(2365),
    [sym__verbatim_begin] = ACTIONS(2365),
  },
  [314] = {
    [ts_builtin_sym_end] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2409),
    [sym__whitespace1] = ACTIONS(2411),
    [sym_quotation_marks] = ACTIONS(2411),
    [sym_ellipsis] = ACTIONS(2411),
    [sym_em_dash] = ACTIONS(2411),
    [sym_en_dash] = ACTIONS(2409),
    [sym_backslash_escape] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(2411),
    [sym_symbol] = ACTIONS(2411),
    [anon_sym_LBRACE_] = ACTIONS(2411),
    [anon_sym__] = ACTIONS(2411),
    [anon_sym_LBRACE_STAR] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LBRACE_CARET] = ACTIONS(2411),
    [anon_sym_CARET] = ACTIONS(2411),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_LBRACE_EQ] = ACTIONS(2411),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2411),
    [anon_sym_LBRACE_DASH] = ACTIONS(2411),
    [anon_sym_LBRACK_CARET] = ACTIONS(2411),
    [anon_sym_BANG_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2411),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_TODO] = ACTIONS(2411),
    [anon_sym_WIP] = ACTIONS(2411),
    [anon_sym_NOTE] = ACTIONS(2411),
    [anon_sym_INFO] = ACTIONS(2411),
    [anon_sym_XXX] = ACTIONS(2411),
    [sym_fixme] = ACTIONS(2411),
    [aux_sym__text_token1] = ACTIONS(2409),
    [sym__newline] = ACTIONS(2411),
    [sym__newline_inline] = ACTIONS(2411),
    [sym_hard_line_break] = ACTIONS(2411),
    [sym__heading_begin] = ACTIONS(2411),
    [sym__div_begin] = ACTIONS(2411),
    [sym__code_block_begin] = ACTIONS(2411),
    [sym__code_block_end] = ACTIONS(2449),
    [sym_list_marker_dash] = ACTIONS(2411),
    [sym_list_marker_star] = ACTIONS(2411),
    [sym_list_marker_plus] = ACTIONS(2411),
    [sym__list_marker_task_begin] = ACTIONS(2411),
    [sym_list_marker_definition] = ACTIONS(2411),
    [sym_list_marker_decimal_period] = ACTIONS(2411),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2411),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2411),
    [sym_list_marker_lower_roman_period] = ACTIONS(2411),
    [sym_list_marker_upper_roman_period] = ACTIONS(2411),
    [sym_list_marker_decimal_paren] = ACTIONS(2411),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2411),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2411),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2411),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2411),
    [sym_list_marker_decimal_parens] = ACTIONS(2411),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2411),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2411),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2411),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2411),
    [sym__block_quote_begin] = ACTIONS(2411),
    [sym__block_quote_continuation] = ACTIONS(2411),
    [sym__thematic_break_dash] = ACTIONS(2411),
    [sym__thematic_break_star] = ACTIONS(2411),
    [sym__footnote_mark_begin] = ACTIONS(2411),
    [sym__link_ref_def_mark_begin] = ACTIONS(2411),
    [sym__table_header_begin] = ACTIONS(2411),
    [sym__table_separator_begin] = ACTIONS(2411),
    [sym__table_row_begin] = ACTIONS(2411),
    [sym__block_attribute_begin] = ACTIONS(2411),
    [sym__verbatim_begin] = ACTIONS(2411),
  },
  [315] = {
    [ts_builtin_sym_end] = ACTIONS(2437),
    [anon_sym_LBRACK] = ACTIONS(2435),
    [sym__whitespace1] = ACTIONS(2437),
    [sym_quotation_marks] = ACTIONS(2437),
    [sym_ellipsis] = ACTIONS(2437),
    [sym_em_dash] = ACTIONS(2437),
    [sym_en_dash] = ACTIONS(2435),
    [sym_backslash_escape] = ACTIONS(2435),
    [anon_sym_LT] = ACTIONS(2437),
    [sym_symbol] = ACTIONS(2437),
    [anon_sym_LBRACE_] = ACTIONS(2437),
    [anon_sym__] = ACTIONS(2437),
    [anon_sym_LBRACE_STAR] = ACTIONS(2437),
    [anon_sym_STAR] = ACTIONS(2437),
    [anon_sym_LBRACE_CARET] = ACTIONS(2437),
    [anon_sym_CARET] = ACTIONS(2437),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2437),
    [anon_sym_TILDE] = ACTIONS(2437),
    [anon_sym_LBRACE_EQ] = ACTIONS(2437),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2437),
    [anon_sym_LBRACE_DASH] = ACTIONS(2437),
    [anon_sym_LBRACK_CARET] = ACTIONS(2437),
    [anon_sym_BANG_LBRACK] = ACTIONS(2437),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2437),
    [anon_sym_LPAREN] = ACTIONS(2437),
    [anon_sym_DOLLAR] = ACTIONS(2437),
    [anon_sym_TODO] = ACTIONS(2437),
    [anon_sym_WIP] = ACTIONS(2437),
    [anon_sym_NOTE] = ACTIONS(2437),
    [anon_sym_INFO] = ACTIONS(2437),
    [anon_sym_XXX] = ACTIONS(2437),
    [sym_fixme] = ACTIONS(2437),
    [aux_sym__text_token1] = ACTIONS(2435),
    [sym__newline] = ACTIONS(2437),
    [sym__newline_inline] = ACTIONS(2437),
    [sym_hard_line_break] = ACTIONS(2437),
    [sym__heading_begin] = ACTIONS(2437),
    [sym__div_begin] = ACTIONS(2437),
    [sym__code_block_begin] = ACTIONS(2437),
    [sym__code_block_end] = ACTIONS(2451),
    [sym_list_marker_dash] = ACTIONS(2437),
    [sym_list_marker_star] = ACTIONS(2437),
    [sym_list_marker_plus] = ACTIONS(2437),
    [sym__list_marker_task_begin] = ACTIONS(2437),
    [sym_list_marker_definition] = ACTIONS(2437),
    [sym_list_marker_decimal_period] = ACTIONS(2437),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2437),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2437),
    [sym_list_marker_lower_roman_period] = ACTIONS(2437),
    [sym_list_marker_upper_roman_period] = ACTIONS(2437),
    [sym_list_marker_decimal_paren] = ACTIONS(2437),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2437),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2437),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2437),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2437),
    [sym_list_marker_decimal_parens] = ACTIONS(2437),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2437),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2437),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2437),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2437),
    [sym__block_quote_begin] = ACTIONS(2437),
    [sym__block_quote_continuation] = ACTIONS(2437),
    [sym__thematic_break_dash] = ACTIONS(2437),
    [sym__thematic_break_star] = ACTIONS(2437),
    [sym__footnote_mark_begin] = ACTIONS(2437),
    [sym__link_ref_def_mark_begin] = ACTIONS(2437),
    [sym__table_header_begin] = ACTIONS(2437),
    [sym__table_separator_begin] = ACTIONS(2437),
    [sym__table_row_begin] = ACTIONS(2437),
    [sym__block_attribute_begin] = ACTIONS(2437),
    [sym__verbatim_begin] = ACTIONS(2437),
  },
  [316] = {
    [ts_builtin_sym_end] = ACTIONS(2417),
    [anon_sym_LBRACK] = ACTIONS(2415),
    [sym__whitespace1] = ACTIONS(2417),
    [sym_quotation_marks] = ACTIONS(2417),
    [sym_ellipsis] = ACTIONS(2417),
    [sym_em_dash] = ACTIONS(2417),
    [sym_en_dash] = ACTIONS(2415),
    [sym_backslash_escape] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2417),
    [sym_symbol] = ACTIONS(2417),
    [anon_sym_LBRACE_] = ACTIONS(2417),
    [anon_sym__] = ACTIONS(2417),
    [anon_sym_LBRACE_STAR] = ACTIONS(2417),
    [anon_sym_STAR] = ACTIONS(2417),
    [anon_sym_LBRACE_CARET] = ACTIONS(2417),
    [anon_sym_CARET] = ACTIONS(2417),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2417),
    [anon_sym_TILDE] = ACTIONS(2417),
    [anon_sym_LBRACE_EQ] = ACTIONS(2417),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2417),
    [anon_sym_LBRACE_DASH] = ACTIONS(2417),
    [anon_sym_LBRACK_CARET] = ACTIONS(2417),
    [anon_sym_BANG_LBRACK] = ACTIONS(2417),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2417),
    [anon_sym_LPAREN] = ACTIONS(2417),
    [anon_sym_DOLLAR] = ACTIONS(2417),
    [anon_sym_TODO] = ACTIONS(2417),
    [anon_sym_WIP] = ACTIONS(2417),
    [anon_sym_NOTE] = ACTIONS(2417),
    [anon_sym_INFO] = ACTIONS(2417),
    [anon_sym_XXX] = ACTIONS(2417),
    [sym_fixme] = ACTIONS(2417),
    [aux_sym__text_token1] = ACTIONS(2415),
    [sym__newline] = ACTIONS(2417),
    [sym__newline_inline] = ACTIONS(2417),
    [sym_hard_line_break] = ACTIONS(2417),
    [sym__heading_begin] = ACTIONS(2417),
    [sym__div_begin] = ACTIONS(2417),
    [sym__code_block_begin] = ACTIONS(2417),
    [sym__code_block_end] = ACTIONS(2453),
    [sym_list_marker_dash] = ACTIONS(2417),
    [sym_list_marker_star] = ACTIONS(2417),
    [sym_list_marker_plus] = ACTIONS(2417),
    [sym__list_marker_task_begin] = ACTIONS(2417),
    [sym_list_marker_definition] = ACTIONS(2417),
    [sym_list_marker_decimal_period] = ACTIONS(2417),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2417),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2417),
    [sym_list_marker_lower_roman_period] = ACTIONS(2417),
    [sym_list_marker_upper_roman_period] = ACTIONS(2417),
    [sym_list_marker_decimal_paren] = ACTIONS(2417),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2417),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2417),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2417),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2417),
    [sym_list_marker_decimal_parens] = ACTIONS(2417),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2417),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2417),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2417),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2417),
    [sym__block_quote_begin] = ACTIONS(2417),
    [sym__block_quote_continuation] = ACTIONS(2417),
    [sym__thematic_break_dash] = ACTIONS(2417),
    [sym__thematic_break_star] = ACTIONS(2417),
    [sym__footnote_mark_begin] = ACTIONS(2417),
    [sym__link_ref_def_mark_begin] = ACTIONS(2417),
    [sym__table_header_begin] = ACTIONS(2417),
    [sym__table_separator_begin] = ACTIONS(2417),
    [sym__table_row_begin] = ACTIONS(2417),
    [sym__block_attribute_begin] = ACTIONS(2417),
    [sym__verbatim_begin] = ACTIONS(2417),
  },
  [317] = {
    [anon_sym_LBRACK] = ACTIONS(2377),
    [sym__whitespace1] = ACTIONS(2375),
    [sym_quotation_marks] = ACTIONS(2375),
    [sym_ellipsis] = ACTIONS(2375),
    [sym_em_dash] = ACTIONS(2375),
    [sym_en_dash] = ACTIONS(2377),
    [sym_backslash_escape] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2375),
    [sym_symbol] = ACTIONS(2375),
    [anon_sym_LBRACE_] = ACTIONS(2375),
    [anon_sym__] = ACTIONS(2375),
    [anon_sym_LBRACE_STAR] = ACTIONS(2375),
    [anon_sym_STAR] = ACTIONS(2375),
    [anon_sym_LBRACE_CARET] = ACTIONS(2375),
    [anon_sym_CARET] = ACTIONS(2375),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2375),
    [anon_sym_TILDE] = ACTIONS(2375),
    [anon_sym_LBRACE_EQ] = ACTIONS(2375),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2375),
    [anon_sym_LBRACE_DASH] = ACTIONS(2375),
    [anon_sym_LBRACK_CARET] = ACTIONS(2375),
    [anon_sym_BANG_LBRACK] = ACTIONS(2375),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2375),
    [anon_sym_LPAREN] = ACTIONS(2375),
    [anon_sym_DOLLAR] = ACTIONS(2375),
    [anon_sym_TODO] = ACTIONS(2375),
    [anon_sym_WIP] = ACTIONS(2375),
    [anon_sym_NOTE] = ACTIONS(2375),
    [anon_sym_INFO] = ACTIONS(2375),
    [anon_sym_XXX] = ACTIONS(2375),
    [sym_fixme] = ACTIONS(2375),
    [aux_sym__text_token1] = ACTIONS(2377),
    [sym__block_close] = ACTIONS(2375),
    [sym__newline] = ACTIONS(2375),
    [sym__newline_inline] = ACTIONS(2375),
    [sym_hard_line_break] = ACTIONS(2375),
    [sym__heading_begin] = ACTIONS(2375),
    [sym__div_begin] = ACTIONS(2375),
    [sym__code_block_begin] = ACTIONS(2375),
    [sym__code_block_end] = ACTIONS(2455),
    [sym_list_marker_dash] = ACTIONS(2375),
    [sym_list_marker_star] = ACTIONS(2375),
    [sym_list_marker_plus] = ACTIONS(2375),
    [sym__list_marker_task_begin] = ACTIONS(2375),
    [sym_list_marker_definition] = ACTIONS(2375),
    [sym_list_marker_decimal_period] = ACTIONS(2375),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2375),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2375),
    [sym_list_marker_lower_roman_period] = ACTIONS(2375),
    [sym_list_marker_upper_roman_period] = ACTIONS(2375),
    [sym_list_marker_decimal_paren] = ACTIONS(2375),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2375),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2375),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2375),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2375),
    [sym_list_marker_decimal_parens] = ACTIONS(2375),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2375),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2375),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2375),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2375),
    [sym__block_quote_begin] = ACTIONS(2375),
    [sym__block_quote_continuation] = ACTIONS(2375),
    [sym__thematic_break_dash] = ACTIONS(2375),
    [sym__thematic_break_star] = ACTIONS(2375),
    [sym__footnote_mark_begin] = ACTIONS(2375),
    [sym__link_ref_def_mark_begin] = ACTIONS(2375),
    [sym__table_header_begin] = ACTIONS(2375),
    [sym__table_separator_begin] = ACTIONS(2375),
    [sym__table_row_begin] = ACTIONS(2375),
    [sym__block_attribute_begin] = ACTIONS(2375),
    [sym__verbatim_begin] = ACTIONS(2375),
  },
  [318] = {
    [anon_sym_LBRACK] = ACTIONS(2383),
    [sym__whitespace1] = ACTIONS(2381),
    [sym_quotation_marks] = ACTIONS(2381),
    [sym_ellipsis] = ACTIONS(2381),
    [sym_em_dash] = ACTIONS(2381),
    [sym_en_dash] = ACTIONS(2383),
    [sym_backslash_escape] = ACTIONS(2383),
    [anon_sym_LT] = ACTIONS(2381),
    [sym_symbol] = ACTIONS(2381),
    [anon_sym_LBRACE_] = ACTIONS(2381),
    [anon_sym__] = ACTIONS(2381),
    [anon_sym_LBRACE_STAR] = ACTIONS(2381),
    [anon_sym_STAR] = ACTIONS(2381),
    [anon_sym_LBRACE_CARET] = ACTIONS(2381),
    [anon_sym_CARET] = ACTIONS(2381),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [anon_sym_LBRACE_EQ] = ACTIONS(2381),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2381),
    [anon_sym_LBRACE_DASH] = ACTIONS(2381),
    [anon_sym_LBRACK_CARET] = ACTIONS(2381),
    [anon_sym_BANG_LBRACK] = ACTIONS(2381),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2381),
    [anon_sym_LPAREN] = ACTIONS(2381),
    [anon_sym_DOLLAR] = ACTIONS(2381),
    [anon_sym_TODO] = ACTIONS(2381),
    [anon_sym_WIP] = ACTIONS(2381),
    [anon_sym_NOTE] = ACTIONS(2381),
    [anon_sym_INFO] = ACTIONS(2381),
    [anon_sym_XXX] = ACTIONS(2381),
    [sym_fixme] = ACTIONS(2381),
    [aux_sym__text_token1] = ACTIONS(2383),
    [sym__block_close] = ACTIONS(2381),
    [sym__newline] = ACTIONS(2381),
    [sym__newline_inline] = ACTIONS(2381),
    [sym_hard_line_break] = ACTIONS(2381),
    [sym__heading_begin] = ACTIONS(2381),
    [sym__div_begin] = ACTIONS(2381),
    [sym__code_block_begin] = ACTIONS(2381),
    [sym__code_block_end] = ACTIONS(2457),
    [sym_list_marker_dash] = ACTIONS(2381),
    [sym_list_marker_star] = ACTIONS(2381),
    [sym_list_marker_plus] = ACTIONS(2381),
    [sym__list_marker_task_begin] = ACTIONS(2381),
    [sym_list_marker_definition] = ACTIONS(2381),
    [sym_list_marker_decimal_period] = ACTIONS(2381),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2381),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2381),
    [sym_list_marker_lower_roman_period] = ACTIONS(2381),
    [sym_list_marker_upper_roman_period] = ACTIONS(2381),
    [sym_list_marker_decimal_paren] = ACTIONS(2381),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2381),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2381),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2381),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2381),
    [sym_list_marker_decimal_parens] = ACTIONS(2381),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2381),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2381),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2381),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2381),
    [sym__block_quote_begin] = ACTIONS(2381),
    [sym__block_quote_continuation] = ACTIONS(2381),
    [sym__thematic_break_dash] = ACTIONS(2381),
    [sym__thematic_break_star] = ACTIONS(2381),
    [sym__footnote_mark_begin] = ACTIONS(2381),
    [sym__link_ref_def_mark_begin] = ACTIONS(2381),
    [sym__table_header_begin] = ACTIONS(2381),
    [sym__table_separator_begin] = ACTIONS(2381),
    [sym__table_row_begin] = ACTIONS(2381),
    [sym__block_attribute_begin] = ACTIONS(2381),
    [sym__verbatim_begin] = ACTIONS(2381),
  },
  [319] = {
    [ts_builtin_sym_end] = ACTIONS(2443),
    [anon_sym_LBRACK] = ACTIONS(2441),
    [sym__whitespace1] = ACTIONS(2443),
    [sym_quotation_marks] = ACTIONS(2443),
    [sym_ellipsis] = ACTIONS(2443),
    [sym_em_dash] = ACTIONS(2443),
    [sym_en_dash] = ACTIONS(2441),
    [sym_backslash_escape] = ACTIONS(2441),
    [anon_sym_LT] = ACTIONS(2443),
    [sym_symbol] = ACTIONS(2443),
    [anon_sym_LBRACE_] = ACTIONS(2443),
    [anon_sym__] = ACTIONS(2443),
    [anon_sym_LBRACE_STAR] = ACTIONS(2443),
    [anon_sym_STAR] = ACTIONS(2443),
    [anon_sym_LBRACE_CARET] = ACTIONS(2443),
    [anon_sym_CARET] = ACTIONS(2443),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2443),
    [anon_sym_TILDE] = ACTIONS(2443),
    [anon_sym_LBRACE_EQ] = ACTIONS(2443),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2443),
    [anon_sym_LBRACE_DASH] = ACTIONS(2443),
    [anon_sym_LBRACK_CARET] = ACTIONS(2443),
    [anon_sym_BANG_LBRACK] = ACTIONS(2443),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2443),
    [anon_sym_LPAREN] = ACTIONS(2443),
    [anon_sym_DOLLAR] = ACTIONS(2443),
    [anon_sym_TODO] = ACTIONS(2443),
    [anon_sym_WIP] = ACTIONS(2443),
    [anon_sym_NOTE] = ACTIONS(2443),
    [anon_sym_INFO] = ACTIONS(2443),
    [anon_sym_XXX] = ACTIONS(2443),
    [sym_fixme] = ACTIONS(2443),
    [aux_sym__text_token1] = ACTIONS(2441),
    [sym__newline] = ACTIONS(2443),
    [sym__newline_inline] = ACTIONS(2443),
    [sym_hard_line_break] = ACTIONS(2443),
    [sym__heading_begin] = ACTIONS(2443),
    [sym__div_begin] = ACTIONS(2443),
    [sym__div_end] = ACTIONS(2459),
    [sym__code_block_begin] = ACTIONS(2443),
    [sym_list_marker_dash] = ACTIONS(2443),
    [sym_list_marker_star] = ACTIONS(2443),
    [sym_list_marker_plus] = ACTIONS(2443),
    [sym__list_marker_task_begin] = ACTIONS(2443),
    [sym_list_marker_definition] = ACTIONS(2443),
    [sym_list_marker_decimal_period] = ACTIONS(2443),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2443),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2443),
    [sym_list_marker_lower_roman_period] = ACTIONS(2443),
    [sym_list_marker_upper_roman_period] = ACTIONS(2443),
    [sym_list_marker_decimal_paren] = ACTIONS(2443),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2443),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2443),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2443),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2443),
    [sym_list_marker_decimal_parens] = ACTIONS(2443),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2443),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2443),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2443),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2443),
    [sym__block_quote_begin] = ACTIONS(2443),
    [sym__block_quote_continuation] = ACTIONS(2443),
    [sym__thematic_break_dash] = ACTIONS(2443),
    [sym__thematic_break_star] = ACTIONS(2443),
    [sym__footnote_mark_begin] = ACTIONS(2443),
    [sym__link_ref_def_mark_begin] = ACTIONS(2443),
    [sym__table_header_begin] = ACTIONS(2443),
    [sym__table_separator_begin] = ACTIONS(2443),
    [sym__table_row_begin] = ACTIONS(2443),
    [sym__block_attribute_begin] = ACTIONS(2443),
    [sym__verbatim_begin] = ACTIONS(2443),
  },
  [320] = {
    [anon_sym_LBRACK] = ACTIONS(2389),
    [sym__whitespace1] = ACTIONS(2387),
    [sym_quotation_marks] = ACTIONS(2387),
    [sym_ellipsis] = ACTIONS(2387),
    [sym_em_dash] = ACTIONS(2387),
    [sym_en_dash] = ACTIONS(2389),
    [sym_backslash_escape] = ACTIONS(2389),
    [anon_sym_LT] = ACTIONS(2387),
    [sym_symbol] = ACTIONS(2387),
    [anon_sym_LBRACE_] = ACTIONS(2387),
    [anon_sym__] = ACTIONS(2387),
    [anon_sym_LBRACE_STAR] = ACTIONS(2387),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_LBRACE_CARET] = ACTIONS(2387),
    [anon_sym_CARET] = ACTIONS(2387),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2387),
    [anon_sym_TILDE] = ACTIONS(2387),
    [anon_sym_LBRACE_EQ] = ACTIONS(2387),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2387),
    [anon_sym_LBRACE_DASH] = ACTIONS(2387),
    [anon_sym_LBRACK_CARET] = ACTIONS(2387),
    [anon_sym_BANG_LBRACK] = ACTIONS(2387),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2387),
    [anon_sym_LPAREN] = ACTIONS(2387),
    [anon_sym_DOLLAR] = ACTIONS(2387),
    [anon_sym_TODO] = ACTIONS(2387),
    [anon_sym_WIP] = ACTIONS(2387),
    [anon_sym_NOTE] = ACTIONS(2387),
    [anon_sym_INFO] = ACTIONS(2387),
    [anon_sym_XXX] = ACTIONS(2387),
    [sym_fixme] = ACTIONS(2387),
    [aux_sym__text_token1] = ACTIONS(2389),
    [sym__block_close] = ACTIONS(2387),
    [sym__newline] = ACTIONS(2387),
    [sym__newline_inline] = ACTIONS(2387),
    [sym_hard_line_break] = ACTIONS(2387),
    [sym__heading_begin] = ACTIONS(2387),
    [sym__div_begin] = ACTIONS(2387),
    [sym__code_block_begin] = ACTIONS(2387),
    [sym__code_block_end] = ACTIONS(2461),
    [sym_list_marker_dash] = ACTIONS(2387),
    [sym_list_marker_star] = ACTIONS(2387),
    [sym_list_marker_plus] = ACTIONS(2387),
    [sym__list_marker_task_begin] = ACTIONS(2387),
    [sym_list_marker_definition] = ACTIONS(2387),
    [sym_list_marker_decimal_period] = ACTIONS(2387),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2387),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2387),
    [sym_list_marker_lower_roman_period] = ACTIONS(2387),
    [sym_list_marker_upper_roman_period] = ACTIONS(2387),
    [sym_list_marker_decimal_paren] = ACTIONS(2387),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2387),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2387),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2387),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2387),
    [sym_list_marker_decimal_parens] = ACTIONS(2387),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2387),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2387),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2387),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2387),
    [sym__block_quote_begin] = ACTIONS(2387),
    [sym__block_quote_continuation] = ACTIONS(2387),
    [sym__thematic_break_dash] = ACTIONS(2387),
    [sym__thematic_break_star] = ACTIONS(2387),
    [sym__footnote_mark_begin] = ACTIONS(2387),
    [sym__link_ref_def_mark_begin] = ACTIONS(2387),
    [sym__table_header_begin] = ACTIONS(2387),
    [sym__table_separator_begin] = ACTIONS(2387),
    [sym__table_row_begin] = ACTIONS(2387),
    [sym__block_attribute_begin] = ACTIONS(2387),
    [sym__verbatim_begin] = ACTIONS(2387),
  },
  [321] = {
    [ts_builtin_sym_end] = ACTIONS(2427),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [sym__whitespace1] = ACTIONS(2427),
    [sym_quotation_marks] = ACTIONS(2427),
    [sym_ellipsis] = ACTIONS(2427),
    [sym_em_dash] = ACTIONS(2427),
    [sym_en_dash] = ACTIONS(2425),
    [sym_backslash_escape] = ACTIONS(2425),
    [anon_sym_LT] = ACTIONS(2427),
    [sym_symbol] = ACTIONS(2427),
    [anon_sym_LBRACE_] = ACTIONS(2427),
    [anon_sym__] = ACTIONS(2427),
    [anon_sym_LBRACE_STAR] = ACTIONS(2427),
    [anon_sym_STAR] = ACTIONS(2427),
    [anon_sym_LBRACE_CARET] = ACTIONS(2427),
    [anon_sym_CARET] = ACTIONS(2427),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [anon_sym_LBRACE_EQ] = ACTIONS(2427),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2427),
    [anon_sym_LBRACE_DASH] = ACTIONS(2427),
    [anon_sym_LBRACK_CARET] = ACTIONS(2427),
    [anon_sym_BANG_LBRACK] = ACTIONS(2427),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2427),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [anon_sym_DOLLAR] = ACTIONS(2427),
    [anon_sym_TODO] = ACTIONS(2427),
    [anon_sym_WIP] = ACTIONS(2427),
    [anon_sym_NOTE] = ACTIONS(2427),
    [anon_sym_INFO] = ACTIONS(2427),
    [anon_sym_XXX] = ACTIONS(2427),
    [sym_fixme] = ACTIONS(2427),
    [aux_sym__text_token1] = ACTIONS(2425),
    [sym__newline] = ACTIONS(2427),
    [sym__newline_inline] = ACTIONS(2427),
    [sym_hard_line_break] = ACTIONS(2427),
    [sym__heading_begin] = ACTIONS(2427),
    [sym__div_begin] = ACTIONS(2427),
    [sym__code_block_begin] = ACTIONS(2427),
    [sym_list_marker_dash] = ACTIONS(2427),
    [sym_list_marker_star] = ACTIONS(2427),
    [sym_list_marker_plus] = ACTIONS(2427),
    [sym__list_marker_task_begin] = ACTIONS(2427),
    [sym_list_marker_definition] = ACTIONS(2427),
    [sym_list_marker_decimal_period] = ACTIONS(2427),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2427),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2427),
    [sym_list_marker_lower_roman_period] = ACTIONS(2427),
    [sym_list_marker_upper_roman_period] = ACTIONS(2427),
    [sym_list_marker_decimal_paren] = ACTIONS(2427),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2427),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2427),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2427),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2427),
    [sym_list_marker_decimal_parens] = ACTIONS(2427),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2427),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2427),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2427),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2427),
    [sym__block_quote_begin] = ACTIONS(2427),
    [sym__block_quote_continuation] = ACTIONS(2427),
    [sym__thematic_break_dash] = ACTIONS(2427),
    [sym__thematic_break_star] = ACTIONS(2427),
    [sym__footnote_mark_begin] = ACTIONS(2427),
    [sym__link_ref_def_mark_begin] = ACTIONS(2427),
    [sym__table_header_begin] = ACTIONS(2427),
    [sym__table_separator_begin] = ACTIONS(2427),
    [sym__table_row_begin] = ACTIONS(2427),
    [sym__table_caption_begin] = ACTIONS(2427),
    [sym__block_attribute_begin] = ACTIONS(2427),
    [sym__verbatim_begin] = ACTIONS(2427),
  },
  [322] = {
    [anon_sym_LBRACK] = ACTIONS(2405),
    [sym__whitespace1] = ACTIONS(2403),
    [sym_quotation_marks] = ACTIONS(2403),
    [sym_ellipsis] = ACTIONS(2403),
    [sym_em_dash] = ACTIONS(2403),
    [sym_en_dash] = ACTIONS(2405),
    [sym_backslash_escape] = ACTIONS(2405),
    [anon_sym_LT] = ACTIONS(2403),
    [sym_symbol] = ACTIONS(2403),
    [anon_sym_LBRACE_] = ACTIONS(2403),
    [anon_sym__] = ACTIONS(2403),
    [anon_sym_LBRACE_STAR] = ACTIONS(2403),
    [anon_sym_STAR] = ACTIONS(2403),
    [anon_sym_LBRACE_CARET] = ACTIONS(2403),
    [anon_sym_CARET] = ACTIONS(2403),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2403),
    [anon_sym_TILDE] = ACTIONS(2403),
    [anon_sym_LBRACE_EQ] = ACTIONS(2403),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2403),
    [anon_sym_LBRACE_DASH] = ACTIONS(2403),
    [anon_sym_LBRACK_CARET] = ACTIONS(2403),
    [anon_sym_BANG_LBRACK] = ACTIONS(2403),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2403),
    [anon_sym_LPAREN] = ACTIONS(2403),
    [anon_sym_DOLLAR] = ACTIONS(2403),
    [anon_sym_TODO] = ACTIONS(2403),
    [anon_sym_WIP] = ACTIONS(2403),
    [anon_sym_NOTE] = ACTIONS(2403),
    [anon_sym_INFO] = ACTIONS(2403),
    [anon_sym_XXX] = ACTIONS(2403),
    [sym_fixme] = ACTIONS(2403),
    [aux_sym__text_token1] = ACTIONS(2405),
    [sym__block_close] = ACTIONS(2403),
    [sym__newline] = ACTIONS(2403),
    [sym__newline_inline] = ACTIONS(2403),
    [sym_hard_line_break] = ACTIONS(2403),
    [sym__heading_begin] = ACTIONS(2403),
    [sym__div_begin] = ACTIONS(2403),
    [sym__div_end] = ACTIONS(2463),
    [sym__code_block_begin] = ACTIONS(2403),
    [sym_list_marker_dash] = ACTIONS(2403),
    [sym_list_marker_star] = ACTIONS(2403),
    [sym_list_marker_plus] = ACTIONS(2403),
    [sym__list_marker_task_begin] = ACTIONS(2403),
    [sym_list_marker_definition] = ACTIONS(2403),
    [sym_list_marker_decimal_period] = ACTIONS(2403),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2403),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2403),
    [sym_list_marker_lower_roman_period] = ACTIONS(2403),
    [sym_list_marker_upper_roman_period] = ACTIONS(2403),
    [sym_list_marker_decimal_paren] = ACTIONS(2403),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2403),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2403),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2403),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2403),
    [sym_list_marker_decimal_parens] = ACTIONS(2403),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2403),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2403),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2403),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2403),
    [sym__block_quote_begin] = ACTIONS(2403),
    [sym__block_quote_continuation] = ACTIONS(2403),
    [sym__thematic_break_dash] = ACTIONS(2403),
    [sym__thematic_break_star] = ACTIONS(2403),
    [sym__footnote_mark_begin] = ACTIONS(2403),
    [sym__link_ref_def_mark_begin] = ACTIONS(2403),
    [sym__table_header_begin] = ACTIONS(2403),
    [sym__table_separator_begin] = ACTIONS(2403),
    [sym__table_row_begin] = ACTIONS(2403),
    [sym__block_attribute_begin] = ACTIONS(2403),
    [sym__verbatim_begin] = ACTIONS(2403),
  },
  [323] = {
    [ts_builtin_sym_end] = ACTIONS(2431),
    [anon_sym_LBRACK] = ACTIONS(2429),
    [sym__whitespace1] = ACTIONS(2431),
    [sym_quotation_marks] = ACTIONS(2431),
    [sym_ellipsis] = ACTIONS(2431),
    [sym_em_dash] = ACTIONS(2431),
    [sym_en_dash] = ACTIONS(2429),
    [sym_backslash_escape] = ACTIONS(2429),
    [anon_sym_LT] = ACTIONS(2431),
    [sym_symbol] = ACTIONS(2431),
    [anon_sym_LBRACE_] = ACTIONS(2431),
    [anon_sym__] = ACTIONS(2431),
    [anon_sym_LBRACE_STAR] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2431),
    [anon_sym_LBRACE_CARET] = ACTIONS(2431),
    [anon_sym_CARET] = ACTIONS(2431),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2431),
    [anon_sym_TILDE] = ACTIONS(2431),
    [anon_sym_LBRACE_EQ] = ACTIONS(2431),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2431),
    [anon_sym_LBRACE_DASH] = ACTIONS(2431),
    [anon_sym_LBRACK_CARET] = ACTIONS(2431),
    [anon_sym_BANG_LBRACK] = ACTIONS(2431),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2431),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_DOLLAR] = ACTIONS(2431),
    [anon_sym_TODO] = ACTIONS(2431),
    [anon_sym_WIP] = ACTIONS(2431),
    [anon_sym_NOTE] = ACTIONS(2431),
    [anon_sym_INFO] = ACTIONS(2431),
    [anon_sym_XXX] = ACTIONS(2431),
    [sym_fixme] = ACTIONS(2431),
    [aux_sym__text_token1] = ACTIONS(2429),
    [sym__newline] = ACTIONS(2431),
    [sym__newline_inline] = ACTIONS(2431),
    [sym_hard_line_break] = ACTIONS(2431),
    [sym__heading_begin] = ACTIONS(2431),
    [sym__div_begin] = ACTIONS(2431),
    [sym__code_block_begin] = ACTIONS(2431),
    [sym_list_marker_dash] = ACTIONS(2431),
    [sym_list_marker_star] = ACTIONS(2431),
    [sym_list_marker_plus] = ACTIONS(2431),
    [sym__list_marker_task_begin] = ACTIONS(2431),
    [sym_list_marker_definition] = ACTIONS(2431),
    [sym_list_marker_decimal_period] = ACTIONS(2431),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2431),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2431),
    [sym_list_marker_lower_roman_period] = ACTIONS(2431),
    [sym_list_marker_upper_roman_period] = ACTIONS(2431),
    [sym_list_marker_decimal_paren] = ACTIONS(2431),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2431),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2431),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2431),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2431),
    [sym_list_marker_decimal_parens] = ACTIONS(2431),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2431),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2431),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2431),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2431),
    [sym__block_quote_begin] = ACTIONS(2431),
    [sym__block_quote_continuation] = ACTIONS(2431),
    [sym__thematic_break_dash] = ACTIONS(2431),
    [sym__thematic_break_star] = ACTIONS(2431),
    [sym__footnote_mark_begin] = ACTIONS(2431),
    [sym__link_ref_def_mark_begin] = ACTIONS(2431),
    [sym__table_header_begin] = ACTIONS(2431),
    [sym__table_separator_begin] = ACTIONS(2431),
    [sym__table_row_begin] = ACTIONS(2431),
    [sym__table_caption_begin] = ACTIONS(2431),
    [sym__block_attribute_begin] = ACTIONS(2431),
    [sym__verbatim_begin] = ACTIONS(2431),
  },
  [324] = {
    [ts_builtin_sym_end] = ACTIONS(2395),
    [anon_sym_LBRACK] = ACTIONS(2393),
    [sym__whitespace1] = ACTIONS(2395),
    [sym_quotation_marks] = ACTIONS(2395),
    [sym_ellipsis] = ACTIONS(2395),
    [sym_em_dash] = ACTIONS(2395),
    [sym_en_dash] = ACTIONS(2393),
    [sym_backslash_escape] = ACTIONS(2393),
    [anon_sym_LT] = ACTIONS(2395),
    [sym_symbol] = ACTIONS(2395),
    [anon_sym_LBRACE_] = ACTIONS(2395),
    [anon_sym__] = ACTIONS(2395),
    [anon_sym_LBRACE_STAR] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2395),
    [anon_sym_LBRACE_CARET] = ACTIONS(2395),
    [anon_sym_CARET] = ACTIONS(2395),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2395),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_LBRACE_EQ] = ACTIONS(2395),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2395),
    [anon_sym_LBRACE_DASH] = ACTIONS(2395),
    [anon_sym_LBRACK_CARET] = ACTIONS(2395),
    [anon_sym_BANG_LBRACK] = ACTIONS(2395),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2395),
    [anon_sym_DOLLAR] = ACTIONS(2395),
    [anon_sym_TODO] = ACTIONS(2395),
    [anon_sym_WIP] = ACTIONS(2395),
    [anon_sym_NOTE] = ACTIONS(2395),
    [anon_sym_INFO] = ACTIONS(2395),
    [anon_sym_XXX] = ACTIONS(2395),
    [sym_fixme] = ACTIONS(2395),
    [aux_sym__text_token1] = ACTIONS(2393),
    [sym__newline] = ACTIONS(2395),
    [sym__newline_inline] = ACTIONS(2395),
    [sym_hard_line_break] = ACTIONS(2395),
    [sym__heading_begin] = ACTIONS(2395),
    [sym__div_begin] = ACTIONS(2395),
    [sym__code_block_begin] = ACTIONS(2395),
    [sym_list_marker_dash] = ACTIONS(2395),
    [sym_list_marker_star] = ACTIONS(2395),
    [sym_list_marker_plus] = ACTIONS(2395),
    [sym__list_marker_task_begin] = ACTIONS(2395),
    [sym_list_marker_definition] = ACTIONS(2395),
    [sym_list_marker_decimal_period] = ACTIONS(2395),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2395),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2395),
    [sym_list_marker_lower_roman_period] = ACTIONS(2395),
    [sym_list_marker_upper_roman_period] = ACTIONS(2395),
    [sym_list_marker_decimal_paren] = ACTIONS(2395),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2395),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2395),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2395),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2395),
    [sym_list_marker_decimal_parens] = ACTIONS(2395),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2395),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2395),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2395),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2395),
    [sym__block_quote_begin] = ACTIONS(2395),
    [sym__block_quote_continuation] = ACTIONS(2395),
    [sym__thematic_break_dash] = ACTIONS(2395),
    [sym__thematic_break_star] = ACTIONS(2395),
    [sym__footnote_mark_begin] = ACTIONS(2395),
    [sym__link_ref_def_mark_begin] = ACTIONS(2395),
    [sym__table_header_begin] = ACTIONS(2395),
    [sym__table_separator_begin] = ACTIONS(2395),
    [sym__table_row_begin] = ACTIONS(2395),
    [sym__table_caption_begin] = ACTIONS(2395),
    [sym__block_attribute_begin] = ACTIONS(2395),
    [sym__verbatim_begin] = ACTIONS(2395),
  },
  [325] = {
    [anon_sym_LBRACK] = ACTIONS(2465),
    [sym__whitespace1] = ACTIONS(2467),
    [sym_quotation_marks] = ACTIONS(2467),
    [sym_ellipsis] = ACTIONS(2467),
    [sym_em_dash] = ACTIONS(2467),
    [sym_en_dash] = ACTIONS(2465),
    [sym_backslash_escape] = ACTIONS(2465),
    [anon_sym_LT] = ACTIONS(2467),
    [sym_symbol] = ACTIONS(2467),
    [anon_sym_LBRACE_] = ACTIONS(2467),
    [anon_sym__] = ACTIONS(2467),
    [anon_sym_LBRACE_STAR] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(2467),
    [anon_sym_LBRACE_CARET] = ACTIONS(2467),
    [anon_sym_CARET] = ACTIONS(2467),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2467),
    [anon_sym_TILDE] = ACTIONS(2467),
    [anon_sym_LBRACE_EQ] = ACTIONS(2467),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2467),
    [anon_sym_LBRACE_DASH] = ACTIONS(2467),
    [anon_sym_LBRACK_CARET] = ACTIONS(2467),
    [anon_sym_BANG_LBRACK] = ACTIONS(2467),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2467),
    [anon_sym_DOLLAR] = ACTIONS(2467),
    [anon_sym_TODO] = ACTIONS(2467),
    [anon_sym_WIP] = ACTIONS(2467),
    [anon_sym_NOTE] = ACTIONS(2467),
    [anon_sym_INFO] = ACTIONS(2467),
    [anon_sym_XXX] = ACTIONS(2467),
    [sym_fixme] = ACTIONS(2467),
    [aux_sym__text_token1] = ACTIONS(2465),
    [sym__block_close] = ACTIONS(2467),
    [sym__newline] = ACTIONS(2467),
    [sym__newline_inline] = ACTIONS(2467),
    [sym_hard_line_break] = ACTIONS(2467),
    [sym__heading_begin] = ACTIONS(2467),
    [sym__div_begin] = ACTIONS(2467),
    [sym__code_block_begin] = ACTIONS(2467),
    [sym_list_marker_dash] = ACTIONS(2467),
    [sym_list_marker_star] = ACTIONS(2467),
    [sym_list_marker_plus] = ACTIONS(2467),
    [sym__list_marker_task_begin] = ACTIONS(2467),
    [sym_list_marker_definition] = ACTIONS(2467),
    [sym_list_marker_decimal_period] = ACTIONS(2467),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2467),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2467),
    [sym_list_marker_lower_roman_period] = ACTIONS(2467),
    [sym_list_marker_upper_roman_period] = ACTIONS(2467),
    [sym_list_marker_decimal_paren] = ACTIONS(2467),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2467),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2467),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2467),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2467),
    [sym_list_marker_decimal_parens] = ACTIONS(2467),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2467),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2467),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2467),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2467),
    [sym__block_quote_begin] = ACTIONS(2467),
    [sym__block_quote_continuation] = ACTIONS(2467),
    [sym__thematic_break_dash] = ACTIONS(2467),
    [sym__thematic_break_star] = ACTIONS(2467),
    [sym__footnote_mark_begin] = ACTIONS(2467),
    [sym__link_ref_def_mark_begin] = ACTIONS(2467),
    [sym__table_header_begin] = ACTIONS(2467),
    [sym__table_separator_begin] = ACTIONS(2467),
    [sym__table_row_begin] = ACTIONS(2467),
    [sym__block_attribute_begin] = ACTIONS(2467),
    [sym__verbatim_begin] = ACTIONS(2467),
  },
  [326] = {
    [ts_builtin_sym_end] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2471),
    [sym__whitespace1] = ACTIONS(2469),
    [sym_quotation_marks] = ACTIONS(2469),
    [sym_ellipsis] = ACTIONS(2469),
    [sym_em_dash] = ACTIONS(2469),
    [sym_en_dash] = ACTIONS(2471),
    [sym_backslash_escape] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [sym_symbol] = ACTIONS(2469),
    [anon_sym_LBRACE_] = ACTIONS(2469),
    [anon_sym__] = ACTIONS(2469),
    [anon_sym_LBRACE_STAR] = ACTIONS(2469),
    [anon_sym_STAR] = ACTIONS(2469),
    [anon_sym_LBRACE_CARET] = ACTIONS(2469),
    [anon_sym_CARET] = ACTIONS(2469),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2469),
    [anon_sym_LBRACE_EQ] = ACTIONS(2469),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2469),
    [anon_sym_LBRACE_DASH] = ACTIONS(2469),
    [anon_sym_LBRACK_CARET] = ACTIONS(2469),
    [anon_sym_BANG_LBRACK] = ACTIONS(2469),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2469),
    [anon_sym_DOLLAR] = ACTIONS(2469),
    [anon_sym_TODO] = ACTIONS(2469),
    [anon_sym_WIP] = ACTIONS(2469),
    [anon_sym_NOTE] = ACTIONS(2469),
    [anon_sym_INFO] = ACTIONS(2469),
    [anon_sym_XXX] = ACTIONS(2469),
    [sym_fixme] = ACTIONS(2469),
    [aux_sym__text_token1] = ACTIONS(2471),
    [sym__newline] = ACTIONS(2469),
    [sym__newline_inline] = ACTIONS(2469),
    [sym_hard_line_break] = ACTIONS(2469),
    [sym__heading_begin] = ACTIONS(2469),
    [sym__div_begin] = ACTIONS(2469),
    [sym__code_block_begin] = ACTIONS(2469),
    [sym_list_marker_dash] = ACTIONS(2469),
    [sym_list_marker_star] = ACTIONS(2469),
    [sym_list_marker_plus] = ACTIONS(2469),
    [sym__list_marker_task_begin] = ACTIONS(2469),
    [sym_list_marker_definition] = ACTIONS(2469),
    [sym_list_marker_decimal_period] = ACTIONS(2469),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2469),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2469),
    [sym_list_marker_lower_roman_period] = ACTIONS(2469),
    [sym_list_marker_upper_roman_period] = ACTIONS(2469),
    [sym_list_marker_decimal_paren] = ACTIONS(2469),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2469),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2469),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2469),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2469),
    [sym_list_marker_decimal_parens] = ACTIONS(2469),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2469),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2469),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2469),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2469),
    [sym__block_quote_begin] = ACTIONS(2469),
    [sym__block_quote_continuation] = ACTIONS(2469),
    [sym__thematic_break_dash] = ACTIONS(2469),
    [sym__thematic_break_star] = ACTIONS(2469),
    [sym__footnote_mark_begin] = ACTIONS(2469),
    [sym__link_ref_def_mark_begin] = ACTIONS(2469),
    [sym__table_header_begin] = ACTIONS(2469),
    [sym__table_separator_begin] = ACTIONS(2469),
    [sym__table_row_begin] = ACTIONS(2469),
    [sym__block_attribute_begin] = ACTIONS(2469),
    [sym__verbatim_begin] = ACTIONS(2469),
  },
  [327] = {
    [ts_builtin_sym_end] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [sym__whitespace1] = ACTIONS(2473),
    [sym_quotation_marks] = ACTIONS(2473),
    [sym_ellipsis] = ACTIONS(2473),
    [sym_em_dash] = ACTIONS(2473),
    [sym_en_dash] = ACTIONS(2475),
    [sym_backslash_escape] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(2473),
    [sym_symbol] = ACTIONS(2473),
    [anon_sym_LBRACE_] = ACTIONS(2473),
    [anon_sym__] = ACTIONS(2473),
    [anon_sym_LBRACE_STAR] = ACTIONS(2473),
    [anon_sym_STAR] = ACTIONS(2473),
    [anon_sym_LBRACE_CARET] = ACTIONS(2473),
    [anon_sym_CARET] = ACTIONS(2473),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [anon_sym_LBRACE_EQ] = ACTIONS(2473),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2473),
    [anon_sym_LBRACE_DASH] = ACTIONS(2473),
    [anon_sym_LBRACK_CARET] = ACTIONS(2473),
    [anon_sym_BANG_LBRACK] = ACTIONS(2473),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2473),
    [anon_sym_DOLLAR] = ACTIONS(2473),
    [anon_sym_TODO] = ACTIONS(2473),
    [anon_sym_WIP] = ACTIONS(2473),
    [anon_sym_NOTE] = ACTIONS(2473),
    [anon_sym_INFO] = ACTIONS(2473),
    [anon_sym_XXX] = ACTIONS(2473),
    [sym_fixme] = ACTIONS(2473),
    [aux_sym__text_token1] = ACTIONS(2475),
    [sym__newline] = ACTIONS(2473),
    [sym__newline_inline] = ACTIONS(2473),
    [sym_hard_line_break] = ACTIONS(2473),
    [sym__heading_begin] = ACTIONS(2473),
    [sym__div_begin] = ACTIONS(2473),
    [sym__code_block_begin] = ACTIONS(2473),
    [sym_list_marker_dash] = ACTIONS(2473),
    [sym_list_marker_star] = ACTIONS(2473),
    [sym_list_marker_plus] = ACTIONS(2473),
    [sym__list_marker_task_begin] = ACTIONS(2473),
    [sym_list_marker_definition] = ACTIONS(2473),
    [sym_list_marker_decimal_period] = ACTIONS(2473),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2473),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2473),
    [sym_list_marker_lower_roman_period] = ACTIONS(2473),
    [sym_list_marker_upper_roman_period] = ACTIONS(2473),
    [sym_list_marker_decimal_paren] = ACTIONS(2473),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2473),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2473),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2473),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2473),
    [sym_list_marker_decimal_parens] = ACTIONS(2473),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2473),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2473),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2473),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2473),
    [sym__block_quote_begin] = ACTIONS(2473),
    [sym__block_quote_continuation] = ACTIONS(2473),
    [sym__thematic_break_dash] = ACTIONS(2473),
    [sym__thematic_break_star] = ACTIONS(2473),
    [sym__footnote_mark_begin] = ACTIONS(2473),
    [sym__link_ref_def_mark_begin] = ACTIONS(2473),
    [sym__table_header_begin] = ACTIONS(2473),
    [sym__table_separator_begin] = ACTIONS(2473),
    [sym__table_row_begin] = ACTIONS(2473),
    [sym__block_attribute_begin] = ACTIONS(2473),
    [sym__verbatim_begin] = ACTIONS(2473),
  },
  [328] = {
    [ts_builtin_sym_end] = ACTIONS(2477),
    [anon_sym_LBRACK] = ACTIONS(2479),
    [sym__whitespace1] = ACTIONS(2477),
    [sym_quotation_marks] = ACTIONS(2477),
    [sym_ellipsis] = ACTIONS(2477),
    [sym_em_dash] = ACTIONS(2477),
    [sym_en_dash] = ACTIONS(2479),
    [sym_backslash_escape] = ACTIONS(2479),
    [anon_sym_LT] = ACTIONS(2477),
    [sym_symbol] = ACTIONS(2477),
    [anon_sym_LBRACE_] = ACTIONS(2477),
    [anon_sym__] = ACTIONS(2477),
    [anon_sym_LBRACE_STAR] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2477),
    [anon_sym_LBRACE_CARET] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2477),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_LBRACE_EQ] = ACTIONS(2477),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2477),
    [anon_sym_LBRACE_DASH] = ACTIONS(2477),
    [anon_sym_LBRACK_CARET] = ACTIONS(2477),
    [anon_sym_BANG_LBRACK] = ACTIONS(2477),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2477),
    [anon_sym_LPAREN] = ACTIONS(2477),
    [anon_sym_DOLLAR] = ACTIONS(2477),
    [anon_sym_TODO] = ACTIONS(2477),
    [anon_sym_WIP] = ACTIONS(2477),
    [anon_sym_NOTE] = ACTIONS(2477),
    [anon_sym_INFO] = ACTIONS(2477),
    [anon_sym_XXX] = ACTIONS(2477),
    [sym_fixme] = ACTIONS(2477),
    [aux_sym__text_token1] = ACTIONS(2479),
    [sym__newline] = ACTIONS(2477),
    [sym__newline_inline] = ACTIONS(2477),
    [sym_hard_line_break] = ACTIONS(2477),
    [sym__heading_begin] = ACTIONS(2477),
    [sym__div_begin] = ACTIONS(2477),
    [sym__code_block_begin] = ACTIONS(2477),
    [sym_list_marker_dash] = ACTIONS(2477),
    [sym_list_marker_star] = ACTIONS(2477),
    [sym_list_marker_plus] = ACTIONS(2477),
    [sym__list_marker_task_begin] = ACTIONS(2477),
    [sym_list_marker_definition] = ACTIONS(2477),
    [sym_list_marker_decimal_period] = ACTIONS(2477),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2477),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2477),
    [sym_list_marker_lower_roman_period] = ACTIONS(2477),
    [sym_list_marker_upper_roman_period] = ACTIONS(2477),
    [sym_list_marker_decimal_paren] = ACTIONS(2477),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2477),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2477),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2477),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2477),
    [sym_list_marker_decimal_parens] = ACTIONS(2477),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2477),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2477),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2477),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2477),
    [sym__block_quote_begin] = ACTIONS(2477),
    [sym__block_quote_continuation] = ACTIONS(2477),
    [sym__thematic_break_dash] = ACTIONS(2477),
    [sym__thematic_break_star] = ACTIONS(2477),
    [sym__footnote_mark_begin] = ACTIONS(2477),
    [sym__link_ref_def_mark_begin] = ACTIONS(2477),
    [sym__table_header_begin] = ACTIONS(2477),
    [sym__table_separator_begin] = ACTIONS(2477),
    [sym__table_row_begin] = ACTIONS(2477),
    [sym__block_attribute_begin] = ACTIONS(2477),
    [sym__verbatim_begin] = ACTIONS(2477),
  },
  [329] = {
    [anon_sym_LBRACK] = ACTIONS(2471),
    [sym__whitespace1] = ACTIONS(2469),
    [sym_quotation_marks] = ACTIONS(2469),
    [sym_ellipsis] = ACTIONS(2469),
    [sym_em_dash] = ACTIONS(2469),
    [sym_en_dash] = ACTIONS(2471),
    [sym_backslash_escape] = ACTIONS(2471),
    [anon_sym_LT] = ACTIONS(2469),
    [sym_symbol] = ACTIONS(2469),
    [anon_sym_LBRACE_] = ACTIONS(2469),
    [anon_sym__] = ACTIONS(2469),
    [anon_sym_LBRACE_STAR] = ACTIONS(2469),
    [anon_sym_STAR] = ACTIONS(2469),
    [anon_sym_LBRACE_CARET] = ACTIONS(2469),
    [anon_sym_CARET] = ACTIONS(2469),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2469),
    [anon_sym_TILDE] = ACTIONS(2469),
    [anon_sym_LBRACE_EQ] = ACTIONS(2469),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2469),
    [anon_sym_LBRACE_DASH] = ACTIONS(2469),
    [anon_sym_LBRACK_CARET] = ACTIONS(2469),
    [anon_sym_BANG_LBRACK] = ACTIONS(2469),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2469),
    [anon_sym_DOLLAR] = ACTIONS(2469),
    [anon_sym_TODO] = ACTIONS(2469),
    [anon_sym_WIP] = ACTIONS(2469),
    [anon_sym_NOTE] = ACTIONS(2469),
    [anon_sym_INFO] = ACTIONS(2469),
    [anon_sym_XXX] = ACTIONS(2469),
    [sym_fixme] = ACTIONS(2469),
    [aux_sym__text_token1] = ACTIONS(2471),
    [sym__block_close] = ACTIONS(2469),
    [sym__newline] = ACTIONS(2469),
    [sym__newline_inline] = ACTIONS(2469),
    [sym_hard_line_break] = ACTIONS(2469),
    [sym__heading_begin] = ACTIONS(2469),
    [sym__div_begin] = ACTIONS(2469),
    [sym__code_block_begin] = ACTIONS(2469),
    [sym_list_marker_dash] = ACTIONS(2469),
    [sym_list_marker_star] = ACTIONS(2469),
    [sym_list_marker_plus] = ACTIONS(2469),
    [sym__list_marker_task_begin] = ACTIONS(2469),
    [sym_list_marker_definition] = ACTIONS(2469),
    [sym_list_marker_decimal_period] = ACTIONS(2469),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2469),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2469),
    [sym_list_marker_lower_roman_period] = ACTIONS(2469),
    [sym_list_marker_upper_roman_period] = ACTIONS(2469),
    [sym_list_marker_decimal_paren] = ACTIONS(2469),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2469),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2469),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2469),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2469),
    [sym_list_marker_decimal_parens] = ACTIONS(2469),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2469),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2469),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2469),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2469),
    [sym__block_quote_begin] = ACTIONS(2469),
    [sym__block_quote_continuation] = ACTIONS(2469),
    [sym__thematic_break_dash] = ACTIONS(2469),
    [sym__thematic_break_star] = ACTIONS(2469),
    [sym__footnote_mark_begin] = ACTIONS(2469),
    [sym__link_ref_def_mark_begin] = ACTIONS(2469),
    [sym__table_header_begin] = ACTIONS(2469),
    [sym__table_separator_begin] = ACTIONS(2469),
    [sym__table_row_begin] = ACTIONS(2469),
    [sym__block_attribute_begin] = ACTIONS(2469),
    [sym__verbatim_begin] = ACTIONS(2469),
  },
  [330] = {
    [ts_builtin_sym_end] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [sym__whitespace1] = ACTIONS(2473),
    [sym_quotation_marks] = ACTIONS(2473),
    [sym_ellipsis] = ACTIONS(2473),
    [sym_em_dash] = ACTIONS(2473),
    [sym_en_dash] = ACTIONS(2475),
    [sym_backslash_escape] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(2473),
    [sym_symbol] = ACTIONS(2473),
    [anon_sym_LBRACE_] = ACTIONS(2473),
    [anon_sym__] = ACTIONS(2473),
    [anon_sym_LBRACE_STAR] = ACTIONS(2473),
    [anon_sym_STAR] = ACTIONS(2473),
    [anon_sym_LBRACE_CARET] = ACTIONS(2473),
    [anon_sym_CARET] = ACTIONS(2473),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [anon_sym_LBRACE_EQ] = ACTIONS(2473),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2473),
    [anon_sym_LBRACE_DASH] = ACTIONS(2473),
    [anon_sym_LBRACK_CARET] = ACTIONS(2473),
    [anon_sym_BANG_LBRACK] = ACTIONS(2473),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2473),
    [anon_sym_DOLLAR] = ACTIONS(2473),
    [anon_sym_TODO] = ACTIONS(2473),
    [anon_sym_WIP] = ACTIONS(2473),
    [anon_sym_NOTE] = ACTIONS(2473),
    [anon_sym_INFO] = ACTIONS(2473),
    [anon_sym_XXX] = ACTIONS(2473),
    [sym_fixme] = ACTIONS(2473),
    [aux_sym__text_token1] = ACTIONS(2475),
    [sym__newline] = ACTIONS(2473),
    [sym__newline_inline] = ACTIONS(2473),
    [sym_hard_line_break] = ACTIONS(2473),
    [sym__heading_begin] = ACTIONS(2473),
    [sym__div_begin] = ACTIONS(2473),
    [sym__code_block_begin] = ACTIONS(2473),
    [sym_list_marker_dash] = ACTIONS(2473),
    [sym_list_marker_star] = ACTIONS(2473),
    [sym_list_marker_plus] = ACTIONS(2473),
    [sym__list_marker_task_begin] = ACTIONS(2473),
    [sym_list_marker_definition] = ACTIONS(2473),
    [sym_list_marker_decimal_period] = ACTIONS(2473),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2473),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2473),
    [sym_list_marker_lower_roman_period] = ACTIONS(2473),
    [sym_list_marker_upper_roman_period] = ACTIONS(2473),
    [sym_list_marker_decimal_paren] = ACTIONS(2473),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2473),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2473),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2473),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2473),
    [sym_list_marker_decimal_parens] = ACTIONS(2473),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2473),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2473),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2473),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2473),
    [sym__block_quote_begin] = ACTIONS(2473),
    [sym__block_quote_continuation] = ACTIONS(2473),
    [sym__thematic_break_dash] = ACTIONS(2473),
    [sym__thematic_break_star] = ACTIONS(2473),
    [sym__footnote_mark_begin] = ACTIONS(2473),
    [sym__link_ref_def_mark_begin] = ACTIONS(2473),
    [sym__table_header_begin] = ACTIONS(2473),
    [sym__table_separator_begin] = ACTIONS(2473),
    [sym__table_row_begin] = ACTIONS(2473),
    [sym__block_attribute_begin] = ACTIONS(2473),
    [sym__verbatim_begin] = ACTIONS(2473),
  },
  [331] = {
    [anon_sym_LBRACK] = ACTIONS(2481),
    [sym__whitespace1] = ACTIONS(2483),
    [sym_quotation_marks] = ACTIONS(2483),
    [sym_ellipsis] = ACTIONS(2483),
    [sym_em_dash] = ACTIONS(2483),
    [sym_en_dash] = ACTIONS(2481),
    [sym_backslash_escape] = ACTIONS(2481),
    [anon_sym_LT] = ACTIONS(2483),
    [sym_symbol] = ACTIONS(2483),
    [anon_sym_LBRACE_] = ACTIONS(2483),
    [anon_sym__] = ACTIONS(2483),
    [anon_sym_LBRACE_STAR] = ACTIONS(2483),
    [anon_sym_STAR] = ACTIONS(2483),
    [anon_sym_LBRACE_CARET] = ACTIONS(2483),
    [anon_sym_CARET] = ACTIONS(2483),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2483),
    [anon_sym_TILDE] = ACTIONS(2483),
    [anon_sym_LBRACE_EQ] = ACTIONS(2483),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2483),
    [anon_sym_LBRACE_DASH] = ACTIONS(2483),
    [anon_sym_LBRACK_CARET] = ACTIONS(2483),
    [anon_sym_BANG_LBRACK] = ACTIONS(2483),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2483),
    [anon_sym_LPAREN] = ACTIONS(2483),
    [anon_sym_DOLLAR] = ACTIONS(2483),
    [anon_sym_TODO] = ACTIONS(2483),
    [anon_sym_WIP] = ACTIONS(2483),
    [anon_sym_NOTE] = ACTIONS(2483),
    [anon_sym_INFO] = ACTIONS(2483),
    [anon_sym_XXX] = ACTIONS(2483),
    [sym_fixme] = ACTIONS(2483),
    [aux_sym__text_token1] = ACTIONS(2481),
    [sym__block_close] = ACTIONS(2483),
    [sym__newline] = ACTIONS(2483),
    [sym__newline_inline] = ACTIONS(2483),
    [sym_hard_line_break] = ACTIONS(2483),
    [sym__heading_begin] = ACTIONS(2483),
    [sym__div_begin] = ACTIONS(2483),
    [sym__code_block_begin] = ACTIONS(2483),
    [sym_list_marker_dash] = ACTIONS(2483),
    [sym_list_marker_star] = ACTIONS(2483),
    [sym_list_marker_plus] = ACTIONS(2483),
    [sym__list_marker_task_begin] = ACTIONS(2483),
    [sym_list_marker_definition] = ACTIONS(2483),
    [sym_list_marker_decimal_period] = ACTIONS(2483),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2483),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2483),
    [sym_list_marker_lower_roman_period] = ACTIONS(2483),
    [sym_list_marker_upper_roman_period] = ACTIONS(2483),
    [sym_list_marker_decimal_paren] = ACTIONS(2483),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2483),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2483),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2483),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2483),
    [sym_list_marker_decimal_parens] = ACTIONS(2483),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2483),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2483),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2483),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2483),
    [sym__block_quote_begin] = ACTIONS(2483),
    [sym__block_quote_continuation] = ACTIONS(2483),
    [sym__thematic_break_dash] = ACTIONS(2483),
    [sym__thematic_break_star] = ACTIONS(2483),
    [sym__footnote_mark_begin] = ACTIONS(2483),
    [sym__link_ref_def_mark_begin] = ACTIONS(2483),
    [sym__table_header_begin] = ACTIONS(2483),
    [sym__table_separator_begin] = ACTIONS(2483),
    [sym__table_row_begin] = ACTIONS(2483),
    [sym__block_attribute_begin] = ACTIONS(2483),
    [sym__verbatim_begin] = ACTIONS(2483),
  },
  [332] = {
    [anon_sym_LBRACK] = ACTIONS(2485),
    [sym__whitespace1] = ACTIONS(2487),
    [sym_quotation_marks] = ACTIONS(2487),
    [sym_ellipsis] = ACTIONS(2487),
    [sym_em_dash] = ACTIONS(2487),
    [sym_en_dash] = ACTIONS(2485),
    [sym_backslash_escape] = ACTIONS(2485),
    [anon_sym_LT] = ACTIONS(2487),
    [sym_symbol] = ACTIONS(2487),
    [anon_sym_LBRACE_] = ACTIONS(2487),
    [anon_sym__] = ACTIONS(2487),
    [anon_sym_LBRACE_STAR] = ACTIONS(2487),
    [anon_sym_STAR] = ACTIONS(2487),
    [anon_sym_LBRACE_CARET] = ACTIONS(2487),
    [anon_sym_CARET] = ACTIONS(2487),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_LBRACE_EQ] = ACTIONS(2487),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2487),
    [anon_sym_LBRACE_DASH] = ACTIONS(2487),
    [anon_sym_LBRACK_CARET] = ACTIONS(2487),
    [anon_sym_BANG_LBRACK] = ACTIONS(2487),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2487),
    [anon_sym_LPAREN] = ACTIONS(2487),
    [anon_sym_DOLLAR] = ACTIONS(2487),
    [anon_sym_TODO] = ACTIONS(2487),
    [anon_sym_WIP] = ACTIONS(2487),
    [anon_sym_NOTE] = ACTIONS(2487),
    [anon_sym_INFO] = ACTIONS(2487),
    [anon_sym_XXX] = ACTIONS(2487),
    [sym_fixme] = ACTIONS(2487),
    [aux_sym__text_token1] = ACTIONS(2485),
    [sym__block_close] = ACTIONS(2487),
    [sym__newline] = ACTIONS(2487),
    [sym__newline_inline] = ACTIONS(2487),
    [sym_hard_line_break] = ACTIONS(2487),
    [sym__heading_begin] = ACTIONS(2487),
    [sym__div_begin] = ACTIONS(2487),
    [sym__code_block_begin] = ACTIONS(2487),
    [sym_list_marker_dash] = ACTIONS(2487),
    [sym_list_marker_star] = ACTIONS(2487),
    [sym_list_marker_plus] = ACTIONS(2487),
    [sym__list_marker_task_begin] = ACTIONS(2487),
    [sym_list_marker_definition] = ACTIONS(2487),
    [sym_list_marker_decimal_period] = ACTIONS(2487),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2487),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2487),
    [sym_list_marker_lower_roman_period] = ACTIONS(2487),
    [sym_list_marker_upper_roman_period] = ACTIONS(2487),
    [sym_list_marker_decimal_paren] = ACTIONS(2487),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2487),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2487),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2487),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2487),
    [sym_list_marker_decimal_parens] = ACTIONS(2487),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2487),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2487),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2487),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2487),
    [sym__block_quote_begin] = ACTIONS(2487),
    [sym__block_quote_continuation] = ACTIONS(2487),
    [sym__thematic_break_dash] = ACTIONS(2487),
    [sym__thematic_break_star] = ACTIONS(2487),
    [sym__footnote_mark_begin] = ACTIONS(2487),
    [sym__link_ref_def_mark_begin] = ACTIONS(2487),
    [sym__table_header_begin] = ACTIONS(2487),
    [sym__table_separator_begin] = ACTIONS(2487),
    [sym__table_row_begin] = ACTIONS(2487),
    [sym__block_attribute_begin] = ACTIONS(2487),
    [sym__verbatim_begin] = ACTIONS(2487),
  },
  [333] = {
    [ts_builtin_sym_end] = ACTIONS(2489),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [sym__whitespace1] = ACTIONS(2489),
    [sym_quotation_marks] = ACTIONS(2489),
    [sym_ellipsis] = ACTIONS(2489),
    [sym_em_dash] = ACTIONS(2489),
    [sym_en_dash] = ACTIONS(2491),
    [sym_backslash_escape] = ACTIONS(2491),
    [anon_sym_LT] = ACTIONS(2489),
    [sym_symbol] = ACTIONS(2489),
    [anon_sym_LBRACE_] = ACTIONS(2489),
    [anon_sym__] = ACTIONS(2489),
    [anon_sym_LBRACE_STAR] = ACTIONS(2489),
    [anon_sym_STAR] = ACTIONS(2489),
    [anon_sym_LBRACE_CARET] = ACTIONS(2489),
    [anon_sym_CARET] = ACTIONS(2489),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2489),
    [anon_sym_TILDE] = ACTIONS(2489),
    [anon_sym_LBRACE_EQ] = ACTIONS(2489),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2489),
    [anon_sym_LBRACE_DASH] = ACTIONS(2489),
    [anon_sym_LBRACK_CARET] = ACTIONS(2489),
    [anon_sym_BANG_LBRACK] = ACTIONS(2489),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2489),
    [anon_sym_LPAREN] = ACTIONS(2489),
    [anon_sym_DOLLAR] = ACTIONS(2489),
    [anon_sym_TODO] = ACTIONS(2489),
    [anon_sym_WIP] = ACTIONS(2489),
    [anon_sym_NOTE] = ACTIONS(2489),
    [anon_sym_INFO] = ACTIONS(2489),
    [anon_sym_XXX] = ACTIONS(2489),
    [sym_fixme] = ACTIONS(2489),
    [aux_sym__text_token1] = ACTIONS(2491),
    [sym__newline] = ACTIONS(2489),
    [sym__newline_inline] = ACTIONS(2489),
    [sym_hard_line_break] = ACTIONS(2489),
    [sym__heading_begin] = ACTIONS(2489),
    [sym__div_begin] = ACTIONS(2489),
    [sym__code_block_begin] = ACTIONS(2489),
    [sym_list_marker_dash] = ACTIONS(2489),
    [sym_list_marker_star] = ACTIONS(2489),
    [sym_list_marker_plus] = ACTIONS(2489),
    [sym__list_marker_task_begin] = ACTIONS(2489),
    [sym_list_marker_definition] = ACTIONS(2489),
    [sym_list_marker_decimal_period] = ACTIONS(2489),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2489),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2489),
    [sym_list_marker_lower_roman_period] = ACTIONS(2489),
    [sym_list_marker_upper_roman_period] = ACTIONS(2489),
    [sym_list_marker_decimal_paren] = ACTIONS(2489),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2489),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2489),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2489),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2489),
    [sym_list_marker_decimal_parens] = ACTIONS(2489),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2489),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2489),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2489),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2489),
    [sym__block_quote_begin] = ACTIONS(2489),
    [sym__block_quote_continuation] = ACTIONS(2489),
    [sym__thematic_break_dash] = ACTIONS(2489),
    [sym__thematic_break_star] = ACTIONS(2489),
    [sym__footnote_mark_begin] = ACTIONS(2489),
    [sym__link_ref_def_mark_begin] = ACTIONS(2489),
    [sym__table_header_begin] = ACTIONS(2489),
    [sym__table_separator_begin] = ACTIONS(2489),
    [sym__table_row_begin] = ACTIONS(2489),
    [sym__block_attribute_begin] = ACTIONS(2489),
    [sym__verbatim_begin] = ACTIONS(2489),
  },
  [334] = {
    [ts_builtin_sym_end] = ACTIONS(2493),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [sym__whitespace1] = ACTIONS(2493),
    [sym_quotation_marks] = ACTIONS(2493),
    [sym_ellipsis] = ACTIONS(2493),
    [sym_em_dash] = ACTIONS(2493),
    [sym_en_dash] = ACTIONS(2495),
    [sym_backslash_escape] = ACTIONS(2495),
    [anon_sym_LT] = ACTIONS(2493),
    [sym_symbol] = ACTIONS(2493),
    [anon_sym_LBRACE_] = ACTIONS(2493),
    [anon_sym__] = ACTIONS(2493),
    [anon_sym_LBRACE_STAR] = ACTIONS(2493),
    [anon_sym_STAR] = ACTIONS(2493),
    [anon_sym_LBRACE_CARET] = ACTIONS(2493),
    [anon_sym_CARET] = ACTIONS(2493),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_LBRACE_EQ] = ACTIONS(2493),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2493),
    [anon_sym_LBRACE_DASH] = ACTIONS(2493),
    [anon_sym_LBRACK_CARET] = ACTIONS(2493),
    [anon_sym_BANG_LBRACK] = ACTIONS(2493),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2493),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_DOLLAR] = ACTIONS(2493),
    [anon_sym_TODO] = ACTIONS(2493),
    [anon_sym_WIP] = ACTIONS(2493),
    [anon_sym_NOTE] = ACTIONS(2493),
    [anon_sym_INFO] = ACTIONS(2493),
    [anon_sym_XXX] = ACTIONS(2493),
    [sym_fixme] = ACTIONS(2493),
    [aux_sym__text_token1] = ACTIONS(2495),
    [sym__newline] = ACTIONS(2493),
    [sym__newline_inline] = ACTIONS(2493),
    [sym_hard_line_break] = ACTIONS(2493),
    [sym__heading_begin] = ACTIONS(2493),
    [sym__div_begin] = ACTIONS(2493),
    [sym__code_block_begin] = ACTIONS(2493),
    [sym_list_marker_dash] = ACTIONS(2493),
    [sym_list_marker_star] = ACTIONS(2493),
    [sym_list_marker_plus] = ACTIONS(2493),
    [sym__list_marker_task_begin] = ACTIONS(2493),
    [sym_list_marker_definition] = ACTIONS(2493),
    [sym_list_marker_decimal_period] = ACTIONS(2493),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2493),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2493),
    [sym_list_marker_lower_roman_period] = ACTIONS(2493),
    [sym_list_marker_upper_roman_period] = ACTIONS(2493),
    [sym_list_marker_decimal_paren] = ACTIONS(2493),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2493),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2493),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2493),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2493),
    [sym_list_marker_decimal_parens] = ACTIONS(2493),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2493),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2493),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2493),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2493),
    [sym__block_quote_begin] = ACTIONS(2493),
    [sym__block_quote_continuation] = ACTIONS(2493),
    [sym__thematic_break_dash] = ACTIONS(2493),
    [sym__thematic_break_star] = ACTIONS(2493),
    [sym__footnote_mark_begin] = ACTIONS(2493),
    [sym__link_ref_def_mark_begin] = ACTIONS(2493),
    [sym__table_header_begin] = ACTIONS(2493),
    [sym__table_separator_begin] = ACTIONS(2493),
    [sym__table_row_begin] = ACTIONS(2493),
    [sym__block_attribute_begin] = ACTIONS(2493),
    [sym__verbatim_begin] = ACTIONS(2493),
  },
  [335] = {
    [ts_builtin_sym_end] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2499),
    [sym__whitespace1] = ACTIONS(2497),
    [sym_quotation_marks] = ACTIONS(2497),
    [sym_ellipsis] = ACTIONS(2497),
    [sym_em_dash] = ACTIONS(2497),
    [sym_en_dash] = ACTIONS(2499),
    [sym_backslash_escape] = ACTIONS(2499),
    [anon_sym_LT] = ACTIONS(2497),
    [sym_symbol] = ACTIONS(2497),
    [anon_sym_LBRACE_] = ACTIONS(2497),
    [anon_sym__] = ACTIONS(2497),
    [anon_sym_LBRACE_STAR] = ACTIONS(2497),
    [anon_sym_STAR] = ACTIONS(2497),
    [anon_sym_LBRACE_CARET] = ACTIONS(2497),
    [anon_sym_CARET] = ACTIONS(2497),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2497),
    [anon_sym_LBRACE_EQ] = ACTIONS(2497),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2497),
    [anon_sym_LBRACE_DASH] = ACTIONS(2497),
    [anon_sym_LBRACK_CARET] = ACTIONS(2497),
    [anon_sym_BANG_LBRACK] = ACTIONS(2497),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2497),
    [anon_sym_LPAREN] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2497),
    [anon_sym_TODO] = ACTIONS(2497),
    [anon_sym_WIP] = ACTIONS(2497),
    [anon_sym_NOTE] = ACTIONS(2497),
    [anon_sym_INFO] = ACTIONS(2497),
    [anon_sym_XXX] = ACTIONS(2497),
    [sym_fixme] = ACTIONS(2497),
    [aux_sym__text_token1] = ACTIONS(2499),
    [sym__newline] = ACTIONS(2497),
    [sym__newline_inline] = ACTIONS(2497),
    [sym_hard_line_break] = ACTIONS(2497),
    [sym__heading_begin] = ACTIONS(2497),
    [sym__div_begin] = ACTIONS(2497),
    [sym__code_block_begin] = ACTIONS(2497),
    [sym_list_marker_dash] = ACTIONS(2497),
    [sym_list_marker_star] = ACTIONS(2497),
    [sym_list_marker_plus] = ACTIONS(2497),
    [sym__list_marker_task_begin] = ACTIONS(2497),
    [sym_list_marker_definition] = ACTIONS(2497),
    [sym_list_marker_decimal_period] = ACTIONS(2497),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2497),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2497),
    [sym_list_marker_lower_roman_period] = ACTIONS(2497),
    [sym_list_marker_upper_roman_period] = ACTIONS(2497),
    [sym_list_marker_decimal_paren] = ACTIONS(2497),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2497),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2497),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2497),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2497),
    [sym_list_marker_decimal_parens] = ACTIONS(2497),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2497),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2497),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2497),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2497),
    [sym__block_quote_begin] = ACTIONS(2497),
    [sym__block_quote_continuation] = ACTIONS(2497),
    [sym__thematic_break_dash] = ACTIONS(2497),
    [sym__thematic_break_star] = ACTIONS(2497),
    [sym__footnote_mark_begin] = ACTIONS(2497),
    [sym__link_ref_def_mark_begin] = ACTIONS(2497),
    [sym__table_header_begin] = ACTIONS(2497),
    [sym__table_separator_begin] = ACTIONS(2497),
    [sym__table_row_begin] = ACTIONS(2497),
    [sym__block_attribute_begin] = ACTIONS(2497),
    [sym__verbatim_begin] = ACTIONS(2497),
  },
  [336] = {
    [ts_builtin_sym_end] = ACTIONS(2501),
    [anon_sym_LBRACK] = ACTIONS(2503),
    [sym__whitespace1] = ACTIONS(2501),
    [sym_quotation_marks] = ACTIONS(2501),
    [sym_ellipsis] = ACTIONS(2501),
    [sym_em_dash] = ACTIONS(2501),
    [sym_en_dash] = ACTIONS(2503),
    [sym_backslash_escape] = ACTIONS(2503),
    [anon_sym_LT] = ACTIONS(2501),
    [sym_symbol] = ACTIONS(2501),
    [anon_sym_LBRACE_] = ACTIONS(2501),
    [anon_sym__] = ACTIONS(2501),
    [anon_sym_LBRACE_STAR] = ACTIONS(2501),
    [anon_sym_STAR] = ACTIONS(2501),
    [anon_sym_LBRACE_CARET] = ACTIONS(2501),
    [anon_sym_CARET] = ACTIONS(2501),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2501),
    [anon_sym_TILDE] = ACTIONS(2501),
    [anon_sym_LBRACE_EQ] = ACTIONS(2501),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2501),
    [anon_sym_LBRACE_DASH] = ACTIONS(2501),
    [anon_sym_LBRACK_CARET] = ACTIONS(2501),
    [anon_sym_BANG_LBRACK] = ACTIONS(2501),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2501),
    [anon_sym_LPAREN] = ACTIONS(2501),
    [anon_sym_DOLLAR] = ACTIONS(2501),
    [anon_sym_TODO] = ACTIONS(2501),
    [anon_sym_WIP] = ACTIONS(2501),
    [anon_sym_NOTE] = ACTIONS(2501),
    [anon_sym_INFO] = ACTIONS(2501),
    [anon_sym_XXX] = ACTIONS(2501),
    [sym_fixme] = ACTIONS(2501),
    [aux_sym__text_token1] = ACTIONS(2503),
    [sym__newline] = ACTIONS(2501),
    [sym__newline_inline] = ACTIONS(2501),
    [sym_hard_line_break] = ACTIONS(2501),
    [sym__heading_begin] = ACTIONS(2501),
    [sym__div_begin] = ACTIONS(2501),
    [sym__code_block_begin] = ACTIONS(2501),
    [sym_list_marker_dash] = ACTIONS(2501),
    [sym_list_marker_star] = ACTIONS(2501),
    [sym_list_marker_plus] = ACTIONS(2501),
    [sym__list_marker_task_begin] = ACTIONS(2501),
    [sym_list_marker_definition] = ACTIONS(2501),
    [sym_list_marker_decimal_period] = ACTIONS(2501),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2501),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2501),
    [sym_list_marker_lower_roman_period] = ACTIONS(2501),
    [sym_list_marker_upper_roman_period] = ACTIONS(2501),
    [sym_list_marker_decimal_paren] = ACTIONS(2501),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2501),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2501),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2501),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2501),
    [sym_list_marker_decimal_parens] = ACTIONS(2501),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2501),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2501),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2501),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2501),
    [sym__block_quote_begin] = ACTIONS(2501),
    [sym__block_quote_continuation] = ACTIONS(2501),
    [sym__thematic_break_dash] = ACTIONS(2501),
    [sym__thematic_break_star] = ACTIONS(2501),
    [sym__footnote_mark_begin] = ACTIONS(2501),
    [sym__link_ref_def_mark_begin] = ACTIONS(2501),
    [sym__table_header_begin] = ACTIONS(2501),
    [sym__table_separator_begin] = ACTIONS(2501),
    [sym__table_row_begin] = ACTIONS(2501),
    [sym__block_attribute_begin] = ACTIONS(2501),
    [sym__verbatim_begin] = ACTIONS(2501),
  },
  [337] = {
    [ts_builtin_sym_end] = ACTIONS(2505),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [sym__whitespace1] = ACTIONS(2505),
    [sym_quotation_marks] = ACTIONS(2505),
    [sym_ellipsis] = ACTIONS(2505),
    [sym_em_dash] = ACTIONS(2505),
    [sym_en_dash] = ACTIONS(2507),
    [sym_backslash_escape] = ACTIONS(2507),
    [anon_sym_LT] = ACTIONS(2505),
    [sym_symbol] = ACTIONS(2505),
    [anon_sym_LBRACE_] = ACTIONS(2505),
    [anon_sym__] = ACTIONS(2505),
    [anon_sym_LBRACE_STAR] = ACTIONS(2505),
    [anon_sym_STAR] = ACTIONS(2505),
    [anon_sym_LBRACE_CARET] = ACTIONS(2505),
    [anon_sym_CARET] = ACTIONS(2505),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2505),
    [anon_sym_TILDE] = ACTIONS(2505),
    [anon_sym_LBRACE_EQ] = ACTIONS(2505),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2505),
    [anon_sym_LBRACE_DASH] = ACTIONS(2505),
    [anon_sym_LBRACK_CARET] = ACTIONS(2505),
    [anon_sym_BANG_LBRACK] = ACTIONS(2505),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2505),
    [anon_sym_LPAREN] = ACTIONS(2505),
    [anon_sym_DOLLAR] = ACTIONS(2505),
    [anon_sym_TODO] = ACTIONS(2505),
    [anon_sym_WIP] = ACTIONS(2505),
    [anon_sym_NOTE] = ACTIONS(2505),
    [anon_sym_INFO] = ACTIONS(2505),
    [anon_sym_XXX] = ACTIONS(2505),
    [sym_fixme] = ACTIONS(2505),
    [aux_sym__text_token1] = ACTIONS(2507),
    [sym__newline] = ACTIONS(2505),
    [sym__newline_inline] = ACTIONS(2505),
    [sym_hard_line_break] = ACTIONS(2505),
    [sym__heading_begin] = ACTIONS(2505),
    [sym__div_begin] = ACTIONS(2505),
    [sym__code_block_begin] = ACTIONS(2505),
    [sym_list_marker_dash] = ACTIONS(2505),
    [sym_list_marker_star] = ACTIONS(2505),
    [sym_list_marker_plus] = ACTIONS(2505),
    [sym__list_marker_task_begin] = ACTIONS(2505),
    [sym_list_marker_definition] = ACTIONS(2505),
    [sym_list_marker_decimal_period] = ACTIONS(2505),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2505),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2505),
    [sym_list_marker_lower_roman_period] = ACTIONS(2505),
    [sym_list_marker_upper_roman_period] = ACTIONS(2505),
    [sym_list_marker_decimal_paren] = ACTIONS(2505),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2505),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2505),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2505),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2505),
    [sym_list_marker_decimal_parens] = ACTIONS(2505),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2505),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2505),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2505),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2505),
    [sym__block_quote_begin] = ACTIONS(2505),
    [sym__block_quote_continuation] = ACTIONS(2505),
    [sym__thematic_break_dash] = ACTIONS(2505),
    [sym__thematic_break_star] = ACTIONS(2505),
    [sym__footnote_mark_begin] = ACTIONS(2505),
    [sym__link_ref_def_mark_begin] = ACTIONS(2505),
    [sym__table_header_begin] = ACTIONS(2505),
    [sym__table_separator_begin] = ACTIONS(2505),
    [sym__table_row_begin] = ACTIONS(2505),
    [sym__block_attribute_begin] = ACTIONS(2505),
    [sym__verbatim_begin] = ACTIONS(2505),
  },
  [338] = {
    [ts_builtin_sym_end] = ACTIONS(2509),
    [anon_sym_LBRACK] = ACTIONS(2511),
    [sym__whitespace1] = ACTIONS(2509),
    [sym_quotation_marks] = ACTIONS(2509),
    [sym_ellipsis] = ACTIONS(2509),
    [sym_em_dash] = ACTIONS(2509),
    [sym_en_dash] = ACTIONS(2511),
    [sym_backslash_escape] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2509),
    [sym_symbol] = ACTIONS(2509),
    [anon_sym_LBRACE_] = ACTIONS(2509),
    [anon_sym__] = ACTIONS(2509),
    [anon_sym_LBRACE_STAR] = ACTIONS(2509),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_LBRACE_CARET] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2509),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2509),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_LBRACE_EQ] = ACTIONS(2509),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2509),
    [anon_sym_LBRACE_DASH] = ACTIONS(2509),
    [anon_sym_LBRACK_CARET] = ACTIONS(2509),
    [anon_sym_BANG_LBRACK] = ACTIONS(2509),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2509),
    [anon_sym_LPAREN] = ACTIONS(2509),
    [anon_sym_DOLLAR] = ACTIONS(2509),
    [anon_sym_TODO] = ACTIONS(2509),
    [anon_sym_WIP] = ACTIONS(2509),
    [anon_sym_NOTE] = ACTIONS(2509),
    [anon_sym_INFO] = ACTIONS(2509),
    [anon_sym_XXX] = ACTIONS(2509),
    [sym_fixme] = ACTIONS(2509),
    [aux_sym__text_token1] = ACTIONS(2511),
    [sym__newline] = ACTIONS(2509),
    [sym__newline_inline] = ACTIONS(2509),
    [sym_hard_line_break] = ACTIONS(2509),
    [sym__heading_begin] = ACTIONS(2509),
    [sym__div_begin] = ACTIONS(2509),
    [sym__code_block_begin] = ACTIONS(2509),
    [sym_list_marker_dash] = ACTIONS(2509),
    [sym_list_marker_star] = ACTIONS(2509),
    [sym_list_marker_plus] = ACTIONS(2509),
    [sym__list_marker_task_begin] = ACTIONS(2509),
    [sym_list_marker_definition] = ACTIONS(2509),
    [sym_list_marker_decimal_period] = ACTIONS(2509),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2509),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2509),
    [sym_list_marker_lower_roman_period] = ACTIONS(2509),
    [sym_list_marker_upper_roman_period] = ACTIONS(2509),
    [sym_list_marker_decimal_paren] = ACTIONS(2509),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2509),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2509),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2509),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2509),
    [sym_list_marker_decimal_parens] = ACTIONS(2509),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2509),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2509),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2509),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2509),
    [sym__block_quote_begin] = ACTIONS(2509),
    [sym__block_quote_continuation] = ACTIONS(2509),
    [sym__thematic_break_dash] = ACTIONS(2509),
    [sym__thematic_break_star] = ACTIONS(2509),
    [sym__footnote_mark_begin] = ACTIONS(2509),
    [sym__link_ref_def_mark_begin] = ACTIONS(2509),
    [sym__table_header_begin] = ACTIONS(2509),
    [sym__table_separator_begin] = ACTIONS(2509),
    [sym__table_row_begin] = ACTIONS(2509),
    [sym__block_attribute_begin] = ACTIONS(2509),
    [sym__verbatim_begin] = ACTIONS(2509),
  },
  [339] = {
    [ts_builtin_sym_end] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(2515),
    [sym__whitespace1] = ACTIONS(2513),
    [sym_quotation_marks] = ACTIONS(2513),
    [sym_ellipsis] = ACTIONS(2513),
    [sym_em_dash] = ACTIONS(2513),
    [sym_en_dash] = ACTIONS(2515),
    [sym_backslash_escape] = ACTIONS(2515),
    [anon_sym_LT] = ACTIONS(2513),
    [sym_symbol] = ACTIONS(2513),
    [anon_sym_LBRACE_] = ACTIONS(2513),
    [anon_sym__] = ACTIONS(2513),
    [anon_sym_LBRACE_STAR] = ACTIONS(2513),
    [anon_sym_STAR] = ACTIONS(2513),
    [anon_sym_LBRACE_CARET] = ACTIONS(2513),
    [anon_sym_CARET] = ACTIONS(2513),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [anon_sym_LBRACE_EQ] = ACTIONS(2513),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2513),
    [anon_sym_LBRACE_DASH] = ACTIONS(2513),
    [anon_sym_LBRACK_CARET] = ACTIONS(2513),
    [anon_sym_BANG_LBRACK] = ACTIONS(2513),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2513),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_DOLLAR] = ACTIONS(2513),
    [anon_sym_TODO] = ACTIONS(2513),
    [anon_sym_WIP] = ACTIONS(2513),
    [anon_sym_NOTE] = ACTIONS(2513),
    [anon_sym_INFO] = ACTIONS(2513),
    [anon_sym_XXX] = ACTIONS(2513),
    [sym_fixme] = ACTIONS(2513),
    [aux_sym__text_token1] = ACTIONS(2515),
    [sym__newline] = ACTIONS(2513),
    [sym__newline_inline] = ACTIONS(2513),
    [sym_hard_line_break] = ACTIONS(2513),
    [sym__heading_begin] = ACTIONS(2513),
    [sym__div_begin] = ACTIONS(2513),
    [sym__code_block_begin] = ACTIONS(2513),
    [sym_list_marker_dash] = ACTIONS(2513),
    [sym_list_marker_star] = ACTIONS(2513),
    [sym_list_marker_plus] = ACTIONS(2513),
    [sym__list_marker_task_begin] = ACTIONS(2513),
    [sym_list_marker_definition] = ACTIONS(2513),
    [sym_list_marker_decimal_period] = ACTIONS(2513),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2513),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2513),
    [sym_list_marker_lower_roman_period] = ACTIONS(2513),
    [sym_list_marker_upper_roman_period] = ACTIONS(2513),
    [sym_list_marker_decimal_paren] = ACTIONS(2513),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2513),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2513),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2513),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2513),
    [sym_list_marker_decimal_parens] = ACTIONS(2513),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2513),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2513),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2513),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2513),
    [sym__block_quote_begin] = ACTIONS(2513),
    [sym__block_quote_continuation] = ACTIONS(2513),
    [sym__thematic_break_dash] = ACTIONS(2513),
    [sym__thematic_break_star] = ACTIONS(2513),
    [sym__footnote_mark_begin] = ACTIONS(2513),
    [sym__link_ref_def_mark_begin] = ACTIONS(2513),
    [sym__table_header_begin] = ACTIONS(2513),
    [sym__table_separator_begin] = ACTIONS(2513),
    [sym__table_row_begin] = ACTIONS(2513),
    [sym__block_attribute_begin] = ACTIONS(2513),
    [sym__verbatim_begin] = ACTIONS(2513),
  },
  [340] = {
    [ts_builtin_sym_end] = ACTIONS(2517),
    [anon_sym_LBRACK] = ACTIONS(2519),
    [sym__whitespace1] = ACTIONS(2517),
    [sym_quotation_marks] = ACTIONS(2517),
    [sym_ellipsis] = ACTIONS(2517),
    [sym_em_dash] = ACTIONS(2517),
    [sym_en_dash] = ACTIONS(2519),
    [sym_backslash_escape] = ACTIONS(2519),
    [anon_sym_LT] = ACTIONS(2517),
    [sym_symbol] = ACTIONS(2517),
    [anon_sym_LBRACE_] = ACTIONS(2517),
    [anon_sym__] = ACTIONS(2517),
    [anon_sym_LBRACE_STAR] = ACTIONS(2517),
    [anon_sym_STAR] = ACTIONS(2517),
    [anon_sym_LBRACE_CARET] = ACTIONS(2517),
    [anon_sym_CARET] = ACTIONS(2517),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2517),
    [anon_sym_TILDE] = ACTIONS(2517),
    [anon_sym_LBRACE_EQ] = ACTIONS(2517),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2517),
    [anon_sym_LBRACE_DASH] = ACTIONS(2517),
    [anon_sym_LBRACK_CARET] = ACTIONS(2517),
    [anon_sym_BANG_LBRACK] = ACTIONS(2517),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2517),
    [anon_sym_LPAREN] = ACTIONS(2517),
    [anon_sym_DOLLAR] = ACTIONS(2517),
    [anon_sym_TODO] = ACTIONS(2517),
    [anon_sym_WIP] = ACTIONS(2517),
    [anon_sym_NOTE] = ACTIONS(2517),
    [anon_sym_INFO] = ACTIONS(2517),
    [anon_sym_XXX] = ACTIONS(2517),
    [sym_fixme] = ACTIONS(2517),
    [aux_sym__text_token1] = ACTIONS(2519),
    [sym__newline] = ACTIONS(2517),
    [sym__newline_inline] = ACTIONS(2517),
    [sym_hard_line_break] = ACTIONS(2517),
    [sym__heading_begin] = ACTIONS(2517),
    [sym__div_begin] = ACTIONS(2517),
    [sym__code_block_begin] = ACTIONS(2517),
    [sym_list_marker_dash] = ACTIONS(2517),
    [sym_list_marker_star] = ACTIONS(2517),
    [sym_list_marker_plus] = ACTIONS(2517),
    [sym__list_marker_task_begin] = ACTIONS(2517),
    [sym_list_marker_definition] = ACTIONS(2517),
    [sym_list_marker_decimal_period] = ACTIONS(2517),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2517),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2517),
    [sym_list_marker_lower_roman_period] = ACTIONS(2517),
    [sym_list_marker_upper_roman_period] = ACTIONS(2517),
    [sym_list_marker_decimal_paren] = ACTIONS(2517),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2517),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2517),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2517),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2517),
    [sym_list_marker_decimal_parens] = ACTIONS(2517),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2517),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2517),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2517),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2517),
    [sym__block_quote_begin] = ACTIONS(2517),
    [sym__block_quote_continuation] = ACTIONS(2517),
    [sym__thematic_break_dash] = ACTIONS(2517),
    [sym__thematic_break_star] = ACTIONS(2517),
    [sym__footnote_mark_begin] = ACTIONS(2517),
    [sym__link_ref_def_mark_begin] = ACTIONS(2517),
    [sym__table_header_begin] = ACTIONS(2517),
    [sym__table_separator_begin] = ACTIONS(2517),
    [sym__table_row_begin] = ACTIONS(2517),
    [sym__block_attribute_begin] = ACTIONS(2517),
    [sym__verbatim_begin] = ACTIONS(2517),
  },
  [341] = {
    [ts_builtin_sym_end] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [sym__whitespace1] = ACTIONS(2521),
    [sym_quotation_marks] = ACTIONS(2521),
    [sym_ellipsis] = ACTIONS(2521),
    [sym_em_dash] = ACTIONS(2521),
    [sym_en_dash] = ACTIONS(2523),
    [sym_backslash_escape] = ACTIONS(2523),
    [anon_sym_LT] = ACTIONS(2521),
    [sym_symbol] = ACTIONS(2521),
    [anon_sym_LBRACE_] = ACTIONS(2521),
    [anon_sym__] = ACTIONS(2521),
    [anon_sym_LBRACE_STAR] = ACTIONS(2521),
    [anon_sym_STAR] = ACTIONS(2521),
    [anon_sym_LBRACE_CARET] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2521),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [anon_sym_LBRACE_EQ] = ACTIONS(2521),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2521),
    [anon_sym_LBRACE_DASH] = ACTIONS(2521),
    [anon_sym_LBRACK_CARET] = ACTIONS(2521),
    [anon_sym_BANG_LBRACK] = ACTIONS(2521),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2521),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_DOLLAR] = ACTIONS(2521),
    [anon_sym_TODO] = ACTIONS(2521),
    [anon_sym_WIP] = ACTIONS(2521),
    [anon_sym_NOTE] = ACTIONS(2521),
    [anon_sym_INFO] = ACTIONS(2521),
    [anon_sym_XXX] = ACTIONS(2521),
    [sym_fixme] = ACTIONS(2521),
    [aux_sym__text_token1] = ACTIONS(2523),
    [sym__newline] = ACTIONS(2521),
    [sym__newline_inline] = ACTIONS(2521),
    [sym_hard_line_break] = ACTIONS(2521),
    [sym__heading_begin] = ACTIONS(2521),
    [sym__div_begin] = ACTIONS(2521),
    [sym__code_block_begin] = ACTIONS(2521),
    [sym_list_marker_dash] = ACTIONS(2521),
    [sym_list_marker_star] = ACTIONS(2521),
    [sym_list_marker_plus] = ACTIONS(2521),
    [sym__list_marker_task_begin] = ACTIONS(2521),
    [sym_list_marker_definition] = ACTIONS(2521),
    [sym_list_marker_decimal_period] = ACTIONS(2521),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2521),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2521),
    [sym_list_marker_lower_roman_period] = ACTIONS(2521),
    [sym_list_marker_upper_roman_period] = ACTIONS(2521),
    [sym_list_marker_decimal_paren] = ACTIONS(2521),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2521),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2521),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2521),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2521),
    [sym_list_marker_decimal_parens] = ACTIONS(2521),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2521),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2521),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2521),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2521),
    [sym__block_quote_begin] = ACTIONS(2521),
    [sym__block_quote_continuation] = ACTIONS(2521),
    [sym__thematic_break_dash] = ACTIONS(2521),
    [sym__thematic_break_star] = ACTIONS(2521),
    [sym__footnote_mark_begin] = ACTIONS(2521),
    [sym__link_ref_def_mark_begin] = ACTIONS(2521),
    [sym__table_header_begin] = ACTIONS(2521),
    [sym__table_separator_begin] = ACTIONS(2521),
    [sym__table_row_begin] = ACTIONS(2521),
    [sym__block_attribute_begin] = ACTIONS(2521),
    [sym__verbatim_begin] = ACTIONS(2521),
  },
  [342] = {
    [ts_builtin_sym_end] = ACTIONS(2525),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [sym__whitespace1] = ACTIONS(2525),
    [sym_quotation_marks] = ACTIONS(2525),
    [sym_ellipsis] = ACTIONS(2525),
    [sym_em_dash] = ACTIONS(2525),
    [sym_en_dash] = ACTIONS(2527),
    [sym_backslash_escape] = ACTIONS(2527),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_symbol] = ACTIONS(2525),
    [anon_sym_LBRACE_] = ACTIONS(2525),
    [anon_sym__] = ACTIONS(2525),
    [anon_sym_LBRACE_STAR] = ACTIONS(2525),
    [anon_sym_STAR] = ACTIONS(2525),
    [anon_sym_LBRACE_CARET] = ACTIONS(2525),
    [anon_sym_CARET] = ACTIONS(2525),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2525),
    [anon_sym_TILDE] = ACTIONS(2525),
    [anon_sym_LBRACE_EQ] = ACTIONS(2525),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2525),
    [anon_sym_LBRACE_DASH] = ACTIONS(2525),
    [anon_sym_LBRACK_CARET] = ACTIONS(2525),
    [anon_sym_BANG_LBRACK] = ACTIONS(2525),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2525),
    [anon_sym_LPAREN] = ACTIONS(2525),
    [anon_sym_DOLLAR] = ACTIONS(2525),
    [anon_sym_TODO] = ACTIONS(2525),
    [anon_sym_WIP] = ACTIONS(2525),
    [anon_sym_NOTE] = ACTIONS(2525),
    [anon_sym_INFO] = ACTIONS(2525),
    [anon_sym_XXX] = ACTIONS(2525),
    [sym_fixme] = ACTIONS(2525),
    [aux_sym__text_token1] = ACTIONS(2527),
    [sym__newline] = ACTIONS(2525),
    [sym__newline_inline] = ACTIONS(2525),
    [sym_hard_line_break] = ACTIONS(2525),
    [sym__heading_begin] = ACTIONS(2525),
    [sym__div_begin] = ACTIONS(2525),
    [sym__code_block_begin] = ACTIONS(2525),
    [sym_list_marker_dash] = ACTIONS(2525),
    [sym_list_marker_star] = ACTIONS(2525),
    [sym_list_marker_plus] = ACTIONS(2525),
    [sym__list_marker_task_begin] = ACTIONS(2525),
    [sym_list_marker_definition] = ACTIONS(2525),
    [sym_list_marker_decimal_period] = ACTIONS(2525),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2525),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2525),
    [sym_list_marker_lower_roman_period] = ACTIONS(2525),
    [sym_list_marker_upper_roman_period] = ACTIONS(2525),
    [sym_list_marker_decimal_paren] = ACTIONS(2525),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2525),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2525),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2525),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2525),
    [sym_list_marker_decimal_parens] = ACTIONS(2525),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2525),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2525),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2525),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2525),
    [sym__block_quote_begin] = ACTIONS(2525),
    [sym__block_quote_continuation] = ACTIONS(2525),
    [sym__thematic_break_dash] = ACTIONS(2525),
    [sym__thematic_break_star] = ACTIONS(2525),
    [sym__footnote_mark_begin] = ACTIONS(2525),
    [sym__link_ref_def_mark_begin] = ACTIONS(2525),
    [sym__table_header_begin] = ACTIONS(2525),
    [sym__table_separator_begin] = ACTIONS(2525),
    [sym__table_row_begin] = ACTIONS(2525),
    [sym__block_attribute_begin] = ACTIONS(2525),
    [sym__verbatim_begin] = ACTIONS(2525),
  },
  [343] = {
    [ts_builtin_sym_end] = ACTIONS(2529),
    [anon_sym_LBRACK] = ACTIONS(2531),
    [sym__whitespace1] = ACTIONS(2529),
    [sym_quotation_marks] = ACTIONS(2529),
    [sym_ellipsis] = ACTIONS(2529),
    [sym_em_dash] = ACTIONS(2529),
    [sym_en_dash] = ACTIONS(2531),
    [sym_backslash_escape] = ACTIONS(2531),
    [anon_sym_LT] = ACTIONS(2529),
    [sym_symbol] = ACTIONS(2529),
    [anon_sym_LBRACE_] = ACTIONS(2529),
    [anon_sym__] = ACTIONS(2529),
    [anon_sym_LBRACE_STAR] = ACTIONS(2529),
    [anon_sym_STAR] = ACTIONS(2529),
    [anon_sym_LBRACE_CARET] = ACTIONS(2529),
    [anon_sym_CARET] = ACTIONS(2529),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2529),
    [anon_sym_TILDE] = ACTIONS(2529),
    [anon_sym_LBRACE_EQ] = ACTIONS(2529),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2529),
    [anon_sym_LBRACE_DASH] = ACTIONS(2529),
    [anon_sym_LBRACK_CARET] = ACTIONS(2529),
    [anon_sym_BANG_LBRACK] = ACTIONS(2529),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2529),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_DOLLAR] = ACTIONS(2529),
    [anon_sym_TODO] = ACTIONS(2529),
    [anon_sym_WIP] = ACTIONS(2529),
    [anon_sym_NOTE] = ACTIONS(2529),
    [anon_sym_INFO] = ACTIONS(2529),
    [anon_sym_XXX] = ACTIONS(2529),
    [sym_fixme] = ACTIONS(2529),
    [aux_sym__text_token1] = ACTIONS(2531),
    [sym__newline] = ACTIONS(2529),
    [sym__newline_inline] = ACTIONS(2529),
    [sym_hard_line_break] = ACTIONS(2529),
    [sym__heading_begin] = ACTIONS(2529),
    [sym__div_begin] = ACTIONS(2529),
    [sym__code_block_begin] = ACTIONS(2529),
    [sym_list_marker_dash] = ACTIONS(2529),
    [sym_list_marker_star] = ACTIONS(2529),
    [sym_list_marker_plus] = ACTIONS(2529),
    [sym__list_marker_task_begin] = ACTIONS(2529),
    [sym_list_marker_definition] = ACTIONS(2529),
    [sym_list_marker_decimal_period] = ACTIONS(2529),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2529),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2529),
    [sym_list_marker_lower_roman_period] = ACTIONS(2529),
    [sym_list_marker_upper_roman_period] = ACTIONS(2529),
    [sym_list_marker_decimal_paren] = ACTIONS(2529),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2529),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2529),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2529),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2529),
    [sym_list_marker_decimal_parens] = ACTIONS(2529),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2529),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2529),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2529),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2529),
    [sym__block_quote_begin] = ACTIONS(2529),
    [sym__block_quote_continuation] = ACTIONS(2529),
    [sym__thematic_break_dash] = ACTIONS(2529),
    [sym__thematic_break_star] = ACTIONS(2529),
    [sym__footnote_mark_begin] = ACTIONS(2529),
    [sym__link_ref_def_mark_begin] = ACTIONS(2529),
    [sym__table_header_begin] = ACTIONS(2529),
    [sym__table_separator_begin] = ACTIONS(2529),
    [sym__table_row_begin] = ACTIONS(2529),
    [sym__block_attribute_begin] = ACTIONS(2529),
    [sym__verbatim_begin] = ACTIONS(2529),
  },
  [344] = {
    [ts_builtin_sym_end] = ACTIONS(2533),
    [anon_sym_LBRACK] = ACTIONS(2535),
    [sym__whitespace1] = ACTIONS(2533),
    [sym_quotation_marks] = ACTIONS(2533),
    [sym_ellipsis] = ACTIONS(2533),
    [sym_em_dash] = ACTIONS(2533),
    [sym_en_dash] = ACTIONS(2535),
    [sym_backslash_escape] = ACTIONS(2535),
    [anon_sym_LT] = ACTIONS(2533),
    [sym_symbol] = ACTIONS(2533),
    [anon_sym_LBRACE_] = ACTIONS(2533),
    [anon_sym__] = ACTIONS(2533),
    [anon_sym_LBRACE_STAR] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(2533),
    [anon_sym_LBRACE_CARET] = ACTIONS(2533),
    [anon_sym_CARET] = ACTIONS(2533),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2533),
    [anon_sym_TILDE] = ACTIONS(2533),
    [anon_sym_LBRACE_EQ] = ACTIONS(2533),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2533),
    [anon_sym_LBRACE_DASH] = ACTIONS(2533),
    [anon_sym_LBRACK_CARET] = ACTIONS(2533),
    [anon_sym_BANG_LBRACK] = ACTIONS(2533),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2533),
    [anon_sym_LPAREN] = ACTIONS(2533),
    [anon_sym_DOLLAR] = ACTIONS(2533),
    [anon_sym_TODO] = ACTIONS(2533),
    [anon_sym_WIP] = ACTIONS(2533),
    [anon_sym_NOTE] = ACTIONS(2533),
    [anon_sym_INFO] = ACTIONS(2533),
    [anon_sym_XXX] = ACTIONS(2533),
    [sym_fixme] = ACTIONS(2533),
    [aux_sym__text_token1] = ACTIONS(2535),
    [sym__newline] = ACTIONS(2533),
    [sym__newline_inline] = ACTIONS(2533),
    [sym_hard_line_break] = ACTIONS(2533),
    [sym__heading_begin] = ACTIONS(2533),
    [sym__div_begin] = ACTIONS(2533),
    [sym__code_block_begin] = ACTIONS(2533),
    [sym_list_marker_dash] = ACTIONS(2533),
    [sym_list_marker_star] = ACTIONS(2533),
    [sym_list_marker_plus] = ACTIONS(2533),
    [sym__list_marker_task_begin] = ACTIONS(2533),
    [sym_list_marker_definition] = ACTIONS(2533),
    [sym_list_marker_decimal_period] = ACTIONS(2533),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2533),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2533),
    [sym_list_marker_lower_roman_period] = ACTIONS(2533),
    [sym_list_marker_upper_roman_period] = ACTIONS(2533),
    [sym_list_marker_decimal_paren] = ACTIONS(2533),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2533),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2533),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2533),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2533),
    [sym_list_marker_decimal_parens] = ACTIONS(2533),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2533),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2533),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2533),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2533),
    [sym__block_quote_begin] = ACTIONS(2533),
    [sym__block_quote_continuation] = ACTIONS(2533),
    [sym__thematic_break_dash] = ACTIONS(2533),
    [sym__thematic_break_star] = ACTIONS(2533),
    [sym__footnote_mark_begin] = ACTIONS(2533),
    [sym__link_ref_def_mark_begin] = ACTIONS(2533),
    [sym__table_header_begin] = ACTIONS(2533),
    [sym__table_separator_begin] = ACTIONS(2533),
    [sym__table_row_begin] = ACTIONS(2533),
    [sym__block_attribute_begin] = ACTIONS(2533),
    [sym__verbatim_begin] = ACTIONS(2533),
  },
  [345] = {
    [ts_builtin_sym_end] = ACTIONS(2537),
    [anon_sym_LBRACK] = ACTIONS(2539),
    [sym__whitespace1] = ACTIONS(2537),
    [sym_quotation_marks] = ACTIONS(2537),
    [sym_ellipsis] = ACTIONS(2537),
    [sym_em_dash] = ACTIONS(2537),
    [sym_en_dash] = ACTIONS(2539),
    [sym_backslash_escape] = ACTIONS(2539),
    [anon_sym_LT] = ACTIONS(2537),
    [sym_symbol] = ACTIONS(2537),
    [anon_sym_LBRACE_] = ACTIONS(2537),
    [anon_sym__] = ACTIONS(2537),
    [anon_sym_LBRACE_STAR] = ACTIONS(2537),
    [anon_sym_STAR] = ACTIONS(2537),
    [anon_sym_LBRACE_CARET] = ACTIONS(2537),
    [anon_sym_CARET] = ACTIONS(2537),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2537),
    [anon_sym_TILDE] = ACTIONS(2537),
    [anon_sym_LBRACE_EQ] = ACTIONS(2537),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2537),
    [anon_sym_LBRACE_DASH] = ACTIONS(2537),
    [anon_sym_LBRACK_CARET] = ACTIONS(2537),
    [anon_sym_BANG_LBRACK] = ACTIONS(2537),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2537),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_DOLLAR] = ACTIONS(2537),
    [anon_sym_TODO] = ACTIONS(2537),
    [anon_sym_WIP] = ACTIONS(2537),
    [anon_sym_NOTE] = ACTIONS(2537),
    [anon_sym_INFO] = ACTIONS(2537),
    [anon_sym_XXX] = ACTIONS(2537),
    [sym_fixme] = ACTIONS(2537),
    [aux_sym__text_token1] = ACTIONS(2539),
    [sym__newline] = ACTIONS(2537),
    [sym__newline_inline] = ACTIONS(2537),
    [sym_hard_line_break] = ACTIONS(2537),
    [sym__heading_begin] = ACTIONS(2537),
    [sym__div_begin] = ACTIONS(2537),
    [sym__code_block_begin] = ACTIONS(2537),
    [sym_list_marker_dash] = ACTIONS(2537),
    [sym_list_marker_star] = ACTIONS(2537),
    [sym_list_marker_plus] = ACTIONS(2537),
    [sym__list_marker_task_begin] = ACTIONS(2537),
    [sym_list_marker_definition] = ACTIONS(2537),
    [sym_list_marker_decimal_period] = ACTIONS(2537),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2537),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2537),
    [sym_list_marker_lower_roman_period] = ACTIONS(2537),
    [sym_list_marker_upper_roman_period] = ACTIONS(2537),
    [sym_list_marker_decimal_paren] = ACTIONS(2537),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2537),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2537),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2537),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2537),
    [sym_list_marker_decimal_parens] = ACTIONS(2537),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2537),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2537),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2537),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2537),
    [sym__block_quote_begin] = ACTIONS(2537),
    [sym__block_quote_continuation] = ACTIONS(2537),
    [sym__thematic_break_dash] = ACTIONS(2537),
    [sym__thematic_break_star] = ACTIONS(2537),
    [sym__footnote_mark_begin] = ACTIONS(2537),
    [sym__link_ref_def_mark_begin] = ACTIONS(2537),
    [sym__table_header_begin] = ACTIONS(2537),
    [sym__table_separator_begin] = ACTIONS(2537),
    [sym__table_row_begin] = ACTIONS(2537),
    [sym__block_attribute_begin] = ACTIONS(2537),
    [sym__verbatim_begin] = ACTIONS(2537),
  },
  [346] = {
    [ts_builtin_sym_end] = ACTIONS(2541),
    [anon_sym_LBRACK] = ACTIONS(2543),
    [sym__whitespace1] = ACTIONS(2541),
    [sym_quotation_marks] = ACTIONS(2541),
    [sym_ellipsis] = ACTIONS(2541),
    [sym_em_dash] = ACTIONS(2541),
    [sym_en_dash] = ACTIONS(2543),
    [sym_backslash_escape] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(2541),
    [sym_symbol] = ACTIONS(2541),
    [anon_sym_LBRACE_] = ACTIONS(2541),
    [anon_sym__] = ACTIONS(2541),
    [anon_sym_LBRACE_STAR] = ACTIONS(2541),
    [anon_sym_STAR] = ACTIONS(2541),
    [anon_sym_LBRACE_CARET] = ACTIONS(2541),
    [anon_sym_CARET] = ACTIONS(2541),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2541),
    [anon_sym_TILDE] = ACTIONS(2541),
    [anon_sym_LBRACE_EQ] = ACTIONS(2541),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2541),
    [anon_sym_LBRACE_DASH] = ACTIONS(2541),
    [anon_sym_LBRACK_CARET] = ACTIONS(2541),
    [anon_sym_BANG_LBRACK] = ACTIONS(2541),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(2541),
    [anon_sym_DOLLAR] = ACTIONS(2541),
    [anon_sym_TODO] = ACTIONS(2541),
    [anon_sym_WIP] = ACTIONS(2541),
    [anon_sym_NOTE] = ACTIONS(2541),
    [anon_sym_INFO] = ACTIONS(2541),
    [anon_sym_XXX] = ACTIONS(2541),
    [sym_fixme] = ACTIONS(2541),
    [aux_sym__text_token1] = ACTIONS(2543),
    [sym__newline] = ACTIONS(2541),
    [sym__newline_inline] = ACTIONS(2541),
    [sym_hard_line_break] = ACTIONS(2541),
    [sym__heading_begin] = ACTIONS(2541),
    [sym__div_begin] = ACTIONS(2541),
    [sym__code_block_begin] = ACTIONS(2541),
    [sym_list_marker_dash] = ACTIONS(2541),
    [sym_list_marker_star] = ACTIONS(2541),
    [sym_list_marker_plus] = ACTIONS(2541),
    [sym__list_marker_task_begin] = ACTIONS(2541),
    [sym_list_marker_definition] = ACTIONS(2541),
    [sym_list_marker_decimal_period] = ACTIONS(2541),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2541),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2541),
    [sym_list_marker_lower_roman_period] = ACTIONS(2541),
    [sym_list_marker_upper_roman_period] = ACTIONS(2541),
    [sym_list_marker_decimal_paren] = ACTIONS(2541),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2541),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2541),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2541),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2541),
    [sym_list_marker_decimal_parens] = ACTIONS(2541),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2541),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2541),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2541),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2541),
    [sym__block_quote_begin] = ACTIONS(2541),
    [sym__block_quote_continuation] = ACTIONS(2541),
    [sym__thematic_break_dash] = ACTIONS(2541),
    [sym__thematic_break_star] = ACTIONS(2541),
    [sym__footnote_mark_begin] = ACTIONS(2541),
    [sym__link_ref_def_mark_begin] = ACTIONS(2541),
    [sym__table_header_begin] = ACTIONS(2541),
    [sym__table_separator_begin] = ACTIONS(2541),
    [sym__table_row_begin] = ACTIONS(2541),
    [sym__block_attribute_begin] = ACTIONS(2541),
    [sym__verbatim_begin] = ACTIONS(2541),
  },
  [347] = {
    [ts_builtin_sym_end] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2547),
    [sym__whitespace1] = ACTIONS(2545),
    [sym_quotation_marks] = ACTIONS(2545),
    [sym_ellipsis] = ACTIONS(2545),
    [sym_em_dash] = ACTIONS(2545),
    [sym_en_dash] = ACTIONS(2547),
    [sym_backslash_escape] = ACTIONS(2547),
    [anon_sym_LT] = ACTIONS(2545),
    [sym_symbol] = ACTIONS(2545),
    [anon_sym_LBRACE_] = ACTIONS(2545),
    [anon_sym__] = ACTIONS(2545),
    [anon_sym_LBRACE_STAR] = ACTIONS(2545),
    [anon_sym_STAR] = ACTIONS(2545),
    [anon_sym_LBRACE_CARET] = ACTIONS(2545),
    [anon_sym_CARET] = ACTIONS(2545),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2545),
    [anon_sym_LBRACE_EQ] = ACTIONS(2545),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2545),
    [anon_sym_LBRACE_DASH] = ACTIONS(2545),
    [anon_sym_LBRACK_CARET] = ACTIONS(2545),
    [anon_sym_BANG_LBRACK] = ACTIONS(2545),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2545),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_DOLLAR] = ACTIONS(2545),
    [anon_sym_TODO] = ACTIONS(2545),
    [anon_sym_WIP] = ACTIONS(2545),
    [anon_sym_NOTE] = ACTIONS(2545),
    [anon_sym_INFO] = ACTIONS(2545),
    [anon_sym_XXX] = ACTIONS(2545),
    [sym_fixme] = ACTIONS(2545),
    [aux_sym__text_token1] = ACTIONS(2547),
    [sym__newline] = ACTIONS(2545),
    [sym__newline_inline] = ACTIONS(2545),
    [sym_hard_line_break] = ACTIONS(2545),
    [sym__heading_begin] = ACTIONS(2545),
    [sym__div_begin] = ACTIONS(2545),
    [sym__code_block_begin] = ACTIONS(2545),
    [sym_list_marker_dash] = ACTIONS(2545),
    [sym_list_marker_star] = ACTIONS(2545),
    [sym_list_marker_plus] = ACTIONS(2545),
    [sym__list_marker_task_begin] = ACTIONS(2545),
    [sym_list_marker_definition] = ACTIONS(2545),
    [sym_list_marker_decimal_period] = ACTIONS(2545),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2545),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2545),
    [sym_list_marker_lower_roman_period] = ACTIONS(2545),
    [sym_list_marker_upper_roman_period] = ACTIONS(2545),
    [sym_list_marker_decimal_paren] = ACTIONS(2545),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2545),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2545),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2545),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2545),
    [sym_list_marker_decimal_parens] = ACTIONS(2545),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2545),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2545),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2545),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2545),
    [sym__block_quote_begin] = ACTIONS(2545),
    [sym__block_quote_continuation] = ACTIONS(2545),
    [sym__thematic_break_dash] = ACTIONS(2545),
    [sym__thematic_break_star] = ACTIONS(2545),
    [sym__footnote_mark_begin] = ACTIONS(2545),
    [sym__link_ref_def_mark_begin] = ACTIONS(2545),
    [sym__table_header_begin] = ACTIONS(2545),
    [sym__table_separator_begin] = ACTIONS(2545),
    [sym__table_row_begin] = ACTIONS(2545),
    [sym__block_attribute_begin] = ACTIONS(2545),
    [sym__verbatim_begin] = ACTIONS(2545),
  },
  [348] = {
    [ts_builtin_sym_end] = ACTIONS(2549),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [sym__whitespace1] = ACTIONS(2549),
    [sym_quotation_marks] = ACTIONS(2549),
    [sym_ellipsis] = ACTIONS(2549),
    [sym_em_dash] = ACTIONS(2549),
    [sym_en_dash] = ACTIONS(2551),
    [sym_backslash_escape] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2549),
    [sym_symbol] = ACTIONS(2549),
    [anon_sym_LBRACE_] = ACTIONS(2549),
    [anon_sym__] = ACTIONS(2549),
    [anon_sym_LBRACE_STAR] = ACTIONS(2549),
    [anon_sym_STAR] = ACTIONS(2549),
    [anon_sym_LBRACE_CARET] = ACTIONS(2549),
    [anon_sym_CARET] = ACTIONS(2549),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2549),
    [anon_sym_TILDE] = ACTIONS(2549),
    [anon_sym_LBRACE_EQ] = ACTIONS(2549),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2549),
    [anon_sym_LBRACE_DASH] = ACTIONS(2549),
    [anon_sym_LBRACK_CARET] = ACTIONS(2549),
    [anon_sym_BANG_LBRACK] = ACTIONS(2549),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2549),
    [anon_sym_LPAREN] = ACTIONS(2549),
    [anon_sym_DOLLAR] = ACTIONS(2549),
    [anon_sym_TODO] = ACTIONS(2549),
    [anon_sym_WIP] = ACTIONS(2549),
    [anon_sym_NOTE] = ACTIONS(2549),
    [anon_sym_INFO] = ACTIONS(2549),
    [anon_sym_XXX] = ACTIONS(2549),
    [sym_fixme] = ACTIONS(2549),
    [aux_sym__text_token1] = ACTIONS(2551),
    [sym__newline] = ACTIONS(2549),
    [sym__newline_inline] = ACTIONS(2549),
    [sym_hard_line_break] = ACTIONS(2549),
    [sym__heading_begin] = ACTIONS(2549),
    [sym__div_begin] = ACTIONS(2549),
    [sym__code_block_begin] = ACTIONS(2549),
    [sym_list_marker_dash] = ACTIONS(2549),
    [sym_list_marker_star] = ACTIONS(2549),
    [sym_list_marker_plus] = ACTIONS(2549),
    [sym__list_marker_task_begin] = ACTIONS(2549),
    [sym_list_marker_definition] = ACTIONS(2549),
    [sym_list_marker_decimal_period] = ACTIONS(2549),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2549),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2549),
    [sym_list_marker_lower_roman_period] = ACTIONS(2549),
    [sym_list_marker_upper_roman_period] = ACTIONS(2549),
    [sym_list_marker_decimal_paren] = ACTIONS(2549),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2549),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2549),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2549),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2549),
    [sym_list_marker_decimal_parens] = ACTIONS(2549),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2549),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2549),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2549),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2549),
    [sym__block_quote_begin] = ACTIONS(2549),
    [sym__block_quote_continuation] = ACTIONS(2549),
    [sym__thematic_break_dash] = ACTIONS(2549),
    [sym__thematic_break_star] = ACTIONS(2549),
    [sym__footnote_mark_begin] = ACTIONS(2549),
    [sym__link_ref_def_mark_begin] = ACTIONS(2549),
    [sym__table_header_begin] = ACTIONS(2549),
    [sym__table_separator_begin] = ACTIONS(2549),
    [sym__table_row_begin] = ACTIONS(2549),
    [sym__block_attribute_begin] = ACTIONS(2549),
    [sym__verbatim_begin] = ACTIONS(2549),
  },
  [349] = {
    [ts_builtin_sym_end] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2555),
    [sym__whitespace1] = ACTIONS(2553),
    [sym_quotation_marks] = ACTIONS(2553),
    [sym_ellipsis] = ACTIONS(2553),
    [sym_em_dash] = ACTIONS(2553),
    [sym_en_dash] = ACTIONS(2555),
    [sym_backslash_escape] = ACTIONS(2555),
    [anon_sym_LT] = ACTIONS(2553),
    [sym_symbol] = ACTIONS(2553),
    [anon_sym_LBRACE_] = ACTIONS(2553),
    [anon_sym__] = ACTIONS(2553),
    [anon_sym_LBRACE_STAR] = ACTIONS(2553),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACE_CARET] = ACTIONS(2553),
    [anon_sym_CARET] = ACTIONS(2553),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2553),
    [anon_sym_TILDE] = ACTIONS(2553),
    [anon_sym_LBRACE_EQ] = ACTIONS(2553),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2553),
    [anon_sym_LBRACE_DASH] = ACTIONS(2553),
    [anon_sym_LBRACK_CARET] = ACTIONS(2553),
    [anon_sym_BANG_LBRACK] = ACTIONS(2553),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2553),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_DOLLAR] = ACTIONS(2553),
    [anon_sym_TODO] = ACTIONS(2553),
    [anon_sym_WIP] = ACTIONS(2553),
    [anon_sym_NOTE] = ACTIONS(2553),
    [anon_sym_INFO] = ACTIONS(2553),
    [anon_sym_XXX] = ACTIONS(2553),
    [sym_fixme] = ACTIONS(2553),
    [aux_sym__text_token1] = ACTIONS(2555),
    [sym__newline] = ACTIONS(2553),
    [sym__newline_inline] = ACTIONS(2553),
    [sym_hard_line_break] = ACTIONS(2553),
    [sym__heading_begin] = ACTIONS(2553),
    [sym__div_begin] = ACTIONS(2553),
    [sym__code_block_begin] = ACTIONS(2553),
    [sym_list_marker_dash] = ACTIONS(2553),
    [sym_list_marker_star] = ACTIONS(2553),
    [sym_list_marker_plus] = ACTIONS(2553),
    [sym__list_marker_task_begin] = ACTIONS(2553),
    [sym_list_marker_definition] = ACTIONS(2553),
    [sym_list_marker_decimal_period] = ACTIONS(2553),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2553),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2553),
    [sym_list_marker_lower_roman_period] = ACTIONS(2553),
    [sym_list_marker_upper_roman_period] = ACTIONS(2553),
    [sym_list_marker_decimal_paren] = ACTIONS(2553),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2553),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2553),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2553),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2553),
    [sym_list_marker_decimal_parens] = ACTIONS(2553),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2553),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2553),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2553),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2553),
    [sym__block_quote_begin] = ACTIONS(2553),
    [sym__block_quote_continuation] = ACTIONS(2553),
    [sym__thematic_break_dash] = ACTIONS(2553),
    [sym__thematic_break_star] = ACTIONS(2553),
    [sym__footnote_mark_begin] = ACTIONS(2553),
    [sym__link_ref_def_mark_begin] = ACTIONS(2553),
    [sym__table_header_begin] = ACTIONS(2553),
    [sym__table_separator_begin] = ACTIONS(2553),
    [sym__table_row_begin] = ACTIONS(2553),
    [sym__block_attribute_begin] = ACTIONS(2553),
    [sym__verbatim_begin] = ACTIONS(2553),
  },
  [350] = {
    [ts_builtin_sym_end] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2559),
    [sym__whitespace1] = ACTIONS(2557),
    [sym_quotation_marks] = ACTIONS(2557),
    [sym_ellipsis] = ACTIONS(2557),
    [sym_em_dash] = ACTIONS(2557),
    [sym_en_dash] = ACTIONS(2559),
    [sym_backslash_escape] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2557),
    [sym_symbol] = ACTIONS(2557),
    [anon_sym_LBRACE_] = ACTIONS(2557),
    [anon_sym__] = ACTIONS(2557),
    [anon_sym_LBRACE_STAR] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2557),
    [anon_sym_LBRACE_CARET] = ACTIONS(2557),
    [anon_sym_CARET] = ACTIONS(2557),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2557),
    [anon_sym_TILDE] = ACTIONS(2557),
    [anon_sym_LBRACE_EQ] = ACTIONS(2557),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2557),
    [anon_sym_LBRACE_DASH] = ACTIONS(2557),
    [anon_sym_LBRACK_CARET] = ACTIONS(2557),
    [anon_sym_BANG_LBRACK] = ACTIONS(2557),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2557),
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_DOLLAR] = ACTIONS(2557),
    [anon_sym_TODO] = ACTIONS(2557),
    [anon_sym_WIP] = ACTIONS(2557),
    [anon_sym_NOTE] = ACTIONS(2557),
    [anon_sym_INFO] = ACTIONS(2557),
    [anon_sym_XXX] = ACTIONS(2557),
    [sym_fixme] = ACTIONS(2557),
    [aux_sym__text_token1] = ACTIONS(2559),
    [sym__newline] = ACTIONS(2557),
    [sym__newline_inline] = ACTIONS(2557),
    [sym_hard_line_break] = ACTIONS(2557),
    [sym__heading_begin] = ACTIONS(2557),
    [sym__div_begin] = ACTIONS(2557),
    [sym__code_block_begin] = ACTIONS(2557),
    [sym_list_marker_dash] = ACTIONS(2557),
    [sym_list_marker_star] = ACTIONS(2557),
    [sym_list_marker_plus] = ACTIONS(2557),
    [sym__list_marker_task_begin] = ACTIONS(2557),
    [sym_list_marker_definition] = ACTIONS(2557),
    [sym_list_marker_decimal_period] = ACTIONS(2557),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2557),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2557),
    [sym_list_marker_lower_roman_period] = ACTIONS(2557),
    [sym_list_marker_upper_roman_period] = ACTIONS(2557),
    [sym_list_marker_decimal_paren] = ACTIONS(2557),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2557),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2557),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2557),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2557),
    [sym_list_marker_decimal_parens] = ACTIONS(2557),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2557),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2557),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2557),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2557),
    [sym__block_quote_begin] = ACTIONS(2557),
    [sym__block_quote_continuation] = ACTIONS(2557),
    [sym__thematic_break_dash] = ACTIONS(2557),
    [sym__thematic_break_star] = ACTIONS(2557),
    [sym__footnote_mark_begin] = ACTIONS(2557),
    [sym__link_ref_def_mark_begin] = ACTIONS(2557),
    [sym__table_header_begin] = ACTIONS(2557),
    [sym__table_separator_begin] = ACTIONS(2557),
    [sym__table_row_begin] = ACTIONS(2557),
    [sym__block_attribute_begin] = ACTIONS(2557),
    [sym__verbatim_begin] = ACTIONS(2557),
  },
  [351] = {
    [ts_builtin_sym_end] = ACTIONS(2561),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [sym__whitespace1] = ACTIONS(2561),
    [sym_quotation_marks] = ACTIONS(2561),
    [sym_ellipsis] = ACTIONS(2561),
    [sym_em_dash] = ACTIONS(2561),
    [sym_en_dash] = ACTIONS(2563),
    [sym_backslash_escape] = ACTIONS(2563),
    [anon_sym_LT] = ACTIONS(2561),
    [sym_symbol] = ACTIONS(2561),
    [anon_sym_LBRACE_] = ACTIONS(2561),
    [anon_sym__] = ACTIONS(2561),
    [anon_sym_LBRACE_STAR] = ACTIONS(2561),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_LBRACE_CARET] = ACTIONS(2561),
    [anon_sym_CARET] = ACTIONS(2561),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2561),
    [anon_sym_TILDE] = ACTIONS(2561),
    [anon_sym_LBRACE_EQ] = ACTIONS(2561),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2561),
    [anon_sym_LBRACE_DASH] = ACTIONS(2561),
    [anon_sym_LBRACK_CARET] = ACTIONS(2561),
    [anon_sym_BANG_LBRACK] = ACTIONS(2561),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2561),
    [anon_sym_LPAREN] = ACTIONS(2561),
    [anon_sym_DOLLAR] = ACTIONS(2561),
    [anon_sym_TODO] = ACTIONS(2561),
    [anon_sym_WIP] = ACTIONS(2561),
    [anon_sym_NOTE] = ACTIONS(2561),
    [anon_sym_INFO] = ACTIONS(2561),
    [anon_sym_XXX] = ACTIONS(2561),
    [sym_fixme] = ACTIONS(2561),
    [aux_sym__text_token1] = ACTIONS(2563),
    [sym__newline] = ACTIONS(2561),
    [sym__newline_inline] = ACTIONS(2561),
    [sym_hard_line_break] = ACTIONS(2561),
    [sym__heading_begin] = ACTIONS(2561),
    [sym__div_begin] = ACTIONS(2561),
    [sym__code_block_begin] = ACTIONS(2561),
    [sym_list_marker_dash] = ACTIONS(2561),
    [sym_list_marker_star] = ACTIONS(2561),
    [sym_list_marker_plus] = ACTIONS(2561),
    [sym__list_marker_task_begin] = ACTIONS(2561),
    [sym_list_marker_definition] = ACTIONS(2561),
    [sym_list_marker_decimal_period] = ACTIONS(2561),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2561),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2561),
    [sym_list_marker_lower_roman_period] = ACTIONS(2561),
    [sym_list_marker_upper_roman_period] = ACTIONS(2561),
    [sym_list_marker_decimal_paren] = ACTIONS(2561),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2561),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2561),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2561),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2561),
    [sym_list_marker_decimal_parens] = ACTIONS(2561),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2561),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2561),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2561),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2561),
    [sym__block_quote_begin] = ACTIONS(2561),
    [sym__block_quote_continuation] = ACTIONS(2561),
    [sym__thematic_break_dash] = ACTIONS(2561),
    [sym__thematic_break_star] = ACTIONS(2561),
    [sym__footnote_mark_begin] = ACTIONS(2561),
    [sym__link_ref_def_mark_begin] = ACTIONS(2561),
    [sym__table_header_begin] = ACTIONS(2561),
    [sym__table_separator_begin] = ACTIONS(2561),
    [sym__table_row_begin] = ACTIONS(2561),
    [sym__block_attribute_begin] = ACTIONS(2561),
    [sym__verbatim_begin] = ACTIONS(2561),
  },
  [352] = {
    [ts_builtin_sym_end] = ACTIONS(2565),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [sym__whitespace1] = ACTIONS(2565),
    [sym_quotation_marks] = ACTIONS(2565),
    [sym_ellipsis] = ACTIONS(2565),
    [sym_em_dash] = ACTIONS(2565),
    [sym_en_dash] = ACTIONS(2567),
    [sym_backslash_escape] = ACTIONS(2567),
    [anon_sym_LT] = ACTIONS(2565),
    [sym_symbol] = ACTIONS(2565),
    [anon_sym_LBRACE_] = ACTIONS(2565),
    [anon_sym__] = ACTIONS(2565),
    [anon_sym_LBRACE_STAR] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2565),
    [anon_sym_LBRACE_CARET] = ACTIONS(2565),
    [anon_sym_CARET] = ACTIONS(2565),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2565),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_LBRACE_EQ] = ACTIONS(2565),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2565),
    [anon_sym_LBRACE_DASH] = ACTIONS(2565),
    [anon_sym_LBRACK_CARET] = ACTIONS(2565),
    [anon_sym_BANG_LBRACK] = ACTIONS(2565),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2565),
    [anon_sym_DOLLAR] = ACTIONS(2565),
    [anon_sym_TODO] = ACTIONS(2565),
    [anon_sym_WIP] = ACTIONS(2565),
    [anon_sym_NOTE] = ACTIONS(2565),
    [anon_sym_INFO] = ACTIONS(2565),
    [anon_sym_XXX] = ACTIONS(2565),
    [sym_fixme] = ACTIONS(2565),
    [aux_sym__text_token1] = ACTIONS(2567),
    [sym__newline] = ACTIONS(2565),
    [sym__newline_inline] = ACTIONS(2565),
    [sym_hard_line_break] = ACTIONS(2565),
    [sym__heading_begin] = ACTIONS(2565),
    [sym__div_begin] = ACTIONS(2565),
    [sym__code_block_begin] = ACTIONS(2565),
    [sym_list_marker_dash] = ACTIONS(2565),
    [sym_list_marker_star] = ACTIONS(2565),
    [sym_list_marker_plus] = ACTIONS(2565),
    [sym__list_marker_task_begin] = ACTIONS(2565),
    [sym_list_marker_definition] = ACTIONS(2565),
    [sym_list_marker_decimal_period] = ACTIONS(2565),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2565),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2565),
    [sym_list_marker_lower_roman_period] = ACTIONS(2565),
    [sym_list_marker_upper_roman_period] = ACTIONS(2565),
    [sym_list_marker_decimal_paren] = ACTIONS(2565),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2565),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2565),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2565),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2565),
    [sym_list_marker_decimal_parens] = ACTIONS(2565),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2565),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2565),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2565),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2565),
    [sym__block_quote_begin] = ACTIONS(2565),
    [sym__block_quote_continuation] = ACTIONS(2565),
    [sym__thematic_break_dash] = ACTIONS(2565),
    [sym__thematic_break_star] = ACTIONS(2565),
    [sym__footnote_mark_begin] = ACTIONS(2565),
    [sym__link_ref_def_mark_begin] = ACTIONS(2565),
    [sym__table_header_begin] = ACTIONS(2565),
    [sym__table_separator_begin] = ACTIONS(2565),
    [sym__table_row_begin] = ACTIONS(2565),
    [sym__block_attribute_begin] = ACTIONS(2565),
    [sym__verbatim_begin] = ACTIONS(2565),
  },
  [353] = {
    [ts_builtin_sym_end] = ACTIONS(2569),
    [anon_sym_LBRACK] = ACTIONS(2571),
    [sym__whitespace1] = ACTIONS(2569),
    [sym_quotation_marks] = ACTIONS(2569),
    [sym_ellipsis] = ACTIONS(2569),
    [sym_em_dash] = ACTIONS(2569),
    [sym_en_dash] = ACTIONS(2571),
    [sym_backslash_escape] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2569),
    [sym_symbol] = ACTIONS(2569),
    [anon_sym_LBRACE_] = ACTIONS(2569),
    [anon_sym__] = ACTIONS(2569),
    [anon_sym_LBRACE_STAR] = ACTIONS(2569),
    [anon_sym_STAR] = ACTIONS(2569),
    [anon_sym_LBRACE_CARET] = ACTIONS(2569),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2569),
    [anon_sym_TILDE] = ACTIONS(2569),
    [anon_sym_LBRACE_EQ] = ACTIONS(2569),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2569),
    [anon_sym_LBRACE_DASH] = ACTIONS(2569),
    [anon_sym_LBRACK_CARET] = ACTIONS(2569),
    [anon_sym_BANG_LBRACK] = ACTIONS(2569),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2569),
    [anon_sym_TODO] = ACTIONS(2569),
    [anon_sym_WIP] = ACTIONS(2569),
    [anon_sym_NOTE] = ACTIONS(2569),
    [anon_sym_INFO] = ACTIONS(2569),
    [anon_sym_XXX] = ACTIONS(2569),
    [sym_fixme] = ACTIONS(2569),
    [aux_sym__text_token1] = ACTIONS(2571),
    [sym__newline] = ACTIONS(2569),
    [sym__newline_inline] = ACTIONS(2569),
    [sym_hard_line_break] = ACTIONS(2569),
    [sym__heading_begin] = ACTIONS(2569),
    [sym__div_begin] = ACTIONS(2569),
    [sym__code_block_begin] = ACTIONS(2569),
    [sym_list_marker_dash] = ACTIONS(2569),
    [sym_list_marker_star] = ACTIONS(2569),
    [sym_list_marker_plus] = ACTIONS(2569),
    [sym__list_marker_task_begin] = ACTIONS(2569),
    [sym_list_marker_definition] = ACTIONS(2569),
    [sym_list_marker_decimal_period] = ACTIONS(2569),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2569),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2569),
    [sym_list_marker_lower_roman_period] = ACTIONS(2569),
    [sym_list_marker_upper_roman_period] = ACTIONS(2569),
    [sym_list_marker_decimal_paren] = ACTIONS(2569),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2569),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2569),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2569),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2569),
    [sym_list_marker_decimal_parens] = ACTIONS(2569),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2569),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2569),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2569),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2569),
    [sym__block_quote_begin] = ACTIONS(2569),
    [sym__block_quote_continuation] = ACTIONS(2569),
    [sym__thematic_break_dash] = ACTIONS(2569),
    [sym__thematic_break_star] = ACTIONS(2569),
    [sym__footnote_mark_begin] = ACTIONS(2569),
    [sym__link_ref_def_mark_begin] = ACTIONS(2569),
    [sym__table_header_begin] = ACTIONS(2569),
    [sym__table_separator_begin] = ACTIONS(2569),
    [sym__table_row_begin] = ACTIONS(2569),
    [sym__block_attribute_begin] = ACTIONS(2569),
    [sym__verbatim_begin] = ACTIONS(2569),
  },
  [354] = {
    [ts_builtin_sym_end] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2349),
    [sym__whitespace1] = ACTIONS(2347),
    [sym_quotation_marks] = ACTIONS(2347),
    [sym_ellipsis] = ACTIONS(2347),
    [sym_em_dash] = ACTIONS(2347),
    [sym_en_dash] = ACTIONS(2349),
    [sym_backslash_escape] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(2347),
    [sym_symbol] = ACTIONS(2347),
    [anon_sym_LBRACE_] = ACTIONS(2347),
    [anon_sym__] = ACTIONS(2347),
    [anon_sym_LBRACE_STAR] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2347),
    [anon_sym_LBRACE_CARET] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2347),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_LBRACE_EQ] = ACTIONS(2347),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2347),
    [anon_sym_LBRACE_DASH] = ACTIONS(2347),
    [anon_sym_LBRACK_CARET] = ACTIONS(2347),
    [anon_sym_BANG_LBRACK] = ACTIONS(2347),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2347),
    [anon_sym_TODO] = ACTIONS(2347),
    [anon_sym_WIP] = ACTIONS(2347),
    [anon_sym_NOTE] = ACTIONS(2347),
    [anon_sym_INFO] = ACTIONS(2347),
    [anon_sym_XXX] = ACTIONS(2347),
    [sym_fixme] = ACTIONS(2347),
    [aux_sym__text_token1] = ACTIONS(2349),
    [sym__newline] = ACTIONS(2347),
    [sym__newline_inline] = ACTIONS(2347),
    [sym_hard_line_break] = ACTIONS(2347),
    [sym__heading_begin] = ACTIONS(2347),
    [sym__div_begin] = ACTIONS(2347),
    [sym__code_block_begin] = ACTIONS(2347),
    [sym_list_marker_dash] = ACTIONS(2347),
    [sym_list_marker_star] = ACTIONS(2347),
    [sym_list_marker_plus] = ACTIONS(2347),
    [sym__list_marker_task_begin] = ACTIONS(2347),
    [sym_list_marker_definition] = ACTIONS(2347),
    [sym_list_marker_decimal_period] = ACTIONS(2347),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2347),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2347),
    [sym_list_marker_lower_roman_period] = ACTIONS(2347),
    [sym_list_marker_upper_roman_period] = ACTIONS(2347),
    [sym_list_marker_decimal_paren] = ACTIONS(2347),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2347),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2347),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2347),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2347),
    [sym_list_marker_decimal_parens] = ACTIONS(2347),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2347),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2347),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2347),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2347),
    [sym__block_quote_begin] = ACTIONS(2347),
    [sym__block_quote_continuation] = ACTIONS(2347),
    [sym__thematic_break_dash] = ACTIONS(2347),
    [sym__thematic_break_star] = ACTIONS(2347),
    [sym__footnote_mark_begin] = ACTIONS(2347),
    [sym__link_ref_def_mark_begin] = ACTIONS(2347),
    [sym__table_header_begin] = ACTIONS(2347),
    [sym__table_separator_begin] = ACTIONS(2347),
    [sym__table_row_begin] = ACTIONS(2347),
    [sym__block_attribute_begin] = ACTIONS(2347),
    [sym__verbatim_begin] = ACTIONS(2347),
  },
  [355] = {
    [ts_builtin_sym_end] = ACTIONS(2467),
    [anon_sym_LBRACK] = ACTIONS(2465),
    [sym__whitespace1] = ACTIONS(2467),
    [sym_quotation_marks] = ACTIONS(2467),
    [sym_ellipsis] = ACTIONS(2467),
    [sym_em_dash] = ACTIONS(2467),
    [sym_en_dash] = ACTIONS(2465),
    [sym_backslash_escape] = ACTIONS(2465),
    [anon_sym_LT] = ACTIONS(2467),
    [sym_symbol] = ACTIONS(2467),
    [anon_sym_LBRACE_] = ACTIONS(2467),
    [anon_sym__] = ACTIONS(2467),
    [anon_sym_LBRACE_STAR] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(2467),
    [anon_sym_LBRACE_CARET] = ACTIONS(2467),
    [anon_sym_CARET] = ACTIONS(2467),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2467),
    [anon_sym_TILDE] = ACTIONS(2467),
    [anon_sym_LBRACE_EQ] = ACTIONS(2467),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2467),
    [anon_sym_LBRACE_DASH] = ACTIONS(2467),
    [anon_sym_LBRACK_CARET] = ACTIONS(2467),
    [anon_sym_BANG_LBRACK] = ACTIONS(2467),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2467),
    [anon_sym_DOLLAR] = ACTIONS(2467),
    [anon_sym_TODO] = ACTIONS(2467),
    [anon_sym_WIP] = ACTIONS(2467),
    [anon_sym_NOTE] = ACTIONS(2467),
    [anon_sym_INFO] = ACTIONS(2467),
    [anon_sym_XXX] = ACTIONS(2467),
    [sym_fixme] = ACTIONS(2467),
    [aux_sym__text_token1] = ACTIONS(2465),
    [sym__newline] = ACTIONS(2467),
    [sym__newline_inline] = ACTIONS(2467),
    [sym_hard_line_break] = ACTIONS(2467),
    [sym__heading_begin] = ACTIONS(2467),
    [sym__div_begin] = ACTIONS(2467),
    [sym__code_block_begin] = ACTIONS(2467),
    [sym_list_marker_dash] = ACTIONS(2467),
    [sym_list_marker_star] = ACTIONS(2467),
    [sym_list_marker_plus] = ACTIONS(2467),
    [sym__list_marker_task_begin] = ACTIONS(2467),
    [sym_list_marker_definition] = ACTIONS(2467),
    [sym_list_marker_decimal_period] = ACTIONS(2467),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2467),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2467),
    [sym_list_marker_lower_roman_period] = ACTIONS(2467),
    [sym_list_marker_upper_roman_period] = ACTIONS(2467),
    [sym_list_marker_decimal_paren] = ACTIONS(2467),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2467),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2467),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2467),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2467),
    [sym_list_marker_decimal_parens] = ACTIONS(2467),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2467),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2467),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2467),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2467),
    [sym__block_quote_begin] = ACTIONS(2467),
    [sym__block_quote_continuation] = ACTIONS(2467),
    [sym__thematic_break_dash] = ACTIONS(2467),
    [sym__thematic_break_star] = ACTIONS(2467),
    [sym__footnote_mark_begin] = ACTIONS(2467),
    [sym__link_ref_def_mark_begin] = ACTIONS(2467),
    [sym__table_header_begin] = ACTIONS(2467),
    [sym__table_separator_begin] = ACTIONS(2467),
    [sym__table_row_begin] = ACTIONS(2467),
    [sym__block_attribute_begin] = ACTIONS(2467),
    [sym__verbatim_begin] = ACTIONS(2467),
  },
  [356] = {
    [ts_builtin_sym_end] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2575),
    [sym__whitespace1] = ACTIONS(2573),
    [sym_quotation_marks] = ACTIONS(2573),
    [sym_ellipsis] = ACTIONS(2573),
    [sym_em_dash] = ACTIONS(2573),
    [sym_en_dash] = ACTIONS(2575),
    [sym_backslash_escape] = ACTIONS(2575),
    [anon_sym_LT] = ACTIONS(2573),
    [sym_symbol] = ACTIONS(2573),
    [anon_sym_LBRACE_] = ACTIONS(2573),
    [anon_sym__] = ACTIONS(2573),
    [anon_sym_LBRACE_STAR] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2573),
    [anon_sym_LBRACE_CARET] = ACTIONS(2573),
    [anon_sym_CARET] = ACTIONS(2573),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2573),
    [anon_sym_TILDE] = ACTIONS(2573),
    [anon_sym_LBRACE_EQ] = ACTIONS(2573),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2573),
    [anon_sym_LBRACE_DASH] = ACTIONS(2573),
    [anon_sym_LBRACK_CARET] = ACTIONS(2573),
    [anon_sym_BANG_LBRACK] = ACTIONS(2573),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2573),
    [anon_sym_LPAREN] = ACTIONS(2573),
    [anon_sym_DOLLAR] = ACTIONS(2573),
    [anon_sym_TODO] = ACTIONS(2573),
    [anon_sym_WIP] = ACTIONS(2573),
    [anon_sym_NOTE] = ACTIONS(2573),
    [anon_sym_INFO] = ACTIONS(2573),
    [anon_sym_XXX] = ACTIONS(2573),
    [sym_fixme] = ACTIONS(2573),
    [aux_sym__text_token1] = ACTIONS(2575),
    [sym__newline] = ACTIONS(2573),
    [sym__newline_inline] = ACTIONS(2573),
    [sym_hard_line_break] = ACTIONS(2573),
    [sym__heading_begin] = ACTIONS(2573),
    [sym__div_begin] = ACTIONS(2573),
    [sym__code_block_begin] = ACTIONS(2573),
    [sym_list_marker_dash] = ACTIONS(2573),
    [sym_list_marker_star] = ACTIONS(2573),
    [sym_list_marker_plus] = ACTIONS(2573),
    [sym__list_marker_task_begin] = ACTIONS(2573),
    [sym_list_marker_definition] = ACTIONS(2573),
    [sym_list_marker_decimal_period] = ACTIONS(2573),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2573),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2573),
    [sym_list_marker_lower_roman_period] = ACTIONS(2573),
    [sym_list_marker_upper_roman_period] = ACTIONS(2573),
    [sym_list_marker_decimal_paren] = ACTIONS(2573),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2573),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2573),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2573),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2573),
    [sym_list_marker_decimal_parens] = ACTIONS(2573),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2573),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2573),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2573),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2573),
    [sym__block_quote_begin] = ACTIONS(2573),
    [sym__block_quote_continuation] = ACTIONS(2573),
    [sym__thematic_break_dash] = ACTIONS(2573),
    [sym__thematic_break_star] = ACTIONS(2573),
    [sym__footnote_mark_begin] = ACTIONS(2573),
    [sym__link_ref_def_mark_begin] = ACTIONS(2573),
    [sym__table_header_begin] = ACTIONS(2573),
    [sym__table_separator_begin] = ACTIONS(2573),
    [sym__table_row_begin] = ACTIONS(2573),
    [sym__block_attribute_begin] = ACTIONS(2573),
    [sym__verbatim_begin] = ACTIONS(2573),
  },
  [357] = {
    [ts_builtin_sym_end] = ACTIONS(2577),
    [anon_sym_LBRACK] = ACTIONS(2579),
    [sym__whitespace1] = ACTIONS(2577),
    [sym_quotation_marks] = ACTIONS(2577),
    [sym_ellipsis] = ACTIONS(2577),
    [sym_em_dash] = ACTIONS(2577),
    [sym_en_dash] = ACTIONS(2579),
    [sym_backslash_escape] = ACTIONS(2579),
    [anon_sym_LT] = ACTIONS(2577),
    [sym_symbol] = ACTIONS(2577),
    [anon_sym_LBRACE_] = ACTIONS(2577),
    [anon_sym__] = ACTIONS(2577),
    [anon_sym_LBRACE_STAR] = ACTIONS(2577),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE_CARET] = ACTIONS(2577),
    [anon_sym_CARET] = ACTIONS(2577),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_LBRACE_EQ] = ACTIONS(2577),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2577),
    [anon_sym_LBRACE_DASH] = ACTIONS(2577),
    [anon_sym_LBRACK_CARET] = ACTIONS(2577),
    [anon_sym_BANG_LBRACK] = ACTIONS(2577),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2577),
    [anon_sym_DOLLAR] = ACTIONS(2577),
    [anon_sym_TODO] = ACTIONS(2577),
    [anon_sym_WIP] = ACTIONS(2577),
    [anon_sym_NOTE] = ACTIONS(2577),
    [anon_sym_INFO] = ACTIONS(2577),
    [anon_sym_XXX] = ACTIONS(2577),
    [sym_fixme] = ACTIONS(2577),
    [aux_sym__text_token1] = ACTIONS(2579),
    [sym__newline] = ACTIONS(2577),
    [sym__newline_inline] = ACTIONS(2577),
    [sym_hard_line_break] = ACTIONS(2577),
    [sym__heading_begin] = ACTIONS(2577),
    [sym__div_begin] = ACTIONS(2577),
    [sym__code_block_begin] = ACTIONS(2577),
    [sym_list_marker_dash] = ACTIONS(2577),
    [sym_list_marker_star] = ACTIONS(2577),
    [sym_list_marker_plus] = ACTIONS(2577),
    [sym__list_marker_task_begin] = ACTIONS(2577),
    [sym_list_marker_definition] = ACTIONS(2577),
    [sym_list_marker_decimal_period] = ACTIONS(2577),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2577),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2577),
    [sym_list_marker_lower_roman_period] = ACTIONS(2577),
    [sym_list_marker_upper_roman_period] = ACTIONS(2577),
    [sym_list_marker_decimal_paren] = ACTIONS(2577),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2577),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2577),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2577),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2577),
    [sym_list_marker_decimal_parens] = ACTIONS(2577),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2577),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2577),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2577),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2577),
    [sym__block_quote_begin] = ACTIONS(2577),
    [sym__block_quote_continuation] = ACTIONS(2577),
    [sym__thematic_break_dash] = ACTIONS(2577),
    [sym__thematic_break_star] = ACTIONS(2577),
    [sym__footnote_mark_begin] = ACTIONS(2577),
    [sym__link_ref_def_mark_begin] = ACTIONS(2577),
    [sym__table_header_begin] = ACTIONS(2577),
    [sym__table_separator_begin] = ACTIONS(2577),
    [sym__table_row_begin] = ACTIONS(2577),
    [sym__block_attribute_begin] = ACTIONS(2577),
    [sym__verbatim_begin] = ACTIONS(2577),
  },
  [358] = {
    [ts_builtin_sym_end] = ACTIONS(2487),
    [anon_sym_LBRACK] = ACTIONS(2485),
    [sym__whitespace1] = ACTIONS(2487),
    [sym_quotation_marks] = ACTIONS(2487),
    [sym_ellipsis] = ACTIONS(2487),
    [sym_em_dash] = ACTIONS(2487),
    [sym_en_dash] = ACTIONS(2485),
    [sym_backslash_escape] = ACTIONS(2485),
    [anon_sym_LT] = ACTIONS(2487),
    [sym_symbol] = ACTIONS(2487),
    [anon_sym_LBRACE_] = ACTIONS(2487),
    [anon_sym__] = ACTIONS(2487),
    [anon_sym_LBRACE_STAR] = ACTIONS(2487),
    [anon_sym_STAR] = ACTIONS(2487),
    [anon_sym_LBRACE_CARET] = ACTIONS(2487),
    [anon_sym_CARET] = ACTIONS(2487),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_LBRACE_EQ] = ACTIONS(2487),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2487),
    [anon_sym_LBRACE_DASH] = ACTIONS(2487),
    [anon_sym_LBRACK_CARET] = ACTIONS(2487),
    [anon_sym_BANG_LBRACK] = ACTIONS(2487),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2487),
    [anon_sym_LPAREN] = ACTIONS(2487),
    [anon_sym_DOLLAR] = ACTIONS(2487),
    [anon_sym_TODO] = ACTIONS(2487),
    [anon_sym_WIP] = ACTIONS(2487),
    [anon_sym_NOTE] = ACTIONS(2487),
    [anon_sym_INFO] = ACTIONS(2487),
    [anon_sym_XXX] = ACTIONS(2487),
    [sym_fixme] = ACTIONS(2487),
    [aux_sym__text_token1] = ACTIONS(2485),
    [sym__newline] = ACTIONS(2487),
    [sym__newline_inline] = ACTIONS(2487),
    [sym_hard_line_break] = ACTIONS(2487),
    [sym__heading_begin] = ACTIONS(2487),
    [sym__div_begin] = ACTIONS(2487),
    [sym__code_block_begin] = ACTIONS(2487),
    [sym_list_marker_dash] = ACTIONS(2487),
    [sym_list_marker_star] = ACTIONS(2487),
    [sym_list_marker_plus] = ACTIONS(2487),
    [sym__list_marker_task_begin] = ACTIONS(2487),
    [sym_list_marker_definition] = ACTIONS(2487),
    [sym_list_marker_decimal_period] = ACTIONS(2487),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2487),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2487),
    [sym_list_marker_lower_roman_period] = ACTIONS(2487),
    [sym_list_marker_upper_roman_period] = ACTIONS(2487),
    [sym_list_marker_decimal_paren] = ACTIONS(2487),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2487),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2487),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2487),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2487),
    [sym_list_marker_decimal_parens] = ACTIONS(2487),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2487),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2487),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2487),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2487),
    [sym__block_quote_begin] = ACTIONS(2487),
    [sym__block_quote_continuation] = ACTIONS(2487),
    [sym__thematic_break_dash] = ACTIONS(2487),
    [sym__thematic_break_star] = ACTIONS(2487),
    [sym__footnote_mark_begin] = ACTIONS(2487),
    [sym__link_ref_def_mark_begin] = ACTIONS(2487),
    [sym__table_header_begin] = ACTIONS(2487),
    [sym__table_separator_begin] = ACTIONS(2487),
    [sym__table_row_begin] = ACTIONS(2487),
    [sym__block_attribute_begin] = ACTIONS(2487),
    [sym__verbatim_begin] = ACTIONS(2487),
  },
  [359] = {
    [anon_sym_LBRACK] = ACTIONS(2581),
    [sym__whitespace1] = ACTIONS(2583),
    [sym_quotation_marks] = ACTIONS(2583),
    [sym_ellipsis] = ACTIONS(2583),
    [sym_em_dash] = ACTIONS(2583),
    [sym_en_dash] = ACTIONS(2581),
    [sym_backslash_escape] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_symbol] = ACTIONS(2583),
    [anon_sym_LBRACE_] = ACTIONS(2583),
    [anon_sym__] = ACTIONS(2583),
    [anon_sym_LBRACE_STAR] = ACTIONS(2583),
    [anon_sym_STAR] = ACTIONS(2583),
    [anon_sym_LBRACE_CARET] = ACTIONS(2583),
    [anon_sym_CARET] = ACTIONS(2583),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2583),
    [anon_sym_TILDE] = ACTIONS(2583),
    [anon_sym_LBRACE_EQ] = ACTIONS(2583),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2583),
    [anon_sym_LBRACE_DASH] = ACTIONS(2583),
    [anon_sym_LBRACK_CARET] = ACTIONS(2583),
    [anon_sym_BANG_LBRACK] = ACTIONS(2583),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2583),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_DOLLAR] = ACTIONS(2583),
    [anon_sym_TODO] = ACTIONS(2583),
    [anon_sym_WIP] = ACTIONS(2583),
    [anon_sym_NOTE] = ACTIONS(2583),
    [anon_sym_INFO] = ACTIONS(2583),
    [anon_sym_XXX] = ACTIONS(2583),
    [sym_fixme] = ACTIONS(2583),
    [aux_sym__text_token1] = ACTIONS(2581),
    [sym__block_close] = ACTIONS(2583),
    [sym__newline] = ACTIONS(2583),
    [sym__newline_inline] = ACTIONS(2583),
    [sym_hard_line_break] = ACTIONS(2583),
    [sym__heading_begin] = ACTIONS(2583),
    [sym__div_begin] = ACTIONS(2583),
    [sym__code_block_begin] = ACTIONS(2583),
    [sym_list_marker_dash] = ACTIONS(2583),
    [sym_list_marker_star] = ACTIONS(2583),
    [sym_list_marker_plus] = ACTIONS(2583),
    [sym__list_marker_task_begin] = ACTIONS(2583),
    [sym_list_marker_definition] = ACTIONS(2583),
    [sym_list_marker_decimal_period] = ACTIONS(2583),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2583),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2583),
    [sym_list_marker_lower_roman_period] = ACTIONS(2583),
    [sym_list_marker_upper_roman_period] = ACTIONS(2583),
    [sym_list_marker_decimal_paren] = ACTIONS(2583),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2583),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2583),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2583),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2583),
    [sym_list_marker_decimal_parens] = ACTIONS(2583),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2583),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2583),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2583),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2583),
    [sym__block_quote_begin] = ACTIONS(2583),
    [sym__block_quote_continuation] = ACTIONS(2583),
    [sym__thematic_break_dash] = ACTIONS(2583),
    [sym__thematic_break_star] = ACTIONS(2583),
    [sym__footnote_mark_begin] = ACTIONS(2583),
    [sym__link_ref_def_mark_begin] = ACTIONS(2583),
    [sym__table_header_begin] = ACTIONS(2583),
    [sym__table_separator_begin] = ACTIONS(2583),
    [sym__table_row_begin] = ACTIONS(2583),
    [sym__block_attribute_begin] = ACTIONS(2583),
    [sym__verbatim_begin] = ACTIONS(2583),
  },
  [360] = {
    [anon_sym_LBRACK] = ACTIONS(2585),
    [sym__whitespace1] = ACTIONS(2587),
    [sym_quotation_marks] = ACTIONS(2587),
    [sym_ellipsis] = ACTIONS(2587),
    [sym_em_dash] = ACTIONS(2587),
    [sym_en_dash] = ACTIONS(2585),
    [sym_backslash_escape] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2587),
    [sym_symbol] = ACTIONS(2587),
    [anon_sym_LBRACE_] = ACTIONS(2587),
    [anon_sym__] = ACTIONS(2587),
    [anon_sym_LBRACE_STAR] = ACTIONS(2587),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE_CARET] = ACTIONS(2587),
    [anon_sym_CARET] = ACTIONS(2587),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [anon_sym_LBRACE_EQ] = ACTIONS(2587),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2587),
    [anon_sym_LBRACE_DASH] = ACTIONS(2587),
    [anon_sym_LBRACK_CARET] = ACTIONS(2587),
    [anon_sym_BANG_LBRACK] = ACTIONS(2587),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2587),
    [anon_sym_LPAREN] = ACTIONS(2587),
    [anon_sym_DOLLAR] = ACTIONS(2587),
    [anon_sym_TODO] = ACTIONS(2587),
    [anon_sym_WIP] = ACTIONS(2587),
    [anon_sym_NOTE] = ACTIONS(2587),
    [anon_sym_INFO] = ACTIONS(2587),
    [anon_sym_XXX] = ACTIONS(2587),
    [sym_fixme] = ACTIONS(2587),
    [aux_sym__text_token1] = ACTIONS(2585),
    [sym__block_close] = ACTIONS(2587),
    [sym__newline] = ACTIONS(2587),
    [sym__newline_inline] = ACTIONS(2587),
    [sym_hard_line_break] = ACTIONS(2587),
    [sym__heading_begin] = ACTIONS(2587),
    [sym__div_begin] = ACTIONS(2587),
    [sym__code_block_begin] = ACTIONS(2587),
    [sym_list_marker_dash] = ACTIONS(2587),
    [sym_list_marker_star] = ACTIONS(2587),
    [sym_list_marker_plus] = ACTIONS(2587),
    [sym__list_marker_task_begin] = ACTIONS(2587),
    [sym_list_marker_definition] = ACTIONS(2587),
    [sym_list_marker_decimal_period] = ACTIONS(2587),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2587),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2587),
    [sym_list_marker_lower_roman_period] = ACTIONS(2587),
    [sym_list_marker_upper_roman_period] = ACTIONS(2587),
    [sym_list_marker_decimal_paren] = ACTIONS(2587),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2587),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2587),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2587),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2587),
    [sym_list_marker_decimal_parens] = ACTIONS(2587),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2587),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2587),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2587),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2587),
    [sym__block_quote_begin] = ACTIONS(2587),
    [sym__block_quote_continuation] = ACTIONS(2587),
    [sym__thematic_break_dash] = ACTIONS(2587),
    [sym__thematic_break_star] = ACTIONS(2587),
    [sym__footnote_mark_begin] = ACTIONS(2587),
    [sym__link_ref_def_mark_begin] = ACTIONS(2587),
    [sym__table_header_begin] = ACTIONS(2587),
    [sym__table_separator_begin] = ACTIONS(2587),
    [sym__table_row_begin] = ACTIONS(2587),
    [sym__block_attribute_begin] = ACTIONS(2587),
    [sym__verbatim_begin] = ACTIONS(2587),
  },
  [361] = {
    [ts_builtin_sym_end] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(2591),
    [sym__whitespace1] = ACTIONS(2589),
    [sym_quotation_marks] = ACTIONS(2589),
    [sym_ellipsis] = ACTIONS(2589),
    [sym_em_dash] = ACTIONS(2589),
    [sym_en_dash] = ACTIONS(2591),
    [sym_backslash_escape] = ACTIONS(2591),
    [anon_sym_LT] = ACTIONS(2589),
    [sym_symbol] = ACTIONS(2589),
    [anon_sym_LBRACE_] = ACTIONS(2589),
    [anon_sym__] = ACTIONS(2589),
    [anon_sym_LBRACE_STAR] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2589),
    [anon_sym_LBRACE_CARET] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2589),
    [anon_sym_TILDE] = ACTIONS(2589),
    [anon_sym_LBRACE_EQ] = ACTIONS(2589),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2589),
    [anon_sym_LBRACE_DASH] = ACTIONS(2589),
    [anon_sym_LBRACK_CARET] = ACTIONS(2589),
    [anon_sym_BANG_LBRACK] = ACTIONS(2589),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(2589),
    [anon_sym_DOLLAR] = ACTIONS(2589),
    [anon_sym_TODO] = ACTIONS(2589),
    [anon_sym_WIP] = ACTIONS(2589),
    [anon_sym_NOTE] = ACTIONS(2589),
    [anon_sym_INFO] = ACTIONS(2589),
    [anon_sym_XXX] = ACTIONS(2589),
    [sym_fixme] = ACTIONS(2589),
    [aux_sym__text_token1] = ACTIONS(2591),
    [sym__newline] = ACTIONS(2589),
    [sym__newline_inline] = ACTIONS(2589),
    [sym_hard_line_break] = ACTIONS(2589),
    [sym__heading_begin] = ACTIONS(2589),
    [sym__div_begin] = ACTIONS(2589),
    [sym__code_block_begin] = ACTIONS(2589),
    [sym_list_marker_dash] = ACTIONS(2589),
    [sym_list_marker_star] = ACTIONS(2589),
    [sym_list_marker_plus] = ACTIONS(2589),
    [sym__list_marker_task_begin] = ACTIONS(2589),
    [sym_list_marker_definition] = ACTIONS(2589),
    [sym_list_marker_decimal_period] = ACTIONS(2589),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2589),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2589),
    [sym_list_marker_lower_roman_period] = ACTIONS(2589),
    [sym_list_marker_upper_roman_period] = ACTIONS(2589),
    [sym_list_marker_decimal_paren] = ACTIONS(2589),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2589),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2589),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2589),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2589),
    [sym_list_marker_decimal_parens] = ACTIONS(2589),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2589),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2589),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2589),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2589),
    [sym__block_quote_begin] = ACTIONS(2589),
    [sym__block_quote_continuation] = ACTIONS(2589),
    [sym__thematic_break_dash] = ACTIONS(2589),
    [sym__thematic_break_star] = ACTIONS(2589),
    [sym__footnote_mark_begin] = ACTIONS(2589),
    [sym__link_ref_def_mark_begin] = ACTIONS(2589),
    [sym__table_header_begin] = ACTIONS(2589),
    [sym__table_separator_begin] = ACTIONS(2589),
    [sym__table_row_begin] = ACTIONS(2589),
    [sym__block_attribute_begin] = ACTIONS(2589),
    [sym__verbatim_begin] = ACTIONS(2589),
  },
  [362] = {
    [anon_sym_LBRACK] = ACTIONS(2593),
    [sym__whitespace1] = ACTIONS(2595),
    [sym_quotation_marks] = ACTIONS(2595),
    [sym_ellipsis] = ACTIONS(2595),
    [sym_em_dash] = ACTIONS(2595),
    [sym_en_dash] = ACTIONS(2593),
    [sym_backslash_escape] = ACTIONS(2593),
    [anon_sym_LT] = ACTIONS(2595),
    [sym_symbol] = ACTIONS(2595),
    [anon_sym_LBRACE_] = ACTIONS(2595),
    [anon_sym__] = ACTIONS(2595),
    [anon_sym_LBRACE_STAR] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(2595),
    [anon_sym_LBRACE_CARET] = ACTIONS(2595),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2595),
    [anon_sym_TILDE] = ACTIONS(2595),
    [anon_sym_LBRACE_EQ] = ACTIONS(2595),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2595),
    [anon_sym_LBRACE_DASH] = ACTIONS(2595),
    [anon_sym_LBRACK_CARET] = ACTIONS(2595),
    [anon_sym_BANG_LBRACK] = ACTIONS(2595),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2595),
    [anon_sym_DOLLAR] = ACTIONS(2595),
    [anon_sym_TODO] = ACTIONS(2595),
    [anon_sym_WIP] = ACTIONS(2595),
    [anon_sym_NOTE] = ACTIONS(2595),
    [anon_sym_INFO] = ACTIONS(2595),
    [anon_sym_XXX] = ACTIONS(2595),
    [sym_fixme] = ACTIONS(2595),
    [aux_sym__text_token1] = ACTIONS(2593),
    [sym__block_close] = ACTIONS(2595),
    [sym__newline] = ACTIONS(2595),
    [sym__newline_inline] = ACTIONS(2595),
    [sym_hard_line_break] = ACTIONS(2595),
    [sym__heading_begin] = ACTIONS(2595),
    [sym__div_begin] = ACTIONS(2595),
    [sym__code_block_begin] = ACTIONS(2595),
    [sym_list_marker_dash] = ACTIONS(2595),
    [sym_list_marker_star] = ACTIONS(2595),
    [sym_list_marker_plus] = ACTIONS(2595),
    [sym__list_marker_task_begin] = ACTIONS(2595),
    [sym_list_marker_definition] = ACTIONS(2595),
    [sym_list_marker_decimal_period] = ACTIONS(2595),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2595),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2595),
    [sym_list_marker_lower_roman_period] = ACTIONS(2595),
    [sym_list_marker_upper_roman_period] = ACTIONS(2595),
    [sym_list_marker_decimal_paren] = ACTIONS(2595),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2595),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2595),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2595),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2595),
    [sym_list_marker_decimal_parens] = ACTIONS(2595),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2595),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2595),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2595),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2595),
    [sym__block_quote_begin] = ACTIONS(2595),
    [sym__block_quote_continuation] = ACTIONS(2595),
    [sym__thematic_break_dash] = ACTIONS(2595),
    [sym__thematic_break_star] = ACTIONS(2595),
    [sym__footnote_mark_begin] = ACTIONS(2595),
    [sym__link_ref_def_mark_begin] = ACTIONS(2595),
    [sym__table_header_begin] = ACTIONS(2595),
    [sym__table_separator_begin] = ACTIONS(2595),
    [sym__table_row_begin] = ACTIONS(2595),
    [sym__block_attribute_begin] = ACTIONS(2595),
    [sym__verbatim_begin] = ACTIONS(2595),
  },
  [363] = {
    [ts_builtin_sym_end] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [sym__whitespace1] = ACTIONS(2597),
    [sym_quotation_marks] = ACTIONS(2597),
    [sym_ellipsis] = ACTIONS(2597),
    [sym_em_dash] = ACTIONS(2597),
    [sym_en_dash] = ACTIONS(2599),
    [sym_backslash_escape] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(2597),
    [sym_symbol] = ACTIONS(2597),
    [anon_sym_LBRACE_] = ACTIONS(2597),
    [anon_sym__] = ACTIONS(2597),
    [anon_sym_LBRACE_STAR] = ACTIONS(2597),
    [anon_sym_STAR] = ACTIONS(2597),
    [anon_sym_LBRACE_CARET] = ACTIONS(2597),
    [anon_sym_CARET] = ACTIONS(2597),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2597),
    [anon_sym_TILDE] = ACTIONS(2597),
    [anon_sym_LBRACE_EQ] = ACTIONS(2597),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2597),
    [anon_sym_LBRACE_DASH] = ACTIONS(2597),
    [anon_sym_LBRACK_CARET] = ACTIONS(2597),
    [anon_sym_BANG_LBRACK] = ACTIONS(2597),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2597),
    [anon_sym_LPAREN] = ACTIONS(2597),
    [anon_sym_DOLLAR] = ACTIONS(2597),
    [anon_sym_TODO] = ACTIONS(2597),
    [anon_sym_WIP] = ACTIONS(2597),
    [anon_sym_NOTE] = ACTIONS(2597),
    [anon_sym_INFO] = ACTIONS(2597),
    [anon_sym_XXX] = ACTIONS(2597),
    [sym_fixme] = ACTIONS(2597),
    [aux_sym__text_token1] = ACTIONS(2599),
    [sym__newline] = ACTIONS(2597),
    [sym__newline_inline] = ACTIONS(2597),
    [sym_hard_line_break] = ACTIONS(2597),
    [sym__heading_begin] = ACTIONS(2597),
    [sym__div_begin] = ACTIONS(2597),
    [sym__code_block_begin] = ACTIONS(2597),
    [sym_list_marker_dash] = ACTIONS(2597),
    [sym_list_marker_star] = ACTIONS(2597),
    [sym_list_marker_plus] = ACTIONS(2597),
    [sym__list_marker_task_begin] = ACTIONS(2597),
    [sym_list_marker_definition] = ACTIONS(2597),
    [sym_list_marker_decimal_period] = ACTIONS(2597),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2597),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2597),
    [sym_list_marker_lower_roman_period] = ACTIONS(2597),
    [sym_list_marker_upper_roman_period] = ACTIONS(2597),
    [sym_list_marker_decimal_paren] = ACTIONS(2597),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2597),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2597),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2597),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2597),
    [sym_list_marker_decimal_parens] = ACTIONS(2597),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2597),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2597),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2597),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2597),
    [sym__block_quote_begin] = ACTIONS(2597),
    [sym__block_quote_continuation] = ACTIONS(2597),
    [sym__thematic_break_dash] = ACTIONS(2597),
    [sym__thematic_break_star] = ACTIONS(2597),
    [sym__footnote_mark_begin] = ACTIONS(2597),
    [sym__link_ref_def_mark_begin] = ACTIONS(2597),
    [sym__table_header_begin] = ACTIONS(2597),
    [sym__table_separator_begin] = ACTIONS(2597),
    [sym__table_row_begin] = ACTIONS(2597),
    [sym__block_attribute_begin] = ACTIONS(2597),
    [sym__verbatim_begin] = ACTIONS(2597),
  },
  [364] = {
    [ts_builtin_sym_end] = ACTIONS(2587),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [sym__whitespace1] = ACTIONS(2587),
    [sym_quotation_marks] = ACTIONS(2587),
    [sym_ellipsis] = ACTIONS(2587),
    [sym_em_dash] = ACTIONS(2587),
    [sym_en_dash] = ACTIONS(2585),
    [sym_backslash_escape] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2587),
    [sym_symbol] = ACTIONS(2587),
    [anon_sym_LBRACE_] = ACTIONS(2587),
    [anon_sym__] = ACTIONS(2587),
    [anon_sym_LBRACE_STAR] = ACTIONS(2587),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_LBRACE_CARET] = ACTIONS(2587),
    [anon_sym_CARET] = ACTIONS(2587),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [anon_sym_LBRACE_EQ] = ACTIONS(2587),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2587),
    [anon_sym_LBRACE_DASH] = ACTIONS(2587),
    [anon_sym_LBRACK_CARET] = ACTIONS(2587),
    [anon_sym_BANG_LBRACK] = ACTIONS(2587),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2587),
    [anon_sym_LPAREN] = ACTIONS(2587),
    [anon_sym_DOLLAR] = ACTIONS(2587),
    [anon_sym_TODO] = ACTIONS(2587),
    [anon_sym_WIP] = ACTIONS(2587),
    [anon_sym_NOTE] = ACTIONS(2587),
    [anon_sym_INFO] = ACTIONS(2587),
    [anon_sym_XXX] = ACTIONS(2587),
    [sym_fixme] = ACTIONS(2587),
    [aux_sym__text_token1] = ACTIONS(2585),
    [sym__newline] = ACTIONS(2587),
    [sym__newline_inline] = ACTIONS(2587),
    [sym_hard_line_break] = ACTIONS(2587),
    [sym__heading_begin] = ACTIONS(2587),
    [sym__div_begin] = ACTIONS(2587),
    [sym__code_block_begin] = ACTIONS(2587),
    [sym_list_marker_dash] = ACTIONS(2587),
    [sym_list_marker_star] = ACTIONS(2587),
    [sym_list_marker_plus] = ACTIONS(2587),
    [sym__list_marker_task_begin] = ACTIONS(2587),
    [sym_list_marker_definition] = ACTIONS(2587),
    [sym_list_marker_decimal_period] = ACTIONS(2587),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2587),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2587),
    [sym_list_marker_lower_roman_period] = ACTIONS(2587),
    [sym_list_marker_upper_roman_period] = ACTIONS(2587),
    [sym_list_marker_decimal_paren] = ACTIONS(2587),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2587),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2587),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2587),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2587),
    [sym_list_marker_decimal_parens] = ACTIONS(2587),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2587),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2587),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2587),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2587),
    [sym__block_quote_begin] = ACTIONS(2587),
    [sym__block_quote_continuation] = ACTIONS(2587),
    [sym__thematic_break_dash] = ACTIONS(2587),
    [sym__thematic_break_star] = ACTIONS(2587),
    [sym__footnote_mark_begin] = ACTIONS(2587),
    [sym__link_ref_def_mark_begin] = ACTIONS(2587),
    [sym__table_header_begin] = ACTIONS(2587),
    [sym__table_separator_begin] = ACTIONS(2587),
    [sym__table_row_begin] = ACTIONS(2587),
    [sym__block_attribute_begin] = ACTIONS(2587),
    [sym__verbatim_begin] = ACTIONS(2587),
  },
  [365] = {
    [ts_builtin_sym_end] = ACTIONS(2595),
    [anon_sym_LBRACK] = ACTIONS(2593),
    [sym__whitespace1] = ACTIONS(2595),
    [sym_quotation_marks] = ACTIONS(2595),
    [sym_ellipsis] = ACTIONS(2595),
    [sym_em_dash] = ACTIONS(2595),
    [sym_en_dash] = ACTIONS(2593),
    [sym_backslash_escape] = ACTIONS(2593),
    [anon_sym_LT] = ACTIONS(2595),
    [sym_symbol] = ACTIONS(2595),
    [anon_sym_LBRACE_] = ACTIONS(2595),
    [anon_sym__] = ACTIONS(2595),
    [anon_sym_LBRACE_STAR] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(2595),
    [anon_sym_LBRACE_CARET] = ACTIONS(2595),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2595),
    [anon_sym_TILDE] = ACTIONS(2595),
    [anon_sym_LBRACE_EQ] = ACTIONS(2595),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2595),
    [anon_sym_LBRACE_DASH] = ACTIONS(2595),
    [anon_sym_LBRACK_CARET] = ACTIONS(2595),
    [anon_sym_BANG_LBRACK] = ACTIONS(2595),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2595),
    [anon_sym_DOLLAR] = ACTIONS(2595),
    [anon_sym_TODO] = ACTIONS(2595),
    [anon_sym_WIP] = ACTIONS(2595),
    [anon_sym_NOTE] = ACTIONS(2595),
    [anon_sym_INFO] = ACTIONS(2595),
    [anon_sym_XXX] = ACTIONS(2595),
    [sym_fixme] = ACTIONS(2595),
    [aux_sym__text_token1] = ACTIONS(2593),
    [sym__newline] = ACTIONS(2595),
    [sym__newline_inline] = ACTIONS(2595),
    [sym_hard_line_break] = ACTIONS(2595),
    [sym__heading_begin] = ACTIONS(2595),
    [sym__div_begin] = ACTIONS(2595),
    [sym__code_block_begin] = ACTIONS(2595),
    [sym_list_marker_dash] = ACTIONS(2595),
    [sym_list_marker_star] = ACTIONS(2595),
    [sym_list_marker_plus] = ACTIONS(2595),
    [sym__list_marker_task_begin] = ACTIONS(2595),
    [sym_list_marker_definition] = ACTIONS(2595),
    [sym_list_marker_decimal_period] = ACTIONS(2595),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2595),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2595),
    [sym_list_marker_lower_roman_period] = ACTIONS(2595),
    [sym_list_marker_upper_roman_period] = ACTIONS(2595),
    [sym_list_marker_decimal_paren] = ACTIONS(2595),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2595),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2595),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2595),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2595),
    [sym_list_marker_decimal_parens] = ACTIONS(2595),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2595),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2595),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2595),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2595),
    [sym__block_quote_begin] = ACTIONS(2595),
    [sym__block_quote_continuation] = ACTIONS(2595),
    [sym__thematic_break_dash] = ACTIONS(2595),
    [sym__thematic_break_star] = ACTIONS(2595),
    [sym__footnote_mark_begin] = ACTIONS(2595),
    [sym__link_ref_def_mark_begin] = ACTIONS(2595),
    [sym__table_header_begin] = ACTIONS(2595),
    [sym__table_separator_begin] = ACTIONS(2595),
    [sym__table_row_begin] = ACTIONS(2595),
    [sym__block_attribute_begin] = ACTIONS(2595),
    [sym__verbatim_begin] = ACTIONS(2595),
  },
  [366] = {
    [ts_builtin_sym_end] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2603),
    [sym__whitespace1] = ACTIONS(2601),
    [sym_quotation_marks] = ACTIONS(2601),
    [sym_ellipsis] = ACTIONS(2601),
    [sym_em_dash] = ACTIONS(2601),
    [sym_en_dash] = ACTIONS(2603),
    [sym_backslash_escape] = ACTIONS(2603),
    [anon_sym_LT] = ACTIONS(2601),
    [sym_symbol] = ACTIONS(2601),
    [anon_sym_LBRACE_] = ACTIONS(2601),
    [anon_sym__] = ACTIONS(2601),
    [anon_sym_LBRACE_STAR] = ACTIONS(2601),
    [anon_sym_STAR] = ACTIONS(2601),
    [anon_sym_LBRACE_CARET] = ACTIONS(2601),
    [anon_sym_CARET] = ACTIONS(2601),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2601),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_LBRACE_EQ] = ACTIONS(2601),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2601),
    [anon_sym_LBRACE_DASH] = ACTIONS(2601),
    [anon_sym_LBRACK_CARET] = ACTIONS(2601),
    [anon_sym_BANG_LBRACK] = ACTIONS(2601),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2601),
    [anon_sym_LPAREN] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2601),
    [anon_sym_TODO] = ACTIONS(2601),
    [anon_sym_WIP] = ACTIONS(2601),
    [anon_sym_NOTE] = ACTIONS(2601),
    [anon_sym_INFO] = ACTIONS(2601),
    [anon_sym_XXX] = ACTIONS(2601),
    [sym_fixme] = ACTIONS(2601),
    [aux_sym__text_token1] = ACTIONS(2603),
    [sym__newline] = ACTIONS(2601),
    [sym__newline_inline] = ACTIONS(2601),
    [sym_hard_line_break] = ACTIONS(2601),
    [sym__heading_begin] = ACTIONS(2601),
    [sym__div_begin] = ACTIONS(2601),
    [sym__code_block_begin] = ACTIONS(2601),
    [sym_list_marker_dash] = ACTIONS(2601),
    [sym_list_marker_star] = ACTIONS(2601),
    [sym_list_marker_plus] = ACTIONS(2601),
    [sym__list_marker_task_begin] = ACTIONS(2601),
    [sym_list_marker_definition] = ACTIONS(2601),
    [sym_list_marker_decimal_period] = ACTIONS(2601),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2601),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2601),
    [sym_list_marker_lower_roman_period] = ACTIONS(2601),
    [sym_list_marker_upper_roman_period] = ACTIONS(2601),
    [sym_list_marker_decimal_paren] = ACTIONS(2601),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2601),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2601),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2601),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2601),
    [sym_list_marker_decimal_parens] = ACTIONS(2601),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2601),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2601),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2601),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2601),
    [sym__block_quote_begin] = ACTIONS(2601),
    [sym__block_quote_continuation] = ACTIONS(2601),
    [sym__thematic_break_dash] = ACTIONS(2601),
    [sym__thematic_break_star] = ACTIONS(2601),
    [sym__footnote_mark_begin] = ACTIONS(2601),
    [sym__link_ref_def_mark_begin] = ACTIONS(2601),
    [sym__table_header_begin] = ACTIONS(2601),
    [sym__table_separator_begin] = ACTIONS(2601),
    [sym__table_row_begin] = ACTIONS(2601),
    [sym__block_attribute_begin] = ACTIONS(2601),
    [sym__verbatim_begin] = ACTIONS(2601),
  },
  [367] = {
    [ts_builtin_sym_end] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(2607),
    [sym__whitespace1] = ACTIONS(2605),
    [sym_quotation_marks] = ACTIONS(2605),
    [sym_ellipsis] = ACTIONS(2605),
    [sym_em_dash] = ACTIONS(2605),
    [sym_en_dash] = ACTIONS(2607),
    [sym_backslash_escape] = ACTIONS(2607),
    [anon_sym_LT] = ACTIONS(2605),
    [sym_symbol] = ACTIONS(2605),
    [anon_sym_LBRACE_] = ACTIONS(2605),
    [anon_sym__] = ACTIONS(2605),
    [anon_sym_LBRACE_STAR] = ACTIONS(2605),
    [anon_sym_STAR] = ACTIONS(2605),
    [anon_sym_LBRACE_CARET] = ACTIONS(2605),
    [anon_sym_CARET] = ACTIONS(2605),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2605),
    [anon_sym_TILDE] = ACTIONS(2605),
    [anon_sym_LBRACE_EQ] = ACTIONS(2605),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2605),
    [anon_sym_LBRACE_DASH] = ACTIONS(2605),
    [anon_sym_LBRACK_CARET] = ACTIONS(2605),
    [anon_sym_BANG_LBRACK] = ACTIONS(2605),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2605),
    [anon_sym_LPAREN] = ACTIONS(2605),
    [anon_sym_DOLLAR] = ACTIONS(2605),
    [anon_sym_TODO] = ACTIONS(2605),
    [anon_sym_WIP] = ACTIONS(2605),
    [anon_sym_NOTE] = ACTIONS(2605),
    [anon_sym_INFO] = ACTIONS(2605),
    [anon_sym_XXX] = ACTIONS(2605),
    [sym_fixme] = ACTIONS(2605),
    [aux_sym__text_token1] = ACTIONS(2607),
    [sym__newline] = ACTIONS(2605),
    [sym__newline_inline] = ACTIONS(2605),
    [sym_hard_line_break] = ACTIONS(2605),
    [sym__heading_begin] = ACTIONS(2605),
    [sym__div_begin] = ACTIONS(2605),
    [sym__code_block_begin] = ACTIONS(2605),
    [sym_list_marker_dash] = ACTIONS(2605),
    [sym_list_marker_star] = ACTIONS(2605),
    [sym_list_marker_plus] = ACTIONS(2605),
    [sym__list_marker_task_begin] = ACTIONS(2605),
    [sym_list_marker_definition] = ACTIONS(2605),
    [sym_list_marker_decimal_period] = ACTIONS(2605),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2605),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2605),
    [sym_list_marker_lower_roman_period] = ACTIONS(2605),
    [sym_list_marker_upper_roman_period] = ACTIONS(2605),
    [sym_list_marker_decimal_paren] = ACTIONS(2605),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2605),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2605),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2605),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2605),
    [sym_list_marker_decimal_parens] = ACTIONS(2605),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2605),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2605),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2605),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2605),
    [sym__block_quote_begin] = ACTIONS(2605),
    [sym__block_quote_continuation] = ACTIONS(2605),
    [sym__thematic_break_dash] = ACTIONS(2605),
    [sym__thematic_break_star] = ACTIONS(2605),
    [sym__footnote_mark_begin] = ACTIONS(2605),
    [sym__link_ref_def_mark_begin] = ACTIONS(2605),
    [sym__table_header_begin] = ACTIONS(2605),
    [sym__table_separator_begin] = ACTIONS(2605),
    [sym__table_row_begin] = ACTIONS(2605),
    [sym__block_attribute_begin] = ACTIONS(2605),
    [sym__verbatim_begin] = ACTIONS(2605),
  },
  [368] = {
    [anon_sym_LBRACK] = ACTIONS(2475),
    [sym__whitespace1] = ACTIONS(2473),
    [sym_quotation_marks] = ACTIONS(2473),
    [sym_ellipsis] = ACTIONS(2473),
    [sym_em_dash] = ACTIONS(2473),
    [sym_en_dash] = ACTIONS(2475),
    [sym_backslash_escape] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(2473),
    [sym_symbol] = ACTIONS(2473),
    [anon_sym_LBRACE_] = ACTIONS(2473),
    [anon_sym__] = ACTIONS(2473),
    [anon_sym_LBRACE_STAR] = ACTIONS(2473),
    [anon_sym_STAR] = ACTIONS(2473),
    [anon_sym_LBRACE_CARET] = ACTIONS(2473),
    [anon_sym_CARET] = ACTIONS(2473),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [anon_sym_LBRACE_EQ] = ACTIONS(2473),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2473),
    [anon_sym_LBRACE_DASH] = ACTIONS(2473),
    [anon_sym_LBRACK_CARET] = ACTIONS(2473),
    [anon_sym_BANG_LBRACK] = ACTIONS(2473),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2473),
    [anon_sym_DOLLAR] = ACTIONS(2473),
    [anon_sym_TODO] = ACTIONS(2473),
    [anon_sym_WIP] = ACTIONS(2473),
    [anon_sym_NOTE] = ACTIONS(2473),
    [anon_sym_INFO] = ACTIONS(2473),
    [anon_sym_XXX] = ACTIONS(2473),
    [sym_fixme] = ACTIONS(2473),
    [aux_sym__text_token1] = ACTIONS(2475),
    [sym__block_close] = ACTIONS(2473),
    [sym__newline] = ACTIONS(2473),
    [sym__newline_inline] = ACTIONS(2473),
    [sym_hard_line_break] = ACTIONS(2473),
    [sym__heading_begin] = ACTIONS(2473),
    [sym__div_begin] = ACTIONS(2473),
    [sym__code_block_begin] = ACTIONS(2473),
    [sym_list_marker_dash] = ACTIONS(2473),
    [sym_list_marker_star] = ACTIONS(2473),
    [sym_list_marker_plus] = ACTIONS(2473),
    [sym__list_marker_task_begin] = ACTIONS(2473),
    [sym_list_marker_definition] = ACTIONS(2473),
    [sym_list_marker_decimal_period] = ACTIONS(2473),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2473),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2473),
    [sym_list_marker_lower_roman_period] = ACTIONS(2473),
    [sym_list_marker_upper_roman_period] = ACTIONS(2473),
    [sym_list_marker_decimal_paren] = ACTIONS(2473),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2473),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2473),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2473),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2473),
    [sym_list_marker_decimal_parens] = ACTIONS(2473),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2473),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2473),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2473),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2473),
    [sym__block_quote_begin] = ACTIONS(2473),
    [sym__block_quote_continuation] = ACTIONS(2473),
    [sym__thematic_break_dash] = ACTIONS(2473),
    [sym__thematic_break_star] = ACTIONS(2473),
    [sym__footnote_mark_begin] = ACTIONS(2473),
    [sym__link_ref_def_mark_begin] = ACTIONS(2473),
    [sym__table_header_begin] = ACTIONS(2473),
    [sym__table_separator_begin] = ACTIONS(2473),
    [sym__table_row_begin] = ACTIONS(2473),
    [sym__block_attribute_begin] = ACTIONS(2473),
    [sym__verbatim_begin] = ACTIONS(2473),
  },
  [369] = {
    [anon_sym_LBRACK] = ACTIONS(2475),
    [sym__whitespace1] = ACTIONS(2473),
    [sym_quotation_marks] = ACTIONS(2473),
    [sym_ellipsis] = ACTIONS(2473),
    [sym_em_dash] = ACTIONS(2473),
    [sym_en_dash] = ACTIONS(2475),
    [sym_backslash_escape] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(2473),
    [sym_symbol] = ACTIONS(2473),
    [anon_sym_LBRACE_] = ACTIONS(2473),
    [anon_sym__] = ACTIONS(2473),
    [anon_sym_LBRACE_STAR] = ACTIONS(2473),
    [anon_sym_STAR] = ACTIONS(2473),
    [anon_sym_LBRACE_CARET] = ACTIONS(2473),
    [anon_sym_CARET] = ACTIONS(2473),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [anon_sym_LBRACE_EQ] = ACTIONS(2473),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2473),
    [anon_sym_LBRACE_DASH] = ACTIONS(2473),
    [anon_sym_LBRACK_CARET] = ACTIONS(2473),
    [anon_sym_BANG_LBRACK] = ACTIONS(2473),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2473),
    [anon_sym_LPAREN] = ACTIONS(2473),
    [anon_sym_DOLLAR] = ACTIONS(2473),
    [anon_sym_TODO] = ACTIONS(2473),
    [anon_sym_WIP] = ACTIONS(2473),
    [anon_sym_NOTE] = ACTIONS(2473),
    [anon_sym_INFO] = ACTIONS(2473),
    [anon_sym_XXX] = ACTIONS(2473),
    [sym_fixme] = ACTIONS(2473),
    [aux_sym__text_token1] = ACTIONS(2475),
    [sym__block_close] = ACTIONS(2473),
    [sym__newline] = ACTIONS(2473),
    [sym__newline_inline] = ACTIONS(2473),
    [sym_hard_line_break] = ACTIONS(2473),
    [sym__heading_begin] = ACTIONS(2473),
    [sym__div_begin] = ACTIONS(2473),
    [sym__code_block_begin] = ACTIONS(2473),
    [sym_list_marker_dash] = ACTIONS(2473),
    [sym_list_marker_star] = ACTIONS(2473),
    [sym_list_marker_plus] = ACTIONS(2473),
    [sym__list_marker_task_begin] = ACTIONS(2473),
    [sym_list_marker_definition] = ACTIONS(2473),
    [sym_list_marker_decimal_period] = ACTIONS(2473),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2473),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2473),
    [sym_list_marker_lower_roman_period] = ACTIONS(2473),
    [sym_list_marker_upper_roman_period] = ACTIONS(2473),
    [sym_list_marker_decimal_paren] = ACTIONS(2473),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2473),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2473),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2473),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2473),
    [sym_list_marker_decimal_parens] = ACTIONS(2473),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2473),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2473),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2473),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2473),
    [sym__block_quote_begin] = ACTIONS(2473),
    [sym__block_quote_continuation] = ACTIONS(2473),
    [sym__thematic_break_dash] = ACTIONS(2473),
    [sym__thematic_break_star] = ACTIONS(2473),
    [sym__footnote_mark_begin] = ACTIONS(2473),
    [sym__link_ref_def_mark_begin] = ACTIONS(2473),
    [sym__table_header_begin] = ACTIONS(2473),
    [sym__table_separator_begin] = ACTIONS(2473),
    [sym__table_row_begin] = ACTIONS(2473),
    [sym__block_attribute_begin] = ACTIONS(2473),
    [sym__verbatim_begin] = ACTIONS(2473),
  },
  [370] = {
    [anon_sym_LBRACK] = ACTIONS(2491),
    [sym__whitespace1] = ACTIONS(2489),
    [sym_quotation_marks] = ACTIONS(2489),
    [sym_ellipsis] = ACTIONS(2489),
    [sym_em_dash] = ACTIONS(2489),
    [sym_en_dash] = ACTIONS(2491),
    [sym_backslash_escape] = ACTIONS(2491),
    [anon_sym_LT] = ACTIONS(2489),
    [sym_symbol] = ACTIONS(2489),
    [anon_sym_LBRACE_] = ACTIONS(2489),
    [anon_sym__] = ACTIONS(2489),
    [anon_sym_LBRACE_STAR] = ACTIONS(2489),
    [anon_sym_STAR] = ACTIONS(2489),
    [anon_sym_LBRACE_CARET] = ACTIONS(2489),
    [anon_sym_CARET] = ACTIONS(2489),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2489),
    [anon_sym_TILDE] = ACTIONS(2489),
    [anon_sym_LBRACE_EQ] = ACTIONS(2489),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2489),
    [anon_sym_LBRACE_DASH] = ACTIONS(2489),
    [anon_sym_LBRACK_CARET] = ACTIONS(2489),
    [anon_sym_BANG_LBRACK] = ACTIONS(2489),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2489),
    [anon_sym_LPAREN] = ACTIONS(2489),
    [anon_sym_DOLLAR] = ACTIONS(2489),
    [anon_sym_TODO] = ACTIONS(2489),
    [anon_sym_WIP] = ACTIONS(2489),
    [anon_sym_NOTE] = ACTIONS(2489),
    [anon_sym_INFO] = ACTIONS(2489),
    [anon_sym_XXX] = ACTIONS(2489),
    [sym_fixme] = ACTIONS(2489),
    [aux_sym__text_token1] = ACTIONS(2491),
    [sym__block_close] = ACTIONS(2489),
    [sym__newline] = ACTIONS(2489),
    [sym__newline_inline] = ACTIONS(2489),
    [sym_hard_line_break] = ACTIONS(2489),
    [sym__heading_begin] = ACTIONS(2489),
    [sym__div_begin] = ACTIONS(2489),
    [sym__code_block_begin] = ACTIONS(2489),
    [sym_list_marker_dash] = ACTIONS(2489),
    [sym_list_marker_star] = ACTIONS(2489),
    [sym_list_marker_plus] = ACTIONS(2489),
    [sym__list_marker_task_begin] = ACTIONS(2489),
    [sym_list_marker_definition] = ACTIONS(2489),
    [sym_list_marker_decimal_period] = ACTIONS(2489),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2489),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2489),
    [sym_list_marker_lower_roman_period] = ACTIONS(2489),
    [sym_list_marker_upper_roman_period] = ACTIONS(2489),
    [sym_list_marker_decimal_paren] = ACTIONS(2489),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2489),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2489),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2489),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2489),
    [sym_list_marker_decimal_parens] = ACTIONS(2489),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2489),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2489),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2489),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2489),
    [sym__block_quote_begin] = ACTIONS(2489),
    [sym__block_quote_continuation] = ACTIONS(2489),
    [sym__thematic_break_dash] = ACTIONS(2489),
    [sym__thematic_break_star] = ACTIONS(2489),
    [sym__footnote_mark_begin] = ACTIONS(2489),
    [sym__link_ref_def_mark_begin] = ACTIONS(2489),
    [sym__table_header_begin] = ACTIONS(2489),
    [sym__table_separator_begin] = ACTIONS(2489),
    [sym__table_row_begin] = ACTIONS(2489),
    [sym__block_attribute_begin] = ACTIONS(2489),
    [sym__verbatim_begin] = ACTIONS(2489),
  },
  [371] = {
    [anon_sym_LBRACK] = ACTIONS(2495),
    [sym__whitespace1] = ACTIONS(2493),
    [sym_quotation_marks] = ACTIONS(2493),
    [sym_ellipsis] = ACTIONS(2493),
    [sym_em_dash] = ACTIONS(2493),
    [sym_en_dash] = ACTIONS(2495),
    [sym_backslash_escape] = ACTIONS(2495),
    [anon_sym_LT] = ACTIONS(2493),
    [sym_symbol] = ACTIONS(2493),
    [anon_sym_LBRACE_] = ACTIONS(2493),
    [anon_sym__] = ACTIONS(2493),
    [anon_sym_LBRACE_STAR] = ACTIONS(2493),
    [anon_sym_STAR] = ACTIONS(2493),
    [anon_sym_LBRACE_CARET] = ACTIONS(2493),
    [anon_sym_CARET] = ACTIONS(2493),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_LBRACE_EQ] = ACTIONS(2493),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2493),
    [anon_sym_LBRACE_DASH] = ACTIONS(2493),
    [anon_sym_LBRACK_CARET] = ACTIONS(2493),
    [anon_sym_BANG_LBRACK] = ACTIONS(2493),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2493),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_DOLLAR] = ACTIONS(2493),
    [anon_sym_TODO] = ACTIONS(2493),
    [anon_sym_WIP] = ACTIONS(2493),
    [anon_sym_NOTE] = ACTIONS(2493),
    [anon_sym_INFO] = ACTIONS(2493),
    [anon_sym_XXX] = ACTIONS(2493),
    [sym_fixme] = ACTIONS(2493),
    [aux_sym__text_token1] = ACTIONS(2495),
    [sym__block_close] = ACTIONS(2493),
    [sym__newline] = ACTIONS(2493),
    [sym__newline_inline] = ACTIONS(2493),
    [sym_hard_line_break] = ACTIONS(2493),
    [sym__heading_begin] = ACTIONS(2493),
    [sym__div_begin] = ACTIONS(2493),
    [sym__code_block_begin] = ACTIONS(2493),
    [sym_list_marker_dash] = ACTIONS(2493),
    [sym_list_marker_star] = ACTIONS(2493),
    [sym_list_marker_plus] = ACTIONS(2493),
    [sym__list_marker_task_begin] = ACTIONS(2493),
    [sym_list_marker_definition] = ACTIONS(2493),
    [sym_list_marker_decimal_period] = ACTIONS(2493),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2493),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2493),
    [sym_list_marker_lower_roman_period] = ACTIONS(2493),
    [sym_list_marker_upper_roman_period] = ACTIONS(2493),
    [sym_list_marker_decimal_paren] = ACTIONS(2493),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2493),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2493),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2493),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2493),
    [sym_list_marker_decimal_parens] = ACTIONS(2493),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2493),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2493),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2493),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2493),
    [sym__block_quote_begin] = ACTIONS(2493),
    [sym__block_quote_continuation] = ACTIONS(2493),
    [sym__thematic_break_dash] = ACTIONS(2493),
    [sym__thematic_break_star] = ACTIONS(2493),
    [sym__footnote_mark_begin] = ACTIONS(2493),
    [sym__link_ref_def_mark_begin] = ACTIONS(2493),
    [sym__table_header_begin] = ACTIONS(2493),
    [sym__table_separator_begin] = ACTIONS(2493),
    [sym__table_row_begin] = ACTIONS(2493),
    [sym__block_attribute_begin] = ACTIONS(2493),
    [sym__verbatim_begin] = ACTIONS(2493),
  },
  [372] = {
    [anon_sym_LBRACK] = ACTIONS(2499),
    [sym__whitespace1] = ACTIONS(2497),
    [sym_quotation_marks] = ACTIONS(2497),
    [sym_ellipsis] = ACTIONS(2497),
    [sym_em_dash] = ACTIONS(2497),
    [sym_en_dash] = ACTIONS(2499),
    [sym_backslash_escape] = ACTIONS(2499),
    [anon_sym_LT] = ACTIONS(2497),
    [sym_symbol] = ACTIONS(2497),
    [anon_sym_LBRACE_] = ACTIONS(2497),
    [anon_sym__] = ACTIONS(2497),
    [anon_sym_LBRACE_STAR] = ACTIONS(2497),
    [anon_sym_STAR] = ACTIONS(2497),
    [anon_sym_LBRACE_CARET] = ACTIONS(2497),
    [anon_sym_CARET] = ACTIONS(2497),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2497),
    [anon_sym_LBRACE_EQ] = ACTIONS(2497),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2497),
    [anon_sym_LBRACE_DASH] = ACTIONS(2497),
    [anon_sym_LBRACK_CARET] = ACTIONS(2497),
    [anon_sym_BANG_LBRACK] = ACTIONS(2497),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2497),
    [anon_sym_LPAREN] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2497),
    [anon_sym_TODO] = ACTIONS(2497),
    [anon_sym_WIP] = ACTIONS(2497),
    [anon_sym_NOTE] = ACTIONS(2497),
    [anon_sym_INFO] = ACTIONS(2497),
    [anon_sym_XXX] = ACTIONS(2497),
    [sym_fixme] = ACTIONS(2497),
    [aux_sym__text_token1] = ACTIONS(2499),
    [sym__block_close] = ACTIONS(2497),
    [sym__newline] = ACTIONS(2497),
    [sym__newline_inline] = ACTIONS(2497),
    [sym_hard_line_break] = ACTIONS(2497),
    [sym__heading_begin] = ACTIONS(2497),
    [sym__div_begin] = ACTIONS(2497),
    [sym__code_block_begin] = ACTIONS(2497),
    [sym_list_marker_dash] = ACTIONS(2497),
    [sym_list_marker_star] = ACTIONS(2497),
    [sym_list_marker_plus] = ACTIONS(2497),
    [sym__list_marker_task_begin] = ACTIONS(2497),
    [sym_list_marker_definition] = ACTIONS(2497),
    [sym_list_marker_decimal_period] = ACTIONS(2497),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2497),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2497),
    [sym_list_marker_lower_roman_period] = ACTIONS(2497),
    [sym_list_marker_upper_roman_period] = ACTIONS(2497),
    [sym_list_marker_decimal_paren] = ACTIONS(2497),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2497),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2497),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2497),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2497),
    [sym_list_marker_decimal_parens] = ACTIONS(2497),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2497),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2497),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2497),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2497),
    [sym__block_quote_begin] = ACTIONS(2497),
    [sym__block_quote_continuation] = ACTIONS(2497),
    [sym__thematic_break_dash] = ACTIONS(2497),
    [sym__thematic_break_star] = ACTIONS(2497),
    [sym__footnote_mark_begin] = ACTIONS(2497),
    [sym__link_ref_def_mark_begin] = ACTIONS(2497),
    [sym__table_header_begin] = ACTIONS(2497),
    [sym__table_separator_begin] = ACTIONS(2497),
    [sym__table_row_begin] = ACTIONS(2497),
    [sym__block_attribute_begin] = ACTIONS(2497),
    [sym__verbatim_begin] = ACTIONS(2497),
  },
  [373] = {
    [anon_sym_LBRACK] = ACTIONS(2507),
    [sym__whitespace1] = ACTIONS(2505),
    [sym_quotation_marks] = ACTIONS(2505),
    [sym_ellipsis] = ACTIONS(2505),
    [sym_em_dash] = ACTIONS(2505),
    [sym_en_dash] = ACTIONS(2507),
    [sym_backslash_escape] = ACTIONS(2507),
    [anon_sym_LT] = ACTIONS(2505),
    [sym_symbol] = ACTIONS(2505),
    [anon_sym_LBRACE_] = ACTIONS(2505),
    [anon_sym__] = ACTIONS(2505),
    [anon_sym_LBRACE_STAR] = ACTIONS(2505),
    [anon_sym_STAR] = ACTIONS(2505),
    [anon_sym_LBRACE_CARET] = ACTIONS(2505),
    [anon_sym_CARET] = ACTIONS(2505),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2505),
    [anon_sym_TILDE] = ACTIONS(2505),
    [anon_sym_LBRACE_EQ] = ACTIONS(2505),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2505),
    [anon_sym_LBRACE_DASH] = ACTIONS(2505),
    [anon_sym_LBRACK_CARET] = ACTIONS(2505),
    [anon_sym_BANG_LBRACK] = ACTIONS(2505),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2505),
    [anon_sym_LPAREN] = ACTIONS(2505),
    [anon_sym_DOLLAR] = ACTIONS(2505),
    [anon_sym_TODO] = ACTIONS(2505),
    [anon_sym_WIP] = ACTIONS(2505),
    [anon_sym_NOTE] = ACTIONS(2505),
    [anon_sym_INFO] = ACTIONS(2505),
    [anon_sym_XXX] = ACTIONS(2505),
    [sym_fixme] = ACTIONS(2505),
    [aux_sym__text_token1] = ACTIONS(2507),
    [sym__block_close] = ACTIONS(2505),
    [sym__newline] = ACTIONS(2505),
    [sym__newline_inline] = ACTIONS(2505),
    [sym_hard_line_break] = ACTIONS(2505),
    [sym__heading_begin] = ACTIONS(2505),
    [sym__div_begin] = ACTIONS(2505),
    [sym__code_block_begin] = ACTIONS(2505),
    [sym_list_marker_dash] = ACTIONS(2505),
    [sym_list_marker_star] = ACTIONS(2505),
    [sym_list_marker_plus] = ACTIONS(2505),
    [sym__list_marker_task_begin] = ACTIONS(2505),
    [sym_list_marker_definition] = ACTIONS(2505),
    [sym_list_marker_decimal_period] = ACTIONS(2505),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2505),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2505),
    [sym_list_marker_lower_roman_period] = ACTIONS(2505),
    [sym_list_marker_upper_roman_period] = ACTIONS(2505),
    [sym_list_marker_decimal_paren] = ACTIONS(2505),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2505),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2505),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2505),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2505),
    [sym_list_marker_decimal_parens] = ACTIONS(2505),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2505),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2505),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2505),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2505),
    [sym__block_quote_begin] = ACTIONS(2505),
    [sym__block_quote_continuation] = ACTIONS(2505),
    [sym__thematic_break_dash] = ACTIONS(2505),
    [sym__thematic_break_star] = ACTIONS(2505),
    [sym__footnote_mark_begin] = ACTIONS(2505),
    [sym__link_ref_def_mark_begin] = ACTIONS(2505),
    [sym__table_header_begin] = ACTIONS(2505),
    [sym__table_separator_begin] = ACTIONS(2505),
    [sym__table_row_begin] = ACTIONS(2505),
    [sym__block_attribute_begin] = ACTIONS(2505),
    [sym__verbatim_begin] = ACTIONS(2505),
  },
  [374] = {
    [ts_builtin_sym_end] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2611),
    [sym__whitespace1] = ACTIONS(2609),
    [sym_quotation_marks] = ACTIONS(2609),
    [sym_ellipsis] = ACTIONS(2609),
    [sym_em_dash] = ACTIONS(2609),
    [sym_en_dash] = ACTIONS(2611),
    [sym_backslash_escape] = ACTIONS(2611),
    [anon_sym_LT] = ACTIONS(2609),
    [sym_symbol] = ACTIONS(2609),
    [anon_sym_LBRACE_] = ACTIONS(2609),
    [anon_sym__] = ACTIONS(2609),
    [anon_sym_LBRACE_STAR] = ACTIONS(2609),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACE_CARET] = ACTIONS(2609),
    [anon_sym_CARET] = ACTIONS(2609),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2609),
    [anon_sym_TILDE] = ACTIONS(2609),
    [anon_sym_LBRACE_EQ] = ACTIONS(2609),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2609),
    [anon_sym_LBRACE_DASH] = ACTIONS(2609),
    [anon_sym_LBRACK_CARET] = ACTIONS(2609),
    [anon_sym_BANG_LBRACK] = ACTIONS(2609),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2609),
    [anon_sym_LPAREN] = ACTIONS(2609),
    [anon_sym_DOLLAR] = ACTIONS(2609),
    [anon_sym_TODO] = ACTIONS(2609),
    [anon_sym_WIP] = ACTIONS(2609),
    [anon_sym_NOTE] = ACTIONS(2609),
    [anon_sym_INFO] = ACTIONS(2609),
    [anon_sym_XXX] = ACTIONS(2609),
    [sym_fixme] = ACTIONS(2609),
    [aux_sym__text_token1] = ACTIONS(2611),
    [sym__newline] = ACTIONS(2609),
    [sym__newline_inline] = ACTIONS(2609),
    [sym_hard_line_break] = ACTIONS(2609),
    [sym__heading_begin] = ACTIONS(2609),
    [sym__div_begin] = ACTIONS(2609),
    [sym__code_block_begin] = ACTIONS(2609),
    [sym_list_marker_dash] = ACTIONS(2609),
    [sym_list_marker_star] = ACTIONS(2609),
    [sym_list_marker_plus] = ACTIONS(2609),
    [sym__list_marker_task_begin] = ACTIONS(2609),
    [sym_list_marker_definition] = ACTIONS(2609),
    [sym_list_marker_decimal_period] = ACTIONS(2609),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2609),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2609),
    [sym_list_marker_lower_roman_period] = ACTIONS(2609),
    [sym_list_marker_upper_roman_period] = ACTIONS(2609),
    [sym_list_marker_decimal_paren] = ACTIONS(2609),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2609),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2609),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2609),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2609),
    [sym_list_marker_decimal_parens] = ACTIONS(2609),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2609),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2609),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2609),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2609),
    [sym__block_quote_begin] = ACTIONS(2609),
    [sym__block_quote_continuation] = ACTIONS(2609),
    [sym__thematic_break_dash] = ACTIONS(2609),
    [sym__thematic_break_star] = ACTIONS(2609),
    [sym__footnote_mark_begin] = ACTIONS(2609),
    [sym__link_ref_def_mark_begin] = ACTIONS(2609),
    [sym__table_header_begin] = ACTIONS(2609),
    [sym__table_separator_begin] = ACTIONS(2609),
    [sym__table_row_begin] = ACTIONS(2609),
    [sym__block_attribute_begin] = ACTIONS(2609),
    [sym__verbatim_begin] = ACTIONS(2609),
  },
  [375] = {
    [anon_sym_LBRACK] = ACTIONS(2511),
    [sym__whitespace1] = ACTIONS(2509),
    [sym_quotation_marks] = ACTIONS(2509),
    [sym_ellipsis] = ACTIONS(2509),
    [sym_em_dash] = ACTIONS(2509),
    [sym_en_dash] = ACTIONS(2511),
    [sym_backslash_escape] = ACTIONS(2511),
    [anon_sym_LT] = ACTIONS(2509),
    [sym_symbol] = ACTIONS(2509),
    [anon_sym_LBRACE_] = ACTIONS(2509),
    [anon_sym__] = ACTIONS(2509),
    [anon_sym_LBRACE_STAR] = ACTIONS(2509),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_LBRACE_CARET] = ACTIONS(2509),
    [anon_sym_CARET] = ACTIONS(2509),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2509),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_LBRACE_EQ] = ACTIONS(2509),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2509),
    [anon_sym_LBRACE_DASH] = ACTIONS(2509),
    [anon_sym_LBRACK_CARET] = ACTIONS(2509),
    [anon_sym_BANG_LBRACK] = ACTIONS(2509),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2509),
    [anon_sym_LPAREN] = ACTIONS(2509),
    [anon_sym_DOLLAR] = ACTIONS(2509),
    [anon_sym_TODO] = ACTIONS(2509),
    [anon_sym_WIP] = ACTIONS(2509),
    [anon_sym_NOTE] = ACTIONS(2509),
    [anon_sym_INFO] = ACTIONS(2509),
    [anon_sym_XXX] = ACTIONS(2509),
    [sym_fixme] = ACTIONS(2509),
    [aux_sym__text_token1] = ACTIONS(2511),
    [sym__block_close] = ACTIONS(2509),
    [sym__newline] = ACTIONS(2509),
    [sym__newline_inline] = ACTIONS(2509),
    [sym_hard_line_break] = ACTIONS(2509),
    [sym__heading_begin] = ACTIONS(2509),
    [sym__div_begin] = ACTIONS(2509),
    [sym__code_block_begin] = ACTIONS(2509),
    [sym_list_marker_dash] = ACTIONS(2509),
    [sym_list_marker_star] = ACTIONS(2509),
    [sym_list_marker_plus] = ACTIONS(2509),
    [sym__list_marker_task_begin] = ACTIONS(2509),
    [sym_list_marker_definition] = ACTIONS(2509),
    [sym_list_marker_decimal_period] = ACTIONS(2509),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2509),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2509),
    [sym_list_marker_lower_roman_period] = ACTIONS(2509),
    [sym_list_marker_upper_roman_period] = ACTIONS(2509),
    [sym_list_marker_decimal_paren] = ACTIONS(2509),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2509),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2509),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2509),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2509),
    [sym_list_marker_decimal_parens] = ACTIONS(2509),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2509),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2509),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2509),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2509),
    [sym__block_quote_begin] = ACTIONS(2509),
    [sym__block_quote_continuation] = ACTIONS(2509),
    [sym__thematic_break_dash] = ACTIONS(2509),
    [sym__thematic_break_star] = ACTIONS(2509),
    [sym__footnote_mark_begin] = ACTIONS(2509),
    [sym__link_ref_def_mark_begin] = ACTIONS(2509),
    [sym__table_header_begin] = ACTIONS(2509),
    [sym__table_separator_begin] = ACTIONS(2509),
    [sym__table_row_begin] = ACTIONS(2509),
    [sym__block_attribute_begin] = ACTIONS(2509),
    [sym__verbatim_begin] = ACTIONS(2509),
  },
  [376] = {
    [anon_sym_LBRACK] = ACTIONS(2515),
    [sym__whitespace1] = ACTIONS(2513),
    [sym_quotation_marks] = ACTIONS(2513),
    [sym_ellipsis] = ACTIONS(2513),
    [sym_em_dash] = ACTIONS(2513),
    [sym_en_dash] = ACTIONS(2515),
    [sym_backslash_escape] = ACTIONS(2515),
    [anon_sym_LT] = ACTIONS(2513),
    [sym_symbol] = ACTIONS(2513),
    [anon_sym_LBRACE_] = ACTIONS(2513),
    [anon_sym__] = ACTIONS(2513),
    [anon_sym_LBRACE_STAR] = ACTIONS(2513),
    [anon_sym_STAR] = ACTIONS(2513),
    [anon_sym_LBRACE_CARET] = ACTIONS(2513),
    [anon_sym_CARET] = ACTIONS(2513),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2513),
    [anon_sym_TILDE] = ACTIONS(2513),
    [anon_sym_LBRACE_EQ] = ACTIONS(2513),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2513),
    [anon_sym_LBRACE_DASH] = ACTIONS(2513),
    [anon_sym_LBRACK_CARET] = ACTIONS(2513),
    [anon_sym_BANG_LBRACK] = ACTIONS(2513),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2513),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_DOLLAR] = ACTIONS(2513),
    [anon_sym_TODO] = ACTIONS(2513),
    [anon_sym_WIP] = ACTIONS(2513),
    [anon_sym_NOTE] = ACTIONS(2513),
    [anon_sym_INFO] = ACTIONS(2513),
    [anon_sym_XXX] = ACTIONS(2513),
    [sym_fixme] = ACTIONS(2513),
    [aux_sym__text_token1] = ACTIONS(2515),
    [sym__block_close] = ACTIONS(2513),
    [sym__newline] = ACTIONS(2513),
    [sym__newline_inline] = ACTIONS(2513),
    [sym_hard_line_break] = ACTIONS(2513),
    [sym__heading_begin] = ACTIONS(2513),
    [sym__div_begin] = ACTIONS(2513),
    [sym__code_block_begin] = ACTIONS(2513),
    [sym_list_marker_dash] = ACTIONS(2513),
    [sym_list_marker_star] = ACTIONS(2513),
    [sym_list_marker_plus] = ACTIONS(2513),
    [sym__list_marker_task_begin] = ACTIONS(2513),
    [sym_list_marker_definition] = ACTIONS(2513),
    [sym_list_marker_decimal_period] = ACTIONS(2513),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2513),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2513),
    [sym_list_marker_lower_roman_period] = ACTIONS(2513),
    [sym_list_marker_upper_roman_period] = ACTIONS(2513),
    [sym_list_marker_decimal_paren] = ACTIONS(2513),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2513),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2513),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2513),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2513),
    [sym_list_marker_decimal_parens] = ACTIONS(2513),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2513),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2513),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2513),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2513),
    [sym__block_quote_begin] = ACTIONS(2513),
    [sym__block_quote_continuation] = ACTIONS(2513),
    [sym__thematic_break_dash] = ACTIONS(2513),
    [sym__thematic_break_star] = ACTIONS(2513),
    [sym__footnote_mark_begin] = ACTIONS(2513),
    [sym__link_ref_def_mark_begin] = ACTIONS(2513),
    [sym__table_header_begin] = ACTIONS(2513),
    [sym__table_separator_begin] = ACTIONS(2513),
    [sym__table_row_begin] = ACTIONS(2513),
    [sym__block_attribute_begin] = ACTIONS(2513),
    [sym__verbatim_begin] = ACTIONS(2513),
  },
  [377] = {
    [anon_sym_LBRACK] = ACTIONS(2519),
    [sym__whitespace1] = ACTIONS(2517),
    [sym_quotation_marks] = ACTIONS(2517),
    [sym_ellipsis] = ACTIONS(2517),
    [sym_em_dash] = ACTIONS(2517),
    [sym_en_dash] = ACTIONS(2519),
    [sym_backslash_escape] = ACTIONS(2519),
    [anon_sym_LT] = ACTIONS(2517),
    [sym_symbol] = ACTIONS(2517),
    [anon_sym_LBRACE_] = ACTIONS(2517),
    [anon_sym__] = ACTIONS(2517),
    [anon_sym_LBRACE_STAR] = ACTIONS(2517),
    [anon_sym_STAR] = ACTIONS(2517),
    [anon_sym_LBRACE_CARET] = ACTIONS(2517),
    [anon_sym_CARET] = ACTIONS(2517),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2517),
    [anon_sym_TILDE] = ACTIONS(2517),
    [anon_sym_LBRACE_EQ] = ACTIONS(2517),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2517),
    [anon_sym_LBRACE_DASH] = ACTIONS(2517),
    [anon_sym_LBRACK_CARET] = ACTIONS(2517),
    [anon_sym_BANG_LBRACK] = ACTIONS(2517),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2517),
    [anon_sym_LPAREN] = ACTIONS(2517),
    [anon_sym_DOLLAR] = ACTIONS(2517),
    [anon_sym_TODO] = ACTIONS(2517),
    [anon_sym_WIP] = ACTIONS(2517),
    [anon_sym_NOTE] = ACTIONS(2517),
    [anon_sym_INFO] = ACTIONS(2517),
    [anon_sym_XXX] = ACTIONS(2517),
    [sym_fixme] = ACTIONS(2517),
    [aux_sym__text_token1] = ACTIONS(2519),
    [sym__block_close] = ACTIONS(2517),
    [sym__newline] = ACTIONS(2517),
    [sym__newline_inline] = ACTIONS(2517),
    [sym_hard_line_break] = ACTIONS(2517),
    [sym__heading_begin] = ACTIONS(2517),
    [sym__div_begin] = ACTIONS(2517),
    [sym__code_block_begin] = ACTIONS(2517),
    [sym_list_marker_dash] = ACTIONS(2517),
    [sym_list_marker_star] = ACTIONS(2517),
    [sym_list_marker_plus] = ACTIONS(2517),
    [sym__list_marker_task_begin] = ACTIONS(2517),
    [sym_list_marker_definition] = ACTIONS(2517),
    [sym_list_marker_decimal_period] = ACTIONS(2517),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2517),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2517),
    [sym_list_marker_lower_roman_period] = ACTIONS(2517),
    [sym_list_marker_upper_roman_period] = ACTIONS(2517),
    [sym_list_marker_decimal_paren] = ACTIONS(2517),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2517),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2517),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2517),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2517),
    [sym_list_marker_decimal_parens] = ACTIONS(2517),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2517),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2517),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2517),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2517),
    [sym__block_quote_begin] = ACTIONS(2517),
    [sym__block_quote_continuation] = ACTIONS(2517),
    [sym__thematic_break_dash] = ACTIONS(2517),
    [sym__thematic_break_star] = ACTIONS(2517),
    [sym__footnote_mark_begin] = ACTIONS(2517),
    [sym__link_ref_def_mark_begin] = ACTIONS(2517),
    [sym__table_header_begin] = ACTIONS(2517),
    [sym__table_separator_begin] = ACTIONS(2517),
    [sym__table_row_begin] = ACTIONS(2517),
    [sym__block_attribute_begin] = ACTIONS(2517),
    [sym__verbatim_begin] = ACTIONS(2517),
  },
  [378] = {
    [anon_sym_LBRACK] = ACTIONS(2523),
    [sym__whitespace1] = ACTIONS(2521),
    [sym_quotation_marks] = ACTIONS(2521),
    [sym_ellipsis] = ACTIONS(2521),
    [sym_em_dash] = ACTIONS(2521),
    [sym_en_dash] = ACTIONS(2523),
    [sym_backslash_escape] = ACTIONS(2523),
    [anon_sym_LT] = ACTIONS(2521),
    [sym_symbol] = ACTIONS(2521),
    [anon_sym_LBRACE_] = ACTIONS(2521),
    [anon_sym__] = ACTIONS(2521),
    [anon_sym_LBRACE_STAR] = ACTIONS(2521),
    [anon_sym_STAR] = ACTIONS(2521),
    [anon_sym_LBRACE_CARET] = ACTIONS(2521),
    [anon_sym_CARET] = ACTIONS(2521),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [anon_sym_LBRACE_EQ] = ACTIONS(2521),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2521),
    [anon_sym_LBRACE_DASH] = ACTIONS(2521),
    [anon_sym_LBRACK_CARET] = ACTIONS(2521),
    [anon_sym_BANG_LBRACK] = ACTIONS(2521),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2521),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_DOLLAR] = ACTIONS(2521),
    [anon_sym_TODO] = ACTIONS(2521),
    [anon_sym_WIP] = ACTIONS(2521),
    [anon_sym_NOTE] = ACTIONS(2521),
    [anon_sym_INFO] = ACTIONS(2521),
    [anon_sym_XXX] = ACTIONS(2521),
    [sym_fixme] = ACTIONS(2521),
    [aux_sym__text_token1] = ACTIONS(2523),
    [sym__block_close] = ACTIONS(2521),
    [sym__newline] = ACTIONS(2521),
    [sym__newline_inline] = ACTIONS(2521),
    [sym_hard_line_break] = ACTIONS(2521),
    [sym__heading_begin] = ACTIONS(2521),
    [sym__div_begin] = ACTIONS(2521),
    [sym__code_block_begin] = ACTIONS(2521),
    [sym_list_marker_dash] = ACTIONS(2521),
    [sym_list_marker_star] = ACTIONS(2521),
    [sym_list_marker_plus] = ACTIONS(2521),
    [sym__list_marker_task_begin] = ACTIONS(2521),
    [sym_list_marker_definition] = ACTIONS(2521),
    [sym_list_marker_decimal_period] = ACTIONS(2521),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2521),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2521),
    [sym_list_marker_lower_roman_period] = ACTIONS(2521),
    [sym_list_marker_upper_roman_period] = ACTIONS(2521),
    [sym_list_marker_decimal_paren] = ACTIONS(2521),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2521),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2521),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2521),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2521),
    [sym_list_marker_decimal_parens] = ACTIONS(2521),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2521),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2521),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2521),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2521),
    [sym__block_quote_begin] = ACTIONS(2521),
    [sym__block_quote_continuation] = ACTIONS(2521),
    [sym__thematic_break_dash] = ACTIONS(2521),
    [sym__thematic_break_star] = ACTIONS(2521),
    [sym__footnote_mark_begin] = ACTIONS(2521),
    [sym__link_ref_def_mark_begin] = ACTIONS(2521),
    [sym__table_header_begin] = ACTIONS(2521),
    [sym__table_separator_begin] = ACTIONS(2521),
    [sym__table_row_begin] = ACTIONS(2521),
    [sym__block_attribute_begin] = ACTIONS(2521),
    [sym__verbatim_begin] = ACTIONS(2521),
  },
  [379] = {
    [anon_sym_LBRACK] = ACTIONS(2527),
    [sym__whitespace1] = ACTIONS(2525),
    [sym_quotation_marks] = ACTIONS(2525),
    [sym_ellipsis] = ACTIONS(2525),
    [sym_em_dash] = ACTIONS(2525),
    [sym_en_dash] = ACTIONS(2527),
    [sym_backslash_escape] = ACTIONS(2527),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_symbol] = ACTIONS(2525),
    [anon_sym_LBRACE_] = ACTIONS(2525),
    [anon_sym__] = ACTIONS(2525),
    [anon_sym_LBRACE_STAR] = ACTIONS(2525),
    [anon_sym_STAR] = ACTIONS(2525),
    [anon_sym_LBRACE_CARET] = ACTIONS(2525),
    [anon_sym_CARET] = ACTIONS(2525),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2525),
    [anon_sym_TILDE] = ACTIONS(2525),
    [anon_sym_LBRACE_EQ] = ACTIONS(2525),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2525),
    [anon_sym_LBRACE_DASH] = ACTIONS(2525),
    [anon_sym_LBRACK_CARET] = ACTIONS(2525),
    [anon_sym_BANG_LBRACK] = ACTIONS(2525),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2525),
    [anon_sym_LPAREN] = ACTIONS(2525),
    [anon_sym_DOLLAR] = ACTIONS(2525),
    [anon_sym_TODO] = ACTIONS(2525),
    [anon_sym_WIP] = ACTIONS(2525),
    [anon_sym_NOTE] = ACTIONS(2525),
    [anon_sym_INFO] = ACTIONS(2525),
    [anon_sym_XXX] = ACTIONS(2525),
    [sym_fixme] = ACTIONS(2525),
    [aux_sym__text_token1] = ACTIONS(2527),
    [sym__block_close] = ACTIONS(2525),
    [sym__newline] = ACTIONS(2525),
    [sym__newline_inline] = ACTIONS(2525),
    [sym_hard_line_break] = ACTIONS(2525),
    [sym__heading_begin] = ACTIONS(2525),
    [sym__div_begin] = ACTIONS(2525),
    [sym__code_block_begin] = ACTIONS(2525),
    [sym_list_marker_dash] = ACTIONS(2525),
    [sym_list_marker_star] = ACTIONS(2525),
    [sym_list_marker_plus] = ACTIONS(2525),
    [sym__list_marker_task_begin] = ACTIONS(2525),
    [sym_list_marker_definition] = ACTIONS(2525),
    [sym_list_marker_decimal_period] = ACTIONS(2525),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2525),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2525),
    [sym_list_marker_lower_roman_period] = ACTIONS(2525),
    [sym_list_marker_upper_roman_period] = ACTIONS(2525),
    [sym_list_marker_decimal_paren] = ACTIONS(2525),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2525),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2525),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2525),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2525),
    [sym_list_marker_decimal_parens] = ACTIONS(2525),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2525),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2525),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2525),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2525),
    [sym__block_quote_begin] = ACTIONS(2525),
    [sym__block_quote_continuation] = ACTIONS(2525),
    [sym__thematic_break_dash] = ACTIONS(2525),
    [sym__thematic_break_star] = ACTIONS(2525),
    [sym__footnote_mark_begin] = ACTIONS(2525),
    [sym__link_ref_def_mark_begin] = ACTIONS(2525),
    [sym__table_header_begin] = ACTIONS(2525),
    [sym__table_separator_begin] = ACTIONS(2525),
    [sym__table_row_begin] = ACTIONS(2525),
    [sym__block_attribute_begin] = ACTIONS(2525),
    [sym__verbatim_begin] = ACTIONS(2525),
  },
  [380] = {
    [anon_sym_LBRACK] = ACTIONS(2531),
    [sym__whitespace1] = ACTIONS(2529),
    [sym_quotation_marks] = ACTIONS(2529),
    [sym_ellipsis] = ACTIONS(2529),
    [sym_em_dash] = ACTIONS(2529),
    [sym_en_dash] = ACTIONS(2531),
    [sym_backslash_escape] = ACTIONS(2531),
    [anon_sym_LT] = ACTIONS(2529),
    [sym_symbol] = ACTIONS(2529),
    [anon_sym_LBRACE_] = ACTIONS(2529),
    [anon_sym__] = ACTIONS(2529),
    [anon_sym_LBRACE_STAR] = ACTIONS(2529),
    [anon_sym_STAR] = ACTIONS(2529),
    [anon_sym_LBRACE_CARET] = ACTIONS(2529),
    [anon_sym_CARET] = ACTIONS(2529),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2529),
    [anon_sym_TILDE] = ACTIONS(2529),
    [anon_sym_LBRACE_EQ] = ACTIONS(2529),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2529),
    [anon_sym_LBRACE_DASH] = ACTIONS(2529),
    [anon_sym_LBRACK_CARET] = ACTIONS(2529),
    [anon_sym_BANG_LBRACK] = ACTIONS(2529),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2529),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_DOLLAR] = ACTIONS(2529),
    [anon_sym_TODO] = ACTIONS(2529),
    [anon_sym_WIP] = ACTIONS(2529),
    [anon_sym_NOTE] = ACTIONS(2529),
    [anon_sym_INFO] = ACTIONS(2529),
    [anon_sym_XXX] = ACTIONS(2529),
    [sym_fixme] = ACTIONS(2529),
    [aux_sym__text_token1] = ACTIONS(2531),
    [sym__block_close] = ACTIONS(2529),
    [sym__newline] = ACTIONS(2529),
    [sym__newline_inline] = ACTIONS(2529),
    [sym_hard_line_break] = ACTIONS(2529),
    [sym__heading_begin] = ACTIONS(2529),
    [sym__div_begin] = ACTIONS(2529),
    [sym__code_block_begin] = ACTIONS(2529),
    [sym_list_marker_dash] = ACTIONS(2529),
    [sym_list_marker_star] = ACTIONS(2529),
    [sym_list_marker_plus] = ACTIONS(2529),
    [sym__list_marker_task_begin] = ACTIONS(2529),
    [sym_list_marker_definition] = ACTIONS(2529),
    [sym_list_marker_decimal_period] = ACTIONS(2529),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2529),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2529),
    [sym_list_marker_lower_roman_period] = ACTIONS(2529),
    [sym_list_marker_upper_roman_period] = ACTIONS(2529),
    [sym_list_marker_decimal_paren] = ACTIONS(2529),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2529),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2529),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2529),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2529),
    [sym_list_marker_decimal_parens] = ACTIONS(2529),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2529),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2529),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2529),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2529),
    [sym__block_quote_begin] = ACTIONS(2529),
    [sym__block_quote_continuation] = ACTIONS(2529),
    [sym__thematic_break_dash] = ACTIONS(2529),
    [sym__thematic_break_star] = ACTIONS(2529),
    [sym__footnote_mark_begin] = ACTIONS(2529),
    [sym__link_ref_def_mark_begin] = ACTIONS(2529),
    [sym__table_header_begin] = ACTIONS(2529),
    [sym__table_separator_begin] = ACTIONS(2529),
    [sym__table_row_begin] = ACTIONS(2529),
    [sym__block_attribute_begin] = ACTIONS(2529),
    [sym__verbatim_begin] = ACTIONS(2529),
  },
  [381] = {
    [anon_sym_LBRACK] = ACTIONS(2535),
    [sym__whitespace1] = ACTIONS(2533),
    [sym_quotation_marks] = ACTIONS(2533),
    [sym_ellipsis] = ACTIONS(2533),
    [sym_em_dash] = ACTIONS(2533),
    [sym_en_dash] = ACTIONS(2535),
    [sym_backslash_escape] = ACTIONS(2535),
    [anon_sym_LT] = ACTIONS(2533),
    [sym_symbol] = ACTIONS(2533),
    [anon_sym_LBRACE_] = ACTIONS(2533),
    [anon_sym__] = ACTIONS(2533),
    [anon_sym_LBRACE_STAR] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(2533),
    [anon_sym_LBRACE_CARET] = ACTIONS(2533),
    [anon_sym_CARET] = ACTIONS(2533),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2533),
    [anon_sym_TILDE] = ACTIONS(2533),
    [anon_sym_LBRACE_EQ] = ACTIONS(2533),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2533),
    [anon_sym_LBRACE_DASH] = ACTIONS(2533),
    [anon_sym_LBRACK_CARET] = ACTIONS(2533),
    [anon_sym_BANG_LBRACK] = ACTIONS(2533),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2533),
    [anon_sym_LPAREN] = ACTIONS(2533),
    [anon_sym_DOLLAR] = ACTIONS(2533),
    [anon_sym_TODO] = ACTIONS(2533),
    [anon_sym_WIP] = ACTIONS(2533),
    [anon_sym_NOTE] = ACTIONS(2533),
    [anon_sym_INFO] = ACTIONS(2533),
    [anon_sym_XXX] = ACTIONS(2533),
    [sym_fixme] = ACTIONS(2533),
    [aux_sym__text_token1] = ACTIONS(2535),
    [sym__block_close] = ACTIONS(2533),
    [sym__newline] = ACTIONS(2533),
    [sym__newline_inline] = ACTIONS(2533),
    [sym_hard_line_break] = ACTIONS(2533),
    [sym__heading_begin] = ACTIONS(2533),
    [sym__div_begin] = ACTIONS(2533),
    [sym__code_block_begin] = ACTIONS(2533),
    [sym_list_marker_dash] = ACTIONS(2533),
    [sym_list_marker_star] = ACTIONS(2533),
    [sym_list_marker_plus] = ACTIONS(2533),
    [sym__list_marker_task_begin] = ACTIONS(2533),
    [sym_list_marker_definition] = ACTIONS(2533),
    [sym_list_marker_decimal_period] = ACTIONS(2533),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2533),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2533),
    [sym_list_marker_lower_roman_period] = ACTIONS(2533),
    [sym_list_marker_upper_roman_period] = ACTIONS(2533),
    [sym_list_marker_decimal_paren] = ACTIONS(2533),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2533),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2533),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2533),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2533),
    [sym_list_marker_decimal_parens] = ACTIONS(2533),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2533),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2533),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2533),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2533),
    [sym__block_quote_begin] = ACTIONS(2533),
    [sym__block_quote_continuation] = ACTIONS(2533),
    [sym__thematic_break_dash] = ACTIONS(2533),
    [sym__thematic_break_star] = ACTIONS(2533),
    [sym__footnote_mark_begin] = ACTIONS(2533),
    [sym__link_ref_def_mark_begin] = ACTIONS(2533),
    [sym__table_header_begin] = ACTIONS(2533),
    [sym__table_separator_begin] = ACTIONS(2533),
    [sym__table_row_begin] = ACTIONS(2533),
    [sym__block_attribute_begin] = ACTIONS(2533),
    [sym__verbatim_begin] = ACTIONS(2533),
  },
  [382] = {
    [anon_sym_LBRACK] = ACTIONS(2539),
    [sym__whitespace1] = ACTIONS(2537),
    [sym_quotation_marks] = ACTIONS(2537),
    [sym_ellipsis] = ACTIONS(2537),
    [sym_em_dash] = ACTIONS(2537),
    [sym_en_dash] = ACTIONS(2539),
    [sym_backslash_escape] = ACTIONS(2539),
    [anon_sym_LT] = ACTIONS(2537),
    [sym_symbol] = ACTIONS(2537),
    [anon_sym_LBRACE_] = ACTIONS(2537),
    [anon_sym__] = ACTIONS(2537),
    [anon_sym_LBRACE_STAR] = ACTIONS(2537),
    [anon_sym_STAR] = ACTIONS(2537),
    [anon_sym_LBRACE_CARET] = ACTIONS(2537),
    [anon_sym_CARET] = ACTIONS(2537),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2537),
    [anon_sym_TILDE] = ACTIONS(2537),
    [anon_sym_LBRACE_EQ] = ACTIONS(2537),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2537),
    [anon_sym_LBRACE_DASH] = ACTIONS(2537),
    [anon_sym_LBRACK_CARET] = ACTIONS(2537),
    [anon_sym_BANG_LBRACK] = ACTIONS(2537),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2537),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_DOLLAR] = ACTIONS(2537),
    [anon_sym_TODO] = ACTIONS(2537),
    [anon_sym_WIP] = ACTIONS(2537),
    [anon_sym_NOTE] = ACTIONS(2537),
    [anon_sym_INFO] = ACTIONS(2537),
    [anon_sym_XXX] = ACTIONS(2537),
    [sym_fixme] = ACTIONS(2537),
    [aux_sym__text_token1] = ACTIONS(2539),
    [sym__block_close] = ACTIONS(2537),
    [sym__newline] = ACTIONS(2537),
    [sym__newline_inline] = ACTIONS(2537),
    [sym_hard_line_break] = ACTIONS(2537),
    [sym__heading_begin] = ACTIONS(2537),
    [sym__div_begin] = ACTIONS(2537),
    [sym__code_block_begin] = ACTIONS(2537),
    [sym_list_marker_dash] = ACTIONS(2537),
    [sym_list_marker_star] = ACTIONS(2537),
    [sym_list_marker_plus] = ACTIONS(2537),
    [sym__list_marker_task_begin] = ACTIONS(2537),
    [sym_list_marker_definition] = ACTIONS(2537),
    [sym_list_marker_decimal_period] = ACTIONS(2537),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2537),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2537),
    [sym_list_marker_lower_roman_period] = ACTIONS(2537),
    [sym_list_marker_upper_roman_period] = ACTIONS(2537),
    [sym_list_marker_decimal_paren] = ACTIONS(2537),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2537),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2537),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2537),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2537),
    [sym_list_marker_decimal_parens] = ACTIONS(2537),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2537),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2537),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2537),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2537),
    [sym__block_quote_begin] = ACTIONS(2537),
    [sym__block_quote_continuation] = ACTIONS(2537),
    [sym__thematic_break_dash] = ACTIONS(2537),
    [sym__thematic_break_star] = ACTIONS(2537),
    [sym__footnote_mark_begin] = ACTIONS(2537),
    [sym__link_ref_def_mark_begin] = ACTIONS(2537),
    [sym__table_header_begin] = ACTIONS(2537),
    [sym__table_separator_begin] = ACTIONS(2537),
    [sym__table_row_begin] = ACTIONS(2537),
    [sym__block_attribute_begin] = ACTIONS(2537),
    [sym__verbatim_begin] = ACTIONS(2537),
  },
  [383] = {
    [anon_sym_LBRACK] = ACTIONS(2543),
    [sym__whitespace1] = ACTIONS(2541),
    [sym_quotation_marks] = ACTIONS(2541),
    [sym_ellipsis] = ACTIONS(2541),
    [sym_em_dash] = ACTIONS(2541),
    [sym_en_dash] = ACTIONS(2543),
    [sym_backslash_escape] = ACTIONS(2543),
    [anon_sym_LT] = ACTIONS(2541),
    [sym_symbol] = ACTIONS(2541),
    [anon_sym_LBRACE_] = ACTIONS(2541),
    [anon_sym__] = ACTIONS(2541),
    [anon_sym_LBRACE_STAR] = ACTIONS(2541),
    [anon_sym_STAR] = ACTIONS(2541),
    [anon_sym_LBRACE_CARET] = ACTIONS(2541),
    [anon_sym_CARET] = ACTIONS(2541),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2541),
    [anon_sym_TILDE] = ACTIONS(2541),
    [anon_sym_LBRACE_EQ] = ACTIONS(2541),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2541),
    [anon_sym_LBRACE_DASH] = ACTIONS(2541),
    [anon_sym_LBRACK_CARET] = ACTIONS(2541),
    [anon_sym_BANG_LBRACK] = ACTIONS(2541),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(2541),
    [anon_sym_DOLLAR] = ACTIONS(2541),
    [anon_sym_TODO] = ACTIONS(2541),
    [anon_sym_WIP] = ACTIONS(2541),
    [anon_sym_NOTE] = ACTIONS(2541),
    [anon_sym_INFO] = ACTIONS(2541),
    [anon_sym_XXX] = ACTIONS(2541),
    [sym_fixme] = ACTIONS(2541),
    [aux_sym__text_token1] = ACTIONS(2543),
    [sym__block_close] = ACTIONS(2541),
    [sym__newline] = ACTIONS(2541),
    [sym__newline_inline] = ACTIONS(2541),
    [sym_hard_line_break] = ACTIONS(2541),
    [sym__heading_begin] = ACTIONS(2541),
    [sym__div_begin] = ACTIONS(2541),
    [sym__code_block_begin] = ACTIONS(2541),
    [sym_list_marker_dash] = ACTIONS(2541),
    [sym_list_marker_star] = ACTIONS(2541),
    [sym_list_marker_plus] = ACTIONS(2541),
    [sym__list_marker_task_begin] = ACTIONS(2541),
    [sym_list_marker_definition] = ACTIONS(2541),
    [sym_list_marker_decimal_period] = ACTIONS(2541),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2541),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2541),
    [sym_list_marker_lower_roman_period] = ACTIONS(2541),
    [sym_list_marker_upper_roman_period] = ACTIONS(2541),
    [sym_list_marker_decimal_paren] = ACTIONS(2541),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2541),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2541),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2541),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2541),
    [sym_list_marker_decimal_parens] = ACTIONS(2541),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2541),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2541),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2541),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2541),
    [sym__block_quote_begin] = ACTIONS(2541),
    [sym__block_quote_continuation] = ACTIONS(2541),
    [sym__thematic_break_dash] = ACTIONS(2541),
    [sym__thematic_break_star] = ACTIONS(2541),
    [sym__footnote_mark_begin] = ACTIONS(2541),
    [sym__link_ref_def_mark_begin] = ACTIONS(2541),
    [sym__table_header_begin] = ACTIONS(2541),
    [sym__table_separator_begin] = ACTIONS(2541),
    [sym__table_row_begin] = ACTIONS(2541),
    [sym__block_attribute_begin] = ACTIONS(2541),
    [sym__verbatim_begin] = ACTIONS(2541),
  },
  [384] = {
    [anon_sym_LBRACK] = ACTIONS(2613),
    [sym__whitespace1] = ACTIONS(2615),
    [sym_quotation_marks] = ACTIONS(2615),
    [sym_ellipsis] = ACTIONS(2615),
    [sym_em_dash] = ACTIONS(2615),
    [sym_en_dash] = ACTIONS(2613),
    [sym_backslash_escape] = ACTIONS(2613),
    [anon_sym_LT] = ACTIONS(2615),
    [sym_symbol] = ACTIONS(2615),
    [anon_sym_LBRACE_] = ACTIONS(2615),
    [anon_sym__] = ACTIONS(2615),
    [anon_sym_LBRACE_STAR] = ACTIONS(2615),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_LBRACE_CARET] = ACTIONS(2615),
    [anon_sym_CARET] = ACTIONS(2615),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [anon_sym_LBRACE_EQ] = ACTIONS(2615),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2615),
    [anon_sym_LBRACE_DASH] = ACTIONS(2615),
    [anon_sym_LBRACK_CARET] = ACTIONS(2615),
    [anon_sym_BANG_LBRACK] = ACTIONS(2615),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2615),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [anon_sym_DOLLAR] = ACTIONS(2615),
    [anon_sym_TODO] = ACTIONS(2615),
    [anon_sym_WIP] = ACTIONS(2615),
    [anon_sym_NOTE] = ACTIONS(2615),
    [anon_sym_INFO] = ACTIONS(2615),
    [anon_sym_XXX] = ACTIONS(2615),
    [sym_fixme] = ACTIONS(2615),
    [aux_sym__text_token1] = ACTIONS(2613),
    [sym__block_close] = ACTIONS(2615),
    [sym__newline] = ACTIONS(2615),
    [sym__newline_inline] = ACTIONS(2615),
    [sym_hard_line_break] = ACTIONS(2615),
    [sym__heading_begin] = ACTIONS(2615),
    [sym__div_begin] = ACTIONS(2615),
    [sym__code_block_begin] = ACTIONS(2615),
    [sym_list_marker_dash] = ACTIONS(2615),
    [sym_list_marker_star] = ACTIONS(2615),
    [sym_list_marker_plus] = ACTIONS(2615),
    [sym__list_marker_task_begin] = ACTIONS(2615),
    [sym_list_marker_definition] = ACTIONS(2615),
    [sym_list_marker_decimal_period] = ACTIONS(2615),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2615),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2615),
    [sym_list_marker_lower_roman_period] = ACTIONS(2615),
    [sym_list_marker_upper_roman_period] = ACTIONS(2615),
    [sym_list_marker_decimal_paren] = ACTIONS(2615),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2615),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2615),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2615),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2615),
    [sym_list_marker_decimal_parens] = ACTIONS(2615),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2615),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2615),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2615),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2615),
    [sym__block_quote_begin] = ACTIONS(2615),
    [sym__block_quote_continuation] = ACTIONS(2615),
    [sym__thematic_break_dash] = ACTIONS(2615),
    [sym__thematic_break_star] = ACTIONS(2615),
    [sym__footnote_mark_begin] = ACTIONS(2615),
    [sym__link_ref_def_mark_begin] = ACTIONS(2615),
    [sym__table_header_begin] = ACTIONS(2615),
    [sym__table_separator_begin] = ACTIONS(2615),
    [sym__table_row_begin] = ACTIONS(2615),
    [sym__block_attribute_begin] = ACTIONS(2615),
    [sym__verbatim_begin] = ACTIONS(2615),
  },
  [385] = {
    [anon_sym_LBRACK] = ACTIONS(2547),
    [sym__whitespace1] = ACTIONS(2545),
    [sym_quotation_marks] = ACTIONS(2545),
    [sym_ellipsis] = ACTIONS(2545),
    [sym_em_dash] = ACTIONS(2545),
    [sym_en_dash] = ACTIONS(2547),
    [sym_backslash_escape] = ACTIONS(2547),
    [anon_sym_LT] = ACTIONS(2545),
    [sym_symbol] = ACTIONS(2545),
    [anon_sym_LBRACE_] = ACTIONS(2545),
    [anon_sym__] = ACTIONS(2545),
    [anon_sym_LBRACE_STAR] = ACTIONS(2545),
    [anon_sym_STAR] = ACTIONS(2545),
    [anon_sym_LBRACE_CARET] = ACTIONS(2545),
    [anon_sym_CARET] = ACTIONS(2545),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2545),
    [anon_sym_LBRACE_EQ] = ACTIONS(2545),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2545),
    [anon_sym_LBRACE_DASH] = ACTIONS(2545),
    [anon_sym_LBRACK_CARET] = ACTIONS(2545),
    [anon_sym_BANG_LBRACK] = ACTIONS(2545),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2545),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_DOLLAR] = ACTIONS(2545),
    [anon_sym_TODO] = ACTIONS(2545),
    [anon_sym_WIP] = ACTIONS(2545),
    [anon_sym_NOTE] = ACTIONS(2545),
    [anon_sym_INFO] = ACTIONS(2545),
    [anon_sym_XXX] = ACTIONS(2545),
    [sym_fixme] = ACTIONS(2545),
    [aux_sym__text_token1] = ACTIONS(2547),
    [sym__block_close] = ACTIONS(2545),
    [sym__newline] = ACTIONS(2545),
    [sym__newline_inline] = ACTIONS(2545),
    [sym_hard_line_break] = ACTIONS(2545),
    [sym__heading_begin] = ACTIONS(2545),
    [sym__div_begin] = ACTIONS(2545),
    [sym__code_block_begin] = ACTIONS(2545),
    [sym_list_marker_dash] = ACTIONS(2545),
    [sym_list_marker_star] = ACTIONS(2545),
    [sym_list_marker_plus] = ACTIONS(2545),
    [sym__list_marker_task_begin] = ACTIONS(2545),
    [sym_list_marker_definition] = ACTIONS(2545),
    [sym_list_marker_decimal_period] = ACTIONS(2545),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2545),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2545),
    [sym_list_marker_lower_roman_period] = ACTIONS(2545),
    [sym_list_marker_upper_roman_period] = ACTIONS(2545),
    [sym_list_marker_decimal_paren] = ACTIONS(2545),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2545),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2545),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2545),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2545),
    [sym_list_marker_decimal_parens] = ACTIONS(2545),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2545),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2545),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2545),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2545),
    [sym__block_quote_begin] = ACTIONS(2545),
    [sym__block_quote_continuation] = ACTIONS(2545),
    [sym__thematic_break_dash] = ACTIONS(2545),
    [sym__thematic_break_star] = ACTIONS(2545),
    [sym__footnote_mark_begin] = ACTIONS(2545),
    [sym__link_ref_def_mark_begin] = ACTIONS(2545),
    [sym__table_header_begin] = ACTIONS(2545),
    [sym__table_separator_begin] = ACTIONS(2545),
    [sym__table_row_begin] = ACTIONS(2545),
    [sym__block_attribute_begin] = ACTIONS(2545),
    [sym__verbatim_begin] = ACTIONS(2545),
  },
  [386] = {
    [anon_sym_LBRACK] = ACTIONS(2551),
    [sym__whitespace1] = ACTIONS(2549),
    [sym_quotation_marks] = ACTIONS(2549),
    [sym_ellipsis] = ACTIONS(2549),
    [sym_em_dash] = ACTIONS(2549),
    [sym_en_dash] = ACTIONS(2551),
    [sym_backslash_escape] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2549),
    [sym_symbol] = ACTIONS(2549),
    [anon_sym_LBRACE_] = ACTIONS(2549),
    [anon_sym__] = ACTIONS(2549),
    [anon_sym_LBRACE_STAR] = ACTIONS(2549),
    [anon_sym_STAR] = ACTIONS(2549),
    [anon_sym_LBRACE_CARET] = ACTIONS(2549),
    [anon_sym_CARET] = ACTIONS(2549),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2549),
    [anon_sym_TILDE] = ACTIONS(2549),
    [anon_sym_LBRACE_EQ] = ACTIONS(2549),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2549),
    [anon_sym_LBRACE_DASH] = ACTIONS(2549),
    [anon_sym_LBRACK_CARET] = ACTIONS(2549),
    [anon_sym_BANG_LBRACK] = ACTIONS(2549),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2549),
    [anon_sym_LPAREN] = ACTIONS(2549),
    [anon_sym_DOLLAR] = ACTIONS(2549),
    [anon_sym_TODO] = ACTIONS(2549),
    [anon_sym_WIP] = ACTIONS(2549),
    [anon_sym_NOTE] = ACTIONS(2549),
    [anon_sym_INFO] = ACTIONS(2549),
    [anon_sym_XXX] = ACTIONS(2549),
    [sym_fixme] = ACTIONS(2549),
    [aux_sym__text_token1] = ACTIONS(2551),
    [sym__block_close] = ACTIONS(2549),
    [sym__newline] = ACTIONS(2549),
    [sym__newline_inline] = ACTIONS(2549),
    [sym_hard_line_break] = ACTIONS(2549),
    [sym__heading_begin] = ACTIONS(2549),
    [sym__div_begin] = ACTIONS(2549),
    [sym__code_block_begin] = ACTIONS(2549),
    [sym_list_marker_dash] = ACTIONS(2549),
    [sym_list_marker_star] = ACTIONS(2549),
    [sym_list_marker_plus] = ACTIONS(2549),
    [sym__list_marker_task_begin] = ACTIONS(2549),
    [sym_list_marker_definition] = ACTIONS(2549),
    [sym_list_marker_decimal_period] = ACTIONS(2549),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2549),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2549),
    [sym_list_marker_lower_roman_period] = ACTIONS(2549),
    [sym_list_marker_upper_roman_period] = ACTIONS(2549),
    [sym_list_marker_decimal_paren] = ACTIONS(2549),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2549),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2549),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2549),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2549),
    [sym_list_marker_decimal_parens] = ACTIONS(2549),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2549),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2549),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2549),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2549),
    [sym__block_quote_begin] = ACTIONS(2549),
    [sym__block_quote_continuation] = ACTIONS(2549),
    [sym__thematic_break_dash] = ACTIONS(2549),
    [sym__thematic_break_star] = ACTIONS(2549),
    [sym__footnote_mark_begin] = ACTIONS(2549),
    [sym__link_ref_def_mark_begin] = ACTIONS(2549),
    [sym__table_header_begin] = ACTIONS(2549),
    [sym__table_separator_begin] = ACTIONS(2549),
    [sym__table_row_begin] = ACTIONS(2549),
    [sym__block_attribute_begin] = ACTIONS(2549),
    [sym__verbatim_begin] = ACTIONS(2549),
  },
  [387] = {
    [anon_sym_LBRACK] = ACTIONS(2555),
    [sym__whitespace1] = ACTIONS(2553),
    [sym_quotation_marks] = ACTIONS(2553),
    [sym_ellipsis] = ACTIONS(2553),
    [sym_em_dash] = ACTIONS(2553),
    [sym_en_dash] = ACTIONS(2555),
    [sym_backslash_escape] = ACTIONS(2555),
    [anon_sym_LT] = ACTIONS(2553),
    [sym_symbol] = ACTIONS(2553),
    [anon_sym_LBRACE_] = ACTIONS(2553),
    [anon_sym__] = ACTIONS(2553),
    [anon_sym_LBRACE_STAR] = ACTIONS(2553),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LBRACE_CARET] = ACTIONS(2553),
    [anon_sym_CARET] = ACTIONS(2553),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2553),
    [anon_sym_TILDE] = ACTIONS(2553),
    [anon_sym_LBRACE_EQ] = ACTIONS(2553),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2553),
    [anon_sym_LBRACE_DASH] = ACTIONS(2553),
    [anon_sym_LBRACK_CARET] = ACTIONS(2553),
    [anon_sym_BANG_LBRACK] = ACTIONS(2553),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2553),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_DOLLAR] = ACTIONS(2553),
    [anon_sym_TODO] = ACTIONS(2553),
    [anon_sym_WIP] = ACTIONS(2553),
    [anon_sym_NOTE] = ACTIONS(2553),
    [anon_sym_INFO] = ACTIONS(2553),
    [anon_sym_XXX] = ACTIONS(2553),
    [sym_fixme] = ACTIONS(2553),
    [aux_sym__text_token1] = ACTIONS(2555),
    [sym__block_close] = ACTIONS(2553),
    [sym__newline] = ACTIONS(2553),
    [sym__newline_inline] = ACTIONS(2553),
    [sym_hard_line_break] = ACTIONS(2553),
    [sym__heading_begin] = ACTIONS(2553),
    [sym__div_begin] = ACTIONS(2553),
    [sym__code_block_begin] = ACTIONS(2553),
    [sym_list_marker_dash] = ACTIONS(2553),
    [sym_list_marker_star] = ACTIONS(2553),
    [sym_list_marker_plus] = ACTIONS(2553),
    [sym__list_marker_task_begin] = ACTIONS(2553),
    [sym_list_marker_definition] = ACTIONS(2553),
    [sym_list_marker_decimal_period] = ACTIONS(2553),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2553),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2553),
    [sym_list_marker_lower_roman_period] = ACTIONS(2553),
    [sym_list_marker_upper_roman_period] = ACTIONS(2553),
    [sym_list_marker_decimal_paren] = ACTIONS(2553),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2553),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2553),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2553),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2553),
    [sym_list_marker_decimal_parens] = ACTIONS(2553),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2553),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2553),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2553),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2553),
    [sym__block_quote_begin] = ACTIONS(2553),
    [sym__block_quote_continuation] = ACTIONS(2553),
    [sym__thematic_break_dash] = ACTIONS(2553),
    [sym__thematic_break_star] = ACTIONS(2553),
    [sym__footnote_mark_begin] = ACTIONS(2553),
    [sym__link_ref_def_mark_begin] = ACTIONS(2553),
    [sym__table_header_begin] = ACTIONS(2553),
    [sym__table_separator_begin] = ACTIONS(2553),
    [sym__table_row_begin] = ACTIONS(2553),
    [sym__block_attribute_begin] = ACTIONS(2553),
    [sym__verbatim_begin] = ACTIONS(2553),
  },
  [388] = {
    [anon_sym_LBRACK] = ACTIONS(2559),
    [sym__whitespace1] = ACTIONS(2557),
    [sym_quotation_marks] = ACTIONS(2557),
    [sym_ellipsis] = ACTIONS(2557),
    [sym_em_dash] = ACTIONS(2557),
    [sym_en_dash] = ACTIONS(2559),
    [sym_backslash_escape] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2557),
    [sym_symbol] = ACTIONS(2557),
    [anon_sym_LBRACE_] = ACTIONS(2557),
    [anon_sym__] = ACTIONS(2557),
    [anon_sym_LBRACE_STAR] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2557),
    [anon_sym_LBRACE_CARET] = ACTIONS(2557),
    [anon_sym_CARET] = ACTIONS(2557),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2557),
    [anon_sym_TILDE] = ACTIONS(2557),
    [anon_sym_LBRACE_EQ] = ACTIONS(2557),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2557),
    [anon_sym_LBRACE_DASH] = ACTIONS(2557),
    [anon_sym_LBRACK_CARET] = ACTIONS(2557),
    [anon_sym_BANG_LBRACK] = ACTIONS(2557),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2557),
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_DOLLAR] = ACTIONS(2557),
    [anon_sym_TODO] = ACTIONS(2557),
    [anon_sym_WIP] = ACTIONS(2557),
    [anon_sym_NOTE] = ACTIONS(2557),
    [anon_sym_INFO] = ACTIONS(2557),
    [anon_sym_XXX] = ACTIONS(2557),
    [sym_fixme] = ACTIONS(2557),
    [aux_sym__text_token1] = ACTIONS(2559),
    [sym__block_close] = ACTIONS(2557),
    [sym__newline] = ACTIONS(2557),
    [sym__newline_inline] = ACTIONS(2557),
    [sym_hard_line_break] = ACTIONS(2557),
    [sym__heading_begin] = ACTIONS(2557),
    [sym__div_begin] = ACTIONS(2557),
    [sym__code_block_begin] = ACTIONS(2557),
    [sym_list_marker_dash] = ACTIONS(2557),
    [sym_list_marker_star] = ACTIONS(2557),
    [sym_list_marker_plus] = ACTIONS(2557),
    [sym__list_marker_task_begin] = ACTIONS(2557),
    [sym_list_marker_definition] = ACTIONS(2557),
    [sym_list_marker_decimal_period] = ACTIONS(2557),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2557),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2557),
    [sym_list_marker_lower_roman_period] = ACTIONS(2557),
    [sym_list_marker_upper_roman_period] = ACTIONS(2557),
    [sym_list_marker_decimal_paren] = ACTIONS(2557),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2557),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2557),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2557),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2557),
    [sym_list_marker_decimal_parens] = ACTIONS(2557),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2557),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2557),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2557),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2557),
    [sym__block_quote_begin] = ACTIONS(2557),
    [sym__block_quote_continuation] = ACTIONS(2557),
    [sym__thematic_break_dash] = ACTIONS(2557),
    [sym__thematic_break_star] = ACTIONS(2557),
    [sym__footnote_mark_begin] = ACTIONS(2557),
    [sym__link_ref_def_mark_begin] = ACTIONS(2557),
    [sym__table_header_begin] = ACTIONS(2557),
    [sym__table_separator_begin] = ACTIONS(2557),
    [sym__table_row_begin] = ACTIONS(2557),
    [sym__block_attribute_begin] = ACTIONS(2557),
    [sym__verbatim_begin] = ACTIONS(2557),
  },
  [389] = {
    [anon_sym_LBRACK] = ACTIONS(2563),
    [sym__whitespace1] = ACTIONS(2561),
    [sym_quotation_marks] = ACTIONS(2561),
    [sym_ellipsis] = ACTIONS(2561),
    [sym_em_dash] = ACTIONS(2561),
    [sym_en_dash] = ACTIONS(2563),
    [sym_backslash_escape] = ACTIONS(2563),
    [anon_sym_LT] = ACTIONS(2561),
    [sym_symbol] = ACTIONS(2561),
    [anon_sym_LBRACE_] = ACTIONS(2561),
    [anon_sym__] = ACTIONS(2561),
    [anon_sym_LBRACE_STAR] = ACTIONS(2561),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_LBRACE_CARET] = ACTIONS(2561),
    [anon_sym_CARET] = ACTIONS(2561),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2561),
    [anon_sym_TILDE] = ACTIONS(2561),
    [anon_sym_LBRACE_EQ] = ACTIONS(2561),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2561),
    [anon_sym_LBRACE_DASH] = ACTIONS(2561),
    [anon_sym_LBRACK_CARET] = ACTIONS(2561),
    [anon_sym_BANG_LBRACK] = ACTIONS(2561),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2561),
    [anon_sym_LPAREN] = ACTIONS(2561),
    [anon_sym_DOLLAR] = ACTIONS(2561),
    [anon_sym_TODO] = ACTIONS(2561),
    [anon_sym_WIP] = ACTIONS(2561),
    [anon_sym_NOTE] = ACTIONS(2561),
    [anon_sym_INFO] = ACTIONS(2561),
    [anon_sym_XXX] = ACTIONS(2561),
    [sym_fixme] = ACTIONS(2561),
    [aux_sym__text_token1] = ACTIONS(2563),
    [sym__block_close] = ACTIONS(2561),
    [sym__newline] = ACTIONS(2561),
    [sym__newline_inline] = ACTIONS(2561),
    [sym_hard_line_break] = ACTIONS(2561),
    [sym__heading_begin] = ACTIONS(2561),
    [sym__div_begin] = ACTIONS(2561),
    [sym__code_block_begin] = ACTIONS(2561),
    [sym_list_marker_dash] = ACTIONS(2561),
    [sym_list_marker_star] = ACTIONS(2561),
    [sym_list_marker_plus] = ACTIONS(2561),
    [sym__list_marker_task_begin] = ACTIONS(2561),
    [sym_list_marker_definition] = ACTIONS(2561),
    [sym_list_marker_decimal_period] = ACTIONS(2561),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2561),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2561),
    [sym_list_marker_lower_roman_period] = ACTIONS(2561),
    [sym_list_marker_upper_roman_period] = ACTIONS(2561),
    [sym_list_marker_decimal_paren] = ACTIONS(2561),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2561),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2561),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2561),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2561),
    [sym_list_marker_decimal_parens] = ACTIONS(2561),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2561),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2561),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2561),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2561),
    [sym__block_quote_begin] = ACTIONS(2561),
    [sym__block_quote_continuation] = ACTIONS(2561),
    [sym__thematic_break_dash] = ACTIONS(2561),
    [sym__thematic_break_star] = ACTIONS(2561),
    [sym__footnote_mark_begin] = ACTIONS(2561),
    [sym__link_ref_def_mark_begin] = ACTIONS(2561),
    [sym__table_header_begin] = ACTIONS(2561),
    [sym__table_separator_begin] = ACTIONS(2561),
    [sym__table_row_begin] = ACTIONS(2561),
    [sym__block_attribute_begin] = ACTIONS(2561),
    [sym__verbatim_begin] = ACTIONS(2561),
  },
  [390] = {
    [anon_sym_LBRACK] = ACTIONS(2567),
    [sym__whitespace1] = ACTIONS(2565),
    [sym_quotation_marks] = ACTIONS(2565),
    [sym_ellipsis] = ACTIONS(2565),
    [sym_em_dash] = ACTIONS(2565),
    [sym_en_dash] = ACTIONS(2567),
    [sym_backslash_escape] = ACTIONS(2567),
    [anon_sym_LT] = ACTIONS(2565),
    [sym_symbol] = ACTIONS(2565),
    [anon_sym_LBRACE_] = ACTIONS(2565),
    [anon_sym__] = ACTIONS(2565),
    [anon_sym_LBRACE_STAR] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2565),
    [anon_sym_LBRACE_CARET] = ACTIONS(2565),
    [anon_sym_CARET] = ACTIONS(2565),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2565),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_LBRACE_EQ] = ACTIONS(2565),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2565),
    [anon_sym_LBRACE_DASH] = ACTIONS(2565),
    [anon_sym_LBRACK_CARET] = ACTIONS(2565),
    [anon_sym_BANG_LBRACK] = ACTIONS(2565),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2565),
    [anon_sym_DOLLAR] = ACTIONS(2565),
    [anon_sym_TODO] = ACTIONS(2565),
    [anon_sym_WIP] = ACTIONS(2565),
    [anon_sym_NOTE] = ACTIONS(2565),
    [anon_sym_INFO] = ACTIONS(2565),
    [anon_sym_XXX] = ACTIONS(2565),
    [sym_fixme] = ACTIONS(2565),
    [aux_sym__text_token1] = ACTIONS(2567),
    [sym__block_close] = ACTIONS(2565),
    [sym__newline] = ACTIONS(2565),
    [sym__newline_inline] = ACTIONS(2565),
    [sym_hard_line_break] = ACTIONS(2565),
    [sym__heading_begin] = ACTIONS(2565),
    [sym__div_begin] = ACTIONS(2565),
    [sym__code_block_begin] = ACTIONS(2565),
    [sym_list_marker_dash] = ACTIONS(2565),
    [sym_list_marker_star] = ACTIONS(2565),
    [sym_list_marker_plus] = ACTIONS(2565),
    [sym__list_marker_task_begin] = ACTIONS(2565),
    [sym_list_marker_definition] = ACTIONS(2565),
    [sym_list_marker_decimal_period] = ACTIONS(2565),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2565),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2565),
    [sym_list_marker_lower_roman_period] = ACTIONS(2565),
    [sym_list_marker_upper_roman_period] = ACTIONS(2565),
    [sym_list_marker_decimal_paren] = ACTIONS(2565),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2565),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2565),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2565),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2565),
    [sym_list_marker_decimal_parens] = ACTIONS(2565),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2565),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2565),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2565),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2565),
    [sym__block_quote_begin] = ACTIONS(2565),
    [sym__block_quote_continuation] = ACTIONS(2565),
    [sym__thematic_break_dash] = ACTIONS(2565),
    [sym__thematic_break_star] = ACTIONS(2565),
    [sym__footnote_mark_begin] = ACTIONS(2565),
    [sym__link_ref_def_mark_begin] = ACTIONS(2565),
    [sym__table_header_begin] = ACTIONS(2565),
    [sym__table_separator_begin] = ACTIONS(2565),
    [sym__table_row_begin] = ACTIONS(2565),
    [sym__block_attribute_begin] = ACTIONS(2565),
    [sym__verbatim_begin] = ACTIONS(2565),
  },
  [391] = {
    [ts_builtin_sym_end] = ACTIONS(2617),
    [anon_sym_LBRACK] = ACTIONS(2619),
    [sym__whitespace1] = ACTIONS(2617),
    [sym_quotation_marks] = ACTIONS(2617),
    [sym_ellipsis] = ACTIONS(2617),
    [sym_em_dash] = ACTIONS(2617),
    [sym_en_dash] = ACTIONS(2619),
    [sym_backslash_escape] = ACTIONS(2619),
    [anon_sym_LT] = ACTIONS(2617),
    [sym_symbol] = ACTIONS(2617),
    [anon_sym_LBRACE_] = ACTIONS(2617),
    [anon_sym__] = ACTIONS(2617),
    [anon_sym_LBRACE_STAR] = ACTIONS(2617),
    [anon_sym_STAR] = ACTIONS(2617),
    [anon_sym_LBRACE_CARET] = ACTIONS(2617),
    [anon_sym_CARET] = ACTIONS(2617),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2617),
    [anon_sym_TILDE] = ACTIONS(2617),
    [anon_sym_LBRACE_EQ] = ACTIONS(2617),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2617),
    [anon_sym_LBRACE_DASH] = ACTIONS(2617),
    [anon_sym_LBRACK_CARET] = ACTIONS(2617),
    [anon_sym_BANG_LBRACK] = ACTIONS(2617),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2617),
    [anon_sym_LPAREN] = ACTIONS(2617),
    [anon_sym_DOLLAR] = ACTIONS(2617),
    [anon_sym_TODO] = ACTIONS(2617),
    [anon_sym_WIP] = ACTIONS(2617),
    [anon_sym_NOTE] = ACTIONS(2617),
    [anon_sym_INFO] = ACTIONS(2617),
    [anon_sym_XXX] = ACTIONS(2617),
    [sym_fixme] = ACTIONS(2617),
    [aux_sym__text_token1] = ACTIONS(2619),
    [sym__newline] = ACTIONS(2617),
    [sym__newline_inline] = ACTIONS(2617),
    [sym_hard_line_break] = ACTIONS(2617),
    [sym__heading_begin] = ACTIONS(2617),
    [sym__div_begin] = ACTIONS(2617),
    [sym__code_block_begin] = ACTIONS(2617),
    [sym_list_marker_dash] = ACTIONS(2617),
    [sym_list_marker_star] = ACTIONS(2617),
    [sym_list_marker_plus] = ACTIONS(2617),
    [sym__list_marker_task_begin] = ACTIONS(2617),
    [sym_list_marker_definition] = ACTIONS(2617),
    [sym_list_marker_decimal_period] = ACTIONS(2617),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2617),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2617),
    [sym_list_marker_lower_roman_period] = ACTIONS(2617),
    [sym_list_marker_upper_roman_period] = ACTIONS(2617),
    [sym_list_marker_decimal_paren] = ACTIONS(2617),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2617),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2617),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2617),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2617),
    [sym_list_marker_decimal_parens] = ACTIONS(2617),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2617),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2617),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2617),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2617),
    [sym__block_quote_begin] = ACTIONS(2617),
    [sym__block_quote_continuation] = ACTIONS(2617),
    [sym__thematic_break_dash] = ACTIONS(2617),
    [sym__thematic_break_star] = ACTIONS(2617),
    [sym__footnote_mark_begin] = ACTIONS(2617),
    [sym__link_ref_def_mark_begin] = ACTIONS(2617),
    [sym__table_header_begin] = ACTIONS(2617),
    [sym__table_separator_begin] = ACTIONS(2617),
    [sym__table_row_begin] = ACTIONS(2617),
    [sym__block_attribute_begin] = ACTIONS(2617),
    [sym__verbatim_begin] = ACTIONS(2617),
  },
  [392] = {
    [anon_sym_LBRACK] = ACTIONS(2349),
    [sym__whitespace1] = ACTIONS(2347),
    [sym_quotation_marks] = ACTIONS(2347),
    [sym_ellipsis] = ACTIONS(2347),
    [sym_em_dash] = ACTIONS(2347),
    [sym_en_dash] = ACTIONS(2349),
    [sym_backslash_escape] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(2347),
    [sym_symbol] = ACTIONS(2347),
    [anon_sym_LBRACE_] = ACTIONS(2347),
    [anon_sym__] = ACTIONS(2347),
    [anon_sym_LBRACE_STAR] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2347),
    [anon_sym_LBRACE_CARET] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2347),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_LBRACE_EQ] = ACTIONS(2347),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2347),
    [anon_sym_LBRACE_DASH] = ACTIONS(2347),
    [anon_sym_LBRACK_CARET] = ACTIONS(2347),
    [anon_sym_BANG_LBRACK] = ACTIONS(2347),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2347),
    [anon_sym_TODO] = ACTIONS(2347),
    [anon_sym_WIP] = ACTIONS(2347),
    [anon_sym_NOTE] = ACTIONS(2347),
    [anon_sym_INFO] = ACTIONS(2347),
    [anon_sym_XXX] = ACTIONS(2347),
    [sym_fixme] = ACTIONS(2347),
    [aux_sym__text_token1] = ACTIONS(2349),
    [sym__block_close] = ACTIONS(2347),
    [sym__newline] = ACTIONS(2347),
    [sym__newline_inline] = ACTIONS(2347),
    [sym_hard_line_break] = ACTIONS(2347),
    [sym__heading_begin] = ACTIONS(2347),
    [sym__div_begin] = ACTIONS(2347),
    [sym__code_block_begin] = ACTIONS(2347),
    [sym_list_marker_dash] = ACTIONS(2347),
    [sym_list_marker_star] = ACTIONS(2347),
    [sym_list_marker_plus] = ACTIONS(2347),
    [sym__list_marker_task_begin] = ACTIONS(2347),
    [sym_list_marker_definition] = ACTIONS(2347),
    [sym_list_marker_decimal_period] = ACTIONS(2347),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2347),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2347),
    [sym_list_marker_lower_roman_period] = ACTIONS(2347),
    [sym_list_marker_upper_roman_period] = ACTIONS(2347),
    [sym_list_marker_decimal_paren] = ACTIONS(2347),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2347),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2347),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2347),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2347),
    [sym_list_marker_decimal_parens] = ACTIONS(2347),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2347),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2347),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2347),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2347),
    [sym__block_quote_begin] = ACTIONS(2347),
    [sym__block_quote_continuation] = ACTIONS(2347),
    [sym__thematic_break_dash] = ACTIONS(2347),
    [sym__thematic_break_star] = ACTIONS(2347),
    [sym__footnote_mark_begin] = ACTIONS(2347),
    [sym__link_ref_def_mark_begin] = ACTIONS(2347),
    [sym__table_header_begin] = ACTIONS(2347),
    [sym__table_separator_begin] = ACTIONS(2347),
    [sym__table_row_begin] = ACTIONS(2347),
    [sym__block_attribute_begin] = ACTIONS(2347),
    [sym__verbatim_begin] = ACTIONS(2347),
  },
  [393] = {
    [ts_builtin_sym_end] = ACTIONS(2621),
    [anon_sym_LBRACK] = ACTIONS(2623),
    [sym__whitespace1] = ACTIONS(2621),
    [sym_quotation_marks] = ACTIONS(2621),
    [sym_ellipsis] = ACTIONS(2621),
    [sym_em_dash] = ACTIONS(2621),
    [sym_en_dash] = ACTIONS(2623),
    [sym_backslash_escape] = ACTIONS(2623),
    [anon_sym_LT] = ACTIONS(2621),
    [sym_symbol] = ACTIONS(2621),
    [anon_sym_LBRACE_] = ACTIONS(2621),
    [anon_sym__] = ACTIONS(2621),
    [anon_sym_LBRACE_STAR] = ACTIONS(2621),
    [anon_sym_STAR] = ACTIONS(2621),
    [anon_sym_LBRACE_CARET] = ACTIONS(2621),
    [anon_sym_CARET] = ACTIONS(2621),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2621),
    [anon_sym_TILDE] = ACTIONS(2621),
    [anon_sym_LBRACE_EQ] = ACTIONS(2621),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2621),
    [anon_sym_LBRACE_DASH] = ACTIONS(2621),
    [anon_sym_LBRACK_CARET] = ACTIONS(2621),
    [anon_sym_BANG_LBRACK] = ACTIONS(2621),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2621),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_DOLLAR] = ACTIONS(2621),
    [anon_sym_TODO] = ACTIONS(2621),
    [anon_sym_WIP] = ACTIONS(2621),
    [anon_sym_NOTE] = ACTIONS(2621),
    [anon_sym_INFO] = ACTIONS(2621),
    [anon_sym_XXX] = ACTIONS(2621),
    [sym_fixme] = ACTIONS(2621),
    [aux_sym__text_token1] = ACTIONS(2623),
    [sym__newline] = ACTIONS(2621),
    [sym__newline_inline] = ACTIONS(2621),
    [sym_hard_line_break] = ACTIONS(2621),
    [sym__heading_begin] = ACTIONS(2621),
    [sym__div_begin] = ACTIONS(2621),
    [sym__code_block_begin] = ACTIONS(2621),
    [sym_list_marker_dash] = ACTIONS(2621),
    [sym_list_marker_star] = ACTIONS(2621),
    [sym_list_marker_plus] = ACTIONS(2621),
    [sym__list_marker_task_begin] = ACTIONS(2621),
    [sym_list_marker_definition] = ACTIONS(2621),
    [sym_list_marker_decimal_period] = ACTIONS(2621),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2621),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2621),
    [sym_list_marker_lower_roman_period] = ACTIONS(2621),
    [sym_list_marker_upper_roman_period] = ACTIONS(2621),
    [sym_list_marker_decimal_paren] = ACTIONS(2621),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2621),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2621),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2621),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2621),
    [sym_list_marker_decimal_parens] = ACTIONS(2621),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2621),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2621),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2621),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2621),
    [sym__block_quote_begin] = ACTIONS(2621),
    [sym__block_quote_continuation] = ACTIONS(2621),
    [sym__thematic_break_dash] = ACTIONS(2621),
    [sym__thematic_break_star] = ACTIONS(2621),
    [sym__footnote_mark_begin] = ACTIONS(2621),
    [sym__link_ref_def_mark_begin] = ACTIONS(2621),
    [sym__table_header_begin] = ACTIONS(2621),
    [sym__table_separator_begin] = ACTIONS(2621),
    [sym__table_row_begin] = ACTIONS(2621),
    [sym__block_attribute_begin] = ACTIONS(2621),
    [sym__verbatim_begin] = ACTIONS(2621),
  },
  [394] = {
    [ts_builtin_sym_end] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [sym__whitespace1] = ACTIONS(2625),
    [sym_quotation_marks] = ACTIONS(2625),
    [sym_ellipsis] = ACTIONS(2625),
    [sym_em_dash] = ACTIONS(2625),
    [sym_en_dash] = ACTIONS(2627),
    [sym_backslash_escape] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2625),
    [sym_symbol] = ACTIONS(2625),
    [anon_sym_LBRACE_] = ACTIONS(2625),
    [anon_sym__] = ACTIONS(2625),
    [anon_sym_LBRACE_STAR] = ACTIONS(2625),
    [anon_sym_STAR] = ACTIONS(2625),
    [anon_sym_LBRACE_CARET] = ACTIONS(2625),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2625),
    [anon_sym_TILDE] = ACTIONS(2625),
    [anon_sym_LBRACE_EQ] = ACTIONS(2625),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2625),
    [anon_sym_LBRACE_DASH] = ACTIONS(2625),
    [anon_sym_LBRACK_CARET] = ACTIONS(2625),
    [anon_sym_BANG_LBRACK] = ACTIONS(2625),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2625),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_DOLLAR] = ACTIONS(2625),
    [anon_sym_TODO] = ACTIONS(2625),
    [anon_sym_WIP] = ACTIONS(2625),
    [anon_sym_NOTE] = ACTIONS(2625),
    [anon_sym_INFO] = ACTIONS(2625),
    [anon_sym_XXX] = ACTIONS(2625),
    [sym_fixme] = ACTIONS(2625),
    [aux_sym__text_token1] = ACTIONS(2627),
    [sym__newline] = ACTIONS(2625),
    [sym__newline_inline] = ACTIONS(2625),
    [sym_hard_line_break] = ACTIONS(2625),
    [sym__heading_begin] = ACTIONS(2625),
    [sym__div_begin] = ACTIONS(2625),
    [sym__code_block_begin] = ACTIONS(2625),
    [sym_list_marker_dash] = ACTIONS(2625),
    [sym_list_marker_star] = ACTIONS(2625),
    [sym_list_marker_plus] = ACTIONS(2625),
    [sym__list_marker_task_begin] = ACTIONS(2625),
    [sym_list_marker_definition] = ACTIONS(2625),
    [sym_list_marker_decimal_period] = ACTIONS(2625),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2625),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2625),
    [sym_list_marker_lower_roman_period] = ACTIONS(2625),
    [sym_list_marker_upper_roman_period] = ACTIONS(2625),
    [sym_list_marker_decimal_paren] = ACTIONS(2625),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2625),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2625),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2625),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2625),
    [sym_list_marker_decimal_parens] = ACTIONS(2625),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2625),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2625),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2625),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2625),
    [sym__block_quote_begin] = ACTIONS(2625),
    [sym__block_quote_continuation] = ACTIONS(2625),
    [sym__thematic_break_dash] = ACTIONS(2625),
    [sym__thematic_break_star] = ACTIONS(2625),
    [sym__footnote_mark_begin] = ACTIONS(2625),
    [sym__link_ref_def_mark_begin] = ACTIONS(2625),
    [sym__table_header_begin] = ACTIONS(2625),
    [sym__table_separator_begin] = ACTIONS(2625),
    [sym__table_row_begin] = ACTIONS(2625),
    [sym__block_attribute_begin] = ACTIONS(2625),
    [sym__verbatim_begin] = ACTIONS(2625),
  },
  [395] = {
    [anon_sym_LBRACK] = ACTIONS(2575),
    [sym__whitespace1] = ACTIONS(2573),
    [sym_quotation_marks] = ACTIONS(2573),
    [sym_ellipsis] = ACTIONS(2573),
    [sym_em_dash] = ACTIONS(2573),
    [sym_en_dash] = ACTIONS(2575),
    [sym_backslash_escape] = ACTIONS(2575),
    [anon_sym_LT] = ACTIONS(2573),
    [sym_symbol] = ACTIONS(2573),
    [anon_sym_LBRACE_] = ACTIONS(2573),
    [anon_sym__] = ACTIONS(2573),
    [anon_sym_LBRACE_STAR] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2573),
    [anon_sym_LBRACE_CARET] = ACTIONS(2573),
    [anon_sym_CARET] = ACTIONS(2573),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2573),
    [anon_sym_TILDE] = ACTIONS(2573),
    [anon_sym_LBRACE_EQ] = ACTIONS(2573),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2573),
    [anon_sym_LBRACE_DASH] = ACTIONS(2573),
    [anon_sym_LBRACK_CARET] = ACTIONS(2573),
    [anon_sym_BANG_LBRACK] = ACTIONS(2573),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2573),
    [anon_sym_LPAREN] = ACTIONS(2573),
    [anon_sym_DOLLAR] = ACTIONS(2573),
    [anon_sym_TODO] = ACTIONS(2573),
    [anon_sym_WIP] = ACTIONS(2573),
    [anon_sym_NOTE] = ACTIONS(2573),
    [anon_sym_INFO] = ACTIONS(2573),
    [anon_sym_XXX] = ACTIONS(2573),
    [sym_fixme] = ACTIONS(2573),
    [aux_sym__text_token1] = ACTIONS(2575),
    [sym__block_close] = ACTIONS(2573),
    [sym__newline] = ACTIONS(2573),
    [sym__newline_inline] = ACTIONS(2573),
    [sym_hard_line_break] = ACTIONS(2573),
    [sym__heading_begin] = ACTIONS(2573),
    [sym__div_begin] = ACTIONS(2573),
    [sym__code_block_begin] = ACTIONS(2573),
    [sym_list_marker_dash] = ACTIONS(2573),
    [sym_list_marker_star] = ACTIONS(2573),
    [sym_list_marker_plus] = ACTIONS(2573),
    [sym__list_marker_task_begin] = ACTIONS(2573),
    [sym_list_marker_definition] = ACTIONS(2573),
    [sym_list_marker_decimal_period] = ACTIONS(2573),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2573),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2573),
    [sym_list_marker_lower_roman_period] = ACTIONS(2573),
    [sym_list_marker_upper_roman_period] = ACTIONS(2573),
    [sym_list_marker_decimal_paren] = ACTIONS(2573),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2573),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2573),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2573),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2573),
    [sym_list_marker_decimal_parens] = ACTIONS(2573),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2573),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2573),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2573),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2573),
    [sym__block_quote_begin] = ACTIONS(2573),
    [sym__block_quote_continuation] = ACTIONS(2573),
    [sym__thematic_break_dash] = ACTIONS(2573),
    [sym__thematic_break_star] = ACTIONS(2573),
    [sym__footnote_mark_begin] = ACTIONS(2573),
    [sym__link_ref_def_mark_begin] = ACTIONS(2573),
    [sym__table_header_begin] = ACTIONS(2573),
    [sym__table_separator_begin] = ACTIONS(2573),
    [sym__table_row_begin] = ACTIONS(2573),
    [sym__block_attribute_begin] = ACTIONS(2573),
    [sym__verbatim_begin] = ACTIONS(2573),
  },
  [396] = {
    [ts_builtin_sym_end] = ACTIONS(2629),
    [anon_sym_LBRACK] = ACTIONS(2631),
    [sym__whitespace1] = ACTIONS(2629),
    [sym_quotation_marks] = ACTIONS(2629),
    [sym_ellipsis] = ACTIONS(2629),
    [sym_em_dash] = ACTIONS(2629),
    [sym_en_dash] = ACTIONS(2631),
    [sym_backslash_escape] = ACTIONS(2631),
    [anon_sym_LT] = ACTIONS(2629),
    [sym_symbol] = ACTIONS(2629),
    [anon_sym_LBRACE_] = ACTIONS(2629),
    [anon_sym__] = ACTIONS(2629),
    [anon_sym_LBRACE_STAR] = ACTIONS(2629),
    [anon_sym_STAR] = ACTIONS(2629),
    [anon_sym_LBRACE_CARET] = ACTIONS(2629),
    [anon_sym_CARET] = ACTIONS(2629),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2629),
    [anon_sym_TILDE] = ACTIONS(2629),
    [anon_sym_LBRACE_EQ] = ACTIONS(2629),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2629),
    [anon_sym_LBRACE_DASH] = ACTIONS(2629),
    [anon_sym_LBRACK_CARET] = ACTIONS(2629),
    [anon_sym_BANG_LBRACK] = ACTIONS(2629),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2629),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_DOLLAR] = ACTIONS(2629),
    [anon_sym_TODO] = ACTIONS(2629),
    [anon_sym_WIP] = ACTIONS(2629),
    [anon_sym_NOTE] = ACTIONS(2629),
    [anon_sym_INFO] = ACTIONS(2629),
    [anon_sym_XXX] = ACTIONS(2629),
    [sym_fixme] = ACTIONS(2629),
    [aux_sym__text_token1] = ACTIONS(2631),
    [sym__newline] = ACTIONS(2629),
    [sym__newline_inline] = ACTIONS(2629),
    [sym_hard_line_break] = ACTIONS(2629),
    [sym__heading_begin] = ACTIONS(2629),
    [sym__div_begin] = ACTIONS(2629),
    [sym__code_block_begin] = ACTIONS(2629),
    [sym_list_marker_dash] = ACTIONS(2629),
    [sym_list_marker_star] = ACTIONS(2629),
    [sym_list_marker_plus] = ACTIONS(2629),
    [sym__list_marker_task_begin] = ACTIONS(2629),
    [sym_list_marker_definition] = ACTIONS(2629),
    [sym_list_marker_decimal_period] = ACTIONS(2629),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2629),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2629),
    [sym_list_marker_lower_roman_period] = ACTIONS(2629),
    [sym_list_marker_upper_roman_period] = ACTIONS(2629),
    [sym_list_marker_decimal_paren] = ACTIONS(2629),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2629),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2629),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2629),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2629),
    [sym_list_marker_decimal_parens] = ACTIONS(2629),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2629),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2629),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2629),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2629),
    [sym__block_quote_begin] = ACTIONS(2629),
    [sym__block_quote_continuation] = ACTIONS(2629),
    [sym__thematic_break_dash] = ACTIONS(2629),
    [sym__thematic_break_star] = ACTIONS(2629),
    [sym__footnote_mark_begin] = ACTIONS(2629),
    [sym__link_ref_def_mark_begin] = ACTIONS(2629),
    [sym__table_header_begin] = ACTIONS(2629),
    [sym__table_separator_begin] = ACTIONS(2629),
    [sym__table_row_begin] = ACTIONS(2629),
    [sym__block_attribute_begin] = ACTIONS(2629),
    [sym__verbatim_begin] = ACTIONS(2629),
  },
  [397] = {
    [ts_builtin_sym_end] = ACTIONS(2633),
    [anon_sym_LBRACK] = ACTIONS(2635),
    [sym__whitespace1] = ACTIONS(2633),
    [sym_quotation_marks] = ACTIONS(2633),
    [sym_ellipsis] = ACTIONS(2633),
    [sym_em_dash] = ACTIONS(2633),
    [sym_en_dash] = ACTIONS(2635),
    [sym_backslash_escape] = ACTIONS(2635),
    [anon_sym_LT] = ACTIONS(2633),
    [sym_symbol] = ACTIONS(2633),
    [anon_sym_LBRACE_] = ACTIONS(2633),
    [anon_sym__] = ACTIONS(2633),
    [anon_sym_LBRACE_STAR] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_LBRACE_CARET] = ACTIONS(2633),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2633),
    [anon_sym_TILDE] = ACTIONS(2633),
    [anon_sym_LBRACE_EQ] = ACTIONS(2633),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2633),
    [anon_sym_LBRACE_DASH] = ACTIONS(2633),
    [anon_sym_LBRACK_CARET] = ACTIONS(2633),
    [anon_sym_BANG_LBRACK] = ACTIONS(2633),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2633),
    [anon_sym_LPAREN] = ACTIONS(2633),
    [anon_sym_DOLLAR] = ACTIONS(2633),
    [anon_sym_TODO] = ACTIONS(2633),
    [anon_sym_WIP] = ACTIONS(2633),
    [anon_sym_NOTE] = ACTIONS(2633),
    [anon_sym_INFO] = ACTIONS(2633),
    [anon_sym_XXX] = ACTIONS(2633),
    [sym_fixme] = ACTIONS(2633),
    [aux_sym__text_token1] = ACTIONS(2635),
    [sym__newline] = ACTIONS(2633),
    [sym__newline_inline] = ACTIONS(2633),
    [sym_hard_line_break] = ACTIONS(2633),
    [sym__heading_begin] = ACTIONS(2633),
    [sym__div_begin] = ACTIONS(2633),
    [sym__code_block_begin] = ACTIONS(2633),
    [sym_list_marker_dash] = ACTIONS(2633),
    [sym_list_marker_star] = ACTIONS(2633),
    [sym_list_marker_plus] = ACTIONS(2633),
    [sym__list_marker_task_begin] = ACTIONS(2633),
    [sym_list_marker_definition] = ACTIONS(2633),
    [sym_list_marker_decimal_period] = ACTIONS(2633),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2633),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2633),
    [sym_list_marker_lower_roman_period] = ACTIONS(2633),
    [sym_list_marker_upper_roman_period] = ACTIONS(2633),
    [sym_list_marker_decimal_paren] = ACTIONS(2633),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2633),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2633),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2633),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2633),
    [sym_list_marker_decimal_parens] = ACTIONS(2633),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2633),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2633),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2633),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2633),
    [sym__block_quote_begin] = ACTIONS(2633),
    [sym__block_quote_continuation] = ACTIONS(2633),
    [sym__thematic_break_dash] = ACTIONS(2633),
    [sym__thematic_break_star] = ACTIONS(2633),
    [sym__footnote_mark_begin] = ACTIONS(2633),
    [sym__link_ref_def_mark_begin] = ACTIONS(2633),
    [sym__table_header_begin] = ACTIONS(2633),
    [sym__table_separator_begin] = ACTIONS(2633),
    [sym__table_row_begin] = ACTIONS(2633),
    [sym__block_attribute_begin] = ACTIONS(2633),
    [sym__verbatim_begin] = ACTIONS(2633),
  },
  [398] = {
    [ts_builtin_sym_end] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [sym__whitespace1] = ACTIONS(2637),
    [sym_quotation_marks] = ACTIONS(2637),
    [sym_ellipsis] = ACTIONS(2637),
    [sym_em_dash] = ACTIONS(2637),
    [sym_en_dash] = ACTIONS(2639),
    [sym_backslash_escape] = ACTIONS(2639),
    [anon_sym_LT] = ACTIONS(2637),
    [sym_symbol] = ACTIONS(2637),
    [anon_sym_LBRACE_] = ACTIONS(2637),
    [anon_sym__] = ACTIONS(2637),
    [anon_sym_LBRACE_STAR] = ACTIONS(2637),
    [anon_sym_STAR] = ACTIONS(2637),
    [anon_sym_LBRACE_CARET] = ACTIONS(2637),
    [anon_sym_CARET] = ACTIONS(2637),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2637),
    [anon_sym_TILDE] = ACTIONS(2637),
    [anon_sym_LBRACE_EQ] = ACTIONS(2637),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2637),
    [anon_sym_LBRACE_DASH] = ACTIONS(2637),
    [anon_sym_LBRACK_CARET] = ACTIONS(2637),
    [anon_sym_BANG_LBRACK] = ACTIONS(2637),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2637),
    [anon_sym_LPAREN] = ACTIONS(2637),
    [anon_sym_DOLLAR] = ACTIONS(2637),
    [anon_sym_TODO] = ACTIONS(2637),
    [anon_sym_WIP] = ACTIONS(2637),
    [anon_sym_NOTE] = ACTIONS(2637),
    [anon_sym_INFO] = ACTIONS(2637),
    [anon_sym_XXX] = ACTIONS(2637),
    [sym_fixme] = ACTIONS(2637),
    [aux_sym__text_token1] = ACTIONS(2639),
    [sym__newline] = ACTIONS(2637),
    [sym__newline_inline] = ACTIONS(2637),
    [sym_hard_line_break] = ACTIONS(2637),
    [sym__heading_begin] = ACTIONS(2637),
    [sym__div_begin] = ACTIONS(2637),
    [sym__code_block_begin] = ACTIONS(2637),
    [sym_list_marker_dash] = ACTIONS(2637),
    [sym_list_marker_star] = ACTIONS(2637),
    [sym_list_marker_plus] = ACTIONS(2637),
    [sym__list_marker_task_begin] = ACTIONS(2637),
    [sym_list_marker_definition] = ACTIONS(2637),
    [sym_list_marker_decimal_period] = ACTIONS(2637),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2637),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2637),
    [sym_list_marker_lower_roman_period] = ACTIONS(2637),
    [sym_list_marker_upper_roman_period] = ACTIONS(2637),
    [sym_list_marker_decimal_paren] = ACTIONS(2637),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2637),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2637),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2637),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2637),
    [sym_list_marker_decimal_parens] = ACTIONS(2637),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2637),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2637),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2637),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2637),
    [sym__block_quote_begin] = ACTIONS(2637),
    [sym__block_quote_continuation] = ACTIONS(2637),
    [sym__thematic_break_dash] = ACTIONS(2637),
    [sym__thematic_break_star] = ACTIONS(2637),
    [sym__footnote_mark_begin] = ACTIONS(2637),
    [sym__link_ref_def_mark_begin] = ACTIONS(2637),
    [sym__table_header_begin] = ACTIONS(2637),
    [sym__table_separator_begin] = ACTIONS(2637),
    [sym__table_row_begin] = ACTIONS(2637),
    [sym__block_attribute_begin] = ACTIONS(2637),
    [sym__verbatim_begin] = ACTIONS(2637),
  },
  [399] = {
    [anon_sym_LBRACK] = ACTIONS(2579),
    [sym__whitespace1] = ACTIONS(2577),
    [sym_quotation_marks] = ACTIONS(2577),
    [sym_ellipsis] = ACTIONS(2577),
    [sym_em_dash] = ACTIONS(2577),
    [sym_en_dash] = ACTIONS(2579),
    [sym_backslash_escape] = ACTIONS(2579),
    [anon_sym_LT] = ACTIONS(2577),
    [sym_symbol] = ACTIONS(2577),
    [anon_sym_LBRACE_] = ACTIONS(2577),
    [anon_sym__] = ACTIONS(2577),
    [anon_sym_LBRACE_STAR] = ACTIONS(2577),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_LBRACE_CARET] = ACTIONS(2577),
    [anon_sym_CARET] = ACTIONS(2577),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_LBRACE_EQ] = ACTIONS(2577),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2577),
    [anon_sym_LBRACE_DASH] = ACTIONS(2577),
    [anon_sym_LBRACK_CARET] = ACTIONS(2577),
    [anon_sym_BANG_LBRACK] = ACTIONS(2577),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2577),
    [anon_sym_DOLLAR] = ACTIONS(2577),
    [anon_sym_TODO] = ACTIONS(2577),
    [anon_sym_WIP] = ACTIONS(2577),
    [anon_sym_NOTE] = ACTIONS(2577),
    [anon_sym_INFO] = ACTIONS(2577),
    [anon_sym_XXX] = ACTIONS(2577),
    [sym_fixme] = ACTIONS(2577),
    [aux_sym__text_token1] = ACTIONS(2579),
    [sym__block_close] = ACTIONS(2577),
    [sym__newline] = ACTIONS(2577),
    [sym__newline_inline] = ACTIONS(2577),
    [sym_hard_line_break] = ACTIONS(2577),
    [sym__heading_begin] = ACTIONS(2577),
    [sym__div_begin] = ACTIONS(2577),
    [sym__code_block_begin] = ACTIONS(2577),
    [sym_list_marker_dash] = ACTIONS(2577),
    [sym_list_marker_star] = ACTIONS(2577),
    [sym_list_marker_plus] = ACTIONS(2577),
    [sym__list_marker_task_begin] = ACTIONS(2577),
    [sym_list_marker_definition] = ACTIONS(2577),
    [sym_list_marker_decimal_period] = ACTIONS(2577),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2577),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2577),
    [sym_list_marker_lower_roman_period] = ACTIONS(2577),
    [sym_list_marker_upper_roman_period] = ACTIONS(2577),
    [sym_list_marker_decimal_paren] = ACTIONS(2577),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2577),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2577),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2577),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2577),
    [sym_list_marker_decimal_parens] = ACTIONS(2577),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2577),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2577),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2577),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2577),
    [sym__block_quote_begin] = ACTIONS(2577),
    [sym__block_quote_continuation] = ACTIONS(2577),
    [sym__thematic_break_dash] = ACTIONS(2577),
    [sym__thematic_break_star] = ACTIONS(2577),
    [sym__footnote_mark_begin] = ACTIONS(2577),
    [sym__link_ref_def_mark_begin] = ACTIONS(2577),
    [sym__table_header_begin] = ACTIONS(2577),
    [sym__table_separator_begin] = ACTIONS(2577),
    [sym__table_row_begin] = ACTIONS(2577),
    [sym__block_attribute_begin] = ACTIONS(2577),
    [sym__verbatim_begin] = ACTIONS(2577),
  },
  [400] = {
    [ts_builtin_sym_end] = ACTIONS(2641),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [sym__whitespace1] = ACTIONS(2641),
    [sym_quotation_marks] = ACTIONS(2641),
    [sym_ellipsis] = ACTIONS(2641),
    [sym_em_dash] = ACTIONS(2641),
    [sym_en_dash] = ACTIONS(2643),
    [sym_backslash_escape] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2641),
    [sym_symbol] = ACTIONS(2641),
    [anon_sym_LBRACE_] = ACTIONS(2641),
    [anon_sym__] = ACTIONS(2641),
    [anon_sym_LBRACE_STAR] = ACTIONS(2641),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE_CARET] = ACTIONS(2641),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_LBRACE_EQ] = ACTIONS(2641),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2641),
    [anon_sym_LBRACE_DASH] = ACTIONS(2641),
    [anon_sym_LBRACK_CARET] = ACTIONS(2641),
    [anon_sym_BANG_LBRACK] = ACTIONS(2641),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2641),
    [anon_sym_LPAREN] = ACTIONS(2641),
    [anon_sym_DOLLAR] = ACTIONS(2641),
    [anon_sym_TODO] = ACTIONS(2641),
    [anon_sym_WIP] = ACTIONS(2641),
    [anon_sym_NOTE] = ACTIONS(2641),
    [anon_sym_INFO] = ACTIONS(2641),
    [anon_sym_XXX] = ACTIONS(2641),
    [sym_fixme] = ACTIONS(2641),
    [aux_sym__text_token1] = ACTIONS(2643),
    [sym__newline] = ACTIONS(2641),
    [sym__newline_inline] = ACTIONS(2641),
    [sym_hard_line_break] = ACTIONS(2641),
    [sym__heading_begin] = ACTIONS(2641),
    [sym__div_begin] = ACTIONS(2641),
    [sym__code_block_begin] = ACTIONS(2641),
    [sym_list_marker_dash] = ACTIONS(2641),
    [sym_list_marker_star] = ACTIONS(2641),
    [sym_list_marker_plus] = ACTIONS(2641),
    [sym__list_marker_task_begin] = ACTIONS(2641),
    [sym_list_marker_definition] = ACTIONS(2641),
    [sym_list_marker_decimal_period] = ACTIONS(2641),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2641),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2641),
    [sym_list_marker_lower_roman_period] = ACTIONS(2641),
    [sym_list_marker_upper_roman_period] = ACTIONS(2641),
    [sym_list_marker_decimal_paren] = ACTIONS(2641),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2641),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2641),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2641),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2641),
    [sym_list_marker_decimal_parens] = ACTIONS(2641),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2641),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2641),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2641),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2641),
    [sym__block_quote_begin] = ACTIONS(2641),
    [sym__block_quote_continuation] = ACTIONS(2641),
    [sym__thematic_break_dash] = ACTIONS(2641),
    [sym__thematic_break_star] = ACTIONS(2641),
    [sym__footnote_mark_begin] = ACTIONS(2641),
    [sym__link_ref_def_mark_begin] = ACTIONS(2641),
    [sym__table_header_begin] = ACTIONS(2641),
    [sym__table_separator_begin] = ACTIONS(2641),
    [sym__table_row_begin] = ACTIONS(2641),
    [sym__block_attribute_begin] = ACTIONS(2641),
    [sym__verbatim_begin] = ACTIONS(2641),
  },
  [401] = {
    [anon_sym_LBRACK] = ACTIONS(2611),
    [sym__whitespace1] = ACTIONS(2609),
    [sym_quotation_marks] = ACTIONS(2609),
    [sym_ellipsis] = ACTIONS(2609),
    [sym_em_dash] = ACTIONS(2609),
    [sym_en_dash] = ACTIONS(2611),
    [sym_backslash_escape] = ACTIONS(2611),
    [anon_sym_LT] = ACTIONS(2609),
    [sym_symbol] = ACTIONS(2609),
    [anon_sym_LBRACE_] = ACTIONS(2609),
    [anon_sym__] = ACTIONS(2609),
    [anon_sym_LBRACE_STAR] = ACTIONS(2609),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACE_CARET] = ACTIONS(2609),
    [anon_sym_CARET] = ACTIONS(2609),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2609),
    [anon_sym_TILDE] = ACTIONS(2609),
    [anon_sym_LBRACE_EQ] = ACTIONS(2609),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2609),
    [anon_sym_LBRACE_DASH] = ACTIONS(2609),
    [anon_sym_LBRACK_CARET] = ACTIONS(2609),
    [anon_sym_BANG_LBRACK] = ACTIONS(2609),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2609),
    [anon_sym_LPAREN] = ACTIONS(2609),
    [anon_sym_DOLLAR] = ACTIONS(2609),
    [anon_sym_TODO] = ACTIONS(2609),
    [anon_sym_WIP] = ACTIONS(2609),
    [anon_sym_NOTE] = ACTIONS(2609),
    [anon_sym_INFO] = ACTIONS(2609),
    [anon_sym_XXX] = ACTIONS(2609),
    [sym_fixme] = ACTIONS(2609),
    [aux_sym__text_token1] = ACTIONS(2611),
    [sym__block_close] = ACTIONS(2609),
    [sym__newline] = ACTIONS(2609),
    [sym__newline_inline] = ACTIONS(2609),
    [sym_hard_line_break] = ACTIONS(2609),
    [sym__heading_begin] = ACTIONS(2609),
    [sym__div_begin] = ACTIONS(2609),
    [sym__code_block_begin] = ACTIONS(2609),
    [sym_list_marker_dash] = ACTIONS(2609),
    [sym_list_marker_star] = ACTIONS(2609),
    [sym_list_marker_plus] = ACTIONS(2609),
    [sym__list_marker_task_begin] = ACTIONS(2609),
    [sym_list_marker_definition] = ACTIONS(2609),
    [sym_list_marker_decimal_period] = ACTIONS(2609),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2609),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2609),
    [sym_list_marker_lower_roman_period] = ACTIONS(2609),
    [sym_list_marker_upper_roman_period] = ACTIONS(2609),
    [sym_list_marker_decimal_paren] = ACTIONS(2609),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2609),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2609),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2609),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2609),
    [sym_list_marker_decimal_parens] = ACTIONS(2609),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2609),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2609),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2609),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2609),
    [sym__block_quote_begin] = ACTIONS(2609),
    [sym__block_quote_continuation] = ACTIONS(2609),
    [sym__thematic_break_dash] = ACTIONS(2609),
    [sym__thematic_break_star] = ACTIONS(2609),
    [sym__footnote_mark_begin] = ACTIONS(2609),
    [sym__link_ref_def_mark_begin] = ACTIONS(2609),
    [sym__table_header_begin] = ACTIONS(2609),
    [sym__table_separator_begin] = ACTIONS(2609),
    [sym__table_row_begin] = ACTIONS(2609),
    [sym__block_attribute_begin] = ACTIONS(2609),
    [sym__verbatim_begin] = ACTIONS(2609),
  },
  [402] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [anon_sym_LBRACK] = ACTIONS(2647),
    [sym__whitespace1] = ACTIONS(2645),
    [sym_quotation_marks] = ACTIONS(2645),
    [sym_ellipsis] = ACTIONS(2645),
    [sym_em_dash] = ACTIONS(2645),
    [sym_en_dash] = ACTIONS(2647),
    [sym_backslash_escape] = ACTIONS(2647),
    [anon_sym_LT] = ACTIONS(2645),
    [sym_symbol] = ACTIONS(2645),
    [anon_sym_LBRACE_] = ACTIONS(2645),
    [anon_sym__] = ACTIONS(2645),
    [anon_sym_LBRACE_STAR] = ACTIONS(2645),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_LBRACE_CARET] = ACTIONS(2645),
    [anon_sym_CARET] = ACTIONS(2645),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_LBRACE_EQ] = ACTIONS(2645),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2645),
    [anon_sym_LBRACE_DASH] = ACTIONS(2645),
    [anon_sym_LBRACK_CARET] = ACTIONS(2645),
    [anon_sym_BANG_LBRACK] = ACTIONS(2645),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2645),
    [anon_sym_DOLLAR] = ACTIONS(2645),
    [anon_sym_TODO] = ACTIONS(2645),
    [anon_sym_WIP] = ACTIONS(2645),
    [anon_sym_NOTE] = ACTIONS(2645),
    [anon_sym_INFO] = ACTIONS(2645),
    [anon_sym_XXX] = ACTIONS(2645),
    [sym_fixme] = ACTIONS(2645),
    [aux_sym__text_token1] = ACTIONS(2647),
    [sym__newline] = ACTIONS(2645),
    [sym__newline_inline] = ACTIONS(2645),
    [sym_hard_line_break] = ACTIONS(2645),
    [sym__heading_begin] = ACTIONS(2645),
    [sym__div_begin] = ACTIONS(2645),
    [sym__code_block_begin] = ACTIONS(2645),
    [sym_list_marker_dash] = ACTIONS(2645),
    [sym_list_marker_star] = ACTIONS(2645),
    [sym_list_marker_plus] = ACTIONS(2645),
    [sym__list_marker_task_begin] = ACTIONS(2645),
    [sym_list_marker_definition] = ACTIONS(2645),
    [sym_list_marker_decimal_period] = ACTIONS(2645),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2645),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2645),
    [sym_list_marker_lower_roman_period] = ACTIONS(2645),
    [sym_list_marker_upper_roman_period] = ACTIONS(2645),
    [sym_list_marker_decimal_paren] = ACTIONS(2645),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2645),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2645),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2645),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2645),
    [sym_list_marker_decimal_parens] = ACTIONS(2645),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2645),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2645),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2645),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2645),
    [sym__block_quote_begin] = ACTIONS(2645),
    [sym__block_quote_continuation] = ACTIONS(2645),
    [sym__thematic_break_dash] = ACTIONS(2645),
    [sym__thematic_break_star] = ACTIONS(2645),
    [sym__footnote_mark_begin] = ACTIONS(2645),
    [sym__link_ref_def_mark_begin] = ACTIONS(2645),
    [sym__table_header_begin] = ACTIONS(2645),
    [sym__table_separator_begin] = ACTIONS(2645),
    [sym__table_row_begin] = ACTIONS(2645),
    [sym__block_attribute_begin] = ACTIONS(2645),
    [sym__verbatim_begin] = ACTIONS(2645),
  },
  [403] = {
    [anon_sym_LBRACK] = ACTIONS(2479),
    [sym__whitespace1] = ACTIONS(2477),
    [sym_quotation_marks] = ACTIONS(2477),
    [sym_ellipsis] = ACTIONS(2477),
    [sym_em_dash] = ACTIONS(2477),
    [sym_en_dash] = ACTIONS(2479),
    [sym_backslash_escape] = ACTIONS(2479),
    [anon_sym_LT] = ACTIONS(2477),
    [sym_symbol] = ACTIONS(2477),
    [anon_sym_LBRACE_] = ACTIONS(2477),
    [anon_sym__] = ACTIONS(2477),
    [anon_sym_LBRACE_STAR] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2477),
    [anon_sym_LBRACE_CARET] = ACTIONS(2477),
    [anon_sym_CARET] = ACTIONS(2477),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2477),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_LBRACE_EQ] = ACTIONS(2477),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2477),
    [anon_sym_LBRACE_DASH] = ACTIONS(2477),
    [anon_sym_LBRACK_CARET] = ACTIONS(2477),
    [anon_sym_BANG_LBRACK] = ACTIONS(2477),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2477),
    [anon_sym_LPAREN] = ACTIONS(2477),
    [anon_sym_DOLLAR] = ACTIONS(2477),
    [anon_sym_TODO] = ACTIONS(2477),
    [anon_sym_WIP] = ACTIONS(2477),
    [anon_sym_NOTE] = ACTIONS(2477),
    [anon_sym_INFO] = ACTIONS(2477),
    [anon_sym_XXX] = ACTIONS(2477),
    [sym_fixme] = ACTIONS(2477),
    [aux_sym__text_token1] = ACTIONS(2479),
    [sym__block_close] = ACTIONS(2477),
    [sym__newline] = ACTIONS(2477),
    [sym__newline_inline] = ACTIONS(2477),
    [sym_hard_line_break] = ACTIONS(2477),
    [sym__heading_begin] = ACTIONS(2477),
    [sym__div_begin] = ACTIONS(2477),
    [sym__code_block_begin] = ACTIONS(2477),
    [sym_list_marker_dash] = ACTIONS(2477),
    [sym_list_marker_star] = ACTIONS(2477),
    [sym_list_marker_plus] = ACTIONS(2477),
    [sym__list_marker_task_begin] = ACTIONS(2477),
    [sym_list_marker_definition] = ACTIONS(2477),
    [sym_list_marker_decimal_period] = ACTIONS(2477),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2477),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2477),
    [sym_list_marker_lower_roman_period] = ACTIONS(2477),
    [sym_list_marker_upper_roman_period] = ACTIONS(2477),
    [sym_list_marker_decimal_paren] = ACTIONS(2477),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2477),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2477),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2477),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2477),
    [sym_list_marker_decimal_parens] = ACTIONS(2477),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2477),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2477),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2477),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2477),
    [sym__block_quote_begin] = ACTIONS(2477),
    [sym__block_quote_continuation] = ACTIONS(2477),
    [sym__thematic_break_dash] = ACTIONS(2477),
    [sym__thematic_break_star] = ACTIONS(2477),
    [sym__footnote_mark_begin] = ACTIONS(2477),
    [sym__link_ref_def_mark_begin] = ACTIONS(2477),
    [sym__table_header_begin] = ACTIONS(2477),
    [sym__table_separator_begin] = ACTIONS(2477),
    [sym__table_row_begin] = ACTIONS(2477),
    [sym__block_attribute_begin] = ACTIONS(2477),
    [sym__verbatim_begin] = ACTIONS(2477),
  },
  [404] = {
    [ts_builtin_sym_end] = ACTIONS(2649),
    [anon_sym_LBRACK] = ACTIONS(2651),
    [sym__whitespace1] = ACTIONS(2649),
    [sym_quotation_marks] = ACTIONS(2649),
    [sym_ellipsis] = ACTIONS(2649),
    [sym_em_dash] = ACTIONS(2649),
    [sym_en_dash] = ACTIONS(2651),
    [sym_backslash_escape] = ACTIONS(2651),
    [anon_sym_LT] = ACTIONS(2649),
    [sym_symbol] = ACTIONS(2649),
    [anon_sym_LBRACE_] = ACTIONS(2649),
    [anon_sym__] = ACTIONS(2649),
    [anon_sym_LBRACE_STAR] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2649),
    [anon_sym_LBRACE_CARET] = ACTIONS(2649),
    [anon_sym_CARET] = ACTIONS(2649),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2649),
    [anon_sym_TILDE] = ACTIONS(2649),
    [anon_sym_LBRACE_EQ] = ACTIONS(2649),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2649),
    [anon_sym_LBRACE_DASH] = ACTIONS(2649),
    [anon_sym_LBRACK_CARET] = ACTIONS(2649),
    [anon_sym_BANG_LBRACK] = ACTIONS(2649),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2649),
    [anon_sym_LPAREN] = ACTIONS(2649),
    [anon_sym_DOLLAR] = ACTIONS(2649),
    [anon_sym_TODO] = ACTIONS(2649),
    [anon_sym_WIP] = ACTIONS(2649),
    [anon_sym_NOTE] = ACTIONS(2649),
    [anon_sym_INFO] = ACTIONS(2649),
    [anon_sym_XXX] = ACTIONS(2649),
    [sym_fixme] = ACTIONS(2649),
    [aux_sym__text_token1] = ACTIONS(2651),
    [sym__newline] = ACTIONS(2649),
    [sym__newline_inline] = ACTIONS(2649),
    [sym_hard_line_break] = ACTIONS(2649),
    [sym__heading_begin] = ACTIONS(2649),
    [sym__div_begin] = ACTIONS(2649),
    [sym__code_block_begin] = ACTIONS(2649),
    [sym_list_marker_dash] = ACTIONS(2649),
    [sym_list_marker_star] = ACTIONS(2649),
    [sym_list_marker_plus] = ACTIONS(2649),
    [sym__list_marker_task_begin] = ACTIONS(2649),
    [sym_list_marker_definition] = ACTIONS(2649),
    [sym_list_marker_decimal_period] = ACTIONS(2649),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2649),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2649),
    [sym_list_marker_lower_roman_period] = ACTIONS(2649),
    [sym_list_marker_upper_roman_period] = ACTIONS(2649),
    [sym_list_marker_decimal_paren] = ACTIONS(2649),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2649),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2649),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2649),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2649),
    [sym_list_marker_decimal_parens] = ACTIONS(2649),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2649),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2649),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2649),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2649),
    [sym__block_quote_begin] = ACTIONS(2649),
    [sym__block_quote_continuation] = ACTIONS(2649),
    [sym__thematic_break_dash] = ACTIONS(2649),
    [sym__thematic_break_star] = ACTIONS(2649),
    [sym__footnote_mark_begin] = ACTIONS(2649),
    [sym__link_ref_def_mark_begin] = ACTIONS(2649),
    [sym__table_header_begin] = ACTIONS(2649),
    [sym__table_separator_begin] = ACTIONS(2649),
    [sym__table_row_begin] = ACTIONS(2649),
    [sym__block_attribute_begin] = ACTIONS(2649),
    [sym__verbatim_begin] = ACTIONS(2649),
  },
  [405] = {
    [ts_builtin_sym_end] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2655),
    [sym__whitespace1] = ACTIONS(2653),
    [sym_quotation_marks] = ACTIONS(2653),
    [sym_ellipsis] = ACTIONS(2653),
    [sym_em_dash] = ACTIONS(2653),
    [sym_en_dash] = ACTIONS(2655),
    [sym_backslash_escape] = ACTIONS(2655),
    [anon_sym_LT] = ACTIONS(2653),
    [sym_symbol] = ACTIONS(2653),
    [anon_sym_LBRACE_] = ACTIONS(2653),
    [anon_sym__] = ACTIONS(2653),
    [anon_sym_LBRACE_STAR] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_LBRACE_CARET] = ACTIONS(2653),
    [anon_sym_CARET] = ACTIONS(2653),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2653),
    [anon_sym_LBRACE_EQ] = ACTIONS(2653),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2653),
    [anon_sym_LBRACE_DASH] = ACTIONS(2653),
    [anon_sym_LBRACK_CARET] = ACTIONS(2653),
    [anon_sym_BANG_LBRACK] = ACTIONS(2653),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2653),
    [anon_sym_LPAREN] = ACTIONS(2653),
    [anon_sym_DOLLAR] = ACTIONS(2653),
    [anon_sym_TODO] = ACTIONS(2653),
    [anon_sym_WIP] = ACTIONS(2653),
    [anon_sym_NOTE] = ACTIONS(2653),
    [anon_sym_INFO] = ACTIONS(2653),
    [anon_sym_XXX] = ACTIONS(2653),
    [sym_fixme] = ACTIONS(2653),
    [aux_sym__text_token1] = ACTIONS(2655),
    [sym__newline] = ACTIONS(2653),
    [sym__newline_inline] = ACTIONS(2653),
    [sym_hard_line_break] = ACTIONS(2653),
    [sym__heading_begin] = ACTIONS(2653),
    [sym__div_begin] = ACTIONS(2653),
    [sym__code_block_begin] = ACTIONS(2653),
    [sym_list_marker_dash] = ACTIONS(2653),
    [sym_list_marker_star] = ACTIONS(2653),
    [sym_list_marker_plus] = ACTIONS(2653),
    [sym__list_marker_task_begin] = ACTIONS(2653),
    [sym_list_marker_definition] = ACTIONS(2653),
    [sym_list_marker_decimal_period] = ACTIONS(2653),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2653),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2653),
    [sym_list_marker_lower_roman_period] = ACTIONS(2653),
    [sym_list_marker_upper_roman_period] = ACTIONS(2653),
    [sym_list_marker_decimal_paren] = ACTIONS(2653),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2653),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2653),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2653),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2653),
    [sym_list_marker_decimal_parens] = ACTIONS(2653),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2653),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2653),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2653),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2653),
    [sym__block_quote_begin] = ACTIONS(2653),
    [sym__block_quote_continuation] = ACTIONS(2653),
    [sym__thematic_break_dash] = ACTIONS(2653),
    [sym__thematic_break_star] = ACTIONS(2653),
    [sym__footnote_mark_begin] = ACTIONS(2653),
    [sym__link_ref_def_mark_begin] = ACTIONS(2653),
    [sym__table_header_begin] = ACTIONS(2653),
    [sym__table_separator_begin] = ACTIONS(2653),
    [sym__table_row_begin] = ACTIONS(2653),
    [sym__block_attribute_begin] = ACTIONS(2653),
    [sym__verbatim_begin] = ACTIONS(2653),
  },
  [406] = {
    [anon_sym_LBRACK] = ACTIONS(2603),
    [sym__whitespace1] = ACTIONS(2601),
    [sym_quotation_marks] = ACTIONS(2601),
    [sym_ellipsis] = ACTIONS(2601),
    [sym_em_dash] = ACTIONS(2601),
    [sym_en_dash] = ACTIONS(2603),
    [sym_backslash_escape] = ACTIONS(2603),
    [anon_sym_LT] = ACTIONS(2601),
    [sym_symbol] = ACTIONS(2601),
    [anon_sym_LBRACE_] = ACTIONS(2601),
    [anon_sym__] = ACTIONS(2601),
    [anon_sym_LBRACE_STAR] = ACTIONS(2601),
    [anon_sym_STAR] = ACTIONS(2601),
    [anon_sym_LBRACE_CARET] = ACTIONS(2601),
    [anon_sym_CARET] = ACTIONS(2601),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2601),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_LBRACE_EQ] = ACTIONS(2601),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2601),
    [anon_sym_LBRACE_DASH] = ACTIONS(2601),
    [anon_sym_LBRACK_CARET] = ACTIONS(2601),
    [anon_sym_BANG_LBRACK] = ACTIONS(2601),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2601),
    [anon_sym_LPAREN] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2601),
    [anon_sym_TODO] = ACTIONS(2601),
    [anon_sym_WIP] = ACTIONS(2601),
    [anon_sym_NOTE] = ACTIONS(2601),
    [anon_sym_INFO] = ACTIONS(2601),
    [anon_sym_XXX] = ACTIONS(2601),
    [sym_fixme] = ACTIONS(2601),
    [aux_sym__text_token1] = ACTIONS(2603),
    [sym__block_close] = ACTIONS(2601),
    [sym__newline] = ACTIONS(2601),
    [sym__newline_inline] = ACTIONS(2601),
    [sym_hard_line_break] = ACTIONS(2601),
    [sym__heading_begin] = ACTIONS(2601),
    [sym__div_begin] = ACTIONS(2601),
    [sym__code_block_begin] = ACTIONS(2601),
    [sym_list_marker_dash] = ACTIONS(2601),
    [sym_list_marker_star] = ACTIONS(2601),
    [sym_list_marker_plus] = ACTIONS(2601),
    [sym__list_marker_task_begin] = ACTIONS(2601),
    [sym_list_marker_definition] = ACTIONS(2601),
    [sym_list_marker_decimal_period] = ACTIONS(2601),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2601),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2601),
    [sym_list_marker_lower_roman_period] = ACTIONS(2601),
    [sym_list_marker_upper_roman_period] = ACTIONS(2601),
    [sym_list_marker_decimal_paren] = ACTIONS(2601),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2601),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2601),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2601),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2601),
    [sym_list_marker_decimal_parens] = ACTIONS(2601),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2601),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2601),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2601),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2601),
    [sym__block_quote_begin] = ACTIONS(2601),
    [sym__block_quote_continuation] = ACTIONS(2601),
    [sym__thematic_break_dash] = ACTIONS(2601),
    [sym__thematic_break_star] = ACTIONS(2601),
    [sym__footnote_mark_begin] = ACTIONS(2601),
    [sym__link_ref_def_mark_begin] = ACTIONS(2601),
    [sym__table_header_begin] = ACTIONS(2601),
    [sym__table_separator_begin] = ACTIONS(2601),
    [sym__table_row_begin] = ACTIONS(2601),
    [sym__block_attribute_begin] = ACTIONS(2601),
    [sym__verbatim_begin] = ACTIONS(2601),
  },
  [407] = {
    [anon_sym_LBRACK] = ACTIONS(2603),
    [sym__whitespace1] = ACTIONS(2601),
    [sym_quotation_marks] = ACTIONS(2601),
    [sym_ellipsis] = ACTIONS(2601),
    [sym_em_dash] = ACTIONS(2601),
    [sym_en_dash] = ACTIONS(2603),
    [sym_backslash_escape] = ACTIONS(2603),
    [anon_sym_LT] = ACTIONS(2601),
    [sym_symbol] = ACTIONS(2601),
    [anon_sym_LBRACE_] = ACTIONS(2601),
    [anon_sym__] = ACTIONS(2601),
    [anon_sym_LBRACE_STAR] = ACTIONS(2601),
    [anon_sym_STAR] = ACTIONS(2601),
    [anon_sym_LBRACE_CARET] = ACTIONS(2601),
    [anon_sym_CARET] = ACTIONS(2601),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2601),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_LBRACE_EQ] = ACTIONS(2601),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2601),
    [anon_sym_LBRACE_DASH] = ACTIONS(2601),
    [anon_sym_LBRACK_CARET] = ACTIONS(2601),
    [anon_sym_BANG_LBRACK] = ACTIONS(2601),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2601),
    [anon_sym_LPAREN] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2601),
    [anon_sym_TODO] = ACTIONS(2601),
    [anon_sym_WIP] = ACTIONS(2601),
    [anon_sym_NOTE] = ACTIONS(2601),
    [anon_sym_INFO] = ACTIONS(2601),
    [anon_sym_XXX] = ACTIONS(2601),
    [sym_fixme] = ACTIONS(2601),
    [aux_sym__text_token1] = ACTIONS(2603),
    [sym__block_close] = ACTIONS(2601),
    [sym__newline] = ACTIONS(2601),
    [sym__newline_inline] = ACTIONS(2601),
    [sym_hard_line_break] = ACTIONS(2601),
    [sym__heading_begin] = ACTIONS(2601),
    [sym__div_begin] = ACTIONS(2601),
    [sym__code_block_begin] = ACTIONS(2601),
    [sym_list_marker_dash] = ACTIONS(2601),
    [sym_list_marker_star] = ACTIONS(2601),
    [sym_list_marker_plus] = ACTIONS(2601),
    [sym__list_marker_task_begin] = ACTIONS(2601),
    [sym_list_marker_definition] = ACTIONS(2601),
    [sym_list_marker_decimal_period] = ACTIONS(2601),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2601),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2601),
    [sym_list_marker_lower_roman_period] = ACTIONS(2601),
    [sym_list_marker_upper_roman_period] = ACTIONS(2601),
    [sym_list_marker_decimal_paren] = ACTIONS(2601),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2601),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2601),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2601),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2601),
    [sym_list_marker_decimal_parens] = ACTIONS(2601),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2601),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2601),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2601),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2601),
    [sym__block_quote_begin] = ACTIONS(2601),
    [sym__block_quote_continuation] = ACTIONS(2601),
    [sym__thematic_break_dash] = ACTIONS(2601),
    [sym__thematic_break_star] = ACTIONS(2601),
    [sym__footnote_mark_begin] = ACTIONS(2601),
    [sym__link_ref_def_mark_begin] = ACTIONS(2601),
    [sym__table_header_begin] = ACTIONS(2601),
    [sym__table_separator_begin] = ACTIONS(2601),
    [sym__table_row_begin] = ACTIONS(2601),
    [sym__block_attribute_begin] = ACTIONS(2601),
    [sym__verbatim_begin] = ACTIONS(2601),
  },
  [408] = {
    [ts_builtin_sym_end] = ACTIONS(2657),
    [anon_sym_LBRACK] = ACTIONS(2659),
    [sym__whitespace1] = ACTIONS(2657),
    [sym_quotation_marks] = ACTIONS(2657),
    [sym_ellipsis] = ACTIONS(2657),
    [sym_em_dash] = ACTIONS(2657),
    [sym_en_dash] = ACTIONS(2659),
    [sym_backslash_escape] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(2657),
    [sym_symbol] = ACTIONS(2657),
    [anon_sym_LBRACE_] = ACTIONS(2657),
    [anon_sym__] = ACTIONS(2657),
    [anon_sym_LBRACE_STAR] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2657),
    [anon_sym_LBRACE_CARET] = ACTIONS(2657),
    [anon_sym_CARET] = ACTIONS(2657),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2657),
    [anon_sym_TILDE] = ACTIONS(2657),
    [anon_sym_LBRACE_EQ] = ACTIONS(2657),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2657),
    [anon_sym_LBRACE_DASH] = ACTIONS(2657),
    [anon_sym_LBRACK_CARET] = ACTIONS(2657),
    [anon_sym_BANG_LBRACK] = ACTIONS(2657),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(2657),
    [anon_sym_DOLLAR] = ACTIONS(2657),
    [anon_sym_TODO] = ACTIONS(2657),
    [anon_sym_WIP] = ACTIONS(2657),
    [anon_sym_NOTE] = ACTIONS(2657),
    [anon_sym_INFO] = ACTIONS(2657),
    [anon_sym_XXX] = ACTIONS(2657),
    [sym_fixme] = ACTIONS(2657),
    [aux_sym__text_token1] = ACTIONS(2659),
    [sym__newline] = ACTIONS(2657),
    [sym__newline_inline] = ACTIONS(2657),
    [sym_hard_line_break] = ACTIONS(2657),
    [sym__heading_begin] = ACTIONS(2657),
    [sym__div_begin] = ACTIONS(2657),
    [sym__code_block_begin] = ACTIONS(2657),
    [sym_list_marker_dash] = ACTIONS(2657),
    [sym_list_marker_star] = ACTIONS(2657),
    [sym_list_marker_plus] = ACTIONS(2657),
    [sym__list_marker_task_begin] = ACTIONS(2657),
    [sym_list_marker_definition] = ACTIONS(2657),
    [sym_list_marker_decimal_period] = ACTIONS(2657),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2657),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2657),
    [sym_list_marker_lower_roman_period] = ACTIONS(2657),
    [sym_list_marker_upper_roman_period] = ACTIONS(2657),
    [sym_list_marker_decimal_paren] = ACTIONS(2657),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2657),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2657),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2657),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2657),
    [sym_list_marker_decimal_parens] = ACTIONS(2657),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2657),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2657),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2657),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2657),
    [sym__block_quote_begin] = ACTIONS(2657),
    [sym__block_quote_continuation] = ACTIONS(2657),
    [sym__thematic_break_dash] = ACTIONS(2657),
    [sym__thematic_break_star] = ACTIONS(2657),
    [sym__footnote_mark_begin] = ACTIONS(2657),
    [sym__link_ref_def_mark_begin] = ACTIONS(2657),
    [sym__table_header_begin] = ACTIONS(2657),
    [sym__table_separator_begin] = ACTIONS(2657),
    [sym__table_row_begin] = ACTIONS(2657),
    [sym__block_attribute_begin] = ACTIONS(2657),
    [sym__verbatim_begin] = ACTIONS(2657),
  },
  [409] = {
    [ts_builtin_sym_end] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2603),
    [sym__whitespace1] = ACTIONS(2601),
    [sym_quotation_marks] = ACTIONS(2601),
    [sym_ellipsis] = ACTIONS(2601),
    [sym_em_dash] = ACTIONS(2601),
    [sym_en_dash] = ACTIONS(2603),
    [sym_backslash_escape] = ACTIONS(2603),
    [anon_sym_LT] = ACTIONS(2601),
    [sym_symbol] = ACTIONS(2601),
    [anon_sym_LBRACE_] = ACTIONS(2601),
    [anon_sym__] = ACTIONS(2601),
    [anon_sym_LBRACE_STAR] = ACTIONS(2601),
    [anon_sym_STAR] = ACTIONS(2601),
    [anon_sym_LBRACE_CARET] = ACTIONS(2601),
    [anon_sym_CARET] = ACTIONS(2601),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2601),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_LBRACE_EQ] = ACTIONS(2601),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2601),
    [anon_sym_LBRACE_DASH] = ACTIONS(2601),
    [anon_sym_LBRACK_CARET] = ACTIONS(2601),
    [anon_sym_BANG_LBRACK] = ACTIONS(2601),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2601),
    [anon_sym_LPAREN] = ACTIONS(2601),
    [anon_sym_DOLLAR] = ACTIONS(2601),
    [anon_sym_TODO] = ACTIONS(2601),
    [anon_sym_WIP] = ACTIONS(2601),
    [anon_sym_NOTE] = ACTIONS(2601),
    [anon_sym_INFO] = ACTIONS(2601),
    [anon_sym_XXX] = ACTIONS(2601),
    [sym_fixme] = ACTIONS(2601),
    [aux_sym__text_token1] = ACTIONS(2603),
    [sym__newline] = ACTIONS(2601),
    [sym__newline_inline] = ACTIONS(2601),
    [sym_hard_line_break] = ACTIONS(2601),
    [sym__heading_begin] = ACTIONS(2601),
    [sym__div_begin] = ACTIONS(2601),
    [sym__code_block_begin] = ACTIONS(2601),
    [sym_list_marker_dash] = ACTIONS(2601),
    [sym_list_marker_star] = ACTIONS(2601),
    [sym_list_marker_plus] = ACTIONS(2601),
    [sym__list_marker_task_begin] = ACTIONS(2601),
    [sym_list_marker_definition] = ACTIONS(2601),
    [sym_list_marker_decimal_period] = ACTIONS(2601),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2601),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2601),
    [sym_list_marker_lower_roman_period] = ACTIONS(2601),
    [sym_list_marker_upper_roman_period] = ACTIONS(2601),
    [sym_list_marker_decimal_paren] = ACTIONS(2601),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2601),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2601),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2601),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2601),
    [sym_list_marker_decimal_parens] = ACTIONS(2601),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2601),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2601),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2601),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2601),
    [sym__block_quote_begin] = ACTIONS(2601),
    [sym__block_quote_continuation] = ACTIONS(2601),
    [sym__thematic_break_dash] = ACTIONS(2601),
    [sym__thematic_break_star] = ACTIONS(2601),
    [sym__footnote_mark_begin] = ACTIONS(2601),
    [sym__link_ref_def_mark_begin] = ACTIONS(2601),
    [sym__table_header_begin] = ACTIONS(2601),
    [sym__table_separator_begin] = ACTIONS(2601),
    [sym__table_row_begin] = ACTIONS(2601),
    [sym__block_attribute_begin] = ACTIONS(2601),
    [sym__verbatim_begin] = ACTIONS(2601),
  },
  [410] = {
    [anon_sym_LBRACK] = ACTIONS(2571),
    [sym__whitespace1] = ACTIONS(2569),
    [sym_quotation_marks] = ACTIONS(2569),
    [sym_ellipsis] = ACTIONS(2569),
    [sym_em_dash] = ACTIONS(2569),
    [sym_en_dash] = ACTIONS(2571),
    [sym_backslash_escape] = ACTIONS(2571),
    [anon_sym_LT] = ACTIONS(2569),
    [sym_symbol] = ACTIONS(2569),
    [anon_sym_LBRACE_] = ACTIONS(2569),
    [anon_sym__] = ACTIONS(2569),
    [anon_sym_LBRACE_STAR] = ACTIONS(2569),
    [anon_sym_STAR] = ACTIONS(2569),
    [anon_sym_LBRACE_CARET] = ACTIONS(2569),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2569),
    [anon_sym_TILDE] = ACTIONS(2569),
    [anon_sym_LBRACE_EQ] = ACTIONS(2569),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2569),
    [anon_sym_LBRACE_DASH] = ACTIONS(2569),
    [anon_sym_LBRACK_CARET] = ACTIONS(2569),
    [anon_sym_BANG_LBRACK] = ACTIONS(2569),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2569),
    [anon_sym_TODO] = ACTIONS(2569),
    [anon_sym_WIP] = ACTIONS(2569),
    [anon_sym_NOTE] = ACTIONS(2569),
    [anon_sym_INFO] = ACTIONS(2569),
    [anon_sym_XXX] = ACTIONS(2569),
    [sym_fixme] = ACTIONS(2569),
    [aux_sym__text_token1] = ACTIONS(2571),
    [sym__block_close] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
    [sym__newline_inline] = ACTIONS(2569),
    [sym_hard_line_break] = ACTIONS(2569),
    [sym__heading_begin] = ACTIONS(2569),
    [sym__div_begin] = ACTIONS(2569),
    [sym__code_block_begin] = ACTIONS(2569),
    [sym_list_marker_dash] = ACTIONS(2569),
    [sym_list_marker_star] = ACTIONS(2569),
    [sym_list_marker_plus] = ACTIONS(2569),
    [sym__list_marker_task_begin] = ACTIONS(2569),
    [sym_list_marker_definition] = ACTIONS(2569),
    [sym_list_marker_decimal_period] = ACTIONS(2569),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2569),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2569),
    [sym_list_marker_lower_roman_period] = ACTIONS(2569),
    [sym_list_marker_upper_roman_period] = ACTIONS(2569),
    [sym_list_marker_decimal_paren] = ACTIONS(2569),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2569),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2569),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2569),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2569),
    [sym_list_marker_decimal_parens] = ACTIONS(2569),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2569),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2569),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2569),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2569),
    [sym__block_quote_begin] = ACTIONS(2569),
    [sym__block_quote_continuation] = ACTIONS(2569),
    [sym__thematic_break_dash] = ACTIONS(2569),
    [sym__thematic_break_star] = ACTIONS(2569),
    [sym__footnote_mark_begin] = ACTIONS(2569),
    [sym__link_ref_def_mark_begin] = ACTIONS(2569),
    [sym__table_header_begin] = ACTIONS(2569),
    [sym__table_separator_begin] = ACTIONS(2569),
    [sym__table_row_begin] = ACTIONS(2569),
    [sym__block_attribute_begin] = ACTIONS(2569),
    [sym__verbatim_begin] = ACTIONS(2569),
  },
  [411] = {
    [ts_builtin_sym_end] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2663),
    [sym__whitespace1] = ACTIONS(2661),
    [sym_quotation_marks] = ACTIONS(2661),
    [sym_ellipsis] = ACTIONS(2661),
    [sym_em_dash] = ACTIONS(2661),
    [sym_en_dash] = ACTIONS(2663),
    [sym_backslash_escape] = ACTIONS(2663),
    [anon_sym_LT] = ACTIONS(2661),
    [sym_symbol] = ACTIONS(2661),
    [anon_sym_LBRACE_] = ACTIONS(2661),
    [anon_sym__] = ACTIONS(2661),
    [anon_sym_LBRACE_STAR] = ACTIONS(2661),
    [anon_sym_STAR] = ACTIONS(2661),
    [anon_sym_LBRACE_CARET] = ACTIONS(2661),
    [anon_sym_CARET] = ACTIONS(2661),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [anon_sym_LBRACE_EQ] = ACTIONS(2661),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2661),
    [anon_sym_LBRACE_DASH] = ACTIONS(2661),
    [anon_sym_LBRACK_CARET] = ACTIONS(2661),
    [anon_sym_BANG_LBRACK] = ACTIONS(2661),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2661),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_DOLLAR] = ACTIONS(2661),
    [anon_sym_TODO] = ACTIONS(2661),
    [anon_sym_WIP] = ACTIONS(2661),
    [anon_sym_NOTE] = ACTIONS(2661),
    [anon_sym_INFO] = ACTIONS(2661),
    [anon_sym_XXX] = ACTIONS(2661),
    [sym_fixme] = ACTIONS(2661),
    [aux_sym__text_token1] = ACTIONS(2663),
    [sym__newline] = ACTIONS(2661),
    [sym__newline_inline] = ACTIONS(2661),
    [sym_hard_line_break] = ACTIONS(2661),
    [sym__heading_begin] = ACTIONS(2661),
    [sym__div_begin] = ACTIONS(2661),
    [sym__code_block_begin] = ACTIONS(2661),
    [sym_list_marker_dash] = ACTIONS(2661),
    [sym_list_marker_star] = ACTIONS(2661),
    [sym_list_marker_plus] = ACTIONS(2661),
    [sym__list_marker_task_begin] = ACTIONS(2661),
    [sym_list_marker_definition] = ACTIONS(2661),
    [sym_list_marker_decimal_period] = ACTIONS(2661),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2661),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2661),
    [sym_list_marker_lower_roman_period] = ACTIONS(2661),
    [sym_list_marker_upper_roman_period] = ACTIONS(2661),
    [sym_list_marker_decimal_paren] = ACTIONS(2661),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2661),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2661),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2661),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2661),
    [sym_list_marker_decimal_parens] = ACTIONS(2661),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2661),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2661),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2661),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2661),
    [sym__block_quote_begin] = ACTIONS(2661),
    [sym__block_quote_continuation] = ACTIONS(2661),
    [sym__thematic_break_dash] = ACTIONS(2661),
    [sym__thematic_break_star] = ACTIONS(2661),
    [sym__footnote_mark_begin] = ACTIONS(2661),
    [sym__link_ref_def_mark_begin] = ACTIONS(2661),
    [sym__table_header_begin] = ACTIONS(2661),
    [sym__table_separator_begin] = ACTIONS(2661),
    [sym__table_row_begin] = ACTIONS(2661),
    [sym__block_attribute_begin] = ACTIONS(2661),
    [sym__verbatim_begin] = ACTIONS(2661),
  },
  [412] = {
    [anon_sym_LBRACK] = ACTIONS(2599),
    [sym__whitespace1] = ACTIONS(2597),
    [sym_quotation_marks] = ACTIONS(2597),
    [sym_ellipsis] = ACTIONS(2597),
    [sym_em_dash] = ACTIONS(2597),
    [sym_en_dash] = ACTIONS(2599),
    [sym_backslash_escape] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(2597),
    [sym_symbol] = ACTIONS(2597),
    [anon_sym_LBRACE_] = ACTIONS(2597),
    [anon_sym__] = ACTIONS(2597),
    [anon_sym_LBRACE_STAR] = ACTIONS(2597),
    [anon_sym_STAR] = ACTIONS(2597),
    [anon_sym_LBRACE_CARET] = ACTIONS(2597),
    [anon_sym_CARET] = ACTIONS(2597),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2597),
    [anon_sym_TILDE] = ACTIONS(2597),
    [anon_sym_LBRACE_EQ] = ACTIONS(2597),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2597),
    [anon_sym_LBRACE_DASH] = ACTIONS(2597),
    [anon_sym_LBRACK_CARET] = ACTIONS(2597),
    [anon_sym_BANG_LBRACK] = ACTIONS(2597),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2597),
    [anon_sym_LPAREN] = ACTIONS(2597),
    [anon_sym_DOLLAR] = ACTIONS(2597),
    [anon_sym_TODO] = ACTIONS(2597),
    [anon_sym_WIP] = ACTIONS(2597),
    [anon_sym_NOTE] = ACTIONS(2597),
    [anon_sym_INFO] = ACTIONS(2597),
    [anon_sym_XXX] = ACTIONS(2597),
    [sym_fixme] = ACTIONS(2597),
    [aux_sym__text_token1] = ACTIONS(2599),
    [sym__block_close] = ACTIONS(2597),
    [sym__newline] = ACTIONS(2597),
    [sym__newline_inline] = ACTIONS(2597),
    [sym_hard_line_break] = ACTIONS(2597),
    [sym__heading_begin] = ACTIONS(2597),
    [sym__div_begin] = ACTIONS(2597),
    [sym__code_block_begin] = ACTIONS(2597),
    [sym_list_marker_dash] = ACTIONS(2597),
    [sym_list_marker_star] = ACTIONS(2597),
    [sym_list_marker_plus] = ACTIONS(2597),
    [sym__list_marker_task_begin] = ACTIONS(2597),
    [sym_list_marker_definition] = ACTIONS(2597),
    [sym_list_marker_decimal_period] = ACTIONS(2597),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2597),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2597),
    [sym_list_marker_lower_roman_period] = ACTIONS(2597),
    [sym_list_marker_upper_roman_period] = ACTIONS(2597),
    [sym_list_marker_decimal_paren] = ACTIONS(2597),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2597),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2597),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2597),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2597),
    [sym_list_marker_decimal_parens] = ACTIONS(2597),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2597),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2597),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2597),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2597),
    [sym__block_quote_begin] = ACTIONS(2597),
    [sym__block_quote_continuation] = ACTIONS(2597),
    [sym__thematic_break_dash] = ACTIONS(2597),
    [sym__thematic_break_star] = ACTIONS(2597),
    [sym__footnote_mark_begin] = ACTIONS(2597),
    [sym__link_ref_def_mark_begin] = ACTIONS(2597),
    [sym__table_header_begin] = ACTIONS(2597),
    [sym__table_separator_begin] = ACTIONS(2597),
    [sym__table_row_begin] = ACTIONS(2597),
    [sym__block_attribute_begin] = ACTIONS(2597),
    [sym__verbatim_begin] = ACTIONS(2597),
  },
  [413] = {
    [ts_builtin_sym_end] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2667),
    [sym__whitespace1] = ACTIONS(2665),
    [sym_quotation_marks] = ACTIONS(2665),
    [sym_ellipsis] = ACTIONS(2665),
    [sym_em_dash] = ACTIONS(2665),
    [sym_en_dash] = ACTIONS(2667),
    [sym_backslash_escape] = ACTIONS(2667),
    [anon_sym_LT] = ACTIONS(2665),
    [sym_symbol] = ACTIONS(2665),
    [anon_sym_LBRACE_] = ACTIONS(2665),
    [anon_sym__] = ACTIONS(2665),
    [anon_sym_LBRACE_STAR] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2665),
    [anon_sym_LBRACE_CARET] = ACTIONS(2665),
    [anon_sym_CARET] = ACTIONS(2665),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2665),
    [anon_sym_TILDE] = ACTIONS(2665),
    [anon_sym_LBRACE_EQ] = ACTIONS(2665),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2665),
    [anon_sym_LBRACE_DASH] = ACTIONS(2665),
    [anon_sym_LBRACK_CARET] = ACTIONS(2665),
    [anon_sym_BANG_LBRACK] = ACTIONS(2665),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2665),
    [anon_sym_LPAREN] = ACTIONS(2665),
    [anon_sym_DOLLAR] = ACTIONS(2665),
    [anon_sym_TODO] = ACTIONS(2665),
    [anon_sym_WIP] = ACTIONS(2665),
    [anon_sym_NOTE] = ACTIONS(2665),
    [anon_sym_INFO] = ACTIONS(2665),
    [anon_sym_XXX] = ACTIONS(2665),
    [sym_fixme] = ACTIONS(2665),
    [aux_sym__text_token1] = ACTIONS(2667),
    [sym__newline] = ACTIONS(2665),
    [sym__newline_inline] = ACTIONS(2665),
    [sym_hard_line_break] = ACTIONS(2665),
    [sym__heading_begin] = ACTIONS(2665),
    [sym__div_begin] = ACTIONS(2665),
    [sym__code_block_begin] = ACTIONS(2665),
    [sym_list_marker_dash] = ACTIONS(2665),
    [sym_list_marker_star] = ACTIONS(2665),
    [sym_list_marker_plus] = ACTIONS(2665),
    [sym__list_marker_task_begin] = ACTIONS(2665),
    [sym_list_marker_definition] = ACTIONS(2665),
    [sym_list_marker_decimal_period] = ACTIONS(2665),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2665),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2665),
    [sym_list_marker_lower_roman_period] = ACTIONS(2665),
    [sym_list_marker_upper_roman_period] = ACTIONS(2665),
    [sym_list_marker_decimal_paren] = ACTIONS(2665),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2665),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2665),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2665),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2665),
    [sym_list_marker_decimal_parens] = ACTIONS(2665),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2665),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2665),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2665),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2665),
    [sym__block_quote_begin] = ACTIONS(2665),
    [sym__block_quote_continuation] = ACTIONS(2665),
    [sym__thematic_break_dash] = ACTIONS(2665),
    [sym__thematic_break_star] = ACTIONS(2665),
    [sym__footnote_mark_begin] = ACTIONS(2665),
    [sym__link_ref_def_mark_begin] = ACTIONS(2665),
    [sym__table_header_begin] = ACTIONS(2665),
    [sym__table_separator_begin] = ACTIONS(2665),
    [sym__table_row_begin] = ACTIONS(2665),
    [sym__block_attribute_begin] = ACTIONS(2665),
    [sym__verbatim_begin] = ACTIONS(2665),
  },
  [414] = {
    [anon_sym_LBRACK] = ACTIONS(2607),
    [sym__whitespace1] = ACTIONS(2605),
    [sym_quotation_marks] = ACTIONS(2605),
    [sym_ellipsis] = ACTIONS(2605),
    [sym_em_dash] = ACTIONS(2605),
    [sym_en_dash] = ACTIONS(2607),
    [sym_backslash_escape] = ACTIONS(2607),
    [anon_sym_LT] = ACTIONS(2605),
    [sym_symbol] = ACTIONS(2605),
    [anon_sym_LBRACE_] = ACTIONS(2605),
    [anon_sym__] = ACTIONS(2605),
    [anon_sym_LBRACE_STAR] = ACTIONS(2605),
    [anon_sym_STAR] = ACTIONS(2605),
    [anon_sym_LBRACE_CARET] = ACTIONS(2605),
    [anon_sym_CARET] = ACTIONS(2605),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2605),
    [anon_sym_TILDE] = ACTIONS(2605),
    [anon_sym_LBRACE_EQ] = ACTIONS(2605),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2605),
    [anon_sym_LBRACE_DASH] = ACTIONS(2605),
    [anon_sym_LBRACK_CARET] = ACTIONS(2605),
    [anon_sym_BANG_LBRACK] = ACTIONS(2605),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2605),
    [anon_sym_LPAREN] = ACTIONS(2605),
    [anon_sym_DOLLAR] = ACTIONS(2605),
    [anon_sym_TODO] = ACTIONS(2605),
    [anon_sym_WIP] = ACTIONS(2605),
    [anon_sym_NOTE] = ACTIONS(2605),
    [anon_sym_INFO] = ACTIONS(2605),
    [anon_sym_XXX] = ACTIONS(2605),
    [sym_fixme] = ACTIONS(2605),
    [aux_sym__text_token1] = ACTIONS(2607),
    [sym__block_close] = ACTIONS(2605),
    [sym__newline] = ACTIONS(2605),
    [sym__newline_inline] = ACTIONS(2605),
    [sym_hard_line_break] = ACTIONS(2605),
    [sym__heading_begin] = ACTIONS(2605),
    [sym__div_begin] = ACTIONS(2605),
    [sym__code_block_begin] = ACTIONS(2605),
    [sym_list_marker_dash] = ACTIONS(2605),
    [sym_list_marker_star] = ACTIONS(2605),
    [sym_list_marker_plus] = ACTIONS(2605),
    [sym__list_marker_task_begin] = ACTIONS(2605),
    [sym_list_marker_definition] = ACTIONS(2605),
    [sym_list_marker_decimal_period] = ACTIONS(2605),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2605),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2605),
    [sym_list_marker_lower_roman_period] = ACTIONS(2605),
    [sym_list_marker_upper_roman_period] = ACTIONS(2605),
    [sym_list_marker_decimal_paren] = ACTIONS(2605),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2605),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2605),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2605),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2605),
    [sym_list_marker_decimal_parens] = ACTIONS(2605),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2605),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2605),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2605),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2605),
    [sym__block_quote_begin] = ACTIONS(2605),
    [sym__block_quote_continuation] = ACTIONS(2605),
    [sym__thematic_break_dash] = ACTIONS(2605),
    [sym__thematic_break_star] = ACTIONS(2605),
    [sym__footnote_mark_begin] = ACTIONS(2605),
    [sym__link_ref_def_mark_begin] = ACTIONS(2605),
    [sym__table_header_begin] = ACTIONS(2605),
    [sym__table_separator_begin] = ACTIONS(2605),
    [sym__table_row_begin] = ACTIONS(2605),
    [sym__block_attribute_begin] = ACTIONS(2605),
    [sym__verbatim_begin] = ACTIONS(2605),
  },
  [415] = {
    [anon_sym_LBRACK] = ACTIONS(2619),
    [sym__whitespace1] = ACTIONS(2617),
    [sym_quotation_marks] = ACTIONS(2617),
    [sym_ellipsis] = ACTIONS(2617),
    [sym_em_dash] = ACTIONS(2617),
    [sym_en_dash] = ACTIONS(2619),
    [sym_backslash_escape] = ACTIONS(2619),
    [anon_sym_LT] = ACTIONS(2617),
    [sym_symbol] = ACTIONS(2617),
    [anon_sym_LBRACE_] = ACTIONS(2617),
    [anon_sym__] = ACTIONS(2617),
    [anon_sym_LBRACE_STAR] = ACTIONS(2617),
    [anon_sym_STAR] = ACTIONS(2617),
    [anon_sym_LBRACE_CARET] = ACTIONS(2617),
    [anon_sym_CARET] = ACTIONS(2617),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2617),
    [anon_sym_TILDE] = ACTIONS(2617),
    [anon_sym_LBRACE_EQ] = ACTIONS(2617),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2617),
    [anon_sym_LBRACE_DASH] = ACTIONS(2617),
    [anon_sym_LBRACK_CARET] = ACTIONS(2617),
    [anon_sym_BANG_LBRACK] = ACTIONS(2617),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2617),
    [anon_sym_LPAREN] = ACTIONS(2617),
    [anon_sym_DOLLAR] = ACTIONS(2617),
    [anon_sym_TODO] = ACTIONS(2617),
    [anon_sym_WIP] = ACTIONS(2617),
    [anon_sym_NOTE] = ACTIONS(2617),
    [anon_sym_INFO] = ACTIONS(2617),
    [anon_sym_XXX] = ACTIONS(2617),
    [sym_fixme] = ACTIONS(2617),
    [aux_sym__text_token1] = ACTIONS(2619),
    [sym__block_close] = ACTIONS(2617),
    [sym__newline] = ACTIONS(2617),
    [sym__newline_inline] = ACTIONS(2617),
    [sym_hard_line_break] = ACTIONS(2617),
    [sym__heading_begin] = ACTIONS(2617),
    [sym__div_begin] = ACTIONS(2617),
    [sym__code_block_begin] = ACTIONS(2617),
    [sym_list_marker_dash] = ACTIONS(2617),
    [sym_list_marker_star] = ACTIONS(2617),
    [sym_list_marker_plus] = ACTIONS(2617),
    [sym__list_marker_task_begin] = ACTIONS(2617),
    [sym_list_marker_definition] = ACTIONS(2617),
    [sym_list_marker_decimal_period] = ACTIONS(2617),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2617),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2617),
    [sym_list_marker_lower_roman_period] = ACTIONS(2617),
    [sym_list_marker_upper_roman_period] = ACTIONS(2617),
    [sym_list_marker_decimal_paren] = ACTIONS(2617),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2617),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2617),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2617),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2617),
    [sym_list_marker_decimal_parens] = ACTIONS(2617),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2617),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2617),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2617),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2617),
    [sym__block_quote_begin] = ACTIONS(2617),
    [sym__block_quote_continuation] = ACTIONS(2617),
    [sym__thematic_break_dash] = ACTIONS(2617),
    [sym__thematic_break_star] = ACTIONS(2617),
    [sym__footnote_mark_begin] = ACTIONS(2617),
    [sym__link_ref_def_mark_begin] = ACTIONS(2617),
    [sym__table_header_begin] = ACTIONS(2617),
    [sym__table_separator_begin] = ACTIONS(2617),
    [sym__table_row_begin] = ACTIONS(2617),
    [sym__block_attribute_begin] = ACTIONS(2617),
    [sym__verbatim_begin] = ACTIONS(2617),
  },
  [416] = {
    [anon_sym_LBRACK] = ACTIONS(2623),
    [sym__whitespace1] = ACTIONS(2621),
    [sym_quotation_marks] = ACTIONS(2621),
    [sym_ellipsis] = ACTIONS(2621),
    [sym_em_dash] = ACTIONS(2621),
    [sym_en_dash] = ACTIONS(2623),
    [sym_backslash_escape] = ACTIONS(2623),
    [anon_sym_LT] = ACTIONS(2621),
    [sym_symbol] = ACTIONS(2621),
    [anon_sym_LBRACE_] = ACTIONS(2621),
    [anon_sym__] = ACTIONS(2621),
    [anon_sym_LBRACE_STAR] = ACTIONS(2621),
    [anon_sym_STAR] = ACTIONS(2621),
    [anon_sym_LBRACE_CARET] = ACTIONS(2621),
    [anon_sym_CARET] = ACTIONS(2621),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2621),
    [anon_sym_TILDE] = ACTIONS(2621),
    [anon_sym_LBRACE_EQ] = ACTIONS(2621),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2621),
    [anon_sym_LBRACE_DASH] = ACTIONS(2621),
    [anon_sym_LBRACK_CARET] = ACTIONS(2621),
    [anon_sym_BANG_LBRACK] = ACTIONS(2621),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2621),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_DOLLAR] = ACTIONS(2621),
    [anon_sym_TODO] = ACTIONS(2621),
    [anon_sym_WIP] = ACTIONS(2621),
    [anon_sym_NOTE] = ACTIONS(2621),
    [anon_sym_INFO] = ACTIONS(2621),
    [anon_sym_XXX] = ACTIONS(2621),
    [sym_fixme] = ACTIONS(2621),
    [aux_sym__text_token1] = ACTIONS(2623),
    [sym__block_close] = ACTIONS(2621),
    [sym__newline] = ACTIONS(2621),
    [sym__newline_inline] = ACTIONS(2621),
    [sym_hard_line_break] = ACTIONS(2621),
    [sym__heading_begin] = ACTIONS(2621),
    [sym__div_begin] = ACTIONS(2621),
    [sym__code_block_begin] = ACTIONS(2621),
    [sym_list_marker_dash] = ACTIONS(2621),
    [sym_list_marker_star] = ACTIONS(2621),
    [sym_list_marker_plus] = ACTIONS(2621),
    [sym__list_marker_task_begin] = ACTIONS(2621),
    [sym_list_marker_definition] = ACTIONS(2621),
    [sym_list_marker_decimal_period] = ACTIONS(2621),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2621),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2621),
    [sym_list_marker_lower_roman_period] = ACTIONS(2621),
    [sym_list_marker_upper_roman_period] = ACTIONS(2621),
    [sym_list_marker_decimal_paren] = ACTIONS(2621),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2621),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2621),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2621),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2621),
    [sym_list_marker_decimal_parens] = ACTIONS(2621),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2621),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2621),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2621),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2621),
    [sym__block_quote_begin] = ACTIONS(2621),
    [sym__block_quote_continuation] = ACTIONS(2621),
    [sym__thematic_break_dash] = ACTIONS(2621),
    [sym__thematic_break_star] = ACTIONS(2621),
    [sym__footnote_mark_begin] = ACTIONS(2621),
    [sym__link_ref_def_mark_begin] = ACTIONS(2621),
    [sym__table_header_begin] = ACTIONS(2621),
    [sym__table_separator_begin] = ACTIONS(2621),
    [sym__table_row_begin] = ACTIONS(2621),
    [sym__block_attribute_begin] = ACTIONS(2621),
    [sym__verbatim_begin] = ACTIONS(2621),
  },
  [417] = {
    [anon_sym_LBRACK] = ACTIONS(2631),
    [sym__whitespace1] = ACTIONS(2629),
    [sym_quotation_marks] = ACTIONS(2629),
    [sym_ellipsis] = ACTIONS(2629),
    [sym_em_dash] = ACTIONS(2629),
    [sym_en_dash] = ACTIONS(2631),
    [sym_backslash_escape] = ACTIONS(2631),
    [anon_sym_LT] = ACTIONS(2629),
    [sym_symbol] = ACTIONS(2629),
    [anon_sym_LBRACE_] = ACTIONS(2629),
    [anon_sym__] = ACTIONS(2629),
    [anon_sym_LBRACE_STAR] = ACTIONS(2629),
    [anon_sym_STAR] = ACTIONS(2629),
    [anon_sym_LBRACE_CARET] = ACTIONS(2629),
    [anon_sym_CARET] = ACTIONS(2629),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2629),
    [anon_sym_TILDE] = ACTIONS(2629),
    [anon_sym_LBRACE_EQ] = ACTIONS(2629),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2629),
    [anon_sym_LBRACE_DASH] = ACTIONS(2629),
    [anon_sym_LBRACK_CARET] = ACTIONS(2629),
    [anon_sym_BANG_LBRACK] = ACTIONS(2629),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2629),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_DOLLAR] = ACTIONS(2629),
    [anon_sym_TODO] = ACTIONS(2629),
    [anon_sym_WIP] = ACTIONS(2629),
    [anon_sym_NOTE] = ACTIONS(2629),
    [anon_sym_INFO] = ACTIONS(2629),
    [anon_sym_XXX] = ACTIONS(2629),
    [sym_fixme] = ACTIONS(2629),
    [aux_sym__text_token1] = ACTIONS(2631),
    [sym__block_close] = ACTIONS(2629),
    [sym__newline] = ACTIONS(2629),
    [sym__newline_inline] = ACTIONS(2629),
    [sym_hard_line_break] = ACTIONS(2629),
    [sym__heading_begin] = ACTIONS(2629),
    [sym__div_begin] = ACTIONS(2629),
    [sym__code_block_begin] = ACTIONS(2629),
    [sym_list_marker_dash] = ACTIONS(2629),
    [sym_list_marker_star] = ACTIONS(2629),
    [sym_list_marker_plus] = ACTIONS(2629),
    [sym__list_marker_task_begin] = ACTIONS(2629),
    [sym_list_marker_definition] = ACTIONS(2629),
    [sym_list_marker_decimal_period] = ACTIONS(2629),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2629),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2629),
    [sym_list_marker_lower_roman_period] = ACTIONS(2629),
    [sym_list_marker_upper_roman_period] = ACTIONS(2629),
    [sym_list_marker_decimal_paren] = ACTIONS(2629),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2629),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2629),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2629),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2629),
    [sym_list_marker_decimal_parens] = ACTIONS(2629),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2629),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2629),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2629),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2629),
    [sym__block_quote_begin] = ACTIONS(2629),
    [sym__block_quote_continuation] = ACTIONS(2629),
    [sym__thematic_break_dash] = ACTIONS(2629),
    [sym__thematic_break_star] = ACTIONS(2629),
    [sym__footnote_mark_begin] = ACTIONS(2629),
    [sym__link_ref_def_mark_begin] = ACTIONS(2629),
    [sym__table_header_begin] = ACTIONS(2629),
    [sym__table_separator_begin] = ACTIONS(2629),
    [sym__table_row_begin] = ACTIONS(2629),
    [sym__block_attribute_begin] = ACTIONS(2629),
    [sym__verbatim_begin] = ACTIONS(2629),
  },
  [418] = {
    [anon_sym_LBRACK] = ACTIONS(2635),
    [sym__whitespace1] = ACTIONS(2633),
    [sym_quotation_marks] = ACTIONS(2633),
    [sym_ellipsis] = ACTIONS(2633),
    [sym_em_dash] = ACTIONS(2633),
    [sym_en_dash] = ACTIONS(2635),
    [sym_backslash_escape] = ACTIONS(2635),
    [anon_sym_LT] = ACTIONS(2633),
    [sym_symbol] = ACTIONS(2633),
    [anon_sym_LBRACE_] = ACTIONS(2633),
    [anon_sym__] = ACTIONS(2633),
    [anon_sym_LBRACE_STAR] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_LBRACE_CARET] = ACTIONS(2633),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2633),
    [anon_sym_TILDE] = ACTIONS(2633),
    [anon_sym_LBRACE_EQ] = ACTIONS(2633),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2633),
    [anon_sym_LBRACE_DASH] = ACTIONS(2633),
    [anon_sym_LBRACK_CARET] = ACTIONS(2633),
    [anon_sym_BANG_LBRACK] = ACTIONS(2633),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2633),
    [anon_sym_LPAREN] = ACTIONS(2633),
    [anon_sym_DOLLAR] = ACTIONS(2633),
    [anon_sym_TODO] = ACTIONS(2633),
    [anon_sym_WIP] = ACTIONS(2633),
    [anon_sym_NOTE] = ACTIONS(2633),
    [anon_sym_INFO] = ACTIONS(2633),
    [anon_sym_XXX] = ACTIONS(2633),
    [sym_fixme] = ACTIONS(2633),
    [aux_sym__text_token1] = ACTIONS(2635),
    [sym__block_close] = ACTIONS(2633),
    [sym__newline] = ACTIONS(2633),
    [sym__newline_inline] = ACTIONS(2633),
    [sym_hard_line_break] = ACTIONS(2633),
    [sym__heading_begin] = ACTIONS(2633),
    [sym__div_begin] = ACTIONS(2633),
    [sym__code_block_begin] = ACTIONS(2633),
    [sym_list_marker_dash] = ACTIONS(2633),
    [sym_list_marker_star] = ACTIONS(2633),
    [sym_list_marker_plus] = ACTIONS(2633),
    [sym__list_marker_task_begin] = ACTIONS(2633),
    [sym_list_marker_definition] = ACTIONS(2633),
    [sym_list_marker_decimal_period] = ACTIONS(2633),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2633),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2633),
    [sym_list_marker_lower_roman_period] = ACTIONS(2633),
    [sym_list_marker_upper_roman_period] = ACTIONS(2633),
    [sym_list_marker_decimal_paren] = ACTIONS(2633),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2633),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2633),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2633),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2633),
    [sym_list_marker_decimal_parens] = ACTIONS(2633),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2633),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2633),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2633),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2633),
    [sym__block_quote_begin] = ACTIONS(2633),
    [sym__block_quote_continuation] = ACTIONS(2633),
    [sym__thematic_break_dash] = ACTIONS(2633),
    [sym__thematic_break_star] = ACTIONS(2633),
    [sym__footnote_mark_begin] = ACTIONS(2633),
    [sym__link_ref_def_mark_begin] = ACTIONS(2633),
    [sym__table_header_begin] = ACTIONS(2633),
    [sym__table_separator_begin] = ACTIONS(2633),
    [sym__table_row_begin] = ACTIONS(2633),
    [sym__block_attribute_begin] = ACTIONS(2633),
    [sym__verbatim_begin] = ACTIONS(2633),
  },
  [419] = {
    [anon_sym_LBRACK] = ACTIONS(2639),
    [sym__whitespace1] = ACTIONS(2637),
    [sym_quotation_marks] = ACTIONS(2637),
    [sym_ellipsis] = ACTIONS(2637),
    [sym_em_dash] = ACTIONS(2637),
    [sym_en_dash] = ACTIONS(2639),
    [sym_backslash_escape] = ACTIONS(2639),
    [anon_sym_LT] = ACTIONS(2637),
    [sym_symbol] = ACTIONS(2637),
    [anon_sym_LBRACE_] = ACTIONS(2637),
    [anon_sym__] = ACTIONS(2637),
    [anon_sym_LBRACE_STAR] = ACTIONS(2637),
    [anon_sym_STAR] = ACTIONS(2637),
    [anon_sym_LBRACE_CARET] = ACTIONS(2637),
    [anon_sym_CARET] = ACTIONS(2637),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2637),
    [anon_sym_TILDE] = ACTIONS(2637),
    [anon_sym_LBRACE_EQ] = ACTIONS(2637),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2637),
    [anon_sym_LBRACE_DASH] = ACTIONS(2637),
    [anon_sym_LBRACK_CARET] = ACTIONS(2637),
    [anon_sym_BANG_LBRACK] = ACTIONS(2637),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2637),
    [anon_sym_LPAREN] = ACTIONS(2637),
    [anon_sym_DOLLAR] = ACTIONS(2637),
    [anon_sym_TODO] = ACTIONS(2637),
    [anon_sym_WIP] = ACTIONS(2637),
    [anon_sym_NOTE] = ACTIONS(2637),
    [anon_sym_INFO] = ACTIONS(2637),
    [anon_sym_XXX] = ACTIONS(2637),
    [sym_fixme] = ACTIONS(2637),
    [aux_sym__text_token1] = ACTIONS(2639),
    [sym__block_close] = ACTIONS(2637),
    [sym__newline] = ACTIONS(2637),
    [sym__newline_inline] = ACTIONS(2637),
    [sym_hard_line_break] = ACTIONS(2637),
    [sym__heading_begin] = ACTIONS(2637),
    [sym__div_begin] = ACTIONS(2637),
    [sym__code_block_begin] = ACTIONS(2637),
    [sym_list_marker_dash] = ACTIONS(2637),
    [sym_list_marker_star] = ACTIONS(2637),
    [sym_list_marker_plus] = ACTIONS(2637),
    [sym__list_marker_task_begin] = ACTIONS(2637),
    [sym_list_marker_definition] = ACTIONS(2637),
    [sym_list_marker_decimal_period] = ACTIONS(2637),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2637),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2637),
    [sym_list_marker_lower_roman_period] = ACTIONS(2637),
    [sym_list_marker_upper_roman_period] = ACTIONS(2637),
    [sym_list_marker_decimal_paren] = ACTIONS(2637),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2637),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2637),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2637),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2637),
    [sym_list_marker_decimal_parens] = ACTIONS(2637),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2637),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2637),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2637),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2637),
    [sym__block_quote_begin] = ACTIONS(2637),
    [sym__block_quote_continuation] = ACTIONS(2637),
    [sym__thematic_break_dash] = ACTIONS(2637),
    [sym__thematic_break_star] = ACTIONS(2637),
    [sym__footnote_mark_begin] = ACTIONS(2637),
    [sym__link_ref_def_mark_begin] = ACTIONS(2637),
    [sym__table_header_begin] = ACTIONS(2637),
    [sym__table_separator_begin] = ACTIONS(2637),
    [sym__table_row_begin] = ACTIONS(2637),
    [sym__block_attribute_begin] = ACTIONS(2637),
    [sym__verbatim_begin] = ACTIONS(2637),
  },
  [420] = {
    [anon_sym_LBRACK] = ACTIONS(2643),
    [sym__whitespace1] = ACTIONS(2641),
    [sym_quotation_marks] = ACTIONS(2641),
    [sym_ellipsis] = ACTIONS(2641),
    [sym_em_dash] = ACTIONS(2641),
    [sym_en_dash] = ACTIONS(2643),
    [sym_backslash_escape] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2641),
    [sym_symbol] = ACTIONS(2641),
    [anon_sym_LBRACE_] = ACTIONS(2641),
    [anon_sym__] = ACTIONS(2641),
    [anon_sym_LBRACE_STAR] = ACTIONS(2641),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_LBRACE_CARET] = ACTIONS(2641),
    [anon_sym_CARET] = ACTIONS(2641),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_LBRACE_EQ] = ACTIONS(2641),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2641),
    [anon_sym_LBRACE_DASH] = ACTIONS(2641),
    [anon_sym_LBRACK_CARET] = ACTIONS(2641),
    [anon_sym_BANG_LBRACK] = ACTIONS(2641),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2641),
    [anon_sym_LPAREN] = ACTIONS(2641),
    [anon_sym_DOLLAR] = ACTIONS(2641),
    [anon_sym_TODO] = ACTIONS(2641),
    [anon_sym_WIP] = ACTIONS(2641),
    [anon_sym_NOTE] = ACTIONS(2641),
    [anon_sym_INFO] = ACTIONS(2641),
    [anon_sym_XXX] = ACTIONS(2641),
    [sym_fixme] = ACTIONS(2641),
    [aux_sym__text_token1] = ACTIONS(2643),
    [sym__block_close] = ACTIONS(2641),
    [sym__newline] = ACTIONS(2641),
    [sym__newline_inline] = ACTIONS(2641),
    [sym_hard_line_break] = ACTIONS(2641),
    [sym__heading_begin] = ACTIONS(2641),
    [sym__div_begin] = ACTIONS(2641),
    [sym__code_block_begin] = ACTIONS(2641),
    [sym_list_marker_dash] = ACTIONS(2641),
    [sym_list_marker_star] = ACTIONS(2641),
    [sym_list_marker_plus] = ACTIONS(2641),
    [sym__list_marker_task_begin] = ACTIONS(2641),
    [sym_list_marker_definition] = ACTIONS(2641),
    [sym_list_marker_decimal_period] = ACTIONS(2641),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2641),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2641),
    [sym_list_marker_lower_roman_period] = ACTIONS(2641),
    [sym_list_marker_upper_roman_period] = ACTIONS(2641),
    [sym_list_marker_decimal_paren] = ACTIONS(2641),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2641),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2641),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2641),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2641),
    [sym_list_marker_decimal_parens] = ACTIONS(2641),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2641),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2641),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2641),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2641),
    [sym__block_quote_begin] = ACTIONS(2641),
    [sym__block_quote_continuation] = ACTIONS(2641),
    [sym__thematic_break_dash] = ACTIONS(2641),
    [sym__thematic_break_star] = ACTIONS(2641),
    [sym__footnote_mark_begin] = ACTIONS(2641),
    [sym__link_ref_def_mark_begin] = ACTIONS(2641),
    [sym__table_header_begin] = ACTIONS(2641),
    [sym__table_separator_begin] = ACTIONS(2641),
    [sym__table_row_begin] = ACTIONS(2641),
    [sym__block_attribute_begin] = ACTIONS(2641),
    [sym__verbatim_begin] = ACTIONS(2641),
  },
  [421] = {
    [anon_sym_LBRACK] = ACTIONS(2647),
    [sym__whitespace1] = ACTIONS(2645),
    [sym_quotation_marks] = ACTIONS(2645),
    [sym_ellipsis] = ACTIONS(2645),
    [sym_em_dash] = ACTIONS(2645),
    [sym_en_dash] = ACTIONS(2647),
    [sym_backslash_escape] = ACTIONS(2647),
    [anon_sym_LT] = ACTIONS(2645),
    [sym_symbol] = ACTIONS(2645),
    [anon_sym_LBRACE_] = ACTIONS(2645),
    [anon_sym__] = ACTIONS(2645),
    [anon_sym_LBRACE_STAR] = ACTIONS(2645),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_LBRACE_CARET] = ACTIONS(2645),
    [anon_sym_CARET] = ACTIONS(2645),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_LBRACE_EQ] = ACTIONS(2645),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2645),
    [anon_sym_LBRACE_DASH] = ACTIONS(2645),
    [anon_sym_LBRACK_CARET] = ACTIONS(2645),
    [anon_sym_BANG_LBRACK] = ACTIONS(2645),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2645),
    [anon_sym_DOLLAR] = ACTIONS(2645),
    [anon_sym_TODO] = ACTIONS(2645),
    [anon_sym_WIP] = ACTIONS(2645),
    [anon_sym_NOTE] = ACTIONS(2645),
    [anon_sym_INFO] = ACTIONS(2645),
    [anon_sym_XXX] = ACTIONS(2645),
    [sym_fixme] = ACTIONS(2645),
    [aux_sym__text_token1] = ACTIONS(2647),
    [sym__block_close] = ACTIONS(2645),
    [sym__newline] = ACTIONS(2645),
    [sym__newline_inline] = ACTIONS(2645),
    [sym_hard_line_break] = ACTIONS(2645),
    [sym__heading_begin] = ACTIONS(2645),
    [sym__div_begin] = ACTIONS(2645),
    [sym__code_block_begin] = ACTIONS(2645),
    [sym_list_marker_dash] = ACTIONS(2645),
    [sym_list_marker_star] = ACTIONS(2645),
    [sym_list_marker_plus] = ACTIONS(2645),
    [sym__list_marker_task_begin] = ACTIONS(2645),
    [sym_list_marker_definition] = ACTIONS(2645),
    [sym_list_marker_decimal_period] = ACTIONS(2645),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2645),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2645),
    [sym_list_marker_lower_roman_period] = ACTIONS(2645),
    [sym_list_marker_upper_roman_period] = ACTIONS(2645),
    [sym_list_marker_decimal_paren] = ACTIONS(2645),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2645),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2645),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2645),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2645),
    [sym_list_marker_decimal_parens] = ACTIONS(2645),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2645),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2645),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2645),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2645),
    [sym__block_quote_begin] = ACTIONS(2645),
    [sym__block_quote_continuation] = ACTIONS(2645),
    [sym__thematic_break_dash] = ACTIONS(2645),
    [sym__thematic_break_star] = ACTIONS(2645),
    [sym__footnote_mark_begin] = ACTIONS(2645),
    [sym__link_ref_def_mark_begin] = ACTIONS(2645),
    [sym__table_header_begin] = ACTIONS(2645),
    [sym__table_separator_begin] = ACTIONS(2645),
    [sym__table_row_begin] = ACTIONS(2645),
    [sym__block_attribute_begin] = ACTIONS(2645),
    [sym__verbatim_begin] = ACTIONS(2645),
  },
  [422] = {
    [anon_sym_LBRACK] = ACTIONS(2651),
    [sym__whitespace1] = ACTIONS(2649),
    [sym_quotation_marks] = ACTIONS(2649),
    [sym_ellipsis] = ACTIONS(2649),
    [sym_em_dash] = ACTIONS(2649),
    [sym_en_dash] = ACTIONS(2651),
    [sym_backslash_escape] = ACTIONS(2651),
    [anon_sym_LT] = ACTIONS(2649),
    [sym_symbol] = ACTIONS(2649),
    [anon_sym_LBRACE_] = ACTIONS(2649),
    [anon_sym__] = ACTIONS(2649),
    [anon_sym_LBRACE_STAR] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2649),
    [anon_sym_LBRACE_CARET] = ACTIONS(2649),
    [anon_sym_CARET] = ACTIONS(2649),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2649),
    [anon_sym_TILDE] = ACTIONS(2649),
    [anon_sym_LBRACE_EQ] = ACTIONS(2649),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2649),
    [anon_sym_LBRACE_DASH] = ACTIONS(2649),
    [anon_sym_LBRACK_CARET] = ACTIONS(2649),
    [anon_sym_BANG_LBRACK] = ACTIONS(2649),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2649),
    [anon_sym_LPAREN] = ACTIONS(2649),
    [anon_sym_DOLLAR] = ACTIONS(2649),
    [anon_sym_TODO] = ACTIONS(2649),
    [anon_sym_WIP] = ACTIONS(2649),
    [anon_sym_NOTE] = ACTIONS(2649),
    [anon_sym_INFO] = ACTIONS(2649),
    [anon_sym_XXX] = ACTIONS(2649),
    [sym_fixme] = ACTIONS(2649),
    [aux_sym__text_token1] = ACTIONS(2651),
    [sym__block_close] = ACTIONS(2649),
    [sym__newline] = ACTIONS(2649),
    [sym__newline_inline] = ACTIONS(2649),
    [sym_hard_line_break] = ACTIONS(2649),
    [sym__heading_begin] = ACTIONS(2649),
    [sym__div_begin] = ACTIONS(2649),
    [sym__code_block_begin] = ACTIONS(2649),
    [sym_list_marker_dash] = ACTIONS(2649),
    [sym_list_marker_star] = ACTIONS(2649),
    [sym_list_marker_plus] = ACTIONS(2649),
    [sym__list_marker_task_begin] = ACTIONS(2649),
    [sym_list_marker_definition] = ACTIONS(2649),
    [sym_list_marker_decimal_period] = ACTIONS(2649),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2649),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2649),
    [sym_list_marker_lower_roman_period] = ACTIONS(2649),
    [sym_list_marker_upper_roman_period] = ACTIONS(2649),
    [sym_list_marker_decimal_paren] = ACTIONS(2649),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2649),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2649),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2649),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2649),
    [sym_list_marker_decimal_parens] = ACTIONS(2649),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2649),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2649),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2649),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2649),
    [sym__block_quote_begin] = ACTIONS(2649),
    [sym__block_quote_continuation] = ACTIONS(2649),
    [sym__thematic_break_dash] = ACTIONS(2649),
    [sym__thematic_break_star] = ACTIONS(2649),
    [sym__footnote_mark_begin] = ACTIONS(2649),
    [sym__link_ref_def_mark_begin] = ACTIONS(2649),
    [sym__table_header_begin] = ACTIONS(2649),
    [sym__table_separator_begin] = ACTIONS(2649),
    [sym__table_row_begin] = ACTIONS(2649),
    [sym__block_attribute_begin] = ACTIONS(2649),
    [sym__verbatim_begin] = ACTIONS(2649),
  },
  [423] = {
    [anon_sym_LBRACK] = ACTIONS(2655),
    [sym__whitespace1] = ACTIONS(2653),
    [sym_quotation_marks] = ACTIONS(2653),
    [sym_ellipsis] = ACTIONS(2653),
    [sym_em_dash] = ACTIONS(2653),
    [sym_en_dash] = ACTIONS(2655),
    [sym_backslash_escape] = ACTIONS(2655),
    [anon_sym_LT] = ACTIONS(2653),
    [sym_symbol] = ACTIONS(2653),
    [anon_sym_LBRACE_] = ACTIONS(2653),
    [anon_sym__] = ACTIONS(2653),
    [anon_sym_LBRACE_STAR] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_LBRACE_CARET] = ACTIONS(2653),
    [anon_sym_CARET] = ACTIONS(2653),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2653),
    [anon_sym_LBRACE_EQ] = ACTIONS(2653),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2653),
    [anon_sym_LBRACE_DASH] = ACTIONS(2653),
    [anon_sym_LBRACK_CARET] = ACTIONS(2653),
    [anon_sym_BANG_LBRACK] = ACTIONS(2653),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2653),
    [anon_sym_LPAREN] = ACTIONS(2653),
    [anon_sym_DOLLAR] = ACTIONS(2653),
    [anon_sym_TODO] = ACTIONS(2653),
    [anon_sym_WIP] = ACTIONS(2653),
    [anon_sym_NOTE] = ACTIONS(2653),
    [anon_sym_INFO] = ACTIONS(2653),
    [anon_sym_XXX] = ACTIONS(2653),
    [sym_fixme] = ACTIONS(2653),
    [aux_sym__text_token1] = ACTIONS(2655),
    [sym__block_close] = ACTIONS(2653),
    [sym__newline] = ACTIONS(2653),
    [sym__newline_inline] = ACTIONS(2653),
    [sym_hard_line_break] = ACTIONS(2653),
    [sym__heading_begin] = ACTIONS(2653),
    [sym__div_begin] = ACTIONS(2653),
    [sym__code_block_begin] = ACTIONS(2653),
    [sym_list_marker_dash] = ACTIONS(2653),
    [sym_list_marker_star] = ACTIONS(2653),
    [sym_list_marker_plus] = ACTIONS(2653),
    [sym__list_marker_task_begin] = ACTIONS(2653),
    [sym_list_marker_definition] = ACTIONS(2653),
    [sym_list_marker_decimal_period] = ACTIONS(2653),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2653),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2653),
    [sym_list_marker_lower_roman_period] = ACTIONS(2653),
    [sym_list_marker_upper_roman_period] = ACTIONS(2653),
    [sym_list_marker_decimal_paren] = ACTIONS(2653),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2653),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2653),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2653),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2653),
    [sym_list_marker_decimal_parens] = ACTIONS(2653),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2653),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2653),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2653),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2653),
    [sym__block_quote_begin] = ACTIONS(2653),
    [sym__block_quote_continuation] = ACTIONS(2653),
    [sym__thematic_break_dash] = ACTIONS(2653),
    [sym__thematic_break_star] = ACTIONS(2653),
    [sym__footnote_mark_begin] = ACTIONS(2653),
    [sym__link_ref_def_mark_begin] = ACTIONS(2653),
    [sym__table_header_begin] = ACTIONS(2653),
    [sym__table_separator_begin] = ACTIONS(2653),
    [sym__table_row_begin] = ACTIONS(2653),
    [sym__block_attribute_begin] = ACTIONS(2653),
    [sym__verbatim_begin] = ACTIONS(2653),
  },
  [424] = {
    [anon_sym_LBRACK] = ACTIONS(2659),
    [sym__whitespace1] = ACTIONS(2657),
    [sym_quotation_marks] = ACTIONS(2657),
    [sym_ellipsis] = ACTIONS(2657),
    [sym_em_dash] = ACTIONS(2657),
    [sym_en_dash] = ACTIONS(2659),
    [sym_backslash_escape] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(2657),
    [sym_symbol] = ACTIONS(2657),
    [anon_sym_LBRACE_] = ACTIONS(2657),
    [anon_sym__] = ACTIONS(2657),
    [anon_sym_LBRACE_STAR] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2657),
    [anon_sym_LBRACE_CARET] = ACTIONS(2657),
    [anon_sym_CARET] = ACTIONS(2657),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2657),
    [anon_sym_TILDE] = ACTIONS(2657),
    [anon_sym_LBRACE_EQ] = ACTIONS(2657),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2657),
    [anon_sym_LBRACE_DASH] = ACTIONS(2657),
    [anon_sym_LBRACK_CARET] = ACTIONS(2657),
    [anon_sym_BANG_LBRACK] = ACTIONS(2657),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(2657),
    [anon_sym_DOLLAR] = ACTIONS(2657),
    [anon_sym_TODO] = ACTIONS(2657),
    [anon_sym_WIP] = ACTIONS(2657),
    [anon_sym_NOTE] = ACTIONS(2657),
    [anon_sym_INFO] = ACTIONS(2657),
    [anon_sym_XXX] = ACTIONS(2657),
    [sym_fixme] = ACTIONS(2657),
    [aux_sym__text_token1] = ACTIONS(2659),
    [sym__block_close] = ACTIONS(2657),
    [sym__newline] = ACTIONS(2657),
    [sym__newline_inline] = ACTIONS(2657),
    [sym_hard_line_break] = ACTIONS(2657),
    [sym__heading_begin] = ACTIONS(2657),
    [sym__div_begin] = ACTIONS(2657),
    [sym__code_block_begin] = ACTIONS(2657),
    [sym_list_marker_dash] = ACTIONS(2657),
    [sym_list_marker_star] = ACTIONS(2657),
    [sym_list_marker_plus] = ACTIONS(2657),
    [sym__list_marker_task_begin] = ACTIONS(2657),
    [sym_list_marker_definition] = ACTIONS(2657),
    [sym_list_marker_decimal_period] = ACTIONS(2657),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2657),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2657),
    [sym_list_marker_lower_roman_period] = ACTIONS(2657),
    [sym_list_marker_upper_roman_period] = ACTIONS(2657),
    [sym_list_marker_decimal_paren] = ACTIONS(2657),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2657),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2657),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2657),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2657),
    [sym_list_marker_decimal_parens] = ACTIONS(2657),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2657),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2657),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2657),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2657),
    [sym__block_quote_begin] = ACTIONS(2657),
    [sym__block_quote_continuation] = ACTIONS(2657),
    [sym__thematic_break_dash] = ACTIONS(2657),
    [sym__thematic_break_star] = ACTIONS(2657),
    [sym__footnote_mark_begin] = ACTIONS(2657),
    [sym__link_ref_def_mark_begin] = ACTIONS(2657),
    [sym__table_header_begin] = ACTIONS(2657),
    [sym__table_separator_begin] = ACTIONS(2657),
    [sym__table_row_begin] = ACTIONS(2657),
    [sym__block_attribute_begin] = ACTIONS(2657),
    [sym__verbatim_begin] = ACTIONS(2657),
  },
  [425] = {
    [anon_sym_LBRACK] = ACTIONS(2663),
    [sym__whitespace1] = ACTIONS(2661),
    [sym_quotation_marks] = ACTIONS(2661),
    [sym_ellipsis] = ACTIONS(2661),
    [sym_em_dash] = ACTIONS(2661),
    [sym_en_dash] = ACTIONS(2663),
    [sym_backslash_escape] = ACTIONS(2663),
    [anon_sym_LT] = ACTIONS(2661),
    [sym_symbol] = ACTIONS(2661),
    [anon_sym_LBRACE_] = ACTIONS(2661),
    [anon_sym__] = ACTIONS(2661),
    [anon_sym_LBRACE_STAR] = ACTIONS(2661),
    [anon_sym_STAR] = ACTIONS(2661),
    [anon_sym_LBRACE_CARET] = ACTIONS(2661),
    [anon_sym_CARET] = ACTIONS(2661),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [anon_sym_LBRACE_EQ] = ACTIONS(2661),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2661),
    [anon_sym_LBRACE_DASH] = ACTIONS(2661),
    [anon_sym_LBRACK_CARET] = ACTIONS(2661),
    [anon_sym_BANG_LBRACK] = ACTIONS(2661),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2661),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_DOLLAR] = ACTIONS(2661),
    [anon_sym_TODO] = ACTIONS(2661),
    [anon_sym_WIP] = ACTIONS(2661),
    [anon_sym_NOTE] = ACTIONS(2661),
    [anon_sym_INFO] = ACTIONS(2661),
    [anon_sym_XXX] = ACTIONS(2661),
    [sym_fixme] = ACTIONS(2661),
    [aux_sym__text_token1] = ACTIONS(2663),
    [sym__block_close] = ACTIONS(2661),
    [sym__newline] = ACTIONS(2661),
    [sym__newline_inline] = ACTIONS(2661),
    [sym_hard_line_break] = ACTIONS(2661),
    [sym__heading_begin] = ACTIONS(2661),
    [sym__div_begin] = ACTIONS(2661),
    [sym__code_block_begin] = ACTIONS(2661),
    [sym_list_marker_dash] = ACTIONS(2661),
    [sym_list_marker_star] = ACTIONS(2661),
    [sym_list_marker_plus] = ACTIONS(2661),
    [sym__list_marker_task_begin] = ACTIONS(2661),
    [sym_list_marker_definition] = ACTIONS(2661),
    [sym_list_marker_decimal_period] = ACTIONS(2661),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2661),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2661),
    [sym_list_marker_lower_roman_period] = ACTIONS(2661),
    [sym_list_marker_upper_roman_period] = ACTIONS(2661),
    [sym_list_marker_decimal_paren] = ACTIONS(2661),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2661),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2661),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2661),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2661),
    [sym_list_marker_decimal_parens] = ACTIONS(2661),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2661),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2661),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2661),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2661),
    [sym__block_quote_begin] = ACTIONS(2661),
    [sym__block_quote_continuation] = ACTIONS(2661),
    [sym__thematic_break_dash] = ACTIONS(2661),
    [sym__thematic_break_star] = ACTIONS(2661),
    [sym__footnote_mark_begin] = ACTIONS(2661),
    [sym__link_ref_def_mark_begin] = ACTIONS(2661),
    [sym__table_header_begin] = ACTIONS(2661),
    [sym__table_separator_begin] = ACTIONS(2661),
    [sym__table_row_begin] = ACTIONS(2661),
    [sym__block_attribute_begin] = ACTIONS(2661),
    [sym__verbatim_begin] = ACTIONS(2661),
  },
  [426] = {
    [anon_sym_LBRACK] = ACTIONS(2667),
    [sym__whitespace1] = ACTIONS(2665),
    [sym_quotation_marks] = ACTIONS(2665),
    [sym_ellipsis] = ACTIONS(2665),
    [sym_em_dash] = ACTIONS(2665),
    [sym_en_dash] = ACTIONS(2667),
    [sym_backslash_escape] = ACTIONS(2667),
    [anon_sym_LT] = ACTIONS(2665),
    [sym_symbol] = ACTIONS(2665),
    [anon_sym_LBRACE_] = ACTIONS(2665),
    [anon_sym__] = ACTIONS(2665),
    [anon_sym_LBRACE_STAR] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2665),
    [anon_sym_LBRACE_CARET] = ACTIONS(2665),
    [anon_sym_CARET] = ACTIONS(2665),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2665),
    [anon_sym_TILDE] = ACTIONS(2665),
    [anon_sym_LBRACE_EQ] = ACTIONS(2665),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2665),
    [anon_sym_LBRACE_DASH] = ACTIONS(2665),
    [anon_sym_LBRACK_CARET] = ACTIONS(2665),
    [anon_sym_BANG_LBRACK] = ACTIONS(2665),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2665),
    [anon_sym_LPAREN] = ACTIONS(2665),
    [anon_sym_DOLLAR] = ACTIONS(2665),
    [anon_sym_TODO] = ACTIONS(2665),
    [anon_sym_WIP] = ACTIONS(2665),
    [anon_sym_NOTE] = ACTIONS(2665),
    [anon_sym_INFO] = ACTIONS(2665),
    [anon_sym_XXX] = ACTIONS(2665),
    [sym_fixme] = ACTIONS(2665),
    [aux_sym__text_token1] = ACTIONS(2667),
    [sym__block_close] = ACTIONS(2665),
    [sym__newline] = ACTIONS(2665),
    [sym__newline_inline] = ACTIONS(2665),
    [sym_hard_line_break] = ACTIONS(2665),
    [sym__heading_begin] = ACTIONS(2665),
    [sym__div_begin] = ACTIONS(2665),
    [sym__code_block_begin] = ACTIONS(2665),
    [sym_list_marker_dash] = ACTIONS(2665),
    [sym_list_marker_star] = ACTIONS(2665),
    [sym_list_marker_plus] = ACTIONS(2665),
    [sym__list_marker_task_begin] = ACTIONS(2665),
    [sym_list_marker_definition] = ACTIONS(2665),
    [sym_list_marker_decimal_period] = ACTIONS(2665),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2665),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2665),
    [sym_list_marker_lower_roman_period] = ACTIONS(2665),
    [sym_list_marker_upper_roman_period] = ACTIONS(2665),
    [sym_list_marker_decimal_paren] = ACTIONS(2665),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2665),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2665),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2665),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2665),
    [sym_list_marker_decimal_parens] = ACTIONS(2665),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2665),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2665),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2665),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2665),
    [sym__block_quote_begin] = ACTIONS(2665),
    [sym__block_quote_continuation] = ACTIONS(2665),
    [sym__thematic_break_dash] = ACTIONS(2665),
    [sym__thematic_break_star] = ACTIONS(2665),
    [sym__footnote_mark_begin] = ACTIONS(2665),
    [sym__link_ref_def_mark_begin] = ACTIONS(2665),
    [sym__table_header_begin] = ACTIONS(2665),
    [sym__table_separator_begin] = ACTIONS(2665),
    [sym__table_row_begin] = ACTIONS(2665),
    [sym__block_attribute_begin] = ACTIONS(2665),
    [sym__verbatim_begin] = ACTIONS(2665),
  },
  [427] = {
    [anon_sym_LBRACK] = ACTIONS(2503),
    [sym__whitespace1] = ACTIONS(2501),
    [sym_quotation_marks] = ACTIONS(2501),
    [sym_ellipsis] = ACTIONS(2501),
    [sym_em_dash] = ACTIONS(2501),
    [sym_en_dash] = ACTIONS(2503),
    [sym_backslash_escape] = ACTIONS(2503),
    [anon_sym_LT] = ACTIONS(2501),
    [sym_symbol] = ACTIONS(2501),
    [anon_sym_LBRACE_] = ACTIONS(2501),
    [anon_sym__] = ACTIONS(2501),
    [anon_sym_LBRACE_STAR] = ACTIONS(2501),
    [anon_sym_STAR] = ACTIONS(2501),
    [anon_sym_LBRACE_CARET] = ACTIONS(2501),
    [anon_sym_CARET] = ACTIONS(2501),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2501),
    [anon_sym_TILDE] = ACTIONS(2501),
    [anon_sym_LBRACE_EQ] = ACTIONS(2501),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2501),
    [anon_sym_LBRACE_DASH] = ACTIONS(2501),
    [anon_sym_LBRACK_CARET] = ACTIONS(2501),
    [anon_sym_BANG_LBRACK] = ACTIONS(2501),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2501),
    [anon_sym_LPAREN] = ACTIONS(2501),
    [anon_sym_DOLLAR] = ACTIONS(2501),
    [anon_sym_TODO] = ACTIONS(2501),
    [anon_sym_WIP] = ACTIONS(2501),
    [anon_sym_NOTE] = ACTIONS(2501),
    [anon_sym_INFO] = ACTIONS(2501),
    [anon_sym_XXX] = ACTIONS(2501),
    [sym_fixme] = ACTIONS(2501),
    [aux_sym__text_token1] = ACTIONS(2503),
    [sym__block_close] = ACTIONS(2501),
    [sym__newline] = ACTIONS(2501),
    [sym__newline_inline] = ACTIONS(2501),
    [sym_hard_line_break] = ACTIONS(2501),
    [sym__heading_begin] = ACTIONS(2501),
    [sym__div_begin] = ACTIONS(2501),
    [sym__code_block_begin] = ACTIONS(2501),
    [sym_list_marker_dash] = ACTIONS(2501),
    [sym_list_marker_star] = ACTIONS(2501),
    [sym_list_marker_plus] = ACTIONS(2501),
    [sym__list_marker_task_begin] = ACTIONS(2501),
    [sym_list_marker_definition] = ACTIONS(2501),
    [sym_list_marker_decimal_period] = ACTIONS(2501),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2501),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2501),
    [sym_list_marker_lower_roman_period] = ACTIONS(2501),
    [sym_list_marker_upper_roman_period] = ACTIONS(2501),
    [sym_list_marker_decimal_paren] = ACTIONS(2501),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2501),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2501),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2501),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2501),
    [sym_list_marker_decimal_parens] = ACTIONS(2501),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2501),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2501),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2501),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2501),
    [sym__block_quote_begin] = ACTIONS(2501),
    [sym__block_quote_continuation] = ACTIONS(2501),
    [sym__thematic_break_dash] = ACTIONS(2501),
    [sym__thematic_break_star] = ACTIONS(2501),
    [sym__footnote_mark_begin] = ACTIONS(2501),
    [sym__link_ref_def_mark_begin] = ACTIONS(2501),
    [sym__table_header_begin] = ACTIONS(2501),
    [sym__table_separator_begin] = ACTIONS(2501),
    [sym__table_row_begin] = ACTIONS(2501),
    [sym__block_attribute_begin] = ACTIONS(2501),
    [sym__verbatim_begin] = ACTIONS(2501),
  },
  [428] = {
    [anon_sym_LBRACK] = ACTIONS(2669),
    [sym__whitespace1] = ACTIONS(2671),
    [sym_quotation_marks] = ACTIONS(2671),
    [sym_ellipsis] = ACTIONS(2671),
    [sym_em_dash] = ACTIONS(2671),
    [sym_en_dash] = ACTIONS(2669),
    [sym_backslash_escape] = ACTIONS(2669),
    [anon_sym_LT] = ACTIONS(2671),
    [sym_symbol] = ACTIONS(2671),
    [anon_sym_LBRACE_] = ACTIONS(2671),
    [anon_sym__] = ACTIONS(2671),
    [anon_sym_LBRACE_STAR] = ACTIONS(2671),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_LBRACE_CARET] = ACTIONS(2671),
    [anon_sym_CARET] = ACTIONS(2671),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_LBRACE_EQ] = ACTIONS(2671),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2671),
    [anon_sym_LBRACE_DASH] = ACTIONS(2671),
    [anon_sym_LBRACK_CARET] = ACTIONS(2671),
    [anon_sym_BANG_LBRACK] = ACTIONS(2671),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2671),
    [anon_sym_LPAREN] = ACTIONS(2671),
    [anon_sym_DOLLAR] = ACTIONS(2671),
    [anon_sym_TODO] = ACTIONS(2671),
    [anon_sym_WIP] = ACTIONS(2671),
    [anon_sym_NOTE] = ACTIONS(2671),
    [anon_sym_INFO] = ACTIONS(2671),
    [anon_sym_XXX] = ACTIONS(2671),
    [sym_fixme] = ACTIONS(2671),
    [aux_sym__text_token1] = ACTIONS(2669),
    [sym__newline] = ACTIONS(2671),
    [sym__newline_inline] = ACTIONS(2671),
    [sym_hard_line_break] = ACTIONS(2671),
    [sym__heading_begin] = ACTIONS(2671),
    [sym__div_begin] = ACTIONS(2671),
    [sym__code_block_begin] = ACTIONS(2671),
    [sym_list_marker_dash] = ACTIONS(2671),
    [sym_list_marker_star] = ACTIONS(2671),
    [sym_list_marker_plus] = ACTIONS(2671),
    [sym__list_marker_task_begin] = ACTIONS(2671),
    [sym_list_marker_definition] = ACTIONS(2671),
    [sym_list_marker_decimal_period] = ACTIONS(2671),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2671),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2671),
    [sym_list_marker_lower_roman_period] = ACTIONS(2671),
    [sym_list_marker_upper_roman_period] = ACTIONS(2671),
    [sym_list_marker_decimal_paren] = ACTIONS(2671),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2671),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2671),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2671),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2671),
    [sym_list_marker_decimal_parens] = ACTIONS(2671),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2671),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2671),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2671),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2671),
    [sym__block_quote_begin] = ACTIONS(2671),
    [sym__block_quote_continuation] = ACTIONS(2671),
    [sym__thematic_break_dash] = ACTIONS(2671),
    [sym__thematic_break_star] = ACTIONS(2671),
    [sym__footnote_mark_begin] = ACTIONS(2671),
    [sym__link_ref_def_mark_begin] = ACTIONS(2671),
    [sym__table_header_begin] = ACTIONS(2671),
    [sym__table_separator_begin] = ACTIONS(2671),
    [sym__table_row_begin] = ACTIONS(2671),
    [sym__block_attribute_begin] = ACTIONS(2671),
    [sym__verbatim_begin] = ACTIONS(2671),
  },
  [429] = {
    [aux_sym__block_quote_prefix_repeat1] = STATE(429),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [sym__whitespace1] = ACTIONS(2675),
    [sym_quotation_marks] = ACTIONS(2675),
    [sym_ellipsis] = ACTIONS(2675),
    [sym_em_dash] = ACTIONS(2675),
    [sym_en_dash] = ACTIONS(2673),
    [sym_backslash_escape] = ACTIONS(2673),
    [anon_sym_LT] = ACTIONS(2675),
    [sym_symbol] = ACTIONS(2675),
    [anon_sym_LBRACE_] = ACTIONS(2675),
    [anon_sym__] = ACTIONS(2675),
    [anon_sym_LBRACE_STAR] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2675),
    [anon_sym_LBRACE_CARET] = ACTIONS(2675),
    [anon_sym_CARET] = ACTIONS(2675),
    [anon_sym_LBRACE_TILDE] = ACTIONS(2675),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_LBRACE_EQ] = ACTIONS(2675),
    [anon_sym_LBRACE_PLUS] = ACTIONS(2675),
    [anon_sym_LBRACE_DASH] = ACTIONS(2675),
    [anon_sym_LBRACK_CARET] = ACTIONS(2675),
    [anon_sym_BANG_LBRACK] = ACTIONS(2675),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_DOLLAR] = ACTIONS(2675),
    [anon_sym_TODO] = ACTIONS(2675),
    [anon_sym_WIP] = ACTIONS(2675),
    [anon_sym_NOTE] = ACTIONS(2675),
    [anon_sym_INFO] = ACTIONS(2675),
    [anon_sym_XXX] = ACTIONS(2675),
    [sym_fixme] = ACTIONS(2675),
    [aux_sym__text_token1] = ACTIONS(2673),
    [sym__block_close] = ACTIONS(2675),
    [sym__newline_inline] = ACTIONS(2675),
    [sym_hard_line_break] = ACTIONS(2675),
    [sym__div_begin] = ACTIONS(2675),
    [sym__code_block_begin] = ACTIONS(2675),
    [sym_list_marker_dash] = ACTIONS(2675),
    [sym_list_marker_star] = ACTIONS(2675),
    [sym_list_marker_plus] = ACTIONS(2675),
    [sym__list_marker_task_begin] = ACTIONS(2675),
    [sym_list_marker_definition] = ACTIONS(2675),
    [sym_list_marker_decimal_period] = ACTIONS(2675),
    [sym_list_marker_lower_alpha_period] = ACTIONS(2675),
    [sym_list_marker_upper_alpha_period] = ACTIONS(2675),
    [sym_list_marker_lower_roman_period] = ACTIONS(2675),
    [sym_list_marker_upper_roman_period] = ACTIONS(2675),
    [sym_list_marker_decimal_paren] = ACTIONS(2675),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(2675),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(2675),
    [sym_list_marker_lower_roman_paren] = ACTIONS(2675),
    [sym_list_marker_upper_roman_paren] = ACTIONS(2675),
    [sym_list_marker_decimal_parens] = ACTIONS(2675),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(2675),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(2675),
    [sym_list_marker_lower_roman_parens] = ACTIONS(2675),
    [sym_list_marker_upper_roman_parens] = ACTIONS(2675),
    [sym__block_quote_begin] = ACTIONS(2675),
    [sym__block_quote_continuation] = ACTIONS(2677),
    [sym__thematic_break_dash] = ACTIONS(2675),
    [sym__thematic_break_star] = ACTIONS(2675),
    [sym__footnote_mark_begin] = ACTIONS(2675),
    [sym__link_ref_def_mark_begin] = ACTIONS(2675),
    [sym__table_header_begin] = ACTIONS(2675),
    [sym__table_separator_begin] = ACTIONS(2675),
    [sym__table_row_begin] = ACTIONS(2675),
    [sym__block_attribute_begin] = ACTIONS(2675),
    [sym__verbatim_begin] = ACTIONS(2675),
  },
  [430] = {
    [anon_sym_LBRACK] = ACTIONS(655),
    [sym__whitespace1] = ACTIONS(657),
    [sym_quotation_marks] = ACTIONS(657),
    [sym_ellipsis] = ACTIONS(657),
    [sym_em_dash] = ACTIONS(657),
    [sym_en_dash] = ACTIONS(655),
    [sym_backslash_escape] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(657),
    [sym_symbol] = ACTIONS(657),
    [anon_sym_LBRACE_] = ACTIONS(657),
    [anon_sym__] = ACTIONS(657),
    [anon_sym_LBRACE_STAR] = ACTIONS(657),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_LBRACE_CARET] = ACTIONS(657),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_LBRACE_TILDE] = ACTIONS(657),
    [anon_sym_TILDE] = ACTIONS(657),
    [anon_sym_LBRACE_EQ] = ACTIONS(657),
    [anon_sym_LBRACE_PLUS] = ACTIONS(657),
    [anon_sym_LBRACE_DASH] = ACTIONS(657),
    [anon_sym_LBRACK_CARET] = ACTIONS(657),
    [anon_sym_BANG_LBRACK] = ACTIONS(657),
    [anon_sym_LBRACK_RBRACK2] = ACTIONS(657),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_DOLLAR] = ACTIONS(657),
    [anon_sym_TODO] = ACTIONS(657),
    [anon_sym_WIP] = ACTIONS(657),
    [anon_sym_NOTE] = ACTIONS(657),
    [anon_sym_INFO] = ACTIONS(657),
    [anon_sym_XXX] = ACTIONS(657),
    [sym_fixme] = ACTIONS(657),
    [aux_sym__text_token1] = ACTIONS(655),
    [sym__block_close] = ACTIONS(657),
    [sym__newline_inline] = ACTIONS(657),
    [sym_hard_line_break] = ACTIONS(657),
    [sym__div_begin] = ACTIONS(657),
    [sym__code_block_begin] = ACTIONS(657),
    [sym_list_marker_dash] = ACTIONS(657),
    [sym_list_marker_star] = ACTIONS(657),
    [sym_list_marker_plus] = ACTIONS(657),
    [sym__list_marker_task_begin] = ACTIONS(657),
    [sym_list_marker_definition] = ACTIONS(657),
    [sym_list_marker_decimal_period] = ACTIONS(657),
    [sym_list_marker_lower_alpha_period] = ACTIONS(657),
    [sym_list_marker_upper_alpha_period] = ACTIONS(657),
    [sym_list_marker_lower_roman_period] = ACTIONS(657),
    [sym_list_marker_upper_roman_period] = ACTIONS(657),
    [sym_list_marker_decimal_paren] = ACTIONS(657),
    [sym_list_marker_lower_alpha_paren] = ACTIONS(657),
    [sym_list_marker_upper_alpha_paren] = ACTIONS(657),
    [sym_list_marker_lower_roman_paren] = ACTIONS(657),
    [sym_list_marker_upper_roman_paren] = ACTIONS(657),
    [sym_list_marker_decimal_parens] = ACTIONS(657),
    [sym_list_marker_lower_alpha_parens] = ACTIONS(657),
    [sym_list_marker_upper_alpha_parens] = ACTIONS(657),
    [sym_list_marker_lower_roman_parens] = ACTIONS(657),
    [sym_list_marker_upper_roman_parens] = ACTIONS(657),
    [sym__block_quote_begin] = ACTIONS(657),
    [sym__block_quote_continuation] = ACTIONS(657),
    [sym__thematic_break_dash] = ACTIONS(657),
    [sym__thematic_break_star] = ACTIONS(657),
    [sym__footnote_mark_begin] = ACTIONS(657),
    [sym__link_ref_def_mark_begin] = ACTIONS(657),
    [sym__table_header_begin] = ACTIONS(657),
    [sym__table_separator_begin] = ACTIONS(657),
    [sym__table_row_begin] = ACTIONS(657),
    [sym__block_attribute_begin] = ACTIONS(657),
    [sym__verbatim_begin] = ACTIONS(657),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 4,
    ACTIONS(2680), 1,
      sym__block_quote_continuation,
    STATE(431), 1,
      aux_sym__block_quote_prefix_repeat1,
    ACTIONS(2673), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2675), 54,
      sym__block_close,
      sym__newline_inline,
      sym_hard_line_break,
      sym_list_marker_dash,
      sym_list_marker_star,
      sym_list_marker_plus,
      sym__list_marker_task_begin,
      sym_list_marker_decimal_period,
      sym_list_marker_lower_alpha_period,
      sym_list_marker_upper_alpha_period,
      sym_list_marker_lower_roman_period,
      sym_list_marker_upper_roman_period,
      sym_list_marker_decimal_paren,
      sym_list_marker_lower_alpha_paren,
      sym_list_marker_upper_alpha_paren,
      sym_list_marker_lower_roman_paren,
      sym_list_marker_upper_roman_paren,
      sym_list_marker_decimal_parens,
      sym_list_marker_lower_alpha_parens,
      sym_list_marker_upper_alpha_parens,
      sym_list_marker_lower_roman_parens,
      sym_list_marker_upper_roman_parens,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [69] = 4,
    ACTIONS(2687), 1,
      sym__block_quote_continuation,
    STATE(431), 1,
      aux_sym__block_quote_prefix_repeat1,
    ACTIONS(2683), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2685), 54,
      sym__block_close,
      sym__newline_inline,
      sym_hard_line_break,
      sym_list_marker_dash,
      sym_list_marker_star,
      sym_list_marker_plus,
      sym__list_marker_task_begin,
      sym_list_marker_decimal_period,
      sym_list_marker_lower_alpha_period,
      sym_list_marker_upper_alpha_period,
      sym_list_marker_lower_roman_period,
      sym_list_marker_upper_roman_period,
      sym_list_marker_decimal_paren,
      sym_list_marker_lower_alpha_paren,
      sym_list_marker_upper_alpha_paren,
      sym_list_marker_lower_roman_paren,
      sym_list_marker_upper_roman_paren,
      sym_list_marker_decimal_parens,
      sym_list_marker_lower_alpha_parens,
      sym_list_marker_upper_alpha_parens,
      sym_list_marker_lower_roman_parens,
      sym_list_marker_upper_roman_parens,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [138] = 4,
    ACTIONS(2689), 1,
      sym__block_quote_continuation,
    STATE(433), 1,
      aux_sym__block_quote_prefix_repeat1,
    ACTIONS(2673), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2675), 53,
      sym__newline_inline,
      sym_hard_line_break,
      sym_list_marker_dash,
      sym_list_marker_star,
      sym_list_marker_plus,
      sym__list_marker_task_begin,
      sym_list_marker_decimal_period,
      sym_list_marker_lower_alpha_period,
      sym_list_marker_upper_alpha_period,
      sym_list_marker_lower_roman_period,
      sym_list_marker_upper_roman_period,
      sym_list_marker_decimal_paren,
      sym_list_marker_lower_alpha_paren,
      sym_list_marker_upper_alpha_paren,
      sym_list_marker_lower_roman_paren,
      sym_list_marker_upper_roman_paren,
      sym_list_marker_decimal_parens,
      sym_list_marker_lower_alpha_parens,
      sym_list_marker_upper_alpha_parens,
      sym_list_marker_lower_roman_parens,
      sym_list_marker_upper_roman_parens,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [206] = 4,
    ACTIONS(103), 1,
      sym__block_quote_continuation,
    STATE(433), 1,
      aux_sym__block_quote_prefix_repeat1,
    ACTIONS(2683), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2685), 53,
      sym__newline_inline,
      sym_hard_line_break,
      sym_list_marker_dash,
      sym_list_marker_star,
      sym_list_marker_plus,
      sym__list_marker_task_begin,
      sym_list_marker_decimal_period,
      sym_list_marker_lower_alpha_period,
      sym_list_marker_upper_alpha_period,
      sym_list_marker_lower_roman_period,
      sym_list_marker_upper_roman_period,
      sym_list_marker_decimal_paren,
      sym_list_marker_lower_alpha_paren,
      sym_list_marker_upper_alpha_paren,
      sym_list_marker_lower_roman_paren,
      sym_list_marker_upper_roman_paren,
      sym_list_marker_decimal_parens,
      sym_list_marker_lower_alpha_parens,
      sym_list_marker_upper_alpha_parens,
      sym_list_marker_lower_roman_parens,
      sym_list_marker_upper_roman_parens,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [274] = 2,
    ACTIONS(655), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(657), 55,
      sym__block_close,
      sym__newline_inline,
      sym_hard_line_break,
      sym_list_marker_dash,
      sym_list_marker_star,
      sym_list_marker_plus,
      sym__list_marker_task_begin,
      sym_list_marker_decimal_period,
      sym_list_marker_lower_alpha_period,
      sym_list_marker_upper_alpha_period,
      sym_list_marker_lower_roman_period,
      sym_list_marker_upper_roman_period,
      sym_list_marker_decimal_paren,
      sym_list_marker_lower_alpha_paren,
      sym_list_marker_upper_alpha_paren,
      sym_list_marker_lower_roman_paren,
      sym_list_marker_upper_roman_paren,
      sym_list_marker_decimal_parens,
      sym_list_marker_lower_alpha_parens,
      sym_list_marker_upper_alpha_parens,
      sym_list_marker_lower_roman_parens,
      sym_list_marker_upper_roman_parens,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [338] = 2,
    ACTIONS(655), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(657), 54,
      sym__newline_inline,
      sym_hard_line_break,
      sym_list_marker_dash,
      sym_list_marker_star,
      sym_list_marker_plus,
      sym__list_marker_task_begin,
      sym_list_marker_decimal_period,
      sym_list_marker_lower_alpha_period,
      sym_list_marker_upper_alpha_period,
      sym_list_marker_lower_roman_period,
      sym_list_marker_upper_roman_period,
      sym_list_marker_decimal_paren,
      sym_list_marker_lower_alpha_paren,
      sym_list_marker_upper_alpha_paren,
      sym_list_marker_lower_roman_paren,
      sym_list_marker_upper_roman_paren,
      sym_list_marker_decimal_parens,
      sym_list_marker_lower_alpha_parens,
      sym_list_marker_upper_alpha_parens,
      sym_list_marker_lower_roman_parens,
      sym_list_marker_upper_roman_parens,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [401] = 7,
    ACTIONS(2696), 1,
      anon_sym_LBRACE,
    STATE(493), 1,
      aux_sym__text,
    STATE(983), 1,
      sym_inline_attribute,
    STATE(984), 1,
      sym__curly_bracket_span_fallback,
    STATE(2229), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [457] = 7,
    ACTIONS(2698), 1,
      anon_sym_LBRACE,
    STATE(492), 1,
      aux_sym__text,
    STATE(941), 1,
      sym_inline_attribute,
    STATE(943), 1,
      sym__curly_bracket_span_fallback,
    STATE(2125), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [513] = 7,
    ACTIONS(2700), 1,
      anon_sym_LBRACE,
    STATE(495), 1,
      aux_sym__text,
    STATE(894), 1,
      sym__curly_bracket_span_fallback,
    STATE(961), 1,
      sym_inline_attribute,
    STATE(2365), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [569] = 7,
    ACTIONS(2702), 1,
      anon_sym_LBRACE,
    STATE(559), 1,
      aux_sym__text,
    STATE(935), 1,
      sym_inline_attribute,
    STATE(936), 1,
      sym__curly_bracket_span_fallback,
    STATE(2399), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [625] = 7,
    ACTIONS(2704), 1,
      anon_sym_LBRACE,
    STATE(516), 1,
      aux_sym__text,
    STATE(979), 1,
      sym_inline_attribute,
    STATE(980), 1,
      sym__curly_bracket_span_fallback,
    STATE(2382), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [681] = 7,
    ACTIONS(2706), 1,
      anon_sym_LBRACE,
    STATE(512), 1,
      aux_sym__text,
    STATE(985), 1,
      sym_inline_attribute,
    STATE(987), 1,
      sym__curly_bracket_span_fallback,
    STATE(2416), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [737] = 7,
    ACTIONS(2708), 1,
      anon_sym_LBRACE,
    STATE(514), 1,
      aux_sym__text,
    STATE(944), 1,
      sym_inline_attribute,
    STATE(945), 1,
      sym__curly_bracket_span_fallback,
    STATE(2197), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [793] = 7,
    ACTIONS(2710), 1,
      anon_sym_LBRACE,
    STATE(496), 1,
      aux_sym__text,
    STATE(1008), 1,
      sym__curly_bracket_span_fallback,
    STATE(1020), 1,
      sym_inline_attribute,
    STATE(2259), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [849] = 7,
    ACTIONS(2712), 1,
      anon_sym_LBRACE,
    STATE(526), 1,
      aux_sym__text,
    STATE(951), 1,
      sym_inline_attribute,
    STATE(954), 1,
      sym__curly_bracket_span_fallback,
    STATE(2288), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [905] = 7,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    STATE(538), 1,
      aux_sym__text,
    STATE(962), 1,
      sym_inline_attribute,
    STATE(966), 1,
      sym__curly_bracket_span_fallback,
    STATE(2314), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [961] = 7,
    ACTIONS(2716), 1,
      anon_sym_LBRACE,
    STATE(550), 1,
      aux_sym__text,
    STATE(1003), 1,
      sym_inline_attribute,
    STATE(1004), 1,
      sym__curly_bracket_span_fallback,
    STATE(2331), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1017] = 7,
    ACTIONS(2718), 1,
      anon_sym_LBRACE,
    STATE(513), 1,
      aux_sym__text,
    STATE(932), 1,
      sym_inline_attribute,
    STATE(937), 1,
      sym__curly_bracket_span_fallback,
    STATE(2633), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1073] = 6,
    ACTIONS(2700), 1,
      anon_sym_LBRACE,
    STATE(897), 1,
      sym__curly_bracket_span_fallback,
    STATE(961), 1,
      sym_inline_attribute,
    STATE(2365), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2720), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2722), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1126] = 6,
    ACTIONS(2718), 1,
      anon_sym_LBRACE,
    STATE(932), 1,
      sym_inline_attribute,
    STATE(948), 1,
      sym__curly_bracket_span_fallback,
    STATE(2633), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2720), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2722), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1179] = 6,
    ACTIONS(2700), 1,
      anon_sym_LBRACE,
    STATE(894), 1,
      sym__curly_bracket_span_fallback,
    STATE(961), 1,
      sym_inline_attribute,
    STATE(2365), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1232] = 6,
    ACTIONS(2696), 1,
      anon_sym_LBRACE,
    STATE(983), 1,
      sym_inline_attribute,
    STATE(984), 1,
      sym__curly_bracket_span_fallback,
    STATE(2229), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1285] = 6,
    ACTIONS(2696), 1,
      anon_sym_LBRACE,
    STATE(983), 1,
      sym_inline_attribute,
    STATE(986), 1,
      sym__curly_bracket_span_fallback,
    STATE(2229), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2720), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2722), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1338] = 6,
    ACTIONS(2704), 1,
      anon_sym_LBRACE,
    STATE(979), 1,
      sym_inline_attribute,
    STATE(980), 1,
      sym__curly_bracket_span_fallback,
    STATE(2382), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1391] = 6,
    ACTIONS(2704), 1,
      anon_sym_LBRACE,
    STATE(979), 1,
      sym_inline_attribute,
    STATE(990), 1,
      sym__curly_bracket_span_fallback,
    STATE(2382), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2720), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2722), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1444] = 6,
    ACTIONS(2702), 1,
      anon_sym_LBRACE,
    STATE(935), 1,
      sym_inline_attribute,
    STATE(936), 1,
      sym__curly_bracket_span_fallback,
    STATE(2399), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1497] = 6,
    ACTIONS(2702), 1,
      anon_sym_LBRACE,
    STATE(935), 1,
      sym_inline_attribute,
    STATE(938), 1,
      sym__curly_bracket_span_fallback,
    STATE(2399), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2720), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2722), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1550] = 6,
    ACTIONS(2706), 1,
      anon_sym_LBRACE,
    STATE(985), 1,
      sym_inline_attribute,
    STATE(987), 1,
      sym__curly_bracket_span_fallback,
    STATE(2416), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1603] = 6,
    ACTIONS(2698), 1,
      anon_sym_LBRACE,
    STATE(941), 1,
      sym_inline_attribute,
    STATE(953), 1,
      sym__curly_bracket_span_fallback,
    STATE(2125), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2720), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2722), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1656] = 6,
    ACTIONS(2710), 1,
      anon_sym_LBRACE,
    STATE(1008), 1,
      sym__curly_bracket_span_fallback,
    STATE(1020), 1,
      sym_inline_attribute,
    STATE(2259), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1709] = 6,
    ACTIONS(2708), 1,
      anon_sym_LBRACE,
    STATE(944), 1,
      sym_inline_attribute,
    STATE(945), 1,
      sym__curly_bracket_span_fallback,
    STATE(2197), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1762] = 6,
    ACTIONS(2706), 1,
      anon_sym_LBRACE,
    STATE(985), 1,
      sym_inline_attribute,
    STATE(989), 1,
      sym__curly_bracket_span_fallback,
    STATE(2416), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2720), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2722), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1815] = 6,
    ACTIONS(2710), 1,
      anon_sym_LBRACE,
    STATE(992), 1,
      sym__curly_bracket_span_fallback,
    STATE(1020), 1,
      sym_inline_attribute,
    STATE(2259), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2720), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2722), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1868] = 6,
    ACTIONS(2712), 1,
      anon_sym_LBRACE,
    STATE(951), 1,
      sym_inline_attribute,
    STATE(954), 1,
      sym__curly_bracket_span_fallback,
    STATE(2288), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1921] = 6,
    ACTIONS(2712), 1,
      anon_sym_LBRACE,
    STATE(951), 1,
      sym_inline_attribute,
    STATE(969), 1,
      sym__curly_bracket_span_fallback,
    STATE(2288), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2720), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2722), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [1974] = 7,
    ACTIONS(2724), 1,
      anon_sym_LBRACE,
    STATE(827), 1,
      aux_sym__text,
    STATE(1025), 1,
      sym__curly_bracket_span_fallback,
    STATE(1029), 1,
      sym_inline_attribute,
    STATE(2433), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2029] = 6,
    ACTIONS(2698), 1,
      anon_sym_LBRACE,
    STATE(941), 1,
      sym_inline_attribute,
    STATE(943), 1,
      sym__curly_bracket_span_fallback,
    STATE(2125), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2082] = 6,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    STATE(962), 1,
      sym_inline_attribute,
    STATE(966), 1,
      sym__curly_bracket_span_fallback,
    STATE(2314), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2135] = 6,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    STATE(962), 1,
      sym_inline_attribute,
    STATE(971), 1,
      sym__curly_bracket_span_fallback,
    STATE(2314), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2720), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2722), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2188] = 6,
    ACTIONS(2716), 1,
      anon_sym_LBRACE,
    STATE(1003), 1,
      sym_inline_attribute,
    STATE(1004), 1,
      sym__curly_bracket_span_fallback,
    STATE(2331), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2241] = 6,
    ACTIONS(2716), 1,
      anon_sym_LBRACE,
    STATE(1003), 1,
      sym_inline_attribute,
    STATE(1012), 1,
      sym__curly_bracket_span_fallback,
    STATE(2331), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2720), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2722), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2294] = 6,
    ACTIONS(2708), 1,
      anon_sym_LBRACE,
    STATE(944), 1,
      sym_inline_attribute,
    STATE(947), 1,
      sym__curly_bracket_span_fallback,
    STATE(2197), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2720), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2722), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2347] = 6,
    ACTIONS(2718), 1,
      anon_sym_LBRACE,
    STATE(932), 1,
      sym_inline_attribute,
    STATE(937), 1,
      sym__curly_bracket_span_fallback,
    STATE(2633), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2400] = 4,
    ACTIONS(2730), 1,
      anon_sym_LBRACE_EQ2,
    STATE(602), 1,
      sym_raw_inline_attribute,
    ACTIONS(2726), 6,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2728), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2448] = 4,
    ACTIONS(2732), 1,
      anon_sym_LBRACE_EQ2,
    STATE(848), 1,
      sym_raw_inline_attribute,
    ACTIONS(2726), 6,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2728), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2496] = 4,
    ACTIONS(2734), 1,
      anon_sym_LBRACE_EQ2,
    STATE(779), 1,
      sym_raw_inline_attribute,
    ACTIONS(2726), 6,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2728), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2544] = 4,
    ACTIONS(2736), 1,
      anon_sym_LBRACE_EQ2,
    STATE(648), 1,
      sym_raw_inline_attribute,
    ACTIONS(2726), 6,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2728), 31,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2592] = 4,
    ACTIONS(2738), 1,
      anon_sym_LBRACE_EQ2,
    STATE(696), 1,
      sym_raw_inline_attribute,
    ACTIONS(2726), 6,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2728), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2640] = 4,
    ACTIONS(2740), 1,
      anon_sym_LBRACE_EQ2,
    STATE(722), 1,
      sym_raw_inline_attribute,
    ACTIONS(2726), 6,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2728), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2688] = 4,
    ACTIONS(2742), 1,
      anon_sym_LBRACE_EQ2,
    STATE(751), 1,
      sym_raw_inline_attribute,
    ACTIONS(2726), 6,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2728), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2736] = 4,
    ACTIONS(2744), 1,
      anon_sym_LBRACE_EQ2,
    STATE(629), 1,
      sym_raw_inline_attribute,
    ACTIONS(2726), 6,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2728), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2784] = 4,
    ACTIONS(2746), 1,
      anon_sym_LBRACE_EQ2,
    STATE(805), 1,
      sym_raw_inline_attribute,
    ACTIONS(2726), 6,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2728), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2832] = 6,
    ACTIONS(2724), 1,
      anon_sym_LBRACE,
    STATE(1025), 1,
      sym__curly_bracket_span_fallback,
    STATE(1029), 1,
      sym_inline_attribute,
    STATE(2433), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2692), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2694), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2884] = 6,
    ACTIONS(2724), 1,
      anon_sym_LBRACE,
    STATE(1027), 1,
      sym__curly_bracket_span_fallback,
    STATE(1029), 1,
      sym_inline_attribute,
    STATE(2433), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(2720), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2722), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2936] = 4,
    ACTIONS(2748), 1,
      anon_sym_LBRACE_EQ2,
    STATE(659), 1,
      sym_raw_inline_attribute,
    ACTIONS(2726), 6,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2728), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [2984] = 4,
    ACTIONS(2750), 1,
      anon_sym_LBRACE_EQ2,
    STATE(875), 1,
      sym_raw_inline_attribute,
    ACTIONS(2726), 6,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2728), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3032] = 4,
    ACTIONS(2752), 1,
      anon_sym_LBRACE_EQ2,
    STATE(573), 1,
      sym_raw_inline_attribute,
    ACTIONS(2726), 6,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2728), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3080] = 5,
    ACTIONS(2754), 1,
      anon_sym_LBRACK,
    ACTIONS(2761), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2763), 1,
      anon_sym_LPAREN,
    ACTIONS(2759), 5,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 30,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3129] = 3,
    ACTIONS(2766), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3174] = 3,
    ACTIONS(2772), 1,
      anon_sym_GT,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3219] = 3,
    ACTIONS(2774), 1,
      anon_sym_GT,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3264] = 4,
    ACTIONS(2780), 1,
      aux_sym__text_token1,
    STATE(492), 1,
      aux_sym__text,
    ACTIONS(2776), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
    ACTIONS(2778), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3311] = 4,
    ACTIONS(2783), 1,
      aux_sym__text_token1,
    STATE(493), 1,
      aux_sym__text,
    ACTIONS(2776), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
    ACTIONS(2778), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3358] = 3,
    ACTIONS(2786), 1,
      anon_sym_GT,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3403] = 4,
    ACTIONS(2788), 1,
      aux_sym__text_token1,
    STATE(495), 1,
      aux_sym__text,
    ACTIONS(2776), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
    ACTIONS(2778), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3450] = 4,
    ACTIONS(2791), 1,
      aux_sym__text_token1,
    STATE(496), 1,
      aux_sym__text,
    ACTIONS(2776), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
    ACTIONS(2778), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3497] = 3,
    ACTIONS(2794), 1,
      aux_sym_autolink_token1,
    ACTIONS(2757), 5,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
    ACTIONS(2759), 32,
      anon_sym_LBRACK,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
      aux_sym__text_token1,
  [3542] = 3,
    ACTIONS(2796), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3587] = 3,
    ACTIONS(2798), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3632] = 3,
    ACTIONS(2800), 1,
      aux_sym_autolink_token1,
    ACTIONS(2757), 5,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
    ACTIONS(2759), 32,
      anon_sym_LBRACK,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
      aux_sym__text_token1,
  [3677] = 3,
    ACTIONS(2802), 1,
      aux_sym_autolink_token1,
    ACTIONS(2757), 5,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
    ACTIONS(2759), 32,
      anon_sym_LBRACK,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
      aux_sym__text_token1,
  [3722] = 3,
    ACTIONS(2804), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3767] = 3,
    ACTIONS(2806), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3812] = 3,
    ACTIONS(2808), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3857] = 3,
    ACTIONS(2810), 1,
      anon_sym_GT,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3902] = 3,
    ACTIONS(2812), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3947] = 5,
    ACTIONS(2754), 1,
      anon_sym_LBRACK,
    ACTIONS(2761), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2763), 1,
      anon_sym_LPAREN,
    ACTIONS(2759), 5,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 30,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [3996] = 5,
    ACTIONS(2754), 1,
      anon_sym_LBRACK,
    ACTIONS(2761), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2763), 1,
      anon_sym_LPAREN,
    ACTIONS(2759), 5,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 30,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4045] = 5,
    ACTIONS(2754), 1,
      anon_sym_LBRACK,
    ACTIONS(2761), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2763), 1,
      anon_sym_LPAREN,
    ACTIONS(2759), 5,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 30,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4094] = 3,
    ACTIONS(2814), 1,
      anon_sym_GT,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4139] = 3,
    ACTIONS(2816), 1,
      aux_sym_autolink_token1,
    ACTIONS(2757), 5,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
    ACTIONS(2759), 32,
      anon_sym_LBRACK,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
      aux_sym__text_token1,
  [4184] = 4,
    ACTIONS(2818), 1,
      aux_sym__text_token1,
    STATE(512), 1,
      aux_sym__text,
    ACTIONS(2776), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
    ACTIONS(2778), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4231] = 4,
    ACTIONS(2821), 1,
      aux_sym__text_token1,
    STATE(513), 1,
      aux_sym__text,
    ACTIONS(2776), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
    ACTIONS(2778), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4278] = 4,
    ACTIONS(2824), 1,
      aux_sym__text_token1,
    STATE(514), 1,
      aux_sym__text,
    ACTIONS(2776), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
    ACTIONS(2778), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4325] = 3,
    ACTIONS(2827), 1,
      anon_sym_GT,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4370] = 4,
    ACTIONS(2829), 1,
      aux_sym__text_token1,
    STATE(516), 1,
      aux_sym__text,
    ACTIONS(2776), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
    ACTIONS(2778), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4417] = 3,
    ACTIONS(2832), 1,
      aux_sym_autolink_token1,
    ACTIONS(2757), 5,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
    ACTIONS(2759), 32,
      anon_sym_LBRACK,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
      aux_sym__text_token1,
  [4462] = 3,
    ACTIONS(2834), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4507] = 3,
    ACTIONS(2836), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4552] = 5,
    ACTIONS(2754), 1,
      anon_sym_LBRACK,
    ACTIONS(2761), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2763), 1,
      anon_sym_LPAREN,
    ACTIONS(2759), 5,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 30,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4601] = 3,
    ACTIONS(2838), 1,
      aux_sym_autolink_token1,
    ACTIONS(2757), 5,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
    ACTIONS(2759), 32,
      anon_sym_LBRACK,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
      aux_sym__text_token1,
  [4646] = 3,
    ACTIONS(2840), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4691] = 3,
    ACTIONS(2842), 1,
      aux_sym_autolink_token1,
    ACTIONS(2757), 5,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
    ACTIONS(2759), 32,
      anon_sym_LBRACK,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
      aux_sym__text_token1,
  [4736] = 3,
    ACTIONS(2844), 1,
      anon_sym_GT,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4781] = 3,
    ACTIONS(2846), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4826] = 4,
    ACTIONS(2848), 1,
      aux_sym__text_token1,
    STATE(526), 1,
      aux_sym__text,
    ACTIONS(2776), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
    ACTIONS(2778), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4873] = 3,
    ACTIONS(2851), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4918] = 3,
    ACTIONS(2853), 1,
      anon_sym_GT,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [4963] = 3,
    ACTIONS(2855), 1,
      aux_sym_autolink_token1,
    ACTIONS(2757), 5,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
    ACTIONS(2759), 32,
      anon_sym_LBRACK,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
      aux_sym__text_token1,
  [5008] = 3,
    ACTIONS(2857), 1,
      aux_sym_autolink_token1,
    ACTIONS(2757), 5,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
    ACTIONS(2759), 32,
      anon_sym_LBRACK,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
      aux_sym__text_token1,
  [5053] = 3,
    ACTIONS(2859), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5098] = 3,
    ACTIONS(2861), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5143] = 5,
    ACTIONS(2754), 1,
      anon_sym_LBRACK,
    ACTIONS(2761), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2763), 1,
      anon_sym_LPAREN,
    ACTIONS(2759), 5,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 30,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5192] = 3,
    ACTIONS(2863), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5237] = 4,
    ACTIONS(2865), 1,
      anon_sym_LBRACE_EQ2,
    STATE(918), 1,
      sym_raw_inline_attribute,
    ACTIONS(2726), 6,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2728), 30,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5284] = 3,
    ACTIONS(2867), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5329] = 3,
    ACTIONS(2869), 1,
      anon_sym_GT,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5374] = 4,
    ACTIONS(2871), 1,
      aux_sym__text_token1,
    STATE(538), 1,
      aux_sym__text,
    ACTIONS(2776), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
    ACTIONS(2778), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5421] = 5,
    ACTIONS(2754), 1,
      anon_sym_LBRACK,
    ACTIONS(2761), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2763), 1,
      anon_sym_LPAREN,
    ACTIONS(2759), 5,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 30,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5470] = 3,
    ACTIONS(2874), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5515] = 5,
    ACTIONS(2754), 1,
      anon_sym_LBRACK,
    ACTIONS(2761), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2763), 1,
      anon_sym_LPAREN,
    ACTIONS(2759), 5,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 30,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_RBRACK2,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5564] = 3,
    ACTIONS(2876), 1,
      aux_sym_autolink_token1,
    ACTIONS(2757), 5,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
    ACTIONS(2759), 32,
      anon_sym_LBRACK,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
      aux_sym__text_token1,
  [5609] = 3,
    ACTIONS(2878), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5654] = 3,
    ACTIONS(2880), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5699] = 5,
    ACTIONS(2754), 1,
      anon_sym_LBRACK,
    ACTIONS(2761), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2763), 1,
      anon_sym_LPAREN,
    ACTIONS(2759), 5,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 30,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5748] = 5,
    ACTIONS(2754), 1,
      anon_sym_LBRACK,
    ACTIONS(2761), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2763), 1,
      anon_sym_LPAREN,
    ACTIONS(2759), 5,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 30,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5797] = 3,
    ACTIONS(2882), 1,
      anon_sym_GT,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5842] = 3,
    ACTIONS(2884), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5887] = 3,
    ACTIONS(2886), 1,
      anon_sym_GT,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5932] = 4,
    ACTIONS(2888), 1,
      aux_sym__text_token1,
    STATE(550), 1,
      aux_sym__text,
    ACTIONS(2776), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
    ACTIONS(2778), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [5979] = 3,
    ACTIONS(2891), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6024] = 3,
    ACTIONS(2893), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6069] = 5,
    ACTIONS(2754), 1,
      anon_sym_LBRACK,
    ACTIONS(2761), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2763), 1,
      anon_sym_LPAREN,
    ACTIONS(2759), 5,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 30,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6118] = 3,
    ACTIONS(2895), 1,
      aux_sym_autolink_token1,
    ACTIONS(2757), 5,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
    ACTIONS(2759), 32,
      anon_sym_LBRACK,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
      aux_sym__text_token1,
  [6163] = 3,
    ACTIONS(2897), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6208] = 3,
    ACTIONS(2899), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6253] = 5,
    ACTIONS(2754), 1,
      anon_sym_LBRACK,
    ACTIONS(2761), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2763), 1,
      anon_sym_LPAREN,
    ACTIONS(2759), 5,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 30,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6302] = 3,
    ACTIONS(2901), 1,
      anon_sym_GT,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6347] = 4,
    ACTIONS(2903), 1,
      aux_sym__text_token1,
    STATE(559), 1,
      aux_sym__text,
    ACTIONS(2776), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
    ACTIONS(2778), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6394] = 3,
    ACTIONS(2906), 1,
      aux_sym_autolink_token1,
    ACTIONS(2757), 4,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
    ACTIONS(2759), 33,
      anon_sym_LBRACK,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
      aux_sym__text_token1,
  [6439] = 3,
    ACTIONS(2912), 1,
      sym__inline_comment_begin,
    ACTIONS(2908), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2910), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6483] = 2,
    ACTIONS(2914), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2916), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6525] = 2,
    ACTIONS(2918), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2920), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6567] = 2,
    ACTIONS(2922), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2924), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6609] = 2,
    ACTIONS(2926), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2928), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6651] = 2,
    ACTIONS(2930), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2932), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6693] = 2,
    ACTIONS(2934), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2936), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6735] = 3,
    ACTIONS(2938), 1,
      sym__verbatim_begin,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 31,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6779] = 2,
    ACTIONS(2941), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2943), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6821] = 2,
    ACTIONS(2945), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2947), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6863] = 2,
    ACTIONS(2941), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2943), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6905] = 2,
    ACTIONS(2945), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2947), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6947] = 2,
    ACTIONS(2949), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2951), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [6989] = 2,
    ACTIONS(2953), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2955), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7031] = 2,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7073] = 2,
    ACTIONS(2957), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2959), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7115] = 2,
    ACTIONS(2961), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2963), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7157] = 2,
    ACTIONS(2965), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2967), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7199] = 2,
    ACTIONS(2969), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2971), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7241] = 2,
    ACTIONS(2973), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2975), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7283] = 2,
    ACTIONS(2977), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2979), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7325] = 2,
    ACTIONS(2981), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2983), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7367] = 2,
    ACTIONS(2985), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2987), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7409] = 2,
    ACTIONS(2989), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2991), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7451] = 2,
    ACTIONS(2993), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2995), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7493] = 2,
    ACTIONS(2997), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2999), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7535] = 2,
    ACTIONS(3001), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3003), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7577] = 3,
    ACTIONS(3005), 1,
      sym__inline_comment_begin,
    ACTIONS(2908), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2910), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7621] = 3,
    ACTIONS(3007), 1,
      sym__verbatim_begin,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7665] = 2,
    ACTIONS(3010), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3012), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7707] = 2,
    ACTIONS(3014), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3016), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7749] = 2,
    ACTIONS(3018), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3020), 33,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_caption_end,
      sym__verbatim_begin,
      anon_sym_NULL,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7791] = 2,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7833] = 2,
    ACTIONS(2914), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2916), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7875] = 2,
    ACTIONS(2918), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2920), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7917] = 2,
    ACTIONS(2922), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2924), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [7959] = 2,
    ACTIONS(2926), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2928), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8001] = 2,
    ACTIONS(2930), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2932), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8043] = 2,
    ACTIONS(2934), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2936), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8085] = 2,
    ACTIONS(2941), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2943), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8127] = 2,
    ACTIONS(2945), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2947), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8169] = 2,
    ACTIONS(2949), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2951), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8211] = 2,
    ACTIONS(2953), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2955), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8253] = 2,
    ACTIONS(2957), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2959), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8295] = 2,
    ACTIONS(2961), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2963), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8337] = 2,
    ACTIONS(2965), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2967), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8379] = 2,
    ACTIONS(2969), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2971), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8421] = 2,
    ACTIONS(2973), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2975), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8463] = 2,
    ACTIONS(2977), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2979), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8505] = 2,
    ACTIONS(2981), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2983), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8547] = 2,
    ACTIONS(2985), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2987), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8589] = 2,
    ACTIONS(2989), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2991), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8631] = 2,
    ACTIONS(2993), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2995), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8673] = 2,
    ACTIONS(2997), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2999), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8715] = 2,
    ACTIONS(3001), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3003), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8757] = 3,
    ACTIONS(3022), 1,
      sym__inline_comment_begin,
    ACTIONS(2908), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2910), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8801] = 3,
    ACTIONS(3024), 1,
      sym__verbatim_begin,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8845] = 2,
    ACTIONS(3010), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3012), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8887] = 2,
    ACTIONS(3014), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3016), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8929] = 2,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [8971] = 2,
    ACTIONS(2914), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2916), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9013] = 2,
    ACTIONS(2918), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2920), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9055] = 2,
    ACTIONS(2922), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2924), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9097] = 2,
    ACTIONS(2926), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2928), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9139] = 2,
    ACTIONS(2930), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2932), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9181] = 2,
    ACTIONS(2934), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2936), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9223] = 2,
    ACTIONS(2941), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2943), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9265] = 2,
    ACTIONS(2945), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2947), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9307] = 2,
    ACTIONS(2949), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2951), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9349] = 2,
    ACTIONS(2953), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2955), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9391] = 2,
    ACTIONS(2957), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2959), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9433] = 2,
    ACTIONS(2961), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2963), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9475] = 2,
    ACTIONS(2965), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2967), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9517] = 2,
    ACTIONS(2969), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2971), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9559] = 2,
    ACTIONS(2973), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2975), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9601] = 2,
    ACTIONS(2977), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2979), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9643] = 2,
    ACTIONS(2981), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2983), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9685] = 2,
    ACTIONS(2985), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2987), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9727] = 2,
    ACTIONS(2989), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2991), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9769] = 2,
    ACTIONS(2993), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2995), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9811] = 2,
    ACTIONS(2997), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2999), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9853] = 2,
    ACTIONS(3001), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3003), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9895] = 3,
    ACTIONS(3027), 1,
      sym__inline_comment_begin,
    ACTIONS(2908), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2910), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9939] = 3,
    ACTIONS(3029), 1,
      sym__verbatim_begin,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [9983] = 2,
    ACTIONS(3010), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3012), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10025] = 2,
    ACTIONS(3014), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3016), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10067] = 2,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10109] = 2,
    ACTIONS(2949), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2951), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10151] = 2,
    ACTIONS(2914), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2916), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10193] = 2,
    ACTIONS(2918), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2920), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10235] = 2,
    ACTIONS(2922), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2924), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10277] = 2,
    ACTIONS(2926), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2928), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10319] = 2,
    ACTIONS(2930), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2932), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10361] = 2,
    ACTIONS(2934), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2936), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10403] = 2,
    ACTIONS(2953), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2955), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10445] = 2,
    ACTIONS(3010), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3012), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10487] = 2,
    ACTIONS(2941), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2943), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10529] = 2,
    ACTIONS(2945), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2947), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10571] = 2,
    ACTIONS(2949), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2951), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10613] = 2,
    ACTIONS(2953), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2955), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10655] = 2,
    ACTIONS(2957), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2959), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10697] = 2,
    ACTIONS(2961), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2963), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10739] = 2,
    ACTIONS(2965), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2967), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10781] = 2,
    ACTIONS(2969), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2971), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10823] = 2,
    ACTIONS(2973), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2975), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10865] = 2,
    ACTIONS(2977), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2979), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10907] = 2,
    ACTIONS(2981), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2983), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10949] = 2,
    ACTIONS(2985), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2987), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [10991] = 2,
    ACTIONS(2989), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2991), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11033] = 2,
    ACTIONS(2993), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2995), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11075] = 2,
    ACTIONS(2997), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2999), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11117] = 2,
    ACTIONS(3001), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3003), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11159] = 3,
    ACTIONS(3032), 1,
      sym__inline_comment_begin,
    ACTIONS(2908), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2910), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11203] = 2,
    ACTIONS(3014), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3016), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11245] = 2,
    ACTIONS(2957), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2959), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11287] = 2,
    ACTIONS(2961), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2963), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11329] = 3,
    ACTIONS(3034), 1,
      sym__verbatim_begin,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11373] = 2,
    ACTIONS(3010), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3012), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11415] = 2,
    ACTIONS(3014), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3016), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11457] = 2,
    ACTIONS(2965), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2967), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11499] = 2,
    ACTIONS(2969), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2971), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11541] = 2,
    ACTIONS(2973), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2975), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11583] = 2,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11625] = 2,
    ACTIONS(2977), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2979), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11667] = 2,
    ACTIONS(2914), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2916), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11709] = 2,
    ACTIONS(2918), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2920), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11751] = 2,
    ACTIONS(2922), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2924), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11793] = 2,
    ACTIONS(2926), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2928), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11835] = 2,
    ACTIONS(2930), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2932), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11877] = 2,
    ACTIONS(2934), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2936), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11919] = 2,
    ACTIONS(2981), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2983), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [11961] = 2,
    ACTIONS(2985), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2987), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12003] = 2,
    ACTIONS(2989), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2991), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12045] = 2,
    ACTIONS(2941), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2943), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12087] = 2,
    ACTIONS(2945), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2947), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12129] = 2,
    ACTIONS(2949), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2951), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12171] = 2,
    ACTIONS(2953), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2955), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12213] = 2,
    ACTIONS(2957), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2959), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12255] = 2,
    ACTIONS(2961), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2963), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12297] = 2,
    ACTIONS(2965), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2967), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12339] = 2,
    ACTIONS(2969), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2971), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12381] = 2,
    ACTIONS(2973), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2975), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12423] = 2,
    ACTIONS(2977), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2979), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12465] = 2,
    ACTIONS(2981), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2983), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12507] = 2,
    ACTIONS(2985), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2987), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12549] = 2,
    ACTIONS(2989), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2991), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12591] = 2,
    ACTIONS(2993), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2995), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12633] = 2,
    ACTIONS(2997), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2999), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12675] = 2,
    ACTIONS(3001), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3003), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12717] = 3,
    ACTIONS(3037), 1,
      sym__verbatim_begin,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12761] = 2,
    ACTIONS(3010), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3012), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12803] = 2,
    ACTIONS(3014), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3016), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12845] = 2,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12887] = 2,
    ACTIONS(2914), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2916), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12929] = 2,
    ACTIONS(2918), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2920), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [12971] = 2,
    ACTIONS(2922), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2924), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13013] = 2,
    ACTIONS(2926), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2928), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13055] = 2,
    ACTIONS(2930), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2932), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13097] = 2,
    ACTIONS(2934), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2936), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13139] = 2,
    ACTIONS(2941), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2943), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13181] = 2,
    ACTIONS(2945), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2947), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13223] = 2,
    ACTIONS(2949), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2951), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13265] = 2,
    ACTIONS(2953), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2955), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13307] = 2,
    ACTIONS(2957), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2959), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13349] = 2,
    ACTIONS(2961), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2963), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13391] = 2,
    ACTIONS(2965), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2967), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13433] = 2,
    ACTIONS(2969), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2971), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13475] = 2,
    ACTIONS(2973), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2975), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13517] = 2,
    ACTIONS(2977), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2979), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13559] = 2,
    ACTIONS(2981), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2983), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13601] = 2,
    ACTIONS(2985), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2987), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13643] = 2,
    ACTIONS(2989), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2991), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13685] = 2,
    ACTIONS(2993), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2995), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13727] = 2,
    ACTIONS(2997), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2999), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13769] = 2,
    ACTIONS(3001), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3003), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13811] = 3,
    ACTIONS(3040), 1,
      sym__inline_comment_begin,
    ACTIONS(2908), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2910), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13855] = 3,
    ACTIONS(3042), 1,
      sym__verbatim_begin,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13899] = 2,
    ACTIONS(3010), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3012), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13941] = 2,
    ACTIONS(3014), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3016), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [13983] = 2,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14025] = 2,
    ACTIONS(2993), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2995), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14067] = 2,
    ACTIONS(2914), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2916), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14109] = 2,
    ACTIONS(2918), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2920), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14151] = 2,
    ACTIONS(2922), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2924), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14193] = 2,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14235] = 2,
    ACTIONS(2930), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2932), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14277] = 2,
    ACTIONS(2934), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2936), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14319] = 2,
    ACTIONS(2997), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2999), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14361] = 2,
    ACTIONS(2941), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2943), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14403] = 2,
    ACTIONS(2945), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2947), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14445] = 2,
    ACTIONS(2949), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2951), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14487] = 2,
    ACTIONS(2953), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2955), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14529] = 2,
    ACTIONS(2957), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2959), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14571] = 2,
    ACTIONS(2961), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2963), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14613] = 2,
    ACTIONS(2965), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2967), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14655] = 2,
    ACTIONS(2969), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2971), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14697] = 2,
    ACTIONS(2973), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2975), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14739] = 2,
    ACTIONS(2977), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2979), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14781] = 2,
    ACTIONS(2981), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2983), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14823] = 2,
    ACTIONS(2985), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2987), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14865] = 2,
    ACTIONS(2989), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2991), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14907] = 2,
    ACTIONS(2993), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2995), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14949] = 2,
    ACTIONS(2997), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2999), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [14991] = 2,
    ACTIONS(3001), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3003), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15033] = 3,
    ACTIONS(3045), 1,
      sym__inline_comment_begin,
    ACTIONS(2908), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2910), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15077] = 3,
    ACTIONS(3047), 1,
      sym__verbatim_begin,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15121] = 2,
    ACTIONS(3010), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3012), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15163] = 2,
    ACTIONS(3014), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3016), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15205] = 2,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15247] = 2,
    ACTIONS(2914), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2916), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15289] = 2,
    ACTIONS(2918), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2920), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15331] = 2,
    ACTIONS(2922), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2924), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15373] = 2,
    ACTIONS(2926), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2928), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15415] = 2,
    ACTIONS(2930), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2932), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15457] = 2,
    ACTIONS(2934), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2936), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15499] = 2,
    ACTIONS(3001), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3003), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15541] = 2,
    ACTIONS(2941), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2943), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15583] = 2,
    ACTIONS(2945), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2947), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15625] = 2,
    ACTIONS(2949), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2951), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15667] = 2,
    ACTIONS(2953), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2955), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15709] = 2,
    ACTIONS(2957), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2959), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15751] = 2,
    ACTIONS(2961), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2963), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15793] = 2,
    ACTIONS(2965), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2967), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15835] = 2,
    ACTIONS(2969), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2971), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15877] = 2,
    ACTIONS(2973), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2975), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15919] = 2,
    ACTIONS(2977), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2979), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [15961] = 2,
    ACTIONS(2981), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2983), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16003] = 2,
    ACTIONS(2985), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2987), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16045] = 2,
    ACTIONS(2989), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2991), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16087] = 2,
    ACTIONS(2993), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2995), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16129] = 2,
    ACTIONS(2997), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2999), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16171] = 2,
    ACTIONS(3001), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3003), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16213] = 3,
    ACTIONS(3050), 1,
      sym__verbatim_begin,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16257] = 2,
    ACTIONS(3010), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3012), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16299] = 2,
    ACTIONS(3014), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3016), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16341] = 2,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16383] = 2,
    ACTIONS(2914), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2916), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16425] = 2,
    ACTIONS(2918), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2920), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16467] = 2,
    ACTIONS(2922), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2924), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16509] = 2,
    ACTIONS(2926), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2928), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16551] = 2,
    ACTIONS(2930), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2932), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16593] = 2,
    ACTIONS(2934), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2936), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16635] = 2,
    ACTIONS(2941), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2943), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16677] = 2,
    ACTIONS(2945), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2947), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16719] = 2,
    ACTIONS(2949), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2951), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16761] = 2,
    ACTIONS(2953), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2955), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16803] = 2,
    ACTIONS(2957), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2959), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16845] = 2,
    ACTIONS(2961), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2963), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16887] = 2,
    ACTIONS(2965), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2967), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16929] = 2,
    ACTIONS(2969), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2971), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [16971] = 2,
    ACTIONS(2973), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2975), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17013] = 2,
    ACTIONS(2977), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2979), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17055] = 2,
    ACTIONS(2981), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2983), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17097] = 2,
    ACTIONS(2985), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2987), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17139] = 2,
    ACTIONS(2989), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2991), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17181] = 2,
    ACTIONS(2993), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2995), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17223] = 2,
    ACTIONS(2997), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2999), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17265] = 2,
    ACTIONS(3001), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3003), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17307] = 2,
    ACTIONS(2914), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2916), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17349] = 3,
    ACTIONS(3053), 1,
      aux_sym_autolink_token1,
    ACTIONS(2757), 4,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
    ACTIONS(2759), 32,
      anon_sym_LBRACK,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
      aux_sym__text_token1,
  [17393] = 3,
    ACTIONS(3055), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17437] = 3,
    ACTIONS(3057), 1,
      sym__non_whitespace_check,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17481] = 5,
    ACTIONS(2754), 1,
      anon_sym_LBRACK,
    ACTIONS(2761), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2763), 1,
      anon_sym_LPAREN,
    ACTIONS(2759), 5,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 29,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17529] = 2,
    ACTIONS(2918), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2920), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17571] = 2,
    ACTIONS(2922), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2924), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17613] = 3,
    ACTIONS(3059), 1,
      anon_sym_GT,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17657] = 4,
    ACTIONS(3061), 1,
      aux_sym__text_token1,
    STATE(827), 1,
      aux_sym__text,
    ACTIONS(2776), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
    ACTIONS(2778), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17703] = 2,
    ACTIONS(2926), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2928), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17745] = 2,
    ACTIONS(2930), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2932), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17787] = 2,
    ACTIONS(2934), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2936), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17829] = 3,
    ACTIONS(3064), 1,
      sym__inline_comment_begin,
    ACTIONS(2908), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2910), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17873] = 3,
    ACTIONS(3066), 1,
      sym__inline_comment_begin,
    ACTIONS(2908), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2910), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17917] = 3,
    ACTIONS(3068), 1,
      sym__verbatim_begin,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [17961] = 2,
    ACTIONS(3010), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3012), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18003] = 2,
    ACTIONS(3014), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3016), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18045] = 4,
    ACTIONS(822), 1,
      sym__block_quote_continuation,
    STATE(844), 1,
      aux_sym__block_quote_prefix_repeat1,
    ACTIONS(2683), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2685), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18091] = 2,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18133] = 2,
    ACTIONS(2914), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2916), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18175] = 2,
    ACTIONS(2918), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2920), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18217] = 2,
    ACTIONS(2922), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2924), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18259] = 2,
    ACTIONS(2926), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2928), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18301] = 2,
    ACTIONS(2930), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2932), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18343] = 2,
    ACTIONS(2934), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2936), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18385] = 4,
    ACTIONS(3071), 1,
      sym__block_quote_continuation,
    STATE(844), 1,
      aux_sym__block_quote_prefix_repeat1,
    ACTIONS(2673), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2675), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18431] = 2,
    ACTIONS(3074), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3076), 33,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_caption_end,
      sym__verbatim_begin,
      anon_sym_NULL,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18473] = 2,
    ACTIONS(2941), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2943), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18515] = 2,
    ACTIONS(2945), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2947), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18557] = 2,
    ACTIONS(2949), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2951), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18599] = 2,
    ACTIONS(2953), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2955), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18641] = 2,
    ACTIONS(2957), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2959), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18683] = 2,
    ACTIONS(2961), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2963), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18725] = 2,
    ACTIONS(2965), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2967), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18767] = 2,
    ACTIONS(2969), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2971), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18809] = 2,
    ACTIONS(2973), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2975), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18851] = 2,
    ACTIONS(2977), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2979), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18893] = 2,
    ACTIONS(2981), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2983), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18935] = 2,
    ACTIONS(2985), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2987), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [18977] = 2,
    ACTIONS(2989), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2991), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19019] = 2,
    ACTIONS(2993), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2995), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19061] = 2,
    ACTIONS(2997), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2999), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19103] = 2,
    ACTIONS(3001), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3003), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19145] = 3,
    ACTIONS(3078), 1,
      sym__inline_comment_begin,
    ACTIONS(2908), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2910), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19189] = 3,
    ACTIONS(3080), 1,
      sym__verbatim_begin,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19233] = 2,
    ACTIONS(3010), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3012), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19275] = 2,
    ACTIONS(3014), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3016), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19317] = 2,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19359] = 2,
    ACTIONS(2914), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2916), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19401] = 2,
    ACTIONS(2918), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2920), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19443] = 2,
    ACTIONS(2922), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2924), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19485] = 2,
    ACTIONS(2926), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2928), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19527] = 2,
    ACTIONS(2930), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2932), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19569] = 2,
    ACTIONS(2934), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2936), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19611] = 2,
    ACTIONS(2941), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2943), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19653] = 2,
    ACTIONS(2945), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2947), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19695] = 2,
    ACTIONS(2949), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2951), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19737] = 2,
    ACTIONS(2953), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2955), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19779] = 2,
    ACTIONS(2957), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2959), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19821] = 2,
    ACTIONS(2961), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2963), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19863] = 2,
    ACTIONS(2965), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2967), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19905] = 2,
    ACTIONS(2969), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2971), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19947] = 2,
    ACTIONS(2973), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2975), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [19989] = 2,
    ACTIONS(2977), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2979), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20031] = 2,
    ACTIONS(2981), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2983), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20073] = 2,
    ACTIONS(2985), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2987), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20115] = 2,
    ACTIONS(2989), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2991), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20157] = 2,
    ACTIONS(2993), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2995), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20199] = 2,
    ACTIONS(2997), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2999), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20241] = 2,
    ACTIONS(3001), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3003), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20283] = 3,
    ACTIONS(3083), 1,
      sym__verbatim_begin,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20327] = 2,
    ACTIONS(3010), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3012), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20369] = 2,
    ACTIONS(3014), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3016), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20411] = 2,
    ACTIONS(2926), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2928), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20453] = 2,
    ACTIONS(3086), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3088), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20494] = 2,
    ACTIONS(3090), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3092), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20535] = 2,
    ACTIONS(3094), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3096), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20576] = 2,
    ACTIONS(3098), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3100), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20617] = 2,
    ACTIONS(3102), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3104), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20658] = 2,
    ACTIONS(3086), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3088), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20699] = 2,
    ACTIONS(3086), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3088), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20740] = 2,
    ACTIONS(3106), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3108), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20781] = 2,
    ACTIONS(3094), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3096), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20822] = 3,
    ACTIONS(3110), 1,
      sym__verbatim_begin,
    ACTIONS(2759), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2757), 30,
      sym__newline_inline,
      sym_hard_line_break,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20865] = 2,
    ACTIONS(3010), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3012), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20906] = 2,
    ACTIONS(3014), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3016), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20947] = 2,
    ACTIONS(3098), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3100), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [20988] = 2,
    ACTIONS(3113), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3115), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21029] = 2,
    ACTIONS(2768), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2770), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21070] = 2,
    ACTIONS(3094), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3096), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21111] = 2,
    ACTIONS(2914), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2916), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21152] = 2,
    ACTIONS(2918), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2920), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21193] = 2,
    ACTIONS(2922), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2924), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21234] = 2,
    ACTIONS(2926), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2928), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21275] = 2,
    ACTIONS(2930), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2932), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21316] = 2,
    ACTIONS(2934), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2936), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21357] = 2,
    ACTIONS(3106), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3108), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21398] = 2,
    ACTIONS(2941), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2943), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21439] = 2,
    ACTIONS(2945), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2947), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21480] = 2,
    ACTIONS(2949), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2951), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21521] = 2,
    ACTIONS(2953), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2955), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21562] = 2,
    ACTIONS(2957), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2959), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21603] = 2,
    ACTIONS(2961), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2963), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21644] = 2,
    ACTIONS(2965), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2967), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21685] = 2,
    ACTIONS(2969), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2971), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21726] = 2,
    ACTIONS(2973), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2975), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21767] = 2,
    ACTIONS(2977), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2979), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21808] = 2,
    ACTIONS(2981), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2983), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21849] = 2,
    ACTIONS(2985), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2987), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21890] = 2,
    ACTIONS(2989), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2991), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21931] = 2,
    ACTIONS(2993), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2995), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [21972] = 2,
    ACTIONS(2997), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(2999), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22013] = 2,
    ACTIONS(3001), 5,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      anon_sym_LBRACE,
      aux_sym__text_token1,
    ACTIONS(3003), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22054] = 2,
    ACTIONS(3117), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3119), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22095] = 2,
    ACTIONS(3113), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3115), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22136] = 2,
    ACTIONS(655), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(657), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__block_quote_continuation,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22177] = 2,
    ACTIONS(3117), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3119), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22218] = 2,
    ACTIONS(3090), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3092), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22259] = 2,
    ACTIONS(3090), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3092), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22300] = 2,
    ACTIONS(3102), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3104), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22341] = 2,
    ACTIONS(3094), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3096), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22382] = 2,
    ACTIONS(3106), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3108), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22423] = 2,
    ACTIONS(3117), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3119), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22464] = 2,
    ACTIONS(3098), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3100), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22505] = 2,
    ACTIONS(3090), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3092), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22546] = 2,
    ACTIONS(3117), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3119), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22587] = 2,
    ACTIONS(3090), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3092), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22628] = 2,
    ACTIONS(3098), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3100), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22669] = 2,
    ACTIONS(3102), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3104), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22710] = 2,
    ACTIONS(3102), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3104), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22751] = 2,
    ACTIONS(3098), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3100), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22792] = 2,
    ACTIONS(3113), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3115), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22833] = 2,
    ACTIONS(3117), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3119), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22874] = 2,
    ACTIONS(3113), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3115), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22915] = 2,
    ACTIONS(3102), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3104), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22956] = 2,
    ACTIONS(3090), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3092), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [22997] = 2,
    ACTIONS(3113), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3115), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23038] = 2,
    ACTIONS(3098), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3100), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23079] = 2,
    ACTIONS(3098), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3100), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23120] = 2,
    ACTIONS(3094), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3096), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23161] = 3,
    ACTIONS(3121), 1,
      sym_strong_end,
    ACTIONS(3106), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3108), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23204] = 2,
    ACTIONS(3098), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3100), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23245] = 2,
    ACTIONS(3117), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3119), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23286] = 2,
    ACTIONS(3117), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3119), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23327] = 2,
    ACTIONS(3113), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3115), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23368] = 3,
    ACTIONS(3123), 1,
      sym_strong_end,
    ACTIONS(3106), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3108), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23411] = 2,
    ACTIONS(3086), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3088), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23452] = 2,
    ACTIONS(3090), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3092), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23493] = 2,
    ACTIONS(3086), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3088), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23534] = 2,
    ACTIONS(3094), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3096), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23575] = 2,
    ACTIONS(3102), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3104), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_strong_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23616] = 2,
    ACTIONS(3098), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3100), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23657] = 2,
    ACTIONS(3102), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3104), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23698] = 2,
    ACTIONS(3086), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3088), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23739] = 2,
    ACTIONS(3086), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3088), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23780] = 2,
    ACTIONS(3094), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3096), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23821] = 2,
    ACTIONS(3113), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3115), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23862] = 2,
    ACTIONS(3094), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3096), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_cell_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23903] = 2,
    ACTIONS(3094), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3096), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23944] = 2,
    ACTIONS(3106), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3108), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [23985] = 2,
    ACTIONS(3117), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3119), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24026] = 2,
    ACTIONS(3090), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3092), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24067] = 2,
    ACTIONS(3113), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3115), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24108] = 2,
    ACTIONS(3106), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3108), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24149] = 2,
    ACTIONS(3117), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3119), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24190] = 2,
    ACTIONS(3090), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3092), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24231] = 2,
    ACTIONS(3117), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3119), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24272] = 2,
    ACTIONS(3102), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3104), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24313] = 2,
    ACTIONS(3090), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3092), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24354] = 3,
    ACTIONS(3121), 1,
      sym_emphasis_end,
    ACTIONS(3106), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3108), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24397] = 2,
    ACTIONS(3102), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3104), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24438] = 2,
    ACTIONS(3102), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3104), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24479] = 2,
    ACTIONS(3086), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3088), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24520] = 2,
    ACTIONS(3102), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3104), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24561] = 2,
    ACTIONS(3113), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3115), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24602] = 2,
    ACTIONS(3086), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3088), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24643] = 2,
    ACTIONS(3094), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3096), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24684] = 2,
    ACTIONS(3098), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3100), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24725] = 2,
    ACTIONS(3106), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3108), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_insert_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24766] = 2,
    ACTIONS(3113), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3115), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24807] = 2,
    ACTIONS(3106), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3108), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24848] = 2,
    ACTIONS(3113), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3115), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24889] = 2,
    ACTIONS(3098), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3100), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24930] = 2,
    ACTIONS(3086), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3088), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [24971] = 2,
    ACTIONS(3117), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3119), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25012] = 2,
    ACTIONS(3090), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3092), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25053] = 2,
    ACTIONS(3098), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3100), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_delete_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25094] = 2,
    ACTIONS(3094), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3096), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25135] = 2,
    ACTIONS(3125), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3127), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__table_row_end_newline,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25176] = 2,
    ACTIONS(3090), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3092), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25217] = 3,
    ACTIONS(3123), 1,
      sym_emphasis_end,
    ACTIONS(3106), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3108), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25260] = 2,
    ACTIONS(3113), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3115), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25301] = 2,
    ACTIONS(3094), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3096), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__link_ref_def_label_end,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25342] = 2,
    ACTIONS(3102), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3104), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_subscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25383] = 3,
    ACTIONS(3129), 1,
      sym__inline_comment_begin,
    ACTIONS(2908), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2910), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25426] = 2,
    ACTIONS(3106), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3108), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25467] = 2,
    ACTIONS(3086), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3088), 32,
      sym__eof_or_newline,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25508] = 2,
    ACTIONS(3086), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3088), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__square_bracket_span_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25549] = 2,
    ACTIONS(3106), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3108), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_superscript_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25590] = 3,
    ACTIONS(3131), 1,
      sym__inline_comment_begin,
    ACTIONS(2908), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2910), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25633] = 3,
    ACTIONS(3133), 1,
      sym__inline_comment_begin,
    ACTIONS(2908), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(2910), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25676] = 2,
    ACTIONS(3117), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3119), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_emphasis_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25717] = 2,
    ACTIONS(3106), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3108), 32,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym_highlighted_end,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25758] = 2,
    ACTIONS(3106), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3108), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25798] = 2,
    ACTIONS(3086), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3088), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25838] = 2,
    ACTIONS(3113), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3115), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25878] = 2,
    ACTIONS(3090), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3092), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25918] = 2,
    ACTIONS(3094), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3096), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25958] = 2,
    ACTIONS(3102), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3104), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [25998] = 2,
    ACTIONS(3098), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3100), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [26038] = 2,
    ACTIONS(3117), 4,
      anon_sym_LBRACK,
      sym_en_dash,
      sym_backslash_escape,
      aux_sym__text_token1,
    ACTIONS(3119), 31,
      sym__newline_inline,
      sym_hard_line_break,
      sym__verbatim_begin,
      sym__whitespace1,
      sym_quotation_marks,
      sym_ellipsis,
      sym_em_dash,
      anon_sym_LT,
      sym_symbol,
      anon_sym_LBRACE_,
      anon_sym__,
      anon_sym_LBRACE_STAR,
      anon_sym_STAR,
      anon_sym_LBRACE_CARET,
      anon_sym_CARET,
      anon_sym_LBRACE_TILDE,
      anon_sym_TILDE,
      anon_sym_LBRACE_EQ,
      anon_sym_LBRACE_PLUS,
      anon_sym_LBRACE_DASH,
      anon_sym_LBRACK_CARET,
      anon_sym_BANG_LBRACK,
      anon_sym_LBRACK_RBRACK2,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
      anon_sym_TODO,
      anon_sym_WIP,
      anon_sym_NOTE,
      anon_sym_INFO,
      anon_sym_XXX,
      sym_fixme,
  [26078] = 11,
    ACTIONS(639), 1,
      sym__table_header_begin,
    ACTIONS(641), 1,
      sym__table_separator_begin,
    ACTIONS(643), 1,
      sym__table_row_begin,
    ACTIONS(1014), 1,
      sym__block_quote_continuation,
    ACTIONS(3135), 1,
      sym__newline,
    ACTIONS(3137), 1,
      sym__table_caption_begin,
    STATE(1307), 1,
      sym__block_quote_prefix,
    STATE(1345), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1473), 1,
      sym_table_caption,
    ACTIONS(1008), 2,
      sym__list_item_continuation,
      sym__list_item_end,
    STATE(1032), 5,
      sym__table_row,
      sym_table_header,
      sym_table_separator,
      sym_table_row,
      aux_sym_table_repeat1,
  [26117] = 11,
    ACTIONS(675), 1,
      sym__table_header_begin,
    ACTIONS(677), 1,
      sym__table_separator_begin,
    ACTIONS(679), 1,
      sym__table_row_begin,
    ACTIONS(1008), 1,
      sym__block_close,
    ACTIONS(1014), 1,
      sym__block_quote_continuation,
    ACTIONS(3139), 1,
      sym__newline,
    ACTIONS(3141), 1,
      sym__table_caption_begin,
    STATE(1275), 1,
      sym__block_quote_prefix,
    STATE(1345), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1964), 1,
      sym_table_caption,
    STATE(1034), 5,
      sym__table_row,
      sym_table_header,
      sym_table_separator,
      sym_table_row,
      aux_sym_table_repeat1,
  [26155] = 8,
    ACTIONS(1326), 1,
      sym__block_quote_continuation,
    ACTIONS(3143), 1,
      sym__table_header_begin,
    ACTIONS(3146), 1,
      sym__table_separator_begin,
    ACTIONS(3149), 1,
      sym__table_row_begin,
    STATE(1307), 1,
      sym__block_quote_prefix,
    STATE(1345), 1,
      aux_sym__block_quote_prefix_repeat1,
    ACTIONS(1324), 4,
      sym__newline,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__table_caption_begin,
    STATE(1032), 5,
      sym__table_row,
      sym_table_header,
      sym_table_separator,
      sym_table_row,
      aux_sym_table_repeat1,
  [26187] = 11,
    ACTIONS(569), 1,
      sym__table_header_begin,
    ACTIONS(571), 1,
      sym__table_separator_begin,
    ACTIONS(573), 1,
      sym__table_row_begin,
    ACTIONS(1008), 1,
      sym__indented_content_spacer,
    ACTIONS(1014), 1,
      sym__block_quote_continuation,
    ACTIONS(3152), 1,
      sym__newline,
    ACTIONS(3154), 1,
      sym__table_caption_begin,
    STATE(1296), 1,
      sym__block_quote_prefix,
    STATE(1345), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2337), 1,
      sym_table_caption,
    STATE(1035), 5,
      sym__table_row,
      sym_table_header,
      sym_table_separator,
      sym_table_row,
      aux_sym_table_repeat1,
  [26225] = 8,
    ACTIONS(1326), 1,
      sym__block_quote_continuation,
    ACTIONS(3156), 1,
      sym__table_header_begin,
    ACTIONS(3159), 1,
      sym__table_separator_begin,
    ACTIONS(3162), 1,
      sym__table_row_begin,
    STATE(1275), 1,
      sym__block_quote_prefix,
    STATE(1345), 1,
      aux_sym__block_quote_prefix_repeat1,
    ACTIONS(1324), 3,
      sym__block_close,
      sym__newline,
      sym__table_caption_begin,
    STATE(1034), 5,
      sym__table_row,
      sym_table_header,
      sym_table_separator,
      sym_table_row,
      aux_sym_table_repeat1,
  [26256] = 8,
    ACTIONS(1326), 1,
      sym__block_quote_continuation,
    ACTIONS(3165), 1,
      sym__table_header_begin,
    ACTIONS(3168), 1,
      sym__table_separator_begin,
    ACTIONS(3171), 1,
      sym__table_row_begin,
    STATE(1296), 1,
      sym__block_quote_prefix,
    STATE(1345), 1,
      aux_sym__block_quote_prefix_repeat1,
    ACTIONS(1324), 3,
      sym__newline,
      sym__indented_content_spacer,
      sym__table_caption_begin,
    STATE(1035), 5,
      sym__table_row,
      sym_table_header,
      sym_table_separator,
      sym_table_row,
      aux_sym_table_repeat1,
  [26287] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3182), 1,
      sym__curly_bracket_span_end,
    STATE(1038), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26318] = 9,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3184), 1,
      anon_sym_RBRACE,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3190), 1,
      anon_sym_PERCENT,
    STATE(1048), 1,
      aux_sym_block_attribute_repeat1,
    STATE(1164), 1,
      sym__comment,
    STATE(1988), 1,
      sym_key,
    STATE(1178), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3188), 3,
      sym__newline,
      sym_identifier,
      sym__whitespace1,
  [26349] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3192), 1,
      sym__curly_bracket_span_end,
    STATE(1040), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26380] = 9,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3190), 1,
      anon_sym_PERCENT,
    ACTIONS(3194), 1,
      anon_sym_RBRACE,
    STATE(1048), 1,
      aux_sym_block_attribute_repeat1,
    STATE(1164), 1,
      sym__comment,
    STATE(1988), 1,
      sym_key,
    STATE(1178), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3188), 3,
      sym__newline,
      sym_identifier,
      sym__whitespace1,
  [26411] = 9,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3202), 1,
      sym__id,
    ACTIONS(3205), 1,
      anon_sym_PERCENT,
    ACTIONS(3208), 1,
      sym__curly_bracket_span_end,
    STATE(1040), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3199), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26442] = 9,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3190), 1,
      anon_sym_PERCENT,
    ACTIONS(3210), 1,
      anon_sym_RBRACE,
    STATE(1039), 1,
      aux_sym_block_attribute_repeat1,
    STATE(1164), 1,
      sym__comment,
    STATE(1988), 1,
      sym_key,
    STATE(1178), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3188), 3,
      sym__newline,
      sym_identifier,
      sym__whitespace1,
  [26473] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3212), 1,
      sym__curly_bracket_span_end,
    STATE(1043), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26504] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3214), 1,
      sym__curly_bracket_span_end,
    STATE(1040), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26535] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3216), 1,
      sym__curly_bracket_span_end,
    STATE(1045), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26566] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3218), 1,
      sym__curly_bracket_span_end,
    STATE(1040), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26597] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3220), 1,
      sym__curly_bracket_span_end,
    STATE(1047), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26628] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3222), 1,
      sym__curly_bracket_span_end,
    STATE(1040), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26659] = 9,
    ACTIONS(3224), 1,
      anon_sym_RBRACE,
    ACTIONS(3226), 1,
      anon_sym_DOT,
    ACTIONS(3232), 1,
      sym__id,
    ACTIONS(3235), 1,
      anon_sym_PERCENT,
    STATE(1048), 1,
      aux_sym_block_attribute_repeat1,
    STATE(1164), 1,
      sym__comment,
    STATE(1988), 1,
      sym_key,
    STATE(1178), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3229), 3,
      sym__newline,
      sym_identifier,
      sym__whitespace1,
  [26690] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3238), 1,
      sym__curly_bracket_span_end,
    STATE(1040), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26721] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3240), 1,
      sym__curly_bracket_span_end,
    STATE(1051), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26752] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3242), 1,
      sym__curly_bracket_span_end,
    STATE(1040), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26783] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3244), 1,
      sym__curly_bracket_span_end,
    STATE(1053), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26814] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3246), 1,
      sym__curly_bracket_span_end,
    STATE(1040), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26845] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3248), 1,
      sym__curly_bracket_span_end,
    STATE(1055), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26876] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3250), 1,
      sym__curly_bracket_span_end,
    STATE(1040), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26907] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3252), 1,
      sym__curly_bracket_span_end,
    STATE(1057), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26938] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3254), 1,
      sym__curly_bracket_span_end,
    STATE(1040), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [26969] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3256), 1,
      sym__curly_bracket_span_end,
    STATE(1059), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [27000] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3258), 1,
      sym__curly_bracket_span_end,
    STATE(1040), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [27031] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3260), 1,
      sym__curly_bracket_span_end,
    STATE(1061), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [27062] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3262), 1,
      sym__curly_bracket_span_end,
    STATE(1040), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [27093] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3264), 1,
      sym__curly_bracket_span_end,
    STATE(1063), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [27124] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3266), 1,
      sym__curly_bracket_span_end,
    STATE(1040), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [27155] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3268), 1,
      sym__curly_bracket_span_end,
    STATE(1065), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [27186] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3270), 1,
      sym__curly_bracket_span_end,
    STATE(1040), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [27217] = 9,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3190), 1,
      anon_sym_PERCENT,
    ACTIONS(3272), 1,
      anon_sym_RBRACE,
    STATE(1067), 1,
      aux_sym_block_attribute_repeat1,
    STATE(1164), 1,
      sym__comment,
    STATE(1988), 1,
      sym_key,
    STATE(1178), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3188), 3,
      sym__newline,
      sym_identifier,
      sym__whitespace1,
  [27248] = 9,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3190), 1,
      anon_sym_PERCENT,
    ACTIONS(3274), 1,
      anon_sym_RBRACE,
    STATE(1048), 1,
      aux_sym_block_attribute_repeat1,
    STATE(1164), 1,
      sym__comment,
    STATE(1988), 1,
      sym_key,
    STATE(1178), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3188), 3,
      sym__newline,
      sym_identifier,
      sym__whitespace1,
  [27279] = 9,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3190), 1,
      anon_sym_PERCENT,
    ACTIONS(3276), 1,
      anon_sym_RBRACE,
    STATE(1069), 1,
      aux_sym_block_attribute_repeat1,
    STATE(1164), 1,
      sym__comment,
    STATE(1988), 1,
      sym_key,
    STATE(1178), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3188), 3,
      sym__newline,
      sym_identifier,
      sym__whitespace1,
  [27310] = 9,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3190), 1,
      anon_sym_PERCENT,
    ACTIONS(3278), 1,
      anon_sym_RBRACE,
    STATE(1048), 1,
      aux_sym_block_attribute_repeat1,
    STATE(1164), 1,
      sym__comment,
    STATE(1988), 1,
      sym_key,
    STATE(1178), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3188), 3,
      sym__newline,
      sym_identifier,
      sym__whitespace1,
  [27341] = 9,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3190), 1,
      anon_sym_PERCENT,
    ACTIONS(3280), 1,
      anon_sym_RBRACE,
    STATE(1071), 1,
      aux_sym_block_attribute_repeat1,
    STATE(1164), 1,
      sym__comment,
    STATE(1988), 1,
      sym_key,
    STATE(1178), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3188), 3,
      sym__newline,
      sym_identifier,
      sym__whitespace1,
  [27372] = 9,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3190), 1,
      anon_sym_PERCENT,
    ACTIONS(3282), 1,
      anon_sym_RBRACE,
    STATE(1048), 1,
      aux_sym_block_attribute_repeat1,
    STATE(1164), 1,
      sym__comment,
    STATE(1988), 1,
      sym_key,
    STATE(1178), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3188), 3,
      sym__newline,
      sym_identifier,
      sym__whitespace1,
  [27403] = 9,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3190), 1,
      anon_sym_PERCENT,
    ACTIONS(3284), 1,
      anon_sym_RBRACE,
    STATE(1037), 1,
      aux_sym_block_attribute_repeat1,
    STATE(1164), 1,
      sym__comment,
    STATE(1988), 1,
      sym_key,
    STATE(1178), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3188), 3,
      sym__newline,
      sym_identifier,
      sym__whitespace1,
  [27434] = 9,
    ACTIONS(3174), 1,
      anon_sym_DOT,
    ACTIONS(3178), 1,
      sym__id,
    ACTIONS(3180), 1,
      anon_sym_PERCENT,
    ACTIONS(3286), 1,
      sym__curly_bracket_span_end,
    STATE(1049), 1,
      aux_sym_inline_attribute_repeat1,
    STATE(1137), 1,
      sym__comment,
    STATE(2200), 1,
      sym_key,
    STATE(1197), 2,
      sym_class,
      sym_key_value,
    ACTIONS(3176), 3,
      sym__newline_inline,
      sym_identifier,
      sym__whitespace1,
  [27465] = 1,
    ACTIONS(2371), 8,
      sym__newline,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [27476] = 7,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    ACTIONS(3290), 1,
      sym__block_close,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(2393), 1,
      sym_code,
    STATE(1210), 2,
      sym__line,
      aux_sym_code_repeat1,
  [27499] = 1,
    ACTIONS(2357), 8,
      sym__newline,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [27510] = 8,
    ACTIONS(67), 1,
      sym__list_marker_task_begin,
    ACTIONS(3294), 1,
      sym__block_close,
    ACTIONS(3296), 1,
      sym__block_quote_continuation,
    STATE(56), 1,
      sym_list_marker_task,
    STATE(1083), 1,
      aux_sym__list_task_repeat1,
    STATE(1521), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1528), 1,
      sym__list_item_task,
    STATE(1872), 1,
      sym__block_quote_prefix,
  [27535] = 1,
    ACTIONS(2421), 8,
      sym__newline,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [27546] = 7,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    ACTIONS(3298), 1,
      sym__block_close,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(2336), 1,
      sym_code,
    STATE(1210), 2,
      sym__line,
      aux_sym_code_repeat1,
  [27569] = 8,
    ACTIONS(67), 1,
      sym__list_marker_task_begin,
    ACTIONS(3296), 1,
      sym__block_quote_continuation,
    ACTIONS(3300), 1,
      sym__block_close,
    STATE(56), 1,
      sym_list_marker_task,
    STATE(1083), 1,
      aux_sym__list_task_repeat1,
    STATE(1521), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1528), 1,
      sym__list_item_task,
    STATE(1872), 1,
      sym__block_quote_prefix,
  [27594] = 7,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    ACTIONS(3302), 1,
      sym__block_close,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(2422), 1,
      sym_code,
    STATE(1210), 2,
      sym__line,
      aux_sym_code_repeat1,
  [27617] = 7,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    ACTIONS(3304), 1,
      sym__block_close,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(2428), 1,
      sym_code,
    STATE(1210), 2,
      sym__line,
      aux_sym_code_repeat1,
  [27640] = 8,
    ACTIONS(3306), 1,
      sym__block_close,
    ACTIONS(3308), 1,
      sym__list_marker_task_begin,
    ACTIONS(3311), 1,
      sym__block_quote_continuation,
    STATE(56), 1,
      sym_list_marker_task,
    STATE(1083), 1,
      aux_sym__list_task_repeat1,
    STATE(1521), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1528), 1,
      sym__list_item_task,
    STATE(1872), 1,
      sym__block_quote_prefix,
  [27665] = 8,
    ACTIONS(67), 1,
      sym__list_marker_task_begin,
    ACTIONS(3296), 1,
      sym__block_quote_continuation,
    ACTIONS(3314), 1,
      sym__block_close,
    STATE(56), 1,
      sym_list_marker_task,
    STATE(1083), 1,
      aux_sym__list_task_repeat1,
    STATE(1521), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1528), 1,
      sym__list_item_task,
    STATE(1872), 1,
      sym__block_quote_prefix,
  [27690] = 1,
    ACTIONS(2427), 8,
      sym__newline,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [27701] = 7,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    ACTIONS(3316), 1,
      sym__block_close,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(2010), 1,
      sym_code,
    STATE(1210), 2,
      sym__line,
      aux_sym_code_repeat1,
  [27724] = 1,
    ACTIONS(2431), 8,
      sym__newline,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [27735] = 7,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    ACTIONS(3318), 1,
      sym__block_close,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(2035), 1,
      sym_code,
    STATE(1210), 2,
      sym__line,
      aux_sym_code_repeat1,
  [27758] = 7,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    ACTIONS(3320), 1,
      sym__block_close,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(2038), 1,
      sym_code,
    STATE(1210), 2,
      sym__line,
      aux_sym_code_repeat1,
  [27781] = 7,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    ACTIONS(3322), 1,
      sym__block_close,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(2373), 1,
      sym_code,
    STATE(1210), 2,
      sym__line,
      aux_sym_code_repeat1,
  [27804] = 8,
    ACTIONS(67), 1,
      sym__list_marker_task_begin,
    ACTIONS(3296), 1,
      sym__block_quote_continuation,
    ACTIONS(3324), 1,
      sym__block_close,
    STATE(56), 1,
      sym_list_marker_task,
    STATE(1083), 1,
      aux_sym__list_task_repeat1,
    STATE(1521), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1528), 1,
      sym__list_item_task,
    STATE(1872), 1,
      sym__block_quote_prefix,
  [27829] = 1,
    ACTIONS(2395), 8,
      sym__newline,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [27840] = 7,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    ACTIONS(3326), 1,
      sym__block_close,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(2194), 1,
      sym_code,
    STATE(1210), 2,
      sym__line,
      aux_sym_code_repeat1,
  [27863] = 7,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    ACTIONS(3328), 1,
      sym__block_close,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(2270), 1,
      sym_code,
    STATE(1210), 2,
      sym__line,
      aux_sym_code_repeat1,
  [27886] = 7,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    ACTIONS(3330), 1,
      sym__block_close,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(2273), 1,
      sym_code,
    STATE(1210), 2,
      sym__line,
      aux_sym_code_repeat1,
  [27909] = 7,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    ACTIONS(3332), 1,
      sym__block_close,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(2113), 1,
      sym_code,
    STATE(1210), 2,
      sym__line,
      aux_sym_code_repeat1,
  [27932] = 7,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    ACTIONS(3334), 1,
      sym__block_close,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(2235), 1,
      sym_code,
    STATE(1210), 2,
      sym__line,
      aux_sym_code_repeat1,
  [27955] = 7,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    ACTIONS(3336), 1,
      sym__block_close,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(2236), 1,
      sym_code,
    STATE(1210), 2,
      sym__line,
      aux_sym_code_repeat1,
  [27978] = 7,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    ACTIONS(3338), 1,
      sym__block_close,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(2391), 1,
      sym_code,
    STATE(1210), 2,
      sym__line,
      aux_sym_code_repeat1,
  [28001] = 8,
    ACTIONS(67), 1,
      sym__list_marker_task_begin,
    ACTIONS(3296), 1,
      sym__block_quote_continuation,
    ACTIONS(3340), 1,
      sym__block_close,
    STATE(56), 1,
      sym_list_marker_task,
    STATE(1083), 1,
      aux_sym__list_task_repeat1,
    STATE(1521), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1528), 1,
      sym__list_item_task,
    STATE(1872), 1,
      sym__block_quote_prefix,
  [28026] = 1,
    ACTIONS(2361), 8,
      sym__newline,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [28037] = 7,
    ACTIONS(75), 1,
      sym_list_marker_upper_alpha_period,
    ACTIONS(3342), 1,
      sym__block_close,
    ACTIONS(3344), 1,
      sym__block_quote_continuation,
    STATE(1230), 1,
      aux_sym__list_upper_alpha_period_repeat1,
    STATE(1418), 1,
      sym__list_item_upper_alpha_period,
    STATE(1506), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2105), 1,
      sym__block_quote_prefix,
  [28059] = 7,
    ACTIONS(83), 1,
      sym_list_marker_lower_alpha_paren,
    ACTIONS(3346), 1,
      sym__block_close,
    ACTIONS(3348), 1,
      sym__block_quote_continuation,
    STATE(1223), 1,
      aux_sym__list_lower_alpha_paren_repeat1,
    STATE(1483), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1627), 1,
      sym__list_item_lower_alpha_paren,
    STATE(2576), 1,
      sym__block_quote_prefix,
  [28081] = 7,
    ACTIONS(3350), 1,
      sym__block_close,
    ACTIONS(3352), 1,
      sym_list_marker_dash,
    ACTIONS(3355), 1,
      sym__block_quote_continuation,
    STATE(1104), 1,
      aux_sym__list_dash_repeat1,
    STATE(1442), 1,
      sym__list_item_dash,
    STATE(1553), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2104), 1,
      sym__block_quote_prefix,
  [28103] = 7,
    ACTIONS(93), 1,
      sym_list_marker_lower_alpha_parens,
    ACTIONS(3358), 1,
      sym__block_close,
    ACTIONS(3360), 1,
      sym__block_quote_continuation,
    STATE(1225), 1,
      aux_sym__list_lower_alpha_parens_repeat1,
    STATE(1416), 1,
      sym__list_item_lower_alpha_parens,
    STATE(1426), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2626), 1,
      sym__block_quote_prefix,
  [28125] = 7,
    ACTIONS(75), 1,
      sym_list_marker_upper_alpha_period,
    ACTIONS(3344), 1,
      sym__block_quote_continuation,
    ACTIONS(3362), 1,
      sym__block_close,
    STATE(1230), 1,
      aux_sym__list_upper_alpha_period_repeat1,
    STATE(1418), 1,
      sym__list_item_upper_alpha_period,
    STATE(1506), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2105), 1,
      sym__block_quote_prefix,
  [28147] = 7,
    ACTIONS(85), 1,
      sym_list_marker_upper_alpha_paren,
    ACTIONS(3364), 1,
      sym__block_close,
    ACTIONS(3366), 1,
      sym__block_quote_continuation,
    STATE(1235), 1,
      aux_sym__list_upper_alpha_paren_repeat1,
    STATE(1441), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1616), 1,
      sym__list_item_upper_alpha_paren,
    STATE(2084), 1,
      sym__block_quote_prefix,
  [28169] = 7,
    ACTIONS(3368), 1,
      sym__block_close,
    ACTIONS(3370), 1,
      sym_list_marker_plus,
    ACTIONS(3373), 1,
      sym__block_quote_continuation,
    STATE(1108), 1,
      aux_sym__list_plus_repeat1,
    STATE(1464), 1,
      sym__list_item_plus,
    STATE(1635), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2139), 1,
      sym__block_quote_prefix,
  [28191] = 7,
    ACTIONS(95), 1,
      sym_list_marker_upper_alpha_parens,
    ACTIONS(3376), 1,
      sym__block_close,
    ACTIONS(3378), 1,
      sym__block_quote_continuation,
    STATE(1238), 1,
      aux_sym__list_upper_alpha_parens_repeat1,
    STATE(1621), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1628), 1,
      sym__list_item_upper_alpha_parens,
    STATE(2147), 1,
      sym__block_quote_prefix,
  [28213] = 7,
    ACTIONS(61), 1,
      sym_list_marker_dash,
    ACTIONS(3380), 1,
      sym__block_close,
    ACTIONS(3382), 1,
      sym__block_quote_continuation,
    STATE(1104), 1,
      aux_sym__list_dash_repeat1,
    STATE(1442), 1,
      sym__list_item_dash,
    STATE(1553), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2104), 1,
      sym__block_quote_prefix,
  [28235] = 7,
    ACTIONS(65), 1,
      sym_list_marker_plus,
    ACTIONS(3384), 1,
      sym__block_close,
    ACTIONS(3386), 1,
      sym__block_quote_continuation,
    STATE(1108), 1,
      aux_sym__list_plus_repeat1,
    STATE(1464), 1,
      sym__list_item_plus,
    STATE(1635), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2139), 1,
      sym__block_quote_prefix,
  [28257] = 7,
    ACTIONS(63), 1,
      sym_list_marker_star,
    ACTIONS(3388), 1,
      sym__block_close,
    ACTIONS(3390), 1,
      sym__block_quote_continuation,
    STATE(1129), 1,
      aux_sym__list_star_repeat1,
    STATE(1414), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1550), 1,
      sym__list_item_star,
    STATE(2180), 1,
      sym__block_quote_prefix,
  [28279] = 7,
    ACTIONS(77), 1,
      sym_list_marker_lower_roman_period,
    ACTIONS(3392), 1,
      sym__block_close,
    ACTIONS(3394), 1,
      sym__block_quote_continuation,
    STATE(1239), 1,
      aux_sym__list_lower_roman_period_repeat1,
    STATE(1425), 1,
      sym__list_item_lower_roman_period,
    STATE(1438), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2378), 1,
      sym__block_quote_prefix,
  [28301] = 7,
    ACTIONS(71), 1,
      sym_list_marker_decimal_period,
    ACTIONS(3396), 1,
      sym__block_close,
    ACTIONS(3398), 1,
      sym__block_quote_continuation,
    STATE(1186), 1,
      aux_sym__list_decimal_period_repeat1,
    STATE(1417), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1559), 1,
      sym__list_item_decimal_period,
    STATE(2267), 1,
      sym__block_quote_prefix,
  [28323] = 7,
    ACTIONS(81), 1,
      sym_list_marker_decimal_paren,
    ACTIONS(3400), 1,
      sym__block_close,
    ACTIONS(3402), 1,
      sym__block_quote_continuation,
    STATE(1204), 1,
      aux_sym__list_decimal_paren_repeat1,
    STATE(1477), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1526), 1,
      sym__list_item_decimal_paren,
    STATE(2289), 1,
      sym__block_quote_prefix,
  [28345] = 7,
    ACTIONS(91), 1,
      sym_list_marker_decimal_parens,
    ACTIONS(3404), 1,
      sym__block_close,
    ACTIONS(3406), 1,
      sym__block_quote_continuation,
    STATE(1218), 1,
      aux_sym__list_decimal_parens_repeat1,
    STATE(1545), 1,
      sym__list_item_decimal_parens,
    STATE(1625), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2306), 1,
      sym__block_quote_prefix,
  [28367] = 7,
    ACTIONS(73), 1,
      sym_list_marker_lower_alpha_period,
    ACTIONS(3408), 1,
      sym__block_close,
    ACTIONS(3410), 1,
      sym__block_quote_continuation,
    STATE(1221), 1,
      aux_sym__list_lower_alpha_period_repeat1,
    STATE(1556), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1568), 1,
      sym__list_item_lower_alpha_period,
    STATE(2344), 1,
      sym__block_quote_prefix,
  [28389] = 7,
    ACTIONS(83), 1,
      sym_list_marker_lower_alpha_paren,
    ACTIONS(3348), 1,
      sym__block_quote_continuation,
    ACTIONS(3412), 1,
      sym__block_close,
    STATE(1223), 1,
      aux_sym__list_lower_alpha_paren_repeat1,
    STATE(1483), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1627), 1,
      sym__list_item_lower_alpha_paren,
    STATE(2576), 1,
      sym__block_quote_prefix,
  [28411] = 7,
    ACTIONS(93), 1,
      sym_list_marker_lower_alpha_parens,
    ACTIONS(3360), 1,
      sym__block_quote_continuation,
    ACTIONS(3414), 1,
      sym__block_close,
    STATE(1225), 1,
      aux_sym__list_lower_alpha_parens_repeat1,
    STATE(1416), 1,
      sym__list_item_lower_alpha_parens,
    STATE(1426), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2626), 1,
      sym__block_quote_prefix,
  [28433] = 7,
    ACTIONS(75), 1,
      sym_list_marker_upper_alpha_period,
    ACTIONS(3344), 1,
      sym__block_quote_continuation,
    ACTIONS(3416), 1,
      sym__block_close,
    STATE(1230), 1,
      aux_sym__list_upper_alpha_period_repeat1,
    STATE(1418), 1,
      sym__list_item_upper_alpha_period,
    STATE(1506), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2105), 1,
      sym__block_quote_prefix,
  [28455] = 7,
    ACTIONS(85), 1,
      sym_list_marker_upper_alpha_paren,
    ACTIONS(3366), 1,
      sym__block_quote_continuation,
    ACTIONS(3418), 1,
      sym__block_close,
    STATE(1235), 1,
      aux_sym__list_upper_alpha_paren_repeat1,
    STATE(1441), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1616), 1,
      sym__list_item_upper_alpha_paren,
    STATE(2084), 1,
      sym__block_quote_prefix,
  [28477] = 7,
    ACTIONS(95), 1,
      sym_list_marker_upper_alpha_parens,
    ACTIONS(3378), 1,
      sym__block_quote_continuation,
    ACTIONS(3420), 1,
      sym__block_close,
    STATE(1238), 1,
      aux_sym__list_upper_alpha_parens_repeat1,
    STATE(1621), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1628), 1,
      sym__list_item_upper_alpha_parens,
    STATE(2147), 1,
      sym__block_quote_prefix,
  [28499] = 7,
    ACTIONS(77), 1,
      sym_list_marker_lower_roman_period,
    ACTIONS(3394), 1,
      sym__block_quote_continuation,
    ACTIONS(3422), 1,
      sym__block_close,
    STATE(1239), 1,
      aux_sym__list_lower_roman_period_repeat1,
    STATE(1425), 1,
      sym__list_item_lower_roman_period,
    STATE(1438), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2378), 1,
      sym__block_quote_prefix,
  [28521] = 7,
    ACTIONS(87), 1,
      sym_list_marker_lower_roman_paren,
    ACTIONS(3424), 1,
      sym__block_close,
    ACTIONS(3426), 1,
      sym__block_quote_continuation,
    STATE(1240), 1,
      aux_sym__list_lower_roman_paren_repeat1,
    STATE(1410), 1,
      sym__list_item_lower_roman_paren,
    STATE(1449), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2081), 1,
      sym__block_quote_prefix,
  [28543] = 7,
    ACTIONS(97), 1,
      sym_list_marker_lower_roman_parens,
    ACTIONS(3428), 1,
      sym__block_close,
    ACTIONS(3430), 1,
      sym__block_quote_continuation,
    STATE(1241), 1,
      aux_sym__list_lower_roman_parens_repeat1,
    STATE(1474), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1510), 1,
      sym__list_item_lower_roman_parens,
    STATE(2319), 1,
      sym__block_quote_prefix,
  [28565] = 7,
    ACTIONS(79), 1,
      sym_list_marker_upper_roman_period,
    ACTIONS(3432), 1,
      sym__block_close,
    ACTIONS(3434), 1,
      sym__block_quote_continuation,
    STATE(1242), 1,
      aux_sym__list_upper_roman_period_repeat1,
    STATE(1492), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1547), 1,
      sym__list_item_upper_roman_period,
    STATE(2013), 1,
      sym__block_quote_prefix,
  [28587] = 7,
    ACTIONS(89), 1,
      sym_list_marker_upper_roman_paren,
    ACTIONS(3436), 1,
      sym__block_close,
    ACTIONS(3438), 1,
      sym__block_quote_continuation,
    STATE(1176), 1,
      aux_sym__list_upper_roman_paren_repeat1,
    STATE(1502), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1598), 1,
      sym__list_item_upper_roman_paren,
    STATE(2020), 1,
      sym__block_quote_prefix,
  [28609] = 7,
    ACTIONS(99), 1,
      sym_list_marker_upper_roman_parens,
    ACTIONS(3440), 1,
      sym__block_close,
    ACTIONS(3442), 1,
      sym__block_quote_continuation,
    STATE(1193), 1,
      aux_sym__list_upper_roman_parens_repeat1,
    STATE(1419), 1,
      sym__list_item_upper_roman_parens,
    STATE(1511), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2069), 1,
      sym__block_quote_prefix,
  [28631] = 7,
    ACTIONS(3444), 1,
      sym__block_close,
    ACTIONS(3446), 1,
      sym_list_marker_star,
    ACTIONS(3449), 1,
      sym__block_quote_continuation,
    STATE(1129), 1,
      aux_sym__list_star_repeat1,
    STATE(1414), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1550), 1,
      sym__list_item_star,
    STATE(2180), 1,
      sym__block_quote_prefix,
  [28653] = 1,
    ACTIONS(2395), 7,
      sym__newline,
      sym__indented_content_spacer,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [28663] = 1,
    ACTIONS(2361), 7,
      sym__newline,
      sym__indented_content_spacer,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [28673] = 7,
    ACTIONS(87), 1,
      sym_list_marker_lower_roman_paren,
    ACTIONS(3426), 1,
      sym__block_quote_continuation,
    ACTIONS(3452), 1,
      sym__block_close,
    STATE(1240), 1,
      aux_sym__list_lower_roman_paren_repeat1,
    STATE(1410), 1,
      sym__list_item_lower_roman_paren,
    STATE(1449), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2081), 1,
      sym__block_quote_prefix,
  [28695] = 1,
    ACTIONS(2371), 7,
      sym__newline,
      sym__indented_content_spacer,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [28705] = 7,
    ACTIONS(97), 1,
      sym_list_marker_lower_roman_parens,
    ACTIONS(3430), 1,
      sym__block_quote_continuation,
    ACTIONS(3454), 1,
      sym__block_close,
    STATE(1241), 1,
      aux_sym__list_lower_roman_parens_repeat1,
    STATE(1474), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1510), 1,
      sym__list_item_lower_roman_parens,
    STATE(2319), 1,
      sym__block_quote_prefix,
  [28727] = 7,
    ACTIONS(79), 1,
      sym_list_marker_upper_roman_period,
    ACTIONS(3434), 1,
      sym__block_quote_continuation,
    ACTIONS(3456), 1,
      sym__block_close,
    STATE(1242), 1,
      aux_sym__list_upper_roman_period_repeat1,
    STATE(1492), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1547), 1,
      sym__list_item_upper_roman_period,
    STATE(2013), 1,
      sym__block_quote_prefix,
  [28749] = 1,
    ACTIONS(3458), 7,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [28759] = 1,
    ACTIONS(3460), 7,
      sym__newline_inline,
      sym__curly_bracket_span_end,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [28769] = 1,
    ACTIONS(2357), 7,
      sym__newline,
      sym__indented_content_spacer,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [28779] = 6,
    ACTIONS(3462), 1,
      aux_sym__line_token1,
    ACTIONS(3465), 1,
      sym__block_close,
    ACTIONS(3467), 1,
      sym__block_quote_continuation,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(1139), 2,
      sym__line,
      aux_sym_code_repeat1,
  [28799] = 7,
    ACTIONS(61), 1,
      sym_list_marker_dash,
    ACTIONS(3382), 1,
      sym__block_quote_continuation,
    ACTIONS(3470), 1,
      sym__block_close,
    STATE(1104), 1,
      aux_sym__list_dash_repeat1,
    STATE(1442), 1,
      sym__list_item_dash,
    STATE(1553), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2104), 1,
      sym__block_quote_prefix,
  [28821] = 7,
    ACTIONS(65), 1,
      sym_list_marker_plus,
    ACTIONS(3386), 1,
      sym__block_quote_continuation,
    ACTIONS(3472), 1,
      sym__block_close,
    STATE(1108), 1,
      aux_sym__list_plus_repeat1,
    STATE(1464), 1,
      sym__list_item_plus,
    STATE(1635), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2139), 1,
      sym__block_quote_prefix,
  [28843] = 7,
    ACTIONS(63), 1,
      sym_list_marker_star,
    ACTIONS(3390), 1,
      sym__block_quote_continuation,
    ACTIONS(3474), 1,
      sym__block_close,
    STATE(1129), 1,
      aux_sym__list_star_repeat1,
    STATE(1414), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1550), 1,
      sym__list_item_star,
    STATE(2180), 1,
      sym__block_quote_prefix,
  [28865] = 1,
    ACTIONS(3476), 7,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [28875] = 7,
    ACTIONS(71), 1,
      sym_list_marker_decimal_period,
    ACTIONS(3398), 1,
      sym__block_quote_continuation,
    ACTIONS(3478), 1,
      sym__block_close,
    STATE(1186), 1,
      aux_sym__list_decimal_period_repeat1,
    STATE(1417), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1559), 1,
      sym__list_item_decimal_period,
    STATE(2267), 1,
      sym__block_quote_prefix,
  [28897] = 7,
    ACTIONS(81), 1,
      sym_list_marker_decimal_paren,
    ACTIONS(3402), 1,
      sym__block_quote_continuation,
    ACTIONS(3480), 1,
      sym__block_close,
    STATE(1204), 1,
      aux_sym__list_decimal_paren_repeat1,
    STATE(1477), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1526), 1,
      sym__list_item_decimal_paren,
    STATE(2289), 1,
      sym__block_quote_prefix,
  [28919] = 7,
    ACTIONS(91), 1,
      sym_list_marker_decimal_parens,
    ACTIONS(3406), 1,
      sym__block_quote_continuation,
    ACTIONS(3482), 1,
      sym__block_close,
    STATE(1218), 1,
      aux_sym__list_decimal_parens_repeat1,
    STATE(1545), 1,
      sym__list_item_decimal_parens,
    STATE(1625), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2306), 1,
      sym__block_quote_prefix,
  [28941] = 7,
    ACTIONS(73), 1,
      sym_list_marker_lower_alpha_period,
    ACTIONS(3410), 1,
      sym__block_quote_continuation,
    ACTIONS(3484), 1,
      sym__block_close,
    STATE(1221), 1,
      aux_sym__list_lower_alpha_period_repeat1,
    STATE(1556), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1568), 1,
      sym__list_item_lower_alpha_period,
    STATE(2344), 1,
      sym__block_quote_prefix,
  [28963] = 7,
    ACTIONS(83), 1,
      sym_list_marker_lower_alpha_paren,
    ACTIONS(3348), 1,
      sym__block_quote_continuation,
    ACTIONS(3486), 1,
      sym__block_close,
    STATE(1223), 1,
      aux_sym__list_lower_alpha_paren_repeat1,
    STATE(1483), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1627), 1,
      sym__list_item_lower_alpha_paren,
    STATE(2576), 1,
      sym__block_quote_prefix,
  [28985] = 7,
    ACTIONS(93), 1,
      sym_list_marker_lower_alpha_parens,
    ACTIONS(3360), 1,
      sym__block_quote_continuation,
    ACTIONS(3488), 1,
      sym__block_close,
    STATE(1225), 1,
      aux_sym__list_lower_alpha_parens_repeat1,
    STATE(1416), 1,
      sym__list_item_lower_alpha_parens,
    STATE(1426), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2626), 1,
      sym__block_quote_prefix,
  [29007] = 7,
    ACTIONS(75), 1,
      sym_list_marker_upper_alpha_period,
    ACTIONS(3344), 1,
      sym__block_quote_continuation,
    ACTIONS(3490), 1,
      sym__block_close,
    STATE(1230), 1,
      aux_sym__list_upper_alpha_period_repeat1,
    STATE(1418), 1,
      sym__list_item_upper_alpha_period,
    STATE(1506), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2105), 1,
      sym__block_quote_prefix,
  [29029] = 7,
    ACTIONS(85), 1,
      sym_list_marker_upper_alpha_paren,
    ACTIONS(3366), 1,
      sym__block_quote_continuation,
    ACTIONS(3492), 1,
      sym__block_close,
    STATE(1235), 1,
      aux_sym__list_upper_alpha_paren_repeat1,
    STATE(1441), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1616), 1,
      sym__list_item_upper_alpha_paren,
    STATE(2084), 1,
      sym__block_quote_prefix,
  [29051] = 7,
    ACTIONS(95), 1,
      sym_list_marker_upper_alpha_parens,
    ACTIONS(3378), 1,
      sym__block_quote_continuation,
    ACTIONS(3494), 1,
      sym__block_close,
    STATE(1238), 1,
      aux_sym__list_upper_alpha_parens_repeat1,
    STATE(1621), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1628), 1,
      sym__list_item_upper_alpha_parens,
    STATE(2147), 1,
      sym__block_quote_prefix,
  [29073] = 7,
    ACTIONS(77), 1,
      sym_list_marker_lower_roman_period,
    ACTIONS(3394), 1,
      sym__block_quote_continuation,
    ACTIONS(3496), 1,
      sym__block_close,
    STATE(1239), 1,
      aux_sym__list_lower_roman_period_repeat1,
    STATE(1425), 1,
      sym__list_item_lower_roman_period,
    STATE(1438), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2378), 1,
      sym__block_quote_prefix,
  [29095] = 7,
    ACTIONS(87), 1,
      sym_list_marker_lower_roman_paren,
    ACTIONS(3426), 1,
      sym__block_quote_continuation,
    ACTIONS(3498), 1,
      sym__block_close,
    STATE(1240), 1,
      aux_sym__list_lower_roman_paren_repeat1,
    STATE(1410), 1,
      sym__list_item_lower_roman_paren,
    STATE(1449), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2081), 1,
      sym__block_quote_prefix,
  [29117] = 7,
    ACTIONS(97), 1,
      sym_list_marker_lower_roman_parens,
    ACTIONS(3430), 1,
      sym__block_quote_continuation,
    ACTIONS(3500), 1,
      sym__block_close,
    STATE(1241), 1,
      aux_sym__list_lower_roman_parens_repeat1,
    STATE(1474), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1510), 1,
      sym__list_item_lower_roman_parens,
    STATE(2319), 1,
      sym__block_quote_prefix,
  [29139] = 7,
    ACTIONS(79), 1,
      sym_list_marker_upper_roman_period,
    ACTIONS(3434), 1,
      sym__block_quote_continuation,
    ACTIONS(3502), 1,
      sym__block_close,
    STATE(1242), 1,
      aux_sym__list_upper_roman_period_repeat1,
    STATE(1492), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1547), 1,
      sym__list_item_upper_roman_period,
    STATE(2013), 1,
      sym__block_quote_prefix,
  [29161] = 7,
    ACTIONS(89), 1,
      sym_list_marker_upper_roman_paren,
    ACTIONS(3438), 1,
      sym__block_quote_continuation,
    ACTIONS(3504), 1,
      sym__block_close,
    STATE(1176), 1,
      aux_sym__list_upper_roman_paren_repeat1,
    STATE(1502), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1598), 1,
      sym__list_item_upper_roman_paren,
    STATE(2020), 1,
      sym__block_quote_prefix,
  [29183] = 7,
    ACTIONS(99), 1,
      sym_list_marker_upper_roman_parens,
    ACTIONS(3442), 1,
      sym__block_quote_continuation,
    ACTIONS(3506), 1,
      sym__block_close,
    STATE(1193), 1,
      aux_sym__list_upper_roman_parens_repeat1,
    STATE(1419), 1,
      sym__list_item_upper_roman_parens,
    STATE(1511), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2069), 1,
      sym__block_quote_prefix,
  [29205] = 7,
    ACTIONS(61), 1,
      sym_list_marker_dash,
    ACTIONS(3382), 1,
      sym__block_quote_continuation,
    ACTIONS(3508), 1,
      sym__block_close,
    STATE(1104), 1,
      aux_sym__list_dash_repeat1,
    STATE(1442), 1,
      sym__list_item_dash,
    STATE(1553), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2104), 1,
      sym__block_quote_prefix,
  [29227] = 1,
    ACTIONS(3510), 7,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [29237] = 1,
    ACTIONS(3512), 7,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [29247] = 1,
    ACTIONS(3514), 7,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [29257] = 7,
    ACTIONS(91), 1,
      sym_list_marker_decimal_parens,
    ACTIONS(3406), 1,
      sym__block_quote_continuation,
    ACTIONS(3516), 1,
      sym__block_close,
    STATE(1218), 1,
      aux_sym__list_decimal_parens_repeat1,
    STATE(1545), 1,
      sym__list_item_decimal_parens,
    STATE(1625), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2306), 1,
      sym__block_quote_prefix,
  [29279] = 1,
    ACTIONS(3518), 7,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [29289] = 7,
    ACTIONS(73), 1,
      sym_list_marker_lower_alpha_period,
    ACTIONS(3410), 1,
      sym__block_quote_continuation,
    ACTIONS(3520), 1,
      sym__block_close,
    STATE(1221), 1,
      aux_sym__list_lower_alpha_period_repeat1,
    STATE(1556), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1568), 1,
      sym__list_item_lower_alpha_period,
    STATE(2344), 1,
      sym__block_quote_prefix,
  [29311] = 7,
    ACTIONS(61), 1,
      sym_list_marker_dash,
    ACTIONS(3382), 1,
      sym__block_quote_continuation,
    ACTIONS(3522), 1,
      sym__block_close,
    STATE(1104), 1,
      aux_sym__list_dash_repeat1,
    STATE(1442), 1,
      sym__list_item_dash,
    STATE(1553), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2104), 1,
      sym__block_quote_prefix,
  [29333] = 7,
    ACTIONS(65), 1,
      sym_list_marker_plus,
    ACTIONS(3386), 1,
      sym__block_quote_continuation,
    ACTIONS(3524), 1,
      sym__block_close,
    STATE(1108), 1,
      aux_sym__list_plus_repeat1,
    STATE(1464), 1,
      sym__list_item_plus,
    STATE(1635), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2139), 1,
      sym__block_quote_prefix,
  [29355] = 7,
    ACTIONS(63), 1,
      sym_list_marker_star,
    ACTIONS(3390), 1,
      sym__block_quote_continuation,
    ACTIONS(3526), 1,
      sym__block_close,
    STATE(1129), 1,
      aux_sym__list_star_repeat1,
    STATE(1414), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1550), 1,
      sym__list_item_star,
    STATE(2180), 1,
      sym__block_quote_prefix,
  [29377] = 1,
    ACTIONS(3528), 7,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [29387] = 7,
    ACTIONS(71), 1,
      sym_list_marker_decimal_period,
    ACTIONS(3398), 1,
      sym__block_quote_continuation,
    ACTIONS(3530), 1,
      sym__block_close,
    STATE(1186), 1,
      aux_sym__list_decimal_period_repeat1,
    STATE(1417), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1559), 1,
      sym__list_item_decimal_period,
    STATE(2267), 1,
      sym__block_quote_prefix,
  [29409] = 7,
    ACTIONS(81), 1,
      sym_list_marker_decimal_paren,
    ACTIONS(3402), 1,
      sym__block_quote_continuation,
    ACTIONS(3532), 1,
      sym__block_close,
    STATE(1204), 1,
      aux_sym__list_decimal_paren_repeat1,
    STATE(1477), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1526), 1,
      sym__list_item_decimal_paren,
    STATE(2289), 1,
      sym__block_quote_prefix,
  [29431] = 7,
    ACTIONS(91), 1,
      sym_list_marker_decimal_parens,
    ACTIONS(3406), 1,
      sym__block_quote_continuation,
    ACTIONS(3534), 1,
      sym__block_close,
    STATE(1218), 1,
      aux_sym__list_decimal_parens_repeat1,
    STATE(1545), 1,
      sym__list_item_decimal_parens,
    STATE(1625), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2306), 1,
      sym__block_quote_prefix,
  [29453] = 7,
    ACTIONS(73), 1,
      sym_list_marker_lower_alpha_period,
    ACTIONS(3410), 1,
      sym__block_quote_continuation,
    ACTIONS(3536), 1,
      sym__block_close,
    STATE(1221), 1,
      aux_sym__list_lower_alpha_period_repeat1,
    STATE(1556), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1568), 1,
      sym__list_item_lower_alpha_period,
    STATE(2344), 1,
      sym__block_quote_prefix,
  [29475] = 7,
    ACTIONS(83), 1,
      sym_list_marker_lower_alpha_paren,
    ACTIONS(3348), 1,
      sym__block_quote_continuation,
    ACTIONS(3538), 1,
      sym__block_close,
    STATE(1223), 1,
      aux_sym__list_lower_alpha_paren_repeat1,
    STATE(1483), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1627), 1,
      sym__list_item_lower_alpha_paren,
    STATE(2576), 1,
      sym__block_quote_prefix,
  [29497] = 7,
    ACTIONS(93), 1,
      sym_list_marker_lower_alpha_parens,
    ACTIONS(3360), 1,
      sym__block_quote_continuation,
    ACTIONS(3540), 1,
      sym__block_close,
    STATE(1225), 1,
      aux_sym__list_lower_alpha_parens_repeat1,
    STATE(1416), 1,
      sym__list_item_lower_alpha_parens,
    STATE(1426), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2626), 1,
      sym__block_quote_prefix,
  [29519] = 7,
    ACTIONS(3542), 1,
      sym__block_close,
    ACTIONS(3544), 1,
      sym_list_marker_upper_roman_paren,
    ACTIONS(3547), 1,
      sym__block_quote_continuation,
    STATE(1176), 1,
      aux_sym__list_upper_roman_paren_repeat1,
    STATE(1502), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1598), 1,
      sym__list_item_upper_roman_paren,
    STATE(2020), 1,
      sym__block_quote_prefix,
  [29541] = 7,
    ACTIONS(85), 1,
      sym_list_marker_upper_alpha_paren,
    ACTIONS(3366), 1,
      sym__block_quote_continuation,
    ACTIONS(3550), 1,
      sym__block_close,
    STATE(1235), 1,
      aux_sym__list_upper_alpha_paren_repeat1,
    STATE(1441), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1616), 1,
      sym__list_item_upper_alpha_paren,
    STATE(2084), 1,
      sym__block_quote_prefix,
  [29563] = 1,
    ACTIONS(3552), 7,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [29573] = 7,
    ACTIONS(77), 1,
      sym_list_marker_lower_roman_period,
    ACTIONS(3394), 1,
      sym__block_quote_continuation,
    ACTIONS(3554), 1,
      sym__block_close,
    STATE(1239), 1,
      aux_sym__list_lower_roman_period_repeat1,
    STATE(1425), 1,
      sym__list_item_lower_roman_period,
    STATE(1438), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2378), 1,
      sym__block_quote_prefix,
  [29595] = 7,
    ACTIONS(87), 1,
      sym_list_marker_lower_roman_paren,
    ACTIONS(3426), 1,
      sym__block_quote_continuation,
    ACTIONS(3556), 1,
      sym__block_close,
    STATE(1240), 1,
      aux_sym__list_lower_roman_paren_repeat1,
    STATE(1410), 1,
      sym__list_item_lower_roman_paren,
    STATE(1449), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2081), 1,
      sym__block_quote_prefix,
  [29617] = 7,
    ACTIONS(97), 1,
      sym_list_marker_lower_roman_parens,
    ACTIONS(3430), 1,
      sym__block_quote_continuation,
    ACTIONS(3558), 1,
      sym__block_close,
    STATE(1241), 1,
      aux_sym__list_lower_roman_parens_repeat1,
    STATE(1474), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1510), 1,
      sym__list_item_lower_roman_parens,
    STATE(2319), 1,
      sym__block_quote_prefix,
  [29639] = 7,
    ACTIONS(79), 1,
      sym_list_marker_upper_roman_period,
    ACTIONS(3434), 1,
      sym__block_quote_continuation,
    ACTIONS(3560), 1,
      sym__block_close,
    STATE(1242), 1,
      aux_sym__list_upper_roman_period_repeat1,
    STATE(1492), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1547), 1,
      sym__list_item_upper_roman_period,
    STATE(2013), 1,
      sym__block_quote_prefix,
  [29661] = 7,
    ACTIONS(89), 1,
      sym_list_marker_upper_roman_paren,
    ACTIONS(3438), 1,
      sym__block_quote_continuation,
    ACTIONS(3562), 1,
      sym__block_close,
    STATE(1176), 1,
      aux_sym__list_upper_roman_paren_repeat1,
    STATE(1502), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1598), 1,
      sym__list_item_upper_roman_paren,
    STATE(2020), 1,
      sym__block_quote_prefix,
  [29683] = 7,
    ACTIONS(99), 1,
      sym_list_marker_upper_roman_parens,
    ACTIONS(3442), 1,
      sym__block_quote_continuation,
    ACTIONS(3564), 1,
      sym__block_close,
    STATE(1193), 1,
      aux_sym__list_upper_roman_parens_repeat1,
    STATE(1419), 1,
      sym__list_item_upper_roman_parens,
    STATE(1511), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2069), 1,
      sym__block_quote_prefix,
  [29705] = 1,
    ACTIONS(3528), 7,
      sym__newline_inline,
      sym__curly_bracket_span_end,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [29715] = 7,
    ACTIONS(3566), 1,
      sym__block_close,
    ACTIONS(3568), 1,
      sym_list_marker_decimal_period,
    ACTIONS(3571), 1,
      sym__block_quote_continuation,
    STATE(1186), 1,
      aux_sym__list_decimal_period_repeat1,
    STATE(1417), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1559), 1,
      sym__list_item_decimal_period,
    STATE(2267), 1,
      sym__block_quote_prefix,
  [29737] = 1,
    ACTIONS(2427), 7,
      sym__newline,
      sym__indented_content_spacer,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [29747] = 1,
    ACTIONS(2431), 7,
      sym__newline,
      sym__indented_content_spacer,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [29757] = 1,
    ACTIONS(2421), 7,
      sym__newline,
      sym__indented_content_spacer,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [29767] = 1,
    ACTIONS(3458), 7,
      sym__newline_inline,
      sym__curly_bracket_span_end,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [29777] = 1,
    ACTIONS(3514), 7,
      sym__newline_inline,
      sym__curly_bracket_span_end,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [29787] = 7,
    ACTIONS(89), 1,
      sym_list_marker_upper_roman_paren,
    ACTIONS(3438), 1,
      sym__block_quote_continuation,
    ACTIONS(3574), 1,
      sym__block_close,
    STATE(1176), 1,
      aux_sym__list_upper_roman_paren_repeat1,
    STATE(1502), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1598), 1,
      sym__list_item_upper_roman_paren,
    STATE(2020), 1,
      sym__block_quote_prefix,
  [29809] = 7,
    ACTIONS(3576), 1,
      sym__block_close,
    ACTIONS(3578), 1,
      sym_list_marker_upper_roman_parens,
    ACTIONS(3581), 1,
      sym__block_quote_continuation,
    STATE(1193), 1,
      aux_sym__list_upper_roman_parens_repeat1,
    STATE(1419), 1,
      sym__list_item_upper_roman_parens,
    STATE(1511), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2069), 1,
      sym__block_quote_prefix,
  [29831] = 7,
    ACTIONS(61), 1,
      sym_list_marker_dash,
    ACTIONS(3382), 1,
      sym__block_quote_continuation,
    ACTIONS(3584), 1,
      sym__block_close,
    STATE(1104), 1,
      aux_sym__list_dash_repeat1,
    STATE(1442), 1,
      sym__list_item_dash,
    STATE(1553), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2104), 1,
      sym__block_quote_prefix,
  [29853] = 7,
    ACTIONS(65), 1,
      sym_list_marker_plus,
    ACTIONS(3386), 1,
      sym__block_quote_continuation,
    ACTIONS(3586), 1,
      sym__block_close,
    STATE(1108), 1,
      aux_sym__list_plus_repeat1,
    STATE(1464), 1,
      sym__list_item_plus,
    STATE(1635), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2139), 1,
      sym__block_quote_prefix,
  [29875] = 7,
    ACTIONS(63), 1,
      sym_list_marker_star,
    ACTIONS(3390), 1,
      sym__block_quote_continuation,
    ACTIONS(3588), 1,
      sym__block_close,
    STATE(1129), 1,
      aux_sym__list_star_repeat1,
    STATE(1414), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1550), 1,
      sym__list_item_star,
    STATE(2180), 1,
      sym__block_quote_prefix,
  [29897] = 1,
    ACTIONS(3590), 7,
      sym__newline_inline,
      sym__curly_bracket_span_end,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [29907] = 7,
    ACTIONS(71), 1,
      sym_list_marker_decimal_period,
    ACTIONS(3398), 1,
      sym__block_quote_continuation,
    ACTIONS(3592), 1,
      sym__block_close,
    STATE(1186), 1,
      aux_sym__list_decimal_period_repeat1,
    STATE(1417), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1559), 1,
      sym__list_item_decimal_period,
    STATE(2267), 1,
      sym__block_quote_prefix,
  [29929] = 7,
    ACTIONS(81), 1,
      sym_list_marker_decimal_paren,
    ACTIONS(3402), 1,
      sym__block_quote_continuation,
    ACTIONS(3594), 1,
      sym__block_close,
    STATE(1204), 1,
      aux_sym__list_decimal_paren_repeat1,
    STATE(1477), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1526), 1,
      sym__list_item_decimal_paren,
    STATE(2289), 1,
      sym__block_quote_prefix,
  [29951] = 7,
    ACTIONS(91), 1,
      sym_list_marker_decimal_parens,
    ACTIONS(3406), 1,
      sym__block_quote_continuation,
    ACTIONS(3596), 1,
      sym__block_close,
    STATE(1218), 1,
      aux_sym__list_decimal_parens_repeat1,
    STATE(1545), 1,
      sym__list_item_decimal_parens,
    STATE(1625), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2306), 1,
      sym__block_quote_prefix,
  [29973] = 7,
    ACTIONS(73), 1,
      sym_list_marker_lower_alpha_period,
    ACTIONS(3410), 1,
      sym__block_quote_continuation,
    ACTIONS(3598), 1,
      sym__block_close,
    STATE(1221), 1,
      aux_sym__list_lower_alpha_period_repeat1,
    STATE(1556), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1568), 1,
      sym__list_item_lower_alpha_period,
    STATE(2344), 1,
      sym__block_quote_prefix,
  [29995] = 7,
    ACTIONS(83), 1,
      sym_list_marker_lower_alpha_paren,
    ACTIONS(3348), 1,
      sym__block_quote_continuation,
    ACTIONS(3600), 1,
      sym__block_close,
    STATE(1223), 1,
      aux_sym__list_lower_alpha_paren_repeat1,
    STATE(1483), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1627), 1,
      sym__list_item_lower_alpha_paren,
    STATE(2576), 1,
      sym__block_quote_prefix,
  [30017] = 7,
    ACTIONS(93), 1,
      sym_list_marker_lower_alpha_parens,
    ACTIONS(3360), 1,
      sym__block_quote_continuation,
    ACTIONS(3602), 1,
      sym__block_close,
    STATE(1225), 1,
      aux_sym__list_lower_alpha_parens_repeat1,
    STATE(1416), 1,
      sym__list_item_lower_alpha_parens,
    STATE(1426), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2626), 1,
      sym__block_quote_prefix,
  [30039] = 7,
    ACTIONS(3604), 1,
      sym__block_close,
    ACTIONS(3606), 1,
      sym_list_marker_decimal_paren,
    ACTIONS(3609), 1,
      sym__block_quote_continuation,
    STATE(1204), 1,
      aux_sym__list_decimal_paren_repeat1,
    STATE(1477), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1526), 1,
      sym__list_item_decimal_paren,
    STATE(2289), 1,
      sym__block_quote_prefix,
  [30061] = 1,
    ACTIONS(3612), 7,
      sym__newline_inline,
      sym__curly_bracket_span_end,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [30071] = 1,
    ACTIONS(3476), 7,
      sym__newline_inline,
      sym__curly_bracket_span_end,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [30081] = 1,
    ACTIONS(3510), 7,
      sym__newline_inline,
      sym__curly_bracket_span_end,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [30091] = 7,
    ACTIONS(75), 1,
      sym_list_marker_upper_alpha_period,
    ACTIONS(3344), 1,
      sym__block_quote_continuation,
    ACTIONS(3614), 1,
      sym__block_close,
    STATE(1230), 1,
      aux_sym__list_upper_alpha_period_repeat1,
    STATE(1418), 1,
      sym__list_item_upper_alpha_period,
    STATE(1506), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2105), 1,
      sym__block_quote_prefix,
  [30113] = 7,
    ACTIONS(85), 1,
      sym_list_marker_upper_alpha_paren,
    ACTIONS(3366), 1,
      sym__block_quote_continuation,
    ACTIONS(3616), 1,
      sym__block_close,
    STATE(1235), 1,
      aux_sym__list_upper_alpha_paren_repeat1,
    STATE(1441), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1616), 1,
      sym__list_item_upper_alpha_paren,
    STATE(2084), 1,
      sym__block_quote_prefix,
  [30135] = 6,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    ACTIONS(3618), 1,
      sym__block_close,
    STATE(1558), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1717), 1,
      sym__block_quote_prefix,
    STATE(1139), 2,
      sym__line,
      aux_sym_code_repeat1,
  [30155] = 7,
    ACTIONS(95), 1,
      sym_list_marker_upper_alpha_parens,
    ACTIONS(3378), 1,
      sym__block_quote_continuation,
    ACTIONS(3620), 1,
      sym__block_close,
    STATE(1238), 1,
      aux_sym__list_upper_alpha_parens_repeat1,
    STATE(1621), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1628), 1,
      sym__list_item_upper_alpha_parens,
    STATE(2147), 1,
      sym__block_quote_prefix,
  [30177] = 7,
    ACTIONS(65), 1,
      sym_list_marker_plus,
    ACTIONS(3386), 1,
      sym__block_quote_continuation,
    ACTIONS(3622), 1,
      sym__block_close,
    STATE(1108), 1,
      aux_sym__list_plus_repeat1,
    STATE(1464), 1,
      sym__list_item_plus,
    STATE(1635), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2139), 1,
      sym__block_quote_prefix,
  [30199] = 7,
    ACTIONS(77), 1,
      sym_list_marker_lower_roman_period,
    ACTIONS(3394), 1,
      sym__block_quote_continuation,
    ACTIONS(3624), 1,
      sym__block_close,
    STATE(1239), 1,
      aux_sym__list_lower_roman_period_repeat1,
    STATE(1425), 1,
      sym__list_item_lower_roman_period,
    STATE(1438), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2378), 1,
      sym__block_quote_prefix,
  [30221] = 7,
    ACTIONS(87), 1,
      sym_list_marker_lower_roman_paren,
    ACTIONS(3426), 1,
      sym__block_quote_continuation,
    ACTIONS(3626), 1,
      sym__block_close,
    STATE(1240), 1,
      aux_sym__list_lower_roman_paren_repeat1,
    STATE(1410), 1,
      sym__list_item_lower_roman_paren,
    STATE(1449), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2081), 1,
      sym__block_quote_prefix,
  [30243] = 7,
    ACTIONS(97), 1,
      sym_list_marker_lower_roman_parens,
    ACTIONS(3430), 1,
      sym__block_quote_continuation,
    ACTIONS(3628), 1,
      sym__block_close,
    STATE(1241), 1,
      aux_sym__list_lower_roman_parens_repeat1,
    STATE(1474), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1510), 1,
      sym__list_item_lower_roman_parens,
    STATE(2319), 1,
      sym__block_quote_prefix,
  [30265] = 7,
    ACTIONS(63), 1,
      sym_list_marker_star,
    ACTIONS(3390), 1,
      sym__block_quote_continuation,
    ACTIONS(3630), 1,
      sym__block_close,
    STATE(1129), 1,
      aux_sym__list_star_repeat1,
    STATE(1414), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1550), 1,
      sym__list_item_star,
    STATE(2180), 1,
      sym__block_quote_prefix,
  [30287] = 1,
    ACTIONS(3512), 7,
      sym__newline_inline,
      sym__curly_bracket_span_end,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [30297] = 7,
    ACTIONS(3632), 1,
      sym__block_close,
    ACTIONS(3634), 1,
      sym_list_marker_decimal_parens,
    ACTIONS(3637), 1,
      sym__block_quote_continuation,
    STATE(1218), 1,
      aux_sym__list_decimal_parens_repeat1,
    STATE(1545), 1,
      sym__list_item_decimal_parens,
    STATE(1625), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2306), 1,
      sym__block_quote_prefix,
  [30319] = 7,
    ACTIONS(79), 1,
      sym_list_marker_upper_roman_period,
    ACTIONS(3434), 1,
      sym__block_quote_continuation,
    ACTIONS(3640), 1,
      sym__block_close,
    STATE(1242), 1,
      aux_sym__list_upper_roman_period_repeat1,
    STATE(1492), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1547), 1,
      sym__list_item_upper_roman_period,
    STATE(2013), 1,
      sym__block_quote_prefix,
  [30341] = 7,
    ACTIONS(89), 1,
      sym_list_marker_upper_roman_paren,
    ACTIONS(3438), 1,
      sym__block_quote_continuation,
    ACTIONS(3642), 1,
      sym__block_close,
    STATE(1176), 1,
      aux_sym__list_upper_roman_paren_repeat1,
    STATE(1502), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1598), 1,
      sym__list_item_upper_roman_paren,
    STATE(2020), 1,
      sym__block_quote_prefix,
  [30363] = 7,
    ACTIONS(3644), 1,
      sym__block_close,
    ACTIONS(3646), 1,
      sym_list_marker_lower_alpha_period,
    ACTIONS(3649), 1,
      sym__block_quote_continuation,
    STATE(1221), 1,
      aux_sym__list_lower_alpha_period_repeat1,
    STATE(1556), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1568), 1,
      sym__list_item_lower_alpha_period,
    STATE(2344), 1,
      sym__block_quote_prefix,
  [30385] = 7,
    ACTIONS(99), 1,
      sym_list_marker_upper_roman_parens,
    ACTIONS(3442), 1,
      sym__block_quote_continuation,
    ACTIONS(3652), 1,
      sym__block_close,
    STATE(1193), 1,
      aux_sym__list_upper_roman_parens_repeat1,
    STATE(1419), 1,
      sym__list_item_upper_roman_parens,
    STATE(1511), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2069), 1,
      sym__block_quote_prefix,
  [30407] = 7,
    ACTIONS(3654), 1,
      sym__block_close,
    ACTIONS(3656), 1,
      sym_list_marker_lower_alpha_paren,
    ACTIONS(3659), 1,
      sym__block_quote_continuation,
    STATE(1223), 1,
      aux_sym__list_lower_alpha_paren_repeat1,
    STATE(1483), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1627), 1,
      sym__list_item_lower_alpha_paren,
    STATE(2576), 1,
      sym__block_quote_prefix,
  [30429] = 7,
    ACTIONS(99), 1,
      sym_list_marker_upper_roman_parens,
    ACTIONS(3442), 1,
      sym__block_quote_continuation,
    ACTIONS(3662), 1,
      sym__block_close,
    STATE(1193), 1,
      aux_sym__list_upper_roman_parens_repeat1,
    STATE(1419), 1,
      sym__list_item_upper_roman_parens,
    STATE(1511), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2069), 1,
      sym__block_quote_prefix,
  [30451] = 7,
    ACTIONS(3664), 1,
      sym__block_close,
    ACTIONS(3666), 1,
      sym_list_marker_lower_alpha_parens,
    ACTIONS(3669), 1,
      sym__block_quote_continuation,
    STATE(1225), 1,
      aux_sym__list_lower_alpha_parens_repeat1,
    STATE(1416), 1,
      sym__list_item_lower_alpha_parens,
    STATE(1426), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2626), 1,
      sym__block_quote_prefix,
  [30473] = 1,
    ACTIONS(2395), 7,
      sym__block_close,
      sym__newline,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [30483] = 1,
    ACTIONS(2361), 7,
      sym__block_close,
      sym__newline,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [30493] = 1,
    ACTIONS(2371), 7,
      sym__block_close,
      sym__newline,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [30503] = 1,
    ACTIONS(2357), 7,
      sym__block_close,
      sym__newline,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [30513] = 7,
    ACTIONS(3672), 1,
      sym__block_close,
    ACTIONS(3674), 1,
      sym_list_marker_upper_alpha_period,
    ACTIONS(3677), 1,
      sym__block_quote_continuation,
    STATE(1230), 1,
      aux_sym__list_upper_alpha_period_repeat1,
    STATE(1418), 1,
      sym__list_item_upper_alpha_period,
    STATE(1506), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2105), 1,
      sym__block_quote_prefix,
  [30535] = 1,
    ACTIONS(3612), 7,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_DOT,
      sym_identifier,
      sym__whitespace1,
      sym__id,
      anon_sym_PERCENT,
  [30545] = 1,
    ACTIONS(2427), 7,
      sym__block_close,
      sym__newline,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [30555] = 1,
    ACTIONS(2431), 7,
      sym__block_close,
      sym__newline,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [30565] = 1,
    ACTIONS(2421), 7,
      sym__block_close,
      sym__newline,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
      sym__table_caption_begin,
  [30575] = 7,
    ACTIONS(3680), 1,
      sym__block_close,
    ACTIONS(3682), 1,
      sym_list_marker_upper_alpha_paren,
    ACTIONS(3685), 1,
      sym__block_quote_continuation,
    STATE(1235), 1,
      aux_sym__list_upper_alpha_paren_repeat1,
    STATE(1441), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1616), 1,
      sym__list_item_upper_alpha_paren,
    STATE(2084), 1,
      sym__block_quote_prefix,
  [30597] = 7,
    ACTIONS(71), 1,
      sym_list_marker_decimal_period,
    ACTIONS(3398), 1,
      sym__block_quote_continuation,
    ACTIONS(3688), 1,
      sym__block_close,
    STATE(1186), 1,
      aux_sym__list_decimal_period_repeat1,
    STATE(1417), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1559), 1,
      sym__list_item_decimal_period,
    STATE(2267), 1,
      sym__block_quote_prefix,
  [30619] = 7,
    ACTIONS(81), 1,
      sym_list_marker_decimal_paren,
    ACTIONS(3402), 1,
      sym__block_quote_continuation,
    ACTIONS(3690), 1,
      sym__block_close,
    STATE(1204), 1,
      aux_sym__list_decimal_paren_repeat1,
    STATE(1477), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1526), 1,
      sym__list_item_decimal_paren,
    STATE(2289), 1,
      sym__block_quote_prefix,
  [30641] = 7,
    ACTIONS(3692), 1,
      sym__block_close,
    ACTIONS(3694), 1,
      sym_list_marker_upper_alpha_parens,
    ACTIONS(3697), 1,
      sym__block_quote_continuation,
    STATE(1238), 1,
      aux_sym__list_upper_alpha_parens_repeat1,
    STATE(1621), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1628), 1,
      sym__list_item_upper_alpha_parens,
    STATE(2147), 1,
      sym__block_quote_prefix,
  [30663] = 7,
    ACTIONS(3700), 1,
      sym__block_close,
    ACTIONS(3702), 1,
      sym_list_marker_lower_roman_period,
    ACTIONS(3705), 1,
      sym__block_quote_continuation,
    STATE(1239), 1,
      aux_sym__list_lower_roman_period_repeat1,
    STATE(1425), 1,
      sym__list_item_lower_roman_period,
    STATE(1438), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2378), 1,
      sym__block_quote_prefix,
  [30685] = 7,
    ACTIONS(3708), 1,
      sym__block_close,
    ACTIONS(3710), 1,
      sym_list_marker_lower_roman_paren,
    ACTIONS(3713), 1,
      sym__block_quote_continuation,
    STATE(1240), 1,
      aux_sym__list_lower_roman_paren_repeat1,
    STATE(1410), 1,
      sym__list_item_lower_roman_paren,
    STATE(1449), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2081), 1,
      sym__block_quote_prefix,
  [30707] = 7,
    ACTIONS(3716), 1,
      sym__block_close,
    ACTIONS(3718), 1,
      sym_list_marker_lower_roman_parens,
    ACTIONS(3721), 1,
      sym__block_quote_continuation,
    STATE(1241), 1,
      aux_sym__list_lower_roman_parens_repeat1,
    STATE(1474), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1510), 1,
      sym__list_item_lower_roman_parens,
    STATE(2319), 1,
      sym__block_quote_prefix,
  [30729] = 7,
    ACTIONS(3724), 1,
      sym__block_close,
    ACTIONS(3726), 1,
      sym_list_marker_upper_roman_period,
    ACTIONS(3729), 1,
      sym__block_quote_continuation,
    STATE(1242), 1,
      aux_sym__list_upper_roman_period_repeat1,
    STATE(1492), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1547), 1,
      sym__list_item_upper_roman_period,
    STATE(2013), 1,
      sym__block_quote_prefix,
  [30751] = 7,
    ACTIONS(95), 1,
      sym_list_marker_upper_alpha_parens,
    ACTIONS(3378), 1,
      sym__block_quote_continuation,
    ACTIONS(3732), 1,
      sym__block_close,
    STATE(1238), 1,
      aux_sym__list_upper_alpha_parens_repeat1,
    STATE(1621), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(1628), 1,
      sym__list_item_upper_alpha_parens,
    STATE(2147), 1,
      sym__block_quote_prefix,
  [30773] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3736), 1,
      sym__list_item_end,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [30792] = 6,
    ACTIONS(3740), 1,
      sym__block_quote_continuation,
    ACTIONS(3743), 1,
      sym__footnote_continuation,
    ACTIONS(3746), 1,
      sym__footnote_end,
    STATE(1245), 1,
      aux_sym_footnote_content_repeat1,
    STATE(1586), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2295), 1,
      sym__block_quote_prefix,
  [30811] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3748), 1,
      sym__list_item_end,
    STATE(1248), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [30830] = 6,
    ACTIONS(3750), 1,
      sym__block_quote_continuation,
    ACTIONS(3752), 1,
      sym__footnote_continuation,
    ACTIONS(3754), 1,
      sym__footnote_end,
    STATE(1245), 1,
      aux_sym_footnote_content_repeat1,
    STATE(1586), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2295), 1,
      sym__block_quote_prefix,
  [30849] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3756), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [30868] = 5,
    ACTIONS(3758), 1,
      anon_sym_LBRACK,
    ACTIONS(3762), 1,
      anon_sym_LBRACE,
    STATE(1006), 1,
      sym_inline_attribute,
    STATE(2633), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(3760), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_LPAREN,
  [30885] = 6,
    ACTIONS(3764), 1,
      anon_sym_LBRACK,
    ACTIONS(3766), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3768), 1,
      anon_sym_LPAREN,
    STATE(715), 1,
      sym__link_label,
    STATE(716), 1,
      sym_inline_link_destination,
    STATE(2553), 1,
      sym__parens_span_begin,
  [30904] = 6,
    ACTIONS(3764), 1,
      anon_sym_LBRACK,
    ACTIONS(3768), 1,
      anon_sym_LPAREN,
    ACTIONS(3770), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(718), 1,
      sym__link_label,
    STATE(719), 1,
      sym_inline_link_destination,
    STATE(2553), 1,
      sym__parens_span_begin,
  [30923] = 6,
    ACTIONS(3772), 1,
      anon_sym_LBRACK,
    ACTIONS(3774), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3776), 1,
      anon_sym_LPAREN,
    STATE(839), 1,
      sym__link_label,
    STATE(840), 1,
      sym_inline_link_destination,
    STATE(2465), 1,
      sym__parens_span_begin,
  [30942] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3778), 1,
      sym__list_item_end,
    STATE(1255), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [30961] = 6,
    ACTIONS(3772), 1,
      anon_sym_LBRACK,
    ACTIONS(3776), 1,
      anon_sym_LPAREN,
    ACTIONS(3780), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(842), 1,
      sym__link_label,
    STATE(843), 1,
      sym_inline_link_destination,
    STATE(2465), 1,
      sym__parens_span_begin,
  [30980] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3782), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [30999] = 5,
    ACTIONS(3758), 1,
      anon_sym_LBRACK,
    ACTIONS(3784), 1,
      anon_sym_LBRACE,
    STATE(968), 1,
      sym_inline_attribute,
    STATE(2365), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(3760), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_LPAREN,
  [31016] = 6,
    ACTIONS(3786), 1,
      anon_sym_LBRACK,
    ACTIONS(3788), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3790), 1,
      anon_sym_LPAREN,
    STATE(743), 1,
      sym__link_label,
    STATE(744), 1,
      sym_inline_link_destination,
    STATE(2564), 1,
      sym__parens_span_begin,
  [31035] = 6,
    ACTIONS(3786), 1,
      anon_sym_LBRACK,
    ACTIONS(3790), 1,
      anon_sym_LPAREN,
    ACTIONS(3792), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(746), 1,
      sym__link_label,
    STATE(747), 1,
      sym_inline_link_destination,
    STATE(2564), 1,
      sym__parens_span_begin,
  [31054] = 6,
    ACTIONS(3750), 1,
      sym__block_quote_continuation,
    ACTIONS(3752), 1,
      sym__footnote_continuation,
    ACTIONS(3794), 1,
      sym__footnote_end,
    STATE(1261), 1,
      aux_sym_footnote_content_repeat1,
    STATE(1586), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2295), 1,
      sym__block_quote_prefix,
  [31073] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3796), 1,
      sym__list_item_end,
    STATE(1262), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31092] = 6,
    ACTIONS(3750), 1,
      sym__block_quote_continuation,
    ACTIONS(3752), 1,
      sym__footnote_continuation,
    ACTIONS(3798), 1,
      sym__footnote_end,
    STATE(1245), 1,
      aux_sym_footnote_content_repeat1,
    STATE(1586), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2295), 1,
      sym__block_quote_prefix,
  [31111] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3800), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31130] = 5,
    ACTIONS(3758), 1,
      anon_sym_LBRACK,
    ACTIONS(3802), 1,
      anon_sym_LBRACE,
    STATE(901), 1,
      sym_inline_attribute,
    STATE(2382), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(3760), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_LPAREN,
  [31147] = 6,
    ACTIONS(3804), 1,
      anon_sym_LBRACK,
    ACTIONS(3806), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3808), 1,
      anon_sym_LPAREN,
    STATE(771), 1,
      sym__link_label,
    STATE(772), 1,
      sym_inline_link_destination,
    STATE(2575), 1,
      sym__parens_span_begin,
  [31166] = 6,
    ACTIONS(3804), 1,
      anon_sym_LBRACK,
    ACTIONS(3808), 1,
      anon_sym_LPAREN,
    ACTIONS(3810), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(774), 1,
      sym__link_label,
    STATE(775), 1,
      sym_inline_link_destination,
    STATE(2575), 1,
      sym__parens_span_begin,
  [31185] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3812), 1,
      sym__list_item_end,
    STATE(1301), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31204] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3814), 1,
      sym__list_item_end,
    STATE(1269), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31223] = 6,
    ACTIONS(3816), 1,
      anon_sym_LBRACK,
    ACTIONS(3818), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3820), 1,
      anon_sym_LPAREN,
    STATE(563), 1,
      sym__link_label,
    STATE(564), 1,
      sym_inline_link_destination,
    STATE(2493), 1,
      sym__parens_span_begin,
  [31242] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3822), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31261] = 5,
    ACTIONS(3758), 1,
      anon_sym_LBRACK,
    ACTIONS(3824), 1,
      anon_sym_LBRACE,
    STATE(977), 1,
      sym_inline_attribute,
    STATE(2399), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(3760), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_LPAREN,
  [31278] = 6,
    ACTIONS(3826), 1,
      anon_sym_LBRACK,
    ACTIONS(3828), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3830), 1,
      anon_sym_LPAREN,
    STATE(798), 1,
      sym__link_label,
    STATE(799), 1,
      sym_inline_link_destination,
    STATE(2586), 1,
      sym__parens_span_begin,
  [31297] = 6,
    ACTIONS(3826), 1,
      anon_sym_LBRACK,
    ACTIONS(3830), 1,
      anon_sym_LPAREN,
    ACTIONS(3832), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(801), 1,
      sym__link_label,
    STATE(802), 1,
      sym_inline_link_destination,
    STATE(2586), 1,
      sym__parens_span_begin,
  [31316] = 6,
    ACTIONS(3816), 1,
      anon_sym_LBRACK,
    ACTIONS(3820), 1,
      anon_sym_LPAREN,
    ACTIONS(3834), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(566), 1,
      sym__link_label,
    STATE(567), 1,
      sym_inline_link_destination,
    STATE(2493), 1,
      sym__parens_span_begin,
  [31335] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3836), 1,
      sym__list_item_end,
    STATE(1276), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31354] = 4,
    ACTIONS(675), 1,
      sym__table_header_begin,
    ACTIONS(677), 1,
      sym__table_separator_begin,
    ACTIONS(679), 1,
      sym__table_row_begin,
    STATE(1229), 3,
      sym_table_header,
      sym_table_separator,
      sym_table_row,
  [31369] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3838), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31388] = 5,
    ACTIONS(3758), 1,
      anon_sym_LBRACK,
    ACTIONS(3840), 1,
      anon_sym_LBRACE,
    STATE(895), 1,
      sym_inline_attribute,
    STATE(2416), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(3760), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_LPAREN,
  [31405] = 6,
    ACTIONS(3842), 1,
      anon_sym_LBRACK,
    ACTIONS(3844), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN,
    STATE(910), 1,
      sym__link_label,
    STATE(911), 1,
      sym_inline_link_destination,
    STATE(2597), 1,
      sym__parens_span_begin,
  [31424] = 6,
    ACTIONS(3842), 1,
      anon_sym_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN,
    ACTIONS(3848), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(913), 1,
      sym__link_label,
    STATE(914), 1,
      sym_inline_link_destination,
    STATE(2597), 1,
      sym__parens_span_begin,
  [31443] = 6,
    ACTIONS(3750), 1,
      sym__block_quote_continuation,
    ACTIONS(3752), 1,
      sym__footnote_continuation,
    ACTIONS(3850), 1,
      sym__footnote_end,
    STATE(1317), 1,
      aux_sym_footnote_content_repeat1,
    STATE(1586), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2295), 1,
      sym__block_quote_prefix,
  [31462] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3852), 1,
      sym__list_item_end,
    STATE(1283), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31481] = 6,
    ACTIONS(3854), 1,
      anon_sym_LBRACK,
    ACTIONS(3856), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3858), 1,
      anon_sym_LPAREN,
    STATE(868), 1,
      sym__link_label,
    STATE(869), 1,
      sym_inline_link_destination,
    STATE(2479), 1,
      sym__parens_span_begin,
  [31500] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3860), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31519] = 5,
    ACTIONS(3758), 1,
      anon_sym_LBRACK,
    ACTIONS(3862), 1,
      anon_sym_LBRACE,
    STATE(1026), 1,
      sym_inline_attribute,
    STATE(2433), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(3760), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_LPAREN,
  [31536] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3864), 1,
      sym__list_item_end,
    STATE(1286), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31555] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3866), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31574] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3868), 1,
      sym__list_item_end,
    STATE(1288), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31593] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3870), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31612] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3872), 1,
      sym__list_item_end,
    STATE(1290), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31631] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3874), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31650] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3876), 1,
      sym__list_item_end,
    STATE(1292), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31669] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3878), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31688] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3880), 1,
      sym__list_item_end,
    STATE(1294), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31707] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3882), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31726] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3884), 1,
      sym__list_item_end,
    STATE(1342), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31745] = 4,
    ACTIONS(569), 1,
      sym__table_header_begin,
    ACTIONS(571), 1,
      sym__table_separator_begin,
    ACTIONS(573), 1,
      sym__table_row_begin,
    STATE(1138), 3,
      sym_table_header,
      sym_table_separator,
      sym_table_row,
  [31760] = 4,
    ACTIONS(137), 1,
      sym__table_header_begin,
    ACTIONS(139), 1,
      sym__table_separator_begin,
    ACTIONS(141), 1,
      sym__table_row_begin,
    STATE(301), 3,
      sym_table_header,
      sym_table_separator,
      sym_table_row,
  [31775] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3886), 1,
      sym__list_item_end,
    STATE(1306), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31794] = 6,
    ACTIONS(3854), 1,
      anon_sym_LBRACK,
    ACTIONS(3858), 1,
      anon_sym_LPAREN,
    ACTIONS(3888), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(871), 1,
      sym__link_label,
    STATE(872), 1,
      sym_inline_link_destination,
    STATE(2479), 1,
      sym__parens_span_begin,
  [31813] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3890), 1,
      sym__list_item_end,
    STATE(1304), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31832] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3892), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31851] = 5,
    ACTIONS(3758), 1,
      anon_sym_LBRACK,
    ACTIONS(3894), 1,
      anon_sym_LBRACE,
    STATE(976), 1,
      sym_inline_attribute,
    STATE(2197), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(3760), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_LPAREN,
  [31868] = 4,
    ACTIONS(111), 1,
      sym__table_header_begin,
    ACTIONS(113), 1,
      sym__table_separator_begin,
    ACTIONS(115), 1,
      sym__table_row_begin,
    STATE(291), 3,
      sym_table_header,
      sym_table_separator,
      sym_table_row,
  [31883] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3896), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31902] = 5,
    ACTIONS(3758), 1,
      anon_sym_LBRACK,
    ACTIONS(3898), 1,
      anon_sym_LBRACE,
    STATE(958), 1,
      sym_inline_attribute,
    STATE(2259), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(3760), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_LPAREN,
  [31919] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3900), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31938] = 4,
    ACTIONS(639), 1,
      sym__table_header_begin,
    ACTIONS(641), 1,
      sym__table_separator_begin,
    ACTIONS(643), 1,
      sym__table_row_begin,
    STATE(1076), 3,
      sym_table_header,
      sym_table_separator,
      sym_table_row,
  [31953] = 6,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3902), 1,
      sym__list_item_continuation,
    ACTIONS(3904), 1,
      sym__list_item_end,
    STATE(1322), 1,
      aux_sym__list_item_definition_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2324), 1,
      sym__block_quote_prefix,
  [31972] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3906), 1,
      sym__list_item_end,
    STATE(1333), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [31991] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3908), 1,
      sym__list_item_end,
    STATE(1318), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [32010] = 6,
    ACTIONS(3750), 1,
      sym__block_quote_continuation,
    ACTIONS(3752), 1,
      sym__footnote_continuation,
    ACTIONS(3910), 1,
      sym__footnote_end,
    STATE(1313), 1,
      aux_sym_footnote_content_repeat1,
    STATE(1586), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2295), 1,
      sym__block_quote_prefix,
  [32029] = 6,
    ACTIONS(3912), 1,
      sym__list_item_continuation,
    ACTIONS(3915), 1,
      sym__list_item_end,
    ACTIONS(3917), 1,
      sym__block_quote_continuation,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [32048] = 6,
    ACTIONS(3750), 1,
      sym__block_quote_continuation,
    ACTIONS(3752), 1,
      sym__footnote_continuation,
    ACTIONS(3920), 1,
      sym__footnote_end,
    STATE(1245), 1,
      aux_sym_footnote_content_repeat1,
    STATE(1586), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2295), 1,
      sym__block_quote_prefix,
  [32067] = 6,
    ACTIONS(3922), 1,
      anon_sym_LBRACK,
    ACTIONS(3924), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3926), 1,
      anon_sym_LPAREN,
    STATE(595), 1,
      sym__link_label,
    STATE(596), 1,
      sym_inline_link_destination,
    STATE(2507), 1,
      sym__parens_span_begin,
  [32086] = 6,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3902), 1,
      sym__list_item_continuation,
    ACTIONS(3928), 1,
      sym__list_item_end,
    STATE(1330), 1,
      aux_sym__list_item_definition_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2324), 1,
      sym__block_quote_prefix,
  [32105] = 6,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3902), 1,
      sym__list_item_continuation,
    ACTIONS(3930), 1,
      sym__list_item_end,
    STATE(1308), 1,
      aux_sym__list_item_definition_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2324), 1,
      sym__block_quote_prefix,
  [32124] = 6,
    ACTIONS(3750), 1,
      sym__block_quote_continuation,
    ACTIONS(3752), 1,
      sym__footnote_continuation,
    ACTIONS(3932), 1,
      sym__footnote_end,
    STATE(1245), 1,
      aux_sym_footnote_content_repeat1,
    STATE(1586), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2295), 1,
      sym__block_quote_prefix,
  [32143] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3934), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [32162] = 6,
    ACTIONS(3922), 1,
      anon_sym_LBRACK,
    ACTIONS(3926), 1,
      anon_sym_LPAREN,
    ACTIONS(3936), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(598), 1,
      sym__link_label,
    STATE(599), 1,
      sym_inline_link_destination,
    STATE(2507), 1,
      sym__parens_span_begin,
  [32181] = 5,
    ACTIONS(3758), 1,
      anon_sym_LBRACK,
    ACTIONS(3938), 1,
      anon_sym_LBRACE,
    STATE(939), 1,
      sym_inline_attribute,
    STATE(2288), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(3760), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_LPAREN,
  [32198] = 6,
    ACTIONS(3750), 1,
      sym__block_quote_continuation,
    ACTIONS(3752), 1,
      sym__footnote_continuation,
    ACTIONS(3940), 1,
      sym__footnote_end,
    STATE(1247), 1,
      aux_sym_footnote_content_repeat1,
    STATE(1586), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2295), 1,
      sym__block_quote_prefix,
  [32217] = 6,
    ACTIONS(3942), 1,
      sym__list_item_continuation,
    ACTIONS(3945), 1,
      sym__list_item_end,
    ACTIONS(3947), 1,
      sym__block_quote_continuation,
    STATE(1322), 1,
      aux_sym__list_item_definition_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2324), 1,
      sym__block_quote_prefix,
  [32236] = 6,
    ACTIONS(3750), 1,
      sym__block_quote_continuation,
    ACTIONS(3752), 1,
      sym__footnote_continuation,
    ACTIONS(3950), 1,
      sym__footnote_end,
    STATE(1324), 1,
      aux_sym_footnote_content_repeat1,
    STATE(1586), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2295), 1,
      sym__block_quote_prefix,
  [32255] = 6,
    ACTIONS(3750), 1,
      sym__block_quote_continuation,
    ACTIONS(3752), 1,
      sym__footnote_continuation,
    ACTIONS(3952), 1,
      sym__footnote_end,
    STATE(1245), 1,
      aux_sym_footnote_content_repeat1,
    STATE(1586), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2295), 1,
      sym__block_quote_prefix,
  [32274] = 6,
    ACTIONS(3954), 1,
      anon_sym_LBRACK,
    ACTIONS(3956), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3958), 1,
      anon_sym_LPAREN,
    STATE(622), 1,
      sym__link_label,
    STATE(623), 1,
      sym_inline_link_destination,
    STATE(2520), 1,
      sym__parens_span_begin,
  [32293] = 6,
    ACTIONS(3954), 1,
      anon_sym_LBRACK,
    ACTIONS(3958), 1,
      anon_sym_LPAREN,
    ACTIONS(3960), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(625), 1,
      sym__link_label,
    STATE(626), 1,
      sym_inline_link_destination,
    STATE(2520), 1,
      sym__parens_span_begin,
  [32312] = 5,
    ACTIONS(3758), 1,
      anon_sym_LBRACK,
    ACTIONS(3962), 1,
      anon_sym_LBRACE,
    STATE(908), 1,
      sym_inline_attribute,
    STATE(2125), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(3760), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_LPAREN,
  [32329] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3964), 1,
      sym__list_item_end,
    STATE(1244), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [32348] = 6,
    ACTIONS(3966), 1,
      anon_sym_LBRACK,
    ACTIONS(3968), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3970), 1,
      anon_sym_LPAREN,
    STATE(824), 1,
      sym__link_label,
    STATE(825), 1,
      sym_inline_link_destination,
    STATE(2341), 1,
      sym__parens_span_begin,
  [32367] = 6,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3902), 1,
      sym__list_item_continuation,
    ACTIONS(3972), 1,
      sym__list_item_end,
    STATE(1322), 1,
      aux_sym__list_item_definition_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2324), 1,
      sym__block_quote_prefix,
  [32386] = 5,
    ACTIONS(3758), 1,
      anon_sym_LBRACK,
    ACTIONS(3974), 1,
      anon_sym_LBRACE,
    STATE(974), 1,
      sym_inline_attribute,
    STATE(2314), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(3760), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_LPAREN,
  [32403] = 6,
    ACTIONS(3976), 1,
      anon_sym_LBRACK,
    ACTIONS(3978), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3980), 1,
      anon_sym_LPAREN,
    STATE(650), 1,
      sym__link_label,
    STATE(651), 1,
      sym_inline_link_destination,
    STATE(2531), 1,
      sym__parens_span_begin,
  [32422] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3982), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [32441] = 6,
    ACTIONS(3976), 1,
      anon_sym_LBRACK,
    ACTIONS(3980), 1,
      anon_sym_LPAREN,
    ACTIONS(3984), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(653), 1,
      sym__link_label,
    STATE(654), 1,
      sym_inline_link_destination,
    STATE(2531), 1,
      sym__parens_span_begin,
  [32460] = 6,
    ACTIONS(3966), 1,
      anon_sym_LBRACK,
    ACTIONS(3970), 1,
      anon_sym_LPAREN,
    ACTIONS(3986), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(829), 1,
      sym__link_label,
    STATE(830), 1,
      sym_inline_link_destination,
    STATE(2341), 1,
      sym__parens_span_begin,
  [32479] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3988), 1,
      sym__list_item_end,
    STATE(1338), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [32498] = 5,
    ACTIONS(3758), 1,
      anon_sym_LBRACK,
    ACTIONS(3990), 1,
      anon_sym_LBRACE,
    STATE(1011), 1,
      sym_inline_attribute,
    STATE(2229), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(3760), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_LPAREN,
  [32515] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(3992), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [32534] = 5,
    ACTIONS(3758), 1,
      anon_sym_LBRACK,
    ACTIONS(3994), 1,
      anon_sym_LBRACE,
    STATE(995), 1,
      sym_inline_attribute,
    STATE(2331), 1,
      sym__curly_bracket_span_begin,
    ACTIONS(3760), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_LPAREN,
  [32551] = 6,
    ACTIONS(3996), 1,
      anon_sym_LBRACK,
    ACTIONS(3998), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4000), 1,
      anon_sym_LPAREN,
    STATE(686), 1,
      sym__link_label,
    STATE(687), 1,
      sym_inline_link_destination,
    STATE(2542), 1,
      sym__parens_span_begin,
  [32570] = 6,
    ACTIONS(3996), 1,
      anon_sym_LBRACK,
    ACTIONS(4000), 1,
      anon_sym_LPAREN,
    ACTIONS(4002), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(689), 1,
      sym__link_label,
    STATE(690), 1,
      sym_inline_link_destination,
    STATE(2542), 1,
      sym__parens_span_begin,
  [32589] = 6,
    ACTIONS(3734), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    ACTIONS(4004), 1,
      sym__list_item_end,
    STATE(1312), 1,
      aux_sym_list_item_content_repeat1,
    STATE(1582), 1,
      aux_sym__block_quote_prefix_repeat1,
    STATE(2126), 1,
      sym__block_quote_prefix,
  [32608] = 3,
    STATE(1351), 1,
      aux_sym__comment_repeat1,
    ACTIONS(4006), 2,
      sym_backslash_escape,
      aux_sym__comment_token1,
    ACTIONS(4008), 2,
      sym__comment_end_marker,
      sym__comment_close,
  [32620] = 3,
    STATE(1343), 1,
      aux_sym__comment_repeat1,
    ACTIONS(4006), 2,
      sym_backslash_escape,
      aux_sym__comment_token1,
    ACTIONS(4010), 2,
      sym__comment_end_marker,
      sym__comment_close,
  [32632] = 3,
    ACTIONS(1014), 1,
      sym__block_quote_continuation,
    STATE(1346), 1,
      aux_sym__block_quote_prefix_repeat1,
    ACTIONS(2685), 3,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
  [32644] = 3,
    ACTIONS(4012), 1,
      sym__block_quote_continuation,
    STATE(1346), 1,
      aux_sym__block_quote_prefix_repeat1,
    ACTIONS(2675), 3,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
  [32656] = 4,
    ACTIONS(4015), 1,
      sym__block_close,
    ACTIONS(4017), 1,
      sym__block_quote_continuation,
    STATE(1347), 1,
      aux_sym__block_quote_content_repeat1,
    STATE(80), 2,
      sym__block_quote_prefix,
      aux_sym__block_quote_prefix_repeat1,
  [32670] = 3,
    STATE(1349), 1,
      aux_sym__comment_repeat1,
    ACTIONS(4006), 2,
      sym_backslash_escape,
      aux_sym__comment_token1,
    ACTIONS(4020), 2,
      sym__comment_end_marker,
      sym__comment_close,
  [32682] = 3,
    STATE(1351), 1,
      aux_sym__comment_repeat1,
    ACTIONS(4006), 2,
      sym_backslash_escape,
      aux_sym__comment_token1,
    ACTIONS(4022), 2,
      sym__comment_end_marker,
      sym__comment_close,
  [32694] = 3,
    ACTIONS(3137), 1,
      sym__table_caption_begin,
    STATE(1491), 1,
      sym_table_caption,
    ACTIONS(2347), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [32706] = 3,
    STATE(1351), 1,
      aux_sym__comment_repeat1,
    ACTIONS(4024), 2,
      sym_backslash_escape,
      aux_sym__comment_token1,
    ACTIONS(4027), 2,
      sym__comment_end_marker,
      sym__comment_close,
  [32718] = 3,
    STATE(1354), 1,
      aux_sym__comment_repeat1,
    ACTIONS(4006), 2,
      sym_backslash_escape,
      aux_sym__comment_token1,
    ACTIONS(4029), 2,
      sym__comment_end_marker,
      sym__comment_close,
  [32730] = 4,
    ACTIONS(4031), 1,
      sym__block_close,
    ACTIONS(4033), 1,
      sym__block_quote_continuation,
    STATE(1355), 1,
      aux_sym__block_quote_content_repeat1,
    STATE(80), 2,
      sym__block_quote_prefix,
      aux_sym__block_quote_prefix_repeat1,
  [32744] = 3,
    STATE(1351), 1,
      aux_sym__comment_repeat1,
    ACTIONS(4006), 2,
      sym_backslash_escape,
      aux_sym__comment_token1,
    ACTIONS(4035), 2,
      sym__comment_end_marker,
      sym__comment_close,
  [32756] = 4,
    ACTIONS(4033), 1,
      sym__block_quote_continuation,
    ACTIONS(4037), 1,
      sym__block_close,
    STATE(1347), 1,
      aux_sym__block_quote_content_repeat1,
    STATE(80), 2,
      sym__block_quote_prefix,
      aux_sym__block_quote_prefix_repeat1,
  [32770] = 2,
    ACTIONS(4039), 1,
      sym__code_block_end,
    ACTIONS(2437), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [32779] = 3,
    ACTIONS(4043), 1,
      sym__parens_span_end,
    STATE(1369), 1,
      aux_sym__inline_link_url,
    ACTIONS(4041), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [32790] = 4,
    ACTIONS(4045), 1,
      sym__block_close,
    ACTIONS(4047), 1,
      sym_list_marker_definition,
    STATE(1358), 1,
      aux_sym__list_definition_repeat1,
    STATE(1873), 1,
      sym__list_item_definition,
  [32803] = 4,
    ACTIONS(69), 1,
      sym_list_marker_definition,
    ACTIONS(4050), 1,
      sym__block_close,
    STATE(1358), 1,
      aux_sym__list_definition_repeat1,
    STATE(1873), 1,
      sym__list_item_definition,
  [32816] = 3,
    ACTIONS(4052), 1,
      sym__parens_span_end,
    STATE(1369), 1,
      aux_sym__inline_link_url,
    ACTIONS(4041), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [32827] = 3,
    ACTIONS(4054), 1,
      sym__parens_span_end,
    STATE(1369), 1,
      aux_sym__inline_link_url,
    ACTIONS(4041), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [32838] = 3,
    ACTIONS(4056), 1,
      aux_sym__table_cell_alignment_token1,
    ACTIONS(4058), 1,
      sym__table_row_end_newline,
    STATE(1406), 2,
      sym__table_cell_alignment,
      aux_sym_table_separator_repeat1,
  [32849] = 2,
    ACTIONS(4060), 1,
      sym__code_block_end,
    ACTIONS(2411), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [32858] = 3,
    ACTIONS(4062), 1,
      sym__parens_span_end,
    STATE(1369), 1,
      aux_sym__inline_link_url,
    ACTIONS(4041), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [32869] = 3,
    ACTIONS(4064), 1,
      sym__parens_span_end,
    STATE(1369), 1,
      aux_sym__inline_link_url,
    ACTIONS(4041), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [32880] = 2,
    ACTIONS(4066), 1,
      sym__code_block_end,
    ACTIONS(2417), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [32889] = 3,
    ACTIONS(4068), 1,
      sym__parens_span_end,
    STATE(1369), 1,
      aux_sym__inline_link_url,
    ACTIONS(4041), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [32900] = 3,
    ACTIONS(4056), 1,
      aux_sym__table_cell_alignment_token1,
    ACTIONS(4070), 1,
      sym__table_row_end_newline,
    STATE(1393), 2,
      sym__table_cell_alignment,
      aux_sym_table_separator_repeat1,
  [32911] = 3,
    ACTIONS(4075), 1,
      sym__parens_span_end,
    STATE(1369), 1,
      aux_sym__inline_link_url,
    ACTIONS(4072), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [32922] = 3,
    ACTIONS(4077), 1,
      sym__parens_span_end,
    STATE(1369), 1,
      aux_sym__inline_link_url,
    ACTIONS(4041), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [32933] = 3,
    ACTIONS(4079), 1,
      sym__parens_span_end,
    STATE(1369), 1,
      aux_sym__inline_link_url,
    ACTIONS(4041), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [32944] = 3,
    ACTIONS(4081), 1,
      sym__parens_span_end,
    STATE(1369), 1,
      aux_sym__inline_link_url,
    ACTIONS(4041), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [32955] = 4,
    ACTIONS(69), 1,
      sym_list_marker_definition,
    ACTIONS(4083), 1,
      sym__block_close,
    STATE(1358), 1,
      aux_sym__list_definition_repeat1,
    STATE(1873), 1,
      sym__list_item_definition,
  [32968] = 3,
    ACTIONS(4056), 1,
      aux_sym__table_cell_alignment_token1,
    ACTIONS(4085), 1,
      sym__table_row_end_newline,
    STATE(1386), 2,
      sym__table_cell_alignment,
      aux_sym_table_separator_repeat1,
  [32979] = 3,
    ACTIONS(4087), 1,
      sym__parens_span_end,
    STATE(1369), 1,
      aux_sym__inline_link_url,
    ACTIONS(4041), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [32990] = 2,
    ACTIONS(4089), 2,
      sym_backslash_escape,
      aux_sym__comment_token1,
    ACTIONS(4091), 2,
      sym__comment_end_marker,
      sym__comment_close,
  [32999] = 4,
    ACTIONS(69), 1,
      sym_list_marker_definition,
    ACTIONS(4093), 1,
      sym__block_close,
    STATE(1358), 1,
      aux_sym__list_definition_repeat1,
    STATE(1873), 1,
      sym__list_item_definition,
  [33012] = 3,
    ACTIONS(4095), 1,
      sym__parens_span_end,
    STATE(1369), 1,
      aux_sym__inline_link_url,
    ACTIONS(4041), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [33023] = 1,
    ACTIONS(657), 4,
      sym__block_quote_continuation,
      sym__table_header_begin,
      sym__table_separator_begin,
      sym__table_row_begin,
  [33030] = 2,
    ACTIONS(4097), 1,
      sym__div_end,
    ACTIONS(2403), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33039] = 3,
    ACTIONS(4099), 1,
      aux_sym__line_token1,
    STATE(2085), 1,
      sym_frontmatter_content,
    STATE(1384), 2,
      sym__line,
      aux_sym_frontmatter_content_repeat1,
  [33050] = 3,
    ACTIONS(4056), 1,
      aux_sym__table_cell_alignment_token1,
    ACTIONS(4101), 1,
      sym__table_row_end_newline,
    STATE(1396), 2,
      sym__table_cell_alignment,
      aux_sym_table_separator_repeat1,
  [33061] = 4,
    ACTIONS(4103), 1,
      anon_sym_EQ,
    ACTIONS(4105), 1,
      sym_language,
    ACTIONS(4107), 1,
      sym__newline,
    STATE(2214), 1,
      sym_raw_block_info,
  [33074] = 3,
    ACTIONS(4099), 1,
      aux_sym__line_token1,
    ACTIONS(4109), 1,
      sym_frontmatter_marker,
    STATE(1408), 2,
      sym__line,
      aux_sym_frontmatter_content_repeat1,
  [33085] = 3,
    ACTIONS(4099), 1,
      aux_sym__line_token1,
    STATE(2262), 1,
      sym_frontmatter_content,
    STATE(1384), 2,
      sym__line,
      aux_sym_frontmatter_content_repeat1,
  [33096] = 3,
    ACTIONS(4056), 1,
      aux_sym__table_cell_alignment_token1,
    ACTIONS(4111), 1,
      sym__table_row_end_newline,
    STATE(1406), 2,
      sym__table_cell_alignment,
      aux_sym_table_separator_repeat1,
  [33107] = 3,
    ACTIONS(4056), 1,
      aux_sym__table_cell_alignment_token1,
    ACTIONS(4113), 1,
      sym__table_row_end_newline,
    STATE(1406), 2,
      sym__table_cell_alignment,
      aux_sym_table_separator_repeat1,
  [33118] = 4,
    ACTIONS(4103), 1,
      anon_sym_EQ,
    ACTIONS(4115), 1,
      sym_language,
    ACTIONS(4117), 1,
      sym__newline,
    STATE(2245), 1,
      sym_raw_block_info,
  [33131] = 4,
    ACTIONS(4103), 1,
      anon_sym_EQ,
    ACTIONS(4119), 1,
      sym_language,
    ACTIONS(4121), 1,
      sym__newline,
    STATE(2017), 1,
      sym_raw_block_info,
  [33144] = 2,
    ACTIONS(4123), 1,
      sym__eof_or_newline,
    ACTIONS(2353), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33153] = 2,
    ACTIONS(4125), 1,
      sym__div_end,
    ACTIONS(2443), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33162] = 2,
    ACTIONS(4127), 1,
      sym__div_end,
    ACTIONS(2365), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33171] = 3,
    ACTIONS(4056), 1,
      aux_sym__table_cell_alignment_token1,
    ACTIONS(4129), 1,
      sym__table_row_end_newline,
    STATE(1406), 2,
      sym__table_cell_alignment,
      aux_sym_table_separator_repeat1,
  [33182] = 4,
    ACTIONS(4103), 1,
      anon_sym_EQ,
    ACTIONS(4131), 1,
      sym_language,
    ACTIONS(4133), 1,
      sym__newline,
    STATE(2275), 1,
      sym_raw_block_info,
  [33195] = 4,
    ACTIONS(4103), 1,
      anon_sym_EQ,
    ACTIONS(4135), 1,
      sym_language,
    ACTIONS(4137), 1,
      sym__newline,
    STATE(2304), 1,
      sym_raw_block_info,
  [33208] = 3,
    ACTIONS(4056), 1,
      aux_sym__table_cell_alignment_token1,
    ACTIONS(4139), 1,
      sym__table_row_end_newline,
    STATE(1406), 2,
      sym__table_cell_alignment,
      aux_sym_table_separator_repeat1,
  [33219] = 3,
    ACTIONS(4141), 1,
      sym__parens_span_end,
    STATE(1369), 1,
      aux_sym__inline_link_url,
    ACTIONS(4041), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [33230] = 3,
    ACTIONS(4056), 1,
      aux_sym__table_cell_alignment_token1,
    ACTIONS(4143), 1,
      sym__table_row_end_newline,
    STATE(1387), 2,
      sym__table_cell_alignment,
      aux_sym_table_separator_repeat1,
  [33241] = 4,
    ACTIONS(69), 1,
      sym_list_marker_definition,
    ACTIONS(4145), 1,
      sym__block_close,
    STATE(1358), 1,
      aux_sym__list_definition_repeat1,
    STATE(1873), 1,
      sym__list_item_definition,
  [33254] = 3,
    ACTIONS(3141), 1,
      sym__table_caption_begin,
    STATE(1645), 1,
      sym_table_caption,
    ACTIONS(2347), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [33265] = 3,
    ACTIONS(4056), 1,
      aux_sym__table_cell_alignment_token1,
    ACTIONS(4147), 1,
      sym__table_row_end_newline,
    STATE(1362), 2,
      sym__table_cell_alignment,
      aux_sym_table_separator_repeat1,
  [33276] = 2,
    ACTIONS(4149), 1,
      sym__code_block_end,
    ACTIONS(2375), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33285] = 4,
    ACTIONS(69), 1,
      sym_list_marker_definition,
    ACTIONS(4151), 1,
      sym__block_close,
    STATE(1358), 1,
      aux_sym__list_definition_repeat1,
    STATE(1873), 1,
      sym__list_item_definition,
  [33298] = 2,
    ACTIONS(4153), 1,
      sym__code_block_end,
    ACTIONS(2381), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33307] = 2,
    ACTIONS(4155), 1,
      sym__code_block_end,
    ACTIONS(2387), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33316] = 3,
    ACTIONS(4157), 1,
      aux_sym__table_cell_alignment_token1,
    ACTIONS(4160), 1,
      sym__table_row_end_newline,
    STATE(1406), 2,
      sym__table_cell_alignment,
      aux_sym_table_separator_repeat1,
  [33327] = 3,
    ACTIONS(4162), 1,
      sym__parens_span_end,
    STATE(1369), 1,
      aux_sym__inline_link_url,
    ACTIONS(4041), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [33338] = 3,
    ACTIONS(4164), 1,
      aux_sym__line_token1,
    ACTIONS(4167), 1,
      sym_frontmatter_marker,
    STATE(1408), 2,
      sym__line,
      aux_sym_frontmatter_content_repeat1,
  [33349] = 2,
    ACTIONS(4169), 1,
      sym__div_end,
    ACTIONS(2397), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33358] = 1,
    ACTIONS(4171), 3,
      sym__block_close,
      sym_list_marker_lower_roman_paren,
      sym__block_quote_continuation,
  [33364] = 1,
    ACTIONS(4173), 3,
      sym__block_close,
      sym_list_marker_lower_roman_paren,
      sym__block_quote_continuation,
  [33370] = 1,
    ACTIONS(2615), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33376] = 1,
    ACTIONS(2653), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33382] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_star,
    ACTIONS(3390), 1,
      sym__block_quote_continuation,
    STATE(1475), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33392] = 3,
    ACTIONS(4175), 1,
      sym__eof_or_newline,
    ACTIONS(4177), 1,
      sym__newline_inline,
    STATE(1614), 1,
      aux_sym__paragraph_content_repeat1,
  [33402] = 1,
    ACTIONS(4179), 3,
      sym__block_close,
      sym_list_marker_lower_alpha_parens,
      sym__block_quote_continuation,
  [33408] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_decimal_period,
    ACTIONS(3398), 1,
      sym__block_quote_continuation,
    STATE(1542), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33418] = 1,
    ACTIONS(4181), 3,
      sym__block_close,
      sym_list_marker_upper_alpha_period,
      sym__block_quote_continuation,
  [33424] = 1,
    ACTIONS(4183), 3,
      sym__block_close,
      sym_list_marker_upper_roman_parens,
      sym__block_quote_continuation,
  [33430] = 1,
    ACTIONS(2489), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33436] = 1,
    ACTIONS(2493), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33442] = 1,
    ACTIONS(2497), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33448] = 1,
    ACTIONS(4185), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33454] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_lower_alpha_parens,
      sym__block_quote_continuation,
  [33460] = 1,
    ACTIONS(4189), 3,
      sym__block_close,
      sym_list_marker_lower_roman_period,
      sym__block_quote_continuation,
  [33466] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_lower_alpha_parens,
    ACTIONS(3360), 1,
      sym__block_quote_continuation,
    STATE(1446), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33476] = 1,
    ACTIONS(2501), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33482] = 1,
    ACTIONS(2505), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33488] = 1,
    ACTIONS(2509), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33494] = 1,
    ACTIONS(2587), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33500] = 1,
    ACTIONS(2513), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33506] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_lower_alpha_parens,
      sym__block_quote_continuation,
  [33512] = 1,
    ACTIONS(2517), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33518] = 1,
    ACTIONS(2521), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33524] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_lower_roman_period,
      sym__block_quote_continuation,
  [33530] = 1,
    ACTIONS(2525), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33536] = 1,
    ACTIONS(2529), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33542] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_lower_roman_period,
    ACTIONS(3394), 1,
      sym__block_quote_continuation,
    STATE(1439), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33552] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_lower_roman_period,
    ACTIONS(4193), 1,
      sym__block_quote_continuation,
    STATE(1439), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33562] = 3,
    ACTIONS(2347), 1,
      sym__indented_content_spacer,
    ACTIONS(3154), 1,
      sym__table_caption_begin,
    STATE(2022), 1,
      sym_table_caption,
  [33572] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_upper_alpha_paren,
    ACTIONS(3366), 1,
      sym__block_quote_continuation,
    STATE(1461), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33582] = 1,
    ACTIONS(4196), 3,
      sym__block_close,
      sym_list_marker_dash,
      sym__block_quote_continuation,
  [33588] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_upper_alpha_parens,
      sym__block_quote_continuation,
  [33594] = 1,
    ACTIONS(2533), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33600] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_lower_alpha_paren,
    ACTIONS(4198), 1,
      sym__block_quote_continuation,
    STATE(1445), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33610] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_lower_alpha_parens,
    ACTIONS(4201), 1,
      sym__block_quote_continuation,
    STATE(1446), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33620] = 1,
    ACTIONS(2537), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33626] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_upper_alpha_parens,
      sym__block_quote_continuation,
  [33632] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_lower_roman_paren,
    ACTIONS(3426), 1,
      sym__block_quote_continuation,
    STATE(1453), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33642] = 3,
    ACTIONS(4204), 1,
      anon_sym_DQUOTE,
    ACTIONS(4206), 1,
      aux_sym_value_token2,
    STATE(1207), 1,
      sym_value,
  [33652] = 2,
    ACTIONS(4208), 1,
      anon_sym_LBRACK,
    STATE(2299), 2,
      sym_checked,
      sym_unchecked,
  [33660] = 1,
    ACTIONS(2605), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33666] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_lower_roman_paren,
    ACTIONS(4210), 1,
      sym__block_quote_continuation,
    STATE(1453), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33676] = 1,
    ACTIONS(4213), 3,
      sym__block_close,
      sym_list_marker_dash,
      sym__block_quote_continuation,
  [33682] = 1,
    ACTIONS(2541), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33688] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_decimal_paren,
      sym__block_quote_continuation,
  [33694] = 1,
    ACTIONS(2545), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33700] = 1,
    ACTIONS(2549), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33706] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_lower_roman_paren,
      sym__block_quote_continuation,
  [33712] = 1,
    ACTIONS(2617), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33718] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_upper_alpha_paren,
    ACTIONS(4215), 1,
      sym__block_quote_continuation,
    STATE(1461), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33728] = 1,
    ACTIONS(2553), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33734] = 1,
    ACTIONS(2557), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33740] = 1,
    ACTIONS(4218), 3,
      sym__block_close,
      sym_list_marker_plus,
      sym__block_quote_continuation,
  [33746] = 1,
    ACTIONS(2561), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33752] = 1,
    ACTIONS(2565), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33758] = 1,
    ACTIONS(2657), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33764] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_lower_roman_parens,
      sym__block_quote_continuation,
  [33770] = 1,
    ACTIONS(2621), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33776] = 1,
    ACTIONS(2629), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33782] = 1,
    ACTIONS(2633), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33788] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_lower_roman_parens,
      sym__block_quote_continuation,
  [33794] = 1,
    ACTIONS(2347), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33800] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_lower_roman_parens,
    ACTIONS(3430), 1,
      sym__block_quote_continuation,
    STATE(1479), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33810] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_star,
    ACTIONS(4220), 1,
      sym__block_quote_continuation,
    STATE(1475), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33820] = 1,
    ACTIONS(2595), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33826] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_decimal_paren,
    ACTIONS(3402), 1,
      sym__block_quote_continuation,
    STATE(1496), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33836] = 1,
    ACTIONS(4223), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33842] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_lower_roman_parens,
    ACTIONS(4225), 1,
      sym__block_quote_continuation,
    STATE(1479), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33852] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_upper_roman_parens,
      sym__block_quote_continuation,
  [33858] = 1,
    ACTIONS(2573), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33864] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_lower_roman_paren,
      sym__block_quote_continuation,
  [33870] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_lower_alpha_paren,
    ACTIONS(3348), 1,
      sym__block_quote_continuation,
    STATE(1445), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33880] = 1,
    ACTIONS(4228), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33886] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_upper_alpha_paren,
      sym__block_quote_continuation,
  [33892] = 1,
    ACTIONS(2577), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33898] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_upper_roman_parens,
      sym__block_quote_continuation,
  [33904] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_decimal_period,
      sym__block_quote_continuation,
  [33910] = 1,
    ACTIONS(4230), 3,
      sym__block_close,
      sym__list_marker_task_begin,
      sym__block_quote_continuation,
  [33916] = 1,
    ACTIONS(2569), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33922] = 1,
    ACTIONS(2609), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33928] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_upper_roman_period,
    ACTIONS(3434), 1,
      sym__block_quote_continuation,
    STATE(1493), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33938] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_upper_roman_period,
    ACTIONS(4232), 1,
      sym__block_quote_continuation,
    STATE(1493), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33948] = 1,
    ACTIONS(4235), 3,
      sym__block_close,
      sym_list_marker_dash,
      sym__block_quote_continuation,
  [33954] = 1,
    ACTIONS(2665), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33960] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_decimal_paren,
    ACTIONS(4237), 1,
      sym__block_quote_continuation,
    STATE(1496), 1,
      aux_sym__block_quote_prefix_repeat1,
  [33970] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym__list_marker_task_begin,
      sym__block_quote_continuation,
  [33976] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_lower_alpha_period,
      sym__block_quote_continuation,
  [33982] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym__list_marker_task_begin,
      sym__block_quote_continuation,
  [33988] = 1,
    ACTIONS(2637), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [33994] = 1,
    ACTIONS(4240), 3,
      sym__block_close,
      sym_list_marker_star,
      sym__block_quote_continuation,
  [34000] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_upper_roman_paren,
    ACTIONS(3438), 1,
      sym__block_quote_continuation,
    STATE(1505), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34010] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_star,
      sym__block_quote_continuation,
  [34016] = 1,
    ACTIONS(2477), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [34022] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_upper_roman_paren,
    ACTIONS(4242), 1,
      sym__block_quote_continuation,
    STATE(1505), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34032] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_upper_alpha_period,
    ACTIONS(3344), 1,
      sym__block_quote_continuation,
    STATE(1551), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34042] = 1,
    ACTIONS(4245), 3,
      sym__block_close,
      sym_list_marker_lower_alpha_parens,
      sym__block_quote_continuation,
  [34048] = 2,
    STATE(1371), 1,
      aux_sym__inline_link_url,
    ACTIONS(4247), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [34056] = 3,
    ACTIONS(4249), 1,
      sym__block_close,
    ACTIONS(4251), 1,
      sym__heading_continuation,
    STATE(1509), 1,
      aux_sym__heading_content_repeat1,
  [34066] = 1,
    ACTIONS(4254), 3,
      sym__block_close,
      sym_list_marker_lower_roman_parens,
      sym__block_quote_continuation,
  [34072] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_upper_roman_parens,
    ACTIONS(3442), 1,
      sym__block_quote_continuation,
    STATE(1512), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34082] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_upper_roman_parens,
    ACTIONS(4256), 1,
      sym__block_quote_continuation,
    STATE(1512), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34092] = 1,
    ACTIONS(2645), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [34098] = 1,
    ACTIONS(4259), 3,
      sym__block_close,
      sym_list_marker_plus,
      sym__block_quote_continuation,
  [34104] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_decimal_period,
      sym__block_quote_continuation,
  [34110] = 1,
    ACTIONS(4261), 3,
      sym__block_close,
      sym_list_marker_decimal_parens,
      sym__block_quote_continuation,
  [34116] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_decimal_paren,
      sym__block_quote_continuation,
  [34122] = 1,
    ACTIONS(4263), 3,
      sym__block_close,
      sym_list_marker_decimal_period,
      sym__block_quote_continuation,
  [34128] = 1,
    ACTIONS(2649), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [34134] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_decimal_parens,
      sym__block_quote_continuation,
  [34140] = 3,
    ACTIONS(2685), 1,
      sym__list_marker_task_begin,
    ACTIONS(3296), 1,
      sym__block_quote_continuation,
    STATE(1585), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34150] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_upper_alpha_paren,
      sym__block_quote_continuation,
  [34156] = 2,
    STATE(1397), 1,
      aux_sym__inline_link_url,
    ACTIONS(4265), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [34164] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_upper_roman_period,
      sym__block_quote_continuation,
  [34170] = 1,
    ACTIONS(4267), 3,
      sym__block_close,
      sym__block_quote_continuation,
      aux_sym__line_token1,
  [34176] = 1,
    ACTIONS(4269), 3,
      sym__block_close,
      sym_list_marker_decimal_paren,
      sym__block_quote_continuation,
  [34182] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_lower_roman_period,
      sym__block_quote_continuation,
  [34188] = 1,
    ACTIONS(4271), 3,
      sym__block_close,
      sym__list_marker_task_begin,
      sym__block_quote_continuation,
  [34194] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_star,
      sym__block_quote_continuation,
  [34200] = 1,
    ACTIONS(3465), 3,
      sym__block_close,
      sym__block_quote_continuation,
      aux_sym__line_token1,
  [34206] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_dash,
      sym__block_quote_continuation,
  [34212] = 3,
    ACTIONS(4273), 1,
      sym__block_close,
    ACTIONS(4275), 1,
      sym__heading_continuation,
    STATE(1533), 1,
      aux_sym__heading_content_repeat1,
  [34222] = 3,
    ACTIONS(4275), 1,
      sym__heading_continuation,
    ACTIONS(4277), 1,
      sym__block_close,
    STATE(1509), 1,
      aux_sym__heading_content_repeat1,
  [34232] = 1,
    ACTIONS(3945), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [34238] = 1,
    ACTIONS(4279), 3,
      sym__block_close,
      sym_list_marker_star,
      sym__block_quote_continuation,
  [34244] = 1,
    ACTIONS(4281), 3,
      sym__block_close,
      sym_list_marker_lower_alpha_period,
      sym__block_quote_continuation,
  [34250] = 1,
    ACTIONS(2473), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [34256] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_upper_roman_paren,
      sym__block_quote_continuation,
  [34262] = 1,
    ACTIONS(4283), 3,
      sym__block_close,
      sym_list_marker_plus,
      sym__block_quote_continuation,
  [34268] = 1,
    ACTIONS(2473), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [34274] = 1,
    ACTIONS(4285), 3,
      sym__block_close,
      sym_list_marker_upper_roman_parens,
      sym__block_quote_continuation,
  [34280] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_decimal_period,
    ACTIONS(4287), 1,
      sym__block_quote_continuation,
    STATE(1542), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34290] = 1,
    ACTIONS(4290), 3,
      sym__block_close,
      sym_list_marker_upper_roman_paren,
      sym__block_quote_continuation,
  [34296] = 2,
    ACTIONS(4294), 1,
      anon_sym_SPACE,
    ACTIONS(4292), 2,
      anon_sym_x,
      anon_sym_X,
  [34304] = 1,
    ACTIONS(4296), 3,
      sym__block_close,
      sym_list_marker_decimal_parens,
      sym__block_quote_continuation,
  [34310] = 1,
    ACTIONS(2661), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [34316] = 1,
    ACTIONS(4298), 3,
      sym__block_close,
      sym_list_marker_upper_roman_period,
      sym__block_quote_continuation,
  [34322] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_decimal_parens,
      sym__block_quote_continuation,
  [34328] = 3,
    ACTIONS(4300), 1,
      anon_sym_DQUOTE,
    ACTIONS(4302), 1,
      aux_sym_value_token2,
    STATE(1160), 1,
      sym_value,
  [34338] = 1,
    ACTIONS(4304), 3,
      sym__block_close,
      sym_list_marker_star,
      sym__block_quote_continuation,
  [34344] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_upper_alpha_period,
    ACTIONS(4306), 1,
      sym__block_quote_continuation,
    STATE(1551), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34354] = 2,
    STATE(1357), 1,
      aux_sym__inline_link_url,
    ACTIONS(4309), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [34362] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_dash,
    ACTIONS(3382), 1,
      sym__block_quote_continuation,
    STATE(1575), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34372] = 3,
    ACTIONS(4177), 1,
      sym__newline_inline,
    ACTIONS(4311), 1,
      sym__eof_or_newline,
    STATE(1619), 1,
      aux_sym__paragraph_content_repeat1,
  [34382] = 3,
    ACTIONS(4177), 1,
      sym__newline_inline,
    ACTIONS(4313), 1,
      sym__eof_or_newline,
    STATE(1554), 1,
      aux_sym__paragraph_content_repeat1,
  [34392] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_lower_alpha_period,
    ACTIONS(3410), 1,
      sym__block_quote_continuation,
    STATE(1593), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34402] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_decimal_parens,
    ACTIONS(4315), 1,
      sym__block_quote_continuation,
    STATE(1557), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34412] = 3,
    ACTIONS(2685), 1,
      aux_sym__line_token1,
    ACTIONS(3292), 1,
      sym__block_quote_continuation,
    STATE(1560), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34422] = 1,
    ACTIONS(4318), 3,
      sym__block_close,
      sym_list_marker_decimal_period,
      sym__block_quote_continuation,
  [34428] = 3,
    ACTIONS(2675), 1,
      aux_sym__line_token1,
    ACTIONS(4320), 1,
      sym__block_quote_continuation,
    STATE(1560), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34438] = 2,
    STATE(1360), 1,
      aux_sym__inline_link_url,
    ACTIONS(4323), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [34446] = 1,
    ACTIONS(4325), 3,
      sym__block_close,
      sym_list_marker_decimal_period,
      sym__block_quote_continuation,
  [34452] = 1,
    ACTIONS(2641), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [34458] = 1,
    ACTIONS(4327), 3,
      sym__block_close,
      sym_list_marker_upper_alpha_period,
      sym__block_quote_continuation,
  [34464] = 1,
    ACTIONS(4329), 3,
      sym__block_close,
      sym_list_marker_lower_roman_period,
      sym__block_quote_continuation,
  [34470] = 1,
    ACTIONS(4331), 3,
      sym__block_close,
      sym_list_marker_upper_roman_period,
      sym__block_quote_continuation,
  [34476] = 1,
    ACTIONS(4333), 3,
      sym__block_close,
      sym_list_marker_decimal_paren,
      sym__block_quote_continuation,
  [34482] = 1,
    ACTIONS(4335), 3,
      sym__block_close,
      sym_list_marker_lower_alpha_period,
      sym__block_quote_continuation,
  [34488] = 1,
    ACTIONS(4337), 3,
      sym__block_close,
      sym_list_marker_lower_alpha_paren,
      sym__block_quote_continuation,
  [34494] = 2,
    STATE(1361), 1,
      aux_sym__inline_link_url,
    ACTIONS(4339), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [34502] = 1,
    ACTIONS(4341), 3,
      sym__block_close,
      sym_list_marker_upper_alpha_paren,
      sym__block_quote_continuation,
  [34508] = 1,
    ACTIONS(2601), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [34514] = 1,
    ACTIONS(4343), 3,
      sym__block_quote_continuation,
      sym__footnote_continuation,
      sym__footnote_end,
  [34520] = 1,
    ACTIONS(2601), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [34526] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_dash,
    ACTIONS(4345), 1,
      sym__block_quote_continuation,
    STATE(1575), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34536] = 1,
    ACTIONS(4348), 3,
      sym__block_close,
      sym_list_marker_lower_alpha_period,
      sym__block_quote_continuation,
  [34542] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_dash,
      sym__block_quote_continuation,
  [34548] = 2,
    ACTIONS(4350), 1,
      sym__eof_or_newline,
    ACTIONS(2353), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [34556] = 2,
    STATE(1364), 1,
      aux_sym__inline_link_url,
    ACTIONS(4352), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [34564] = 1,
    ACTIONS(2483), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [34570] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_upper_roman_paren,
      sym__block_quote_continuation,
  [34576] = 3,
    ACTIONS(2685), 1,
      sym__list_item_continuation,
    ACTIONS(3738), 1,
      sym__block_quote_continuation,
    STATE(1584), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34586] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_upper_roman_period,
      sym__block_quote_continuation,
  [34592] = 3,
    ACTIONS(2675), 1,
      sym__list_item_continuation,
    ACTIONS(4354), 1,
      sym__block_quote_continuation,
    STATE(1584), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34602] = 3,
    ACTIONS(2675), 1,
      sym__list_marker_task_begin,
    ACTIONS(4357), 1,
      sym__block_quote_continuation,
    STATE(1585), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34612] = 3,
    ACTIONS(2685), 1,
      sym__footnote_continuation,
    ACTIONS(3750), 1,
      sym__block_quote_continuation,
    STATE(1592), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34622] = 2,
    ACTIONS(4360), 1,
      sym__div_end,
    ACTIONS(2397), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [34630] = 2,
    STATE(1367), 1,
      aux_sym__inline_link_url,
    ACTIONS(4362), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [34638] = 1,
    ACTIONS(4364), 3,
      sym__block_close,
      sym_list_marker_lower_roman_paren,
      sym__block_quote_continuation,
  [34644] = 2,
    ACTIONS(4366), 1,
      sym__code_block_end,
    ACTIONS(2437), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [34652] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_plus,
      sym__block_quote_continuation,
  [34658] = 3,
    ACTIONS(2675), 1,
      sym__footnote_continuation,
    ACTIONS(4368), 1,
      sym__block_quote_continuation,
    STATE(1592), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34668] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_lower_alpha_period,
    ACTIONS(4371), 1,
      sym__block_quote_continuation,
    STATE(1593), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34678] = 2,
    ACTIONS(4374), 1,
      sym__div_end,
    ACTIONS(2443), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [34686] = 2,
    ACTIONS(4376), 1,
      sym__div_end,
    ACTIONS(2365), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [34694] = 1,
    ACTIONS(4378), 3,
      sym__block_quote_continuation,
      sym__footnote_continuation,
      sym__footnote_end,
  [34700] = 2,
    STATE(1370), 1,
      aux_sym__inline_link_url,
    ACTIONS(4380), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [34708] = 1,
    ACTIONS(4382), 3,
      sym__block_close,
      sym_list_marker_upper_roman_paren,
      sym__block_quote_continuation,
  [34714] = 1,
    ACTIONS(4384), 3,
      sym__block_close,
      sym_list_marker_upper_roman_paren,
      sym__block_quote_continuation,
  [34720] = 1,
    ACTIONS(4386), 3,
      sym__block_close,
      sym_list_marker_decimal_parens,
      sym__block_quote_continuation,
  [34726] = 1,
    ACTIONS(4388), 3,
      sym__block_close,
      sym_list_marker_lower_alpha_parens,
      sym__block_quote_continuation,
  [34732] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_upper_alpha_period,
      sym__block_quote_continuation,
  [34738] = 1,
    ACTIONS(4187), 3,
      sym__block_close,
      sym_list_marker_lower_alpha_paren,
      sym__block_quote_continuation,
  [34744] = 1,
    ACTIONS(4390), 3,
      sym__block_close,
      sym_list_marker_upper_alpha_parens,
      sym__block_quote_continuation,
  [34750] = 1,
    ACTIONS(4392), 3,
      sym__block_close,
      sym_list_marker_lower_roman_parens,
      sym__block_quote_continuation,
  [34756] = 2,
    STATE(1372), 1,
      aux_sym__inline_link_url,
    ACTIONS(4394), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [34764] = 1,
    ACTIONS(4396), 3,
      sym__block_close,
      sym_list_marker_upper_roman_parens,
      sym__block_quote_continuation,
  [34770] = 2,
    ACTIONS(4398), 1,
      sym__code_block_end,
    ACTIONS(2375), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [34778] = 2,
    ACTIONS(4400), 1,
      sym__code_block_end,
    ACTIONS(2381), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [34786] = 2,
    ACTIONS(4402), 1,
      sym__code_block_end,
    ACTIONS(2387), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [34794] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_plus,
      sym__block_quote_continuation,
  [34800] = 1,
    ACTIONS(4404), 3,
      sym__block_close,
      sym__list_marker_task_begin,
      sym__block_quote_continuation,
  [34806] = 2,
    ACTIONS(4406), 1,
      sym__div_end,
    ACTIONS(2403), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [34814] = 3,
    ACTIONS(4177), 1,
      sym__newline_inline,
    ACTIONS(4408), 1,
      sym__eof_or_newline,
    STATE(1619), 1,
      aux_sym__paragraph_content_repeat1,
  [34824] = 2,
    STATE(1375), 1,
      aux_sym__inline_link_url,
    ACTIONS(4410), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [34832] = 1,
    ACTIONS(4412), 3,
      sym__block_close,
      sym_list_marker_upper_alpha_paren,
      sym__block_quote_continuation,
  [34838] = 2,
    ACTIONS(4414), 1,
      sym__code_block_end,
    ACTIONS(2411), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [34846] = 2,
    ACTIONS(4416), 1,
      sym__code_block_end,
    ACTIONS(2417), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [34854] = 3,
    ACTIONS(4418), 1,
      sym__eof_or_newline,
    ACTIONS(4420), 1,
      sym__newline_inline,
    STATE(1619), 1,
      aux_sym__paragraph_content_repeat1,
  [34864] = 1,
    ACTIONS(4423), 3,
      sym__block_close,
      sym_list_marker_upper_alpha_period,
      sym__block_quote_continuation,
  [34870] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_upper_alpha_parens,
    ACTIONS(3378), 1,
      sym__block_quote_continuation,
    STATE(1640), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34880] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_lower_alpha_period,
      sym__block_quote_continuation,
  [34886] = 1,
    ACTIONS(4425), 3,
      sym__block_close,
      sym_list_marker_lower_roman_period,
      sym__block_quote_continuation,
  [34892] = 2,
    STATE(1378), 1,
      aux_sym__inline_link_url,
    ACTIONS(4427), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [34900] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_decimal_parens,
    ACTIONS(3406), 1,
      sym__block_quote_continuation,
    STATE(1557), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34910] = 1,
    ACTIONS(4429), 3,
      sym__block_close,
      sym_list_marker_upper_roman_period,
      sym__block_quote_continuation,
  [34916] = 1,
    ACTIONS(4431), 3,
      sym__block_close,
      sym_list_marker_lower_alpha_paren,
      sym__block_quote_continuation,
  [34922] = 1,
    ACTIONS(4433), 3,
      sym__block_close,
      sym_list_marker_upper_alpha_parens,
      sym__block_quote_continuation,
  [34928] = 2,
    STATE(1407), 1,
      aux_sym__inline_link_url,
    ACTIONS(4435), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [34936] = 2,
    ACTIONS(4437), 1,
      anon_sym_LBRACK,
    ACTIONS(4439), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_LPAREN,
  [34944] = 2,
    ACTIONS(4441), 1,
      anon_sym_LBRACK,
    ACTIONS(4443), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_LPAREN,
  [34952] = 1,
    ACTIONS(4445), 3,
      sym__block_close,
      sym_list_marker_decimal_paren,
      sym__block_quote_continuation,
  [34958] = 1,
    ACTIONS(4447), 3,
      sym__block_close,
      sym_list_marker_upper_alpha_parens,
      sym__block_quote_continuation,
  [34964] = 1,
    ACTIONS(4449), 3,
      sym__block_close,
      sym_list_marker_lower_alpha_paren,
      sym__block_quote_continuation,
  [34970] = 3,
    ACTIONS(2685), 1,
      sym_list_marker_plus,
    ACTIONS(3386), 1,
      sym__block_quote_continuation,
    STATE(1639), 1,
      aux_sym__block_quote_prefix_repeat1,
  [34980] = 1,
    ACTIONS(4451), 3,
      sym__block_close,
      sym_list_marker_lower_roman_parens,
      sym__block_quote_continuation,
  [34986] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_lower_alpha_paren,
      sym__block_quote_continuation,
  [34992] = 1,
    ACTIONS(4191), 3,
      sym__block_close,
      sym_list_marker_upper_alpha_period,
      sym__block_quote_continuation,
  [34998] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_plus,
    ACTIONS(4453), 1,
      sym__block_quote_continuation,
    STATE(1639), 1,
      aux_sym__block_quote_prefix_repeat1,
  [35008] = 3,
    ACTIONS(2675), 1,
      sym_list_marker_upper_alpha_parens,
    ACTIONS(4456), 1,
      sym__block_quote_continuation,
    STATE(1640), 1,
      aux_sym__block_quote_prefix_repeat1,
  [35018] = 1,
    ACTIONS(4459), 3,
      sym__block_close,
      sym_list_marker_upper_alpha_paren,
      sym__block_quote_continuation,
  [35024] = 1,
    ACTIONS(2597), 3,
      sym__list_item_continuation,
      sym__list_item_end,
      sym__block_quote_continuation,
  [35030] = 2,
    STATE(1365), 1,
      aux_sym__inline_link_url,
    ACTIONS(4461), 2,
      sym__newline_inline,
      aux_sym__inline_link_url_token1,
  [35038] = 2,
    ACTIONS(4463), 1,
      sym__highlighted_mark_begin,
    ACTIONS(4466), 1,
      sym__in_fallback,
  [35045] = 1,
    ACTIONS(2609), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35050] = 2,
    ACTIONS(4468), 1,
      sym__curly_bracket_span_mark_begin,
    ACTIONS(4471), 1,
      sym__in_fallback,
  [35057] = 2,
    ACTIONS(4473), 1,
      anon_sym_LBRACK_CARET,
    STATE(1702), 1,
      sym_footnote_marker_begin,
  [35064] = 1,
    ACTIONS(2615), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35069] = 2,
    ACTIONS(4475), 1,
      sym__whitespace1,
    ACTIONS(4477), 1,
      sym__newline,
  [35076] = 2,
    ACTIONS(4479), 1,
      sym__emphasis_mark_begin,
    ACTIONS(4482), 1,
      sym__in_fallback,
  [35083] = 2,
    ACTIONS(4482), 1,
      sym__in_fallback,
    ACTIONS(4484), 1,
      sym__strong_mark_begin,
  [35090] = 1,
    ACTIONS(2477), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35095] = 1,
    ACTIONS(657), 2,
      sym_list_marker_lower_alpha_paren,
      sym__block_quote_continuation,
  [35100] = 2,
    ACTIONS(4487), 1,
      sym__emphasis_mark_begin,
    ACTIONS(4490), 1,
      sym__in_fallback,
  [35107] = 2,
    ACTIONS(4492), 1,
      sym__whitespace1,
    ACTIONS(4494), 1,
      sym__newline,
  [35114] = 2,
    ACTIONS(4490), 1,
      sym__in_fallback,
    ACTIONS(4496), 1,
      sym__strong_mark_begin,
  [35121] = 1,
    ACTIONS(4499), 2,
      sym__eof_or_newline,
      sym__close_paragraph,
  [35126] = 2,
    ACTIONS(4501), 1,
      sym__eof_or_newline,
    ACTIONS(4503), 1,
      sym__close_paragraph,
  [35133] = 1,
    ACTIONS(657), 2,
      sym__list_marker_task_begin,
      sym__block_quote_continuation,
  [35138] = 1,
    ACTIONS(2601), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35143] = 2,
    ACTIONS(4505), 1,
      sym__whitespace1,
    ACTIONS(4507), 1,
      sym__newline,
  [35150] = 1,
    ACTIONS(2601), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35155] = 1,
    ACTIONS(4509), 2,
      sym__eof_or_newline,
      sym__newline_inline,
  [35160] = 1,
    ACTIONS(4511), 2,
      sym__eof_or_newline,
      sym__close_paragraph,
  [35165] = 2,
    ACTIONS(4513), 1,
      sym__square_bracket_span_mark_begin,
    ACTIONS(4516), 1,
      sym__in_fallback,
  [35172] = 2,
    ACTIONS(4516), 1,
      sym__in_fallback,
    ACTIONS(4518), 1,
      sym__emphasis_mark_begin,
  [35179] = 2,
    ACTIONS(4516), 1,
      sym__in_fallback,
    ACTIONS(4521), 1,
      sym__strong_mark_begin,
  [35186] = 2,
    ACTIONS(4516), 1,
      sym__in_fallback,
    ACTIONS(4524), 1,
      sym__superscript_mark_begin,
  [35193] = 2,
    ACTIONS(4516), 1,
      sym__in_fallback,
    ACTIONS(4527), 1,
      sym__subscript_mark_begin,
  [35200] = 2,
    ACTIONS(4516), 1,
      sym__in_fallback,
    ACTIONS(4530), 1,
      sym__highlighted_mark_begin,
  [35207] = 2,
    ACTIONS(4516), 1,
      sym__in_fallback,
    ACTIONS(4533), 1,
      sym__insert_mark_begin,
  [35214] = 2,
    ACTIONS(4516), 1,
      sym__in_fallback,
    ACTIONS(4536), 1,
      sym__delete_mark_begin,
  [35221] = 2,
    ACTIONS(4516), 1,
      sym__in_fallback,
    ACTIONS(4539), 1,
      sym__square_bracket_span_mark_begin,
  [35228] = 2,
    ACTIONS(4516), 1,
      sym__in_fallback,
    ACTIONS(4542), 1,
      sym__square_bracket_span_mark_begin,
  [35235] = 1,
    ACTIONS(4516), 2,
      sym__parens_span_mark_begin,
      sym__in_fallback,
  [35240] = 2,
    ACTIONS(4490), 1,
      sym__in_fallback,
    ACTIONS(4545), 1,
      sym__superscript_mark_begin,
  [35247] = 2,
    ACTIONS(4548), 1,
      sym__eof_or_newline,
    ACTIONS(4550), 1,
      sym__close_paragraph,
  [35254] = 1,
    ACTIONS(2569), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35259] = 2,
    ACTIONS(4490), 1,
      sym__in_fallback,
    ACTIONS(4552), 1,
      sym__subscript_mark_begin,
  [35266] = 1,
    ACTIONS(2597), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35271] = 1,
    ACTIONS(2605), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35276] = 1,
    ACTIONS(2617), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35281] = 1,
    ACTIONS(2621), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35286] = 1,
    ACTIONS(2629), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35291] = 1,
    ACTIONS(2633), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35296] = 1,
    ACTIONS(2637), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35301] = 1,
    ACTIONS(2641), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35306] = 1,
    ACTIONS(2645), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35311] = 1,
    ACTIONS(2649), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35316] = 1,
    ACTIONS(2653), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35321] = 1,
    ACTIONS(2657), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35326] = 1,
    ACTIONS(2661), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35331] = 1,
    ACTIONS(2665), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35336] = 2,
    ACTIONS(4555), 1,
      sym__curly_bracket_span_mark_begin,
    ACTIONS(4558), 1,
      sym__in_fallback,
  [35343] = 1,
    ACTIONS(657), 2,
      sym_list_marker_plus,
      sym__block_quote_continuation,
  [35348] = 2,
    ACTIONS(4560), 1,
      sym__emphasis_mark_begin,
    ACTIONS(4563), 1,
      sym__in_fallback,
  [35355] = 2,
    ACTIONS(4563), 1,
      sym__in_fallback,
    ACTIONS(4565), 1,
      sym__strong_mark_begin,
  [35362] = 1,
    ACTIONS(657), 2,
      sym_list_marker_lower_alpha_parens,
      sym__block_quote_continuation,
  [35367] = 1,
    ACTIONS(4568), 2,
      sym__eof_or_newline,
      sym__close_paragraph,
  [35372] = 2,
    ACTIONS(4490), 1,
      sym__in_fallback,
    ACTIONS(4570), 1,
      sym__highlighted_mark_begin,
  [35379] = 2,
    ACTIONS(4573), 1,
      sym__whitespace1,
    ACTIONS(4575), 1,
      sym__newline,
  [35386] = 2,
    ACTIONS(4577), 1,
      sym__id,
    STATE(2122), 1,
      sym_reference_label,
  [35393] = 1,
    ACTIONS(657), 2,
      sym_list_marker_decimal_period,
      sym__block_quote_continuation,
  [35398] = 2,
    ACTIONS(4579), 1,
      sym__square_bracket_span_mark_begin,
    ACTIONS(4582), 1,
      sym__in_fallback,
  [35405] = 2,
    ACTIONS(4582), 1,
      sym__in_fallback,
    ACTIONS(4584), 1,
      sym__emphasis_mark_begin,
  [35412] = 2,
    ACTIONS(4582), 1,
      sym__in_fallback,
    ACTIONS(4587), 1,
      sym__strong_mark_begin,
  [35419] = 2,
    ACTIONS(4582), 1,
      sym__in_fallback,
    ACTIONS(4590), 1,
      sym__superscript_mark_begin,
  [35426] = 2,
    ACTIONS(4582), 1,
      sym__in_fallback,
    ACTIONS(4593), 1,
      sym__subscript_mark_begin,
  [35433] = 2,
    ACTIONS(4582), 1,
      sym__in_fallback,
    ACTIONS(4596), 1,
      sym__highlighted_mark_begin,
  [35440] = 2,
    ACTIONS(4582), 1,
      sym__in_fallback,
    ACTIONS(4599), 1,
      sym__insert_mark_begin,
  [35447] = 2,
    ACTIONS(4582), 1,
      sym__in_fallback,
    ACTIONS(4602), 1,
      sym__delete_mark_begin,
  [35454] = 2,
    ACTIONS(4582), 1,
      sym__in_fallback,
    ACTIONS(4605), 1,
      sym__square_bracket_span_mark_begin,
  [35461] = 2,
    ACTIONS(4582), 1,
      sym__in_fallback,
    ACTIONS(4608), 1,
      sym__square_bracket_span_mark_begin,
  [35468] = 1,
    ACTIONS(4582), 2,
      sym__parens_span_mark_begin,
      sym__in_fallback,
  [35473] = 2,
    ACTIONS(4611), 1,
      sym__eof_or_newline,
    ACTIONS(4613), 1,
      sym__close_paragraph,
  [35480] = 1,
    ACTIONS(4615), 2,
      sym__block_close,
      sym__heading_continuation,
  [35485] = 2,
    ACTIONS(3288), 1,
      aux_sym__line_token1,
    STATE(1530), 1,
      sym__line,
  [35492] = 2,
    ACTIONS(4617), 1,
      sym__id,
    STATE(2624), 1,
      sym_reference_label,
  [35499] = 2,
    ACTIONS(4619), 1,
      sym__curly_bracket_span_mark_begin,
    ACTIONS(4622), 1,
      sym__in_fallback,
  [35506] = 2,
    ACTIONS(4624), 1,
      sym__curly_bracket_span_mark_begin,
    ACTIONS(4627), 1,
      sym__in_fallback,
  [35513] = 1,
    ACTIONS(4629), 2,
      sym__block_close,
      sym_list_marker_definition,
  [35518] = 2,
    ACTIONS(4631), 1,
      sym__emphasis_mark_begin,
    ACTIONS(4634), 1,
      sym__in_fallback,
  [35525] = 2,
    ACTIONS(4634), 1,
      sym__in_fallback,
    ACTIONS(4636), 1,
      sym__strong_mark_begin,
  [35532] = 1,
    ACTIONS(657), 2,
      sym_list_marker_upper_alpha_period,
      sym__block_quote_continuation,
  [35537] = 2,
    ACTIONS(4639), 1,
      sym__whitespace1,
    ACTIONS(4641), 1,
      sym__newline,
  [35544] = 2,
    ACTIONS(4643), 1,
      sym__square_bracket_span_mark_begin,
    ACTIONS(4646), 1,
      sym__in_fallback,
  [35551] = 2,
    ACTIONS(4646), 1,
      sym__in_fallback,
    ACTIONS(4648), 1,
      sym__emphasis_mark_begin,
  [35558] = 2,
    ACTIONS(4646), 1,
      sym__in_fallback,
    ACTIONS(4651), 1,
      sym__strong_mark_begin,
  [35565] = 2,
    ACTIONS(4646), 1,
      sym__in_fallback,
    ACTIONS(4654), 1,
      sym__superscript_mark_begin,
  [35572] = 2,
    ACTIONS(4646), 1,
      sym__in_fallback,
    ACTIONS(4657), 1,
      sym__subscript_mark_begin,
  [35579] = 2,
    ACTIONS(4646), 1,
      sym__in_fallback,
    ACTIONS(4660), 1,
      sym__highlighted_mark_begin,
  [35586] = 2,
    ACTIONS(4646), 1,
      sym__in_fallback,
    ACTIONS(4663), 1,
      sym__insert_mark_begin,
  [35593] = 2,
    ACTIONS(4646), 1,
      sym__in_fallback,
    ACTIONS(4666), 1,
      sym__delete_mark_begin,
  [35600] = 2,
    ACTIONS(4646), 1,
      sym__in_fallback,
    ACTIONS(4669), 1,
      sym__square_bracket_span_mark_begin,
  [35607] = 2,
    ACTIONS(4646), 1,
      sym__in_fallback,
    ACTIONS(4672), 1,
      sym__square_bracket_span_mark_begin,
  [35614] = 1,
    ACTIONS(4646), 2,
      sym__parens_span_mark_begin,
      sym__in_fallback,
  [35619] = 2,
    ACTIONS(4675), 1,
      sym__curly_bracket_span_mark_begin,
    ACTIONS(4678), 1,
      sym__in_fallback,
  [35626] = 2,
    ACTIONS(4680), 1,
      sym__emphasis_mark_begin,
    ACTIONS(4683), 1,
      sym__in_fallback,
  [35633] = 2,
    ACTIONS(4683), 1,
      sym__in_fallback,
    ACTIONS(4685), 1,
      sym__strong_mark_begin,
  [35640] = 1,
    ACTIONS(4629), 2,
      sym__block_close,
      sym_list_marker_definition,
  [35645] = 1,
    ACTIONS(3076), 2,
      sym__block_close,
      sym__heading_continuation,
  [35650] = 1,
    ACTIONS(4015), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [35655] = 2,
    ACTIONS(2353), 1,
      sym__indented_content_spacer,
    ACTIONS(4688), 1,
      sym__eof_or_newline,
  [35662] = 2,
    ACTIONS(4690), 1,
      sym__square_bracket_span_mark_begin,
    ACTIONS(4693), 1,
      sym__in_fallback,
  [35669] = 2,
    ACTIONS(4693), 1,
      sym__in_fallback,
    ACTIONS(4695), 1,
      sym__emphasis_mark_begin,
  [35676] = 2,
    ACTIONS(4693), 1,
      sym__in_fallback,
    ACTIONS(4698), 1,
      sym__strong_mark_begin,
  [35683] = 2,
    ACTIONS(4693), 1,
      sym__in_fallback,
    ACTIONS(4701), 1,
      sym__superscript_mark_begin,
  [35690] = 2,
    ACTIONS(4693), 1,
      sym__in_fallback,
    ACTIONS(4704), 1,
      sym__subscript_mark_begin,
  [35697] = 2,
    ACTIONS(4693), 1,
      sym__in_fallback,
    ACTIONS(4707), 1,
      sym__highlighted_mark_begin,
  [35704] = 2,
    ACTIONS(4693), 1,
      sym__in_fallback,
    ACTIONS(4710), 1,
      sym__insert_mark_begin,
  [35711] = 2,
    ACTIONS(4693), 1,
      sym__in_fallback,
    ACTIONS(4713), 1,
      sym__delete_mark_begin,
  [35718] = 2,
    ACTIONS(4693), 1,
      sym__in_fallback,
    ACTIONS(4716), 1,
      sym__square_bracket_span_mark_begin,
  [35725] = 2,
    ACTIONS(4693), 1,
      sym__in_fallback,
    ACTIONS(4719), 1,
      sym__square_bracket_span_mark_begin,
  [35732] = 1,
    ACTIONS(4693), 2,
      sym__parens_span_mark_begin,
      sym__in_fallback,
  [35737] = 1,
    ACTIONS(657), 2,
      sym_list_marker_decimal_paren,
      sym__block_quote_continuation,
  [35742] = 2,
    ACTIONS(4722), 1,
      sym__id,
    STATE(1136), 1,
      sym_class_name,
  [35749] = 2,
    ACTIONS(4724), 1,
      sym__curly_bracket_span_mark_begin,
    ACTIONS(4727), 1,
      sym__in_fallback,
  [35756] = 2,
    ACTIONS(4729), 1,
      sym__emphasis_mark_begin,
    ACTIONS(4732), 1,
      sym__in_fallback,
  [35763] = 2,
    ACTIONS(4732), 1,
      sym__in_fallback,
    ACTIONS(4734), 1,
      sym__strong_mark_begin,
  [35770] = 2,
    ACTIONS(4737), 1,
      sym__square_bracket_span_mark_begin,
    ACTIONS(4740), 1,
      sym__in_fallback,
  [35777] = 2,
    ACTIONS(4740), 1,
      sym__in_fallback,
    ACTIONS(4742), 1,
      sym__emphasis_mark_begin,
  [35784] = 2,
    ACTIONS(4740), 1,
      sym__in_fallback,
    ACTIONS(4745), 1,
      sym__strong_mark_begin,
  [35791] = 2,
    ACTIONS(4740), 1,
      sym__in_fallback,
    ACTIONS(4748), 1,
      sym__superscript_mark_begin,
  [35798] = 2,
    ACTIONS(4740), 1,
      sym__in_fallback,
    ACTIONS(4751), 1,
      sym__subscript_mark_begin,
  [35805] = 2,
    ACTIONS(4740), 1,
      sym__in_fallback,
    ACTIONS(4754), 1,
      sym__highlighted_mark_begin,
  [35812] = 2,
    ACTIONS(4740), 1,
      sym__in_fallback,
    ACTIONS(4757), 1,
      sym__insert_mark_begin,
  [35819] = 2,
    ACTIONS(4740), 1,
      sym__in_fallback,
    ACTIONS(4760), 1,
      sym__delete_mark_begin,
  [35826] = 2,
    ACTIONS(4740), 1,
      sym__in_fallback,
    ACTIONS(4763), 1,
      sym__square_bracket_span_mark_begin,
  [35833] = 2,
    ACTIONS(4740), 1,
      sym__in_fallback,
    ACTIONS(4766), 1,
      sym__square_bracket_span_mark_begin,
  [35840] = 1,
    ACTIONS(4740), 2,
      sym__parens_span_mark_begin,
      sym__in_fallback,
  [35845] = 2,
    ACTIONS(4769), 1,
      sym__curly_bracket_span_mark_begin,
    ACTIONS(4772), 1,
      sym__in_fallback,
  [35852] = 2,
    ACTIONS(4774), 1,
      sym__emphasis_mark_begin,
    ACTIONS(4777), 1,
      sym__in_fallback,
  [35859] = 2,
    ACTIONS(4777), 1,
      sym__in_fallback,
    ACTIONS(4779), 1,
      sym__strong_mark_begin,
  [35866] = 2,
    ACTIONS(4782), 1,
      sym__square_bracket_span_mark_begin,
    ACTIONS(4785), 1,
      sym__in_fallback,
  [35873] = 2,
    ACTIONS(4785), 1,
      sym__in_fallback,
    ACTIONS(4787), 1,
      sym__emphasis_mark_begin,
  [35880] = 2,
    ACTIONS(4785), 1,
      sym__in_fallback,
    ACTIONS(4790), 1,
      sym__strong_mark_begin,
  [35887] = 2,
    ACTIONS(4785), 1,
      sym__in_fallback,
    ACTIONS(4793), 1,
      sym__superscript_mark_begin,
  [35894] = 2,
    ACTIONS(4785), 1,
      sym__in_fallback,
    ACTIONS(4796), 1,
      sym__subscript_mark_begin,
  [35901] = 2,
    ACTIONS(4785), 1,
      sym__in_fallback,
    ACTIONS(4799), 1,
      sym__highlighted_mark_begin,
  [35908] = 2,
    ACTIONS(4785), 1,
      sym__in_fallback,
    ACTIONS(4802), 1,
      sym__insert_mark_begin,
  [35915] = 2,
    ACTIONS(4785), 1,
      sym__in_fallback,
    ACTIONS(4805), 1,
      sym__delete_mark_begin,
  [35922] = 2,
    ACTIONS(4785), 1,
      sym__in_fallback,
    ACTIONS(4808), 1,
      sym__square_bracket_span_mark_begin,
  [35929] = 2,
    ACTIONS(4785), 1,
      sym__in_fallback,
    ACTIONS(4811), 1,
      sym__square_bracket_span_mark_begin,
  [35936] = 1,
    ACTIONS(4785), 2,
      sym__parens_span_mark_begin,
      sym__in_fallback,
  [35941] = 2,
    ACTIONS(2397), 1,
      sym__indented_content_spacer,
    ACTIONS(4814), 1,
      sym__div_end,
  [35948] = 2,
    ACTIONS(4816), 1,
      sym__curly_bracket_span_mark_begin,
    ACTIONS(4819), 1,
      sym__in_fallback,
  [35955] = 2,
    ACTIONS(4821), 1,
      sym__emphasis_mark_begin,
    ACTIONS(4824), 1,
      sym__in_fallback,
  [35962] = 2,
    ACTIONS(4824), 1,
      sym__in_fallback,
    ACTIONS(4826), 1,
      sym__strong_mark_begin,
  [35969] = 2,
    ACTIONS(2437), 1,
      sym__indented_content_spacer,
    ACTIONS(4829), 1,
      sym__code_block_end,
  [35976] = 2,
    ACTIONS(4831), 1,
      sym_language,
    ACTIONS(4833), 1,
      sym__newline,
  [35983] = 2,
    ACTIONS(4835), 1,
      sym__square_bracket_span_mark_begin,
    ACTIONS(4838), 1,
      sym__in_fallback,
  [35990] = 2,
    ACTIONS(4838), 1,
      sym__in_fallback,
    ACTIONS(4840), 1,
      sym__emphasis_mark_begin,
  [35997] = 2,
    ACTIONS(4838), 1,
      sym__in_fallback,
    ACTIONS(4843), 1,
      sym__strong_mark_begin,
  [36004] = 2,
    ACTIONS(4838), 1,
      sym__in_fallback,
    ACTIONS(4846), 1,
      sym__superscript_mark_begin,
  [36011] = 2,
    ACTIONS(4838), 1,
      sym__in_fallback,
    ACTIONS(4849), 1,
      sym__subscript_mark_begin,
  [36018] = 2,
    ACTIONS(4838), 1,
      sym__in_fallback,
    ACTIONS(4852), 1,
      sym__highlighted_mark_begin,
  [36025] = 2,
    ACTIONS(4838), 1,
      sym__in_fallback,
    ACTIONS(4855), 1,
      sym__insert_mark_begin,
  [36032] = 2,
    ACTIONS(4838), 1,
      sym__in_fallback,
    ACTIONS(4858), 1,
      sym__delete_mark_begin,
  [36039] = 2,
    ACTIONS(4838), 1,
      sym__in_fallback,
    ACTIONS(4861), 1,
      sym__square_bracket_span_mark_begin,
  [36046] = 2,
    ACTIONS(4838), 1,
      sym__in_fallback,
    ACTIONS(4864), 1,
      sym__square_bracket_span_mark_begin,
  [36053] = 1,
    ACTIONS(4838), 2,
      sym__parens_span_mark_begin,
      sym__in_fallback,
  [36058] = 2,
    ACTIONS(4867), 1,
      sym__curly_bracket_span_mark_begin,
    ACTIONS(4870), 1,
      sym__in_fallback,
  [36065] = 2,
    ACTIONS(4872), 1,
      sym__emphasis_mark_begin,
    ACTIONS(4875), 1,
      sym__in_fallback,
  [36072] = 2,
    ACTIONS(4875), 1,
      sym__in_fallback,
    ACTIONS(4877), 1,
      sym__strong_mark_begin,
  [36079] = 1,
    ACTIONS(657), 2,
      sym_list_marker_upper_alpha_paren,
      sym__block_quote_continuation,
  [36084] = 1,
    ACTIONS(4880), 2,
      sym__eof_or_newline,
      sym__close_paragraph,
  [36089] = 1,
    ACTIONS(4882), 2,
      sym__eof_or_newline,
      sym__newline_inline,
  [36094] = 2,
    ACTIONS(2443), 1,
      sym__indented_content_spacer,
    ACTIONS(4884), 1,
      sym__div_end,
  [36101] = 2,
    ACTIONS(2365), 1,
      sym__indented_content_spacer,
    ACTIONS(4886), 1,
      sym__div_end,
  [36108] = 2,
    ACTIONS(4888), 1,
      sym__square_bracket_span_mark_begin,
    ACTIONS(4891), 1,
      sym__in_fallback,
  [36115] = 2,
    ACTIONS(4891), 1,
      sym__in_fallback,
    ACTIONS(4893), 1,
      sym__emphasis_mark_begin,
  [36122] = 2,
    ACTIONS(4891), 1,
      sym__in_fallback,
    ACTIONS(4896), 1,
      sym__strong_mark_begin,
  [36129] = 2,
    ACTIONS(4891), 1,
      sym__in_fallback,
    ACTIONS(4899), 1,
      sym__superscript_mark_begin,
  [36136] = 2,
    ACTIONS(4891), 1,
      sym__in_fallback,
    ACTIONS(4902), 1,
      sym__subscript_mark_begin,
  [36143] = 2,
    ACTIONS(4891), 1,
      sym__in_fallback,
    ACTIONS(4905), 1,
      sym__highlighted_mark_begin,
  [36150] = 2,
    ACTIONS(4891), 1,
      sym__in_fallback,
    ACTIONS(4908), 1,
      sym__insert_mark_begin,
  [36157] = 2,
    ACTIONS(4891), 1,
      sym__in_fallback,
    ACTIONS(4911), 1,
      sym__delete_mark_begin,
  [36164] = 2,
    ACTIONS(4891), 1,
      sym__in_fallback,
    ACTIONS(4914), 1,
      sym__square_bracket_span_mark_begin,
  [36171] = 2,
    ACTIONS(4891), 1,
      sym__in_fallback,
    ACTIONS(4917), 1,
      sym__square_bracket_span_mark_begin,
  [36178] = 1,
    ACTIONS(4891), 2,
      sym__parens_span_mark_begin,
      sym__in_fallback,
  [36183] = 1,
    ACTIONS(657), 2,
      sym_list_marker_upper_alpha_parens,
      sym__block_quote_continuation,
  [36188] = 2,
    ACTIONS(4920), 1,
      sym__curly_bracket_span_mark_begin,
    ACTIONS(4923), 1,
      sym__in_fallback,
  [36195] = 2,
    ACTIONS(4925), 1,
      sym__emphasis_mark_begin,
    ACTIONS(4928), 1,
      sym__in_fallback,
  [36202] = 2,
    ACTIONS(4928), 1,
      sym__in_fallback,
    ACTIONS(4930), 1,
      sym__strong_mark_begin,
  [36209] = 1,
    ACTIONS(657), 2,
      sym_list_marker_lower_roman_period,
      sym__block_quote_continuation,
  [36214] = 2,
    ACTIONS(4933), 1,
      sym__square_bracket_span_mark_begin,
    ACTIONS(4936), 1,
      sym__in_fallback,
  [36221] = 2,
    ACTIONS(4936), 1,
      sym__in_fallback,
    ACTIONS(4938), 1,
      sym__emphasis_mark_begin,
  [36228] = 1,
    ACTIONS(2577), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36233] = 2,
    ACTIONS(4936), 1,
      sym__in_fallback,
    ACTIONS(4941), 1,
      sym__superscript_mark_begin,
  [36240] = 2,
    ACTIONS(4936), 1,
      sym__in_fallback,
    ACTIONS(4944), 1,
      sym__subscript_mark_begin,
  [36247] = 2,
    ACTIONS(4936), 1,
      sym__in_fallback,
    ACTIONS(4947), 1,
      sym__highlighted_mark_begin,
  [36254] = 2,
    ACTIONS(4936), 1,
      sym__in_fallback,
    ACTIONS(4950), 1,
      sym__insert_mark_begin,
  [36261] = 2,
    ACTIONS(4936), 1,
      sym__in_fallback,
    ACTIONS(4953), 1,
      sym__delete_mark_begin,
  [36268] = 2,
    ACTIONS(4936), 1,
      sym__in_fallback,
    ACTIONS(4956), 1,
      sym__square_bracket_span_mark_begin,
  [36275] = 2,
    ACTIONS(4936), 1,
      sym__in_fallback,
    ACTIONS(4959), 1,
      sym__square_bracket_span_mark_begin,
  [36282] = 1,
    ACTIONS(4936), 2,
      sym__parens_span_mark_begin,
      sym__in_fallback,
  [36287] = 2,
    ACTIONS(4962), 1,
      sym__curly_bracket_span_mark_begin,
    ACTIONS(4965), 1,
      sym__in_fallback,
  [36294] = 2,
    ACTIONS(4967), 1,
      sym__emphasis_mark_begin,
    ACTIONS(4970), 1,
      sym__in_fallback,
  [36301] = 2,
    ACTIONS(4970), 1,
      sym__in_fallback,
    ACTIONS(4972), 1,
      sym__strong_mark_begin,
  [36308] = 1,
    ACTIONS(657), 2,
      sym_list_marker_lower_roman_paren,
      sym__block_quote_continuation,
  [36313] = 1,
    ACTIONS(657), 2,
      sym_list_marker_lower_roman_parens,
      sym__block_quote_continuation,
  [36318] = 2,
    ACTIONS(4975), 1,
      sym__square_bracket_span_mark_begin,
    ACTIONS(4978), 1,
      sym__in_fallback,
  [36325] = 2,
    ACTIONS(4978), 1,
      sym__in_fallback,
    ACTIONS(4980), 1,
      sym__emphasis_mark_begin,
  [36332] = 2,
    ACTIONS(4978), 1,
      sym__in_fallback,
    ACTIONS(4983), 1,
      sym__strong_mark_begin,
  [36339] = 2,
    ACTIONS(4978), 1,
      sym__in_fallback,
    ACTIONS(4986), 1,
      sym__superscript_mark_begin,
  [36346] = 2,
    ACTIONS(4978), 1,
      sym__in_fallback,
    ACTIONS(4989), 1,
      sym__subscript_mark_begin,
  [36353] = 2,
    ACTIONS(4978), 1,
      sym__in_fallback,
    ACTIONS(4992), 1,
      sym__highlighted_mark_begin,
  [36360] = 2,
    ACTIONS(4978), 1,
      sym__in_fallback,
    ACTIONS(4995), 1,
      sym__insert_mark_begin,
  [36367] = 2,
    ACTIONS(4978), 1,
      sym__in_fallback,
    ACTIONS(4998), 1,
      sym__delete_mark_begin,
  [36374] = 2,
    ACTIONS(4978), 1,
      sym__in_fallback,
    ACTIONS(5001), 1,
      sym__square_bracket_span_mark_begin,
  [36381] = 2,
    ACTIONS(4978), 1,
      sym__in_fallback,
    ACTIONS(5004), 1,
      sym__square_bracket_span_mark_begin,
  [36388] = 1,
    ACTIONS(4978), 2,
      sym__parens_span_mark_begin,
      sym__in_fallback,
  [36393] = 2,
    ACTIONS(5007), 1,
      sym__emphasis_mark_begin,
    ACTIONS(5010), 1,
      sym__in_fallback,
  [36400] = 2,
    ACTIONS(5010), 1,
      sym__in_fallback,
    ACTIONS(5012), 1,
      sym__strong_mark_begin,
  [36407] = 2,
    ACTIONS(5015), 1,
      sym__curly_bracket_span_mark_begin,
    ACTIONS(5018), 1,
      sym__in_fallback,
  [36414] = 2,
    ACTIONS(5020), 1,
      sym__emphasis_mark_begin,
    ACTIONS(5023), 1,
      sym__in_fallback,
  [36421] = 2,
    ACTIONS(5023), 1,
      sym__in_fallback,
    ACTIONS(5025), 1,
      sym__strong_mark_begin,
  [36428] = 2,
    ACTIONS(2375), 1,
      sym__indented_content_spacer,
    ACTIONS(5028), 1,
      sym__code_block_end,
  [36435] = 2,
    ACTIONS(2381), 1,
      sym__indented_content_spacer,
    ACTIONS(5030), 1,
      sym__code_block_end,
  [36442] = 1,
    ACTIONS(657), 2,
      sym_list_marker_upper_roman_period,
      sym__block_quote_continuation,
  [36447] = 2,
    ACTIONS(2387), 1,
      sym__indented_content_spacer,
    ACTIONS(5032), 1,
      sym__code_block_end,
  [36454] = 1,
    ACTIONS(5034), 2,
      sym__table_row_end_newline,
      aux_sym__table_cell_alignment_token1,
  [36459] = 1,
    ACTIONS(657), 2,
      sym_list_marker_star,
      sym__block_quote_continuation,
  [36464] = 1,
    ACTIONS(657), 2,
      sym_list_marker_upper_roman_paren,
      sym__block_quote_continuation,
  [36469] = 1,
    ACTIONS(657), 2,
      sym_list_marker_decimal_parens,
      sym__block_quote_continuation,
  [36474] = 1,
    ACTIONS(657), 2,
      sym_list_marker_upper_roman_parens,
      sym__block_quote_continuation,
  [36479] = 2,
    ACTIONS(2403), 1,
      sym__indented_content_spacer,
    ACTIONS(5036), 1,
      sym__div_end,
  [36486] = 2,
    ACTIONS(4722), 1,
      sym__id,
    STATE(1987), 1,
      sym_class_name,
  [36493] = 2,
    ACTIONS(2411), 1,
      sym__indented_content_spacer,
    ACTIONS(5038), 1,
      sym__code_block_end,
  [36500] = 2,
    ACTIONS(2417), 1,
      sym__indented_content_spacer,
    ACTIONS(5040), 1,
      sym__code_block_end,
  [36507] = 1,
    ACTIONS(657), 2,
      sym__block_quote_continuation,
      aux_sym__line_token1,
  [36512] = 2,
    ACTIONS(67), 1,
      sym__list_marker_task_begin,
    STATE(41), 1,
      sym_list_marker_task,
  [36519] = 1,
    ACTIONS(5042), 2,
      sym__block_close,
      sym_list_marker_definition,
  [36524] = 1,
    ACTIONS(657), 2,
      sym__list_item_continuation,
      sym__block_quote_continuation,
  [36529] = 1,
    ACTIONS(657), 2,
      sym__block_quote_continuation,
      sym__footnote_continuation,
  [36534] = 2,
    ACTIONS(4617), 1,
      sym__id,
    STATE(2368), 1,
      sym_reference_label,
  [36541] = 2,
    ACTIONS(5044), 1,
      anon_sym_PERCENT,
    STATE(2385), 1,
      sym__comment,
  [36548] = 2,
    ACTIONS(5046), 1,
      sym__square_bracket_span_mark_begin,
    ACTIONS(5049), 1,
      sym__in_fallback,
  [36555] = 2,
    ACTIONS(5049), 1,
      sym__in_fallback,
    ACTIONS(5051), 1,
      sym__emphasis_mark_begin,
  [36562] = 2,
    ACTIONS(5049), 1,
      sym__in_fallback,
    ACTIONS(5054), 1,
      sym__strong_mark_begin,
  [36569] = 2,
    ACTIONS(5049), 1,
      sym__in_fallback,
    ACTIONS(5057), 1,
      sym__superscript_mark_begin,
  [36576] = 2,
    ACTIONS(5049), 1,
      sym__in_fallback,
    ACTIONS(5060), 1,
      sym__subscript_mark_begin,
  [36583] = 2,
    ACTIONS(5049), 1,
      sym__in_fallback,
    ACTIONS(5063), 1,
      sym__highlighted_mark_begin,
  [36590] = 2,
    ACTIONS(5049), 1,
      sym__in_fallback,
    ACTIONS(5066), 1,
      sym__insert_mark_begin,
  [36597] = 2,
    ACTIONS(5049), 1,
      sym__in_fallback,
    ACTIONS(5069), 1,
      sym__delete_mark_begin,
  [36604] = 2,
    ACTIONS(5049), 1,
      sym__in_fallback,
    ACTIONS(5072), 1,
      sym__square_bracket_span_mark_begin,
  [36611] = 2,
    ACTIONS(5049), 1,
      sym__in_fallback,
    ACTIONS(5075), 1,
      sym__square_bracket_span_mark_begin,
  [36618] = 1,
    ACTIONS(5049), 2,
      sym__parens_span_mark_begin,
      sym__in_fallback,
  [36623] = 2,
    ACTIONS(4617), 1,
      sym__id,
    STATE(2302), 1,
      sym_reference_label,
  [36630] = 2,
    ACTIONS(5044), 1,
      anon_sym_PERCENT,
    STATE(2392), 1,
      sym__comment,
  [36637] = 2,
    ACTIONS(5078), 1,
      sym__eof_or_newline,
    ACTIONS(5080), 1,
      sym__close_paragraph,
  [36644] = 1,
    ACTIONS(4267), 2,
      sym_frontmatter_marker,
      aux_sym__line_token1,
  [36649] = 1,
    ACTIONS(657), 2,
      sym_list_marker_dash,
      sym__block_quote_continuation,
  [36654] = 2,
    ACTIONS(4490), 1,
      sym__in_fallback,
    ACTIONS(5082), 1,
      sym__insert_mark_begin,
  [36661] = 1,
    ACTIONS(2587), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36666] = 2,
    ACTIONS(4617), 1,
      sym__id,
    STATE(2006), 1,
      sym_reference_label,
  [36673] = 2,
    ACTIONS(5044), 1,
      anon_sym_PERCENT,
    STATE(2014), 1,
      sym__comment,
  [36680] = 2,
    ACTIONS(4490), 1,
      sym__in_fallback,
    ACTIONS(5085), 1,
      sym__delete_mark_begin,
  [36687] = 2,
    ACTIONS(5044), 1,
      anon_sym_PERCENT,
    STATE(2003), 1,
      sym__comment,
  [36694] = 2,
    ACTIONS(4490), 1,
      sym__in_fallback,
    ACTIONS(5088), 1,
      sym__square_bracket_span_mark_begin,
  [36701] = 1,
    ACTIONS(2595), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36706] = 1,
    ACTIONS(5091), 2,
      sym__block_close,
      sym_list_marker_definition,
  [36711] = 2,
    ACTIONS(5093), 1,
      sym__curly_bracket_span_mark_begin,
    ACTIONS(5096), 1,
      sym__in_fallback,
  [36718] = 2,
    ACTIONS(4617), 1,
      sym__id,
    STATE(2189), 1,
      sym_reference_label,
  [36725] = 1,
    ACTIONS(5091), 2,
      sym__block_close,
      sym_list_marker_definition,
  [36730] = 2,
    ACTIONS(5044), 1,
      anon_sym_PERCENT,
    STATE(2215), 1,
      sym__comment,
  [36737] = 2,
    ACTIONS(5098), 1,
      sym__id,
    STATE(1190), 1,
      sym_class_name,
  [36744] = 1,
    ACTIONS(2473), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36749] = 2,
    ACTIONS(5100), 1,
      sym__emphasis_mark_begin,
    ACTIONS(5103), 1,
      sym__in_fallback,
  [36756] = 2,
    ACTIONS(5103), 1,
      sym__in_fallback,
    ACTIONS(5105), 1,
      sym__strong_mark_begin,
  [36763] = 2,
    ACTIONS(4617), 1,
      sym__id,
    STATE(2376), 1,
      sym_reference_label,
  [36770] = 1,
    ACTIONS(2473), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36775] = 2,
    ACTIONS(5044), 1,
      anon_sym_PERCENT,
    STATE(2388), 1,
      sym__comment,
  [36782] = 1,
    ACTIONS(657), 2,
      sym_list_marker_lower_alpha_period,
      sym__block_quote_continuation,
  [36787] = 2,
    ACTIONS(4490), 1,
      sym__in_fallback,
    ACTIONS(5108), 1,
      sym__square_bracket_span_mark_begin,
  [36794] = 2,
    ACTIONS(5111), 1,
      sym__eof_or_newline,
    ACTIONS(5113), 1,
      sym__close_paragraph,
  [36801] = 2,
    ACTIONS(4617), 1,
      sym__id,
    STATE(2532), 1,
      sym_reference_label,
  [36808] = 2,
    ACTIONS(5044), 1,
      anon_sym_PERCENT,
    STATE(2572), 1,
      sym__comment,
  [36815] = 1,
    ACTIONS(2489), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36820] = 2,
    ACTIONS(4617), 1,
      sym__id,
    STATE(1997), 1,
      sym_reference_label,
  [36827] = 2,
    ACTIONS(5044), 1,
      anon_sym_PERCENT,
    STATE(2001), 1,
      sym__comment,
  [36834] = 1,
    ACTIONS(2493), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36839] = 1,
    ACTIONS(2497), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36844] = 1,
    ACTIONS(2501), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36849] = 2,
    ACTIONS(4617), 1,
      sym__id,
    STATE(2032), 1,
      sym_reference_label,
  [36856] = 1,
    ACTIONS(2505), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36861] = 2,
    ACTIONS(5044), 1,
      anon_sym_PERCENT,
    STATE(2036), 1,
      sym__comment,
  [36868] = 1,
    ACTIONS(2509), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36873] = 1,
    ACTIONS(2513), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36878] = 1,
    ACTIONS(2517), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36883] = 1,
    ACTIONS(2521), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36888] = 2,
    ACTIONS(4617), 1,
      sym__id,
    STATE(2067), 1,
      sym_reference_label,
  [36895] = 2,
    ACTIONS(5044), 1,
      anon_sym_PERCENT,
    STATE(2071), 1,
      sym__comment,
  [36902] = 1,
    ACTIONS(2525), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36907] = 2,
    ACTIONS(4617), 1,
      sym__id,
    STATE(2102), 1,
      sym_reference_label,
  [36914] = 2,
    ACTIONS(5115), 1,
      sym__whitespace1,
    ACTIONS(5117), 1,
      sym__newline,
  [36921] = 2,
    ACTIONS(5044), 1,
      anon_sym_PERCENT,
    STATE(2106), 1,
      sym__comment,
  [36928] = 1,
    ACTIONS(2529), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36933] = 1,
    ACTIONS(2533), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36938] = 1,
    ACTIONS(2537), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36943] = 2,
    ACTIONS(4617), 1,
      sym__id,
    STATE(2137), 1,
      sym_reference_label,
  [36950] = 1,
    ACTIONS(2541), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36955] = 2,
    ACTIONS(5044), 1,
      anon_sym_PERCENT,
    STATE(2141), 1,
      sym__comment,
  [36962] = 1,
    ACTIONS(2545), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [36967] = 2,
    ACTIONS(4466), 1,
      sym__in_fallback,
    ACTIONS(5119), 1,
      sym__square_bracket_span_mark_begin,
  [36974] = 2,
    ACTIONS(4466), 1,
      sym__in_fallback,
    ACTIONS(5122), 1,
      sym__emphasis_mark_begin,
  [36981] = 2,
    ACTIONS(4466), 1,
      sym__in_fallback,
    ACTIONS(5125), 1,
      sym__strong_mark_begin,
  [36988] = 2,
    ACTIONS(4466), 1,
      sym__in_fallback,
    ACTIONS(5128), 1,
      sym__superscript_mark_begin,
  [36995] = 2,
    ACTIONS(4466), 1,
      sym__in_fallback,
    ACTIONS(5131), 1,
      sym__subscript_mark_begin,
  [37002] = 1,
    ACTIONS(2549), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [37007] = 2,
    ACTIONS(4466), 1,
      sym__in_fallback,
    ACTIONS(5134), 1,
      sym__insert_mark_begin,
  [37014] = 2,
    ACTIONS(4617), 1,
      sym__id,
    STATE(2172), 1,
      sym_reference_label,
  [37021] = 2,
    ACTIONS(4466), 1,
      sym__in_fallback,
    ACTIONS(5137), 1,
      sym__delete_mark_begin,
  [37028] = 2,
    ACTIONS(5044), 1,
      anon_sym_PERCENT,
    STATE(2176), 1,
      sym__comment,
  [37035] = 2,
    ACTIONS(4466), 1,
      sym__in_fallback,
    ACTIONS(5140), 1,
      sym__square_bracket_span_mark_begin,
  [37042] = 2,
    ACTIONS(4466), 1,
      sym__in_fallback,
    ACTIONS(5143), 1,
      sym__square_bracket_span_mark_begin,
  [37049] = 1,
    ACTIONS(4466), 2,
      sym__parens_span_mark_begin,
      sym__in_fallback,
  [37054] = 1,
    ACTIONS(2553), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [37059] = 2,
    ACTIONS(5146), 1,
      sym__eof_or_newline,
    ACTIONS(5148), 1,
      sym__close_paragraph,
  [37066] = 1,
    ACTIONS(2557), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [37071] = 1,
    ACTIONS(2561), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [37076] = 1,
    ACTIONS(2565), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [37081] = 1,
    ACTIONS(4490), 2,
      sym__parens_span_mark_begin,
      sym__in_fallback,
  [37086] = 1,
    ACTIONS(2347), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [37091] = 2,
    ACTIONS(4490), 1,
      sym__in_fallback,
    ACTIONS(5150), 1,
      sym__square_bracket_span_mark_begin,
  [37098] = 2,
    ACTIONS(4577), 1,
      sym__id,
    STATE(2467), 1,
      sym_reference_label,
  [37105] = 2,
    ACTIONS(4577), 1,
      sym__id,
    STATE(2481), 1,
      sym_reference_label,
  [37112] = 2,
    ACTIONS(4577), 1,
      sym__id,
    STATE(2495), 1,
      sym_reference_label,
  [37119] = 2,
    ACTIONS(4577), 1,
      sym__id,
    STATE(2509), 1,
      sym_reference_label,
  [37126] = 2,
    ACTIONS(4473), 1,
      anon_sym_LBRACK_CARET,
    STATE(1966), 1,
      sym_footnote_marker_begin,
  [37133] = 2,
    ACTIONS(4473), 1,
      anon_sym_LBRACK_CARET,
    STATE(1967), 1,
      sym_footnote_marker_begin,
  [37140] = 1,
    ACTIONS(2573), 2,
      sym__block_close,
      sym__block_quote_continuation,
  [37145] = 2,
    ACTIONS(4473), 1,
      anon_sym_LBRACK_CARET,
    STATE(1968), 1,
      sym_footnote_marker_begin,
  [37152] = 2,
    ACTIONS(4473), 1,
      anon_sym_LBRACK_CARET,
    STATE(1969), 1,
      sym_footnote_marker_begin,
  [37159] = 2,
    ACTIONS(4936), 1,
      sym__in_fallback,
    ACTIONS(5153), 1,
      sym__strong_mark_begin,
  [37166] = 1,
    ACTIONS(5156), 1,
      sym__delete_mark_begin,
  [37170] = 1,
    ACTIONS(5158), 1,
      anon_sym_RBRACK2,
  [37174] = 1,
    ACTIONS(5160), 1,
      sym_emphasis_end,
  [37178] = 1,
    ACTIONS(5162), 1,
      sym_strong_end,
  [37182] = 1,
    ACTIONS(5164), 1,
      sym_superscript_end,
  [37186] = 1,
    ACTIONS(5166), 1,
      aux_sym_value_token1,
  [37190] = 1,
    ACTIONS(2577), 1,
      sym__indented_content_spacer,
  [37194] = 1,
    ACTIONS(5168), 1,
      sym_subscript_end,
  [37198] = 1,
    ACTIONS(5170), 1,
      sym__verbatim_end,
  [37202] = 1,
    ACTIONS(5172), 1,
      sym_highlighted_end,
  [37206] = 1,
    ACTIONS(5174), 1,
      sym_insert_end,
  [37210] = 1,
    ACTIONS(5176), 1,
      sym__newline,
  [37214] = 1,
    ACTIONS(5178), 1,
      anon_sym_EQ,
  [37218] = 1,
    ACTIONS(5180), 1,
      sym__verbatim_end,
  [37222] = 1,
    ACTIONS(5182), 1,
      sym_emphasis_end,
  [37226] = 1,
    ACTIONS(5184), 1,
      sym_strong_end,
  [37230] = 1,
    ACTIONS(5186), 1,
      sym_superscript_end,
  [37234] = 1,
    ACTIONS(5188), 1,
      sym_subscript_end,
  [37238] = 1,
    ACTIONS(5190), 1,
      sym_highlighted_end,
  [37242] = 1,
    ACTIONS(5192), 1,
      sym_insert_end,
  [37246] = 1,
    ACTIONS(5194), 1,
      sym_delete_end,
  [37250] = 1,
    ACTIONS(5196), 1,
      sym__square_bracket_span_end,
  [37254] = 1,
    ACTIONS(5198), 1,
      anon_sym_RBRACK2,
  [37258] = 1,
    ACTIONS(5200), 1,
      sym_language,
  [37262] = 1,
    ACTIONS(5202), 1,
      sym_language,
  [37266] = 1,
    ACTIONS(5204), 1,
      sym__curly_bracket_span_end,
  [37270] = 1,
    ACTIONS(5206), 1,
      sym__newline,
  [37274] = 1,
    ACTIONS(5208), 1,
      sym__curly_bracket_span_end,
  [37278] = 1,
    ACTIONS(5210), 1,
      anon_sym_RBRACE,
  [37282] = 1,
    ACTIONS(5212), 1,
      sym_delete_end,
  [37286] = 1,
    ACTIONS(5214), 1,
      sym__square_bracket_span_end,
  [37290] = 1,
    ACTIONS(5216), 1,
      anon_sym_RBRACK2,
  [37294] = 1,
    ACTIONS(5218), 1,
      sym__block_close,
  [37298] = 1,
    ACTIONS(5220), 1,
      sym__newline,
  [37302] = 1,
    ACTIONS(5222), 1,
      sym__block_close,
  [37306] = 1,
    ACTIONS(5224), 1,
      sym__square_bracket_span_end,
  [37310] = 1,
    ACTIONS(5226), 1,
      sym__square_bracket_span_end,
  [37314] = 1,
    ACTIONS(708), 1,
      sym_list_marker_upper_roman_period,
  [37318] = 1,
    ACTIONS(5228), 1,
      sym__curly_bracket_span_end,
  [37322] = 1,
    ACTIONS(5230), 1,
      sym__newline,
  [37326] = 1,
    ACTIONS(5232), 1,
      sym__newline,
  [37330] = 1,
    ACTIONS(5234), 1,
      sym__newline,
  [37334] = 1,
    ACTIONS(5236), 1,
      sym__id,
  [37338] = 1,
    ACTIONS(5238), 1,
      sym__verbatim_end,
  [37342] = 1,
    ACTIONS(718), 1,
      sym_list_marker_upper_roman_paren,
  [37346] = 1,
    ACTIONS(5240), 1,
      sym__newline,
  [37350] = 1,
    ACTIONS(2609), 1,
      sym__indented_content_spacer,
  [37354] = 1,
    ACTIONS(5242), 1,
      sym__newline,
  [37358] = 1,
    ACTIONS(5244), 1,
      sym__verbatim_end,
  [37362] = 1,
    ACTIONS(5246), 1,
      sym_emphasis_end,
  [37366] = 1,
    ACTIONS(5248), 1,
      sym_strong_end,
  [37370] = 1,
    ACTIONS(5250), 1,
      sym_superscript_end,
  [37374] = 1,
    ACTIONS(5252), 1,
      sym_subscript_end,
  [37378] = 1,
    ACTIONS(5254), 1,
      sym_highlighted_end,
  [37382] = 1,
    ACTIONS(5256), 1,
      sym_insert_end,
  [37386] = 1,
    ACTIONS(5258), 1,
      sym_delete_end,
  [37390] = 1,
    ACTIONS(5260), 1,
      sym__square_bracket_span_end,
  [37394] = 1,
    ACTIONS(5262), 1,
      anon_sym_RBRACK2,
  [37398] = 1,
    ACTIONS(2615), 1,
      sym__indented_content_spacer,
  [37402] = 1,
    ACTIONS(5264), 1,
      sym__block_close,
  [37406] = 1,
    ACTIONS(5266), 1,
      sym__curly_bracket_span_end,
  [37410] = 1,
    ACTIONS(2483), 1,
      sym__indented_content_spacer,
  [37414] = 1,
    ACTIONS(5268), 1,
      sym__block_close,
  [37418] = 1,
    ACTIONS(5270), 1,
      anon_sym_RBRACE,
  [37422] = 1,
    ACTIONS(2587), 1,
      sym__indented_content_spacer,
  [37426] = 1,
    ACTIONS(5272), 1,
      anon_sym_RBRACE,
  [37430] = 1,
    ACTIONS(5274), 1,
      sym__newline,
  [37434] = 1,
    ACTIONS(5276), 1,
      sym__newline,
  [37438] = 1,
    ACTIONS(5278), 1,
      sym__newline,
  [37442] = 1,
    ACTIONS(5280), 1,
      sym__newline,
  [37446] = 1,
    ACTIONS(5282), 1,
      sym__newline,
  [37450] = 1,
    ACTIONS(5284), 1,
      sym__newline,
  [37454] = 1,
    ACTIONS(5286), 1,
      sym__newline,
  [37458] = 1,
    ACTIONS(5288), 1,
      sym__newline,
  [37462] = 1,
    ACTIONS(5290), 1,
      sym__newline,
  [37466] = 1,
    ACTIONS(5292), 1,
      anon_sym_RBRACK,
  [37470] = 1,
    ACTIONS(5294), 1,
      anon_sym_RBRACK,
  [37474] = 1,
    ACTIONS(5296), 1,
      sym__newline,
  [37478] = 1,
    ACTIONS(5298), 1,
      sym__verbatim_end,
  [37482] = 1,
    ACTIONS(5300), 1,
      sym__emphasis_mark_begin,
  [37486] = 1,
    ACTIONS(5302), 1,
      sym__newline,
  [37490] = 1,
    ACTIONS(2477), 1,
      sym__indented_content_spacer,
  [37494] = 1,
    ACTIONS(5304), 1,
      sym__newline,
  [37498] = 1,
    ACTIONS(5306), 1,
      sym__verbatim_end,
  [37502] = 1,
    ACTIONS(5308), 1,
      sym_emphasis_end,
  [37506] = 1,
    ACTIONS(5310), 1,
      sym_strong_end,
  [37510] = 1,
    ACTIONS(5312), 1,
      sym_superscript_end,
  [37514] = 1,
    ACTIONS(5314), 1,
      sym_subscript_end,
  [37518] = 1,
    ACTIONS(5316), 1,
      sym_highlighted_end,
  [37522] = 1,
    ACTIONS(5318), 1,
      sym_insert_end,
  [37526] = 1,
    ACTIONS(5320), 1,
      sym_delete_end,
  [37530] = 1,
    ACTIONS(5322), 1,
      sym__square_bracket_span_end,
  [37534] = 1,
    ACTIONS(5324), 1,
      anon_sym_RBRACK2,
  [37538] = 1,
    ACTIONS(728), 1,
      sym_list_marker_upper_roman_parens,
  [37542] = 1,
    ACTIONS(5326), 1,
      sym__newline,
  [37546] = 1,
    ACTIONS(5328), 1,
      sym__curly_bracket_span_end,
  [37550] = 1,
    ACTIONS(3514), 1,
      sym__curly_bracket_span_end,
  [37554] = 1,
    ACTIONS(5330), 1,
      sym__newline,
  [37558] = 1,
    ACTIONS(5332), 1,
      anon_sym_RBRACE,
  [37562] = 1,
    ACTIONS(5334), 1,
      sym__newline,
  [37566] = 1,
    ACTIONS(5336), 1,
      sym__newline,
  [37570] = 1,
    ACTIONS(5338), 1,
      ts_builtin_sym_end,
  [37574] = 1,
    ACTIONS(5340), 1,
      sym_link_destination,
  [37578] = 1,
    ACTIONS(5342), 1,
      sym__newline,
  [37582] = 1,
    ACTIONS(5344), 1,
      sym__newline,
  [37586] = 1,
    ACTIONS(716), 1,
      sym_list_marker_lower_roman_paren,
  [37590] = 1,
    ACTIONS(5346), 1,
      sym__block_close,
  [37594] = 1,
    ACTIONS(5348), 1,
      sym__indented_content_spacer,
  [37598] = 1,
    ACTIONS(714), 1,
      sym_list_marker_upper_alpha_paren,
  [37602] = 1,
    ACTIONS(5350), 1,
      sym_frontmatter_marker,
  [37606] = 1,
    ACTIONS(5352), 1,
      sym__block_close,
  [37610] = 1,
    ACTIONS(5354), 1,
      sym__block_close,
  [37614] = 1,
    ACTIONS(5356), 1,
      sym__strong_mark_begin,
  [37618] = 1,
    ACTIONS(5358), 1,
      sym__verbatim_end,
  [37622] = 1,
    ACTIONS(5360), 1,
      sym__table_cell_end,
  [37626] = 1,
    ACTIONS(5362), 1,
      sym__superscript_mark_begin,
  [37630] = 1,
    ACTIONS(5364), 1,
      sym__verbatim_end,
  [37634] = 1,
    ACTIONS(5366), 1,
      sym__eof_or_newline,
  [37638] = 1,
    ACTIONS(5368), 1,
      sym__verbatim_end,
  [37642] = 1,
    ACTIONS(5370), 1,
      sym_emphasis_end,
  [37646] = 1,
    ACTIONS(5372), 1,
      sym_strong_end,
  [37650] = 1,
    ACTIONS(5374), 1,
      sym_superscript_end,
  [37654] = 1,
    ACTIONS(5376), 1,
      sym_subscript_end,
  [37658] = 1,
    ACTIONS(5378), 1,
      sym_highlighted_end,
  [37662] = 1,
    ACTIONS(5380), 1,
      sym_insert_end,
  [37666] = 1,
    ACTIONS(5382), 1,
      sym_delete_end,
  [37670] = 1,
    ACTIONS(5384), 1,
      sym__square_bracket_span_end,
  [37674] = 1,
    ACTIONS(5386), 1,
      anon_sym_RBRACK2,
  [37678] = 1,
    ACTIONS(694), 1,
      sym_list_marker_dash,
  [37682] = 1,
    ACTIONS(704), 1,
      sym_list_marker_upper_alpha_period,
  [37686] = 1,
    ACTIONS(5388), 1,
      sym__curly_bracket_span_end,
  [37690] = 1,
    ACTIONS(5390), 1,
      sym__curly_bracket_span_mark_begin,
  [37694] = 1,
    ACTIONS(5392), 1,
      sym__square_bracket_span_mark_begin,
  [37698] = 1,
    ACTIONS(5394), 1,
      anon_sym_RBRACE,
  [37702] = 1,
    ACTIONS(2595), 1,
      sym__indented_content_spacer,
  [37706] = 1,
    ACTIONS(5396), 1,
      sym__subscript_mark_begin,
  [37710] = 1,
    ACTIONS(5398), 1,
      sym__table_cell_end,
  [37714] = 1,
    ACTIONS(5400), 1,
      sym__block_close,
  [37718] = 1,
    ACTIONS(5402), 1,
      sym__newline,
  [37722] = 1,
    ACTIONS(5404), 1,
      sym__highlighted_mark_begin,
  [37726] = 1,
    ACTIONS(5406), 1,
      sym__newline,
  [37730] = 1,
    ACTIONS(5408), 1,
      sym__newline,
  [37734] = 1,
    ACTIONS(2473), 1,
      sym__indented_content_spacer,
  [37738] = 1,
    ACTIONS(2473), 1,
      sym__indented_content_spacer,
  [37742] = 1,
    ACTIONS(5410), 1,
      sym__verbatim_end,
  [37746] = 1,
    ACTIONS(5412), 1,
      anon_sym_RBRACK_COLON,
  [37750] = 1,
    ACTIONS(5414), 1,
      anon_sym_RBRACK_COLON,
  [37754] = 1,
    ACTIONS(5416), 1,
      sym__insert_mark_begin,
  [37758] = 1,
    ACTIONS(5418), 1,
      sym__verbatim_end,
  [37762] = 1,
    ACTIONS(5420), 1,
      sym__curly_bracket_span_mark_begin,
  [37766] = 1,
    ACTIONS(5422), 1,
      sym__list_item_continuation,
  [37770] = 1,
    ACTIONS(5424), 1,
      sym__newline,
  [37774] = 1,
    ACTIONS(5426), 1,
      sym__link_ref_def_label_end,
  [37778] = 1,
    ACTIONS(5428), 1,
      sym__verbatim_end,
  [37782] = 1,
    ACTIONS(5430), 1,
      sym_emphasis_end,
  [37786] = 1,
    ACTIONS(5432), 1,
      sym_strong_end,
  [37790] = 1,
    ACTIONS(5434), 1,
      sym_superscript_end,
  [37794] = 1,
    ACTIONS(5436), 1,
      sym_subscript_end,
  [37798] = 1,
    ACTIONS(5438), 1,
      sym_highlighted_end,
  [37802] = 1,
    ACTIONS(5440), 1,
      sym_insert_end,
  [37806] = 1,
    ACTIONS(5442), 1,
      sym_delete_end,
  [37810] = 1,
    ACTIONS(5444), 1,
      sym__square_bracket_span_end,
  [37814] = 1,
    ACTIONS(5446), 1,
      anon_sym_RBRACK2,
  [37818] = 1,
    ACTIONS(698), 1,
      sym_list_marker_plus,
  [37822] = 1,
    ACTIONS(2601), 1,
      sym__indented_content_spacer,
  [37826] = 1,
    ACTIONS(5448), 1,
      sym__curly_bracket_span_end,
  [37830] = 1,
    ACTIONS(2601), 1,
      sym__indented_content_spacer,
  [37834] = 1,
    ACTIONS(5450), 1,
      sym__whitespace1,
  [37838] = 1,
    ACTIONS(5452), 1,
      anon_sym_RBRACE,
  [37842] = 1,
    ACTIONS(5454), 1,
      sym__whitespace1,
  [37846] = 1,
    ACTIONS(5456), 1,
      sym__newline,
  [37850] = 1,
    ACTIONS(724), 1,
      sym_list_marker_upper_alpha_parens,
  [37854] = 1,
    ACTIONS(5458), 1,
      sym__block_close,
  [37858] = 1,
    ACTIONS(5460), 1,
      sym__indented_content_spacer,
  [37862] = 1,
    ACTIONS(2489), 1,
      sym__indented_content_spacer,
  [37866] = 1,
    ACTIONS(2493), 1,
      sym__indented_content_spacer,
  [37870] = 1,
    ACTIONS(5462), 1,
      sym__newline,
  [37874] = 1,
    ACTIONS(5464), 1,
      sym__verbatim_end,
  [37878] = 1,
    ACTIONS(5466), 1,
      sym_emphasis_end,
  [37882] = 1,
    ACTIONS(5468), 1,
      sym_strong_end,
  [37886] = 1,
    ACTIONS(2497), 1,
      sym__indented_content_spacer,
  [37890] = 1,
    ACTIONS(2501), 1,
      sym__indented_content_spacer,
  [37894] = 1,
    ACTIONS(2505), 1,
      sym__indented_content_spacer,
  [37898] = 1,
    ACTIONS(5470), 1,
      sym__verbatim_end,
  [37902] = 1,
    ACTIONS(2509), 1,
      sym__indented_content_spacer,
  [37906] = 1,
    ACTIONS(2513), 1,
      sym__indented_content_spacer,
  [37910] = 1,
    ACTIONS(5472), 1,
      sym__newline,
  [37914] = 1,
    ACTIONS(5474), 1,
      sym__verbatim_end,
  [37918] = 1,
    ACTIONS(5476), 1,
      sym__verbatim_end,
  [37922] = 1,
    ACTIONS(5478), 1,
      sym_emphasis_end,
  [37926] = 1,
    ACTIONS(5480), 1,
      sym_strong_end,
  [37930] = 1,
    ACTIONS(5482), 1,
      sym_superscript_end,
  [37934] = 1,
    ACTIONS(5484), 1,
      sym_subscript_end,
  [37938] = 1,
    ACTIONS(5486), 1,
      sym_highlighted_end,
  [37942] = 1,
    ACTIONS(5488), 1,
      sym_insert_end,
  [37946] = 1,
    ACTIONS(5490), 1,
      sym_delete_end,
  [37950] = 1,
    ACTIONS(5492), 1,
      sym__square_bracket_span_end,
  [37954] = 1,
    ACTIONS(5494), 1,
      anon_sym_RBRACK2,
  [37958] = 1,
    ACTIONS(2517), 1,
      sym__indented_content_spacer,
  [37962] = 1,
    ACTIONS(5496), 1,
      sym_superscript_end,
  [37966] = 1,
    ACTIONS(5498), 1,
      sym__curly_bracket_span_end,
  [37970] = 1,
    ACTIONS(5500), 1,
      sym_emphasis_end,
  [37974] = 1,
    ACTIONS(5502), 1,
      sym_strong_end,
  [37978] = 1,
    ACTIONS(5504), 1,
      anon_sym_RBRACE,
  [37982] = 1,
    ACTIONS(696), 1,
      sym_list_marker_star,
  [37986] = 1,
    ACTIONS(5506), 1,
      sym_superscript_end,
  [37990] = 1,
    ACTIONS(2569), 1,
      sym__indented_content_spacer,
  [37994] = 1,
    ACTIONS(5508), 1,
      sym_subscript_end,
  [37998] = 1,
    ACTIONS(5510), 1,
      sym_highlighted_end,
  [38002] = 1,
    ACTIONS(5512), 1,
      sym_insert_end,
  [38006] = 1,
    ACTIONS(5514), 1,
      sym__verbatim_content,
  [38010] = 1,
    ACTIONS(5516), 1,
      sym_delete_end,
  [38014] = 1,
    ACTIONS(2597), 1,
      sym__indented_content_spacer,
  [38018] = 1,
    ACTIONS(5518), 1,
      sym__square_bracket_span_end,
  [38022] = 1,
    ACTIONS(5520), 1,
      anon_sym_RBRACK2,
  [38026] = 1,
    ACTIONS(2605), 1,
      sym__indented_content_spacer,
  [38030] = 1,
    ACTIONS(2521), 1,
      sym__indented_content_spacer,
  [38034] = 1,
    ACTIONS(2525), 1,
      sym__indented_content_spacer,
  [38038] = 1,
    ACTIONS(5522), 1,
      sym__block_close,
  [38042] = 1,
    ACTIONS(5524), 1,
      sym__verbatim_content,
  [38046] = 1,
    ACTIONS(5526), 1,
      sym__newline,
  [38050] = 1,
    ACTIONS(5528), 1,
      sym__curly_bracket_span_mark_begin,
  [38054] = 1,
    ACTIONS(2529), 1,
      sym__indented_content_spacer,
  [38058] = 1,
    ACTIONS(5530), 1,
      sym__indented_content_spacer,
  [38062] = 1,
    ACTIONS(5532), 1,
      anon_sym_EQ,
  [38066] = 1,
    ACTIONS(2617), 1,
      sym__indented_content_spacer,
  [38070] = 1,
    ACTIONS(5534), 1,
      sym__verbatim_content,
  [38074] = 1,
    ACTIONS(2621), 1,
      sym__indented_content_spacer,
  [38078] = 1,
    ACTIONS(2629), 1,
      sym__indented_content_spacer,
  [38082] = 1,
    ACTIONS(2633), 1,
      sym__indented_content_spacer,
  [38086] = 1,
    ACTIONS(2637), 1,
      sym__indented_content_spacer,
  [38090] = 1,
    ACTIONS(2533), 1,
      sym__indented_content_spacer,
  [38094] = 1,
    ACTIONS(2641), 1,
      sym__indented_content_spacer,
  [38098] = 1,
    ACTIONS(2645), 1,
      sym__indented_content_spacer,
  [38102] = 1,
    ACTIONS(2537), 1,
      sym__indented_content_spacer,
  [38106] = 1,
    ACTIONS(5536), 1,
      sym__newline,
  [38110] = 1,
    ACTIONS(2649), 1,
      sym__indented_content_spacer,
  [38114] = 1,
    ACTIONS(5538), 1,
      sym__newline,
  [38118] = 1,
    ACTIONS(5540), 1,
      sym__newline,
  [38122] = 1,
    ACTIONS(5542), 1,
      sym__curly_bracket_span_end,
  [38126] = 1,
    ACTIONS(2653), 1,
      sym__indented_content_spacer,
  [38130] = 1,
    ACTIONS(5544), 1,
      sym__square_bracket_span_end,
  [38134] = 1,
    ACTIONS(5546), 1,
      sym__whitespace1,
  [38138] = 1,
    ACTIONS(5548), 1,
      aux_sym_value_token1,
  [38142] = 1,
    ACTIONS(5550), 1,
      sym_language,
  [38146] = 1,
    ACTIONS(5552), 1,
      anon_sym_COLON,
  [38150] = 1,
    ACTIONS(5554), 1,
      sym__indented_content_spacer,
  [38154] = 1,
    ACTIONS(5556), 1,
      sym_link_destination,
  [38158] = 1,
    ACTIONS(2657), 1,
      sym__indented_content_spacer,
  [38162] = 1,
    ACTIONS(5558), 1,
      sym__newline,
  [38166] = 1,
    ACTIONS(2541), 1,
      sym__indented_content_spacer,
  [38170] = 1,
    ACTIONS(5560), 1,
      sym__verbatim_content,
  [38174] = 1,
    ACTIONS(5562), 1,
      sym__newline,
  [38178] = 1,
    ACTIONS(5564), 1,
      sym__curly_bracket_span_mark_begin,
  [38182] = 1,
    ACTIONS(2545), 1,
      sym__indented_content_spacer,
  [38186] = 1,
    ACTIONS(5566), 1,
      sym__indented_content_spacer,
  [38190] = 1,
    ACTIONS(2549), 1,
      sym__indented_content_spacer,
  [38194] = 1,
    ACTIONS(5568), 1,
      sym__verbatim_content,
  [38198] = 1,
    ACTIONS(5570), 1,
      sym__newline,
  [38202] = 1,
    ACTIONS(5572), 1,
      sym__block_close,
  [38206] = 1,
    ACTIONS(5574), 1,
      sym__block_close,
  [38210] = 1,
    ACTIONS(2553), 1,
      sym__indented_content_spacer,
  [38214] = 1,
    ACTIONS(5576), 1,
      anon_sym_RBRACE,
  [38218] = 1,
    ACTIONS(5578), 1,
      sym__newline,
  [38222] = 1,
    ACTIONS(5580), 1,
      sym__newline,
  [38226] = 1,
    ACTIONS(5582), 1,
      sym__newline,
  [38230] = 1,
    ACTIONS(2661), 1,
      sym__indented_content_spacer,
  [38234] = 1,
    ACTIONS(2665), 1,
      sym__indented_content_spacer,
  [38238] = 1,
    ACTIONS(5584), 1,
      sym__newline,
  [38242] = 1,
    ACTIONS(5586), 1,
      sym__newline,
  [38246] = 1,
    ACTIONS(5588), 1,
      sym__newline,
  [38250] = 1,
    ACTIONS(5590), 1,
      sym__newline,
  [38254] = 1,
    ACTIONS(5592), 1,
      sym__square_bracket_span_end,
  [38258] = 1,
    ACTIONS(5594), 1,
      sym__whitespace1,
  [38262] = 1,
    ACTIONS(5596), 1,
      sym_language,
  [38266] = 1,
    ACTIONS(5598), 1,
      anon_sym_COLON,
  [38270] = 1,
    ACTIONS(5600), 1,
      sym__indented_content_spacer,
  [38274] = 1,
    ACTIONS(5602), 1,
      sym_link_destination,
  [38278] = 1,
    ACTIONS(5604), 1,
      sym_subscript_end,
  [38282] = 1,
    ACTIONS(5606), 1,
      sym__newline,
  [38286] = 1,
    ACTIONS(5608), 1,
      sym__newline,
  [38290] = 1,
    ACTIONS(5610), 1,
      sym__verbatim_content,
  [38294] = 1,
    ACTIONS(5612), 1,
      sym__newline,
  [38298] = 1,
    ACTIONS(5614), 1,
      sym__curly_bracket_span_mark_begin,
  [38302] = 1,
    ACTIONS(5616), 1,
      sym__square_bracket_span_mark_begin,
  [38306] = 1,
    ACTIONS(5618), 1,
      sym__indented_content_spacer,
  [38310] = 1,
    ACTIONS(5620), 1,
      sym_frontmatter_marker,
  [38314] = 1,
    ACTIONS(5622), 1,
      sym__verbatim_content,
  [38318] = 1,
    ACTIONS(5624), 1,
      sym__newline,
  [38322] = 1,
    ACTIONS(5626), 1,
      sym__indented_content_spacer,
  [38326] = 1,
    ACTIONS(5628), 1,
      sym__newline,
  [38330] = 1,
    ACTIONS(700), 1,
      sym_list_marker_decimal_period,
  [38334] = 1,
    ACTIONS(5630), 1,
      sym__newline,
  [38338] = 1,
    ACTIONS(5632), 1,
      sym__newline,
  [38342] = 1,
    ACTIONS(5634), 1,
      sym__block_close,
  [38346] = 1,
    ACTIONS(2557), 1,
      sym__indented_content_spacer,
  [38350] = 1,
    ACTIONS(5636), 1,
      sym__square_bracket_span_mark_begin,
  [38354] = 1,
    ACTIONS(5638), 1,
      sym__block_close,
  [38358] = 1,
    ACTIONS(5640), 1,
      sym__newline,
  [38362] = 1,
    ACTIONS(5642), 1,
      sym__newline,
  [38366] = 1,
    ACTIONS(2561), 1,
      sym__indented_content_spacer,
  [38370] = 1,
    ACTIONS(5644), 1,
      sym__indented_content_spacer,
  [38374] = 1,
    ACTIONS(5646), 1,
      sym__square_bracket_span_end,
  [38378] = 1,
    ACTIONS(5648), 1,
      sym__whitespace1,
  [38382] = 1,
    ACTIONS(5650), 1,
      sym_language,
  [38386] = 1,
    ACTIONS(5652), 1,
      anon_sym_COLON,
  [38390] = 1,
    ACTIONS(5654), 1,
      sym__indented_content_spacer,
  [38394] = 1,
    ACTIONS(5656), 1,
      sym_link_destination,
  [38398] = 1,
    ACTIONS(5658), 1,
      sym__newline,
  [38402] = 1,
    ACTIONS(5660), 1,
      sym_highlighted_end,
  [38406] = 1,
    ACTIONS(5662), 1,
      sym__verbatim_content,
  [38410] = 1,
    ACTIONS(5664), 1,
      sym__newline,
  [38414] = 1,
    ACTIONS(5666), 1,
      sym__curly_bracket_span_mark_begin,
  [38418] = 1,
    ACTIONS(710), 1,
      sym_list_marker_decimal_paren,
  [38422] = 1,
    ACTIONS(5668), 1,
      sym__indented_content_spacer,
  [38426] = 1,
    ACTIONS(5670), 1,
      sym_emphasis_end,
  [38430] = 1,
    ACTIONS(5672), 1,
      sym__verbatim_content,
  [38434] = 1,
    ACTIONS(5674), 1,
      sym_insert_end,
  [38438] = 1,
    ACTIONS(5676), 1,
      sym__verbatim_end,
  [38442] = 1,
    ACTIONS(5678), 1,
      sym__footnote_continuation,
  [38446] = 1,
    ACTIONS(5680), 1,
      sym_delete_end,
  [38450] = 1,
    ACTIONS(5682), 1,
      sym__block_close,
  [38454] = 1,
    ACTIONS(5684), 1,
      sym__eof_or_newline,
  [38458] = 1,
    ACTIONS(5686), 1,
      sym__whitespace1,
  [38462] = 1,
    ACTIONS(5688), 1,
      sym__newline,
  [38466] = 1,
    ACTIONS(5690), 1,
      sym__block_close,
  [38470] = 1,
    ACTIONS(5692), 1,
      sym__square_bracket_span_end,
  [38474] = 1,
    ACTIONS(5694), 1,
      sym__newline,
  [38478] = 1,
    ACTIONS(5696), 1,
      sym__newline,
  [38482] = 1,
    ACTIONS(5698), 1,
      sym__indented_content_spacer,
  [38486] = 1,
    ACTIONS(720), 1,
      sym_list_marker_decimal_parens,
  [38490] = 1,
    ACTIONS(5700), 1,
      sym__square_bracket_span_end,
  [38494] = 1,
    ACTIONS(5702), 1,
      sym__whitespace1,
  [38498] = 1,
    ACTIONS(5704), 1,
      sym_language,
  [38502] = 1,
    ACTIONS(5706), 1,
      anon_sym_COLON,
  [38506] = 1,
    ACTIONS(5708), 1,
      sym__indented_content_spacer,
  [38510] = 1,
    ACTIONS(5710), 1,
      sym_link_destination,
  [38514] = 1,
    ACTIONS(5712), 1,
      sym__verbatim_content,
  [38518] = 1,
    ACTIONS(5714), 1,
      sym__curly_bracket_span_mark_begin,
  [38522] = 1,
    ACTIONS(5716), 1,
      sym__indented_content_spacer,
  [38526] = 1,
    ACTIONS(5718), 1,
      sym__verbatim_content,
  [38530] = 1,
    ACTIONS(5720), 1,
      anon_sym_COLON,
  [38534] = 1,
    ACTIONS(5722), 1,
      sym__newline,
  [38538] = 1,
    ACTIONS(726), 1,
      sym_list_marker_lower_roman_parens,
  [38542] = 1,
    ACTIONS(5724), 1,
      anon_sym_RBRACK2,
  [38546] = 1,
    ACTIONS(5726), 1,
      sym__verbatim_end,
  [38550] = 1,
    ACTIONS(5728), 1,
      sym_strong_end,
  [38554] = 1,
    ACTIONS(2565), 1,
      sym__indented_content_spacer,
  [38558] = 1,
    ACTIONS(5730), 1,
      sym__list_item_continuation,
  [38562] = 1,
    ACTIONS(5732), 1,
      sym__newline,
  [38566] = 1,
    ACTIONS(5734), 1,
      sym__verbatim_end,
  [38570] = 1,
    ACTIONS(5736), 1,
      anon_sym_DQUOTE,
  [38574] = 1,
    ACTIONS(5738), 1,
      sym__square_bracket_span_end,
  [38578] = 1,
    ACTIONS(5740), 1,
      sym_language,
  [38582] = 1,
    ACTIONS(5742), 1,
      sym__verbatim_content,
  [38586] = 1,
    ACTIONS(5744), 1,
      sym__curly_bracket_span_mark_begin,
  [38590] = 1,
    ACTIONS(5746), 1,
      sym__indented_content_spacer,
  [38594] = 1,
    ACTIONS(5748), 1,
      sym__verbatim_content,
  [38598] = 1,
    ACTIONS(5750), 1,
      anon_sym_RBRACE,
  [38602] = 1,
    ACTIONS(5752), 1,
      sym__newline,
  [38606] = 1,
    ACTIONS(5754), 1,
      sym__block_close,
  [38610] = 1,
    ACTIONS(2347), 1,
      sym__indented_content_spacer,
  [38614] = 1,
    ACTIONS(5756), 1,
      sym__newline,
  [38618] = 1,
    ACTIONS(5758), 1,
      sym__newline,
  [38622] = 1,
    ACTIONS(5760), 1,
      sym__newline,
  [38626] = 1,
    ACTIONS(5762), 1,
      sym__parens_span_mark_begin,
  [38630] = 1,
    ACTIONS(5764), 1,
      sym__verbatim_end,
  [38634] = 1,
    ACTIONS(5766), 1,
      sym__verbatim_end,
  [38638] = 1,
    ACTIONS(702), 1,
      sym_list_marker_lower_alpha_period,
  [38642] = 1,
    ACTIONS(5768), 1,
      sym__square_bracket_span_end,
  [38646] = 1,
    ACTIONS(5770), 1,
      sym_language,
  [38650] = 1,
    ACTIONS(5772), 1,
      sym__verbatim_content,
  [38654] = 1,
    ACTIONS(5774), 1,
      sym__newline,
  [38658] = 1,
    ACTIONS(5776), 1,
      sym__indented_content_spacer,
  [38662] = 1,
    ACTIONS(5778), 1,
      sym__verbatim_content,
  [38666] = 1,
    ACTIONS(5780), 1,
      sym__whitespace,
  [38670] = 1,
    ACTIONS(5782), 1,
      sym_emphasis_end,
  [38674] = 1,
    ACTIONS(5784), 1,
      sym_emphasis_end,
  [38678] = 1,
    ACTIONS(5786), 1,
      sym_strong_end,
  [38682] = 1,
    ACTIONS(5788), 1,
      sym_superscript_end,
  [38686] = 1,
    ACTIONS(5790), 1,
      sym_subscript_end,
  [38690] = 1,
    ACTIONS(5792), 1,
      sym_highlighted_end,
  [38694] = 1,
    ACTIONS(5794), 1,
      sym_strong_end,
  [38698] = 1,
    ACTIONS(5796), 1,
      sym_insert_end,
  [38702] = 1,
    ACTIONS(5798), 1,
      sym_superscript_end,
  [38706] = 1,
    ACTIONS(5800), 1,
      sym_delete_end,
  [38710] = 1,
    ACTIONS(5802), 1,
      sym__square_bracket_span_end,
  [38714] = 1,
    ACTIONS(5804), 1,
      sym_language,
  [38718] = 1,
    ACTIONS(5806), 1,
      sym__verbatim_content,
  [38722] = 1,
    ACTIONS(5808), 1,
      sym__curly_bracket_span_mark_begin,
  [38726] = 1,
    ACTIONS(5810), 1,
      sym__indented_content_spacer,
  [38730] = 1,
    ACTIONS(5812), 1,
      sym__verbatim_content,
  [38734] = 1,
    ACTIONS(5814), 1,
      sym__square_bracket_span_end,
  [38738] = 1,
    ACTIONS(5816), 1,
      anon_sym_RBRACK2,
  [38742] = 1,
    ACTIONS(5818), 1,
      sym_subscript_end,
  [38746] = 1,
    ACTIONS(5820), 1,
      sym_highlighted_end,
  [38750] = 1,
    ACTIONS(5822), 1,
      sym__newline,
  [38754] = 1,
    ACTIONS(5824), 1,
      sym__block_close,
  [38758] = 1,
    ACTIONS(5826), 1,
      sym_insert_end,
  [38762] = 1,
    ACTIONS(5828), 1,
      sym_delete_end,
  [38766] = 1,
    ACTIONS(5830), 1,
      sym__square_bracket_span_end,
  [38770] = 1,
    ACTIONS(5832), 1,
      anon_sym_RBRACK2,
  [38774] = 1,
    ACTIONS(706), 1,
      sym_list_marker_lower_roman_period,
  [38778] = 1,
    ACTIONS(5834), 1,
      sym__square_bracket_span_end,
  [38782] = 1,
    ACTIONS(5836), 1,
      sym_language,
  [38786] = 1,
    ACTIONS(5838), 1,
      sym__verbatim_content,
  [38790] = 1,
    ACTIONS(5840), 1,
      sym__curly_bracket_span_mark_begin,
  [38794] = 1,
    ACTIONS(5842), 1,
      sym__indented_content_spacer,
  [38798] = 1,
    ACTIONS(5844), 1,
      sym__verbatim_content,
  [38802] = 1,
    ACTIONS(5846), 1,
      sym__curly_bracket_span_end,
  [38806] = 1,
    ACTIONS(5848), 1,
      sym__newline,
  [38810] = 1,
    ACTIONS(5850), 1,
      sym__newline,
  [38814] = 1,
    ACTIONS(5852), 1,
      sym__curly_bracket_span_end,
  [38818] = 1,
    ACTIONS(5854), 1,
      sym__whitespace,
  [38822] = 1,
    ACTIONS(5856), 1,
      sym__newline,
  [38826] = 1,
    ACTIONS(5858), 1,
      sym__block_close,
  [38830] = 1,
    ACTIONS(5860), 1,
      sym__curly_bracket_span_end,
  [38834] = 1,
    ACTIONS(5862), 1,
      sym__block_close,
  [38838] = 1,
    ACTIONS(5864), 1,
      anon_sym_RBRACE,
  [38842] = 1,
    ACTIONS(5866), 1,
      sym__newline,
  [38846] = 1,
    ACTIONS(5868), 1,
      sym__square_bracket_span_end,
  [38850] = 1,
    ACTIONS(5870), 1,
      sym_language,
  [38854] = 1,
    ACTIONS(5872), 1,
      sym__verbatim_content,
  [38858] = 1,
    ACTIONS(5874), 1,
      sym__curly_bracket_span_mark_begin,
  [38862] = 1,
    ACTIONS(5876), 1,
      sym__indented_content_spacer,
  [38866] = 1,
    ACTIONS(5878), 1,
      sym__verbatim_content,
  [38870] = 1,
    ACTIONS(5880), 1,
      anon_sym_DQUOTE,
  [38874] = 1,
    ACTIONS(5882), 1,
      anon_sym_RBRACE,
  [38878] = 1,
    ACTIONS(5884), 1,
      sym__newline,
  [38882] = 1,
    ACTIONS(5886), 1,
      sym__newline,
  [38886] = 1,
    ACTIONS(5888), 1,
      sym__newline,
  [38890] = 1,
    ACTIONS(5890), 1,
      sym__newline,
  [38894] = 1,
    ACTIONS(5892), 1,
      sym__newline,
  [38898] = 1,
    ACTIONS(5894), 1,
      anon_sym_LBRACK,
  [38902] = 1,
    ACTIONS(5896), 1,
      sym__newline,
  [38906] = 1,
    ACTIONS(3612), 1,
      sym__curly_bracket_span_end,
  [38910] = 1,
    ACTIONS(5898), 1,
      sym__newline,
  [38914] = 1,
    ACTIONS(5900), 1,
      sym__square_bracket_span_end,
  [38918] = 1,
    ACTIONS(5902), 1,
      sym_language,
  [38922] = 1,
    ACTIONS(5904), 1,
      sym__verbatim_content,
  [38926] = 1,
    ACTIONS(5906), 1,
      sym__curly_bracket_span_mark_begin,
  [38930] = 1,
    ACTIONS(5908), 1,
      sym__indented_content_spacer,
  [38934] = 1,
    ACTIONS(5910), 1,
      sym__verbatim_content,
  [38938] = 1,
    ACTIONS(5912), 1,
      sym__newline,
  [38942] = 1,
    ACTIONS(5914), 1,
      sym__newline,
  [38946] = 1,
    ACTIONS(5916), 1,
      sym__newline,
  [38950] = 1,
    ACTIONS(5918), 1,
      sym__block_close,
  [38954] = 1,
    ACTIONS(5920), 1,
      sym__newline,
  [38958] = 1,
    ACTIONS(5922), 1,
      sym__newline,
  [38962] = 1,
    ACTIONS(5924), 1,
      sym__block_close,
  [38966] = 1,
    ACTIONS(5926), 1,
      sym__block_close,
  [38970] = 1,
    ACTIONS(5928), 1,
      sym_superscript_end,
  [38974] = 1,
    ACTIONS(5930), 1,
      sym__block_close,
  [38978] = 1,
    ACTIONS(5932), 1,
      sym_subscript_end,
  [38982] = 1,
    ACTIONS(5934), 1,
      sym__square_bracket_span_end,
  [38986] = 1,
    ACTIONS(5936), 1,
      sym_language,
  [38990] = 1,
    ACTIONS(5938), 1,
      sym__verbatim_content,
  [38994] = 1,
    ACTIONS(5940), 1,
      sym__curly_bracket_span_mark_begin,
  [38998] = 1,
    ACTIONS(5942), 1,
      sym__indented_content_spacer,
  [39002] = 1,
    ACTIONS(5944), 1,
      sym__verbatim_content,
  [39006] = 1,
    ACTIONS(5946), 1,
      sym__newline,
  [39010] = 1,
    ACTIONS(5948), 1,
      sym__verbatim_end,
  [39014] = 1,
    ACTIONS(5950), 1,
      sym__verbatim_end,
  [39018] = 1,
    ACTIONS(5952), 1,
      sym__verbatim_end,
  [39022] = 1,
    ACTIONS(5954), 1,
      anon_sym_RBRACE,
  [39026] = 1,
    ACTIONS(5956), 1,
      sym_highlighted_end,
  [39030] = 1,
    ACTIONS(5958), 1,
      sym__whitespace1,
  [39034] = 1,
    ACTIONS(5960), 1,
      anon_sym_RBRACK,
  [39038] = 1,
    ACTIONS(5962), 1,
      sym__verbatim_end,
  [39042] = 1,
    ACTIONS(5964), 1,
      sym_emphasis_end,
  [39046] = 1,
    ACTIONS(5966), 1,
      sym_strong_end,
  [39050] = 1,
    ACTIONS(5968), 1,
      sym__square_bracket_span_end,
  [39054] = 1,
    ACTIONS(5970), 1,
      sym_language,
  [39058] = 1,
    ACTIONS(5972), 1,
      sym__indented_content_spacer,
  [39062] = 1,
    ACTIONS(5974), 1,
      sym__indented_content_spacer,
  [39066] = 1,
    ACTIONS(5976), 1,
      sym__indented_content_spacer,
  [39070] = 1,
    ACTIONS(5978), 1,
      sym__indented_content_spacer,
  [39074] = 1,
    ACTIONS(5980), 1,
      sym__indented_content_spacer,
  [39078] = 1,
    ACTIONS(5982), 1,
      sym__indented_content_spacer,
  [39082] = 1,
    ACTIONS(5984), 1,
      sym__whitespace,
  [39086] = 1,
    ACTIONS(5986), 1,
      sym__emphasis_mark_begin,
  [39090] = 1,
    ACTIONS(5988), 1,
      sym__strong_mark_begin,
  [39094] = 1,
    ACTIONS(5990), 1,
      sym__superscript_mark_begin,
  [39098] = 1,
    ACTIONS(5992), 1,
      sym__subscript_mark_begin,
  [39102] = 1,
    ACTIONS(5994), 1,
      sym__highlighted_mark_begin,
  [39106] = 1,
    ACTIONS(5996), 1,
      sym__insert_mark_begin,
  [39110] = 1,
    ACTIONS(5998), 1,
      sym__delete_mark_begin,
  [39114] = 1,
    ACTIONS(6000), 1,
      sym__square_bracket_span_mark_begin,
  [39118] = 1,
    ACTIONS(6002), 1,
      sym__curly_bracket_span_mark_begin,
  [39122] = 1,
    ACTIONS(6004), 1,
      sym__parens_span_mark_begin,
  [39126] = 1,
    ACTIONS(6006), 1,
      sym_superscript_end,
  [39130] = 1,
    ACTIONS(6008), 1,
      anon_sym_RBRACK_COLON,
  [39134] = 1,
    ACTIONS(6010), 1,
      anon_sym_RBRACK,
  [39138] = 1,
    ACTIONS(6012), 1,
      sym__whitespace,
  [39142] = 1,
    ACTIONS(6014), 1,
      sym__emphasis_mark_begin,
  [39146] = 1,
    ACTIONS(6016), 1,
      sym__strong_mark_begin,
  [39150] = 1,
    ACTIONS(6018), 1,
      sym__superscript_mark_begin,
  [39154] = 1,
    ACTIONS(6020), 1,
      sym__subscript_mark_begin,
  [39158] = 1,
    ACTIONS(6022), 1,
      sym__highlighted_mark_begin,
  [39162] = 1,
    ACTIONS(6024), 1,
      sym__insert_mark_begin,
  [39166] = 1,
    ACTIONS(6026), 1,
      sym__delete_mark_begin,
  [39170] = 1,
    ACTIONS(6028), 1,
      sym__square_bracket_span_mark_begin,
  [39174] = 1,
    ACTIONS(6030), 1,
      sym__curly_bracket_span_mark_begin,
  [39178] = 1,
    ACTIONS(6032), 1,
      sym__parens_span_mark_begin,
  [39182] = 1,
    ACTIONS(6034), 1,
      sym_subscript_end,
  [39186] = 1,
    ACTIONS(6036), 1,
      anon_sym_RBRACK_COLON,
  [39190] = 1,
    ACTIONS(6038), 1,
      anon_sym_RBRACK,
  [39194] = 1,
    ACTIONS(6040), 1,
      sym__whitespace,
  [39198] = 1,
    ACTIONS(6042), 1,
      sym__emphasis_mark_begin,
  [39202] = 1,
    ACTIONS(6044), 1,
      sym__strong_mark_begin,
  [39206] = 1,
    ACTIONS(6046), 1,
      sym__superscript_mark_begin,
  [39210] = 1,
    ACTIONS(6048), 1,
      sym__subscript_mark_begin,
  [39214] = 1,
    ACTIONS(6050), 1,
      sym__highlighted_mark_begin,
  [39218] = 1,
    ACTIONS(6052), 1,
      sym__insert_mark_begin,
  [39222] = 1,
    ACTIONS(6054), 1,
      sym__delete_mark_begin,
  [39226] = 1,
    ACTIONS(6056), 1,
      sym__square_bracket_span_mark_begin,
  [39230] = 1,
    ACTIONS(6058), 1,
      sym__curly_bracket_span_mark_begin,
  [39234] = 1,
    ACTIONS(6060), 1,
      sym__parens_span_mark_begin,
  [39238] = 1,
    ACTIONS(6062), 1,
      sym_highlighted_end,
  [39242] = 1,
    ACTIONS(6064), 1,
      anon_sym_RBRACK_COLON,
  [39246] = 1,
    ACTIONS(6066), 1,
      anon_sym_RBRACK,
  [39250] = 1,
    ACTIONS(6068), 1,
      sym__whitespace,
  [39254] = 1,
    ACTIONS(6070), 1,
      sym__emphasis_mark_begin,
  [39258] = 1,
    ACTIONS(6072), 1,
      sym__strong_mark_begin,
  [39262] = 1,
    ACTIONS(6074), 1,
      sym__superscript_mark_begin,
  [39266] = 1,
    ACTIONS(6076), 1,
      sym__subscript_mark_begin,
  [39270] = 1,
    ACTIONS(6078), 1,
      sym__highlighted_mark_begin,
  [39274] = 1,
    ACTIONS(6080), 1,
      sym__insert_mark_begin,
  [39278] = 1,
    ACTIONS(6082), 1,
      sym__delete_mark_begin,
  [39282] = 1,
    ACTIONS(6084), 1,
      sym__square_bracket_span_mark_begin,
  [39286] = 1,
    ACTIONS(6086), 1,
      sym__curly_bracket_span_mark_begin,
  [39290] = 1,
    ACTIONS(6088), 1,
      sym__parens_span_mark_begin,
  [39294] = 1,
    ACTIONS(6090), 1,
      sym_insert_end,
  [39298] = 1,
    ACTIONS(6092), 1,
      anon_sym_RBRACK_COLON,
  [39302] = 1,
    ACTIONS(6094), 1,
      anon_sym_RBRACK,
  [39306] = 1,
    ACTIONS(6096), 1,
      sym__emphasis_mark_begin,
  [39310] = 1,
    ACTIONS(6098), 1,
      sym__strong_mark_begin,
  [39314] = 1,
    ACTIONS(6100), 1,
      sym__superscript_mark_begin,
  [39318] = 1,
    ACTIONS(6102), 1,
      sym__subscript_mark_begin,
  [39322] = 1,
    ACTIONS(6104), 1,
      sym__highlighted_mark_begin,
  [39326] = 1,
    ACTIONS(6106), 1,
      sym__insert_mark_begin,
  [39330] = 1,
    ACTIONS(6108), 1,
      sym__delete_mark_begin,
  [39334] = 1,
    ACTIONS(6110), 1,
      sym__square_bracket_span_mark_begin,
  [39338] = 1,
    ACTIONS(6112), 1,
      sym__curly_bracket_span_mark_begin,
  [39342] = 1,
    ACTIONS(6114), 1,
      sym__parens_span_mark_begin,
  [39346] = 1,
    ACTIONS(6116), 1,
      sym_delete_end,
  [39350] = 1,
    ACTIONS(6118), 1,
      sym__emphasis_mark_begin,
  [39354] = 1,
    ACTIONS(6120), 1,
      sym__strong_mark_begin,
  [39358] = 1,
    ACTIONS(6122), 1,
      sym__superscript_mark_begin,
  [39362] = 1,
    ACTIONS(6124), 1,
      sym__subscript_mark_begin,
  [39366] = 1,
    ACTIONS(6126), 1,
      sym__highlighted_mark_begin,
  [39370] = 1,
    ACTIONS(6128), 1,
      sym__insert_mark_begin,
  [39374] = 1,
    ACTIONS(6130), 1,
      sym__delete_mark_begin,
  [39378] = 1,
    ACTIONS(6132), 1,
      sym__square_bracket_span_mark_begin,
  [39382] = 1,
    ACTIONS(6134), 1,
      sym__curly_bracket_span_mark_begin,
  [39386] = 1,
    ACTIONS(6136), 1,
      sym__parens_span_mark_begin,
  [39390] = 1,
    ACTIONS(6138), 1,
      sym__square_bracket_span_end,
  [39394] = 1,
    ACTIONS(6140), 1,
      sym__emphasis_mark_begin,
  [39398] = 1,
    ACTIONS(6142), 1,
      sym__strong_mark_begin,
  [39402] = 1,
    ACTIONS(6144), 1,
      sym__superscript_mark_begin,
  [39406] = 1,
    ACTIONS(6146), 1,
      sym__subscript_mark_begin,
  [39410] = 1,
    ACTIONS(6148), 1,
      sym__highlighted_mark_begin,
  [39414] = 1,
    ACTIONS(6150), 1,
      sym__insert_mark_begin,
  [39418] = 1,
    ACTIONS(6152), 1,
      sym__delete_mark_begin,
  [39422] = 1,
    ACTIONS(6154), 1,
      sym__square_bracket_span_mark_begin,
  [39426] = 1,
    ACTIONS(6156), 1,
      sym__curly_bracket_span_mark_begin,
  [39430] = 1,
    ACTIONS(6158), 1,
      sym__parens_span_mark_begin,
  [39434] = 1,
    ACTIONS(6160), 1,
      anon_sym_RBRACK2,
  [39438] = 1,
    ACTIONS(6162), 1,
      sym__emphasis_mark_begin,
  [39442] = 1,
    ACTIONS(6164), 1,
      sym__strong_mark_begin,
  [39446] = 1,
    ACTIONS(6166), 1,
      sym__superscript_mark_begin,
  [39450] = 1,
    ACTIONS(6168), 1,
      sym__subscript_mark_begin,
  [39454] = 1,
    ACTIONS(6170), 1,
      sym__highlighted_mark_begin,
  [39458] = 1,
    ACTIONS(6172), 1,
      sym__insert_mark_begin,
  [39462] = 1,
    ACTIONS(6174), 1,
      sym__delete_mark_begin,
  [39466] = 1,
    ACTIONS(6176), 1,
      sym__square_bracket_span_mark_begin,
  [39470] = 1,
    ACTIONS(6178), 1,
      sym__curly_bracket_span_mark_begin,
  [39474] = 1,
    ACTIONS(6180), 1,
      sym__parens_span_mark_begin,
  [39478] = 1,
    ACTIONS(2573), 1,
      sym__indented_content_spacer,
  [39482] = 1,
    ACTIONS(6182), 1,
      sym__emphasis_mark_begin,
  [39486] = 1,
    ACTIONS(6184), 1,
      sym__strong_mark_begin,
  [39490] = 1,
    ACTIONS(6186), 1,
      sym__superscript_mark_begin,
  [39494] = 1,
    ACTIONS(6188), 1,
      sym__subscript_mark_begin,
  [39498] = 1,
    ACTIONS(6190), 1,
      sym__highlighted_mark_begin,
  [39502] = 1,
    ACTIONS(6192), 1,
      sym__insert_mark_begin,
  [39506] = 1,
    ACTIONS(6194), 1,
      sym__delete_mark_begin,
  [39510] = 1,
    ACTIONS(6196), 1,
      sym__square_bracket_span_mark_begin,
  [39514] = 1,
    ACTIONS(6198), 1,
      sym__curly_bracket_span_mark_begin,
  [39518] = 1,
    ACTIONS(6200), 1,
      sym__parens_span_mark_begin,
  [39522] = 1,
    ACTIONS(5412), 1,
      sym__square_bracket_span_end,
  [39526] = 1,
    ACTIONS(6202), 1,
      sym__emphasis_mark_begin,
  [39530] = 1,
    ACTIONS(6204), 1,
      sym__strong_mark_begin,
  [39534] = 1,
    ACTIONS(6206), 1,
      sym__superscript_mark_begin,
  [39538] = 1,
    ACTIONS(6208), 1,
      sym__subscript_mark_begin,
  [39542] = 1,
    ACTIONS(6210), 1,
      sym__highlighted_mark_begin,
  [39546] = 1,
    ACTIONS(6212), 1,
      sym__insert_mark_begin,
  [39550] = 1,
    ACTIONS(6214), 1,
      sym__curly_bracket_span_end,
  [39554] = 1,
    ACTIONS(6216), 1,
      sym__square_bracket_span_mark_begin,
  [39558] = 1,
    ACTIONS(6218), 1,
      sym__curly_bracket_span_mark_begin,
  [39562] = 1,
    ACTIONS(6220), 1,
      sym__parens_span_mark_begin,
  [39566] = 1,
    ACTIONS(712), 1,
      sym_list_marker_lower_alpha_paren,
  [39570] = 1,
    ACTIONS(6222), 1,
      sym__emphasis_mark_begin,
  [39574] = 1,
    ACTIONS(6224), 1,
      sym__strong_mark_begin,
  [39578] = 1,
    ACTIONS(6226), 1,
      sym__superscript_mark_begin,
  [39582] = 1,
    ACTIONS(6228), 1,
      sym__subscript_mark_begin,
  [39586] = 1,
    ACTIONS(6230), 1,
      sym__highlighted_mark_begin,
  [39590] = 1,
    ACTIONS(6232), 1,
      sym__insert_mark_begin,
  [39594] = 1,
    ACTIONS(6234), 1,
      sym__delete_mark_begin,
  [39598] = 1,
    ACTIONS(6236), 1,
      sym__square_bracket_span_mark_begin,
  [39602] = 1,
    ACTIONS(6238), 1,
      sym__curly_bracket_span_mark_begin,
  [39606] = 1,
    ACTIONS(6240), 1,
      sym__parens_span_mark_begin,
  [39610] = 1,
    ACTIONS(6242), 1,
      sym__newline,
  [39614] = 1,
    ACTIONS(6244), 1,
      sym__emphasis_mark_begin,
  [39618] = 1,
    ACTIONS(6246), 1,
      sym__strong_mark_begin,
  [39622] = 1,
    ACTIONS(6248), 1,
      sym__superscript_mark_begin,
  [39626] = 1,
    ACTIONS(6250), 1,
      sym__subscript_mark_begin,
  [39630] = 1,
    ACTIONS(6252), 1,
      sym__highlighted_mark_begin,
  [39634] = 1,
    ACTIONS(6254), 1,
      sym__insert_mark_begin,
  [39638] = 1,
    ACTIONS(6256), 1,
      sym__delete_mark_begin,
  [39642] = 1,
    ACTIONS(6258), 1,
      sym__square_bracket_span_mark_begin,
  [39646] = 1,
    ACTIONS(6260), 1,
      sym__curly_bracket_span_mark_begin,
  [39650] = 1,
    ACTIONS(6262), 1,
      sym__parens_span_mark_begin,
  [39654] = 1,
    ACTIONS(6264), 1,
      sym__newline,
  [39658] = 1,
    ACTIONS(6266), 1,
      sym__square_bracket_span_mark_begin,
  [39662] = 1,
    ACTIONS(6268), 1,
      anon_sym_EQ,
  [39666] = 1,
    ACTIONS(6270), 1,
      sym__link_ref_def_label_end,
  [39670] = 1,
    ACTIONS(6272), 1,
      sym__verbatim_content,
  [39674] = 1,
    ACTIONS(6274), 1,
      sym__square_bracket_span_mark_begin,
  [39678] = 1,
    ACTIONS(6276), 1,
      sym__delete_mark_begin,
  [39682] = 1,
    ACTIONS(6278), 1,
      sym__link_ref_def_label_end,
  [39686] = 1,
    ACTIONS(6280), 1,
      sym__newline,
  [39690] = 1,
    ACTIONS(6282), 1,
      sym__square_bracket_span_mark_begin,
  [39694] = 1,
    ACTIONS(6284), 1,
      anon_sym_RBRACE,
  [39698] = 1,
    ACTIONS(6286), 1,
      sym__link_ref_def_label_end,
  [39702] = 1,
    ACTIONS(6288), 1,
      sym__square_bracket_span_mark_begin,
  [39706] = 1,
    ACTIONS(6290), 1,
      sym__indented_content_spacer,
  [39710] = 1,
    ACTIONS(6292), 1,
      sym__link_ref_def_label_end,
  [39714] = 1,
    ACTIONS(6294), 1,
      sym__square_bracket_span_mark_begin,
  [39718] = 1,
    ACTIONS(6296), 1,
      sym__square_bracket_span_mark_begin,
  [39722] = 1,
    ACTIONS(6298), 1,
      sym__square_bracket_span_mark_begin,
  [39726] = 1,
    ACTIONS(6300), 1,
      sym__square_bracket_span_mark_begin,
  [39730] = 1,
    ACTIONS(6302), 1,
      sym__square_bracket_span_mark_begin,
  [39734] = 1,
    ACTIONS(6304), 1,
      sym__square_bracket_span_mark_begin,
  [39738] = 1,
    ACTIONS(6306), 1,
      sym__square_bracket_span_mark_begin,
  [39742] = 1,
    ACTIONS(6308), 1,
      sym__square_bracket_span_mark_begin,
  [39746] = 1,
    ACTIONS(6310), 1,
      sym_insert_end,
  [39750] = 1,
    ACTIONS(6312), 1,
      sym__newline,
  [39754] = 1,
    ACTIONS(6314), 1,
      sym_delete_end,
  [39758] = 1,
    ACTIONS(6316), 1,
      sym__square_bracket_span_end,
  [39762] = 1,
    ACTIONS(6318), 1,
      sym__newline,
  [39766] = 1,
    ACTIONS(722), 1,
      sym_list_marker_lower_alpha_parens,
  [39770] = 1,
    ACTIONS(6320), 1,
      sym__verbatim_end,
  [39774] = 1,
    ACTIONS(6322), 1,
      sym__newline,
  [39778] = 1,
    ACTIONS(6324), 1,
      anon_sym_LBRACK,
  [39782] = 1,
    ACTIONS(6326), 1,
      anon_sym_LBRACK,
  [39786] = 1,
    ACTIONS(6328), 1,
      anon_sym_LBRACK,
  [39790] = 1,
    ACTIONS(6330), 1,
      anon_sym_LBRACK,
  [39794] = 1,
    ACTIONS(6332), 1,
      sym__curly_bracket_span_mark_begin,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(431)] = 0,
  [SMALL_STATE(432)] = 69,
  [SMALL_STATE(433)] = 138,
  [SMALL_STATE(434)] = 206,
  [SMALL_STATE(435)] = 274,
  [SMALL_STATE(436)] = 338,
  [SMALL_STATE(437)] = 401,
  [SMALL_STATE(438)] = 457,
  [SMALL_STATE(439)] = 513,
  [SMALL_STATE(440)] = 569,
  [SMALL_STATE(441)] = 625,
  [SMALL_STATE(442)] = 681,
  [SMALL_STATE(443)] = 737,
  [SMALL_STATE(444)] = 793,
  [SMALL_STATE(445)] = 849,
  [SMALL_STATE(446)] = 905,
  [SMALL_STATE(447)] = 961,
  [SMALL_STATE(448)] = 1017,
  [SMALL_STATE(449)] = 1073,
  [SMALL_STATE(450)] = 1126,
  [SMALL_STATE(451)] = 1179,
  [SMALL_STATE(452)] = 1232,
  [SMALL_STATE(453)] = 1285,
  [SMALL_STATE(454)] = 1338,
  [SMALL_STATE(455)] = 1391,
  [SMALL_STATE(456)] = 1444,
  [SMALL_STATE(457)] = 1497,
  [SMALL_STATE(458)] = 1550,
  [SMALL_STATE(459)] = 1603,
  [SMALL_STATE(460)] = 1656,
  [SMALL_STATE(461)] = 1709,
  [SMALL_STATE(462)] = 1762,
  [SMALL_STATE(463)] = 1815,
  [SMALL_STATE(464)] = 1868,
  [SMALL_STATE(465)] = 1921,
  [SMALL_STATE(466)] = 1974,
  [SMALL_STATE(467)] = 2029,
  [SMALL_STATE(468)] = 2082,
  [SMALL_STATE(469)] = 2135,
  [SMALL_STATE(470)] = 2188,
  [SMALL_STATE(471)] = 2241,
  [SMALL_STATE(472)] = 2294,
  [SMALL_STATE(473)] = 2347,
  [SMALL_STATE(474)] = 2400,
  [SMALL_STATE(475)] = 2448,
  [SMALL_STATE(476)] = 2496,
  [SMALL_STATE(477)] = 2544,
  [SMALL_STATE(478)] = 2592,
  [SMALL_STATE(479)] = 2640,
  [SMALL_STATE(480)] = 2688,
  [SMALL_STATE(481)] = 2736,
  [SMALL_STATE(482)] = 2784,
  [SMALL_STATE(483)] = 2832,
  [SMALL_STATE(484)] = 2884,
  [SMALL_STATE(485)] = 2936,
  [SMALL_STATE(486)] = 2984,
  [SMALL_STATE(487)] = 3032,
  [SMALL_STATE(488)] = 3080,
  [SMALL_STATE(489)] = 3129,
  [SMALL_STATE(490)] = 3174,
  [SMALL_STATE(491)] = 3219,
  [SMALL_STATE(492)] = 3264,
  [SMALL_STATE(493)] = 3311,
  [SMALL_STATE(494)] = 3358,
  [SMALL_STATE(495)] = 3403,
  [SMALL_STATE(496)] = 3450,
  [SMALL_STATE(497)] = 3497,
  [SMALL_STATE(498)] = 3542,
  [SMALL_STATE(499)] = 3587,
  [SMALL_STATE(500)] = 3632,
  [SMALL_STATE(501)] = 3677,
  [SMALL_STATE(502)] = 3722,
  [SMALL_STATE(503)] = 3767,
  [SMALL_STATE(504)] = 3812,
  [SMALL_STATE(505)] = 3857,
  [SMALL_STATE(506)] = 3902,
  [SMALL_STATE(507)] = 3947,
  [SMALL_STATE(508)] = 3996,
  [SMALL_STATE(509)] = 4045,
  [SMALL_STATE(510)] = 4094,
  [SMALL_STATE(511)] = 4139,
  [SMALL_STATE(512)] = 4184,
  [SMALL_STATE(513)] = 4231,
  [SMALL_STATE(514)] = 4278,
  [SMALL_STATE(515)] = 4325,
  [SMALL_STATE(516)] = 4370,
  [SMALL_STATE(517)] = 4417,
  [SMALL_STATE(518)] = 4462,
  [SMALL_STATE(519)] = 4507,
  [SMALL_STATE(520)] = 4552,
  [SMALL_STATE(521)] = 4601,
  [SMALL_STATE(522)] = 4646,
  [SMALL_STATE(523)] = 4691,
  [SMALL_STATE(524)] = 4736,
  [SMALL_STATE(525)] = 4781,
  [SMALL_STATE(526)] = 4826,
  [SMALL_STATE(527)] = 4873,
  [SMALL_STATE(528)] = 4918,
  [SMALL_STATE(529)] = 4963,
  [SMALL_STATE(530)] = 5008,
  [SMALL_STATE(531)] = 5053,
  [SMALL_STATE(532)] = 5098,
  [SMALL_STATE(533)] = 5143,
  [SMALL_STATE(534)] = 5192,
  [SMALL_STATE(535)] = 5237,
  [SMALL_STATE(536)] = 5284,
  [SMALL_STATE(537)] = 5329,
  [SMALL_STATE(538)] = 5374,
  [SMALL_STATE(539)] = 5421,
  [SMALL_STATE(540)] = 5470,
  [SMALL_STATE(541)] = 5515,
  [SMALL_STATE(542)] = 5564,
  [SMALL_STATE(543)] = 5609,
  [SMALL_STATE(544)] = 5654,
  [SMALL_STATE(545)] = 5699,
  [SMALL_STATE(546)] = 5748,
  [SMALL_STATE(547)] = 5797,
  [SMALL_STATE(548)] = 5842,
  [SMALL_STATE(549)] = 5887,
  [SMALL_STATE(550)] = 5932,
  [SMALL_STATE(551)] = 5979,
  [SMALL_STATE(552)] = 6024,
  [SMALL_STATE(553)] = 6069,
  [SMALL_STATE(554)] = 6118,
  [SMALL_STATE(555)] = 6163,
  [SMALL_STATE(556)] = 6208,
  [SMALL_STATE(557)] = 6253,
  [SMALL_STATE(558)] = 6302,
  [SMALL_STATE(559)] = 6347,
  [SMALL_STATE(560)] = 6394,
  [SMALL_STATE(561)] = 6439,
  [SMALL_STATE(562)] = 6483,
  [SMALL_STATE(563)] = 6525,
  [SMALL_STATE(564)] = 6567,
  [SMALL_STATE(565)] = 6609,
  [SMALL_STATE(566)] = 6651,
  [SMALL_STATE(567)] = 6693,
  [SMALL_STATE(568)] = 6735,
  [SMALL_STATE(569)] = 6779,
  [SMALL_STATE(570)] = 6821,
  [SMALL_STATE(571)] = 6863,
  [SMALL_STATE(572)] = 6905,
  [SMALL_STATE(573)] = 6947,
  [SMALL_STATE(574)] = 6989,
  [SMALL_STATE(575)] = 7031,
  [SMALL_STATE(576)] = 7073,
  [SMALL_STATE(577)] = 7115,
  [SMALL_STATE(578)] = 7157,
  [SMALL_STATE(579)] = 7199,
  [SMALL_STATE(580)] = 7241,
  [SMALL_STATE(581)] = 7283,
  [SMALL_STATE(582)] = 7325,
  [SMALL_STATE(583)] = 7367,
  [SMALL_STATE(584)] = 7409,
  [SMALL_STATE(585)] = 7451,
  [SMALL_STATE(586)] = 7493,
  [SMALL_STATE(587)] = 7535,
  [SMALL_STATE(588)] = 7577,
  [SMALL_STATE(589)] = 7621,
  [SMALL_STATE(590)] = 7665,
  [SMALL_STATE(591)] = 7707,
  [SMALL_STATE(592)] = 7749,
  [SMALL_STATE(593)] = 7791,
  [SMALL_STATE(594)] = 7833,
  [SMALL_STATE(595)] = 7875,
  [SMALL_STATE(596)] = 7917,
  [SMALL_STATE(597)] = 7959,
  [SMALL_STATE(598)] = 8001,
  [SMALL_STATE(599)] = 8043,
  [SMALL_STATE(600)] = 8085,
  [SMALL_STATE(601)] = 8127,
  [SMALL_STATE(602)] = 8169,
  [SMALL_STATE(603)] = 8211,
  [SMALL_STATE(604)] = 8253,
  [SMALL_STATE(605)] = 8295,
  [SMALL_STATE(606)] = 8337,
  [SMALL_STATE(607)] = 8379,
  [SMALL_STATE(608)] = 8421,
  [SMALL_STATE(609)] = 8463,
  [SMALL_STATE(610)] = 8505,
  [SMALL_STATE(611)] = 8547,
  [SMALL_STATE(612)] = 8589,
  [SMALL_STATE(613)] = 8631,
  [SMALL_STATE(614)] = 8673,
  [SMALL_STATE(615)] = 8715,
  [SMALL_STATE(616)] = 8757,
  [SMALL_STATE(617)] = 8801,
  [SMALL_STATE(618)] = 8845,
  [SMALL_STATE(619)] = 8887,
  [SMALL_STATE(620)] = 8929,
  [SMALL_STATE(621)] = 8971,
  [SMALL_STATE(622)] = 9013,
  [SMALL_STATE(623)] = 9055,
  [SMALL_STATE(624)] = 9097,
  [SMALL_STATE(625)] = 9139,
  [SMALL_STATE(626)] = 9181,
  [SMALL_STATE(627)] = 9223,
  [SMALL_STATE(628)] = 9265,
  [SMALL_STATE(629)] = 9307,
  [SMALL_STATE(630)] = 9349,
  [SMALL_STATE(631)] = 9391,
  [SMALL_STATE(632)] = 9433,
  [SMALL_STATE(633)] = 9475,
  [SMALL_STATE(634)] = 9517,
  [SMALL_STATE(635)] = 9559,
  [SMALL_STATE(636)] = 9601,
  [SMALL_STATE(637)] = 9643,
  [SMALL_STATE(638)] = 9685,
  [SMALL_STATE(639)] = 9727,
  [SMALL_STATE(640)] = 9769,
  [SMALL_STATE(641)] = 9811,
  [SMALL_STATE(642)] = 9853,
  [SMALL_STATE(643)] = 9895,
  [SMALL_STATE(644)] = 9939,
  [SMALL_STATE(645)] = 9983,
  [SMALL_STATE(646)] = 10025,
  [SMALL_STATE(647)] = 10067,
  [SMALL_STATE(648)] = 10109,
  [SMALL_STATE(649)] = 10151,
  [SMALL_STATE(650)] = 10193,
  [SMALL_STATE(651)] = 10235,
  [SMALL_STATE(652)] = 10277,
  [SMALL_STATE(653)] = 10319,
  [SMALL_STATE(654)] = 10361,
  [SMALL_STATE(655)] = 10403,
  [SMALL_STATE(656)] = 10445,
  [SMALL_STATE(657)] = 10487,
  [SMALL_STATE(658)] = 10529,
  [SMALL_STATE(659)] = 10571,
  [SMALL_STATE(660)] = 10613,
  [SMALL_STATE(661)] = 10655,
  [SMALL_STATE(662)] = 10697,
  [SMALL_STATE(663)] = 10739,
  [SMALL_STATE(664)] = 10781,
  [SMALL_STATE(665)] = 10823,
  [SMALL_STATE(666)] = 10865,
  [SMALL_STATE(667)] = 10907,
  [SMALL_STATE(668)] = 10949,
  [SMALL_STATE(669)] = 10991,
  [SMALL_STATE(670)] = 11033,
  [SMALL_STATE(671)] = 11075,
  [SMALL_STATE(672)] = 11117,
  [SMALL_STATE(673)] = 11159,
  [SMALL_STATE(674)] = 11203,
  [SMALL_STATE(675)] = 11245,
  [SMALL_STATE(676)] = 11287,
  [SMALL_STATE(677)] = 11329,
  [SMALL_STATE(678)] = 11373,
  [SMALL_STATE(679)] = 11415,
  [SMALL_STATE(680)] = 11457,
  [SMALL_STATE(681)] = 11499,
  [SMALL_STATE(682)] = 11541,
  [SMALL_STATE(683)] = 11583,
  [SMALL_STATE(684)] = 11625,
  [SMALL_STATE(685)] = 11667,
  [SMALL_STATE(686)] = 11709,
  [SMALL_STATE(687)] = 11751,
  [SMALL_STATE(688)] = 11793,
  [SMALL_STATE(689)] = 11835,
  [SMALL_STATE(690)] = 11877,
  [SMALL_STATE(691)] = 11919,
  [SMALL_STATE(692)] = 11961,
  [SMALL_STATE(693)] = 12003,
  [SMALL_STATE(694)] = 12045,
  [SMALL_STATE(695)] = 12087,
  [SMALL_STATE(696)] = 12129,
  [SMALL_STATE(697)] = 12171,
  [SMALL_STATE(698)] = 12213,
  [SMALL_STATE(699)] = 12255,
  [SMALL_STATE(700)] = 12297,
  [SMALL_STATE(701)] = 12339,
  [SMALL_STATE(702)] = 12381,
  [SMALL_STATE(703)] = 12423,
  [SMALL_STATE(704)] = 12465,
  [SMALL_STATE(705)] = 12507,
  [SMALL_STATE(706)] = 12549,
  [SMALL_STATE(707)] = 12591,
  [SMALL_STATE(708)] = 12633,
  [SMALL_STATE(709)] = 12675,
  [SMALL_STATE(710)] = 12717,
  [SMALL_STATE(711)] = 12761,
  [SMALL_STATE(712)] = 12803,
  [SMALL_STATE(713)] = 12845,
  [SMALL_STATE(714)] = 12887,
  [SMALL_STATE(715)] = 12929,
  [SMALL_STATE(716)] = 12971,
  [SMALL_STATE(717)] = 13013,
  [SMALL_STATE(718)] = 13055,
  [SMALL_STATE(719)] = 13097,
  [SMALL_STATE(720)] = 13139,
  [SMALL_STATE(721)] = 13181,
  [SMALL_STATE(722)] = 13223,
  [SMALL_STATE(723)] = 13265,
  [SMALL_STATE(724)] = 13307,
  [SMALL_STATE(725)] = 13349,
  [SMALL_STATE(726)] = 13391,
  [SMALL_STATE(727)] = 13433,
  [SMALL_STATE(728)] = 13475,
  [SMALL_STATE(729)] = 13517,
  [SMALL_STATE(730)] = 13559,
  [SMALL_STATE(731)] = 13601,
  [SMALL_STATE(732)] = 13643,
  [SMALL_STATE(733)] = 13685,
  [SMALL_STATE(734)] = 13727,
  [SMALL_STATE(735)] = 13769,
  [SMALL_STATE(736)] = 13811,
  [SMALL_STATE(737)] = 13855,
  [SMALL_STATE(738)] = 13899,
  [SMALL_STATE(739)] = 13941,
  [SMALL_STATE(740)] = 13983,
  [SMALL_STATE(741)] = 14025,
  [SMALL_STATE(742)] = 14067,
  [SMALL_STATE(743)] = 14109,
  [SMALL_STATE(744)] = 14151,
  [SMALL_STATE(745)] = 14193,
  [SMALL_STATE(746)] = 14235,
  [SMALL_STATE(747)] = 14277,
  [SMALL_STATE(748)] = 14319,
  [SMALL_STATE(749)] = 14361,
  [SMALL_STATE(750)] = 14403,
  [SMALL_STATE(751)] = 14445,
  [SMALL_STATE(752)] = 14487,
  [SMALL_STATE(753)] = 14529,
  [SMALL_STATE(754)] = 14571,
  [SMALL_STATE(755)] = 14613,
  [SMALL_STATE(756)] = 14655,
  [SMALL_STATE(757)] = 14697,
  [SMALL_STATE(758)] = 14739,
  [SMALL_STATE(759)] = 14781,
  [SMALL_STATE(760)] = 14823,
  [SMALL_STATE(761)] = 14865,
  [SMALL_STATE(762)] = 14907,
  [SMALL_STATE(763)] = 14949,
  [SMALL_STATE(764)] = 14991,
  [SMALL_STATE(765)] = 15033,
  [SMALL_STATE(766)] = 15077,
  [SMALL_STATE(767)] = 15121,
  [SMALL_STATE(768)] = 15163,
  [SMALL_STATE(769)] = 15205,
  [SMALL_STATE(770)] = 15247,
  [SMALL_STATE(771)] = 15289,
  [SMALL_STATE(772)] = 15331,
  [SMALL_STATE(773)] = 15373,
  [SMALL_STATE(774)] = 15415,
  [SMALL_STATE(775)] = 15457,
  [SMALL_STATE(776)] = 15499,
  [SMALL_STATE(777)] = 15541,
  [SMALL_STATE(778)] = 15583,
  [SMALL_STATE(779)] = 15625,
  [SMALL_STATE(780)] = 15667,
  [SMALL_STATE(781)] = 15709,
  [SMALL_STATE(782)] = 15751,
  [SMALL_STATE(783)] = 15793,
  [SMALL_STATE(784)] = 15835,
  [SMALL_STATE(785)] = 15877,
  [SMALL_STATE(786)] = 15919,
  [SMALL_STATE(787)] = 15961,
  [SMALL_STATE(788)] = 16003,
  [SMALL_STATE(789)] = 16045,
  [SMALL_STATE(790)] = 16087,
  [SMALL_STATE(791)] = 16129,
  [SMALL_STATE(792)] = 16171,
  [SMALL_STATE(793)] = 16213,
  [SMALL_STATE(794)] = 16257,
  [SMALL_STATE(795)] = 16299,
  [SMALL_STATE(796)] = 16341,
  [SMALL_STATE(797)] = 16383,
  [SMALL_STATE(798)] = 16425,
  [SMALL_STATE(799)] = 16467,
  [SMALL_STATE(800)] = 16509,
  [SMALL_STATE(801)] = 16551,
  [SMALL_STATE(802)] = 16593,
  [SMALL_STATE(803)] = 16635,
  [SMALL_STATE(804)] = 16677,
  [SMALL_STATE(805)] = 16719,
  [SMALL_STATE(806)] = 16761,
  [SMALL_STATE(807)] = 16803,
  [SMALL_STATE(808)] = 16845,
  [SMALL_STATE(809)] = 16887,
  [SMALL_STATE(810)] = 16929,
  [SMALL_STATE(811)] = 16971,
  [SMALL_STATE(812)] = 17013,
  [SMALL_STATE(813)] = 17055,
  [SMALL_STATE(814)] = 17097,
  [SMALL_STATE(815)] = 17139,
  [SMALL_STATE(816)] = 17181,
  [SMALL_STATE(817)] = 17223,
  [SMALL_STATE(818)] = 17265,
  [SMALL_STATE(819)] = 17307,
  [SMALL_STATE(820)] = 17349,
  [SMALL_STATE(821)] = 17393,
  [SMALL_STATE(822)] = 17437,
  [SMALL_STATE(823)] = 17481,
  [SMALL_STATE(824)] = 17529,
  [SMALL_STATE(825)] = 17571,
  [SMALL_STATE(826)] = 17613,
  [SMALL_STATE(827)] = 17657,
  [SMALL_STATE(828)] = 17703,
  [SMALL_STATE(829)] = 17745,
  [SMALL_STATE(830)] = 17787,
  [SMALL_STATE(831)] = 17829,
  [SMALL_STATE(832)] = 17873,
  [SMALL_STATE(833)] = 17917,
  [SMALL_STATE(834)] = 17961,
  [SMALL_STATE(835)] = 18003,
  [SMALL_STATE(836)] = 18045,
  [SMALL_STATE(837)] = 18091,
  [SMALL_STATE(838)] = 18133,
  [SMALL_STATE(839)] = 18175,
  [SMALL_STATE(840)] = 18217,
  [SMALL_STATE(841)] = 18259,
  [SMALL_STATE(842)] = 18301,
  [SMALL_STATE(843)] = 18343,
  [SMALL_STATE(844)] = 18385,
  [SMALL_STATE(845)] = 18431,
  [SMALL_STATE(846)] = 18473,
  [SMALL_STATE(847)] = 18515,
  [SMALL_STATE(848)] = 18557,
  [SMALL_STATE(849)] = 18599,
  [SMALL_STATE(850)] = 18641,
  [SMALL_STATE(851)] = 18683,
  [SMALL_STATE(852)] = 18725,
  [SMALL_STATE(853)] = 18767,
  [SMALL_STATE(854)] = 18809,
  [SMALL_STATE(855)] = 18851,
  [SMALL_STATE(856)] = 18893,
  [SMALL_STATE(857)] = 18935,
  [SMALL_STATE(858)] = 18977,
  [SMALL_STATE(859)] = 19019,
  [SMALL_STATE(860)] = 19061,
  [SMALL_STATE(861)] = 19103,
  [SMALL_STATE(862)] = 19145,
  [SMALL_STATE(863)] = 19189,
  [SMALL_STATE(864)] = 19233,
  [SMALL_STATE(865)] = 19275,
  [SMALL_STATE(866)] = 19317,
  [SMALL_STATE(867)] = 19359,
  [SMALL_STATE(868)] = 19401,
  [SMALL_STATE(869)] = 19443,
  [SMALL_STATE(870)] = 19485,
  [SMALL_STATE(871)] = 19527,
  [SMALL_STATE(872)] = 19569,
  [SMALL_STATE(873)] = 19611,
  [SMALL_STATE(874)] = 19653,
  [SMALL_STATE(875)] = 19695,
  [SMALL_STATE(876)] = 19737,
  [SMALL_STATE(877)] = 19779,
  [SMALL_STATE(878)] = 19821,
  [SMALL_STATE(879)] = 19863,
  [SMALL_STATE(880)] = 19905,
  [SMALL_STATE(881)] = 19947,
  [SMALL_STATE(882)] = 19989,
  [SMALL_STATE(883)] = 20031,
  [SMALL_STATE(884)] = 20073,
  [SMALL_STATE(885)] = 20115,
  [SMALL_STATE(886)] = 20157,
  [SMALL_STATE(887)] = 20199,
  [SMALL_STATE(888)] = 20241,
  [SMALL_STATE(889)] = 20283,
  [SMALL_STATE(890)] = 20327,
  [SMALL_STATE(891)] = 20369,
  [SMALL_STATE(892)] = 20411,
  [SMALL_STATE(893)] = 20453,
  [SMALL_STATE(894)] = 20494,
  [SMALL_STATE(895)] = 20535,
  [SMALL_STATE(896)] = 20576,
  [SMALL_STATE(897)] = 20617,
  [SMALL_STATE(898)] = 20658,
  [SMALL_STATE(899)] = 20699,
  [SMALL_STATE(900)] = 20740,
  [SMALL_STATE(901)] = 20781,
  [SMALL_STATE(902)] = 20822,
  [SMALL_STATE(903)] = 20865,
  [SMALL_STATE(904)] = 20906,
  [SMALL_STATE(905)] = 20947,
  [SMALL_STATE(906)] = 20988,
  [SMALL_STATE(907)] = 21029,
  [SMALL_STATE(908)] = 21070,
  [SMALL_STATE(909)] = 21111,
  [SMALL_STATE(910)] = 21152,
  [SMALL_STATE(911)] = 21193,
  [SMALL_STATE(912)] = 21234,
  [SMALL_STATE(913)] = 21275,
  [SMALL_STATE(914)] = 21316,
  [SMALL_STATE(915)] = 21357,
  [SMALL_STATE(916)] = 21398,
  [SMALL_STATE(917)] = 21439,
  [SMALL_STATE(918)] = 21480,
  [SMALL_STATE(919)] = 21521,
  [SMALL_STATE(920)] = 21562,
  [SMALL_STATE(921)] = 21603,
  [SMALL_STATE(922)] = 21644,
  [SMALL_STATE(923)] = 21685,
  [SMALL_STATE(924)] = 21726,
  [SMALL_STATE(925)] = 21767,
  [SMALL_STATE(926)] = 21808,
  [SMALL_STATE(927)] = 21849,
  [SMALL_STATE(928)] = 21890,
  [SMALL_STATE(929)] = 21931,
  [SMALL_STATE(930)] = 21972,
  [SMALL_STATE(931)] = 22013,
  [SMALL_STATE(932)] = 22054,
  [SMALL_STATE(933)] = 22095,
  [SMALL_STATE(934)] = 22136,
  [SMALL_STATE(935)] = 22177,
  [SMALL_STATE(936)] = 22218,
  [SMALL_STATE(937)] = 22259,
  [SMALL_STATE(938)] = 22300,
  [SMALL_STATE(939)] = 22341,
  [SMALL_STATE(940)] = 22382,
  [SMALL_STATE(941)] = 22423,
  [SMALL_STATE(942)] = 22464,
  [SMALL_STATE(943)] = 22505,
  [SMALL_STATE(944)] = 22546,
  [SMALL_STATE(945)] = 22587,
  [SMALL_STATE(946)] = 22628,
  [SMALL_STATE(947)] = 22669,
  [SMALL_STATE(948)] = 22710,
  [SMALL_STATE(949)] = 22751,
  [SMALL_STATE(950)] = 22792,
  [SMALL_STATE(951)] = 22833,
  [SMALL_STATE(952)] = 22874,
  [SMALL_STATE(953)] = 22915,
  [SMALL_STATE(954)] = 22956,
  [SMALL_STATE(955)] = 22997,
  [SMALL_STATE(956)] = 23038,
  [SMALL_STATE(957)] = 23079,
  [SMALL_STATE(958)] = 23120,
  [SMALL_STATE(959)] = 23161,
  [SMALL_STATE(960)] = 23204,
  [SMALL_STATE(961)] = 23245,
  [SMALL_STATE(962)] = 23286,
  [SMALL_STATE(963)] = 23327,
  [SMALL_STATE(964)] = 23368,
  [SMALL_STATE(965)] = 23411,
  [SMALL_STATE(966)] = 23452,
  [SMALL_STATE(967)] = 23493,
  [SMALL_STATE(968)] = 23534,
  [SMALL_STATE(969)] = 23575,
  [SMALL_STATE(970)] = 23616,
  [SMALL_STATE(971)] = 23657,
  [SMALL_STATE(972)] = 23698,
  [SMALL_STATE(973)] = 23739,
  [SMALL_STATE(974)] = 23780,
  [SMALL_STATE(975)] = 23821,
  [SMALL_STATE(976)] = 23862,
  [SMALL_STATE(977)] = 23903,
  [SMALL_STATE(978)] = 23944,
  [SMALL_STATE(979)] = 23985,
  [SMALL_STATE(980)] = 24026,
  [SMALL_STATE(981)] = 24067,
  [SMALL_STATE(982)] = 24108,
  [SMALL_STATE(983)] = 24149,
  [SMALL_STATE(984)] = 24190,
  [SMALL_STATE(985)] = 24231,
  [SMALL_STATE(986)] = 24272,
  [SMALL_STATE(987)] = 24313,
  [SMALL_STATE(988)] = 24354,
  [SMALL_STATE(989)] = 24397,
  [SMALL_STATE(990)] = 24438,
  [SMALL_STATE(991)] = 24479,
  [SMALL_STATE(992)] = 24520,
  [SMALL_STATE(993)] = 24561,
  [SMALL_STATE(994)] = 24602,
  [SMALL_STATE(995)] = 24643,
  [SMALL_STATE(996)] = 24684,
  [SMALL_STATE(997)] = 24725,
  [SMALL_STATE(998)] = 24766,
  [SMALL_STATE(999)] = 24807,
  [SMALL_STATE(1000)] = 24848,
  [SMALL_STATE(1001)] = 24889,
  [SMALL_STATE(1002)] = 24930,
  [SMALL_STATE(1003)] = 24971,
  [SMALL_STATE(1004)] = 25012,
  [SMALL_STATE(1005)] = 25053,
  [SMALL_STATE(1006)] = 25094,
  [SMALL_STATE(1007)] = 25135,
  [SMALL_STATE(1008)] = 25176,
  [SMALL_STATE(1009)] = 25217,
  [SMALL_STATE(1010)] = 25260,
  [SMALL_STATE(1011)] = 25301,
  [SMALL_STATE(1012)] = 25342,
  [SMALL_STATE(1013)] = 25383,
  [SMALL_STATE(1014)] = 25426,
  [SMALL_STATE(1015)] = 25467,
  [SMALL_STATE(1016)] = 25508,
  [SMALL_STATE(1017)] = 25549,
  [SMALL_STATE(1018)] = 25590,
  [SMALL_STATE(1019)] = 25633,
  [SMALL_STATE(1020)] = 25676,
  [SMALL_STATE(1021)] = 25717,
  [SMALL_STATE(1022)] = 25758,
  [SMALL_STATE(1023)] = 25798,
  [SMALL_STATE(1024)] = 25838,
  [SMALL_STATE(1025)] = 25878,
  [SMALL_STATE(1026)] = 25918,
  [SMALL_STATE(1027)] = 25958,
  [SMALL_STATE(1028)] = 25998,
  [SMALL_STATE(1029)] = 26038,
  [SMALL_STATE(1030)] = 26078,
  [SMALL_STATE(1031)] = 26117,
  [SMALL_STATE(1032)] = 26155,
  [SMALL_STATE(1033)] = 26187,
  [SMALL_STATE(1034)] = 26225,
  [SMALL_STATE(1035)] = 26256,
  [SMALL_STATE(1036)] = 26287,
  [SMALL_STATE(1037)] = 26318,
  [SMALL_STATE(1038)] = 26349,
  [SMALL_STATE(1039)] = 26380,
  [SMALL_STATE(1040)] = 26411,
  [SMALL_STATE(1041)] = 26442,
  [SMALL_STATE(1042)] = 26473,
  [SMALL_STATE(1043)] = 26504,
  [SMALL_STATE(1044)] = 26535,
  [SMALL_STATE(1045)] = 26566,
  [SMALL_STATE(1046)] = 26597,
  [SMALL_STATE(1047)] = 26628,
  [SMALL_STATE(1048)] = 26659,
  [SMALL_STATE(1049)] = 26690,
  [SMALL_STATE(1050)] = 26721,
  [SMALL_STATE(1051)] = 26752,
  [SMALL_STATE(1052)] = 26783,
  [SMALL_STATE(1053)] = 26814,
  [SMALL_STATE(1054)] = 26845,
  [SMALL_STATE(1055)] = 26876,
  [SMALL_STATE(1056)] = 26907,
  [SMALL_STATE(1057)] = 26938,
  [SMALL_STATE(1058)] = 26969,
  [SMALL_STATE(1059)] = 27000,
  [SMALL_STATE(1060)] = 27031,
  [SMALL_STATE(1061)] = 27062,
  [SMALL_STATE(1062)] = 27093,
  [SMALL_STATE(1063)] = 27124,
  [SMALL_STATE(1064)] = 27155,
  [SMALL_STATE(1065)] = 27186,
  [SMALL_STATE(1066)] = 27217,
  [SMALL_STATE(1067)] = 27248,
  [SMALL_STATE(1068)] = 27279,
  [SMALL_STATE(1069)] = 27310,
  [SMALL_STATE(1070)] = 27341,
  [SMALL_STATE(1071)] = 27372,
  [SMALL_STATE(1072)] = 27403,
  [SMALL_STATE(1073)] = 27434,
  [SMALL_STATE(1074)] = 27465,
  [SMALL_STATE(1075)] = 27476,
  [SMALL_STATE(1076)] = 27499,
  [SMALL_STATE(1077)] = 27510,
  [SMALL_STATE(1078)] = 27535,
  [SMALL_STATE(1079)] = 27546,
  [SMALL_STATE(1080)] = 27569,
  [SMALL_STATE(1081)] = 27594,
  [SMALL_STATE(1082)] = 27617,
  [SMALL_STATE(1083)] = 27640,
  [SMALL_STATE(1084)] = 27665,
  [SMALL_STATE(1085)] = 27690,
  [SMALL_STATE(1086)] = 27701,
  [SMALL_STATE(1087)] = 27724,
  [SMALL_STATE(1088)] = 27735,
  [SMALL_STATE(1089)] = 27758,
  [SMALL_STATE(1090)] = 27781,
  [SMALL_STATE(1091)] = 27804,
  [SMALL_STATE(1092)] = 27829,
  [SMALL_STATE(1093)] = 27840,
  [SMALL_STATE(1094)] = 27863,
  [SMALL_STATE(1095)] = 27886,
  [SMALL_STATE(1096)] = 27909,
  [SMALL_STATE(1097)] = 27932,
  [SMALL_STATE(1098)] = 27955,
  [SMALL_STATE(1099)] = 27978,
  [SMALL_STATE(1100)] = 28001,
  [SMALL_STATE(1101)] = 28026,
  [SMALL_STATE(1102)] = 28037,
  [SMALL_STATE(1103)] = 28059,
  [SMALL_STATE(1104)] = 28081,
  [SMALL_STATE(1105)] = 28103,
  [SMALL_STATE(1106)] = 28125,
  [SMALL_STATE(1107)] = 28147,
  [SMALL_STATE(1108)] = 28169,
  [SMALL_STATE(1109)] = 28191,
  [SMALL_STATE(1110)] = 28213,
  [SMALL_STATE(1111)] = 28235,
  [SMALL_STATE(1112)] = 28257,
  [SMALL_STATE(1113)] = 28279,
  [SMALL_STATE(1114)] = 28301,
  [SMALL_STATE(1115)] = 28323,
  [SMALL_STATE(1116)] = 28345,
  [SMALL_STATE(1117)] = 28367,
  [SMALL_STATE(1118)] = 28389,
  [SMALL_STATE(1119)] = 28411,
  [SMALL_STATE(1120)] = 28433,
  [SMALL_STATE(1121)] = 28455,
  [SMALL_STATE(1122)] = 28477,
  [SMALL_STATE(1123)] = 28499,
  [SMALL_STATE(1124)] = 28521,
  [SMALL_STATE(1125)] = 28543,
  [SMALL_STATE(1126)] = 28565,
  [SMALL_STATE(1127)] = 28587,
  [SMALL_STATE(1128)] = 28609,
  [SMALL_STATE(1129)] = 28631,
  [SMALL_STATE(1130)] = 28653,
  [SMALL_STATE(1131)] = 28663,
  [SMALL_STATE(1132)] = 28673,
  [SMALL_STATE(1133)] = 28695,
  [SMALL_STATE(1134)] = 28705,
  [SMALL_STATE(1135)] = 28727,
  [SMALL_STATE(1136)] = 28749,
  [SMALL_STATE(1137)] = 28759,
  [SMALL_STATE(1138)] = 28769,
  [SMALL_STATE(1139)] = 28779,
  [SMALL_STATE(1140)] = 28799,
  [SMALL_STATE(1141)] = 28821,
  [SMALL_STATE(1142)] = 28843,
  [SMALL_STATE(1143)] = 28865,
  [SMALL_STATE(1144)] = 28875,
  [SMALL_STATE(1145)] = 28897,
  [SMALL_STATE(1146)] = 28919,
  [SMALL_STATE(1147)] = 28941,
  [SMALL_STATE(1148)] = 28963,
  [SMALL_STATE(1149)] = 28985,
  [SMALL_STATE(1150)] = 29007,
  [SMALL_STATE(1151)] = 29029,
  [SMALL_STATE(1152)] = 29051,
  [SMALL_STATE(1153)] = 29073,
  [SMALL_STATE(1154)] = 29095,
  [SMALL_STATE(1155)] = 29117,
  [SMALL_STATE(1156)] = 29139,
  [SMALL_STATE(1157)] = 29161,
  [SMALL_STATE(1158)] = 29183,
  [SMALL_STATE(1159)] = 29205,
  [SMALL_STATE(1160)] = 29227,
  [SMALL_STATE(1161)] = 29237,
  [SMALL_STATE(1162)] = 29247,
  [SMALL_STATE(1163)] = 29257,
  [SMALL_STATE(1164)] = 29279,
  [SMALL_STATE(1165)] = 29289,
  [SMALL_STATE(1166)] = 29311,
  [SMALL_STATE(1167)] = 29333,
  [SMALL_STATE(1168)] = 29355,
  [SMALL_STATE(1169)] = 29377,
  [SMALL_STATE(1170)] = 29387,
  [SMALL_STATE(1171)] = 29409,
  [SMALL_STATE(1172)] = 29431,
  [SMALL_STATE(1173)] = 29453,
  [SMALL_STATE(1174)] = 29475,
  [SMALL_STATE(1175)] = 29497,
  [SMALL_STATE(1176)] = 29519,
  [SMALL_STATE(1177)] = 29541,
  [SMALL_STATE(1178)] = 29563,
  [SMALL_STATE(1179)] = 29573,
  [SMALL_STATE(1180)] = 29595,
  [SMALL_STATE(1181)] = 29617,
  [SMALL_STATE(1182)] = 29639,
  [SMALL_STATE(1183)] = 29661,
  [SMALL_STATE(1184)] = 29683,
  [SMALL_STATE(1185)] = 29705,
  [SMALL_STATE(1186)] = 29715,
  [SMALL_STATE(1187)] = 29737,
  [SMALL_STATE(1188)] = 29747,
  [SMALL_STATE(1189)] = 29757,
  [SMALL_STATE(1190)] = 29767,
  [SMALL_STATE(1191)] = 29777,
  [SMALL_STATE(1192)] = 29787,
  [SMALL_STATE(1193)] = 29809,
  [SMALL_STATE(1194)] = 29831,
  [SMALL_STATE(1195)] = 29853,
  [SMALL_STATE(1196)] = 29875,
  [SMALL_STATE(1197)] = 29897,
  [SMALL_STATE(1198)] = 29907,
  [SMALL_STATE(1199)] = 29929,
  [SMALL_STATE(1200)] = 29951,
  [SMALL_STATE(1201)] = 29973,
  [SMALL_STATE(1202)] = 29995,
  [SMALL_STATE(1203)] = 30017,
  [SMALL_STATE(1204)] = 30039,
  [SMALL_STATE(1205)] = 30061,
  [SMALL_STATE(1206)] = 30071,
  [SMALL_STATE(1207)] = 30081,
  [SMALL_STATE(1208)] = 30091,
  [SMALL_STATE(1209)] = 30113,
  [SMALL_STATE(1210)] = 30135,
  [SMALL_STATE(1211)] = 30155,
  [SMALL_STATE(1212)] = 30177,
  [SMALL_STATE(1213)] = 30199,
  [SMALL_STATE(1214)] = 30221,
  [SMALL_STATE(1215)] = 30243,
  [SMALL_STATE(1216)] = 30265,
  [SMALL_STATE(1217)] = 30287,
  [SMALL_STATE(1218)] = 30297,
  [SMALL_STATE(1219)] = 30319,
  [SMALL_STATE(1220)] = 30341,
  [SMALL_STATE(1221)] = 30363,
  [SMALL_STATE(1222)] = 30385,
  [SMALL_STATE(1223)] = 30407,
  [SMALL_STATE(1224)] = 30429,
  [SMALL_STATE(1225)] = 30451,
  [SMALL_STATE(1226)] = 30473,
  [SMALL_STATE(1227)] = 30483,
  [SMALL_STATE(1228)] = 30493,
  [SMALL_STATE(1229)] = 30503,
  [SMALL_STATE(1230)] = 30513,
  [SMALL_STATE(1231)] = 30535,
  [SMALL_STATE(1232)] = 30545,
  [SMALL_STATE(1233)] = 30555,
  [SMALL_STATE(1234)] = 30565,
  [SMALL_STATE(1235)] = 30575,
  [SMALL_STATE(1236)] = 30597,
  [SMALL_STATE(1237)] = 30619,
  [SMALL_STATE(1238)] = 30641,
  [SMALL_STATE(1239)] = 30663,
  [SMALL_STATE(1240)] = 30685,
  [SMALL_STATE(1241)] = 30707,
  [SMALL_STATE(1242)] = 30729,
  [SMALL_STATE(1243)] = 30751,
  [SMALL_STATE(1244)] = 30773,
  [SMALL_STATE(1245)] = 30792,
  [SMALL_STATE(1246)] = 30811,
  [SMALL_STATE(1247)] = 30830,
  [SMALL_STATE(1248)] = 30849,
  [SMALL_STATE(1249)] = 30868,
  [SMALL_STATE(1250)] = 30885,
  [SMALL_STATE(1251)] = 30904,
  [SMALL_STATE(1252)] = 30923,
  [SMALL_STATE(1253)] = 30942,
  [SMALL_STATE(1254)] = 30961,
  [SMALL_STATE(1255)] = 30980,
  [SMALL_STATE(1256)] = 30999,
  [SMALL_STATE(1257)] = 31016,
  [SMALL_STATE(1258)] = 31035,
  [SMALL_STATE(1259)] = 31054,
  [SMALL_STATE(1260)] = 31073,
  [SMALL_STATE(1261)] = 31092,
  [SMALL_STATE(1262)] = 31111,
  [SMALL_STATE(1263)] = 31130,
  [SMALL_STATE(1264)] = 31147,
  [SMALL_STATE(1265)] = 31166,
  [SMALL_STATE(1266)] = 31185,
  [SMALL_STATE(1267)] = 31204,
  [SMALL_STATE(1268)] = 31223,
  [SMALL_STATE(1269)] = 31242,
  [SMALL_STATE(1270)] = 31261,
  [SMALL_STATE(1271)] = 31278,
  [SMALL_STATE(1272)] = 31297,
  [SMALL_STATE(1273)] = 31316,
  [SMALL_STATE(1274)] = 31335,
  [SMALL_STATE(1275)] = 31354,
  [SMALL_STATE(1276)] = 31369,
  [SMALL_STATE(1277)] = 31388,
  [SMALL_STATE(1278)] = 31405,
  [SMALL_STATE(1279)] = 31424,
  [SMALL_STATE(1280)] = 31443,
  [SMALL_STATE(1281)] = 31462,
  [SMALL_STATE(1282)] = 31481,
  [SMALL_STATE(1283)] = 31500,
  [SMALL_STATE(1284)] = 31519,
  [SMALL_STATE(1285)] = 31536,
  [SMALL_STATE(1286)] = 31555,
  [SMALL_STATE(1287)] = 31574,
  [SMALL_STATE(1288)] = 31593,
  [SMALL_STATE(1289)] = 31612,
  [SMALL_STATE(1290)] = 31631,
  [SMALL_STATE(1291)] = 31650,
  [SMALL_STATE(1292)] = 31669,
  [SMALL_STATE(1293)] = 31688,
  [SMALL_STATE(1294)] = 31707,
  [SMALL_STATE(1295)] = 31726,
  [SMALL_STATE(1296)] = 31745,
  [SMALL_STATE(1297)] = 31760,
  [SMALL_STATE(1298)] = 31775,
  [SMALL_STATE(1299)] = 31794,
  [SMALL_STATE(1300)] = 31813,
  [SMALL_STATE(1301)] = 31832,
  [SMALL_STATE(1302)] = 31851,
  [SMALL_STATE(1303)] = 31868,
  [SMALL_STATE(1304)] = 31883,
  [SMALL_STATE(1305)] = 31902,
  [SMALL_STATE(1306)] = 31919,
  [SMALL_STATE(1307)] = 31938,
  [SMALL_STATE(1308)] = 31953,
  [SMALL_STATE(1309)] = 31972,
  [SMALL_STATE(1310)] = 31991,
  [SMALL_STATE(1311)] = 32010,
  [SMALL_STATE(1312)] = 32029,
  [SMALL_STATE(1313)] = 32048,
  [SMALL_STATE(1314)] = 32067,
  [SMALL_STATE(1315)] = 32086,
  [SMALL_STATE(1316)] = 32105,
  [SMALL_STATE(1317)] = 32124,
  [SMALL_STATE(1318)] = 32143,
  [SMALL_STATE(1319)] = 32162,
  [SMALL_STATE(1320)] = 32181,
  [SMALL_STATE(1321)] = 32198,
  [SMALL_STATE(1322)] = 32217,
  [SMALL_STATE(1323)] = 32236,
  [SMALL_STATE(1324)] = 32255,
  [SMALL_STATE(1325)] = 32274,
  [SMALL_STATE(1326)] = 32293,
  [SMALL_STATE(1327)] = 32312,
  [SMALL_STATE(1328)] = 32329,
  [SMALL_STATE(1329)] = 32348,
  [SMALL_STATE(1330)] = 32367,
  [SMALL_STATE(1331)] = 32386,
  [SMALL_STATE(1332)] = 32403,
  [SMALL_STATE(1333)] = 32422,
  [SMALL_STATE(1334)] = 32441,
  [SMALL_STATE(1335)] = 32460,
  [SMALL_STATE(1336)] = 32479,
  [SMALL_STATE(1337)] = 32498,
  [SMALL_STATE(1338)] = 32515,
  [SMALL_STATE(1339)] = 32534,
  [SMALL_STATE(1340)] = 32551,
  [SMALL_STATE(1341)] = 32570,
  [SMALL_STATE(1342)] = 32589,
  [SMALL_STATE(1343)] = 32608,
  [SMALL_STATE(1344)] = 32620,
  [SMALL_STATE(1345)] = 32632,
  [SMALL_STATE(1346)] = 32644,
  [SMALL_STATE(1347)] = 32656,
  [SMALL_STATE(1348)] = 32670,
  [SMALL_STATE(1349)] = 32682,
  [SMALL_STATE(1350)] = 32694,
  [SMALL_STATE(1351)] = 32706,
  [SMALL_STATE(1352)] = 32718,
  [SMALL_STATE(1353)] = 32730,
  [SMALL_STATE(1354)] = 32744,
  [SMALL_STATE(1355)] = 32756,
  [SMALL_STATE(1356)] = 32770,
  [SMALL_STATE(1357)] = 32779,
  [SMALL_STATE(1358)] = 32790,
  [SMALL_STATE(1359)] = 32803,
  [SMALL_STATE(1360)] = 32816,
  [SMALL_STATE(1361)] = 32827,
  [SMALL_STATE(1362)] = 32838,
  [SMALL_STATE(1363)] = 32849,
  [SMALL_STATE(1364)] = 32858,
  [SMALL_STATE(1365)] = 32869,
  [SMALL_STATE(1366)] = 32880,
  [SMALL_STATE(1367)] = 32889,
  [SMALL_STATE(1368)] = 32900,
  [SMALL_STATE(1369)] = 32911,
  [SMALL_STATE(1370)] = 32922,
  [SMALL_STATE(1371)] = 32933,
  [SMALL_STATE(1372)] = 32944,
  [SMALL_STATE(1373)] = 32955,
  [SMALL_STATE(1374)] = 32968,
  [SMALL_STATE(1375)] = 32979,
  [SMALL_STATE(1376)] = 32990,
  [SMALL_STATE(1377)] = 32999,
  [SMALL_STATE(1378)] = 33012,
  [SMALL_STATE(1379)] = 33023,
  [SMALL_STATE(1380)] = 33030,
  [SMALL_STATE(1381)] = 33039,
  [SMALL_STATE(1382)] = 33050,
  [SMALL_STATE(1383)] = 33061,
  [SMALL_STATE(1384)] = 33074,
  [SMALL_STATE(1385)] = 33085,
  [SMALL_STATE(1386)] = 33096,
  [SMALL_STATE(1387)] = 33107,
  [SMALL_STATE(1388)] = 33118,
  [SMALL_STATE(1389)] = 33131,
  [SMALL_STATE(1390)] = 33144,
  [SMALL_STATE(1391)] = 33153,
  [SMALL_STATE(1392)] = 33162,
  [SMALL_STATE(1393)] = 33171,
  [SMALL_STATE(1394)] = 33182,
  [SMALL_STATE(1395)] = 33195,
  [SMALL_STATE(1396)] = 33208,
  [SMALL_STATE(1397)] = 33219,
  [SMALL_STATE(1398)] = 33230,
  [SMALL_STATE(1399)] = 33241,
  [SMALL_STATE(1400)] = 33254,
  [SMALL_STATE(1401)] = 33265,
  [SMALL_STATE(1402)] = 33276,
  [SMALL_STATE(1403)] = 33285,
  [SMALL_STATE(1404)] = 33298,
  [SMALL_STATE(1405)] = 33307,
  [SMALL_STATE(1406)] = 33316,
  [SMALL_STATE(1407)] = 33327,
  [SMALL_STATE(1408)] = 33338,
  [SMALL_STATE(1409)] = 33349,
  [SMALL_STATE(1410)] = 33358,
  [SMALL_STATE(1411)] = 33364,
  [SMALL_STATE(1412)] = 33370,
  [SMALL_STATE(1413)] = 33376,
  [SMALL_STATE(1414)] = 33382,
  [SMALL_STATE(1415)] = 33392,
  [SMALL_STATE(1416)] = 33402,
  [SMALL_STATE(1417)] = 33408,
  [SMALL_STATE(1418)] = 33418,
  [SMALL_STATE(1419)] = 33424,
  [SMALL_STATE(1420)] = 33430,
  [SMALL_STATE(1421)] = 33436,
  [SMALL_STATE(1422)] = 33442,
  [SMALL_STATE(1423)] = 33448,
  [SMALL_STATE(1424)] = 33454,
  [SMALL_STATE(1425)] = 33460,
  [SMALL_STATE(1426)] = 33466,
  [SMALL_STATE(1427)] = 33476,
  [SMALL_STATE(1428)] = 33482,
  [SMALL_STATE(1429)] = 33488,
  [SMALL_STATE(1430)] = 33494,
  [SMALL_STATE(1431)] = 33500,
  [SMALL_STATE(1432)] = 33506,
  [SMALL_STATE(1433)] = 33512,
  [SMALL_STATE(1434)] = 33518,
  [SMALL_STATE(1435)] = 33524,
  [SMALL_STATE(1436)] = 33530,
  [SMALL_STATE(1437)] = 33536,
  [SMALL_STATE(1438)] = 33542,
  [SMALL_STATE(1439)] = 33552,
  [SMALL_STATE(1440)] = 33562,
  [SMALL_STATE(1441)] = 33572,
  [SMALL_STATE(1442)] = 33582,
  [SMALL_STATE(1443)] = 33588,
  [SMALL_STATE(1444)] = 33594,
  [SMALL_STATE(1445)] = 33600,
  [SMALL_STATE(1446)] = 33610,
  [SMALL_STATE(1447)] = 33620,
  [SMALL_STATE(1448)] = 33626,
  [SMALL_STATE(1449)] = 33632,
  [SMALL_STATE(1450)] = 33642,
  [SMALL_STATE(1451)] = 33652,
  [SMALL_STATE(1452)] = 33660,
  [SMALL_STATE(1453)] = 33666,
  [SMALL_STATE(1454)] = 33676,
  [SMALL_STATE(1455)] = 33682,
  [SMALL_STATE(1456)] = 33688,
  [SMALL_STATE(1457)] = 33694,
  [SMALL_STATE(1458)] = 33700,
  [SMALL_STATE(1459)] = 33706,
  [SMALL_STATE(1460)] = 33712,
  [SMALL_STATE(1461)] = 33718,
  [SMALL_STATE(1462)] = 33728,
  [SMALL_STATE(1463)] = 33734,
  [SMALL_STATE(1464)] = 33740,
  [SMALL_STATE(1465)] = 33746,
  [SMALL_STATE(1466)] = 33752,
  [SMALL_STATE(1467)] = 33758,
  [SMALL_STATE(1468)] = 33764,
  [SMALL_STATE(1469)] = 33770,
  [SMALL_STATE(1470)] = 33776,
  [SMALL_STATE(1471)] = 33782,
  [SMALL_STATE(1472)] = 33788,
  [SMALL_STATE(1473)] = 33794,
  [SMALL_STATE(1474)] = 33800,
  [SMALL_STATE(1475)] = 33810,
  [SMALL_STATE(1476)] = 33820,
  [SMALL_STATE(1477)] = 33826,
  [SMALL_STATE(1478)] = 33836,
  [SMALL_STATE(1479)] = 33842,
  [SMALL_STATE(1480)] = 33852,
  [SMALL_STATE(1481)] = 33858,
  [SMALL_STATE(1482)] = 33864,
  [SMALL_STATE(1483)] = 33870,
  [SMALL_STATE(1484)] = 33880,
  [SMALL_STATE(1485)] = 33886,
  [SMALL_STATE(1486)] = 33892,
  [SMALL_STATE(1487)] = 33898,
  [SMALL_STATE(1488)] = 33904,
  [SMALL_STATE(1489)] = 33910,
  [SMALL_STATE(1490)] = 33916,
  [SMALL_STATE(1491)] = 33922,
  [SMALL_STATE(1492)] = 33928,
  [SMALL_STATE(1493)] = 33938,
  [SMALL_STATE(1494)] = 33948,
  [SMALL_STATE(1495)] = 33954,
  [SMALL_STATE(1496)] = 33960,
  [SMALL_STATE(1497)] = 33970,
  [SMALL_STATE(1498)] = 33976,
  [SMALL_STATE(1499)] = 33982,
  [SMALL_STATE(1500)] = 33988,
  [SMALL_STATE(1501)] = 33994,
  [SMALL_STATE(1502)] = 34000,
  [SMALL_STATE(1503)] = 34010,
  [SMALL_STATE(1504)] = 34016,
  [SMALL_STATE(1505)] = 34022,
  [SMALL_STATE(1506)] = 34032,
  [SMALL_STATE(1507)] = 34042,
  [SMALL_STATE(1508)] = 34048,
  [SMALL_STATE(1509)] = 34056,
  [SMALL_STATE(1510)] = 34066,
  [SMALL_STATE(1511)] = 34072,
  [SMALL_STATE(1512)] = 34082,
  [SMALL_STATE(1513)] = 34092,
  [SMALL_STATE(1514)] = 34098,
  [SMALL_STATE(1515)] = 34104,
  [SMALL_STATE(1516)] = 34110,
  [SMALL_STATE(1517)] = 34116,
  [SMALL_STATE(1518)] = 34122,
  [SMALL_STATE(1519)] = 34128,
  [SMALL_STATE(1520)] = 34134,
  [SMALL_STATE(1521)] = 34140,
  [SMALL_STATE(1522)] = 34150,
  [SMALL_STATE(1523)] = 34156,
  [SMALL_STATE(1524)] = 34164,
  [SMALL_STATE(1525)] = 34170,
  [SMALL_STATE(1526)] = 34176,
  [SMALL_STATE(1527)] = 34182,
  [SMALL_STATE(1528)] = 34188,
  [SMALL_STATE(1529)] = 34194,
  [SMALL_STATE(1530)] = 34200,
  [SMALL_STATE(1531)] = 34206,
  [SMALL_STATE(1532)] = 34212,
  [SMALL_STATE(1533)] = 34222,
  [SMALL_STATE(1534)] = 34232,
  [SMALL_STATE(1535)] = 34238,
  [SMALL_STATE(1536)] = 34244,
  [SMALL_STATE(1537)] = 34250,
  [SMALL_STATE(1538)] = 34256,
  [SMALL_STATE(1539)] = 34262,
  [SMALL_STATE(1540)] = 34268,
  [SMALL_STATE(1541)] = 34274,
  [SMALL_STATE(1542)] = 34280,
  [SMALL_STATE(1543)] = 34290,
  [SMALL_STATE(1544)] = 34296,
  [SMALL_STATE(1545)] = 34304,
  [SMALL_STATE(1546)] = 34310,
  [SMALL_STATE(1547)] = 34316,
  [SMALL_STATE(1548)] = 34322,
  [SMALL_STATE(1549)] = 34328,
  [SMALL_STATE(1550)] = 34338,
  [SMALL_STATE(1551)] = 34344,
  [SMALL_STATE(1552)] = 34354,
  [SMALL_STATE(1553)] = 34362,
  [SMALL_STATE(1554)] = 34372,
  [SMALL_STATE(1555)] = 34382,
  [SMALL_STATE(1556)] = 34392,
  [SMALL_STATE(1557)] = 34402,
  [SMALL_STATE(1558)] = 34412,
  [SMALL_STATE(1559)] = 34422,
  [SMALL_STATE(1560)] = 34428,
  [SMALL_STATE(1561)] = 34438,
  [SMALL_STATE(1562)] = 34446,
  [SMALL_STATE(1563)] = 34452,
  [SMALL_STATE(1564)] = 34458,
  [SMALL_STATE(1565)] = 34464,
  [SMALL_STATE(1566)] = 34470,
  [SMALL_STATE(1567)] = 34476,
  [SMALL_STATE(1568)] = 34482,
  [SMALL_STATE(1569)] = 34488,
  [SMALL_STATE(1570)] = 34494,
  [SMALL_STATE(1571)] = 34502,
  [SMALL_STATE(1572)] = 34508,
  [SMALL_STATE(1573)] = 34514,
  [SMALL_STATE(1574)] = 34520,
  [SMALL_STATE(1575)] = 34526,
  [SMALL_STATE(1576)] = 34536,
  [SMALL_STATE(1577)] = 34542,
  [SMALL_STATE(1578)] = 34548,
  [SMALL_STATE(1579)] = 34556,
  [SMALL_STATE(1580)] = 34564,
  [SMALL_STATE(1581)] = 34570,
  [SMALL_STATE(1582)] = 34576,
  [SMALL_STATE(1583)] = 34586,
  [SMALL_STATE(1584)] = 34592,
  [SMALL_STATE(1585)] = 34602,
  [SMALL_STATE(1586)] = 34612,
  [SMALL_STATE(1587)] = 34622,
  [SMALL_STATE(1588)] = 34630,
  [SMALL_STATE(1589)] = 34638,
  [SMALL_STATE(1590)] = 34644,
  [SMALL_STATE(1591)] = 34652,
  [SMALL_STATE(1592)] = 34658,
  [SMALL_STATE(1593)] = 34668,
  [SMALL_STATE(1594)] = 34678,
  [SMALL_STATE(1595)] = 34686,
  [SMALL_STATE(1596)] = 34694,
  [SMALL_STATE(1597)] = 34700,
  [SMALL_STATE(1598)] = 34708,
  [SMALL_STATE(1599)] = 34714,
  [SMALL_STATE(1600)] = 34720,
  [SMALL_STATE(1601)] = 34726,
  [SMALL_STATE(1602)] = 34732,
  [SMALL_STATE(1603)] = 34738,
  [SMALL_STATE(1604)] = 34744,
  [SMALL_STATE(1605)] = 34750,
  [SMALL_STATE(1606)] = 34756,
  [SMALL_STATE(1607)] = 34764,
  [SMALL_STATE(1608)] = 34770,
  [SMALL_STATE(1609)] = 34778,
  [SMALL_STATE(1610)] = 34786,
  [SMALL_STATE(1611)] = 34794,
  [SMALL_STATE(1612)] = 34800,
  [SMALL_STATE(1613)] = 34806,
  [SMALL_STATE(1614)] = 34814,
  [SMALL_STATE(1615)] = 34824,
  [SMALL_STATE(1616)] = 34832,
  [SMALL_STATE(1617)] = 34838,
  [SMALL_STATE(1618)] = 34846,
  [SMALL_STATE(1619)] = 34854,
  [SMALL_STATE(1620)] = 34864,
  [SMALL_STATE(1621)] = 34870,
  [SMALL_STATE(1622)] = 34880,
  [SMALL_STATE(1623)] = 34886,
  [SMALL_STATE(1624)] = 34892,
  [SMALL_STATE(1625)] = 34900,
  [SMALL_STATE(1626)] = 34910,
  [SMALL_STATE(1627)] = 34916,
  [SMALL_STATE(1628)] = 34922,
  [SMALL_STATE(1629)] = 34928,
  [SMALL_STATE(1630)] = 34936,
  [SMALL_STATE(1631)] = 34944,
  [SMALL_STATE(1632)] = 34952,
  [SMALL_STATE(1633)] = 34958,
  [SMALL_STATE(1634)] = 34964,
  [SMALL_STATE(1635)] = 34970,
  [SMALL_STATE(1636)] = 34980,
  [SMALL_STATE(1637)] = 34986,
  [SMALL_STATE(1638)] = 34992,
  [SMALL_STATE(1639)] = 34998,
  [SMALL_STATE(1640)] = 35008,
  [SMALL_STATE(1641)] = 35018,
  [SMALL_STATE(1642)] = 35024,
  [SMALL_STATE(1643)] = 35030,
  [SMALL_STATE(1644)] = 35038,
  [SMALL_STATE(1645)] = 35045,
  [SMALL_STATE(1646)] = 35050,
  [SMALL_STATE(1647)] = 35057,
  [SMALL_STATE(1648)] = 35064,
  [SMALL_STATE(1649)] = 35069,
  [SMALL_STATE(1650)] = 35076,
  [SMALL_STATE(1651)] = 35083,
  [SMALL_STATE(1652)] = 35090,
  [SMALL_STATE(1653)] = 35095,
  [SMALL_STATE(1654)] = 35100,
  [SMALL_STATE(1655)] = 35107,
  [SMALL_STATE(1656)] = 35114,
  [SMALL_STATE(1657)] = 35121,
  [SMALL_STATE(1658)] = 35126,
  [SMALL_STATE(1659)] = 35133,
  [SMALL_STATE(1660)] = 35138,
  [SMALL_STATE(1661)] = 35143,
  [SMALL_STATE(1662)] = 35150,
  [SMALL_STATE(1663)] = 35155,
  [SMALL_STATE(1664)] = 35160,
  [SMALL_STATE(1665)] = 35165,
  [SMALL_STATE(1666)] = 35172,
  [SMALL_STATE(1667)] = 35179,
  [SMALL_STATE(1668)] = 35186,
  [SMALL_STATE(1669)] = 35193,
  [SMALL_STATE(1670)] = 35200,
  [SMALL_STATE(1671)] = 35207,
  [SMALL_STATE(1672)] = 35214,
  [SMALL_STATE(1673)] = 35221,
  [SMALL_STATE(1674)] = 35228,
  [SMALL_STATE(1675)] = 35235,
  [SMALL_STATE(1676)] = 35240,
  [SMALL_STATE(1677)] = 35247,
  [SMALL_STATE(1678)] = 35254,
  [SMALL_STATE(1679)] = 35259,
  [SMALL_STATE(1680)] = 35266,
  [SMALL_STATE(1681)] = 35271,
  [SMALL_STATE(1682)] = 35276,
  [SMALL_STATE(1683)] = 35281,
  [SMALL_STATE(1684)] = 35286,
  [SMALL_STATE(1685)] = 35291,
  [SMALL_STATE(1686)] = 35296,
  [SMALL_STATE(1687)] = 35301,
  [SMALL_STATE(1688)] = 35306,
  [SMALL_STATE(1689)] = 35311,
  [SMALL_STATE(1690)] = 35316,
  [SMALL_STATE(1691)] = 35321,
  [SMALL_STATE(1692)] = 35326,
  [SMALL_STATE(1693)] = 35331,
  [SMALL_STATE(1694)] = 35336,
  [SMALL_STATE(1695)] = 35343,
  [SMALL_STATE(1696)] = 35348,
  [SMALL_STATE(1697)] = 35355,
  [SMALL_STATE(1698)] = 35362,
  [SMALL_STATE(1699)] = 35367,
  [SMALL_STATE(1700)] = 35372,
  [SMALL_STATE(1701)] = 35379,
  [SMALL_STATE(1702)] = 35386,
  [SMALL_STATE(1703)] = 35393,
  [SMALL_STATE(1704)] = 35398,
  [SMALL_STATE(1705)] = 35405,
  [SMALL_STATE(1706)] = 35412,
  [SMALL_STATE(1707)] = 35419,
  [SMALL_STATE(1708)] = 35426,
  [SMALL_STATE(1709)] = 35433,
  [SMALL_STATE(1710)] = 35440,
  [SMALL_STATE(1711)] = 35447,
  [SMALL_STATE(1712)] = 35454,
  [SMALL_STATE(1713)] = 35461,
  [SMALL_STATE(1714)] = 35468,
  [SMALL_STATE(1715)] = 35473,
  [SMALL_STATE(1716)] = 35480,
  [SMALL_STATE(1717)] = 35485,
  [SMALL_STATE(1718)] = 35492,
  [SMALL_STATE(1719)] = 35499,
  [SMALL_STATE(1720)] = 35506,
  [SMALL_STATE(1721)] = 35513,
  [SMALL_STATE(1722)] = 35518,
  [SMALL_STATE(1723)] = 35525,
  [SMALL_STATE(1724)] = 35532,
  [SMALL_STATE(1725)] = 35537,
  [SMALL_STATE(1726)] = 35544,
  [SMALL_STATE(1727)] = 35551,
  [SMALL_STATE(1728)] = 35558,
  [SMALL_STATE(1729)] = 35565,
  [SMALL_STATE(1730)] = 35572,
  [SMALL_STATE(1731)] = 35579,
  [SMALL_STATE(1732)] = 35586,
  [SMALL_STATE(1733)] = 35593,
  [SMALL_STATE(1734)] = 35600,
  [SMALL_STATE(1735)] = 35607,
  [SMALL_STATE(1736)] = 35614,
  [SMALL_STATE(1737)] = 35619,
  [SMALL_STATE(1738)] = 35626,
  [SMALL_STATE(1739)] = 35633,
  [SMALL_STATE(1740)] = 35640,
  [SMALL_STATE(1741)] = 35645,
  [SMALL_STATE(1742)] = 35650,
  [SMALL_STATE(1743)] = 35655,
  [SMALL_STATE(1744)] = 35662,
  [SMALL_STATE(1745)] = 35669,
  [SMALL_STATE(1746)] = 35676,
  [SMALL_STATE(1747)] = 35683,
  [SMALL_STATE(1748)] = 35690,
  [SMALL_STATE(1749)] = 35697,
  [SMALL_STATE(1750)] = 35704,
  [SMALL_STATE(1751)] = 35711,
  [SMALL_STATE(1752)] = 35718,
  [SMALL_STATE(1753)] = 35725,
  [SMALL_STATE(1754)] = 35732,
  [SMALL_STATE(1755)] = 35737,
  [SMALL_STATE(1756)] = 35742,
  [SMALL_STATE(1757)] = 35749,
  [SMALL_STATE(1758)] = 35756,
  [SMALL_STATE(1759)] = 35763,
  [SMALL_STATE(1760)] = 35770,
  [SMALL_STATE(1761)] = 35777,
  [SMALL_STATE(1762)] = 35784,
  [SMALL_STATE(1763)] = 35791,
  [SMALL_STATE(1764)] = 35798,
  [SMALL_STATE(1765)] = 35805,
  [SMALL_STATE(1766)] = 35812,
  [SMALL_STATE(1767)] = 35819,
  [SMALL_STATE(1768)] = 35826,
  [SMALL_STATE(1769)] = 35833,
  [SMALL_STATE(1770)] = 35840,
  [SMALL_STATE(1771)] = 35845,
  [SMALL_STATE(1772)] = 35852,
  [SMALL_STATE(1773)] = 35859,
  [SMALL_STATE(1774)] = 35866,
  [SMALL_STATE(1775)] = 35873,
  [SMALL_STATE(1776)] = 35880,
  [SMALL_STATE(1777)] = 35887,
  [SMALL_STATE(1778)] = 35894,
  [SMALL_STATE(1779)] = 35901,
  [SMALL_STATE(1780)] = 35908,
  [SMALL_STATE(1781)] = 35915,
  [SMALL_STATE(1782)] = 35922,
  [SMALL_STATE(1783)] = 35929,
  [SMALL_STATE(1784)] = 35936,
  [SMALL_STATE(1785)] = 35941,
  [SMALL_STATE(1786)] = 35948,
  [SMALL_STATE(1787)] = 35955,
  [SMALL_STATE(1788)] = 35962,
  [SMALL_STATE(1789)] = 35969,
  [SMALL_STATE(1790)] = 35976,
  [SMALL_STATE(1791)] = 35983,
  [SMALL_STATE(1792)] = 35990,
  [SMALL_STATE(1793)] = 35997,
  [SMALL_STATE(1794)] = 36004,
  [SMALL_STATE(1795)] = 36011,
  [SMALL_STATE(1796)] = 36018,
  [SMALL_STATE(1797)] = 36025,
  [SMALL_STATE(1798)] = 36032,
  [SMALL_STATE(1799)] = 36039,
  [SMALL_STATE(1800)] = 36046,
  [SMALL_STATE(1801)] = 36053,
  [SMALL_STATE(1802)] = 36058,
  [SMALL_STATE(1803)] = 36065,
  [SMALL_STATE(1804)] = 36072,
  [SMALL_STATE(1805)] = 36079,
  [SMALL_STATE(1806)] = 36084,
  [SMALL_STATE(1807)] = 36089,
  [SMALL_STATE(1808)] = 36094,
  [SMALL_STATE(1809)] = 36101,
  [SMALL_STATE(1810)] = 36108,
  [SMALL_STATE(1811)] = 36115,
  [SMALL_STATE(1812)] = 36122,
  [SMALL_STATE(1813)] = 36129,
  [SMALL_STATE(1814)] = 36136,
  [SMALL_STATE(1815)] = 36143,
  [SMALL_STATE(1816)] = 36150,
  [SMALL_STATE(1817)] = 36157,
  [SMALL_STATE(1818)] = 36164,
  [SMALL_STATE(1819)] = 36171,
  [SMALL_STATE(1820)] = 36178,
  [SMALL_STATE(1821)] = 36183,
  [SMALL_STATE(1822)] = 36188,
  [SMALL_STATE(1823)] = 36195,
  [SMALL_STATE(1824)] = 36202,
  [SMALL_STATE(1825)] = 36209,
  [SMALL_STATE(1826)] = 36214,
  [SMALL_STATE(1827)] = 36221,
  [SMALL_STATE(1828)] = 36228,
  [SMALL_STATE(1829)] = 36233,
  [SMALL_STATE(1830)] = 36240,
  [SMALL_STATE(1831)] = 36247,
  [SMALL_STATE(1832)] = 36254,
  [SMALL_STATE(1833)] = 36261,
  [SMALL_STATE(1834)] = 36268,
  [SMALL_STATE(1835)] = 36275,
  [SMALL_STATE(1836)] = 36282,
  [SMALL_STATE(1837)] = 36287,
  [SMALL_STATE(1838)] = 36294,
  [SMALL_STATE(1839)] = 36301,
  [SMALL_STATE(1840)] = 36308,
  [SMALL_STATE(1841)] = 36313,
  [SMALL_STATE(1842)] = 36318,
  [SMALL_STATE(1843)] = 36325,
  [SMALL_STATE(1844)] = 36332,
  [SMALL_STATE(1845)] = 36339,
  [SMALL_STATE(1846)] = 36346,
  [SMALL_STATE(1847)] = 36353,
  [SMALL_STATE(1848)] = 36360,
  [SMALL_STATE(1849)] = 36367,
  [SMALL_STATE(1850)] = 36374,
  [SMALL_STATE(1851)] = 36381,
  [SMALL_STATE(1852)] = 36388,
  [SMALL_STATE(1853)] = 36393,
  [SMALL_STATE(1854)] = 36400,
  [SMALL_STATE(1855)] = 36407,
  [SMALL_STATE(1856)] = 36414,
  [SMALL_STATE(1857)] = 36421,
  [SMALL_STATE(1858)] = 36428,
  [SMALL_STATE(1859)] = 36435,
  [SMALL_STATE(1860)] = 36442,
  [SMALL_STATE(1861)] = 36447,
  [SMALL_STATE(1862)] = 36454,
  [SMALL_STATE(1863)] = 36459,
  [SMALL_STATE(1864)] = 36464,
  [SMALL_STATE(1865)] = 36469,
  [SMALL_STATE(1866)] = 36474,
  [SMALL_STATE(1867)] = 36479,
  [SMALL_STATE(1868)] = 36486,
  [SMALL_STATE(1869)] = 36493,
  [SMALL_STATE(1870)] = 36500,
  [SMALL_STATE(1871)] = 36507,
  [SMALL_STATE(1872)] = 36512,
  [SMALL_STATE(1873)] = 36519,
  [SMALL_STATE(1874)] = 36524,
  [SMALL_STATE(1875)] = 36529,
  [SMALL_STATE(1876)] = 36534,
  [SMALL_STATE(1877)] = 36541,
  [SMALL_STATE(1878)] = 36548,
  [SMALL_STATE(1879)] = 36555,
  [SMALL_STATE(1880)] = 36562,
  [SMALL_STATE(1881)] = 36569,
  [SMALL_STATE(1882)] = 36576,
  [SMALL_STATE(1883)] = 36583,
  [SMALL_STATE(1884)] = 36590,
  [SMALL_STATE(1885)] = 36597,
  [SMALL_STATE(1886)] = 36604,
  [SMALL_STATE(1887)] = 36611,
  [SMALL_STATE(1888)] = 36618,
  [SMALL_STATE(1889)] = 36623,
  [SMALL_STATE(1890)] = 36630,
  [SMALL_STATE(1891)] = 36637,
  [SMALL_STATE(1892)] = 36644,
  [SMALL_STATE(1893)] = 36649,
  [SMALL_STATE(1894)] = 36654,
  [SMALL_STATE(1895)] = 36661,
  [SMALL_STATE(1896)] = 36666,
  [SMALL_STATE(1897)] = 36673,
  [SMALL_STATE(1898)] = 36680,
  [SMALL_STATE(1899)] = 36687,
  [SMALL_STATE(1900)] = 36694,
  [SMALL_STATE(1901)] = 36701,
  [SMALL_STATE(1902)] = 36706,
  [SMALL_STATE(1903)] = 36711,
  [SMALL_STATE(1904)] = 36718,
  [SMALL_STATE(1905)] = 36725,
  [SMALL_STATE(1906)] = 36730,
  [SMALL_STATE(1907)] = 36737,
  [SMALL_STATE(1908)] = 36744,
  [SMALL_STATE(1909)] = 36749,
  [SMALL_STATE(1910)] = 36756,
  [SMALL_STATE(1911)] = 36763,
  [SMALL_STATE(1912)] = 36770,
  [SMALL_STATE(1913)] = 36775,
  [SMALL_STATE(1914)] = 36782,
  [SMALL_STATE(1915)] = 36787,
  [SMALL_STATE(1916)] = 36794,
  [SMALL_STATE(1917)] = 36801,
  [SMALL_STATE(1918)] = 36808,
  [SMALL_STATE(1919)] = 36815,
  [SMALL_STATE(1920)] = 36820,
  [SMALL_STATE(1921)] = 36827,
  [SMALL_STATE(1922)] = 36834,
  [SMALL_STATE(1923)] = 36839,
  [SMALL_STATE(1924)] = 36844,
  [SMALL_STATE(1925)] = 36849,
  [SMALL_STATE(1926)] = 36856,
  [SMALL_STATE(1927)] = 36861,
  [SMALL_STATE(1928)] = 36868,
  [SMALL_STATE(1929)] = 36873,
  [SMALL_STATE(1930)] = 36878,
  [SMALL_STATE(1931)] = 36883,
  [SMALL_STATE(1932)] = 36888,
  [SMALL_STATE(1933)] = 36895,
  [SMALL_STATE(1934)] = 36902,
  [SMALL_STATE(1935)] = 36907,
  [SMALL_STATE(1936)] = 36914,
  [SMALL_STATE(1937)] = 36921,
  [SMALL_STATE(1938)] = 36928,
  [SMALL_STATE(1939)] = 36933,
  [SMALL_STATE(1940)] = 36938,
  [SMALL_STATE(1941)] = 36943,
  [SMALL_STATE(1942)] = 36950,
  [SMALL_STATE(1943)] = 36955,
  [SMALL_STATE(1944)] = 36962,
  [SMALL_STATE(1945)] = 36967,
  [SMALL_STATE(1946)] = 36974,
  [SMALL_STATE(1947)] = 36981,
  [SMALL_STATE(1948)] = 36988,
  [SMALL_STATE(1949)] = 36995,
  [SMALL_STATE(1950)] = 37002,
  [SMALL_STATE(1951)] = 37007,
  [SMALL_STATE(1952)] = 37014,
  [SMALL_STATE(1953)] = 37021,
  [SMALL_STATE(1954)] = 37028,
  [SMALL_STATE(1955)] = 37035,
  [SMALL_STATE(1956)] = 37042,
  [SMALL_STATE(1957)] = 37049,
  [SMALL_STATE(1958)] = 37054,
  [SMALL_STATE(1959)] = 37059,
  [SMALL_STATE(1960)] = 37066,
  [SMALL_STATE(1961)] = 37071,
  [SMALL_STATE(1962)] = 37076,
  [SMALL_STATE(1963)] = 37081,
  [SMALL_STATE(1964)] = 37086,
  [SMALL_STATE(1965)] = 37091,
  [SMALL_STATE(1966)] = 37098,
  [SMALL_STATE(1967)] = 37105,
  [SMALL_STATE(1968)] = 37112,
  [SMALL_STATE(1969)] = 37119,
  [SMALL_STATE(1970)] = 37126,
  [SMALL_STATE(1971)] = 37133,
  [SMALL_STATE(1972)] = 37140,
  [SMALL_STATE(1973)] = 37145,
  [SMALL_STATE(1974)] = 37152,
  [SMALL_STATE(1975)] = 37159,
  [SMALL_STATE(1976)] = 37166,
  [SMALL_STATE(1977)] = 37170,
  [SMALL_STATE(1978)] = 37174,
  [SMALL_STATE(1979)] = 37178,
  [SMALL_STATE(1980)] = 37182,
  [SMALL_STATE(1981)] = 37186,
  [SMALL_STATE(1982)] = 37190,
  [SMALL_STATE(1983)] = 37194,
  [SMALL_STATE(1984)] = 37198,
  [SMALL_STATE(1985)] = 37202,
  [SMALL_STATE(1986)] = 37206,
  [SMALL_STATE(1987)] = 37210,
  [SMALL_STATE(1988)] = 37214,
  [SMALL_STATE(1989)] = 37218,
  [SMALL_STATE(1990)] = 37222,
  [SMALL_STATE(1991)] = 37226,
  [SMALL_STATE(1992)] = 37230,
  [SMALL_STATE(1993)] = 37234,
  [SMALL_STATE(1994)] = 37238,
  [SMALL_STATE(1995)] = 37242,
  [SMALL_STATE(1996)] = 37246,
  [SMALL_STATE(1997)] = 37250,
  [SMALL_STATE(1998)] = 37254,
  [SMALL_STATE(1999)] = 37258,
  [SMALL_STATE(2000)] = 37262,
  [SMALL_STATE(2001)] = 37266,
  [SMALL_STATE(2002)] = 37270,
  [SMALL_STATE(2003)] = 37274,
  [SMALL_STATE(2004)] = 37278,
  [SMALL_STATE(2005)] = 37282,
  [SMALL_STATE(2006)] = 37286,
  [SMALL_STATE(2007)] = 37290,
  [SMALL_STATE(2008)] = 37294,
  [SMALL_STATE(2009)] = 37298,
  [SMALL_STATE(2010)] = 37302,
  [SMALL_STATE(2011)] = 37306,
  [SMALL_STATE(2012)] = 37310,
  [SMALL_STATE(2013)] = 37314,
  [SMALL_STATE(2014)] = 37318,
  [SMALL_STATE(2015)] = 37322,
  [SMALL_STATE(2016)] = 37326,
  [SMALL_STATE(2017)] = 37330,
  [SMALL_STATE(2018)] = 37334,
  [SMALL_STATE(2019)] = 37338,
  [SMALL_STATE(2020)] = 37342,
  [SMALL_STATE(2021)] = 37346,
  [SMALL_STATE(2022)] = 37350,
  [SMALL_STATE(2023)] = 37354,
  [SMALL_STATE(2024)] = 37358,
  [SMALL_STATE(2025)] = 37362,
  [SMALL_STATE(2026)] = 37366,
  [SMALL_STATE(2027)] = 37370,
  [SMALL_STATE(2028)] = 37374,
  [SMALL_STATE(2029)] = 37378,
  [SMALL_STATE(2030)] = 37382,
  [SMALL_STATE(2031)] = 37386,
  [SMALL_STATE(2032)] = 37390,
  [SMALL_STATE(2033)] = 37394,
  [SMALL_STATE(2034)] = 37398,
  [SMALL_STATE(2035)] = 37402,
  [SMALL_STATE(2036)] = 37406,
  [SMALL_STATE(2037)] = 37410,
  [SMALL_STATE(2038)] = 37414,
  [SMALL_STATE(2039)] = 37418,
  [SMALL_STATE(2040)] = 37422,
  [SMALL_STATE(2041)] = 37426,
  [SMALL_STATE(2042)] = 37430,
  [SMALL_STATE(2043)] = 37434,
  [SMALL_STATE(2044)] = 37438,
  [SMALL_STATE(2045)] = 37442,
  [SMALL_STATE(2046)] = 37446,
  [SMALL_STATE(2047)] = 37450,
  [SMALL_STATE(2048)] = 37454,
  [SMALL_STATE(2049)] = 37458,
  [SMALL_STATE(2050)] = 37462,
  [SMALL_STATE(2051)] = 37466,
  [SMALL_STATE(2052)] = 37470,
  [SMALL_STATE(2053)] = 37474,
  [SMALL_STATE(2054)] = 37478,
  [SMALL_STATE(2055)] = 37482,
  [SMALL_STATE(2056)] = 37486,
  [SMALL_STATE(2057)] = 37490,
  [SMALL_STATE(2058)] = 37494,
  [SMALL_STATE(2059)] = 37498,
  [SMALL_STATE(2060)] = 37502,
  [SMALL_STATE(2061)] = 37506,
  [SMALL_STATE(2062)] = 37510,
  [SMALL_STATE(2063)] = 37514,
  [SMALL_STATE(2064)] = 37518,
  [SMALL_STATE(2065)] = 37522,
  [SMALL_STATE(2066)] = 37526,
  [SMALL_STATE(2067)] = 37530,
  [SMALL_STATE(2068)] = 37534,
  [SMALL_STATE(2069)] = 37538,
  [SMALL_STATE(2070)] = 37542,
  [SMALL_STATE(2071)] = 37546,
  [SMALL_STATE(2072)] = 37550,
  [SMALL_STATE(2073)] = 37554,
  [SMALL_STATE(2074)] = 37558,
  [SMALL_STATE(2075)] = 37562,
  [SMALL_STATE(2076)] = 37566,
  [SMALL_STATE(2077)] = 37570,
  [SMALL_STATE(2078)] = 37574,
  [SMALL_STATE(2079)] = 37578,
  [SMALL_STATE(2080)] = 37582,
  [SMALL_STATE(2081)] = 37586,
  [SMALL_STATE(2082)] = 37590,
  [SMALL_STATE(2083)] = 37594,
  [SMALL_STATE(2084)] = 37598,
  [SMALL_STATE(2085)] = 37602,
  [SMALL_STATE(2086)] = 37606,
  [SMALL_STATE(2087)] = 37610,
  [SMALL_STATE(2088)] = 37614,
  [SMALL_STATE(2089)] = 37618,
  [SMALL_STATE(2090)] = 37622,
  [SMALL_STATE(2091)] = 37626,
  [SMALL_STATE(2092)] = 37630,
  [SMALL_STATE(2093)] = 37634,
  [SMALL_STATE(2094)] = 37638,
  [SMALL_STATE(2095)] = 37642,
  [SMALL_STATE(2096)] = 37646,
  [SMALL_STATE(2097)] = 37650,
  [SMALL_STATE(2098)] = 37654,
  [SMALL_STATE(2099)] = 37658,
  [SMALL_STATE(2100)] = 37662,
  [SMALL_STATE(2101)] = 37666,
  [SMALL_STATE(2102)] = 37670,
  [SMALL_STATE(2103)] = 37674,
  [SMALL_STATE(2104)] = 37678,
  [SMALL_STATE(2105)] = 37682,
  [SMALL_STATE(2106)] = 37686,
  [SMALL_STATE(2107)] = 37690,
  [SMALL_STATE(2108)] = 37694,
  [SMALL_STATE(2109)] = 37698,
  [SMALL_STATE(2110)] = 37702,
  [SMALL_STATE(2111)] = 37706,
  [SMALL_STATE(2112)] = 37710,
  [SMALL_STATE(2113)] = 37714,
  [SMALL_STATE(2114)] = 37718,
  [SMALL_STATE(2115)] = 37722,
  [SMALL_STATE(2116)] = 37726,
  [SMALL_STATE(2117)] = 37730,
  [SMALL_STATE(2118)] = 37734,
  [SMALL_STATE(2119)] = 37738,
  [SMALL_STATE(2120)] = 37742,
  [SMALL_STATE(2121)] = 37746,
  [SMALL_STATE(2122)] = 37750,
  [SMALL_STATE(2123)] = 37754,
  [SMALL_STATE(2124)] = 37758,
  [SMALL_STATE(2125)] = 37762,
  [SMALL_STATE(2126)] = 37766,
  [SMALL_STATE(2127)] = 37770,
  [SMALL_STATE(2128)] = 37774,
  [SMALL_STATE(2129)] = 37778,
  [SMALL_STATE(2130)] = 37782,
  [SMALL_STATE(2131)] = 37786,
  [SMALL_STATE(2132)] = 37790,
  [SMALL_STATE(2133)] = 37794,
  [SMALL_STATE(2134)] = 37798,
  [SMALL_STATE(2135)] = 37802,
  [SMALL_STATE(2136)] = 37806,
  [SMALL_STATE(2137)] = 37810,
  [SMALL_STATE(2138)] = 37814,
  [SMALL_STATE(2139)] = 37818,
  [SMALL_STATE(2140)] = 37822,
  [SMALL_STATE(2141)] = 37826,
  [SMALL_STATE(2142)] = 37830,
  [SMALL_STATE(2143)] = 37834,
  [SMALL_STATE(2144)] = 37838,
  [SMALL_STATE(2145)] = 37842,
  [SMALL_STATE(2146)] = 37846,
  [SMALL_STATE(2147)] = 37850,
  [SMALL_STATE(2148)] = 37854,
  [SMALL_STATE(2149)] = 37858,
  [SMALL_STATE(2150)] = 37862,
  [SMALL_STATE(2151)] = 37866,
  [SMALL_STATE(2152)] = 37870,
  [SMALL_STATE(2153)] = 37874,
  [SMALL_STATE(2154)] = 37878,
  [SMALL_STATE(2155)] = 37882,
  [SMALL_STATE(2156)] = 37886,
  [SMALL_STATE(2157)] = 37890,
  [SMALL_STATE(2158)] = 37894,
  [SMALL_STATE(2159)] = 37898,
  [SMALL_STATE(2160)] = 37902,
  [SMALL_STATE(2161)] = 37906,
  [SMALL_STATE(2162)] = 37910,
  [SMALL_STATE(2163)] = 37914,
  [SMALL_STATE(2164)] = 37918,
  [SMALL_STATE(2165)] = 37922,
  [SMALL_STATE(2166)] = 37926,
  [SMALL_STATE(2167)] = 37930,
  [SMALL_STATE(2168)] = 37934,
  [SMALL_STATE(2169)] = 37938,
  [SMALL_STATE(2170)] = 37942,
  [SMALL_STATE(2171)] = 37946,
  [SMALL_STATE(2172)] = 37950,
  [SMALL_STATE(2173)] = 37954,
  [SMALL_STATE(2174)] = 37958,
  [SMALL_STATE(2175)] = 37962,
  [SMALL_STATE(2176)] = 37966,
  [SMALL_STATE(2177)] = 37970,
  [SMALL_STATE(2178)] = 37974,
  [SMALL_STATE(2179)] = 37978,
  [SMALL_STATE(2180)] = 37982,
  [SMALL_STATE(2181)] = 37986,
  [SMALL_STATE(2182)] = 37990,
  [SMALL_STATE(2183)] = 37994,
  [SMALL_STATE(2184)] = 37998,
  [SMALL_STATE(2185)] = 38002,
  [SMALL_STATE(2186)] = 38006,
  [SMALL_STATE(2187)] = 38010,
  [SMALL_STATE(2188)] = 38014,
  [SMALL_STATE(2189)] = 38018,
  [SMALL_STATE(2190)] = 38022,
  [SMALL_STATE(2191)] = 38026,
  [SMALL_STATE(2192)] = 38030,
  [SMALL_STATE(2193)] = 38034,
  [SMALL_STATE(2194)] = 38038,
  [SMALL_STATE(2195)] = 38042,
  [SMALL_STATE(2196)] = 38046,
  [SMALL_STATE(2197)] = 38050,
  [SMALL_STATE(2198)] = 38054,
  [SMALL_STATE(2199)] = 38058,
  [SMALL_STATE(2200)] = 38062,
  [SMALL_STATE(2201)] = 38066,
  [SMALL_STATE(2202)] = 38070,
  [SMALL_STATE(2203)] = 38074,
  [SMALL_STATE(2204)] = 38078,
  [SMALL_STATE(2205)] = 38082,
  [SMALL_STATE(2206)] = 38086,
  [SMALL_STATE(2207)] = 38090,
  [SMALL_STATE(2208)] = 38094,
  [SMALL_STATE(2209)] = 38098,
  [SMALL_STATE(2210)] = 38102,
  [SMALL_STATE(2211)] = 38106,
  [SMALL_STATE(2212)] = 38110,
  [SMALL_STATE(2213)] = 38114,
  [SMALL_STATE(2214)] = 38118,
  [SMALL_STATE(2215)] = 38122,
  [SMALL_STATE(2216)] = 38126,
  [SMALL_STATE(2217)] = 38130,
  [SMALL_STATE(2218)] = 38134,
  [SMALL_STATE(2219)] = 38138,
  [SMALL_STATE(2220)] = 38142,
  [SMALL_STATE(2221)] = 38146,
  [SMALL_STATE(2222)] = 38150,
  [SMALL_STATE(2223)] = 38154,
  [SMALL_STATE(2224)] = 38158,
  [SMALL_STATE(2225)] = 38162,
  [SMALL_STATE(2226)] = 38166,
  [SMALL_STATE(2227)] = 38170,
  [SMALL_STATE(2228)] = 38174,
  [SMALL_STATE(2229)] = 38178,
  [SMALL_STATE(2230)] = 38182,
  [SMALL_STATE(2231)] = 38186,
  [SMALL_STATE(2232)] = 38190,
  [SMALL_STATE(2233)] = 38194,
  [SMALL_STATE(2234)] = 38198,
  [SMALL_STATE(2235)] = 38202,
  [SMALL_STATE(2236)] = 38206,
  [SMALL_STATE(2237)] = 38210,
  [SMALL_STATE(2238)] = 38214,
  [SMALL_STATE(2239)] = 38218,
  [SMALL_STATE(2240)] = 38222,
  [SMALL_STATE(2241)] = 38226,
  [SMALL_STATE(2242)] = 38230,
  [SMALL_STATE(2243)] = 38234,
  [SMALL_STATE(2244)] = 38238,
  [SMALL_STATE(2245)] = 38242,
  [SMALL_STATE(2246)] = 38246,
  [SMALL_STATE(2247)] = 38250,
  [SMALL_STATE(2248)] = 38254,
  [SMALL_STATE(2249)] = 38258,
  [SMALL_STATE(2250)] = 38262,
  [SMALL_STATE(2251)] = 38266,
  [SMALL_STATE(2252)] = 38270,
  [SMALL_STATE(2253)] = 38274,
  [SMALL_STATE(2254)] = 38278,
  [SMALL_STATE(2255)] = 38282,
  [SMALL_STATE(2256)] = 38286,
  [SMALL_STATE(2257)] = 38290,
  [SMALL_STATE(2258)] = 38294,
  [SMALL_STATE(2259)] = 38298,
  [SMALL_STATE(2260)] = 38302,
  [SMALL_STATE(2261)] = 38306,
  [SMALL_STATE(2262)] = 38310,
  [SMALL_STATE(2263)] = 38314,
  [SMALL_STATE(2264)] = 38318,
  [SMALL_STATE(2265)] = 38322,
  [SMALL_STATE(2266)] = 38326,
  [SMALL_STATE(2267)] = 38330,
  [SMALL_STATE(2268)] = 38334,
  [SMALL_STATE(2269)] = 38338,
  [SMALL_STATE(2270)] = 38342,
  [SMALL_STATE(2271)] = 38346,
  [SMALL_STATE(2272)] = 38350,
  [SMALL_STATE(2273)] = 38354,
  [SMALL_STATE(2274)] = 38358,
  [SMALL_STATE(2275)] = 38362,
  [SMALL_STATE(2276)] = 38366,
  [SMALL_STATE(2277)] = 38370,
  [SMALL_STATE(2278)] = 38374,
  [SMALL_STATE(2279)] = 38378,
  [SMALL_STATE(2280)] = 38382,
  [SMALL_STATE(2281)] = 38386,
  [SMALL_STATE(2282)] = 38390,
  [SMALL_STATE(2283)] = 38394,
  [SMALL_STATE(2284)] = 38398,
  [SMALL_STATE(2285)] = 38402,
  [SMALL_STATE(2286)] = 38406,
  [SMALL_STATE(2287)] = 38410,
  [SMALL_STATE(2288)] = 38414,
  [SMALL_STATE(2289)] = 38418,
  [SMALL_STATE(2290)] = 38422,
  [SMALL_STATE(2291)] = 38426,
  [SMALL_STATE(2292)] = 38430,
  [SMALL_STATE(2293)] = 38434,
  [SMALL_STATE(2294)] = 38438,
  [SMALL_STATE(2295)] = 38442,
  [SMALL_STATE(2296)] = 38446,
  [SMALL_STATE(2297)] = 38450,
  [SMALL_STATE(2298)] = 38454,
  [SMALL_STATE(2299)] = 38458,
  [SMALL_STATE(2300)] = 38462,
  [SMALL_STATE(2301)] = 38466,
  [SMALL_STATE(2302)] = 38470,
  [SMALL_STATE(2303)] = 38474,
  [SMALL_STATE(2304)] = 38478,
  [SMALL_STATE(2305)] = 38482,
  [SMALL_STATE(2306)] = 38486,
  [SMALL_STATE(2307)] = 38490,
  [SMALL_STATE(2308)] = 38494,
  [SMALL_STATE(2309)] = 38498,
  [SMALL_STATE(2310)] = 38502,
  [SMALL_STATE(2311)] = 38506,
  [SMALL_STATE(2312)] = 38510,
  [SMALL_STATE(2313)] = 38514,
  [SMALL_STATE(2314)] = 38518,
  [SMALL_STATE(2315)] = 38522,
  [SMALL_STATE(2316)] = 38526,
  [SMALL_STATE(2317)] = 38530,
  [SMALL_STATE(2318)] = 38534,
  [SMALL_STATE(2319)] = 38538,
  [SMALL_STATE(2320)] = 38542,
  [SMALL_STATE(2321)] = 38546,
  [SMALL_STATE(2322)] = 38550,
  [SMALL_STATE(2323)] = 38554,
  [SMALL_STATE(2324)] = 38558,
  [SMALL_STATE(2325)] = 38562,
  [SMALL_STATE(2326)] = 38566,
  [SMALL_STATE(2327)] = 38570,
  [SMALL_STATE(2328)] = 38574,
  [SMALL_STATE(2329)] = 38578,
  [SMALL_STATE(2330)] = 38582,
  [SMALL_STATE(2331)] = 38586,
  [SMALL_STATE(2332)] = 38590,
  [SMALL_STATE(2333)] = 38594,
  [SMALL_STATE(2334)] = 38598,
  [SMALL_STATE(2335)] = 38602,
  [SMALL_STATE(2336)] = 38606,
  [SMALL_STATE(2337)] = 38610,
  [SMALL_STATE(2338)] = 38614,
  [SMALL_STATE(2339)] = 38618,
  [SMALL_STATE(2340)] = 38622,
  [SMALL_STATE(2341)] = 38626,
  [SMALL_STATE(2342)] = 38630,
  [SMALL_STATE(2343)] = 38634,
  [SMALL_STATE(2344)] = 38638,
  [SMALL_STATE(2345)] = 38642,
  [SMALL_STATE(2346)] = 38646,
  [SMALL_STATE(2347)] = 38650,
  [SMALL_STATE(2348)] = 38654,
  [SMALL_STATE(2349)] = 38658,
  [SMALL_STATE(2350)] = 38662,
  [SMALL_STATE(2351)] = 38666,
  [SMALL_STATE(2352)] = 38670,
  [SMALL_STATE(2353)] = 38674,
  [SMALL_STATE(2354)] = 38678,
  [SMALL_STATE(2355)] = 38682,
  [SMALL_STATE(2356)] = 38686,
  [SMALL_STATE(2357)] = 38690,
  [SMALL_STATE(2358)] = 38694,
  [SMALL_STATE(2359)] = 38698,
  [SMALL_STATE(2360)] = 38702,
  [SMALL_STATE(2361)] = 38706,
  [SMALL_STATE(2362)] = 38710,
  [SMALL_STATE(2363)] = 38714,
  [SMALL_STATE(2364)] = 38718,
  [SMALL_STATE(2365)] = 38722,
  [SMALL_STATE(2366)] = 38726,
  [SMALL_STATE(2367)] = 38730,
  [SMALL_STATE(2368)] = 38734,
  [SMALL_STATE(2369)] = 38738,
  [SMALL_STATE(2370)] = 38742,
  [SMALL_STATE(2371)] = 38746,
  [SMALL_STATE(2372)] = 38750,
  [SMALL_STATE(2373)] = 38754,
  [SMALL_STATE(2374)] = 38758,
  [SMALL_STATE(2375)] = 38762,
  [SMALL_STATE(2376)] = 38766,
  [SMALL_STATE(2377)] = 38770,
  [SMALL_STATE(2378)] = 38774,
  [SMALL_STATE(2379)] = 38778,
  [SMALL_STATE(2380)] = 38782,
  [SMALL_STATE(2381)] = 38786,
  [SMALL_STATE(2382)] = 38790,
  [SMALL_STATE(2383)] = 38794,
  [SMALL_STATE(2384)] = 38798,
  [SMALL_STATE(2385)] = 38802,
  [SMALL_STATE(2386)] = 38806,
  [SMALL_STATE(2387)] = 38810,
  [SMALL_STATE(2388)] = 38814,
  [SMALL_STATE(2389)] = 38818,
  [SMALL_STATE(2390)] = 38822,
  [SMALL_STATE(2391)] = 38826,
  [SMALL_STATE(2392)] = 38830,
  [SMALL_STATE(2393)] = 38834,
  [SMALL_STATE(2394)] = 38838,
  [SMALL_STATE(2395)] = 38842,
  [SMALL_STATE(2396)] = 38846,
  [SMALL_STATE(2397)] = 38850,
  [SMALL_STATE(2398)] = 38854,
  [SMALL_STATE(2399)] = 38858,
  [SMALL_STATE(2400)] = 38862,
  [SMALL_STATE(2401)] = 38866,
  [SMALL_STATE(2402)] = 38870,
  [SMALL_STATE(2403)] = 38874,
  [SMALL_STATE(2404)] = 38878,
  [SMALL_STATE(2405)] = 38882,
  [SMALL_STATE(2406)] = 38886,
  [SMALL_STATE(2407)] = 38890,
  [SMALL_STATE(2408)] = 38894,
  [SMALL_STATE(2409)] = 38898,
  [SMALL_STATE(2410)] = 38902,
  [SMALL_STATE(2411)] = 38906,
  [SMALL_STATE(2412)] = 38910,
  [SMALL_STATE(2413)] = 38914,
  [SMALL_STATE(2414)] = 38918,
  [SMALL_STATE(2415)] = 38922,
  [SMALL_STATE(2416)] = 38926,
  [SMALL_STATE(2417)] = 38930,
  [SMALL_STATE(2418)] = 38934,
  [SMALL_STATE(2419)] = 38938,
  [SMALL_STATE(2420)] = 38942,
  [SMALL_STATE(2421)] = 38946,
  [SMALL_STATE(2422)] = 38950,
  [SMALL_STATE(2423)] = 38954,
  [SMALL_STATE(2424)] = 38958,
  [SMALL_STATE(2425)] = 38962,
  [SMALL_STATE(2426)] = 38966,
  [SMALL_STATE(2427)] = 38970,
  [SMALL_STATE(2428)] = 38974,
  [SMALL_STATE(2429)] = 38978,
  [SMALL_STATE(2430)] = 38982,
  [SMALL_STATE(2431)] = 38986,
  [SMALL_STATE(2432)] = 38990,
  [SMALL_STATE(2433)] = 38994,
  [SMALL_STATE(2434)] = 38998,
  [SMALL_STATE(2435)] = 39002,
  [SMALL_STATE(2436)] = 39006,
  [SMALL_STATE(2437)] = 39010,
  [SMALL_STATE(2438)] = 39014,
  [SMALL_STATE(2439)] = 39018,
  [SMALL_STATE(2440)] = 39022,
  [SMALL_STATE(2441)] = 39026,
  [SMALL_STATE(2442)] = 39030,
  [SMALL_STATE(2443)] = 39034,
  [SMALL_STATE(2444)] = 39038,
  [SMALL_STATE(2445)] = 39042,
  [SMALL_STATE(2446)] = 39046,
  [SMALL_STATE(2447)] = 39050,
  [SMALL_STATE(2448)] = 39054,
  [SMALL_STATE(2449)] = 39058,
  [SMALL_STATE(2450)] = 39062,
  [SMALL_STATE(2451)] = 39066,
  [SMALL_STATE(2452)] = 39070,
  [SMALL_STATE(2453)] = 39074,
  [SMALL_STATE(2454)] = 39078,
  [SMALL_STATE(2455)] = 39082,
  [SMALL_STATE(2456)] = 39086,
  [SMALL_STATE(2457)] = 39090,
  [SMALL_STATE(2458)] = 39094,
  [SMALL_STATE(2459)] = 39098,
  [SMALL_STATE(2460)] = 39102,
  [SMALL_STATE(2461)] = 39106,
  [SMALL_STATE(2462)] = 39110,
  [SMALL_STATE(2463)] = 39114,
  [SMALL_STATE(2464)] = 39118,
  [SMALL_STATE(2465)] = 39122,
  [SMALL_STATE(2466)] = 39126,
  [SMALL_STATE(2467)] = 39130,
  [SMALL_STATE(2468)] = 39134,
  [SMALL_STATE(2469)] = 39138,
  [SMALL_STATE(2470)] = 39142,
  [SMALL_STATE(2471)] = 39146,
  [SMALL_STATE(2472)] = 39150,
  [SMALL_STATE(2473)] = 39154,
  [SMALL_STATE(2474)] = 39158,
  [SMALL_STATE(2475)] = 39162,
  [SMALL_STATE(2476)] = 39166,
  [SMALL_STATE(2477)] = 39170,
  [SMALL_STATE(2478)] = 39174,
  [SMALL_STATE(2479)] = 39178,
  [SMALL_STATE(2480)] = 39182,
  [SMALL_STATE(2481)] = 39186,
  [SMALL_STATE(2482)] = 39190,
  [SMALL_STATE(2483)] = 39194,
  [SMALL_STATE(2484)] = 39198,
  [SMALL_STATE(2485)] = 39202,
  [SMALL_STATE(2486)] = 39206,
  [SMALL_STATE(2487)] = 39210,
  [SMALL_STATE(2488)] = 39214,
  [SMALL_STATE(2489)] = 39218,
  [SMALL_STATE(2490)] = 39222,
  [SMALL_STATE(2491)] = 39226,
  [SMALL_STATE(2492)] = 39230,
  [SMALL_STATE(2493)] = 39234,
  [SMALL_STATE(2494)] = 39238,
  [SMALL_STATE(2495)] = 39242,
  [SMALL_STATE(2496)] = 39246,
  [SMALL_STATE(2497)] = 39250,
  [SMALL_STATE(2498)] = 39254,
  [SMALL_STATE(2499)] = 39258,
  [SMALL_STATE(2500)] = 39262,
  [SMALL_STATE(2501)] = 39266,
  [SMALL_STATE(2502)] = 39270,
  [SMALL_STATE(2503)] = 39274,
  [SMALL_STATE(2504)] = 39278,
  [SMALL_STATE(2505)] = 39282,
  [SMALL_STATE(2506)] = 39286,
  [SMALL_STATE(2507)] = 39290,
  [SMALL_STATE(2508)] = 39294,
  [SMALL_STATE(2509)] = 39298,
  [SMALL_STATE(2510)] = 39302,
  [SMALL_STATE(2511)] = 39306,
  [SMALL_STATE(2512)] = 39310,
  [SMALL_STATE(2513)] = 39314,
  [SMALL_STATE(2514)] = 39318,
  [SMALL_STATE(2515)] = 39322,
  [SMALL_STATE(2516)] = 39326,
  [SMALL_STATE(2517)] = 39330,
  [SMALL_STATE(2518)] = 39334,
  [SMALL_STATE(2519)] = 39338,
  [SMALL_STATE(2520)] = 39342,
  [SMALL_STATE(2521)] = 39346,
  [SMALL_STATE(2522)] = 39350,
  [SMALL_STATE(2523)] = 39354,
  [SMALL_STATE(2524)] = 39358,
  [SMALL_STATE(2525)] = 39362,
  [SMALL_STATE(2526)] = 39366,
  [SMALL_STATE(2527)] = 39370,
  [SMALL_STATE(2528)] = 39374,
  [SMALL_STATE(2529)] = 39378,
  [SMALL_STATE(2530)] = 39382,
  [SMALL_STATE(2531)] = 39386,
  [SMALL_STATE(2532)] = 39390,
  [SMALL_STATE(2533)] = 39394,
  [SMALL_STATE(2534)] = 39398,
  [SMALL_STATE(2535)] = 39402,
  [SMALL_STATE(2536)] = 39406,
  [SMALL_STATE(2537)] = 39410,
  [SMALL_STATE(2538)] = 39414,
  [SMALL_STATE(2539)] = 39418,
  [SMALL_STATE(2540)] = 39422,
  [SMALL_STATE(2541)] = 39426,
  [SMALL_STATE(2542)] = 39430,
  [SMALL_STATE(2543)] = 39434,
  [SMALL_STATE(2544)] = 39438,
  [SMALL_STATE(2545)] = 39442,
  [SMALL_STATE(2546)] = 39446,
  [SMALL_STATE(2547)] = 39450,
  [SMALL_STATE(2548)] = 39454,
  [SMALL_STATE(2549)] = 39458,
  [SMALL_STATE(2550)] = 39462,
  [SMALL_STATE(2551)] = 39466,
  [SMALL_STATE(2552)] = 39470,
  [SMALL_STATE(2553)] = 39474,
  [SMALL_STATE(2554)] = 39478,
  [SMALL_STATE(2555)] = 39482,
  [SMALL_STATE(2556)] = 39486,
  [SMALL_STATE(2557)] = 39490,
  [SMALL_STATE(2558)] = 39494,
  [SMALL_STATE(2559)] = 39498,
  [SMALL_STATE(2560)] = 39502,
  [SMALL_STATE(2561)] = 39506,
  [SMALL_STATE(2562)] = 39510,
  [SMALL_STATE(2563)] = 39514,
  [SMALL_STATE(2564)] = 39518,
  [SMALL_STATE(2565)] = 39522,
  [SMALL_STATE(2566)] = 39526,
  [SMALL_STATE(2567)] = 39530,
  [SMALL_STATE(2568)] = 39534,
  [SMALL_STATE(2569)] = 39538,
  [SMALL_STATE(2570)] = 39542,
  [SMALL_STATE(2571)] = 39546,
  [SMALL_STATE(2572)] = 39550,
  [SMALL_STATE(2573)] = 39554,
  [SMALL_STATE(2574)] = 39558,
  [SMALL_STATE(2575)] = 39562,
  [SMALL_STATE(2576)] = 39566,
  [SMALL_STATE(2577)] = 39570,
  [SMALL_STATE(2578)] = 39574,
  [SMALL_STATE(2579)] = 39578,
  [SMALL_STATE(2580)] = 39582,
  [SMALL_STATE(2581)] = 39586,
  [SMALL_STATE(2582)] = 39590,
  [SMALL_STATE(2583)] = 39594,
  [SMALL_STATE(2584)] = 39598,
  [SMALL_STATE(2585)] = 39602,
  [SMALL_STATE(2586)] = 39606,
  [SMALL_STATE(2587)] = 39610,
  [SMALL_STATE(2588)] = 39614,
  [SMALL_STATE(2589)] = 39618,
  [SMALL_STATE(2590)] = 39622,
  [SMALL_STATE(2591)] = 39626,
  [SMALL_STATE(2592)] = 39630,
  [SMALL_STATE(2593)] = 39634,
  [SMALL_STATE(2594)] = 39638,
  [SMALL_STATE(2595)] = 39642,
  [SMALL_STATE(2596)] = 39646,
  [SMALL_STATE(2597)] = 39650,
  [SMALL_STATE(2598)] = 39654,
  [SMALL_STATE(2599)] = 39658,
  [SMALL_STATE(2600)] = 39662,
  [SMALL_STATE(2601)] = 39666,
  [SMALL_STATE(2602)] = 39670,
  [SMALL_STATE(2603)] = 39674,
  [SMALL_STATE(2604)] = 39678,
  [SMALL_STATE(2605)] = 39682,
  [SMALL_STATE(2606)] = 39686,
  [SMALL_STATE(2607)] = 39690,
  [SMALL_STATE(2608)] = 39694,
  [SMALL_STATE(2609)] = 39698,
  [SMALL_STATE(2610)] = 39702,
  [SMALL_STATE(2611)] = 39706,
  [SMALL_STATE(2612)] = 39710,
  [SMALL_STATE(2613)] = 39714,
  [SMALL_STATE(2614)] = 39718,
  [SMALL_STATE(2615)] = 39722,
  [SMALL_STATE(2616)] = 39726,
  [SMALL_STATE(2617)] = 39730,
  [SMALL_STATE(2618)] = 39734,
  [SMALL_STATE(2619)] = 39738,
  [SMALL_STATE(2620)] = 39742,
  [SMALL_STATE(2621)] = 39746,
  [SMALL_STATE(2622)] = 39750,
  [SMALL_STATE(2623)] = 39754,
  [SMALL_STATE(2624)] = 39758,
  [SMALL_STATE(2625)] = 39762,
  [SMALL_STATE(2626)] = 39766,
  [SMALL_STATE(2627)] = 39770,
  [SMALL_STATE(2628)] = 39774,
  [SMALL_STATE(2629)] = 39778,
  [SMALL_STATE(2630)] = 39782,
  [SMALL_STATE(2631)] = 39786,
  [SMALL_STATE(2632)] = 39790,
  [SMALL_STATE(2633)] = 39794,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 0, 0, 0),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 1, 0, 0),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 2, 0, 0),
  [149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0),
  [151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1965),
  [154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(832),
  [157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(467),
  [160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(467),
  [163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(529),
  [166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1654),
  [169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(548),
  [172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1656),
  [175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(552),
  [178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1676),
  [181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1679),
  [184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1700),
  [187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1894),
  [190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1898),
  [193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1900),
  [196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1915),
  [199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(553),
  [202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1963),
  [205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(568),
  [208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(656),
  [211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(674),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(438),
  [217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(355),
  [220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(171),
  [223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(133),
  [226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1655),
  [229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(2389),
  [232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(44),
  [235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(35),
  [238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(42),
  [241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1451),
  [244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(97),
  [247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(54),
  [250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(55),
  [253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(58),
  [256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(59),
  [259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(61),
  [262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(62),
  [265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(64),
  [268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(43),
  [271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(45),
  [274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(47),
  [277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(48),
  [280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(49),
  [283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(50),
  [286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(51),
  [289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(52),
  [292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(73),
  [295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(436),
  [298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(2587),
  [301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1647),
  [304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(2409),
  [307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(123),
  [310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1382),
  [313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(106),
  [316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1041),
  [319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(2602),
  [322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(325),
  [325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(2483),
  [328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(78),
  [331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(2080),
  [334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1973),
  [337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(2631),
  [340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(104),
  [343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1398),
  [346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(105),
  [349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2, 0, 0), SHIFT_REPEAT(1070),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(1965),
  [369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(832),
  [372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(467),
  [375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(467),
  [378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(529),
  [381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(1654),
  [384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(548),
  [387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(1656),
  [390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(552),
  [393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(1676),
  [396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(1679),
  [399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(1700),
  [402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(1894),
  [405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(1898),
  [408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(1900),
  [411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(1915),
  [414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(553),
  [417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(1963),
  [420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(568),
  [423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(656),
  [426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(674),
  [429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(438),
  [432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0),
  [434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(359),
  [437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(171),
  [440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(133),
  [443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(1655),
  [446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(2483),
  [449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(44),
  [452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(35),
  [455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(42),
  [458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(1451),
  [461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(97),
  [464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(54),
  [467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(55),
  [470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(58),
  [473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(59),
  [476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(61),
  [479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(62),
  [482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(64),
  [485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(43),
  [488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(45),
  [491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(47),
  [494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(48),
  [497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(49),
  [500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(50),
  [503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(51),
  [506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(52),
  [509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(78),
  [512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(72),
  [515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(2080),
  [518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(1973),
  [521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(2631),
  [524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(104),
  [527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(1398),
  [530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(105),
  [533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(1070),
  [536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 2, 0, 0), SHIFT_REPEAT(2602),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2451),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 1, 0, 1),
  [657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 1, 0, 1),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__block_quote_content_repeat1, 1, 0, 0),
  [689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_content_repeat1, 1, 0, 0), SHIFT_REPEAT(436),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(1965),
  [751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16),
  [753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(832),
  [756] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(467),
  [759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(467),
  [762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(529),
  [765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(1654),
  [768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(548),
  [771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(1656),
  [774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(552),
  [777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(1676),
  [780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(1679),
  [783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(1700),
  [786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(1894),
  [789] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(1898),
  [792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(1900),
  [795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(1915),
  [798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(553),
  [801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(1963),
  [804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(568),
  [807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(656),
  [810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(674),
  [813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(438),
  [816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(140),
  [819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 2, 0, 16), SHIFT_REPEAT(2602),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(1878),
  [933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(831),
  [936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(461),
  [939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(461),
  [942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(523),
  [945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(1879),
  [948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(527),
  [951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(1880),
  [954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(536),
  [957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(1881),
  [960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(1882),
  [963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(1883),
  [966] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(1884),
  [969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(1885),
  [972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(1886),
  [975] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(1887),
  [978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(539),
  [981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(1888),
  [984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(833),
  [987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(834),
  [990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(835),
  [993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(443),
  [996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(142),
  [999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0),
  [1001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_header_repeat1, 2, 0, 0), SHIFT_REPEAT(2195),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [1008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 1, 0, 0),
  [1010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 1, 0, 0),
  [1012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [1022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [1028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [1040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [1044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [1064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [1072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [1080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [1114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [1120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1945),
  [1122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [1128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [1142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [1144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [1146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [1162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [1168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline, 1, 0, 4),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [1172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1878),
  [1175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(831),
  [1178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(461),
  [1181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(461),
  [1184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(523),
  [1187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1879),
  [1190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(527),
  [1193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1880),
  [1196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(536),
  [1199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1881),
  [1202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1882),
  [1205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1883),
  [1208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1884),
  [1211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1885),
  [1214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1886),
  [1217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1887),
  [1220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(539),
  [1223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1888),
  [1226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(833),
  [1229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(834),
  [1232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(835),
  [1235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(443),
  [1238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(141),
  [1241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16),
  [1243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(2195),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1945),
  [1251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(862),
  [1254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(452),
  [1257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(452),
  [1260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(511),
  [1263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1946),
  [1266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(522),
  [1269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1947),
  [1272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(525),
  [1275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1948),
  [1278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1949),
  [1281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1644),
  [1284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1951),
  [1287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1953),
  [1290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1955),
  [1293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1956),
  [1296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(546),
  [1299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1957),
  [1302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(863),
  [1305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(864),
  [1308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(865),
  [1311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(437),
  [1314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(143),
  [1317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(2227),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0),
  [1324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0),
  [1326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0), SHIFT_REPEAT(1379),
  [1329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0), SHIFT_REPEAT(104),
  [1332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0), SHIFT_REPEAT(1398),
  [1335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0), SHIFT_REPEAT(105),
  [1338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [1366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [1380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [1386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1726),
  [1389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(588),
  [1392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(468),
  [1395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(468),
  [1398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(530),
  [1401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1727),
  [1404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(531),
  [1407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1728),
  [1410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(532),
  [1413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1729),
  [1416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1730),
  [1419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1731),
  [1422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1732),
  [1425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1733),
  [1428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1734),
  [1431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1735),
  [1434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(533),
  [1437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1736),
  [1440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(617),
  [1443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(618),
  [1446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(619),
  [1449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(446),
  [1452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(147),
  [1455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(2313),
  [1458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [1464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [1486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [1500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [1506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1744),
  [1509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(616),
  [1512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(470),
  [1515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(470),
  [1518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(542),
  [1521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1745),
  [1524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(543),
  [1527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1746),
  [1530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(544),
  [1533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1747),
  [1536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1748),
  [1539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1749),
  [1542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1750),
  [1545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1751),
  [1548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1752),
  [1551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1753),
  [1554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(545),
  [1557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1754),
  [1560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(644),
  [1563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(645),
  [1566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(646),
  [1569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(447),
  [1572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(149),
  [1575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(2330),
  [1578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1760),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [1582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [1584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [1590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [1594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [1602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [1620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [1626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1760),
  [1629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(643),
  [1632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(473),
  [1635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(473),
  [1638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(554),
  [1641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1761),
  [1644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(555),
  [1647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1762),
  [1650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(556),
  [1653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1763),
  [1656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1764),
  [1659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1765),
  [1662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1766),
  [1665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1767),
  [1668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1768),
  [1671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1769),
  [1674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(557),
  [1677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1770),
  [1680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(677),
  [1683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(678),
  [1686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(679),
  [1689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(448),
  [1692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(151),
  [1695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(2347),
  [1698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1774),
  [1703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(673),
  [1706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(451),
  [1709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(451),
  [1712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(521),
  [1715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1775),
  [1718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(551),
  [1721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1776),
  [1724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(489),
  [1727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1777),
  [1730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1778),
  [1733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1779),
  [1736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1780),
  [1739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1781),
  [1742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1782),
  [1745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1783),
  [1748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(509),
  [1751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1784),
  [1754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(710),
  [1757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(711),
  [1760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(712),
  [1763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(439),
  [1766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(153),
  [1769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(2364),
  [1772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [1774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [1780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1791),
  [1822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [1852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [1858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [1862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [1864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [1868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1791),
  [1871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(561),
  [1874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(454),
  [1877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(454),
  [1880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(500),
  [1883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1792),
  [1886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(502),
  [1889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1793),
  [1892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(506),
  [1895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1794),
  [1898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1795),
  [1901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1796),
  [1904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1797),
  [1907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1798),
  [1910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1799),
  [1913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1800),
  [1916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(507),
  [1919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1801),
  [1922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(737),
  [1925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(738),
  [1928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(739),
  [1931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(441),
  [1934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(156),
  [1937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(2381),
  [1940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [1960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [1964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [1966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [1980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [1982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [1986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [1988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1810),
  [1991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(736),
  [1994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(456),
  [1997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(456),
  [2000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(560),
  [2003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1811),
  [2006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(534),
  [2009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1812),
  [2012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(540),
  [2015] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1813),
  [2018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1814),
  [2021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1815),
  [2024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1816),
  [2027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1817),
  [2030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1818),
  [2033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1819),
  [2036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(541),
  [2039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1820),
  [2042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(766),
  [2045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(767),
  [2048] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(768),
  [2051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(440),
  [2054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(158),
  [2057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(2398),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [2062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1826),
  [2065] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(765),
  [2068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(458),
  [2071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(458),
  [2074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(497),
  [2077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1827),
  [2080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(498),
  [2083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1975),
  [2086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(499),
  [2089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1829),
  [2092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1830),
  [2095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1831),
  [2098] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1832),
  [2101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1833),
  [2104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1834),
  [2107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1835),
  [2110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(488),
  [2113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1836),
  [2116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(793),
  [2119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(794),
  [2122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(795),
  [2125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(442),
  [2128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(160),
  [2131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(2415),
  [2134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1704),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [2140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [2172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [2176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [2192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0), SHIFT_REPEAT(123),
  [2195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0), SHIFT_REPEAT(1382),
  [2198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0), SHIFT_REPEAT(106),
  [2201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1965),
  [2204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(832),
  [2207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(467),
  [2210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(467),
  [2213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(529),
  [2216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1654),
  [2219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(548),
  [2222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1656),
  [2225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(552),
  [2228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1676),
  [2231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1679),
  [2234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1700),
  [2237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1894),
  [2240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1898),
  [2243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1900),
  [2246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1915),
  [2249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(553),
  [2252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1963),
  [2255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(568),
  [2258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(656),
  [2261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(674),
  [2264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(438),
  [2267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(170),
  [2270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(2602),
  [2273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1842),
  [2276] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1019),
  [2279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(483),
  [2282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(483),
  [2285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(820),
  [2288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1843),
  [2291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(821),
  [2294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1844),
  [2297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(822),
  [2300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1845),
  [2303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1846),
  [2306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1847),
  [2309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1848),
  [2312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1849),
  [2315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1850),
  [2318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1851),
  [2321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(823),
  [2324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(1852),
  [2327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(902),
  [2330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(903),
  [2333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(904),
  [2336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(466),
  [2339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(285),
  [2342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 2, 0, 16), SHIFT_REPEAT(2432),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [2347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 2, 0, 0),
  [2349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 2, 0, 0),
  [2351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heading, 3, 0, 17),
  [2353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heading, 3, 0, 17),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [2357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__table_row, 2, 0, 0),
  [2359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__table_row, 2, 0, 0),
  [2361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_separator, 2, 0, 0),
  [2363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_separator, 2, 0, 0),
  [2365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_div, 4, 0, 35),
  [2367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_div, 4, 0, 35),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [2371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_row, 2, 0, 0),
  [2373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_row, 2, 0, 0),
  [2375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_code_block, 5, 0, 44),
  [2377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_code_block, 5, 0, 44),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [2381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_code_block, 5, 0, 45),
  [2383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_code_block, 5, 0, 45),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [2387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_block, 5, 0, 46),
  [2389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_block, 5, 0, 46),
  [2391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [2393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_header, 2, 0, 0),
  [2395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_header, 2, 0, 0),
  [2397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_div, 3, 0, 25),
  [2399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_div, 3, 0, 25),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [2403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_div, 5, 0, 35),
  [2405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_div, 5, 0, 35),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [2409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_code_block, 6, 0, 51),
  [2411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_code_block, 6, 0, 51),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [2415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_block, 6, 0, 52),
  [2417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_block, 6, 0, 52),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [2421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_row, 3, 0, 0),
  [2423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_row, 3, 0, 0),
  [2425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_header, 3, 0, 0),
  [2427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_header, 3, 0, 0),
  [2429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_separator, 3, 0, 0),
  [2431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_separator, 3, 0, 0),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [2435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_code_block, 4, 0, 0),
  [2437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_code_block, 4, 0, 0),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [2441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_div, 4, 0, 25),
  [2443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_div, 4, 0, 25),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [2451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [2465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 1, 0, 0),
  [2467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 1, 0, 0),
  [2469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_section, 2, 0, 8),
  [2471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_section, 2, 0, 8),
  [2473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__paragraph, 2, 0, 9),
  [2475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__paragraph, 2, 0, 9),
  [2477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_attribute, 4, 0, 32),
  [2479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_attribute, 4, 0, 32),
  [2481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block_with_heading, 2, 0, 0),
  [2483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_with_heading, 2, 0, 0),
  [2485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_section, 3, 0, 24),
  [2487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_section, 3, 0, 24),
  [2489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_dash, 2, 0, 0),
  [2491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_dash, 2, 0, 0),
  [2493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_plus, 2, 0, 0),
  [2495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_plus, 2, 0, 0),
  [2497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_star, 2, 0, 0),
  [2499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_star, 2, 0, 0),
  [2501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_task, 2, 0, 0),
  [2503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_task, 2, 0, 0),
  [2505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_definition, 2, 0, 0),
  [2507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_definition, 2, 0, 0),
  [2509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_decimal_period, 2, 0, 0),
  [2511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_decimal_period, 2, 0, 0),
  [2513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_decimal_paren, 2, 0, 0),
  [2515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_decimal_paren, 2, 0, 0),
  [2517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_decimal_parens, 2, 0, 0),
  [2519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_decimal_parens, 2, 0, 0),
  [2521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_lower_alpha_period, 2, 0, 0),
  [2523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_lower_alpha_period, 2, 0, 0),
  [2525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_lower_alpha_paren, 2, 0, 0),
  [2527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_lower_alpha_paren, 2, 0, 0),
  [2529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_lower_alpha_parens, 2, 0, 0),
  [2531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_lower_alpha_parens, 2, 0, 0),
  [2533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_upper_alpha_period, 2, 0, 0),
  [2535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_upper_alpha_period, 2, 0, 0),
  [2537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_upper_alpha_paren, 2, 0, 0),
  [2539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_upper_alpha_paren, 2, 0, 0),
  [2541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_upper_alpha_parens, 2, 0, 0),
  [2543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_upper_alpha_parens, 2, 0, 0),
  [2545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_lower_roman_period, 2, 0, 0),
  [2547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_lower_roman_period, 2, 0, 0),
  [2549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_lower_roman_paren, 2, 0, 0),
  [2551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_lower_roman_paren, 2, 0, 0),
  [2553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_lower_roman_parens, 2, 0, 0),
  [2555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_lower_roman_parens, 2, 0, 0),
  [2557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_upper_roman_period, 2, 0, 0),
  [2559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_upper_roman_period, 2, 0, 0),
  [2561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_upper_roman_paren, 2, 0, 0),
  [2563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_upper_roman_paren, 2, 0, 0),
  [2565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_upper_roman_parens, 2, 0, 0),
  [2567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_upper_roman_parens, 2, 0, 0),
  [2569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_div, 5, 0, 25),
  [2571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_div, 5, 0, 25),
  [2573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_quote, 3, 0, 20),
  [2575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_quote, 3, 0, 20),
  [2577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_attribute, 3, 0, 0),
  [2579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_attribute, 3, 0, 0),
  [2581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_div_repeat1, 1, 0, 0),
  [2583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_div_repeat1, 1, 0, 0),
  [2585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 1, 0, 0),
  [2587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 1, 0, 0),
  [2589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_frontmatter, 6, 0, 50),
  [2591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_frontmatter, 6, 0, 50),
  [2593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_thematic_break, 2, 0, 0),
  [2595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_thematic_break, 2, 0, 0),
  [2597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_code_block, 6, 0, 0),
  [2599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_code_block, 6, 0, 0),
  [2601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_caption, 3, 0, 42),
  [2603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_caption, 3, 0, 42),
  [2605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_footnote, 6, 0, 53),
  [2607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_footnote, 6, 0, 53),
  [2609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 3, 0, 0),
  [2611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 3, 0, 0),
  [2613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heading, 4, 0, 17),
  [2615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heading, 4, 0, 17),
  [2617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_div, 6, 0, 25),
  [2619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_div, 6, 0, 25),
  [2621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_div, 6, 0, 35),
  [2623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_div, 6, 0, 35),
  [2625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_frontmatter, 7, 0, 55),
  [2627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_frontmatter, 7, 0, 55),
  [2629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_code_block, 7, 0, 44),
  [2631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_code_block, 7, 0, 44),
  [2633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_code_block, 7, 0, 45),
  [2635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_code_block, 7, 0, 45),
  [2637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_block, 7, 0, 56),
  [2639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_block, 7, 0, 56),
  [2641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference_definition, 7, 0, 57),
  [2643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_reference_definition, 7, 0, 57),
  [2645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_div, 7, 0, 35),
  [2647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_div, 7, 0, 35),
  [2649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_code_block, 8, 0, 51),
  [2651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_code_block, 8, 0, 51),
  [2653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_block, 8, 0, 58),
  [2655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_block, 8, 0, 58),
  [2657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_footnote_content, 3, 0, 0),
  [2659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_footnote_content, 3, 0, 0),
  [2661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_footnote_content, 4, 0, 0),
  [2663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_footnote_content, 4, 0, 0),
  [2665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference_definition, 9, 0, 59),
  [2667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_reference_definition, 9, 0, 59),
  [2669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_marker_task, 3, 0, 19),
  [2671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_marker_task, 3, 0, 19),
  [2673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0),
  [2675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0),
  [2677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(430),
  [2680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(435),
  [2683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block_quote_prefix, 1, 0, 0),
  [2685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_quote_prefix, 1, 0, 0),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [2689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(436),
  [2692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element, 1, 0, 0),
  [2694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element, 1, 0, 0),
  [2696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [2698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1719),
  [2700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [2702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [2704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [2706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [2708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [2710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [2712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1737),
  [2716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [2718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [2720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element, 1, 100, 0),
  [2722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element, 1, 100, 0),
  [2724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [2726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verbatim, 3, 0, 23),
  [2728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verbatim, 3, 0, 23),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [2754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_link_text, 1, 0, 0), REDUCE(sym__symbol_fallback, 1, 0, 0),
  [2757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__symbol_fallback, 1, 0, 0),
  [2759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__symbol_fallback, 1, 0, 0),
  [2761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_text, 1, 0, 0),
  [2763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_text, 1, 0, 0), REDUCE(sym__symbol_fallback, 1, 0, 0),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [2768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__symbol_fallback, 2, 0, 0),
  [2770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__symbol_fallback, 2, 0, 0),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [2776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__text, 2, 0, 0),
  [2778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__text, 2, 0, 0),
  [2780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__text, 2, 0, 0), SHIFT_REPEAT(492),
  [2783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__text, 2, 0, 0), SHIFT_REPEAT(493),
  [2786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [2788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__text, 2, 0, 0), SHIFT_REPEAT(495),
  [2791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__text, 2, 0, 0), SHIFT_REPEAT(496),
  [2794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [2798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [2800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [2802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [2806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [2814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [2816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [2818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__text, 2, 0, 0), SHIFT_REPEAT(512),
  [2821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__text, 2, 0, 0), SHIFT_REPEAT(513),
  [2824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__text, 2, 0, 0), SHIFT_REPEAT(514),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [2829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__text, 2, 0, 0), SHIFT_REPEAT(516),
  [2832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [2834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [2836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [2838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [2842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [2848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__text, 2, 0, 0), SHIFT_REPEAT(526),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [2855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [2857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [2871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__text, 2, 0, 0), SHIFT_REPEAT(538),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [2876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [2888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__text, 2, 0, 0), SHIFT_REPEAT(550),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [2895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [2903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__text, 2, 0, 0), SHIFT_REPEAT(559),
  [2906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [2908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 1, 0, 0),
  [2910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 1, 0, 0),
  [2912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [2914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_collapsed_reference_image, 2, 0, 10),
  [2916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_collapsed_reference_image, 2, 0, 10),
  [2918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_full_reference_image, 2, 0, 11),
  [2920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_reference_image, 2, 0, 11),
  [2922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_image, 2, 0, 12),
  [2924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_image, 2, 0, 12),
  [2926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_collapsed_reference_link, 2, 0, 13),
  [2928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_collapsed_reference_link, 2, 0, 13),
  [2930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_full_reference_link, 2, 0, 14),
  [2932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_reference_link, 2, 0, 14),
  [2934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_link, 2, 0, 15),
  [2936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_link, 2, 0, 15),
  [2938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__symbol_fallback, 1, 0, 0), SHIFT(2186),
  [2941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_autolink, 3, 0, 0),
  [2943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_autolink, 3, 0, 0),
  [2945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__symbol_fallback, 3, 0, 0),
  [2947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__symbol_fallback, 3, 0, 0),
  [2949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_inline, 4, 0, 33),
  [2951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_inline, 4, 0, 33),
  [2953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_math, 4, 0, 34),
  [2955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_math, 4, 0, 34),
  [2957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_emphasis, 4, 0, 38),
  [2959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_emphasis, 4, 0, 38),
  [2961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_strong, 4, 0, 38),
  [2963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_strong, 4, 0, 38),
  [2965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_superscript, 4, 0, 39),
  [2967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_superscript, 4, 0, 39),
  [2969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 4, 0, 39),
  [2971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 4, 0, 39),
  [2973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_highlighted, 4, 0, 39),
  [2975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_highlighted, 4, 0, 39),
  [2977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_insert, 4, 0, 39),
  [2979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 4, 0, 39),
  [2981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete, 4, 0, 39),
  [2983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete, 4, 0, 39),
  [2985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_footnote_reference, 4, 0, 40),
  [2987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_footnote_reference, 4, 0, 40),
  [2989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__link_label, 3, 0, 41),
  [2991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__link_label, 3, 0, 41),
  [2993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_comment, 5, 0, 48),
  [2995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_comment, 5, 0, 48),
  [2997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_link_destination, 4, 0, 0),
  [2999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_link_destination, 4, 0, 0),
  [3001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_inline_attribute, 3, 0, 54),
  [3003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_inline_attribute, 3, 0, 54),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [3007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__symbol_fallback, 1, 0, 0), SHIFT(2292),
  [3010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_todo, 1, 0, 0),
  [3012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_todo, 1, 0, 0),
  [3014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_note, 1, 0, 0),
  [3016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_note, 1, 0, 0),
  [3018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_table_caption_repeat1, 1, 0, 4),
  [3020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_table_caption_repeat1, 1, 0, 4),
  [3022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [3024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__symbol_fallback, 1, 0, 0), SHIFT(2316),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [3029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__symbol_fallback, 1, 0, 0), SHIFT(2333),
  [3032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [3034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__symbol_fallback, 1, 0, 0), SHIFT(2350),
  [3037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__symbol_fallback, 1, 0, 0), SHIFT(2367),
  [3040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [3042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__symbol_fallback, 1, 0, 0), SHIFT(2384),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [3047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__symbol_fallback, 1, 0, 0), SHIFT(2401),
  [3050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__symbol_fallback, 1, 0, 0), SHIFT(2418),
  [3053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [3061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__text, 2, 0, 0), SHIFT_REPEAT(827),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [3066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [3068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__symbol_fallback, 1, 0, 0), SHIFT(2202),
  [3071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(934),
  [3074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_line, 2, 0, 4),
  [3076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_line, 2, 0, 4),
  [3078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [3080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__symbol_fallback, 1, 0, 0), SHIFT(2233),
  [3083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__symbol_fallback, 1, 0, 0), SHIFT(2263),
  [3086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_attribute, 4, 0, 43),
  [3088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_attribute, 4, 0, 43),
  [3090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element, 2, 0, 0),
  [3092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element, 2, 0, 0),
  [3094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_span, 5, 100, 49),
  [3096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_span, 5, 100, 49),
  [3098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_attribute, 3, 0, 0),
  [3100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_attribute, 3, 0, 0),
  [3102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element, 2, 100, 0),
  [3104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element, 2, 100, 0),
  [3106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__inline_repeat1, 1, 0, 4),
  [3108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_repeat1, 1, 0, 4),
  [3110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__symbol_fallback, 1, 0, 0), SHIFT(2435),
  [3113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__curly_bracket_span_fallback, 2, 0, 0),
  [3115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__curly_bracket_span_fallback, 2, 0, 0),
  [3117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element, 2, 200, 5),
  [3119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element, 2, 200, 5),
  [3121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_without_trailing_space, 1, 0, 4),
  [3123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_without_trailing_space, 2, 0, 16),
  [3125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__table_cell, 2, 0, 21),
  [3127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__table_cell, 2, 0, 21),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [3143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0), SHIFT_REPEAT(113),
  [3146] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0), SHIFT_REPEAT(1368),
  [3149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0), SHIFT_REPEAT(114),
  [3152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [3154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [3156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0), SHIFT_REPEAT(120),
  [3159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0), SHIFT_REPEAT(1374),
  [3162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0), SHIFT_REPEAT(121),
  [3165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0), SHIFT_REPEAT(112),
  [3168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0), SHIFT_REPEAT(1401),
  [3171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_repeat1, 2, 0, 0), SHIFT_REPEAT(118),
  [3174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [3180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [3182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [3186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [3196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(1907),
  [3199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(1197),
  [3202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(2600),
  [3205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(1348),
  [3208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_inline_attribute_repeat1, 2, 0, 0),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [3224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_attribute_repeat1, 2, 0, 0),
  [3226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(1756),
  [3229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(1178),
  [3232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(2600),
  [3235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(1344),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [3306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_task_repeat1, 2, 0, 0),
  [3308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_task_repeat1, 2, 0, 0), SHIFT_REPEAT(1451),
  [3311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_task_repeat1, 2, 0, 0), SHIFT_REPEAT(1659),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [3350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_dash_repeat1, 2, 0, 0),
  [3352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_dash_repeat1, 2, 0, 0), SHIFT_REPEAT(44),
  [3355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_dash_repeat1, 2, 0, 0), SHIFT_REPEAT(1893),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [3368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_plus_repeat1, 2, 0, 0),
  [3370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_plus_repeat1, 2, 0, 0), SHIFT_REPEAT(42),
  [3373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_plus_repeat1, 2, 0, 0), SHIFT_REPEAT(1695),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [3430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [3432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [3444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_star_repeat1, 2, 0, 0),
  [3446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_star_repeat1, 2, 0, 0), SHIFT_REPEAT(35),
  [3449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_star_repeat1, 2, 0, 0), SHIFT_REPEAT(1863),
  [3452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, 0, 22),
  [3460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_inline_attribute_repeat1, 1, 0, 7),
  [3462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_repeat1, 2, 0, 0), SHIFT_REPEAT(2372),
  [3465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_code_repeat1, 2, 0, 0),
  [3467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_repeat1, 2, 0, 0), SHIFT_REPEAT(1871),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [3476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value, 1, 0, 0),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [3510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key_value, 3, 0, 31),
  [3512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value, 3, 0, 0),
  [3514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comment, 2, 0, 0),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [3518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_attribute_repeat1, 1, 0, 7),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [3528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_name, 1, 0, 0),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [3538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [3542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_upper_roman_paren_repeat1, 2, 0, 0),
  [3544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_upper_roman_paren_repeat1, 2, 0, 0), SHIFT_REPEAT(47),
  [3547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_upper_roman_paren_repeat1, 2, 0, 0), SHIFT_REPEAT(1864),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [3552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_attribute_repeat1, 1, 0, 0),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [3562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [3566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_decimal_period_repeat1, 2, 0, 0),
  [3568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_decimal_period_repeat1, 2, 0, 0), SHIFT_REPEAT(54),
  [3571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_decimal_period_repeat1, 2, 0, 0), SHIFT_REPEAT(1703),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_upper_roman_parens_repeat1, 2, 0, 0),
  [3578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_upper_roman_parens_repeat1, 2, 0, 0), SHIFT_REPEAT(52),
  [3581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_upper_roman_parens_repeat1, 2, 0, 0), SHIFT_REPEAT(1866),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [3590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_inline_attribute_repeat1, 1, 0, 0),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [3602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [3604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_decimal_paren_repeat1, 2, 0, 0),
  [3606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_decimal_paren_repeat1, 2, 0, 0), SHIFT_REPEAT(62),
  [3609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_decimal_paren_repeat1, 2, 0, 0), SHIFT_REPEAT(1755),
  [3612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comment, 3, 0, 30),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [3618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_code, 1, 0, 0),
  [3620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [3626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [3632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_decimal_parens_repeat1, 2, 0, 0),
  [3634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_decimal_parens_repeat1, 2, 0, 0), SHIFT_REPEAT(48),
  [3637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_decimal_parens_repeat1, 2, 0, 0), SHIFT_REPEAT(1865),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [3644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_lower_alpha_period_repeat1, 2, 0, 0),
  [3646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_lower_alpha_period_repeat1, 2, 0, 0), SHIFT_REPEAT(55),
  [3649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_lower_alpha_period_repeat1, 2, 0, 0), SHIFT_REPEAT(1914),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [3654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_lower_alpha_paren_repeat1, 2, 0, 0),
  [3656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_lower_alpha_paren_repeat1, 2, 0, 0), SHIFT_REPEAT(64),
  [3659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_lower_alpha_paren_repeat1, 2, 0, 0), SHIFT_REPEAT(1653),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [3664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_lower_alpha_parens_repeat1, 2, 0, 0),
  [3666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_lower_alpha_parens_repeat1, 2, 0, 0), SHIFT_REPEAT(49),
  [3669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_lower_alpha_parens_repeat1, 2, 0, 0), SHIFT_REPEAT(1698),
  [3672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_upper_alpha_period_repeat1, 2, 0, 0),
  [3674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_upper_alpha_period_repeat1, 2, 0, 0), SHIFT_REPEAT(58),
  [3677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_upper_alpha_period_repeat1, 2, 0, 0), SHIFT_REPEAT(1724),
  [3680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_upper_alpha_paren_repeat1, 2, 0, 0),
  [3682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_upper_alpha_paren_repeat1, 2, 0, 0), SHIFT_REPEAT(43),
  [3685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_upper_alpha_paren_repeat1, 2, 0, 0), SHIFT_REPEAT(1805),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [3692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_upper_alpha_parens_repeat1, 2, 0, 0),
  [3694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_upper_alpha_parens_repeat1, 2, 0, 0), SHIFT_REPEAT(50),
  [3697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_upper_alpha_parens_repeat1, 2, 0, 0), SHIFT_REPEAT(1821),
  [3700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_lower_roman_period_repeat1, 2, 0, 0),
  [3702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_lower_roman_period_repeat1, 2, 0, 0), SHIFT_REPEAT(59),
  [3705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_lower_roman_period_repeat1, 2, 0, 0), SHIFT_REPEAT(1825),
  [3708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_lower_roman_paren_repeat1, 2, 0, 0),
  [3710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_lower_roman_paren_repeat1, 2, 0, 0), SHIFT_REPEAT(45),
  [3713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_lower_roman_paren_repeat1, 2, 0, 0), SHIFT_REPEAT(1840),
  [3716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_lower_roman_parens_repeat1, 2, 0, 0),
  [3718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_lower_roman_parens_repeat1, 2, 0, 0), SHIFT_REPEAT(51),
  [3721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_lower_roman_parens_repeat1, 2, 0, 0), SHIFT_REPEAT(1841),
  [3724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_upper_roman_period_repeat1, 2, 0, 0),
  [3726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_upper_roman_period_repeat1, 2, 0, 0), SHIFT_REPEAT(61),
  [3729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_upper_roman_period_repeat1, 2, 0, 0), SHIFT_REPEAT(1860),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [3734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [3740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_footnote_content_repeat1, 2, 0, 0), SHIFT_REPEAT(1875),
  [3743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_footnote_content_repeat1, 2, 0, 0), SHIFT_REPEAT(66),
  [3746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_footnote_content_repeat1, 2, 0, 0),
  [3748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [3758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_text, 4, 0, 37),
  [3760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_text, 4, 0, 37),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [3764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [3772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [3776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [3778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [3782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [3786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [3790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [3792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [3794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [3796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [3798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [3804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [3806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [3810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [3812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [3814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [3816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [3822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [3824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [3826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [3828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [3830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [3832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [3834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [3836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [3838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [3840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [3842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [3844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [3848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [3850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [3852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [3854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [3856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [3858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [3860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [3862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [3864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [3866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [3870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [3882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [3884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [3890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [3896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [3900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [3908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [3912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_item_content_repeat1, 2, 0, 0), SHIFT_REPEAT(71),
  [3915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_item_content_repeat1, 2, 0, 0),
  [3917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_item_content_repeat1, 2, 0, 0), SHIFT_REPEAT(1874),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [3922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [3934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [3942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_item_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(65),
  [3945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_item_definition_repeat1, 2, 0, 0),
  [3947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_item_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1874),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [3954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [3958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [3966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [3974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [3976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [3982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [3988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [3992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [3996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [3998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [4000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [4006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [4008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [4010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [4012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1379),
  [4015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__block_quote_content_repeat1, 2, 0, 0),
  [4017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_content_repeat1, 2, 0, 0), SHIFT_REPEAT(430),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [4024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__comment_repeat1, 2, 0, 0), SHIFT_REPEAT(1376),
  [4027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__comment_repeat1, 2, 0, 0),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [4031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_quote_content, 1, 0, 0),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [4037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_quote_content, 2, 0, 0),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [4045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_definition_repeat1, 2, 0, 0),
  [4047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(97),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [4072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_link_url, 2, 0, 0), SHIFT_REPEAT(1369),
  [4075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_link_url, 2, 0, 0),
  [4077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [4089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__comment_repeat1, 1, 0, 0),
  [4091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__comment_repeat1, 1, 0, 0),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [4099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [4103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [4109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_frontmatter_content, 1, 0, 0),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [4119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [4125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [4157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_separator_repeat1, 2, 0, 0), SHIFT_REPEAT(2112),
  [4160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_table_separator_repeat1, 2, 0, 0),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [4164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_frontmatter_content_repeat1, 2, 0, 0), SHIFT_REPEAT(2070),
  [4167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_frontmatter_content_repeat1, 2, 0, 0),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [4171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_lower_roman_paren_repeat1, 1, 0, 2),
  [4173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_lower_roman_paren, 2, 0, 6),
  [4175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [4179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_lower_alpha_parens_repeat1, 1, 0, 2),
  [4181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_upper_alpha_period_repeat1, 1, 0, 2),
  [4183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_upper_roman_parens_repeat1, 1, 0, 2),
  [4185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_item_content_repeat1, 4, 0, 0),
  [4187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_item_content, 3, 0, 0),
  [4189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_lower_roman_period_repeat1, 1, 0, 2),
  [4191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_item_content, 4, 0, 0),
  [4193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1825),
  [4196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_dash_repeat1, 1, 0, 2),
  [4198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1653),
  [4201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1698),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [4210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1840),
  [4213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_dash, 3, 0, 26),
  [4215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1805),
  [4218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_plus_repeat1, 1, 0, 2),
  [4220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1863),
  [4223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_item_content_repeat1, 3, 0, 0),
  [4225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1841),
  [4228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_item_definition_repeat1, 3, 0, 0),
  [4230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_task, 2, 0, 6),
  [4232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1860),
  [4235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_dash, 2, 0, 6),
  [4237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1755),
  [4240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_star, 3, 0, 26),
  [4242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1864),
  [4245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_lower_alpha_parens, 2, 0, 6),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [4249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__heading_content_repeat1, 2, 0, 16),
  [4251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__heading_content_repeat1, 2, 0, 16), SHIFT_REPEAT(135),
  [4254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_lower_roman_parens_repeat1, 1, 0, 2),
  [4256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1866),
  [4259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_plus, 3, 0, 26),
  [4261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_decimal_parens, 2, 0, 6),
  [4263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_decimal_period, 3, 0, 26),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [4267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__line, 2, 0, 0),
  [4269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_decimal_paren_repeat1, 1, 0, 2),
  [4271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_task_repeat1, 1, 0, 2),
  [4273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__heading_content, 1, 0, 4),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [4277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__heading_content, 2, 0, 16),
  [4279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_star, 2, 0, 6),
  [4281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_lower_alpha_period, 3, 0, 26),
  [4283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_plus, 2, 0, 6),
  [4285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_upper_roman_parens, 2, 0, 6),
  [4287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1703),
  [4290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_upper_roman_paren, 2, 0, 6),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [4296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_decimal_parens_repeat1, 1, 0, 2),
  [4298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_upper_roman_period_repeat1, 1, 0, 2),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [4302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [4304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_star_repeat1, 1, 0, 2),
  [4306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1724),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [4313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [4315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1865),
  [4318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_decimal_period_repeat1, 1, 0, 2),
  [4320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1871),
  [4323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [4325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_decimal_period, 2, 0, 6),
  [4327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_upper_alpha_period, 3, 0, 26),
  [4329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_lower_roman_period, 3, 0, 26),
  [4331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_upper_roman_period, 3, 0, 26),
  [4333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_decimal_paren, 3, 0, 26),
  [4335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_lower_alpha_period_repeat1, 1, 0, 2),
  [4337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_lower_alpha_paren, 3, 0, 26),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [4341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_upper_alpha_paren, 3, 0, 26),
  [4343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_footnote_content_repeat1, 3, 0, 0),
  [4345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1893),
  [4348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_lower_alpha_period, 2, 0, 6),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [4354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1874),
  [4357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1659),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [4364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_lower_roman_paren, 3, 0, 26),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [4368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1875),
  [4371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1914),
  [4374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [4378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_footnote_content_repeat1, 4, 0, 0),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [4382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_upper_roman_paren_repeat1, 1, 0, 2),
  [4384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_upper_roman_paren, 3, 0, 26),
  [4386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_decimal_parens, 3, 0, 26),
  [4388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_lower_alpha_parens, 3, 0, 26),
  [4390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_upper_alpha_parens, 3, 0, 26),
  [4392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_lower_roman_parens, 3, 0, 26),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [4396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_upper_roman_parens, 3, 0, 26),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [4402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [4404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_task, 3, 0, 26),
  [4406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [4410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [4412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_upper_alpha_paren_repeat1, 1, 0, 2),
  [4414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [4418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__paragraph_content_repeat1, 2, 0, 16),
  [4420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paragraph_content_repeat1, 2, 0, 16), SHIFT_REPEAT(109),
  [4423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_upper_alpha_period, 2, 0, 6),
  [4425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_lower_roman_period, 2, 0, 6),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [4429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_upper_roman_period, 2, 0, 6),
  [4431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_lower_alpha_paren_repeat1, 1, 0, 2),
  [4433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_upper_alpha_parens_repeat1, 1, 0, 2),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [4437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_image_description, 4, 0, 37),
  [4439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_image_description, 4, 0, 37),
  [4441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_image_description, 3, 0, 0),
  [4443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_image_description, 3, 0, 0),
  [4445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_decimal_paren, 2, 0, 6),
  [4447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_upper_alpha_parens, 2, 0, 6),
  [4449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_lower_alpha_paren, 2, 0, 6),
  [4451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_lower_roman_parens, 2, 0, 6),
  [4453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1695),
  [4456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_quote_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(1821),
  [4459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_upper_alpha_paren, 2, 0, 6),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [4463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_highlighted_begin, 1, 0, 0), SHIFT(866),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [4468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__curly_bracket_span_begin, 1, 0, 0), SHIFT(993),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [4473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [4475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [4477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [4479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 2, 0, 0), SHIFT(874),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [4484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 2, 0, 0), SHIFT(874),
  [4487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 1, 0, 0), SHIFT(575),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [4494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__div_marker_begin, 1, 0, 0),
  [4496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 1, 0, 0), SHIFT(575),
  [4499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__paragraph_content, 3, 0, 27),
  [4501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [4503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [4505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [4507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [4509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__paragraph_content_repeat1, 2, 0, 27),
  [4511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__paragraph_content, 3, 0, 16),
  [4513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__bracketed_text_begin, 1, 0, 0), SHIFT(745),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [4518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 1, 0, 0), SHIFT(745),
  [4521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 1, 0, 0), SHIFT(745),
  [4524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_superscript_begin, 1, 0, 0), SHIFT(745),
  [4527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subscript_begin, 1, 0, 0), SHIFT(745),
  [4530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_highlighted_begin, 1, 0, 0), SHIFT(745),
  [4533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_insert_begin, 1, 0, 0), SHIFT(745),
  [4536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_delete_begin, 1, 0, 0), SHIFT(745),
  [4539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_footnote_marker_begin, 1, 0, 0), SHIFT(745),
  [4542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__image_description_begin, 1, 0, 0), SHIFT(745),
  [4545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_superscript_begin, 1, 0, 0), SHIFT(575),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [4552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subscript_begin, 1, 0, 0), SHIFT(575),
  [4555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__curly_bracket_span_begin, 1, 0, 0), SHIFT(975),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [4560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 2, 0, 0), SHIFT(570),
  [4563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [4565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 2, 0, 0), SHIFT(570),
  [4568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__paragraph_content, 2, 0, 4),
  [4570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_highlighted_begin, 1, 0, 0), SHIFT(575),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [4579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__bracketed_text_begin, 1, 0, 0), SHIFT(593),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [4584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 1, 0, 0), SHIFT(593),
  [4587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 1, 0, 0), SHIFT(593),
  [4590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_superscript_begin, 1, 0, 0), SHIFT(593),
  [4593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subscript_begin, 1, 0, 0), SHIFT(593),
  [4596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_highlighted_begin, 1, 0, 0), SHIFT(593),
  [4599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_insert_begin, 1, 0, 0), SHIFT(593),
  [4602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_delete_begin, 1, 0, 0), SHIFT(593),
  [4605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_footnote_marker_begin, 1, 0, 0), SHIFT(593),
  [4608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__image_description_begin, 1, 0, 0), SHIFT(593),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [4615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__heading_content_repeat1, 2, 0, 27),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [4619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__curly_bracket_span_begin, 1, 0, 0), SHIFT(981),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [4624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__curly_bracket_span_begin, 1, 0, 0), SHIFT(906),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [4629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_definition, 4, 0, 29),
  [4631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 2, 0, 0), SHIFT(601),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [4636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 2, 0, 0), SHIFT(601),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [4641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [4643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__bracketed_text_begin, 1, 0, 0), SHIFT(620),
  [4646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [4648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 1, 0, 0), SHIFT(620),
  [4651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 1, 0, 0), SHIFT(620),
  [4654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_superscript_begin, 1, 0, 0), SHIFT(620),
  [4657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subscript_begin, 1, 0, 0), SHIFT(620),
  [4660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_highlighted_begin, 1, 0, 0), SHIFT(620),
  [4663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_insert_begin, 1, 0, 0), SHIFT(620),
  [4666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_delete_begin, 1, 0, 0), SHIFT(620),
  [4669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_footnote_marker_begin, 1, 0, 0), SHIFT(620),
  [4672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__image_description_begin, 1, 0, 0), SHIFT(620),
  [4675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__curly_bracket_span_begin, 1, 0, 0), SHIFT(1010),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [4680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 2, 0, 0), SHIFT(628),
  [4683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [4685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 2, 0, 0), SHIFT(628),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [4690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__bracketed_text_begin, 1, 0, 0), SHIFT(647),
  [4693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [4695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 1, 0, 0), SHIFT(647),
  [4698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 1, 0, 0), SHIFT(647),
  [4701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_superscript_begin, 1, 0, 0), SHIFT(647),
  [4704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subscript_begin, 1, 0, 0), SHIFT(647),
  [4707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_highlighted_begin, 1, 0, 0), SHIFT(647),
  [4710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_insert_begin, 1, 0, 0), SHIFT(647),
  [4713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_delete_begin, 1, 0, 0), SHIFT(647),
  [4716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_footnote_marker_begin, 1, 0, 0), SHIFT(647),
  [4719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__image_description_begin, 1, 0, 0), SHIFT(647),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [4724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__curly_bracket_span_begin, 1, 0, 0), SHIFT(950),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [4729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 2, 0, 0), SHIFT(658),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [4734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 2, 0, 0), SHIFT(658),
  [4737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__bracketed_text_begin, 1, 0, 0), SHIFT(683),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [4742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 1, 0, 0), SHIFT(683),
  [4745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 1, 0, 0), SHIFT(683),
  [4748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_superscript_begin, 1, 0, 0), SHIFT(683),
  [4751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subscript_begin, 1, 0, 0), SHIFT(683),
  [4754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_highlighted_begin, 1, 0, 0), SHIFT(683),
  [4757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_insert_begin, 1, 0, 0), SHIFT(683),
  [4760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_delete_begin, 1, 0, 0), SHIFT(683),
  [4763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_footnote_marker_begin, 1, 0, 0), SHIFT(683),
  [4766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__image_description_begin, 1, 0, 0), SHIFT(683),
  [4769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__curly_bracket_span_begin, 1, 0, 0), SHIFT(963),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [4774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 2, 0, 0), SHIFT(695),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [4779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 2, 0, 0), SHIFT(695),
  [4782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__bracketed_text_begin, 1, 0, 0), SHIFT(713),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [4787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 1, 0, 0), SHIFT(713),
  [4790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 1, 0, 0), SHIFT(713),
  [4793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_superscript_begin, 1, 0, 0), SHIFT(713),
  [4796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subscript_begin, 1, 0, 0), SHIFT(713),
  [4799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_highlighted_begin, 1, 0, 0), SHIFT(713),
  [4802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_insert_begin, 1, 0, 0), SHIFT(713),
  [4805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_delete_begin, 1, 0, 0), SHIFT(713),
  [4808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_footnote_marker_begin, 1, 0, 0), SHIFT(713),
  [4811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__image_description_begin, 1, 0, 0), SHIFT(713),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [4816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__curly_bracket_span_begin, 1, 0, 0), SHIFT(933),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [4821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 2, 0, 0), SHIFT(721),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [4826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 2, 0, 0), SHIFT(721),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [4835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__bracketed_text_begin, 1, 0, 0), SHIFT(740),
  [4838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [4840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 1, 0, 0), SHIFT(740),
  [4843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 1, 0, 0), SHIFT(740),
  [4846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_superscript_begin, 1, 0, 0), SHIFT(740),
  [4849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subscript_begin, 1, 0, 0), SHIFT(740),
  [4852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_highlighted_begin, 1, 0, 0), SHIFT(740),
  [4855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_insert_begin, 1, 0, 0), SHIFT(740),
  [4858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_delete_begin, 1, 0, 0), SHIFT(740),
  [4861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_footnote_marker_begin, 1, 0, 0), SHIFT(740),
  [4864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__image_description_begin, 1, 0, 0), SHIFT(740),
  [4867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__curly_bracket_span_begin, 1, 0, 0), SHIFT(1000),
  [4870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [4872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 2, 0, 0), SHIFT(750),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [4877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 2, 0, 0), SHIFT(750),
  [4880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__paragraph_content, 4, 0, 36),
  [4882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__paragraph_content_repeat1, 3, 0, 37),
  [4884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [4886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [4888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__bracketed_text_begin, 1, 0, 0), SHIFT(769),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [4893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 1, 0, 0), SHIFT(769),
  [4896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 1, 0, 0), SHIFT(769),
  [4899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_superscript_begin, 1, 0, 0), SHIFT(769),
  [4902] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subscript_begin, 1, 0, 0), SHIFT(769),
  [4905] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_highlighted_begin, 1, 0, 0), SHIFT(769),
  [4908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_insert_begin, 1, 0, 0), SHIFT(769),
  [4911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_delete_begin, 1, 0, 0), SHIFT(769),
  [4914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_footnote_marker_begin, 1, 0, 0), SHIFT(769),
  [4917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__image_description_begin, 1, 0, 0), SHIFT(769),
  [4920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__curly_bracket_span_begin, 1, 0, 0), SHIFT(952),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [4925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 2, 0, 0), SHIFT(778),
  [4928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [4930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 2, 0, 0), SHIFT(778),
  [4933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__bracketed_text_begin, 1, 0, 0), SHIFT(796),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [4938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 1, 0, 0), SHIFT(796),
  [4941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_superscript_begin, 1, 0, 0), SHIFT(796),
  [4944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subscript_begin, 1, 0, 0), SHIFT(796),
  [4947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_highlighted_begin, 1, 0, 0), SHIFT(796),
  [4950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_insert_begin, 1, 0, 0), SHIFT(796),
  [4953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_delete_begin, 1, 0, 0), SHIFT(796),
  [4956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_footnote_marker_begin, 1, 0, 0), SHIFT(796),
  [4959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__image_description_begin, 1, 0, 0), SHIFT(796),
  [4962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__curly_bracket_span_begin, 1, 0, 0), SHIFT(998),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [4967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 2, 0, 0), SHIFT(804),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [4972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 2, 0, 0), SHIFT(804),
  [4975] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__bracketed_text_begin, 1, 0, 0), SHIFT(907),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [4980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 1, 0, 0), SHIFT(907),
  [4983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 1, 0, 0), SHIFT(907),
  [4986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_superscript_begin, 1, 0, 0), SHIFT(907),
  [4989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subscript_begin, 1, 0, 0), SHIFT(907),
  [4992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_highlighted_begin, 1, 0, 0), SHIFT(907),
  [4995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_insert_begin, 1, 0, 0), SHIFT(907),
  [4998] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_delete_begin, 1, 0, 0), SHIFT(907),
  [5001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_footnote_marker_begin, 1, 0, 0), SHIFT(907),
  [5004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__image_description_begin, 1, 0, 0), SHIFT(907),
  [5007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 2, 0, 0), SHIFT(572),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [5012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 2, 0, 0), SHIFT(572),
  [5015] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__curly_bracket_span_begin, 1, 0, 0), SHIFT(1024),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [5020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 2, 0, 0), SHIFT(917),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [5025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 2, 0, 0), SHIFT(917),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [5030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [5032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [5034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__table_cell_alignment, 2, 0, 0),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [5042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_definition_repeat1, 1, 0, 3),
  [5044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [5046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__bracketed_text_begin, 1, 0, 0), SHIFT(837),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [5051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 1, 0, 0), SHIFT(837),
  [5054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 1, 0, 0), SHIFT(837),
  [5057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_superscript_begin, 1, 0, 0), SHIFT(837),
  [5060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subscript_begin, 1, 0, 0), SHIFT(837),
  [5063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_highlighted_begin, 1, 0, 0), SHIFT(837),
  [5066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_insert_begin, 1, 0, 0), SHIFT(837),
  [5069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_delete_begin, 1, 0, 0), SHIFT(837),
  [5072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_footnote_marker_begin, 1, 0, 0), SHIFT(837),
  [5075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__image_description_begin, 1, 0, 0), SHIFT(837),
  [5078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [5080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [5082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_insert_begin, 1, 0, 0), SHIFT(575),
  [5085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_delete_begin, 1, 0, 0), SHIFT(575),
  [5088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_footnote_marker_begin, 1, 0, 0), SHIFT(575),
  [5091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_definition, 5, 0, 47),
  [5093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__curly_bracket_span_begin, 1, 0, 0), SHIFT(955),
  [5096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [5098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [5100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 2, 0, 0), SHIFT(847),
  [5103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [5105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 2, 0, 0), SHIFT(847),
  [5108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__image_description_begin, 1, 0, 0), SHIFT(575),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [5115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [5119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__bracketed_text_begin, 1, 0, 0), SHIFT(866),
  [5122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_emphasis_begin, 1, 0, 0), SHIFT(866),
  [5125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 1, 0, 0), SHIFT(866),
  [5128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_superscript_begin, 1, 0, 0), SHIFT(866),
  [5131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subscript_begin, 1, 0, 0), SHIFT(866),
  [5134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_insert_begin, 1, 0, 0), SHIFT(866),
  [5137] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_delete_begin, 1, 0, 0), SHIFT(866),
  [5140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_footnote_marker_begin, 1, 0, 0), SHIFT(866),
  [5143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__image_description_begin, 1, 0, 0), SHIFT(866),
  [5146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [5148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [5150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__bracketed_text_begin, 1, 0, 0), SHIFT(575),
  [5153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_strong_begin, 1, 0, 0), SHIFT(796),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [5158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [5160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [5162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [5164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [5166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [5170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [5172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [5174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [5176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__div_marker_begin, 3, 0, 18),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [5182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [5186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [5188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [5190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [5196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [5198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [5200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [5204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [5206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [5208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [5212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [5216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [5218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [5224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [5228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [5230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [5232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [5236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_footnote_marker_begin, 1, 0, 0),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [5246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [5264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [5270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [5290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [5294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [5304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [5306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [5310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [5312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [5314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [5316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [5318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [5320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [5322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [5324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [5326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [5328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [5330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [5332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [5334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [5336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [5338] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [5340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [5342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [5344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [5348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [5350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [5352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [5354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [5356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [5358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [5360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [5362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [5364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [5366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [5368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [5370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [5372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [5374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [5376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [5378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [5380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [5382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [5384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [5386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [5388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [5390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [5392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [5396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [5404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [5406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_block_info, 2, 0, 28),
  [5408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [5410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [5412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_label, 1, 0, 0),
  [5414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [5416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [5422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [5446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [5448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [5450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_checked, 3, 0, 0),
  [5452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [5454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unchecked, 3, 0, 0),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [5458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [5466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [5468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [5472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [5474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [5476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [5478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [5480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [5482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [5484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [5490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [5494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [5496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [5498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [5500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [5502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [5508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [5510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [5520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [5522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [5526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [5528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [5530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [5532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [5534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [5536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [5538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [5542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [5544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [5546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [5548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [5550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [5556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [5588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [5600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [5604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [5606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [5612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [5618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [5622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [5624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [5628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [5630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [5634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [5636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [5648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [5654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [5712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [5714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [5718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [5736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [5772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [5780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [5788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [5792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [5796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [5808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [5810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [5812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [5814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [5816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [5818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [5820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [5822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [5824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [5826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [5828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [5838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [5846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [5860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [5948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [5970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [5982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [5984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [5988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [5996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [5998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [6000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [6002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [6014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [6016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [6018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [6020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [6024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [6030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [6032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [6036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [6044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [6048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [6056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [6060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [6080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [6088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [6090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [6092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [6094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [6096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [6100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [6122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [6130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [6132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [6134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [6140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [6144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [6148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [6158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [6164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [6170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [6172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [6176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [6178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [6182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [6194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [6204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [6206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [6224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [6226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [6228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [6230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [6232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [6236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [6238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [6240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [6242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [6244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [6246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [6250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [6252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [6254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [6256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [6260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [6262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [6264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [6268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key, 1, 0, 0),
  [6270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [6274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [6278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [6280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [6284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [6286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [6292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [6296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [6300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [6302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [6304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [6306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [6308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [6310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [6312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [6314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [6324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__ignored = 0,
  ts_external_token__block_close = 1,
  ts_external_token__eof_or_newline = 2,
  ts_external_token__newline = 3,
  ts_external_token__newline_inline = 4,
  ts_external_token__non_whitespace_check = 5,
  ts_external_token_hard_line_break = 6,
  ts_external_token_frontmatter_marker = 7,
  ts_external_token__heading_begin = 8,
  ts_external_token__heading_continuation = 9,
  ts_external_token__div_begin = 10,
  ts_external_token__div_end = 11,
  ts_external_token__code_block_begin = 12,
  ts_external_token__code_block_end = 13,
  ts_external_token_list_marker_dash = 14,
  ts_external_token_list_marker_star = 15,
  ts_external_token_list_marker_plus = 16,
  ts_external_token__list_marker_task_begin = 17,
  ts_external_token_list_marker_definition = 18,
  ts_external_token_list_marker_decimal_period = 19,
  ts_external_token_list_marker_lower_alpha_period = 20,
  ts_external_token_list_marker_upper_alpha_period = 21,
  ts_external_token_list_marker_lower_roman_period = 22,
  ts_external_token_list_marker_upper_roman_period = 23,
  ts_external_token_list_marker_decimal_paren = 24,
  ts_external_token_list_marker_lower_alpha_paren = 25,
  ts_external_token_list_marker_upper_alpha_paren = 26,
  ts_external_token_list_marker_lower_roman_paren = 27,
  ts_external_token_list_marker_upper_roman_paren = 28,
  ts_external_token_list_marker_decimal_parens = 29,
  ts_external_token_list_marker_lower_alpha_parens = 30,
  ts_external_token_list_marker_upper_alpha_parens = 31,
  ts_external_token_list_marker_lower_roman_parens = 32,
  ts_external_token_list_marker_upper_roman_parens = 33,
  ts_external_token__list_item_continuation = 34,
  ts_external_token__list_item_end = 35,
  ts_external_token__indented_content_spacer = 36,
  ts_external_token__close_paragraph = 37,
  ts_external_token__block_quote_begin = 38,
  ts_external_token__block_quote_continuation = 39,
  ts_external_token__thematic_break_dash = 40,
  ts_external_token__thematic_break_star = 41,
  ts_external_token__footnote_mark_begin = 42,
  ts_external_token__footnote_continuation = 43,
  ts_external_token__footnote_end = 44,
  ts_external_token__link_ref_def_mark_begin = 45,
  ts_external_token__link_ref_def_label_end = 46,
  ts_external_token__table_header_begin = 47,
  ts_external_token__table_separator_begin = 48,
  ts_external_token__table_row_begin = 49,
  ts_external_token__table_row_end_newline = 50,
  ts_external_token__table_cell_end = 51,
  ts_external_token__table_caption_begin = 52,
  ts_external_token__table_caption_end = 53,
  ts_external_token__block_attribute_begin = 54,
  ts_external_token__comment_end_marker = 55,
  ts_external_token__comment_close = 56,
  ts_external_token__inline_comment_begin = 57,
  ts_external_token__verbatim_begin = 58,
  ts_external_token__verbatim_end = 59,
  ts_external_token__verbatim_content = 60,
  ts_external_token__emphasis_mark_begin = 61,
  ts_external_token_emphasis_end = 62,
  ts_external_token__strong_mark_begin = 63,
  ts_external_token_strong_end = 64,
  ts_external_token__superscript_mark_begin = 65,
  ts_external_token_superscript_end = 66,
  ts_external_token__subscript_mark_begin = 67,
  ts_external_token_subscript_end = 68,
  ts_external_token__highlighted_mark_begin = 69,
  ts_external_token_highlighted_end = 70,
  ts_external_token__insert_mark_begin = 71,
  ts_external_token_insert_end = 72,
  ts_external_token__delete_mark_begin = 73,
  ts_external_token_delete_end = 74,
  ts_external_token__parens_span_mark_begin = 75,
  ts_external_token__parens_span_end = 76,
  ts_external_token__curly_bracket_span_mark_begin = 77,
  ts_external_token__curly_bracket_span_end = 78,
  ts_external_token__square_bracket_span_mark_begin = 79,
  ts_external_token__square_bracket_span_end = 80,
  ts_external_token__in_fallback = 81,
  ts_external_token__error = 82,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__ignored] = sym__ignored,
  [ts_external_token__block_close] = sym__block_close,
  [ts_external_token__eof_or_newline] = sym__eof_or_newline,
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__newline_inline] = sym__newline_inline,
  [ts_external_token__non_whitespace_check] = sym__non_whitespace_check,
  [ts_external_token_hard_line_break] = sym_hard_line_break,
  [ts_external_token_frontmatter_marker] = sym_frontmatter_marker,
  [ts_external_token__heading_begin] = sym__heading_begin,
  [ts_external_token__heading_continuation] = sym__heading_continuation,
  [ts_external_token__div_begin] = sym__div_begin,
  [ts_external_token__div_end] = sym__div_end,
  [ts_external_token__code_block_begin] = sym__code_block_begin,
  [ts_external_token__code_block_end] = sym__code_block_end,
  [ts_external_token_list_marker_dash] = sym_list_marker_dash,
  [ts_external_token_list_marker_star] = sym_list_marker_star,
  [ts_external_token_list_marker_plus] = sym_list_marker_plus,
  [ts_external_token__list_marker_task_begin] = sym__list_marker_task_begin,
  [ts_external_token_list_marker_definition] = sym_list_marker_definition,
  [ts_external_token_list_marker_decimal_period] = sym_list_marker_decimal_period,
  [ts_external_token_list_marker_lower_alpha_period] = sym_list_marker_lower_alpha_period,
  [ts_external_token_list_marker_upper_alpha_period] = sym_list_marker_upper_alpha_period,
  [ts_external_token_list_marker_lower_roman_period] = sym_list_marker_lower_roman_period,
  [ts_external_token_list_marker_upper_roman_period] = sym_list_marker_upper_roman_period,
  [ts_external_token_list_marker_decimal_paren] = sym_list_marker_decimal_paren,
  [ts_external_token_list_marker_lower_alpha_paren] = sym_list_marker_lower_alpha_paren,
  [ts_external_token_list_marker_upper_alpha_paren] = sym_list_marker_upper_alpha_paren,
  [ts_external_token_list_marker_lower_roman_paren] = sym_list_marker_lower_roman_paren,
  [ts_external_token_list_marker_upper_roman_paren] = sym_list_marker_upper_roman_paren,
  [ts_external_token_list_marker_decimal_parens] = sym_list_marker_decimal_parens,
  [ts_external_token_list_marker_lower_alpha_parens] = sym_list_marker_lower_alpha_parens,
  [ts_external_token_list_marker_upper_alpha_parens] = sym_list_marker_upper_alpha_parens,
  [ts_external_token_list_marker_lower_roman_parens] = sym_list_marker_lower_roman_parens,
  [ts_external_token_list_marker_upper_roman_parens] = sym_list_marker_upper_roman_parens,
  [ts_external_token__list_item_continuation] = sym__list_item_continuation,
  [ts_external_token__list_item_end] = sym__list_item_end,
  [ts_external_token__indented_content_spacer] = sym__indented_content_spacer,
  [ts_external_token__close_paragraph] = sym__close_paragraph,
  [ts_external_token__block_quote_begin] = sym__block_quote_begin,
  [ts_external_token__block_quote_continuation] = sym__block_quote_continuation,
  [ts_external_token__thematic_break_dash] = sym__thematic_break_dash,
  [ts_external_token__thematic_break_star] = sym__thematic_break_star,
  [ts_external_token__footnote_mark_begin] = sym__footnote_mark_begin,
  [ts_external_token__footnote_continuation] = sym__footnote_continuation,
  [ts_external_token__footnote_end] = sym__footnote_end,
  [ts_external_token__link_ref_def_mark_begin] = sym__link_ref_def_mark_begin,
  [ts_external_token__link_ref_def_label_end] = sym__link_ref_def_label_end,
  [ts_external_token__table_header_begin] = sym__table_header_begin,
  [ts_external_token__table_separator_begin] = sym__table_separator_begin,
  [ts_external_token__table_row_begin] = sym__table_row_begin,
  [ts_external_token__table_row_end_newline] = sym__table_row_end_newline,
  [ts_external_token__table_cell_end] = sym__table_cell_end,
  [ts_external_token__table_caption_begin] = sym__table_caption_begin,
  [ts_external_token__table_caption_end] = sym__table_caption_end,
  [ts_external_token__block_attribute_begin] = sym__block_attribute_begin,
  [ts_external_token__comment_end_marker] = sym__comment_end_marker,
  [ts_external_token__comment_close] = sym__comment_close,
  [ts_external_token__inline_comment_begin] = sym__inline_comment_begin,
  [ts_external_token__verbatim_begin] = sym__verbatim_begin,
  [ts_external_token__verbatim_end] = sym__verbatim_end,
  [ts_external_token__verbatim_content] = sym__verbatim_content,
  [ts_external_token__emphasis_mark_begin] = sym__emphasis_mark_begin,
  [ts_external_token_emphasis_end] = sym_emphasis_end,
  [ts_external_token__strong_mark_begin] = sym__strong_mark_begin,
  [ts_external_token_strong_end] = sym_strong_end,
  [ts_external_token__superscript_mark_begin] = sym__superscript_mark_begin,
  [ts_external_token_superscript_end] = sym_superscript_end,
  [ts_external_token__subscript_mark_begin] = sym__subscript_mark_begin,
  [ts_external_token_subscript_end] = sym_subscript_end,
  [ts_external_token__highlighted_mark_begin] = sym__highlighted_mark_begin,
  [ts_external_token_highlighted_end] = sym_highlighted_end,
  [ts_external_token__insert_mark_begin] = sym__insert_mark_begin,
  [ts_external_token_insert_end] = sym_insert_end,
  [ts_external_token__delete_mark_begin] = sym__delete_mark_begin,
  [ts_external_token_delete_end] = sym_delete_end,
  [ts_external_token__parens_span_mark_begin] = sym__parens_span_mark_begin,
  [ts_external_token__parens_span_end] = sym__parens_span_end,
  [ts_external_token__curly_bracket_span_mark_begin] = sym__curly_bracket_span_mark_begin,
  [ts_external_token__curly_bracket_span_end] = sym__curly_bracket_span_end,
  [ts_external_token__square_bracket_span_mark_begin] = sym__square_bracket_span_mark_begin,
  [ts_external_token__square_bracket_span_end] = sym__square_bracket_span_end,
  [ts_external_token__in_fallback] = sym__in_fallback,
  [ts_external_token__error] = sym__error,
};

static const bool ts_external_scanner_states[184][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__ignored] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token__eof_or_newline] = true,
    [ts_external_token__newline] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token__non_whitespace_check] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token_frontmatter_marker] = true,
    [ts_external_token__heading_begin] = true,
    [ts_external_token__heading_continuation] = true,
    [ts_external_token__div_begin] = true,
    [ts_external_token__div_end] = true,
    [ts_external_token__code_block_begin] = true,
    [ts_external_token__code_block_end] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_definition] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__list_item_continuation] = true,
    [ts_external_token__list_item_end] = true,
    [ts_external_token__indented_content_spacer] = true,
    [ts_external_token__close_paragraph] = true,
    [ts_external_token__block_quote_begin] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__thematic_break_dash] = true,
    [ts_external_token__thematic_break_star] = true,
    [ts_external_token__footnote_mark_begin] = true,
    [ts_external_token__footnote_continuation] = true,
    [ts_external_token__footnote_end] = true,
    [ts_external_token__link_ref_def_mark_begin] = true,
    [ts_external_token__link_ref_def_label_end] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__table_row_end_newline] = true,
    [ts_external_token__table_cell_end] = true,
    [ts_external_token__table_caption_begin] = true,
    [ts_external_token__table_caption_end] = true,
    [ts_external_token__block_attribute_begin] = true,
    [ts_external_token__comment_end_marker] = true,
    [ts_external_token__comment_close] = true,
    [ts_external_token__inline_comment_begin] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token__verbatim_end] = true,
    [ts_external_token__verbatim_content] = true,
    [ts_external_token__emphasis_mark_begin] = true,
    [ts_external_token_emphasis_end] = true,
    [ts_external_token__strong_mark_begin] = true,
    [ts_external_token_strong_end] = true,
    [ts_external_token__superscript_mark_begin] = true,
    [ts_external_token_superscript_end] = true,
    [ts_external_token__subscript_mark_begin] = true,
    [ts_external_token_subscript_end] = true,
    [ts_external_token__highlighted_mark_begin] = true,
    [ts_external_token_highlighted_end] = true,
    [ts_external_token__insert_mark_begin] = true,
    [ts_external_token_insert_end] = true,
    [ts_external_token__delete_mark_begin] = true,
    [ts_external_token_delete_end] = true,
    [ts_external_token__parens_span_mark_begin] = true,
    [ts_external_token__parens_span_end] = true,
    [ts_external_token__curly_bracket_span_mark_begin] = true,
    [ts_external_token__curly_bracket_span_end] = true,
    [ts_external_token__square_bracket_span_mark_begin] = true,
    [ts_external_token__square_bracket_span_end] = true,
    [ts_external_token__in_fallback] = true,
    [ts_external_token__error] = true,
  },
  [2] = {
    [ts_external_token__newline] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token_frontmatter_marker] = true,
    [ts_external_token__heading_begin] = true,
    [ts_external_token__div_begin] = true,
    [ts_external_token__code_block_begin] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_definition] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__block_quote_begin] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__thematic_break_dash] = true,
    [ts_external_token__thematic_break_star] = true,
    [ts_external_token__footnote_mark_begin] = true,
    [ts_external_token__link_ref_def_mark_begin] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__block_attribute_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [3] = {
    [ts_external_token__newline] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__heading_begin] = true,
    [ts_external_token__div_begin] = true,
    [ts_external_token__code_block_begin] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_definition] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__block_quote_begin] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__thematic_break_dash] = true,
    [ts_external_token__thematic_break_star] = true,
    [ts_external_token__footnote_mark_begin] = true,
    [ts_external_token__link_ref_def_mark_begin] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__block_attribute_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [4] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__newline] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__heading_begin] = true,
    [ts_external_token__div_begin] = true,
    [ts_external_token__code_block_begin] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_definition] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__block_quote_begin] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__thematic_break_dash] = true,
    [ts_external_token__thematic_break_star] = true,
    [ts_external_token__footnote_mark_begin] = true,
    [ts_external_token__link_ref_def_mark_begin] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__block_attribute_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [5] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__heading_begin] = true,
    [ts_external_token__div_begin] = true,
    [ts_external_token__code_block_begin] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_definition] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__block_quote_begin] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__thematic_break_dash] = true,
    [ts_external_token__thematic_break_star] = true,
    [ts_external_token__footnote_mark_begin] = true,
    [ts_external_token__link_ref_def_mark_begin] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__block_attribute_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [6] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__div_begin] = true,
    [ts_external_token__code_block_begin] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_definition] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__block_quote_begin] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__thematic_break_dash] = true,
    [ts_external_token__thematic_break_star] = true,
    [ts_external_token__footnote_mark_begin] = true,
    [ts_external_token__link_ref_def_mark_begin] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__block_attribute_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [7] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [8] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [9] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__table_caption_end] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [10] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [11] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__table_row_end_newline] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [12] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [13] = {
    [ts_external_token__newline] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__heading_begin] = true,
    [ts_external_token__div_begin] = true,
    [ts_external_token__code_block_begin] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_definition] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__block_quote_begin] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__thematic_break_dash] = true,
    [ts_external_token__thematic_break_star] = true,
    [ts_external_token__footnote_mark_begin] = true,
    [ts_external_token__link_ref_def_mark_begin] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__table_caption_begin] = true,
    [ts_external_token__block_attribute_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [14] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__newline] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__heading_begin] = true,
    [ts_external_token__div_begin] = true,
    [ts_external_token__code_block_begin] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_definition] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__block_quote_begin] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__thematic_break_dash] = true,
    [ts_external_token__thematic_break_star] = true,
    [ts_external_token__footnote_mark_begin] = true,
    [ts_external_token__link_ref_def_mark_begin] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__table_caption_begin] = true,
    [ts_external_token__block_attribute_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [15] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token__square_bracket_span_end] = true,
  },
  [16] = {
    [ts_external_token__eof_or_newline] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [17] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__table_cell_end] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [18] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__link_ref_def_label_end] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [19] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_superscript_end] = true,
  },
  [20] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_subscript_end] = true,
  },
  [21] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_highlighted_end] = true,
  },
  [22] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_insert_end] = true,
  },
  [23] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_delete_end] = true,
  },
  [24] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__eof_or_newline] = true,
    [ts_external_token__newline] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__heading_begin] = true,
    [ts_external_token__div_begin] = true,
    [ts_external_token__code_block_begin] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_definition] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__block_quote_begin] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__thematic_break_dash] = true,
    [ts_external_token__thematic_break_star] = true,
    [ts_external_token__footnote_mark_begin] = true,
    [ts_external_token__link_ref_def_mark_begin] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__block_attribute_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [25] = {
    [ts_external_token__newline] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__heading_begin] = true,
    [ts_external_token__div_begin] = true,
    [ts_external_token__div_end] = true,
    [ts_external_token__code_block_begin] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_definition] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__block_quote_begin] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__thematic_break_dash] = true,
    [ts_external_token__thematic_break_star] = true,
    [ts_external_token__footnote_mark_begin] = true,
    [ts_external_token__link_ref_def_mark_begin] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__block_attribute_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [26] = {
    [ts_external_token__newline] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__heading_begin] = true,
    [ts_external_token__div_begin] = true,
    [ts_external_token__code_block_begin] = true,
    [ts_external_token__code_block_end] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_definition] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__block_quote_begin] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__thematic_break_dash] = true,
    [ts_external_token__thematic_break_star] = true,
    [ts_external_token__footnote_mark_begin] = true,
    [ts_external_token__link_ref_def_mark_begin] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__block_attribute_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [27] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__newline] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__heading_begin] = true,
    [ts_external_token__div_begin] = true,
    [ts_external_token__code_block_begin] = true,
    [ts_external_token__code_block_end] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_definition] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__block_quote_begin] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__thematic_break_dash] = true,
    [ts_external_token__thematic_break_star] = true,
    [ts_external_token__footnote_mark_begin] = true,
    [ts_external_token__link_ref_def_mark_begin] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__block_attribute_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [28] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__newline] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__heading_begin] = true,
    [ts_external_token__div_begin] = true,
    [ts_external_token__div_end] = true,
    [ts_external_token__code_block_begin] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_definition] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__block_quote_begin] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__thematic_break_dash] = true,
    [ts_external_token__thematic_break_star] = true,
    [ts_external_token__footnote_mark_begin] = true,
    [ts_external_token__link_ref_def_mark_begin] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__block_attribute_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [29] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [30] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [31] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_emphasis_end] = true,
  },
  [32] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_strong_end] = true,
  },
  [33] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token__non_whitespace_check] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_insert_end] = true,
  },
  [34] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token__non_whitespace_check] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token__square_bracket_span_end] = true,
  },
  [35] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token__non_whitespace_check] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_delete_end] = true,
  },
  [36] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token__non_whitespace_check] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_emphasis_end] = true,
  },
  [37] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token__non_whitespace_check] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_strong_end] = true,
  },
  [38] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token__non_whitespace_check] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__link_ref_def_label_end] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [39] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token__non_whitespace_check] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__table_cell_end] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [40] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token__non_whitespace_check] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_superscript_end] = true,
  },
  [41] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token__non_whitespace_check] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [42] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token__non_whitespace_check] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_subscript_end] = true,
  },
  [43] = {
    [ts_external_token__eof_or_newline] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token__non_whitespace_check] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [44] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token__non_whitespace_check] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_highlighted_end] = true,
  },
  [45] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__inline_comment_begin] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_delete_end] = true,
  },
  [46] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__inline_comment_begin] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_superscript_end] = true,
  },
  [47] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__inline_comment_begin] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_subscript_end] = true,
  },
  [48] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__inline_comment_begin] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_highlighted_end] = true,
  },
  [49] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__inline_comment_begin] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token_insert_end] = true,
  },
  [50] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__inline_comment_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [51] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__inline_comment_begin] = true,
    [ts_external_token__verbatim_begin] = true,
    [ts_external_token__square_bracket_span_end] = true,
  },
  [52] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__table_cell_end] = true,
    [ts_external_token__inline_comment_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [53] = {
    [ts_external_token__eof_or_newline] = true,
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__inline_comment_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [54] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token_hard_line_break] = true,
    [ts_external_token__link_ref_def_label_end] = true,
    [ts_external_token__inline_comment_begin] = true,
    [ts_external_token__verbatim_begin] = true,
  },
  [55] = {
    [ts_external_token__newline] = true,
    [ts_external_token__list_item_continuation] = true,
    [ts_external_token__list_item_end] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__table_caption_begin] = true,
  },
  [56] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__newline] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__table_caption_begin] = true,
  },
  [57] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indented_content_spacer] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
    [ts_external_token__table_caption_begin] = true,
  },
  [58] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token__curly_bracket_span_end] = true,
  },
  [59] = {
    [ts_external_token__newline] = true,
  },
  [60] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [61] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [62] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [63] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [64] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [65] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [66] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [67] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [68] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [69] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_star] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [70] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [71] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [72] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [73] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [74] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [75] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [76] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [77] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [78] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [79] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [80] = {
    [ts_external_token__list_item_continuation] = true,
    [ts_external_token__list_item_end] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [81] = {
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__footnote_continuation] = true,
    [ts_external_token__footnote_end] = true,
  },
  [82] = {
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
  },
  [83] = {
    [ts_external_token__comment_end_marker] = true,
    [ts_external_token__comment_close] = true,
  },
  [84] = {
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__table_header_begin] = true,
    [ts_external_token__table_separator_begin] = true,
    [ts_external_token__table_row_begin] = true,
  },
  [85] = {
    [ts_external_token__list_item_continuation] = true,
    [ts_external_token__list_item_end] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__table_caption_begin] = true,
  },
  [86] = {
    [ts_external_token__code_block_end] = true,
    [ts_external_token__list_item_continuation] = true,
    [ts_external_token__list_item_end] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [87] = {
    [ts_external_token__newline_inline] = true,
    [ts_external_token__parens_span_end] = true,
  },
  [88] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_list_marker_definition] = true,
  },
  [89] = {
    [ts_external_token__table_row_end_newline] = true,
  },
  [90] = {
    [ts_external_token__div_end] = true,
    [ts_external_token__list_item_continuation] = true,
    [ts_external_token__list_item_end] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [91] = {
    [ts_external_token_frontmatter_marker] = true,
  },
  [92] = {
    [ts_external_token__eof_or_newline] = true,
    [ts_external_token__list_item_continuation] = true,
    [ts_external_token__list_item_end] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [93] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__table_caption_begin] = true,
  },
  [94] = {
    [ts_external_token_list_marker_star] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [95] = {
    [ts_external_token__eof_or_newline] = true,
    [ts_external_token__newline_inline] = true,
  },
  [96] = {
    [ts_external_token_list_marker_decimal_period] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [97] = {
    [ts_external_token_list_marker_lower_alpha_parens] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [98] = {
    [ts_external_token_list_marker_lower_roman_period] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [99] = {
    [ts_external_token__indented_content_spacer] = true,
    [ts_external_token__table_caption_begin] = true,
  },
  [100] = {
    [ts_external_token_list_marker_upper_alpha_paren] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [101] = {
    [ts_external_token_list_marker_lower_alpha_paren] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [102] = {
    [ts_external_token_list_marker_lower_roman_paren] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [103] = {
    [ts_external_token_list_marker_lower_roman_parens] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [104] = {
    [ts_external_token_list_marker_decimal_paren] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [105] = {
    [ts_external_token_list_marker_upper_roman_period] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [106] = {
    [ts_external_token_list_marker_upper_roman_paren] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [107] = {
    [ts_external_token_list_marker_upper_alpha_period] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [108] = {
    [ts_external_token__newline_inline] = true,
  },
  [109] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__heading_continuation] = true,
  },
  [110] = {
    [ts_external_token_list_marker_upper_roman_parens] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [111] = {
    [ts_external_token__list_marker_task_begin] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [112] = {
    [ts_external_token_list_marker_dash] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [113] = {
    [ts_external_token_list_marker_lower_alpha_period] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [114] = {
    [ts_external_token_list_marker_decimal_parens] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [115] = {
    [ts_external_token__block_quote_continuation] = true,
  },
  [116] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__eof_or_newline] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [117] = {
    [ts_external_token__list_item_continuation] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [118] = {
    [ts_external_token__block_quote_continuation] = true,
    [ts_external_token__footnote_continuation] = true,
  },
  [119] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__div_end] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [120] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__code_block_end] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [121] = {
    [ts_external_token_list_marker_upper_alpha_parens] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [122] = {
    [ts_external_token_list_marker_plus] = true,
    [ts_external_token__block_quote_continuation] = true,
  },
  [123] = {
    [ts_external_token__highlighted_mark_begin] = true,
    [ts_external_token__in_fallback] = true,
  },
  [124] = {
    [ts_external_token__curly_bracket_span_mark_begin] = true,
    [ts_external_token__in_fallback] = true,
  },
  [125] = {
    [ts_external_token__emphasis_mark_begin] = true,
    [ts_external_token__in_fallback] = true,
  },
  [126] = {
    [ts_external_token__strong_mark_begin] = true,
    [ts_external_token__in_fallback] = true,
  },
  [127] = {
    [ts_external_token__eof_or_newline] = true,
    [ts_external_token__close_paragraph] = true,
  },
  [128] = {
    [ts_external_token__square_bracket_span_mark_begin] = true,
    [ts_external_token__in_fallback] = true,
  },
  [129] = {
    [ts_external_token__superscript_mark_begin] = true,
    [ts_external_token__in_fallback] = true,
  },
  [130] = {
    [ts_external_token__subscript_mark_begin] = true,
    [ts_external_token__in_fallback] = true,
  },
  [131] = {
    [ts_external_token__insert_mark_begin] = true,
    [ts_external_token__in_fallback] = true,
  },
  [132] = {
    [ts_external_token__delete_mark_begin] = true,
    [ts_external_token__in_fallback] = true,
  },
  [133] = {
    [ts_external_token__parens_span_mark_begin] = true,
    [ts_external_token__in_fallback] = true,
  },
  [134] = {
    [ts_external_token__eof_or_newline] = true,
    [ts_external_token__indented_content_spacer] = true,
  },
  [135] = {
    [ts_external_token__div_end] = true,
    [ts_external_token__indented_content_spacer] = true,
  },
  [136] = {
    [ts_external_token__code_block_end] = true,
    [ts_external_token__indented_content_spacer] = true,
  },
  [137] = {
    [ts_external_token__list_marker_task_begin] = true,
  },
  [138] = {
    [ts_external_token__delete_mark_begin] = true,
  },
  [139] = {
    [ts_external_token_emphasis_end] = true,
  },
  [140] = {
    [ts_external_token_strong_end] = true,
  },
  [141] = {
    [ts_external_token_superscript_end] = true,
  },
  [142] = {
    [ts_external_token__indented_content_spacer] = true,
  },
  [143] = {
    [ts_external_token_subscript_end] = true,
  },
  [144] = {
    [ts_external_token__verbatim_end] = true,
  },
  [145] = {
    [ts_external_token_highlighted_end] = true,
  },
  [146] = {
    [ts_external_token_insert_end] = true,
  },
  [147] = {
    [ts_external_token_delete_end] = true,
  },
  [148] = {
    [ts_external_token__square_bracket_span_end] = true,
  },
  [149] = {
    [ts_external_token__curly_bracket_span_end] = true,
  },
  [150] = {
    [ts_external_token__block_close] = true,
  },
  [151] = {
    [ts_external_token_list_marker_upper_roman_period] = true,
  },
  [152] = {
    [ts_external_token_list_marker_upper_roman_paren] = true,
  },
  [153] = {
    [ts_external_token__emphasis_mark_begin] = true,
  },
  [154] = {
    [ts_external_token_list_marker_upper_roman_parens] = true,
  },
  [155] = {
    [ts_external_token_list_marker_lower_roman_paren] = true,
  },
  [156] = {
    [ts_external_token_list_marker_upper_alpha_paren] = true,
  },
  [157] = {
    [ts_external_token__strong_mark_begin] = true,
  },
  [158] = {
    [ts_external_token__table_cell_end] = true,
  },
  [159] = {
    [ts_external_token__superscript_mark_begin] = true,
  },
  [160] = {
    [ts_external_token__eof_or_newline] = true,
  },
  [161] = {
    [ts_external_token_list_marker_dash] = true,
  },
  [162] = {
    [ts_external_token_list_marker_upper_alpha_period] = true,
  },
  [163] = {
    [ts_external_token__curly_bracket_span_mark_begin] = true,
  },
  [164] = {
    [ts_external_token__square_bracket_span_mark_begin] = true,
  },
  [165] = {
    [ts_external_token__subscript_mark_begin] = true,
  },
  [166] = {
    [ts_external_token__highlighted_mark_begin] = true,
  },
  [167] = {
    [ts_external_token__insert_mark_begin] = true,
  },
  [168] = {
    [ts_external_token__list_item_continuation] = true,
  },
  [169] = {
    [ts_external_token__link_ref_def_label_end] = true,
  },
  [170] = {
    [ts_external_token_list_marker_plus] = true,
  },
  [171] = {
    [ts_external_token_list_marker_upper_alpha_parens] = true,
  },
  [172] = {
    [ts_external_token_list_marker_star] = true,
  },
  [173] = {
    [ts_external_token__verbatim_content] = true,
  },
  [174] = {
    [ts_external_token_list_marker_decimal_period] = true,
  },
  [175] = {
    [ts_external_token_list_marker_decimal_paren] = true,
  },
  [176] = {
    [ts_external_token__footnote_continuation] = true,
  },
  [177] = {
    [ts_external_token_list_marker_decimal_parens] = true,
  },
  [178] = {
    [ts_external_token_list_marker_lower_roman_parens] = true,
  },
  [179] = {
    [ts_external_token__parens_span_mark_begin] = true,
  },
  [180] = {
    [ts_external_token_list_marker_lower_alpha_period] = true,
  },
  [181] = {
    [ts_external_token_list_marker_lower_roman_period] = true,
  },
  [182] = {
    [ts_external_token_list_marker_lower_alpha_paren] = true,
  },
  [183] = {
    [ts_external_token_list_marker_lower_alpha_parens] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_djot_external_scanner_create(void);
void tree_sitter_djot_external_scanner_destroy(void *);
bool tree_sitter_djot_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_djot_external_scanner_serialize(void *, char *);
void tree_sitter_djot_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_djot(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_djot_external_scanner_create,
      tree_sitter_djot_external_scanner_destroy,
      tree_sitter_djot_external_scanner_scan,
      tree_sitter_djot_external_scanner_serialize,
      tree_sitter_djot_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
