#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 3725
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 228
#define ALIAS_COUNT 1
#define TOKEN_COUNT 94
#define EXTERNAL_TOKEN_COUNT 36
#define FIELD_COUNT 34
#define MAX_ALIAS_SEQUENCE_LENGTH 11
#define PRODUCTION_ID_COUNT 103

enum ts_symbol_identifiers {
  sym_name = 1,
  anon_sym_SEMI = 2,
  anon_sym_return = 3,
  anon_sym_local = 4,
  anon_sym_function = 5,
  anon_sym_COLON = 6,
  anon_sym_for = 7,
  anon_sym_in = 8,
  anon_sym_do = 9,
  anon_sym_end = 10,
  anon_sym_EQ = 11,
  anon_sym_COMMA = 12,
  anon_sym_if = 13,
  anon_sym_then = 14,
  anon_sym_elseif = 15,
  anon_sym_else = 16,
  anon_sym_repeat = 17,
  anon_sym_until = 18,
  anon_sym_while = 19,
  anon_sym_break = 20,
  sym_continue_stmt = 21,
  anon_sym_export = 22,
  aux_sym_type_stmt_token1 = 23,
  anon_sym_type = 24,
  anon_sym_LT = 25,
  anon_sym_GT = 26,
  anon_sym_PLUS_EQ = 27,
  anon_sym_DASH_EQ = 28,
  anon_sym_STAR_EQ = 29,
  anon_sym_SLASH_SLASH_EQ = 30,
  anon_sym_SLASH_EQ = 31,
  anon_sym_PERCENT_EQ = 32,
  anon_sym_CARET_EQ = 33,
  anon_sym_DOT_DOT_EQ = 34,
  anon_sym_or = 35,
  anon_sym_and = 36,
  anon_sym_EQ_EQ = 37,
  anon_sym_TILDE_EQ = 38,
  anon_sym_LT_EQ = 39,
  anon_sym_GT_EQ = 40,
  anon_sym_PLUS = 41,
  anon_sym_DASH = 42,
  anon_sym_STAR = 43,
  anon_sym_SLASH_SLASH = 44,
  anon_sym_SLASH = 45,
  anon_sym_PERCENT = 46,
  anon_sym_DOT_DOT = 47,
  anon_sym_CARET = 48,
  anon_sym_COLON_COLON = 49,
  anon_sym_not = 50,
  anon_sym_POUND = 51,
  anon_sym_LBRACE = 52,
  anon_sym_RBRACE = 53,
  anon_sym_LBRACK = 54,
  anon_sym_RBRACK = 55,
  anon_sym_LPAREN = 56,
  anon_sym_RPAREN = 57,
  anon_sym_DOT = 58,
  anon_sym_AMP = 59,
  anon_sym_PIPE = 60,
  anon_sym_DOT_DOT_DOT = 61,
  anon_sym_typeof = 62,
  anon_sym_DASH_GT = 63,
  anon_sym_QMARK = 64,
  sym_number = 65,
  anon_sym_LBRACE2 = 66,
  aux_sym_unicode_escape_token1 = 67,
  anon_sym_RBRACE2 = 68,
  aux_sym_dec_byte_escape_token1 = 69,
  aux_sym_hex_byte_escape_token1 = 70,
  anon_sym_true = 71,
  anon_sym_false = 72,
  anon_sym_nil = 73,
  anon_sym_read = 74,
  anon_sym_write = 75,
  anon_sym_AT = 76,
  aux_sym_attribute_token1 = 77,
  anon_sym_AT_LBRACK = 78,
  sym__comment_start = 79,
  sym__comment_content = 80,
  sym__comment_end = 81,
  sym__string_start = 82,
  sym__string_content = 83,
  sym__string_end = 84,
  sym_interp_start = 85,
  sym_interp_content = 86,
  sym_interp_brace_open = 87,
  sym_interp_brace_close = 88,
  sym_interp_end = 89,
  sym_simple_escape = 90,
  sym__unicode_escape_sequence = 91,
  sym__dec_byte_escape_sequence = 92,
  sym__hex_byte_escape_sequence = 93,
  sym_chunk = 94,
  sym_block = 95,
  sym__block = 96,
  sym_ret_stmt = 97,
  sym_statement = 98,
  sym_local_fn_stmt = 99,
  sym_fn_stmt = 100,
  sym__tbl_fn_member = 101,
  aux_sym__attrlist = 102,
  sym_for_in_stmt = 103,
  sym_for_range_stmt = 104,
  sym_if_stmt = 105,
  sym_elseif_clause = 106,
  sym_else_clause = 107,
  sym_repeat_stmt = 108,
  sym_while_stmt = 109,
  sym_do_stmt = 110,
  sym_break_stmt = 111,
  sym_local_var_stmt = 112,
  sym_var_stmt = 113,
  sym_assign_stmt = 114,
  sym__varlist = 115,
  sym_type_stmt = 116,
  sym_type_fn_stmt = 117,
  sym__type_assign = 118,
  sym_genericdef = 119,
  sym__type_stmt_genlist = 120,
  sym_genpackdef = 121,
  sym__type_stmt_packlist = 122,
  sym__assign = 123,
  sym_exp = 124,
  sym__explist = 125,
  sym_binexp = 126,
  sym_cast = 127,
  sym_unexp = 128,
  sym_ifexp = 129,
  sym__ifexp_elseif = 130,
  sym_table = 131,
  sym__fieldlist = 132,
  sym_field = 133,
  sym_prefixexp = 134,
  sym__prefixexp = 135,
  sym_exp_wrap = 136,
  sym_call_stmt = 137,
  sym__tbl_method = 138,
  sym__method_name = 139,
  sym_arglist = 140,
  sym_binding = 141,
  sym_bindinglist = 142,
  sym_var = 143,
  sym__tbl_seq = 144,
  sym_key = 145,
  sym__key_named = 146,
  sym_anon_fn = 147,
  sym__fn_body = 148,
  sym_paramlist = 149,
  sym_param = 150,
  sym__param_vararg = 151,
  sym_type = 152,
  sym__outertype = 153,
  sym_singleton = 154,
  sym_namedtype = 155,
  sym_typelist = 156,
  sym__typelist_vrd = 157,
  sym_wraptype = 158,
  sym_typeparam = 159,
  sym__typeparamlist = 160,
  sym_typepack = 161,
  sym__typepack_wrap = 162,
  sym__typepack_vrd = 163,
  sym__typepack_gen = 164,
  sym_variadic = 165,
  sym_dyntype = 166,
  sym_fntype = 167,
  sym__fntype_gen = 168,
  sym_paramtypelist = 169,
  sym__fntype_param = 170,
  sym__fntype_paramlist = 171,
  sym__fntype_paramlist_vrd = 172,
  sym_tbtype = 173,
  sym__tbtype_content = 174,
  sym__array_type = 175,
  sym__tbtype_kv = 176,
  sym_kvtypelist = 177,
  sym_indexertype = 178,
  sym_proptype = 179,
  sym_bintype = 180,
  sym_untype = 181,
  sym_generic = 182,
  sym__genlist = 183,
  sym_genpack = 184,
  sym__genpack_list = 185,
  sym_vararg = 186,
  sym_string = 187,
  sym_string_interp = 188,
  sym_interp_exp = 189,
  sym__escape_sequence = 190,
  sym_unicode_escape = 191,
  sym_dec_byte_escape = 192,
  sym_hex_byte_escape = 193,
  sym_boolean = 194,
  sym_nil = 195,
  sym_readwrite = 196,
  sym_attribute = 197,
  sym__parattrlist = 198,
  sym_parattr = 199,
  sym_parattr_param = 200,
  sym_literal = 201,
  sym__litlist = 202,
  sym_littable = 203,
  sym__litfieldlist = 204,
  sym_litfield = 205,
  sym_comment = 206,
  aux_sym__block_repeat1 = 207,
  aux_sym_if_stmt_repeat1 = 208,
  aux_sym__varlist_repeat1 = 209,
  aux_sym__type_stmt_genlist_repeat1 = 210,
  aux_sym__type_stmt_packlist_repeat1 = 211,
  aux_sym__explist_repeat1 = 212,
  aux_sym_ifexp_repeat1 = 213,
  aux_sym__fieldlist_repeat1 = 214,
  aux_sym_bindinglist_repeat1 = 215,
  aux_sym_paramlist_repeat1 = 216,
  aux_sym_typelist_repeat1 = 217,
  aux_sym__typeparamlist_repeat1 = 218,
  aux_sym__fntype_paramlist_repeat1 = 219,
  aux_sym_kvtypelist_repeat1 = 220,
  aux_sym__genlist_repeat1 = 221,
  aux_sym__genpack_list_repeat1 = 222,
  aux_sym_string_repeat1 = 223,
  aux_sym_string_interp_repeat1 = 224,
  aux_sym__parattrlist_repeat1 = 225,
  aux_sym__litlist_repeat1 = 226,
  aux_sym__litfieldlist_repeat1 = 227,
  alias_sym_explist = 228,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_name] = "name",
  [anon_sym_SEMI] = ";",
  [anon_sym_return] = "return",
  [anon_sym_local] = "local",
  [anon_sym_function] = "function",
  [anon_sym_COLON] = ":",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_do] = "do",
  [anon_sym_end] = "end",
  [anon_sym_EQ] = "=",
  [anon_sym_COMMA] = ",",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_elseif] = "elseif",
  [anon_sym_else] = "else",
  [anon_sym_repeat] = "repeat",
  [anon_sym_until] = "until",
  [anon_sym_while] = "while",
  [anon_sym_break] = "break",
  [sym_continue_stmt] = "continue_stmt",
  [anon_sym_export] = "export",
  [aux_sym_type_stmt_token1] = "type_stmt_token1",
  [anon_sym_type] = "type",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_DOT_DOT_EQ] = "..=",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_TILDE_EQ] = "~=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_CARET] = "^",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_not] = "not",
  [anon_sym_POUND] = "#",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT] = ".",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE] = "|",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_typeof] = "typeof",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_QMARK] = "\?",
  [sym_number] = "number",
  [anon_sym_LBRACE2] = "{",
  [aux_sym_unicode_escape_token1] = "codepoint",
  [anon_sym_RBRACE2] = "}",
  [aux_sym_dec_byte_escape_token1] = "dec_byte_escape_token1",
  [aux_sym_hex_byte_escape_token1] = "hex_byte_escape_token1",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_nil] = "nil",
  [anon_sym_read] = "read",
  [anon_sym_write] = "write",
  [anon_sym_AT] = "@",
  [aux_sym_attribute_token1] = "attribute_token1",
  [anon_sym_AT_LBRACK] = "@[",
  [sym__comment_start] = "_comment_start",
  [sym__comment_content] = "_comment_content",
  [sym__comment_end] = "_comment_end",
  [sym__string_start] = "_string_start",
  [sym__string_content] = "_string_content",
  [sym__string_end] = "_string_end",
  [sym_interp_start] = "interp_start",
  [sym_interp_content] = "interp_content",
  [sym_interp_brace_open] = "interp_brace_open",
  [sym_interp_brace_close] = "interp_brace_close",
  [sym_interp_end] = "interp_end",
  [sym_simple_escape] = "simple_escape",
  [sym__unicode_escape_sequence] = "_unicode_escape_sequence",
  [sym__dec_byte_escape_sequence] = "_dec_byte_escape_sequence",
  [sym__hex_byte_escape_sequence] = "_hex_byte_escape_sequence",
  [sym_chunk] = "chunk",
  [sym_block] = "block",
  [sym__block] = "_block",
  [sym_ret_stmt] = "ret_stmt",
  [sym_statement] = "statement",
  [sym_local_fn_stmt] = "local_fn_stmt",
  [sym_fn_stmt] = "fn_stmt",
  [sym__tbl_fn_member] = "_tbl_fn_member",
  [aux_sym__attrlist] = "_attrlist",
  [sym_for_in_stmt] = "for_in_stmt",
  [sym_for_range_stmt] = "for_range_stmt",
  [sym_if_stmt] = "if_stmt",
  [sym_elseif_clause] = "elseif_clause",
  [sym_else_clause] = "else_clause",
  [sym_repeat_stmt] = "repeat_stmt",
  [sym_while_stmt] = "while_stmt",
  [sym_do_stmt] = "do_stmt",
  [sym_break_stmt] = "break_stmt",
  [sym_local_var_stmt] = "local_var_stmt",
  [sym_var_stmt] = "var_stmt",
  [sym_assign_stmt] = "assign_stmt",
  [sym__varlist] = "varlist",
  [sym_type_stmt] = "type_stmt",
  [sym_type_fn_stmt] = "type_fn_stmt",
  [sym__type_assign] = "_type_assign",
  [sym_genericdef] = "genericdef",
  [sym__type_stmt_genlist] = "_type_stmt_genlist",
  [sym_genpackdef] = "genpackdef",
  [sym__type_stmt_packlist] = "_type_stmt_packlist",
  [sym__assign] = "_assign",
  [sym_exp] = "exp",
  [sym__explist] = "_explist",
  [sym_binexp] = "binexp",
  [sym_cast] = "cast",
  [sym_unexp] = "unexp",
  [sym_ifexp] = "ifexp",
  [sym__ifexp_elseif] = "_ifexp_elseif",
  [sym_table] = "table",
  [sym__fieldlist] = "_fieldlist",
  [sym_field] = "field",
  [sym_prefixexp] = "prefixexp",
  [sym__prefixexp] = "_prefixexp",
  [sym_exp_wrap] = "exp_wrap",
  [sym_call_stmt] = "call_stmt",
  [sym__tbl_method] = "_tbl_method",
  [sym__method_name] = "_method_name",
  [sym_arglist] = "arglist",
  [sym_binding] = "binding",
  [sym_bindinglist] = "bindinglist",
  [sym_var] = "var",
  [sym__tbl_seq] = "_tbl_seq",
  [sym_key] = "key",
  [sym__key_named] = "_key_named",
  [sym_anon_fn] = "anon_fn",
  [sym__fn_body] = "_fn_body",
  [sym_paramlist] = "paramlist",
  [sym_param] = "param",
  [sym__param_vararg] = "param",
  [sym_type] = "type",
  [sym__outertype] = "_outertype",
  [sym_singleton] = "singleton",
  [sym_namedtype] = "namedtype",
  [sym_typelist] = "typelist",
  [sym__typelist_vrd] = "_typelist_vrd",
  [sym_wraptype] = "wraptype",
  [sym_typeparam] = "typeparam",
  [sym__typeparamlist] = "_typeparamlist",
  [sym_typepack] = "typepack",
  [sym__typepack_wrap] = "_typepack_wrap",
  [sym__typepack_vrd] = "_typepack_vrd",
  [sym__typepack_gen] = "_typepack_gen",
  [sym_variadic] = "variadic",
  [sym_dyntype] = "dyntype",
  [sym_fntype] = "fntype",
  [sym__fntype_gen] = "_fntype_gen",
  [sym_paramtypelist] = "paramtypelist",
  [sym__fntype_param] = "_fntype_param",
  [sym__fntype_paramlist] = "_fntype_paramlist",
  [sym__fntype_paramlist_vrd] = "_fntype_paramlist_vrd",
  [sym_tbtype] = "tbtype",
  [sym__tbtype_content] = "_tbtype_content",
  [sym__array_type] = "_array_type",
  [sym__tbtype_kv] = "_tbtype_kv",
  [sym_kvtypelist] = "kvtypelist",
  [sym_indexertype] = "indexertype",
  [sym_proptype] = "proptype",
  [sym_bintype] = "bintype",
  [sym_untype] = "untype",
  [sym_generic] = "generic",
  [sym__genlist] = "_genlist",
  [sym_genpack] = "genpack",
  [sym__genpack_list] = "_genpack_list",
  [sym_vararg] = "vararg",
  [sym_string] = "string",
  [sym_string_interp] = "string_interp",
  [sym_interp_exp] = "interp_exp",
  [sym__escape_sequence] = "_escape_sequence",
  [sym_unicode_escape] = "unicode_escape",
  [sym_dec_byte_escape] = "dec_byte_escape",
  [sym_hex_byte_escape] = "hex_byte_escape",
  [sym_boolean] = "boolean",
  [sym_nil] = "nil",
  [sym_readwrite] = "readwrite",
  [sym_attribute] = "attribute",
  [sym__parattrlist] = "_parattrlist",
  [sym_parattr] = "parattr",
  [sym_parattr_param] = "parattr_param",
  [sym_literal] = "literal",
  [sym__litlist] = "_litlist",
  [sym_littable] = "littable",
  [sym__litfieldlist] = "_litfieldlist",
  [sym_litfield] = "litfield",
  [sym_comment] = "comment",
  [aux_sym__block_repeat1] = "_block_repeat1",
  [aux_sym_if_stmt_repeat1] = "if_stmt_repeat1",
  [aux_sym__varlist_repeat1] = "_varlist_repeat1",
  [aux_sym__type_stmt_genlist_repeat1] = "_type_stmt_genlist_repeat1",
  [aux_sym__type_stmt_packlist_repeat1] = "_type_stmt_packlist_repeat1",
  [aux_sym__explist_repeat1] = "_explist_repeat1",
  [aux_sym_ifexp_repeat1] = "ifexp_repeat1",
  [aux_sym__fieldlist_repeat1] = "_fieldlist_repeat1",
  [aux_sym_bindinglist_repeat1] = "bindinglist_repeat1",
  [aux_sym_paramlist_repeat1] = "paramlist_repeat1",
  [aux_sym_typelist_repeat1] = "typelist_repeat1",
  [aux_sym__typeparamlist_repeat1] = "_typeparamlist_repeat1",
  [aux_sym__fntype_paramlist_repeat1] = "_fntype_paramlist_repeat1",
  [aux_sym_kvtypelist_repeat1] = "kvtypelist_repeat1",
  [aux_sym__genlist_repeat1] = "_genlist_repeat1",
  [aux_sym__genpack_list_repeat1] = "_genpack_list_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_interp_repeat1] = "string_interp_repeat1",
  [aux_sym__parattrlist_repeat1] = "_parattrlist_repeat1",
  [aux_sym__litlist_repeat1] = "_litlist_repeat1",
  [aux_sym__litfieldlist_repeat1] = "_litfieldlist_repeat1",
  [alias_sym_explist] = "explist",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_name] = sym_name,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_local] = anon_sym_local,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_elseif] = anon_sym_elseif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_repeat] = anon_sym_repeat,
  [anon_sym_until] = anon_sym_until,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_break] = anon_sym_break,
  [sym_continue_stmt] = sym_continue_stmt,
  [anon_sym_export] = anon_sym_export,
  [aux_sym_type_stmt_token1] = aux_sym_type_stmt_token1,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_SLASH_EQ] = anon_sym_SLASH_SLASH_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_DOT_DOT_EQ] = anon_sym_DOT_DOT_EQ,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_TILDE_EQ] = anon_sym_TILDE_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [sym_number] = sym_number,
  [anon_sym_LBRACE2] = anon_sym_LBRACE,
  [aux_sym_unicode_escape_token1] = aux_sym_unicode_escape_token1,
  [anon_sym_RBRACE2] = anon_sym_RBRACE,
  [aux_sym_dec_byte_escape_token1] = aux_sym_dec_byte_escape_token1,
  [aux_sym_hex_byte_escape_token1] = aux_sym_hex_byte_escape_token1,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_nil] = anon_sym_nil,
  [anon_sym_read] = anon_sym_read,
  [anon_sym_write] = anon_sym_write,
  [anon_sym_AT] = anon_sym_AT,
  [aux_sym_attribute_token1] = aux_sym_attribute_token1,
  [anon_sym_AT_LBRACK] = anon_sym_AT_LBRACK,
  [sym__comment_start] = sym__comment_start,
  [sym__comment_content] = sym__comment_content,
  [sym__comment_end] = sym__comment_end,
  [sym__string_start] = sym__string_start,
  [sym__string_content] = sym__string_content,
  [sym__string_end] = sym__string_end,
  [sym_interp_start] = sym_interp_start,
  [sym_interp_content] = sym_interp_content,
  [sym_interp_brace_open] = sym_interp_brace_open,
  [sym_interp_brace_close] = sym_interp_brace_close,
  [sym_interp_end] = sym_interp_end,
  [sym_simple_escape] = sym_simple_escape,
  [sym__unicode_escape_sequence] = sym__unicode_escape_sequence,
  [sym__dec_byte_escape_sequence] = sym__dec_byte_escape_sequence,
  [sym__hex_byte_escape_sequence] = sym__hex_byte_escape_sequence,
  [sym_chunk] = sym_chunk,
  [sym_block] = sym_block,
  [sym__block] = sym__block,
  [sym_ret_stmt] = sym_ret_stmt,
  [sym_statement] = sym_statement,
  [sym_local_fn_stmt] = sym_local_fn_stmt,
  [sym_fn_stmt] = sym_fn_stmt,
  [sym__tbl_fn_member] = sym__tbl_fn_member,
  [aux_sym__attrlist] = aux_sym__attrlist,
  [sym_for_in_stmt] = sym_for_in_stmt,
  [sym_for_range_stmt] = sym_for_range_stmt,
  [sym_if_stmt] = sym_if_stmt,
  [sym_elseif_clause] = sym_elseif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_repeat_stmt] = sym_repeat_stmt,
  [sym_while_stmt] = sym_while_stmt,
  [sym_do_stmt] = sym_do_stmt,
  [sym_break_stmt] = sym_break_stmt,
  [sym_local_var_stmt] = sym_local_var_stmt,
  [sym_var_stmt] = sym_var_stmt,
  [sym_assign_stmt] = sym_assign_stmt,
  [sym__varlist] = sym__varlist,
  [sym_type_stmt] = sym_type_stmt,
  [sym_type_fn_stmt] = sym_type_fn_stmt,
  [sym__type_assign] = sym__type_assign,
  [sym_genericdef] = sym_genericdef,
  [sym__type_stmt_genlist] = sym__type_stmt_genlist,
  [sym_genpackdef] = sym_genpackdef,
  [sym__type_stmt_packlist] = sym__type_stmt_packlist,
  [sym__assign] = sym__assign,
  [sym_exp] = sym_exp,
  [sym__explist] = sym__explist,
  [sym_binexp] = sym_binexp,
  [sym_cast] = sym_cast,
  [sym_unexp] = sym_unexp,
  [sym_ifexp] = sym_ifexp,
  [sym__ifexp_elseif] = sym__ifexp_elseif,
  [sym_table] = sym_table,
  [sym__fieldlist] = sym__fieldlist,
  [sym_field] = sym_field,
  [sym_prefixexp] = sym_prefixexp,
  [sym__prefixexp] = sym__prefixexp,
  [sym_exp_wrap] = sym_exp_wrap,
  [sym_call_stmt] = sym_call_stmt,
  [sym__tbl_method] = sym__tbl_method,
  [sym__method_name] = sym__method_name,
  [sym_arglist] = sym_arglist,
  [sym_binding] = sym_binding,
  [sym_bindinglist] = sym_bindinglist,
  [sym_var] = sym_var,
  [sym__tbl_seq] = sym__tbl_seq,
  [sym_key] = sym_key,
  [sym__key_named] = sym__key_named,
  [sym_anon_fn] = sym_anon_fn,
  [sym__fn_body] = sym__fn_body,
  [sym_paramlist] = sym_paramlist,
  [sym_param] = sym_param,
  [sym__param_vararg] = sym_param,
  [sym_type] = sym_type,
  [sym__outertype] = sym__outertype,
  [sym_singleton] = sym_singleton,
  [sym_namedtype] = sym_namedtype,
  [sym_typelist] = sym_typelist,
  [sym__typelist_vrd] = sym__typelist_vrd,
  [sym_wraptype] = sym_wraptype,
  [sym_typeparam] = sym_typeparam,
  [sym__typeparamlist] = sym__typeparamlist,
  [sym_typepack] = sym_typepack,
  [sym__typepack_wrap] = sym__typepack_wrap,
  [sym__typepack_vrd] = sym__typepack_vrd,
  [sym__typepack_gen] = sym__typepack_gen,
  [sym_variadic] = sym_variadic,
  [sym_dyntype] = sym_dyntype,
  [sym_fntype] = sym_fntype,
  [sym__fntype_gen] = sym__fntype_gen,
  [sym_paramtypelist] = sym_paramtypelist,
  [sym__fntype_param] = sym__fntype_param,
  [sym__fntype_paramlist] = sym__fntype_paramlist,
  [sym__fntype_paramlist_vrd] = sym__fntype_paramlist_vrd,
  [sym_tbtype] = sym_tbtype,
  [sym__tbtype_content] = sym__tbtype_content,
  [sym__array_type] = sym__array_type,
  [sym__tbtype_kv] = sym__tbtype_kv,
  [sym_kvtypelist] = sym_kvtypelist,
  [sym_indexertype] = sym_indexertype,
  [sym_proptype] = sym_proptype,
  [sym_bintype] = sym_bintype,
  [sym_untype] = sym_untype,
  [sym_generic] = sym_generic,
  [sym__genlist] = sym__genlist,
  [sym_genpack] = sym_genpack,
  [sym__genpack_list] = sym__genpack_list,
  [sym_vararg] = sym_vararg,
  [sym_string] = sym_string,
  [sym_string_interp] = sym_string_interp,
  [sym_interp_exp] = sym_interp_exp,
  [sym__escape_sequence] = sym__escape_sequence,
  [sym_unicode_escape] = sym_unicode_escape,
  [sym_dec_byte_escape] = sym_dec_byte_escape,
  [sym_hex_byte_escape] = sym_hex_byte_escape,
  [sym_boolean] = sym_boolean,
  [sym_nil] = sym_nil,
  [sym_readwrite] = sym_readwrite,
  [sym_attribute] = sym_attribute,
  [sym__parattrlist] = sym__parattrlist,
  [sym_parattr] = sym_parattr,
  [sym_parattr_param] = sym_parattr_param,
  [sym_literal] = sym_literal,
  [sym__litlist] = sym__litlist,
  [sym_littable] = sym_littable,
  [sym__litfieldlist] = sym__litfieldlist,
  [sym_litfield] = sym_litfield,
  [sym_comment] = sym_comment,
  [aux_sym__block_repeat1] = aux_sym__block_repeat1,
  [aux_sym_if_stmt_repeat1] = aux_sym_if_stmt_repeat1,
  [aux_sym__varlist_repeat1] = aux_sym__varlist_repeat1,
  [aux_sym__type_stmt_genlist_repeat1] = aux_sym__type_stmt_genlist_repeat1,
  [aux_sym__type_stmt_packlist_repeat1] = aux_sym__type_stmt_packlist_repeat1,
  [aux_sym__explist_repeat1] = aux_sym__explist_repeat1,
  [aux_sym_ifexp_repeat1] = aux_sym_ifexp_repeat1,
  [aux_sym__fieldlist_repeat1] = aux_sym__fieldlist_repeat1,
  [aux_sym_bindinglist_repeat1] = aux_sym_bindinglist_repeat1,
  [aux_sym_paramlist_repeat1] = aux_sym_paramlist_repeat1,
  [aux_sym_typelist_repeat1] = aux_sym_typelist_repeat1,
  [aux_sym__typeparamlist_repeat1] = aux_sym__typeparamlist_repeat1,
  [aux_sym__fntype_paramlist_repeat1] = aux_sym__fntype_paramlist_repeat1,
  [aux_sym_kvtypelist_repeat1] = aux_sym_kvtypelist_repeat1,
  [aux_sym__genlist_repeat1] = aux_sym__genlist_repeat1,
  [aux_sym__genpack_list_repeat1] = aux_sym__genpack_list_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_interp_repeat1] = aux_sym_string_interp_repeat1,
  [aux_sym__parattrlist_repeat1] = aux_sym__parattrlist_repeat1,
  [aux_sym__litlist_repeat1] = aux_sym__litlist_repeat1,
  [aux_sym__litfieldlist_repeat1] = aux_sym__litfieldlist_repeat1,
  [alias_sym_explist] = alias_sym_explist,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_name] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elseif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_repeat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [sym_continue_stmt] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_stmt_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_unicode_escape_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_dec_byte_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_hex_byte_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nil] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_read] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_write] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_attribute_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_AT_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym__comment_start] = {
    .visible = false,
    .named = true,
  },
  [sym__comment_content] = {
    .visible = false,
    .named = true,
  },
  [sym__comment_end] = {
    .visible = false,
    .named = true,
  },
  [sym__string_start] = {
    .visible = false,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__string_end] = {
    .visible = false,
    .named = true,
  },
  [sym_interp_start] = {
    .visible = true,
    .named = true,
  },
  [sym_interp_content] = {
    .visible = true,
    .named = true,
  },
  [sym_interp_brace_open] = {
    .visible = true,
    .named = true,
  },
  [sym_interp_brace_close] = {
    .visible = true,
    .named = true,
  },
  [sym_interp_end] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_escape] = {
    .visible = true,
    .named = true,
  },
  [sym__unicode_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym__dec_byte_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym__hex_byte_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_chunk] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__block] = {
    .visible = false,
    .named = true,
  },
  [sym_ret_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_local_fn_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_fn_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__tbl_fn_member] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__attrlist] = {
    .visible = false,
    .named = false,
  },
  [sym_for_in_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_for_range_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_if_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_while_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_do_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_break_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_local_var_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_var_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_assign_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__varlist] = {
    .visible = true,
    .named = true,
  },
  [sym_type_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_type_fn_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__type_assign] = {
    .visible = false,
    .named = true,
  },
  [sym_genericdef] = {
    .visible = true,
    .named = true,
  },
  [sym__type_stmt_genlist] = {
    .visible = false,
    .named = true,
  },
  [sym_genpackdef] = {
    .visible = true,
    .named = true,
  },
  [sym__type_stmt_packlist] = {
    .visible = false,
    .named = true,
  },
  [sym__assign] = {
    .visible = false,
    .named = true,
  },
  [sym_exp] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__explist] = {
    .visible = false,
    .named = true,
  },
  [sym_binexp] = {
    .visible = true,
    .named = true,
  },
  [sym_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_unexp] = {
    .visible = true,
    .named = true,
  },
  [sym_ifexp] = {
    .visible = true,
    .named = true,
  },
  [sym__ifexp_elseif] = {
    .visible = false,
    .named = true,
  },
  [sym_table] = {
    .visible = true,
    .named = true,
  },
  [sym__fieldlist] = {
    .visible = false,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym_prefixexp] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__prefixexp] = {
    .visible = false,
    .named = true,
  },
  [sym_exp_wrap] = {
    .visible = true,
    .named = true,
  },
  [sym_call_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__tbl_method] = {
    .visible = false,
    .named = true,
  },
  [sym__method_name] = {
    .visible = false,
    .named = true,
  },
  [sym_arglist] = {
    .visible = true,
    .named = true,
  },
  [sym_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_bindinglist] = {
    .visible = true,
    .named = true,
  },
  [sym_var] = {
    .visible = true,
    .named = true,
  },
  [sym__tbl_seq] = {
    .visible = false,
    .named = true,
  },
  [sym_key] = {
    .visible = true,
    .named = true,
  },
  [sym__key_named] = {
    .visible = false,
    .named = true,
  },
  [sym_anon_fn] = {
    .visible = true,
    .named = true,
  },
  [sym__fn_body] = {
    .visible = false,
    .named = true,
  },
  [sym_paramlist] = {
    .visible = true,
    .named = true,
  },
  [sym_param] = {
    .visible = true,
    .named = true,
  },
  [sym__param_vararg] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__outertype] = {
    .visible = false,
    .named = true,
  },
  [sym_singleton] = {
    .visible = true,
    .named = true,
  },
  [sym_namedtype] = {
    .visible = true,
    .named = true,
  },
  [sym_typelist] = {
    .visible = true,
    .named = true,
  },
  [sym__typelist_vrd] = {
    .visible = false,
    .named = true,
  },
  [sym_wraptype] = {
    .visible = true,
    .named = true,
  },
  [sym_typeparam] = {
    .visible = true,
    .named = true,
  },
  [sym__typeparamlist] = {
    .visible = false,
    .named = true,
  },
  [sym_typepack] = {
    .visible = true,
    .named = true,
  },
  [sym__typepack_wrap] = {
    .visible = false,
    .named = true,
  },
  [sym__typepack_vrd] = {
    .visible = false,
    .named = true,
  },
  [sym__typepack_gen] = {
    .visible = false,
    .named = true,
  },
  [sym_variadic] = {
    .visible = true,
    .named = true,
  },
  [sym_dyntype] = {
    .visible = true,
    .named = true,
  },
  [sym_fntype] = {
    .visible = true,
    .named = true,
  },
  [sym__fntype_gen] = {
    .visible = false,
    .named = true,
  },
  [sym_paramtypelist] = {
    .visible = true,
    .named = true,
  },
  [sym__fntype_param] = {
    .visible = false,
    .named = true,
  },
  [sym__fntype_paramlist] = {
    .visible = false,
    .named = true,
  },
  [sym__fntype_paramlist_vrd] = {
    .visible = false,
    .named = true,
  },
  [sym_tbtype] = {
    .visible = true,
    .named = true,
  },
  [sym__tbtype_content] = {
    .visible = false,
    .named = true,
  },
  [sym__array_type] = {
    .visible = false,
    .named = true,
  },
  [sym__tbtype_kv] = {
    .visible = false,
    .named = true,
  },
  [sym_kvtypelist] = {
    .visible = true,
    .named = true,
  },
  [sym_indexertype] = {
    .visible = true,
    .named = true,
  },
  [sym_proptype] = {
    .visible = true,
    .named = true,
  },
  [sym_bintype] = {
    .visible = true,
    .named = true,
  },
  [sym_untype] = {
    .visible = true,
    .named = true,
  },
  [sym_generic] = {
    .visible = true,
    .named = true,
  },
  [sym__genlist] = {
    .visible = false,
    .named = true,
  },
  [sym_genpack] = {
    .visible = true,
    .named = true,
  },
  [sym__genpack_list] = {
    .visible = false,
    .named = true,
  },
  [sym_vararg] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_interp] = {
    .visible = true,
    .named = true,
  },
  [sym_interp_exp] = {
    .visible = true,
    .named = true,
  },
  [sym__escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_unicode_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_dec_byte_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_byte_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_readwrite] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__parattrlist] = {
    .visible = false,
    .named = true,
  },
  [sym_parattr] = {
    .visible = true,
    .named = true,
  },
  [sym_parattr_param] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__litlist] = {
    .visible = false,
    .named = true,
  },
  [sym_littable] = {
    .visible = true,
    .named = true,
  },
  [sym__litfieldlist] = {
    .visible = false,
    .named = true,
  },
  [sym_litfield] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_stmt_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__varlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_stmt_genlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_stmt_packlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__explist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ifexp_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__fieldlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_bindinglist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_paramlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_typelist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__typeparamlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__fntype_paramlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_kvtypelist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__genlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__genpack_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_interp_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parattrlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__litlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__litfieldlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_explist] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_array_type_specifier = 2,
  field_assign_symbol = 3,
  field_attribute_name = 4,
  field_body = 5,
  field_condition = 6,
  field_consequence = 7,
  field_field_indexer = 8,
  field_field_name = 9,
  field_function_name = 10,
  field_generic_type_name = 11,
  field_generic_typepack_name = 12,
  field_indexer_type_specifier = 13,
  field_invoked = 14,
  field_left = 15,
  field_method_name = 16,
  field_method_table = 17,
  field_module_namespace = 18,
  field_operand = 19,
  field_operator = 20,
  field_parameter_name = 21,
  field_return_type = 22,
  field_right = 23,
  field_start = 24,
  field_step = 25,
  field_stop = 26,
  field_table_name = 27,
  field_type_name = 28,
  field_type_specifier = 29,
  field_type_value = 30,
  field_typepack_value = 31,
  field_value = 32,
  field_value_type_specifier = 33,
  field_variable_name = 34,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_array_type_specifier] = "array_type_specifier",
  [field_assign_symbol] = "assign_symbol",
  [field_attribute_name] = "attribute_name",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_field_indexer] = "field_indexer",
  [field_field_name] = "field_name",
  [field_function_name] = "function_name",
  [field_generic_type_name] = "generic_type_name",
  [field_generic_typepack_name] = "generic_typepack_name",
  [field_indexer_type_specifier] = "indexer_type_specifier",
  [field_invoked] = "invoked",
  [field_left] = "left",
  [field_method_name] = "method_name",
  [field_method_table] = "method_table",
  [field_module_namespace] = "module_namespace",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_parameter_name] = "parameter_name",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_start] = "start",
  [field_step] = "step",
  [field_stop] = "stop",
  [field_table_name] = "table_name",
  [field_type_name] = "type_name",
  [field_type_specifier] = "type_specifier",
  [field_type_value] = "type_value",
  [field_typepack_value] = "typepack_value",
  [field_value] = "value",
  [field_value_type_specifier] = "value_type_specifier",
  [field_variable_name] = "variable_name",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 1},
  [7] = {.index = 5, .length = 2},
  [8] = {.index = 7, .length = 1},
  [9] = {.index = 8, .length = 2},
  [10] = {.index = 10, .length = 3},
  [11] = {.index = 13, .length = 2},
  [12] = {.index = 15, .length = 1},
  [13] = {.index = 3, .length = 1},
  [14] = {.index = 16, .length = 4},
  [15] = {.index = 20, .length = 1},
  [16] = {.index = 21, .length = 1},
  [17] = {.index = 22, .length = 4},
  [18] = {.index = 26, .length = 1},
  [19] = {.index = 27, .length = 1},
  [20] = {.index = 28, .length = 1},
  [21] = {.index = 29, .length = 1},
  [22] = {.index = 30, .length = 3},
  [23] = {.index = 33, .length = 1},
  [24] = {.index = 34, .length = 2},
  [25] = {.index = 36, .length = 3},
  [26] = {.index = 39, .length = 1},
  [27] = {.index = 40, .length = 4},
  [28] = {.index = 44, .length = 4},
  [29] = {.index = 48, .length = 3},
  [30] = {.index = 51, .length = 1},
  [31] = {.index = 52, .length = 5},
  [32] = {.index = 57, .length = 2},
  [33] = {.index = 59, .length = 1},
  [34] = {.index = 60, .length = 1},
  [35] = {.index = 61, .length = 2},
  [36] = {.index = 63, .length = 1},
  [37] = {.index = 64, .length = 1},
  [38] = {.index = 65, .length = 3},
  [39] = {.index = 68, .length = 2},
  [40] = {.index = 70, .length = 2},
  [41] = {.index = 72, .length = 1},
  [42] = {.index = 73, .length = 1},
  [43] = {.index = 74, .length = 2},
  [44] = {.index = 76, .length = 1},
  [45] = {.index = 77, .length = 2},
  [46] = {.index = 79, .length = 2},
  [47] = {.index = 81, .length = 2},
  [48] = {.index = 83, .length = 2},
  [49] = {.index = 85, .length = 2},
  [50] = {.index = 87, .length = 4},
  [51] = {.index = 91, .length = 4},
  [52] = {.index = 95, .length = 4},
  [53] = {.index = 99, .length = 1},
  [54] = {.index = 100, .length = 5},
  [55] = {.index = 105, .length = 1},
  [56] = {.index = 106, .length = 3},
  [57] = {.index = 109, .length = 2},
  [58] = {.index = 111, .length = 2},
  [59] = {.index = 113, .length = 2},
  [60] = {.index = 115, .length = 2},
  [61] = {.index = 117, .length = 1},
  [62] = {.index = 118, .length = 2},
  [63] = {.index = 120, .length = 2},
  [64] = {.index = 122, .length = 1},
  [66] = {.index = 123, .length = 3},
  [67] = {.index = 126, .length = 3},
  [68] = {.index = 129, .length = 3},
  [69] = {.index = 132, .length = 2},
  [70] = {.index = 134, .length = 1},
  [71] = {.index = 135, .length = 1},
  [72] = {.index = 136, .length = 2},
  [73] = {.index = 138, .length = 3},
  [74] = {.index = 141, .length = 3},
  [75] = {.index = 144, .length = 1},
  [76] = {.index = 145, .length = 1},
  [77] = {.index = 146, .length = 4},
  [78] = {.index = 150, .length = 4},
  [79] = {.index = 154, .length = 4},
  [80] = {.index = 158, .length = 2},
  [81] = {.index = 160, .length = 3},
  [82] = {.index = 163, .length = 2},
  [83] = {.index = 165, .length = 2},
  [84] = {.index = 167, .length = 1},
  [85] = {.index = 168, .length = 2},
  [86] = {.index = 170, .length = 4},
  [87] = {.index = 145, .length = 1},
  [88] = {.index = 174, .length = 3},
  [89] = {.index = 177, .length = 2},
  [90] = {.index = 179, .length = 4},
  [91] = {.index = 183, .length = 3},
  [92] = {.index = 186, .length = 2},
  [93] = {.index = 188, .length = 1},
  [94] = {.index = 189, .length = 1},
  [95] = {.index = 190, .length = 3},
  [96] = {.index = 193, .length = 3},
  [97] = {.index = 196, .length = 2},
  [98] = {.index = 198, .length = 2},
  [99] = {.index = 200, .length = 1},
  [100] = {.index = 201, .length = 4},
  [101] = {.index = 205, .length = 3},
  [102] = {.index = 208, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_variable_name, 0},
  [1] =
    {field_table_name, 0, .inherited = true},
  [2] =
    {field_table_name, 0},
  [3] =
    {field_field_name, 0, .inherited = true},
  [4] =
    {field_attribute_name, 1},
  [5] =
    {field_method_name, 1, .inherited = true},
    {field_method_table, 0},
  [7] =
    {field_invoked, 0},
  [8] =
    {field_method_name, 0, .inherited = true},
    {field_method_table, 0, .inherited = true},
  [10] =
    {field_body, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [13] =
    {field_operand, 1},
    {field_operator, 0},
  [15] =
    {field_value, 0},
  [16] =
    {field_body, 2, .inherited = true},
    {field_function_name, 1},
    {field_operator, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
  [20] =
    {field_body, 1},
  [21] =
    {field_condition, 2},
  [22] =
    {field_assign_symbol, 2, .inherited = true},
    {field_left, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [26] =
    {field_field_name, 1},
  [27] =
    {field_attribute_name, 0},
  [28] =
    {field_assign_symbol, 1},
  [29] =
    {field_method_name, 1},
  [30] =
    {field_assign_symbol, 1},
    {field_left, 0},
    {field_right, 2},
  [33] =
    {field_parameter_name, 0},
  [34] =
    {field_operator, 0, .inherited = true},
    {field_type_specifier, 0, .inherited = true},
  [36] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [39] =
    {field_type_name, 0},
  [40] =
    {field_left, 0},
    {field_operator, 1},
    {field_operator, 2, .inherited = true},
    {field_right, 2},
  [44] =
    {field_body, 3, .inherited = true},
    {field_function_name, 2},
    {field_operator, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
  [48] =
    {field_operator, 2, .inherited = true},
    {field_type_specifier, 2},
    {field_variable_name, 0},
  [51] =
    {field_assign_symbol, 2},
  [52] =
    {field_body, 3, .inherited = true},
    {field_method_name, 2, .inherited = true},
    {field_operator, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_table_name, 1},
  [57] =
    {field_field_name, 0, .inherited = true},
    {field_method_name, 1, .inherited = true},
  [59] =
    {field_condition, 1},
  [60] =
    {field_alternative, 0},
  [61] =
    {field_body, 1},
    {field_condition, 3},
  [63] =
    {field_field_indexer, 1},
  [64] =
    {field_generic_typepack_name, 0},
  [65] =
    {field_assign_symbol, 1},
    {field_field_name, 0},
    {field_value, 2},
  [68] =
    {field_array_type_specifier, 0},
    {field_operator, 0, .inherited = true},
  [70] =
    {field_array_type_specifier, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [72] =
    {field_operator, 0, .inherited = true},
  [73] =
    {field_operator, 0},
  [74] =
    {field_operand, 0},
    {field_operator, 1},
  [76] =
    {field_return_type, 1},
  [77] =
    {field_condition, 1},
    {field_consequence, 3},
  [79] =
    {field_alternative, 3},
    {field_condition, 1},
  [81] =
    {field_alternative, 3, .inherited = true},
    {field_condition, 1},
  [83] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [85] =
    {field_body, 3},
    {field_condition, 1},
  [87] =
    {field_assign_symbol, 4, .inherited = true},
    {field_left, 4, .inherited = true},
    {field_operator, 4, .inherited = true},
    {field_right, 4, .inherited = true},
  [91] =
    {field_body, 4, .inherited = true},
    {field_function_name, 3},
    {field_operator, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
  [95] =
    {field_assign_symbol, 1},
    {field_left, 0},
    {field_operator, 2, .inherited = true},
    {field_right, 2},
  [99] =
    {field_generic_type_name, 0},
  [100] =
    {field_body, 4, .inherited = true},
    {field_method_name, 3, .inherited = true},
    {field_operator, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_table_name, 2},
  [105] =
    {field_body, 2},
  [106] =
    {field_operator, 2, .inherited = true},
    {field_parameter_name, 0},
    {field_type_specifier, 2},
  [109] =
    {field_operator, 2, .inherited = true},
    {field_type_specifier, 2, .inherited = true},
  [111] =
    {field_operator, 2, .inherited = true},
    {field_type_specifier, 2},
  [113] =
    {field_array_type_specifier, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
  [115] =
    {field_array_type_specifier, 1},
    {field_operator, 1, .inherited = true},
  [117] =
    {field_operator, 1, .inherited = true},
  [118] =
    {field_operator, 0, .inherited = true},
    {field_operator, 1, .inherited = true},
  [120] =
    {field_module_namespace, 0},
    {field_type_name, 2},
  [122] =
    {field_return_type, 2},
  [123] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 3},
  [126] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [129] =
    {field_alternative, 3, .inherited = true},
    {field_alternative, 4},
    {field_condition, 1},
  [132] =
    {field_operator, 3, .inherited = true},
    {field_return_type, 3},
  [134] =
    {field_return_type, 3},
  [135] =
    {field_body, 3},
  [136] =
    {field_operator, 3, .inherited = true},
    {field_type_specifier, 3, .inherited = true},
  [138] =
    {field_assign_symbol, 3},
    {field_field_indexer, 1},
    {field_value, 4},
  [141] =
    {field_field_name, 0},
    {field_operator, 2, .inherited = true},
    {field_type_specifier, 2},
  [144] =
    {field_operator, 2, .inherited = true},
  [145] =
    {field_body, 5},
  [146] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
  [150] =
    {field_body, 6, .inherited = true},
    {field_function_name, 5},
    {field_operator, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
  [154] =
    {field_assign_symbol, 1},
    {field_generic_type_name, 0},
    {field_operator, 2, .inherited = true},
    {field_type_value, 2},
  [158] =
    {field_assign_symbol, 1},
    {field_typepack_value, 2},
  [160] =
    {field_body, 4},
    {field_operator, 3, .inherited = true},
    {field_return_type, 3},
  [163] =
    {field_body, 4},
    {field_return_type, 3},
  [165] =
    {field_operator, 4, .inherited = true},
    {field_return_type, 4},
  [167] =
    {field_return_type, 4},
  [168] =
    {field_start, 3},
    {field_stop, 5},
  [170] =
    {field_assign_symbol, 4},
    {field_left, 0},
    {field_operator, 5, .inherited = true},
    {field_right, 5},
  [174] =
    {field_body, 5},
    {field_operator, 4, .inherited = true},
    {field_return_type, 4},
  [177] =
    {field_body, 5},
    {field_return_type, 4},
  [179] =
    {field_indexer_type_specifier, 1},
    {field_operator, 1, .inherited = true},
    {field_operator, 4, .inherited = true},
    {field_value_type_specifier, 4},
  [183] =
    {field_body, 7},
    {field_start, 3},
    {field_stop, 5},
  [186] =
    {field_operator, 6, .inherited = true},
    {field_return_type, 6},
  [188] =
    {field_return_type, 6},
  [189] =
    {field_body, 6},
  [190] =
    {field_start, 3},
    {field_step, 7},
    {field_stop, 5},
  [193] =
    {field_body, 7},
    {field_operator, 6, .inherited = true},
    {field_return_type, 6},
  [196] =
    {field_body, 7},
    {field_return_type, 6},
  [198] =
    {field_operator, 7, .inherited = true},
    {field_return_type, 7},
  [200] =
    {field_return_type, 7},
  [201] =
    {field_body, 9},
    {field_start, 3},
    {field_step, 7},
    {field_stop, 5},
  [205] =
    {field_body, 8},
    {field_operator, 7, .inherited = true},
    {field_return_type, 7},
  [208] =
    {field_body, 8},
    {field_return_type, 7},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [3] = {
    [1] = alias_sym_explist,
  },
  [13] = {
    [0] = sym_key,
  },
  [20] = {
    [2] = alias_sym_explist,
  },
  [30] = {
    [3] = alias_sym_explist,
  },
  [32] = {
    [0] = sym_key,
  },
  [65] = {
    [3] = alias_sym_explist,
  },
  [76] = {
    [3] = alias_sym_explist,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__explist, 2,
    sym__explist,
    alias_sym_explist,
  sym__key_named, 2,
    sym__key_named,
    sym_key,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 2,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 7,
  [10] = 10,
  [11] = 11,
  [12] = 8,
  [13] = 8,
  [14] = 7,
  [15] = 10,
  [16] = 11,
  [17] = 10,
  [18] = 8,
  [19] = 7,
  [20] = 10,
  [21] = 11,
  [22] = 8,
  [23] = 7,
  [24] = 10,
  [25] = 11,
  [26] = 8,
  [27] = 7,
  [28] = 10,
  [29] = 11,
  [30] = 8,
  [31] = 7,
  [32] = 10,
  [33] = 11,
  [34] = 8,
  [35] = 7,
  [36] = 10,
  [37] = 11,
  [38] = 8,
  [39] = 7,
  [40] = 10,
  [41] = 11,
  [42] = 8,
  [43] = 7,
  [44] = 10,
  [45] = 11,
  [46] = 8,
  [47] = 7,
  [48] = 10,
  [49] = 11,
  [50] = 8,
  [51] = 7,
  [52] = 10,
  [53] = 11,
  [54] = 8,
  [55] = 7,
  [56] = 10,
  [57] = 11,
  [58] = 8,
  [59] = 7,
  [60] = 10,
  [61] = 11,
  [62] = 8,
  [63] = 7,
  [64] = 10,
  [65] = 11,
  [66] = 8,
  [67] = 7,
  [68] = 10,
  [69] = 11,
  [70] = 11,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 73,
  [77] = 77,
  [78] = 78,
  [79] = 71,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 77,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 73,
  [90] = 78,
  [91] = 75,
  [92] = 75,
  [93] = 71,
  [94] = 77,
  [95] = 78,
  [96] = 80,
  [97] = 80,
  [98] = 81,
  [99] = 82,
  [100] = 81,
  [101] = 84,
  [102] = 85,
  [103] = 86,
  [104] = 87,
  [105] = 88,
  [106] = 73,
  [107] = 82,
  [108] = 75,
  [109] = 84,
  [110] = 71,
  [111] = 77,
  [112] = 78,
  [113] = 85,
  [114] = 80,
  [115] = 81,
  [116] = 82,
  [117] = 86,
  [118] = 84,
  [119] = 85,
  [120] = 86,
  [121] = 87,
  [122] = 88,
  [123] = 87,
  [124] = 88,
  [125] = 77,
  [126] = 78,
  [127] = 80,
  [128] = 81,
  [129] = 84,
  [130] = 85,
  [131] = 87,
  [132] = 88,
  [133] = 77,
  [134] = 78,
  [135] = 80,
  [136] = 81,
  [137] = 137,
  [138] = 84,
  [139] = 85,
  [140] = 87,
  [141] = 88,
  [142] = 77,
  [143] = 78,
  [144] = 80,
  [145] = 81,
  [146] = 84,
  [147] = 85,
  [148] = 87,
  [149] = 88,
  [150] = 77,
  [151] = 78,
  [152] = 80,
  [153] = 72,
  [154] = 84,
  [155] = 85,
  [156] = 87,
  [157] = 88,
  [158] = 77,
  [159] = 78,
  [160] = 80,
  [161] = 81,
  [162] = 84,
  [163] = 85,
  [164] = 87,
  [165] = 88,
  [166] = 77,
  [167] = 78,
  [168] = 80,
  [169] = 81,
  [170] = 84,
  [171] = 85,
  [172] = 87,
  [173] = 88,
  [174] = 77,
  [175] = 78,
  [176] = 80,
  [177] = 81,
  [178] = 84,
  [179] = 85,
  [180] = 87,
  [181] = 88,
  [182] = 77,
  [183] = 78,
  [184] = 80,
  [185] = 81,
  [186] = 84,
  [187] = 85,
  [188] = 87,
  [189] = 88,
  [190] = 77,
  [191] = 78,
  [192] = 80,
  [193] = 81,
  [194] = 84,
  [195] = 85,
  [196] = 87,
  [197] = 88,
  [198] = 77,
  [199] = 78,
  [200] = 80,
  [201] = 81,
  [202] = 84,
  [203] = 85,
  [204] = 87,
  [205] = 88,
  [206] = 72,
  [207] = 77,
  [208] = 78,
  [209] = 80,
  [210] = 81,
  [211] = 84,
  [212] = 85,
  [213] = 87,
  [214] = 88,
  [215] = 77,
  [216] = 78,
  [217] = 80,
  [218] = 81,
  [219] = 84,
  [220] = 85,
  [221] = 87,
  [222] = 88,
  [223] = 72,
  [224] = 81,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 137,
  [230] = 137,
  [231] = 137,
  [232] = 227,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 226,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 226,
  [244] = 226,
  [245] = 245,
  [246] = 225,
  [247] = 228,
  [248] = 227,
  [249] = 225,
  [250] = 228,
  [251] = 227,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 228,
  [259] = 225,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 252,
  [264] = 254,
  [265] = 253,
  [266] = 255,
  [267] = 254,
  [268] = 255,
  [269] = 256,
  [270] = 256,
  [271] = 237,
  [272] = 238,
  [273] = 239,
  [274] = 257,
  [275] = 240,
  [276] = 241,
  [277] = 241,
  [278] = 242,
  [279] = 245,
  [280] = 245,
  [281] = 242,
  [282] = 282,
  [283] = 283,
  [284] = 245,
  [285] = 257,
  [286] = 235,
  [287] = 237,
  [288] = 238,
  [289] = 260,
  [290] = 235,
  [291] = 233,
  [292] = 253,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 239,
  [297] = 254,
  [298] = 298,
  [299] = 299,
  [300] = 240,
  [301] = 234,
  [302] = 302,
  [303] = 241,
  [304] = 304,
  [305] = 305,
  [306] = 257,
  [307] = 307,
  [308] = 255,
  [309] = 242,
  [310] = 310,
  [311] = 311,
  [312] = 256,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 252,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 237,
  [328] = 238,
  [329] = 234,
  [330] = 235,
  [331] = 239,
  [332] = 260,
  [333] = 233,
  [334] = 240,
  [335] = 260,
  [336] = 233,
  [337] = 234,
  [338] = 235,
  [339] = 252,
  [340] = 253,
  [341] = 234,
  [342] = 342,
  [343] = 343,
  [344] = 262,
  [345] = 262,
  [346] = 261,
  [347] = 262,
  [348] = 261,
  [349] = 261,
  [350] = 313,
  [351] = 317,
  [352] = 305,
  [353] = 315,
  [354] = 318,
  [355] = 319,
  [356] = 283,
  [357] = 321,
  [358] = 322,
  [359] = 307,
  [360] = 310,
  [361] = 323,
  [362] = 324,
  [363] = 325,
  [364] = 311,
  [365] = 313,
  [366] = 326,
  [367] = 314,
  [368] = 368,
  [369] = 293,
  [370] = 294,
  [371] = 315,
  [372] = 295,
  [373] = 316,
  [374] = 298,
  [375] = 299,
  [376] = 342,
  [377] = 302,
  [378] = 234,
  [379] = 304,
  [380] = 305,
  [381] = 235,
  [382] = 317,
  [383] = 307,
  [384] = 282,
  [385] = 310,
  [386] = 311,
  [387] = 313,
  [388] = 314,
  [389] = 316,
  [390] = 318,
  [391] = 317,
  [392] = 318,
  [393] = 393,
  [394] = 319,
  [395] = 321,
  [396] = 322,
  [397] = 319,
  [398] = 316,
  [399] = 324,
  [400] = 325,
  [401] = 326,
  [402] = 282,
  [403] = 321,
  [404] = 322,
  [405] = 283,
  [406] = 406,
  [407] = 323,
  [408] = 315,
  [409] = 324,
  [410] = 325,
  [411] = 293,
  [412] = 294,
  [413] = 326,
  [414] = 293,
  [415] = 295,
  [416] = 282,
  [417] = 294,
  [418] = 295,
  [419] = 283,
  [420] = 298,
  [421] = 299,
  [422] = 234,
  [423] = 235,
  [424] = 298,
  [425] = 342,
  [426] = 302,
  [427] = 304,
  [428] = 305,
  [429] = 299,
  [430] = 342,
  [431] = 302,
  [432] = 307,
  [433] = 433,
  [434] = 310,
  [435] = 311,
  [436] = 304,
  [437] = 235,
  [438] = 314,
  [439] = 234,
  [440] = 323,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 441,
  [445] = 445,
  [446] = 446,
  [447] = 441,
  [448] = 441,
  [449] = 441,
  [450] = 441,
  [451] = 441,
  [452] = 343,
  [453] = 441,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 441,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 441,
  [478] = 478,
  [479] = 479,
  [480] = 441,
  [481] = 441,
  [482] = 343,
  [483] = 343,
  [484] = 441,
  [485] = 441,
  [486] = 486,
  [487] = 441,
  [488] = 260,
  [489] = 233,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 441,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 441,
  [504] = 441,
  [505] = 441,
  [506] = 441,
  [507] = 441,
  [508] = 441,
  [509] = 441,
  [510] = 441,
  [511] = 441,
  [512] = 441,
  [513] = 441,
  [514] = 441,
  [515] = 441,
  [516] = 516,
  [517] = 517,
  [518] = 516,
  [519] = 516,
  [520] = 393,
  [521] = 368,
  [522] = 368,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 517,
  [527] = 516,
  [528] = 517,
  [529] = 516,
  [530] = 517,
  [531] = 516,
  [532] = 517,
  [533] = 516,
  [534] = 517,
  [535] = 516,
  [536] = 516,
  [537] = 516,
  [538] = 517,
  [539] = 516,
  [540] = 393,
  [541] = 368,
  [542] = 517,
  [543] = 517,
  [544] = 516,
  [545] = 517,
  [546] = 516,
  [547] = 517,
  [548] = 516,
  [549] = 517,
  [550] = 517,
  [551] = 516,
  [552] = 516,
  [553] = 393,
  [554] = 517,
  [555] = 516,
  [556] = 517,
  [557] = 517,
  [558] = 516,
  [559] = 517,
  [560] = 517,
  [561] = 561,
  [562] = 501,
  [563] = 502,
  [564] = 469,
  [565] = 442,
  [566] = 470,
  [567] = 471,
  [568] = 472,
  [569] = 473,
  [570] = 474,
  [571] = 475,
  [572] = 476,
  [573] = 478,
  [574] = 561,
  [575] = 479,
  [576] = 445,
  [577] = 497,
  [578] = 561,
  [579] = 498,
  [580] = 493,
  [581] = 462,
  [582] = 463,
  [583] = 465,
  [584] = 561,
  [585] = 494,
  [586] = 496,
  [587] = 497,
  [588] = 260,
  [589] = 498,
  [590] = 561,
  [591] = 443,
  [592] = 561,
  [593] = 499,
  [594] = 446,
  [595] = 497,
  [596] = 498,
  [597] = 499,
  [598] = 500,
  [599] = 501,
  [600] = 260,
  [601] = 502,
  [602] = 233,
  [603] = 455,
  [604] = 456,
  [605] = 500,
  [606] = 561,
  [607] = 442,
  [608] = 233,
  [609] = 443,
  [610] = 446,
  [611] = 501,
  [612] = 466,
  [613] = 561,
  [614] = 445,
  [615] = 486,
  [616] = 502,
  [617] = 499,
  [618] = 457,
  [619] = 458,
  [620] = 459,
  [621] = 500,
  [622] = 459,
  [623] = 561,
  [624] = 624,
  [625] = 490,
  [626] = 486,
  [627] = 491,
  [628] = 460,
  [629] = 461,
  [630] = 462,
  [631] = 463,
  [632] = 465,
  [633] = 466,
  [634] = 467,
  [635] = 468,
  [636] = 469,
  [637] = 454,
  [638] = 561,
  [639] = 492,
  [640] = 478,
  [641] = 476,
  [642] = 467,
  [643] = 471,
  [644] = 472,
  [645] = 473,
  [646] = 474,
  [647] = 475,
  [648] = 476,
  [649] = 478,
  [650] = 479,
  [651] = 455,
  [652] = 493,
  [653] = 456,
  [654] = 561,
  [655] = 446,
  [656] = 445,
  [657] = 494,
  [658] = 490,
  [659] = 496,
  [660] = 490,
  [661] = 457,
  [662] = 458,
  [663] = 459,
  [664] = 442,
  [665] = 460,
  [666] = 491,
  [667] = 561,
  [668] = 460,
  [669] = 491,
  [670] = 561,
  [671] = 461,
  [672] = 492,
  [673] = 486,
  [674] = 454,
  [675] = 462,
  [676] = 493,
  [677] = 561,
  [678] = 463,
  [679] = 465,
  [680] = 443,
  [681] = 494,
  [682] = 466,
  [683] = 496,
  [684] = 492,
  [685] = 467,
  [686] = 561,
  [687] = 468,
  [688] = 458,
  [689] = 468,
  [690] = 561,
  [691] = 260,
  [692] = 469,
  [693] = 470,
  [694] = 471,
  [695] = 461,
  [696] = 561,
  [697] = 472,
  [698] = 479,
  [699] = 473,
  [700] = 233,
  [701] = 474,
  [702] = 475,
  [703] = 454,
  [704] = 455,
  [705] = 456,
  [706] = 457,
  [707] = 470,
  [708] = 708,
  [709] = 523,
  [710] = 524,
  [711] = 525,
  [712] = 712,
  [713] = 713,
  [714] = 714,
  [715] = 713,
  [716] = 714,
  [717] = 523,
  [718] = 524,
  [719] = 525,
  [720] = 523,
  [721] = 524,
  [722] = 713,
  [723] = 714,
  [724] = 708,
  [725] = 525,
  [726] = 726,
  [727] = 727,
  [728] = 713,
  [729] = 729,
  [730] = 714,
  [731] = 708,
  [732] = 726,
  [733] = 729,
  [734] = 708,
  [735] = 726,
  [736] = 729,
  [737] = 726,
  [738] = 729,
  [739] = 708,
  [740] = 726,
  [741] = 729,
  [742] = 708,
  [743] = 726,
  [744] = 729,
  [745] = 708,
  [746] = 726,
  [747] = 729,
  [748] = 712,
  [749] = 726,
  [750] = 729,
  [751] = 708,
  [752] = 726,
  [753] = 729,
  [754] = 708,
  [755] = 726,
  [756] = 729,
  [757] = 708,
  [758] = 726,
  [759] = 729,
  [760] = 708,
  [761] = 726,
  [762] = 729,
  [763] = 708,
  [764] = 726,
  [765] = 729,
  [766] = 708,
  [767] = 726,
  [768] = 729,
  [769] = 708,
  [770] = 726,
  [771] = 729,
  [772] = 708,
  [773] = 726,
  [774] = 729,
  [775] = 708,
  [776] = 726,
  [777] = 729,
  [778] = 708,
  [779] = 726,
  [780] = 729,
  [781] = 712,
  [782] = 712,
  [783] = 708,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 787,
  [788] = 788,
  [789] = 789,
  [790] = 790,
  [791] = 789,
  [792] = 788,
  [793] = 793,
  [794] = 794,
  [795] = 795,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 784,
  [802] = 802,
  [803] = 786,
  [804] = 787,
  [805] = 788,
  [806] = 790,
  [807] = 807,
  [808] = 808,
  [809] = 789,
  [810] = 790,
  [811] = 794,
  [812] = 797,
  [813] = 799,
  [814] = 795,
  [815] = 796,
  [816] = 798,
  [817] = 800,
  [818] = 802,
  [819] = 787,
  [820] = 797,
  [821] = 799,
  [822] = 789,
  [823] = 790,
  [824] = 794,
  [825] = 795,
  [826] = 796,
  [827] = 798,
  [828] = 800,
  [829] = 802,
  [830] = 787,
  [831] = 797,
  [832] = 799,
  [833] = 833,
  [834] = 834,
  [835] = 789,
  [836] = 794,
  [837] = 797,
  [838] = 799,
  [839] = 795,
  [840] = 796,
  [841] = 790,
  [842] = 798,
  [843] = 800,
  [844] = 802,
  [845] = 787,
  [846] = 784,
  [847] = 797,
  [848] = 799,
  [849] = 849,
  [850] = 789,
  [851] = 790,
  [852] = 852,
  [853] = 789,
  [854] = 799,
  [855] = 794,
  [856] = 795,
  [857] = 796,
  [858] = 798,
  [859] = 800,
  [860] = 802,
  [861] = 787,
  [862] = 799,
  [863] = 863,
  [864] = 864,
  [865] = 789,
  [866] = 790,
  [867] = 786,
  [868] = 868,
  [869] = 799,
  [870] = 870,
  [871] = 789,
  [872] = 872,
  [873] = 794,
  [874] = 795,
  [875] = 796,
  [876] = 798,
  [877] = 800,
  [878] = 802,
  [879] = 787,
  [880] = 789,
  [881] = 790,
  [882] = 882,
  [883] = 883,
  [884] = 797,
  [885] = 790,
  [886] = 886,
  [887] = 790,
  [888] = 794,
  [889] = 889,
  [890] = 794,
  [891] = 795,
  [892] = 796,
  [893] = 798,
  [894] = 800,
  [895] = 802,
  [896] = 787,
  [897] = 795,
  [898] = 898,
  [899] = 796,
  [900] = 798,
  [901] = 800,
  [902] = 802,
  [903] = 787,
  [904] = 789,
  [905] = 790,
  [906] = 797,
  [907] = 794,
  [908] = 833,
  [909] = 849,
  [910] = 807,
  [911] = 852,
  [912] = 794,
  [913] = 795,
  [914] = 795,
  [915] = 833,
  [916] = 849,
  [917] = 807,
  [918] = 796,
  [919] = 852,
  [920] = 798,
  [921] = 800,
  [922] = 796,
  [923] = 833,
  [924] = 849,
  [925] = 807,
  [926] = 798,
  [927] = 852,
  [928] = 802,
  [929] = 833,
  [930] = 849,
  [931] = 807,
  [932] = 852,
  [933] = 787,
  [934] = 785,
  [935] = 833,
  [936] = 849,
  [937] = 807,
  [938] = 852,
  [939] = 833,
  [940] = 849,
  [941] = 807,
  [942] = 799,
  [943] = 852,
  [944] = 800,
  [945] = 833,
  [946] = 849,
  [947] = 807,
  [948] = 852,
  [949] = 799,
  [950] = 786,
  [951] = 833,
  [952] = 849,
  [953] = 807,
  [954] = 852,
  [955] = 833,
  [956] = 849,
  [957] = 807,
  [958] = 788,
  [959] = 852,
  [960] = 789,
  [961] = 790,
  [962] = 833,
  [963] = 849,
  [964] = 807,
  [965] = 852,
  [966] = 833,
  [967] = 849,
  [968] = 807,
  [969] = 852,
  [970] = 794,
  [971] = 795,
  [972] = 833,
  [973] = 849,
  [974] = 852,
  [975] = 794,
  [976] = 795,
  [977] = 796,
  [978] = 852,
  [979] = 798,
  [980] = 800,
  [981] = 852,
  [982] = 802,
  [983] = 787,
  [984] = 796,
  [985] = 852,
  [986] = 798,
  [987] = 800,
  [988] = 797,
  [989] = 852,
  [990] = 852,
  [991] = 802,
  [992] = 799,
  [993] = 864,
  [994] = 793,
  [995] = 787,
  [996] = 863,
  [997] = 889,
  [998] = 864,
  [999] = 793,
  [1000] = 784,
  [1001] = 863,
  [1002] = 889,
  [1003] = 864,
  [1004] = 793,
  [1005] = 863,
  [1006] = 889,
  [1007] = 868,
  [1008] = 868,
  [1009] = 868,
  [1010] = 868,
  [1011] = 868,
  [1012] = 868,
  [1013] = 868,
  [1014] = 868,
  [1015] = 868,
  [1016] = 868,
  [1017] = 868,
  [1018] = 785,
  [1019] = 785,
  [1020] = 802,
  [1021] = 1021,
  [1022] = 1021,
  [1023] = 1023,
  [1024] = 1021,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 1023,
  [1028] = 1021,
  [1029] = 1025,
  [1030] = 1026,
  [1031] = 1023,
  [1032] = 1021,
  [1033] = 1025,
  [1034] = 1025,
  [1035] = 1026,
  [1036] = 1023,
  [1037] = 1021,
  [1038] = 1025,
  [1039] = 1026,
  [1040] = 1023,
  [1041] = 1021,
  [1042] = 1025,
  [1043] = 1026,
  [1044] = 1023,
  [1045] = 1021,
  [1046] = 1025,
  [1047] = 1026,
  [1048] = 1023,
  [1049] = 1021,
  [1050] = 1025,
  [1051] = 1026,
  [1052] = 1023,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1026,
  [1056] = 1023,
  [1057] = 1021,
  [1058] = 1025,
  [1059] = 1026,
  [1060] = 1023,
  [1061] = 1021,
  [1062] = 1025,
  [1063] = 1026,
  [1064] = 1023,
  [1065] = 1021,
  [1066] = 1025,
  [1067] = 1026,
  [1068] = 1023,
  [1069] = 1021,
  [1070] = 1025,
  [1071] = 1026,
  [1072] = 1023,
  [1073] = 1021,
  [1074] = 1025,
  [1075] = 1026,
  [1076] = 1023,
  [1077] = 1021,
  [1078] = 1025,
  [1079] = 1026,
  [1080] = 1026,
  [1081] = 1023,
  [1082] = 1021,
  [1083] = 1025,
  [1084] = 1026,
  [1085] = 1023,
  [1086] = 1025,
  [1087] = 1087,
  [1088] = 227,
  [1089] = 225,
  [1090] = 228,
  [1091] = 1091,
  [1092] = 1092,
  [1093] = 1091,
  [1094] = 1091,
  [1095] = 1091,
  [1096] = 1092,
  [1097] = 1091,
  [1098] = 225,
  [1099] = 1092,
  [1100] = 228,
  [1101] = 227,
  [1102] = 1092,
  [1103] = 1091,
  [1104] = 1092,
  [1105] = 1092,
  [1106] = 1091,
  [1107] = 1092,
  [1108] = 1092,
  [1109] = 1091,
  [1110] = 1091,
  [1111] = 1092,
  [1112] = 1092,
  [1113] = 1091,
  [1114] = 1091,
  [1115] = 1092,
  [1116] = 1092,
  [1117] = 1092,
  [1118] = 1091,
  [1119] = 1092,
  [1120] = 1091,
  [1121] = 1092,
  [1122] = 1092,
  [1123] = 1092,
  [1124] = 1091,
  [1125] = 1091,
  [1126] = 1092,
  [1127] = 1091,
  [1128] = 1091,
  [1129] = 1091,
  [1130] = 1130,
  [1131] = 241,
  [1132] = 237,
  [1133] = 245,
  [1134] = 234,
  [1135] = 260,
  [1136] = 235,
  [1137] = 238,
  [1138] = 1138,
  [1139] = 233,
  [1140] = 256,
  [1141] = 252,
  [1142] = 1142,
  [1143] = 253,
  [1144] = 239,
  [1145] = 254,
  [1146] = 255,
  [1147] = 240,
  [1148] = 1148,
  [1149] = 242,
  [1150] = 233,
  [1151] = 241,
  [1152] = 227,
  [1153] = 234,
  [1154] = 242,
  [1155] = 257,
  [1156] = 237,
  [1157] = 245,
  [1158] = 257,
  [1159] = 260,
  [1160] = 235,
  [1161] = 225,
  [1162] = 228,
  [1163] = 227,
  [1164] = 253,
  [1165] = 252,
  [1166] = 255,
  [1167] = 239,
  [1168] = 240,
  [1169] = 225,
  [1170] = 228,
  [1171] = 256,
  [1172] = 254,
  [1173] = 238,
  [1174] = 257,
  [1175] = 262,
  [1176] = 261,
  [1177] = 225,
  [1178] = 228,
  [1179] = 1179,
  [1180] = 225,
  [1181] = 228,
  [1182] = 227,
  [1183] = 261,
  [1184] = 315,
  [1185] = 1185,
  [1186] = 227,
  [1187] = 228,
  [1188] = 245,
  [1189] = 307,
  [1190] = 254,
  [1191] = 310,
  [1192] = 239,
  [1193] = 260,
  [1194] = 1194,
  [1195] = 298,
  [1196] = 1196,
  [1197] = 317,
  [1198] = 1198,
  [1199] = 262,
  [1200] = 1194,
  [1201] = 1201,
  [1202] = 1194,
  [1203] = 252,
  [1204] = 323,
  [1205] = 1194,
  [1206] = 1196,
  [1207] = 262,
  [1208] = 1208,
  [1209] = 1196,
  [1210] = 295,
  [1211] = 311,
  [1212] = 245,
  [1213] = 1208,
  [1214] = 240,
  [1215] = 1196,
  [1216] = 324,
  [1217] = 241,
  [1218] = 302,
  [1219] = 255,
  [1220] = 1208,
  [1221] = 253,
  [1222] = 1194,
  [1223] = 293,
  [1224] = 315,
  [1225] = 299,
  [1226] = 256,
  [1227] = 294,
  [1228] = 233,
  [1229] = 1229,
  [1230] = 261,
  [1231] = 242,
  [1232] = 225,
  [1233] = 225,
  [1234] = 1234,
  [1235] = 227,
  [1236] = 235,
  [1237] = 1237,
  [1238] = 257,
  [1239] = 228,
  [1240] = 242,
  [1241] = 241,
  [1242] = 234,
  [1243] = 235,
  [1244] = 1244,
  [1245] = 252,
  [1246] = 1194,
  [1247] = 282,
  [1248] = 253,
  [1249] = 304,
  [1250] = 254,
  [1251] = 260,
  [1252] = 1194,
  [1253] = 237,
  [1254] = 238,
  [1255] = 257,
  [1256] = 325,
  [1257] = 237,
  [1258] = 305,
  [1259] = 326,
  [1260] = 1194,
  [1261] = 1237,
  [1262] = 1194,
  [1263] = 233,
  [1264] = 257,
  [1265] = 1208,
  [1266] = 1208,
  [1267] = 234,
  [1268] = 342,
  [1269] = 314,
  [1270] = 1270,
  [1271] = 1237,
  [1272] = 1194,
  [1273] = 234,
  [1274] = 255,
  [1275] = 1275,
  [1276] = 1194,
  [1277] = 313,
  [1278] = 238,
  [1279] = 239,
  [1280] = 1280,
  [1281] = 316,
  [1282] = 240,
  [1283] = 317,
  [1284] = 318,
  [1285] = 319,
  [1286] = 321,
  [1287] = 256,
  [1288] = 283,
  [1289] = 322,
  [1290] = 1194,
  [1291] = 1237,
  [1292] = 235,
  [1293] = 227,
  [1294] = 343,
  [1295] = 261,
  [1296] = 257,
  [1297] = 261,
  [1298] = 257,
  [1299] = 237,
  [1300] = 238,
  [1301] = 239,
  [1302] = 240,
  [1303] = 241,
  [1304] = 242,
  [1305] = 1179,
  [1306] = 234,
  [1307] = 260,
  [1308] = 245,
  [1309] = 235,
  [1310] = 233,
  [1311] = 1179,
  [1312] = 252,
  [1313] = 253,
  [1314] = 254,
  [1315] = 255,
  [1316] = 256,
  [1317] = 261,
  [1318] = 282,
  [1319] = 283,
  [1320] = 252,
  [1321] = 253,
  [1322] = 254,
  [1323] = 255,
  [1324] = 256,
  [1325] = 293,
  [1326] = 294,
  [1327] = 295,
  [1328] = 298,
  [1329] = 299,
  [1330] = 342,
  [1331] = 302,
  [1332] = 304,
  [1333] = 305,
  [1334] = 307,
  [1335] = 310,
  [1336] = 311,
  [1337] = 313,
  [1338] = 314,
  [1339] = 316,
  [1340] = 317,
  [1341] = 318,
  [1342] = 321,
  [1343] = 322,
  [1344] = 323,
  [1345] = 324,
  [1346] = 325,
  [1347] = 326,
  [1348] = 293,
  [1349] = 294,
  [1350] = 295,
  [1351] = 298,
  [1352] = 299,
  [1353] = 342,
  [1354] = 302,
  [1355] = 304,
  [1356] = 305,
  [1357] = 307,
  [1358] = 310,
  [1359] = 311,
  [1360] = 313,
  [1361] = 314,
  [1362] = 316,
  [1363] = 318,
  [1364] = 319,
  [1365] = 321,
  [1366] = 322,
  [1367] = 323,
  [1368] = 324,
  [1369] = 325,
  [1370] = 326,
  [1371] = 282,
  [1372] = 283,
  [1373] = 260,
  [1374] = 233,
  [1375] = 1179,
  [1376] = 260,
  [1377] = 233,
  [1378] = 234,
  [1379] = 235,
  [1380] = 234,
  [1381] = 235,
  [1382] = 234,
  [1383] = 235,
  [1384] = 234,
  [1385] = 235,
  [1386] = 237,
  [1387] = 238,
  [1388] = 239,
  [1389] = 240,
  [1390] = 241,
  [1391] = 242,
  [1392] = 245,
  [1393] = 252,
  [1394] = 253,
  [1395] = 254,
  [1396] = 255,
  [1397] = 256,
  [1398] = 319,
  [1399] = 238,
  [1400] = 260,
  [1401] = 233,
  [1402] = 234,
  [1403] = 235,
  [1404] = 317,
  [1405] = 262,
  [1406] = 257,
  [1407] = 255,
  [1408] = 233,
  [1409] = 256,
  [1410] = 261,
  [1411] = 242,
  [1412] = 237,
  [1413] = 317,
  [1414] = 262,
  [1415] = 245,
  [1416] = 238,
  [1417] = 237,
  [1418] = 241,
  [1419] = 235,
  [1420] = 240,
  [1421] = 241,
  [1422] = 242,
  [1423] = 315,
  [1424] = 239,
  [1425] = 262,
  [1426] = 252,
  [1427] = 253,
  [1428] = 317,
  [1429] = 254,
  [1430] = 262,
  [1431] = 343,
  [1432] = 245,
  [1433] = 255,
  [1434] = 240,
  [1435] = 256,
  [1436] = 315,
  [1437] = 234,
  [1438] = 257,
  [1439] = 262,
  [1440] = 252,
  [1441] = 253,
  [1442] = 260,
  [1443] = 261,
  [1444] = 254,
  [1445] = 239,
  [1446] = 325,
  [1447] = 458,
  [1448] = 293,
  [1449] = 294,
  [1450] = 295,
  [1451] = 298,
  [1452] = 299,
  [1453] = 342,
  [1454] = 302,
  [1455] = 304,
  [1456] = 305,
  [1457] = 307,
  [1458] = 310,
  [1459] = 311,
  [1460] = 313,
  [1461] = 314,
  [1462] = 316,
  [1463] = 318,
  [1464] = 319,
  [1465] = 321,
  [1466] = 322,
  [1467] = 459,
  [1468] = 323,
  [1469] = 324,
  [1470] = 325,
  [1471] = 326,
  [1472] = 442,
  [1473] = 1473,
  [1474] = 313,
  [1475] = 314,
  [1476] = 316,
  [1477] = 317,
  [1478] = 318,
  [1479] = 319,
  [1480] = 321,
  [1481] = 234,
  [1482] = 260,
  [1483] = 322,
  [1484] = 235,
  [1485] = 233,
  [1486] = 490,
  [1487] = 491,
  [1488] = 492,
  [1489] = 260,
  [1490] = 460,
  [1491] = 461,
  [1492] = 462,
  [1493] = 463,
  [1494] = 465,
  [1495] = 443,
  [1496] = 1496,
  [1497] = 323,
  [1498] = 466,
  [1499] = 324,
  [1500] = 467,
  [1501] = 468,
  [1502] = 469,
  [1503] = 470,
  [1504] = 471,
  [1505] = 472,
  [1506] = 257,
  [1507] = 473,
  [1508] = 474,
  [1509] = 475,
  [1510] = 476,
  [1511] = 478,
  [1512] = 479,
  [1513] = 282,
  [1514] = 283,
  [1515] = 1515,
  [1516] = 326,
  [1517] = 293,
  [1518] = 294,
  [1519] = 295,
  [1520] = 234,
  [1521] = 235,
  [1522] = 261,
  [1523] = 262,
  [1524] = 282,
  [1525] = 283,
  [1526] = 299,
  [1527] = 1527,
  [1528] = 282,
  [1529] = 283,
  [1530] = 368,
  [1531] = 255,
  [1532] = 233,
  [1533] = 1527,
  [1534] = 235,
  [1535] = 293,
  [1536] = 294,
  [1537] = 304,
  [1538] = 295,
  [1539] = 298,
  [1540] = 1473,
  [1541] = 1496,
  [1542] = 299,
  [1543] = 293,
  [1544] = 294,
  [1545] = 295,
  [1546] = 342,
  [1547] = 298,
  [1548] = 305,
  [1549] = 307,
  [1550] = 299,
  [1551] = 342,
  [1552] = 302,
  [1553] = 310,
  [1554] = 311,
  [1555] = 304,
  [1556] = 445,
  [1557] = 313,
  [1558] = 316,
  [1559] = 1473,
  [1560] = 318,
  [1561] = 319,
  [1562] = 321,
  [1563] = 322,
  [1564] = 1496,
  [1565] = 305,
  [1566] = 302,
  [1567] = 307,
  [1568] = 310,
  [1569] = 311,
  [1570] = 313,
  [1571] = 314,
  [1572] = 316,
  [1573] = 304,
  [1574] = 318,
  [1575] = 319,
  [1576] = 321,
  [1577] = 322,
  [1578] = 1473,
  [1579] = 323,
  [1580] = 324,
  [1581] = 260,
  [1582] = 326,
  [1583] = 455,
  [1584] = 234,
  [1585] = 456,
  [1586] = 252,
  [1587] = 253,
  [1588] = 323,
  [1589] = 324,
  [1590] = 325,
  [1591] = 326,
  [1592] = 1496,
  [1593] = 235,
  [1594] = 486,
  [1595] = 254,
  [1596] = 305,
  [1597] = 293,
  [1598] = 234,
  [1599] = 294,
  [1600] = 235,
  [1601] = 295,
  [1602] = 298,
  [1603] = 299,
  [1604] = 342,
  [1605] = 302,
  [1606] = 234,
  [1607] = 235,
  [1608] = 315,
  [1609] = 304,
  [1610] = 1473,
  [1611] = 1496,
  [1612] = 305,
  [1613] = 307,
  [1614] = 307,
  [1615] = 252,
  [1616] = 253,
  [1617] = 310,
  [1618] = 254,
  [1619] = 311,
  [1620] = 493,
  [1621] = 1527,
  [1622] = 313,
  [1623] = 1515,
  [1624] = 255,
  [1625] = 1473,
  [1626] = 1496,
  [1627] = 1515,
  [1628] = 1527,
  [1629] = 314,
  [1630] = 256,
  [1631] = 298,
  [1632] = 1515,
  [1633] = 1473,
  [1634] = 1496,
  [1635] = 342,
  [1636] = 302,
  [1637] = 1473,
  [1638] = 1496,
  [1639] = 1527,
  [1640] = 314,
  [1641] = 1515,
  [1642] = 1473,
  [1643] = 1496,
  [1644] = 1527,
  [1645] = 1515,
  [1646] = 1473,
  [1647] = 1496,
  [1648] = 1527,
  [1649] = 233,
  [1650] = 1515,
  [1651] = 1473,
  [1652] = 1496,
  [1653] = 494,
  [1654] = 496,
  [1655] = 1527,
  [1656] = 282,
  [1657] = 283,
  [1658] = 497,
  [1659] = 316,
  [1660] = 1660,
  [1661] = 1515,
  [1662] = 317,
  [1663] = 318,
  [1664] = 1473,
  [1665] = 1496,
  [1666] = 319,
  [1667] = 321,
  [1668] = 322,
  [1669] = 310,
  [1670] = 323,
  [1671] = 1527,
  [1672] = 498,
  [1673] = 234,
  [1674] = 260,
  [1675] = 499,
  [1676] = 500,
  [1677] = 501,
  [1678] = 1515,
  [1679] = 1515,
  [1680] = 1473,
  [1681] = 1496,
  [1682] = 1527,
  [1683] = 324,
  [1684] = 325,
  [1685] = 326,
  [1686] = 235,
  [1687] = 233,
  [1688] = 1515,
  [1689] = 502,
  [1690] = 1473,
  [1691] = 1496,
  [1692] = 1527,
  [1693] = 1515,
  [1694] = 1473,
  [1695] = 1496,
  [1696] = 1527,
  [1697] = 1473,
  [1698] = 1496,
  [1699] = 257,
  [1700] = 1515,
  [1701] = 1527,
  [1702] = 1515,
  [1703] = 1527,
  [1704] = 1515,
  [1705] = 1527,
  [1706] = 1515,
  [1707] = 1527,
  [1708] = 282,
  [1709] = 283,
  [1710] = 1515,
  [1711] = 1711,
  [1712] = 252,
  [1713] = 253,
  [1714] = 254,
  [1715] = 1527,
  [1716] = 1515,
  [1717] = 1527,
  [1718] = 1718,
  [1719] = 315,
  [1720] = 255,
  [1721] = 261,
  [1722] = 1722,
  [1723] = 256,
  [1724] = 1473,
  [1725] = 1496,
  [1726] = 262,
  [1727] = 457,
  [1728] = 234,
  [1729] = 256,
  [1730] = 235,
  [1731] = 454,
  [1732] = 1473,
  [1733] = 1496,
  [1734] = 311,
  [1735] = 325,
  [1736] = 234,
  [1737] = 294,
  [1738] = 499,
  [1739] = 500,
  [1740] = 501,
  [1741] = 261,
  [1742] = 262,
  [1743] = 502,
  [1744] = 315,
  [1745] = 282,
  [1746] = 283,
  [1747] = 1747,
  [1748] = 260,
  [1749] = 233,
  [1750] = 234,
  [1751] = 235,
  [1752] = 1752,
  [1753] = 282,
  [1754] = 283,
  [1755] = 454,
  [1756] = 234,
  [1757] = 455,
  [1758] = 456,
  [1759] = 442,
  [1760] = 235,
  [1761] = 457,
  [1762] = 458,
  [1763] = 459,
  [1764] = 460,
  [1765] = 461,
  [1766] = 462,
  [1767] = 463,
  [1768] = 465,
  [1769] = 466,
  [1770] = 467,
  [1771] = 468,
  [1772] = 469,
  [1773] = 470,
  [1774] = 471,
  [1775] = 472,
  [1776] = 473,
  [1777] = 368,
  [1778] = 474,
  [1779] = 475,
  [1780] = 476,
  [1781] = 478,
  [1782] = 479,
  [1783] = 486,
  [1784] = 490,
  [1785] = 443,
  [1786] = 293,
  [1787] = 343,
  [1788] = 294,
  [1789] = 295,
  [1790] = 298,
  [1791] = 299,
  [1792] = 342,
  [1793] = 315,
  [1794] = 304,
  [1795] = 305,
  [1796] = 307,
  [1797] = 310,
  [1798] = 311,
  [1799] = 313,
  [1800] = 314,
  [1801] = 316,
  [1802] = 317,
  [1803] = 318,
  [1804] = 319,
  [1805] = 321,
  [1806] = 322,
  [1807] = 491,
  [1808] = 323,
  [1809] = 324,
  [1810] = 325,
  [1811] = 261,
  [1812] = 326,
  [1813] = 262,
  [1814] = 492,
  [1815] = 343,
  [1816] = 445,
  [1817] = 493,
  [1818] = 494,
  [1819] = 293,
  [1820] = 295,
  [1821] = 1821,
  [1822] = 1822,
  [1823] = 299,
  [1824] = 304,
  [1825] = 496,
  [1826] = 305,
  [1827] = 307,
  [1828] = 310,
  [1829] = 311,
  [1830] = 313,
  [1831] = 316,
  [1832] = 317,
  [1833] = 318,
  [1834] = 319,
  [1835] = 321,
  [1836] = 322,
  [1837] = 497,
  [1838] = 323,
  [1839] = 324,
  [1840] = 325,
  [1841] = 326,
  [1842] = 446,
  [1843] = 298,
  [1844] = 342,
  [1845] = 302,
  [1846] = 498,
  [1847] = 314,
  [1848] = 302,
  [1849] = 293,
  [1850] = 307,
  [1851] = 1711,
  [1852] = 310,
  [1853] = 368,
  [1854] = 343,
  [1855] = 1855,
  [1856] = 1855,
  [1857] = 293,
  [1858] = 294,
  [1859] = 295,
  [1860] = 1722,
  [1861] = 1660,
  [1862] = 1855,
  [1863] = 299,
  [1864] = 304,
  [1865] = 305,
  [1866] = 1711,
  [1867] = 307,
  [1868] = 310,
  [1869] = 311,
  [1870] = 1855,
  [1871] = 313,
  [1872] = 316,
  [1873] = 317,
  [1874] = 318,
  [1875] = 319,
  [1876] = 321,
  [1877] = 322,
  [1878] = 1660,
  [1879] = 323,
  [1880] = 324,
  [1881] = 325,
  [1882] = 326,
  [1883] = 234,
  [1884] = 235,
  [1885] = 343,
  [1886] = 1855,
  [1887] = 1722,
  [1888] = 235,
  [1889] = 446,
  [1890] = 323,
  [1891] = 1855,
  [1892] = 324,
  [1893] = 305,
  [1894] = 298,
  [1895] = 1718,
  [1896] = 342,
  [1897] = 302,
  [1898] = 325,
  [1899] = 1718,
  [1900] = 1711,
  [1901] = 326,
  [1902] = 1902,
  [1903] = 282,
  [1904] = 1855,
  [1905] = 314,
  [1906] = 283,
  [1907] = 1722,
  [1908] = 368,
  [1909] = 311,
  [1910] = 1660,
  [1911] = 1855,
  [1912] = 313,
  [1913] = 314,
  [1914] = 316,
  [1915] = 234,
  [1916] = 317,
  [1917] = 304,
  [1918] = 294,
  [1919] = 318,
  [1920] = 295,
  [1921] = 1855,
  [1922] = 319,
  [1923] = 1855,
  [1924] = 321,
  [1925] = 1718,
  [1926] = 298,
  [1927] = 299,
  [1928] = 1855,
  [1929] = 342,
  [1930] = 282,
  [1931] = 283,
  [1932] = 322,
  [1933] = 302,
  [1934] = 1855,
  [1935] = 501,
  [1936] = 1747,
  [1937] = 1937,
  [1938] = 1938,
  [1939] = 1939,
  [1940] = 457,
  [1941] = 1941,
  [1942] = 458,
  [1943] = 459,
  [1944] = 493,
  [1945] = 494,
  [1946] = 460,
  [1947] = 461,
  [1948] = 496,
  [1949] = 497,
  [1950] = 498,
  [1951] = 499,
  [1952] = 500,
  [1953] = 343,
  [1954] = 462,
  [1955] = 1821,
  [1956] = 502,
  [1957] = 1822,
  [1958] = 465,
  [1959] = 1752,
  [1960] = 1960,
  [1961] = 1821,
  [1962] = 1822,
  [1963] = 1963,
  [1964] = 463,
  [1965] = 1965,
  [1966] = 1966,
  [1967] = 465,
  [1968] = 466,
  [1969] = 1969,
  [1970] = 1970,
  [1971] = 467,
  [1972] = 468,
  [1973] = 469,
  [1974] = 466,
  [1975] = 470,
  [1976] = 1976,
  [1977] = 1977,
  [1978] = 1978,
  [1979] = 1979,
  [1980] = 1980,
  [1981] = 1981,
  [1982] = 1982,
  [1983] = 471,
  [1984] = 1984,
  [1985] = 1985,
  [1986] = 260,
  [1987] = 467,
  [1988] = 458,
  [1989] = 472,
  [1990] = 468,
  [1991] = 1991,
  [1992] = 1992,
  [1993] = 1993,
  [1994] = 473,
  [1995] = 1995,
  [1996] = 442,
  [1997] = 1997,
  [1998] = 1998,
  [1999] = 474,
  [2000] = 2000,
  [2001] = 443,
  [2002] = 475,
  [2003] = 2003,
  [2004] = 2004,
  [2005] = 2005,
  [2006] = 476,
  [2007] = 2007,
  [2008] = 2008,
  [2009] = 445,
  [2010] = 486,
  [2011] = 479,
  [2012] = 469,
  [2013] = 368,
  [2014] = 456,
  [2015] = 2015,
  [2016] = 1821,
  [2017] = 1822,
  [2018] = 470,
  [2019] = 479,
  [2020] = 2020,
  [2021] = 457,
  [2022] = 490,
  [2023] = 491,
  [2024] = 492,
  [2025] = 455,
  [2026] = 2026,
  [2027] = 471,
  [2028] = 493,
  [2029] = 494,
  [2030] = 496,
  [2031] = 497,
  [2032] = 498,
  [2033] = 499,
  [2034] = 500,
  [2035] = 501,
  [2036] = 460,
  [2037] = 472,
  [2038] = 502,
  [2039] = 1747,
  [2040] = 473,
  [2041] = 2041,
  [2042] = 461,
  [2043] = 462,
  [2044] = 474,
  [2045] = 454,
  [2046] = 475,
  [2047] = 445,
  [2048] = 486,
  [2049] = 1752,
  [2050] = 463,
  [2051] = 455,
  [2052] = 456,
  [2053] = 446,
  [2054] = 2054,
  [2055] = 476,
  [2056] = 454,
  [2057] = 457,
  [2058] = 458,
  [2059] = 459,
  [2060] = 442,
  [2061] = 460,
  [2062] = 461,
  [2063] = 462,
  [2064] = 463,
  [2065] = 465,
  [2066] = 443,
  [2067] = 466,
  [2068] = 467,
  [2069] = 468,
  [2070] = 469,
  [2071] = 470,
  [2072] = 471,
  [2073] = 472,
  [2074] = 473,
  [2075] = 474,
  [2076] = 475,
  [2077] = 476,
  [2078] = 478,
  [2079] = 479,
  [2080] = 478,
  [2081] = 260,
  [2082] = 454,
  [2083] = 1747,
  [2084] = 233,
  [2085] = 2085,
  [2086] = 1752,
  [2087] = 2087,
  [2088] = 233,
  [2089] = 455,
  [2090] = 490,
  [2091] = 491,
  [2092] = 492,
  [2093] = 456,
  [2094] = 459,
  [2095] = 343,
  [2096] = 446,
  [2097] = 478,
  [2098] = 455,
  [2099] = 460,
  [2100] = 461,
  [2101] = 462,
  [2102] = 463,
  [2103] = 465,
  [2104] = 476,
  [2105] = 501,
  [2106] = 2106,
  [2107] = 462,
  [2108] = 445,
  [2109] = 2106,
  [2110] = 478,
  [2111] = 479,
  [2112] = 466,
  [2113] = 467,
  [2114] = 468,
  [2115] = 469,
  [2116] = 502,
  [2117] = 490,
  [2118] = 2106,
  [2119] = 501,
  [2120] = 475,
  [2121] = 455,
  [2122] = 469,
  [2123] = 470,
  [2124] = 456,
  [2125] = 471,
  [2126] = 457,
  [2127] = 260,
  [2128] = 472,
  [2129] = 502,
  [2130] = 2106,
  [2131] = 490,
  [2132] = 486,
  [2133] = 491,
  [2134] = 473,
  [2135] = 474,
  [2136] = 475,
  [2137] = 476,
  [2138] = 492,
  [2139] = 2139,
  [2140] = 260,
  [2141] = 463,
  [2142] = 478,
  [2143] = 494,
  [2144] = 479,
  [2145] = 499,
  [2146] = 498,
  [2147] = 498,
  [2148] = 470,
  [2149] = 454,
  [2150] = 454,
  [2151] = 233,
  [2152] = 1902,
  [2153] = 471,
  [2154] = 465,
  [2155] = 466,
  [2156] = 442,
  [2157] = 472,
  [2158] = 496,
  [2159] = 461,
  [2160] = 442,
  [2161] = 491,
  [2162] = 492,
  [2163] = 443,
  [2164] = 497,
  [2165] = 467,
  [2166] = 445,
  [2167] = 468,
  [2168] = 493,
  [2169] = 458,
  [2170] = 457,
  [2171] = 499,
  [2172] = 458,
  [2173] = 494,
  [2174] = 500,
  [2175] = 459,
  [2176] = 496,
  [2177] = 2177,
  [2178] = 460,
  [2179] = 446,
  [2180] = 1902,
  [2181] = 473,
  [2182] = 443,
  [2183] = 1902,
  [2184] = 497,
  [2185] = 459,
  [2186] = 474,
  [2187] = 493,
  [2188] = 486,
  [2189] = 233,
  [2190] = 500,
  [2191] = 456,
  [2192] = 496,
  [2193] = 462,
  [2194] = 463,
  [2195] = 465,
  [2196] = 443,
  [2197] = 2003,
  [2198] = 2004,
  [2199] = 466,
  [2200] = 467,
  [2201] = 468,
  [2202] = 469,
  [2203] = 2005,
  [2204] = 470,
  [2205] = 471,
  [2206] = 472,
  [2207] = 2007,
  [2208] = 473,
  [2209] = 474,
  [2210] = 475,
  [2211] = 476,
  [2212] = 2008,
  [2213] = 478,
  [2214] = 479,
  [2215] = 2020,
  [2216] = 2026,
  [2217] = 2041,
  [2218] = 1979,
  [2219] = 2003,
  [2220] = 2220,
  [2221] = 2004,
  [2222] = 2222,
  [2223] = 227,
  [2224] = 1980,
  [2225] = 1981,
  [2226] = 2054,
  [2227] = 2005,
  [2228] = 443,
  [2229] = 2229,
  [2230] = 1982,
  [2231] = 2231,
  [2232] = 2007,
  [2233] = 2233,
  [2234] = 2026,
  [2235] = 1937,
  [2236] = 1938,
  [2237] = 1939,
  [2238] = 1941,
  [2239] = 502,
  [2240] = 2229,
  [2241] = 2233,
  [2242] = 2231,
  [2243] = 454,
  [2244] = 1960,
  [2245] = 2233,
  [2246] = 493,
  [2247] = 2008,
  [2248] = 1963,
  [2249] = 1965,
  [2250] = 1966,
  [2251] = 1969,
  [2252] = 1970,
  [2253] = 454,
  [2254] = 2020,
  [2255] = 2026,
  [2256] = 2229,
  [2257] = 1976,
  [2258] = 1977,
  [2259] = 2231,
  [2260] = 1978,
  [2261] = 1979,
  [2262] = 1980,
  [2263] = 1981,
  [2264] = 2041,
  [2265] = 1982,
  [2266] = 1984,
  [2267] = 1985,
  [2268] = 455,
  [2269] = 2233,
  [2270] = 456,
  [2271] = 2271,
  [2272] = 1991,
  [2273] = 1992,
  [2274] = 1993,
  [2275] = 1995,
  [2276] = 457,
  [2277] = 2229,
  [2278] = 458,
  [2279] = 459,
  [2280] = 2231,
  [2281] = 445,
  [2282] = 486,
  [2283] = 2041,
  [2284] = 1997,
  [2285] = 2233,
  [2286] = 1998,
  [2287] = 2000,
  [2288] = 460,
  [2289] = 461,
  [2290] = 462,
  [2291] = 463,
  [2292] = 465,
  [2293] = 2003,
  [2294] = 2004,
  [2295] = 466,
  [2296] = 467,
  [2297] = 468,
  [2298] = 469,
  [2299] = 2229,
  [2300] = 2231,
  [2301] = 2005,
  [2302] = 470,
  [2303] = 471,
  [2304] = 472,
  [2305] = 2007,
  [2306] = 473,
  [2307] = 2233,
  [2308] = 474,
  [2309] = 475,
  [2310] = 476,
  [2311] = 2008,
  [2312] = 478,
  [2313] = 479,
  [2314] = 1991,
  [2315] = 2054,
  [2316] = 2229,
  [2317] = 2231,
  [2318] = 1992,
  [2319] = 260,
  [2320] = 1937,
  [2321] = 2233,
  [2322] = 1993,
  [2323] = 233,
  [2324] = 1938,
  [2325] = 1995,
  [2326] = 490,
  [2327] = 491,
  [2328] = 2229,
  [2329] = 492,
  [2330] = 2231,
  [2331] = 260,
  [2332] = 2020,
  [2333] = 2233,
  [2334] = 1939,
  [2335] = 2231,
  [2336] = 494,
  [2337] = 2229,
  [2338] = 2231,
  [2339] = 1937,
  [2340] = 1938,
  [2341] = 2233,
  [2342] = 2229,
  [2343] = 2231,
  [2344] = 1939,
  [2345] = 1941,
  [2346] = 2233,
  [2347] = 493,
  [2348] = 233,
  [2349] = 455,
  [2350] = 494,
  [2351] = 496,
  [2352] = 497,
  [2353] = 498,
  [2354] = 499,
  [2355] = 500,
  [2356] = 501,
  [2357] = 2229,
  [2358] = 456,
  [2359] = 2231,
  [2360] = 442,
  [2361] = 502,
  [2362] = 497,
  [2363] = 2233,
  [2364] = 1960,
  [2365] = 498,
  [2366] = 499,
  [2367] = 1963,
  [2368] = 1965,
  [2369] = 2229,
  [2370] = 1966,
  [2371] = 2231,
  [2372] = 461,
  [2373] = 458,
  [2374] = 454,
  [2375] = 459,
  [2376] = 2233,
  [2377] = 460,
  [2378] = 461,
  [2379] = 455,
  [2380] = 456,
  [2381] = 2229,
  [2382] = 2231,
  [2383] = 462,
  [2384] = 463,
  [2385] = 465,
  [2386] = 466,
  [2387] = 467,
  [2388] = 2233,
  [2389] = 1969,
  [2390] = 468,
  [2391] = 469,
  [2392] = 457,
  [2393] = 458,
  [2394] = 459,
  [2395] = 470,
  [2396] = 471,
  [2397] = 472,
  [2398] = 473,
  [2399] = 474,
  [2400] = 460,
  [2401] = 461,
  [2402] = 462,
  [2403] = 463,
  [2404] = 465,
  [2405] = 475,
  [2406] = 466,
  [2407] = 2233,
  [2408] = 467,
  [2409] = 468,
  [2410] = 469,
  [2411] = 476,
  [2412] = 470,
  [2413] = 471,
  [2414] = 472,
  [2415] = 473,
  [2416] = 474,
  [2417] = 475,
  [2418] = 476,
  [2419] = 478,
  [2420] = 479,
  [2421] = 460,
  [2422] = 2422,
  [2423] = 478,
  [2424] = 479,
  [2425] = 2233,
  [2426] = 1960,
  [2427] = 1984,
  [2428] = 1985,
  [2429] = 1963,
  [2430] = 2233,
  [2431] = 1965,
  [2432] = 2432,
  [2433] = 1966,
  [2434] = 1970,
  [2435] = 2233,
  [2436] = 1941,
  [2437] = 2233,
  [2438] = 454,
  [2439] = 2054,
  [2440] = 500,
  [2441] = 2441,
  [2442] = 2442,
  [2443] = 2443,
  [2444] = 1969,
  [2445] = 2220,
  [2446] = 2441,
  [2447] = 2442,
  [2448] = 501,
  [2449] = 1976,
  [2450] = 2220,
  [2451] = 2441,
  [2452] = 2442,
  [2453] = 2453,
  [2454] = 1976,
  [2455] = 1977,
  [2456] = 1978,
  [2457] = 1979,
  [2458] = 1980,
  [2459] = 2220,
  [2460] = 1981,
  [2461] = 1982,
  [2462] = 1977,
  [2463] = 1984,
  [2464] = 1985,
  [2465] = 455,
  [2466] = 456,
  [2467] = 1997,
  [2468] = 1998,
  [2469] = 2000,
  [2470] = 1991,
  [2471] = 1992,
  [2472] = 1993,
  [2473] = 1995,
  [2474] = 457,
  [2475] = 1978,
  [2476] = 1970,
  [2477] = 458,
  [2478] = 2441,
  [2479] = 225,
  [2480] = 459,
  [2481] = 454,
  [2482] = 442,
  [2483] = 455,
  [2484] = 456,
  [2485] = 457,
  [2486] = 458,
  [2487] = 459,
  [2488] = 2442,
  [2489] = 460,
  [2490] = 461,
  [2491] = 462,
  [2492] = 463,
  [2493] = 465,
  [2494] = 466,
  [2495] = 467,
  [2496] = 468,
  [2497] = 469,
  [2498] = 470,
  [2499] = 471,
  [2500] = 472,
  [2501] = 473,
  [2502] = 474,
  [2503] = 2453,
  [2504] = 475,
  [2505] = 476,
  [2506] = 478,
  [2507] = 479,
  [2508] = 2453,
  [2509] = 445,
  [2510] = 486,
  [2511] = 2453,
  [2512] = 2453,
  [2513] = 2453,
  [2514] = 2453,
  [2515] = 2453,
  [2516] = 2453,
  [2517] = 2453,
  [2518] = 2453,
  [2519] = 2453,
  [2520] = 1997,
  [2521] = 2432,
  [2522] = 2432,
  [2523] = 2432,
  [2524] = 2229,
  [2525] = 1998,
  [2526] = 490,
  [2527] = 491,
  [2528] = 492,
  [2529] = 2000,
  [2530] = 457,
  [2531] = 2139,
  [2532] = 2139,
  [2533] = 2139,
  [2534] = 2534,
  [2535] = 237,
  [2536] = 242,
  [2537] = 2534,
  [2538] = 245,
  [2539] = 2534,
  [2540] = 240,
  [2541] = 238,
  [2542] = 239,
  [2543] = 2534,
  [2544] = 2544,
  [2545] = 2545,
  [2546] = 2546,
  [2547] = 2547,
  [2548] = 2548,
  [2549] = 2549,
  [2550] = 2550,
  [2551] = 2548,
  [2552] = 2550,
  [2553] = 2548,
  [2554] = 2548,
  [2555] = 2550,
  [2556] = 2550,
  [2557] = 2550,
  [2558] = 2550,
  [2559] = 2559,
  [2560] = 2548,
  [2561] = 2548,
  [2562] = 2548,
  [2563] = 2550,
  [2564] = 2564,
  [2565] = 2548,
  [2566] = 2550,
  [2567] = 2550,
  [2568] = 2548,
  [2569] = 2548,
  [2570] = 2550,
  [2571] = 2550,
  [2572] = 2548,
  [2573] = 2548,
  [2574] = 2550,
  [2575] = 257,
  [2576] = 2576,
  [2577] = 2577,
  [2578] = 2577,
  [2579] = 2579,
  [2580] = 2577,
  [2581] = 2579,
  [2582] = 2579,
  [2583] = 2577,
  [2584] = 2577,
  [2585] = 2579,
  [2586] = 2579,
  [2587] = 2577,
  [2588] = 2579,
  [2589] = 2577,
  [2590] = 2590,
  [2591] = 2579,
  [2592] = 2577,
  [2593] = 2579,
  [2594] = 2577,
  [2595] = 2579,
  [2596] = 2577,
  [2597] = 2579,
  [2598] = 2577,
  [2599] = 2579,
  [2600] = 2577,
  [2601] = 2579,
  [2602] = 2577,
  [2603] = 2579,
  [2604] = 2577,
  [2605] = 2579,
  [2606] = 2577,
  [2607] = 2579,
  [2608] = 2577,
  [2609] = 2579,
  [2610] = 2577,
  [2611] = 2579,
  [2612] = 2577,
  [2613] = 2579,
  [2614] = 2577,
  [2615] = 2579,
  [2616] = 2577,
  [2617] = 2579,
  [2618] = 2577,
  [2619] = 2579,
  [2620] = 2577,
  [2621] = 2579,
  [2622] = 2577,
  [2623] = 2579,
  [2624] = 2577,
  [2625] = 2579,
  [2626] = 2577,
  [2627] = 2579,
  [2628] = 2577,
  [2629] = 2579,
  [2630] = 2577,
  [2631] = 2579,
  [2632] = 2579,
  [2633] = 2579,
  [2634] = 2579,
  [2635] = 2577,
  [2636] = 2577,
  [2637] = 2577,
  [2638] = 2579,
  [2639] = 2579,
  [2640] = 2577,
  [2641] = 2577,
  [2642] = 2642,
  [2643] = 2579,
  [2644] = 2579,
  [2645] = 261,
  [2646] = 2577,
  [2647] = 2577,
  [2648] = 2577,
  [2649] = 2649,
  [2650] = 2579,
  [2651] = 2651,
  [2652] = 298,
  [2653] = 2653,
  [2654] = 262,
  [2655] = 317,
  [2656] = 322,
  [2657] = 325,
  [2658] = 234,
  [2659] = 2659,
  [2660] = 302,
  [2661] = 311,
  [2662] = 235,
  [2663] = 257,
  [2664] = 293,
  [2665] = 294,
  [2666] = 295,
  [2667] = 2667,
  [2668] = 299,
  [2669] = 304,
  [2670] = 305,
  [2671] = 307,
  [2672] = 310,
  [2673] = 2673,
  [2674] = 313,
  [2675] = 316,
  [2676] = 318,
  [2677] = 319,
  [2678] = 321,
  [2679] = 2679,
  [2680] = 323,
  [2681] = 324,
  [2682] = 326,
  [2683] = 314,
  [2684] = 2684,
  [2685] = 342,
  [2686] = 282,
  [2687] = 283,
  [2688] = 2688,
  [2689] = 2689,
  [2690] = 261,
  [2691] = 228,
  [2692] = 2692,
  [2693] = 2693,
  [2694] = 2694,
  [2695] = 2693,
  [2696] = 2696,
  [2697] = 2696,
  [2698] = 2698,
  [2699] = 2699,
  [2700] = 2696,
  [2701] = 2693,
  [2702] = 2702,
  [2703] = 2693,
  [2704] = 2696,
  [2705] = 2696,
  [2706] = 2694,
  [2707] = 2694,
  [2708] = 2693,
  [2709] = 2693,
  [2710] = 2696,
  [2711] = 2711,
  [2712] = 2702,
  [2713] = 2696,
  [2714] = 2696,
  [2715] = 2696,
  [2716] = 2693,
  [2717] = 2693,
  [2718] = 2693,
  [2719] = 2693,
  [2720] = 2696,
  [2721] = 2721,
  [2722] = 2696,
  [2723] = 2693,
  [2724] = 2696,
  [2725] = 2696,
  [2726] = 2693,
  [2727] = 2696,
  [2728] = 2728,
  [2729] = 2693,
  [2730] = 2702,
  [2731] = 2693,
  [2732] = 2732,
  [2733] = 2693,
  [2734] = 2696,
  [2735] = 317,
  [2736] = 262,
  [2737] = 2702,
  [2738] = 2692,
  [2739] = 2694,
  [2740] = 2692,
  [2741] = 2693,
  [2742] = 2692,
  [2743] = 2696,
  [2744] = 2744,
  [2745] = 2745,
  [2746] = 2746,
  [2747] = 2747,
  [2748] = 2747,
  [2749] = 2749,
  [2750] = 313,
  [2751] = 2749,
  [2752] = 2752,
  [2753] = 304,
  [2754] = 241,
  [2755] = 234,
  [2756] = 316,
  [2757] = 1752,
  [2758] = 2749,
  [2759] = 2744,
  [2760] = 2760,
  [2761] = 2761,
  [2762] = 260,
  [2763] = 255,
  [2764] = 305,
  [2765] = 2760,
  [2766] = 2752,
  [2767] = 2760,
  [2768] = 2747,
  [2769] = 235,
  [2770] = 2749,
  [2771] = 323,
  [2772] = 2747,
  [2773] = 2747,
  [2774] = 2749,
  [2775] = 2747,
  [2776] = 2747,
  [2777] = 324,
  [2778] = 2749,
  [2779] = 2749,
  [2780] = 2747,
  [2781] = 2781,
  [2782] = 2747,
  [2783] = 2749,
  [2784] = 2781,
  [2785] = 2747,
  [2786] = 2749,
  [2787] = 2787,
  [2788] = 2749,
  [2789] = 2698,
  [2790] = 325,
  [2791] = 282,
  [2792] = 283,
  [2793] = 2747,
  [2794] = 2749,
  [2795] = 318,
  [2796] = 2747,
  [2797] = 2749,
  [2798] = 307,
  [2799] = 319,
  [2800] = 293,
  [2801] = 2752,
  [2802] = 321,
  [2803] = 322,
  [2804] = 2760,
  [2805] = 234,
  [2806] = 2747,
  [2807] = 294,
  [2808] = 298,
  [2809] = 295,
  [2810] = 2781,
  [2811] = 342,
  [2812] = 2812,
  [2813] = 2699,
  [2814] = 302,
  [2815] = 2781,
  [2816] = 2787,
  [2817] = 2752,
  [2818] = 2747,
  [2819] = 2749,
  [2820] = 2787,
  [2821] = 252,
  [2822] = 253,
  [2823] = 233,
  [2824] = 2747,
  [2825] = 2787,
  [2826] = 2749,
  [2827] = 2827,
  [2828] = 235,
  [2829] = 2711,
  [2830] = 256,
  [2831] = 326,
  [2832] = 254,
  [2833] = 2749,
  [2834] = 2747,
  [2835] = 2749,
  [2836] = 310,
  [2837] = 2837,
  [2838] = 311,
  [2839] = 314,
  [2840] = 2749,
  [2841] = 2841,
  [2842] = 1747,
  [2843] = 299,
  [2844] = 2747,
  [2845] = 2845,
  [2846] = 1747,
  [2847] = 2847,
  [2848] = 2848,
  [2849] = 2849,
  [2850] = 2845,
  [2851] = 2851,
  [2852] = 1752,
  [2853] = 2845,
  [2854] = 2845,
  [2855] = 2845,
  [2856] = 2845,
  [2857] = 2845,
  [2858] = 2845,
  [2859] = 2845,
  [2860] = 2845,
  [2861] = 2845,
  [2862] = 2845,
  [2863] = 2845,
  [2864] = 2845,
  [2865] = 2845,
  [2866] = 2845,
  [2867] = 2867,
  [2868] = 2868,
  [2869] = 1747,
  [2870] = 2867,
  [2871] = 2867,
  [2872] = 2867,
  [2873] = 2873,
  [2874] = 245,
  [2875] = 1752,
  [2876] = 2876,
  [2877] = 2867,
  [2878] = 2867,
  [2879] = 2879,
  [2880] = 2880,
  [2881] = 2867,
  [2882] = 2882,
  [2883] = 2883,
  [2884] = 2884,
  [2885] = 2885,
  [2886] = 2867,
  [2887] = 1752,
  [2888] = 2867,
  [2889] = 2889,
  [2890] = 2868,
  [2891] = 2891,
  [2892] = 1711,
  [2893] = 2893,
  [2894] = 2867,
  [2895] = 1747,
  [2896] = 2896,
  [2897] = 2867,
  [2898] = 2898,
  [2899] = 2899,
  [2900] = 2867,
  [2901] = 2901,
  [2902] = 2902,
  [2903] = 2903,
  [2904] = 2868,
  [2905] = 2868,
  [2906] = 2893,
  [2907] = 2893,
  [2908] = 2893,
  [2909] = 2909,
  [2910] = 1722,
  [2911] = 2911,
  [2912] = 2912,
  [2913] = 2913,
  [2914] = 2914,
  [2915] = 2915,
  [2916] = 1821,
  [2917] = 2917,
  [2918] = 2912,
  [2919] = 2911,
  [2920] = 2912,
  [2921] = 2921,
  [2922] = 2911,
  [2923] = 2911,
  [2924] = 2924,
  [2925] = 2925,
  [2926] = 2912,
  [2927] = 2927,
  [2928] = 2928,
  [2929] = 2929,
  [2930] = 2912,
  [2931] = 2911,
  [2932] = 2911,
  [2933] = 2933,
  [2934] = 2934,
  [2935] = 2928,
  [2936] = 2936,
  [2937] = 2937,
  [2938] = 2938,
  [2939] = 2939,
  [2940] = 2937,
  [2941] = 2937,
  [2942] = 2911,
  [2943] = 2911,
  [2944] = 2939,
  [2945] = 2945,
  [2946] = 2912,
  [2947] = 2947,
  [2948] = 2948,
  [2949] = 2949,
  [2950] = 2950,
  [2951] = 2951,
  [2952] = 2952,
  [2953] = 2953,
  [2954] = 2954,
  [2955] = 2955,
  [2956] = 1747,
  [2957] = 2957,
  [2958] = 2958,
  [2959] = 2911,
  [2960] = 2912,
  [2961] = 2913,
  [2962] = 2962,
  [2963] = 2963,
  [2964] = 2939,
  [2965] = 2965,
  [2966] = 2948,
  [2967] = 2949,
  [2968] = 2968,
  [2969] = 2969,
  [2970] = 1752,
  [2971] = 2971,
  [2972] = 2950,
  [2973] = 2973,
  [2974] = 2974,
  [2975] = 2912,
  [2976] = 2976,
  [2977] = 2977,
  [2978] = 2913,
  [2979] = 2951,
  [2980] = 2911,
  [2981] = 2912,
  [2982] = 2911,
  [2983] = 2948,
  [2984] = 2911,
  [2985] = 2985,
  [2986] = 2986,
  [2987] = 2987,
  [2988] = 2988,
  [2989] = 2911,
  [2990] = 2911,
  [2991] = 2991,
  [2992] = 2992,
  [2993] = 2993,
  [2994] = 2949,
  [2995] = 2995,
  [2996] = 2996,
  [2997] = 2997,
  [2998] = 2998,
  [2999] = 2999,
  [3000] = 2950,
  [3001] = 2951,
  [3002] = 3002,
  [3003] = 2912,
  [3004] = 3004,
  [3005] = 3005,
  [3006] = 3006,
  [3007] = 3007,
  [3008] = 3008,
  [3009] = 2911,
  [3010] = 2928,
  [3011] = 2912,
  [3012] = 1718,
  [3013] = 3013,
  [3014] = 3014,
  [3015] = 3015,
  [3016] = 3016,
  [3017] = 2911,
  [3018] = 2937,
  [3019] = 3019,
  [3020] = 2939,
  [3021] = 3021,
  [3022] = 2913,
  [3023] = 3023,
  [3024] = 3024,
  [3025] = 2911,
  [3026] = 2928,
  [3027] = 2912,
  [3028] = 3028,
  [3029] = 3029,
  [3030] = 2948,
  [3031] = 2949,
  [3032] = 2950,
  [3033] = 3033,
  [3034] = 2951,
  [3035] = 2987,
  [3036] = 2987,
  [3037] = 2987,
  [3038] = 2911,
  [3039] = 3039,
  [3040] = 3040,
  [3041] = 3041,
  [3042] = 3042,
  [3043] = 3043,
  [3044] = 3042,
  [3045] = 3045,
  [3046] = 3046,
  [3047] = 3042,
  [3048] = 3046,
  [3049] = 3049,
  [3050] = 3050,
  [3051] = 3042,
  [3052] = 3046,
  [3053] = 3042,
  [3054] = 3046,
  [3055] = 2901,
  [3056] = 3056,
  [3057] = 3057,
  [3058] = 3058,
  [3059] = 3059,
  [3060] = 3060,
  [3061] = 3061,
  [3062] = 3062,
  [3063] = 3063,
  [3064] = 2901,
  [3065] = 2576,
  [3066] = 3042,
  [3067] = 3042,
  [3068] = 3046,
  [3069] = 3046,
  [3070] = 3042,
  [3071] = 3071,
  [3072] = 3042,
  [3073] = 3045,
  [3074] = 1822,
  [3075] = 3045,
  [3076] = 3076,
  [3077] = 3077,
  [3078] = 3042,
  [3079] = 3046,
  [3080] = 3042,
  [3081] = 3046,
  [3082] = 3046,
  [3083] = 3046,
  [3084] = 3046,
  [3085] = 3045,
  [3086] = 3042,
  [3087] = 3087,
  [3088] = 3046,
  [3089] = 3089,
  [3090] = 3042,
  [3091] = 3091,
  [3092] = 3092,
  [3093] = 3061,
  [3094] = 3094,
  [3095] = 3095,
  [3096] = 3096,
  [3097] = 3097,
  [3098] = 2901,
  [3099] = 3099,
  [3100] = 3046,
  [3101] = 3042,
  [3102] = 3042,
  [3103] = 3061,
  [3104] = 3104,
  [3105] = 3105,
  [3106] = 3106,
  [3107] = 3107,
  [3108] = 3046,
  [3109] = 3042,
  [3110] = 3110,
  [3111] = 3042,
  [3112] = 3042,
  [3113] = 3113,
  [3114] = 3114,
  [3115] = 3046,
  [3116] = 3046,
  [3117] = 3117,
  [3118] = 3118,
  [3119] = 3046,
  [3120] = 3045,
  [3121] = 3121,
  [3122] = 3046,
  [3123] = 445,
  [3124] = 3061,
  [3125] = 3125,
  [3126] = 3126,
  [3127] = 3127,
  [3128] = 3128,
  [3129] = 3125,
  [3130] = 3125,
  [3131] = 3131,
  [3132] = 3132,
  [3133] = 3133,
  [3134] = 3134,
  [3135] = 3135,
  [3136] = 3128,
  [3137] = 3137,
  [3138] = 3138,
  [3139] = 3139,
  [3140] = 3140,
  [3141] = 3141,
  [3142] = 3142,
  [3143] = 3143,
  [3144] = 3144,
  [3145] = 3145,
  [3146] = 3146,
  [3147] = 3147,
  [3148] = 3148,
  [3149] = 3131,
  [3150] = 3133,
  [3151] = 3151,
  [3152] = 3152,
  [3153] = 3135,
  [3154] = 3154,
  [3155] = 3155,
  [3156] = 3156,
  [3157] = 3138,
  [3158] = 3158,
  [3159] = 3128,
  [3160] = 3126,
  [3161] = 3127,
  [3162] = 3125,
  [3163] = 3138,
  [3164] = 3140,
  [3165] = 3133,
  [3166] = 3138,
  [3167] = 3139,
  [3168] = 3139,
  [3169] = 3147,
  [3170] = 3147,
  [3171] = 3148,
  [3172] = 3140,
  [3173] = 2958,
  [3174] = 3174,
  [3175] = 3152,
  [3176] = 3142,
  [3177] = 3177,
  [3178] = 3148,
  [3179] = 3156,
  [3180] = 3145,
  [3181] = 3135,
  [3182] = 3128,
  [3183] = 3142,
  [3184] = 3184,
  [3185] = 3151,
  [3186] = 3140,
  [3187] = 3147,
  [3188] = 3142,
  [3189] = 3148,
  [3190] = 3147,
  [3191] = 3145,
  [3192] = 3147,
  [3193] = 3146,
  [3194] = 3194,
  [3195] = 3131,
  [3196] = 3196,
  [3197] = 3151,
  [3198] = 3152,
  [3199] = 3199,
  [3200] = 3154,
  [3201] = 3155,
  [3202] = 3202,
  [3203] = 3131,
  [3204] = 3158,
  [3205] = 3152,
  [3206] = 3126,
  [3207] = 3127,
  [3208] = 3125,
  [3209] = 3145,
  [3210] = 3210,
  [3211] = 3133,
  [3212] = 3138,
  [3213] = 3139,
  [3214] = 3214,
  [3215] = 3151,
  [3216] = 3147,
  [3217] = 3148,
  [3218] = 3218,
  [3219] = 3219,
  [3220] = 3152,
  [3221] = 3128,
  [3222] = 3154,
  [3223] = 3155,
  [3224] = 3135,
  [3225] = 3225,
  [3226] = 3226,
  [3227] = 3135,
  [3228] = 3128,
  [3229] = 3128,
  [3230] = 3230,
  [3231] = 3142,
  [3232] = 3232,
  [3233] = 3233,
  [3234] = 3145,
  [3235] = 3158,
  [3236] = 3236,
  [3237] = 3151,
  [3238] = 3152,
  [3239] = 3125,
  [3240] = 3126,
  [3241] = 3134,
  [3242] = 3127,
  [3243] = 3135,
  [3244] = 3125,
  [3245] = 3245,
  [3246] = 3142,
  [3247] = 3140,
  [3248] = 3145,
  [3249] = 3249,
  [3250] = 3155,
  [3251] = 3151,
  [3252] = 3152,
  [3253] = 3125,
  [3254] = 3133,
  [3255] = 3138,
  [3256] = 3139,
  [3257] = 3135,
  [3258] = 3258,
  [3259] = 3259,
  [3260] = 3147,
  [3261] = 3135,
  [3262] = 3148,
  [3263] = 3131,
  [3264] = 3264,
  [3265] = 3135,
  [3266] = 3146,
  [3267] = 3142,
  [3268] = 3133,
  [3269] = 3135,
  [3270] = 3134,
  [3271] = 3019,
  [3272] = 3148,
  [3273] = 3135,
  [3274] = 3151,
  [3275] = 3145,
  [3276] = 3152,
  [3277] = 3135,
  [3278] = 3225,
  [3279] = 3245,
  [3280] = 3280,
  [3281] = 3135,
  [3282] = 3225,
  [3283] = 3141,
  [3284] = 3284,
  [3285] = 3135,
  [3286] = 3146,
  [3287] = 3154,
  [3288] = 3288,
  [3289] = 3135,
  [3290] = 3154,
  [3291] = 3155,
  [3292] = 3135,
  [3293] = 3135,
  [3294] = 3148,
  [3295] = 3131,
  [3296] = 3128,
  [3297] = 3135,
  [3298] = 3135,
  [3299] = 3143,
  [3300] = 3155,
  [3301] = 3140,
  [3302] = 3151,
  [3303] = 3152,
  [3304] = 3142,
  [3305] = 3128,
  [3306] = 3154,
  [3307] = 3145,
  [3308] = 3158,
  [3309] = 3155,
  [3310] = 3310,
  [3311] = 3126,
  [3312] = 3312,
  [3313] = 3133,
  [3314] = 3314,
  [3315] = 3131,
  [3316] = 3316,
  [3317] = 3127,
  [3318] = 3318,
  [3319] = 3125,
  [3320] = 3320,
  [3321] = 3321,
  [3322] = 3151,
  [3323] = 3323,
  [3324] = 3324,
  [3325] = 3158,
  [3326] = 3326,
  [3327] = 3327,
  [3328] = 3328,
  [3329] = 3329,
  [3330] = 3152,
  [3331] = 3210,
  [3332] = 3332,
  [3333] = 3333,
  [3334] = 3131,
  [3335] = 3196,
  [3336] = 3141,
  [3337] = 3126,
  [3338] = 3338,
  [3339] = 3339,
  [3340] = 3340,
  [3341] = 3154,
  [3342] = 3155,
  [3343] = 3127,
  [3344] = 3125,
  [3345] = 3310,
  [3346] = 3346,
  [3347] = 3312,
  [3348] = 3321,
  [3349] = 3314,
  [3350] = 3350,
  [3351] = 3316,
  [3352] = 3158,
  [3353] = 3318,
  [3354] = 3133,
  [3355] = 3126,
  [3356] = 3321,
  [3357] = 3127,
  [3358] = 3323,
  [3359] = 3324,
  [3360] = 3133,
  [3361] = 3326,
  [3362] = 3328,
  [3363] = 3138,
  [3364] = 3364,
  [3365] = 3210,
  [3366] = 3139,
  [3367] = 3226,
  [3368] = 3139,
  [3369] = 3196,
  [3370] = 2965,
  [3371] = 3139,
  [3372] = 3133,
  [3373] = 3339,
  [3374] = 3340,
  [3375] = 3138,
  [3376] = 3128,
  [3377] = 3139,
  [3378] = 3138,
  [3379] = 3310,
  [3380] = 3146,
  [3381] = 3312,
  [3382] = 3147,
  [3383] = 3314,
  [3384] = 3147,
  [3385] = 3316,
  [3386] = 3148,
  [3387] = 3318,
  [3388] = 2991,
  [3389] = 3143,
  [3390] = 3321,
  [3391] = 3245,
  [3392] = 3323,
  [3393] = 3324,
  [3394] = 3148,
  [3395] = 3326,
  [3396] = 3328,
  [3397] = 3310,
  [3398] = 3154,
  [3399] = 3210,
  [3400] = 3139,
  [3401] = 3140,
  [3402] = 3328,
  [3403] = 3196,
  [3404] = 3126,
  [3405] = 3135,
  [3406] = 3151,
  [3407] = 3339,
  [3408] = 3340,
  [3409] = 3156,
  [3410] = 3147,
  [3411] = 3148,
  [3412] = 3146,
  [3413] = 3413,
  [3414] = 3128,
  [3415] = 2991,
  [3416] = 3328,
  [3417] = 3417,
  [3418] = 3146,
  [3419] = 3140,
  [3420] = 2965,
  [3421] = 2958,
  [3422] = 3135,
  [3423] = 3340,
  [3424] = 3146,
  [3425] = 3128,
  [3426] = 3314,
  [3427] = 3142,
  [3428] = 3013,
  [3429] = 3135,
  [3430] = 3328,
  [3431] = 3236,
  [3432] = 3128,
  [3433] = 3140,
  [3434] = 3140,
  [3435] = 3435,
  [3436] = 3156,
  [3437] = 3323,
  [3438] = 3340,
  [3439] = 3350,
  [3440] = 3142,
  [3441] = 3127,
  [3442] = 3140,
  [3443] = 3145,
  [3444] = 3145,
  [3445] = 3328,
  [3446] = 3142,
  [3447] = 3142,
  [3448] = 3138,
  [3449] = 3142,
  [3450] = 3145,
  [3451] = 3324,
  [3452] = 3158,
  [3453] = 3340,
  [3454] = 3350,
  [3455] = 3131,
  [3456] = 3139,
  [3457] = 3131,
  [3458] = 3131,
  [3459] = 3151,
  [3460] = 3148,
  [3461] = 3461,
  [3462] = 3145,
  [3463] = 3463,
  [3464] = 3151,
  [3465] = 3152,
  [3466] = 3152,
  [3467] = 3126,
  [3468] = 3340,
  [3469] = 3154,
  [3470] = 3155,
  [3471] = 3471,
  [3472] = 3154,
  [3473] = 3146,
  [3474] = 3155,
  [3475] = 3328,
  [3476] = 3476,
  [3477] = 3158,
  [3478] = 3326,
  [3479] = 3126,
  [3480] = 3145,
  [3481] = 3127,
  [3482] = 3158,
  [3483] = 3340,
  [3484] = 3125,
  [3485] = 3417,
  [3486] = 3126,
  [3487] = 3127,
  [3488] = 3125,
  [3489] = 3489,
  [3490] = 3328,
  [3491] = 3131,
  [3492] = 3492,
  [3493] = 3493,
  [3494] = 3133,
  [3495] = 3138,
  [3496] = 3139,
  [3497] = 3135,
  [3498] = 3340,
  [3499] = 3499,
  [3500] = 3019,
  [3501] = 3158,
  [3502] = 3133,
  [3503] = 3140,
  [3504] = 3138,
  [3505] = 3328,
  [3506] = 3139,
  [3507] = 3013,
  [3508] = 3226,
  [3509] = 3145,
  [3510] = 3318,
  [3511] = 3147,
  [3512] = 3236,
  [3513] = 3340,
  [3514] = 3148,
  [3515] = 3312,
  [3516] = 3516,
  [3517] = 3151,
  [3518] = 3147,
  [3519] = 3148,
  [3520] = 3328,
  [3521] = 3521,
  [3522] = 3522,
  [3523] = 3146,
  [3524] = 3126,
  [3525] = 3350,
  [3526] = 3152,
  [3527] = 2958,
  [3528] = 3340,
  [3529] = 3127,
  [3530] = 2965,
  [3531] = 3146,
  [3532] = 3127,
  [3533] = 3154,
  [3534] = 3534,
  [3535] = 3328,
  [3536] = 3155,
  [3537] = 3537,
  [3538] = 3236,
  [3539] = 3146,
  [3540] = 3540,
  [3541] = 3541,
  [3542] = 3340,
  [3543] = 3135,
  [3544] = 3135,
  [3545] = 3158,
  [3546] = 3546,
  [3547] = 3328,
  [3548] = 3128,
  [3549] = 3146,
  [3550] = 3131,
  [3551] = 3151,
  [3552] = 3140,
  [3553] = 3135,
  [3554] = 3340,
  [3555] = 3339,
  [3556] = 3142,
  [3557] = 3126,
  [3558] = 3135,
  [3559] = 3328,
  [3560] = 3145,
  [3561] = 3128,
  [3562] = 3127,
  [3563] = 3316,
  [3564] = 3564,
  [3565] = 3131,
  [3566] = 3340,
  [3567] = 3125,
  [3568] = 3152,
  [3569] = 3151,
  [3570] = 3152,
  [3571] = 3328,
  [3572] = 3140,
  [3573] = 3327,
  [3574] = 3154,
  [3575] = 3155,
  [3576] = 3151,
  [3577] = 3476,
  [3578] = 3340,
  [3579] = 3158,
  [3580] = 3152,
  [3581] = 3581,
  [3582] = 3126,
  [3583] = 3127,
  [3584] = 3125,
  [3585] = 3225,
  [3586] = 3245,
  [3587] = 3133,
  [3588] = 3138,
  [3589] = 3139,
  [3590] = 3135,
  [3591] = 3128,
  [3592] = 3147,
  [3593] = 3593,
  [3594] = 3230,
  [3595] = 3288,
  [3596] = 3148,
  [3597] = 3142,
  [3598] = 3534,
  [3599] = 3492,
  [3600] = 3125,
  [3601] = 3132,
  [3602] = 3154,
  [3603] = 3145,
  [3604] = 3593,
  [3605] = 3133,
  [3606] = 3593,
  [3607] = 3230,
  [3608] = 3138,
  [3609] = 3139,
  [3610] = 3534,
  [3611] = 3492,
  [3612] = 3154,
  [3613] = 3132,
  [3614] = 3131,
  [3615] = 3155,
  [3616] = 3616,
  [3617] = 3134,
  [3618] = 3593,
  [3619] = 3230,
  [3620] = 3155,
  [3621] = 3151,
  [3622] = 3534,
  [3623] = 3492,
  [3624] = 3624,
  [3625] = 3132,
  [3626] = 3152,
  [3627] = 3627,
  [3628] = 3534,
  [3629] = 3492,
  [3630] = 3146,
  [3631] = 3534,
  [3632] = 3492,
  [3633] = 3154,
  [3634] = 3534,
  [3635] = 3492,
  [3636] = 3143,
  [3637] = 3534,
  [3638] = 3492,
  [3639] = 3155,
  [3640] = 3534,
  [3641] = 3492,
  [3642] = 3135,
  [3643] = 3534,
  [3644] = 3492,
  [3645] = 3147,
  [3646] = 3534,
  [3647] = 3492,
  [3648] = 3128,
  [3649] = 3534,
  [3650] = 3492,
  [3651] = 3534,
  [3652] = 3492,
  [3653] = 3534,
  [3654] = 3492,
  [3655] = 3534,
  [3656] = 3492,
  [3657] = 3534,
  [3658] = 3492,
  [3659] = 3534,
  [3660] = 3534,
  [3661] = 3541,
  [3662] = 3493,
  [3663] = 3219,
  [3664] = 3489,
  [3665] = 3148,
  [3666] = 3158,
  [3667] = 3541,
  [3668] = 3668,
  [3669] = 3219,
  [3670] = 3489,
  [3671] = 3140,
  [3672] = 3125,
  [3673] = 3541,
  [3674] = 3142,
  [3675] = 3219,
  [3676] = 3489,
  [3677] = 3126,
  [3678] = 3142,
  [3679] = 3679,
  [3680] = 3489,
  [3681] = 3340,
  [3682] = 3489,
  [3683] = 3683,
  [3684] = 3489,
  [3685] = 3127,
  [3686] = 3489,
  [3687] = 3125,
  [3688] = 3489,
  [3689] = 3145,
  [3690] = 3489,
  [3691] = 3226,
  [3692] = 3489,
  [3693] = 2991,
  [3694] = 3489,
  [3695] = 3489,
  [3696] = 3489,
  [3697] = 3489,
  [3698] = 3489,
  [3699] = 3133,
  [3700] = 3140,
  [3701] = 3131,
  [3702] = 3138,
  [3703] = 3013,
  [3704] = 3139,
  [3705] = 3158,
  [3706] = 3151,
  [3707] = 3707,
  [3708] = 3152,
  [3709] = 3142,
  [3710] = 3154,
  [3711] = 3155,
  [3712] = 3141,
  [3713] = 3158,
  [3714] = 3147,
  [3715] = 3126,
  [3716] = 3127,
  [3717] = 3125,
  [3718] = 3145,
  [3719] = 3158,
  [3720] = 3133,
  [3721] = 3138,
  [3722] = 3328,
  [3723] = 3723,
  [3724] = 3724,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(24);
      ADVANCE_MAP(
        '#', 67,
        '%', 60,
        '&', 78,
        '(', 72,
        ')', 73,
        '*', 54,
        '+', 49,
        ',', 30,
        '-', 51,
        '.', 74,
        '/', 57,
        '0', 91,
        ':', 27,
        ';', 25,
        '<', 33,
        '=', 29,
        '>', 35,
        '?', 82,
        '@', 189,
        '[', 70,
        ']', 71,
        '^', 65,
        '{', 89,
        '|', 79,
        '}', 183,
        '~', 12,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(92);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(181);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '%', 7,
        '&', 78,
        '(', 72,
        ')', 73,
        '*', 8,
        '+', 9,
        ',', 30,
        '-', 10,
        '.', 77,
        '/', 6,
        ':', 26,
        ';', 25,
        '<', 32,
        '=', 28,
        '>', 34,
        '?', 82,
        '[', 70,
        ']', 71,
        '^', 11,
        '{', 68,
        '|', 79,
        '}', 69,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '%', 7,
        '&', 78,
        '(', 72,
        ')', 73,
        '*', 8,
        '+', 9,
        ',', 30,
        '-', 10,
        '.', 77,
        '/', 6,
        ':', 26,
        ';', 25,
        '<', 32,
        '=', 28,
        '>', 34,
        '?', 82,
        '[', 70,
        ']', 71,
        '^', 11,
        '{', 68,
        '|', 79,
        '}', 69,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(152);
      END_STATE();
    case 3:
      if (lookahead == '.') ADVANCE(80);
      END_STATE();
    case 4:
      if (lookahead == '.') ADVANCE(80);
      if (lookahead == '=') ADVANCE(43);
      END_STATE();
    case 5:
      if (lookahead == '.') ADVANCE(3);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(85);
      END_STATE();
    case 6:
      if (lookahead == '/') ADVANCE(13);
      if (lookahead == '=') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == '=') ADVANCE(41);
      END_STATE();
    case 8:
      if (lookahead == '=') ADVANCE(38);
      END_STATE();
    case 9:
      if (lookahead == '=') ADVANCE(36);
      END_STATE();
    case 10:
      if (lookahead == '=') ADVANCE(37);
      END_STATE();
    case 11:
      if (lookahead == '=') ADVANCE(42);
      END_STATE();
    case 12:
      if (lookahead == '=') ADVANCE(45);
      END_STATE();
    case 13:
      if (lookahead == '=') ADVANCE(39);
      END_STATE();
    case 14:
      if (lookahead == '_') ADVANCE(15);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(87);
      END_STATE();
    case 15:
      if (lookahead == '_') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(87);
      END_STATE();
    case 16:
      if (lookahead == '{') ADVANCE(89);
      if (lookahead == '}') ADVANCE(183);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(190);
      END_STATE();
    case 17:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(187);
      END_STATE();
    case 18:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(17);
      END_STATE();
    case 19:
      if (eof) ADVANCE(24);
      ADVANCE_MAP(
        '#', 67,
        '%', 60,
        '&', 78,
        '(', 72,
        ')', 73,
        '*', 54,
        '+', 49,
        ',', 30,
        '-', 51,
        '.', 74,
        '/', 57,
        '0', 83,
        ':', 27,
        ';', 25,
        '<', 33,
        '=', 29,
        '>', 35,
        '?', 82,
        '@', 189,
        '[', 70,
        ']', 71,
        '^', 65,
        '{', 68,
        '|', 79,
        '}', 69,
        '~', 12,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(84);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 20:
      if (eof) ADVANCE(24);
      ADVANCE_MAP(
        '#', 67,
        '&', 78,
        '(', 72,
        ')', 73,
        ',', 30,
        '-', 52,
        '.', 5,
        '0', 83,
        ';', 25,
        '<', 32,
        '=', 28,
        '>', 34,
        '?', 82,
        '[', 70,
        ']', 71,
        '{', 68,
        '|', 79,
        '}', 69,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(20);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(84);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 21:
      if (eof) ADVANCE(24);
      ADVANCE_MAP(
        '%', 59,
        '&', 78,
        '(', 72,
        ')', 73,
        '*', 53,
        '+', 48,
        ',', 30,
        '-', 52,
        '.', 75,
        '/', 58,
        ':', 27,
        ';', 25,
        '<', 33,
        '=', 29,
        '>', 35,
        '?', 82,
        '@', 189,
        '[', 70,
        ']', 71,
        '^', 64,
        '{', 68,
        '|', 79,
        '}', 69,
        '~', 12,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(186);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 22:
      if (eof) ADVANCE(24);
      ADVANCE_MAP(
        '%', 59,
        '&', 78,
        '(', 72,
        ')', 73,
        '*', 53,
        '+', 48,
        ',', 30,
        '-', 52,
        '.', 75,
        '/', 58,
        ':', 27,
        ';', 25,
        '<', 33,
        '=', 29,
        '>', 35,
        '?', 82,
        '@', 189,
        '[', 70,
        ']', 71,
        '^', 64,
        '{', 68,
        '|', 79,
        '}', 69,
        '~', 12,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(22);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 23:
      if (eof) ADVANCE(24);
      ADVANCE_MAP(
        '%', 59,
        '&', 78,
        '(', 72,
        ')', 73,
        '*', 53,
        '+', 48,
        ',', 30,
        '-', 50,
        '.', 76,
        '/', 58,
        ':', 27,
        ';', 25,
        '<', 33,
        '=', 29,
        '>', 35,
        '?', 82,
        '@', 189,
        ']', 71,
        '^', 64,
        '{', 68,
        '|', 79,
        '}', 69,
        '~', 12,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(23);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(66);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(44);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(aux_sym_type_stmt_token1);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(46);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(47);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_EQ);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_TILDE_EQ);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(36);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(37);
      if (lookahead == '>') ADVANCE(81);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(81);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(38);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=') ADVANCE(39);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(56);
      if (lookahead == '=') ADVANCE(40);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(55);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(41);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(80);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(80);
      if (lookahead == '=') ADVANCE(43);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(42);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(85);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(61);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(62);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(4);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_number);
      ADVANCE_MAP(
        '.', 85,
        '_', 83,
        'B', 86,
        'b', 86,
        'E', 14,
        'e', 14,
        'X', 88,
        'x', 88,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(84);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(84);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(85);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(86);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(87);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(88);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_LBRACE2);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      ADVANCE_MAP(
        '.', 85,
        '_', 83,
        'B', 121,
        'b', 121,
        'E', 122,
        'e', 122,
        'X', 88,
        'x', 88,
        'A', 180,
        'C', 180,
        'D', 180,
        'F', 180,
        'a', 180,
        'c', 180,
        'd', 180,
        'f', 180,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(106);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '_') ADVANCE(84);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(122);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(180);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(106);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '_') ADVANCE(84);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(123);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '_') ADVANCE(84);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(124);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(93);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '_') ADVANCE(84);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(125);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(158);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(96);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '_') ADVANCE(84);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(126);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(94);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '_') ADVANCE(84);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(127);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(95);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '_') ADVANCE(84);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(128);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(162);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '_') ADVANCE(84);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(129);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(164);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(98);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '_') ADVANCE(84);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(130);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(166);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(99);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '_') ADVANCE(84);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(131);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(168);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(100);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '_') ADVANCE(84);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(132);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(170);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(101);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '_') ADVANCE(84);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(133);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(172);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(102);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '_') ADVANCE(84);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(134);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(174);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(103);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '_') ADVANCE(84);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(135);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(176);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(104);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '_') ADVANCE(84);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(136);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(178);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(105);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(84);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(86);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(150);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(90);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(86);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(108);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(153);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(86);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(109);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(156);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(86);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(110);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(158);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(86);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(111);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(160);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(86);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(112);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(162);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(86);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(113);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(164);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(86);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(114);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(166);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(86);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(115);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(168);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(86);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(116);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(170);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(86);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(117);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(172);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(86);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(118);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(174);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(86);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(119);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(176);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(86);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(120);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(178);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(15);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(149);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(178);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(15);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(87);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(15);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(90);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(15);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(139);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(156);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(15);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(153);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(15);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(158);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(15);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(140);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(160);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(15);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(141);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(162);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(15);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(164);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(15);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(143);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(166);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(15);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(144);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(168);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(15);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(170);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(15);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(146);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(172);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(15);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(147);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(174);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(15);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(148);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(176);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(90);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(139);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(156);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(153);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(158);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(140);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(160);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(141);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(162);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(164);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(143);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(166);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(144);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(168);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(170);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(146);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(172);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(147);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(174);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '_') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(148);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(176);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(86);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(87);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(180);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(90);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(182);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(154);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(153);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(155);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(156);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(157);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(158);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(159);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(160);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(161);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(162);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(163);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(164);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(165);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(166);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(167);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(168);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(169);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(170);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(171);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(172);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(173);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(174);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(175);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(176);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(177);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(178);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(179);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_RBRACE2);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(aux_sym_dec_byte_escape_token1);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(aux_sym_dec_byte_escape_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(aux_sym_dec_byte_escape_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(185);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(aux_sym_hex_byte_escape_token1);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '[') ADVANCE(191);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(aux_sym_attribute_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(190);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_AT_LBRACK);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'd', 4,
        'e', 5,
        'f', 6,
        'i', 7,
        'l', 8,
        'n', 9,
        'o', 10,
        'r', 11,
        't', 12,
        'u', 13,
        'w', 14,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'n') ADVANCE(15);
      END_STATE();
    case 2:
      if (lookahead == 'r') ADVANCE(16);
      END_STATE();
    case 3:
      if (lookahead == 'o') ADVANCE(17);
      END_STATE();
    case 4:
      if (lookahead == 'o') ADVANCE(18);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(19);
      if (lookahead == 'n') ADVANCE(20);
      if (lookahead == 'x') ADVANCE(21);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(22);
      if (lookahead == 'o') ADVANCE(23);
      if (lookahead == 'u') ADVANCE(24);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(25);
      if (lookahead == 'n') ADVANCE(26);
      END_STATE();
    case 8:
      if (lookahead == 'o') ADVANCE(27);
      END_STATE();
    case 9:
      if (lookahead == 'i') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 10:
      if (lookahead == 'r') ADVANCE(30);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(31);
      END_STATE();
    case 12:
      if (lookahead == 'h') ADVANCE(32);
      if (lookahead == 'r') ADVANCE(33);
      if (lookahead == 'y') ADVANCE(34);
      END_STATE();
    case 13:
      if (lookahead == 'n') ADVANCE(35);
      END_STATE();
    case 14:
      if (lookahead == 'h') ADVANCE(36);
      if (lookahead == 'r') ADVANCE(37);
      END_STATE();
    case 15:
      if (lookahead == 'd') ADVANCE(38);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(39);
      END_STATE();
    case 17:
      if (lookahead == 'n') ADVANCE(40);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 19:
      if (lookahead == 's') ADVANCE(41);
      END_STATE();
    case 20:
      if (lookahead == 'd') ADVANCE(42);
      END_STATE();
    case 21:
      if (lookahead == 'p') ADVANCE(43);
      END_STATE();
    case 22:
      if (lookahead == 'l') ADVANCE(44);
      END_STATE();
    case 23:
      if (lookahead == 'r') ADVANCE(45);
      END_STATE();
    case 24:
      if (lookahead == 'n') ADVANCE(46);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 27:
      if (lookahead == 'c') ADVANCE(47);
      END_STATE();
    case 28:
      if (lookahead == 'l') ADVANCE(48);
      END_STATE();
    case 29:
      if (lookahead == 't') ADVANCE(49);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 31:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'p') ADVANCE(51);
      if (lookahead == 't') ADVANCE(52);
      END_STATE();
    case 32:
      if (lookahead == 'e') ADVANCE(53);
      END_STATE();
    case 33:
      if (lookahead == 'u') ADVANCE(54);
      END_STATE();
    case 34:
      if (lookahead == 'p') ADVANCE(55);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(56);
      END_STATE();
    case 36:
      if (lookahead == 'i') ADVANCE(57);
      END_STATE();
    case 37:
      if (lookahead == 'i') ADVANCE(58);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 39:
      if (lookahead == 'a') ADVANCE(59);
      END_STATE();
    case 40:
      if (lookahead == 't') ADVANCE(60);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(61);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 43:
      if (lookahead == 'o') ADVANCE(62);
      END_STATE();
    case 44:
      if (lookahead == 's') ADVANCE(63);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 46:
      if (lookahead == 'c') ADVANCE(64);
      END_STATE();
    case 47:
      if (lookahead == 'a') ADVANCE(65);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_nil);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 50:
      if (lookahead == 'd') ADVANCE(66);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(67);
      END_STATE();
    case 52:
      if (lookahead == 'u') ADVANCE(68);
      END_STATE();
    case 53:
      if (lookahead == 'n') ADVANCE(69);
      END_STATE();
    case 54:
      if (lookahead == 'e') ADVANCE(70);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(71);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(72);
      END_STATE();
    case 57:
      if (lookahead == 'l') ADVANCE(73);
      END_STATE();
    case 58:
      if (lookahead == 't') ADVANCE(74);
      END_STATE();
    case 59:
      if (lookahead == 'k') ADVANCE(75);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(76);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(77);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(78);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(79);
      END_STATE();
    case 64:
      if (lookahead == 't') ADVANCE(80);
      END_STATE();
    case 65:
      if (lookahead == 'l') ADVANCE(81);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_read);
      END_STATE();
    case 67:
      if (lookahead == 'a') ADVANCE(82);
      END_STATE();
    case 68:
      if (lookahead == 'r') ADVANCE(83);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(84);
      END_STATE();
    case 72:
      if (lookahead == 'l') ADVANCE(85);
      END_STATE();
    case 73:
      if (lookahead == 'e') ADVANCE(86);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 76:
      if (lookahead == 'n') ADVANCE(88);
      END_STATE();
    case 77:
      if (lookahead == 'f') ADVANCE(89);
      END_STATE();
    case 78:
      if (lookahead == 't') ADVANCE(90);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 80:
      if (lookahead == 'i') ADVANCE(91);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 82:
      if (lookahead == 't') ADVANCE(92);
      END_STATE();
    case 83:
      if (lookahead == 'n') ADVANCE(93);
      END_STATE();
    case 84:
      if (lookahead == 'f') ADVANCE(94);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_write);
      END_STATE();
    case 88:
      if (lookahead == 'u') ADVANCE(95);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_elseif);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 91:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_repeat);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 95:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 96:
      if (lookahead == 'n') ADVANCE(98);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_continue_stmt);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 21, .external_lex_state = 2},
  [2] = {.lex_state = 21, .external_lex_state = 3},
  [3] = {.lex_state = 21, .external_lex_state = 3},
  [4] = {.lex_state = 21, .external_lex_state = 3},
  [5] = {.lex_state = 21, .external_lex_state = 3},
  [6] = {.lex_state = 21, .external_lex_state = 3},
  [7] = {.lex_state = 21, .external_lex_state = 4},
  [8] = {.lex_state = 21, .external_lex_state = 4},
  [9] = {.lex_state = 21, .external_lex_state = 4},
  [10] = {.lex_state = 21, .external_lex_state = 4},
  [11] = {.lex_state = 21, .external_lex_state = 4},
  [12] = {.lex_state = 21, .external_lex_state = 4},
  [13] = {.lex_state = 21, .external_lex_state = 4},
  [14] = {.lex_state = 21, .external_lex_state = 4},
  [15] = {.lex_state = 21, .external_lex_state = 4},
  [16] = {.lex_state = 21, .external_lex_state = 4},
  [17] = {.lex_state = 21, .external_lex_state = 4},
  [18] = {.lex_state = 21, .external_lex_state = 4},
  [19] = {.lex_state = 21, .external_lex_state = 4},
  [20] = {.lex_state = 21, .external_lex_state = 4},
  [21] = {.lex_state = 21, .external_lex_state = 4},
  [22] = {.lex_state = 21, .external_lex_state = 4},
  [23] = {.lex_state = 21, .external_lex_state = 4},
  [24] = {.lex_state = 21, .external_lex_state = 4},
  [25] = {.lex_state = 21, .external_lex_state = 4},
  [26] = {.lex_state = 21, .external_lex_state = 4},
  [27] = {.lex_state = 21, .external_lex_state = 4},
  [28] = {.lex_state = 21, .external_lex_state = 4},
  [29] = {.lex_state = 21, .external_lex_state = 4},
  [30] = {.lex_state = 21, .external_lex_state = 4},
  [31] = {.lex_state = 21, .external_lex_state = 4},
  [32] = {.lex_state = 21, .external_lex_state = 4},
  [33] = {.lex_state = 21, .external_lex_state = 4},
  [34] = {.lex_state = 21, .external_lex_state = 4},
  [35] = {.lex_state = 21, .external_lex_state = 4},
  [36] = {.lex_state = 21, .external_lex_state = 4},
  [37] = {.lex_state = 21, .external_lex_state = 4},
  [38] = {.lex_state = 21, .external_lex_state = 4},
  [39] = {.lex_state = 21, .external_lex_state = 4},
  [40] = {.lex_state = 21, .external_lex_state = 4},
  [41] = {.lex_state = 21, .external_lex_state = 4},
  [42] = {.lex_state = 21, .external_lex_state = 4},
  [43] = {.lex_state = 21, .external_lex_state = 4},
  [44] = {.lex_state = 21, .external_lex_state = 4},
  [45] = {.lex_state = 21, .external_lex_state = 4},
  [46] = {.lex_state = 21, .external_lex_state = 4},
  [47] = {.lex_state = 21, .external_lex_state = 4},
  [48] = {.lex_state = 21, .external_lex_state = 4},
  [49] = {.lex_state = 21, .external_lex_state = 4},
  [50] = {.lex_state = 21, .external_lex_state = 4},
  [51] = {.lex_state = 21, .external_lex_state = 4},
  [52] = {.lex_state = 21, .external_lex_state = 4},
  [53] = {.lex_state = 21, .external_lex_state = 4},
  [54] = {.lex_state = 21, .external_lex_state = 4},
  [55] = {.lex_state = 21, .external_lex_state = 4},
  [56] = {.lex_state = 21, .external_lex_state = 4},
  [57] = {.lex_state = 21, .external_lex_state = 4},
  [58] = {.lex_state = 21, .external_lex_state = 4},
  [59] = {.lex_state = 21, .external_lex_state = 4},
  [60] = {.lex_state = 21, .external_lex_state = 4},
  [61] = {.lex_state = 21, .external_lex_state = 4},
  [62] = {.lex_state = 21, .external_lex_state = 4},
  [63] = {.lex_state = 21, .external_lex_state = 4},
  [64] = {.lex_state = 21, .external_lex_state = 4},
  [65] = {.lex_state = 21, .external_lex_state = 4},
  [66] = {.lex_state = 21, .external_lex_state = 4},
  [67] = {.lex_state = 21, .external_lex_state = 4},
  [68] = {.lex_state = 21, .external_lex_state = 4},
  [69] = {.lex_state = 21, .external_lex_state = 4},
  [70] = {.lex_state = 21, .external_lex_state = 4},
  [71] = {.lex_state = 21, .external_lex_state = 4},
  [72] = {.lex_state = 21, .external_lex_state = 5},
  [73] = {.lex_state = 21, .external_lex_state = 4},
  [74] = {.lex_state = 21, .external_lex_state = 4},
  [75] = {.lex_state = 21, .external_lex_state = 4},
  [76] = {.lex_state = 21, .external_lex_state = 4},
  [77] = {.lex_state = 21, .external_lex_state = 4},
  [78] = {.lex_state = 21, .external_lex_state = 4},
  [79] = {.lex_state = 21, .external_lex_state = 4},
  [80] = {.lex_state = 21, .external_lex_state = 4},
  [81] = {.lex_state = 21, .external_lex_state = 4},
  [82] = {.lex_state = 21, .external_lex_state = 4},
  [83] = {.lex_state = 21, .external_lex_state = 4},
  [84] = {.lex_state = 21, .external_lex_state = 4},
  [85] = {.lex_state = 21, .external_lex_state = 4},
  [86] = {.lex_state = 21, .external_lex_state = 4},
  [87] = {.lex_state = 21, .external_lex_state = 4},
  [88] = {.lex_state = 21, .external_lex_state = 4},
  [89] = {.lex_state = 21, .external_lex_state = 4},
  [90] = {.lex_state = 21, .external_lex_state = 4},
  [91] = {.lex_state = 21, .external_lex_state = 4},
  [92] = {.lex_state = 21, .external_lex_state = 4},
  [93] = {.lex_state = 21, .external_lex_state = 4},
  [94] = {.lex_state = 21, .external_lex_state = 4},
  [95] = {.lex_state = 21, .external_lex_state = 4},
  [96] = {.lex_state = 21, .external_lex_state = 4},
  [97] = {.lex_state = 21, .external_lex_state = 4},
  [98] = {.lex_state = 21, .external_lex_state = 4},
  [99] = {.lex_state = 21, .external_lex_state = 4},
  [100] = {.lex_state = 21, .external_lex_state = 4},
  [101] = {.lex_state = 21, .external_lex_state = 4},
  [102] = {.lex_state = 21, .external_lex_state = 4},
  [103] = {.lex_state = 21, .external_lex_state = 4},
  [104] = {.lex_state = 21, .external_lex_state = 4},
  [105] = {.lex_state = 21, .external_lex_state = 4},
  [106] = {.lex_state = 21, .external_lex_state = 4},
  [107] = {.lex_state = 21, .external_lex_state = 4},
  [108] = {.lex_state = 21, .external_lex_state = 4},
  [109] = {.lex_state = 21, .external_lex_state = 4},
  [110] = {.lex_state = 21, .external_lex_state = 4},
  [111] = {.lex_state = 21, .external_lex_state = 4},
  [112] = {.lex_state = 21, .external_lex_state = 4},
  [113] = {.lex_state = 21, .external_lex_state = 4},
  [114] = {.lex_state = 21, .external_lex_state = 4},
  [115] = {.lex_state = 21, .external_lex_state = 4},
  [116] = {.lex_state = 21, .external_lex_state = 4},
  [117] = {.lex_state = 21, .external_lex_state = 4},
  [118] = {.lex_state = 21, .external_lex_state = 4},
  [119] = {.lex_state = 21, .external_lex_state = 4},
  [120] = {.lex_state = 21, .external_lex_state = 4},
  [121] = {.lex_state = 21, .external_lex_state = 4},
  [122] = {.lex_state = 21, .external_lex_state = 4},
  [123] = {.lex_state = 21, .external_lex_state = 4},
  [124] = {.lex_state = 21, .external_lex_state = 4},
  [125] = {.lex_state = 21, .external_lex_state = 4},
  [126] = {.lex_state = 21, .external_lex_state = 4},
  [127] = {.lex_state = 21, .external_lex_state = 4},
  [128] = {.lex_state = 21, .external_lex_state = 4},
  [129] = {.lex_state = 21, .external_lex_state = 4},
  [130] = {.lex_state = 21, .external_lex_state = 4},
  [131] = {.lex_state = 21, .external_lex_state = 4},
  [132] = {.lex_state = 21, .external_lex_state = 4},
  [133] = {.lex_state = 21, .external_lex_state = 4},
  [134] = {.lex_state = 21, .external_lex_state = 4},
  [135] = {.lex_state = 21, .external_lex_state = 4},
  [136] = {.lex_state = 21, .external_lex_state = 4},
  [137] = {.lex_state = 21, .external_lex_state = 3},
  [138] = {.lex_state = 21, .external_lex_state = 4},
  [139] = {.lex_state = 21, .external_lex_state = 4},
  [140] = {.lex_state = 21, .external_lex_state = 4},
  [141] = {.lex_state = 21, .external_lex_state = 4},
  [142] = {.lex_state = 21, .external_lex_state = 4},
  [143] = {.lex_state = 21, .external_lex_state = 4},
  [144] = {.lex_state = 21, .external_lex_state = 4},
  [145] = {.lex_state = 21, .external_lex_state = 4},
  [146] = {.lex_state = 21, .external_lex_state = 4},
  [147] = {.lex_state = 21, .external_lex_state = 4},
  [148] = {.lex_state = 21, .external_lex_state = 4},
  [149] = {.lex_state = 21, .external_lex_state = 4},
  [150] = {.lex_state = 21, .external_lex_state = 4},
  [151] = {.lex_state = 21, .external_lex_state = 4},
  [152] = {.lex_state = 21, .external_lex_state = 4},
  [153] = {.lex_state = 21, .external_lex_state = 5},
  [154] = {.lex_state = 21, .external_lex_state = 4},
  [155] = {.lex_state = 21, .external_lex_state = 4},
  [156] = {.lex_state = 21, .external_lex_state = 4},
  [157] = {.lex_state = 21, .external_lex_state = 4},
  [158] = {.lex_state = 21, .external_lex_state = 4},
  [159] = {.lex_state = 21, .external_lex_state = 4},
  [160] = {.lex_state = 21, .external_lex_state = 4},
  [161] = {.lex_state = 21, .external_lex_state = 4},
  [162] = {.lex_state = 21, .external_lex_state = 4},
  [163] = {.lex_state = 21, .external_lex_state = 4},
  [164] = {.lex_state = 21, .external_lex_state = 4},
  [165] = {.lex_state = 21, .external_lex_state = 4},
  [166] = {.lex_state = 21, .external_lex_state = 4},
  [167] = {.lex_state = 21, .external_lex_state = 4},
  [168] = {.lex_state = 21, .external_lex_state = 4},
  [169] = {.lex_state = 21, .external_lex_state = 4},
  [170] = {.lex_state = 21, .external_lex_state = 4},
  [171] = {.lex_state = 21, .external_lex_state = 4},
  [172] = {.lex_state = 21, .external_lex_state = 4},
  [173] = {.lex_state = 21, .external_lex_state = 4},
  [174] = {.lex_state = 21, .external_lex_state = 4},
  [175] = {.lex_state = 21, .external_lex_state = 4},
  [176] = {.lex_state = 21, .external_lex_state = 4},
  [177] = {.lex_state = 21, .external_lex_state = 4},
  [178] = {.lex_state = 21, .external_lex_state = 4},
  [179] = {.lex_state = 21, .external_lex_state = 4},
  [180] = {.lex_state = 21, .external_lex_state = 4},
  [181] = {.lex_state = 21, .external_lex_state = 4},
  [182] = {.lex_state = 21, .external_lex_state = 4},
  [183] = {.lex_state = 21, .external_lex_state = 4},
  [184] = {.lex_state = 21, .external_lex_state = 4},
  [185] = {.lex_state = 21, .external_lex_state = 4},
  [186] = {.lex_state = 21, .external_lex_state = 4},
  [187] = {.lex_state = 21, .external_lex_state = 4},
  [188] = {.lex_state = 21, .external_lex_state = 4},
  [189] = {.lex_state = 21, .external_lex_state = 4},
  [190] = {.lex_state = 21, .external_lex_state = 4},
  [191] = {.lex_state = 21, .external_lex_state = 4},
  [192] = {.lex_state = 21, .external_lex_state = 4},
  [193] = {.lex_state = 21, .external_lex_state = 4},
  [194] = {.lex_state = 21, .external_lex_state = 4},
  [195] = {.lex_state = 21, .external_lex_state = 4},
  [196] = {.lex_state = 21, .external_lex_state = 4},
  [197] = {.lex_state = 21, .external_lex_state = 4},
  [198] = {.lex_state = 21, .external_lex_state = 4},
  [199] = {.lex_state = 21, .external_lex_state = 4},
  [200] = {.lex_state = 21, .external_lex_state = 4},
  [201] = {.lex_state = 21, .external_lex_state = 4},
  [202] = {.lex_state = 21, .external_lex_state = 4},
  [203] = {.lex_state = 21, .external_lex_state = 4},
  [204] = {.lex_state = 21, .external_lex_state = 4},
  [205] = {.lex_state = 21, .external_lex_state = 4},
  [206] = {.lex_state = 21, .external_lex_state = 5},
  [207] = {.lex_state = 21, .external_lex_state = 4},
  [208] = {.lex_state = 21, .external_lex_state = 4},
  [209] = {.lex_state = 21, .external_lex_state = 4},
  [210] = {.lex_state = 21, .external_lex_state = 4},
  [211] = {.lex_state = 21, .external_lex_state = 4},
  [212] = {.lex_state = 21, .external_lex_state = 4},
  [213] = {.lex_state = 21, .external_lex_state = 4},
  [214] = {.lex_state = 21, .external_lex_state = 4},
  [215] = {.lex_state = 21, .external_lex_state = 4},
  [216] = {.lex_state = 21, .external_lex_state = 4},
  [217] = {.lex_state = 21, .external_lex_state = 4},
  [218] = {.lex_state = 21, .external_lex_state = 4},
  [219] = {.lex_state = 21, .external_lex_state = 4},
  [220] = {.lex_state = 21, .external_lex_state = 4},
  [221] = {.lex_state = 21, .external_lex_state = 4},
  [222] = {.lex_state = 21, .external_lex_state = 4},
  [223] = {.lex_state = 21, .external_lex_state = 5},
  [224] = {.lex_state = 21, .external_lex_state = 4},
  [225] = {.lex_state = 21, .external_lex_state = 6},
  [226] = {.lex_state = 21, .external_lex_state = 3},
  [227] = {.lex_state = 21, .external_lex_state = 6},
  [228] = {.lex_state = 21, .external_lex_state = 6},
  [229] = {.lex_state = 21, .external_lex_state = 5},
  [230] = {.lex_state = 21, .external_lex_state = 2},
  [231] = {.lex_state = 21, .external_lex_state = 4},
  [232] = {.lex_state = 21, .external_lex_state = 7},
  [233] = {.lex_state = 21, .external_lex_state = 6},
  [234] = {.lex_state = 21, .external_lex_state = 6},
  [235] = {.lex_state = 21, .external_lex_state = 6},
  [236] = {.lex_state = 21, .external_lex_state = 2},
  [237] = {.lex_state = 21, .external_lex_state = 6},
  [238] = {.lex_state = 21, .external_lex_state = 6},
  [239] = {.lex_state = 21, .external_lex_state = 6},
  [240] = {.lex_state = 21, .external_lex_state = 6},
  [241] = {.lex_state = 21, .external_lex_state = 6},
  [242] = {.lex_state = 21, .external_lex_state = 6},
  [243] = {.lex_state = 21, .external_lex_state = 4},
  [244] = {.lex_state = 21, .external_lex_state = 5},
  [245] = {.lex_state = 21, .external_lex_state = 6},
  [246] = {.lex_state = 21, .external_lex_state = 8},
  [247] = {.lex_state = 21, .external_lex_state = 8},
  [248] = {.lex_state = 21, .external_lex_state = 8},
  [249] = {.lex_state = 21, .external_lex_state = 9},
  [250] = {.lex_state = 21, .external_lex_state = 9},
  [251] = {.lex_state = 21, .external_lex_state = 9},
  [252] = {.lex_state = 21, .external_lex_state = 6},
  [253] = {.lex_state = 21, .external_lex_state = 6},
  [254] = {.lex_state = 21, .external_lex_state = 6},
  [255] = {.lex_state = 21, .external_lex_state = 6},
  [256] = {.lex_state = 21, .external_lex_state = 6},
  [257] = {.lex_state = 23, .external_lex_state = 10},
  [258] = {.lex_state = 21, .external_lex_state = 7},
  [259] = {.lex_state = 21, .external_lex_state = 7},
  [260] = {.lex_state = 21, .external_lex_state = 6},
  [261] = {.lex_state = 21, .external_lex_state = 10},
  [262] = {.lex_state = 21, .external_lex_state = 10},
  [263] = {.lex_state = 21, .external_lex_state = 8},
  [264] = {.lex_state = 21, .external_lex_state = 7},
  [265] = {.lex_state = 21, .external_lex_state = 9},
  [266] = {.lex_state = 21, .external_lex_state = 7},
  [267] = {.lex_state = 21, .external_lex_state = 9},
  [268] = {.lex_state = 21, .external_lex_state = 9},
  [269] = {.lex_state = 21, .external_lex_state = 7},
  [270] = {.lex_state = 21, .external_lex_state = 9},
  [271] = {.lex_state = 21, .external_lex_state = 8},
  [272] = {.lex_state = 21, .external_lex_state = 8},
  [273] = {.lex_state = 21, .external_lex_state = 8},
  [274] = {.lex_state = 23, .external_lex_state = 11},
  [275] = {.lex_state = 21, .external_lex_state = 8},
  [276] = {.lex_state = 21, .external_lex_state = 8},
  [277] = {.lex_state = 21, .external_lex_state = 7},
  [278] = {.lex_state = 21, .external_lex_state = 8},
  [279] = {.lex_state = 21, .external_lex_state = 8},
  [280] = {.lex_state = 21, .external_lex_state = 9},
  [281] = {.lex_state = 21, .external_lex_state = 7},
  [282] = {.lex_state = 21, .external_lex_state = 10},
  [283] = {.lex_state = 21, .external_lex_state = 10},
  [284] = {.lex_state = 21, .external_lex_state = 7},
  [285] = {.lex_state = 23, .external_lex_state = 12},
  [286] = {.lex_state = 21, .external_lex_state = 10},
  [287] = {.lex_state = 21, .external_lex_state = 9},
  [288] = {.lex_state = 21, .external_lex_state = 9},
  [289] = {.lex_state = 21, .external_lex_state = 8},
  [290] = {.lex_state = 21, .external_lex_state = 7},
  [291] = {.lex_state = 21, .external_lex_state = 8},
  [292] = {.lex_state = 21, .external_lex_state = 8},
  [293] = {.lex_state = 21, .external_lex_state = 10},
  [294] = {.lex_state = 21, .external_lex_state = 10},
  [295] = {.lex_state = 21, .external_lex_state = 10},
  [296] = {.lex_state = 21, .external_lex_state = 9},
  [297] = {.lex_state = 21, .external_lex_state = 8},
  [298] = {.lex_state = 21, .external_lex_state = 10},
  [299] = {.lex_state = 21, .external_lex_state = 10},
  [300] = {.lex_state = 21, .external_lex_state = 9},
  [301] = {.lex_state = 21, .external_lex_state = 10},
  [302] = {.lex_state = 21, .external_lex_state = 10},
  [303] = {.lex_state = 21, .external_lex_state = 9},
  [304] = {.lex_state = 21, .external_lex_state = 10},
  [305] = {.lex_state = 21, .external_lex_state = 10},
  [306] = {.lex_state = 23, .external_lex_state = 13},
  [307] = {.lex_state = 21, .external_lex_state = 10},
  [308] = {.lex_state = 21, .external_lex_state = 8},
  [309] = {.lex_state = 21, .external_lex_state = 9},
  [310] = {.lex_state = 21, .external_lex_state = 10},
  [311] = {.lex_state = 21, .external_lex_state = 10},
  [312] = {.lex_state = 21, .external_lex_state = 8},
  [313] = {.lex_state = 21, .external_lex_state = 10},
  [314] = {.lex_state = 21, .external_lex_state = 10},
  [315] = {.lex_state = 21, .external_lex_state = 6},
  [316] = {.lex_state = 21, .external_lex_state = 10},
  [317] = {.lex_state = 21, .external_lex_state = 10},
  [318] = {.lex_state = 21, .external_lex_state = 10},
  [319] = {.lex_state = 21, .external_lex_state = 10},
  [320] = {.lex_state = 21, .external_lex_state = 9},
  [321] = {.lex_state = 21, .external_lex_state = 10},
  [322] = {.lex_state = 21, .external_lex_state = 10},
  [323] = {.lex_state = 21, .external_lex_state = 10},
  [324] = {.lex_state = 21, .external_lex_state = 10},
  [325] = {.lex_state = 21, .external_lex_state = 10},
  [326] = {.lex_state = 21, .external_lex_state = 10},
  [327] = {.lex_state = 21, .external_lex_state = 7},
  [328] = {.lex_state = 21, .external_lex_state = 7},
  [329] = {.lex_state = 21, .external_lex_state = 8},
  [330] = {.lex_state = 21, .external_lex_state = 8},
  [331] = {.lex_state = 21, .external_lex_state = 7},
  [332] = {.lex_state = 21, .external_lex_state = 9},
  [333] = {.lex_state = 21, .external_lex_state = 9},
  [334] = {.lex_state = 21, .external_lex_state = 7},
  [335] = {.lex_state = 21, .external_lex_state = 7},
  [336] = {.lex_state = 21, .external_lex_state = 7},
  [337] = {.lex_state = 21, .external_lex_state = 9},
  [338] = {.lex_state = 21, .external_lex_state = 9},
  [339] = {.lex_state = 21, .external_lex_state = 7},
  [340] = {.lex_state = 21, .external_lex_state = 7},
  [341] = {.lex_state = 21, .external_lex_state = 7},
  [342] = {.lex_state = 21, .external_lex_state = 10},
  [343] = {.lex_state = 21, .external_lex_state = 10},
  [344] = {.lex_state = 21, .external_lex_state = 13},
  [345] = {.lex_state = 21, .external_lex_state = 11},
  [346] = {.lex_state = 21, .external_lex_state = 12},
  [347] = {.lex_state = 21, .external_lex_state = 12},
  [348] = {.lex_state = 21, .external_lex_state = 13},
  [349] = {.lex_state = 21, .external_lex_state = 11},
  [350] = {.lex_state = 21, .external_lex_state = 11},
  [351] = {.lex_state = 21, .external_lex_state = 11},
  [352] = {.lex_state = 21, .external_lex_state = 12},
  [353] = {.lex_state = 21, .external_lex_state = 9},
  [354] = {.lex_state = 21, .external_lex_state = 11},
  [355] = {.lex_state = 21, .external_lex_state = 11},
  [356] = {.lex_state = 21, .external_lex_state = 11},
  [357] = {.lex_state = 21, .external_lex_state = 11},
  [358] = {.lex_state = 21, .external_lex_state = 11},
  [359] = {.lex_state = 21, .external_lex_state = 12},
  [360] = {.lex_state = 21, .external_lex_state = 12},
  [361] = {.lex_state = 21, .external_lex_state = 11},
  [362] = {.lex_state = 21, .external_lex_state = 11},
  [363] = {.lex_state = 21, .external_lex_state = 11},
  [364] = {.lex_state = 21, .external_lex_state = 12},
  [365] = {.lex_state = 21, .external_lex_state = 12},
  [366] = {.lex_state = 21, .external_lex_state = 11},
  [367] = {.lex_state = 21, .external_lex_state = 12},
  [368] = {.lex_state = 21, .external_lex_state = 10},
  [369] = {.lex_state = 21, .external_lex_state = 13},
  [370] = {.lex_state = 21, .external_lex_state = 13},
  [371] = {.lex_state = 21, .external_lex_state = 7},
  [372] = {.lex_state = 21, .external_lex_state = 13},
  [373] = {.lex_state = 21, .external_lex_state = 12},
  [374] = {.lex_state = 21, .external_lex_state = 13},
  [375] = {.lex_state = 21, .external_lex_state = 13},
  [376] = {.lex_state = 21, .external_lex_state = 13},
  [377] = {.lex_state = 21, .external_lex_state = 13},
  [378] = {.lex_state = 21, .external_lex_state = 13},
  [379] = {.lex_state = 21, .external_lex_state = 13},
  [380] = {.lex_state = 21, .external_lex_state = 13},
  [381] = {.lex_state = 21, .external_lex_state = 13},
  [382] = {.lex_state = 21, .external_lex_state = 12},
  [383] = {.lex_state = 21, .external_lex_state = 13},
  [384] = {.lex_state = 21, .external_lex_state = 11},
  [385] = {.lex_state = 21, .external_lex_state = 13},
  [386] = {.lex_state = 21, .external_lex_state = 13},
  [387] = {.lex_state = 21, .external_lex_state = 13},
  [388] = {.lex_state = 21, .external_lex_state = 13},
  [389] = {.lex_state = 21, .external_lex_state = 13},
  [390] = {.lex_state = 21, .external_lex_state = 12},
  [391] = {.lex_state = 21, .external_lex_state = 13},
  [392] = {.lex_state = 21, .external_lex_state = 13},
  [393] = {.lex_state = 20, .external_lex_state = 14},
  [394] = {.lex_state = 21, .external_lex_state = 13},
  [395] = {.lex_state = 21, .external_lex_state = 13},
  [396] = {.lex_state = 21, .external_lex_state = 13},
  [397] = {.lex_state = 21, .external_lex_state = 12},
  [398] = {.lex_state = 21, .external_lex_state = 11},
  [399] = {.lex_state = 21, .external_lex_state = 13},
  [400] = {.lex_state = 21, .external_lex_state = 13},
  [401] = {.lex_state = 21, .external_lex_state = 13},
  [402] = {.lex_state = 21, .external_lex_state = 12},
  [403] = {.lex_state = 21, .external_lex_state = 12},
  [404] = {.lex_state = 21, .external_lex_state = 12},
  [405] = {.lex_state = 21, .external_lex_state = 12},
  [406] = {.lex_state = 20, .external_lex_state = 15},
  [407] = {.lex_state = 21, .external_lex_state = 12},
  [408] = {.lex_state = 21, .external_lex_state = 8},
  [409] = {.lex_state = 21, .external_lex_state = 12},
  [410] = {.lex_state = 21, .external_lex_state = 12},
  [411] = {.lex_state = 21, .external_lex_state = 11},
  [412] = {.lex_state = 21, .external_lex_state = 11},
  [413] = {.lex_state = 21, .external_lex_state = 12},
  [414] = {.lex_state = 21, .external_lex_state = 12},
  [415] = {.lex_state = 21, .external_lex_state = 11},
  [416] = {.lex_state = 21, .external_lex_state = 13},
  [417] = {.lex_state = 21, .external_lex_state = 12},
  [418] = {.lex_state = 21, .external_lex_state = 12},
  [419] = {.lex_state = 21, .external_lex_state = 13},
  [420] = {.lex_state = 21, .external_lex_state = 11},
  [421] = {.lex_state = 21, .external_lex_state = 11},
  [422] = {.lex_state = 21, .external_lex_state = 11},
  [423] = {.lex_state = 21, .external_lex_state = 11},
  [424] = {.lex_state = 21, .external_lex_state = 12},
  [425] = {.lex_state = 21, .external_lex_state = 11},
  [426] = {.lex_state = 21, .external_lex_state = 11},
  [427] = {.lex_state = 21, .external_lex_state = 11},
  [428] = {.lex_state = 21, .external_lex_state = 11},
  [429] = {.lex_state = 21, .external_lex_state = 12},
  [430] = {.lex_state = 21, .external_lex_state = 12},
  [431] = {.lex_state = 21, .external_lex_state = 12},
  [432] = {.lex_state = 21, .external_lex_state = 11},
  [433] = {.lex_state = 20, .external_lex_state = 15},
  [434] = {.lex_state = 21, .external_lex_state = 11},
  [435] = {.lex_state = 21, .external_lex_state = 11},
  [436] = {.lex_state = 21, .external_lex_state = 12},
  [437] = {.lex_state = 21, .external_lex_state = 12},
  [438] = {.lex_state = 21, .external_lex_state = 11},
  [439] = {.lex_state = 21, .external_lex_state = 12},
  [440] = {.lex_state = 21, .external_lex_state = 13},
  [441] = {.lex_state = 20, .external_lex_state = 15},
  [442] = {.lex_state = 21, .external_lex_state = 10},
  [443] = {.lex_state = 21, .external_lex_state = 10},
  [444] = {.lex_state = 20, .external_lex_state = 15},
  [445] = {.lex_state = 21, .external_lex_state = 10},
  [446] = {.lex_state = 21, .external_lex_state = 10},
  [447] = {.lex_state = 20, .external_lex_state = 15},
  [448] = {.lex_state = 20, .external_lex_state = 15},
  [449] = {.lex_state = 20, .external_lex_state = 15},
  [450] = {.lex_state = 20, .external_lex_state = 15},
  [451] = {.lex_state = 20, .external_lex_state = 15},
  [452] = {.lex_state = 21, .external_lex_state = 13},
  [453] = {.lex_state = 20, .external_lex_state = 15},
  [454] = {.lex_state = 21, .external_lex_state = 10},
  [455] = {.lex_state = 21, .external_lex_state = 10},
  [456] = {.lex_state = 21, .external_lex_state = 10},
  [457] = {.lex_state = 21, .external_lex_state = 10},
  [458] = {.lex_state = 21, .external_lex_state = 10},
  [459] = {.lex_state = 21, .external_lex_state = 10},
  [460] = {.lex_state = 21, .external_lex_state = 10},
  [461] = {.lex_state = 21, .external_lex_state = 10},
  [462] = {.lex_state = 21, .external_lex_state = 10},
  [463] = {.lex_state = 21, .external_lex_state = 10},
  [464] = {.lex_state = 20, .external_lex_state = 15},
  [465] = {.lex_state = 21, .external_lex_state = 10},
  [466] = {.lex_state = 21, .external_lex_state = 10},
  [467] = {.lex_state = 21, .external_lex_state = 10},
  [468] = {.lex_state = 21, .external_lex_state = 10},
  [469] = {.lex_state = 21, .external_lex_state = 10},
  [470] = {.lex_state = 21, .external_lex_state = 10},
  [471] = {.lex_state = 21, .external_lex_state = 10},
  [472] = {.lex_state = 21, .external_lex_state = 10},
  [473] = {.lex_state = 21, .external_lex_state = 10},
  [474] = {.lex_state = 21, .external_lex_state = 10},
  [475] = {.lex_state = 21, .external_lex_state = 10},
  [476] = {.lex_state = 21, .external_lex_state = 10},
  [477] = {.lex_state = 20, .external_lex_state = 15},
  [478] = {.lex_state = 21, .external_lex_state = 10},
  [479] = {.lex_state = 21, .external_lex_state = 10},
  [480] = {.lex_state = 20, .external_lex_state = 15},
  [481] = {.lex_state = 20, .external_lex_state = 15},
  [482] = {.lex_state = 21, .external_lex_state = 12},
  [483] = {.lex_state = 21, .external_lex_state = 11},
  [484] = {.lex_state = 20, .external_lex_state = 15},
  [485] = {.lex_state = 20, .external_lex_state = 15},
  [486] = {.lex_state = 21, .external_lex_state = 10},
  [487] = {.lex_state = 20, .external_lex_state = 15},
  [488] = {.lex_state = 21, .external_lex_state = 10},
  [489] = {.lex_state = 21, .external_lex_state = 10},
  [490] = {.lex_state = 21, .external_lex_state = 10},
  [491] = {.lex_state = 21, .external_lex_state = 10},
  [492] = {.lex_state = 21, .external_lex_state = 10},
  [493] = {.lex_state = 21, .external_lex_state = 10},
  [494] = {.lex_state = 21, .external_lex_state = 10},
  [495] = {.lex_state = 20, .external_lex_state = 15},
  [496] = {.lex_state = 21, .external_lex_state = 10},
  [497] = {.lex_state = 21, .external_lex_state = 10},
  [498] = {.lex_state = 21, .external_lex_state = 10},
  [499] = {.lex_state = 21, .external_lex_state = 10},
  [500] = {.lex_state = 21, .external_lex_state = 10},
  [501] = {.lex_state = 21, .external_lex_state = 10},
  [502] = {.lex_state = 21, .external_lex_state = 10},
  [503] = {.lex_state = 20, .external_lex_state = 15},
  [504] = {.lex_state = 20, .external_lex_state = 15},
  [505] = {.lex_state = 20, .external_lex_state = 15},
  [506] = {.lex_state = 20, .external_lex_state = 15},
  [507] = {.lex_state = 20, .external_lex_state = 15},
  [508] = {.lex_state = 20, .external_lex_state = 15},
  [509] = {.lex_state = 20, .external_lex_state = 15},
  [510] = {.lex_state = 20, .external_lex_state = 15},
  [511] = {.lex_state = 20, .external_lex_state = 15},
  [512] = {.lex_state = 20, .external_lex_state = 15},
  [513] = {.lex_state = 20, .external_lex_state = 15},
  [514] = {.lex_state = 20, .external_lex_state = 15},
  [515] = {.lex_state = 20, .external_lex_state = 15},
  [516] = {.lex_state = 23, .external_lex_state = 16},
  [517] = {.lex_state = 21, .external_lex_state = 16},
  [518] = {.lex_state = 23, .external_lex_state = 16},
  [519] = {.lex_state = 23, .external_lex_state = 16},
  [520] = {.lex_state = 20, .external_lex_state = 17},
  [521] = {.lex_state = 21, .external_lex_state = 11},
  [522] = {.lex_state = 21, .external_lex_state = 12},
  [523] = {.lex_state = 21, .external_lex_state = 10},
  [524] = {.lex_state = 21, .external_lex_state = 10},
  [525] = {.lex_state = 21, .external_lex_state = 10},
  [526] = {.lex_state = 21, .external_lex_state = 16},
  [527] = {.lex_state = 23, .external_lex_state = 16},
  [528] = {.lex_state = 21, .external_lex_state = 16},
  [529] = {.lex_state = 23, .external_lex_state = 16},
  [530] = {.lex_state = 21, .external_lex_state = 16},
  [531] = {.lex_state = 23, .external_lex_state = 16},
  [532] = {.lex_state = 21, .external_lex_state = 16},
  [533] = {.lex_state = 23, .external_lex_state = 16},
  [534] = {.lex_state = 21, .external_lex_state = 16},
  [535] = {.lex_state = 23, .external_lex_state = 16},
  [536] = {.lex_state = 23, .external_lex_state = 16},
  [537] = {.lex_state = 23, .external_lex_state = 16},
  [538] = {.lex_state = 21, .external_lex_state = 16},
  [539] = {.lex_state = 23, .external_lex_state = 16},
  [540] = {.lex_state = 20, .external_lex_state = 18},
  [541] = {.lex_state = 21, .external_lex_state = 13},
  [542] = {.lex_state = 21, .external_lex_state = 16},
  [543] = {.lex_state = 21, .external_lex_state = 16},
  [544] = {.lex_state = 23, .external_lex_state = 16},
  [545] = {.lex_state = 21, .external_lex_state = 16},
  [546] = {.lex_state = 23, .external_lex_state = 16},
  [547] = {.lex_state = 21, .external_lex_state = 16},
  [548] = {.lex_state = 23, .external_lex_state = 16},
  [549] = {.lex_state = 21, .external_lex_state = 16},
  [550] = {.lex_state = 21, .external_lex_state = 16},
  [551] = {.lex_state = 23, .external_lex_state = 16},
  [552] = {.lex_state = 23, .external_lex_state = 16},
  [553] = {.lex_state = 20, .external_lex_state = 15},
  [554] = {.lex_state = 21, .external_lex_state = 16},
  [555] = {.lex_state = 23, .external_lex_state = 16},
  [556] = {.lex_state = 21, .external_lex_state = 16},
  [557] = {.lex_state = 21, .external_lex_state = 16},
  [558] = {.lex_state = 23, .external_lex_state = 16},
  [559] = {.lex_state = 21, .external_lex_state = 16},
  [560] = {.lex_state = 21, .external_lex_state = 16},
  [561] = {.lex_state = 20, .external_lex_state = 15},
  [562] = {.lex_state = 21, .external_lex_state = 12},
  [563] = {.lex_state = 21, .external_lex_state = 12},
  [564] = {.lex_state = 21, .external_lex_state = 11},
  [565] = {.lex_state = 21, .external_lex_state = 12},
  [566] = {.lex_state = 21, .external_lex_state = 11},
  [567] = {.lex_state = 21, .external_lex_state = 11},
  [568] = {.lex_state = 21, .external_lex_state = 11},
  [569] = {.lex_state = 21, .external_lex_state = 11},
  [570] = {.lex_state = 21, .external_lex_state = 11},
  [571] = {.lex_state = 21, .external_lex_state = 11},
  [572] = {.lex_state = 21, .external_lex_state = 11},
  [573] = {.lex_state = 21, .external_lex_state = 11},
  [574] = {.lex_state = 20, .external_lex_state = 15},
  [575] = {.lex_state = 21, .external_lex_state = 11},
  [576] = {.lex_state = 21, .external_lex_state = 11},
  [577] = {.lex_state = 21, .external_lex_state = 12},
  [578] = {.lex_state = 20, .external_lex_state = 15},
  [579] = {.lex_state = 21, .external_lex_state = 12},
  [580] = {.lex_state = 21, .external_lex_state = 11},
  [581] = {.lex_state = 21, .external_lex_state = 11},
  [582] = {.lex_state = 21, .external_lex_state = 11},
  [583] = {.lex_state = 21, .external_lex_state = 11},
  [584] = {.lex_state = 20, .external_lex_state = 15},
  [585] = {.lex_state = 21, .external_lex_state = 11},
  [586] = {.lex_state = 21, .external_lex_state = 11},
  [587] = {.lex_state = 21, .external_lex_state = 11},
  [588] = {.lex_state = 21, .external_lex_state = 12},
  [589] = {.lex_state = 21, .external_lex_state = 11},
  [590] = {.lex_state = 20, .external_lex_state = 15},
  [591] = {.lex_state = 21, .external_lex_state = 12},
  [592] = {.lex_state = 20, .external_lex_state = 15},
  [593] = {.lex_state = 21, .external_lex_state = 11},
  [594] = {.lex_state = 21, .external_lex_state = 12},
  [595] = {.lex_state = 21, .external_lex_state = 13},
  [596] = {.lex_state = 21, .external_lex_state = 13},
  [597] = {.lex_state = 21, .external_lex_state = 13},
  [598] = {.lex_state = 21, .external_lex_state = 13},
  [599] = {.lex_state = 21, .external_lex_state = 13},
  [600] = {.lex_state = 21, .external_lex_state = 11},
  [601] = {.lex_state = 21, .external_lex_state = 13},
  [602] = {.lex_state = 21, .external_lex_state = 11},
  [603] = {.lex_state = 21, .external_lex_state = 13},
  [604] = {.lex_state = 21, .external_lex_state = 13},
  [605] = {.lex_state = 21, .external_lex_state = 11},
  [606] = {.lex_state = 20, .external_lex_state = 15},
  [607] = {.lex_state = 21, .external_lex_state = 13},
  [608] = {.lex_state = 21, .external_lex_state = 12},
  [609] = {.lex_state = 21, .external_lex_state = 13},
  [610] = {.lex_state = 21, .external_lex_state = 11},
  [611] = {.lex_state = 21, .external_lex_state = 11},
  [612] = {.lex_state = 21, .external_lex_state = 11},
  [613] = {.lex_state = 20, .external_lex_state = 15},
  [614] = {.lex_state = 21, .external_lex_state = 13},
  [615] = {.lex_state = 21, .external_lex_state = 11},
  [616] = {.lex_state = 21, .external_lex_state = 11},
  [617] = {.lex_state = 21, .external_lex_state = 12},
  [618] = {.lex_state = 21, .external_lex_state = 13},
  [619] = {.lex_state = 21, .external_lex_state = 13},
  [620] = {.lex_state = 21, .external_lex_state = 13},
  [621] = {.lex_state = 21, .external_lex_state = 12},
  [622] = {.lex_state = 21, .external_lex_state = 11},
  [623] = {.lex_state = 20, .external_lex_state = 15},
  [624] = {.lex_state = 20, .external_lex_state = 15},
  [625] = {.lex_state = 21, .external_lex_state = 12},
  [626] = {.lex_state = 21, .external_lex_state = 13},
  [627] = {.lex_state = 21, .external_lex_state = 12},
  [628] = {.lex_state = 21, .external_lex_state = 13},
  [629] = {.lex_state = 21, .external_lex_state = 13},
  [630] = {.lex_state = 21, .external_lex_state = 13},
  [631] = {.lex_state = 21, .external_lex_state = 13},
  [632] = {.lex_state = 21, .external_lex_state = 13},
  [633] = {.lex_state = 21, .external_lex_state = 13},
  [634] = {.lex_state = 21, .external_lex_state = 13},
  [635] = {.lex_state = 21, .external_lex_state = 13},
  [636] = {.lex_state = 21, .external_lex_state = 13},
  [637] = {.lex_state = 21, .external_lex_state = 12},
  [638] = {.lex_state = 20, .external_lex_state = 15},
  [639] = {.lex_state = 21, .external_lex_state = 12},
  [640] = {.lex_state = 21, .external_lex_state = 12},
  [641] = {.lex_state = 21, .external_lex_state = 12},
  [642] = {.lex_state = 21, .external_lex_state = 11},
  [643] = {.lex_state = 21, .external_lex_state = 13},
  [644] = {.lex_state = 21, .external_lex_state = 13},
  [645] = {.lex_state = 21, .external_lex_state = 13},
  [646] = {.lex_state = 21, .external_lex_state = 13},
  [647] = {.lex_state = 21, .external_lex_state = 13},
  [648] = {.lex_state = 21, .external_lex_state = 13},
  [649] = {.lex_state = 21, .external_lex_state = 13},
  [650] = {.lex_state = 21, .external_lex_state = 13},
  [651] = {.lex_state = 21, .external_lex_state = 12},
  [652] = {.lex_state = 21, .external_lex_state = 12},
  [653] = {.lex_state = 21, .external_lex_state = 12},
  [654] = {.lex_state = 20, .external_lex_state = 15},
  [655] = {.lex_state = 21, .external_lex_state = 13},
  [656] = {.lex_state = 21, .external_lex_state = 12},
  [657] = {.lex_state = 21, .external_lex_state = 12},
  [658] = {.lex_state = 21, .external_lex_state = 13},
  [659] = {.lex_state = 21, .external_lex_state = 12},
  [660] = {.lex_state = 21, .external_lex_state = 11},
  [661] = {.lex_state = 21, .external_lex_state = 12},
  [662] = {.lex_state = 21, .external_lex_state = 12},
  [663] = {.lex_state = 21, .external_lex_state = 12},
  [664] = {.lex_state = 21, .external_lex_state = 11},
  [665] = {.lex_state = 21, .external_lex_state = 11},
  [666] = {.lex_state = 21, .external_lex_state = 11},
  [667] = {.lex_state = 20, .external_lex_state = 15},
  [668] = {.lex_state = 21, .external_lex_state = 12},
  [669] = {.lex_state = 21, .external_lex_state = 13},
  [670] = {.lex_state = 20, .external_lex_state = 15},
  [671] = {.lex_state = 21, .external_lex_state = 12},
  [672] = {.lex_state = 21, .external_lex_state = 13},
  [673] = {.lex_state = 21, .external_lex_state = 12},
  [674] = {.lex_state = 21, .external_lex_state = 13},
  [675] = {.lex_state = 21, .external_lex_state = 12},
  [676] = {.lex_state = 21, .external_lex_state = 13},
  [677] = {.lex_state = 20, .external_lex_state = 15},
  [678] = {.lex_state = 21, .external_lex_state = 12},
  [679] = {.lex_state = 21, .external_lex_state = 12},
  [680] = {.lex_state = 21, .external_lex_state = 11},
  [681] = {.lex_state = 21, .external_lex_state = 13},
  [682] = {.lex_state = 21, .external_lex_state = 12},
  [683] = {.lex_state = 21, .external_lex_state = 13},
  [684] = {.lex_state = 21, .external_lex_state = 11},
  [685] = {.lex_state = 21, .external_lex_state = 12},
  [686] = {.lex_state = 20, .external_lex_state = 15},
  [687] = {.lex_state = 21, .external_lex_state = 11},
  [688] = {.lex_state = 21, .external_lex_state = 11},
  [689] = {.lex_state = 21, .external_lex_state = 12},
  [690] = {.lex_state = 20, .external_lex_state = 15},
  [691] = {.lex_state = 21, .external_lex_state = 13},
  [692] = {.lex_state = 21, .external_lex_state = 12},
  [693] = {.lex_state = 21, .external_lex_state = 12},
  [694] = {.lex_state = 21, .external_lex_state = 12},
  [695] = {.lex_state = 21, .external_lex_state = 11},
  [696] = {.lex_state = 20, .external_lex_state = 15},
  [697] = {.lex_state = 21, .external_lex_state = 12},
  [698] = {.lex_state = 21, .external_lex_state = 12},
  [699] = {.lex_state = 21, .external_lex_state = 12},
  [700] = {.lex_state = 21, .external_lex_state = 13},
  [701] = {.lex_state = 21, .external_lex_state = 12},
  [702] = {.lex_state = 21, .external_lex_state = 12},
  [703] = {.lex_state = 21, .external_lex_state = 11},
  [704] = {.lex_state = 21, .external_lex_state = 11},
  [705] = {.lex_state = 21, .external_lex_state = 11},
  [706] = {.lex_state = 21, .external_lex_state = 11},
  [707] = {.lex_state = 21, .external_lex_state = 13},
  [708] = {.lex_state = 23, .external_lex_state = 16},
  [709] = {.lex_state = 21, .external_lex_state = 13},
  [710] = {.lex_state = 21, .external_lex_state = 13},
  [711] = {.lex_state = 21, .external_lex_state = 13},
  [712] = {.lex_state = 20, .external_lex_state = 15},
  [713] = {.lex_state = 20, .external_lex_state = 15},
  [714] = {.lex_state = 20, .external_lex_state = 15},
  [715] = {.lex_state = 20, .external_lex_state = 15},
  [716] = {.lex_state = 20, .external_lex_state = 15},
  [717] = {.lex_state = 21, .external_lex_state = 11},
  [718] = {.lex_state = 21, .external_lex_state = 11},
  [719] = {.lex_state = 21, .external_lex_state = 11},
  [720] = {.lex_state = 21, .external_lex_state = 12},
  [721] = {.lex_state = 21, .external_lex_state = 12},
  [722] = {.lex_state = 20, .external_lex_state = 15},
  [723] = {.lex_state = 20, .external_lex_state = 15},
  [724] = {.lex_state = 23, .external_lex_state = 16},
  [725] = {.lex_state = 21, .external_lex_state = 12},
  [726] = {.lex_state = 23, .external_lex_state = 16},
  [727] = {.lex_state = 23, .external_lex_state = 16},
  [728] = {.lex_state = 20, .external_lex_state = 15},
  [729] = {.lex_state = 23, .external_lex_state = 16},
  [730] = {.lex_state = 20, .external_lex_state = 15},
  [731] = {.lex_state = 23, .external_lex_state = 16},
  [732] = {.lex_state = 23, .external_lex_state = 16},
  [733] = {.lex_state = 23, .external_lex_state = 16},
  [734] = {.lex_state = 23, .external_lex_state = 16},
  [735] = {.lex_state = 23, .external_lex_state = 16},
  [736] = {.lex_state = 23, .external_lex_state = 16},
  [737] = {.lex_state = 23, .external_lex_state = 16},
  [738] = {.lex_state = 23, .external_lex_state = 16},
  [739] = {.lex_state = 23, .external_lex_state = 16},
  [740] = {.lex_state = 23, .external_lex_state = 16},
  [741] = {.lex_state = 23, .external_lex_state = 16},
  [742] = {.lex_state = 23, .external_lex_state = 16},
  [743] = {.lex_state = 23, .external_lex_state = 16},
  [744] = {.lex_state = 23, .external_lex_state = 16},
  [745] = {.lex_state = 23, .external_lex_state = 16},
  [746] = {.lex_state = 23, .external_lex_state = 16},
  [747] = {.lex_state = 23, .external_lex_state = 16},
  [748] = {.lex_state = 20, .external_lex_state = 15},
  [749] = {.lex_state = 23, .external_lex_state = 16},
  [750] = {.lex_state = 23, .external_lex_state = 16},
  [751] = {.lex_state = 23, .external_lex_state = 16},
  [752] = {.lex_state = 23, .external_lex_state = 16},
  [753] = {.lex_state = 23, .external_lex_state = 16},
  [754] = {.lex_state = 23, .external_lex_state = 16},
  [755] = {.lex_state = 23, .external_lex_state = 16},
  [756] = {.lex_state = 23, .external_lex_state = 16},
  [757] = {.lex_state = 23, .external_lex_state = 16},
  [758] = {.lex_state = 23, .external_lex_state = 16},
  [759] = {.lex_state = 23, .external_lex_state = 16},
  [760] = {.lex_state = 23, .external_lex_state = 16},
  [761] = {.lex_state = 23, .external_lex_state = 16},
  [762] = {.lex_state = 23, .external_lex_state = 16},
  [763] = {.lex_state = 23, .external_lex_state = 16},
  [764] = {.lex_state = 23, .external_lex_state = 16},
  [765] = {.lex_state = 23, .external_lex_state = 16},
  [766] = {.lex_state = 23, .external_lex_state = 16},
  [767] = {.lex_state = 23, .external_lex_state = 16},
  [768] = {.lex_state = 23, .external_lex_state = 16},
  [769] = {.lex_state = 23, .external_lex_state = 16},
  [770] = {.lex_state = 23, .external_lex_state = 16},
  [771] = {.lex_state = 23, .external_lex_state = 16},
  [772] = {.lex_state = 23, .external_lex_state = 16},
  [773] = {.lex_state = 23, .external_lex_state = 16},
  [774] = {.lex_state = 23, .external_lex_state = 16},
  [775] = {.lex_state = 23, .external_lex_state = 16},
  [776] = {.lex_state = 23, .external_lex_state = 16},
  [777] = {.lex_state = 23, .external_lex_state = 16},
  [778] = {.lex_state = 23, .external_lex_state = 16},
  [779] = {.lex_state = 23, .external_lex_state = 16},
  [780] = {.lex_state = 23, .external_lex_state = 16},
  [781] = {.lex_state = 20, .external_lex_state = 15},
  [782] = {.lex_state = 20, .external_lex_state = 15},
  [783] = {.lex_state = 23, .external_lex_state = 16},
  [784] = {.lex_state = 20, .external_lex_state = 15},
  [785] = {.lex_state = 20, .external_lex_state = 15},
  [786] = {.lex_state = 20, .external_lex_state = 15},
  [787] = {.lex_state = 20, .external_lex_state = 15},
  [788] = {.lex_state = 20, .external_lex_state = 15},
  [789] = {.lex_state = 20, .external_lex_state = 15},
  [790] = {.lex_state = 20, .external_lex_state = 15},
  [791] = {.lex_state = 20, .external_lex_state = 15},
  [792] = {.lex_state = 20, .external_lex_state = 15},
  [793] = {.lex_state = 20, .external_lex_state = 15},
  [794] = {.lex_state = 20, .external_lex_state = 15},
  [795] = {.lex_state = 20, .external_lex_state = 15},
  [796] = {.lex_state = 20, .external_lex_state = 15},
  [797] = {.lex_state = 20, .external_lex_state = 15},
  [798] = {.lex_state = 20, .external_lex_state = 15},
  [799] = {.lex_state = 20, .external_lex_state = 15},
  [800] = {.lex_state = 20, .external_lex_state = 15},
  [801] = {.lex_state = 20, .external_lex_state = 15},
  [802] = {.lex_state = 20, .external_lex_state = 15},
  [803] = {.lex_state = 20, .external_lex_state = 15},
  [804] = {.lex_state = 20, .external_lex_state = 15},
  [805] = {.lex_state = 20, .external_lex_state = 15},
  [806] = {.lex_state = 20, .external_lex_state = 15},
  [807] = {.lex_state = 20, .external_lex_state = 15},
  [808] = {.lex_state = 20, .external_lex_state = 15},
  [809] = {.lex_state = 20, .external_lex_state = 15},
  [810] = {.lex_state = 20, .external_lex_state = 15},
  [811] = {.lex_state = 20, .external_lex_state = 15},
  [812] = {.lex_state = 20, .external_lex_state = 15},
  [813] = {.lex_state = 20, .external_lex_state = 15},
  [814] = {.lex_state = 20, .external_lex_state = 15},
  [815] = {.lex_state = 20, .external_lex_state = 15},
  [816] = {.lex_state = 20, .external_lex_state = 15},
  [817] = {.lex_state = 20, .external_lex_state = 15},
  [818] = {.lex_state = 20, .external_lex_state = 15},
  [819] = {.lex_state = 20, .external_lex_state = 15},
  [820] = {.lex_state = 20, .external_lex_state = 15},
  [821] = {.lex_state = 20, .external_lex_state = 15},
  [822] = {.lex_state = 20, .external_lex_state = 15},
  [823] = {.lex_state = 20, .external_lex_state = 15},
  [824] = {.lex_state = 20, .external_lex_state = 15},
  [825] = {.lex_state = 20, .external_lex_state = 15},
  [826] = {.lex_state = 20, .external_lex_state = 15},
  [827] = {.lex_state = 20, .external_lex_state = 15},
  [828] = {.lex_state = 20, .external_lex_state = 15},
  [829] = {.lex_state = 20, .external_lex_state = 15},
  [830] = {.lex_state = 20, .external_lex_state = 15},
  [831] = {.lex_state = 20, .external_lex_state = 15},
  [832] = {.lex_state = 20, .external_lex_state = 15},
  [833] = {.lex_state = 20, .external_lex_state = 15},
  [834] = {.lex_state = 20, .external_lex_state = 15},
  [835] = {.lex_state = 20, .external_lex_state = 15},
  [836] = {.lex_state = 20, .external_lex_state = 15},
  [837] = {.lex_state = 20, .external_lex_state = 15},
  [838] = {.lex_state = 20, .external_lex_state = 15},
  [839] = {.lex_state = 20, .external_lex_state = 15},
  [840] = {.lex_state = 20, .external_lex_state = 15},
  [841] = {.lex_state = 20, .external_lex_state = 15},
  [842] = {.lex_state = 20, .external_lex_state = 15},
  [843] = {.lex_state = 20, .external_lex_state = 15},
  [844] = {.lex_state = 20, .external_lex_state = 15},
  [845] = {.lex_state = 20, .external_lex_state = 15},
  [846] = {.lex_state = 20, .external_lex_state = 15},
  [847] = {.lex_state = 20, .external_lex_state = 15},
  [848] = {.lex_state = 20, .external_lex_state = 15},
  [849] = {.lex_state = 20, .external_lex_state = 15},
  [850] = {.lex_state = 20, .external_lex_state = 15},
  [851] = {.lex_state = 20, .external_lex_state = 15},
  [852] = {.lex_state = 20, .external_lex_state = 15},
  [853] = {.lex_state = 20, .external_lex_state = 15},
  [854] = {.lex_state = 20, .external_lex_state = 15},
  [855] = {.lex_state = 20, .external_lex_state = 15},
  [856] = {.lex_state = 20, .external_lex_state = 15},
  [857] = {.lex_state = 20, .external_lex_state = 15},
  [858] = {.lex_state = 20, .external_lex_state = 15},
  [859] = {.lex_state = 20, .external_lex_state = 15},
  [860] = {.lex_state = 20, .external_lex_state = 15},
  [861] = {.lex_state = 20, .external_lex_state = 15},
  [862] = {.lex_state = 20, .external_lex_state = 15},
  [863] = {.lex_state = 20, .external_lex_state = 15},
  [864] = {.lex_state = 20, .external_lex_state = 15},
  [865] = {.lex_state = 20, .external_lex_state = 15},
  [866] = {.lex_state = 20, .external_lex_state = 15},
  [867] = {.lex_state = 20, .external_lex_state = 15},
  [868] = {.lex_state = 20, .external_lex_state = 15},
  [869] = {.lex_state = 20, .external_lex_state = 15},
  [870] = {.lex_state = 20, .external_lex_state = 15},
  [871] = {.lex_state = 20, .external_lex_state = 15},
  [872] = {.lex_state = 20, .external_lex_state = 15},
  [873] = {.lex_state = 20, .external_lex_state = 15},
  [874] = {.lex_state = 20, .external_lex_state = 15},
  [875] = {.lex_state = 20, .external_lex_state = 15},
  [876] = {.lex_state = 20, .external_lex_state = 15},
  [877] = {.lex_state = 20, .external_lex_state = 15},
  [878] = {.lex_state = 20, .external_lex_state = 15},
  [879] = {.lex_state = 20, .external_lex_state = 15},
  [880] = {.lex_state = 20, .external_lex_state = 15},
  [881] = {.lex_state = 20, .external_lex_state = 15},
  [882] = {.lex_state = 20, .external_lex_state = 15},
  [883] = {.lex_state = 20, .external_lex_state = 15},
  [884] = {.lex_state = 20, .external_lex_state = 15},
  [885] = {.lex_state = 20, .external_lex_state = 15},
  [886] = {.lex_state = 23, .external_lex_state = 16},
  [887] = {.lex_state = 20, .external_lex_state = 15},
  [888] = {.lex_state = 20, .external_lex_state = 15},
  [889] = {.lex_state = 20, .external_lex_state = 15},
  [890] = {.lex_state = 20, .external_lex_state = 15},
  [891] = {.lex_state = 20, .external_lex_state = 15},
  [892] = {.lex_state = 20, .external_lex_state = 15},
  [893] = {.lex_state = 20, .external_lex_state = 15},
  [894] = {.lex_state = 20, .external_lex_state = 15},
  [895] = {.lex_state = 20, .external_lex_state = 15},
  [896] = {.lex_state = 20, .external_lex_state = 15},
  [897] = {.lex_state = 20, .external_lex_state = 15},
  [898] = {.lex_state = 20, .external_lex_state = 15},
  [899] = {.lex_state = 20, .external_lex_state = 15},
  [900] = {.lex_state = 20, .external_lex_state = 15},
  [901] = {.lex_state = 20, .external_lex_state = 15},
  [902] = {.lex_state = 20, .external_lex_state = 15},
  [903] = {.lex_state = 20, .external_lex_state = 15},
  [904] = {.lex_state = 20, .external_lex_state = 15},
  [905] = {.lex_state = 20, .external_lex_state = 15},
  [906] = {.lex_state = 20, .external_lex_state = 15},
  [907] = {.lex_state = 20, .external_lex_state = 15},
  [908] = {.lex_state = 20, .external_lex_state = 15},
  [909] = {.lex_state = 20, .external_lex_state = 15},
  [910] = {.lex_state = 20, .external_lex_state = 15},
  [911] = {.lex_state = 20, .external_lex_state = 15},
  [912] = {.lex_state = 20, .external_lex_state = 15},
  [913] = {.lex_state = 20, .external_lex_state = 15},
  [914] = {.lex_state = 20, .external_lex_state = 15},
  [915] = {.lex_state = 20, .external_lex_state = 15},
  [916] = {.lex_state = 20, .external_lex_state = 15},
  [917] = {.lex_state = 20, .external_lex_state = 15},
  [918] = {.lex_state = 20, .external_lex_state = 15},
  [919] = {.lex_state = 20, .external_lex_state = 15},
  [920] = {.lex_state = 20, .external_lex_state = 15},
  [921] = {.lex_state = 20, .external_lex_state = 15},
  [922] = {.lex_state = 20, .external_lex_state = 15},
  [923] = {.lex_state = 20, .external_lex_state = 15},
  [924] = {.lex_state = 20, .external_lex_state = 15},
  [925] = {.lex_state = 20, .external_lex_state = 15},
  [926] = {.lex_state = 20, .external_lex_state = 15},
  [927] = {.lex_state = 20, .external_lex_state = 15},
  [928] = {.lex_state = 20, .external_lex_state = 15},
  [929] = {.lex_state = 20, .external_lex_state = 15},
  [930] = {.lex_state = 20, .external_lex_state = 15},
  [931] = {.lex_state = 20, .external_lex_state = 15},
  [932] = {.lex_state = 20, .external_lex_state = 15},
  [933] = {.lex_state = 20, .external_lex_state = 15},
  [934] = {.lex_state = 20, .external_lex_state = 15},
  [935] = {.lex_state = 20, .external_lex_state = 15},
  [936] = {.lex_state = 20, .external_lex_state = 15},
  [937] = {.lex_state = 20, .external_lex_state = 15},
  [938] = {.lex_state = 20, .external_lex_state = 15},
  [939] = {.lex_state = 20, .external_lex_state = 15},
  [940] = {.lex_state = 20, .external_lex_state = 15},
  [941] = {.lex_state = 20, .external_lex_state = 15},
  [942] = {.lex_state = 20, .external_lex_state = 15},
  [943] = {.lex_state = 20, .external_lex_state = 15},
  [944] = {.lex_state = 20, .external_lex_state = 15},
  [945] = {.lex_state = 20, .external_lex_state = 15},
  [946] = {.lex_state = 20, .external_lex_state = 15},
  [947] = {.lex_state = 20, .external_lex_state = 15},
  [948] = {.lex_state = 20, .external_lex_state = 15},
  [949] = {.lex_state = 20, .external_lex_state = 15},
  [950] = {.lex_state = 20, .external_lex_state = 15},
  [951] = {.lex_state = 20, .external_lex_state = 15},
  [952] = {.lex_state = 20, .external_lex_state = 15},
  [953] = {.lex_state = 20, .external_lex_state = 15},
  [954] = {.lex_state = 20, .external_lex_state = 15},
  [955] = {.lex_state = 20, .external_lex_state = 15},
  [956] = {.lex_state = 20, .external_lex_state = 15},
  [957] = {.lex_state = 20, .external_lex_state = 15},
  [958] = {.lex_state = 20, .external_lex_state = 15},
  [959] = {.lex_state = 20, .external_lex_state = 15},
  [960] = {.lex_state = 20, .external_lex_state = 15},
  [961] = {.lex_state = 20, .external_lex_state = 15},
  [962] = {.lex_state = 20, .external_lex_state = 15},
  [963] = {.lex_state = 20, .external_lex_state = 15},
  [964] = {.lex_state = 20, .external_lex_state = 15},
  [965] = {.lex_state = 20, .external_lex_state = 15},
  [966] = {.lex_state = 20, .external_lex_state = 15},
  [967] = {.lex_state = 20, .external_lex_state = 15},
  [968] = {.lex_state = 20, .external_lex_state = 15},
  [969] = {.lex_state = 20, .external_lex_state = 15},
  [970] = {.lex_state = 20, .external_lex_state = 15},
  [971] = {.lex_state = 20, .external_lex_state = 15},
  [972] = {.lex_state = 20, .external_lex_state = 15},
  [973] = {.lex_state = 20, .external_lex_state = 15},
  [974] = {.lex_state = 20, .external_lex_state = 15},
  [975] = {.lex_state = 20, .external_lex_state = 15},
  [976] = {.lex_state = 20, .external_lex_state = 15},
  [977] = {.lex_state = 20, .external_lex_state = 15},
  [978] = {.lex_state = 20, .external_lex_state = 15},
  [979] = {.lex_state = 20, .external_lex_state = 15},
  [980] = {.lex_state = 20, .external_lex_state = 15},
  [981] = {.lex_state = 20, .external_lex_state = 15},
  [982] = {.lex_state = 20, .external_lex_state = 15},
  [983] = {.lex_state = 20, .external_lex_state = 15},
  [984] = {.lex_state = 20, .external_lex_state = 15},
  [985] = {.lex_state = 20, .external_lex_state = 15},
  [986] = {.lex_state = 20, .external_lex_state = 15},
  [987] = {.lex_state = 20, .external_lex_state = 15},
  [988] = {.lex_state = 20, .external_lex_state = 15},
  [989] = {.lex_state = 20, .external_lex_state = 15},
  [990] = {.lex_state = 20, .external_lex_state = 15},
  [991] = {.lex_state = 20, .external_lex_state = 15},
  [992] = {.lex_state = 20, .external_lex_state = 15},
  [993] = {.lex_state = 20, .external_lex_state = 15},
  [994] = {.lex_state = 20, .external_lex_state = 15},
  [995] = {.lex_state = 20, .external_lex_state = 15},
  [996] = {.lex_state = 20, .external_lex_state = 15},
  [997] = {.lex_state = 20, .external_lex_state = 15},
  [998] = {.lex_state = 20, .external_lex_state = 15},
  [999] = {.lex_state = 20, .external_lex_state = 15},
  [1000] = {.lex_state = 20, .external_lex_state = 15},
  [1001] = {.lex_state = 20, .external_lex_state = 15},
  [1002] = {.lex_state = 20, .external_lex_state = 15},
  [1003] = {.lex_state = 20, .external_lex_state = 15},
  [1004] = {.lex_state = 20, .external_lex_state = 15},
  [1005] = {.lex_state = 20, .external_lex_state = 15},
  [1006] = {.lex_state = 20, .external_lex_state = 15},
  [1007] = {.lex_state = 20, .external_lex_state = 15},
  [1008] = {.lex_state = 20, .external_lex_state = 15},
  [1009] = {.lex_state = 20, .external_lex_state = 15},
  [1010] = {.lex_state = 20, .external_lex_state = 15},
  [1011] = {.lex_state = 20, .external_lex_state = 15},
  [1012] = {.lex_state = 20, .external_lex_state = 15},
  [1013] = {.lex_state = 20, .external_lex_state = 15},
  [1014] = {.lex_state = 20, .external_lex_state = 15},
  [1015] = {.lex_state = 20, .external_lex_state = 15},
  [1016] = {.lex_state = 20, .external_lex_state = 15},
  [1017] = {.lex_state = 20, .external_lex_state = 15},
  [1018] = {.lex_state = 20, .external_lex_state = 15},
  [1019] = {.lex_state = 20, .external_lex_state = 15},
  [1020] = {.lex_state = 20, .external_lex_state = 15},
  [1021] = {.lex_state = 23, .external_lex_state = 16},
  [1022] = {.lex_state = 23, .external_lex_state = 16},
  [1023] = {.lex_state = 23, .external_lex_state = 16},
  [1024] = {.lex_state = 23, .external_lex_state = 16},
  [1025] = {.lex_state = 23, .external_lex_state = 16},
  [1026] = {.lex_state = 23, .external_lex_state = 16},
  [1027] = {.lex_state = 23, .external_lex_state = 16},
  [1028] = {.lex_state = 23, .external_lex_state = 16},
  [1029] = {.lex_state = 23, .external_lex_state = 16},
  [1030] = {.lex_state = 23, .external_lex_state = 16},
  [1031] = {.lex_state = 23, .external_lex_state = 16},
  [1032] = {.lex_state = 23, .external_lex_state = 16},
  [1033] = {.lex_state = 23, .external_lex_state = 16},
  [1034] = {.lex_state = 23, .external_lex_state = 16},
  [1035] = {.lex_state = 23, .external_lex_state = 16},
  [1036] = {.lex_state = 23, .external_lex_state = 16},
  [1037] = {.lex_state = 23, .external_lex_state = 16},
  [1038] = {.lex_state = 23, .external_lex_state = 16},
  [1039] = {.lex_state = 23, .external_lex_state = 16},
  [1040] = {.lex_state = 23, .external_lex_state = 16},
  [1041] = {.lex_state = 23, .external_lex_state = 16},
  [1042] = {.lex_state = 23, .external_lex_state = 16},
  [1043] = {.lex_state = 23, .external_lex_state = 16},
  [1044] = {.lex_state = 23, .external_lex_state = 16},
  [1045] = {.lex_state = 23, .external_lex_state = 16},
  [1046] = {.lex_state = 23, .external_lex_state = 16},
  [1047] = {.lex_state = 23, .external_lex_state = 16},
  [1048] = {.lex_state = 23, .external_lex_state = 16},
  [1049] = {.lex_state = 23, .external_lex_state = 16},
  [1050] = {.lex_state = 23, .external_lex_state = 16},
  [1051] = {.lex_state = 23, .external_lex_state = 16},
  [1052] = {.lex_state = 23, .external_lex_state = 16},
  [1053] = {.lex_state = 23, .external_lex_state = 16},
  [1054] = {.lex_state = 23, .external_lex_state = 16},
  [1055] = {.lex_state = 23, .external_lex_state = 16},
  [1056] = {.lex_state = 23, .external_lex_state = 16},
  [1057] = {.lex_state = 23, .external_lex_state = 16},
  [1058] = {.lex_state = 23, .external_lex_state = 16},
  [1059] = {.lex_state = 23, .external_lex_state = 16},
  [1060] = {.lex_state = 23, .external_lex_state = 16},
  [1061] = {.lex_state = 23, .external_lex_state = 16},
  [1062] = {.lex_state = 23, .external_lex_state = 16},
  [1063] = {.lex_state = 23, .external_lex_state = 16},
  [1064] = {.lex_state = 23, .external_lex_state = 16},
  [1065] = {.lex_state = 23, .external_lex_state = 16},
  [1066] = {.lex_state = 23, .external_lex_state = 16},
  [1067] = {.lex_state = 23, .external_lex_state = 16},
  [1068] = {.lex_state = 23, .external_lex_state = 16},
  [1069] = {.lex_state = 23, .external_lex_state = 16},
  [1070] = {.lex_state = 23, .external_lex_state = 16},
  [1071] = {.lex_state = 23, .external_lex_state = 16},
  [1072] = {.lex_state = 23, .external_lex_state = 16},
  [1073] = {.lex_state = 23, .external_lex_state = 16},
  [1074] = {.lex_state = 23, .external_lex_state = 16},
  [1075] = {.lex_state = 23, .external_lex_state = 16},
  [1076] = {.lex_state = 23, .external_lex_state = 16},
  [1077] = {.lex_state = 23, .external_lex_state = 16},
  [1078] = {.lex_state = 23, .external_lex_state = 16},
  [1079] = {.lex_state = 23, .external_lex_state = 16},
  [1080] = {.lex_state = 23, .external_lex_state = 16},
  [1081] = {.lex_state = 23, .external_lex_state = 16},
  [1082] = {.lex_state = 23, .external_lex_state = 16},
  [1083] = {.lex_state = 23, .external_lex_state = 16},
  [1084] = {.lex_state = 23, .external_lex_state = 16},
  [1085] = {.lex_state = 23, .external_lex_state = 16},
  [1086] = {.lex_state = 23, .external_lex_state = 16},
  [1087] = {.lex_state = 23, .external_lex_state = 16},
  [1088] = {.lex_state = 21, .external_lex_state = 19},
  [1089] = {.lex_state = 21, .external_lex_state = 19},
  [1090] = {.lex_state = 21, .external_lex_state = 19},
  [1091] = {.lex_state = 23, .external_lex_state = 16},
  [1092] = {.lex_state = 23, .external_lex_state = 16},
  [1093] = {.lex_state = 23, .external_lex_state = 16},
  [1094] = {.lex_state = 23, .external_lex_state = 16},
  [1095] = {.lex_state = 23, .external_lex_state = 16},
  [1096] = {.lex_state = 23, .external_lex_state = 16},
  [1097] = {.lex_state = 23, .external_lex_state = 16},
  [1098] = {.lex_state = 21, .external_lex_state = 20},
  [1099] = {.lex_state = 23, .external_lex_state = 16},
  [1100] = {.lex_state = 21, .external_lex_state = 20},
  [1101] = {.lex_state = 21, .external_lex_state = 20},
  [1102] = {.lex_state = 23, .external_lex_state = 16},
  [1103] = {.lex_state = 23, .external_lex_state = 16},
  [1104] = {.lex_state = 23, .external_lex_state = 16},
  [1105] = {.lex_state = 23, .external_lex_state = 16},
  [1106] = {.lex_state = 23, .external_lex_state = 16},
  [1107] = {.lex_state = 23, .external_lex_state = 16},
  [1108] = {.lex_state = 23, .external_lex_state = 16},
  [1109] = {.lex_state = 23, .external_lex_state = 16},
  [1110] = {.lex_state = 23, .external_lex_state = 16},
  [1111] = {.lex_state = 23, .external_lex_state = 16},
  [1112] = {.lex_state = 23, .external_lex_state = 16},
  [1113] = {.lex_state = 23, .external_lex_state = 16},
  [1114] = {.lex_state = 23, .external_lex_state = 16},
  [1115] = {.lex_state = 23, .external_lex_state = 16},
  [1116] = {.lex_state = 23, .external_lex_state = 16},
  [1117] = {.lex_state = 23, .external_lex_state = 16},
  [1118] = {.lex_state = 23, .external_lex_state = 16},
  [1119] = {.lex_state = 23, .external_lex_state = 16},
  [1120] = {.lex_state = 23, .external_lex_state = 16},
  [1121] = {.lex_state = 23, .external_lex_state = 16},
  [1122] = {.lex_state = 23, .external_lex_state = 16},
  [1123] = {.lex_state = 23, .external_lex_state = 16},
  [1124] = {.lex_state = 23, .external_lex_state = 16},
  [1125] = {.lex_state = 23, .external_lex_state = 16},
  [1126] = {.lex_state = 23, .external_lex_state = 16},
  [1127] = {.lex_state = 23, .external_lex_state = 16},
  [1128] = {.lex_state = 23, .external_lex_state = 16},
  [1129] = {.lex_state = 23, .external_lex_state = 16},
  [1130] = {.lex_state = 21, .external_lex_state = 16},
  [1131] = {.lex_state = 21, .external_lex_state = 19},
  [1132] = {.lex_state = 21, .external_lex_state = 19},
  [1133] = {.lex_state = 21, .external_lex_state = 19},
  [1134] = {.lex_state = 21, .external_lex_state = 19},
  [1135] = {.lex_state = 21, .external_lex_state = 19},
  [1136] = {.lex_state = 21, .external_lex_state = 19},
  [1137] = {.lex_state = 21, .external_lex_state = 19},
  [1138] = {.lex_state = 23, .external_lex_state = 16},
  [1139] = {.lex_state = 21, .external_lex_state = 19},
  [1140] = {.lex_state = 21, .external_lex_state = 19},
  [1141] = {.lex_state = 21, .external_lex_state = 19},
  [1142] = {.lex_state = 23, .external_lex_state = 16},
  [1143] = {.lex_state = 21, .external_lex_state = 19},
  [1144] = {.lex_state = 21, .external_lex_state = 19},
  [1145] = {.lex_state = 21, .external_lex_state = 19},
  [1146] = {.lex_state = 21, .external_lex_state = 19},
  [1147] = {.lex_state = 21, .external_lex_state = 19},
  [1148] = {.lex_state = 21, .external_lex_state = 19},
  [1149] = {.lex_state = 21, .external_lex_state = 19},
  [1150] = {.lex_state = 21, .external_lex_state = 20},
  [1151] = {.lex_state = 21, .external_lex_state = 20},
  [1152] = {.lex_state = 21, .external_lex_state = 21},
  [1153] = {.lex_state = 21, .external_lex_state = 20},
  [1154] = {.lex_state = 21, .external_lex_state = 20},
  [1155] = {.lex_state = 23, .external_lex_state = 22},
  [1156] = {.lex_state = 21, .external_lex_state = 20},
  [1157] = {.lex_state = 21, .external_lex_state = 20},
  [1158] = {.lex_state = 23, .external_lex_state = 3},
  [1159] = {.lex_state = 21, .external_lex_state = 20},
  [1160] = {.lex_state = 21, .external_lex_state = 20},
  [1161] = {.lex_state = 21, .external_lex_state = 23},
  [1162] = {.lex_state = 21, .external_lex_state = 23},
  [1163] = {.lex_state = 21, .external_lex_state = 23},
  [1164] = {.lex_state = 21, .external_lex_state = 20},
  [1165] = {.lex_state = 21, .external_lex_state = 20},
  [1166] = {.lex_state = 21, .external_lex_state = 20},
  [1167] = {.lex_state = 21, .external_lex_state = 20},
  [1168] = {.lex_state = 21, .external_lex_state = 20},
  [1169] = {.lex_state = 21, .external_lex_state = 21},
  [1170] = {.lex_state = 21, .external_lex_state = 21},
  [1171] = {.lex_state = 21, .external_lex_state = 20},
  [1172] = {.lex_state = 21, .external_lex_state = 20},
  [1173] = {.lex_state = 21, .external_lex_state = 20},
  [1174] = {.lex_state = 23, .external_lex_state = 24},
  [1175] = {.lex_state = 21, .external_lex_state = 22},
  [1176] = {.lex_state = 21, .external_lex_state = 3},
  [1177] = {.lex_state = 21, .external_lex_state = 25},
  [1178] = {.lex_state = 21, .external_lex_state = 25},
  [1179] = {.lex_state = 21, .external_lex_state = 26},
  [1180] = {.lex_state = 21, .external_lex_state = 27},
  [1181] = {.lex_state = 21, .external_lex_state = 27},
  [1182] = {.lex_state = 21, .external_lex_state = 27},
  [1183] = {.lex_state = 21, .external_lex_state = 22},
  [1184] = {.lex_state = 21, .external_lex_state = 19},
  [1185] = {.lex_state = 21, .external_lex_state = 16},
  [1186] = {.lex_state = 21, .external_lex_state = 25},
  [1187] = {.lex_state = 21, .external_lex_state = 28},
  [1188] = {.lex_state = 21, .external_lex_state = 23},
  [1189] = {.lex_state = 21, .external_lex_state = 22},
  [1190] = {.lex_state = 21, .external_lex_state = 23},
  [1191] = {.lex_state = 21, .external_lex_state = 22},
  [1192] = {.lex_state = 21, .external_lex_state = 21},
  [1193] = {.lex_state = 21, .external_lex_state = 21},
  [1194] = {.lex_state = 21, .external_lex_state = 16},
  [1195] = {.lex_state = 21, .external_lex_state = 22},
  [1196] = {.lex_state = 21, .external_lex_state = 16},
  [1197] = {.lex_state = 21, .external_lex_state = 3},
  [1198] = {.lex_state = 21, .external_lex_state = 16},
  [1199] = {.lex_state = 21, .external_lex_state = 3},
  [1200] = {.lex_state = 21, .external_lex_state = 16},
  [1201] = {.lex_state = 21, .external_lex_state = 16},
  [1202] = {.lex_state = 21, .external_lex_state = 16},
  [1203] = {.lex_state = 21, .external_lex_state = 23},
  [1204] = {.lex_state = 21, .external_lex_state = 22},
  [1205] = {.lex_state = 21, .external_lex_state = 16},
  [1206] = {.lex_state = 21, .external_lex_state = 16},
  [1207] = {.lex_state = 21, .external_lex_state = 24},
  [1208] = {.lex_state = 21, .external_lex_state = 16},
  [1209] = {.lex_state = 21, .external_lex_state = 16},
  [1210] = {.lex_state = 21, .external_lex_state = 22},
  [1211] = {.lex_state = 21, .external_lex_state = 22},
  [1212] = {.lex_state = 21, .external_lex_state = 21},
  [1213] = {.lex_state = 21, .external_lex_state = 16},
  [1214] = {.lex_state = 21, .external_lex_state = 21},
  [1215] = {.lex_state = 21, .external_lex_state = 16},
  [1216] = {.lex_state = 21, .external_lex_state = 22},
  [1217] = {.lex_state = 21, .external_lex_state = 23},
  [1218] = {.lex_state = 21, .external_lex_state = 22},
  [1219] = {.lex_state = 21, .external_lex_state = 23},
  [1220] = {.lex_state = 21, .external_lex_state = 16},
  [1221] = {.lex_state = 21, .external_lex_state = 23},
  [1222] = {.lex_state = 21, .external_lex_state = 16},
  [1223] = {.lex_state = 21, .external_lex_state = 22},
  [1224] = {.lex_state = 21, .external_lex_state = 20},
  [1225] = {.lex_state = 21, .external_lex_state = 22},
  [1226] = {.lex_state = 21, .external_lex_state = 23},
  [1227] = {.lex_state = 21, .external_lex_state = 22},
  [1228] = {.lex_state = 21, .external_lex_state = 21},
  [1229] = {.lex_state = 21, .external_lex_state = 16},
  [1230] = {.lex_state = 21, .external_lex_state = 24},
  [1231] = {.lex_state = 21, .external_lex_state = 21},
  [1232] = {.lex_state = 21, .external_lex_state = 28},
  [1233] = {.lex_state = 21, .external_lex_state = 29},
  [1234] = {.lex_state = 21, .external_lex_state = 16},
  [1235] = {.lex_state = 21, .external_lex_state = 28},
  [1236] = {.lex_state = 21, .external_lex_state = 22},
  [1237] = {.lex_state = 21, .external_lex_state = 16},
  [1238] = {.lex_state = 23, .external_lex_state = 4},
  [1239] = {.lex_state = 21, .external_lex_state = 29},
  [1240] = {.lex_state = 21, .external_lex_state = 23},
  [1241] = {.lex_state = 21, .external_lex_state = 21},
  [1242] = {.lex_state = 21, .external_lex_state = 21},
  [1243] = {.lex_state = 21, .external_lex_state = 23},
  [1244] = {.lex_state = 21, .external_lex_state = 16},
  [1245] = {.lex_state = 21, .external_lex_state = 21},
  [1246] = {.lex_state = 21, .external_lex_state = 16},
  [1247] = {.lex_state = 21, .external_lex_state = 22},
  [1248] = {.lex_state = 21, .external_lex_state = 21},
  [1249] = {.lex_state = 21, .external_lex_state = 22},
  [1250] = {.lex_state = 21, .external_lex_state = 21},
  [1251] = {.lex_state = 21, .external_lex_state = 23},
  [1252] = {.lex_state = 21, .external_lex_state = 16},
  [1253] = {.lex_state = 21, .external_lex_state = 21},
  [1254] = {.lex_state = 21, .external_lex_state = 21},
  [1255] = {.lex_state = 23, .external_lex_state = 2},
  [1256] = {.lex_state = 21, .external_lex_state = 22},
  [1257] = {.lex_state = 21, .external_lex_state = 23},
  [1258] = {.lex_state = 21, .external_lex_state = 22},
  [1259] = {.lex_state = 21, .external_lex_state = 22},
  [1260] = {.lex_state = 21, .external_lex_state = 16},
  [1261] = {.lex_state = 21, .external_lex_state = 16},
  [1262] = {.lex_state = 21, .external_lex_state = 16},
  [1263] = {.lex_state = 21, .external_lex_state = 23},
  [1264] = {.lex_state = 23, .external_lex_state = 5},
  [1265] = {.lex_state = 21, .external_lex_state = 16},
  [1266] = {.lex_state = 21, .external_lex_state = 16},
  [1267] = {.lex_state = 21, .external_lex_state = 23},
  [1268] = {.lex_state = 21, .external_lex_state = 22},
  [1269] = {.lex_state = 21, .external_lex_state = 22},
  [1270] = {.lex_state = 21, .external_lex_state = 16},
  [1271] = {.lex_state = 21, .external_lex_state = 16},
  [1272] = {.lex_state = 21, .external_lex_state = 16},
  [1273] = {.lex_state = 21, .external_lex_state = 22},
  [1274] = {.lex_state = 21, .external_lex_state = 21},
  [1275] = {.lex_state = 21, .external_lex_state = 16},
  [1276] = {.lex_state = 21, .external_lex_state = 16},
  [1277] = {.lex_state = 21, .external_lex_state = 22},
  [1278] = {.lex_state = 21, .external_lex_state = 23},
  [1279] = {.lex_state = 21, .external_lex_state = 23},
  [1280] = {.lex_state = 21, .external_lex_state = 16},
  [1281] = {.lex_state = 21, .external_lex_state = 22},
  [1282] = {.lex_state = 21, .external_lex_state = 23},
  [1283] = {.lex_state = 21, .external_lex_state = 22},
  [1284] = {.lex_state = 21, .external_lex_state = 22},
  [1285] = {.lex_state = 21, .external_lex_state = 22},
  [1286] = {.lex_state = 21, .external_lex_state = 22},
  [1287] = {.lex_state = 21, .external_lex_state = 21},
  [1288] = {.lex_state = 21, .external_lex_state = 22},
  [1289] = {.lex_state = 21, .external_lex_state = 22},
  [1290] = {.lex_state = 21, .external_lex_state = 16},
  [1291] = {.lex_state = 21, .external_lex_state = 16},
  [1292] = {.lex_state = 21, .external_lex_state = 21},
  [1293] = {.lex_state = 21, .external_lex_state = 29},
  [1294] = {.lex_state = 21, .external_lex_state = 22},
  [1295] = {.lex_state = 21, .external_lex_state = 4},
  [1296] = {.lex_state = 23, .external_lex_state = 30},
  [1297] = {.lex_state = 21, .external_lex_state = 5},
  [1298] = {.lex_state = 23, .external_lex_state = 31},
  [1299] = {.lex_state = 21, .external_lex_state = 27},
  [1300] = {.lex_state = 21, .external_lex_state = 27},
  [1301] = {.lex_state = 21, .external_lex_state = 27},
  [1302] = {.lex_state = 21, .external_lex_state = 27},
  [1303] = {.lex_state = 21, .external_lex_state = 27},
  [1304] = {.lex_state = 21, .external_lex_state = 27},
  [1305] = {.lex_state = 21, .external_lex_state = 32},
  [1306] = {.lex_state = 21, .external_lex_state = 25},
  [1307] = {.lex_state = 21, .external_lex_state = 25},
  [1308] = {.lex_state = 21, .external_lex_state = 27},
  [1309] = {.lex_state = 21, .external_lex_state = 25},
  [1310] = {.lex_state = 21, .external_lex_state = 25},
  [1311] = {.lex_state = 21, .external_lex_state = 33},
  [1312] = {.lex_state = 21, .external_lex_state = 26},
  [1313] = {.lex_state = 21, .external_lex_state = 26},
  [1314] = {.lex_state = 21, .external_lex_state = 26},
  [1315] = {.lex_state = 21, .external_lex_state = 26},
  [1316] = {.lex_state = 21, .external_lex_state = 26},
  [1317] = {.lex_state = 21, .external_lex_state = 2},
  [1318] = {.lex_state = 21, .external_lex_state = 24},
  [1319] = {.lex_state = 21, .external_lex_state = 24},
  [1320] = {.lex_state = 21, .external_lex_state = 27},
  [1321] = {.lex_state = 21, .external_lex_state = 27},
  [1322] = {.lex_state = 21, .external_lex_state = 27},
  [1323] = {.lex_state = 21, .external_lex_state = 27},
  [1324] = {.lex_state = 21, .external_lex_state = 27},
  [1325] = {.lex_state = 21, .external_lex_state = 24},
  [1326] = {.lex_state = 21, .external_lex_state = 24},
  [1327] = {.lex_state = 21, .external_lex_state = 24},
  [1328] = {.lex_state = 21, .external_lex_state = 24},
  [1329] = {.lex_state = 21, .external_lex_state = 24},
  [1330] = {.lex_state = 21, .external_lex_state = 24},
  [1331] = {.lex_state = 21, .external_lex_state = 24},
  [1332] = {.lex_state = 21, .external_lex_state = 24},
  [1333] = {.lex_state = 21, .external_lex_state = 24},
  [1334] = {.lex_state = 21, .external_lex_state = 24},
  [1335] = {.lex_state = 21, .external_lex_state = 24},
  [1336] = {.lex_state = 21, .external_lex_state = 24},
  [1337] = {.lex_state = 21, .external_lex_state = 24},
  [1338] = {.lex_state = 21, .external_lex_state = 24},
  [1339] = {.lex_state = 21, .external_lex_state = 24},
  [1340] = {.lex_state = 21, .external_lex_state = 24},
  [1341] = {.lex_state = 21, .external_lex_state = 24},
  [1342] = {.lex_state = 21, .external_lex_state = 24},
  [1343] = {.lex_state = 21, .external_lex_state = 24},
  [1344] = {.lex_state = 21, .external_lex_state = 24},
  [1345] = {.lex_state = 21, .external_lex_state = 24},
  [1346] = {.lex_state = 21, .external_lex_state = 24},
  [1347] = {.lex_state = 21, .external_lex_state = 24},
  [1348] = {.lex_state = 21, .external_lex_state = 3},
  [1349] = {.lex_state = 21, .external_lex_state = 3},
  [1350] = {.lex_state = 21, .external_lex_state = 3},
  [1351] = {.lex_state = 21, .external_lex_state = 3},
  [1352] = {.lex_state = 21, .external_lex_state = 3},
  [1353] = {.lex_state = 21, .external_lex_state = 3},
  [1354] = {.lex_state = 21, .external_lex_state = 3},
  [1355] = {.lex_state = 21, .external_lex_state = 3},
  [1356] = {.lex_state = 21, .external_lex_state = 3},
  [1357] = {.lex_state = 21, .external_lex_state = 3},
  [1358] = {.lex_state = 21, .external_lex_state = 3},
  [1359] = {.lex_state = 21, .external_lex_state = 3},
  [1360] = {.lex_state = 21, .external_lex_state = 3},
  [1361] = {.lex_state = 21, .external_lex_state = 3},
  [1362] = {.lex_state = 21, .external_lex_state = 3},
  [1363] = {.lex_state = 21, .external_lex_state = 3},
  [1364] = {.lex_state = 21, .external_lex_state = 3},
  [1365] = {.lex_state = 21, .external_lex_state = 3},
  [1366] = {.lex_state = 21, .external_lex_state = 3},
  [1367] = {.lex_state = 21, .external_lex_state = 3},
  [1368] = {.lex_state = 21, .external_lex_state = 3},
  [1369] = {.lex_state = 21, .external_lex_state = 3},
  [1370] = {.lex_state = 21, .external_lex_state = 3},
  [1371] = {.lex_state = 21, .external_lex_state = 3},
  [1372] = {.lex_state = 21, .external_lex_state = 3},
  [1373] = {.lex_state = 21, .external_lex_state = 26},
  [1374] = {.lex_state = 21, .external_lex_state = 26},
  [1375] = {.lex_state = 21, .external_lex_state = 34},
  [1376] = {.lex_state = 21, .external_lex_state = 27},
  [1377] = {.lex_state = 21, .external_lex_state = 27},
  [1378] = {.lex_state = 21, .external_lex_state = 24},
  [1379] = {.lex_state = 21, .external_lex_state = 24},
  [1380] = {.lex_state = 21, .external_lex_state = 26},
  [1381] = {.lex_state = 21, .external_lex_state = 26},
  [1382] = {.lex_state = 21, .external_lex_state = 27},
  [1383] = {.lex_state = 21, .external_lex_state = 27},
  [1384] = {.lex_state = 21, .external_lex_state = 3},
  [1385] = {.lex_state = 21, .external_lex_state = 3},
  [1386] = {.lex_state = 21, .external_lex_state = 25},
  [1387] = {.lex_state = 21, .external_lex_state = 25},
  [1388] = {.lex_state = 21, .external_lex_state = 25},
  [1389] = {.lex_state = 21, .external_lex_state = 25},
  [1390] = {.lex_state = 21, .external_lex_state = 25},
  [1391] = {.lex_state = 21, .external_lex_state = 25},
  [1392] = {.lex_state = 21, .external_lex_state = 25},
  [1393] = {.lex_state = 21, .external_lex_state = 25},
  [1394] = {.lex_state = 21, .external_lex_state = 25},
  [1395] = {.lex_state = 21, .external_lex_state = 25},
  [1396] = {.lex_state = 21, .external_lex_state = 25},
  [1397] = {.lex_state = 21, .external_lex_state = 25},
  [1398] = {.lex_state = 21, .external_lex_state = 24},
  [1399] = {.lex_state = 21, .external_lex_state = 29},
  [1400] = {.lex_state = 21, .external_lex_state = 28},
  [1401] = {.lex_state = 21, .external_lex_state = 28},
  [1402] = {.lex_state = 21, .external_lex_state = 28},
  [1403] = {.lex_state = 21, .external_lex_state = 28},
  [1404] = {.lex_state = 21, .external_lex_state = 2},
  [1405] = {.lex_state = 21, .external_lex_state = 2},
  [1406] = {.lex_state = 23, .external_lex_state = 35},
  [1407] = {.lex_state = 21, .external_lex_state = 28},
  [1408] = {.lex_state = 21, .external_lex_state = 29},
  [1409] = {.lex_state = 21, .external_lex_state = 28},
  [1410] = {.lex_state = 21, .external_lex_state = 31},
  [1411] = {.lex_state = 21, .external_lex_state = 28},
  [1412] = {.lex_state = 21, .external_lex_state = 28},
  [1413] = {.lex_state = 21, .external_lex_state = 4},
  [1414] = {.lex_state = 21, .external_lex_state = 30},
  [1415] = {.lex_state = 21, .external_lex_state = 28},
  [1416] = {.lex_state = 21, .external_lex_state = 28},
  [1417] = {.lex_state = 21, .external_lex_state = 29},
  [1418] = {.lex_state = 21, .external_lex_state = 28},
  [1419] = {.lex_state = 21, .external_lex_state = 29},
  [1420] = {.lex_state = 21, .external_lex_state = 29},
  [1421] = {.lex_state = 21, .external_lex_state = 29},
  [1422] = {.lex_state = 21, .external_lex_state = 29},
  [1423] = {.lex_state = 21, .external_lex_state = 23},
  [1424] = {.lex_state = 21, .external_lex_state = 28},
  [1425] = {.lex_state = 21, .external_lex_state = 31},
  [1426] = {.lex_state = 21, .external_lex_state = 29},
  [1427] = {.lex_state = 21, .external_lex_state = 29},
  [1428] = {.lex_state = 21, .external_lex_state = 5},
  [1429] = {.lex_state = 21, .external_lex_state = 29},
  [1430] = {.lex_state = 21, .external_lex_state = 5},
  [1431] = {.lex_state = 21, .external_lex_state = 24},
  [1432] = {.lex_state = 21, .external_lex_state = 29},
  [1433] = {.lex_state = 21, .external_lex_state = 29},
  [1434] = {.lex_state = 21, .external_lex_state = 28},
  [1435] = {.lex_state = 21, .external_lex_state = 29},
  [1436] = {.lex_state = 21, .external_lex_state = 21},
  [1437] = {.lex_state = 21, .external_lex_state = 29},
  [1438] = {.lex_state = 23, .external_lex_state = 36},
  [1439] = {.lex_state = 21, .external_lex_state = 4},
  [1440] = {.lex_state = 21, .external_lex_state = 28},
  [1441] = {.lex_state = 21, .external_lex_state = 28},
  [1442] = {.lex_state = 21, .external_lex_state = 29},
  [1443] = {.lex_state = 21, .external_lex_state = 30},
  [1444] = {.lex_state = 21, .external_lex_state = 28},
  [1445] = {.lex_state = 21, .external_lex_state = 29},
  [1446] = {.lex_state = 21, .external_lex_state = 30},
  [1447] = {.lex_state = 21, .external_lex_state = 22},
  [1448] = {.lex_state = 21, .external_lex_state = 5},
  [1449] = {.lex_state = 21, .external_lex_state = 5},
  [1450] = {.lex_state = 21, .external_lex_state = 5},
  [1451] = {.lex_state = 21, .external_lex_state = 5},
  [1452] = {.lex_state = 21, .external_lex_state = 5},
  [1453] = {.lex_state = 21, .external_lex_state = 5},
  [1454] = {.lex_state = 21, .external_lex_state = 5},
  [1455] = {.lex_state = 21, .external_lex_state = 5},
  [1456] = {.lex_state = 21, .external_lex_state = 5},
  [1457] = {.lex_state = 21, .external_lex_state = 5},
  [1458] = {.lex_state = 21, .external_lex_state = 5},
  [1459] = {.lex_state = 21, .external_lex_state = 5},
  [1460] = {.lex_state = 21, .external_lex_state = 5},
  [1461] = {.lex_state = 21, .external_lex_state = 5},
  [1462] = {.lex_state = 21, .external_lex_state = 5},
  [1463] = {.lex_state = 21, .external_lex_state = 5},
  [1464] = {.lex_state = 21, .external_lex_state = 5},
  [1465] = {.lex_state = 21, .external_lex_state = 5},
  [1466] = {.lex_state = 21, .external_lex_state = 5},
  [1467] = {.lex_state = 21, .external_lex_state = 22},
  [1468] = {.lex_state = 21, .external_lex_state = 5},
  [1469] = {.lex_state = 21, .external_lex_state = 5},
  [1470] = {.lex_state = 21, .external_lex_state = 5},
  [1471] = {.lex_state = 21, .external_lex_state = 5},
  [1472] = {.lex_state = 21, .external_lex_state = 22},
  [1473] = {.lex_state = 21, .external_lex_state = 16},
  [1474] = {.lex_state = 21, .external_lex_state = 30},
  [1475] = {.lex_state = 21, .external_lex_state = 4},
  [1476] = {.lex_state = 21, .external_lex_state = 30},
  [1477] = {.lex_state = 21, .external_lex_state = 30},
  [1478] = {.lex_state = 21, .external_lex_state = 30},
  [1479] = {.lex_state = 21, .external_lex_state = 30},
  [1480] = {.lex_state = 21, .external_lex_state = 30},
  [1481] = {.lex_state = 21, .external_lex_state = 34},
  [1482] = {.lex_state = 21, .external_lex_state = 34},
  [1483] = {.lex_state = 21, .external_lex_state = 30},
  [1484] = {.lex_state = 21, .external_lex_state = 34},
  [1485] = {.lex_state = 21, .external_lex_state = 34},
  [1486] = {.lex_state = 21, .external_lex_state = 22},
  [1487] = {.lex_state = 21, .external_lex_state = 22},
  [1488] = {.lex_state = 21, .external_lex_state = 22},
  [1489] = {.lex_state = 21, .external_lex_state = 22},
  [1490] = {.lex_state = 21, .external_lex_state = 22},
  [1491] = {.lex_state = 21, .external_lex_state = 22},
  [1492] = {.lex_state = 21, .external_lex_state = 22},
  [1493] = {.lex_state = 21, .external_lex_state = 22},
  [1494] = {.lex_state = 21, .external_lex_state = 22},
  [1495] = {.lex_state = 21, .external_lex_state = 22},
  [1496] = {.lex_state = 21, .external_lex_state = 16},
  [1497] = {.lex_state = 21, .external_lex_state = 30},
  [1498] = {.lex_state = 21, .external_lex_state = 22},
  [1499] = {.lex_state = 21, .external_lex_state = 30},
  [1500] = {.lex_state = 21, .external_lex_state = 22},
  [1501] = {.lex_state = 21, .external_lex_state = 22},
  [1502] = {.lex_state = 21, .external_lex_state = 22},
  [1503] = {.lex_state = 21, .external_lex_state = 22},
  [1504] = {.lex_state = 21, .external_lex_state = 22},
  [1505] = {.lex_state = 21, .external_lex_state = 22},
  [1506] = {.lex_state = 23, .external_lex_state = 37},
  [1507] = {.lex_state = 21, .external_lex_state = 22},
  [1508] = {.lex_state = 21, .external_lex_state = 22},
  [1509] = {.lex_state = 21, .external_lex_state = 22},
  [1510] = {.lex_state = 21, .external_lex_state = 22},
  [1511] = {.lex_state = 21, .external_lex_state = 22},
  [1512] = {.lex_state = 21, .external_lex_state = 22},
  [1513] = {.lex_state = 21, .external_lex_state = 4},
  [1514] = {.lex_state = 21, .external_lex_state = 4},
  [1515] = {.lex_state = 21, .external_lex_state = 16},
  [1516] = {.lex_state = 21, .external_lex_state = 30},
  [1517] = {.lex_state = 21, .external_lex_state = 2},
  [1518] = {.lex_state = 21, .external_lex_state = 2},
  [1519] = {.lex_state = 21, .external_lex_state = 2},
  [1520] = {.lex_state = 21, .external_lex_state = 2},
  [1521] = {.lex_state = 21, .external_lex_state = 2},
  [1522] = {.lex_state = 21, .external_lex_state = 35},
  [1523] = {.lex_state = 21, .external_lex_state = 35},
  [1524] = {.lex_state = 21, .external_lex_state = 5},
  [1525] = {.lex_state = 21, .external_lex_state = 5},
  [1526] = {.lex_state = 21, .external_lex_state = 2},
  [1527] = {.lex_state = 21, .external_lex_state = 16},
  [1528] = {.lex_state = 21, .external_lex_state = 2},
  [1529] = {.lex_state = 21, .external_lex_state = 2},
  [1530] = {.lex_state = 21, .external_lex_state = 24},
  [1531] = {.lex_state = 21, .external_lex_state = 32},
  [1532] = {.lex_state = 21, .external_lex_state = 33},
  [1533] = {.lex_state = 21, .external_lex_state = 16},
  [1534] = {.lex_state = 21, .external_lex_state = 33},
  [1535] = {.lex_state = 21, .external_lex_state = 30},
  [1536] = {.lex_state = 21, .external_lex_state = 30},
  [1537] = {.lex_state = 21, .external_lex_state = 2},
  [1538] = {.lex_state = 21, .external_lex_state = 30},
  [1539] = {.lex_state = 21, .external_lex_state = 4},
  [1540] = {.lex_state = 21, .external_lex_state = 16},
  [1541] = {.lex_state = 21, .external_lex_state = 16},
  [1542] = {.lex_state = 21, .external_lex_state = 30},
  [1543] = {.lex_state = 21, .external_lex_state = 4},
  [1544] = {.lex_state = 21, .external_lex_state = 4},
  [1545] = {.lex_state = 21, .external_lex_state = 4},
  [1546] = {.lex_state = 21, .external_lex_state = 4},
  [1547] = {.lex_state = 21, .external_lex_state = 30},
  [1548] = {.lex_state = 21, .external_lex_state = 2},
  [1549] = {.lex_state = 21, .external_lex_state = 2},
  [1550] = {.lex_state = 21, .external_lex_state = 4},
  [1551] = {.lex_state = 21, .external_lex_state = 30},
  [1552] = {.lex_state = 21, .external_lex_state = 30},
  [1553] = {.lex_state = 21, .external_lex_state = 2},
  [1554] = {.lex_state = 21, .external_lex_state = 2},
  [1555] = {.lex_state = 21, .external_lex_state = 4},
  [1556] = {.lex_state = 21, .external_lex_state = 22},
  [1557] = {.lex_state = 21, .external_lex_state = 2},
  [1558] = {.lex_state = 21, .external_lex_state = 2},
  [1559] = {.lex_state = 21, .external_lex_state = 16},
  [1560] = {.lex_state = 21, .external_lex_state = 2},
  [1561] = {.lex_state = 21, .external_lex_state = 2},
  [1562] = {.lex_state = 21, .external_lex_state = 2},
  [1563] = {.lex_state = 21, .external_lex_state = 2},
  [1564] = {.lex_state = 21, .external_lex_state = 16},
  [1565] = {.lex_state = 21, .external_lex_state = 4},
  [1566] = {.lex_state = 21, .external_lex_state = 4},
  [1567] = {.lex_state = 21, .external_lex_state = 4},
  [1568] = {.lex_state = 21, .external_lex_state = 4},
  [1569] = {.lex_state = 21, .external_lex_state = 30},
  [1570] = {.lex_state = 21, .external_lex_state = 4},
  [1571] = {.lex_state = 21, .external_lex_state = 30},
  [1572] = {.lex_state = 21, .external_lex_state = 4},
  [1573] = {.lex_state = 21, .external_lex_state = 30},
  [1574] = {.lex_state = 21, .external_lex_state = 4},
  [1575] = {.lex_state = 21, .external_lex_state = 4},
  [1576] = {.lex_state = 21, .external_lex_state = 4},
  [1577] = {.lex_state = 21, .external_lex_state = 4},
  [1578] = {.lex_state = 21, .external_lex_state = 16},
  [1579] = {.lex_state = 21, .external_lex_state = 4},
  [1580] = {.lex_state = 21, .external_lex_state = 4},
  [1581] = {.lex_state = 21, .external_lex_state = 33},
  [1582] = {.lex_state = 21, .external_lex_state = 4},
  [1583] = {.lex_state = 21, .external_lex_state = 22},
  [1584] = {.lex_state = 21, .external_lex_state = 31},
  [1585] = {.lex_state = 21, .external_lex_state = 22},
  [1586] = {.lex_state = 21, .external_lex_state = 32},
  [1587] = {.lex_state = 21, .external_lex_state = 32},
  [1588] = {.lex_state = 21, .external_lex_state = 2},
  [1589] = {.lex_state = 21, .external_lex_state = 2},
  [1590] = {.lex_state = 21, .external_lex_state = 2},
  [1591] = {.lex_state = 21, .external_lex_state = 2},
  [1592] = {.lex_state = 21, .external_lex_state = 16},
  [1593] = {.lex_state = 21, .external_lex_state = 31},
  [1594] = {.lex_state = 21, .external_lex_state = 22},
  [1595] = {.lex_state = 21, .external_lex_state = 32},
  [1596] = {.lex_state = 21, .external_lex_state = 30},
  [1597] = {.lex_state = 21, .external_lex_state = 31},
  [1598] = {.lex_state = 21, .external_lex_state = 4},
  [1599] = {.lex_state = 21, .external_lex_state = 31},
  [1600] = {.lex_state = 21, .external_lex_state = 4},
  [1601] = {.lex_state = 21, .external_lex_state = 31},
  [1602] = {.lex_state = 21, .external_lex_state = 31},
  [1603] = {.lex_state = 21, .external_lex_state = 31},
  [1604] = {.lex_state = 21, .external_lex_state = 31},
  [1605] = {.lex_state = 21, .external_lex_state = 31},
  [1606] = {.lex_state = 21, .external_lex_state = 33},
  [1607] = {.lex_state = 21, .external_lex_state = 5},
  [1608] = {.lex_state = 21, .external_lex_state = 25},
  [1609] = {.lex_state = 21, .external_lex_state = 31},
  [1610] = {.lex_state = 21, .external_lex_state = 16},
  [1611] = {.lex_state = 21, .external_lex_state = 16},
  [1612] = {.lex_state = 21, .external_lex_state = 31},
  [1613] = {.lex_state = 21, .external_lex_state = 30},
  [1614] = {.lex_state = 21, .external_lex_state = 31},
  [1615] = {.lex_state = 21, .external_lex_state = 33},
  [1616] = {.lex_state = 21, .external_lex_state = 33},
  [1617] = {.lex_state = 21, .external_lex_state = 31},
  [1618] = {.lex_state = 21, .external_lex_state = 33},
  [1619] = {.lex_state = 21, .external_lex_state = 31},
  [1620] = {.lex_state = 21, .external_lex_state = 22},
  [1621] = {.lex_state = 21, .external_lex_state = 16},
  [1622] = {.lex_state = 21, .external_lex_state = 31},
  [1623] = {.lex_state = 21, .external_lex_state = 16},
  [1624] = {.lex_state = 21, .external_lex_state = 33},
  [1625] = {.lex_state = 21, .external_lex_state = 16},
  [1626] = {.lex_state = 21, .external_lex_state = 16},
  [1627] = {.lex_state = 21, .external_lex_state = 16},
  [1628] = {.lex_state = 21, .external_lex_state = 16},
  [1629] = {.lex_state = 21, .external_lex_state = 31},
  [1630] = {.lex_state = 21, .external_lex_state = 33},
  [1631] = {.lex_state = 21, .external_lex_state = 2},
  [1632] = {.lex_state = 21, .external_lex_state = 16},
  [1633] = {.lex_state = 21, .external_lex_state = 16},
  [1634] = {.lex_state = 21, .external_lex_state = 16},
  [1635] = {.lex_state = 21, .external_lex_state = 2},
  [1636] = {.lex_state = 21, .external_lex_state = 2},
  [1637] = {.lex_state = 21, .external_lex_state = 16},
  [1638] = {.lex_state = 21, .external_lex_state = 16},
  [1639] = {.lex_state = 21, .external_lex_state = 16},
  [1640] = {.lex_state = 21, .external_lex_state = 2},
  [1641] = {.lex_state = 21, .external_lex_state = 16},
  [1642] = {.lex_state = 21, .external_lex_state = 16},
  [1643] = {.lex_state = 21, .external_lex_state = 16},
  [1644] = {.lex_state = 21, .external_lex_state = 16},
  [1645] = {.lex_state = 21, .external_lex_state = 16},
  [1646] = {.lex_state = 21, .external_lex_state = 16},
  [1647] = {.lex_state = 21, .external_lex_state = 16},
  [1648] = {.lex_state = 21, .external_lex_state = 16},
  [1649] = {.lex_state = 21, .external_lex_state = 22},
  [1650] = {.lex_state = 21, .external_lex_state = 16},
  [1651] = {.lex_state = 21, .external_lex_state = 16},
  [1652] = {.lex_state = 21, .external_lex_state = 16},
  [1653] = {.lex_state = 21, .external_lex_state = 22},
  [1654] = {.lex_state = 21, .external_lex_state = 22},
  [1655] = {.lex_state = 21, .external_lex_state = 16},
  [1656] = {.lex_state = 21, .external_lex_state = 30},
  [1657] = {.lex_state = 21, .external_lex_state = 30},
  [1658] = {.lex_state = 21, .external_lex_state = 22},
  [1659] = {.lex_state = 21, .external_lex_state = 31},
  [1660] = {.lex_state = 21, .external_lex_state = 3},
  [1661] = {.lex_state = 21, .external_lex_state = 16},
  [1662] = {.lex_state = 21, .external_lex_state = 31},
  [1663] = {.lex_state = 21, .external_lex_state = 31},
  [1664] = {.lex_state = 21, .external_lex_state = 16},
  [1665] = {.lex_state = 21, .external_lex_state = 16},
  [1666] = {.lex_state = 21, .external_lex_state = 31},
  [1667] = {.lex_state = 21, .external_lex_state = 31},
  [1668] = {.lex_state = 21, .external_lex_state = 31},
  [1669] = {.lex_state = 21, .external_lex_state = 30},
  [1670] = {.lex_state = 21, .external_lex_state = 31},
  [1671] = {.lex_state = 21, .external_lex_state = 16},
  [1672] = {.lex_state = 21, .external_lex_state = 22},
  [1673] = {.lex_state = 21, .external_lex_state = 32},
  [1674] = {.lex_state = 21, .external_lex_state = 32},
  [1675] = {.lex_state = 21, .external_lex_state = 22},
  [1676] = {.lex_state = 21, .external_lex_state = 22},
  [1677] = {.lex_state = 21, .external_lex_state = 22},
  [1678] = {.lex_state = 21, .external_lex_state = 16},
  [1679] = {.lex_state = 21, .external_lex_state = 16},
  [1680] = {.lex_state = 21, .external_lex_state = 16},
  [1681] = {.lex_state = 21, .external_lex_state = 16},
  [1682] = {.lex_state = 21, .external_lex_state = 16},
  [1683] = {.lex_state = 21, .external_lex_state = 31},
  [1684] = {.lex_state = 21, .external_lex_state = 31},
  [1685] = {.lex_state = 21, .external_lex_state = 31},
  [1686] = {.lex_state = 21, .external_lex_state = 32},
  [1687] = {.lex_state = 21, .external_lex_state = 32},
  [1688] = {.lex_state = 21, .external_lex_state = 16},
  [1689] = {.lex_state = 21, .external_lex_state = 22},
  [1690] = {.lex_state = 21, .external_lex_state = 16},
  [1691] = {.lex_state = 21, .external_lex_state = 16},
  [1692] = {.lex_state = 21, .external_lex_state = 16},
  [1693] = {.lex_state = 21, .external_lex_state = 16},
  [1694] = {.lex_state = 21, .external_lex_state = 16},
  [1695] = {.lex_state = 21, .external_lex_state = 16},
  [1696] = {.lex_state = 21, .external_lex_state = 16},
  [1697] = {.lex_state = 21, .external_lex_state = 16},
  [1698] = {.lex_state = 21, .external_lex_state = 16},
  [1699] = {.lex_state = 23, .external_lex_state = 38},
  [1700] = {.lex_state = 21, .external_lex_state = 16},
  [1701] = {.lex_state = 21, .external_lex_state = 16},
  [1702] = {.lex_state = 21, .external_lex_state = 16},
  [1703] = {.lex_state = 21, .external_lex_state = 16},
  [1704] = {.lex_state = 21, .external_lex_state = 16},
  [1705] = {.lex_state = 21, .external_lex_state = 16},
  [1706] = {.lex_state = 21, .external_lex_state = 16},
  [1707] = {.lex_state = 21, .external_lex_state = 16},
  [1708] = {.lex_state = 21, .external_lex_state = 31},
  [1709] = {.lex_state = 21, .external_lex_state = 31},
  [1710] = {.lex_state = 21, .external_lex_state = 16},
  [1711] = {.lex_state = 21, .external_lex_state = 3},
  [1712] = {.lex_state = 21, .external_lex_state = 34},
  [1713] = {.lex_state = 21, .external_lex_state = 34},
  [1714] = {.lex_state = 21, .external_lex_state = 34},
  [1715] = {.lex_state = 21, .external_lex_state = 16},
  [1716] = {.lex_state = 21, .external_lex_state = 16},
  [1717] = {.lex_state = 21, .external_lex_state = 16},
  [1718] = {.lex_state = 21, .external_lex_state = 3},
  [1719] = {.lex_state = 21, .external_lex_state = 27},
  [1720] = {.lex_state = 21, .external_lex_state = 34},
  [1721] = {.lex_state = 21, .external_lex_state = 36},
  [1722] = {.lex_state = 21, .external_lex_state = 3},
  [1723] = {.lex_state = 21, .external_lex_state = 34},
  [1724] = {.lex_state = 21, .external_lex_state = 16},
  [1725] = {.lex_state = 21, .external_lex_state = 16},
  [1726] = {.lex_state = 21, .external_lex_state = 36},
  [1727] = {.lex_state = 21, .external_lex_state = 22},
  [1728] = {.lex_state = 21, .external_lex_state = 30},
  [1729] = {.lex_state = 21, .external_lex_state = 32},
  [1730] = {.lex_state = 21, .external_lex_state = 30},
  [1731] = {.lex_state = 21, .external_lex_state = 22},
  [1732] = {.lex_state = 21, .external_lex_state = 16},
  [1733] = {.lex_state = 21, .external_lex_state = 16},
  [1734] = {.lex_state = 21, .external_lex_state = 4},
  [1735] = {.lex_state = 21, .external_lex_state = 4},
  [1736] = {.lex_state = 21, .external_lex_state = 5},
  [1737] = {.lex_state = 21, .external_lex_state = 36},
  [1738] = {.lex_state = 21, .external_lex_state = 24},
  [1739] = {.lex_state = 21, .external_lex_state = 24},
  [1740] = {.lex_state = 21, .external_lex_state = 24},
  [1741] = {.lex_state = 21, .external_lex_state = 37},
  [1742] = {.lex_state = 21, .external_lex_state = 37},
  [1743] = {.lex_state = 21, .external_lex_state = 24},
  [1744] = {.lex_state = 21, .external_lex_state = 29},
  [1745] = {.lex_state = 21, .external_lex_state = 35},
  [1746] = {.lex_state = 21, .external_lex_state = 35},
  [1747] = {.lex_state = 21, .external_lex_state = 3},
  [1748] = {.lex_state = 21, .external_lex_state = 24},
  [1749] = {.lex_state = 21, .external_lex_state = 24},
  [1750] = {.lex_state = 21, .external_lex_state = 35},
  [1751] = {.lex_state = 21, .external_lex_state = 35},
  [1752] = {.lex_state = 21, .external_lex_state = 3},
  [1753] = {.lex_state = 21, .external_lex_state = 36},
  [1754] = {.lex_state = 21, .external_lex_state = 36},
  [1755] = {.lex_state = 21, .external_lex_state = 24},
  [1756] = {.lex_state = 21, .external_lex_state = 36},
  [1757] = {.lex_state = 21, .external_lex_state = 24},
  [1758] = {.lex_state = 21, .external_lex_state = 24},
  [1759] = {.lex_state = 21, .external_lex_state = 24},
  [1760] = {.lex_state = 21, .external_lex_state = 36},
  [1761] = {.lex_state = 21, .external_lex_state = 24},
  [1762] = {.lex_state = 21, .external_lex_state = 24},
  [1763] = {.lex_state = 21, .external_lex_state = 24},
  [1764] = {.lex_state = 21, .external_lex_state = 24},
  [1765] = {.lex_state = 21, .external_lex_state = 24},
  [1766] = {.lex_state = 21, .external_lex_state = 24},
  [1767] = {.lex_state = 21, .external_lex_state = 24},
  [1768] = {.lex_state = 21, .external_lex_state = 24},
  [1769] = {.lex_state = 21, .external_lex_state = 24},
  [1770] = {.lex_state = 21, .external_lex_state = 24},
  [1771] = {.lex_state = 21, .external_lex_state = 24},
  [1772] = {.lex_state = 21, .external_lex_state = 24},
  [1773] = {.lex_state = 21, .external_lex_state = 24},
  [1774] = {.lex_state = 21, .external_lex_state = 24},
  [1775] = {.lex_state = 21, .external_lex_state = 24},
  [1776] = {.lex_state = 21, .external_lex_state = 24},
  [1777] = {.lex_state = 21, .external_lex_state = 22},
  [1778] = {.lex_state = 21, .external_lex_state = 24},
  [1779] = {.lex_state = 21, .external_lex_state = 24},
  [1780] = {.lex_state = 21, .external_lex_state = 24},
  [1781] = {.lex_state = 21, .external_lex_state = 24},
  [1782] = {.lex_state = 21, .external_lex_state = 24},
  [1783] = {.lex_state = 21, .external_lex_state = 24},
  [1784] = {.lex_state = 21, .external_lex_state = 24},
  [1785] = {.lex_state = 21, .external_lex_state = 24},
  [1786] = {.lex_state = 21, .external_lex_state = 35},
  [1787] = {.lex_state = 21, .external_lex_state = 30},
  [1788] = {.lex_state = 21, .external_lex_state = 35},
  [1789] = {.lex_state = 21, .external_lex_state = 35},
  [1790] = {.lex_state = 21, .external_lex_state = 35},
  [1791] = {.lex_state = 21, .external_lex_state = 35},
  [1792] = {.lex_state = 21, .external_lex_state = 35},
  [1793] = {.lex_state = 21, .external_lex_state = 28},
  [1794] = {.lex_state = 21, .external_lex_state = 35},
  [1795] = {.lex_state = 21, .external_lex_state = 35},
  [1796] = {.lex_state = 21, .external_lex_state = 35},
  [1797] = {.lex_state = 21, .external_lex_state = 35},
  [1798] = {.lex_state = 21, .external_lex_state = 35},
  [1799] = {.lex_state = 21, .external_lex_state = 35},
  [1800] = {.lex_state = 21, .external_lex_state = 35},
  [1801] = {.lex_state = 21, .external_lex_state = 35},
  [1802] = {.lex_state = 21, .external_lex_state = 35},
  [1803] = {.lex_state = 21, .external_lex_state = 35},
  [1804] = {.lex_state = 21, .external_lex_state = 35},
  [1805] = {.lex_state = 21, .external_lex_state = 35},
  [1806] = {.lex_state = 21, .external_lex_state = 35},
  [1807] = {.lex_state = 21, .external_lex_state = 24},
  [1808] = {.lex_state = 21, .external_lex_state = 35},
  [1809] = {.lex_state = 21, .external_lex_state = 35},
  [1810] = {.lex_state = 21, .external_lex_state = 35},
  [1811] = {.lex_state = 21, .external_lex_state = 38},
  [1812] = {.lex_state = 21, .external_lex_state = 35},
  [1813] = {.lex_state = 21, .external_lex_state = 38},
  [1814] = {.lex_state = 21, .external_lex_state = 24},
  [1815] = {.lex_state = 21, .external_lex_state = 31},
  [1816] = {.lex_state = 21, .external_lex_state = 24},
  [1817] = {.lex_state = 21, .external_lex_state = 24},
  [1818] = {.lex_state = 21, .external_lex_state = 24},
  [1819] = {.lex_state = 21, .external_lex_state = 36},
  [1820] = {.lex_state = 21, .external_lex_state = 36},
  [1821] = {.lex_state = 21, .external_lex_state = 3},
  [1822] = {.lex_state = 21, .external_lex_state = 3},
  [1823] = {.lex_state = 21, .external_lex_state = 36},
  [1824] = {.lex_state = 21, .external_lex_state = 36},
  [1825] = {.lex_state = 21, .external_lex_state = 24},
  [1826] = {.lex_state = 21, .external_lex_state = 36},
  [1827] = {.lex_state = 21, .external_lex_state = 36},
  [1828] = {.lex_state = 21, .external_lex_state = 36},
  [1829] = {.lex_state = 21, .external_lex_state = 36},
  [1830] = {.lex_state = 21, .external_lex_state = 36},
  [1831] = {.lex_state = 21, .external_lex_state = 36},
  [1832] = {.lex_state = 21, .external_lex_state = 36},
  [1833] = {.lex_state = 21, .external_lex_state = 36},
  [1834] = {.lex_state = 21, .external_lex_state = 36},
  [1835] = {.lex_state = 21, .external_lex_state = 36},
  [1836] = {.lex_state = 21, .external_lex_state = 36},
  [1837] = {.lex_state = 21, .external_lex_state = 24},
  [1838] = {.lex_state = 21, .external_lex_state = 36},
  [1839] = {.lex_state = 21, .external_lex_state = 36},
  [1840] = {.lex_state = 21, .external_lex_state = 36},
  [1841] = {.lex_state = 21, .external_lex_state = 36},
  [1842] = {.lex_state = 21, .external_lex_state = 24},
  [1843] = {.lex_state = 21, .external_lex_state = 36},
  [1844] = {.lex_state = 21, .external_lex_state = 36},
  [1845] = {.lex_state = 21, .external_lex_state = 36},
  [1846] = {.lex_state = 21, .external_lex_state = 24},
  [1847] = {.lex_state = 21, .external_lex_state = 36},
  [1848] = {.lex_state = 21, .external_lex_state = 35},
  [1849] = {.lex_state = 21, .external_lex_state = 37},
  [1850] = {.lex_state = 21, .external_lex_state = 37},
  [1851] = {.lex_state = 21, .external_lex_state = 2},
  [1852] = {.lex_state = 21, .external_lex_state = 37},
  [1853] = {.lex_state = 21, .external_lex_state = 31},
  [1854] = {.lex_state = 21, .external_lex_state = 36},
  [1855] = {.lex_state = 21, .external_lex_state = 35},
  [1856] = {.lex_state = 21, .external_lex_state = 35},
  [1857] = {.lex_state = 21, .external_lex_state = 38},
  [1858] = {.lex_state = 21, .external_lex_state = 38},
  [1859] = {.lex_state = 21, .external_lex_state = 38},
  [1860] = {.lex_state = 21, .external_lex_state = 5},
  [1861] = {.lex_state = 21, .external_lex_state = 2},
  [1862] = {.lex_state = 21, .external_lex_state = 35},
  [1863] = {.lex_state = 21, .external_lex_state = 38},
  [1864] = {.lex_state = 21, .external_lex_state = 38},
  [1865] = {.lex_state = 21, .external_lex_state = 38},
  [1866] = {.lex_state = 21, .external_lex_state = 4},
  [1867] = {.lex_state = 21, .external_lex_state = 38},
  [1868] = {.lex_state = 21, .external_lex_state = 38},
  [1869] = {.lex_state = 21, .external_lex_state = 38},
  [1870] = {.lex_state = 21, .external_lex_state = 35},
  [1871] = {.lex_state = 21, .external_lex_state = 38},
  [1872] = {.lex_state = 21, .external_lex_state = 38},
  [1873] = {.lex_state = 21, .external_lex_state = 38},
  [1874] = {.lex_state = 21, .external_lex_state = 38},
  [1875] = {.lex_state = 21, .external_lex_state = 38},
  [1876] = {.lex_state = 21, .external_lex_state = 38},
  [1877] = {.lex_state = 21, .external_lex_state = 38},
  [1878] = {.lex_state = 21, .external_lex_state = 5},
  [1879] = {.lex_state = 21, .external_lex_state = 38},
  [1880] = {.lex_state = 21, .external_lex_state = 38},
  [1881] = {.lex_state = 21, .external_lex_state = 38},
  [1882] = {.lex_state = 21, .external_lex_state = 38},
  [1883] = {.lex_state = 21, .external_lex_state = 37},
  [1884] = {.lex_state = 21, .external_lex_state = 37},
  [1885] = {.lex_state = 21, .external_lex_state = 35},
  [1886] = {.lex_state = 21, .external_lex_state = 35},
  [1887] = {.lex_state = 21, .external_lex_state = 2},
  [1888] = {.lex_state = 21, .external_lex_state = 38},
  [1889] = {.lex_state = 21, .external_lex_state = 22},
  [1890] = {.lex_state = 21, .external_lex_state = 37},
  [1891] = {.lex_state = 21, .external_lex_state = 35},
  [1892] = {.lex_state = 21, .external_lex_state = 37},
  [1893] = {.lex_state = 21, .external_lex_state = 37},
  [1894] = {.lex_state = 21, .external_lex_state = 38},
  [1895] = {.lex_state = 21, .external_lex_state = 4},
  [1896] = {.lex_state = 21, .external_lex_state = 38},
  [1897] = {.lex_state = 21, .external_lex_state = 38},
  [1898] = {.lex_state = 21, .external_lex_state = 37},
  [1899] = {.lex_state = 21, .external_lex_state = 2},
  [1900] = {.lex_state = 21, .external_lex_state = 5},
  [1901] = {.lex_state = 21, .external_lex_state = 37},
  [1902] = {.lex_state = 21, .external_lex_state = 3},
  [1903] = {.lex_state = 21, .external_lex_state = 38},
  [1904] = {.lex_state = 21, .external_lex_state = 35},
  [1905] = {.lex_state = 21, .external_lex_state = 38},
  [1906] = {.lex_state = 21, .external_lex_state = 38},
  [1907] = {.lex_state = 21, .external_lex_state = 4},
  [1908] = {.lex_state = 21, .external_lex_state = 30},
  [1909] = {.lex_state = 21, .external_lex_state = 37},
  [1910] = {.lex_state = 21, .external_lex_state = 4},
  [1911] = {.lex_state = 21, .external_lex_state = 35},
  [1912] = {.lex_state = 21, .external_lex_state = 37},
  [1913] = {.lex_state = 21, .external_lex_state = 37},
  [1914] = {.lex_state = 21, .external_lex_state = 37},
  [1915] = {.lex_state = 21, .external_lex_state = 38},
  [1916] = {.lex_state = 21, .external_lex_state = 37},
  [1917] = {.lex_state = 21, .external_lex_state = 37},
  [1918] = {.lex_state = 21, .external_lex_state = 37},
  [1919] = {.lex_state = 21, .external_lex_state = 37},
  [1920] = {.lex_state = 21, .external_lex_state = 37},
  [1921] = {.lex_state = 21, .external_lex_state = 35},
  [1922] = {.lex_state = 21, .external_lex_state = 37},
  [1923] = {.lex_state = 21, .external_lex_state = 35},
  [1924] = {.lex_state = 21, .external_lex_state = 37},
  [1925] = {.lex_state = 21, .external_lex_state = 5},
  [1926] = {.lex_state = 21, .external_lex_state = 37},
  [1927] = {.lex_state = 21, .external_lex_state = 37},
  [1928] = {.lex_state = 21, .external_lex_state = 35},
  [1929] = {.lex_state = 21, .external_lex_state = 37},
  [1930] = {.lex_state = 21, .external_lex_state = 37},
  [1931] = {.lex_state = 21, .external_lex_state = 37},
  [1932] = {.lex_state = 21, .external_lex_state = 37},
  [1933] = {.lex_state = 21, .external_lex_state = 37},
  [1934] = {.lex_state = 21, .external_lex_state = 35},
  [1935] = {.lex_state = 21, .external_lex_state = 30},
  [1936] = {.lex_state = 21, .external_lex_state = 2},
  [1937] = {.lex_state = 21, .external_lex_state = 3},
  [1938] = {.lex_state = 21, .external_lex_state = 3},
  [1939] = {.lex_state = 21, .external_lex_state = 3},
  [1940] = {.lex_state = 21, .external_lex_state = 3},
  [1941] = {.lex_state = 21, .external_lex_state = 3},
  [1942] = {.lex_state = 21, .external_lex_state = 3},
  [1943] = {.lex_state = 21, .external_lex_state = 3},
  [1944] = {.lex_state = 21, .external_lex_state = 30},
  [1945] = {.lex_state = 21, .external_lex_state = 30},
  [1946] = {.lex_state = 21, .external_lex_state = 3},
  [1947] = {.lex_state = 21, .external_lex_state = 3},
  [1948] = {.lex_state = 21, .external_lex_state = 30},
  [1949] = {.lex_state = 21, .external_lex_state = 30},
  [1950] = {.lex_state = 21, .external_lex_state = 30},
  [1951] = {.lex_state = 21, .external_lex_state = 30},
  [1952] = {.lex_state = 21, .external_lex_state = 30},
  [1953] = {.lex_state = 21, .external_lex_state = 38},
  [1954] = {.lex_state = 21, .external_lex_state = 3},
  [1955] = {.lex_state = 21, .external_lex_state = 4},
  [1956] = {.lex_state = 21, .external_lex_state = 30},
  [1957] = {.lex_state = 21, .external_lex_state = 4},
  [1958] = {.lex_state = 21, .external_lex_state = 31},
  [1959] = {.lex_state = 21, .external_lex_state = 2},
  [1960] = {.lex_state = 21, .external_lex_state = 3},
  [1961] = {.lex_state = 21, .external_lex_state = 5},
  [1962] = {.lex_state = 21, .external_lex_state = 5},
  [1963] = {.lex_state = 21, .external_lex_state = 3},
  [1964] = {.lex_state = 21, .external_lex_state = 3},
  [1965] = {.lex_state = 21, .external_lex_state = 3},
  [1966] = {.lex_state = 21, .external_lex_state = 3},
  [1967] = {.lex_state = 21, .external_lex_state = 3},
  [1968] = {.lex_state = 21, .external_lex_state = 3},
  [1969] = {.lex_state = 21, .external_lex_state = 3},
  [1970] = {.lex_state = 21, .external_lex_state = 3},
  [1971] = {.lex_state = 21, .external_lex_state = 3},
  [1972] = {.lex_state = 21, .external_lex_state = 3},
  [1973] = {.lex_state = 21, .external_lex_state = 3},
  [1974] = {.lex_state = 21, .external_lex_state = 31},
  [1975] = {.lex_state = 21, .external_lex_state = 3},
  [1976] = {.lex_state = 21, .external_lex_state = 3},
  [1977] = {.lex_state = 21, .external_lex_state = 3},
  [1978] = {.lex_state = 21, .external_lex_state = 3},
  [1979] = {.lex_state = 21, .external_lex_state = 3},
  [1980] = {.lex_state = 21, .external_lex_state = 3},
  [1981] = {.lex_state = 21, .external_lex_state = 3},
  [1982] = {.lex_state = 21, .external_lex_state = 3},
  [1983] = {.lex_state = 21, .external_lex_state = 3},
  [1984] = {.lex_state = 21, .external_lex_state = 3},
  [1985] = {.lex_state = 21, .external_lex_state = 3},
  [1986] = {.lex_state = 21, .external_lex_state = 31},
  [1987] = {.lex_state = 21, .external_lex_state = 31},
  [1988] = {.lex_state = 21, .external_lex_state = 31},
  [1989] = {.lex_state = 21, .external_lex_state = 3},
  [1990] = {.lex_state = 21, .external_lex_state = 31},
  [1991] = {.lex_state = 21, .external_lex_state = 3},
  [1992] = {.lex_state = 21, .external_lex_state = 3},
  [1993] = {.lex_state = 21, .external_lex_state = 3},
  [1994] = {.lex_state = 21, .external_lex_state = 3},
  [1995] = {.lex_state = 21, .external_lex_state = 3},
  [1996] = {.lex_state = 21, .external_lex_state = 30},
  [1997] = {.lex_state = 21, .external_lex_state = 3},
  [1998] = {.lex_state = 21, .external_lex_state = 3},
  [1999] = {.lex_state = 21, .external_lex_state = 3},
  [2000] = {.lex_state = 21, .external_lex_state = 3},
  [2001] = {.lex_state = 21, .external_lex_state = 30},
  [2002] = {.lex_state = 21, .external_lex_state = 3},
  [2003] = {.lex_state = 21, .external_lex_state = 3},
  [2004] = {.lex_state = 21, .external_lex_state = 3},
  [2005] = {.lex_state = 21, .external_lex_state = 3},
  [2006] = {.lex_state = 21, .external_lex_state = 3},
  [2007] = {.lex_state = 21, .external_lex_state = 3},
  [2008] = {.lex_state = 21, .external_lex_state = 3},
  [2009] = {.lex_state = 21, .external_lex_state = 31},
  [2010] = {.lex_state = 21, .external_lex_state = 31},
  [2011] = {.lex_state = 21, .external_lex_state = 3},
  [2012] = {.lex_state = 21, .external_lex_state = 31},
  [2013] = {.lex_state = 21, .external_lex_state = 36},
  [2014] = {.lex_state = 21, .external_lex_state = 31},
  [2015] = {.lex_state = 21, .external_lex_state = 22},
  [2016] = {.lex_state = 21, .external_lex_state = 2},
  [2017] = {.lex_state = 21, .external_lex_state = 2},
  [2018] = {.lex_state = 21, .external_lex_state = 31},
  [2019] = {.lex_state = 21, .external_lex_state = 31},
  [2020] = {.lex_state = 21, .external_lex_state = 3},
  [2021] = {.lex_state = 21, .external_lex_state = 31},
  [2022] = {.lex_state = 21, .external_lex_state = 31},
  [2023] = {.lex_state = 21, .external_lex_state = 31},
  [2024] = {.lex_state = 21, .external_lex_state = 31},
  [2025] = {.lex_state = 21, .external_lex_state = 31},
  [2026] = {.lex_state = 21, .external_lex_state = 3},
  [2027] = {.lex_state = 21, .external_lex_state = 31},
  [2028] = {.lex_state = 21, .external_lex_state = 31},
  [2029] = {.lex_state = 21, .external_lex_state = 31},
  [2030] = {.lex_state = 21, .external_lex_state = 31},
  [2031] = {.lex_state = 21, .external_lex_state = 31},
  [2032] = {.lex_state = 21, .external_lex_state = 31},
  [2033] = {.lex_state = 21, .external_lex_state = 31},
  [2034] = {.lex_state = 21, .external_lex_state = 31},
  [2035] = {.lex_state = 21, .external_lex_state = 31},
  [2036] = {.lex_state = 21, .external_lex_state = 31},
  [2037] = {.lex_state = 21, .external_lex_state = 31},
  [2038] = {.lex_state = 21, .external_lex_state = 31},
  [2039] = {.lex_state = 21, .external_lex_state = 5},
  [2040] = {.lex_state = 21, .external_lex_state = 31},
  [2041] = {.lex_state = 21, .external_lex_state = 3},
  [2042] = {.lex_state = 21, .external_lex_state = 31},
  [2043] = {.lex_state = 21, .external_lex_state = 31},
  [2044] = {.lex_state = 21, .external_lex_state = 31},
  [2045] = {.lex_state = 21, .external_lex_state = 30},
  [2046] = {.lex_state = 21, .external_lex_state = 31},
  [2047] = {.lex_state = 21, .external_lex_state = 30},
  [2048] = {.lex_state = 21, .external_lex_state = 30},
  [2049] = {.lex_state = 21, .external_lex_state = 5},
  [2050] = {.lex_state = 21, .external_lex_state = 31},
  [2051] = {.lex_state = 21, .external_lex_state = 30},
  [2052] = {.lex_state = 21, .external_lex_state = 30},
  [2053] = {.lex_state = 21, .external_lex_state = 30},
  [2054] = {.lex_state = 21, .external_lex_state = 3},
  [2055] = {.lex_state = 21, .external_lex_state = 31},
  [2056] = {.lex_state = 21, .external_lex_state = 3},
  [2057] = {.lex_state = 21, .external_lex_state = 30},
  [2058] = {.lex_state = 21, .external_lex_state = 30},
  [2059] = {.lex_state = 21, .external_lex_state = 30},
  [2060] = {.lex_state = 21, .external_lex_state = 31},
  [2061] = {.lex_state = 21, .external_lex_state = 30},
  [2062] = {.lex_state = 21, .external_lex_state = 30},
  [2063] = {.lex_state = 21, .external_lex_state = 30},
  [2064] = {.lex_state = 21, .external_lex_state = 30},
  [2065] = {.lex_state = 21, .external_lex_state = 30},
  [2066] = {.lex_state = 21, .external_lex_state = 31},
  [2067] = {.lex_state = 21, .external_lex_state = 30},
  [2068] = {.lex_state = 21, .external_lex_state = 30},
  [2069] = {.lex_state = 21, .external_lex_state = 30},
  [2070] = {.lex_state = 21, .external_lex_state = 30},
  [2071] = {.lex_state = 21, .external_lex_state = 30},
  [2072] = {.lex_state = 21, .external_lex_state = 30},
  [2073] = {.lex_state = 21, .external_lex_state = 30},
  [2074] = {.lex_state = 21, .external_lex_state = 30},
  [2075] = {.lex_state = 21, .external_lex_state = 30},
  [2076] = {.lex_state = 21, .external_lex_state = 30},
  [2077] = {.lex_state = 21, .external_lex_state = 30},
  [2078] = {.lex_state = 21, .external_lex_state = 30},
  [2079] = {.lex_state = 21, .external_lex_state = 30},
  [2080] = {.lex_state = 21, .external_lex_state = 31},
  [2081] = {.lex_state = 21, .external_lex_state = 30},
  [2082] = {.lex_state = 21, .external_lex_state = 31},
  [2083] = {.lex_state = 21, .external_lex_state = 4},
  [2084] = {.lex_state = 21, .external_lex_state = 30},
  [2085] = {.lex_state = 21, .external_lex_state = 22},
  [2086] = {.lex_state = 21, .external_lex_state = 4},
  [2087] = {.lex_state = 21, .external_lex_state = 22},
  [2088] = {.lex_state = 21, .external_lex_state = 31},
  [2089] = {.lex_state = 21, .external_lex_state = 3},
  [2090] = {.lex_state = 21, .external_lex_state = 30},
  [2091] = {.lex_state = 21, .external_lex_state = 30},
  [2092] = {.lex_state = 21, .external_lex_state = 30},
  [2093] = {.lex_state = 21, .external_lex_state = 3},
  [2094] = {.lex_state = 21, .external_lex_state = 31},
  [2095] = {.lex_state = 21, .external_lex_state = 37},
  [2096] = {.lex_state = 21, .external_lex_state = 31},
  [2097] = {.lex_state = 21, .external_lex_state = 3},
  [2098] = {.lex_state = 21, .external_lex_state = 36},
  [2099] = {.lex_state = 21, .external_lex_state = 36},
  [2100] = {.lex_state = 21, .external_lex_state = 36},
  [2101] = {.lex_state = 21, .external_lex_state = 36},
  [2102] = {.lex_state = 21, .external_lex_state = 36},
  [2103] = {.lex_state = 21, .external_lex_state = 36},
  [2104] = {.lex_state = 21, .external_lex_state = 35},
  [2105] = {.lex_state = 21, .external_lex_state = 36},
  [2106] = {.lex_state = 21, .external_lex_state = 36},
  [2107] = {.lex_state = 21, .external_lex_state = 35},
  [2108] = {.lex_state = 21, .external_lex_state = 35},
  [2109] = {.lex_state = 21, .external_lex_state = 36},
  [2110] = {.lex_state = 21, .external_lex_state = 35},
  [2111] = {.lex_state = 21, .external_lex_state = 35},
  [2112] = {.lex_state = 21, .external_lex_state = 36},
  [2113] = {.lex_state = 21, .external_lex_state = 36},
  [2114] = {.lex_state = 21, .external_lex_state = 36},
  [2115] = {.lex_state = 21, .external_lex_state = 36},
  [2116] = {.lex_state = 21, .external_lex_state = 35},
  [2117] = {.lex_state = 21, .external_lex_state = 35},
  [2118] = {.lex_state = 21, .external_lex_state = 36},
  [2119] = {.lex_state = 21, .external_lex_state = 35},
  [2120] = {.lex_state = 21, .external_lex_state = 35},
  [2121] = {.lex_state = 21, .external_lex_state = 35},
  [2122] = {.lex_state = 21, .external_lex_state = 35},
  [2123] = {.lex_state = 21, .external_lex_state = 36},
  [2124] = {.lex_state = 21, .external_lex_state = 35},
  [2125] = {.lex_state = 21, .external_lex_state = 36},
  [2126] = {.lex_state = 21, .external_lex_state = 35},
  [2127] = {.lex_state = 21, .external_lex_state = 35},
  [2128] = {.lex_state = 21, .external_lex_state = 36},
  [2129] = {.lex_state = 21, .external_lex_state = 36},
  [2130] = {.lex_state = 21, .external_lex_state = 36},
  [2131] = {.lex_state = 21, .external_lex_state = 36},
  [2132] = {.lex_state = 21, .external_lex_state = 35},
  [2133] = {.lex_state = 21, .external_lex_state = 36},
  [2134] = {.lex_state = 21, .external_lex_state = 36},
  [2135] = {.lex_state = 21, .external_lex_state = 36},
  [2136] = {.lex_state = 21, .external_lex_state = 36},
  [2137] = {.lex_state = 21, .external_lex_state = 36},
  [2138] = {.lex_state = 21, .external_lex_state = 36},
  [2139] = {.lex_state = 21, .external_lex_state = 3},
  [2140] = {.lex_state = 21, .external_lex_state = 36},
  [2141] = {.lex_state = 21, .external_lex_state = 35},
  [2142] = {.lex_state = 21, .external_lex_state = 36},
  [2143] = {.lex_state = 21, .external_lex_state = 36},
  [2144] = {.lex_state = 21, .external_lex_state = 36},
  [2145] = {.lex_state = 21, .external_lex_state = 36},
  [2146] = {.lex_state = 21, .external_lex_state = 36},
  [2147] = {.lex_state = 21, .external_lex_state = 35},
  [2148] = {.lex_state = 21, .external_lex_state = 35},
  [2149] = {.lex_state = 21, .external_lex_state = 36},
  [2150] = {.lex_state = 21, .external_lex_state = 35},
  [2151] = {.lex_state = 21, .external_lex_state = 35},
  [2152] = {.lex_state = 21, .external_lex_state = 5},
  [2153] = {.lex_state = 21, .external_lex_state = 35},
  [2154] = {.lex_state = 21, .external_lex_state = 35},
  [2155] = {.lex_state = 21, .external_lex_state = 35},
  [2156] = {.lex_state = 21, .external_lex_state = 36},
  [2157] = {.lex_state = 21, .external_lex_state = 35},
  [2158] = {.lex_state = 21, .external_lex_state = 36},
  [2159] = {.lex_state = 21, .external_lex_state = 35},
  [2160] = {.lex_state = 21, .external_lex_state = 35},
  [2161] = {.lex_state = 21, .external_lex_state = 35},
  [2162] = {.lex_state = 21, .external_lex_state = 35},
  [2163] = {.lex_state = 21, .external_lex_state = 35},
  [2164] = {.lex_state = 21, .external_lex_state = 36},
  [2165] = {.lex_state = 21, .external_lex_state = 35},
  [2166] = {.lex_state = 21, .external_lex_state = 36},
  [2167] = {.lex_state = 21, .external_lex_state = 35},
  [2168] = {.lex_state = 21, .external_lex_state = 35},
  [2169] = {.lex_state = 21, .external_lex_state = 35},
  [2170] = {.lex_state = 21, .external_lex_state = 36},
  [2171] = {.lex_state = 21, .external_lex_state = 35},
  [2172] = {.lex_state = 21, .external_lex_state = 36},
  [2173] = {.lex_state = 21, .external_lex_state = 35},
  [2174] = {.lex_state = 21, .external_lex_state = 35},
  [2175] = {.lex_state = 21, .external_lex_state = 36},
  [2176] = {.lex_state = 21, .external_lex_state = 35},
  [2177] = {.lex_state = 21, .external_lex_state = 35},
  [2178] = {.lex_state = 21, .external_lex_state = 35},
  [2179] = {.lex_state = 21, .external_lex_state = 36},
  [2180] = {.lex_state = 21, .external_lex_state = 2},
  [2181] = {.lex_state = 21, .external_lex_state = 35},
  [2182] = {.lex_state = 21, .external_lex_state = 36},
  [2183] = {.lex_state = 21, .external_lex_state = 4},
  [2184] = {.lex_state = 21, .external_lex_state = 35},
  [2185] = {.lex_state = 21, .external_lex_state = 35},
  [2186] = {.lex_state = 21, .external_lex_state = 35},
  [2187] = {.lex_state = 21, .external_lex_state = 36},
  [2188] = {.lex_state = 21, .external_lex_state = 36},
  [2189] = {.lex_state = 21, .external_lex_state = 36},
  [2190] = {.lex_state = 21, .external_lex_state = 36},
  [2191] = {.lex_state = 21, .external_lex_state = 36},
  [2192] = {.lex_state = 21, .external_lex_state = 37},
  [2193] = {.lex_state = 21, .external_lex_state = 2},
  [2194] = {.lex_state = 21, .external_lex_state = 2},
  [2195] = {.lex_state = 21, .external_lex_state = 2},
  [2196] = {.lex_state = 21, .external_lex_state = 38},
  [2197] = {.lex_state = 21, .external_lex_state = 4},
  [2198] = {.lex_state = 21, .external_lex_state = 4},
  [2199] = {.lex_state = 21, .external_lex_state = 2},
  [2200] = {.lex_state = 21, .external_lex_state = 2},
  [2201] = {.lex_state = 21, .external_lex_state = 2},
  [2202] = {.lex_state = 21, .external_lex_state = 2},
  [2203] = {.lex_state = 21, .external_lex_state = 4},
  [2204] = {.lex_state = 21, .external_lex_state = 2},
  [2205] = {.lex_state = 21, .external_lex_state = 2},
  [2206] = {.lex_state = 21, .external_lex_state = 2},
  [2207] = {.lex_state = 21, .external_lex_state = 4},
  [2208] = {.lex_state = 21, .external_lex_state = 2},
  [2209] = {.lex_state = 21, .external_lex_state = 2},
  [2210] = {.lex_state = 21, .external_lex_state = 2},
  [2211] = {.lex_state = 21, .external_lex_state = 2},
  [2212] = {.lex_state = 21, .external_lex_state = 4},
  [2213] = {.lex_state = 21, .external_lex_state = 2},
  [2214] = {.lex_state = 21, .external_lex_state = 2},
  [2215] = {.lex_state = 21, .external_lex_state = 5},
  [2216] = {.lex_state = 21, .external_lex_state = 5},
  [2217] = {.lex_state = 21, .external_lex_state = 5},
  [2218] = {.lex_state = 21, .external_lex_state = 2},
  [2219] = {.lex_state = 21, .external_lex_state = 2},
  [2220] = {.lex_state = 21, .external_lex_state = 36},
  [2221] = {.lex_state = 21, .external_lex_state = 2},
  [2222] = {.lex_state = 21, .external_lex_state = 37},
  [2223] = {.lex_state = 2, .external_lex_state = 39},
  [2224] = {.lex_state = 21, .external_lex_state = 2},
  [2225] = {.lex_state = 21, .external_lex_state = 2},
  [2226] = {.lex_state = 21, .external_lex_state = 5},
  [2227] = {.lex_state = 21, .external_lex_state = 2},
  [2228] = {.lex_state = 21, .external_lex_state = 37},
  [2229] = {.lex_state = 21, .external_lex_state = 22},
  [2230] = {.lex_state = 21, .external_lex_state = 2},
  [2231] = {.lex_state = 21, .external_lex_state = 22},
  [2232] = {.lex_state = 21, .external_lex_state = 2},
  [2233] = {.lex_state = 21, .external_lex_state = 22},
  [2234] = {.lex_state = 21, .external_lex_state = 2},
  [2235] = {.lex_state = 21, .external_lex_state = 5},
  [2236] = {.lex_state = 21, .external_lex_state = 5},
  [2237] = {.lex_state = 21, .external_lex_state = 5},
  [2238] = {.lex_state = 21, .external_lex_state = 5},
  [2239] = {.lex_state = 21, .external_lex_state = 37},
  [2240] = {.lex_state = 21, .external_lex_state = 22},
  [2241] = {.lex_state = 21, .external_lex_state = 22},
  [2242] = {.lex_state = 21, .external_lex_state = 22},
  [2243] = {.lex_state = 21, .external_lex_state = 5},
  [2244] = {.lex_state = 21, .external_lex_state = 5},
  [2245] = {.lex_state = 21, .external_lex_state = 22},
  [2246] = {.lex_state = 21, .external_lex_state = 37},
  [2247] = {.lex_state = 21, .external_lex_state = 2},
  [2248] = {.lex_state = 21, .external_lex_state = 5},
  [2249] = {.lex_state = 21, .external_lex_state = 5},
  [2250] = {.lex_state = 21, .external_lex_state = 5},
  [2251] = {.lex_state = 21, .external_lex_state = 5},
  [2252] = {.lex_state = 21, .external_lex_state = 5},
  [2253] = {.lex_state = 21, .external_lex_state = 38},
  [2254] = {.lex_state = 21, .external_lex_state = 4},
  [2255] = {.lex_state = 21, .external_lex_state = 4},
  [2256] = {.lex_state = 21, .external_lex_state = 22},
  [2257] = {.lex_state = 21, .external_lex_state = 5},
  [2258] = {.lex_state = 21, .external_lex_state = 5},
  [2259] = {.lex_state = 21, .external_lex_state = 22},
  [2260] = {.lex_state = 21, .external_lex_state = 5},
  [2261] = {.lex_state = 21, .external_lex_state = 5},
  [2262] = {.lex_state = 21, .external_lex_state = 5},
  [2263] = {.lex_state = 21, .external_lex_state = 5},
  [2264] = {.lex_state = 21, .external_lex_state = 4},
  [2265] = {.lex_state = 21, .external_lex_state = 5},
  [2266] = {.lex_state = 21, .external_lex_state = 5},
  [2267] = {.lex_state = 21, .external_lex_state = 5},
  [2268] = {.lex_state = 21, .external_lex_state = 38},
  [2269] = {.lex_state = 21, .external_lex_state = 22},
  [2270] = {.lex_state = 21, .external_lex_state = 38},
  [2271] = {.lex_state = 21, .external_lex_state = 22},
  [2272] = {.lex_state = 21, .external_lex_state = 5},
  [2273] = {.lex_state = 21, .external_lex_state = 5},
  [2274] = {.lex_state = 21, .external_lex_state = 5},
  [2275] = {.lex_state = 21, .external_lex_state = 5},
  [2276] = {.lex_state = 21, .external_lex_state = 38},
  [2277] = {.lex_state = 21, .external_lex_state = 22},
  [2278] = {.lex_state = 21, .external_lex_state = 38},
  [2279] = {.lex_state = 21, .external_lex_state = 38},
  [2280] = {.lex_state = 21, .external_lex_state = 22},
  [2281] = {.lex_state = 21, .external_lex_state = 38},
  [2282] = {.lex_state = 21, .external_lex_state = 38},
  [2283] = {.lex_state = 21, .external_lex_state = 2},
  [2284] = {.lex_state = 21, .external_lex_state = 5},
  [2285] = {.lex_state = 21, .external_lex_state = 22},
  [2286] = {.lex_state = 21, .external_lex_state = 5},
  [2287] = {.lex_state = 21, .external_lex_state = 5},
  [2288] = {.lex_state = 21, .external_lex_state = 38},
  [2289] = {.lex_state = 21, .external_lex_state = 38},
  [2290] = {.lex_state = 21, .external_lex_state = 38},
  [2291] = {.lex_state = 21, .external_lex_state = 38},
  [2292] = {.lex_state = 21, .external_lex_state = 38},
  [2293] = {.lex_state = 21, .external_lex_state = 5},
  [2294] = {.lex_state = 21, .external_lex_state = 5},
  [2295] = {.lex_state = 21, .external_lex_state = 38},
  [2296] = {.lex_state = 21, .external_lex_state = 38},
  [2297] = {.lex_state = 21, .external_lex_state = 38},
  [2298] = {.lex_state = 21, .external_lex_state = 38},
  [2299] = {.lex_state = 21, .external_lex_state = 22},
  [2300] = {.lex_state = 21, .external_lex_state = 22},
  [2301] = {.lex_state = 21, .external_lex_state = 5},
  [2302] = {.lex_state = 21, .external_lex_state = 38},
  [2303] = {.lex_state = 21, .external_lex_state = 38},
  [2304] = {.lex_state = 21, .external_lex_state = 38},
  [2305] = {.lex_state = 21, .external_lex_state = 5},
  [2306] = {.lex_state = 21, .external_lex_state = 38},
  [2307] = {.lex_state = 21, .external_lex_state = 22},
  [2308] = {.lex_state = 21, .external_lex_state = 38},
  [2309] = {.lex_state = 21, .external_lex_state = 38},
  [2310] = {.lex_state = 21, .external_lex_state = 38},
  [2311] = {.lex_state = 21, .external_lex_state = 5},
  [2312] = {.lex_state = 21, .external_lex_state = 38},
  [2313] = {.lex_state = 21, .external_lex_state = 38},
  [2314] = {.lex_state = 21, .external_lex_state = 2},
  [2315] = {.lex_state = 21, .external_lex_state = 4},
  [2316] = {.lex_state = 21, .external_lex_state = 22},
  [2317] = {.lex_state = 21, .external_lex_state = 22},
  [2318] = {.lex_state = 21, .external_lex_state = 2},
  [2319] = {.lex_state = 21, .external_lex_state = 37},
  [2320] = {.lex_state = 21, .external_lex_state = 2},
  [2321] = {.lex_state = 21, .external_lex_state = 22},
  [2322] = {.lex_state = 21, .external_lex_state = 2},
  [2323] = {.lex_state = 21, .external_lex_state = 37},
  [2324] = {.lex_state = 21, .external_lex_state = 2},
  [2325] = {.lex_state = 21, .external_lex_state = 2},
  [2326] = {.lex_state = 21, .external_lex_state = 38},
  [2327] = {.lex_state = 21, .external_lex_state = 38},
  [2328] = {.lex_state = 21, .external_lex_state = 22},
  [2329] = {.lex_state = 21, .external_lex_state = 38},
  [2330] = {.lex_state = 21, .external_lex_state = 22},
  [2331] = {.lex_state = 21, .external_lex_state = 38},
  [2332] = {.lex_state = 21, .external_lex_state = 2},
  [2333] = {.lex_state = 21, .external_lex_state = 22},
  [2334] = {.lex_state = 21, .external_lex_state = 2},
  [2335] = {.lex_state = 21, .external_lex_state = 22},
  [2336] = {.lex_state = 21, .external_lex_state = 37},
  [2337] = {.lex_state = 21, .external_lex_state = 22},
  [2338] = {.lex_state = 21, .external_lex_state = 22},
  [2339] = {.lex_state = 21, .external_lex_state = 4},
  [2340] = {.lex_state = 21, .external_lex_state = 4},
  [2341] = {.lex_state = 21, .external_lex_state = 22},
  [2342] = {.lex_state = 21, .external_lex_state = 22},
  [2343] = {.lex_state = 21, .external_lex_state = 22},
  [2344] = {.lex_state = 21, .external_lex_state = 4},
  [2345] = {.lex_state = 21, .external_lex_state = 4},
  [2346] = {.lex_state = 21, .external_lex_state = 22},
  [2347] = {.lex_state = 21, .external_lex_state = 38},
  [2348] = {.lex_state = 21, .external_lex_state = 38},
  [2349] = {.lex_state = 21, .external_lex_state = 5},
  [2350] = {.lex_state = 21, .external_lex_state = 38},
  [2351] = {.lex_state = 21, .external_lex_state = 38},
  [2352] = {.lex_state = 21, .external_lex_state = 38},
  [2353] = {.lex_state = 21, .external_lex_state = 38},
  [2354] = {.lex_state = 21, .external_lex_state = 38},
  [2355] = {.lex_state = 21, .external_lex_state = 38},
  [2356] = {.lex_state = 21, .external_lex_state = 38},
  [2357] = {.lex_state = 21, .external_lex_state = 22},
  [2358] = {.lex_state = 21, .external_lex_state = 5},
  [2359] = {.lex_state = 21, .external_lex_state = 22},
  [2360] = {.lex_state = 21, .external_lex_state = 37},
  [2361] = {.lex_state = 21, .external_lex_state = 38},
  [2362] = {.lex_state = 21, .external_lex_state = 37},
  [2363] = {.lex_state = 21, .external_lex_state = 22},
  [2364] = {.lex_state = 21, .external_lex_state = 4},
  [2365] = {.lex_state = 21, .external_lex_state = 37},
  [2366] = {.lex_state = 21, .external_lex_state = 37},
  [2367] = {.lex_state = 21, .external_lex_state = 4},
  [2368] = {.lex_state = 21, .external_lex_state = 4},
  [2369] = {.lex_state = 21, .external_lex_state = 22},
  [2370] = {.lex_state = 21, .external_lex_state = 4},
  [2371] = {.lex_state = 21, .external_lex_state = 22},
  [2372] = {.lex_state = 21, .external_lex_state = 2},
  [2373] = {.lex_state = 21, .external_lex_state = 5},
  [2374] = {.lex_state = 21, .external_lex_state = 37},
  [2375] = {.lex_state = 21, .external_lex_state = 5},
  [2376] = {.lex_state = 21, .external_lex_state = 22},
  [2377] = {.lex_state = 21, .external_lex_state = 5},
  [2378] = {.lex_state = 21, .external_lex_state = 5},
  [2379] = {.lex_state = 21, .external_lex_state = 37},
  [2380] = {.lex_state = 21, .external_lex_state = 37},
  [2381] = {.lex_state = 21, .external_lex_state = 22},
  [2382] = {.lex_state = 21, .external_lex_state = 22},
  [2383] = {.lex_state = 21, .external_lex_state = 5},
  [2384] = {.lex_state = 21, .external_lex_state = 5},
  [2385] = {.lex_state = 21, .external_lex_state = 5},
  [2386] = {.lex_state = 21, .external_lex_state = 5},
  [2387] = {.lex_state = 21, .external_lex_state = 5},
  [2388] = {.lex_state = 21, .external_lex_state = 22},
  [2389] = {.lex_state = 21, .external_lex_state = 4},
  [2390] = {.lex_state = 21, .external_lex_state = 5},
  [2391] = {.lex_state = 21, .external_lex_state = 5},
  [2392] = {.lex_state = 21, .external_lex_state = 37},
  [2393] = {.lex_state = 21, .external_lex_state = 37},
  [2394] = {.lex_state = 21, .external_lex_state = 37},
  [2395] = {.lex_state = 21, .external_lex_state = 5},
  [2396] = {.lex_state = 21, .external_lex_state = 5},
  [2397] = {.lex_state = 21, .external_lex_state = 5},
  [2398] = {.lex_state = 21, .external_lex_state = 5},
  [2399] = {.lex_state = 21, .external_lex_state = 5},
  [2400] = {.lex_state = 21, .external_lex_state = 37},
  [2401] = {.lex_state = 21, .external_lex_state = 37},
  [2402] = {.lex_state = 21, .external_lex_state = 37},
  [2403] = {.lex_state = 21, .external_lex_state = 37},
  [2404] = {.lex_state = 21, .external_lex_state = 37},
  [2405] = {.lex_state = 21, .external_lex_state = 5},
  [2406] = {.lex_state = 21, .external_lex_state = 37},
  [2407] = {.lex_state = 21, .external_lex_state = 22},
  [2408] = {.lex_state = 21, .external_lex_state = 37},
  [2409] = {.lex_state = 21, .external_lex_state = 37},
  [2410] = {.lex_state = 21, .external_lex_state = 37},
  [2411] = {.lex_state = 21, .external_lex_state = 5},
  [2412] = {.lex_state = 21, .external_lex_state = 37},
  [2413] = {.lex_state = 21, .external_lex_state = 37},
  [2414] = {.lex_state = 21, .external_lex_state = 37},
  [2415] = {.lex_state = 21, .external_lex_state = 37},
  [2416] = {.lex_state = 21, .external_lex_state = 37},
  [2417] = {.lex_state = 21, .external_lex_state = 37},
  [2418] = {.lex_state = 21, .external_lex_state = 37},
  [2419] = {.lex_state = 21, .external_lex_state = 37},
  [2420] = {.lex_state = 21, .external_lex_state = 37},
  [2421] = {.lex_state = 21, .external_lex_state = 2},
  [2422] = {.lex_state = 21, .external_lex_state = 38},
  [2423] = {.lex_state = 21, .external_lex_state = 5},
  [2424] = {.lex_state = 21, .external_lex_state = 5},
  [2425] = {.lex_state = 21, .external_lex_state = 22},
  [2426] = {.lex_state = 21, .external_lex_state = 2},
  [2427] = {.lex_state = 21, .external_lex_state = 2},
  [2428] = {.lex_state = 21, .external_lex_state = 2},
  [2429] = {.lex_state = 21, .external_lex_state = 2},
  [2430] = {.lex_state = 21, .external_lex_state = 22},
  [2431] = {.lex_state = 21, .external_lex_state = 2},
  [2432] = {.lex_state = 21, .external_lex_state = 22},
  [2433] = {.lex_state = 21, .external_lex_state = 2},
  [2434] = {.lex_state = 21, .external_lex_state = 4},
  [2435] = {.lex_state = 21, .external_lex_state = 22},
  [2436] = {.lex_state = 21, .external_lex_state = 2},
  [2437] = {.lex_state = 21, .external_lex_state = 22},
  [2438] = {.lex_state = 21, .external_lex_state = 2},
  [2439] = {.lex_state = 21, .external_lex_state = 2},
  [2440] = {.lex_state = 21, .external_lex_state = 37},
  [2441] = {.lex_state = 21, .external_lex_state = 38},
  [2442] = {.lex_state = 21, .external_lex_state = 36},
  [2443] = {.lex_state = 21, .external_lex_state = 38},
  [2444] = {.lex_state = 21, .external_lex_state = 2},
  [2445] = {.lex_state = 21, .external_lex_state = 36},
  [2446] = {.lex_state = 21, .external_lex_state = 38},
  [2447] = {.lex_state = 21, .external_lex_state = 36},
  [2448] = {.lex_state = 21, .external_lex_state = 37},
  [2449] = {.lex_state = 21, .external_lex_state = 2},
  [2450] = {.lex_state = 21, .external_lex_state = 36},
  [2451] = {.lex_state = 21, .external_lex_state = 38},
  [2452] = {.lex_state = 21, .external_lex_state = 36},
  [2453] = {.lex_state = 21, .external_lex_state = 38},
  [2454] = {.lex_state = 21, .external_lex_state = 4},
  [2455] = {.lex_state = 21, .external_lex_state = 4},
  [2456] = {.lex_state = 21, .external_lex_state = 4},
  [2457] = {.lex_state = 21, .external_lex_state = 4},
  [2458] = {.lex_state = 21, .external_lex_state = 4},
  [2459] = {.lex_state = 21, .external_lex_state = 36},
  [2460] = {.lex_state = 21, .external_lex_state = 4},
  [2461] = {.lex_state = 21, .external_lex_state = 4},
  [2462] = {.lex_state = 21, .external_lex_state = 2},
  [2463] = {.lex_state = 21, .external_lex_state = 4},
  [2464] = {.lex_state = 21, .external_lex_state = 4},
  [2465] = {.lex_state = 21, .external_lex_state = 2},
  [2466] = {.lex_state = 21, .external_lex_state = 2},
  [2467] = {.lex_state = 21, .external_lex_state = 2},
  [2468] = {.lex_state = 21, .external_lex_state = 2},
  [2469] = {.lex_state = 21, .external_lex_state = 2},
  [2470] = {.lex_state = 21, .external_lex_state = 4},
  [2471] = {.lex_state = 21, .external_lex_state = 4},
  [2472] = {.lex_state = 21, .external_lex_state = 4},
  [2473] = {.lex_state = 21, .external_lex_state = 4},
  [2474] = {.lex_state = 21, .external_lex_state = 2},
  [2475] = {.lex_state = 21, .external_lex_state = 2},
  [2476] = {.lex_state = 21, .external_lex_state = 2},
  [2477] = {.lex_state = 21, .external_lex_state = 2},
  [2478] = {.lex_state = 21, .external_lex_state = 38},
  [2479] = {.lex_state = 2, .external_lex_state = 39},
  [2480] = {.lex_state = 21, .external_lex_state = 2},
  [2481] = {.lex_state = 21, .external_lex_state = 4},
  [2482] = {.lex_state = 21, .external_lex_state = 38},
  [2483] = {.lex_state = 21, .external_lex_state = 4},
  [2484] = {.lex_state = 21, .external_lex_state = 4},
  [2485] = {.lex_state = 21, .external_lex_state = 4},
  [2486] = {.lex_state = 21, .external_lex_state = 4},
  [2487] = {.lex_state = 21, .external_lex_state = 4},
  [2488] = {.lex_state = 21, .external_lex_state = 36},
  [2489] = {.lex_state = 21, .external_lex_state = 4},
  [2490] = {.lex_state = 21, .external_lex_state = 4},
  [2491] = {.lex_state = 21, .external_lex_state = 4},
  [2492] = {.lex_state = 21, .external_lex_state = 4},
  [2493] = {.lex_state = 21, .external_lex_state = 4},
  [2494] = {.lex_state = 21, .external_lex_state = 4},
  [2495] = {.lex_state = 21, .external_lex_state = 4},
  [2496] = {.lex_state = 21, .external_lex_state = 4},
  [2497] = {.lex_state = 21, .external_lex_state = 4},
  [2498] = {.lex_state = 21, .external_lex_state = 4},
  [2499] = {.lex_state = 21, .external_lex_state = 4},
  [2500] = {.lex_state = 21, .external_lex_state = 4},
  [2501] = {.lex_state = 21, .external_lex_state = 4},
  [2502] = {.lex_state = 21, .external_lex_state = 4},
  [2503] = {.lex_state = 21, .external_lex_state = 38},
  [2504] = {.lex_state = 21, .external_lex_state = 4},
  [2505] = {.lex_state = 21, .external_lex_state = 4},
  [2506] = {.lex_state = 21, .external_lex_state = 4},
  [2507] = {.lex_state = 21, .external_lex_state = 4},
  [2508] = {.lex_state = 21, .external_lex_state = 38},
  [2509] = {.lex_state = 21, .external_lex_state = 37},
  [2510] = {.lex_state = 21, .external_lex_state = 37},
  [2511] = {.lex_state = 21, .external_lex_state = 38},
  [2512] = {.lex_state = 21, .external_lex_state = 38},
  [2513] = {.lex_state = 21, .external_lex_state = 38},
  [2514] = {.lex_state = 21, .external_lex_state = 38},
  [2515] = {.lex_state = 21, .external_lex_state = 38},
  [2516] = {.lex_state = 21, .external_lex_state = 38},
  [2517] = {.lex_state = 21, .external_lex_state = 38},
  [2518] = {.lex_state = 21, .external_lex_state = 38},
  [2519] = {.lex_state = 21, .external_lex_state = 38},
  [2520] = {.lex_state = 21, .external_lex_state = 4},
  [2521] = {.lex_state = 21, .external_lex_state = 22},
  [2522] = {.lex_state = 21, .external_lex_state = 22},
  [2523] = {.lex_state = 21, .external_lex_state = 22},
  [2524] = {.lex_state = 21, .external_lex_state = 22},
  [2525] = {.lex_state = 21, .external_lex_state = 4},
  [2526] = {.lex_state = 21, .external_lex_state = 37},
  [2527] = {.lex_state = 21, .external_lex_state = 37},
  [2528] = {.lex_state = 21, .external_lex_state = 37},
  [2529] = {.lex_state = 21, .external_lex_state = 4},
  [2530] = {.lex_state = 21, .external_lex_state = 5},
  [2531] = {.lex_state = 21, .external_lex_state = 4},
  [2532] = {.lex_state = 21, .external_lex_state = 5},
  [2533] = {.lex_state = 21, .external_lex_state = 2},
  [2534] = {.lex_state = 2, .external_lex_state = 39},
  [2535] = {.lex_state = 2, .external_lex_state = 39},
  [2536] = {.lex_state = 2, .external_lex_state = 39},
  [2537] = {.lex_state = 2, .external_lex_state = 39},
  [2538] = {.lex_state = 2, .external_lex_state = 39},
  [2539] = {.lex_state = 2, .external_lex_state = 39},
  [2540] = {.lex_state = 2, .external_lex_state = 39},
  [2541] = {.lex_state = 2, .external_lex_state = 39},
  [2542] = {.lex_state = 2, .external_lex_state = 39},
  [2543] = {.lex_state = 2, .external_lex_state = 39},
  [2544] = {.lex_state = 20, .external_lex_state = 16},
  [2545] = {.lex_state = 20, .external_lex_state = 15},
  [2546] = {.lex_state = 20, .external_lex_state = 16},
  [2547] = {.lex_state = 20, .external_lex_state = 16},
  [2548] = {.lex_state = 0, .external_lex_state = 40},
  [2549] = {.lex_state = 20, .external_lex_state = 16},
  [2550] = {.lex_state = 0, .external_lex_state = 40},
  [2551] = {.lex_state = 0, .external_lex_state = 40},
  [2552] = {.lex_state = 0, .external_lex_state = 40},
  [2553] = {.lex_state = 0, .external_lex_state = 40},
  [2554] = {.lex_state = 0, .external_lex_state = 40},
  [2555] = {.lex_state = 0, .external_lex_state = 40},
  [2556] = {.lex_state = 0, .external_lex_state = 40},
  [2557] = {.lex_state = 0, .external_lex_state = 40},
  [2558] = {.lex_state = 0, .external_lex_state = 40},
  [2559] = {.lex_state = 0, .external_lex_state = 40},
  [2560] = {.lex_state = 0, .external_lex_state = 40},
  [2561] = {.lex_state = 0, .external_lex_state = 40},
  [2562] = {.lex_state = 0, .external_lex_state = 40},
  [2563] = {.lex_state = 0, .external_lex_state = 40},
  [2564] = {.lex_state = 20, .external_lex_state = 16},
  [2565] = {.lex_state = 0, .external_lex_state = 40},
  [2566] = {.lex_state = 0, .external_lex_state = 40},
  [2567] = {.lex_state = 0, .external_lex_state = 40},
  [2568] = {.lex_state = 0, .external_lex_state = 40},
  [2569] = {.lex_state = 0, .external_lex_state = 40},
  [2570] = {.lex_state = 0, .external_lex_state = 40},
  [2571] = {.lex_state = 0, .external_lex_state = 40},
  [2572] = {.lex_state = 0, .external_lex_state = 40},
  [2573] = {.lex_state = 0, .external_lex_state = 40},
  [2574] = {.lex_state = 0, .external_lex_state = 40},
  [2575] = {.lex_state = 2, .external_lex_state = 41},
  [2576] = {.lex_state = 21, .external_lex_state = 16},
  [2577] = {.lex_state = 0, .external_lex_state = 42},
  [2578] = {.lex_state = 0, .external_lex_state = 42},
  [2579] = {.lex_state = 0, .external_lex_state = 42},
  [2580] = {.lex_state = 0, .external_lex_state = 42},
  [2581] = {.lex_state = 0, .external_lex_state = 42},
  [2582] = {.lex_state = 0, .external_lex_state = 42},
  [2583] = {.lex_state = 0, .external_lex_state = 42},
  [2584] = {.lex_state = 0, .external_lex_state = 42},
  [2585] = {.lex_state = 0, .external_lex_state = 42},
  [2586] = {.lex_state = 0, .external_lex_state = 42},
  [2587] = {.lex_state = 0, .external_lex_state = 42},
  [2588] = {.lex_state = 0, .external_lex_state = 42},
  [2589] = {.lex_state = 0, .external_lex_state = 42},
  [2590] = {.lex_state = 20, .external_lex_state = 16},
  [2591] = {.lex_state = 0, .external_lex_state = 42},
  [2592] = {.lex_state = 0, .external_lex_state = 42},
  [2593] = {.lex_state = 0, .external_lex_state = 42},
  [2594] = {.lex_state = 0, .external_lex_state = 42},
  [2595] = {.lex_state = 0, .external_lex_state = 42},
  [2596] = {.lex_state = 0, .external_lex_state = 42},
  [2597] = {.lex_state = 0, .external_lex_state = 42},
  [2598] = {.lex_state = 0, .external_lex_state = 42},
  [2599] = {.lex_state = 0, .external_lex_state = 42},
  [2600] = {.lex_state = 0, .external_lex_state = 42},
  [2601] = {.lex_state = 0, .external_lex_state = 42},
  [2602] = {.lex_state = 0, .external_lex_state = 42},
  [2603] = {.lex_state = 0, .external_lex_state = 42},
  [2604] = {.lex_state = 0, .external_lex_state = 42},
  [2605] = {.lex_state = 0, .external_lex_state = 42},
  [2606] = {.lex_state = 0, .external_lex_state = 42},
  [2607] = {.lex_state = 0, .external_lex_state = 42},
  [2608] = {.lex_state = 0, .external_lex_state = 42},
  [2609] = {.lex_state = 0, .external_lex_state = 42},
  [2610] = {.lex_state = 0, .external_lex_state = 42},
  [2611] = {.lex_state = 0, .external_lex_state = 42},
  [2612] = {.lex_state = 0, .external_lex_state = 42},
  [2613] = {.lex_state = 0, .external_lex_state = 42},
  [2614] = {.lex_state = 0, .external_lex_state = 42},
  [2615] = {.lex_state = 0, .external_lex_state = 42},
  [2616] = {.lex_state = 0, .external_lex_state = 42},
  [2617] = {.lex_state = 0, .external_lex_state = 42},
  [2618] = {.lex_state = 0, .external_lex_state = 42},
  [2619] = {.lex_state = 0, .external_lex_state = 42},
  [2620] = {.lex_state = 0, .external_lex_state = 42},
  [2621] = {.lex_state = 0, .external_lex_state = 42},
  [2622] = {.lex_state = 0, .external_lex_state = 42},
  [2623] = {.lex_state = 0, .external_lex_state = 42},
  [2624] = {.lex_state = 0, .external_lex_state = 42},
  [2625] = {.lex_state = 0, .external_lex_state = 42},
  [2626] = {.lex_state = 0, .external_lex_state = 42},
  [2627] = {.lex_state = 0, .external_lex_state = 42},
  [2628] = {.lex_state = 0, .external_lex_state = 42},
  [2629] = {.lex_state = 0, .external_lex_state = 42},
  [2630] = {.lex_state = 0, .external_lex_state = 42},
  [2631] = {.lex_state = 0, .external_lex_state = 42},
  [2632] = {.lex_state = 0, .external_lex_state = 42},
  [2633] = {.lex_state = 0, .external_lex_state = 42},
  [2634] = {.lex_state = 0, .external_lex_state = 42},
  [2635] = {.lex_state = 0, .external_lex_state = 42},
  [2636] = {.lex_state = 0, .external_lex_state = 42},
  [2637] = {.lex_state = 0, .external_lex_state = 42},
  [2638] = {.lex_state = 0, .external_lex_state = 42},
  [2639] = {.lex_state = 0, .external_lex_state = 42},
  [2640] = {.lex_state = 0, .external_lex_state = 42},
  [2641] = {.lex_state = 0, .external_lex_state = 42},
  [2642] = {.lex_state = 0, .external_lex_state = 42},
  [2643] = {.lex_state = 0, .external_lex_state = 42},
  [2644] = {.lex_state = 0, .external_lex_state = 42},
  [2645] = {.lex_state = 2, .external_lex_state = 41},
  [2646] = {.lex_state = 0, .external_lex_state = 42},
  [2647] = {.lex_state = 0, .external_lex_state = 42},
  [2648] = {.lex_state = 0, .external_lex_state = 42},
  [2649] = {.lex_state = 20, .external_lex_state = 16},
  [2650] = {.lex_state = 0, .external_lex_state = 42},
  [2651] = {.lex_state = 23, .external_lex_state = 16},
  [2652] = {.lex_state = 20, .external_lex_state = 41},
  [2653] = {.lex_state = 23, .external_lex_state = 16},
  [2654] = {.lex_state = 20, .external_lex_state = 41},
  [2655] = {.lex_state = 20, .external_lex_state = 41},
  [2656] = {.lex_state = 20, .external_lex_state = 41},
  [2657] = {.lex_state = 20, .external_lex_state = 41},
  [2658] = {.lex_state = 20, .external_lex_state = 41},
  [2659] = {.lex_state = 23, .external_lex_state = 41},
  [2660] = {.lex_state = 20, .external_lex_state = 41},
  [2661] = {.lex_state = 20, .external_lex_state = 41},
  [2662] = {.lex_state = 20, .external_lex_state = 41},
  [2663] = {.lex_state = 23, .external_lex_state = 43},
  [2664] = {.lex_state = 20, .external_lex_state = 41},
  [2665] = {.lex_state = 20, .external_lex_state = 41},
  [2666] = {.lex_state = 20, .external_lex_state = 41},
  [2667] = {.lex_state = 21, .external_lex_state = 41},
  [2668] = {.lex_state = 20, .external_lex_state = 41},
  [2669] = {.lex_state = 20, .external_lex_state = 41},
  [2670] = {.lex_state = 20, .external_lex_state = 41},
  [2671] = {.lex_state = 20, .external_lex_state = 41},
  [2672] = {.lex_state = 20, .external_lex_state = 41},
  [2673] = {.lex_state = 21, .external_lex_state = 41},
  [2674] = {.lex_state = 20, .external_lex_state = 41},
  [2675] = {.lex_state = 20, .external_lex_state = 41},
  [2676] = {.lex_state = 20, .external_lex_state = 41},
  [2677] = {.lex_state = 20, .external_lex_state = 41},
  [2678] = {.lex_state = 20, .external_lex_state = 41},
  [2679] = {.lex_state = 21, .external_lex_state = 41},
  [2680] = {.lex_state = 20, .external_lex_state = 41},
  [2681] = {.lex_state = 20, .external_lex_state = 41},
  [2682] = {.lex_state = 20, .external_lex_state = 41},
  [2683] = {.lex_state = 20, .external_lex_state = 41},
  [2684] = {.lex_state = 23, .external_lex_state = 41},
  [2685] = {.lex_state = 20, .external_lex_state = 41},
  [2686] = {.lex_state = 20, .external_lex_state = 41},
  [2687] = {.lex_state = 20, .external_lex_state = 41},
  [2688] = {.lex_state = 21, .external_lex_state = 41},
  [2689] = {.lex_state = 21, .external_lex_state = 41},
  [2690] = {.lex_state = 21, .external_lex_state = 43},
  [2691] = {.lex_state = 21, .external_lex_state = 39},
  [2692] = {.lex_state = 21, .external_lex_state = 41},
  [2693] = {.lex_state = 23, .external_lex_state = 41},
  [2694] = {.lex_state = 21, .external_lex_state = 41},
  [2695] = {.lex_state = 23, .external_lex_state = 41},
  [2696] = {.lex_state = 23, .external_lex_state = 41},
  [2697] = {.lex_state = 23, .external_lex_state = 41},
  [2698] = {.lex_state = 0, .external_lex_state = 40},
  [2699] = {.lex_state = 0, .external_lex_state = 40},
  [2700] = {.lex_state = 23, .external_lex_state = 41},
  [2701] = {.lex_state = 23, .external_lex_state = 41},
  [2702] = {.lex_state = 21, .external_lex_state = 41},
  [2703] = {.lex_state = 23, .external_lex_state = 41},
  [2704] = {.lex_state = 23, .external_lex_state = 41},
  [2705] = {.lex_state = 23, .external_lex_state = 41},
  [2706] = {.lex_state = 21, .external_lex_state = 41},
  [2707] = {.lex_state = 21, .external_lex_state = 41},
  [2708] = {.lex_state = 23, .external_lex_state = 41},
  [2709] = {.lex_state = 23, .external_lex_state = 41},
  [2710] = {.lex_state = 23, .external_lex_state = 41},
  [2711] = {.lex_state = 0, .external_lex_state = 40},
  [2712] = {.lex_state = 21, .external_lex_state = 41},
  [2713] = {.lex_state = 23, .external_lex_state = 41},
  [2714] = {.lex_state = 23, .external_lex_state = 41},
  [2715] = {.lex_state = 23, .external_lex_state = 41},
  [2716] = {.lex_state = 23, .external_lex_state = 41},
  [2717] = {.lex_state = 23, .external_lex_state = 41},
  [2718] = {.lex_state = 23, .external_lex_state = 41},
  [2719] = {.lex_state = 23, .external_lex_state = 41},
  [2720] = {.lex_state = 23, .external_lex_state = 41},
  [2721] = {.lex_state = 0, .external_lex_state = 40},
  [2722] = {.lex_state = 23, .external_lex_state = 41},
  [2723] = {.lex_state = 23, .external_lex_state = 41},
  [2724] = {.lex_state = 23, .external_lex_state = 41},
  [2725] = {.lex_state = 23, .external_lex_state = 41},
  [2726] = {.lex_state = 23, .external_lex_state = 41},
  [2727] = {.lex_state = 23, .external_lex_state = 41},
  [2728] = {.lex_state = 0, .external_lex_state = 40},
  [2729] = {.lex_state = 23, .external_lex_state = 41},
  [2730] = {.lex_state = 21, .external_lex_state = 41},
  [2731] = {.lex_state = 23, .external_lex_state = 41},
  [2732] = {.lex_state = 21, .external_lex_state = 41},
  [2733] = {.lex_state = 23, .external_lex_state = 41},
  [2734] = {.lex_state = 23, .external_lex_state = 41},
  [2735] = {.lex_state = 21, .external_lex_state = 43},
  [2736] = {.lex_state = 21, .external_lex_state = 43},
  [2737] = {.lex_state = 21, .external_lex_state = 41},
  [2738] = {.lex_state = 21, .external_lex_state = 41},
  [2739] = {.lex_state = 21, .external_lex_state = 41},
  [2740] = {.lex_state = 21, .external_lex_state = 41},
  [2741] = {.lex_state = 23, .external_lex_state = 41},
  [2742] = {.lex_state = 21, .external_lex_state = 41},
  [2743] = {.lex_state = 23, .external_lex_state = 41},
  [2744] = {.lex_state = 0, .external_lex_state = 40},
  [2745] = {.lex_state = 21, .external_lex_state = 41},
  [2746] = {.lex_state = 21, .external_lex_state = 39},
  [2747] = {.lex_state = 21, .external_lex_state = 39},
  [2748] = {.lex_state = 21, .external_lex_state = 39},
  [2749] = {.lex_state = 21, .external_lex_state = 39},
  [2750] = {.lex_state = 21, .external_lex_state = 43},
  [2751] = {.lex_state = 21, .external_lex_state = 39},
  [2752] = {.lex_state = 21, .external_lex_state = 44},
  [2753] = {.lex_state = 21, .external_lex_state = 43},
  [2754] = {.lex_state = 21, .external_lex_state = 39},
  [2755] = {.lex_state = 21, .external_lex_state = 43},
  [2756] = {.lex_state = 21, .external_lex_state = 43},
  [2757] = {.lex_state = 21, .external_lex_state = 44},
  [2758] = {.lex_state = 21, .external_lex_state = 39},
  [2759] = {.lex_state = 0, .external_lex_state = 42},
  [2760] = {.lex_state = 21, .external_lex_state = 44},
  [2761] = {.lex_state = 21, .external_lex_state = 41},
  [2762] = {.lex_state = 21, .external_lex_state = 39},
  [2763] = {.lex_state = 21, .external_lex_state = 39},
  [2764] = {.lex_state = 21, .external_lex_state = 43},
  [2765] = {.lex_state = 21, .external_lex_state = 44},
  [2766] = {.lex_state = 21, .external_lex_state = 44},
  [2767] = {.lex_state = 21, .external_lex_state = 44},
  [2768] = {.lex_state = 21, .external_lex_state = 39},
  [2769] = {.lex_state = 21, .external_lex_state = 43},
  [2770] = {.lex_state = 21, .external_lex_state = 39},
  [2771] = {.lex_state = 21, .external_lex_state = 43},
  [2772] = {.lex_state = 21, .external_lex_state = 39},
  [2773] = {.lex_state = 21, .external_lex_state = 39},
  [2774] = {.lex_state = 21, .external_lex_state = 39},
  [2775] = {.lex_state = 21, .external_lex_state = 39},
  [2776] = {.lex_state = 21, .external_lex_state = 39},
  [2777] = {.lex_state = 21, .external_lex_state = 43},
  [2778] = {.lex_state = 21, .external_lex_state = 39},
  [2779] = {.lex_state = 21, .external_lex_state = 39},
  [2780] = {.lex_state = 21, .external_lex_state = 39},
  [2781] = {.lex_state = 21, .external_lex_state = 44},
  [2782] = {.lex_state = 21, .external_lex_state = 39},
  [2783] = {.lex_state = 21, .external_lex_state = 39},
  [2784] = {.lex_state = 21, .external_lex_state = 44},
  [2785] = {.lex_state = 21, .external_lex_state = 39},
  [2786] = {.lex_state = 21, .external_lex_state = 39},
  [2787] = {.lex_state = 21, .external_lex_state = 45},
  [2788] = {.lex_state = 21, .external_lex_state = 39},
  [2789] = {.lex_state = 0, .external_lex_state = 42},
  [2790] = {.lex_state = 21, .external_lex_state = 43},
  [2791] = {.lex_state = 21, .external_lex_state = 43},
  [2792] = {.lex_state = 21, .external_lex_state = 43},
  [2793] = {.lex_state = 21, .external_lex_state = 39},
  [2794] = {.lex_state = 21, .external_lex_state = 39},
  [2795] = {.lex_state = 21, .external_lex_state = 43},
  [2796] = {.lex_state = 21, .external_lex_state = 39},
  [2797] = {.lex_state = 21, .external_lex_state = 39},
  [2798] = {.lex_state = 21, .external_lex_state = 43},
  [2799] = {.lex_state = 21, .external_lex_state = 43},
  [2800] = {.lex_state = 21, .external_lex_state = 43},
  [2801] = {.lex_state = 21, .external_lex_state = 44},
  [2802] = {.lex_state = 21, .external_lex_state = 43},
  [2803] = {.lex_state = 21, .external_lex_state = 43},
  [2804] = {.lex_state = 21, .external_lex_state = 44},
  [2805] = {.lex_state = 21, .external_lex_state = 39},
  [2806] = {.lex_state = 21, .external_lex_state = 39},
  [2807] = {.lex_state = 21, .external_lex_state = 43},
  [2808] = {.lex_state = 21, .external_lex_state = 43},
  [2809] = {.lex_state = 21, .external_lex_state = 43},
  [2810] = {.lex_state = 21, .external_lex_state = 44},
  [2811] = {.lex_state = 21, .external_lex_state = 43},
  [2812] = {.lex_state = 21, .external_lex_state = 41},
  [2813] = {.lex_state = 0, .external_lex_state = 42},
  [2814] = {.lex_state = 21, .external_lex_state = 43},
  [2815] = {.lex_state = 21, .external_lex_state = 44},
  [2816] = {.lex_state = 21, .external_lex_state = 45},
  [2817] = {.lex_state = 21, .external_lex_state = 44},
  [2818] = {.lex_state = 21, .external_lex_state = 39},
  [2819] = {.lex_state = 21, .external_lex_state = 39},
  [2820] = {.lex_state = 21, .external_lex_state = 45},
  [2821] = {.lex_state = 21, .external_lex_state = 39},
  [2822] = {.lex_state = 21, .external_lex_state = 39},
  [2823] = {.lex_state = 21, .external_lex_state = 39},
  [2824] = {.lex_state = 21, .external_lex_state = 39},
  [2825] = {.lex_state = 21, .external_lex_state = 45},
  [2826] = {.lex_state = 21, .external_lex_state = 39},
  [2827] = {.lex_state = 21, .external_lex_state = 39},
  [2828] = {.lex_state = 21, .external_lex_state = 39},
  [2829] = {.lex_state = 0, .external_lex_state = 42},
  [2830] = {.lex_state = 21, .external_lex_state = 39},
  [2831] = {.lex_state = 21, .external_lex_state = 43},
  [2832] = {.lex_state = 21, .external_lex_state = 39},
  [2833] = {.lex_state = 21, .external_lex_state = 39},
  [2834] = {.lex_state = 21, .external_lex_state = 39},
  [2835] = {.lex_state = 21, .external_lex_state = 39},
  [2836] = {.lex_state = 21, .external_lex_state = 43},
  [2837] = {.lex_state = 0, .external_lex_state = 42},
  [2838] = {.lex_state = 21, .external_lex_state = 43},
  [2839] = {.lex_state = 21, .external_lex_state = 43},
  [2840] = {.lex_state = 21, .external_lex_state = 39},
  [2841] = {.lex_state = 21, .external_lex_state = 45},
  [2842] = {.lex_state = 21, .external_lex_state = 44},
  [2843] = {.lex_state = 21, .external_lex_state = 43},
  [2844] = {.lex_state = 21, .external_lex_state = 39},
  [2845] = {.lex_state = 21, .external_lex_state = 41},
  [2846] = {.lex_state = 0, .external_lex_state = 41},
  [2847] = {.lex_state = 23, .external_lex_state = 41},
  [2848] = {.lex_state = 21, .external_lex_state = 41},
  [2849] = {.lex_state = 21, .external_lex_state = 44},
  [2850] = {.lex_state = 21, .external_lex_state = 41},
  [2851] = {.lex_state = 23, .external_lex_state = 41},
  [2852] = {.lex_state = 0, .external_lex_state = 41},
  [2853] = {.lex_state = 21, .external_lex_state = 41},
  [2854] = {.lex_state = 21, .external_lex_state = 41},
  [2855] = {.lex_state = 21, .external_lex_state = 41},
  [2856] = {.lex_state = 21, .external_lex_state = 41},
  [2857] = {.lex_state = 21, .external_lex_state = 41},
  [2858] = {.lex_state = 21, .external_lex_state = 41},
  [2859] = {.lex_state = 21, .external_lex_state = 41},
  [2860] = {.lex_state = 21, .external_lex_state = 41},
  [2861] = {.lex_state = 21, .external_lex_state = 41},
  [2862] = {.lex_state = 21, .external_lex_state = 41},
  [2863] = {.lex_state = 21, .external_lex_state = 41},
  [2864] = {.lex_state = 21, .external_lex_state = 41},
  [2865] = {.lex_state = 21, .external_lex_state = 41},
  [2866] = {.lex_state = 21, .external_lex_state = 41},
  [2867] = {.lex_state = 21, .external_lex_state = 46},
  [2868] = {.lex_state = 21, .external_lex_state = 47},
  [2869] = {.lex_state = 21, .external_lex_state = 48},
  [2870] = {.lex_state = 21, .external_lex_state = 46},
  [2871] = {.lex_state = 21, .external_lex_state = 46},
  [2872] = {.lex_state = 21, .external_lex_state = 46},
  [2873] = {.lex_state = 21, .external_lex_state = 41},
  [2874] = {.lex_state = 21, .external_lex_state = 41},
  [2875] = {.lex_state = 21, .external_lex_state = 49},
  [2876] = {.lex_state = 21, .external_lex_state = 41},
  [2877] = {.lex_state = 21, .external_lex_state = 46},
  [2878] = {.lex_state = 21, .external_lex_state = 46},
  [2879] = {.lex_state = 21, .external_lex_state = 41},
  [2880] = {.lex_state = 21, .external_lex_state = 41},
  [2881] = {.lex_state = 21, .external_lex_state = 46},
  [2882] = {.lex_state = 21, .external_lex_state = 45},
  [2883] = {.lex_state = 21, .external_lex_state = 41},
  [2884] = {.lex_state = 21, .external_lex_state = 41},
  [2885] = {.lex_state = 20, .external_lex_state = 41},
  [2886] = {.lex_state = 21, .external_lex_state = 46},
  [2887] = {.lex_state = 21, .external_lex_state = 48},
  [2888] = {.lex_state = 21, .external_lex_state = 46},
  [2889] = {.lex_state = 21, .external_lex_state = 41},
  [2890] = {.lex_state = 21, .external_lex_state = 47},
  [2891] = {.lex_state = 21, .external_lex_state = 41},
  [2892] = {.lex_state = 21, .external_lex_state = 43},
  [2893] = {.lex_state = 21, .external_lex_state = 43},
  [2894] = {.lex_state = 21, .external_lex_state = 46},
  [2895] = {.lex_state = 21, .external_lex_state = 49},
  [2896] = {.lex_state = 21, .external_lex_state = 41},
  [2897] = {.lex_state = 21, .external_lex_state = 46},
  [2898] = {.lex_state = 21, .external_lex_state = 41},
  [2899] = {.lex_state = 21, .external_lex_state = 46},
  [2900] = {.lex_state = 21, .external_lex_state = 46},
  [2901] = {.lex_state = 21, .external_lex_state = 44},
  [2902] = {.lex_state = 21, .external_lex_state = 45},
  [2903] = {.lex_state = 21, .external_lex_state = 41},
  [2904] = {.lex_state = 21, .external_lex_state = 47},
  [2905] = {.lex_state = 21, .external_lex_state = 47},
  [2906] = {.lex_state = 21, .external_lex_state = 43},
  [2907] = {.lex_state = 21, .external_lex_state = 43},
  [2908] = {.lex_state = 21, .external_lex_state = 43},
  [2909] = {.lex_state = 21, .external_lex_state = 45},
  [2910] = {.lex_state = 21, .external_lex_state = 43},
  [2911] = {.lex_state = 0, .external_lex_state = 41},
  [2912] = {.lex_state = 0, .external_lex_state = 41},
  [2913] = {.lex_state = 0, .external_lex_state = 41},
  [2914] = {.lex_state = 0, .external_lex_state = 41},
  [2915] = {.lex_state = 0, .external_lex_state = 41},
  [2916] = {.lex_state = 21, .external_lex_state = 43},
  [2917] = {.lex_state = 20, .external_lex_state = 41},
  [2918] = {.lex_state = 0, .external_lex_state = 41},
  [2919] = {.lex_state = 0, .external_lex_state = 41},
  [2920] = {.lex_state = 0, .external_lex_state = 41},
  [2921] = {.lex_state = 0, .external_lex_state = 41},
  [2922] = {.lex_state = 0, .external_lex_state = 41},
  [2923] = {.lex_state = 0, .external_lex_state = 41},
  [2924] = {.lex_state = 21, .external_lex_state = 41},
  [2925] = {.lex_state = 0, .external_lex_state = 41},
  [2926] = {.lex_state = 0, .external_lex_state = 41},
  [2927] = {.lex_state = 0, .external_lex_state = 41},
  [2928] = {.lex_state = 21, .external_lex_state = 47},
  [2929] = {.lex_state = 21, .external_lex_state = 41},
  [2930] = {.lex_state = 0, .external_lex_state = 41},
  [2931] = {.lex_state = 0, .external_lex_state = 41},
  [2932] = {.lex_state = 0, .external_lex_state = 41},
  [2933] = {.lex_state = 21, .external_lex_state = 41},
  [2934] = {.lex_state = 0, .external_lex_state = 41},
  [2935] = {.lex_state = 21, .external_lex_state = 47},
  [2936] = {.lex_state = 21, .external_lex_state = 41},
  [2937] = {.lex_state = 0, .external_lex_state = 41},
  [2938] = {.lex_state = 0, .external_lex_state = 41},
  [2939] = {.lex_state = 0, .external_lex_state = 41},
  [2940] = {.lex_state = 0, .external_lex_state = 41},
  [2941] = {.lex_state = 0, .external_lex_state = 41},
  [2942] = {.lex_state = 0, .external_lex_state = 41},
  [2943] = {.lex_state = 0, .external_lex_state = 41},
  [2944] = {.lex_state = 0, .external_lex_state = 41},
  [2945] = {.lex_state = 20, .external_lex_state = 41},
  [2946] = {.lex_state = 0, .external_lex_state = 41},
  [2947] = {.lex_state = 20, .external_lex_state = 41},
  [2948] = {.lex_state = 21, .external_lex_state = 47},
  [2949] = {.lex_state = 0, .external_lex_state = 41},
  [2950] = {.lex_state = 0, .external_lex_state = 41},
  [2951] = {.lex_state = 0, .external_lex_state = 41},
  [2952] = {.lex_state = 20, .external_lex_state = 41},
  [2953] = {.lex_state = 20, .external_lex_state = 41},
  [2954] = {.lex_state = 21, .external_lex_state = 41},
  [2955] = {.lex_state = 21, .external_lex_state = 44},
  [2956] = {.lex_state = 21, .external_lex_state = 50},
  [2957] = {.lex_state = 21, .external_lex_state = 41},
  [2958] = {.lex_state = 21, .external_lex_state = 44},
  [2959] = {.lex_state = 0, .external_lex_state = 41},
  [2960] = {.lex_state = 0, .external_lex_state = 41},
  [2961] = {.lex_state = 0, .external_lex_state = 41},
  [2962] = {.lex_state = 21, .external_lex_state = 39},
  [2963] = {.lex_state = 21, .external_lex_state = 39},
  [2964] = {.lex_state = 0, .external_lex_state = 41},
  [2965] = {.lex_state = 21, .external_lex_state = 44},
  [2966] = {.lex_state = 21, .external_lex_state = 47},
  [2967] = {.lex_state = 0, .external_lex_state = 41},
  [2968] = {.lex_state = 0, .external_lex_state = 41},
  [2969] = {.lex_state = 21, .external_lex_state = 41},
  [2970] = {.lex_state = 21, .external_lex_state = 50},
  [2971] = {.lex_state = 0, .external_lex_state = 41},
  [2972] = {.lex_state = 0, .external_lex_state = 41},
  [2973] = {.lex_state = 20, .external_lex_state = 41},
  [2974] = {.lex_state = 0, .external_lex_state = 41},
  [2975] = {.lex_state = 0, .external_lex_state = 41},
  [2976] = {.lex_state = 20, .external_lex_state = 41},
  [2977] = {.lex_state = 0, .external_lex_state = 41},
  [2978] = {.lex_state = 0, .external_lex_state = 41},
  [2979] = {.lex_state = 0, .external_lex_state = 41},
  [2980] = {.lex_state = 0, .external_lex_state = 41},
  [2981] = {.lex_state = 0, .external_lex_state = 41},
  [2982] = {.lex_state = 0, .external_lex_state = 41},
  [2983] = {.lex_state = 21, .external_lex_state = 47},
  [2984] = {.lex_state = 0, .external_lex_state = 41},
  [2985] = {.lex_state = 0, .external_lex_state = 41},
  [2986] = {.lex_state = 0, .external_lex_state = 41},
  [2987] = {.lex_state = 21, .external_lex_state = 41},
  [2988] = {.lex_state = 21, .external_lex_state = 44},
  [2989] = {.lex_state = 0, .external_lex_state = 41},
  [2990] = {.lex_state = 0, .external_lex_state = 41},
  [2991] = {.lex_state = 21, .external_lex_state = 44},
  [2992] = {.lex_state = 20, .external_lex_state = 41},
  [2993] = {.lex_state = 20, .external_lex_state = 41},
  [2994] = {.lex_state = 0, .external_lex_state = 41},
  [2995] = {.lex_state = 20, .external_lex_state = 41},
  [2996] = {.lex_state = 21, .external_lex_state = 41},
  [2997] = {.lex_state = 21, .external_lex_state = 41},
  [2998] = {.lex_state = 0, .external_lex_state = 41},
  [2999] = {.lex_state = 0, .external_lex_state = 41},
  [3000] = {.lex_state = 0, .external_lex_state = 41},
  [3001] = {.lex_state = 0, .external_lex_state = 41},
  [3002] = {.lex_state = 20, .external_lex_state = 41},
  [3003] = {.lex_state = 0, .external_lex_state = 41},
  [3004] = {.lex_state = 20, .external_lex_state = 41},
  [3005] = {.lex_state = 20, .external_lex_state = 41},
  [3006] = {.lex_state = 20, .external_lex_state = 41},
  [3007] = {.lex_state = 0, .external_lex_state = 41},
  [3008] = {.lex_state = 20, .external_lex_state = 41},
  [3009] = {.lex_state = 0, .external_lex_state = 41},
  [3010] = {.lex_state = 21, .external_lex_state = 47},
  [3011] = {.lex_state = 0, .external_lex_state = 41},
  [3012] = {.lex_state = 21, .external_lex_state = 43},
  [3013] = {.lex_state = 21, .external_lex_state = 44},
  [3014] = {.lex_state = 20, .external_lex_state = 41},
  [3015] = {.lex_state = 21, .external_lex_state = 41},
  [3016] = {.lex_state = 21, .external_lex_state = 41},
  [3017] = {.lex_state = 0, .external_lex_state = 41},
  [3018] = {.lex_state = 0, .external_lex_state = 41},
  [3019] = {.lex_state = 21, .external_lex_state = 44},
  [3020] = {.lex_state = 0, .external_lex_state = 41},
  [3021] = {.lex_state = 20, .external_lex_state = 41},
  [3022] = {.lex_state = 0, .external_lex_state = 41},
  [3023] = {.lex_state = 20, .external_lex_state = 41},
  [3024] = {.lex_state = 21, .external_lex_state = 41},
  [3025] = {.lex_state = 0, .external_lex_state = 41},
  [3026] = {.lex_state = 21, .external_lex_state = 47},
  [3027] = {.lex_state = 0, .external_lex_state = 41},
  [3028] = {.lex_state = 0, .external_lex_state = 41},
  [3029] = {.lex_state = 0, .external_lex_state = 41},
  [3030] = {.lex_state = 21, .external_lex_state = 47},
  [3031] = {.lex_state = 0, .external_lex_state = 41},
  [3032] = {.lex_state = 0, .external_lex_state = 41},
  [3033] = {.lex_state = 21, .external_lex_state = 41},
  [3034] = {.lex_state = 0, .external_lex_state = 41},
  [3035] = {.lex_state = 21, .external_lex_state = 41},
  [3036] = {.lex_state = 21, .external_lex_state = 41},
  [3037] = {.lex_state = 21, .external_lex_state = 41},
  [3038] = {.lex_state = 0, .external_lex_state = 41},
  [3039] = {.lex_state = 0, .external_lex_state = 41},
  [3040] = {.lex_state = 0, .external_lex_state = 41},
  [3041] = {.lex_state = 21, .external_lex_state = 41},
  [3042] = {.lex_state = 0, .external_lex_state = 41},
  [3043] = {.lex_state = 20, .external_lex_state = 41},
  [3044] = {.lex_state = 0, .external_lex_state = 41},
  [3045] = {.lex_state = 21, .external_lex_state = 41},
  [3046] = {.lex_state = 0, .external_lex_state = 41},
  [3047] = {.lex_state = 0, .external_lex_state = 41},
  [3048] = {.lex_state = 0, .external_lex_state = 41},
  [3049] = {.lex_state = 0, .external_lex_state = 41},
  [3050] = {.lex_state = 20, .external_lex_state = 41},
  [3051] = {.lex_state = 0, .external_lex_state = 41},
  [3052] = {.lex_state = 0, .external_lex_state = 41},
  [3053] = {.lex_state = 0, .external_lex_state = 41},
  [3054] = {.lex_state = 0, .external_lex_state = 41},
  [3055] = {.lex_state = 0, .external_lex_state = 41},
  [3056] = {.lex_state = 21, .external_lex_state = 41},
  [3057] = {.lex_state = 20, .external_lex_state = 41},
  [3058] = {.lex_state = 0, .external_lex_state = 41},
  [3059] = {.lex_state = 0, .external_lex_state = 41},
  [3060] = {.lex_state = 20, .external_lex_state = 41},
  [3061] = {.lex_state = 0, .external_lex_state = 41},
  [3062] = {.lex_state = 0, .external_lex_state = 41},
  [3063] = {.lex_state = 20, .external_lex_state = 41},
  [3064] = {.lex_state = 21, .external_lex_state = 49},
  [3065] = {.lex_state = 21, .external_lex_state = 41},
  [3066] = {.lex_state = 0, .external_lex_state = 41},
  [3067] = {.lex_state = 0, .external_lex_state = 41},
  [3068] = {.lex_state = 0, .external_lex_state = 41},
  [3069] = {.lex_state = 0, .external_lex_state = 41},
  [3070] = {.lex_state = 0, .external_lex_state = 41},
  [3071] = {.lex_state = 21, .external_lex_state = 41},
  [3072] = {.lex_state = 0, .external_lex_state = 41},
  [3073] = {.lex_state = 21, .external_lex_state = 41},
  [3074] = {.lex_state = 21, .external_lex_state = 43},
  [3075] = {.lex_state = 21, .external_lex_state = 41},
  [3076] = {.lex_state = 0, .external_lex_state = 51},
  [3077] = {.lex_state = 21, .external_lex_state = 41},
  [3078] = {.lex_state = 0, .external_lex_state = 41},
  [3079] = {.lex_state = 0, .external_lex_state = 41},
  [3080] = {.lex_state = 0, .external_lex_state = 41},
  [3081] = {.lex_state = 0, .external_lex_state = 41},
  [3082] = {.lex_state = 0, .external_lex_state = 41},
  [3083] = {.lex_state = 0, .external_lex_state = 41},
  [3084] = {.lex_state = 0, .external_lex_state = 41},
  [3085] = {.lex_state = 21, .external_lex_state = 41},
  [3086] = {.lex_state = 0, .external_lex_state = 41},
  [3087] = {.lex_state = 0, .external_lex_state = 41},
  [3088] = {.lex_state = 0, .external_lex_state = 41},
  [3089] = {.lex_state = 0, .external_lex_state = 41},
  [3090] = {.lex_state = 0, .external_lex_state = 41},
  [3091] = {.lex_state = 0, .external_lex_state = 41},
  [3092] = {.lex_state = 20, .external_lex_state = 41},
  [3093] = {.lex_state = 0, .external_lex_state = 41},
  [3094] = {.lex_state = 0, .external_lex_state = 41},
  [3095] = {.lex_state = 21, .external_lex_state = 41},
  [3096] = {.lex_state = 21, .external_lex_state = 41},
  [3097] = {.lex_state = 0, .external_lex_state = 41},
  [3098] = {.lex_state = 21, .external_lex_state = 48},
  [3099] = {.lex_state = 0, .external_lex_state = 41},
  [3100] = {.lex_state = 0, .external_lex_state = 41},
  [3101] = {.lex_state = 0, .external_lex_state = 41},
  [3102] = {.lex_state = 0, .external_lex_state = 41},
  [3103] = {.lex_state = 0, .external_lex_state = 41},
  [3104] = {.lex_state = 21, .external_lex_state = 46},
  [3105] = {.lex_state = 20, .external_lex_state = 41},
  [3106] = {.lex_state = 20, .external_lex_state = 41},
  [3107] = {.lex_state = 21, .external_lex_state = 41},
  [3108] = {.lex_state = 0, .external_lex_state = 41},
  [3109] = {.lex_state = 0, .external_lex_state = 41},
  [3110] = {.lex_state = 0, .external_lex_state = 41},
  [3111] = {.lex_state = 0, .external_lex_state = 41},
  [3112] = {.lex_state = 0, .external_lex_state = 41},
  [3113] = {.lex_state = 0, .external_lex_state = 41},
  [3114] = {.lex_state = 20, .external_lex_state = 41},
  [3115] = {.lex_state = 0, .external_lex_state = 41},
  [3116] = {.lex_state = 0, .external_lex_state = 41},
  [3117] = {.lex_state = 0, .external_lex_state = 41},
  [3118] = {.lex_state = 20, .external_lex_state = 41},
  [3119] = {.lex_state = 0, .external_lex_state = 41},
  [3120] = {.lex_state = 21, .external_lex_state = 41},
  [3121] = {.lex_state = 0, .external_lex_state = 41},
  [3122] = {.lex_state = 0, .external_lex_state = 41},
  [3123] = {.lex_state = 0, .external_lex_state = 41},
  [3124] = {.lex_state = 0, .external_lex_state = 41},
  [3125] = {.lex_state = 20, .external_lex_state = 41},
  [3126] = {.lex_state = 21, .external_lex_state = 49},
  [3127] = {.lex_state = 21, .external_lex_state = 49},
  [3128] = {.lex_state = 0, .external_lex_state = 41},
  [3129] = {.lex_state = 20, .external_lex_state = 41},
  [3130] = {.lex_state = 20, .external_lex_state = 41},
  [3131] = {.lex_state = 21, .external_lex_state = 49},
  [3132] = {.lex_state = 20, .external_lex_state = 41},
  [3133] = {.lex_state = 21, .external_lex_state = 49},
  [3134] = {.lex_state = 21, .external_lex_state = 49},
  [3135] = {.lex_state = 21, .external_lex_state = 41},
  [3136] = {.lex_state = 0, .external_lex_state = 41},
  [3137] = {.lex_state = 0, .external_lex_state = 41},
  [3138] = {.lex_state = 21, .external_lex_state = 49},
  [3139] = {.lex_state = 21, .external_lex_state = 49},
  [3140] = {.lex_state = 21, .external_lex_state = 49},
  [3141] = {.lex_state = 21, .external_lex_state = 49},
  [3142] = {.lex_state = 21, .external_lex_state = 41},
  [3143] = {.lex_state = 21, .external_lex_state = 49},
  [3144] = {.lex_state = 20, .external_lex_state = 41},
  [3145] = {.lex_state = 21, .external_lex_state = 41},
  [3146] = {.lex_state = 21, .external_lex_state = 41},
  [3147] = {.lex_state = 21, .external_lex_state = 49},
  [3148] = {.lex_state = 21, .external_lex_state = 49},
  [3149] = {.lex_state = 21, .external_lex_state = 49},
  [3150] = {.lex_state = 21, .external_lex_state = 49},
  [3151] = {.lex_state = 20, .external_lex_state = 41},
  [3152] = {.lex_state = 0, .external_lex_state = 41},
  [3153] = {.lex_state = 21, .external_lex_state = 41},
  [3154] = {.lex_state = 21, .external_lex_state = 49},
  [3155] = {.lex_state = 21, .external_lex_state = 49},
  [3156] = {.lex_state = 21, .external_lex_state = 49},
  [3157] = {.lex_state = 21, .external_lex_state = 49},
  [3158] = {.lex_state = 21, .external_lex_state = 49},
  [3159] = {.lex_state = 0, .external_lex_state = 41},
  [3160] = {.lex_state = 21, .external_lex_state = 49},
  [3161] = {.lex_state = 21, .external_lex_state = 49},
  [3162] = {.lex_state = 20, .external_lex_state = 41},
  [3163] = {.lex_state = 21, .external_lex_state = 49},
  [3164] = {.lex_state = 21, .external_lex_state = 49},
  [3165] = {.lex_state = 21, .external_lex_state = 49},
  [3166] = {.lex_state = 21, .external_lex_state = 49},
  [3167] = {.lex_state = 21, .external_lex_state = 49},
  [3168] = {.lex_state = 21, .external_lex_state = 49},
  [3169] = {.lex_state = 21, .external_lex_state = 49},
  [3170] = {.lex_state = 21, .external_lex_state = 49},
  [3171] = {.lex_state = 21, .external_lex_state = 49},
  [3172] = {.lex_state = 21, .external_lex_state = 49},
  [3173] = {.lex_state = 21, .external_lex_state = 48},
  [3174] = {.lex_state = 20, .external_lex_state = 41},
  [3175] = {.lex_state = 0, .external_lex_state = 41},
  [3176] = {.lex_state = 21, .external_lex_state = 41},
  [3177] = {.lex_state = 0, .external_lex_state = 41},
  [3178] = {.lex_state = 21, .external_lex_state = 49},
  [3179] = {.lex_state = 21, .external_lex_state = 49},
  [3180] = {.lex_state = 21, .external_lex_state = 41},
  [3181] = {.lex_state = 21, .external_lex_state = 41},
  [3182] = {.lex_state = 0, .external_lex_state = 41},
  [3183] = {.lex_state = 21, .external_lex_state = 41},
  [3184] = {.lex_state = 0, .external_lex_state = 41},
  [3185] = {.lex_state = 20, .external_lex_state = 41},
  [3186] = {.lex_state = 21, .external_lex_state = 49},
  [3187] = {.lex_state = 21, .external_lex_state = 49},
  [3188] = {.lex_state = 21, .external_lex_state = 41},
  [3189] = {.lex_state = 21, .external_lex_state = 49},
  [3190] = {.lex_state = 21, .external_lex_state = 49},
  [3191] = {.lex_state = 21, .external_lex_state = 41},
  [3192] = {.lex_state = 21, .external_lex_state = 49},
  [3193] = {.lex_state = 21, .external_lex_state = 41},
  [3194] = {.lex_state = 21, .external_lex_state = 41},
  [3195] = {.lex_state = 21, .external_lex_state = 49},
  [3196] = {.lex_state = 21, .external_lex_state = 41},
  [3197] = {.lex_state = 20, .external_lex_state = 41},
  [3198] = {.lex_state = 0, .external_lex_state = 41},
  [3199] = {.lex_state = 0, .external_lex_state = 41},
  [3200] = {.lex_state = 21, .external_lex_state = 49},
  [3201] = {.lex_state = 21, .external_lex_state = 49},
  [3202] = {.lex_state = 0, .external_lex_state = 41},
  [3203] = {.lex_state = 21, .external_lex_state = 49},
  [3204] = {.lex_state = 21, .external_lex_state = 49},
  [3205] = {.lex_state = 0, .external_lex_state = 41},
  [3206] = {.lex_state = 21, .external_lex_state = 49},
  [3207] = {.lex_state = 21, .external_lex_state = 49},
  [3208] = {.lex_state = 20, .external_lex_state = 41},
  [3209] = {.lex_state = 21, .external_lex_state = 41},
  [3210] = {.lex_state = 21, .external_lex_state = 50},
  [3211] = {.lex_state = 21, .external_lex_state = 49},
  [3212] = {.lex_state = 21, .external_lex_state = 49},
  [3213] = {.lex_state = 21, .external_lex_state = 49},
  [3214] = {.lex_state = 0, .external_lex_state = 41},
  [3215] = {.lex_state = 20, .external_lex_state = 41},
  [3216] = {.lex_state = 21, .external_lex_state = 49},
  [3217] = {.lex_state = 21, .external_lex_state = 49},
  [3218] = {.lex_state = 0, .external_lex_state = 41},
  [3219] = {.lex_state = 21, .external_lex_state = 43},
  [3220] = {.lex_state = 0, .external_lex_state = 41},
  [3221] = {.lex_state = 0, .external_lex_state = 41},
  [3222] = {.lex_state = 21, .external_lex_state = 49},
  [3223] = {.lex_state = 21, .external_lex_state = 49},
  [3224] = {.lex_state = 21, .external_lex_state = 41},
  [3225] = {.lex_state = 21, .external_lex_state = 49},
  [3226] = {.lex_state = 21, .external_lex_state = 49},
  [3227] = {.lex_state = 21, .external_lex_state = 41},
  [3228] = {.lex_state = 0, .external_lex_state = 41},
  [3229] = {.lex_state = 0, .external_lex_state = 41},
  [3230] = {.lex_state = 21, .external_lex_state = 47},
  [3231] = {.lex_state = 21, .external_lex_state = 41},
  [3232] = {.lex_state = 0, .external_lex_state = 41},
  [3233] = {.lex_state = 21, .external_lex_state = 41},
  [3234] = {.lex_state = 21, .external_lex_state = 41},
  [3235] = {.lex_state = 21, .external_lex_state = 49},
  [3236] = {.lex_state = 21, .external_lex_state = 49},
  [3237] = {.lex_state = 20, .external_lex_state = 41},
  [3238] = {.lex_state = 0, .external_lex_state = 41},
  [3239] = {.lex_state = 20, .external_lex_state = 41},
  [3240] = {.lex_state = 21, .external_lex_state = 49},
  [3241] = {.lex_state = 21, .external_lex_state = 49},
  [3242] = {.lex_state = 21, .external_lex_state = 49},
  [3243] = {.lex_state = 21, .external_lex_state = 41},
  [3244] = {.lex_state = 20, .external_lex_state = 41},
  [3245] = {.lex_state = 21, .external_lex_state = 49},
  [3246] = {.lex_state = 21, .external_lex_state = 41},
  [3247] = {.lex_state = 21, .external_lex_state = 49},
  [3248] = {.lex_state = 21, .external_lex_state = 41},
  [3249] = {.lex_state = 20, .external_lex_state = 41},
  [3250] = {.lex_state = 21, .external_lex_state = 49},
  [3251] = {.lex_state = 20, .external_lex_state = 41},
  [3252] = {.lex_state = 0, .external_lex_state = 41},
  [3253] = {.lex_state = 20, .external_lex_state = 41},
  [3254] = {.lex_state = 21, .external_lex_state = 49},
  [3255] = {.lex_state = 21, .external_lex_state = 49},
  [3256] = {.lex_state = 21, .external_lex_state = 49},
  [3257] = {.lex_state = 21, .external_lex_state = 41},
  [3258] = {.lex_state = 0, .external_lex_state = 41},
  [3259] = {.lex_state = 0, .external_lex_state = 41},
  [3260] = {.lex_state = 21, .external_lex_state = 49},
  [3261] = {.lex_state = 21, .external_lex_state = 41},
  [3262] = {.lex_state = 21, .external_lex_state = 49},
  [3263] = {.lex_state = 21, .external_lex_state = 49},
  [3264] = {.lex_state = 0, .external_lex_state = 41},
  [3265] = {.lex_state = 21, .external_lex_state = 41},
  [3266] = {.lex_state = 21, .external_lex_state = 41},
  [3267] = {.lex_state = 21, .external_lex_state = 41},
  [3268] = {.lex_state = 21, .external_lex_state = 49},
  [3269] = {.lex_state = 21, .external_lex_state = 41},
  [3270] = {.lex_state = 21, .external_lex_state = 49},
  [3271] = {.lex_state = 21, .external_lex_state = 48},
  [3272] = {.lex_state = 21, .external_lex_state = 49},
  [3273] = {.lex_state = 21, .external_lex_state = 41},
  [3274] = {.lex_state = 20, .external_lex_state = 41},
  [3275] = {.lex_state = 21, .external_lex_state = 41},
  [3276] = {.lex_state = 0, .external_lex_state = 41},
  [3277] = {.lex_state = 21, .external_lex_state = 41},
  [3278] = {.lex_state = 21, .external_lex_state = 49},
  [3279] = {.lex_state = 21, .external_lex_state = 49},
  [3280] = {.lex_state = 0, .external_lex_state = 41},
  [3281] = {.lex_state = 21, .external_lex_state = 41},
  [3282] = {.lex_state = 21, .external_lex_state = 49},
  [3283] = {.lex_state = 21, .external_lex_state = 49},
  [3284] = {.lex_state = 0, .external_lex_state = 52},
  [3285] = {.lex_state = 21, .external_lex_state = 41},
  [3286] = {.lex_state = 21, .external_lex_state = 41},
  [3287] = {.lex_state = 21, .external_lex_state = 49},
  [3288] = {.lex_state = 16, .external_lex_state = 41},
  [3289] = {.lex_state = 21, .external_lex_state = 41},
  [3290] = {.lex_state = 21, .external_lex_state = 49},
  [3291] = {.lex_state = 21, .external_lex_state = 49},
  [3292] = {.lex_state = 21, .external_lex_state = 41},
  [3293] = {.lex_state = 21, .external_lex_state = 41},
  [3294] = {.lex_state = 21, .external_lex_state = 49},
  [3295] = {.lex_state = 21, .external_lex_state = 49},
  [3296] = {.lex_state = 0, .external_lex_state = 41},
  [3297] = {.lex_state = 21, .external_lex_state = 41},
  [3298] = {.lex_state = 21, .external_lex_state = 41},
  [3299] = {.lex_state = 21, .external_lex_state = 49},
  [3300] = {.lex_state = 21, .external_lex_state = 49},
  [3301] = {.lex_state = 21, .external_lex_state = 49},
  [3302] = {.lex_state = 20, .external_lex_state = 41},
  [3303] = {.lex_state = 0, .external_lex_state = 41},
  [3304] = {.lex_state = 21, .external_lex_state = 41},
  [3305] = {.lex_state = 0, .external_lex_state = 41},
  [3306] = {.lex_state = 21, .external_lex_state = 49},
  [3307] = {.lex_state = 21, .external_lex_state = 41},
  [3308] = {.lex_state = 21, .external_lex_state = 49},
  [3309] = {.lex_state = 21, .external_lex_state = 49},
  [3310] = {.lex_state = 21, .external_lex_state = 41},
  [3311] = {.lex_state = 21, .external_lex_state = 49},
  [3312] = {.lex_state = 16, .external_lex_state = 41},
  [3313] = {.lex_state = 21, .external_lex_state = 49},
  [3314] = {.lex_state = 0, .external_lex_state = 41},
  [3315] = {.lex_state = 21, .external_lex_state = 49},
  [3316] = {.lex_state = 21, .external_lex_state = 41},
  [3317] = {.lex_state = 21, .external_lex_state = 49},
  [3318] = {.lex_state = 21, .external_lex_state = 48},
  [3319] = {.lex_state = 20, .external_lex_state = 41},
  [3320] = {.lex_state = 0, .external_lex_state = 41},
  [3321] = {.lex_state = 21, .external_lex_state = 41},
  [3322] = {.lex_state = 20, .external_lex_state = 41},
  [3323] = {.lex_state = 16, .external_lex_state = 41},
  [3324] = {.lex_state = 21, .external_lex_state = 41},
  [3325] = {.lex_state = 21, .external_lex_state = 49},
  [3326] = {.lex_state = 21, .external_lex_state = 41},
  [3327] = {.lex_state = 2, .external_lex_state = 41},
  [3328] = {.lex_state = 0, .external_lex_state = 41},
  [3329] = {.lex_state = 0, .external_lex_state = 41},
  [3330] = {.lex_state = 0, .external_lex_state = 41},
  [3331] = {.lex_state = 21, .external_lex_state = 50},
  [3332] = {.lex_state = 21, .external_lex_state = 41},
  [3333] = {.lex_state = 21, .external_lex_state = 49},
  [3334] = {.lex_state = 21, .external_lex_state = 49},
  [3335] = {.lex_state = 21, .external_lex_state = 41},
  [3336] = {.lex_state = 21, .external_lex_state = 49},
  [3337] = {.lex_state = 21, .external_lex_state = 49},
  [3338] = {.lex_state = 0, .external_lex_state = 41},
  [3339] = {.lex_state = 0, .external_lex_state = 41},
  [3340] = {.lex_state = 0, .external_lex_state = 41},
  [3341] = {.lex_state = 21, .external_lex_state = 49},
  [3342] = {.lex_state = 21, .external_lex_state = 49},
  [3343] = {.lex_state = 21, .external_lex_state = 49},
  [3344] = {.lex_state = 20, .external_lex_state = 41},
  [3345] = {.lex_state = 21, .external_lex_state = 41},
  [3346] = {.lex_state = 0, .external_lex_state = 41},
  [3347] = {.lex_state = 16, .external_lex_state = 41},
  [3348] = {.lex_state = 21, .external_lex_state = 41},
  [3349] = {.lex_state = 0, .external_lex_state = 41},
  [3350] = {.lex_state = 21, .external_lex_state = 49},
  [3351] = {.lex_state = 21, .external_lex_state = 41},
  [3352] = {.lex_state = 21, .external_lex_state = 49},
  [3353] = {.lex_state = 21, .external_lex_state = 48},
  [3354] = {.lex_state = 21, .external_lex_state = 49},
  [3355] = {.lex_state = 21, .external_lex_state = 49},
  [3356] = {.lex_state = 21, .external_lex_state = 41},
  [3357] = {.lex_state = 21, .external_lex_state = 49},
  [3358] = {.lex_state = 16, .external_lex_state = 41},
  [3359] = {.lex_state = 21, .external_lex_state = 41},
  [3360] = {.lex_state = 21, .external_lex_state = 49},
  [3361] = {.lex_state = 21, .external_lex_state = 41},
  [3362] = {.lex_state = 0, .external_lex_state = 41},
  [3363] = {.lex_state = 21, .external_lex_state = 49},
  [3364] = {.lex_state = 0, .external_lex_state = 41},
  [3365] = {.lex_state = 21, .external_lex_state = 50},
  [3366] = {.lex_state = 21, .external_lex_state = 49},
  [3367] = {.lex_state = 21, .external_lex_state = 49},
  [3368] = {.lex_state = 21, .external_lex_state = 49},
  [3369] = {.lex_state = 21, .external_lex_state = 41},
  [3370] = {.lex_state = 0, .external_lex_state = 41},
  [3371] = {.lex_state = 21, .external_lex_state = 49},
  [3372] = {.lex_state = 21, .external_lex_state = 49},
  [3373] = {.lex_state = 0, .external_lex_state = 41},
  [3374] = {.lex_state = 0, .external_lex_state = 41},
  [3375] = {.lex_state = 21, .external_lex_state = 49},
  [3376] = {.lex_state = 0, .external_lex_state = 41},
  [3377] = {.lex_state = 21, .external_lex_state = 49},
  [3378] = {.lex_state = 21, .external_lex_state = 49},
  [3379] = {.lex_state = 21, .external_lex_state = 41},
  [3380] = {.lex_state = 21, .external_lex_state = 41},
  [3381] = {.lex_state = 16, .external_lex_state = 41},
  [3382] = {.lex_state = 21, .external_lex_state = 49},
  [3383] = {.lex_state = 0, .external_lex_state = 41},
  [3384] = {.lex_state = 21, .external_lex_state = 49},
  [3385] = {.lex_state = 21, .external_lex_state = 41},
  [3386] = {.lex_state = 21, .external_lex_state = 49},
  [3387] = {.lex_state = 21, .external_lex_state = 48},
  [3388] = {.lex_state = 21, .external_lex_state = 49},
  [3389] = {.lex_state = 21, .external_lex_state = 49},
  [3390] = {.lex_state = 21, .external_lex_state = 41},
  [3391] = {.lex_state = 21, .external_lex_state = 49},
  [3392] = {.lex_state = 16, .external_lex_state = 41},
  [3393] = {.lex_state = 21, .external_lex_state = 41},
  [3394] = {.lex_state = 21, .external_lex_state = 49},
  [3395] = {.lex_state = 21, .external_lex_state = 41},
  [3396] = {.lex_state = 0, .external_lex_state = 41},
  [3397] = {.lex_state = 21, .external_lex_state = 41},
  [3398] = {.lex_state = 21, .external_lex_state = 49},
  [3399] = {.lex_state = 21, .external_lex_state = 50},
  [3400] = {.lex_state = 21, .external_lex_state = 49},
  [3401] = {.lex_state = 21, .external_lex_state = 49},
  [3402] = {.lex_state = 0, .external_lex_state = 41},
  [3403] = {.lex_state = 21, .external_lex_state = 41},
  [3404] = {.lex_state = 21, .external_lex_state = 49},
  [3405] = {.lex_state = 21, .external_lex_state = 41},
  [3406] = {.lex_state = 20, .external_lex_state = 41},
  [3407] = {.lex_state = 0, .external_lex_state = 41},
  [3408] = {.lex_state = 0, .external_lex_state = 41},
  [3409] = {.lex_state = 21, .external_lex_state = 49},
  [3410] = {.lex_state = 21, .external_lex_state = 49},
  [3411] = {.lex_state = 21, .external_lex_state = 49},
  [3412] = {.lex_state = 21, .external_lex_state = 41},
  [3413] = {.lex_state = 16, .external_lex_state = 41},
  [3414] = {.lex_state = 0, .external_lex_state = 41},
  [3415] = {.lex_state = 0, .external_lex_state = 41},
  [3416] = {.lex_state = 0, .external_lex_state = 41},
  [3417] = {.lex_state = 16, .external_lex_state = 41},
  [3418] = {.lex_state = 21, .external_lex_state = 41},
  [3419] = {.lex_state = 21, .external_lex_state = 49},
  [3420] = {.lex_state = 21, .external_lex_state = 49},
  [3421] = {.lex_state = 0, .external_lex_state = 41},
  [3422] = {.lex_state = 21, .external_lex_state = 41},
  [3423] = {.lex_state = 0, .external_lex_state = 41},
  [3424] = {.lex_state = 21, .external_lex_state = 41},
  [3425] = {.lex_state = 0, .external_lex_state = 41},
  [3426] = {.lex_state = 0, .external_lex_state = 41},
  [3427] = {.lex_state = 21, .external_lex_state = 41},
  [3428] = {.lex_state = 0, .external_lex_state = 41},
  [3429] = {.lex_state = 21, .external_lex_state = 41},
  [3430] = {.lex_state = 0, .external_lex_state = 41},
  [3431] = {.lex_state = 21, .external_lex_state = 49},
  [3432] = {.lex_state = 0, .external_lex_state = 41},
  [3433] = {.lex_state = 21, .external_lex_state = 49},
  [3434] = {.lex_state = 21, .external_lex_state = 49},
  [3435] = {.lex_state = 20, .external_lex_state = 41},
  [3436] = {.lex_state = 21, .external_lex_state = 49},
  [3437] = {.lex_state = 16, .external_lex_state = 41},
  [3438] = {.lex_state = 0, .external_lex_state = 41},
  [3439] = {.lex_state = 21, .external_lex_state = 49},
  [3440] = {.lex_state = 21, .external_lex_state = 41},
  [3441] = {.lex_state = 21, .external_lex_state = 49},
  [3442] = {.lex_state = 21, .external_lex_state = 49},
  [3443] = {.lex_state = 21, .external_lex_state = 41},
  [3444] = {.lex_state = 21, .external_lex_state = 41},
  [3445] = {.lex_state = 0, .external_lex_state = 41},
  [3446] = {.lex_state = 21, .external_lex_state = 41},
  [3447] = {.lex_state = 21, .external_lex_state = 41},
  [3448] = {.lex_state = 21, .external_lex_state = 49},
  [3449] = {.lex_state = 21, .external_lex_state = 41},
  [3450] = {.lex_state = 21, .external_lex_state = 41},
  [3451] = {.lex_state = 21, .external_lex_state = 41},
  [3452] = {.lex_state = 21, .external_lex_state = 49},
  [3453] = {.lex_state = 0, .external_lex_state = 41},
  [3454] = {.lex_state = 21, .external_lex_state = 49},
  [3455] = {.lex_state = 21, .external_lex_state = 49},
  [3456] = {.lex_state = 21, .external_lex_state = 49},
  [3457] = {.lex_state = 21, .external_lex_state = 49},
  [3458] = {.lex_state = 21, .external_lex_state = 49},
  [3459] = {.lex_state = 20, .external_lex_state = 41},
  [3460] = {.lex_state = 21, .external_lex_state = 49},
  [3461] = {.lex_state = 0, .external_lex_state = 41},
  [3462] = {.lex_state = 21, .external_lex_state = 41},
  [3463] = {.lex_state = 21, .external_lex_state = 41},
  [3464] = {.lex_state = 20, .external_lex_state = 41},
  [3465] = {.lex_state = 0, .external_lex_state = 41},
  [3466] = {.lex_state = 0, .external_lex_state = 41},
  [3467] = {.lex_state = 21, .external_lex_state = 49},
  [3468] = {.lex_state = 0, .external_lex_state = 41},
  [3469] = {.lex_state = 21, .external_lex_state = 49},
  [3470] = {.lex_state = 21, .external_lex_state = 49},
  [3471] = {.lex_state = 0, .external_lex_state = 41},
  [3472] = {.lex_state = 21, .external_lex_state = 49},
  [3473] = {.lex_state = 21, .external_lex_state = 41},
  [3474] = {.lex_state = 21, .external_lex_state = 49},
  [3475] = {.lex_state = 0, .external_lex_state = 41},
  [3476] = {.lex_state = 21, .external_lex_state = 41},
  [3477] = {.lex_state = 21, .external_lex_state = 49},
  [3478] = {.lex_state = 21, .external_lex_state = 41},
  [3479] = {.lex_state = 21, .external_lex_state = 49},
  [3480] = {.lex_state = 21, .external_lex_state = 41},
  [3481] = {.lex_state = 21, .external_lex_state = 49},
  [3482] = {.lex_state = 21, .external_lex_state = 49},
  [3483] = {.lex_state = 0, .external_lex_state = 41},
  [3484] = {.lex_state = 20, .external_lex_state = 41},
  [3485] = {.lex_state = 16, .external_lex_state = 41},
  [3486] = {.lex_state = 21, .external_lex_state = 49},
  [3487] = {.lex_state = 21, .external_lex_state = 49},
  [3488] = {.lex_state = 20, .external_lex_state = 41},
  [3489] = {.lex_state = 20, .external_lex_state = 41},
  [3490] = {.lex_state = 0, .external_lex_state = 41},
  [3491] = {.lex_state = 21, .external_lex_state = 49},
  [3492] = {.lex_state = 0, .external_lex_state = 41},
  [3493] = {.lex_state = 18, .external_lex_state = 41},
  [3494] = {.lex_state = 21, .external_lex_state = 49},
  [3495] = {.lex_state = 21, .external_lex_state = 49},
  [3496] = {.lex_state = 21, .external_lex_state = 49},
  [3497] = {.lex_state = 21, .external_lex_state = 41},
  [3498] = {.lex_state = 0, .external_lex_state = 41},
  [3499] = {.lex_state = 21, .external_lex_state = 41},
  [3500] = {.lex_state = 21, .external_lex_state = 49},
  [3501] = {.lex_state = 21, .external_lex_state = 49},
  [3502] = {.lex_state = 21, .external_lex_state = 49},
  [3503] = {.lex_state = 21, .external_lex_state = 49},
  [3504] = {.lex_state = 21, .external_lex_state = 49},
  [3505] = {.lex_state = 0, .external_lex_state = 41},
  [3506] = {.lex_state = 21, .external_lex_state = 49},
  [3507] = {.lex_state = 21, .external_lex_state = 49},
  [3508] = {.lex_state = 21, .external_lex_state = 49},
  [3509] = {.lex_state = 21, .external_lex_state = 41},
  [3510] = {.lex_state = 21, .external_lex_state = 48},
  [3511] = {.lex_state = 21, .external_lex_state = 49},
  [3512] = {.lex_state = 21, .external_lex_state = 49},
  [3513] = {.lex_state = 0, .external_lex_state = 41},
  [3514] = {.lex_state = 21, .external_lex_state = 49},
  [3515] = {.lex_state = 16, .external_lex_state = 41},
  [3516] = {.lex_state = 0, .external_lex_state = 41},
  [3517] = {.lex_state = 20, .external_lex_state = 41},
  [3518] = {.lex_state = 21, .external_lex_state = 49},
  [3519] = {.lex_state = 21, .external_lex_state = 49},
  [3520] = {.lex_state = 0, .external_lex_state = 41},
  [3521] = {.lex_state = 0, .external_lex_state = 41},
  [3522] = {.lex_state = 0, .external_lex_state = 41},
  [3523] = {.lex_state = 21, .external_lex_state = 41},
  [3524] = {.lex_state = 21, .external_lex_state = 49},
  [3525] = {.lex_state = 21, .external_lex_state = 49},
  [3526] = {.lex_state = 0, .external_lex_state = 41},
  [3527] = {.lex_state = 21, .external_lex_state = 49},
  [3528] = {.lex_state = 0, .external_lex_state = 41},
  [3529] = {.lex_state = 21, .external_lex_state = 49},
  [3530] = {.lex_state = 21, .external_lex_state = 48},
  [3531] = {.lex_state = 21, .external_lex_state = 41},
  [3532] = {.lex_state = 21, .external_lex_state = 49},
  [3533] = {.lex_state = 21, .external_lex_state = 49},
  [3534] = {.lex_state = 0, .external_lex_state = 41},
  [3535] = {.lex_state = 0, .external_lex_state = 41},
  [3536] = {.lex_state = 21, .external_lex_state = 49},
  [3537] = {.lex_state = 21, .external_lex_state = 41},
  [3538] = {.lex_state = 21, .external_lex_state = 49},
  [3539] = {.lex_state = 21, .external_lex_state = 41},
  [3540] = {.lex_state = 0, .external_lex_state = 41},
  [3541] = {.lex_state = 16, .external_lex_state = 41},
  [3542] = {.lex_state = 0, .external_lex_state = 41},
  [3543] = {.lex_state = 21, .external_lex_state = 41},
  [3544] = {.lex_state = 21, .external_lex_state = 41},
  [3545] = {.lex_state = 21, .external_lex_state = 49},
  [3546] = {.lex_state = 20, .external_lex_state = 41},
  [3547] = {.lex_state = 0, .external_lex_state = 41},
  [3548] = {.lex_state = 0, .external_lex_state = 41},
  [3549] = {.lex_state = 21, .external_lex_state = 41},
  [3550] = {.lex_state = 21, .external_lex_state = 49},
  [3551] = {.lex_state = 20, .external_lex_state = 41},
  [3552] = {.lex_state = 21, .external_lex_state = 49},
  [3553] = {.lex_state = 21, .external_lex_state = 41},
  [3554] = {.lex_state = 0, .external_lex_state = 41},
  [3555] = {.lex_state = 0, .external_lex_state = 41},
  [3556] = {.lex_state = 21, .external_lex_state = 41},
  [3557] = {.lex_state = 21, .external_lex_state = 49},
  [3558] = {.lex_state = 21, .external_lex_state = 41},
  [3559] = {.lex_state = 0, .external_lex_state = 41},
  [3560] = {.lex_state = 21, .external_lex_state = 41},
  [3561] = {.lex_state = 0, .external_lex_state = 41},
  [3562] = {.lex_state = 21, .external_lex_state = 49},
  [3563] = {.lex_state = 21, .external_lex_state = 41},
  [3564] = {.lex_state = 0, .external_lex_state = 41},
  [3565] = {.lex_state = 21, .external_lex_state = 49},
  [3566] = {.lex_state = 0, .external_lex_state = 41},
  [3567] = {.lex_state = 20, .external_lex_state = 41},
  [3568] = {.lex_state = 0, .external_lex_state = 41},
  [3569] = {.lex_state = 20, .external_lex_state = 41},
  [3570] = {.lex_state = 0, .external_lex_state = 41},
  [3571] = {.lex_state = 0, .external_lex_state = 41},
  [3572] = {.lex_state = 21, .external_lex_state = 49},
  [3573] = {.lex_state = 2, .external_lex_state = 41},
  [3574] = {.lex_state = 21, .external_lex_state = 49},
  [3575] = {.lex_state = 21, .external_lex_state = 49},
  [3576] = {.lex_state = 20, .external_lex_state = 41},
  [3577] = {.lex_state = 21, .external_lex_state = 41},
  [3578] = {.lex_state = 0, .external_lex_state = 41},
  [3579] = {.lex_state = 21, .external_lex_state = 49},
  [3580] = {.lex_state = 0, .external_lex_state = 41},
  [3581] = {.lex_state = 20, .external_lex_state = 41},
  [3582] = {.lex_state = 21, .external_lex_state = 49},
  [3583] = {.lex_state = 21, .external_lex_state = 49},
  [3584] = {.lex_state = 20, .external_lex_state = 41},
  [3585] = {.lex_state = 21, .external_lex_state = 49},
  [3586] = {.lex_state = 21, .external_lex_state = 49},
  [3587] = {.lex_state = 21, .external_lex_state = 49},
  [3588] = {.lex_state = 21, .external_lex_state = 49},
  [3589] = {.lex_state = 21, .external_lex_state = 49},
  [3590] = {.lex_state = 21, .external_lex_state = 41},
  [3591] = {.lex_state = 0, .external_lex_state = 41},
  [3592] = {.lex_state = 21, .external_lex_state = 49},
  [3593] = {.lex_state = 21, .external_lex_state = 41},
  [3594] = {.lex_state = 21, .external_lex_state = 47},
  [3595] = {.lex_state = 16, .external_lex_state = 41},
  [3596] = {.lex_state = 21, .external_lex_state = 49},
  [3597] = {.lex_state = 21, .external_lex_state = 41},
  [3598] = {.lex_state = 0, .external_lex_state = 41},
  [3599] = {.lex_state = 0, .external_lex_state = 41},
  [3600] = {.lex_state = 20, .external_lex_state = 41},
  [3601] = {.lex_state = 20, .external_lex_state = 41},
  [3602] = {.lex_state = 21, .external_lex_state = 49},
  [3603] = {.lex_state = 21, .external_lex_state = 41},
  [3604] = {.lex_state = 21, .external_lex_state = 41},
  [3605] = {.lex_state = 21, .external_lex_state = 49},
  [3606] = {.lex_state = 21, .external_lex_state = 41},
  [3607] = {.lex_state = 21, .external_lex_state = 47},
  [3608] = {.lex_state = 21, .external_lex_state = 49},
  [3609] = {.lex_state = 21, .external_lex_state = 49},
  [3610] = {.lex_state = 0, .external_lex_state = 41},
  [3611] = {.lex_state = 0, .external_lex_state = 41},
  [3612] = {.lex_state = 21, .external_lex_state = 49},
  [3613] = {.lex_state = 20, .external_lex_state = 41},
  [3614] = {.lex_state = 21, .external_lex_state = 49},
  [3615] = {.lex_state = 21, .external_lex_state = 49},
  [3616] = {.lex_state = 0, .external_lex_state = 41},
  [3617] = {.lex_state = 21, .external_lex_state = 49},
  [3618] = {.lex_state = 21, .external_lex_state = 41},
  [3619] = {.lex_state = 21, .external_lex_state = 47},
  [3620] = {.lex_state = 21, .external_lex_state = 49},
  [3621] = {.lex_state = 20, .external_lex_state = 41},
  [3622] = {.lex_state = 0, .external_lex_state = 41},
  [3623] = {.lex_state = 0, .external_lex_state = 41},
  [3624] = {.lex_state = 20, .external_lex_state = 41},
  [3625] = {.lex_state = 20, .external_lex_state = 41},
  [3626] = {.lex_state = 0, .external_lex_state = 41},
  [3627] = {.lex_state = 0, .external_lex_state = 41},
  [3628] = {.lex_state = 0, .external_lex_state = 41},
  [3629] = {.lex_state = 0, .external_lex_state = 41},
  [3630] = {.lex_state = 21, .external_lex_state = 41},
  [3631] = {.lex_state = 0, .external_lex_state = 41},
  [3632] = {.lex_state = 0, .external_lex_state = 41},
  [3633] = {.lex_state = 21, .external_lex_state = 49},
  [3634] = {.lex_state = 0, .external_lex_state = 41},
  [3635] = {.lex_state = 0, .external_lex_state = 41},
  [3636] = {.lex_state = 21, .external_lex_state = 49},
  [3637] = {.lex_state = 0, .external_lex_state = 41},
  [3638] = {.lex_state = 0, .external_lex_state = 41},
  [3639] = {.lex_state = 21, .external_lex_state = 49},
  [3640] = {.lex_state = 0, .external_lex_state = 41},
  [3641] = {.lex_state = 0, .external_lex_state = 41},
  [3642] = {.lex_state = 21, .external_lex_state = 41},
  [3643] = {.lex_state = 0, .external_lex_state = 41},
  [3644] = {.lex_state = 0, .external_lex_state = 41},
  [3645] = {.lex_state = 21, .external_lex_state = 49},
  [3646] = {.lex_state = 0, .external_lex_state = 41},
  [3647] = {.lex_state = 0, .external_lex_state = 41},
  [3648] = {.lex_state = 0, .external_lex_state = 41},
  [3649] = {.lex_state = 0, .external_lex_state = 41},
  [3650] = {.lex_state = 0, .external_lex_state = 41},
  [3651] = {.lex_state = 0, .external_lex_state = 41},
  [3652] = {.lex_state = 0, .external_lex_state = 41},
  [3653] = {.lex_state = 0, .external_lex_state = 41},
  [3654] = {.lex_state = 0, .external_lex_state = 41},
  [3655] = {.lex_state = 0, .external_lex_state = 41},
  [3656] = {.lex_state = 0, .external_lex_state = 41},
  [3657] = {.lex_state = 0, .external_lex_state = 41},
  [3658] = {.lex_state = 0, .external_lex_state = 41},
  [3659] = {.lex_state = 0, .external_lex_state = 41},
  [3660] = {.lex_state = 0, .external_lex_state = 41},
  [3661] = {.lex_state = 16, .external_lex_state = 41},
  [3662] = {.lex_state = 18, .external_lex_state = 41},
  [3663] = {.lex_state = 21, .external_lex_state = 43},
  [3664] = {.lex_state = 20, .external_lex_state = 41},
  [3665] = {.lex_state = 21, .external_lex_state = 49},
  [3666] = {.lex_state = 21, .external_lex_state = 49},
  [3667] = {.lex_state = 16, .external_lex_state = 41},
  [3668] = {.lex_state = 21, .external_lex_state = 41},
  [3669] = {.lex_state = 21, .external_lex_state = 43},
  [3670] = {.lex_state = 20, .external_lex_state = 41},
  [3671] = {.lex_state = 21, .external_lex_state = 49},
  [3672] = {.lex_state = 20, .external_lex_state = 41},
  [3673] = {.lex_state = 16, .external_lex_state = 41},
  [3674] = {.lex_state = 21, .external_lex_state = 41},
  [3675] = {.lex_state = 21, .external_lex_state = 43},
  [3676] = {.lex_state = 20, .external_lex_state = 41},
  [3677] = {.lex_state = 21, .external_lex_state = 49},
  [3678] = {.lex_state = 21, .external_lex_state = 41},
  [3679] = {.lex_state = 21, .external_lex_state = 41},
  [3680] = {.lex_state = 20, .external_lex_state = 41},
  [3681] = {.lex_state = 0, .external_lex_state = 41},
  [3682] = {.lex_state = 20, .external_lex_state = 41},
  [3683] = {.lex_state = 21, .external_lex_state = 41},
  [3684] = {.lex_state = 20, .external_lex_state = 41},
  [3685] = {.lex_state = 21, .external_lex_state = 49},
  [3686] = {.lex_state = 20, .external_lex_state = 41},
  [3687] = {.lex_state = 20, .external_lex_state = 41},
  [3688] = {.lex_state = 20, .external_lex_state = 41},
  [3689] = {.lex_state = 21, .external_lex_state = 41},
  [3690] = {.lex_state = 20, .external_lex_state = 41},
  [3691] = {.lex_state = 21, .external_lex_state = 49},
  [3692] = {.lex_state = 20, .external_lex_state = 41},
  [3693] = {.lex_state = 21, .external_lex_state = 48},
  [3694] = {.lex_state = 20, .external_lex_state = 41},
  [3695] = {.lex_state = 20, .external_lex_state = 41},
  [3696] = {.lex_state = 20, .external_lex_state = 41},
  [3697] = {.lex_state = 20, .external_lex_state = 41},
  [3698] = {.lex_state = 20, .external_lex_state = 41},
  [3699] = {.lex_state = 21, .external_lex_state = 49},
  [3700] = {.lex_state = 21, .external_lex_state = 49},
  [3701] = {.lex_state = 21, .external_lex_state = 49},
  [3702] = {.lex_state = 21, .external_lex_state = 49},
  [3703] = {.lex_state = 21, .external_lex_state = 48},
  [3704] = {.lex_state = 21, .external_lex_state = 49},
  [3705] = {.lex_state = 21, .external_lex_state = 49},
  [3706] = {.lex_state = 20, .external_lex_state = 41},
  [3707] = {.lex_state = 0, .external_lex_state = 41},
  [3708] = {.lex_state = 0, .external_lex_state = 41},
  [3709] = {.lex_state = 21, .external_lex_state = 41},
  [3710] = {.lex_state = 21, .external_lex_state = 49},
  [3711] = {.lex_state = 21, .external_lex_state = 49},
  [3712] = {.lex_state = 21, .external_lex_state = 49},
  [3713] = {.lex_state = 21, .external_lex_state = 49},
  [3714] = {.lex_state = 21, .external_lex_state = 49},
  [3715] = {.lex_state = 21, .external_lex_state = 49},
  [3716] = {.lex_state = 21, .external_lex_state = 49},
  [3717] = {.lex_state = 20, .external_lex_state = 41},
  [3718] = {.lex_state = 21, .external_lex_state = 41},
  [3719] = {.lex_state = 21, .external_lex_state = 49},
  [3720] = {.lex_state = 21, .external_lex_state = 49},
  [3721] = {.lex_state = 21, .external_lex_state = 49},
  [3722] = {.lex_state = 0, .external_lex_state = 41},
  [3723] = {(TSStateId)(-1)},
  [3724] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_name] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_elseif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_repeat] = ACTIONS(1),
    [anon_sym_until] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [sym_continue_stmt] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_TILDE_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_LBRACE2] = ACTIONS(1),
    [aux_sym_unicode_escape_token1] = ACTIONS(1),
    [anon_sym_RBRACE2] = ACTIONS(1),
    [aux_sym_dec_byte_escape_token1] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_nil] = ACTIONS(1),
    [anon_sym_read] = ACTIONS(1),
    [anon_sym_write] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_AT_LBRACK] = ACTIONS(1),
    [sym__comment_start] = ACTIONS(3),
    [sym__comment_content] = ACTIONS(1),
    [sym__comment_end] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
    [sym_interp_start] = ACTIONS(1),
    [sym_interp_content] = ACTIONS(1),
    [sym_interp_brace_open] = ACTIONS(1),
    [sym_interp_brace_close] = ACTIONS(1),
    [sym_interp_end] = ACTIONS(1),
    [sym_simple_escape] = ACTIONS(1),
    [sym__unicode_escape_sequence] = ACTIONS(1),
    [sym__dec_byte_escape_sequence] = ACTIONS(1),
    [sym__hex_byte_escape_sequence] = ACTIONS(1),
  },
  [1] = {
    [sym_chunk] = STATE(3329),
    [sym__block] = STATE(3202),
    [sym_ret_stmt] = STATE(3421),
    [sym_statement] = STATE(2283),
    [sym_local_fn_stmt] = STATE(2234),
    [sym_fn_stmt] = STATE(2234),
    [aux_sym__attrlist] = STATE(2787),
    [sym_for_in_stmt] = STATE(2234),
    [sym_for_range_stmt] = STATE(2234),
    [sym_if_stmt] = STATE(2234),
    [sym_repeat_stmt] = STATE(2234),
    [sym_while_stmt] = STATE(2234),
    [sym_do_stmt] = STATE(2234),
    [sym_break_stmt] = STATE(2234),
    [sym_local_var_stmt] = STATE(2234),
    [sym_var_stmt] = STATE(2234),
    [sym_assign_stmt] = STATE(2234),
    [sym__varlist] = STATE(3426),
    [sym_type_stmt] = STATE(2234),
    [sym_type_fn_stmt] = STATE(2234),
    [sym_prefixexp] = STATE(3049),
    [sym__prefixexp] = STATE(2785),
    [sym_exp_wrap] = STATE(2691),
    [sym_call_stmt] = STATE(1305),
    [sym__tbl_method] = STATE(2833),
    [sym_var] = STATE(2539),
    [sym__tbl_seq] = STATE(2223),
    [sym_attribute] = STATE(2882),
    [sym_comment] = STATE(1),
    [aux_sym__block_repeat1] = STATE(230),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_name] = ACTIONS(7),
    [anon_sym_return] = ACTIONS(9),
    [anon_sym_local] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_do] = ACTIONS(17),
    [anon_sym_if] = ACTIONS(19),
    [anon_sym_repeat] = ACTIONS(21),
    [anon_sym_while] = ACTIONS(23),
    [anon_sym_break] = ACTIONS(25),
    [sym_continue_stmt] = ACTIONS(27),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(33),
    [anon_sym_AT] = ACTIONS(35),
    [anon_sym_AT_LBRACK] = ACTIONS(37),
    [sym__comment_start] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 40,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(39), 1,
      anon_sym_return,
    ACTIONS(41), 1,
      anon_sym_local,
    ACTIONS(43), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_for,
    ACTIONS(47), 1,
      anon_sym_do,
    ACTIONS(49), 1,
      anon_sym_end,
    ACTIONS(51), 1,
      anon_sym_if,
    ACTIONS(53), 1,
      anon_sym_elseif,
    ACTIONS(55), 1,
      anon_sym_else,
    ACTIONS(57), 1,
      anon_sym_repeat,
    ACTIONS(59), 1,
      anon_sym_while,
    ACTIONS(61), 1,
      anon_sym_break,
    ACTIONS(63), 1,
      sym_continue_stmt,
    ACTIONS(65), 1,
      anon_sym_export,
    ACTIONS(67), 1,
      anon_sym_type,
    STATE(2), 1,
      sym_comment,
    STATE(137), 1,
      aux_sym__block_repeat1,
    STATE(1179), 1,
      sym_call_stmt,
    STATE(2041), 1,
      sym_statement,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2537), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2758), 1,
      sym__tbl_method,
    STATE(2760), 1,
      aux_sym_if_stmt_repeat1,
    STATE(2817), 1,
      sym_block,
    STATE(2825), 1,
      aux_sym__attrlist,
    STATE(2844), 1,
      sym__prefixexp,
    STATE(2882), 1,
      sym_attribute,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(2958), 1,
      sym_ret_stmt,
    STATE(3019), 1,
      sym__block,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3241), 1,
      sym_else_clause,
    STATE(3383), 1,
      sym__varlist,
    STATE(2026), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [134] = 40,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(39), 1,
      anon_sym_return,
    ACTIONS(41), 1,
      anon_sym_local,
    ACTIONS(43), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_for,
    ACTIONS(47), 1,
      anon_sym_do,
    ACTIONS(51), 1,
      anon_sym_if,
    ACTIONS(53), 1,
      anon_sym_elseif,
    ACTIONS(55), 1,
      anon_sym_else,
    ACTIONS(57), 1,
      anon_sym_repeat,
    ACTIONS(59), 1,
      anon_sym_while,
    ACTIONS(61), 1,
      anon_sym_break,
    ACTIONS(63), 1,
      sym_continue_stmt,
    ACTIONS(65), 1,
      anon_sym_export,
    ACTIONS(67), 1,
      anon_sym_type,
    ACTIONS(69), 1,
      anon_sym_end,
    STATE(3), 1,
      sym_comment,
    STATE(137), 1,
      aux_sym__block_repeat1,
    STATE(1179), 1,
      sym_call_stmt,
    STATE(2041), 1,
      sym_statement,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2537), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2752), 1,
      sym_block,
    STATE(2758), 1,
      sym__tbl_method,
    STATE(2765), 1,
      aux_sym_if_stmt_repeat1,
    STATE(2825), 1,
      aux_sym__attrlist,
    STATE(2844), 1,
      sym__prefixexp,
    STATE(2882), 1,
      sym_attribute,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(2958), 1,
      sym_ret_stmt,
    STATE(3019), 1,
      sym__block,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3270), 1,
      sym_else_clause,
    STATE(3383), 1,
      sym__varlist,
    STATE(2026), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [268] = 40,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(39), 1,
      anon_sym_return,
    ACTIONS(41), 1,
      anon_sym_local,
    ACTIONS(43), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_for,
    ACTIONS(47), 1,
      anon_sym_do,
    ACTIONS(51), 1,
      anon_sym_if,
    ACTIONS(53), 1,
      anon_sym_elseif,
    ACTIONS(55), 1,
      anon_sym_else,
    ACTIONS(57), 1,
      anon_sym_repeat,
    ACTIONS(59), 1,
      anon_sym_while,
    ACTIONS(61), 1,
      anon_sym_break,
    ACTIONS(63), 1,
      sym_continue_stmt,
    ACTIONS(65), 1,
      anon_sym_export,
    ACTIONS(67), 1,
      anon_sym_type,
    ACTIONS(71), 1,
      anon_sym_end,
    STATE(4), 1,
      sym_comment,
    STATE(137), 1,
      aux_sym__block_repeat1,
    STATE(1179), 1,
      sym_call_stmt,
    STATE(2041), 1,
      sym_statement,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2537), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2758), 1,
      sym__tbl_method,
    STATE(2801), 1,
      sym_block,
    STATE(2804), 1,
      aux_sym_if_stmt_repeat1,
    STATE(2825), 1,
      aux_sym__attrlist,
    STATE(2844), 1,
      sym__prefixexp,
    STATE(2882), 1,
      sym_attribute,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(2958), 1,
      sym_ret_stmt,
    STATE(3019), 1,
      sym__block,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3134), 1,
      sym_else_clause,
    STATE(3383), 1,
      sym__varlist,
    STATE(2026), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [402] = 40,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(39), 1,
      anon_sym_return,
    ACTIONS(41), 1,
      anon_sym_local,
    ACTIONS(43), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_for,
    ACTIONS(47), 1,
      anon_sym_do,
    ACTIONS(51), 1,
      anon_sym_if,
    ACTIONS(53), 1,
      anon_sym_elseif,
    ACTIONS(55), 1,
      anon_sym_else,
    ACTIONS(57), 1,
      anon_sym_repeat,
    ACTIONS(59), 1,
      anon_sym_while,
    ACTIONS(61), 1,
      anon_sym_break,
    ACTIONS(63), 1,
      sym_continue_stmt,
    ACTIONS(65), 1,
      anon_sym_export,
    ACTIONS(67), 1,
      anon_sym_type,
    ACTIONS(73), 1,
      anon_sym_end,
    STATE(5), 1,
      sym_comment,
    STATE(137), 1,
      aux_sym__block_repeat1,
    STATE(1179), 1,
      sym_call_stmt,
    STATE(2041), 1,
      sym_statement,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2537), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2758), 1,
      sym__tbl_method,
    STATE(2766), 1,
      sym_block,
    STATE(2767), 1,
      aux_sym_if_stmt_repeat1,
    STATE(2825), 1,
      aux_sym__attrlist,
    STATE(2844), 1,
      sym__prefixexp,
    STATE(2882), 1,
      sym_attribute,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(2958), 1,
      sym_ret_stmt,
    STATE(3019), 1,
      sym__block,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3383), 1,
      sym__varlist,
    STATE(3617), 1,
      sym_else_clause,
    STATE(2026), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [536] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(39), 1,
      anon_sym_return,
    ACTIONS(41), 1,
      anon_sym_local,
    ACTIONS(43), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_for,
    ACTIONS(47), 1,
      anon_sym_do,
    ACTIONS(51), 1,
      anon_sym_if,
    ACTIONS(57), 1,
      anon_sym_repeat,
    ACTIONS(59), 1,
      anon_sym_while,
    ACTIONS(61), 1,
      anon_sym_break,
    ACTIONS(63), 1,
      sym_continue_stmt,
    ACTIONS(65), 1,
      anon_sym_export,
    ACTIONS(67), 1,
      anon_sym_type,
    STATE(6), 1,
      sym_comment,
    STATE(137), 1,
      aux_sym__block_repeat1,
    STATE(1179), 1,
      sym_call_stmt,
    STATE(2041), 1,
      sym_statement,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2537), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2758), 1,
      sym__tbl_method,
    STATE(2825), 1,
      aux_sym__attrlist,
    STATE(2844), 1,
      sym__prefixexp,
    STATE(2882), 1,
      sym_attribute,
    STATE(2958), 1,
      sym_ret_stmt,
    STATE(2988), 1,
      sym_block,
    STATE(3019), 1,
      sym__block,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3383), 1,
      sym__varlist,
    ACTIONS(75), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
    STATE(2026), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [657] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(83), 1,
      anon_sym_COLON,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(89), 1,
      anon_sym_end,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    STATE(7), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3455), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [779] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(105), 1,
      anon_sym_COLON,
    ACTIONS(107), 1,
      anon_sym_end,
    STATE(8), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3419), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [901] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(109), 1,
      anon_sym_COLON,
    ACTIONS(111), 1,
      anon_sym_end,
    STATE(9), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3550), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [1023] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(113), 1,
      anon_sym_COLON,
    ACTIONS(115), 1,
      anon_sym_end,
    STATE(10), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3719), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [1145] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(117), 1,
      anon_sym_COLON,
    ACTIONS(119), 1,
      anon_sym_end,
    STATE(11), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3313), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [1267] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(121), 1,
      anon_sym_COLON,
    ACTIONS(123), 1,
      anon_sym_end,
    STATE(12), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3503), 1,
      sym_block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [1389] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(125), 1,
      anon_sym_COLON,
    ACTIONS(127), 1,
      anon_sym_end,
    STATE(13), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3164), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [1511] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(129), 1,
      anon_sym_COLON,
    ACTIONS(131), 1,
      anon_sym_end,
    STATE(14), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3263), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [1633] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(133), 1,
      anon_sym_COLON,
    ACTIONS(135), 1,
      anon_sym_end,
    STATE(15), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3308), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [1755] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(137), 1,
      anon_sym_COLON,
    ACTIONS(139), 1,
      anon_sym_end,
    STATE(16), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3354), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [1877] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(141), 1,
      anon_sym_COLON,
    ACTIONS(143), 1,
      anon_sym_end,
    STATE(17), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3501), 1,
      sym_block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [1999] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(145), 1,
      anon_sym_COLON,
    ACTIONS(147), 1,
      anon_sym_end,
    STATE(18), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3700), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [2121] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(149), 1,
      anon_sym_COLON,
    ACTIONS(151), 1,
      anon_sym_end,
    STATE(19), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3131), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [2243] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(153), 1,
      anon_sym_COLON,
    ACTIONS(155), 1,
      anon_sym_end,
    STATE(20), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3452), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [2365] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(157), 1,
      anon_sym_COLON,
    ACTIONS(159), 1,
      anon_sym_end,
    STATE(21), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3150), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [2487] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(161), 1,
      anon_sym_COLON,
    ACTIONS(163), 1,
      anon_sym_end,
    STATE(22), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3434), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [2609] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(165), 1,
      anon_sym_COLON,
    ACTIONS(167), 1,
      anon_sym_end,
    STATE(23), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3491), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [2731] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(169), 1,
      anon_sym_COLON,
    ACTIONS(171), 1,
      anon_sym_end,
    STATE(24), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3545), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [2853] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(173), 1,
      anon_sym_COLON,
    ACTIONS(175), 1,
      anon_sym_end,
    STATE(25), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3605), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [2975] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(177), 1,
      anon_sym_COLON,
    ACTIONS(179), 1,
      anon_sym_end,
    STATE(26), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3172), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [3097] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(181), 1,
      anon_sym_COLON,
    ACTIONS(183), 1,
      anon_sym_end,
    STATE(27), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3203), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [3219] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(185), 1,
      anon_sym_COLON,
    ACTIONS(187), 1,
      anon_sym_end,
    STATE(28), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3235), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [3341] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(189), 1,
      anon_sym_COLON,
    ACTIONS(191), 1,
      anon_sym_end,
    STATE(29), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3254), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [3463] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(193), 1,
      anon_sym_COLON,
    ACTIONS(195), 1,
      anon_sym_end,
    STATE(30), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3301), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [3585] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(197), 1,
      anon_sym_COLON,
    ACTIONS(199), 1,
      anon_sym_end,
    STATE(31), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3315), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [3707] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(201), 1,
      anon_sym_COLON,
    ACTIONS(203), 1,
      anon_sym_end,
    STATE(32), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3352), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [3829] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(205), 1,
      anon_sym_COLON,
    ACTIONS(207), 1,
      anon_sym_end,
    STATE(33), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3372), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [3951] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(209), 1,
      anon_sym_COLON,
    ACTIONS(211), 1,
      anon_sym_end,
    STATE(34), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3433), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [4073] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(213), 1,
      anon_sym_COLON,
    ACTIONS(215), 1,
      anon_sym_end,
    STATE(35), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3334), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [4195] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(217), 1,
      anon_sym_COLON,
    ACTIONS(219), 1,
      anon_sym_end,
    STATE(36), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3482), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [4317] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(221), 1,
      anon_sym_COLON,
    ACTIONS(223), 1,
      anon_sym_end,
    STATE(37), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3502), 1,
      sym_block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [4439] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(225), 1,
      anon_sym_COLON,
    ACTIONS(227), 1,
      anon_sym_end,
    STATE(38), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3552), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [4561] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(229), 1,
      anon_sym_COLON,
    ACTIONS(231), 1,
      anon_sym_end,
    STATE(39), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3565), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [4683] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(233), 1,
      anon_sym_COLON,
    ACTIONS(235), 1,
      anon_sym_end,
    STATE(40), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3579), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [4805] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(237), 1,
      anon_sym_COLON,
    ACTIONS(239), 1,
      anon_sym_end,
    STATE(41), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3587), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [4927] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(241), 1,
      anon_sym_COLON,
    ACTIONS(243), 1,
      anon_sym_end,
    STATE(42), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3671), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [5049] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(245), 1,
      anon_sym_COLON,
    ACTIONS(247), 1,
      anon_sym_end,
    STATE(43), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3701), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [5171] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(249), 1,
      anon_sym_COLON,
    ACTIONS(251), 1,
      anon_sym_end,
    STATE(44), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3713), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [5293] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(253), 1,
      anon_sym_COLON,
    ACTIONS(255), 1,
      anon_sym_end,
    STATE(45), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3720), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [5415] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(257), 1,
      anon_sym_COLON,
    ACTIONS(259), 1,
      anon_sym_end,
    STATE(46), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3401), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [5537] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(261), 1,
      anon_sym_COLON,
    ACTIONS(263), 1,
      anon_sym_end,
    STATE(47), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3457), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [5659] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(265), 1,
      anon_sym_COLON,
    ACTIONS(267), 1,
      anon_sym_end,
    STATE(48), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3705), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [5781] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(269), 1,
      anon_sym_COLON,
    ACTIONS(271), 1,
      anon_sym_end,
    STATE(49), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3133), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [5903] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(273), 1,
      anon_sym_COLON,
    ACTIONS(275), 1,
      anon_sym_end,
    STATE(50), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3247), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [6025] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(277), 1,
      anon_sym_COLON,
    ACTIONS(279), 1,
      anon_sym_end,
    STATE(51), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3295), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [6147] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(281), 1,
      anon_sym_COLON,
    ACTIONS(283), 1,
      anon_sym_end,
    STATE(52), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3325), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [6269] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(285), 1,
      anon_sym_COLON,
    ACTIONS(287), 1,
      anon_sym_end,
    STATE(53), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3360), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [6391] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(289), 1,
      anon_sym_COLON,
    ACTIONS(291), 1,
      anon_sym_end,
    STATE(54), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3442), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [6513] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(293), 1,
      anon_sym_COLON,
    ACTIONS(295), 1,
      anon_sym_end,
    STATE(55), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3458), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [6635] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(297), 1,
      anon_sym_COLON,
    ACTIONS(299), 1,
      anon_sym_end,
    STATE(56), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3477), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [6757] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(301), 1,
      anon_sym_COLON,
    ACTIONS(303), 1,
      anon_sym_end,
    STATE(57), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3494), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [6879] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(305), 1,
      anon_sym_COLON,
    ACTIONS(307), 1,
      anon_sym_end,
    STATE(58), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3572), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [7001] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(309), 1,
      anon_sym_COLON,
    ACTIONS(311), 1,
      anon_sym_end,
    STATE(59), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3614), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [7123] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(313), 1,
      anon_sym_COLON,
    ACTIONS(315), 1,
      anon_sym_end,
    STATE(60), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3666), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [7245] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(317), 1,
      anon_sym_COLON,
    ACTIONS(319), 1,
      anon_sym_end,
    STATE(61), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3699), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [7367] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(321), 1,
      anon_sym_COLON,
    ACTIONS(323), 1,
      anon_sym_end,
    STATE(62), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3140), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [7489] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(325), 1,
      anon_sym_COLON,
    ACTIONS(327), 1,
      anon_sym_end,
    STATE(63), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3149), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [7611] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(329), 1,
      anon_sym_COLON,
    ACTIONS(331), 1,
      anon_sym_end,
    STATE(64), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3158), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [7733] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(333), 1,
      anon_sym_COLON,
    ACTIONS(335), 1,
      anon_sym_end,
    STATE(65), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3165), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [7855] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(337), 1,
      anon_sym_COLON,
    ACTIONS(339), 1,
      anon_sym_end,
    STATE(66), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3186), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [7977] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(341), 1,
      anon_sym_COLON,
    ACTIONS(343), 1,
      anon_sym_end,
    STATE(67), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3195), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [8099] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(345), 1,
      anon_sym_COLON,
    ACTIONS(347), 1,
      anon_sym_end,
    STATE(68), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3204), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [8221] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(349), 1,
      anon_sym_COLON,
    ACTIONS(351), 1,
      anon_sym_end,
    STATE(69), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3211), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [8343] = 36,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(353), 1,
      anon_sym_COLON,
    ACTIONS(355), 1,
      anon_sym_end,
    STATE(70), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3268), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [8465] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(357), 1,
      anon_sym_end,
    STATE(71), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3585), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [8584] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(359), 1,
      anon_sym_return,
    ACTIONS(361), 1,
      anon_sym_local,
    ACTIONS(363), 1,
      anon_sym_function,
    ACTIONS(365), 1,
      anon_sym_for,
    ACTIONS(367), 1,
      anon_sym_do,
    ACTIONS(369), 1,
      anon_sym_if,
    ACTIONS(371), 1,
      anon_sym_repeat,
    ACTIONS(373), 1,
      anon_sym_until,
    ACTIONS(375), 1,
      anon_sym_while,
    ACTIONS(377), 1,
      anon_sym_break,
    ACTIONS(379), 1,
      sym_continue_stmt,
    ACTIONS(381), 1,
      anon_sym_export,
    ACTIONS(383), 1,
      anon_sym_type,
    STATE(72), 1,
      sym_comment,
    STATE(229), 1,
      aux_sym__block_repeat1,
    STATE(1375), 1,
      sym_call_stmt,
    STATE(2217), 1,
      sym_statement,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2534), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2747), 1,
      sym__prefixexp,
    STATE(2751), 1,
      sym__tbl_method,
    STATE(2820), 1,
      aux_sym__attrlist,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3173), 1,
      sym_ret_stmt,
    STATE(3271), 1,
      sym__block,
    STATE(3349), 1,
      sym__varlist,
    STATE(3353), 1,
      sym_block,
    STATE(2216), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [8703] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(385), 1,
      anon_sym_end,
    STATE(73), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3350), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [8822] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(387), 1,
      anon_sym_end,
    STATE(74), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3333), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [8941] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(389), 1,
      anon_sym_end,
    STATE(75), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3299), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [9060] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_end,
    STATE(76), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3454), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [9179] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(393), 1,
      anon_sym_end,
    STATE(77), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3612), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [9298] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(395), 1,
      anon_sym_end,
    STATE(78), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3615), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [9417] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(397), 1,
      anon_sym_end,
    STATE(79), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3282), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [9536] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(399), 1,
      anon_sym_end,
    STATE(80), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3404), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [9655] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(401), 1,
      anon_sym_end,
    STATE(81), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3441), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [9774] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(403), 1,
      anon_sym_end,
    STATE(82), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3141), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [9893] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(405), 1,
      anon_sym_end,
    STATE(83), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3398), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [10012] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(407), 1,
      anon_sym_end,
    STATE(84), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3448), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [10131] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(409), 1,
      anon_sym_end,
    STATE(85), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3456), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [10250] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(411), 1,
      anon_sym_end,
    STATE(86), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3156), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [10369] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(413), 1,
      anon_sym_end,
    STATE(87), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3169), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [10488] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(415), 1,
      anon_sym_end,
    STATE(88), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3178), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [10607] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(417), 1,
      anon_sym_end,
    STATE(89), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3439), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [10726] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(419), 1,
      anon_sym_end,
    STATE(90), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3250), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [10845] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(421), 1,
      anon_sym_end,
    STATE(91), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3143), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [10964] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(423), 1,
      anon_sym_end,
    STATE(92), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3389), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [11083] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(425), 1,
      anon_sym_end,
    STATE(93), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3278), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [11202] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(427), 1,
      anon_sym_end,
    STATE(94), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3290), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [11321] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(429), 1,
      anon_sym_end,
    STATE(95), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3291), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [11440] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(431), 1,
      anon_sym_end,
    STATE(96), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3524), 1,
      sym_block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [11559] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(433), 1,
      anon_sym_end,
    STATE(97), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3311), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [11678] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(435), 1,
      anon_sym_end,
    STATE(98), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3317), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [11797] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(437), 1,
      anon_sym_end,
    STATE(99), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3336), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [11916] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(439), 1,
      anon_sym_end,
    STATE(100), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3532), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [12035] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(441), 1,
      anon_sym_end,
    STATE(101), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3378), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [12154] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(443), 1,
      anon_sym_end,
    STATE(102), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3400), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [12273] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(445), 1,
      anon_sym_end,
    STATE(103), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3409), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [12392] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(447), 1,
      anon_sym_end,
    STATE(104), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3410), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [12511] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(449), 1,
      anon_sym_end,
    STATE(105), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3411), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [12630] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(451), 1,
      anon_sym_end,
    STATE(106), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3525), 1,
      sym_block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [12749] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(453), 1,
      anon_sym_end,
    STATE(107), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3283), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [12868] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(455), 1,
      anon_sym_end,
    STATE(108), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3636), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [12987] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(457), 1,
      anon_sym_end,
    STATE(109), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3163), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [13106] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(459), 1,
      anon_sym_end,
    STATE(110), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3225), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [13225] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(461), 1,
      anon_sym_end,
    STATE(111), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3287), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [13344] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(463), 1,
      anon_sym_end,
    STATE(112), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3300), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [13463] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(465), 1,
      anon_sym_end,
    STATE(113), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3371), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [13582] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(467), 1,
      anon_sym_end,
    STATE(114), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3467), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [13701] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(469), 1,
      anon_sym_end,
    STATE(115), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3529), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [13820] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(471), 1,
      anon_sym_end,
    STATE(116), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3712), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [13939] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(473), 1,
      anon_sym_end,
    STATE(117), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3436), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [14058] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(475), 1,
      anon_sym_end,
    STATE(118), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3157), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [14177] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(477), 1,
      anon_sym_end,
    STATE(119), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3168), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [14296] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(479), 1,
      anon_sym_end,
    STATE(120), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3179), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [14415] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(481), 1,
      anon_sym_end,
    STATE(121), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3187), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [14534] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(483), 1,
      anon_sym_end,
    STATE(122), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3189), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [14653] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(485), 1,
      anon_sym_end,
    STATE(123), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3192), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [14772] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_end,
    STATE(124), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3294), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [14891] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(489), 1,
      anon_sym_end,
    STATE(125), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3533), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [15010] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(491), 1,
      anon_sym_end,
    STATE(126), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3536), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [15129] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(493), 1,
      anon_sym_end,
    STATE(127), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3557), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [15248] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(495), 1,
      anon_sym_end,
    STATE(128), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3562), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [15367] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(497), 1,
      anon_sym_end,
    STATE(129), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3608), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [15486] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(499), 1,
      anon_sym_end,
    STATE(130), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3609), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [15605] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(501), 1,
      anon_sym_end,
    STATE(131), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3645), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [15724] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(503), 1,
      anon_sym_end,
    STATE(132), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3665), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [15843] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(505), 1,
      anon_sym_end,
    STATE(133), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3222), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [15962] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(507), 1,
      anon_sym_end,
    STATE(134), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3223), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [16081] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(509), 1,
      anon_sym_end,
    STATE(135), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3240), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [16200] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(511), 1,
      anon_sym_end,
    STATE(136), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3242), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [16319] = 33,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(39), 1,
      anon_sym_return,
    ACTIONS(41), 1,
      anon_sym_local,
    ACTIONS(43), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_for,
    ACTIONS(47), 1,
      anon_sym_do,
    ACTIONS(51), 1,
      anon_sym_if,
    ACTIONS(57), 1,
      anon_sym_repeat,
    ACTIONS(59), 1,
      anon_sym_while,
    ACTIONS(61), 1,
      anon_sym_break,
    ACTIONS(63), 1,
      sym_continue_stmt,
    ACTIONS(65), 1,
      anon_sym_export,
    ACTIONS(67), 1,
      anon_sym_type,
    STATE(137), 1,
      sym_comment,
    STATE(226), 1,
      aux_sym__block_repeat1,
    STATE(1179), 1,
      sym_call_stmt,
    STATE(2041), 1,
      sym_statement,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2537), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2758), 1,
      sym__tbl_method,
    STATE(2825), 1,
      aux_sym__attrlist,
    STATE(2844), 1,
      sym__prefixexp,
    STATE(2882), 1,
      sym_attribute,
    STATE(2991), 1,
      sym_ret_stmt,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3383), 1,
      sym__varlist,
    ACTIONS(513), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
    STATE(2026), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [16434] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(515), 1,
      anon_sym_end,
    STATE(138), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3255), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [16553] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(517), 1,
      anon_sym_end,
    STATE(139), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3256), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [16672] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(519), 1,
      anon_sym_end,
    STATE(140), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3260), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [16791] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(521), 1,
      anon_sym_end,
    STATE(141), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3262), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [16910] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(523), 1,
      anon_sym_end,
    STATE(142), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3341), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [17029] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(525), 1,
      anon_sym_end,
    STATE(143), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3342), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [17148] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(527), 1,
      anon_sym_end,
    STATE(144), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3355), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [17267] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(529), 1,
      anon_sym_end,
    STATE(145), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3357), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [17386] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(531), 1,
      anon_sym_end,
    STATE(146), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3375), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [17505] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(533), 1,
      anon_sym_end,
    STATE(147), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3377), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [17624] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(535), 1,
      anon_sym_end,
    STATE(148), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3384), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [17743] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(537), 1,
      anon_sym_end,
    STATE(149), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3386), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [17862] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(539), 1,
      anon_sym_end,
    STATE(150), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3472), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [17981] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(541), 1,
      anon_sym_end,
    STATE(151), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3474), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [18100] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(543), 1,
      anon_sym_end,
    STATE(152), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3486), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [18219] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(359), 1,
      anon_sym_return,
    ACTIONS(361), 1,
      anon_sym_local,
    ACTIONS(363), 1,
      anon_sym_function,
    ACTIONS(365), 1,
      anon_sym_for,
    ACTIONS(367), 1,
      anon_sym_do,
    ACTIONS(369), 1,
      anon_sym_if,
    ACTIONS(371), 1,
      anon_sym_repeat,
    ACTIONS(375), 1,
      anon_sym_while,
    ACTIONS(377), 1,
      anon_sym_break,
    ACTIONS(379), 1,
      sym_continue_stmt,
    ACTIONS(381), 1,
      anon_sym_export,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(545), 1,
      anon_sym_until,
    STATE(153), 1,
      sym_comment,
    STATE(229), 1,
      aux_sym__block_repeat1,
    STATE(1375), 1,
      sym_call_stmt,
    STATE(2217), 1,
      sym_statement,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2534), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2747), 1,
      sym__prefixexp,
    STATE(2751), 1,
      sym__tbl_method,
    STATE(2820), 1,
      aux_sym__attrlist,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3173), 1,
      sym_ret_stmt,
    STATE(3271), 1,
      sym__block,
    STATE(3349), 1,
      sym__varlist,
    STATE(3387), 1,
      sym_block,
    STATE(2216), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [18338] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(547), 1,
      anon_sym_end,
    STATE(154), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3504), 1,
      sym_block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [18457] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(549), 1,
      anon_sym_end,
    STATE(155), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3506), 1,
      sym_block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [18576] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_end,
    STATE(156), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3511), 1,
      sym_block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [18695] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(553), 1,
      anon_sym_end,
    STATE(157), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3514), 1,
      sym_block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [18814] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(555), 1,
      anon_sym_end,
    STATE(158), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3574), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [18933] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(557), 1,
      anon_sym_end,
    STATE(159), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3575), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [19052] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(559), 1,
      anon_sym_end,
    STATE(160), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3582), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [19171] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(561), 1,
      anon_sym_end,
    STATE(161), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3583), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [19290] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(563), 1,
      anon_sym_end,
    STATE(162), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3588), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [19409] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(565), 1,
      anon_sym_end,
    STATE(163), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3589), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [19528] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(567), 1,
      anon_sym_end,
    STATE(164), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3592), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [19647] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(569), 1,
      anon_sym_end,
    STATE(165), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3596), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [19766] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(571), 1,
      anon_sym_end,
    STATE(166), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3710), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [19885] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(573), 1,
      anon_sym_end,
    STATE(167), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3711), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [20004] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(575), 1,
      anon_sym_end,
    STATE(168), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3715), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [20123] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(577), 1,
      anon_sym_end,
    STATE(169), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3716), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [20242] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(579), 1,
      anon_sym_end,
    STATE(170), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3721), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [20361] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(581), 1,
      anon_sym_end,
    STATE(171), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3366), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [20480] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(583), 1,
      anon_sym_end,
    STATE(172), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3190), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [20599] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(585), 1,
      anon_sym_end,
    STATE(173), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3272), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [20718] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(587), 1,
      anon_sym_end,
    STATE(174), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3602), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [20837] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(589), 1,
      anon_sym_end,
    STATE(175), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3620), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [20956] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(591), 1,
      anon_sym_end,
    STATE(176), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3126), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [21075] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(593), 1,
      anon_sym_end,
    STATE(177), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3127), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [21194] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(595), 1,
      anon_sym_end,
    STATE(178), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3138), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [21313] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(597), 1,
      anon_sym_end,
    STATE(179), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3139), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [21432] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(599), 1,
      anon_sym_end,
    STATE(180), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3147), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [21551] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(601), 1,
      anon_sym_end,
    STATE(181), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3148), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [21670] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(603), 1,
      anon_sym_end,
    STATE(182), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3306), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [21789] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(605), 1,
      anon_sym_end,
    STATE(183), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3309), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [21908] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(607), 1,
      anon_sym_end,
    STATE(184), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3337), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [22027] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(609), 1,
      anon_sym_end,
    STATE(185), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3343), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [22146] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(611), 1,
      anon_sym_end,
    STATE(186), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3363), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [22265] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(613), 1,
      anon_sym_end,
    STATE(187), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3368), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [22384] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(615), 1,
      anon_sym_end,
    STATE(188), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3382), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [22503] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(617), 1,
      anon_sym_end,
    STATE(189), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3394), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [22622] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(619), 1,
      anon_sym_end,
    STATE(190), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3469), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [22741] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(621), 1,
      anon_sym_end,
    STATE(191), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3470), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [22860] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(623), 1,
      anon_sym_end,
    STATE(192), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3479), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [22979] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(625), 1,
      anon_sym_end,
    STATE(193), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3481), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [23098] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(627), 1,
      anon_sym_end,
    STATE(194), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3495), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [23217] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(629), 1,
      anon_sym_end,
    STATE(195), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3496), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [23336] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(631), 1,
      anon_sym_end,
    STATE(196), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3518), 1,
      sym_block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [23455] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(633), 1,
      anon_sym_end,
    STATE(197), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3519), 1,
      sym_block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [23574] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(635), 1,
      anon_sym_end,
    STATE(198), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3633), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [23693] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(637), 1,
      anon_sym_end,
    STATE(199), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3639), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [23812] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(639), 1,
      anon_sym_end,
    STATE(200), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3677), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [23931] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(641), 1,
      anon_sym_end,
    STATE(201), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3685), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [24050] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(643), 1,
      anon_sym_end,
    STATE(202), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3702), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [24169] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(645), 1,
      anon_sym_end,
    STATE(203), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3704), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [24288] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(647), 1,
      anon_sym_end,
    STATE(204), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(3714), 1,
      sym_block,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [24407] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(649), 1,
      anon_sym_end,
    STATE(205), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3460), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [24526] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(359), 1,
      anon_sym_return,
    ACTIONS(361), 1,
      anon_sym_local,
    ACTIONS(363), 1,
      anon_sym_function,
    ACTIONS(365), 1,
      anon_sym_for,
    ACTIONS(367), 1,
      anon_sym_do,
    ACTIONS(369), 1,
      anon_sym_if,
    ACTIONS(371), 1,
      anon_sym_repeat,
    ACTIONS(375), 1,
      anon_sym_while,
    ACTIONS(377), 1,
      anon_sym_break,
    ACTIONS(379), 1,
      sym_continue_stmt,
    ACTIONS(381), 1,
      anon_sym_export,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(651), 1,
      anon_sym_until,
    STATE(206), 1,
      sym_comment,
    STATE(229), 1,
      aux_sym__block_repeat1,
    STATE(1375), 1,
      sym_call_stmt,
    STATE(2217), 1,
      sym_statement,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2534), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2747), 1,
      sym__prefixexp,
    STATE(2751), 1,
      sym__tbl_method,
    STATE(2820), 1,
      aux_sym__attrlist,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3173), 1,
      sym_ret_stmt,
    STATE(3271), 1,
      sym__block,
    STATE(3349), 1,
      sym__varlist,
    STATE(3510), 1,
      sym_block,
    STATE(2216), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [24645] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(653), 1,
      anon_sym_end,
    STATE(207), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3154), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [24764] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(655), 1,
      anon_sym_end,
    STATE(208), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3155), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [24883] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(657), 1,
      anon_sym_end,
    STATE(209), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3160), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [25002] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(659), 1,
      anon_sym_end,
    STATE(210), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3161), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [25121] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(661), 1,
      anon_sym_end,
    STATE(211), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3166), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [25240] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(663), 1,
      anon_sym_end,
    STATE(212), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3167), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [25359] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(665), 1,
      anon_sym_end,
    STATE(213), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3170), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [25478] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(667), 1,
      anon_sym_end,
    STATE(214), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3171), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [25597] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(669), 1,
      anon_sym_end,
    STATE(215), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3200), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [25716] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(671), 1,
      anon_sym_end,
    STATE(216), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3201), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [25835] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(673), 1,
      anon_sym_end,
    STATE(217), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3206), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [25954] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(675), 1,
      anon_sym_end,
    STATE(218), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3207), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [26073] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_end,
    STATE(219), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3212), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [26192] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(679), 1,
      anon_sym_end,
    STATE(220), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3213), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [26311] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(681), 1,
      anon_sym_end,
    STATE(221), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3216), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [26430] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(683), 1,
      anon_sym_end,
    STATE(222), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3217), 1,
      sym_block,
    STATE(3314), 1,
      sym__varlist,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [26549] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(359), 1,
      anon_sym_return,
    ACTIONS(361), 1,
      anon_sym_local,
    ACTIONS(363), 1,
      anon_sym_function,
    ACTIONS(365), 1,
      anon_sym_for,
    ACTIONS(367), 1,
      anon_sym_do,
    ACTIONS(369), 1,
      anon_sym_if,
    ACTIONS(371), 1,
      anon_sym_repeat,
    ACTIONS(375), 1,
      anon_sym_while,
    ACTIONS(377), 1,
      anon_sym_break,
    ACTIONS(379), 1,
      sym_continue_stmt,
    ACTIONS(381), 1,
      anon_sym_export,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      anon_sym_until,
    STATE(223), 1,
      sym_comment,
    STATE(229), 1,
      aux_sym__block_repeat1,
    STATE(1375), 1,
      sym_call_stmt,
    STATE(2217), 1,
      sym_statement,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2534), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2747), 1,
      sym__prefixexp,
    STATE(2751), 1,
      sym__tbl_method,
    STATE(2820), 1,
      aux_sym__attrlist,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3173), 1,
      sym_ret_stmt,
    STATE(3271), 1,
      sym__block,
    STATE(3318), 1,
      sym_block,
    STATE(3349), 1,
      sym__varlist,
    STATE(2216), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [26668] = 35,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(687), 1,
      anon_sym_end,
    STATE(224), 1,
      sym_comment,
    STATE(231), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3487), 1,
      sym_block,
    STATE(3500), 1,
      sym__block,
    STATE(3527), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [26787] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(693), 1,
      anon_sym_LBRACK,
    ACTIONS(695), 1,
      anon_sym_DOT,
    STATE(225), 1,
      sym_comment,
    STATE(237), 1,
      sym_key,
    STATE(238), 1,
      sym__key_named,
    ACTIONS(691), 18,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(689), 23,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [26851] = 30,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(697), 1,
      sym_name,
    ACTIONS(702), 1,
      anon_sym_local,
    ACTIONS(705), 1,
      anon_sym_function,
    ACTIONS(708), 1,
      anon_sym_for,
    ACTIONS(711), 1,
      anon_sym_do,
    ACTIONS(714), 1,
      anon_sym_if,
    ACTIONS(717), 1,
      anon_sym_repeat,
    ACTIONS(720), 1,
      anon_sym_while,
    ACTIONS(723), 1,
      anon_sym_break,
    ACTIONS(726), 1,
      sym_continue_stmt,
    ACTIONS(729), 1,
      anon_sym_export,
    ACTIONS(732), 1,
      anon_sym_type,
    ACTIONS(735), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_AT,
    ACTIONS(741), 1,
      anon_sym_AT_LBRACK,
    STATE(1179), 1,
      sym_call_stmt,
    STATE(2041), 1,
      sym_statement,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2537), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2758), 1,
      sym__tbl_method,
    STATE(2825), 1,
      aux_sym__attrlist,
    STATE(2844), 1,
      sym__prefixexp,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3383), 1,
      sym__varlist,
    STATE(226), 2,
      sym_comment,
      aux_sym__block_repeat1,
    ACTIONS(700), 4,
      anon_sym_return,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
    STATE(2026), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [26959] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(693), 1,
      anon_sym_LBRACK,
    ACTIONS(695), 1,
      anon_sym_DOT,
    STATE(227), 1,
      sym_comment,
    STATE(238), 1,
      sym__key_named,
    STATE(240), 1,
      sym_key,
    ACTIONS(746), 18,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(744), 23,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [27023] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(693), 1,
      anon_sym_LBRACK,
    ACTIONS(695), 1,
      anon_sym_DOT,
    STATE(228), 1,
      sym_comment,
    STATE(238), 1,
      sym__key_named,
    STATE(239), 1,
      sym_key,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(750), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AT_LBRACK,
    ACTIONS(748), 23,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [27089] = 33,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(359), 1,
      anon_sym_return,
    ACTIONS(361), 1,
      anon_sym_local,
    ACTIONS(363), 1,
      anon_sym_function,
    ACTIONS(365), 1,
      anon_sym_for,
    ACTIONS(367), 1,
      anon_sym_do,
    ACTIONS(369), 1,
      anon_sym_if,
    ACTIONS(371), 1,
      anon_sym_repeat,
    ACTIONS(375), 1,
      anon_sym_while,
    ACTIONS(377), 1,
      anon_sym_break,
    ACTIONS(379), 1,
      sym_continue_stmt,
    ACTIONS(381), 1,
      anon_sym_export,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(513), 1,
      anon_sym_until,
    STATE(229), 1,
      sym_comment,
    STATE(244), 1,
      aux_sym__block_repeat1,
    STATE(1375), 1,
      sym_call_stmt,
    STATE(2217), 1,
      sym_statement,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2534), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2747), 1,
      sym__prefixexp,
    STATE(2751), 1,
      sym__tbl_method,
    STATE(2820), 1,
      aux_sym__attrlist,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3349), 1,
      sym__varlist,
    STATE(3693), 1,
      sym_ret_stmt,
    STATE(2216), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [27202] = 33,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(9), 1,
      anon_sym_return,
    ACTIONS(11), 1,
      anon_sym_local,
    ACTIONS(13), 1,
      anon_sym_function,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_do,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_repeat,
    ACTIONS(23), 1,
      anon_sym_while,
    ACTIONS(25), 1,
      anon_sym_break,
    ACTIONS(27), 1,
      sym_continue_stmt,
    ACTIONS(29), 1,
      anon_sym_export,
    ACTIONS(31), 1,
      anon_sym_type,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(754), 1,
      ts_builtin_sym_end,
    STATE(230), 1,
      sym_comment,
    STATE(236), 1,
      aux_sym__block_repeat1,
    STATE(1305), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2283), 1,
      sym_statement,
    STATE(2539), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2785), 1,
      sym__prefixexp,
    STATE(2787), 1,
      aux_sym__attrlist,
    STATE(2833), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3415), 1,
      sym_ret_stmt,
    STATE(3426), 1,
      sym__varlist,
    STATE(2234), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [27315] = 33,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(7), 1,
      sym_name,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(77), 1,
      anon_sym_return,
    ACTIONS(79), 1,
      anon_sym_local,
    ACTIONS(81), 1,
      anon_sym_function,
    ACTIONS(85), 1,
      anon_sym_for,
    ACTIONS(87), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_if,
    ACTIONS(93), 1,
      anon_sym_repeat,
    ACTIONS(95), 1,
      anon_sym_while,
    ACTIONS(97), 1,
      anon_sym_break,
    ACTIONS(99), 1,
      sym_continue_stmt,
    ACTIONS(101), 1,
      anon_sym_export,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(513), 1,
      anon_sym_end,
    STATE(231), 1,
      sym_comment,
    STATE(243), 1,
      aux_sym__block_repeat1,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    STATE(3388), 1,
      sym_ret_stmt,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [27428] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(756), 1,
      anon_sym_LBRACK,
    ACTIONS(758), 1,
      anon_sym_DOT,
    STATE(232), 1,
      sym_comment,
    STATE(328), 1,
      sym__key_named,
    STATE(334), 1,
      sym_key,
    ACTIONS(746), 18,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(744), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [27490] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(233), 1,
      sym_comment,
    ACTIONS(762), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(760), 24,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [27544] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(234), 1,
      sym_comment,
    ACTIONS(766), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(764), 24,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [27598] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(235), 1,
      sym_comment,
    ACTIONS(770), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(768), 24,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [27652] = 31,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(697), 1,
      sym_name,
    ACTIONS(700), 1,
      anon_sym_return,
    ACTIONS(735), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_AT,
    ACTIONS(741), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(772), 1,
      ts_builtin_sym_end,
    ACTIONS(774), 1,
      anon_sym_local,
    ACTIONS(777), 1,
      anon_sym_function,
    ACTIONS(780), 1,
      anon_sym_for,
    ACTIONS(783), 1,
      anon_sym_do,
    ACTIONS(786), 1,
      anon_sym_if,
    ACTIONS(789), 1,
      anon_sym_repeat,
    ACTIONS(792), 1,
      anon_sym_while,
    ACTIONS(795), 1,
      anon_sym_break,
    ACTIONS(798), 1,
      sym_continue_stmt,
    ACTIONS(801), 1,
      anon_sym_export,
    ACTIONS(804), 1,
      anon_sym_type,
    STATE(1305), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2283), 1,
      sym_statement,
    STATE(2539), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2785), 1,
      sym__prefixexp,
    STATE(2787), 1,
      aux_sym__attrlist,
    STATE(2833), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3426), 1,
      sym__varlist,
    STATE(236), 2,
      sym_comment,
      aux_sym__block_repeat1,
    STATE(2234), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [27760] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(237), 1,
      sym_comment,
    ACTIONS(809), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(807), 24,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [27814] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(238), 1,
      sym_comment,
    ACTIONS(813), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(811), 24,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [27868] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(239), 1,
      sym_comment,
    ACTIONS(817), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(815), 24,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [27922] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(240), 1,
      sym_comment,
    ACTIONS(821), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(819), 24,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [27976] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(241), 1,
      sym_comment,
    ACTIONS(825), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(823), 24,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [28030] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(242), 1,
      sym_comment,
    ACTIONS(829), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(827), 24,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [28084] = 30,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(697), 1,
      sym_name,
    ACTIONS(735), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_AT,
    ACTIONS(741), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(831), 1,
      anon_sym_local,
    ACTIONS(834), 1,
      anon_sym_function,
    ACTIONS(837), 1,
      anon_sym_for,
    ACTIONS(840), 1,
      anon_sym_do,
    ACTIONS(843), 1,
      anon_sym_if,
    ACTIONS(846), 1,
      anon_sym_repeat,
    ACTIONS(849), 1,
      anon_sym_while,
    ACTIONS(852), 1,
      anon_sym_break,
    ACTIONS(855), 1,
      sym_continue_stmt,
    ACTIONS(858), 1,
      anon_sym_export,
    ACTIONS(861), 1,
      anon_sym_type,
    STATE(1311), 1,
      sym_call_stmt,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2264), 1,
      sym_statement,
    STATE(2543), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2806), 1,
      sym__prefixexp,
    STATE(2816), 1,
      aux_sym__attrlist,
    STATE(2840), 1,
      sym__tbl_method,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3314), 1,
      sym__varlist,
    ACTIONS(700), 2,
      anon_sym_return,
      anon_sym_end,
    STATE(243), 2,
      sym_comment,
      aux_sym__block_repeat1,
    STATE(2255), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [28190] = 30,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(697), 1,
      sym_name,
    ACTIONS(735), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_AT,
    ACTIONS(741), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(864), 1,
      anon_sym_local,
    ACTIONS(867), 1,
      anon_sym_function,
    ACTIONS(870), 1,
      anon_sym_for,
    ACTIONS(873), 1,
      anon_sym_do,
    ACTIONS(876), 1,
      anon_sym_if,
    ACTIONS(879), 1,
      anon_sym_repeat,
    ACTIONS(882), 1,
      anon_sym_while,
    ACTIONS(885), 1,
      anon_sym_break,
    ACTIONS(888), 1,
      sym_continue_stmt,
    ACTIONS(891), 1,
      anon_sym_export,
    ACTIONS(894), 1,
      anon_sym_type,
    STATE(1375), 1,
      sym_call_stmt,
    STATE(2217), 1,
      sym_statement,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2534), 1,
      sym_var,
    STATE(2691), 1,
      sym_exp_wrap,
    STATE(2747), 1,
      sym__prefixexp,
    STATE(2751), 1,
      sym__tbl_method,
    STATE(2820), 1,
      aux_sym__attrlist,
    STATE(2882), 1,
      sym_attribute,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(3349), 1,
      sym__varlist,
    ACTIONS(700), 2,
      anon_sym_return,
      anon_sym_until,
    STATE(244), 2,
      sym_comment,
      aux_sym__block_repeat1,
    STATE(2216), 14,
      sym_local_fn_stmt,
      sym_fn_stmt,
      sym_for_in_stmt,
      sym_for_range_stmt,
      sym_if_stmt,
      sym_repeat_stmt,
      sym_while_stmt,
      sym_do_stmt,
      sym_break_stmt,
      sym_local_var_stmt,
      sym_var_stmt,
      sym_assign_stmt,
      sym_type_stmt,
      sym_type_fn_stmt,
  [28296] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(245), 1,
      sym_comment,
    ACTIONS(899), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(897), 24,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [28350] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(901), 1,
      anon_sym_LBRACK,
    ACTIONS(903), 1,
      anon_sym_DOT,
    STATE(246), 1,
      sym_comment,
    STATE(271), 1,
      sym_key,
    STATE(272), 1,
      sym__key_named,
    ACTIONS(691), 19,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(689), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [28412] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(901), 1,
      anon_sym_LBRACK,
    ACTIONS(903), 1,
      anon_sym_DOT,
    STATE(247), 1,
      sym_comment,
    STATE(272), 1,
      sym__key_named,
    STATE(273), 1,
      sym_key,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(750), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AT_LBRACK,
    ACTIONS(748), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [28476] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(901), 1,
      anon_sym_LBRACK,
    ACTIONS(903), 1,
      anon_sym_DOT,
    STATE(248), 1,
      sym_comment,
    STATE(272), 1,
      sym__key_named,
    STATE(275), 1,
      sym_key,
    ACTIONS(746), 19,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(744), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [28538] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(905), 1,
      anon_sym_LBRACK,
    ACTIONS(907), 1,
      anon_sym_DOT,
    STATE(249), 1,
      sym_comment,
    STATE(287), 1,
      sym_key,
    STATE(288), 1,
      sym__key_named,
    ACTIONS(691), 18,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(689), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [28600] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(905), 1,
      anon_sym_LBRACK,
    ACTIONS(907), 1,
      anon_sym_DOT,
    STATE(250), 1,
      sym_comment,
    STATE(288), 1,
      sym__key_named,
    STATE(296), 1,
      sym_key,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(750), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AT_LBRACK,
    ACTIONS(748), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [28664] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(905), 1,
      anon_sym_LBRACK,
    ACTIONS(907), 1,
      anon_sym_DOT,
    STATE(251), 1,
      sym_comment,
    STATE(288), 1,
      sym__key_named,
    STATE(300), 1,
      sym_key,
    ACTIONS(746), 18,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(744), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [28726] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(252), 1,
      sym_comment,
    ACTIONS(911), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(909), 24,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [28780] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(253), 1,
      sym_comment,
    ACTIONS(915), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(913), 24,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [28834] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(254), 1,
      sym_comment,
    ACTIONS(919), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(917), 24,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [28888] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(255), 1,
      sym_comment,
    ACTIONS(923), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(921), 24,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [28942] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(256), 1,
      sym_comment,
    ACTIONS(927), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(925), 24,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [28996] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(933), 1,
      anon_sym_LT,
    ACTIONS(935), 1,
      anon_sym_DOT,
    ACTIONS(937), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(257), 1,
      sym_comment,
    ACTIONS(931), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(929), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT_DOT,
      sym_name,
      anon_sym_AT,
  [29056] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(756), 1,
      anon_sym_LBRACK,
    ACTIONS(758), 1,
      anon_sym_DOT,
    STATE(258), 1,
      sym_comment,
    STATE(328), 1,
      sym__key_named,
    STATE(331), 1,
      sym_key,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(750), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AT_LBRACK,
    ACTIONS(748), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [29120] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(756), 1,
      anon_sym_LBRACK,
    ACTIONS(758), 1,
      anon_sym_DOT,
    STATE(259), 1,
      sym_comment,
    STATE(327), 1,
      sym_key,
    STATE(328), 1,
      sym__key_named,
    ACTIONS(691), 18,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(689), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [29182] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(260), 1,
      sym_comment,
    ACTIONS(941), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(939), 24,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [29236] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(933), 1,
      anon_sym_LT,
    ACTIONS(935), 1,
      anon_sym_DOT,
    STATE(261), 1,
      sym_comment,
    ACTIONS(931), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(929), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [29293] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(262), 1,
      sym_comment,
    ACTIONS(945), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(943), 23,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [29348] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(263), 1,
      sym_comment,
    ACTIONS(911), 20,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(909), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [29400] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(264), 1,
      sym_comment,
    ACTIONS(919), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(917), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [29452] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(265), 1,
      sym_comment,
    ACTIONS(915), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(913), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [29504] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(266), 1,
      sym_comment,
    ACTIONS(923), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(921), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [29556] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(267), 1,
      sym_comment,
    ACTIONS(919), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(917), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [29608] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(268), 1,
      sym_comment,
    ACTIONS(923), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(921), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [29660] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(269), 1,
      sym_comment,
    ACTIONS(927), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(925), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [29712] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(270), 1,
      sym_comment,
    ACTIONS(927), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(925), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [29764] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(271), 1,
      sym_comment,
    ACTIONS(809), 20,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(807), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [29816] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(272), 1,
      sym_comment,
    ACTIONS(813), 20,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(811), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [29868] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(273), 1,
      sym_comment,
    ACTIONS(817), 20,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(815), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [29920] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(949), 1,
      anon_sym_LT,
    ACTIONS(951), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(274), 1,
      sym_comment,
    ACTIONS(931), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(929), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT_DOT,
      sym_name,
      anon_sym_AT,
  [29978] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(275), 1,
      sym_comment,
    ACTIONS(821), 20,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(819), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [30030] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(276), 1,
      sym_comment,
    ACTIONS(825), 20,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(823), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [30082] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(277), 1,
      sym_comment,
    ACTIONS(825), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(823), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [30134] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(278), 1,
      sym_comment,
    ACTIONS(829), 20,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(827), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [30186] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(279), 1,
      sym_comment,
    ACTIONS(899), 20,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(897), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [30238] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(280), 1,
      sym_comment,
    ACTIONS(899), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(897), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [30290] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(281), 1,
      sym_comment,
    ACTIONS(829), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(827), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [30342] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(282), 1,
      sym_comment,
    ACTIONS(957), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(955), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [30394] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(283), 1,
      sym_comment,
    ACTIONS(961), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(959), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [30446] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(284), 1,
      sym_comment,
    ACTIONS(899), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(897), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [30498] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(963), 1,
      anon_sym_LT,
    ACTIONS(965), 1,
      anon_sym_DOT,
    ACTIONS(967), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(285), 1,
      sym_comment,
    ACTIONS(929), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT_DOT,
      sym_name,
      anon_sym_AT,
    ACTIONS(931), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [30556] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(286), 1,
      sym_comment,
    ACTIONS(770), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(768), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [30608] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(287), 1,
      sym_comment,
    ACTIONS(809), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(807), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [30660] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(288), 1,
      sym_comment,
    ACTIONS(813), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(811), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [30712] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(289), 1,
      sym_comment,
    ACTIONS(941), 20,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(939), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [30764] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(290), 1,
      sym_comment,
    ACTIONS(770), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(768), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [30816] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(291), 1,
      sym_comment,
    ACTIONS(762), 20,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(760), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [30868] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(292), 1,
      sym_comment,
    ACTIONS(915), 20,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(913), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [30920] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(973), 1,
      anon_sym_AMP,
    ACTIONS(975), 1,
      anon_sym_PIPE,
    ACTIONS(977), 1,
      anon_sym_QMARK,
    STATE(293), 1,
      sym_comment,
    ACTIONS(971), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(969), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [30978] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(294), 1,
      sym_comment,
    ACTIONS(981), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(979), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [31030] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(295), 1,
      sym_comment,
    ACTIONS(985), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(983), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [31082] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(296), 1,
      sym_comment,
    ACTIONS(817), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(815), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [31134] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(297), 1,
      sym_comment,
    ACTIONS(919), 20,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(917), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [31186] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(298), 1,
      sym_comment,
    ACTIONS(989), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(987), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [31238] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(299), 1,
      sym_comment,
    ACTIONS(993), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(991), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [31290] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(300), 1,
      sym_comment,
    ACTIONS(821), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(819), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [31342] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(301), 1,
      sym_comment,
    ACTIONS(766), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(764), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [31394] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(302), 1,
      sym_comment,
    ACTIONS(997), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(995), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [31446] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(303), 1,
      sym_comment,
    ACTIONS(825), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(823), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [31498] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(973), 1,
      anon_sym_AMP,
    ACTIONS(975), 1,
      anon_sym_PIPE,
    ACTIONS(977), 1,
      anon_sym_QMARK,
    STATE(304), 1,
      sym_comment,
    ACTIONS(1001), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(999), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [31556] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(305), 1,
      sym_comment,
    ACTIONS(1005), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1003), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [31608] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1007), 1,
      anon_sym_LT,
    ACTIONS(1009), 1,
      anon_sym_DOT,
    ACTIONS(1011), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(306), 1,
      sym_comment,
    ACTIONS(931), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(929), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT_DOT,
      sym_name,
      anon_sym_AT,
  [31666] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(973), 1,
      anon_sym_AMP,
    ACTIONS(975), 1,
      anon_sym_PIPE,
    ACTIONS(977), 1,
      anon_sym_QMARK,
    STATE(307), 1,
      sym_comment,
    ACTIONS(1015), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1013), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [31724] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(308), 1,
      sym_comment,
    ACTIONS(923), 20,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(921), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [31776] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(309), 1,
      sym_comment,
    ACTIONS(829), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(827), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [31828] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(310), 1,
      sym_comment,
    ACTIONS(1015), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1013), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [31880] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(311), 1,
      sym_comment,
    ACTIONS(1019), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1017), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [31932] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(312), 1,
      sym_comment,
    ACTIONS(927), 20,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(925), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [31984] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(313), 1,
      sym_comment,
    ACTIONS(1023), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1021), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [32036] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(973), 1,
      anon_sym_AMP,
    ACTIONS(975), 1,
      anon_sym_PIPE,
    ACTIONS(977), 1,
      anon_sym_QMARK,
    STATE(314), 1,
      sym_comment,
    ACTIONS(1027), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1025), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [32094] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(315), 1,
      sym_comment,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(750), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AT_LBRACK,
    ACTIONS(748), 23,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [32148] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(316), 1,
      sym_comment,
    ACTIONS(1031), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1029), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [32200] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1037), 1,
      anon_sym_LT,
    STATE(317), 1,
      sym_comment,
    ACTIONS(1035), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1033), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [32254] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(977), 1,
      anon_sym_QMARK,
    STATE(318), 1,
      sym_comment,
    ACTIONS(1041), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT_LBRACK,
    ACTIONS(1039), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [32308] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(973), 1,
      anon_sym_AMP,
    ACTIONS(977), 1,
      anon_sym_QMARK,
    STATE(319), 1,
      sym_comment,
    ACTIONS(1041), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_AT_LBRACK,
    ACTIONS(1039), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [32364] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(320), 1,
      sym_comment,
    ACTIONS(911), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(909), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [32416] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(973), 1,
      anon_sym_AMP,
    ACTIONS(975), 1,
      anon_sym_PIPE,
    ACTIONS(977), 1,
      anon_sym_QMARK,
    STATE(321), 1,
      sym_comment,
    ACTIONS(1045), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1043), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [32474] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(322), 1,
      sym_comment,
    ACTIONS(1045), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1043), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [32526] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(323), 1,
      sym_comment,
    ACTIONS(1049), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1047), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [32578] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(324), 1,
      sym_comment,
    ACTIONS(1053), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1051), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [32630] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(325), 1,
      sym_comment,
    ACTIONS(1057), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1055), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [32682] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(326), 1,
      sym_comment,
    ACTIONS(1061), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1059), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [32734] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(327), 1,
      sym_comment,
    ACTIONS(809), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(807), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [32786] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(328), 1,
      sym_comment,
    ACTIONS(813), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(811), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [32838] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(329), 1,
      sym_comment,
    ACTIONS(766), 20,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(764), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [32890] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(330), 1,
      sym_comment,
    ACTIONS(770), 20,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(768), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [32942] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(331), 1,
      sym_comment,
    ACTIONS(817), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(815), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [32994] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(332), 1,
      sym_comment,
    ACTIONS(941), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(939), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [33046] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(333), 1,
      sym_comment,
    ACTIONS(762), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(760), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [33098] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(334), 1,
      sym_comment,
    ACTIONS(821), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(819), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [33150] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(335), 1,
      sym_comment,
    ACTIONS(941), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(939), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [33202] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(336), 1,
      sym_comment,
    ACTIONS(762), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(760), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [33254] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(337), 1,
      sym_comment,
    ACTIONS(766), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(764), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [33306] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(338), 1,
      sym_comment,
    ACTIONS(770), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(768), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [33358] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(339), 1,
      sym_comment,
    ACTIONS(911), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(909), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [33410] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(340), 1,
      sym_comment,
    ACTIONS(915), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(913), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [33462] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(341), 1,
      sym_comment,
    ACTIONS(766), 19,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(764), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      anon_sym_DOT,
      sym_name,
      anon_sym_AT,
  [33514] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(342), 1,
      sym_comment,
    ACTIONS(1065), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1063), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [33566] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1071), 1,
      anon_sym_COLON,
    STATE(343), 1,
      sym_comment,
    STATE(2962), 1,
      sym__method_name,
    ACTIONS(1069), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1067), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [33621] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(344), 1,
      sym_comment,
    ACTIONS(945), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(943), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [33674] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(345), 1,
      sym_comment,
    ACTIONS(945), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(943), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [33727] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(963), 1,
      anon_sym_LT,
    ACTIONS(965), 1,
      anon_sym_DOT,
    STATE(346), 1,
      sym_comment,
    ACTIONS(929), 18,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(931), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [33782] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(347), 1,
      sym_comment,
    ACTIONS(945), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(943), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [33835] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1007), 1,
      anon_sym_LT,
    ACTIONS(1009), 1,
      anon_sym_DOT,
    STATE(348), 1,
      sym_comment,
    ACTIONS(929), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(931), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [33890] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(949), 1,
      anon_sym_LT,
    ACTIONS(951), 1,
      anon_sym_DOT,
    STATE(349), 1,
      sym_comment,
    ACTIONS(929), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(931), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [33945] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(350), 1,
      sym_comment,
    ACTIONS(1023), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1021), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [33995] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1073), 1,
      anon_sym_LT,
    STATE(351), 1,
      sym_comment,
    ACTIONS(1033), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(1035), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [34047] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(352), 1,
      sym_comment,
    ACTIONS(1003), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(1005), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [34097] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(353), 1,
      sym_comment,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(750), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AT_LBRACK,
    ACTIONS(748), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [34149] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1075), 1,
      anon_sym_QMARK,
    STATE(354), 1,
      sym_comment,
    ACTIONS(1041), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT_LBRACK,
    ACTIONS(1039), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [34201] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1075), 1,
      anon_sym_QMARK,
    ACTIONS(1077), 1,
      anon_sym_AMP,
    STATE(355), 1,
      sym_comment,
    ACTIONS(1041), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_AT_LBRACK,
    ACTIONS(1039), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [34255] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(356), 1,
      sym_comment,
    ACTIONS(961), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(959), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [34305] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1075), 1,
      anon_sym_QMARK,
    ACTIONS(1077), 1,
      anon_sym_AMP,
    ACTIONS(1079), 1,
      anon_sym_PIPE,
    STATE(357), 1,
      sym_comment,
    ACTIONS(1045), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1043), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [34361] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(358), 1,
      sym_comment,
    ACTIONS(1045), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1043), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [34411] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1081), 1,
      anon_sym_AMP,
    ACTIONS(1083), 1,
      anon_sym_PIPE,
    ACTIONS(1085), 1,
      anon_sym_QMARK,
    STATE(359), 1,
      sym_comment,
    ACTIONS(1015), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1013), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [34467] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(360), 1,
      sym_comment,
    ACTIONS(1013), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(1015), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [34517] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(361), 1,
      sym_comment,
    ACTIONS(1049), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1047), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [34567] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(362), 1,
      sym_comment,
    ACTIONS(1053), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1051), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [34617] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(363), 1,
      sym_comment,
    ACTIONS(1057), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1055), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [34667] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(364), 1,
      sym_comment,
    ACTIONS(1017), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(1019), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [34717] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(365), 1,
      sym_comment,
    ACTIONS(1021), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(1023), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [34767] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(366), 1,
      sym_comment,
    ACTIONS(1061), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1059), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [34817] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1081), 1,
      anon_sym_AMP,
    ACTIONS(1083), 1,
      anon_sym_PIPE,
    ACTIONS(1085), 1,
      anon_sym_QMARK,
    STATE(367), 1,
      sym_comment,
    ACTIONS(1027), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1025), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [34873] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1091), 1,
      anon_sym_COMMA,
    ACTIONS(1095), 1,
      anon_sym_or,
    ACTIONS(1097), 1,
      anon_sym_and,
    ACTIONS(1105), 1,
      anon_sym_SLASH,
    ACTIONS(1107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1109), 1,
      anon_sym_CARET,
    ACTIONS(1111), 1,
      anon_sym_COLON_COLON,
    STATE(368), 1,
      sym_comment,
    STATE(1747), 1,
      aux_sym__explist_repeat1,
    ACTIONS(1093), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1089), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1103), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1099), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1087), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [34947] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1113), 1,
      anon_sym_AMP,
    ACTIONS(1115), 1,
      anon_sym_PIPE,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    STATE(369), 1,
      sym_comment,
    ACTIONS(971), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(969), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35003] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(370), 1,
      sym_comment,
    ACTIONS(981), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(979), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35053] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(371), 1,
      sym_comment,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(750), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AT_LBRACK,
    ACTIONS(748), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35105] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(372), 1,
      sym_comment,
    ACTIONS(985), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(983), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35155] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(373), 1,
      sym_comment,
    ACTIONS(1029), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(1031), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [35205] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(374), 1,
      sym_comment,
    ACTIONS(989), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(987), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35255] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(375), 1,
      sym_comment,
    ACTIONS(993), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(991), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35305] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(376), 1,
      sym_comment,
    ACTIONS(1065), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1063), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35355] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(377), 1,
      sym_comment,
    ACTIONS(997), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(995), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35405] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(378), 1,
      sym_comment,
    ACTIONS(766), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(764), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35455] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1113), 1,
      anon_sym_AMP,
    ACTIONS(1115), 1,
      anon_sym_PIPE,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    STATE(379), 1,
      sym_comment,
    ACTIONS(1001), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(999), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35511] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(380), 1,
      sym_comment,
    ACTIONS(1005), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1003), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35561] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(381), 1,
      sym_comment,
    ACTIONS(770), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(768), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35611] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1119), 1,
      anon_sym_LT,
    STATE(382), 1,
      sym_comment,
    ACTIONS(1033), 18,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(1035), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [35663] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1113), 1,
      anon_sym_AMP,
    ACTIONS(1115), 1,
      anon_sym_PIPE,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    STATE(383), 1,
      sym_comment,
    ACTIONS(1015), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1013), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35719] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(384), 1,
      sym_comment,
    ACTIONS(957), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(955), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35769] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(385), 1,
      sym_comment,
    ACTIONS(1015), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1013), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35819] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(386), 1,
      sym_comment,
    ACTIONS(1019), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1017), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35869] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(387), 1,
      sym_comment,
    ACTIONS(1023), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1021), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35919] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1113), 1,
      anon_sym_AMP,
    ACTIONS(1115), 1,
      anon_sym_PIPE,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    STATE(388), 1,
      sym_comment,
    ACTIONS(1027), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1025), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [35975] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(389), 1,
      sym_comment,
    ACTIONS(1031), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1029), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [36025] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1085), 1,
      anon_sym_QMARK,
    STATE(390), 1,
      sym_comment,
    ACTIONS(1039), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(1041), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT_LBRACK,
  [36077] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1121), 1,
      anon_sym_LT,
    STATE(391), 1,
      sym_comment,
    ACTIONS(1033), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(1035), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [36129] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    STATE(392), 1,
      sym_comment,
    ACTIONS(1041), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT_LBRACK,
    ACTIONS(1039), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [36181] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1123), 1,
      sym_name,
    ACTIONS(1125), 1,
      anon_sym_SEMI,
    ACTIONS(1127), 1,
      anon_sym_function,
    ACTIONS(1131), 1,
      anon_sym_if,
    ACTIONS(1135), 1,
      anon_sym_not,
    ACTIONS(1137), 1,
      anon_sym_LBRACE,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1143), 1,
      sym_number,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1151), 1,
      sym_interp_start,
    STATE(393), 1,
      sym_comment,
    STATE(1101), 1,
      sym__tbl_seq,
    STATE(1224), 1,
      sym_var,
    STATE(1431), 1,
      sym_prefixexp,
    STATE(1530), 1,
      sym_exp,
    STATE(2793), 1,
      sym__prefixexp,
    STATE(2794), 1,
      sym__tbl_method,
    STATE(2901), 1,
      sym__explist,
    ACTIONS(1133), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1100), 2,
      sym_exp_wrap,
      sym_call_stmt,
    ACTIONS(1129), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
    STATE(1783), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [36275] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1113), 1,
      anon_sym_AMP,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    STATE(394), 1,
      sym_comment,
    ACTIONS(1041), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_AT_LBRACK,
    ACTIONS(1039), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [36329] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1113), 1,
      anon_sym_AMP,
    ACTIONS(1115), 1,
      anon_sym_PIPE,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    STATE(395), 1,
      sym_comment,
    ACTIONS(1045), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1043), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [36385] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(396), 1,
      sym_comment,
    ACTIONS(1045), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1043), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [36435] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1081), 1,
      anon_sym_AMP,
    ACTIONS(1085), 1,
      anon_sym_QMARK,
    STATE(397), 1,
      sym_comment,
    ACTIONS(1041), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_AT_LBRACK,
    ACTIONS(1039), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [36489] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(398), 1,
      sym_comment,
    ACTIONS(1031), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1029), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [36539] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(399), 1,
      sym_comment,
    ACTIONS(1053), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1051), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [36589] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(400), 1,
      sym_comment,
    ACTIONS(1057), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1055), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [36639] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(401), 1,
      sym_comment,
    ACTIONS(1061), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1059), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [36689] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(402), 1,
      sym_comment,
    ACTIONS(955), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(957), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [36739] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1081), 1,
      anon_sym_AMP,
    ACTIONS(1083), 1,
      anon_sym_PIPE,
    ACTIONS(1085), 1,
      anon_sym_QMARK,
    STATE(403), 1,
      sym_comment,
    ACTIONS(1045), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1043), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [36795] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(404), 1,
      sym_comment,
    ACTIONS(1043), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(1045), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [36845] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(405), 1,
      sym_comment,
    ACTIONS(959), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(961), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [36895] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1167), 1,
      anon_sym_RBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    STATE(406), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3015), 1,
      sym_field,
    ACTIONS(1155), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [36991] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(407), 1,
      sym_comment,
    ACTIONS(1047), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(1049), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [37041] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(408), 1,
      sym_comment,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(750), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AT_LBRACK,
    ACTIONS(748), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_COLON,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [37093] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(409), 1,
      sym_comment,
    ACTIONS(1051), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(1053), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [37143] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(410), 1,
      sym_comment,
    ACTIONS(1055), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(1057), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [37193] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1075), 1,
      anon_sym_QMARK,
    ACTIONS(1077), 1,
      anon_sym_AMP,
    ACTIONS(1079), 1,
      anon_sym_PIPE,
    STATE(411), 1,
      sym_comment,
    ACTIONS(971), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(969), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [37249] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(412), 1,
      sym_comment,
    ACTIONS(981), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(979), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [37299] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(413), 1,
      sym_comment,
    ACTIONS(1059), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(1061), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [37349] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1081), 1,
      anon_sym_AMP,
    ACTIONS(1083), 1,
      anon_sym_PIPE,
    ACTIONS(1085), 1,
      anon_sym_QMARK,
    STATE(414), 1,
      sym_comment,
    ACTIONS(971), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(969), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [37405] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(415), 1,
      sym_comment,
    ACTIONS(985), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(983), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [37455] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(416), 1,
      sym_comment,
    ACTIONS(957), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(955), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [37505] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(417), 1,
      sym_comment,
    ACTIONS(979), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(981), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [37555] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(418), 1,
      sym_comment,
    ACTIONS(983), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(985), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [37605] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(419), 1,
      sym_comment,
    ACTIONS(961), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(959), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [37655] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(420), 1,
      sym_comment,
    ACTIONS(989), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(987), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [37705] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(421), 1,
      sym_comment,
    ACTIONS(993), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(991), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [37755] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(422), 1,
      sym_comment,
    ACTIONS(766), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(764), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [37805] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(423), 1,
      sym_comment,
    ACTIONS(770), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(768), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [37855] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(424), 1,
      sym_comment,
    ACTIONS(987), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(989), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [37905] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(425), 1,
      sym_comment,
    ACTIONS(1065), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1063), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [37955] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(426), 1,
      sym_comment,
    ACTIONS(997), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(995), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [38005] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1075), 1,
      anon_sym_QMARK,
    ACTIONS(1077), 1,
      anon_sym_AMP,
    ACTIONS(1079), 1,
      anon_sym_PIPE,
    STATE(427), 1,
      sym_comment,
    ACTIONS(1001), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(999), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [38061] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(428), 1,
      sym_comment,
    ACTIONS(1005), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1003), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [38111] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(429), 1,
      sym_comment,
    ACTIONS(991), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(993), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [38161] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(430), 1,
      sym_comment,
    ACTIONS(1063), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(1065), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [38211] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(431), 1,
      sym_comment,
    ACTIONS(995), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(997), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [38261] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1075), 1,
      anon_sym_QMARK,
    ACTIONS(1077), 1,
      anon_sym_AMP,
    ACTIONS(1079), 1,
      anon_sym_PIPE,
    STATE(432), 1,
      sym_comment,
    ACTIONS(1015), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1013), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [38317] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1187), 1,
      anon_sym_RBRACE,
    STATE(433), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3015), 1,
      sym_field,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1185), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [38413] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(434), 1,
      sym_comment,
    ACTIONS(1015), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1013), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [38463] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(435), 1,
      sym_comment,
    ACTIONS(1019), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1017), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [38513] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1081), 1,
      anon_sym_AMP,
    ACTIONS(1083), 1,
      anon_sym_PIPE,
    ACTIONS(1085), 1,
      anon_sym_QMARK,
    STATE(436), 1,
      sym_comment,
    ACTIONS(1001), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(999), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [38569] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(437), 1,
      sym_comment,
    ACTIONS(768), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(770), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [38619] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1075), 1,
      anon_sym_QMARK,
    ACTIONS(1077), 1,
      anon_sym_AMP,
    ACTIONS(1079), 1,
      anon_sym_PIPE,
    STATE(438), 1,
      sym_comment,
    ACTIONS(1027), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1025), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [38675] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(439), 1,
      sym_comment,
    ACTIONS(764), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
    ACTIONS(766), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
  [38725] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(440), 1,
      sym_comment,
    ACTIONS(1049), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1047), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [38775] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1189), 1,
      anon_sym_RBRACE,
    STATE(441), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3590), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [38870] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1095), 1,
      anon_sym_or,
    ACTIONS(1097), 1,
      anon_sym_and,
    ACTIONS(1105), 1,
      anon_sym_SLASH,
    ACTIONS(1107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1109), 1,
      anon_sym_CARET,
    ACTIONS(1111), 1,
      anon_sym_COLON_COLON,
    STATE(442), 1,
      sym_comment,
    ACTIONS(1093), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1103), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1099), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1193), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1191), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [38939] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1095), 1,
      anon_sym_or,
    ACTIONS(1097), 1,
      anon_sym_and,
    ACTIONS(1105), 1,
      anon_sym_SLASH,
    ACTIONS(1107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1109), 1,
      anon_sym_CARET,
    ACTIONS(1111), 1,
      anon_sym_COLON_COLON,
    STATE(443), 1,
      sym_comment,
    ACTIONS(1093), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1103), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1099), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1197), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1195), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [39008] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1199), 1,
      anon_sym_RBRACE,
    STATE(444), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3543), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [39103] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(445), 1,
      sym_comment,
    ACTIONS(1203), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1201), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [39152] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1095), 1,
      anon_sym_or,
    ACTIONS(1097), 1,
      anon_sym_and,
    ACTIONS(1105), 1,
      anon_sym_SLASH,
    ACTIONS(1107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1109), 1,
      anon_sym_CARET,
    ACTIONS(1111), 1,
      anon_sym_COLON_COLON,
    STATE(446), 1,
      sym_comment,
    ACTIONS(1093), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1103), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1099), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1205), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [39221] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1209), 1,
      anon_sym_RBRACE,
    STATE(447), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3553), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [39316] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1211), 1,
      anon_sym_RBRACE,
    STATE(448), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3405), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [39411] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1213), 1,
      anon_sym_RBRACE,
    STATE(449), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3153), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [39506] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1215), 1,
      anon_sym_RBRACE,
    STATE(450), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3292), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [39601] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1217), 1,
      anon_sym_RBRACE,
    STATE(451), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3422), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [39696] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1071), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_comment,
    STATE(2962), 1,
      sym__method_name,
    ACTIONS(1069), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1067), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [39749] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1219), 1,
      anon_sym_RBRACE,
    STATE(453), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3544), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [39844] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(454), 1,
      sym_comment,
    ACTIONS(1223), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1221), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [39893] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(455), 1,
      sym_comment,
    ACTIONS(1227), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1225), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [39942] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(456), 1,
      sym_comment,
    ACTIONS(1231), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1229), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [39991] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(457), 1,
      sym_comment,
    ACTIONS(1235), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1233), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40040] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(458), 1,
      sym_comment,
    ACTIONS(1239), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1237), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40089] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(459), 1,
      sym_comment,
    ACTIONS(1243), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1241), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40138] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(460), 1,
      sym_comment,
    ACTIONS(1247), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1245), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40187] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(461), 1,
      sym_comment,
    ACTIONS(1251), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1249), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40236] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(462), 1,
      sym_comment,
    ACTIONS(1255), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1253), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40285] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(463), 1,
      sym_comment,
    ACTIONS(1259), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1257), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40334] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1261), 1,
      anon_sym_RBRACE,
    STATE(464), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3642), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [40429] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(465), 1,
      sym_comment,
    ACTIONS(1265), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1263), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40478] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(466), 1,
      sym_comment,
    ACTIONS(1269), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1267), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40527] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(467), 1,
      sym_comment,
    ACTIONS(1273), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1271), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40576] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(468), 1,
      sym_comment,
    ACTIONS(1277), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1275), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40625] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(469), 1,
      sym_comment,
    ACTIONS(1281), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1279), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40674] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(470), 1,
      sym_comment,
    ACTIONS(1285), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1283), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40723] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(471), 1,
      sym_comment,
    ACTIONS(1289), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1287), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40772] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(472), 1,
      sym_comment,
    ACTIONS(1293), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1291), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40821] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(473), 1,
      sym_comment,
    ACTIONS(1297), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1295), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40870] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(474), 1,
      sym_comment,
    ACTIONS(1301), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1299), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40919] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(475), 1,
      sym_comment,
    ACTIONS(1305), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1303), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [40968] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(476), 1,
      sym_comment,
    ACTIONS(1309), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1307), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [41017] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1311), 1,
      anon_sym_RBRACE,
    STATE(477), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3298), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [41112] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(478), 1,
      sym_comment,
    ACTIONS(1315), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1313), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [41161] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(479), 1,
      sym_comment,
    ACTIONS(1319), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1317), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [41210] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1321), 1,
      anon_sym_RBRACE,
    STATE(480), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3224), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [41305] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1323), 1,
      anon_sym_RBRACE,
    STATE(481), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3297), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [41400] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1071), 1,
      anon_sym_COLON,
    STATE(482), 1,
      sym_comment,
    STATE(2962), 1,
      sym__method_name,
    ACTIONS(1069), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1067), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [41453] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1071), 1,
      anon_sym_COLON,
    STATE(483), 1,
      sym_comment,
    STATE(2962), 1,
      sym__method_name,
    ACTIONS(1069), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1067), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [41506] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1325), 1,
      anon_sym_RBRACE,
    STATE(484), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3429), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [41601] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1327), 1,
      anon_sym_RBRACE,
    STATE(485), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3558), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [41696] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(486), 1,
      sym_comment,
    ACTIONS(1069), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1067), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [41745] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1329), 1,
      anon_sym_RBRACE,
    STATE(487), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3135), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [41840] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(488), 1,
      sym_comment,
    ACTIONS(941), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(939), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [41889] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(489), 1,
      sym_comment,
    ACTIONS(762), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(760), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [41938] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(490), 1,
      sym_comment,
    ACTIONS(1333), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1331), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [41987] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(491), 1,
      sym_comment,
    ACTIONS(1337), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1335), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [42036] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1109), 1,
      anon_sym_CARET,
    ACTIONS(1111), 1,
      anon_sym_COLON_COLON,
    STATE(492), 1,
      sym_comment,
    ACTIONS(1341), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1339), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [42089] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(493), 1,
      sym_comment,
    ACTIONS(1345), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1343), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [42138] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1105), 1,
      anon_sym_SLASH,
    ACTIONS(1107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1109), 1,
      anon_sym_CARET,
    ACTIONS(1111), 1,
      anon_sym_COLON_COLON,
    STATE(494), 1,
      sym_comment,
    ACTIONS(1101), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1103), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_name,
      anon_sym_AT,
  [42199] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1351), 1,
      anon_sym_RBRACE,
    STATE(495), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3181), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [42294] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1097), 1,
      anon_sym_and,
    ACTIONS(1105), 1,
      anon_sym_SLASH,
    ACTIONS(1107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1109), 1,
      anon_sym_CARET,
    ACTIONS(1111), 1,
      anon_sym_COLON_COLON,
    STATE(496), 1,
      sym_comment,
    ACTIONS(1093), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1103), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1099), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1349), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 18,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_or,
      sym_name,
      anon_sym_AT,
  [42361] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1105), 1,
      anon_sym_SLASH,
    ACTIONS(1107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1109), 1,
      anon_sym_CARET,
    ACTIONS(1111), 1,
      anon_sym_COLON_COLON,
    STATE(497), 1,
      sym_comment,
    ACTIONS(1093), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1103), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1099), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1349), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_or,
      anon_sym_and,
      sym_name,
      anon_sym_AT,
  [42426] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1105), 1,
      anon_sym_SLASH,
    ACTIONS(1109), 1,
      anon_sym_CARET,
    ACTIONS(1111), 1,
      anon_sym_COLON_COLON,
    STATE(498), 1,
      sym_comment,
    ACTIONS(1103), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_name,
      anon_sym_AT,
  [42483] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1109), 1,
      anon_sym_CARET,
    ACTIONS(1111), 1,
      anon_sym_COLON_COLON,
    STATE(499), 1,
      sym_comment,
    ACTIONS(1349), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [42536] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1105), 1,
      anon_sym_SLASH,
    ACTIONS(1107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1109), 1,
      anon_sym_CARET,
    ACTIONS(1111), 1,
      anon_sym_COLON_COLON,
    STATE(500), 1,
      sym_comment,
    ACTIONS(1101), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1103), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 21,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_name,
      anon_sym_AT,
  [42597] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1109), 1,
      anon_sym_CARET,
    ACTIONS(1111), 1,
      anon_sym_COLON_COLON,
    STATE(501), 1,
      sym_comment,
    ACTIONS(1349), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [42650] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(502), 1,
      sym_comment,
    ACTIONS(1355), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1353), 22,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [42699] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1357), 1,
      anon_sym_RBRACE,
    STATE(503), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3227), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [42794] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1359), 1,
      anon_sym_RBRACE,
    STATE(504), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3243), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [42889] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1361), 1,
      anon_sym_RBRACE,
    STATE(505), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3257), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [42984] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1363), 1,
      anon_sym_RBRACE,
    STATE(506), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3261), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [43079] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1365), 1,
      anon_sym_RBRACE,
    STATE(507), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3265), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [43174] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1367), 1,
      anon_sym_RBRACE,
    STATE(508), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3269), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [43269] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1369), 1,
      anon_sym_RBRACE,
    STATE(509), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3273), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [43364] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1371), 1,
      anon_sym_RBRACE,
    STATE(510), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3277), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [43459] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1373), 1,
      anon_sym_RBRACE,
    STATE(511), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3281), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [43554] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1375), 1,
      anon_sym_RBRACE,
    STATE(512), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3285), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [43649] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1377), 1,
      anon_sym_RBRACE,
    STATE(513), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3289), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [43744] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1379), 1,
      anon_sym_RBRACE,
    STATE(514), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3293), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [43839] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1381), 1,
      anon_sym_RBRACE,
    STATE(515), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(2889), 1,
      sym_field,
    STATE(3497), 1,
      sym__fieldlist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [43934] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1391), 1,
      anon_sym_RPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    STATE(516), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3038), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3238), 1,
      sym_typelist,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [44028] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1407), 1,
      anon_sym_RBRACE,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    STATE(517), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3304), 1,
      sym__tbtype_content,
    STATE(3668), 1,
      sym__outertype,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [44120] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1413), 1,
      anon_sym_RPAREN,
    STATE(518), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(2942), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3175), 1,
      sym_typelist,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [44214] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1415), 1,
      anon_sym_RPAREN,
    STATE(519), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(2990), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    STATE(3330), 1,
      sym_typelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [44308] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1129), 1,
      anon_sym_end,
    ACTIONS(1417), 1,
      sym_name,
    ACTIONS(1419), 1,
      anon_sym_SEMI,
    ACTIONS(1421), 1,
      anon_sym_function,
    ACTIONS(1423), 1,
      anon_sym_if,
    ACTIONS(1427), 1,
      anon_sym_not,
    ACTIONS(1429), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LPAREN,
    ACTIONS(1433), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(1443), 1,
      sym_interp_start,
    STATE(520), 1,
      sym_comment,
    STATE(1163), 1,
      sym__tbl_seq,
    STATE(1423), 1,
      sym_var,
    STATE(1787), 1,
      sym_prefixexp,
    STATE(1908), 1,
      sym_exp,
    STATE(2775), 1,
      sym__prefixexp,
    STATE(2779), 1,
      sym__tbl_method,
    STATE(3064), 1,
      sym__explist,
    ACTIONS(1425), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2048), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [44400] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1445), 1,
      anon_sym_COMMA,
    ACTIONS(1449), 1,
      anon_sym_or,
    ACTIONS(1451), 1,
      anon_sym_and,
    ACTIONS(1459), 1,
      anon_sym_SLASH,
    ACTIONS(1461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1463), 1,
      anon_sym_CARET,
    ACTIONS(1465), 1,
      anon_sym_COLON_COLON,
    STATE(521), 1,
      sym_comment,
    STATE(2039), 1,
      aux_sym__explist_repeat1,
    ACTIONS(1447), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1455), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1089), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1457), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1453), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1087), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [44472] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1467), 1,
      anon_sym_COMMA,
    ACTIONS(1471), 1,
      anon_sym_or,
    ACTIONS(1473), 1,
      anon_sym_and,
    ACTIONS(1481), 1,
      anon_sym_SLASH,
    ACTIONS(1483), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1485), 1,
      anon_sym_CARET,
    ACTIONS(1487), 1,
      anon_sym_COLON_COLON,
    STATE(522), 1,
      sym_comment,
    STATE(1936), 1,
      aux_sym__explist_repeat1,
    ACTIONS(1469), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1089), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1475), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1087), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [44544] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1095), 1,
      anon_sym_or,
    ACTIONS(1097), 1,
      anon_sym_and,
    ACTIONS(1105), 1,
      anon_sym_SLASH,
    ACTIONS(1107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1109), 1,
      anon_sym_CARET,
    ACTIONS(1111), 1,
      anon_sym_COLON_COLON,
    STATE(523), 1,
      sym_comment,
    ACTIONS(1093), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1103), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1491), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1099), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1489), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [44612] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1095), 1,
      anon_sym_or,
    ACTIONS(1097), 1,
      anon_sym_and,
    ACTIONS(1105), 1,
      anon_sym_SLASH,
    ACTIONS(1107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1109), 1,
      anon_sym_CARET,
    ACTIONS(1111), 1,
      anon_sym_COLON_COLON,
    STATE(524), 1,
      sym_comment,
    ACTIONS(1093), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1103), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1495), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1099), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1493), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [44680] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1095), 1,
      anon_sym_or,
    ACTIONS(1097), 1,
      anon_sym_and,
    ACTIONS(1105), 1,
      anon_sym_SLASH,
    ACTIONS(1107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1109), 1,
      anon_sym_CARET,
    ACTIONS(1111), 1,
      anon_sym_COLON_COLON,
    STATE(525), 1,
      sym_comment,
    ACTIONS(1093), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1103), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1499), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1099), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1497), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [44748] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1501), 1,
      anon_sym_RBRACE,
    STATE(526), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3440), 1,
      sym__tbtype_content,
    STATE(3668), 1,
      sym__outertype,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [44840] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1503), 1,
      anon_sym_RPAREN,
    STATE(527), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(2923), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    STATE(3466), 1,
      sym_typelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [44934] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1505), 1,
      anon_sym_RBRACE,
    STATE(528), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3556), 1,
      sym__tbtype_content,
    STATE(3668), 1,
      sym__outertype,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [45026] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1507), 1,
      anon_sym_RPAREN,
    STATE(529), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(2984), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    STATE(3570), 1,
      sym_typelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [45120] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1509), 1,
      anon_sym_RBRACE,
    STATE(530), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3183), 1,
      sym__tbtype_content,
    STATE(3668), 1,
      sym__outertype,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [45212] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1511), 1,
      anon_sym_RPAREN,
    STATE(531), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(2919), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3276), 1,
      sym_typelist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [45306] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1513), 1,
      anon_sym_RBRACE,
    STATE(532), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3668), 1,
      sym__outertype,
    STATE(3678), 1,
      sym__tbtype_content,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [45398] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1515), 1,
      anon_sym_RPAREN,
    STATE(533), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(2922), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    STATE(3708), 1,
      sym_typelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [45492] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1517), 1,
      anon_sym_RBRACE,
    STATE(534), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3668), 1,
      sym__outertype,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    STATE(3709), 1,
      sym__tbtype_content,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [45584] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1519), 1,
      anon_sym_RPAREN,
    STATE(535), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(2932), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3205), 1,
      sym_typelist,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [45678] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1521), 1,
      anon_sym_RPAREN,
    STATE(536), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3017), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3220), 1,
      sym_typelist,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [45772] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1523), 1,
      anon_sym_RPAREN,
    STATE(537), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(2943), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    STATE(3568), 1,
      sym_typelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [45866] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1525), 1,
      anon_sym_RBRACE,
    STATE(538), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3267), 1,
      sym__tbtype_content,
    STATE(3668), 1,
      sym__outertype,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [45958] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1527), 1,
      anon_sym_RPAREN,
    STATE(539), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(2959), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    STATE(3303), 1,
      sym_typelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [46052] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1129), 1,
      anon_sym_until,
    ACTIONS(1529), 1,
      sym_name,
    ACTIONS(1531), 1,
      anon_sym_SEMI,
    ACTIONS(1533), 1,
      anon_sym_function,
    ACTIONS(1535), 1,
      anon_sym_if,
    ACTIONS(1539), 1,
      anon_sym_not,
    ACTIONS(1541), 1,
      anon_sym_LBRACE,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1547), 1,
      sym_number,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1555), 1,
      sym_interp_start,
    STATE(540), 1,
      sym_comment,
    STATE(1152), 1,
      sym__tbl_seq,
    STATE(1436), 1,
      sym_var,
    STATE(1815), 1,
      sym_prefixexp,
    STATE(1853), 1,
      sym_exp,
    STATE(2776), 1,
      sym__prefixexp,
    STATE(2778), 1,
      sym__tbl_method,
    STATE(3098), 1,
      sym__explist,
    ACTIONS(1537), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1170), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2010), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [46144] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1557), 1,
      anon_sym_COMMA,
    ACTIONS(1561), 1,
      anon_sym_or,
    ACTIONS(1563), 1,
      anon_sym_and,
    ACTIONS(1571), 1,
      anon_sym_SLASH,
    ACTIONS(1573), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1575), 1,
      anon_sym_CARET,
    ACTIONS(1577), 1,
      anon_sym_COLON_COLON,
    STATE(541), 1,
      sym_comment,
    STATE(2083), 1,
      aux_sym__explist_repeat1,
    ACTIONS(1559), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1567), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1089), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1569), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1565), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1087), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [46216] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1579), 1,
      anon_sym_RBRACE,
    STATE(542), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3668), 1,
      sym__outertype,
    STATE(3674), 1,
      sym__tbtype_content,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [46308] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_RBRACE,
    STATE(543), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3446), 1,
      sym__tbtype_content,
    STATE(3668), 1,
      sym__outertype,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [46400] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1583), 1,
      anon_sym_RPAREN,
    STATE(544), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(2980), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    STATE(3465), 1,
      sym_typelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [46494] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1585), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3597), 1,
      sym__tbtype_content,
    STATE(3668), 1,
      sym__outertype,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [46586] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1587), 1,
      anon_sym_RPAREN,
    STATE(546), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3009), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    STATE(3626), 1,
      sym_typelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [46680] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1589), 1,
      anon_sym_RBRACE,
    STATE(547), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3142), 1,
      sym__tbtype_content,
    STATE(3668), 1,
      sym__outertype,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [46772] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1591), 1,
      anon_sym_RPAREN,
    STATE(548), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3025), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3152), 1,
      sym_typelist,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [46866] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_RBRACE,
    STATE(549), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3447), 1,
      sym__tbtype_content,
    STATE(3668), 1,
      sym__outertype,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [46958] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1595), 1,
      anon_sym_RBRACE,
    STATE(550), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3188), 1,
      sym__tbtype_content,
    STATE(3668), 1,
      sym__outertype,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [47050] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1597), 1,
      anon_sym_RPAREN,
    STATE(551), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(2982), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    STATE(3526), 1,
      sym_typelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [47144] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1599), 1,
      anon_sym_RPAREN,
    STATE(552), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2911), 1,
      sym__outertype,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3198), 1,
      sym_typelist,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [47238] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1601), 1,
      ts_builtin_sym_end,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1605), 1,
      anon_sym_SEMI,
    STATE(553), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3055), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [47330] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_RBRACE,
    STATE(554), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3449), 1,
      sym__tbtype_content,
    STATE(3668), 1,
      sym__outertype,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [47422] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1609), 1,
      anon_sym_RPAREN,
    STATE(555), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(2989), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    STATE(3580), 1,
      sym_typelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [47516] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1611), 1,
      anon_sym_RBRACE,
    STATE(556), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3231), 1,
      sym__tbtype_content,
    STATE(3668), 1,
      sym__outertype,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [47608] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1613), 1,
      anon_sym_RBRACE,
    STATE(557), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3246), 1,
      sym__tbtype_content,
    STATE(3668), 1,
      sym__outertype,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [47700] = 27,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1615), 1,
      anon_sym_RPAREN,
    STATE(558), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(2931), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3252), 1,
      sym_typelist,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3259), 1,
      sym_variadic,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [47794] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_RBRACE,
    STATE(559), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3176), 1,
      sym__tbtype_content,
    STATE(3668), 1,
      sym__outertype,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [47886] = 26,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(1619), 1,
      anon_sym_RBRACE,
    STATE(560), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_readwrite,
    STATE(2664), 1,
      sym_type,
    STATE(2884), 1,
      sym__tbtype_kv,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3427), 1,
      sym__tbtype_content,
    STATE(3668), 1,
      sym__outertype,
    STATE(3679), 1,
      sym__array_type,
    STATE(3683), 1,
      sym_kvtypelist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1411), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [47978] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1621), 1,
      anon_sym_RPAREN,
    STATE(561), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3432), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [48067] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1485), 1,
      anon_sym_CARET,
    ACTIONS(1487), 1,
      anon_sym_COLON_COLON,
    STATE(562), 1,
      sym_comment,
    ACTIONS(1349), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [48118] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(563), 1,
      sym_comment,
    ACTIONS(1355), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1353), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [48165] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(564), 1,
      sym_comment,
    ACTIONS(1281), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1279), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [48212] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1471), 1,
      anon_sym_or,
    ACTIONS(1473), 1,
      anon_sym_and,
    ACTIONS(1481), 1,
      anon_sym_SLASH,
    ACTIONS(1483), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1485), 1,
      anon_sym_CARET,
    ACTIONS(1487), 1,
      anon_sym_COLON_COLON,
    STATE(565), 1,
      sym_comment,
    ACTIONS(1469), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1475), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1193), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1191), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [48279] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(566), 1,
      sym_comment,
    ACTIONS(1285), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1283), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [48326] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(567), 1,
      sym_comment,
    ACTIONS(1289), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1287), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [48373] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(568), 1,
      sym_comment,
    ACTIONS(1293), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1291), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [48420] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(569), 1,
      sym_comment,
    ACTIONS(1297), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1295), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [48467] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(570), 1,
      sym_comment,
    ACTIONS(1301), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1299), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [48514] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(571), 1,
      sym_comment,
    ACTIONS(1305), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1303), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [48561] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(572), 1,
      sym_comment,
    ACTIONS(1309), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1307), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [48608] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(573), 1,
      sym_comment,
    ACTIONS(1315), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1313), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [48655] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1623), 1,
      anon_sym_RPAREN,
    STATE(574), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3648), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [48744] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(575), 1,
      sym_comment,
    ACTIONS(1319), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1317), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [48791] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(576), 1,
      sym_comment,
    ACTIONS(1203), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1201), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [48838] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1481), 1,
      anon_sym_SLASH,
    ACTIONS(1483), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1485), 1,
      anon_sym_CARET,
    ACTIONS(1487), 1,
      anon_sym_COLON_COLON,
    STATE(577), 1,
      sym_comment,
    ACTIONS(1469), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1475), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1349), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 16,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_or,
      anon_sym_and,
      sym_name,
      anon_sym_AT,
  [48901] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1625), 1,
      anon_sym_RPAREN,
    STATE(578), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3376), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [48990] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1481), 1,
      anon_sym_SLASH,
    ACTIONS(1485), 1,
      anon_sym_CARET,
    ACTIONS(1487), 1,
      anon_sym_COLON_COLON,
    STATE(579), 1,
      sym_comment,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 18,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_name,
      anon_sym_AT,
  [49045] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(580), 1,
      sym_comment,
    ACTIONS(1345), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1343), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [49092] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(581), 1,
      sym_comment,
    ACTIONS(1255), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1253), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [49139] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(582), 1,
      sym_comment,
    ACTIONS(1259), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1257), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [49186] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(583), 1,
      sym_comment,
    ACTIONS(1265), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1263), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [49233] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1627), 1,
      anon_sym_RPAREN,
    STATE(584), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3591), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [49322] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1459), 1,
      anon_sym_SLASH,
    ACTIONS(1461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1463), 1,
      anon_sym_CARET,
    ACTIONS(1465), 1,
      anon_sym_COLON_COLON,
    STATE(585), 1,
      sym_comment,
    ACTIONS(1455), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1457), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_name,
      anon_sym_AT,
  [49381] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1451), 1,
      anon_sym_and,
    ACTIONS(1459), 1,
      anon_sym_SLASH,
    ACTIONS(1461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1463), 1,
      anon_sym_CARET,
    ACTIONS(1465), 1,
      anon_sym_COLON_COLON,
    STATE(586), 1,
      sym_comment,
    ACTIONS(1447), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1455), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1457), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1453), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1347), 16,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_or,
      sym_name,
      anon_sym_AT,
  [49446] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1459), 1,
      anon_sym_SLASH,
    ACTIONS(1461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1463), 1,
      anon_sym_CARET,
    ACTIONS(1465), 1,
      anon_sym_COLON_COLON,
    STATE(587), 1,
      sym_comment,
    ACTIONS(1447), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1455), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1457), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1453), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1347), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_or,
      anon_sym_and,
      sym_name,
      anon_sym_AT,
  [49509] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(588), 1,
      sym_comment,
    ACTIONS(941), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(939), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [49556] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1459), 1,
      anon_sym_SLASH,
    ACTIONS(1463), 1,
      anon_sym_CARET,
    ACTIONS(1465), 1,
      anon_sym_COLON_COLON,
    STATE(589), 1,
      sym_comment,
    ACTIONS(1457), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_name,
      anon_sym_AT,
  [49611] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1629), 1,
      anon_sym_RPAREN,
    STATE(590), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3305), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [49700] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1471), 1,
      anon_sym_or,
    ACTIONS(1473), 1,
      anon_sym_and,
    ACTIONS(1481), 1,
      anon_sym_SLASH,
    ACTIONS(1483), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1485), 1,
      anon_sym_CARET,
    ACTIONS(1487), 1,
      anon_sym_COLON_COLON,
    STATE(591), 1,
      sym_comment,
    ACTIONS(1469), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1475), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1197), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1195), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [49767] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1631), 1,
      anon_sym_RPAREN,
    STATE(592), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3128), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [49856] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1463), 1,
      anon_sym_CARET,
    ACTIONS(1465), 1,
      anon_sym_COLON_COLON,
    STATE(593), 1,
      sym_comment,
    ACTIONS(1349), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [49907] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1471), 1,
      anon_sym_or,
    ACTIONS(1473), 1,
      anon_sym_and,
    ACTIONS(1481), 1,
      anon_sym_SLASH,
    ACTIONS(1483), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1485), 1,
      anon_sym_CARET,
    ACTIONS(1487), 1,
      anon_sym_COLON_COLON,
    STATE(594), 1,
      sym_comment,
    ACTIONS(1469), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1475), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1205), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [49974] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1571), 1,
      anon_sym_SLASH,
    ACTIONS(1573), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1575), 1,
      anon_sym_CARET,
    ACTIONS(1577), 1,
      anon_sym_COLON_COLON,
    STATE(595), 1,
      sym_comment,
    ACTIONS(1559), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1567), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1569), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1565), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1347), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_or,
      anon_sym_and,
      sym_name,
      anon_sym_AT,
  [50037] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1571), 1,
      anon_sym_SLASH,
    ACTIONS(1575), 1,
      anon_sym_CARET,
    ACTIONS(1577), 1,
      anon_sym_COLON_COLON,
    STATE(596), 1,
      sym_comment,
    ACTIONS(1569), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_name,
      anon_sym_AT,
  [50092] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1575), 1,
      anon_sym_CARET,
    ACTIONS(1577), 1,
      anon_sym_COLON_COLON,
    STATE(597), 1,
      sym_comment,
    ACTIONS(1349), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [50143] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1571), 1,
      anon_sym_SLASH,
    ACTIONS(1573), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1575), 1,
      anon_sym_CARET,
    ACTIONS(1577), 1,
      anon_sym_COLON_COLON,
    STATE(598), 1,
      sym_comment,
    ACTIONS(1567), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1569), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_name,
      anon_sym_AT,
  [50202] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1575), 1,
      anon_sym_CARET,
    ACTIONS(1577), 1,
      anon_sym_COLON_COLON,
    STATE(599), 1,
      sym_comment,
    ACTIONS(1349), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [50253] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(600), 1,
      sym_comment,
    ACTIONS(941), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(939), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [50300] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(601), 1,
      sym_comment,
    ACTIONS(1355), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1353), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [50347] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(602), 1,
      sym_comment,
    ACTIONS(762), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(760), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [50394] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(603), 1,
      sym_comment,
    ACTIONS(1227), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1225), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [50441] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(604), 1,
      sym_comment,
    ACTIONS(1231), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1229), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [50488] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1459), 1,
      anon_sym_SLASH,
    ACTIONS(1461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1463), 1,
      anon_sym_CARET,
    ACTIONS(1465), 1,
      anon_sym_COLON_COLON,
    STATE(605), 1,
      sym_comment,
    ACTIONS(1455), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1457), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_name,
      anon_sym_AT,
  [50547] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1633), 1,
      anon_sym_RPAREN,
    STATE(606), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3229), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [50636] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1561), 1,
      anon_sym_or,
    ACTIONS(1563), 1,
      anon_sym_and,
    ACTIONS(1571), 1,
      anon_sym_SLASH,
    ACTIONS(1573), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1575), 1,
      anon_sym_CARET,
    ACTIONS(1577), 1,
      anon_sym_COLON_COLON,
    STATE(607), 1,
      sym_comment,
    ACTIONS(1559), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1567), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1569), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1193), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1565), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1191), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [50703] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(608), 1,
      sym_comment,
    ACTIONS(762), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(760), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [50750] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1561), 1,
      anon_sym_or,
    ACTIONS(1563), 1,
      anon_sym_and,
    ACTIONS(1571), 1,
      anon_sym_SLASH,
    ACTIONS(1573), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1575), 1,
      anon_sym_CARET,
    ACTIONS(1577), 1,
      anon_sym_COLON_COLON,
    STATE(609), 1,
      sym_comment,
    ACTIONS(1559), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1567), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1569), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1197), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1565), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1195), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [50817] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1449), 1,
      anon_sym_or,
    ACTIONS(1451), 1,
      anon_sym_and,
    ACTIONS(1459), 1,
      anon_sym_SLASH,
    ACTIONS(1461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1463), 1,
      anon_sym_CARET,
    ACTIONS(1465), 1,
      anon_sym_COLON_COLON,
    STATE(610), 1,
      sym_comment,
    ACTIONS(1447), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1455), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1457), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1207), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1453), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1205), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [50884] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1463), 1,
      anon_sym_CARET,
    ACTIONS(1465), 1,
      anon_sym_COLON_COLON,
    STATE(611), 1,
      sym_comment,
    ACTIONS(1349), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [50935] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(612), 1,
      sym_comment,
    ACTIONS(1269), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1267), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [50982] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1635), 1,
      anon_sym_RPAREN,
    STATE(613), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3425), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [51071] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(614), 1,
      sym_comment,
    ACTIONS(1203), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1201), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [51118] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(615), 1,
      sym_comment,
    ACTIONS(1069), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1067), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [51165] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(616), 1,
      sym_comment,
    ACTIONS(1355), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1353), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [51212] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1485), 1,
      anon_sym_CARET,
    ACTIONS(1487), 1,
      anon_sym_COLON_COLON,
    STATE(617), 1,
      sym_comment,
    ACTIONS(1349), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [51263] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(618), 1,
      sym_comment,
    ACTIONS(1235), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1233), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [51310] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(619), 1,
      sym_comment,
    ACTIONS(1239), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1237), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [51357] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(620), 1,
      sym_comment,
    ACTIONS(1243), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1241), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [51404] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1481), 1,
      anon_sym_SLASH,
    ACTIONS(1483), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1485), 1,
      anon_sym_CARET,
    ACTIONS(1487), 1,
      anon_sym_COLON_COLON,
    STATE(621), 1,
      sym_comment,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 18,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_name,
      anon_sym_AT,
  [51463] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(622), 1,
      sym_comment,
    ACTIONS(1243), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1241), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [51510] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1637), 1,
      anon_sym_RPAREN,
    STATE(623), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3296), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [51599] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1153), 1,
      sym_name,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    STATE(624), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2085), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3015), 1,
      sym_field,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [51688] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(625), 1,
      sym_comment,
    ACTIONS(1333), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1331), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [51735] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(626), 1,
      sym_comment,
    ACTIONS(1069), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1067), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [51782] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(627), 1,
      sym_comment,
    ACTIONS(1337), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1335), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [51829] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(628), 1,
      sym_comment,
    ACTIONS(1247), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1245), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [51876] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(629), 1,
      sym_comment,
    ACTIONS(1251), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1249), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [51923] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(630), 1,
      sym_comment,
    ACTIONS(1255), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1253), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [51970] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(631), 1,
      sym_comment,
    ACTIONS(1259), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1257), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52017] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(632), 1,
      sym_comment,
    ACTIONS(1265), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1263), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52064] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(633), 1,
      sym_comment,
    ACTIONS(1269), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1267), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52111] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(634), 1,
      sym_comment,
    ACTIONS(1273), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1271), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52158] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(635), 1,
      sym_comment,
    ACTIONS(1277), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1275), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52205] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(636), 1,
      sym_comment,
    ACTIONS(1281), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1279), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52252] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(637), 1,
      sym_comment,
    ACTIONS(1223), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1221), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52299] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1639), 1,
      anon_sym_RPAREN,
    STATE(638), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3561), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [52388] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1485), 1,
      anon_sym_CARET,
    ACTIONS(1487), 1,
      anon_sym_COLON_COLON,
    STATE(639), 1,
      sym_comment,
    ACTIONS(1341), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1339), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52439] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(640), 1,
      sym_comment,
    ACTIONS(1315), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1313), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52486] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(641), 1,
      sym_comment,
    ACTIONS(1309), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1307), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52533] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(642), 1,
      sym_comment,
    ACTIONS(1273), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1271), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52580] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(643), 1,
      sym_comment,
    ACTIONS(1289), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1287), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52627] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(644), 1,
      sym_comment,
    ACTIONS(1293), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1291), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52674] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(645), 1,
      sym_comment,
    ACTIONS(1297), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1295), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52721] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(646), 1,
      sym_comment,
    ACTIONS(1301), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1299), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52768] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(647), 1,
      sym_comment,
    ACTIONS(1305), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1303), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52815] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(648), 1,
      sym_comment,
    ACTIONS(1309), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1307), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52862] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(649), 1,
      sym_comment,
    ACTIONS(1315), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1313), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52909] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(650), 1,
      sym_comment,
    ACTIONS(1319), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1317), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [52956] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(651), 1,
      sym_comment,
    ACTIONS(1227), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1225), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [53003] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(652), 1,
      sym_comment,
    ACTIONS(1345), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1343), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [53050] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(653), 1,
      sym_comment,
    ACTIONS(1231), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1229), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [53097] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1641), 1,
      anon_sym_RPAREN,
    STATE(654), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3136), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [53186] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1561), 1,
      anon_sym_or,
    ACTIONS(1563), 1,
      anon_sym_and,
    ACTIONS(1571), 1,
      anon_sym_SLASH,
    ACTIONS(1573), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1575), 1,
      anon_sym_CARET,
    ACTIONS(1577), 1,
      anon_sym_COLON_COLON,
    STATE(655), 1,
      sym_comment,
    ACTIONS(1559), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1567), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1569), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1207), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1565), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1205), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [53253] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(656), 1,
      sym_comment,
    ACTIONS(1203), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1201), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [53300] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1481), 1,
      anon_sym_SLASH,
    ACTIONS(1483), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1485), 1,
      anon_sym_CARET,
    ACTIONS(1487), 1,
      anon_sym_COLON_COLON,
    STATE(657), 1,
      sym_comment,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 18,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_name,
      anon_sym_AT,
  [53359] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(658), 1,
      sym_comment,
    ACTIONS(1333), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1331), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [53406] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1473), 1,
      anon_sym_and,
    ACTIONS(1481), 1,
      anon_sym_SLASH,
    ACTIONS(1483), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1485), 1,
      anon_sym_CARET,
    ACTIONS(1487), 1,
      anon_sym_COLON_COLON,
    STATE(659), 1,
      sym_comment,
    ACTIONS(1469), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1475), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1349), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_or,
      sym_name,
      anon_sym_AT,
  [53471] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(660), 1,
      sym_comment,
    ACTIONS(1333), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1331), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [53518] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(661), 1,
      sym_comment,
    ACTIONS(1235), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1233), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [53565] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(662), 1,
      sym_comment,
    ACTIONS(1239), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1237), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [53612] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(663), 1,
      sym_comment,
    ACTIONS(1243), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1241), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [53659] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1449), 1,
      anon_sym_or,
    ACTIONS(1451), 1,
      anon_sym_and,
    ACTIONS(1459), 1,
      anon_sym_SLASH,
    ACTIONS(1461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1463), 1,
      anon_sym_CARET,
    ACTIONS(1465), 1,
      anon_sym_COLON_COLON,
    STATE(664), 1,
      sym_comment,
    ACTIONS(1447), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1455), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1457), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1193), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1453), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1191), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [53726] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(665), 1,
      sym_comment,
    ACTIONS(1247), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1245), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [53773] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(666), 1,
      sym_comment,
    ACTIONS(1337), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1335), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [53820] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1643), 1,
      anon_sym_RPAREN,
    STATE(667), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3414), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [53909] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(668), 1,
      sym_comment,
    ACTIONS(1247), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1245), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [53956] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(669), 1,
      sym_comment,
    ACTIONS(1337), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1335), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [54003] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1645), 1,
      anon_sym_RPAREN,
    STATE(670), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3182), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [54092] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(671), 1,
      sym_comment,
    ACTIONS(1251), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1249), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [54139] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1575), 1,
      anon_sym_CARET,
    ACTIONS(1577), 1,
      anon_sym_COLON_COLON,
    STATE(672), 1,
      sym_comment,
    ACTIONS(1341), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1339), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [54190] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(673), 1,
      sym_comment,
    ACTIONS(1069), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1067), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [54237] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(674), 1,
      sym_comment,
    ACTIONS(1223), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1221), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [54284] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(675), 1,
      sym_comment,
    ACTIONS(1255), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1253), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [54331] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(676), 1,
      sym_comment,
    ACTIONS(1345), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1343), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [54378] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1647), 1,
      anon_sym_RPAREN,
    STATE(677), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3221), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [54467] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(678), 1,
      sym_comment,
    ACTIONS(1259), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1257), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [54514] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(679), 1,
      sym_comment,
    ACTIONS(1265), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1263), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [54561] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1449), 1,
      anon_sym_or,
    ACTIONS(1451), 1,
      anon_sym_and,
    ACTIONS(1459), 1,
      anon_sym_SLASH,
    ACTIONS(1461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1463), 1,
      anon_sym_CARET,
    ACTIONS(1465), 1,
      anon_sym_COLON_COLON,
    STATE(680), 1,
      sym_comment,
    ACTIONS(1447), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1455), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1457), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1197), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1453), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1195), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [54628] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1571), 1,
      anon_sym_SLASH,
    ACTIONS(1573), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1575), 1,
      anon_sym_CARET,
    ACTIONS(1577), 1,
      anon_sym_COLON_COLON,
    STATE(681), 1,
      sym_comment,
    ACTIONS(1567), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1569), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1347), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_name,
      anon_sym_AT,
  [54687] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(682), 1,
      sym_comment,
    ACTIONS(1269), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1267), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [54734] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1563), 1,
      anon_sym_and,
    ACTIONS(1571), 1,
      anon_sym_SLASH,
    ACTIONS(1573), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1575), 1,
      anon_sym_CARET,
    ACTIONS(1577), 1,
      anon_sym_COLON_COLON,
    STATE(683), 1,
      sym_comment,
    ACTIONS(1559), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1567), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1569), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1565), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1347), 16,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_or,
      sym_name,
      anon_sym_AT,
  [54799] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1463), 1,
      anon_sym_CARET,
    ACTIONS(1465), 1,
      anon_sym_COLON_COLON,
    STATE(684), 1,
      sym_comment,
    ACTIONS(1341), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1339), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [54850] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(685), 1,
      sym_comment,
    ACTIONS(1273), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1271), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [54897] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1649), 1,
      anon_sym_RPAREN,
    STATE(686), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3228), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [54986] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(687), 1,
      sym_comment,
    ACTIONS(1277), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1275), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55033] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(688), 1,
      sym_comment,
    ACTIONS(1239), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1237), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55080] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(689), 1,
      sym_comment,
    ACTIONS(1277), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1275), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55127] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1651), 1,
      anon_sym_RPAREN,
    STATE(690), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3548), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [55216] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(691), 1,
      sym_comment,
    ACTIONS(941), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(939), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55263] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(692), 1,
      sym_comment,
    ACTIONS(1281), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1279), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55310] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(693), 1,
      sym_comment,
    ACTIONS(1285), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1283), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55357] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(694), 1,
      sym_comment,
    ACTIONS(1289), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1287), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55404] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(695), 1,
      sym_comment,
    ACTIONS(1251), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1249), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55451] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    ACTIONS(1653), 1,
      anon_sym_RPAREN,
    STATE(696), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1777), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    STATE(3159), 1,
      sym__explist,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [55540] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(697), 1,
      sym_comment,
    ACTIONS(1293), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1291), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55587] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(698), 1,
      sym_comment,
    ACTIONS(1319), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1317), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55634] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(699), 1,
      sym_comment,
    ACTIONS(1297), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1295), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55681] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(700), 1,
      sym_comment,
    ACTIONS(762), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(760), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55728] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(701), 1,
      sym_comment,
    ACTIONS(1301), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1299), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55775] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(702), 1,
      sym_comment,
    ACTIONS(1305), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1303), 19,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55822] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(703), 1,
      sym_comment,
    ACTIONS(1223), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1221), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55869] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(704), 1,
      sym_comment,
    ACTIONS(1227), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1225), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55916] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(705), 1,
      sym_comment,
    ACTIONS(1231), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1229), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [55963] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(706), 1,
      sym_comment,
    ACTIONS(1235), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1233), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [56010] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(707), 1,
      sym_comment,
    ACTIONS(1285), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1283), 20,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_SLASH,
      sym_name,
      anon_sym_AT,
  [56057] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(708), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3122), 1,
      sym__outertype,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [56145] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1561), 1,
      anon_sym_or,
    ACTIONS(1563), 1,
      anon_sym_and,
    ACTIONS(1571), 1,
      anon_sym_SLASH,
    ACTIONS(1573), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1575), 1,
      anon_sym_CARET,
    ACTIONS(1577), 1,
      anon_sym_COLON_COLON,
    STATE(709), 1,
      sym_comment,
    ACTIONS(1559), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1567), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1491), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1569), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1565), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1489), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [56211] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1561), 1,
      anon_sym_or,
    ACTIONS(1563), 1,
      anon_sym_and,
    ACTIONS(1571), 1,
      anon_sym_SLASH,
    ACTIONS(1573), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1575), 1,
      anon_sym_CARET,
    ACTIONS(1577), 1,
      anon_sym_COLON_COLON,
    STATE(710), 1,
      sym_comment,
    ACTIONS(1559), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1567), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1569), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1565), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1493), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [56277] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1561), 1,
      anon_sym_or,
    ACTIONS(1563), 1,
      anon_sym_and,
    ACTIONS(1571), 1,
      anon_sym_SLASH,
    ACTIONS(1573), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1575), 1,
      anon_sym_CARET,
    ACTIONS(1577), 1,
      anon_sym_COLON_COLON,
    STATE(711), 1,
      sym_comment,
    ACTIONS(1559), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1567), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1499), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1569), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1565), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1497), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [56343] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(712), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2013), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    STATE(3210), 1,
      sym__explist,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [56429] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1683), 1,
      sym_name,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1687), 1,
      anon_sym_if,
    ACTIONS(1691), 1,
      anon_sym_not,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      anon_sym_LPAREN,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1699), 1,
      sym_number,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1707), 1,
      sym_interp_start,
    STATE(251), 1,
      sym__tbl_seq,
    STATE(353), 1,
      sym_var,
    STATE(452), 1,
      sym_prefixexp,
    STATE(541), 1,
      sym_exp,
    STATE(713), 1,
      sym_comment,
    STATE(2345), 1,
      sym__explist,
    STATE(2818), 1,
      sym__prefixexp,
    STATE(2819), 1,
      sym__tbl_method,
    ACTIONS(1689), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(250), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(626), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [56515] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1683), 1,
      sym_name,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1687), 1,
      anon_sym_if,
    ACTIONS(1691), 1,
      anon_sym_not,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      anon_sym_LPAREN,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1699), 1,
      sym_number,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1707), 1,
      sym_interp_start,
    STATE(251), 1,
      sym__tbl_seq,
    STATE(353), 1,
      sym_var,
    STATE(452), 1,
      sym_prefixexp,
    STATE(541), 1,
      sym_exp,
    STATE(714), 1,
      sym_comment,
    STATE(2367), 1,
      sym__explist,
    STATE(2818), 1,
      sym__prefixexp,
    STATE(2819), 1,
      sym__tbl_method,
    ACTIONS(1689), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(250), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(626), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [56601] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1709), 1,
      sym_name,
    ACTIONS(1711), 1,
      anon_sym_function,
    ACTIONS(1713), 1,
      anon_sym_if,
    ACTIONS(1717), 1,
      anon_sym_not,
    ACTIONS(1719), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1725), 1,
      sym_number,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(1733), 1,
      sym_interp_start,
    STATE(232), 1,
      sym__tbl_seq,
    STATE(371), 1,
      sym_var,
    STATE(483), 1,
      sym_prefixexp,
    STATE(521), 1,
      sym_exp,
    STATE(715), 1,
      sym_comment,
    STATE(2238), 1,
      sym__explist,
    STATE(2782), 1,
      sym__prefixexp,
    STATE(2786), 1,
      sym__tbl_method,
    ACTIONS(1715), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(258), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(615), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [56687] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1709), 1,
      sym_name,
    ACTIONS(1711), 1,
      anon_sym_function,
    ACTIONS(1713), 1,
      anon_sym_if,
    ACTIONS(1717), 1,
      anon_sym_not,
    ACTIONS(1719), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1725), 1,
      sym_number,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(1733), 1,
      sym_interp_start,
    STATE(232), 1,
      sym__tbl_seq,
    STATE(371), 1,
      sym_var,
    STATE(483), 1,
      sym_prefixexp,
    STATE(521), 1,
      sym_exp,
    STATE(716), 1,
      sym_comment,
    STATE(2248), 1,
      sym__explist,
    STATE(2782), 1,
      sym__prefixexp,
    STATE(2786), 1,
      sym__tbl_method,
    ACTIONS(1715), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(258), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(615), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [56773] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1449), 1,
      anon_sym_or,
    ACTIONS(1451), 1,
      anon_sym_and,
    ACTIONS(1459), 1,
      anon_sym_SLASH,
    ACTIONS(1461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1463), 1,
      anon_sym_CARET,
    ACTIONS(1465), 1,
      anon_sym_COLON_COLON,
    STATE(717), 1,
      sym_comment,
    ACTIONS(1447), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1455), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1457), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1491), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1453), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1489), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [56839] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1449), 1,
      anon_sym_or,
    ACTIONS(1451), 1,
      anon_sym_and,
    ACTIONS(1459), 1,
      anon_sym_SLASH,
    ACTIONS(1461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1463), 1,
      anon_sym_CARET,
    ACTIONS(1465), 1,
      anon_sym_COLON_COLON,
    STATE(718), 1,
      sym_comment,
    ACTIONS(1447), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1455), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1457), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1495), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1453), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1493), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [56905] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1449), 1,
      anon_sym_or,
    ACTIONS(1451), 1,
      anon_sym_and,
    ACTIONS(1459), 1,
      anon_sym_SLASH,
    ACTIONS(1461), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1463), 1,
      anon_sym_CARET,
    ACTIONS(1465), 1,
      anon_sym_COLON_COLON,
    STATE(719), 1,
      sym_comment,
    ACTIONS(1447), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1455), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1457), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1499), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1453), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1497), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [56971] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1471), 1,
      anon_sym_or,
    ACTIONS(1473), 1,
      anon_sym_and,
    ACTIONS(1481), 1,
      anon_sym_SLASH,
    ACTIONS(1483), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1485), 1,
      anon_sym_CARET,
    ACTIONS(1487), 1,
      anon_sym_COLON_COLON,
    STATE(720), 1,
      sym_comment,
    ACTIONS(1469), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1475), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1491), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1489), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [57037] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1471), 1,
      anon_sym_or,
    ACTIONS(1473), 1,
      anon_sym_and,
    ACTIONS(1481), 1,
      anon_sym_SLASH,
    ACTIONS(1483), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1485), 1,
      anon_sym_CARET,
    ACTIONS(1487), 1,
      anon_sym_COLON_COLON,
    STATE(721), 1,
      sym_comment,
    ACTIONS(1469), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1475), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1495), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1493), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [57103] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1735), 1,
      sym_name,
    ACTIONS(1737), 1,
      anon_sym_function,
    ACTIONS(1739), 1,
      anon_sym_if,
    ACTIONS(1743), 1,
      anon_sym_not,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1751), 1,
      sym_number,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1759), 1,
      sym_interp_start,
    STATE(227), 1,
      sym__tbl_seq,
    STATE(315), 1,
      sym_var,
    STATE(343), 1,
      sym_prefixexp,
    STATE(368), 1,
      sym_exp,
    STATE(722), 1,
      sym_comment,
    STATE(1941), 1,
      sym__explist,
    STATE(2834), 1,
      sym__prefixexp,
    STATE(2835), 1,
      sym__tbl_method,
    ACTIONS(1741), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(228), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(486), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [57189] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1735), 1,
      sym_name,
    ACTIONS(1737), 1,
      anon_sym_function,
    ACTIONS(1739), 1,
      anon_sym_if,
    ACTIONS(1743), 1,
      anon_sym_not,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1751), 1,
      sym_number,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1759), 1,
      sym_interp_start,
    STATE(227), 1,
      sym__tbl_seq,
    STATE(315), 1,
      sym_var,
    STATE(343), 1,
      sym_prefixexp,
    STATE(368), 1,
      sym_exp,
    STATE(723), 1,
      sym_comment,
    STATE(1963), 1,
      sym__explist,
    STATE(2834), 1,
      sym__prefixexp,
    STATE(2835), 1,
      sym__tbl_method,
    ACTIONS(1741), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(228), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(486), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [57275] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(724), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3068), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [57363] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1471), 1,
      anon_sym_or,
    ACTIONS(1473), 1,
      anon_sym_and,
    ACTIONS(1481), 1,
      anon_sym_SLASH,
    ACTIONS(1483), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1485), 1,
      anon_sym_CARET,
    ACTIONS(1487), 1,
      anon_sym_COLON_COLON,
    STATE(725), 1,
      sym_comment,
    ACTIONS(1469), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1475), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1499), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1497), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [57429] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(726), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3406), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [57515] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(727), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3059), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [57603] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1765), 1,
      sym_name,
    ACTIONS(1767), 1,
      anon_sym_function,
    ACTIONS(1769), 1,
      anon_sym_if,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1775), 1,
      anon_sym_LBRACE,
    ACTIONS(1777), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1781), 1,
      sym_number,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1789), 1,
      sym_interp_start,
    STATE(248), 1,
      sym__tbl_seq,
    STATE(408), 1,
      sym_var,
    STATE(482), 1,
      sym_prefixexp,
    STATE(522), 1,
      sym_exp,
    STATE(728), 1,
      sym_comment,
    STATE(2436), 1,
      sym__explist,
    STATE(2796), 1,
      sym__prefixexp,
    STATE(2797), 1,
      sym__tbl_method,
    ACTIONS(1771), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(247), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(673), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [57689] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(729), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3130), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [57775] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1765), 1,
      sym_name,
    ACTIONS(1767), 1,
      anon_sym_function,
    ACTIONS(1769), 1,
      anon_sym_if,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1775), 1,
      anon_sym_LBRACE,
    ACTIONS(1777), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1781), 1,
      sym_number,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1789), 1,
      sym_interp_start,
    STATE(248), 1,
      sym__tbl_seq,
    STATE(408), 1,
      sym_var,
    STATE(482), 1,
      sym_prefixexp,
    STATE(522), 1,
      sym_exp,
    STATE(730), 1,
      sym_comment,
    STATE(2429), 1,
      sym__explist,
    STATE(2796), 1,
      sym__prefixexp,
    STATE(2797), 1,
      sym__tbl_method,
    ACTIONS(1771), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(247), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(673), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [57861] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(731), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3054), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [57949] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(732), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3576), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [58035] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(733), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3672), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [58121] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(734), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3082), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [58209] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(735), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3274), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [58295] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(736), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3319), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [58381] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(737), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3185), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [58467] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(738), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3600), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [58553] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(739), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3084), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [58641] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(740), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3517), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [58727] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(741), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3567), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [58813] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(742), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3108), 1,
      sym__outertype,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [58901] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(743), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3215), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [58987] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(744), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3244), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [59073] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(745), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3079), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [59161] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(746), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3322), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [59247] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(747), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3125), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [59333] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(748), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2013), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    STATE(3399), 1,
      sym__explist,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [59419] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(749), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3459), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [59505] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(750), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3488), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [59591] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(751), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3088), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [59679] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(752), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3569), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [59765] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(753), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3584), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [59851] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(754), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3115), 1,
      sym__outertype,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [59939] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(755), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3706), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [60025] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(756), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3717), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [60111] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(757), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3100), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [60199] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(758), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3551), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [60285] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(759), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3129), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [60371] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3116), 1,
      sym__outertype,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [60459] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(761), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3302), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [60545] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(762), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3344), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [60631] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(763), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3069), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [60719] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(764), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3464), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [60805] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(765), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3484), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [60891] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(766), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3083), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [60979] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(767), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3621), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [61065] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(768), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3687), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [61151] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(769), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3081), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [61239] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(770), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3151), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [61325] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(771), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3162), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [61411] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(772), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3119), 1,
      sym__outertype,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [61499] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(773), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3197), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [61585] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(774), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3208), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [61671] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(775), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3048), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [61759] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(776), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3237), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [61845] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(777), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3239), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [61931] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(778), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3052), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [62019] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(779), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3251), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [62105] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(780), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2973), 1,
      sym_typeparam,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3118), 1,
      sym_typepack,
    STATE(3253), 1,
      sym__typeparamlist,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [62191] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(781), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2013), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    STATE(3331), 1,
      sym__explist,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [62277] = 24,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(782), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2013), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    STATE(3365), 1,
      sym__explist,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [62363] = 25,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(783), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(2914), 1,
      sym__fntype_param,
    STATE(3046), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3264), 1,
      sym__fntype_paramlist,
    STATE(3280), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [62451] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1683), 1,
      sym_name,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1687), 1,
      anon_sym_if,
    ACTIONS(1691), 1,
      anon_sym_not,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      anon_sym_LPAREN,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1699), 1,
      sym_number,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1707), 1,
      sym_interp_start,
    STATE(251), 1,
      sym__tbl_seq,
    STATE(353), 1,
      sym_var,
    STATE(452), 1,
      sym_prefixexp,
    STATE(709), 1,
      sym_exp,
    STATE(784), 1,
      sym_comment,
    STATE(2818), 1,
      sym__prefixexp,
    STATE(2819), 1,
      sym__tbl_method,
    ACTIONS(1689), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(250), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(626), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [62534] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(785), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2523), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [62617] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1709), 1,
      sym_name,
    ACTIONS(1711), 1,
      anon_sym_function,
    ACTIONS(1713), 1,
      anon_sym_if,
    ACTIONS(1717), 1,
      anon_sym_not,
    ACTIONS(1719), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1725), 1,
      sym_number,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(1733), 1,
      sym_interp_start,
    STATE(232), 1,
      sym__tbl_seq,
    STATE(371), 1,
      sym_var,
    STATE(483), 1,
      sym_prefixexp,
    STATE(718), 1,
      sym_exp,
    STATE(786), 1,
      sym_comment,
    STATE(2782), 1,
      sym__prefixexp,
    STATE(2786), 1,
      sym__tbl_method,
    ACTIONS(1715), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(258), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(615), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [62700] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(787), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2356), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [62783] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1709), 1,
      sym_name,
    ACTIONS(1711), 1,
      anon_sym_function,
    ACTIONS(1713), 1,
      anon_sym_if,
    ACTIONS(1717), 1,
      anon_sym_not,
    ACTIONS(1719), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1725), 1,
      sym_number,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(1733), 1,
      sym_interp_start,
    STATE(232), 1,
      sym__tbl_seq,
    STATE(371), 1,
      sym_var,
    STATE(483), 1,
      sym_prefixexp,
    STATE(719), 1,
      sym_exp,
    STATE(788), 1,
      sym_comment,
    STATE(2782), 1,
      sym__prefixexp,
    STATE(2786), 1,
      sym__tbl_method,
    ACTIONS(1715), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(258), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(615), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [62866] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(789), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2156), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [62949] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(790), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2182), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [63032] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1123), 1,
      sym_name,
    ACTIONS(1127), 1,
      anon_sym_function,
    ACTIONS(1131), 1,
      anon_sym_if,
    ACTIONS(1135), 1,
      anon_sym_not,
    ACTIONS(1137), 1,
      anon_sym_LBRACE,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1143), 1,
      sym_number,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1151), 1,
      sym_interp_start,
    STATE(791), 1,
      sym_comment,
    STATE(1101), 1,
      sym__tbl_seq,
    STATE(1224), 1,
      sym_var,
    STATE(1431), 1,
      sym_prefixexp,
    STATE(1759), 1,
      sym_exp,
    STATE(2793), 1,
      sym__prefixexp,
    STATE(2794), 1,
      sym__tbl_method,
    ACTIONS(1133), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1100), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1783), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [63115] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1765), 1,
      sym_name,
    ACTIONS(1767), 1,
      anon_sym_function,
    ACTIONS(1769), 1,
      anon_sym_if,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1775), 1,
      anon_sym_LBRACE,
    ACTIONS(1777), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1781), 1,
      sym_number,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1789), 1,
      sym_interp_start,
    STATE(248), 1,
      sym__tbl_seq,
    STATE(408), 1,
      sym_var,
    STATE(482), 1,
      sym_prefixexp,
    STATE(725), 1,
      sym_exp,
    STATE(792), 1,
      sym_comment,
    STATE(2796), 1,
      sym__prefixexp,
    STATE(2797), 1,
      sym__tbl_method,
    ACTIONS(1771), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(247), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(673), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [63198] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(793), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2488), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [63281] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1417), 1,
      sym_name,
    ACTIONS(1421), 1,
      anon_sym_function,
    ACTIONS(1423), 1,
      anon_sym_if,
    ACTIONS(1427), 1,
      anon_sym_not,
    ACTIONS(1429), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LPAREN,
    ACTIONS(1433), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(1443), 1,
      sym_interp_start,
    STATE(794), 1,
      sym_comment,
    STATE(1163), 1,
      sym__tbl_seq,
    STATE(1423), 1,
      sym_var,
    STATE(1787), 1,
      sym_prefixexp,
    STATE(1945), 1,
      sym_exp,
    STATE(2775), 1,
      sym__prefixexp,
    STATE(2779), 1,
      sym__tbl_method,
    ACTIONS(1425), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2048), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [63364] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1417), 1,
      sym_name,
    ACTIONS(1421), 1,
      anon_sym_function,
    ACTIONS(1423), 1,
      anon_sym_if,
    ACTIONS(1427), 1,
      anon_sym_not,
    ACTIONS(1429), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LPAREN,
    ACTIONS(1433), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(1443), 1,
      sym_interp_start,
    STATE(795), 1,
      sym_comment,
    STATE(1163), 1,
      sym__tbl_seq,
    STATE(1423), 1,
      sym_var,
    STATE(1787), 1,
      sym_prefixexp,
    STATE(1948), 1,
      sym_exp,
    STATE(2775), 1,
      sym__prefixexp,
    STATE(2779), 1,
      sym__tbl_method,
    ACTIONS(1425), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2048), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [63447] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1417), 1,
      sym_name,
    ACTIONS(1421), 1,
      anon_sym_function,
    ACTIONS(1423), 1,
      anon_sym_if,
    ACTIONS(1427), 1,
      anon_sym_not,
    ACTIONS(1429), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LPAREN,
    ACTIONS(1433), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(1443), 1,
      sym_interp_start,
    STATE(796), 1,
      sym_comment,
    STATE(1163), 1,
      sym__tbl_seq,
    STATE(1423), 1,
      sym_var,
    STATE(1787), 1,
      sym_prefixexp,
    STATE(1949), 1,
      sym_exp,
    STATE(2775), 1,
      sym__prefixexp,
    STATE(2779), 1,
      sym__tbl_method,
    ACTIONS(1425), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2048), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [63530] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1765), 1,
      sym_name,
    ACTIONS(1767), 1,
      anon_sym_function,
    ACTIONS(1769), 1,
      anon_sym_if,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1775), 1,
      anon_sym_LBRACE,
    ACTIONS(1777), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1781), 1,
      sym_number,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1789), 1,
      sym_interp_start,
    STATE(248), 1,
      sym__tbl_seq,
    STATE(408), 1,
      sym_var,
    STATE(482), 1,
      sym_prefixexp,
    STATE(594), 1,
      sym_exp,
    STATE(797), 1,
      sym_comment,
    STATE(2796), 1,
      sym__prefixexp,
    STATE(2797), 1,
      sym__tbl_method,
    ACTIONS(1771), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(247), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(673), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [63613] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1417), 1,
      sym_name,
    ACTIONS(1421), 1,
      anon_sym_function,
    ACTIONS(1423), 1,
      anon_sym_if,
    ACTIONS(1427), 1,
      anon_sym_not,
    ACTIONS(1429), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LPAREN,
    ACTIONS(1433), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(1443), 1,
      sym_interp_start,
    STATE(798), 1,
      sym_comment,
    STATE(1163), 1,
      sym__tbl_seq,
    STATE(1423), 1,
      sym_var,
    STATE(1787), 1,
      sym_prefixexp,
    STATE(1950), 1,
      sym_exp,
    STATE(2775), 1,
      sym__prefixexp,
    STATE(2779), 1,
      sym__tbl_method,
    ACTIONS(1425), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2048), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [63696] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1417), 1,
      sym_name,
    ACTIONS(1421), 1,
      anon_sym_function,
    ACTIONS(1423), 1,
      anon_sym_if,
    ACTIONS(1427), 1,
      anon_sym_not,
    ACTIONS(1429), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LPAREN,
    ACTIONS(1433), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(1443), 1,
      sym_interp_start,
    STATE(799), 1,
      sym_comment,
    STATE(1163), 1,
      sym__tbl_seq,
    STATE(1423), 1,
      sym_var,
    STATE(1787), 1,
      sym_prefixexp,
    STATE(2092), 1,
      sym_exp,
    STATE(2775), 1,
      sym__prefixexp,
    STATE(2779), 1,
      sym__tbl_method,
    ACTIONS(1425), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2048), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [63779] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1417), 1,
      sym_name,
    ACTIONS(1421), 1,
      anon_sym_function,
    ACTIONS(1423), 1,
      anon_sym_if,
    ACTIONS(1427), 1,
      anon_sym_not,
    ACTIONS(1429), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LPAREN,
    ACTIONS(1433), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(1443), 1,
      sym_interp_start,
    STATE(800), 1,
      sym_comment,
    STATE(1163), 1,
      sym__tbl_seq,
    STATE(1423), 1,
      sym_var,
    STATE(1787), 1,
      sym_prefixexp,
    STATE(1951), 1,
      sym_exp,
    STATE(2775), 1,
      sym__prefixexp,
    STATE(2779), 1,
      sym__tbl_method,
    ACTIONS(1425), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2048), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [63862] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1735), 1,
      sym_name,
    ACTIONS(1737), 1,
      anon_sym_function,
    ACTIONS(1739), 1,
      anon_sym_if,
    ACTIONS(1743), 1,
      anon_sym_not,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1751), 1,
      sym_number,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1759), 1,
      sym_interp_start,
    STATE(227), 1,
      sym__tbl_seq,
    STATE(315), 1,
      sym_var,
    STATE(343), 1,
      sym_prefixexp,
    STATE(523), 1,
      sym_exp,
    STATE(801), 1,
      sym_comment,
    STATE(2834), 1,
      sym__prefixexp,
    STATE(2835), 1,
      sym__tbl_method,
    ACTIONS(1741), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(228), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(486), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [63945] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1417), 1,
      sym_name,
    ACTIONS(1421), 1,
      anon_sym_function,
    ACTIONS(1423), 1,
      anon_sym_if,
    ACTIONS(1427), 1,
      anon_sym_not,
    ACTIONS(1429), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LPAREN,
    ACTIONS(1433), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(1443), 1,
      sym_interp_start,
    STATE(802), 1,
      sym_comment,
    STATE(1163), 1,
      sym__tbl_seq,
    STATE(1423), 1,
      sym_var,
    STATE(1787), 1,
      sym_prefixexp,
    STATE(1952), 1,
      sym_exp,
    STATE(2775), 1,
      sym__prefixexp,
    STATE(2779), 1,
      sym__tbl_method,
    ACTIONS(1425), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2048), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [64028] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1735), 1,
      sym_name,
    ACTIONS(1737), 1,
      anon_sym_function,
    ACTIONS(1739), 1,
      anon_sym_if,
    ACTIONS(1743), 1,
      anon_sym_not,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1751), 1,
      sym_number,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1759), 1,
      sym_interp_start,
    STATE(227), 1,
      sym__tbl_seq,
    STATE(315), 1,
      sym_var,
    STATE(343), 1,
      sym_prefixexp,
    STATE(524), 1,
      sym_exp,
    STATE(803), 1,
      sym_comment,
    STATE(2834), 1,
      sym__prefixexp,
    STATE(2835), 1,
      sym__tbl_method,
    ACTIONS(1741), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(228), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(486), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [64111] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1417), 1,
      sym_name,
    ACTIONS(1421), 1,
      anon_sym_function,
    ACTIONS(1423), 1,
      anon_sym_if,
    ACTIONS(1427), 1,
      anon_sym_not,
    ACTIONS(1429), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LPAREN,
    ACTIONS(1433), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(1443), 1,
      sym_interp_start,
    STATE(804), 1,
      sym_comment,
    STATE(1163), 1,
      sym__tbl_seq,
    STATE(1423), 1,
      sym_var,
    STATE(1787), 1,
      sym_prefixexp,
    STATE(1935), 1,
      sym_exp,
    STATE(2775), 1,
      sym__prefixexp,
    STATE(2779), 1,
      sym__tbl_method,
    ACTIONS(1425), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2048), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [64194] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1735), 1,
      sym_name,
    ACTIONS(1737), 1,
      anon_sym_function,
    ACTIONS(1739), 1,
      anon_sym_if,
    ACTIONS(1743), 1,
      anon_sym_not,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1751), 1,
      sym_number,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1759), 1,
      sym_interp_start,
    STATE(227), 1,
      sym__tbl_seq,
    STATE(315), 1,
      sym_var,
    STATE(343), 1,
      sym_prefixexp,
    STATE(525), 1,
      sym_exp,
    STATE(805), 1,
      sym_comment,
    STATE(2834), 1,
      sym__prefixexp,
    STATE(2835), 1,
      sym__tbl_method,
    ACTIONS(1741), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(228), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(486), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [64277] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1123), 1,
      sym_name,
    ACTIONS(1127), 1,
      anon_sym_function,
    ACTIONS(1131), 1,
      anon_sym_if,
    ACTIONS(1135), 1,
      anon_sym_not,
    ACTIONS(1137), 1,
      anon_sym_LBRACE,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1143), 1,
      sym_number,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1151), 1,
      sym_interp_start,
    STATE(806), 1,
      sym_comment,
    STATE(1101), 1,
      sym__tbl_seq,
    STATE(1224), 1,
      sym_var,
    STATE(1431), 1,
      sym_prefixexp,
    STATE(1785), 1,
      sym_exp,
    STATE(2793), 1,
      sym__prefixexp,
    STATE(2794), 1,
      sym__tbl_method,
    ACTIONS(1133), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1100), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1783), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [64360] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(807), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(1921), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [64443] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(808), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2087), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [64526] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1417), 1,
      sym_name,
    ACTIONS(1421), 1,
      anon_sym_function,
    ACTIONS(1423), 1,
      anon_sym_if,
    ACTIONS(1427), 1,
      anon_sym_not,
    ACTIONS(1429), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LPAREN,
    ACTIONS(1433), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(1443), 1,
      sym_interp_start,
    STATE(809), 1,
      sym_comment,
    STATE(1163), 1,
      sym__tbl_seq,
    STATE(1423), 1,
      sym_var,
    STATE(1787), 1,
      sym_prefixexp,
    STATE(1996), 1,
      sym_exp,
    STATE(2775), 1,
      sym__prefixexp,
    STATE(2779), 1,
      sym__tbl_method,
    ACTIONS(1425), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2048), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [64609] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1417), 1,
      sym_name,
    ACTIONS(1421), 1,
      anon_sym_function,
    ACTIONS(1423), 1,
      anon_sym_if,
    ACTIONS(1427), 1,
      anon_sym_not,
    ACTIONS(1429), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LPAREN,
    ACTIONS(1433), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(1443), 1,
      sym_interp_start,
    STATE(810), 1,
      sym_comment,
    STATE(1163), 1,
      sym__tbl_seq,
    STATE(1423), 1,
      sym_var,
    STATE(1787), 1,
      sym_prefixexp,
    STATE(2001), 1,
      sym_exp,
    STATE(2775), 1,
      sym__prefixexp,
    STATE(2779), 1,
      sym__tbl_method,
    ACTIONS(1425), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2048), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [64692] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1529), 1,
      sym_name,
    ACTIONS(1533), 1,
      anon_sym_function,
    ACTIONS(1535), 1,
      anon_sym_if,
    ACTIONS(1539), 1,
      anon_sym_not,
    ACTIONS(1541), 1,
      anon_sym_LBRACE,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1547), 1,
      sym_number,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1555), 1,
      sym_interp_start,
    STATE(811), 1,
      sym_comment,
    STATE(1152), 1,
      sym__tbl_seq,
    STATE(1436), 1,
      sym_var,
    STATE(1815), 1,
      sym_prefixexp,
    STATE(2029), 1,
      sym_exp,
    STATE(2776), 1,
      sym__prefixexp,
    STATE(2778), 1,
      sym__tbl_method,
    ACTIONS(1537), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1170), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2010), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [64775] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(812), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2179), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [64858] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1529), 1,
      sym_name,
    ACTIONS(1533), 1,
      anon_sym_function,
    ACTIONS(1535), 1,
      anon_sym_if,
    ACTIONS(1539), 1,
      anon_sym_not,
    ACTIONS(1541), 1,
      anon_sym_LBRACE,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1547), 1,
      sym_number,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1555), 1,
      sym_interp_start,
    STATE(813), 1,
      sym_comment,
    STATE(1152), 1,
      sym__tbl_seq,
    STATE(1436), 1,
      sym_var,
    STATE(1815), 1,
      sym_prefixexp,
    STATE(2024), 1,
      sym_exp,
    STATE(2776), 1,
      sym__prefixexp,
    STATE(2778), 1,
      sym__tbl_method,
    ACTIONS(1537), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1170), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2010), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [64941] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1529), 1,
      sym_name,
    ACTIONS(1533), 1,
      anon_sym_function,
    ACTIONS(1535), 1,
      anon_sym_if,
    ACTIONS(1539), 1,
      anon_sym_not,
    ACTIONS(1541), 1,
      anon_sym_LBRACE,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1547), 1,
      sym_number,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1555), 1,
      sym_interp_start,
    STATE(814), 1,
      sym_comment,
    STATE(1152), 1,
      sym__tbl_seq,
    STATE(1436), 1,
      sym_var,
    STATE(1815), 1,
      sym_prefixexp,
    STATE(2030), 1,
      sym_exp,
    STATE(2776), 1,
      sym__prefixexp,
    STATE(2778), 1,
      sym__tbl_method,
    ACTIONS(1537), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1170), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2010), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [65024] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1529), 1,
      sym_name,
    ACTIONS(1533), 1,
      anon_sym_function,
    ACTIONS(1535), 1,
      anon_sym_if,
    ACTIONS(1539), 1,
      anon_sym_not,
    ACTIONS(1541), 1,
      anon_sym_LBRACE,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1547), 1,
      sym_number,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1555), 1,
      sym_interp_start,
    STATE(815), 1,
      sym_comment,
    STATE(1152), 1,
      sym__tbl_seq,
    STATE(1436), 1,
      sym_var,
    STATE(1815), 1,
      sym_prefixexp,
    STATE(2031), 1,
      sym_exp,
    STATE(2776), 1,
      sym__prefixexp,
    STATE(2778), 1,
      sym__tbl_method,
    ACTIONS(1537), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1170), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2010), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [65107] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1529), 1,
      sym_name,
    ACTIONS(1533), 1,
      anon_sym_function,
    ACTIONS(1535), 1,
      anon_sym_if,
    ACTIONS(1539), 1,
      anon_sym_not,
    ACTIONS(1541), 1,
      anon_sym_LBRACE,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1547), 1,
      sym_number,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1555), 1,
      sym_interp_start,
    STATE(816), 1,
      sym_comment,
    STATE(1152), 1,
      sym__tbl_seq,
    STATE(1436), 1,
      sym_var,
    STATE(1815), 1,
      sym_prefixexp,
    STATE(2032), 1,
      sym_exp,
    STATE(2776), 1,
      sym__prefixexp,
    STATE(2778), 1,
      sym__tbl_method,
    ACTIONS(1537), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1170), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2010), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [65190] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1529), 1,
      sym_name,
    ACTIONS(1533), 1,
      anon_sym_function,
    ACTIONS(1535), 1,
      anon_sym_if,
    ACTIONS(1539), 1,
      anon_sym_not,
    ACTIONS(1541), 1,
      anon_sym_LBRACE,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1547), 1,
      sym_number,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1555), 1,
      sym_interp_start,
    STATE(817), 1,
      sym_comment,
    STATE(1152), 1,
      sym__tbl_seq,
    STATE(1436), 1,
      sym_var,
    STATE(1815), 1,
      sym_prefixexp,
    STATE(2033), 1,
      sym_exp,
    STATE(2776), 1,
      sym__prefixexp,
    STATE(2778), 1,
      sym__tbl_method,
    ACTIONS(1537), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1170), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2010), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [65273] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1529), 1,
      sym_name,
    ACTIONS(1533), 1,
      anon_sym_function,
    ACTIONS(1535), 1,
      anon_sym_if,
    ACTIONS(1539), 1,
      anon_sym_not,
    ACTIONS(1541), 1,
      anon_sym_LBRACE,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1547), 1,
      sym_number,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1555), 1,
      sym_interp_start,
    STATE(818), 1,
      sym_comment,
    STATE(1152), 1,
      sym__tbl_seq,
    STATE(1436), 1,
      sym_var,
    STATE(1815), 1,
      sym_prefixexp,
    STATE(2034), 1,
      sym_exp,
    STATE(2776), 1,
      sym__prefixexp,
    STATE(2778), 1,
      sym__tbl_method,
    ACTIONS(1537), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1170), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2010), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [65356] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1529), 1,
      sym_name,
    ACTIONS(1533), 1,
      anon_sym_function,
    ACTIONS(1535), 1,
      anon_sym_if,
    ACTIONS(1539), 1,
      anon_sym_not,
    ACTIONS(1541), 1,
      anon_sym_LBRACE,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1547), 1,
      sym_number,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1555), 1,
      sym_interp_start,
    STATE(819), 1,
      sym_comment,
    STATE(1152), 1,
      sym__tbl_seq,
    STATE(1436), 1,
      sym_var,
    STATE(1815), 1,
      sym_prefixexp,
    STATE(2035), 1,
      sym_exp,
    STATE(2776), 1,
      sym__prefixexp,
    STATE(2778), 1,
      sym__tbl_method,
    ACTIONS(1537), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1170), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2010), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [65439] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1683), 1,
      sym_name,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1687), 1,
      anon_sym_if,
    ACTIONS(1691), 1,
      anon_sym_not,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      anon_sym_LPAREN,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1699), 1,
      sym_number,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1707), 1,
      sym_interp_start,
    STATE(251), 1,
      sym__tbl_seq,
    STATE(353), 1,
      sym_var,
    STATE(452), 1,
      sym_prefixexp,
    STATE(655), 1,
      sym_exp,
    STATE(820), 1,
      sym_comment,
    STATE(2818), 1,
      sym__prefixexp,
    STATE(2819), 1,
      sym__tbl_method,
    ACTIONS(1689), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(250), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(626), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [65522] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1765), 1,
      sym_name,
    ACTIONS(1767), 1,
      anon_sym_function,
    ACTIONS(1769), 1,
      anon_sym_if,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1775), 1,
      anon_sym_LBRACE,
    ACTIONS(1777), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1781), 1,
      sym_number,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1789), 1,
      sym_interp_start,
    STATE(248), 1,
      sym__tbl_seq,
    STATE(408), 1,
      sym_var,
    STATE(482), 1,
      sym_prefixexp,
    STATE(639), 1,
      sym_exp,
    STATE(821), 1,
      sym_comment,
    STATE(2796), 1,
      sym__prefixexp,
    STATE(2797), 1,
      sym__tbl_method,
    ACTIONS(1771), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(247), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(673), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [65605] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1529), 1,
      sym_name,
    ACTIONS(1533), 1,
      anon_sym_function,
    ACTIONS(1535), 1,
      anon_sym_if,
    ACTIONS(1539), 1,
      anon_sym_not,
    ACTIONS(1541), 1,
      anon_sym_LBRACE,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1547), 1,
      sym_number,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1555), 1,
      sym_interp_start,
    STATE(822), 1,
      sym_comment,
    STATE(1152), 1,
      sym__tbl_seq,
    STATE(1436), 1,
      sym_var,
    STATE(1815), 1,
      sym_prefixexp,
    STATE(2060), 1,
      sym_exp,
    STATE(2776), 1,
      sym__prefixexp,
    STATE(2778), 1,
      sym__tbl_method,
    ACTIONS(1537), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1170), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2010), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [65688] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1529), 1,
      sym_name,
    ACTIONS(1533), 1,
      anon_sym_function,
    ACTIONS(1535), 1,
      anon_sym_if,
    ACTIONS(1539), 1,
      anon_sym_not,
    ACTIONS(1541), 1,
      anon_sym_LBRACE,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1547), 1,
      sym_number,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1555), 1,
      sym_interp_start,
    STATE(823), 1,
      sym_comment,
    STATE(1152), 1,
      sym__tbl_seq,
    STATE(1436), 1,
      sym_var,
    STATE(1815), 1,
      sym_prefixexp,
    STATE(2066), 1,
      sym_exp,
    STATE(2776), 1,
      sym__prefixexp,
    STATE(2778), 1,
      sym__tbl_method,
    ACTIONS(1537), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1170), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2010), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [65771] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1735), 1,
      sym_name,
    ACTIONS(1737), 1,
      anon_sym_function,
    ACTIONS(1739), 1,
      anon_sym_if,
    ACTIONS(1743), 1,
      anon_sym_not,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1751), 1,
      sym_number,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1759), 1,
      sym_interp_start,
    STATE(227), 1,
      sym__tbl_seq,
    STATE(315), 1,
      sym_var,
    STATE(343), 1,
      sym_prefixexp,
    STATE(494), 1,
      sym_exp,
    STATE(824), 1,
      sym_comment,
    STATE(2834), 1,
      sym__prefixexp,
    STATE(2835), 1,
      sym__tbl_method,
    ACTIONS(1741), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(228), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(486), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [65854] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1735), 1,
      sym_name,
    ACTIONS(1737), 1,
      anon_sym_function,
    ACTIONS(1739), 1,
      anon_sym_if,
    ACTIONS(1743), 1,
      anon_sym_not,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1751), 1,
      sym_number,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1759), 1,
      sym_interp_start,
    STATE(227), 1,
      sym__tbl_seq,
    STATE(315), 1,
      sym_var,
    STATE(343), 1,
      sym_prefixexp,
    STATE(496), 1,
      sym_exp,
    STATE(825), 1,
      sym_comment,
    STATE(2834), 1,
      sym__prefixexp,
    STATE(2835), 1,
      sym__tbl_method,
    ACTIONS(1741), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(228), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(486), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [65937] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1735), 1,
      sym_name,
    ACTIONS(1737), 1,
      anon_sym_function,
    ACTIONS(1739), 1,
      anon_sym_if,
    ACTIONS(1743), 1,
      anon_sym_not,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1751), 1,
      sym_number,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1759), 1,
      sym_interp_start,
    STATE(227), 1,
      sym__tbl_seq,
    STATE(315), 1,
      sym_var,
    STATE(343), 1,
      sym_prefixexp,
    STATE(497), 1,
      sym_exp,
    STATE(826), 1,
      sym_comment,
    STATE(2834), 1,
      sym__prefixexp,
    STATE(2835), 1,
      sym__tbl_method,
    ACTIONS(1741), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(228), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(486), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [66020] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1735), 1,
      sym_name,
    ACTIONS(1737), 1,
      anon_sym_function,
    ACTIONS(1739), 1,
      anon_sym_if,
    ACTIONS(1743), 1,
      anon_sym_not,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1751), 1,
      sym_number,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1759), 1,
      sym_interp_start,
    STATE(227), 1,
      sym__tbl_seq,
    STATE(315), 1,
      sym_var,
    STATE(343), 1,
      sym_prefixexp,
    STATE(498), 1,
      sym_exp,
    STATE(827), 1,
      sym_comment,
    STATE(2834), 1,
      sym__prefixexp,
    STATE(2835), 1,
      sym__tbl_method,
    ACTIONS(1741), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(228), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(486), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [66103] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1735), 1,
      sym_name,
    ACTIONS(1737), 1,
      anon_sym_function,
    ACTIONS(1739), 1,
      anon_sym_if,
    ACTIONS(1743), 1,
      anon_sym_not,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1751), 1,
      sym_number,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1759), 1,
      sym_interp_start,
    STATE(227), 1,
      sym__tbl_seq,
    STATE(315), 1,
      sym_var,
    STATE(343), 1,
      sym_prefixexp,
    STATE(499), 1,
      sym_exp,
    STATE(828), 1,
      sym_comment,
    STATE(2834), 1,
      sym__prefixexp,
    STATE(2835), 1,
      sym__tbl_method,
    ACTIONS(1741), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(228), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(486), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [66186] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1735), 1,
      sym_name,
    ACTIONS(1737), 1,
      anon_sym_function,
    ACTIONS(1739), 1,
      anon_sym_if,
    ACTIONS(1743), 1,
      anon_sym_not,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1751), 1,
      sym_number,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1759), 1,
      sym_interp_start,
    STATE(227), 1,
      sym__tbl_seq,
    STATE(315), 1,
      sym_var,
    STATE(343), 1,
      sym_prefixexp,
    STATE(500), 1,
      sym_exp,
    STATE(829), 1,
      sym_comment,
    STATE(2834), 1,
      sym__prefixexp,
    STATE(2835), 1,
      sym__tbl_method,
    ACTIONS(1741), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(228), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(486), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [66269] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1735), 1,
      sym_name,
    ACTIONS(1737), 1,
      anon_sym_function,
    ACTIONS(1739), 1,
      anon_sym_if,
    ACTIONS(1743), 1,
      anon_sym_not,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1751), 1,
      sym_number,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1759), 1,
      sym_interp_start,
    STATE(227), 1,
      sym__tbl_seq,
    STATE(315), 1,
      sym_var,
    STATE(343), 1,
      sym_prefixexp,
    STATE(501), 1,
      sym_exp,
    STATE(830), 1,
      sym_comment,
    STATE(2834), 1,
      sym__prefixexp,
    STATE(2835), 1,
      sym__tbl_method,
    ACTIONS(1741), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(228), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(486), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [66352] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1709), 1,
      sym_name,
    ACTIONS(1711), 1,
      anon_sym_function,
    ACTIONS(1713), 1,
      anon_sym_if,
    ACTIONS(1717), 1,
      anon_sym_not,
    ACTIONS(1719), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1725), 1,
      sym_number,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(1733), 1,
      sym_interp_start,
    STATE(232), 1,
      sym__tbl_seq,
    STATE(371), 1,
      sym_var,
    STATE(483), 1,
      sym_prefixexp,
    STATE(610), 1,
      sym_exp,
    STATE(831), 1,
      sym_comment,
    STATE(2782), 1,
      sym__prefixexp,
    STATE(2786), 1,
      sym__tbl_method,
    ACTIONS(1715), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(258), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(615), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [66435] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1843), 1,
      sym_name,
    ACTIONS(1845), 1,
      anon_sym_function,
    ACTIONS(1847), 1,
      anon_sym_if,
    ACTIONS(1851), 1,
      anon_sym_not,
    ACTIONS(1853), 1,
      anon_sym_LBRACE,
    ACTIONS(1855), 1,
      anon_sym_LPAREN,
    ACTIONS(1857), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1859), 1,
      sym_number,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1867), 1,
      sym_interp_start,
    STATE(832), 1,
      sym_comment,
    STATE(1235), 1,
      sym__tbl_seq,
    STATE(1793), 1,
      sym_var,
    STATE(2095), 1,
      sym_prefixexp,
    STATE(2528), 1,
      sym_exp,
    STATE(2780), 1,
      sym__prefixexp,
    STATE(2783), 1,
      sym__tbl_method,
    ACTIONS(1849), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1187), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2510), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [66518] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(833), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2524), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [66601] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(834), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2443), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [66684] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1735), 1,
      sym_name,
    ACTIONS(1737), 1,
      anon_sym_function,
    ACTIONS(1739), 1,
      anon_sym_if,
    ACTIONS(1743), 1,
      anon_sym_not,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1751), 1,
      sym_number,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1759), 1,
      sym_interp_start,
    STATE(227), 1,
      sym__tbl_seq,
    STATE(315), 1,
      sym_var,
    STATE(343), 1,
      sym_prefixexp,
    STATE(442), 1,
      sym_exp,
    STATE(835), 1,
      sym_comment,
    STATE(2834), 1,
      sym__prefixexp,
    STATE(2835), 1,
      sym__tbl_method,
    ACTIONS(1741), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(228), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(486), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [66767] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1765), 1,
      sym_name,
    ACTIONS(1767), 1,
      anon_sym_function,
    ACTIONS(1769), 1,
      anon_sym_if,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1775), 1,
      anon_sym_LBRACE,
    ACTIONS(1777), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1781), 1,
      sym_number,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1789), 1,
      sym_interp_start,
    STATE(248), 1,
      sym__tbl_seq,
    STATE(408), 1,
      sym_var,
    STATE(482), 1,
      sym_prefixexp,
    STATE(657), 1,
      sym_exp,
    STATE(836), 1,
      sym_comment,
    STATE(2796), 1,
      sym__prefixexp,
    STATE(2797), 1,
      sym__tbl_method,
    ACTIONS(1771), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(247), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(673), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [66850] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1123), 1,
      sym_name,
    ACTIONS(1127), 1,
      anon_sym_function,
    ACTIONS(1131), 1,
      anon_sym_if,
    ACTIONS(1135), 1,
      anon_sym_not,
    ACTIONS(1137), 1,
      anon_sym_LBRACE,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1143), 1,
      sym_number,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1151), 1,
      sym_interp_start,
    STATE(837), 1,
      sym_comment,
    STATE(1101), 1,
      sym__tbl_seq,
    STATE(1224), 1,
      sym_var,
    STATE(1431), 1,
      sym_prefixexp,
    STATE(1842), 1,
      sym_exp,
    STATE(2793), 1,
      sym__prefixexp,
    STATE(2794), 1,
      sym__tbl_method,
    ACTIONS(1133), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1100), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1783), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [66933] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1683), 1,
      sym_name,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1687), 1,
      anon_sym_if,
    ACTIONS(1691), 1,
      anon_sym_not,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      anon_sym_LPAREN,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1699), 1,
      sym_number,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1707), 1,
      sym_interp_start,
    STATE(251), 1,
      sym__tbl_seq,
    STATE(353), 1,
      sym_var,
    STATE(452), 1,
      sym_prefixexp,
    STATE(672), 1,
      sym_exp,
    STATE(838), 1,
      sym_comment,
    STATE(2818), 1,
      sym__prefixexp,
    STATE(2819), 1,
      sym__tbl_method,
    ACTIONS(1689), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(250), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(626), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [67016] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1765), 1,
      sym_name,
    ACTIONS(1767), 1,
      anon_sym_function,
    ACTIONS(1769), 1,
      anon_sym_if,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1775), 1,
      anon_sym_LBRACE,
    ACTIONS(1777), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1781), 1,
      sym_number,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1789), 1,
      sym_interp_start,
    STATE(248), 1,
      sym__tbl_seq,
    STATE(408), 1,
      sym_var,
    STATE(482), 1,
      sym_prefixexp,
    STATE(659), 1,
      sym_exp,
    STATE(839), 1,
      sym_comment,
    STATE(2796), 1,
      sym__prefixexp,
    STATE(2797), 1,
      sym__tbl_method,
    ACTIONS(1771), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(247), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(673), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [67099] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1765), 1,
      sym_name,
    ACTIONS(1767), 1,
      anon_sym_function,
    ACTIONS(1769), 1,
      anon_sym_if,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1775), 1,
      anon_sym_LBRACE,
    ACTIONS(1777), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1781), 1,
      sym_number,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1789), 1,
      sym_interp_start,
    STATE(248), 1,
      sym__tbl_seq,
    STATE(408), 1,
      sym_var,
    STATE(482), 1,
      sym_prefixexp,
    STATE(577), 1,
      sym_exp,
    STATE(840), 1,
      sym_comment,
    STATE(2796), 1,
      sym__prefixexp,
    STATE(2797), 1,
      sym__tbl_method,
    ACTIONS(1771), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(247), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(673), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [67182] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1735), 1,
      sym_name,
    ACTIONS(1737), 1,
      anon_sym_function,
    ACTIONS(1739), 1,
      anon_sym_if,
    ACTIONS(1743), 1,
      anon_sym_not,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1751), 1,
      sym_number,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1759), 1,
      sym_interp_start,
    STATE(227), 1,
      sym__tbl_seq,
    STATE(315), 1,
      sym_var,
    STATE(343), 1,
      sym_prefixexp,
    STATE(443), 1,
      sym_exp,
    STATE(841), 1,
      sym_comment,
    STATE(2834), 1,
      sym__prefixexp,
    STATE(2835), 1,
      sym__tbl_method,
    ACTIONS(1741), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(228), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(486), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [67265] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1765), 1,
      sym_name,
    ACTIONS(1767), 1,
      anon_sym_function,
    ACTIONS(1769), 1,
      anon_sym_if,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1775), 1,
      anon_sym_LBRACE,
    ACTIONS(1777), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1781), 1,
      sym_number,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1789), 1,
      sym_interp_start,
    STATE(248), 1,
      sym__tbl_seq,
    STATE(408), 1,
      sym_var,
    STATE(482), 1,
      sym_prefixexp,
    STATE(579), 1,
      sym_exp,
    STATE(842), 1,
      sym_comment,
    STATE(2796), 1,
      sym__prefixexp,
    STATE(2797), 1,
      sym__tbl_method,
    ACTIONS(1771), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(247), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(673), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [67348] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1765), 1,
      sym_name,
    ACTIONS(1767), 1,
      anon_sym_function,
    ACTIONS(1769), 1,
      anon_sym_if,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1775), 1,
      anon_sym_LBRACE,
    ACTIONS(1777), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1781), 1,
      sym_number,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1789), 1,
      sym_interp_start,
    STATE(248), 1,
      sym__tbl_seq,
    STATE(408), 1,
      sym_var,
    STATE(482), 1,
      sym_prefixexp,
    STATE(617), 1,
      sym_exp,
    STATE(843), 1,
      sym_comment,
    STATE(2796), 1,
      sym__prefixexp,
    STATE(2797), 1,
      sym__tbl_method,
    ACTIONS(1771), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(247), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(673), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [67431] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1765), 1,
      sym_name,
    ACTIONS(1767), 1,
      anon_sym_function,
    ACTIONS(1769), 1,
      anon_sym_if,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1775), 1,
      anon_sym_LBRACE,
    ACTIONS(1777), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1781), 1,
      sym_number,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1789), 1,
      sym_interp_start,
    STATE(248), 1,
      sym__tbl_seq,
    STATE(408), 1,
      sym_var,
    STATE(482), 1,
      sym_prefixexp,
    STATE(621), 1,
      sym_exp,
    STATE(844), 1,
      sym_comment,
    STATE(2796), 1,
      sym__prefixexp,
    STATE(2797), 1,
      sym__tbl_method,
    ACTIONS(1771), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(247), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(673), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [67514] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1765), 1,
      sym_name,
    ACTIONS(1767), 1,
      anon_sym_function,
    ACTIONS(1769), 1,
      anon_sym_if,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1775), 1,
      anon_sym_LBRACE,
    ACTIONS(1777), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1781), 1,
      sym_number,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1789), 1,
      sym_interp_start,
    STATE(248), 1,
      sym__tbl_seq,
    STATE(408), 1,
      sym_var,
    STATE(482), 1,
      sym_prefixexp,
    STATE(562), 1,
      sym_exp,
    STATE(845), 1,
      sym_comment,
    STATE(2796), 1,
      sym__prefixexp,
    STATE(2797), 1,
      sym__tbl_method,
    ACTIONS(1771), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(247), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(673), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [67597] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1765), 1,
      sym_name,
    ACTIONS(1767), 1,
      anon_sym_function,
    ACTIONS(1769), 1,
      anon_sym_if,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1775), 1,
      anon_sym_LBRACE,
    ACTIONS(1777), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1781), 1,
      sym_number,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1789), 1,
      sym_interp_start,
    STATE(248), 1,
      sym__tbl_seq,
    STATE(408), 1,
      sym_var,
    STATE(482), 1,
      sym_prefixexp,
    STATE(720), 1,
      sym_exp,
    STATE(846), 1,
      sym_comment,
    STATE(2796), 1,
      sym__prefixexp,
    STATE(2797), 1,
      sym__tbl_method,
    ACTIONS(1771), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(247), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(673), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [67680] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1735), 1,
      sym_name,
    ACTIONS(1737), 1,
      anon_sym_function,
    ACTIONS(1739), 1,
      anon_sym_if,
    ACTIONS(1743), 1,
      anon_sym_not,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1751), 1,
      sym_number,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1759), 1,
      sym_interp_start,
    STATE(227), 1,
      sym__tbl_seq,
    STATE(315), 1,
      sym_var,
    STATE(343), 1,
      sym_prefixexp,
    STATE(446), 1,
      sym_exp,
    STATE(847), 1,
      sym_comment,
    STATE(2834), 1,
      sym__prefixexp,
    STATE(2835), 1,
      sym__tbl_method,
    ACTIONS(1741), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(228), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(486), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [67763] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1709), 1,
      sym_name,
    ACTIONS(1711), 1,
      anon_sym_function,
    ACTIONS(1713), 1,
      anon_sym_if,
    ACTIONS(1717), 1,
      anon_sym_not,
    ACTIONS(1719), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1725), 1,
      sym_number,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(1733), 1,
      sym_interp_start,
    STATE(232), 1,
      sym__tbl_seq,
    STATE(371), 1,
      sym_var,
    STATE(483), 1,
      sym_prefixexp,
    STATE(684), 1,
      sym_exp,
    STATE(848), 1,
      sym_comment,
    STATE(2782), 1,
      sym__prefixexp,
    STATE(2786), 1,
      sym__tbl_method,
    ACTIONS(1715), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(258), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(615), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [67846] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(849), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2335), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [67929] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1765), 1,
      sym_name,
    ACTIONS(1767), 1,
      anon_sym_function,
    ACTIONS(1769), 1,
      anon_sym_if,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1775), 1,
      anon_sym_LBRACE,
    ACTIONS(1777), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1781), 1,
      sym_number,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1789), 1,
      sym_interp_start,
    STATE(248), 1,
      sym__tbl_seq,
    STATE(408), 1,
      sym_var,
    STATE(482), 1,
      sym_prefixexp,
    STATE(565), 1,
      sym_exp,
    STATE(850), 1,
      sym_comment,
    STATE(2796), 1,
      sym__prefixexp,
    STATE(2797), 1,
      sym__tbl_method,
    ACTIONS(1771), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(247), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(673), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [68012] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1765), 1,
      sym_name,
    ACTIONS(1767), 1,
      anon_sym_function,
    ACTIONS(1769), 1,
      anon_sym_if,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1775), 1,
      anon_sym_LBRACE,
    ACTIONS(1777), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1781), 1,
      sym_number,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1789), 1,
      sym_interp_start,
    STATE(248), 1,
      sym__tbl_seq,
    STATE(408), 1,
      sym_var,
    STATE(482), 1,
      sym_prefixexp,
    STATE(591), 1,
      sym_exp,
    STATE(851), 1,
      sym_comment,
    STATE(2796), 1,
      sym__prefixexp,
    STATE(2797), 1,
      sym__tbl_method,
    ACTIONS(1771), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(247), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(673), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [68095] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(852), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2241), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [68178] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(853), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2482), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [68261] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(854), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(2162), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [68344] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1843), 1,
      sym_name,
    ACTIONS(1845), 1,
      anon_sym_function,
    ACTIONS(1847), 1,
      anon_sym_if,
    ACTIONS(1851), 1,
      anon_sym_not,
    ACTIONS(1853), 1,
      anon_sym_LBRACE,
    ACTIONS(1855), 1,
      anon_sym_LPAREN,
    ACTIONS(1857), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1859), 1,
      sym_number,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1867), 1,
      sym_interp_start,
    STATE(855), 1,
      sym_comment,
    STATE(1235), 1,
      sym__tbl_seq,
    STATE(1793), 1,
      sym_var,
    STATE(2095), 1,
      sym_prefixexp,
    STATE(2336), 1,
      sym_exp,
    STATE(2780), 1,
      sym__prefixexp,
    STATE(2783), 1,
      sym__tbl_method,
    ACTIONS(1849), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1187), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2510), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [68427] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1843), 1,
      sym_name,
    ACTIONS(1845), 1,
      anon_sym_function,
    ACTIONS(1847), 1,
      anon_sym_if,
    ACTIONS(1851), 1,
      anon_sym_not,
    ACTIONS(1853), 1,
      anon_sym_LBRACE,
    ACTIONS(1855), 1,
      anon_sym_LPAREN,
    ACTIONS(1857), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1859), 1,
      sym_number,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1867), 1,
      sym_interp_start,
    STATE(856), 1,
      sym_comment,
    STATE(1235), 1,
      sym__tbl_seq,
    STATE(1793), 1,
      sym_var,
    STATE(2095), 1,
      sym_prefixexp,
    STATE(2192), 1,
      sym_exp,
    STATE(2780), 1,
      sym__prefixexp,
    STATE(2783), 1,
      sym__tbl_method,
    ACTIONS(1849), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1187), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2510), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [68510] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1843), 1,
      sym_name,
    ACTIONS(1845), 1,
      anon_sym_function,
    ACTIONS(1847), 1,
      anon_sym_if,
    ACTIONS(1851), 1,
      anon_sym_not,
    ACTIONS(1853), 1,
      anon_sym_LBRACE,
    ACTIONS(1855), 1,
      anon_sym_LPAREN,
    ACTIONS(1857), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1859), 1,
      sym_number,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1867), 1,
      sym_interp_start,
    STATE(857), 1,
      sym_comment,
    STATE(1235), 1,
      sym__tbl_seq,
    STATE(1793), 1,
      sym_var,
    STATE(2095), 1,
      sym_prefixexp,
    STATE(2362), 1,
      sym_exp,
    STATE(2780), 1,
      sym__prefixexp,
    STATE(2783), 1,
      sym__tbl_method,
    ACTIONS(1849), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1187), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2510), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [68593] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1843), 1,
      sym_name,
    ACTIONS(1845), 1,
      anon_sym_function,
    ACTIONS(1847), 1,
      anon_sym_if,
    ACTIONS(1851), 1,
      anon_sym_not,
    ACTIONS(1853), 1,
      anon_sym_LBRACE,
    ACTIONS(1855), 1,
      anon_sym_LPAREN,
    ACTIONS(1857), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1859), 1,
      sym_number,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1867), 1,
      sym_interp_start,
    STATE(858), 1,
      sym_comment,
    STATE(1235), 1,
      sym__tbl_seq,
    STATE(1793), 1,
      sym_var,
    STATE(2095), 1,
      sym_prefixexp,
    STATE(2365), 1,
      sym_exp,
    STATE(2780), 1,
      sym__prefixexp,
    STATE(2783), 1,
      sym__tbl_method,
    ACTIONS(1849), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1187), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2510), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [68676] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1843), 1,
      sym_name,
    ACTIONS(1845), 1,
      anon_sym_function,
    ACTIONS(1847), 1,
      anon_sym_if,
    ACTIONS(1851), 1,
      anon_sym_not,
    ACTIONS(1853), 1,
      anon_sym_LBRACE,
    ACTIONS(1855), 1,
      anon_sym_LPAREN,
    ACTIONS(1857), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1859), 1,
      sym_number,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1867), 1,
      sym_interp_start,
    STATE(859), 1,
      sym_comment,
    STATE(1235), 1,
      sym__tbl_seq,
    STATE(1793), 1,
      sym_var,
    STATE(2095), 1,
      sym_prefixexp,
    STATE(2366), 1,
      sym_exp,
    STATE(2780), 1,
      sym__prefixexp,
    STATE(2783), 1,
      sym__tbl_method,
    ACTIONS(1849), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1187), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2510), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [68759] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1843), 1,
      sym_name,
    ACTIONS(1845), 1,
      anon_sym_function,
    ACTIONS(1847), 1,
      anon_sym_if,
    ACTIONS(1851), 1,
      anon_sym_not,
    ACTIONS(1853), 1,
      anon_sym_LBRACE,
    ACTIONS(1855), 1,
      anon_sym_LPAREN,
    ACTIONS(1857), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1859), 1,
      sym_number,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1867), 1,
      sym_interp_start,
    STATE(860), 1,
      sym_comment,
    STATE(1235), 1,
      sym__tbl_seq,
    STATE(1793), 1,
      sym_var,
    STATE(2095), 1,
      sym_prefixexp,
    STATE(2440), 1,
      sym_exp,
    STATE(2780), 1,
      sym__prefixexp,
    STATE(2783), 1,
      sym__tbl_method,
    ACTIONS(1849), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1187), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2510), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [68842] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1843), 1,
      sym_name,
    ACTIONS(1845), 1,
      anon_sym_function,
    ACTIONS(1847), 1,
      anon_sym_if,
    ACTIONS(1851), 1,
      anon_sym_not,
    ACTIONS(1853), 1,
      anon_sym_LBRACE,
    ACTIONS(1855), 1,
      anon_sym_LPAREN,
    ACTIONS(1857), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1859), 1,
      sym_number,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1867), 1,
      sym_interp_start,
    STATE(861), 1,
      sym_comment,
    STATE(1235), 1,
      sym__tbl_seq,
    STATE(1793), 1,
      sym_var,
    STATE(2095), 1,
      sym_prefixexp,
    STATE(2448), 1,
      sym_exp,
    STATE(2780), 1,
      sym__prefixexp,
    STATE(2783), 1,
      sym__tbl_method,
    ACTIONS(1849), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1187), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2510), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [68925] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1123), 1,
      sym_name,
    ACTIONS(1127), 1,
      anon_sym_function,
    ACTIONS(1131), 1,
      anon_sym_if,
    ACTIONS(1135), 1,
      anon_sym_not,
    ACTIONS(1137), 1,
      anon_sym_LBRACE,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1143), 1,
      sym_number,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1151), 1,
      sym_interp_start,
    STATE(862), 1,
      sym_comment,
    STATE(1101), 1,
      sym__tbl_seq,
    STATE(1224), 1,
      sym_var,
    STATE(1431), 1,
      sym_prefixexp,
    STATE(1814), 1,
      sym_exp,
    STATE(2793), 1,
      sym__prefixexp,
    STATE(2794), 1,
      sym__tbl_method,
    ACTIONS(1133), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1100), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1783), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [69008] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(863), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2109), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [69091] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(864), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2478), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [69174] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1843), 1,
      sym_name,
    ACTIONS(1845), 1,
      anon_sym_function,
    ACTIONS(1847), 1,
      anon_sym_if,
    ACTIONS(1851), 1,
      anon_sym_not,
    ACTIONS(1853), 1,
      anon_sym_LBRACE,
    ACTIONS(1855), 1,
      anon_sym_LPAREN,
    ACTIONS(1857), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1859), 1,
      sym_number,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1867), 1,
      sym_interp_start,
    STATE(865), 1,
      sym_comment,
    STATE(1235), 1,
      sym__tbl_seq,
    STATE(1793), 1,
      sym_var,
    STATE(2095), 1,
      sym_prefixexp,
    STATE(2360), 1,
      sym_exp,
    STATE(2780), 1,
      sym__prefixexp,
    STATE(2783), 1,
      sym__tbl_method,
    ACTIONS(1849), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1187), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2510), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [69257] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1843), 1,
      sym_name,
    ACTIONS(1845), 1,
      anon_sym_function,
    ACTIONS(1847), 1,
      anon_sym_if,
    ACTIONS(1851), 1,
      anon_sym_not,
    ACTIONS(1853), 1,
      anon_sym_LBRACE,
    ACTIONS(1855), 1,
      anon_sym_LPAREN,
    ACTIONS(1857), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1859), 1,
      sym_number,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1867), 1,
      sym_interp_start,
    STATE(866), 1,
      sym_comment,
    STATE(1235), 1,
      sym__tbl_seq,
    STATE(1793), 1,
      sym_var,
    STATE(2095), 1,
      sym_prefixexp,
    STATE(2228), 1,
      sym_exp,
    STATE(2780), 1,
      sym__prefixexp,
    STATE(2783), 1,
      sym__tbl_method,
    ACTIONS(1849), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1187), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2510), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [69340] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1765), 1,
      sym_name,
    ACTIONS(1767), 1,
      anon_sym_function,
    ACTIONS(1769), 1,
      anon_sym_if,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1775), 1,
      anon_sym_LBRACE,
    ACTIONS(1777), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1781), 1,
      sym_number,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1789), 1,
      sym_interp_start,
    STATE(248), 1,
      sym__tbl_seq,
    STATE(408), 1,
      sym_var,
    STATE(482), 1,
      sym_prefixexp,
    STATE(721), 1,
      sym_exp,
    STATE(867), 1,
      sym_comment,
    STATE(2796), 1,
      sym__prefixexp,
    STATE(2797), 1,
      sym__tbl_method,
    ACTIONS(1771), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(247), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(673), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [69423] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(868), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2453), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [69506] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1735), 1,
      sym_name,
    ACTIONS(1737), 1,
      anon_sym_function,
    ACTIONS(1739), 1,
      anon_sym_if,
    ACTIONS(1743), 1,
      anon_sym_not,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1751), 1,
      sym_number,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1759), 1,
      sym_interp_start,
    STATE(227), 1,
      sym__tbl_seq,
    STATE(315), 1,
      sym_var,
    STATE(343), 1,
      sym_prefixexp,
    STATE(492), 1,
      sym_exp,
    STATE(869), 1,
      sym_comment,
    STATE(2834), 1,
      sym__prefixexp,
    STATE(2835), 1,
      sym__tbl_method,
    ACTIONS(1741), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(228), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(486), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [69589] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(870), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2422), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [69672] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(871), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1472), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [69755] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(872), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2015), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [69838] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1683), 1,
      sym_name,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1687), 1,
      anon_sym_if,
    ACTIONS(1691), 1,
      anon_sym_not,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      anon_sym_LPAREN,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1699), 1,
      sym_number,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1707), 1,
      sym_interp_start,
    STATE(251), 1,
      sym__tbl_seq,
    STATE(353), 1,
      sym_var,
    STATE(452), 1,
      sym_prefixexp,
    STATE(681), 1,
      sym_exp,
    STATE(873), 1,
      sym_comment,
    STATE(2818), 1,
      sym__prefixexp,
    STATE(2819), 1,
      sym__tbl_method,
    ACTIONS(1689), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(250), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(626), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [69921] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1683), 1,
      sym_name,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1687), 1,
      anon_sym_if,
    ACTIONS(1691), 1,
      anon_sym_not,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      anon_sym_LPAREN,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1699), 1,
      sym_number,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1707), 1,
      sym_interp_start,
    STATE(251), 1,
      sym__tbl_seq,
    STATE(353), 1,
      sym_var,
    STATE(452), 1,
      sym_prefixexp,
    STATE(683), 1,
      sym_exp,
    STATE(874), 1,
      sym_comment,
    STATE(2818), 1,
      sym__prefixexp,
    STATE(2819), 1,
      sym__tbl_method,
    ACTIONS(1689), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(250), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(626), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [70004] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1683), 1,
      sym_name,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1687), 1,
      anon_sym_if,
    ACTIONS(1691), 1,
      anon_sym_not,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      anon_sym_LPAREN,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1699), 1,
      sym_number,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1707), 1,
      sym_interp_start,
    STATE(251), 1,
      sym__tbl_seq,
    STATE(353), 1,
      sym_var,
    STATE(452), 1,
      sym_prefixexp,
    STATE(595), 1,
      sym_exp,
    STATE(875), 1,
      sym_comment,
    STATE(2818), 1,
      sym__prefixexp,
    STATE(2819), 1,
      sym__tbl_method,
    ACTIONS(1689), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(250), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(626), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [70087] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1683), 1,
      sym_name,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1687), 1,
      anon_sym_if,
    ACTIONS(1691), 1,
      anon_sym_not,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      anon_sym_LPAREN,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1699), 1,
      sym_number,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1707), 1,
      sym_interp_start,
    STATE(251), 1,
      sym__tbl_seq,
    STATE(353), 1,
      sym_var,
    STATE(452), 1,
      sym_prefixexp,
    STATE(596), 1,
      sym_exp,
    STATE(876), 1,
      sym_comment,
    STATE(2818), 1,
      sym__prefixexp,
    STATE(2819), 1,
      sym__tbl_method,
    ACTIONS(1689), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(250), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(626), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [70170] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1683), 1,
      sym_name,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1687), 1,
      anon_sym_if,
    ACTIONS(1691), 1,
      anon_sym_not,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      anon_sym_LPAREN,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1699), 1,
      sym_number,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1707), 1,
      sym_interp_start,
    STATE(251), 1,
      sym__tbl_seq,
    STATE(353), 1,
      sym_var,
    STATE(452), 1,
      sym_prefixexp,
    STATE(597), 1,
      sym_exp,
    STATE(877), 1,
      sym_comment,
    STATE(2818), 1,
      sym__prefixexp,
    STATE(2819), 1,
      sym__tbl_method,
    ACTIONS(1689), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(250), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(626), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [70253] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1683), 1,
      sym_name,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1687), 1,
      anon_sym_if,
    ACTIONS(1691), 1,
      anon_sym_not,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      anon_sym_LPAREN,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1699), 1,
      sym_number,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1707), 1,
      sym_interp_start,
    STATE(251), 1,
      sym__tbl_seq,
    STATE(353), 1,
      sym_var,
    STATE(452), 1,
      sym_prefixexp,
    STATE(598), 1,
      sym_exp,
    STATE(878), 1,
      sym_comment,
    STATE(2818), 1,
      sym__prefixexp,
    STATE(2819), 1,
      sym__tbl_method,
    ACTIONS(1689), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(250), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(626), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [70336] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1683), 1,
      sym_name,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1687), 1,
      anon_sym_if,
    ACTIONS(1691), 1,
      anon_sym_not,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      anon_sym_LPAREN,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1699), 1,
      sym_number,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1707), 1,
      sym_interp_start,
    STATE(251), 1,
      sym__tbl_seq,
    STATE(353), 1,
      sym_var,
    STATE(452), 1,
      sym_prefixexp,
    STATE(599), 1,
      sym_exp,
    STATE(879), 1,
      sym_comment,
    STATE(2818), 1,
      sym__prefixexp,
    STATE(2819), 1,
      sym__tbl_method,
    ACTIONS(1689), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(250), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(626), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [70419] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1683), 1,
      sym_name,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1687), 1,
      anon_sym_if,
    ACTIONS(1691), 1,
      anon_sym_not,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      anon_sym_LPAREN,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1699), 1,
      sym_number,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1707), 1,
      sym_interp_start,
    STATE(251), 1,
      sym__tbl_seq,
    STATE(353), 1,
      sym_var,
    STATE(452), 1,
      sym_prefixexp,
    STATE(607), 1,
      sym_exp,
    STATE(880), 1,
      sym_comment,
    STATE(2818), 1,
      sym__prefixexp,
    STATE(2819), 1,
      sym__tbl_method,
    ACTIONS(1689), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(250), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(626), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [70502] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1683), 1,
      sym_name,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1687), 1,
      anon_sym_if,
    ACTIONS(1691), 1,
      anon_sym_not,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      anon_sym_LPAREN,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1699), 1,
      sym_number,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1707), 1,
      sym_interp_start,
    STATE(251), 1,
      sym__tbl_seq,
    STATE(353), 1,
      sym_var,
    STATE(452), 1,
      sym_prefixexp,
    STATE(609), 1,
      sym_exp,
    STATE(881), 1,
      sym_comment,
    STATE(2818), 1,
      sym__prefixexp,
    STATE(2819), 1,
      sym__tbl_method,
    ACTIONS(1689), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(250), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(626), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [70585] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1843), 1,
      sym_name,
    ACTIONS(1845), 1,
      anon_sym_function,
    ACTIONS(1847), 1,
      anon_sym_if,
    ACTIONS(1851), 1,
      anon_sym_not,
    ACTIONS(1853), 1,
      anon_sym_LBRACE,
    ACTIONS(1855), 1,
      anon_sym_LPAREN,
    ACTIONS(1857), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1859), 1,
      sym_number,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1867), 1,
      sym_interp_start,
    STATE(882), 1,
      sym_comment,
    STATE(1235), 1,
      sym__tbl_seq,
    STATE(1793), 1,
      sym_var,
    STATE(2095), 1,
      sym_prefixexp,
    STATE(2222), 1,
      sym_exp,
    STATE(2780), 1,
      sym__prefixexp,
    STATE(2783), 1,
      sym__tbl_method,
    ACTIONS(1849), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1187), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2510), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [70668] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(883), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2271), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [70751] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(884), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1889), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [70834] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(885), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1495), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [70917] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(886), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(3057), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3105), 1,
      sym_typeparam,
    STATE(3118), 1,
      sym_typepack,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [71000] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(887), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2196), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [71083] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(888), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1653), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [71166] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(889), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2220), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [71249] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1709), 1,
      sym_name,
    ACTIONS(1711), 1,
      anon_sym_function,
    ACTIONS(1713), 1,
      anon_sym_if,
    ACTIONS(1717), 1,
      anon_sym_not,
    ACTIONS(1719), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1725), 1,
      sym_number,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(1733), 1,
      sym_interp_start,
    STATE(232), 1,
      sym__tbl_seq,
    STATE(371), 1,
      sym_var,
    STATE(483), 1,
      sym_prefixexp,
    STATE(585), 1,
      sym_exp,
    STATE(890), 1,
      sym_comment,
    STATE(2782), 1,
      sym__prefixexp,
    STATE(2786), 1,
      sym__tbl_method,
    ACTIONS(1715), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(258), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(615), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [71332] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1709), 1,
      sym_name,
    ACTIONS(1711), 1,
      anon_sym_function,
    ACTIONS(1713), 1,
      anon_sym_if,
    ACTIONS(1717), 1,
      anon_sym_not,
    ACTIONS(1719), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1725), 1,
      sym_number,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(1733), 1,
      sym_interp_start,
    STATE(232), 1,
      sym__tbl_seq,
    STATE(371), 1,
      sym_var,
    STATE(483), 1,
      sym_prefixexp,
    STATE(586), 1,
      sym_exp,
    STATE(891), 1,
      sym_comment,
    STATE(2782), 1,
      sym__prefixexp,
    STATE(2786), 1,
      sym__tbl_method,
    ACTIONS(1715), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(258), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(615), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [71415] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1709), 1,
      sym_name,
    ACTIONS(1711), 1,
      anon_sym_function,
    ACTIONS(1713), 1,
      anon_sym_if,
    ACTIONS(1717), 1,
      anon_sym_not,
    ACTIONS(1719), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1725), 1,
      sym_number,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(1733), 1,
      sym_interp_start,
    STATE(232), 1,
      sym__tbl_seq,
    STATE(371), 1,
      sym_var,
    STATE(483), 1,
      sym_prefixexp,
    STATE(587), 1,
      sym_exp,
    STATE(892), 1,
      sym_comment,
    STATE(2782), 1,
      sym__prefixexp,
    STATE(2786), 1,
      sym__tbl_method,
    ACTIONS(1715), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(258), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(615), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [71498] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1709), 1,
      sym_name,
    ACTIONS(1711), 1,
      anon_sym_function,
    ACTIONS(1713), 1,
      anon_sym_if,
    ACTIONS(1717), 1,
      anon_sym_not,
    ACTIONS(1719), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1725), 1,
      sym_number,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(1733), 1,
      sym_interp_start,
    STATE(232), 1,
      sym__tbl_seq,
    STATE(371), 1,
      sym_var,
    STATE(483), 1,
      sym_prefixexp,
    STATE(589), 1,
      sym_exp,
    STATE(893), 1,
      sym_comment,
    STATE(2782), 1,
      sym__prefixexp,
    STATE(2786), 1,
      sym__tbl_method,
    ACTIONS(1715), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(258), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(615), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [71581] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1709), 1,
      sym_name,
    ACTIONS(1711), 1,
      anon_sym_function,
    ACTIONS(1713), 1,
      anon_sym_if,
    ACTIONS(1717), 1,
      anon_sym_not,
    ACTIONS(1719), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1725), 1,
      sym_number,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(1733), 1,
      sym_interp_start,
    STATE(232), 1,
      sym__tbl_seq,
    STATE(371), 1,
      sym_var,
    STATE(483), 1,
      sym_prefixexp,
    STATE(593), 1,
      sym_exp,
    STATE(894), 1,
      sym_comment,
    STATE(2782), 1,
      sym__prefixexp,
    STATE(2786), 1,
      sym__tbl_method,
    ACTIONS(1715), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(258), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(615), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [71664] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1709), 1,
      sym_name,
    ACTIONS(1711), 1,
      anon_sym_function,
    ACTIONS(1713), 1,
      anon_sym_if,
    ACTIONS(1717), 1,
      anon_sym_not,
    ACTIONS(1719), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1725), 1,
      sym_number,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(1733), 1,
      sym_interp_start,
    STATE(232), 1,
      sym__tbl_seq,
    STATE(371), 1,
      sym_var,
    STATE(483), 1,
      sym_prefixexp,
    STATE(605), 1,
      sym_exp,
    STATE(895), 1,
      sym_comment,
    STATE(2782), 1,
      sym__prefixexp,
    STATE(2786), 1,
      sym__tbl_method,
    ACTIONS(1715), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(258), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(615), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [71747] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1709), 1,
      sym_name,
    ACTIONS(1711), 1,
      anon_sym_function,
    ACTIONS(1713), 1,
      anon_sym_if,
    ACTIONS(1717), 1,
      anon_sym_not,
    ACTIONS(1719), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1725), 1,
      sym_number,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(1733), 1,
      sym_interp_start,
    STATE(232), 1,
      sym__tbl_seq,
    STATE(371), 1,
      sym_var,
    STATE(483), 1,
      sym_prefixexp,
    STATE(611), 1,
      sym_exp,
    STATE(896), 1,
      sym_comment,
    STATE(2782), 1,
      sym__prefixexp,
    STATE(2786), 1,
      sym__tbl_method,
    ACTIONS(1715), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(258), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(615), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [71830] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(897), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1654), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [71913] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(898), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(2177), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [71996] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(899), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1658), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [72079] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(900), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1672), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [72162] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(901), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1675), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [72245] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(902), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1676), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [72328] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(903), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1677), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [72411] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1709), 1,
      sym_name,
    ACTIONS(1711), 1,
      anon_sym_function,
    ACTIONS(1713), 1,
      anon_sym_if,
    ACTIONS(1717), 1,
      anon_sym_not,
    ACTIONS(1719), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1725), 1,
      sym_number,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(1733), 1,
      sym_interp_start,
    STATE(232), 1,
      sym__tbl_seq,
    STATE(371), 1,
      sym_var,
    STATE(483), 1,
      sym_prefixexp,
    STATE(664), 1,
      sym_exp,
    STATE(904), 1,
      sym_comment,
    STATE(2782), 1,
      sym__prefixexp,
    STATE(2786), 1,
      sym__tbl_method,
    ACTIONS(1715), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(258), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(615), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [72494] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1709), 1,
      sym_name,
    ACTIONS(1711), 1,
      anon_sym_function,
    ACTIONS(1713), 1,
      anon_sym_if,
    ACTIONS(1717), 1,
      anon_sym_not,
    ACTIONS(1719), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1725), 1,
      sym_number,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(1733), 1,
      sym_interp_start,
    STATE(232), 1,
      sym__tbl_seq,
    STATE(371), 1,
      sym_var,
    STATE(483), 1,
      sym_prefixexp,
    STATE(680), 1,
      sym_exp,
    STATE(905), 1,
      sym_comment,
    STATE(2782), 1,
      sym__prefixexp,
    STATE(2786), 1,
      sym__tbl_method,
    ACTIONS(1715), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(258), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(615), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [72577] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1417), 1,
      sym_name,
    ACTIONS(1421), 1,
      anon_sym_function,
    ACTIONS(1423), 1,
      anon_sym_if,
    ACTIONS(1427), 1,
      anon_sym_not,
    ACTIONS(1429), 1,
      anon_sym_LBRACE,
    ACTIONS(1431), 1,
      anon_sym_LPAREN,
    ACTIONS(1433), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(1443), 1,
      sym_interp_start,
    STATE(906), 1,
      sym_comment,
    STATE(1163), 1,
      sym__tbl_seq,
    STATE(1423), 1,
      sym_var,
    STATE(1787), 1,
      sym_prefixexp,
    STATE(2053), 1,
      sym_exp,
    STATE(2775), 1,
      sym__prefixexp,
    STATE(2779), 1,
      sym__tbl_method,
    ACTIONS(1425), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2048), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [72660] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(907), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2350), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [72743] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(908), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2229), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [72826] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(909), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2231), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [72909] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(910), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(1934), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [72992] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(911), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2233), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [73075] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(912), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(2173), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [73158] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(913), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(2176), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [73241] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(914), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2351), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [73324] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(915), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2240), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [73407] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(916), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2242), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [73490] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(917), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(1904), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [73573] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(918), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(2184), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [73656] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(919), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2245), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [73739] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(920), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(2147), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [73822] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(921), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(2171), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [73905] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(922), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2352), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [73988] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(923), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2256), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [74071] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(924), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2259), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [74154] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(925), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(1923), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [74237] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(926), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2353), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [74320] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(927), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2269), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [74403] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(928), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(2174), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [74486] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(929), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2277), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [74569] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(930), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2280), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [74652] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(931), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1856), 1,
      sym_exp,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [74735] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(932), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2285), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [74818] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(933), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(2119), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [74901] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(934), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2432), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [74984] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(935), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2299), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [75067] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(936), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2300), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [75150] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(937), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(1886), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [75233] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(938), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2307), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [75316] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(939), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2316), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [75399] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(940), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2317), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [75482] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(941), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(1891), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [75565] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(942), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2329), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [75648] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(943), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2321), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [75731] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(944), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2354), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [75814] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(945), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2328), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [75897] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(946), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2330), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [75980] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(947), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(1911), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [76063] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(948), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2333), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [76146] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(949), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(1488), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [76229] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1683), 1,
      sym_name,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1687), 1,
      anon_sym_if,
    ACTIONS(1691), 1,
      anon_sym_not,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      anon_sym_LPAREN,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1699), 1,
      sym_number,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1707), 1,
      sym_interp_start,
    STATE(251), 1,
      sym__tbl_seq,
    STATE(353), 1,
      sym_var,
    STATE(452), 1,
      sym_prefixexp,
    STATE(710), 1,
      sym_exp,
    STATE(950), 1,
      sym_comment,
    STATE(2818), 1,
      sym__prefixexp,
    STATE(2819), 1,
      sym__tbl_method,
    ACTIONS(1689), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(250), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(626), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [76312] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(951), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2337), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [76395] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(952), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2338), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [76478] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(953), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(1928), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [76561] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(954), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2341), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [76644] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(955), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2342), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [76727] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(956), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2343), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [76810] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(957), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1855), 1,
      sym_exp,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [76893] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1683), 1,
      sym_name,
    ACTIONS(1685), 1,
      anon_sym_function,
    ACTIONS(1687), 1,
      anon_sym_if,
    ACTIONS(1691), 1,
      anon_sym_not,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      anon_sym_LPAREN,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1699), 1,
      sym_number,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1707), 1,
      sym_interp_start,
    STATE(251), 1,
      sym__tbl_seq,
    STATE(353), 1,
      sym_var,
    STATE(452), 1,
      sym_prefixexp,
    STATE(711), 1,
      sym_exp,
    STATE(958), 1,
      sym_comment,
    STATE(2818), 1,
      sym__prefixexp,
    STATE(2819), 1,
      sym__tbl_method,
    ACTIONS(1689), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(250), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(626), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [76976] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(959), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2346), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [77059] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(960), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(2160), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [77142] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(961), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(2163), 1,
      sym_exp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [77225] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(962), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2357), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [77308] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(963), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2359), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [77391] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(964), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1862), 1,
      sym_exp,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [77474] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(965), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2363), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [77557] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(966), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2369), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [77640] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(967), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2371), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [77723] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1817), 1,
      sym_name,
    ACTIONS(1819), 1,
      anon_sym_function,
    ACTIONS(1821), 1,
      anon_sym_if,
    ACTIONS(1825), 1,
      anon_sym_not,
    ACTIONS(1827), 1,
      anon_sym_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1833), 1,
      sym_number,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1841), 1,
      sym_interp_start,
    STATE(968), 1,
      sym_comment,
    STATE(1182), 1,
      sym__tbl_seq,
    STATE(1719), 1,
      sym_var,
    STATE(1870), 1,
      sym_exp,
    STATE(1885), 1,
      sym_prefixexp,
    STATE(2773), 1,
      sym__prefixexp,
    STATE(2774), 1,
      sym__tbl_method,
    ACTIONS(1823), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1181), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2132), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [77806] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(969), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2376), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [77889] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(970), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2143), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [77972] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(971), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2158), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [78055] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(972), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2381), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [78138] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(973), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2382), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [78221] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(974), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2388), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [78304] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1123), 1,
      sym_name,
    ACTIONS(1127), 1,
      anon_sym_function,
    ACTIONS(1131), 1,
      anon_sym_if,
    ACTIONS(1135), 1,
      anon_sym_not,
    ACTIONS(1137), 1,
      anon_sym_LBRACE,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1143), 1,
      sym_number,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1151), 1,
      sym_interp_start,
    STATE(975), 1,
      sym_comment,
    STATE(1101), 1,
      sym__tbl_seq,
    STATE(1224), 1,
      sym_var,
    STATE(1431), 1,
      sym_prefixexp,
    STATE(1818), 1,
      sym_exp,
    STATE(2793), 1,
      sym__prefixexp,
    STATE(2794), 1,
      sym__tbl_method,
    ACTIONS(1133), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1100), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1783), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [78387] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1123), 1,
      sym_name,
    ACTIONS(1127), 1,
      anon_sym_function,
    ACTIONS(1131), 1,
      anon_sym_if,
    ACTIONS(1135), 1,
      anon_sym_not,
    ACTIONS(1137), 1,
      anon_sym_LBRACE,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1143), 1,
      sym_number,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1151), 1,
      sym_interp_start,
    STATE(976), 1,
      sym_comment,
    STATE(1101), 1,
      sym__tbl_seq,
    STATE(1224), 1,
      sym_var,
    STATE(1431), 1,
      sym_prefixexp,
    STATE(1825), 1,
      sym_exp,
    STATE(2793), 1,
      sym__prefixexp,
    STATE(2794), 1,
      sym__tbl_method,
    ACTIONS(1133), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1100), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1783), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [78470] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1123), 1,
      sym_name,
    ACTIONS(1127), 1,
      anon_sym_function,
    ACTIONS(1131), 1,
      anon_sym_if,
    ACTIONS(1135), 1,
      anon_sym_not,
    ACTIONS(1137), 1,
      anon_sym_LBRACE,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1143), 1,
      sym_number,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1151), 1,
      sym_interp_start,
    STATE(977), 1,
      sym_comment,
    STATE(1101), 1,
      sym__tbl_seq,
    STATE(1224), 1,
      sym_var,
    STATE(1431), 1,
      sym_prefixexp,
    STATE(1837), 1,
      sym_exp,
    STATE(2793), 1,
      sym__prefixexp,
    STATE(2794), 1,
      sym__tbl_method,
    ACTIONS(1133), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1100), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1783), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [78553] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(978), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2407), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [78636] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1123), 1,
      sym_name,
    ACTIONS(1127), 1,
      anon_sym_function,
    ACTIONS(1131), 1,
      anon_sym_if,
    ACTIONS(1135), 1,
      anon_sym_not,
    ACTIONS(1137), 1,
      anon_sym_LBRACE,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1143), 1,
      sym_number,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1151), 1,
      sym_interp_start,
    STATE(979), 1,
      sym_comment,
    STATE(1101), 1,
      sym__tbl_seq,
    STATE(1224), 1,
      sym_var,
    STATE(1431), 1,
      sym_prefixexp,
    STATE(1846), 1,
      sym_exp,
    STATE(2793), 1,
      sym__prefixexp,
    STATE(2794), 1,
      sym__tbl_method,
    ACTIONS(1133), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1100), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1783), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [78719] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1123), 1,
      sym_name,
    ACTIONS(1127), 1,
      anon_sym_function,
    ACTIONS(1131), 1,
      anon_sym_if,
    ACTIONS(1135), 1,
      anon_sym_not,
    ACTIONS(1137), 1,
      anon_sym_LBRACE,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1143), 1,
      sym_number,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1151), 1,
      sym_interp_start,
    STATE(980), 1,
      sym_comment,
    STATE(1101), 1,
      sym__tbl_seq,
    STATE(1224), 1,
      sym_var,
    STATE(1431), 1,
      sym_prefixexp,
    STATE(1738), 1,
      sym_exp,
    STATE(2793), 1,
      sym__prefixexp,
    STATE(2794), 1,
      sym__tbl_method,
    ACTIONS(1133), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1100), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1783), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [78802] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(981), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2425), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [78885] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1123), 1,
      sym_name,
    ACTIONS(1127), 1,
      anon_sym_function,
    ACTIONS(1131), 1,
      anon_sym_if,
    ACTIONS(1135), 1,
      anon_sym_not,
    ACTIONS(1137), 1,
      anon_sym_LBRACE,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1143), 1,
      sym_number,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1151), 1,
      sym_interp_start,
    STATE(982), 1,
      sym_comment,
    STATE(1101), 1,
      sym__tbl_seq,
    STATE(1224), 1,
      sym_var,
    STATE(1431), 1,
      sym_prefixexp,
    STATE(1739), 1,
      sym_exp,
    STATE(2793), 1,
      sym__prefixexp,
    STATE(2794), 1,
      sym__tbl_method,
    ACTIONS(1133), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1100), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1783), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [78968] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1123), 1,
      sym_name,
    ACTIONS(1127), 1,
      anon_sym_function,
    ACTIONS(1131), 1,
      anon_sym_if,
    ACTIONS(1135), 1,
      anon_sym_not,
    ACTIONS(1137), 1,
      anon_sym_LBRACE,
    ACTIONS(1139), 1,
      anon_sym_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1143), 1,
      sym_number,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1151), 1,
      sym_interp_start,
    STATE(983), 1,
      sym_comment,
    STATE(1101), 1,
      sym__tbl_seq,
    STATE(1224), 1,
      sym_var,
    STATE(1431), 1,
      sym_prefixexp,
    STATE(1740), 1,
      sym_exp,
    STATE(2793), 1,
      sym__prefixexp,
    STATE(2794), 1,
      sym__tbl_method,
    ACTIONS(1133), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1100), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1783), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [79051] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(984), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2164), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [79134] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(985), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2430), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [79217] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(986), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2146), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [79300] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(987), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2145), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [79383] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1529), 1,
      sym_name,
    ACTIONS(1533), 1,
      anon_sym_function,
    ACTIONS(1535), 1,
      anon_sym_if,
    ACTIONS(1539), 1,
      anon_sym_not,
    ACTIONS(1541), 1,
      anon_sym_LBRACE,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1547), 1,
      sym_number,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1555), 1,
      sym_interp_start,
    STATE(988), 1,
      sym_comment,
    STATE(1152), 1,
      sym__tbl_seq,
    STATE(1436), 1,
      sym_var,
    STATE(1815), 1,
      sym_prefixexp,
    STATE(2096), 1,
      sym_exp,
    STATE(2776), 1,
      sym__prefixexp,
    STATE(2778), 1,
      sym__tbl_method,
    ACTIONS(1537), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1170), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2010), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [79466] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(989), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2435), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [79549] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(990), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2437), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [79632] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(991), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2190), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [79715] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(992), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2138), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [79798] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(993), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2441), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [79881] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(994), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2442), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [79964] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(995), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2105), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [80047] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(996), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2106), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [80130] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(997), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2445), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [80213] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(998), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2446), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [80296] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(999), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2447), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [80379] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1709), 1,
      sym_name,
    ACTIONS(1711), 1,
      anon_sym_function,
    ACTIONS(1713), 1,
      anon_sym_if,
    ACTIONS(1717), 1,
      anon_sym_not,
    ACTIONS(1719), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1725), 1,
      sym_number,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(1733), 1,
      sym_interp_start,
    STATE(232), 1,
      sym__tbl_seq,
    STATE(371), 1,
      sym_var,
    STATE(483), 1,
      sym_prefixexp,
    STATE(717), 1,
      sym_exp,
    STATE(1000), 1,
      sym_comment,
    STATE(2782), 1,
      sym__prefixexp,
    STATE(2786), 1,
      sym__tbl_method,
    ACTIONS(1715), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(258), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(615), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [80462] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(1001), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2118), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [80545] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(1002), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2450), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [80628] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(1003), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2451), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [80711] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(1004), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2452), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [80794] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(1005), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2130), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [80877] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1657), 1,
      sym_name,
    ACTIONS(1659), 1,
      anon_sym_function,
    ACTIONS(1661), 1,
      anon_sym_if,
    ACTIONS(1665), 1,
      anon_sym_not,
    ACTIONS(1667), 1,
      anon_sym_LBRACE,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1673), 1,
      sym_number,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_interp_start,
    STATE(1006), 1,
      sym_comment,
    STATE(1186), 1,
      sym__tbl_seq,
    STATE(1608), 1,
      sym_var,
    STATE(1854), 1,
      sym_prefixexp,
    STATE(2459), 1,
      sym_exp,
    STATE(2824), 1,
      sym__prefixexp,
    STATE(2826), 1,
      sym__tbl_method,
    ACTIONS(1663), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1178), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2188), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [80960] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(1007), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2503), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [81043] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(1008), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2508), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [81126] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(1009), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2511), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [81209] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(1010), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2512), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [81292] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(1011), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2513), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [81375] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(1012), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2514), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [81458] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(1013), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2515), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [81541] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(1014), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2516), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [81624] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(1015), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2517), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [81707] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(1016), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2518), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [81790] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(1017), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2519), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [81873] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(1018), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2521), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [81956] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1157), 1,
      anon_sym_function,
    ACTIONS(1159), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      anon_sym_not,
    ACTIONS(1165), 1,
      anon_sym_LBRACE,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1173), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1175), 1,
      sym_number,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1183), 1,
      sym_interp_start,
    ACTIONS(1603), 1,
      sym_name,
    STATE(1019), 1,
      sym_comment,
    STATE(1088), 1,
      sym__tbl_seq,
    STATE(1184), 1,
      sym_var,
    STATE(1294), 1,
      sym_prefixexp,
    STATE(2522), 1,
      sym_exp,
    STATE(2768), 1,
      sym__prefixexp,
    STATE(2770), 1,
      sym__tbl_method,
    ACTIONS(1161), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1090), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(1594), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [82039] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1793), 1,
      anon_sym_function,
    ACTIONS(1795), 1,
      anon_sym_if,
    ACTIONS(1799), 1,
      anon_sym_not,
    ACTIONS(1801), 1,
      anon_sym_LBRACE,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1805), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1807), 1,
      sym_number,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(1815), 1,
      sym_interp_start,
    STATE(1020), 1,
      sym_comment,
    STATE(1293), 1,
      sym__tbl_seq,
    STATE(1744), 1,
      sym_var,
    STATE(1953), 1,
      sym_prefixexp,
    STATE(2355), 1,
      sym_exp,
    STATE(2772), 1,
      sym__prefixexp,
    STATE(2788), 1,
      sym__tbl_method,
    ACTIONS(1797), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1239), 2,
      sym_exp_wrap,
      sym_call_stmt,
    STATE(2282), 11,
      sym_binexp,
      sym_cast,
      sym_unexp,
      sym_ifexp,
      sym_table,
      sym_anon_fn,
      sym_vararg,
      sym_string,
      sym_string_interp,
      sym_boolean,
      sym_nil,
  [82122] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(156), 1,
      sym__outertype,
    STATE(157), 1,
      sym_typepack,
    STATE(1021), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [82202] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(221), 1,
      sym__outertype,
    STATE(222), 1,
      sym_typepack,
    STATE(1022), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [82282] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(109), 1,
      sym__outertype,
    STATE(113), 1,
      sym_typepack,
    STATE(1023), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [82362] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(123), 1,
      sym__outertype,
    STATE(124), 1,
      sym_typepack,
    STATE(1024), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [82442] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(77), 1,
      sym__outertype,
    STATE(78), 1,
      sym_typepack,
    STATE(1025), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [82522] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(80), 1,
      sym__outertype,
    STATE(81), 1,
      sym_typepack,
    STATE(1026), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [82602] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(84), 1,
      sym__outertype,
    STATE(85), 1,
      sym_typepack,
    STATE(1027), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [82682] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(87), 1,
      sym__outertype,
    STATE(88), 1,
      sym_typepack,
    STATE(1028), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [82762] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(94), 1,
      sym__outertype,
    STATE(95), 1,
      sym_typepack,
    STATE(1029), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [82842] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(97), 1,
      sym__outertype,
    STATE(98), 1,
      sym_typepack,
    STATE(1030), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [82922] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(101), 1,
      sym__outertype,
    STATE(102), 1,
      sym_typepack,
    STATE(1031), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [83002] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(104), 1,
      sym__outertype,
    STATE(105), 1,
      sym_typepack,
    STATE(1032), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [83082] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(83), 1,
      sym__outertype,
    STATE(90), 1,
      sym_typepack,
    STATE(1033), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [83162] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(111), 1,
      sym__outertype,
    STATE(112), 1,
      sym_typepack,
    STATE(1034), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [83242] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(114), 1,
      sym__outertype,
    STATE(115), 1,
      sym_typepack,
    STATE(1035), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [83322] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(118), 1,
      sym__outertype,
    STATE(119), 1,
      sym_typepack,
    STATE(1036), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [83402] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(121), 1,
      sym__outertype,
    STATE(122), 1,
      sym_typepack,
    STATE(1037), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [83482] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(125), 1,
      sym__outertype,
    STATE(126), 1,
      sym_typepack,
    STATE(1038), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [83562] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(127), 1,
      sym__outertype,
    STATE(128), 1,
      sym_typepack,
    STATE(1039), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [83642] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(129), 1,
      sym__outertype,
    STATE(130), 1,
      sym_typepack,
    STATE(1040), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [83722] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(131), 1,
      sym__outertype,
    STATE(132), 1,
      sym_typepack,
    STATE(1041), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [83802] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(133), 1,
      sym__outertype,
    STATE(134), 1,
      sym_typepack,
    STATE(1042), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [83882] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(135), 1,
      sym__outertype,
    STATE(136), 1,
      sym_typepack,
    STATE(1043), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [83962] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(138), 1,
      sym__outertype,
    STATE(139), 1,
      sym_typepack,
    STATE(1044), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [84042] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(140), 1,
      sym__outertype,
    STATE(141), 1,
      sym_typepack,
    STATE(1045), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [84122] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(142), 1,
      sym__outertype,
    STATE(143), 1,
      sym_typepack,
    STATE(1046), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [84202] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(144), 1,
      sym__outertype,
    STATE(145), 1,
      sym_typepack,
    STATE(1047), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [84282] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(146), 1,
      sym__outertype,
    STATE(147), 1,
      sym_typepack,
    STATE(1048), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [84362] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(148), 1,
      sym__outertype,
    STATE(149), 1,
      sym_typepack,
    STATE(1049), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [84442] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(150), 1,
      sym__outertype,
    STATE(151), 1,
      sym_typepack,
    STATE(1050), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [84522] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(152), 1,
      sym__outertype,
    STATE(224), 1,
      sym_typepack,
    STATE(1051), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [84602] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(154), 1,
      sym__outertype,
    STATE(155), 1,
      sym_typepack,
    STATE(1052), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [84682] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    STATE(1053), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(3059), 1,
      sym__outertype,
    STATE(3094), 1,
      sym__fntype_param,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3364), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [84764] = 23,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1383), 1,
      sym_name,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    STATE(1054), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2660), 1,
      sym_genpack,
    STATE(2664), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(3059), 1,
      sym__outertype,
    STATE(3094), 1,
      sym__fntype_param,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3616), 1,
      sym__fntype_paramlist_vrd,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3177), 2,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [84846] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(160), 1,
      sym__outertype,
    STATE(161), 1,
      sym_typepack,
    STATE(1055), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [84926] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(162), 1,
      sym__outertype,
    STATE(163), 1,
      sym_typepack,
    STATE(1056), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [85006] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(164), 1,
      sym__outertype,
    STATE(165), 1,
      sym_typepack,
    STATE(1057), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [85086] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(166), 1,
      sym__outertype,
    STATE(167), 1,
      sym_typepack,
    STATE(1058), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [85166] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(168), 1,
      sym__outertype,
    STATE(169), 1,
      sym_typepack,
    STATE(1059), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [85246] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(170), 1,
      sym__outertype,
    STATE(171), 1,
      sym_typepack,
    STATE(1060), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [85326] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(172), 1,
      sym__outertype,
    STATE(173), 1,
      sym_typepack,
    STATE(1061), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [85406] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(174), 1,
      sym__outertype,
    STATE(175), 1,
      sym_typepack,
    STATE(1062), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [85486] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(176), 1,
      sym__outertype,
    STATE(177), 1,
      sym_typepack,
    STATE(1063), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [85566] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(178), 1,
      sym__outertype,
    STATE(179), 1,
      sym_typepack,
    STATE(1064), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [85646] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(180), 1,
      sym__outertype,
    STATE(181), 1,
      sym_typepack,
    STATE(1065), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [85726] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(182), 1,
      sym__outertype,
    STATE(183), 1,
      sym_typepack,
    STATE(1066), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [85806] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(184), 1,
      sym__outertype,
    STATE(185), 1,
      sym_typepack,
    STATE(1067), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [85886] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(186), 1,
      sym__outertype,
    STATE(187), 1,
      sym_typepack,
    STATE(1068), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [85966] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(188), 1,
      sym__outertype,
    STATE(189), 1,
      sym_typepack,
    STATE(1069), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [86046] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(190), 1,
      sym__outertype,
    STATE(191), 1,
      sym_typepack,
    STATE(1070), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [86126] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(192), 1,
      sym__outertype,
    STATE(193), 1,
      sym_typepack,
    STATE(1071), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [86206] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(194), 1,
      sym__outertype,
    STATE(195), 1,
      sym_typepack,
    STATE(1072), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [86286] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(196), 1,
      sym__outertype,
    STATE(197), 1,
      sym_typepack,
    STATE(1073), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [86366] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(198), 1,
      sym__outertype,
    STATE(199), 1,
      sym_typepack,
    STATE(1074), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [86446] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(200), 1,
      sym__outertype,
    STATE(201), 1,
      sym_typepack,
    STATE(1075), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [86526] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(202), 1,
      sym__outertype,
    STATE(203), 1,
      sym_typepack,
    STATE(1076), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [86606] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(204), 1,
      sym__outertype,
    STATE(205), 1,
      sym_typepack,
    STATE(1077), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [86686] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(207), 1,
      sym__outertype,
    STATE(208), 1,
      sym_typepack,
    STATE(1078), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [86766] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(96), 1,
      sym__outertype,
    STATE(100), 1,
      sym_typepack,
    STATE(1079), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [86846] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(209), 1,
      sym__outertype,
    STATE(210), 1,
      sym_typepack,
    STATE(1080), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [86926] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(211), 1,
      sym__outertype,
    STATE(212), 1,
      sym_typepack,
    STATE(1081), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [87006] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(213), 1,
      sym__outertype,
    STATE(214), 1,
      sym_typepack,
    STATE(1082), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [87086] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(215), 1,
      sym__outertype,
    STATE(216), 1,
      sym_typepack,
    STATE(1083), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [87166] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(217), 1,
      sym__outertype,
    STATE(218), 1,
      sym_typepack,
    STATE(1084), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [87246] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(219), 1,
      sym__outertype,
    STATE(220), 1,
      sym_typepack,
    STATE(1085), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [87326] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(158), 1,
      sym__outertype,
    STATE(159), 1,
      sym_typepack,
    STATE(1086), 1,
      sym_comment,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1543), 1,
      sym_type,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [87406] = 22,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1887), 1,
      sym_name,
    ACTIONS(1889), 1,
      anon_sym_RPAREN,
    STATE(1087), 1,
      sym_comment,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(2664), 1,
      sym_type,
    STATE(2986), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3258), 1,
      sym__typelist_vrd,
    STATE(3330), 1,
      sym_typelist,
    STATE(3564), 1,
      sym_variadic,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [87484] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1891), 1,
      anon_sym_LBRACK,
    ACTIONS(1893), 1,
      anon_sym_DOT,
    STATE(1088), 1,
      sym_comment,
    STATE(1137), 1,
      sym__key_named,
    STATE(1147), 1,
      sym_key,
    ACTIONS(744), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(746), 23,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [87534] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1891), 1,
      anon_sym_LBRACK,
    ACTIONS(1893), 1,
      anon_sym_DOT,
    STATE(1089), 1,
      sym_comment,
    STATE(1132), 1,
      sym_key,
    STATE(1137), 1,
      sym__key_named,
    ACTIONS(689), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(691), 23,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [87584] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1891), 1,
      anon_sym_LBRACK,
    ACTIONS(1893), 1,
      anon_sym_DOT,
    STATE(1090), 1,
      sym_comment,
    STATE(1137), 1,
      sym__key_named,
    STATE(1144), 1,
      sym_key,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(748), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(750), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [87636] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1895), 1,
      sym_name,
    ACTIONS(1897), 1,
      anon_sym_LBRACE,
    ACTIONS(1899), 1,
      anon_sym_LPAREN,
    ACTIONS(1901), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1903), 1,
      anon_sym_typeof,
    STATE(376), 1,
      sym_variadic,
    STATE(377), 1,
      sym_genpack,
    STATE(395), 1,
      sym_type,
    STATE(396), 1,
      sym_typepack,
    STATE(1091), 1,
      sym_comment,
    STATE(1119), 1,
      sym_paramtypelist,
    STATE(3067), 1,
      sym__fntype_gen,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(372), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(386), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(370), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [87709] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1905), 1,
      sym_name,
    ACTIONS(1907), 1,
      anon_sym_LBRACE,
    ACTIONS(1909), 1,
      anon_sym_LPAREN,
    ACTIONS(1911), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1913), 1,
      anon_sym_typeof,
    STATE(302), 1,
      sym_genpack,
    STATE(307), 1,
      sym_type,
    STATE(310), 1,
      sym_typepack,
    STATE(342), 1,
      sym_variadic,
    STATE(3051), 1,
      sym__fntype_gen,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1092), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(295), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(311), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(294), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [87780] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1905), 1,
      sym_name,
    ACTIONS(1907), 1,
      anon_sym_LBRACE,
    ACTIONS(1909), 1,
      anon_sym_LPAREN,
    ACTIONS(1911), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1913), 1,
      anon_sym_typeof,
    STATE(302), 1,
      sym_genpack,
    STATE(321), 1,
      sym_type,
    STATE(322), 1,
      sym_typepack,
    STATE(342), 1,
      sym_variadic,
    STATE(1092), 1,
      sym_paramtypelist,
    STATE(1093), 1,
      sym_comment,
    STATE(3051), 1,
      sym__fntype_gen,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(295), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(311), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(294), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [87853] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1915), 1,
      sym_name,
    ACTIONS(1917), 1,
      anon_sym_LBRACE,
    ACTIONS(1919), 1,
      anon_sym_LPAREN,
    ACTIONS(1921), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1923), 1,
      anon_sym_typeof,
    STATE(1094), 1,
      sym_comment,
    STATE(1112), 1,
      sym_paramtypelist,
    STATE(1835), 1,
      sym_type,
    STATE(1836), 1,
      sym_typepack,
    STATE(1844), 1,
      sym_variadic,
    STATE(1845), 1,
      sym_genpack,
    STATE(3066), 1,
      sym__fntype_gen,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1820), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1829), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1737), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [87926] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      sym_name,
    ACTIONS(1927), 1,
      anon_sym_LBRACE,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    ACTIONS(1931), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1933), 1,
      anon_sym_typeof,
    STATE(1095), 1,
      sym_comment,
    STATE(1107), 1,
      sym_paramtypelist,
    STATE(1218), 1,
      sym_genpack,
    STATE(1268), 1,
      sym_variadic,
    STATE(1286), 1,
      sym_type,
    STATE(1289), 1,
      sym_typepack,
    STATE(3080), 1,
      sym__fntype_gen,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1210), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1211), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1227), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [87999] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1935), 1,
      sym_name,
    ACTIONS(1937), 1,
      anon_sym_LBRACE,
    ACTIONS(1939), 1,
      anon_sym_LPAREN,
    ACTIONS(1941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1943), 1,
      anon_sym_typeof,
    STATE(359), 1,
      sym_type,
    STATE(360), 1,
      sym_typepack,
    STATE(430), 1,
      sym_variadic,
    STATE(431), 1,
      sym_genpack,
    STATE(3044), 1,
      sym__fntype_gen,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1096), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(364), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(418), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(417), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [88070] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1935), 1,
      sym_name,
    ACTIONS(1937), 1,
      anon_sym_LBRACE,
    ACTIONS(1939), 1,
      anon_sym_LPAREN,
    ACTIONS(1941), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1943), 1,
      anon_sym_typeof,
    STATE(403), 1,
      sym_type,
    STATE(404), 1,
      sym_typepack,
    STATE(430), 1,
      sym_variadic,
    STATE(431), 1,
      sym_genpack,
    STATE(1096), 1,
      sym_paramtypelist,
    STATE(1097), 1,
      sym_comment,
    STATE(3044), 1,
      sym__fntype_gen,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(364), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(418), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(417), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [88143] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1945), 1,
      anon_sym_LBRACK,
    ACTIONS(1947), 1,
      anon_sym_DOT,
    STATE(1098), 1,
      sym_comment,
    STATE(1156), 1,
      sym_key,
    STATE(1173), 1,
      sym__key_named,
    ACTIONS(689), 5,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(691), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [88192] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1949), 1,
      sym_name,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1953), 1,
      anon_sym_LPAREN,
    ACTIONS(1955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1957), 1,
      anon_sym_typeof,
    STATE(1604), 1,
      sym_variadic,
    STATE(1605), 1,
      sym_genpack,
    STATE(1614), 1,
      sym_type,
    STATE(1617), 1,
      sym_typepack,
    STATE(3086), 1,
      sym__fntype_gen,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1099), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(1601), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1619), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1599), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [88263] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1945), 1,
      anon_sym_LBRACK,
    ACTIONS(1947), 1,
      anon_sym_DOT,
    STATE(1100), 1,
      sym_comment,
    STATE(1167), 1,
      sym_key,
    STATE(1173), 1,
      sym__key_named,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(748), 5,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(750), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [88314] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1945), 1,
      anon_sym_LBRACK,
    ACTIONS(1947), 1,
      anon_sym_DOT,
    STATE(1101), 1,
      sym_comment,
    STATE(1168), 1,
      sym_key,
    STATE(1173), 1,
      sym__key_named,
    ACTIONS(744), 5,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(746), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [88363] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1959), 1,
      sym_name,
    ACTIONS(1961), 1,
      anon_sym_LBRACE,
    ACTIONS(1963), 1,
      anon_sym_LPAREN,
    ACTIONS(1965), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1967), 1,
      anon_sym_typeof,
    STATE(1792), 1,
      sym_variadic,
    STATE(1796), 1,
      sym_type,
    STATE(1797), 1,
      sym_typepack,
    STATE(1848), 1,
      sym_genpack,
    STATE(3078), 1,
      sym__fntype_gen,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1102), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(1789), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1798), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1788), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [88434] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1949), 1,
      sym_name,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1953), 1,
      anon_sym_LPAREN,
    ACTIONS(1955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1957), 1,
      anon_sym_typeof,
    STATE(1099), 1,
      sym_paramtypelist,
    STATE(1103), 1,
      sym_comment,
    STATE(1604), 1,
      sym_variadic,
    STATE(1605), 1,
      sym_genpack,
    STATE(1667), 1,
      sym_type,
    STATE(1668), 1,
      sym_typepack,
    STATE(3086), 1,
      sym__fntype_gen,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1601), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1619), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1599), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [88507] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1969), 1,
      sym_name,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(1973), 1,
      anon_sym_LPAREN,
    ACTIONS(1975), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1977), 1,
      anon_sym_typeof,
    STATE(1330), 1,
      sym_variadic,
    STATE(1331), 1,
      sym_genpack,
    STATE(1334), 1,
      sym_type,
    STATE(1335), 1,
      sym_typepack,
    STATE(3112), 1,
      sym__fntype_gen,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1104), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(1327), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1336), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1326), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [88578] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1979), 1,
      sym_name,
    ACTIONS(1981), 1,
      anon_sym_LBRACE,
    ACTIONS(1983), 1,
      anon_sym_LPAREN,
    ACTIONS(1985), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1987), 1,
      anon_sym_typeof,
    STATE(1850), 1,
      sym_type,
    STATE(1852), 1,
      sym_typepack,
    STATE(1929), 1,
      sym_variadic,
    STATE(1933), 1,
      sym_genpack,
    STATE(3090), 1,
      sym__fntype_gen,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1105), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(1909), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1920), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1918), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [88649] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1969), 1,
      sym_name,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(1973), 1,
      anon_sym_LPAREN,
    ACTIONS(1975), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1977), 1,
      anon_sym_typeof,
    STATE(1104), 1,
      sym_paramtypelist,
    STATE(1106), 1,
      sym_comment,
    STATE(1330), 1,
      sym_variadic,
    STATE(1331), 1,
      sym_genpack,
    STATE(1342), 1,
      sym_type,
    STATE(1343), 1,
      sym_typepack,
    STATE(3112), 1,
      sym__fntype_gen,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1327), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1336), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1326), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [88722] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1925), 1,
      sym_name,
    ACTIONS(1927), 1,
      anon_sym_LBRACE,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    ACTIONS(1931), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1933), 1,
      anon_sym_typeof,
    STATE(1189), 1,
      sym_type,
    STATE(1191), 1,
      sym_typepack,
    STATE(1218), 1,
      sym_genpack,
    STATE(1268), 1,
      sym_variadic,
    STATE(3080), 1,
      sym__fntype_gen,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1107), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(1210), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1211), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1227), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [88793] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1989), 1,
      sym_name,
    ACTIONS(1991), 1,
      anon_sym_LBRACE,
    ACTIONS(1993), 1,
      anon_sym_LPAREN,
    ACTIONS(1995), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1997), 1,
      anon_sym_typeof,
    ACTIONS(2001), 1,
      anon_sym_nil,
    ACTIONS(2003), 1,
      sym__string_start,
    STATE(1549), 1,
      sym_type,
    STATE(1553), 1,
      sym_typepack,
    STATE(1635), 1,
      sym_variadic,
    STATE(1636), 1,
      sym_genpack,
    STATE(3053), 1,
      sym__fntype_gen,
    ACTIONS(1999), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1108), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(1519), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1554), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1518), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [88864] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1959), 1,
      sym_name,
    ACTIONS(1961), 1,
      anon_sym_LBRACE,
    ACTIONS(1963), 1,
      anon_sym_LPAREN,
    ACTIONS(1965), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1967), 1,
      anon_sym_typeof,
    STATE(1102), 1,
      sym_paramtypelist,
    STATE(1109), 1,
      sym_comment,
    STATE(1792), 1,
      sym_variadic,
    STATE(1805), 1,
      sym_type,
    STATE(1806), 1,
      sym_typepack,
    STATE(1848), 1,
      sym_genpack,
    STATE(3078), 1,
      sym__fntype_gen,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1789), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1798), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1788), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [88937] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1989), 1,
      sym_name,
    ACTIONS(1991), 1,
      anon_sym_LBRACE,
    ACTIONS(1993), 1,
      anon_sym_LPAREN,
    ACTIONS(1995), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1997), 1,
      anon_sym_typeof,
    ACTIONS(2001), 1,
      anon_sym_nil,
    ACTIONS(2003), 1,
      sym__string_start,
    STATE(1108), 1,
      sym_paramtypelist,
    STATE(1110), 1,
      sym_comment,
    STATE(1562), 1,
      sym_type,
    STATE(1563), 1,
      sym_typepack,
    STATE(1635), 1,
      sym_variadic,
    STATE(1636), 1,
      sym_genpack,
    STATE(3053), 1,
      sym__fntype_gen,
    ACTIONS(1999), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1519), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1554), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1518), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [89010] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(1567), 1,
      sym_type,
    STATE(1568), 1,
      sym_typepack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1111), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [89081] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1915), 1,
      sym_name,
    ACTIONS(1917), 1,
      anon_sym_LBRACE,
    ACTIONS(1919), 1,
      anon_sym_LPAREN,
    ACTIONS(1921), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1923), 1,
      anon_sym_typeof,
    STATE(1827), 1,
      sym_type,
    STATE(1828), 1,
      sym_typepack,
    STATE(1844), 1,
      sym_variadic,
    STATE(1845), 1,
      sym_genpack,
    STATE(3066), 1,
      sym__fntype_gen,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1112), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(1820), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1829), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1737), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [89152] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1869), 1,
      sym_name,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1113), 1,
      sym_comment,
    STATE(1546), 1,
      sym_variadic,
    STATE(1566), 1,
      sym_genpack,
    STATE(1576), 1,
      sym_type,
    STATE(1577), 1,
      sym_typepack,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1734), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [89225] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(2005), 1,
      sym_name,
    ACTIONS(2007), 1,
      anon_sym_LBRACE,
    ACTIONS(2009), 1,
      anon_sym_LPAREN,
    ACTIONS(2011), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2013), 1,
      anon_sym_typeof,
    STATE(1114), 1,
      sym_comment,
    STATE(1121), 1,
      sym_paramtypelist,
    STATE(1876), 1,
      sym_type,
    STATE(1877), 1,
      sym_typepack,
    STATE(1896), 1,
      sym_variadic,
    STATE(1897), 1,
      sym_genpack,
    STATE(3102), 1,
      sym__fntype_gen,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1859), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1869), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1858), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [89298] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2015), 1,
      sym_name,
    ACTIONS(2017), 1,
      anon_sym_LBRACE,
    ACTIONS(2019), 1,
      anon_sym_LPAREN,
    ACTIONS(2021), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2023), 1,
      anon_sym_typeof,
    ACTIONS(2027), 1,
      anon_sym_nil,
    ACTIONS(2029), 1,
      sym__string_start,
    STATE(1353), 1,
      sym_variadic,
    STATE(1354), 1,
      sym_genpack,
    STATE(1357), 1,
      sym_type,
    STATE(1358), 1,
      sym_typepack,
    STATE(3047), 1,
      sym__fntype_gen,
    ACTIONS(2025), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1115), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(1350), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1359), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1349), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [89369] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(2660), 1,
      sym_genpack,
    STATE(2671), 1,
      sym_type,
    STATE(2672), 1,
      sym_typepack,
    STATE(2685), 1,
      sym_variadic,
    STATE(3101), 1,
      sym__fntype_gen,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1116), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [89440] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2031), 1,
      sym_name,
    ACTIONS(2033), 1,
      anon_sym_LBRACE,
    ACTIONS(2035), 1,
      anon_sym_LPAREN,
    ACTIONS(2037), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2039), 1,
      anon_sym_typeof,
    ACTIONS(2043), 1,
      anon_sym_nil,
    ACTIONS(2045), 1,
      sym__string_start,
    STATE(1453), 1,
      sym_variadic,
    STATE(1454), 1,
      sym_genpack,
    STATE(1457), 1,
      sym_type,
    STATE(1458), 1,
      sym_typepack,
    STATE(3111), 1,
      sym__fntype_gen,
    ACTIONS(2041), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1117), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(1450), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1459), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1449), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [89511] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2031), 1,
      sym_name,
    ACTIONS(2033), 1,
      anon_sym_LBRACE,
    ACTIONS(2035), 1,
      anon_sym_LPAREN,
    ACTIONS(2037), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2039), 1,
      anon_sym_typeof,
    ACTIONS(2043), 1,
      anon_sym_nil,
    ACTIONS(2045), 1,
      sym__string_start,
    STATE(1117), 1,
      sym_paramtypelist,
    STATE(1118), 1,
      sym_comment,
    STATE(1453), 1,
      sym_variadic,
    STATE(1454), 1,
      sym_genpack,
    STATE(1465), 1,
      sym_type,
    STATE(1466), 1,
      sym_typepack,
    STATE(3111), 1,
      sym__fntype_gen,
    ACTIONS(2041), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1450), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1459), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1449), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [89584] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1895), 1,
      sym_name,
    ACTIONS(1897), 1,
      anon_sym_LBRACE,
    ACTIONS(1899), 1,
      anon_sym_LPAREN,
    ACTIONS(1901), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1903), 1,
      anon_sym_typeof,
    STATE(376), 1,
      sym_variadic,
    STATE(377), 1,
      sym_genpack,
    STATE(383), 1,
      sym_type,
    STATE(385), 1,
      sym_typepack,
    STATE(3067), 1,
      sym__fntype_gen,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1119), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(372), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(386), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(370), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [89655] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2015), 1,
      sym_name,
    ACTIONS(2017), 1,
      anon_sym_LBRACE,
    ACTIONS(2019), 1,
      anon_sym_LPAREN,
    ACTIONS(2021), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2023), 1,
      anon_sym_typeof,
    ACTIONS(2027), 1,
      anon_sym_nil,
    ACTIONS(2029), 1,
      sym__string_start,
    STATE(1115), 1,
      sym_paramtypelist,
    STATE(1120), 1,
      sym_comment,
    STATE(1353), 1,
      sym_variadic,
    STATE(1354), 1,
      sym_genpack,
    STATE(1365), 1,
      sym_type,
    STATE(1366), 1,
      sym_typepack,
    STATE(3047), 1,
      sym__fntype_gen,
    ACTIONS(2025), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1350), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1359), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1349), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [89728] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(2005), 1,
      sym_name,
    ACTIONS(2007), 1,
      anon_sym_LBRACE,
    ACTIONS(2009), 1,
      anon_sym_LPAREN,
    ACTIONS(2011), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2013), 1,
      anon_sym_typeof,
    STATE(1867), 1,
      sym_type,
    STATE(1868), 1,
      sym_typepack,
    STATE(1896), 1,
      sym_variadic,
    STATE(1897), 1,
      sym_genpack,
    STATE(3102), 1,
      sym__fntype_gen,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1121), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(1859), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1869), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1858), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [89799] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(2047), 1,
      sym_name,
    ACTIONS(2049), 1,
      anon_sym_LBRACE,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2055), 1,
      anon_sym_typeof,
    STATE(1551), 1,
      sym_variadic,
    STATE(1552), 1,
      sym_genpack,
    STATE(1613), 1,
      sym_type,
    STATE(1669), 1,
      sym_typepack,
    STATE(3072), 1,
      sym__fntype_gen,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1122), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(1538), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1569), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1536), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [89870] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2057), 1,
      sym_name,
    ACTIONS(2059), 1,
      anon_sym_LBRACE,
    ACTIONS(2061), 1,
      anon_sym_LPAREN,
    ACTIONS(2063), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2065), 1,
      anon_sym_typeof,
    ACTIONS(2069), 1,
      anon_sym_nil,
    ACTIONS(2071), 1,
      sym__string_start,
    STATE(2798), 1,
      sym_type,
    STATE(2811), 1,
      sym_variadic,
    STATE(2814), 1,
      sym_genpack,
    STATE(2836), 1,
      sym_typepack,
    STATE(3070), 1,
      sym__fntype_gen,
    ACTIONS(2067), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1123), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(2809), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2838), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2807), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [89941] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2057), 1,
      sym_name,
    ACTIONS(2059), 1,
      anon_sym_LBRACE,
    ACTIONS(2061), 1,
      anon_sym_LPAREN,
    ACTIONS(2063), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2065), 1,
      anon_sym_typeof,
    ACTIONS(2069), 1,
      anon_sym_nil,
    ACTIONS(2071), 1,
      sym__string_start,
    STATE(1123), 1,
      sym_paramtypelist,
    STATE(1124), 1,
      sym_comment,
    STATE(2802), 1,
      sym_type,
    STATE(2803), 1,
      sym_typepack,
    STATE(2811), 1,
      sym_variadic,
    STATE(2814), 1,
      sym_genpack,
    STATE(3070), 1,
      sym__fntype_gen,
    ACTIONS(2067), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2809), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2838), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2807), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [90014] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(2047), 1,
      sym_name,
    ACTIONS(2049), 1,
      anon_sym_LBRACE,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2055), 1,
      anon_sym_typeof,
    STATE(1122), 1,
      sym_paramtypelist,
    STATE(1125), 1,
      sym_comment,
    STATE(1480), 1,
      sym_type,
    STATE(1483), 1,
      sym_typepack,
    STATE(1551), 1,
      sym_variadic,
    STATE(1552), 1,
      sym_genpack,
    STATE(3072), 1,
      sym__fntype_gen,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1538), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1569), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1536), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [90087] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(2073), 1,
      sym_name,
    ACTIONS(2075), 1,
      anon_sym_LBRACE,
    ACTIONS(2077), 1,
      anon_sym_LPAREN,
    ACTIONS(2079), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2081), 1,
      anon_sym_typeof,
    STATE(425), 1,
      sym_variadic,
    STATE(426), 1,
      sym_genpack,
    STATE(432), 1,
      sym_type,
    STATE(434), 1,
      sym_typepack,
    STATE(3109), 1,
      sym__fntype_gen,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1126), 2,
      sym_paramtypelist,
      sym_comment,
    STATE(415), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(435), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(412), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [90158] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(2073), 1,
      sym_name,
    ACTIONS(2075), 1,
      anon_sym_LBRACE,
    ACTIONS(2077), 1,
      anon_sym_LPAREN,
    ACTIONS(2079), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2081), 1,
      anon_sym_typeof,
    STATE(357), 1,
      sym_type,
    STATE(358), 1,
      sym_typepack,
    STATE(425), 1,
      sym_variadic,
    STATE(426), 1,
      sym_genpack,
    STATE(1126), 1,
      sym_paramtypelist,
    STATE(1127), 1,
      sym_comment,
    STATE(3109), 1,
      sym__fntype_gen,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(415), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(435), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(412), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [90231] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1761), 1,
      sym_name,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1128), 1,
      sym_comment,
    STATE(2656), 1,
      sym_typepack,
    STATE(2660), 1,
      sym_genpack,
    STATE(2678), 1,
      sym_type,
    STATE(2685), 1,
      sym_variadic,
    STATE(3101), 1,
      sym__fntype_gen,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [90304] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1979), 1,
      sym_name,
    ACTIONS(1981), 1,
      anon_sym_LBRACE,
    ACTIONS(1983), 1,
      anon_sym_LPAREN,
    ACTIONS(1985), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1987), 1,
      anon_sym_typeof,
    STATE(1105), 1,
      sym_paramtypelist,
    STATE(1129), 1,
      sym_comment,
    STATE(1924), 1,
      sym_type,
    STATE(1929), 1,
      sym_variadic,
    STATE(1932), 1,
      sym_typepack,
    STATE(1933), 1,
      sym_genpack,
    STATE(3090), 1,
      sym__fntype_gen,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1909), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
    STATE(1920), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1918), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [90377] = 19,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1405), 1,
      sym_name,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1130), 1,
      sym_comment,
    STATE(2664), 1,
      sym_type,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3332), 1,
      sym__outertype,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2929), 2,
      sym_indexertype,
      sym_proptype,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [90447] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1131), 1,
      sym_comment,
    ACTIONS(823), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(825), 24,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [90487] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1132), 1,
      sym_comment,
    ACTIONS(807), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(809), 24,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [90527] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1133), 1,
      sym_comment,
    ACTIONS(897), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(899), 24,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [90567] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1134), 1,
      sym_comment,
    ACTIONS(764), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(766), 24,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [90607] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1135), 1,
      sym_comment,
    ACTIONS(939), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(941), 24,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [90647] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1136), 1,
      sym_comment,
    ACTIONS(768), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(770), 24,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [90687] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1137), 1,
      sym_comment,
    ACTIONS(811), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(813), 24,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [90727] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1887), 1,
      sym_name,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1138), 1,
      sym_comment,
    STATE(2664), 1,
      sym_type,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3110), 1,
      sym__outertype,
    STATE(3540), 1,
      sym__typelist_vrd,
    STATE(3564), 1,
      sym_variadic,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [90799] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1139), 1,
      sym_comment,
    ACTIONS(760), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(762), 24,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [90839] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1140), 1,
      sym_comment,
    ACTIONS(925), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(927), 24,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [90879] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1141), 1,
      sym_comment,
    ACTIONS(909), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(911), 24,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [90919] = 20,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1887), 1,
      sym_name,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1142), 1,
      sym_comment,
    STATE(2664), 1,
      sym_type,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3110), 1,
      sym__outertype,
    STATE(3232), 1,
      sym__typelist_vrd,
    STATE(3564), 1,
      sym_variadic,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [90991] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1143), 1,
      sym_comment,
    ACTIONS(913), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(915), 24,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [91031] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1144), 1,
      sym_comment,
    ACTIONS(815), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(817), 24,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [91071] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1145), 1,
      sym_comment,
    ACTIONS(917), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(919), 24,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [91111] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1146), 1,
      sym_comment,
    ACTIONS(921), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(923), 24,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [91151] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1147), 1,
      sym_comment,
    ACTIONS(819), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(821), 24,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [91191] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1891), 1,
      anon_sym_LBRACK,
    ACTIONS(1893), 1,
      anon_sym_DOT,
    ACTIONS(2083), 1,
      anon_sym_EQ,
    STATE(1132), 1,
      sym_key,
    STATE(1137), 1,
      sym__key_named,
    STATE(1148), 1,
      sym_comment,
    ACTIONS(689), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(691), 20,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
  [91241] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1149), 1,
      sym_comment,
    ACTIONS(827), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(829), 24,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [91281] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1150), 1,
      sym_comment,
    ACTIONS(760), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(762), 22,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [91320] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1151), 1,
      sym_comment,
    ACTIONS(823), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(825), 22,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [91359] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2085), 1,
      anon_sym_LBRACK,
    ACTIONS(2087), 1,
      anon_sym_DOT,
    STATE(1152), 1,
      sym_comment,
    STATE(1214), 1,
      sym_key,
    STATE(1254), 1,
      sym__key_named,
    ACTIONS(744), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(746), 20,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [91406] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1153), 1,
      sym_comment,
    ACTIONS(764), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(766), 22,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [91445] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1154), 1,
      sym_comment,
    ACTIONS(827), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(829), 22,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [91484] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2089), 1,
      anon_sym_LT,
    ACTIONS(2091), 1,
      anon_sym_DOT,
    ACTIONS(2093), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1155), 1,
      sym_comment,
    ACTIONS(929), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT_DOT,
    ACTIONS(931), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [91529] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1156), 1,
      sym_comment,
    ACTIONS(807), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(809), 22,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [91568] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1157), 1,
      sym_comment,
    ACTIONS(897), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(899), 22,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [91607] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2095), 1,
      anon_sym_LT,
    ACTIONS(2097), 1,
      anon_sym_DOT,
    ACTIONS(2099), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1158), 1,
      sym_comment,
    ACTIONS(931), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(929), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [91652] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1159), 1,
      sym_comment,
    ACTIONS(939), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(941), 22,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [91691] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1160), 1,
      sym_comment,
    ACTIONS(768), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(770), 22,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [91730] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2101), 1,
      anon_sym_LBRACK,
    ACTIONS(2103), 1,
      anon_sym_DOT,
    STATE(1161), 1,
      sym_comment,
    STATE(1257), 1,
      sym_key,
    STATE(1278), 1,
      sym__key_named,
    ACTIONS(689), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(691), 20,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [91777] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2101), 1,
      anon_sym_LBRACK,
    ACTIONS(2103), 1,
      anon_sym_DOT,
    STATE(1162), 1,
      sym_comment,
    STATE(1278), 1,
      sym__key_named,
    STATE(1279), 1,
      sym_key,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(748), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(750), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [91826] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2101), 1,
      anon_sym_LBRACK,
    ACTIONS(2103), 1,
      anon_sym_DOT,
    STATE(1163), 1,
      sym_comment,
    STATE(1278), 1,
      sym__key_named,
    STATE(1282), 1,
      sym_key,
    ACTIONS(744), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(746), 20,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [91873] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1164), 1,
      sym_comment,
    ACTIONS(913), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(915), 22,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [91912] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1165), 1,
      sym_comment,
    ACTIONS(909), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(911), 22,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [91951] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1166), 1,
      sym_comment,
    ACTIONS(921), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(923), 22,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [91990] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1167), 1,
      sym_comment,
    ACTIONS(815), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(817), 22,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [92029] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1168), 1,
      sym_comment,
    ACTIONS(819), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(821), 22,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [92068] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2085), 1,
      anon_sym_LBRACK,
    ACTIONS(2087), 1,
      anon_sym_DOT,
    STATE(1169), 1,
      sym_comment,
    STATE(1253), 1,
      sym_key,
    STATE(1254), 1,
      sym__key_named,
    ACTIONS(689), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(691), 20,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [92115] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2085), 1,
      anon_sym_LBRACK,
    ACTIONS(2087), 1,
      anon_sym_DOT,
    STATE(1170), 1,
      sym_comment,
    STATE(1192), 1,
      sym_key,
    STATE(1254), 1,
      sym__key_named,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(748), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(750), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [92164] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1171), 1,
      sym_comment,
    ACTIONS(925), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(927), 22,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [92203] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1172), 1,
      sym_comment,
    ACTIONS(917), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(919), 22,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [92242] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1173), 1,
      sym_comment,
    ACTIONS(811), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(813), 22,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [92281] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2105), 1,
      anon_sym_LT,
    ACTIONS(2107), 1,
      anon_sym_DOT,
    ACTIONS(2109), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1174), 1,
      sym_comment,
    ACTIONS(929), 4,
      anon_sym_else,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT_DOT,
    ACTIONS(931), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [92325] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(1175), 1,
      sym_comment,
    ACTIONS(943), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(945), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [92365] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2095), 1,
      anon_sym_LT,
    ACTIONS(2111), 1,
      anon_sym_DOT,
    STATE(1176), 1,
      sym_comment,
    ACTIONS(931), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(929), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [92407] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2113), 1,
      anon_sym_LBRACK,
    ACTIONS(2115), 1,
      anon_sym_DOT,
    STATE(1177), 1,
      sym_comment,
    STATE(1386), 1,
      sym_key,
    STATE(1387), 1,
      sym__key_named,
    ACTIONS(689), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(691), 19,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [92453] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2113), 1,
      anon_sym_LBRACK,
    ACTIONS(2115), 1,
      anon_sym_DOT,
    STATE(1178), 1,
      sym_comment,
    STATE(1387), 1,
      sym__key_named,
    STATE(1388), 1,
      sym_key,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(748), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(750), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [92501] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(750), 1,
      anon_sym_COLON,
    ACTIONS(2121), 1,
      anon_sym_LBRACK,
    ACTIONS(2123), 1,
      anon_sym_DOT,
    STATE(1179), 1,
      sym_comment,
    STATE(2541), 1,
      sym__key_named,
    STATE(2542), 1,
      sym_key,
    ACTIONS(2119), 2,
      anon_sym_SEMI,
      anon_sym_AT_LBRACK,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(2117), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [92551] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2125), 1,
      anon_sym_LBRACK,
    ACTIONS(2127), 1,
      anon_sym_DOT,
    STATE(1180), 1,
      sym_comment,
    STATE(1299), 1,
      sym_key,
    STATE(1300), 1,
      sym__key_named,
    ACTIONS(689), 5,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(691), 18,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [92597] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2125), 1,
      anon_sym_LBRACK,
    ACTIONS(2127), 1,
      anon_sym_DOT,
    STATE(1181), 1,
      sym_comment,
    STATE(1300), 1,
      sym__key_named,
    STATE(1301), 1,
      sym_key,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(748), 5,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(750), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [92645] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2125), 1,
      anon_sym_LBRACK,
    ACTIONS(2127), 1,
      anon_sym_DOT,
    STATE(1182), 1,
      sym_comment,
    STATE(1300), 1,
      sym__key_named,
    STATE(1302), 1,
      sym_key,
    ACTIONS(744), 5,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(746), 18,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [92691] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2089), 1,
      anon_sym_LT,
    ACTIONS(2091), 1,
      anon_sym_DOT,
    STATE(1183), 1,
      sym_comment,
    ACTIONS(929), 2,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(931), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [92733] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1184), 1,
      sym_comment,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(748), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(750), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [92773] = 18,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(2129), 1,
      sym_name,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1185), 1,
      sym_comment,
    STATE(2664), 1,
      sym_type,
    STATE(3059), 1,
      sym__outertype,
    STATE(3094), 1,
      sym__fntype_param,
    STATE(3101), 1,
      sym__fntype_gen,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [92839] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2113), 1,
      anon_sym_LBRACK,
    ACTIONS(2115), 1,
      anon_sym_DOT,
    STATE(1186), 1,
      sym_comment,
    STATE(1387), 1,
      sym__key_named,
    STATE(1389), 1,
      sym_key,
    ACTIONS(744), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(746), 19,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [92885] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2131), 1,
      anon_sym_LBRACK,
    ACTIONS(2133), 1,
      anon_sym_DOT,
    STATE(1187), 1,
      sym_comment,
    STATE(1416), 1,
      sym__key_named,
    STATE(1424), 1,
      sym_key,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(748), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(750), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [92932] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1188), 1,
      sym_comment,
    ACTIONS(897), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(899), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [92969] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2135), 1,
      anon_sym_AMP,
    ACTIONS(2137), 1,
      anon_sym_PIPE,
    ACTIONS(2139), 1,
      anon_sym_QMARK,
    STATE(1189), 1,
      sym_comment,
    ACTIONS(1013), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1015), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [93012] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1190), 1,
      sym_comment,
    ACTIONS(917), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(919), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [93049] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1191), 1,
      sym_comment,
    ACTIONS(1013), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1015), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [93086] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1192), 1,
      sym_comment,
    ACTIONS(815), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(817), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [93123] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1193), 1,
      sym_comment,
    ACTIONS(939), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(941), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [93160] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1937), 1,
      anon_sym_LBRACE,
    ACTIONS(1943), 1,
      anon_sym_typeof,
    ACTIONS(2141), 1,
      sym_name,
    ACTIONS(2143), 1,
      anon_sym_LPAREN,
    STATE(414), 1,
      sym_type,
    STATE(563), 1,
      sym__outertype,
    STATE(1096), 1,
      sym_paramtypelist,
    STATE(1194), 1,
      sym_comment,
    STATE(3044), 1,
      sym__fntype_gen,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2145), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(418), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(417), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [93223] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1195), 1,
      sym_comment,
    ACTIONS(987), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(989), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [93260] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_LBRACE,
    ACTIONS(1997), 1,
      anon_sym_typeof,
    ACTIONS(2001), 1,
      anon_sym_nil,
    ACTIONS(2003), 1,
      sym__string_start,
    ACTIONS(2147), 1,
      sym_name,
    ACTIONS(2149), 1,
      anon_sym_LPAREN,
    STATE(1108), 1,
      sym_paramtypelist,
    STATE(1196), 1,
      sym_comment,
    STATE(1517), 1,
      sym_type,
    STATE(2230), 1,
      sym__outertype,
    STATE(3053), 1,
      sym__fntype_gen,
    ACTIONS(1999), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2151), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1519), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1518), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [93323] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2153), 1,
      anon_sym_LT,
    STATE(1197), 1,
      sym_comment,
    ACTIONS(1035), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1033), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [93362] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1887), 1,
      sym_name,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1198), 1,
      sym_comment,
    STATE(2664), 1,
      sym_type,
    STATE(3039), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [93425] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(1199), 1,
      sym_comment,
    ACTIONS(945), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(943), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [93464] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1927), 1,
      anon_sym_LBRACE,
    ACTIONS(1933), 1,
      anon_sym_typeof,
    ACTIONS(2155), 1,
      sym_name,
    ACTIONS(2157), 1,
      anon_sym_LPAREN,
    STATE(1107), 1,
      sym_paramtypelist,
    STATE(1200), 1,
      sym_comment,
    STATE(1223), 1,
      sym_type,
    STATE(1689), 1,
      sym__outertype,
    STATE(3080), 1,
      sym__fntype_gen,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2159), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1210), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1227), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [93527] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1887), 1,
      sym_name,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1201), 1,
      sym_comment,
    STATE(2664), 1,
      sym_type,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3346), 1,
      sym__outertype,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [93590] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1957), 1,
      anon_sym_typeof,
    ACTIONS(2161), 1,
      sym_name,
    ACTIONS(2163), 1,
      anon_sym_LPAREN,
    STATE(1099), 1,
      sym_paramtypelist,
    STATE(1202), 1,
      sym_comment,
    STATE(1597), 1,
      sym_type,
    STATE(2038), 1,
      sym__outertype,
    STATE(3086), 1,
      sym__fntype_gen,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2165), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1601), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1599), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [93653] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1203), 1,
      sym_comment,
    ACTIONS(909), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(911), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [93690] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1204), 1,
      sym_comment,
    ACTIONS(1047), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1049), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [93727] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1981), 1,
      anon_sym_LBRACE,
    ACTIONS(1987), 1,
      anon_sym_typeof,
    ACTIONS(2167), 1,
      sym_name,
    ACTIONS(2169), 1,
      anon_sym_LPAREN,
    STATE(1105), 1,
      sym_paramtypelist,
    STATE(1205), 1,
      sym_comment,
    STATE(1849), 1,
      sym_type,
    STATE(2239), 1,
      sym__outertype,
    STATE(3090), 1,
      sym__fntype_gen,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2171), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1920), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1918), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [93790] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    ACTIONS(2173), 1,
      sym_name,
    ACTIONS(2175), 1,
      anon_sym_LPAREN,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1206), 1,
      sym_comment,
    STATE(1543), 1,
      sym_type,
    STATE(2461), 1,
      sym__outertype,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [93853] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(1207), 1,
      sym_comment,
    ACTIONS(943), 5,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(945), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [93892] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2059), 1,
      anon_sym_LBRACE,
    ACTIONS(2065), 1,
      anon_sym_typeof,
    ACTIONS(2069), 1,
      anon_sym_nil,
    ACTIONS(2071), 1,
      sym__string_start,
    ACTIONS(2177), 1,
      sym_name,
    ACTIONS(2179), 1,
      anon_sym_LPAREN,
    STATE(1123), 1,
      sym_paramtypelist,
    STATE(1208), 1,
      sym_comment,
    STATE(2800), 1,
      sym_type,
    STATE(2916), 1,
      sym__outertype,
    STATE(3070), 1,
      sym__fntype_gen,
    ACTIONS(2067), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2181), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(2809), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2807), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [93955] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2017), 1,
      anon_sym_LBRACE,
    ACTIONS(2023), 1,
      anon_sym_typeof,
    ACTIONS(2027), 1,
      anon_sym_nil,
    ACTIONS(2029), 1,
      sym__string_start,
    ACTIONS(2183), 1,
      sym_name,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    STATE(1115), 1,
      sym_paramtypelist,
    STATE(1209), 1,
      sym_comment,
    STATE(1348), 1,
      sym_type,
    STATE(1982), 1,
      sym__outertype,
    STATE(3047), 1,
      sym__fntype_gen,
    ACTIONS(2025), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2187), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1350), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1349), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [94018] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1210), 1,
      sym_comment,
    ACTIONS(983), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(985), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [94055] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1211), 1,
      sym_comment,
    ACTIONS(1017), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1019), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [94092] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1212), 1,
      sym_comment,
    ACTIONS(897), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(899), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [94129] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_LBRACE,
    ACTIONS(1997), 1,
      anon_sym_typeof,
    ACTIONS(2001), 1,
      anon_sym_nil,
    ACTIONS(2003), 1,
      sym__string_start,
    ACTIONS(2147), 1,
      sym_name,
    ACTIONS(2149), 1,
      anon_sym_LPAREN,
    STATE(1108), 1,
      sym_paramtypelist,
    STATE(1213), 1,
      sym_comment,
    STATE(1517), 1,
      sym_type,
    STATE(2016), 1,
      sym__outertype,
    STATE(3053), 1,
      sym__fntype_gen,
    ACTIONS(1999), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2151), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1519), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1518), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [94192] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1214), 1,
      sym_comment,
    ACTIONS(819), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(821), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [94229] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2033), 1,
      anon_sym_LBRACE,
    ACTIONS(2039), 1,
      anon_sym_typeof,
    ACTIONS(2043), 1,
      anon_sym_nil,
    ACTIONS(2045), 1,
      sym__string_start,
    ACTIONS(2189), 1,
      sym_name,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    STATE(1117), 1,
      sym_paramtypelist,
    STATE(1215), 1,
      sym_comment,
    STATE(1448), 1,
      sym_type,
    STATE(2265), 1,
      sym__outertype,
    STATE(3111), 1,
      sym__fntype_gen,
    ACTIONS(2041), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2193), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1450), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1449), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [94292] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1216), 1,
      sym_comment,
    ACTIONS(1051), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1053), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [94329] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1217), 1,
      sym_comment,
    ACTIONS(823), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(825), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [94366] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1218), 1,
      sym_comment,
    ACTIONS(995), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(997), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [94403] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1219), 1,
      sym_comment,
    ACTIONS(921), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(923), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [94440] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    ACTIONS(2173), 1,
      sym_name,
    ACTIONS(2175), 1,
      anon_sym_LPAREN,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1220), 1,
      sym_comment,
    STATE(1543), 1,
      sym_type,
    STATE(1955), 1,
      sym__outertype,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [94503] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1221), 1,
      sym_comment,
    ACTIONS(913), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(915), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [94540] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(1977), 1,
      anon_sym_typeof,
    ACTIONS(2195), 1,
      sym_name,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    STATE(1104), 1,
      sym_paramtypelist,
    STATE(1222), 1,
      sym_comment,
    STATE(1325), 1,
      sym_type,
    STATE(1743), 1,
      sym__outertype,
    STATE(3112), 1,
      sym__fntype_gen,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2199), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1327), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1326), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [94603] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2135), 1,
      anon_sym_AMP,
    ACTIONS(2137), 1,
      anon_sym_PIPE,
    ACTIONS(2139), 1,
      anon_sym_QMARK,
    STATE(1223), 1,
      sym_comment,
    ACTIONS(969), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(971), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [94646] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1224), 1,
      sym_comment,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(748), 5,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(750), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [94685] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1225), 1,
      sym_comment,
    ACTIONS(991), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(993), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [94722] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1226), 1,
      sym_comment,
    ACTIONS(925), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(927), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [94759] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1227), 1,
      sym_comment,
    ACTIONS(979), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(981), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [94796] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1228), 1,
      sym_comment,
    ACTIONS(760), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(762), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [94833] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1887), 1,
      sym_name,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1229), 1,
      sym_comment,
    STATE(2664), 1,
      sym_type,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3522), 1,
      sym__outertype,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [94896] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2105), 1,
      anon_sym_LT,
    ACTIONS(2107), 1,
      anon_sym_DOT,
    STATE(1230), 1,
      sym_comment,
    ACTIONS(929), 3,
      anon_sym_else,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(931), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [94937] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1231), 1,
      sym_comment,
    ACTIONS(827), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(829), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [94974] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2131), 1,
      anon_sym_LBRACK,
    ACTIONS(2133), 1,
      anon_sym_DOT,
    STATE(1232), 1,
      sym_comment,
    STATE(1412), 1,
      sym_key,
    STATE(1416), 1,
      sym__key_named,
    ACTIONS(689), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(691), 18,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [95019] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2201), 1,
      anon_sym_LBRACK,
    ACTIONS(2203), 1,
      anon_sym_DOT,
    STATE(1233), 1,
      sym_comment,
    STATE(1399), 1,
      sym__key_named,
    STATE(1417), 1,
      sym_key,
    ACTIONS(689), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(691), 18,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [95064] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1887), 1,
      sym_name,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1234), 1,
      sym_comment,
    STATE(2664), 1,
      sym_type,
    STATE(3060), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [95127] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2131), 1,
      anon_sym_LBRACK,
    ACTIONS(2133), 1,
      anon_sym_DOT,
    STATE(1235), 1,
      sym_comment,
    STATE(1416), 1,
      sym__key_named,
    STATE(1434), 1,
      sym_key,
    ACTIONS(744), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(746), 18,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [95172] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1236), 1,
      sym_comment,
    ACTIONS(768), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(770), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [95209] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    ACTIONS(2173), 1,
      sym_name,
    ACTIONS(2175), 1,
      anon_sym_LPAREN,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1237), 1,
      sym_comment,
    STATE(1543), 1,
      sym_type,
    STATE(2198), 1,
      sym__outertype,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1875), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [95272] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2205), 1,
      anon_sym_LT,
    ACTIONS(2207), 1,
      anon_sym_DOT,
    ACTIONS(2209), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1238), 1,
      sym_comment,
    ACTIONS(931), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(929), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [95315] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2201), 1,
      anon_sym_LBRACK,
    ACTIONS(2203), 1,
      anon_sym_DOT,
    STATE(1239), 1,
      sym_comment,
    STATE(1399), 1,
      sym__key_named,
    STATE(1445), 1,
      sym_key,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(748), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(750), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [95362] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1240), 1,
      sym_comment,
    ACTIONS(827), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(829), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [95399] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1241), 1,
      sym_comment,
    ACTIONS(823), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(825), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [95436] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1242), 1,
      sym_comment,
    ACTIONS(764), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(766), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [95473] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1243), 1,
      sym_comment,
    ACTIONS(768), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(770), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [95510] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1887), 1,
      sym_name,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1244), 1,
      sym_comment,
    STATE(2664), 1,
      sym_type,
    STATE(2936), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [95573] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1245), 1,
      sym_comment,
    ACTIONS(909), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(911), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [95610] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1917), 1,
      anon_sym_LBRACE,
    ACTIONS(1923), 1,
      anon_sym_typeof,
    ACTIONS(2211), 1,
      sym_name,
    ACTIONS(2213), 1,
      anon_sym_LPAREN,
    STATE(1112), 1,
      sym_paramtypelist,
    STATE(1246), 1,
      sym_comment,
    STATE(1819), 1,
      sym_type,
    STATE(2129), 1,
      sym__outertype,
    STATE(3066), 1,
      sym__fntype_gen,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2215), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1820), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1737), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [95673] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1247), 1,
      sym_comment,
    ACTIONS(955), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(957), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [95710] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1248), 1,
      sym_comment,
    ACTIONS(913), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(915), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [95747] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2135), 1,
      anon_sym_AMP,
    ACTIONS(2137), 1,
      anon_sym_PIPE,
    ACTIONS(2139), 1,
      anon_sym_QMARK,
    STATE(1249), 1,
      sym_comment,
    ACTIONS(999), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1001), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [95790] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1250), 1,
      sym_comment,
    ACTIONS(917), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(919), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [95827] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1251), 1,
      sym_comment,
    ACTIONS(939), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(941), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [95864] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1961), 1,
      anon_sym_LBRACE,
    ACTIONS(1967), 1,
      anon_sym_typeof,
    ACTIONS(2217), 1,
      sym_name,
    ACTIONS(2219), 1,
      anon_sym_LPAREN,
    STATE(1102), 1,
      sym_paramtypelist,
    STATE(1252), 1,
      sym_comment,
    STATE(1786), 1,
      sym_type,
    STATE(2116), 1,
      sym__outertype,
    STATE(3078), 1,
      sym__fntype_gen,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2221), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1789), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1788), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [95927] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1253), 1,
      sym_comment,
    ACTIONS(807), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(809), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [95964] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1254), 1,
      sym_comment,
    ACTIONS(811), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(813), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [96001] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2223), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_DOT,
    ACTIONS(2227), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1255), 1,
      sym_comment,
    ACTIONS(931), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(929), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [96044] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1256), 1,
      sym_comment,
    ACTIONS(1055), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1057), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [96081] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1257), 1,
      sym_comment,
    ACTIONS(807), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(809), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [96118] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1258), 1,
      sym_comment,
    ACTIONS(1003), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1005), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [96155] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1259), 1,
      sym_comment,
    ACTIONS(1059), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1061), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [96192] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(2075), 1,
      anon_sym_LBRACE,
    ACTIONS(2081), 1,
      anon_sym_typeof,
    ACTIONS(2229), 1,
      sym_name,
    ACTIONS(2231), 1,
      anon_sym_LPAREN,
    STATE(411), 1,
      sym_type,
    STATE(616), 1,
      sym__outertype,
    STATE(1126), 1,
      sym_paramtypelist,
    STATE(1260), 1,
      sym_comment,
    STATE(3109), 1,
      sym__fntype_gen,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2233), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(415), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(412), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [96255] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2017), 1,
      anon_sym_LBRACE,
    ACTIONS(2023), 1,
      anon_sym_typeof,
    ACTIONS(2027), 1,
      anon_sym_nil,
    ACTIONS(2029), 1,
      sym__string_start,
    ACTIONS(2183), 1,
      sym_name,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    STATE(1115), 1,
      sym_paramtypelist,
    STATE(1261), 1,
      sym_comment,
    STATE(1348), 1,
      sym_type,
    STATE(2004), 1,
      sym__outertype,
    STATE(3047), 1,
      sym__fntype_gen,
    ACTIONS(2025), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2187), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1350), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1349), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [96318] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1907), 1,
      anon_sym_LBRACE,
    ACTIONS(1913), 1,
      anon_sym_typeof,
    ACTIONS(2235), 1,
      sym_name,
    ACTIONS(2237), 1,
      anon_sym_LPAREN,
    STATE(293), 1,
      sym_type,
    STATE(502), 1,
      sym__outertype,
    STATE(1092), 1,
      sym_paramtypelist,
    STATE(1262), 1,
      sym_comment,
    STATE(3051), 1,
      sym__fntype_gen,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2239), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(295), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(294), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [96381] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1263), 1,
      sym_comment,
    ACTIONS(760), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(762), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [96418] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2241), 1,
      anon_sym_LT,
    ACTIONS(2243), 1,
      anon_sym_DOT,
    ACTIONS(2245), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1264), 1,
      sym_comment,
    ACTIONS(931), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(929), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [96461] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2017), 1,
      anon_sym_LBRACE,
    ACTIONS(2023), 1,
      anon_sym_typeof,
    ACTIONS(2027), 1,
      anon_sym_nil,
    ACTIONS(2029), 1,
      sym__string_start,
    ACTIONS(2183), 1,
      sym_name,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    STATE(1115), 1,
      sym_paramtypelist,
    STATE(1265), 1,
      sym_comment,
    STATE(1348), 1,
      sym_type,
    STATE(1821), 1,
      sym__outertype,
    STATE(3047), 1,
      sym__fntype_gen,
    ACTIONS(2025), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2187), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1350), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1349), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [96524] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2033), 1,
      anon_sym_LBRACE,
    ACTIONS(2039), 1,
      anon_sym_typeof,
    ACTIONS(2043), 1,
      anon_sym_nil,
    ACTIONS(2045), 1,
      sym__string_start,
    ACTIONS(2189), 1,
      sym_name,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    STATE(1117), 1,
      sym_paramtypelist,
    STATE(1266), 1,
      sym_comment,
    STATE(1448), 1,
      sym_type,
    STATE(1961), 1,
      sym__outertype,
    STATE(3111), 1,
      sym__fntype_gen,
    ACTIONS(2041), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2193), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1450), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1449), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [96587] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1267), 1,
      sym_comment,
    ACTIONS(764), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(766), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [96624] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1268), 1,
      sym_comment,
    ACTIONS(1063), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1065), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [96661] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2135), 1,
      anon_sym_AMP,
    ACTIONS(2137), 1,
      anon_sym_PIPE,
    ACTIONS(2139), 1,
      anon_sym_QMARK,
    STATE(1269), 1,
      sym_comment,
    ACTIONS(1025), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1027), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [96704] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1887), 1,
      sym_name,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1270), 1,
      sym_comment,
    STATE(2664), 1,
      sym_type,
    STATE(3101), 1,
      sym__fntype_gen,
    STATE(3110), 1,
      sym__outertype,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [96767] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2033), 1,
      anon_sym_LBRACE,
    ACTIONS(2039), 1,
      anon_sym_typeof,
    ACTIONS(2043), 1,
      anon_sym_nil,
    ACTIONS(2045), 1,
      sym__string_start,
    ACTIONS(2189), 1,
      sym_name,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    STATE(1117), 1,
      sym_paramtypelist,
    STATE(1271), 1,
      sym_comment,
    STATE(1448), 1,
      sym_type,
    STATE(2294), 1,
      sym__outertype,
    STATE(3111), 1,
      sym__fntype_gen,
    ACTIONS(2041), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2193), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1450), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1449), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [96830] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1897), 1,
      anon_sym_LBRACE,
    ACTIONS(1903), 1,
      anon_sym_typeof,
    ACTIONS(2247), 1,
      sym_name,
    ACTIONS(2249), 1,
      anon_sym_LPAREN,
    STATE(369), 1,
      sym_type,
    STATE(601), 1,
      sym__outertype,
    STATE(1119), 1,
      sym_paramtypelist,
    STATE(1272), 1,
      sym_comment,
    STATE(3067), 1,
      sym__fntype_gen,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2251), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(372), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(370), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [96893] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1273), 1,
      sym_comment,
    ACTIONS(764), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(766), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [96930] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1274), 1,
      sym_comment,
    ACTIONS(921), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(923), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [96967] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1887), 1,
      sym_name,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1275), 1,
      sym_comment,
    STATE(2664), 1,
      sym_type,
    STATE(2954), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [97030] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(2007), 1,
      anon_sym_LBRACE,
    ACTIONS(2013), 1,
      anon_sym_typeof,
    ACTIONS(2253), 1,
      sym_name,
    ACTIONS(2255), 1,
      anon_sym_LPAREN,
    STATE(1121), 1,
      sym_paramtypelist,
    STATE(1276), 1,
      sym_comment,
    STATE(1857), 1,
      sym_type,
    STATE(2361), 1,
      sym__outertype,
    STATE(3102), 1,
      sym__fntype_gen,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2257), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1859), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1858), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [97093] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1277), 1,
      sym_comment,
    ACTIONS(1021), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1023), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [97130] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1278), 1,
      sym_comment,
    ACTIONS(811), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(813), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [97167] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1279), 1,
      sym_comment,
    ACTIONS(815), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(817), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [97204] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1887), 1,
      sym_name,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1280), 1,
      sym_comment,
    STATE(2664), 1,
      sym_type,
    STATE(3091), 1,
      sym__outertype,
    STATE(3101), 1,
      sym__fntype_gen,
    ACTIONS(1393), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [97267] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1281), 1,
      sym_comment,
    ACTIONS(1029), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1031), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [97304] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1282), 1,
      sym_comment,
    ACTIONS(819), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(821), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [97341] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2259), 1,
      anon_sym_LT,
    STATE(1283), 1,
      sym_comment,
    ACTIONS(1033), 2,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1035), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [97380] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2139), 1,
      anon_sym_QMARK,
    STATE(1284), 1,
      sym_comment,
    ACTIONS(1039), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1041), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
  [97419] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2135), 1,
      anon_sym_AMP,
    ACTIONS(2139), 1,
      anon_sym_QMARK,
    STATE(1285), 1,
      sym_comment,
    ACTIONS(1039), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1041), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_PIPE,
  [97460] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2135), 1,
      anon_sym_AMP,
    ACTIONS(2137), 1,
      anon_sym_PIPE,
    ACTIONS(2139), 1,
      anon_sym_QMARK,
    STATE(1286), 1,
      sym_comment,
    ACTIONS(1043), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1045), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [97503] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1287), 1,
      sym_comment,
    ACTIONS(925), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(927), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [97540] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1288), 1,
      sym_comment,
    ACTIONS(959), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(961), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [97577] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1289), 1,
      sym_comment,
    ACTIONS(1043), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1045), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [97614] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(2049), 1,
      anon_sym_LBRACE,
    ACTIONS(2055), 1,
      anon_sym_typeof,
    ACTIONS(2261), 1,
      sym_name,
    ACTIONS(2263), 1,
      anon_sym_LPAREN,
    STATE(1122), 1,
      sym_paramtypelist,
    STATE(1290), 1,
      sym_comment,
    STATE(1535), 1,
      sym_type,
    STATE(1956), 1,
      sym__outertype,
    STATE(3072), 1,
      sym__fntype_gen,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2265), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1538), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1536), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [97677] = 17,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_LBRACE,
    ACTIONS(1997), 1,
      anon_sym_typeof,
    ACTIONS(2001), 1,
      anon_sym_nil,
    ACTIONS(2003), 1,
      sym__string_start,
    ACTIONS(2147), 1,
      sym_name,
    ACTIONS(2149), 1,
      anon_sym_LPAREN,
    STATE(1108), 1,
      sym_paramtypelist,
    STATE(1291), 1,
      sym_comment,
    STATE(1517), 1,
      sym_type,
    STATE(2221), 1,
      sym__outertype,
    STATE(3053), 1,
      sym__fntype_gen,
    ACTIONS(1999), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2151), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1519), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1518), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [97740] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1292), 1,
      sym_comment,
    ACTIONS(768), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(770), 21,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [97777] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2201), 1,
      anon_sym_LBRACK,
    ACTIONS(2203), 1,
      anon_sym_DOT,
    STATE(1293), 1,
      sym_comment,
    STATE(1399), 1,
      sym__key_named,
    STATE(1420), 1,
      sym_key,
    ACTIONS(744), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(746), 18,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [97822] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1071), 1,
      anon_sym_COLON,
    STATE(1294), 1,
      sym_comment,
    STATE(2962), 1,
      sym__method_name,
    ACTIONS(1067), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1069), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [97862] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2205), 1,
      anon_sym_LT,
    ACTIONS(2267), 1,
      anon_sym_DOT,
    STATE(1295), 1,
      sym_comment,
    ACTIONS(931), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(929), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [97902] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2269), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_DOT,
    ACTIONS(2273), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1296), 1,
      sym_comment,
    ACTIONS(929), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT_DOT,
    ACTIONS(931), 19,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [97944] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2241), 1,
      anon_sym_LT,
    ACTIONS(2275), 1,
      anon_sym_DOT,
    STATE(1297), 1,
      sym_comment,
    ACTIONS(931), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(929), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [97984] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2277), 1,
      anon_sym_LT,
    ACTIONS(2279), 1,
      anon_sym_DOT,
    ACTIONS(2281), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1298), 1,
      sym_comment,
    ACTIONS(929), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT_DOT,
    ACTIONS(931), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [98026] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1299), 1,
      sym_comment,
    ACTIONS(807), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(809), 19,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98062] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1300), 1,
      sym_comment,
    ACTIONS(811), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(813), 19,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98098] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1301), 1,
      sym_comment,
    ACTIONS(815), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(817), 19,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98134] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1302), 1,
      sym_comment,
    ACTIONS(819), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(821), 19,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98170] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1303), 1,
      sym_comment,
    ACTIONS(823), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(825), 19,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98206] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1304), 1,
      sym_comment,
    ACTIONS(827), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(829), 19,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98242] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(750), 1,
      anon_sym_COLON,
    ACTIONS(2121), 1,
      anon_sym_LBRACK,
    ACTIONS(2123), 1,
      anon_sym_DOT,
    STATE(1305), 1,
      sym_comment,
    STATE(2541), 1,
      sym__key_named,
    STATE(2542), 1,
      sym_key,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(2119), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_AT_LBRACK,
    ACTIONS(2117), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [98290] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1306), 1,
      sym_comment,
    ACTIONS(764), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(766), 20,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98326] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1307), 1,
      sym_comment,
    ACTIONS(939), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(941), 20,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98362] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1308), 1,
      sym_comment,
    ACTIONS(897), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(899), 19,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98398] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1309), 1,
      sym_comment,
    ACTIONS(768), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(770), 20,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98434] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1310), 1,
      sym_comment,
    ACTIONS(760), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(762), 20,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98470] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(750), 1,
      anon_sym_COLON,
    ACTIONS(2121), 1,
      anon_sym_LBRACK,
    ACTIONS(2123), 1,
      anon_sym_DOT,
    STATE(1311), 1,
      sym_comment,
    STATE(2541), 1,
      sym__key_named,
    STATE(2542), 1,
      sym_key,
    ACTIONS(2119), 2,
      anon_sym_SEMI,
      anon_sym_AT_LBRACK,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(2117), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [98518] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1312), 1,
      sym_comment,
    ACTIONS(911), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(909), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [98554] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1313), 1,
      sym_comment,
    ACTIONS(915), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(913), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [98590] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1314), 1,
      sym_comment,
    ACTIONS(919), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(917), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [98626] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1315), 1,
      sym_comment,
    ACTIONS(923), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(921), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [98662] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1316), 1,
      sym_comment,
    ACTIONS(927), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(925), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [98698] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2223), 1,
      anon_sym_LT,
    ACTIONS(2283), 1,
      anon_sym_DOT,
    STATE(1317), 1,
      sym_comment,
    ACTIONS(931), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(929), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [98738] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1318), 1,
      sym_comment,
    ACTIONS(955), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(957), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [98774] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1319), 1,
      sym_comment,
    ACTIONS(959), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(961), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [98810] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1320), 1,
      sym_comment,
    ACTIONS(909), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(911), 19,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98846] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1321), 1,
      sym_comment,
    ACTIONS(913), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(915), 19,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98882] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1322), 1,
      sym_comment,
    ACTIONS(917), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(919), 19,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98918] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1323), 1,
      sym_comment,
    ACTIONS(921), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(923), 19,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98954] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1324), 1,
      sym_comment,
    ACTIONS(925), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(927), 19,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [98990] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2285), 1,
      anon_sym_AMP,
    ACTIONS(2287), 1,
      anon_sym_PIPE,
    ACTIONS(2289), 1,
      anon_sym_QMARK,
    STATE(1325), 1,
      sym_comment,
    ACTIONS(969), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(971), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [99032] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1326), 1,
      sym_comment,
    ACTIONS(979), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(981), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99068] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1327), 1,
      sym_comment,
    ACTIONS(983), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(985), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99104] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1328), 1,
      sym_comment,
    ACTIONS(987), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(989), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99140] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1329), 1,
      sym_comment,
    ACTIONS(991), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(993), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99176] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1330), 1,
      sym_comment,
    ACTIONS(1063), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1065), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99212] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1331), 1,
      sym_comment,
    ACTIONS(995), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(997), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99248] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2285), 1,
      anon_sym_AMP,
    ACTIONS(2287), 1,
      anon_sym_PIPE,
    ACTIONS(2289), 1,
      anon_sym_QMARK,
    STATE(1332), 1,
      sym_comment,
    ACTIONS(999), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1001), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [99290] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1333), 1,
      sym_comment,
    ACTIONS(1003), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1005), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99326] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2285), 1,
      anon_sym_AMP,
    ACTIONS(2287), 1,
      anon_sym_PIPE,
    ACTIONS(2289), 1,
      anon_sym_QMARK,
    STATE(1334), 1,
      sym_comment,
    ACTIONS(1013), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1015), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [99368] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1335), 1,
      sym_comment,
    ACTIONS(1013), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1015), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99404] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1336), 1,
      sym_comment,
    ACTIONS(1017), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1019), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99440] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1337), 1,
      sym_comment,
    ACTIONS(1021), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1023), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99476] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2285), 1,
      anon_sym_AMP,
    ACTIONS(2287), 1,
      anon_sym_PIPE,
    ACTIONS(2289), 1,
      anon_sym_QMARK,
    STATE(1338), 1,
      sym_comment,
    ACTIONS(1025), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1027), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [99518] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1339), 1,
      sym_comment,
    ACTIONS(1029), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1031), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99554] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2291), 1,
      anon_sym_LT,
    STATE(1340), 1,
      sym_comment,
    ACTIONS(1033), 3,
      anon_sym_else,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1035), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99592] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2289), 1,
      anon_sym_QMARK,
    STATE(1341), 1,
      sym_comment,
    ACTIONS(1039), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1041), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
  [99630] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2285), 1,
      anon_sym_AMP,
    ACTIONS(2287), 1,
      anon_sym_PIPE,
    ACTIONS(2289), 1,
      anon_sym_QMARK,
    STATE(1342), 1,
      sym_comment,
    ACTIONS(1043), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1045), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [99672] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1343), 1,
      sym_comment,
    ACTIONS(1043), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1045), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99708] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1344), 1,
      sym_comment,
    ACTIONS(1047), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1049), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99744] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1345), 1,
      sym_comment,
    ACTIONS(1051), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1053), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99780] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1346), 1,
      sym_comment,
    ACTIONS(1055), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1057), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99816] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1347), 1,
      sym_comment,
    ACTIONS(1059), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1061), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [99852] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2293), 1,
      anon_sym_AMP,
    ACTIONS(2295), 1,
      anon_sym_PIPE,
    ACTIONS(2297), 1,
      anon_sym_QMARK,
    STATE(1348), 1,
      sym_comment,
    ACTIONS(971), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(969), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [99894] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1349), 1,
      sym_comment,
    ACTIONS(981), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(979), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [99930] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1350), 1,
      sym_comment,
    ACTIONS(985), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(983), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [99966] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1351), 1,
      sym_comment,
    ACTIONS(989), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(987), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100002] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1352), 1,
      sym_comment,
    ACTIONS(993), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(991), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100038] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1353), 1,
      sym_comment,
    ACTIONS(1065), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1063), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100074] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1354), 1,
      sym_comment,
    ACTIONS(997), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(995), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100110] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2293), 1,
      anon_sym_AMP,
    ACTIONS(2295), 1,
      anon_sym_PIPE,
    ACTIONS(2297), 1,
      anon_sym_QMARK,
    STATE(1355), 1,
      sym_comment,
    ACTIONS(1001), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(999), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100152] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1356), 1,
      sym_comment,
    ACTIONS(1005), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1003), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100188] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2293), 1,
      anon_sym_AMP,
    ACTIONS(2295), 1,
      anon_sym_PIPE,
    ACTIONS(2297), 1,
      anon_sym_QMARK,
    STATE(1357), 1,
      sym_comment,
    ACTIONS(1015), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1013), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100230] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1358), 1,
      sym_comment,
    ACTIONS(1015), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1013), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100266] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1359), 1,
      sym_comment,
    ACTIONS(1019), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1017), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100302] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1360), 1,
      sym_comment,
    ACTIONS(1023), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1021), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100338] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2293), 1,
      anon_sym_AMP,
    ACTIONS(2295), 1,
      anon_sym_PIPE,
    ACTIONS(2297), 1,
      anon_sym_QMARK,
    STATE(1361), 1,
      sym_comment,
    ACTIONS(1027), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1025), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100380] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1362), 1,
      sym_comment,
    ACTIONS(1031), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1029), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100416] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2297), 1,
      anon_sym_QMARK,
    STATE(1363), 1,
      sym_comment,
    ACTIONS(1041), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT_LBRACK,
    ACTIONS(1039), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100454] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2293), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_QMARK,
    STATE(1364), 1,
      sym_comment,
    ACTIONS(1041), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_AT_LBRACK,
    ACTIONS(1039), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100494] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2293), 1,
      anon_sym_AMP,
    ACTIONS(2295), 1,
      anon_sym_PIPE,
    ACTIONS(2297), 1,
      anon_sym_QMARK,
    STATE(1365), 1,
      sym_comment,
    ACTIONS(1045), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1043), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100536] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1366), 1,
      sym_comment,
    ACTIONS(1045), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1043), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100572] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1367), 1,
      sym_comment,
    ACTIONS(1049), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1047), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100608] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1368), 1,
      sym_comment,
    ACTIONS(1053), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1051), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100644] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1369), 1,
      sym_comment,
    ACTIONS(1057), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1055), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100680] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1370), 1,
      sym_comment,
    ACTIONS(1061), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1059), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100716] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1371), 1,
      sym_comment,
    ACTIONS(957), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(955), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100752] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1372), 1,
      sym_comment,
    ACTIONS(961), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(959), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100788] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1373), 1,
      sym_comment,
    ACTIONS(941), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(939), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100824] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1374), 1,
      sym_comment,
    ACTIONS(762), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(760), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100860] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(750), 1,
      anon_sym_COLON,
    ACTIONS(2121), 1,
      anon_sym_LBRACK,
    ACTIONS(2123), 1,
      anon_sym_DOT,
    STATE(1375), 1,
      sym_comment,
    STATE(2541), 1,
      sym__key_named,
    STATE(2542), 1,
      sym_key,
    ACTIONS(2119), 2,
      anon_sym_SEMI,
      anon_sym_AT_LBRACK,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(2117), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [100908] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1376), 1,
      sym_comment,
    ACTIONS(939), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(941), 19,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [100944] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1377), 1,
      sym_comment,
    ACTIONS(760), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(762), 19,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [100980] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1378), 1,
      sym_comment,
    ACTIONS(764), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(766), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [101016] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1379), 1,
      sym_comment,
    ACTIONS(768), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(770), 21,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [101052] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1380), 1,
      sym_comment,
    ACTIONS(766), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(764), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [101088] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1381), 1,
      sym_comment,
    ACTIONS(770), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(768), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [101124] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1382), 1,
      sym_comment,
    ACTIONS(764), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(766), 19,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101160] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1383), 1,
      sym_comment,
    ACTIONS(768), 6,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(770), 19,
      sym__string_start,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101196] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1384), 1,
      sym_comment,
    ACTIONS(766), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(764), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [101232] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1385), 1,
      sym_comment,
    ACTIONS(770), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(768), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [101268] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1386), 1,
      sym_comment,
    ACTIONS(807), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(809), 20,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101304] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1387), 1,
      sym_comment,
    ACTIONS(811), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(813), 20,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101340] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1388), 1,
      sym_comment,
    ACTIONS(815), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(817), 20,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101376] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1389), 1,
      sym_comment,
    ACTIONS(819), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(821), 20,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101412] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1390), 1,
      sym_comment,
    ACTIONS(823), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(825), 20,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101448] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1391), 1,
      sym_comment,
    ACTIONS(827), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(829), 20,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101484] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1392), 1,
      sym_comment,
    ACTIONS(897), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(899), 20,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101520] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1393), 1,
      sym_comment,
    ACTIONS(909), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(911), 20,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101556] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1394), 1,
      sym_comment,
    ACTIONS(913), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(915), 20,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101592] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1395), 1,
      sym_comment,
    ACTIONS(917), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(919), 20,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101628] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1396), 1,
      sym_comment,
    ACTIONS(921), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(923), 20,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101664] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1397), 1,
      sym_comment,
    ACTIONS(925), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(927), 20,
      sym__string_start,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101700] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2285), 1,
      anon_sym_AMP,
    ACTIONS(2289), 1,
      anon_sym_QMARK,
    STATE(1398), 1,
      sym_comment,
    ACTIONS(1039), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1041), 19,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [101740] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1399), 1,
      sym_comment,
    ACTIONS(811), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(813), 19,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101775] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1400), 1,
      sym_comment,
    ACTIONS(939), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(941), 19,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101810] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1401), 1,
      sym_comment,
    ACTIONS(760), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(762), 19,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101845] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1402), 1,
      sym_comment,
    ACTIONS(764), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(766), 19,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101880] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1403), 1,
      sym_comment,
    ACTIONS(768), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(770), 19,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [101915] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2299), 1,
      anon_sym_LT,
    STATE(1404), 1,
      sym_comment,
    ACTIONS(1035), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1033), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [101952] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(1405), 1,
      sym_comment,
    ACTIONS(945), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(943), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [101989] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2301), 1,
      anon_sym_LT,
    ACTIONS(2303), 1,
      anon_sym_DOT,
    ACTIONS(2305), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1406), 1,
      sym_comment,
    ACTIONS(929), 4,
      anon_sym_else,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT_DOT,
    ACTIONS(931), 17,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [102030] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1407), 1,
      sym_comment,
    ACTIONS(921), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(923), 19,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102065] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1408), 1,
      sym_comment,
    ACTIONS(760), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(762), 19,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102100] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1409), 1,
      sym_comment,
    ACTIONS(925), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(927), 19,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102135] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2277), 1,
      anon_sym_LT,
    ACTIONS(2279), 1,
      anon_sym_DOT,
    STATE(1410), 1,
      sym_comment,
    ACTIONS(929), 2,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(931), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [102174] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1411), 1,
      sym_comment,
    ACTIONS(827), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(829), 19,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102209] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1412), 1,
      sym_comment,
    ACTIONS(807), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(809), 19,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102244] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2307), 1,
      anon_sym_LT,
    STATE(1413), 1,
      sym_comment,
    ACTIONS(1035), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1033), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [102281] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(1414), 1,
      sym_comment,
    ACTIONS(943), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(945), 19,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [102318] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1415), 1,
      sym_comment,
    ACTIONS(897), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(899), 19,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102353] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1416), 1,
      sym_comment,
    ACTIONS(811), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(813), 19,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102388] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1417), 1,
      sym_comment,
    ACTIONS(807), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(809), 19,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102423] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1418), 1,
      sym_comment,
    ACTIONS(823), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(825), 19,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102458] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1419), 1,
      sym_comment,
    ACTIONS(768), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(770), 19,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102493] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1420), 1,
      sym_comment,
    ACTIONS(819), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(821), 19,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102528] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1421), 1,
      sym_comment,
    ACTIONS(823), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(825), 19,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102563] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1422), 1,
      sym_comment,
    ACTIONS(827), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(829), 19,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102598] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1423), 1,
      sym_comment,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(748), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(750), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [102635] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1424), 1,
      sym_comment,
    ACTIONS(815), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(817), 19,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102670] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(1425), 1,
      sym_comment,
    ACTIONS(943), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(945), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [102707] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1426), 1,
      sym_comment,
    ACTIONS(909), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(911), 19,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102742] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1427), 1,
      sym_comment,
    ACTIONS(913), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(915), 19,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102777] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2309), 1,
      anon_sym_LT,
    STATE(1428), 1,
      sym_comment,
    ACTIONS(1035), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1033), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [102814] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1429), 1,
      sym_comment,
    ACTIONS(917), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(919), 19,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102849] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(1430), 1,
      sym_comment,
    ACTIONS(945), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(943), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [102886] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1071), 1,
      anon_sym_COLON,
    STATE(1431), 1,
      sym_comment,
    STATE(2962), 1,
      sym__method_name,
    ACTIONS(1067), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1069), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [102925] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1432), 1,
      sym_comment,
    ACTIONS(897), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(899), 19,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102960] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1433), 1,
      sym_comment,
    ACTIONS(921), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(923), 19,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [102995] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1434), 1,
      sym_comment,
    ACTIONS(819), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(821), 19,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [103030] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1435), 1,
      sym_comment,
    ACTIONS(925), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(927), 19,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [103065] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1436), 1,
      sym_comment,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(748), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(750), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [103102] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1437), 1,
      sym_comment,
    ACTIONS(764), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(766), 19,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [103137] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2311), 1,
      anon_sym_LT,
    ACTIONS(2313), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1438), 1,
      sym_comment,
    ACTIONS(929), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT_DOT,
    ACTIONS(931), 18,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [103178] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(1439), 1,
      sym_comment,
    ACTIONS(945), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(943), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [103215] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1440), 1,
      sym_comment,
    ACTIONS(909), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(911), 19,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [103250] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1441), 1,
      sym_comment,
    ACTIONS(913), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(915), 19,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [103285] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1442), 1,
      sym_comment,
    ACTIONS(939), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(941), 19,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [103320] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2269), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_DOT,
    STATE(1443), 1,
      sym_comment,
    ACTIONS(929), 2,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(931), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [103359] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1444), 1,
      sym_comment,
    ACTIONS(917), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(919), 19,
      sym__string_start,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [103394] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1445), 1,
      sym_comment,
    ACTIONS(815), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(817), 19,
      sym__string_start,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [103429] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1446), 1,
      sym_comment,
    ACTIONS(1055), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1057), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [103463] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1447), 1,
      sym_comment,
    ACTIONS(1237), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1239), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [103497] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2317), 1,
      anon_sym_AMP,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK,
    STATE(1448), 1,
      sym_comment,
    ACTIONS(971), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(969), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [103537] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1449), 1,
      sym_comment,
    ACTIONS(981), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(979), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [103571] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1450), 1,
      sym_comment,
    ACTIONS(985), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(983), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [103605] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1451), 1,
      sym_comment,
    ACTIONS(989), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(987), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [103639] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1452), 1,
      sym_comment,
    ACTIONS(993), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(991), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [103673] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1453), 1,
      sym_comment,
    ACTIONS(1065), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1063), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [103707] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1454), 1,
      sym_comment,
    ACTIONS(997), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(995), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [103741] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2317), 1,
      anon_sym_AMP,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK,
    STATE(1455), 1,
      sym_comment,
    ACTIONS(1001), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(999), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [103781] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1456), 1,
      sym_comment,
    ACTIONS(1005), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1003), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [103815] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2317), 1,
      anon_sym_AMP,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK,
    STATE(1457), 1,
      sym_comment,
    ACTIONS(1015), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1013), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [103855] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1458), 1,
      sym_comment,
    ACTIONS(1015), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1013), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [103889] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1459), 1,
      sym_comment,
    ACTIONS(1019), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1017), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [103923] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1460), 1,
      sym_comment,
    ACTIONS(1023), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1021), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [103957] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2317), 1,
      anon_sym_AMP,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK,
    STATE(1461), 1,
      sym_comment,
    ACTIONS(1027), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1025), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [103997] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1462), 1,
      sym_comment,
    ACTIONS(1031), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1029), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [104031] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2321), 1,
      anon_sym_QMARK,
    STATE(1463), 1,
      sym_comment,
    ACTIONS(1041), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT_LBRACK,
    ACTIONS(1039), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [104067] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2317), 1,
      anon_sym_AMP,
    ACTIONS(2321), 1,
      anon_sym_QMARK,
    STATE(1464), 1,
      sym_comment,
    ACTIONS(1041), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_AT_LBRACK,
    ACTIONS(1039), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [104105] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2317), 1,
      anon_sym_AMP,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK,
    STATE(1465), 1,
      sym_comment,
    ACTIONS(1045), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1043), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [104145] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1466), 1,
      sym_comment,
    ACTIONS(1045), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1043), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [104179] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1467), 1,
      sym_comment,
    ACTIONS(1241), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1243), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [104213] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1468), 1,
      sym_comment,
    ACTIONS(1049), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1047), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [104247] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1469), 1,
      sym_comment,
    ACTIONS(1053), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1051), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [104281] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1470), 1,
      sym_comment,
    ACTIONS(1057), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1055), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [104315] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1471), 1,
      sym_comment,
    ACTIONS(1061), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1059), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [104349] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    STATE(1472), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1193), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [104401] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1927), 1,
      anon_sym_LBRACE,
    ACTIONS(1933), 1,
      anon_sym_typeof,
    ACTIONS(2155), 1,
      sym_name,
    ACTIONS(2157), 1,
      anon_sym_LPAREN,
    STATE(1107), 1,
      sym_paramtypelist,
    STATE(1284), 1,
      sym_type,
    STATE(1473), 1,
      sym_comment,
    STATE(3080), 1,
      sym__fntype_gen,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1210), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1227), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [104457] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1474), 1,
      sym_comment,
    ACTIONS(1021), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1023), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [104491] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2343), 1,
      anon_sym_AMP,
    ACTIONS(2345), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    STATE(1475), 1,
      sym_comment,
    ACTIONS(1027), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1025), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [104531] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1476), 1,
      sym_comment,
    ACTIONS(1029), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1031), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [104565] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2349), 1,
      anon_sym_LT,
    STATE(1477), 1,
      sym_comment,
    ACTIONS(1033), 2,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1035), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [104601] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2351), 1,
      anon_sym_QMARK,
    STATE(1478), 1,
      sym_comment,
    ACTIONS(1039), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1041), 19,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
  [104637] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2351), 1,
      anon_sym_QMARK,
    ACTIONS(2353), 1,
      anon_sym_AMP,
    STATE(1479), 1,
      sym_comment,
    ACTIONS(1039), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1041), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [104675] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2351), 1,
      anon_sym_QMARK,
    ACTIONS(2353), 1,
      anon_sym_AMP,
    ACTIONS(2355), 1,
      anon_sym_PIPE,
    STATE(1480), 1,
      sym_comment,
    ACTIONS(1043), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1045), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [104715] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1481), 1,
      sym_comment,
    ACTIONS(766), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(764), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [104749] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1482), 1,
      sym_comment,
    ACTIONS(941), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(939), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [104783] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1483), 1,
      sym_comment,
    ACTIONS(1043), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1045), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [104817] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1484), 1,
      sym_comment,
    ACTIONS(770), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(768), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [104851] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1485), 1,
      sym_comment,
    ACTIONS(762), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(760), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [104885] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1486), 1,
      sym_comment,
    ACTIONS(1331), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1333), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [104919] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1487), 1,
      sym_comment,
    ACTIONS(1335), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1337), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [104953] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    STATE(1488), 1,
      sym_comment,
    ACTIONS(1339), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1341), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [104991] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1489), 1,
      sym_comment,
    ACTIONS(939), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(941), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105025] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1490), 1,
      sym_comment,
    ACTIONS(1245), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1247), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105059] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1491), 1,
      sym_comment,
    ACTIONS(1249), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1251), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105093] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1492), 1,
      sym_comment,
    ACTIONS(1253), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1255), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105127] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1493), 1,
      sym_comment,
    ACTIONS(1257), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1259), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105161] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1494), 1,
      sym_comment,
    ACTIONS(1263), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1265), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105195] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    STATE(1495), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1197), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105247] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1927), 1,
      anon_sym_LBRACE,
    ACTIONS(1933), 1,
      anon_sym_typeof,
    ACTIONS(2155), 1,
      sym_name,
    ACTIONS(2157), 1,
      anon_sym_LPAREN,
    STATE(1107), 1,
      sym_paramtypelist,
    STATE(1285), 1,
      sym_type,
    STATE(1496), 1,
      sym_comment,
    STATE(3080), 1,
      sym__fntype_gen,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1210), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1227), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [105303] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1497), 1,
      sym_comment,
    ACTIONS(1047), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1049), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [105337] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1498), 1,
      sym_comment,
    ACTIONS(1267), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1269), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105371] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1499), 1,
      sym_comment,
    ACTIONS(1051), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1053), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [105405] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1500), 1,
      sym_comment,
    ACTIONS(1271), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1273), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105439] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1501), 1,
      sym_comment,
    ACTIONS(1275), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1277), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105473] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1502), 1,
      sym_comment,
    ACTIONS(1279), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1281), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105507] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1503), 1,
      sym_comment,
    ACTIONS(1283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1285), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105541] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1504), 1,
      sym_comment,
    ACTIONS(1287), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1289), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105575] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1505), 1,
      sym_comment,
    ACTIONS(1291), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1293), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105609] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2357), 1,
      anon_sym_LT,
    ACTIONS(2359), 1,
      anon_sym_DOT,
    ACTIONS(2361), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1506), 1,
      sym_comment,
    ACTIONS(929), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT_DOT,
    ACTIONS(931), 17,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [105649] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1507), 1,
      sym_comment,
    ACTIONS(1295), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1297), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105683] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1508), 1,
      sym_comment,
    ACTIONS(1299), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1301), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105717] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1509), 1,
      sym_comment,
    ACTIONS(1303), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1305), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105751] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1510), 1,
      sym_comment,
    ACTIONS(1307), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1309), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105785] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1511), 1,
      sym_comment,
    ACTIONS(1313), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1315), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105819] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1512), 1,
      sym_comment,
    ACTIONS(1317), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1319), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [105853] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1513), 1,
      sym_comment,
    ACTIONS(957), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(955), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [105887] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1514), 1,
      sym_comment,
    ACTIONS(961), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(959), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [105921] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_LBRACE,
    ACTIONS(1997), 1,
      anon_sym_typeof,
    ACTIONS(2001), 1,
      anon_sym_nil,
    ACTIONS(2003), 1,
      sym__string_start,
    ACTIONS(2147), 1,
      sym_name,
    ACTIONS(2149), 1,
      anon_sym_LPAREN,
    STATE(1108), 1,
      sym_paramtypelist,
    STATE(1515), 1,
      sym_comment,
    STATE(1537), 1,
      sym_type,
    STATE(3053), 1,
      sym__fntype_gen,
    ACTIONS(1999), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1519), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1518), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [105977] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1516), 1,
      sym_comment,
    ACTIONS(1059), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1061), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [106011] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_PIPE,
    ACTIONS(2367), 1,
      anon_sym_QMARK,
    STATE(1517), 1,
      sym_comment,
    ACTIONS(971), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(969), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [106051] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1518), 1,
      sym_comment,
    ACTIONS(981), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(979), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [106085] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1519), 1,
      sym_comment,
    ACTIONS(985), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(983), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [106119] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1520), 1,
      sym_comment,
    ACTIONS(766), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(764), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [106153] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1521), 1,
      sym_comment,
    ACTIONS(770), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(768), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [106187] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2301), 1,
      anon_sym_LT,
    ACTIONS(2303), 1,
      anon_sym_DOT,
    STATE(1522), 1,
      sym_comment,
    ACTIONS(929), 3,
      anon_sym_else,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(931), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [106225] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(1523), 1,
      sym_comment,
    ACTIONS(943), 5,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(945), 17,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [106261] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1524), 1,
      sym_comment,
    ACTIONS(957), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(955), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [106295] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1525), 1,
      sym_comment,
    ACTIONS(961), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(959), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [106329] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1526), 1,
      sym_comment,
    ACTIONS(993), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(991), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [106363] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1927), 1,
      anon_sym_LBRACE,
    ACTIONS(1933), 1,
      anon_sym_typeof,
    ACTIONS(2155), 1,
      sym_name,
    ACTIONS(2157), 1,
      anon_sym_LPAREN,
    STATE(1107), 1,
      sym_paramtypelist,
    STATE(1269), 1,
      sym_type,
    STATE(1527), 1,
      sym_comment,
    STATE(3080), 1,
      sym__fntype_gen,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1210), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1227), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [106419] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1528), 1,
      sym_comment,
    ACTIONS(957), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(955), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [106453] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1529), 1,
      sym_comment,
    ACTIONS(961), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(959), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [106487] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1087), 1,
      anon_sym_else,
    ACTIONS(2369), 1,
      anon_sym_COMMA,
    ACTIONS(2373), 1,
      anon_sym_or,
    ACTIONS(2375), 1,
      anon_sym_and,
    ACTIONS(2383), 1,
      anon_sym_SLASH,
    ACTIONS(2385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2387), 1,
      anon_sym_CARET,
    ACTIONS(2389), 1,
      anon_sym_COLON_COLON,
    STATE(1530), 1,
      sym_comment,
    STATE(2842), 1,
      aux_sym__explist_repeat1,
    ACTIONS(2371), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2379), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1089), 3,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_elseif,
    ACTIONS(2381), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2377), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [106545] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1531), 1,
      sym_comment,
    ACTIONS(923), 9,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(921), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [106579] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1532), 1,
      sym_comment,
    ACTIONS(762), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(760), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [106613] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1887), 1,
      sym_name,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1533), 1,
      sym_comment,
    STATE(2683), 1,
      sym_type,
    STATE(3101), 1,
      sym__fntype_gen,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [106669] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1534), 1,
      sym_comment,
    ACTIONS(770), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(768), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [106703] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2351), 1,
      anon_sym_QMARK,
    ACTIONS(2353), 1,
      anon_sym_AMP,
    ACTIONS(2355), 1,
      anon_sym_PIPE,
    STATE(1535), 1,
      sym_comment,
    ACTIONS(969), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(971), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [106743] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1536), 1,
      sym_comment,
    ACTIONS(979), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(981), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [106777] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_PIPE,
    ACTIONS(2367), 1,
      anon_sym_QMARK,
    STATE(1537), 1,
      sym_comment,
    ACTIONS(1001), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(999), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [106817] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1538), 1,
      sym_comment,
    ACTIONS(983), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(985), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [106851] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1539), 1,
      sym_comment,
    ACTIONS(989), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(987), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [106885] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_LBRACE,
    ACTIONS(1997), 1,
      anon_sym_typeof,
    ACTIONS(2001), 1,
      anon_sym_nil,
    ACTIONS(2003), 1,
      sym__string_start,
    ACTIONS(2147), 1,
      sym_name,
    ACTIONS(2149), 1,
      anon_sym_LPAREN,
    STATE(1108), 1,
      sym_paramtypelist,
    STATE(1540), 1,
      sym_comment,
    STATE(1560), 1,
      sym_type,
    STATE(3053), 1,
      sym__fntype_gen,
    ACTIONS(1999), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1519), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1518), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [106941] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_LBRACE,
    ACTIONS(1997), 1,
      anon_sym_typeof,
    ACTIONS(2001), 1,
      anon_sym_nil,
    ACTIONS(2003), 1,
      sym__string_start,
    ACTIONS(2147), 1,
      sym_name,
    ACTIONS(2149), 1,
      anon_sym_LPAREN,
    STATE(1108), 1,
      sym_paramtypelist,
    STATE(1541), 1,
      sym_comment,
    STATE(1561), 1,
      sym_type,
    STATE(3053), 1,
      sym__fntype_gen,
    ACTIONS(1999), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1519), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1518), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [106997] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1542), 1,
      sym_comment,
    ACTIONS(991), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(993), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [107031] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2343), 1,
      anon_sym_AMP,
    ACTIONS(2345), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    STATE(1543), 1,
      sym_comment,
    ACTIONS(971), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(969), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107071] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1544), 1,
      sym_comment,
    ACTIONS(981), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(979), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107105] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1545), 1,
      sym_comment,
    ACTIONS(985), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(983), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107139] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1546), 1,
      sym_comment,
    ACTIONS(1065), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1063), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107173] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1547), 1,
      sym_comment,
    ACTIONS(987), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(989), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [107207] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1548), 1,
      sym_comment,
    ACTIONS(1005), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1003), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107241] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_PIPE,
    ACTIONS(2367), 1,
      anon_sym_QMARK,
    STATE(1549), 1,
      sym_comment,
    ACTIONS(1015), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1013), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107281] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1550), 1,
      sym_comment,
    ACTIONS(993), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(991), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107315] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1551), 1,
      sym_comment,
    ACTIONS(1063), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1065), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [107349] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1552), 1,
      sym_comment,
    ACTIONS(995), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(997), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [107383] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1553), 1,
      sym_comment,
    ACTIONS(1015), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1013), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107417] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1554), 1,
      sym_comment,
    ACTIONS(1019), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1017), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107451] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2343), 1,
      anon_sym_AMP,
    ACTIONS(2345), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    STATE(1555), 1,
      sym_comment,
    ACTIONS(1001), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(999), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107491] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1556), 1,
      sym_comment,
    ACTIONS(1201), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1203), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [107525] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1557), 1,
      sym_comment,
    ACTIONS(1023), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1021), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107559] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1558), 1,
      sym_comment,
    ACTIONS(1031), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1029), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107593] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1957), 1,
      anon_sym_typeof,
    ACTIONS(2161), 1,
      sym_name,
    ACTIONS(2163), 1,
      anon_sym_LPAREN,
    STATE(1099), 1,
      sym_paramtypelist,
    STATE(1559), 1,
      sym_comment,
    STATE(1663), 1,
      sym_type,
    STATE(3086), 1,
      sym__fntype_gen,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1601), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1599), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [107649] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2367), 1,
      anon_sym_QMARK,
    STATE(1560), 1,
      sym_comment,
    ACTIONS(1041), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT_LBRACK,
    ACTIONS(1039), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107685] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2367), 1,
      anon_sym_QMARK,
    STATE(1561), 1,
      sym_comment,
    ACTIONS(1041), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_AT_LBRACK,
    ACTIONS(1039), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107723] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_PIPE,
    ACTIONS(2367), 1,
      anon_sym_QMARK,
    STATE(1562), 1,
      sym_comment,
    ACTIONS(1045), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1043), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107763] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1563), 1,
      sym_comment,
    ACTIONS(1045), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1043), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107797] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1957), 1,
      anon_sym_typeof,
    ACTIONS(2161), 1,
      sym_name,
    ACTIONS(2163), 1,
      anon_sym_LPAREN,
    STATE(1099), 1,
      sym_paramtypelist,
    STATE(1564), 1,
      sym_comment,
    STATE(1666), 1,
      sym_type,
    STATE(3086), 1,
      sym__fntype_gen,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1601), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1599), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [107853] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1565), 1,
      sym_comment,
    ACTIONS(1005), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1003), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107887] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1566), 1,
      sym_comment,
    ACTIONS(997), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(995), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107921] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2343), 1,
      anon_sym_AMP,
    ACTIONS(2345), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    STATE(1567), 1,
      sym_comment,
    ACTIONS(1015), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1013), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107961] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1568), 1,
      sym_comment,
    ACTIONS(1015), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1013), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [107995] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1569), 1,
      sym_comment,
    ACTIONS(1017), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1019), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [108029] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1570), 1,
      sym_comment,
    ACTIONS(1023), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1021), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108063] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2351), 1,
      anon_sym_QMARK,
    ACTIONS(2353), 1,
      anon_sym_AMP,
    ACTIONS(2355), 1,
      anon_sym_PIPE,
    STATE(1571), 1,
      sym_comment,
    ACTIONS(1025), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1027), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [108103] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1572), 1,
      sym_comment,
    ACTIONS(1031), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1029), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108137] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2351), 1,
      anon_sym_QMARK,
    ACTIONS(2353), 1,
      anon_sym_AMP,
    ACTIONS(2355), 1,
      anon_sym_PIPE,
    STATE(1573), 1,
      sym_comment,
    ACTIONS(999), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1001), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [108177] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    STATE(1574), 1,
      sym_comment,
    ACTIONS(1041), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT_LBRACK,
    ACTIONS(1039), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108213] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2343), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    STATE(1575), 1,
      sym_comment,
    ACTIONS(1041), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_AT_LBRACK,
    ACTIONS(1039), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108251] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2343), 1,
      anon_sym_AMP,
    ACTIONS(2345), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    STATE(1576), 1,
      sym_comment,
    ACTIONS(1045), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1043), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108291] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1577), 1,
      sym_comment,
    ACTIONS(1045), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1043), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108325] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(2049), 1,
      anon_sym_LBRACE,
    ACTIONS(2055), 1,
      anon_sym_typeof,
    ACTIONS(2261), 1,
      sym_name,
    ACTIONS(2263), 1,
      anon_sym_LPAREN,
    STATE(1122), 1,
      sym_paramtypelist,
    STATE(1478), 1,
      sym_type,
    STATE(1578), 1,
      sym_comment,
    STATE(3072), 1,
      sym__fntype_gen,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1538), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1536), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [108381] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1579), 1,
      sym_comment,
    ACTIONS(1049), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1047), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108415] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1580), 1,
      sym_comment,
    ACTIONS(1053), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1051), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108449] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1581), 1,
      sym_comment,
    ACTIONS(941), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(939), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108483] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1582), 1,
      sym_comment,
    ACTIONS(1061), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1059), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108517] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1583), 1,
      sym_comment,
    ACTIONS(1225), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1227), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [108551] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1584), 1,
      sym_comment,
    ACTIONS(764), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(766), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [108585] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1585), 1,
      sym_comment,
    ACTIONS(1229), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1231), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [108619] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1586), 1,
      sym_comment,
    ACTIONS(911), 9,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(909), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108653] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1587), 1,
      sym_comment,
    ACTIONS(915), 9,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(913), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108687] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1588), 1,
      sym_comment,
    ACTIONS(1049), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1047), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108721] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1589), 1,
      sym_comment,
    ACTIONS(1053), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1051), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108755] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1590), 1,
      sym_comment,
    ACTIONS(1057), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1055), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108789] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1591), 1,
      sym_comment,
    ACTIONS(1061), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1059), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108823] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(2049), 1,
      anon_sym_LBRACE,
    ACTIONS(2055), 1,
      anon_sym_typeof,
    ACTIONS(2261), 1,
      sym_name,
    ACTIONS(2263), 1,
      anon_sym_LPAREN,
    STATE(1122), 1,
      sym_paramtypelist,
    STATE(1479), 1,
      sym_type,
    STATE(1592), 1,
      sym_comment,
    STATE(3072), 1,
      sym__fntype_gen,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1538), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1536), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [108879] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1593), 1,
      sym_comment,
    ACTIONS(768), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(770), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [108913] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1594), 1,
      sym_comment,
    ACTIONS(1067), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1069), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [108947] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1595), 1,
      sym_comment,
    ACTIONS(919), 9,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(917), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [108981] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1596), 1,
      sym_comment,
    ACTIONS(1003), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1005), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [109015] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2391), 1,
      anon_sym_AMP,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK,
    STATE(1597), 1,
      sym_comment,
    ACTIONS(969), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(971), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [109055] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1598), 1,
      sym_comment,
    ACTIONS(766), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(764), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [109089] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1599), 1,
      sym_comment,
    ACTIONS(979), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(981), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [109123] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1600), 1,
      sym_comment,
    ACTIONS(770), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(768), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [109157] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1601), 1,
      sym_comment,
    ACTIONS(983), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(985), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [109191] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1602), 1,
      sym_comment,
    ACTIONS(987), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(989), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [109225] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1603), 1,
      sym_comment,
    ACTIONS(991), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(993), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [109259] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1604), 1,
      sym_comment,
    ACTIONS(1063), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1065), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [109293] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1605), 1,
      sym_comment,
    ACTIONS(995), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(997), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [109327] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1606), 1,
      sym_comment,
    ACTIONS(766), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(764), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [109361] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1607), 1,
      sym_comment,
    ACTIONS(770), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(768), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [109395] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1608), 1,
      sym_comment,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(748), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(750), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [109431] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2391), 1,
      anon_sym_AMP,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK,
    STATE(1609), 1,
      sym_comment,
    ACTIONS(999), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1001), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [109471] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1937), 1,
      anon_sym_LBRACE,
    ACTIONS(1943), 1,
      anon_sym_typeof,
    ACTIONS(2141), 1,
      sym_name,
    ACTIONS(2143), 1,
      anon_sym_LPAREN,
    STATE(390), 1,
      sym_type,
    STATE(1096), 1,
      sym_paramtypelist,
    STATE(1610), 1,
      sym_comment,
    STATE(3044), 1,
      sym__fntype_gen,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(418), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(417), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [109527] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1937), 1,
      anon_sym_LBRACE,
    ACTIONS(1943), 1,
      anon_sym_typeof,
    ACTIONS(2141), 1,
      sym_name,
    ACTIONS(2143), 1,
      anon_sym_LPAREN,
    STATE(397), 1,
      sym_type,
    STATE(1096), 1,
      sym_paramtypelist,
    STATE(1611), 1,
      sym_comment,
    STATE(3044), 1,
      sym__fntype_gen,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(418), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(417), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [109583] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1612), 1,
      sym_comment,
    ACTIONS(1003), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1005), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [109617] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2351), 1,
      anon_sym_QMARK,
    ACTIONS(2353), 1,
      anon_sym_AMP,
    ACTIONS(2355), 1,
      anon_sym_PIPE,
    STATE(1613), 1,
      sym_comment,
    ACTIONS(1013), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1015), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [109657] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2391), 1,
      anon_sym_AMP,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK,
    STATE(1614), 1,
      sym_comment,
    ACTIONS(1013), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1015), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [109697] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1615), 1,
      sym_comment,
    ACTIONS(911), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(909), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [109731] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1616), 1,
      sym_comment,
    ACTIONS(915), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(913), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [109765] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1617), 1,
      sym_comment,
    ACTIONS(1013), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1015), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [109799] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1618), 1,
      sym_comment,
    ACTIONS(919), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(917), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [109833] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1619), 1,
      sym_comment,
    ACTIONS(1017), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1019), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [109867] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1620), 1,
      sym_comment,
    ACTIONS(1343), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1345), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [109901] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_LBRACE,
    ACTIONS(1997), 1,
      anon_sym_typeof,
    ACTIONS(2001), 1,
      anon_sym_nil,
    ACTIONS(2003), 1,
      sym__string_start,
    ACTIONS(2147), 1,
      sym_name,
    ACTIONS(2149), 1,
      anon_sym_LPAREN,
    STATE(1108), 1,
      sym_paramtypelist,
    STATE(1621), 1,
      sym_comment,
    STATE(1640), 1,
      sym_type,
    STATE(3053), 1,
      sym__fntype_gen,
    ACTIONS(1999), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1519), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1518), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [109957] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1622), 1,
      sym_comment,
    ACTIONS(1021), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1023), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [109991] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2059), 1,
      anon_sym_LBRACE,
    ACTIONS(2065), 1,
      anon_sym_typeof,
    ACTIONS(2069), 1,
      anon_sym_nil,
    ACTIONS(2071), 1,
      sym__string_start,
    ACTIONS(2177), 1,
      sym_name,
    ACTIONS(2179), 1,
      anon_sym_LPAREN,
    STATE(1123), 1,
      sym_paramtypelist,
    STATE(1623), 1,
      sym_comment,
    STATE(2753), 1,
      sym_type,
    STATE(3070), 1,
      sym__fntype_gen,
    ACTIONS(2067), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2809), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2807), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [110047] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1624), 1,
      sym_comment,
    ACTIONS(923), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(921), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [110081] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    ACTIONS(2173), 1,
      sym_name,
    ACTIONS(2175), 1,
      anon_sym_LPAREN,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1574), 1,
      sym_type,
    STATE(1625), 1,
      sym_comment,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [110137] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    ACTIONS(2173), 1,
      sym_name,
    ACTIONS(2175), 1,
      anon_sym_LPAREN,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1575), 1,
      sym_type,
    STATE(1626), 1,
      sym_comment,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [110193] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(2007), 1,
      anon_sym_LBRACE,
    ACTIONS(2013), 1,
      anon_sym_typeof,
    ACTIONS(2253), 1,
      sym_name,
    ACTIONS(2255), 1,
      anon_sym_LPAREN,
    STATE(1121), 1,
      sym_paramtypelist,
    STATE(1627), 1,
      sym_comment,
    STATE(1864), 1,
      sym_type,
    STATE(3102), 1,
      sym__fntype_gen,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1859), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1858), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [110249] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2059), 1,
      anon_sym_LBRACE,
    ACTIONS(2065), 1,
      anon_sym_typeof,
    ACTIONS(2069), 1,
      anon_sym_nil,
    ACTIONS(2071), 1,
      sym__string_start,
    ACTIONS(2177), 1,
      sym_name,
    ACTIONS(2179), 1,
      anon_sym_LPAREN,
    STATE(1123), 1,
      sym_paramtypelist,
    STATE(1628), 1,
      sym_comment,
    STATE(2839), 1,
      sym_type,
    STATE(3070), 1,
      sym__fntype_gen,
    ACTIONS(2067), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2809), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2807), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [110305] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2391), 1,
      anon_sym_AMP,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK,
    STATE(1629), 1,
      sym_comment,
    ACTIONS(1025), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1027), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [110345] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1630), 1,
      sym_comment,
    ACTIONS(927), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(925), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [110379] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1631), 1,
      sym_comment,
    ACTIONS(989), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(987), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [110413] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1917), 1,
      anon_sym_LBRACE,
    ACTIONS(1923), 1,
      anon_sym_typeof,
    ACTIONS(2211), 1,
      sym_name,
    ACTIONS(2213), 1,
      anon_sym_LPAREN,
    STATE(1112), 1,
      sym_paramtypelist,
    STATE(1632), 1,
      sym_comment,
    STATE(1824), 1,
      sym_type,
    STATE(3066), 1,
      sym__fntype_gen,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1820), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1737), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [110469] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2033), 1,
      anon_sym_LBRACE,
    ACTIONS(2039), 1,
      anon_sym_typeof,
    ACTIONS(2043), 1,
      anon_sym_nil,
    ACTIONS(2045), 1,
      sym__string_start,
    ACTIONS(2189), 1,
      sym_name,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    STATE(1117), 1,
      sym_paramtypelist,
    STATE(1463), 1,
      sym_type,
    STATE(1633), 1,
      sym_comment,
    STATE(3111), 1,
      sym__fntype_gen,
    ACTIONS(2041), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1450), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1449), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [110525] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2033), 1,
      anon_sym_LBRACE,
    ACTIONS(2039), 1,
      anon_sym_typeof,
    ACTIONS(2043), 1,
      anon_sym_nil,
    ACTIONS(2045), 1,
      sym__string_start,
    ACTIONS(2189), 1,
      sym_name,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    STATE(1117), 1,
      sym_paramtypelist,
    STATE(1464), 1,
      sym_type,
    STATE(1634), 1,
      sym_comment,
    STATE(3111), 1,
      sym__fntype_gen,
    ACTIONS(2041), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1450), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1449), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [110581] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1635), 1,
      sym_comment,
    ACTIONS(1065), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1063), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [110615] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1636), 1,
      sym_comment,
    ACTIONS(997), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(995), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [110649] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2059), 1,
      anon_sym_LBRACE,
    ACTIONS(2065), 1,
      anon_sym_typeof,
    ACTIONS(2069), 1,
      anon_sym_nil,
    ACTIONS(2071), 1,
      sym__string_start,
    ACTIONS(2177), 1,
      sym_name,
    ACTIONS(2179), 1,
      anon_sym_LPAREN,
    STATE(1123), 1,
      sym_paramtypelist,
    STATE(1637), 1,
      sym_comment,
    STATE(2795), 1,
      sym_type,
    STATE(3070), 1,
      sym__fntype_gen,
    ACTIONS(2067), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2809), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2807), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [110705] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2059), 1,
      anon_sym_LBRACE,
    ACTIONS(2065), 1,
      anon_sym_typeof,
    ACTIONS(2069), 1,
      anon_sym_nil,
    ACTIONS(2071), 1,
      sym__string_start,
    ACTIONS(2177), 1,
      sym_name,
    ACTIONS(2179), 1,
      anon_sym_LPAREN,
    STATE(1123), 1,
      sym_paramtypelist,
    STATE(1638), 1,
      sym_comment,
    STATE(2799), 1,
      sym_type,
    STATE(3070), 1,
      sym__fntype_gen,
    ACTIONS(2067), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2809), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2807), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [110761] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(2007), 1,
      anon_sym_LBRACE,
    ACTIONS(2013), 1,
      anon_sym_typeof,
    ACTIONS(2253), 1,
      sym_name,
    ACTIONS(2255), 1,
      anon_sym_LPAREN,
    STATE(1121), 1,
      sym_paramtypelist,
    STATE(1639), 1,
      sym_comment,
    STATE(1905), 1,
      sym_type,
    STATE(3102), 1,
      sym__fntype_gen,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1859), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1858), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [110817] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_PIPE,
    ACTIONS(2367), 1,
      anon_sym_QMARK,
    STATE(1640), 1,
      sym_comment,
    ACTIONS(1027), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1025), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [110857] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1887), 1,
      sym_name,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1641), 1,
      sym_comment,
    STATE(2669), 1,
      sym_type,
    STATE(3101), 1,
      sym__fntype_gen,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [110913] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1981), 1,
      anon_sym_LBRACE,
    ACTIONS(1987), 1,
      anon_sym_typeof,
    ACTIONS(2167), 1,
      sym_name,
    ACTIONS(2169), 1,
      anon_sym_LPAREN,
    STATE(1105), 1,
      sym_paramtypelist,
    STATE(1642), 1,
      sym_comment,
    STATE(1919), 1,
      sym_type,
    STATE(3090), 1,
      sym__fntype_gen,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1920), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1918), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [110969] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1981), 1,
      anon_sym_LBRACE,
    ACTIONS(1987), 1,
      anon_sym_typeof,
    ACTIONS(2167), 1,
      sym_name,
    ACTIONS(2169), 1,
      anon_sym_LPAREN,
    STATE(1105), 1,
      sym_paramtypelist,
    STATE(1643), 1,
      sym_comment,
    STATE(1922), 1,
      sym_type,
    STATE(3090), 1,
      sym__fntype_gen,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1920), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1918), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [111025] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1917), 1,
      anon_sym_LBRACE,
    ACTIONS(1923), 1,
      anon_sym_typeof,
    ACTIONS(2211), 1,
      sym_name,
    ACTIONS(2213), 1,
      anon_sym_LPAREN,
    STATE(1112), 1,
      sym_paramtypelist,
    STATE(1644), 1,
      sym_comment,
    STATE(1847), 1,
      sym_type,
    STATE(3066), 1,
      sym__fntype_gen,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1820), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1737), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [111081] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(2049), 1,
      anon_sym_LBRACE,
    ACTIONS(2055), 1,
      anon_sym_typeof,
    ACTIONS(2261), 1,
      sym_name,
    ACTIONS(2263), 1,
      anon_sym_LPAREN,
    STATE(1122), 1,
      sym_paramtypelist,
    STATE(1573), 1,
      sym_type,
    STATE(1645), 1,
      sym_comment,
    STATE(3072), 1,
      sym__fntype_gen,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1538), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1536), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [111137] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1897), 1,
      anon_sym_LBRACE,
    ACTIONS(1903), 1,
      anon_sym_typeof,
    ACTIONS(2247), 1,
      sym_name,
    ACTIONS(2249), 1,
      anon_sym_LPAREN,
    STATE(392), 1,
      sym_type,
    STATE(1119), 1,
      sym_paramtypelist,
    STATE(1646), 1,
      sym_comment,
    STATE(3067), 1,
      sym__fntype_gen,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(372), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(370), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [111193] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1897), 1,
      anon_sym_LBRACE,
    ACTIONS(1903), 1,
      anon_sym_typeof,
    ACTIONS(2247), 1,
      sym_name,
    ACTIONS(2249), 1,
      anon_sym_LPAREN,
    STATE(394), 1,
      sym_type,
    STATE(1119), 1,
      sym_paramtypelist,
    STATE(1647), 1,
      sym_comment,
    STATE(3067), 1,
      sym__fntype_gen,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(372), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(370), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [111249] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    ACTIONS(2173), 1,
      sym_name,
    ACTIONS(2175), 1,
      anon_sym_LPAREN,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1475), 1,
      sym_type,
    STATE(1648), 1,
      sym_comment,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [111305] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1649), 1,
      sym_comment,
    ACTIONS(760), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(762), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [111339] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      anon_sym_typeof,
    ACTIONS(1883), 1,
      anon_sym_nil,
    ACTIONS(1885), 1,
      sym__string_start,
    ACTIONS(2173), 1,
      sym_name,
    ACTIONS(2175), 1,
      anon_sym_LPAREN,
    STATE(1111), 1,
      sym_paramtypelist,
    STATE(1555), 1,
      sym_type,
    STATE(1650), 1,
      sym_comment,
    STATE(3042), 1,
      sym__fntype_gen,
    ACTIONS(1881), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1545), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1544), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [111395] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(2075), 1,
      anon_sym_LBRACE,
    ACTIONS(2081), 1,
      anon_sym_typeof,
    ACTIONS(2229), 1,
      sym_name,
    ACTIONS(2231), 1,
      anon_sym_LPAREN,
    STATE(354), 1,
      sym_type,
    STATE(1126), 1,
      sym_paramtypelist,
    STATE(1651), 1,
      sym_comment,
    STATE(3109), 1,
      sym__fntype_gen,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(415), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(412), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [111451] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(2075), 1,
      anon_sym_LBRACE,
    ACTIONS(2081), 1,
      anon_sym_typeof,
    ACTIONS(2229), 1,
      sym_name,
    ACTIONS(2231), 1,
      anon_sym_LPAREN,
    STATE(355), 1,
      sym_type,
    STATE(1126), 1,
      sym_paramtypelist,
    STATE(1652), 1,
      sym_comment,
    STATE(3109), 1,
      sym__fntype_gen,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(415), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(412), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [111507] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    STATE(1653), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [111553] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    STATE(1654), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1349), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [111603] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1439), 1,
      anon_sym_nil,
    ACTIONS(1441), 1,
      sym__string_start,
    ACTIONS(2049), 1,
      anon_sym_LBRACE,
    ACTIONS(2055), 1,
      anon_sym_typeof,
    ACTIONS(2261), 1,
      sym_name,
    ACTIONS(2263), 1,
      anon_sym_LPAREN,
    STATE(1122), 1,
      sym_paramtypelist,
    STATE(1571), 1,
      sym_type,
    STATE(1655), 1,
      sym_comment,
    STATE(3072), 1,
      sym__fntype_gen,
    ACTIONS(1437), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1538), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1536), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [111659] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1656), 1,
      sym_comment,
    ACTIONS(955), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(957), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [111693] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1657), 1,
      sym_comment,
    ACTIONS(959), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(961), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [111727] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    STATE(1658), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1349), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [111775] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1659), 1,
      sym_comment,
    ACTIONS(1029), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1031), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [111809] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2401), 1,
      anon_sym_COMMA,
    STATE(1660), 1,
      sym_comment,
    STATE(1718), 1,
      aux_sym_bindinglist_repeat1,
    ACTIONS(2399), 4,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2397), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [111847] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1957), 1,
      anon_sym_typeof,
    ACTIONS(2161), 1,
      sym_name,
    ACTIONS(2163), 1,
      anon_sym_LPAREN,
    STATE(1099), 1,
      sym_paramtypelist,
    STATE(1609), 1,
      sym_type,
    STATE(1661), 1,
      sym_comment,
    STATE(3086), 1,
      sym__fntype_gen,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1601), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1599), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [111903] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2403), 1,
      anon_sym_LT,
    STATE(1662), 1,
      sym_comment,
    ACTIONS(1033), 2,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1035), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [111939] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2395), 1,
      anon_sym_QMARK,
    STATE(1663), 1,
      sym_comment,
    ACTIONS(1039), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1041), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
  [111975] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1961), 1,
      anon_sym_LBRACE,
    ACTIONS(1967), 1,
      anon_sym_typeof,
    ACTIONS(2217), 1,
      sym_name,
    ACTIONS(2219), 1,
      anon_sym_LPAREN,
    STATE(1102), 1,
      sym_paramtypelist,
    STATE(1664), 1,
      sym_comment,
    STATE(1803), 1,
      sym_type,
    STATE(3078), 1,
      sym__fntype_gen,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1789), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1788), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [112031] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1961), 1,
      anon_sym_LBRACE,
    ACTIONS(1967), 1,
      anon_sym_typeof,
    ACTIONS(2217), 1,
      sym_name,
    ACTIONS(2219), 1,
      anon_sym_LPAREN,
    STATE(1102), 1,
      sym_paramtypelist,
    STATE(1665), 1,
      sym_comment,
    STATE(1804), 1,
      sym_type,
    STATE(3078), 1,
      sym__fntype_gen,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1789), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1788), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [112087] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2391), 1,
      anon_sym_AMP,
    ACTIONS(2395), 1,
      anon_sym_QMARK,
    STATE(1666), 1,
      sym_comment,
    ACTIONS(1039), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1041), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [112125] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2391), 1,
      anon_sym_AMP,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK,
    STATE(1667), 1,
      sym_comment,
    ACTIONS(1043), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1045), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [112165] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1668), 1,
      sym_comment,
    ACTIONS(1043), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1045), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [112199] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1669), 1,
      sym_comment,
    ACTIONS(1013), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1015), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [112233] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1670), 1,
      sym_comment,
    ACTIONS(1047), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1049), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [112267] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1551), 1,
      anon_sym_nil,
    ACTIONS(1553), 1,
      sym__string_start,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1957), 1,
      anon_sym_typeof,
    ACTIONS(2161), 1,
      sym_name,
    ACTIONS(2163), 1,
      anon_sym_LPAREN,
    STATE(1099), 1,
      sym_paramtypelist,
    STATE(1629), 1,
      sym_type,
    STATE(1671), 1,
      sym_comment,
    STATE(3086), 1,
      sym__fntype_gen,
    ACTIONS(1549), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1601), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1599), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [112323] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    STATE(1672), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT_DOT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [112365] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1673), 1,
      sym_comment,
    ACTIONS(766), 9,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(764), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [112399] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1674), 1,
      sym_comment,
    ACTIONS(941), 9,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(939), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [112433] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    STATE(1675), 1,
      sym_comment,
    ACTIONS(1347), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1349), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [112471] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    STATE(1676), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [112517] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    STATE(1677), 1,
      sym_comment,
    ACTIONS(1347), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1349), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [112555] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2033), 1,
      anon_sym_LBRACE,
    ACTIONS(2039), 1,
      anon_sym_typeof,
    ACTIONS(2043), 1,
      anon_sym_nil,
    ACTIONS(2045), 1,
      sym__string_start,
    ACTIONS(2189), 1,
      sym_name,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    STATE(1117), 1,
      sym_paramtypelist,
    STATE(1455), 1,
      sym_type,
    STATE(1678), 1,
      sym_comment,
    STATE(3111), 1,
      sym__fntype_gen,
    ACTIONS(2041), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1450), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1449), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [112611] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1179), 1,
      anon_sym_nil,
    ACTIONS(1181), 1,
      sym__string_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1927), 1,
      anon_sym_LBRACE,
    ACTIONS(1933), 1,
      anon_sym_typeof,
    ACTIONS(2155), 1,
      sym_name,
    ACTIONS(2157), 1,
      anon_sym_LPAREN,
    STATE(1107), 1,
      sym_paramtypelist,
    STATE(1249), 1,
      sym_type,
    STATE(1679), 1,
      sym_comment,
    STATE(3080), 1,
      sym__fntype_gen,
    ACTIONS(1177), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1210), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1227), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [112667] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(1977), 1,
      anon_sym_typeof,
    ACTIONS(2195), 1,
      sym_name,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    STATE(1104), 1,
      sym_paramtypelist,
    STATE(1341), 1,
      sym_type,
    STATE(1680), 1,
      sym_comment,
    STATE(3112), 1,
      sym__fntype_gen,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1327), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1326), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [112723] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(1977), 1,
      anon_sym_typeof,
    ACTIONS(2195), 1,
      sym_name,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    STATE(1104), 1,
      sym_paramtypelist,
    STATE(1398), 1,
      sym_type,
    STATE(1681), 1,
      sym_comment,
    STATE(3112), 1,
      sym__fntype_gen,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1327), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1326), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [112779] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2033), 1,
      anon_sym_LBRACE,
    ACTIONS(2039), 1,
      anon_sym_typeof,
    ACTIONS(2043), 1,
      anon_sym_nil,
    ACTIONS(2045), 1,
      sym__string_start,
    ACTIONS(2189), 1,
      sym_name,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    STATE(1117), 1,
      sym_paramtypelist,
    STATE(1461), 1,
      sym_type,
    STATE(1682), 1,
      sym_comment,
    STATE(3111), 1,
      sym__fntype_gen,
    ACTIONS(2041), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1450), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1449), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [112835] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1683), 1,
      sym_comment,
    ACTIONS(1051), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1053), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [112869] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1684), 1,
      sym_comment,
    ACTIONS(1055), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1057), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [112903] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1685), 1,
      sym_comment,
    ACTIONS(1059), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1061), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [112937] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1686), 1,
      sym_comment,
    ACTIONS(770), 9,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(768), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [112971] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1687), 1,
      sym_comment,
    ACTIONS(762), 9,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(760), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [113005] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1937), 1,
      anon_sym_LBRACE,
    ACTIONS(1943), 1,
      anon_sym_typeof,
    ACTIONS(2141), 1,
      sym_name,
    ACTIONS(2143), 1,
      anon_sym_LPAREN,
    STATE(436), 1,
      sym_type,
    STATE(1096), 1,
      sym_paramtypelist,
    STATE(1688), 1,
      sym_comment,
    STATE(3044), 1,
      sym__fntype_gen,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(418), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(417), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [113061] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1689), 1,
      sym_comment,
    ACTIONS(1353), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1355), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [113095] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2017), 1,
      anon_sym_LBRACE,
    ACTIONS(2023), 1,
      anon_sym_typeof,
    ACTIONS(2027), 1,
      anon_sym_nil,
    ACTIONS(2029), 1,
      sym__string_start,
    ACTIONS(2183), 1,
      sym_name,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    STATE(1115), 1,
      sym_paramtypelist,
    STATE(1363), 1,
      sym_type,
    STATE(1690), 1,
      sym_comment,
    STATE(3047), 1,
      sym__fntype_gen,
    ACTIONS(2025), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1350), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1349), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [113151] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2017), 1,
      anon_sym_LBRACE,
    ACTIONS(2023), 1,
      anon_sym_typeof,
    ACTIONS(2027), 1,
      anon_sym_nil,
    ACTIONS(2029), 1,
      sym__string_start,
    ACTIONS(2183), 1,
      sym_name,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    STATE(1115), 1,
      sym_paramtypelist,
    STATE(1364), 1,
      sym_type,
    STATE(1691), 1,
      sym_comment,
    STATE(3047), 1,
      sym__fntype_gen,
    ACTIONS(2025), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1350), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1349), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [113207] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1785), 1,
      anon_sym_nil,
    ACTIONS(1787), 1,
      sym__string_start,
    ACTIONS(1937), 1,
      anon_sym_LBRACE,
    ACTIONS(1943), 1,
      anon_sym_typeof,
    ACTIONS(2141), 1,
      sym_name,
    ACTIONS(2143), 1,
      anon_sym_LPAREN,
    STATE(367), 1,
      sym_type,
    STATE(1096), 1,
      sym_paramtypelist,
    STATE(1692), 1,
      sym_comment,
    STATE(3044), 1,
      sym__fntype_gen,
    ACTIONS(1783), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(418), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(417), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [113263] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1981), 1,
      anon_sym_LBRACE,
    ACTIONS(1987), 1,
      anon_sym_typeof,
    ACTIONS(2167), 1,
      sym_name,
    ACTIONS(2169), 1,
      anon_sym_LPAREN,
    STATE(1105), 1,
      sym_paramtypelist,
    STATE(1693), 1,
      sym_comment,
    STATE(1917), 1,
      sym_type,
    STATE(3090), 1,
      sym__fntype_gen,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1920), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1918), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [113319] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1907), 1,
      anon_sym_LBRACE,
    ACTIONS(1913), 1,
      anon_sym_typeof,
    ACTIONS(2235), 1,
      sym_name,
    ACTIONS(2237), 1,
      anon_sym_LPAREN,
    STATE(318), 1,
      sym_type,
    STATE(1092), 1,
      sym_paramtypelist,
    STATE(1694), 1,
      sym_comment,
    STATE(3051), 1,
      sym__fntype_gen,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(295), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(294), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [113375] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1907), 1,
      anon_sym_LBRACE,
    ACTIONS(1913), 1,
      anon_sym_typeof,
    ACTIONS(2235), 1,
      sym_name,
    ACTIONS(2237), 1,
      anon_sym_LPAREN,
    STATE(319), 1,
      sym_type,
    STATE(1092), 1,
      sym_paramtypelist,
    STATE(1695), 1,
      sym_comment,
    STATE(3051), 1,
      sym__fntype_gen,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(295), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(294), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [113431] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1863), 1,
      anon_sym_nil,
    ACTIONS(1865), 1,
      sym__string_start,
    ACTIONS(1981), 1,
      anon_sym_LBRACE,
    ACTIONS(1987), 1,
      anon_sym_typeof,
    ACTIONS(2167), 1,
      sym_name,
    ACTIONS(2169), 1,
      anon_sym_LPAREN,
    STATE(1105), 1,
      sym_paramtypelist,
    STATE(1696), 1,
      sym_comment,
    STATE(1913), 1,
      sym_type,
    STATE(3090), 1,
      sym__fntype_gen,
    ACTIONS(1861), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1920), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1918), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [113487] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(2007), 1,
      anon_sym_LBRACE,
    ACTIONS(2013), 1,
      anon_sym_typeof,
    ACTIONS(2253), 1,
      sym_name,
    ACTIONS(2255), 1,
      anon_sym_LPAREN,
    STATE(1121), 1,
      sym_paramtypelist,
    STATE(1697), 1,
      sym_comment,
    STATE(1874), 1,
      sym_type,
    STATE(3102), 1,
      sym__fntype_gen,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1859), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1858), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [113543] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1811), 1,
      anon_sym_nil,
    ACTIONS(1813), 1,
      sym__string_start,
    ACTIONS(2007), 1,
      anon_sym_LBRACE,
    ACTIONS(2013), 1,
      anon_sym_typeof,
    ACTIONS(2253), 1,
      sym_name,
    ACTIONS(2255), 1,
      anon_sym_LPAREN,
    STATE(1121), 1,
      sym_paramtypelist,
    STATE(1698), 1,
      sym_comment,
    STATE(1875), 1,
      sym_type,
    STATE(3102), 1,
      sym__fntype_gen,
    ACTIONS(1809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1859), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1858), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [113599] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2405), 1,
      anon_sym_LT,
    ACTIONS(2407), 1,
      anon_sym_DOT,
    ACTIONS(2409), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1699), 1,
      sym_comment,
    ACTIONS(929), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT_DOT,
    ACTIONS(931), 17,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [113639] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1897), 1,
      anon_sym_LBRACE,
    ACTIONS(1903), 1,
      anon_sym_typeof,
    ACTIONS(2247), 1,
      sym_name,
    ACTIONS(2249), 1,
      anon_sym_LPAREN,
    STATE(379), 1,
      sym_type,
    STATE(1119), 1,
      sym_paramtypelist,
    STATE(1700), 1,
      sym_comment,
    STATE(3067), 1,
      sym__fntype_gen,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(372), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(370), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [113695] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1703), 1,
      anon_sym_nil,
    ACTIONS(1705), 1,
      sym__string_start,
    ACTIONS(1897), 1,
      anon_sym_LBRACE,
    ACTIONS(1903), 1,
      anon_sym_typeof,
    ACTIONS(2247), 1,
      sym_name,
    ACTIONS(2249), 1,
      anon_sym_LPAREN,
    STATE(388), 1,
      sym_type,
    STATE(1119), 1,
      sym_paramtypelist,
    STATE(1701), 1,
      sym_comment,
    STATE(3067), 1,
      sym__fntype_gen,
    ACTIONS(1701), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(372), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(370), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [113751] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(2075), 1,
      anon_sym_LBRACE,
    ACTIONS(2081), 1,
      anon_sym_typeof,
    ACTIONS(2229), 1,
      sym_name,
    ACTIONS(2231), 1,
      anon_sym_LPAREN,
    STATE(427), 1,
      sym_type,
    STATE(1126), 1,
      sym_paramtypelist,
    STATE(1702), 1,
      sym_comment,
    STATE(3109), 1,
      sym__fntype_gen,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(415), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(412), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [113807] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1729), 1,
      anon_sym_nil,
    ACTIONS(1731), 1,
      sym__string_start,
    ACTIONS(2075), 1,
      anon_sym_LBRACE,
    ACTIONS(2081), 1,
      anon_sym_typeof,
    ACTIONS(2229), 1,
      sym_name,
    ACTIONS(2231), 1,
      anon_sym_LPAREN,
    STATE(438), 1,
      sym_type,
    STATE(1126), 1,
      sym_paramtypelist,
    STATE(1703), 1,
      sym_comment,
    STATE(3109), 1,
      sym__fntype_gen,
    ACTIONS(1727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(415), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(412), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [113863] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1961), 1,
      anon_sym_LBRACE,
    ACTIONS(1967), 1,
      anon_sym_typeof,
    ACTIONS(2217), 1,
      sym_name,
    ACTIONS(2219), 1,
      anon_sym_LPAREN,
    STATE(1102), 1,
      sym_paramtypelist,
    STATE(1704), 1,
      sym_comment,
    STATE(1794), 1,
      sym_type,
    STATE(3078), 1,
      sym__fntype_gen,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1789), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1788), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [113919] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1837), 1,
      anon_sym_nil,
    ACTIONS(1839), 1,
      sym__string_start,
    ACTIONS(1961), 1,
      anon_sym_LBRACE,
    ACTIONS(1967), 1,
      anon_sym_typeof,
    ACTIONS(2217), 1,
      sym_name,
    ACTIONS(2219), 1,
      anon_sym_LPAREN,
    STATE(1102), 1,
      sym_paramtypelist,
    STATE(1705), 1,
      sym_comment,
    STATE(1800), 1,
      sym_type,
    STATE(3078), 1,
      sym__fntype_gen,
    ACTIONS(1835), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1789), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1788), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [113975] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(1977), 1,
      anon_sym_typeof,
    ACTIONS(2195), 1,
      sym_name,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    STATE(1104), 1,
      sym_paramtypelist,
    STATE(1332), 1,
      sym_type,
    STATE(1706), 1,
      sym_comment,
    STATE(3112), 1,
      sym__fntype_gen,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1327), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1326), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [114031] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1147), 1,
      anon_sym_nil,
    ACTIONS(1149), 1,
      sym__string_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(1977), 1,
      anon_sym_typeof,
    ACTIONS(2195), 1,
      sym_name,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    STATE(1104), 1,
      sym_paramtypelist,
    STATE(1338), 1,
      sym_type,
    STATE(1707), 1,
      sym_comment,
    STATE(3112), 1,
      sym__fntype_gen,
    ACTIONS(1145), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1327), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1326), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [114087] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1708), 1,
      sym_comment,
    ACTIONS(955), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(957), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [114121] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1709), 1,
      sym_comment,
    ACTIONS(959), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(961), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [114155] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2017), 1,
      anon_sym_LBRACE,
    ACTIONS(2023), 1,
      anon_sym_typeof,
    ACTIONS(2027), 1,
      anon_sym_nil,
    ACTIONS(2029), 1,
      sym__string_start,
    ACTIONS(2183), 1,
      sym_name,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    STATE(1115), 1,
      sym_paramtypelist,
    STATE(1355), 1,
      sym_type,
    STATE(1710), 1,
      sym_comment,
    STATE(3047), 1,
      sym__fntype_gen,
    ACTIONS(2025), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1350), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1349), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [114211] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2415), 1,
      anon_sym_COLON,
    STATE(1711), 1,
      sym_comment,
    ACTIONS(2413), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2411), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [114247] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1712), 1,
      sym_comment,
    ACTIONS(911), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(909), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [114281] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1713), 1,
      sym_comment,
    ACTIONS(915), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(913), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [114315] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1714), 1,
      sym_comment,
    ACTIONS(919), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(917), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [114349] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(2017), 1,
      anon_sym_LBRACE,
    ACTIONS(2023), 1,
      anon_sym_typeof,
    ACTIONS(2027), 1,
      anon_sym_nil,
    ACTIONS(2029), 1,
      sym__string_start,
    ACTIONS(2183), 1,
      sym_name,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    STATE(1115), 1,
      sym_paramtypelist,
    STATE(1361), 1,
      sym_type,
    STATE(1715), 1,
      sym_comment,
    STATE(3047), 1,
      sym__fntype_gen,
    ACTIONS(2025), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1350), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1349), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [114405] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1907), 1,
      anon_sym_LBRACE,
    ACTIONS(1913), 1,
      anon_sym_typeof,
    ACTIONS(2235), 1,
      sym_name,
    ACTIONS(2237), 1,
      anon_sym_LPAREN,
    STATE(304), 1,
      sym_type,
    STATE(1092), 1,
      sym_paramtypelist,
    STATE(1716), 1,
      sym_comment,
    STATE(3051), 1,
      sym__fntype_gen,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(295), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(294), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [114461] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1755), 1,
      anon_sym_nil,
    ACTIONS(1757), 1,
      sym__string_start,
    ACTIONS(1907), 1,
      anon_sym_LBRACE,
    ACTIONS(1913), 1,
      anon_sym_typeof,
    ACTIONS(2235), 1,
      sym_name,
    ACTIONS(2237), 1,
      anon_sym_LPAREN,
    STATE(314), 1,
      sym_type,
    STATE(1092), 1,
      sym_paramtypelist,
    STATE(1717), 1,
      sym_comment,
    STATE(3051), 1,
      sym__fntype_gen,
    ACTIONS(1753), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(295), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(294), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [114517] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2401), 1,
      anon_sym_COMMA,
    STATE(1718), 1,
      sym_comment,
    STATE(1722), 1,
      aux_sym_bindinglist_repeat1,
    ACTIONS(2419), 4,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2417), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [114555] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1719), 1,
      sym_comment,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(748), 5,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(750), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [114591] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1720), 1,
      sym_comment,
    ACTIONS(923), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(921), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [114625] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2311), 1,
      anon_sym_LT,
    ACTIONS(2313), 1,
      anon_sym_DOT,
    STATE(1721), 1,
      sym_comment,
    ACTIONS(929), 2,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(931), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [114663] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2425), 1,
      anon_sym_COMMA,
    STATE(1722), 2,
      sym_comment,
      aux_sym_bindinglist_repeat1,
    ACTIONS(2423), 4,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2421), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [114699] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1723), 1,
      sym_comment,
    ACTIONS(927), 8,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(925), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [114733] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1917), 1,
      anon_sym_LBRACE,
    ACTIONS(1923), 1,
      anon_sym_typeof,
    ACTIONS(2211), 1,
      sym_name,
    ACTIONS(2213), 1,
      anon_sym_LPAREN,
    STATE(1112), 1,
      sym_paramtypelist,
    STATE(1724), 1,
      sym_comment,
    STATE(1833), 1,
      sym_type,
    STATE(3066), 1,
      sym__fntype_gen,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1820), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1737), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [114789] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1677), 1,
      anon_sym_nil,
    ACTIONS(1679), 1,
      sym__string_start,
    ACTIONS(1917), 1,
      anon_sym_LBRACE,
    ACTIONS(1923), 1,
      anon_sym_typeof,
    ACTIONS(2211), 1,
      sym_name,
    ACTIONS(2213), 1,
      anon_sym_LPAREN,
    STATE(1112), 1,
      sym_paramtypelist,
    STATE(1725), 1,
      sym_comment,
    STATE(1834), 1,
      sym_type,
    STATE(3066), 1,
      sym__fntype_gen,
    ACTIONS(1675), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1820), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(1737), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [114845] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(1726), 1,
      sym_comment,
    ACTIONS(943), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(945), 18,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [114881] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1727), 1,
      sym_comment,
    ACTIONS(1233), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1235), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [114915] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1728), 1,
      sym_comment,
    ACTIONS(764), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(766), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [114949] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1729), 1,
      sym_comment,
    ACTIONS(927), 9,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT_LBRACK,
    ACTIONS(925), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [114983] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1730), 1,
      sym_comment,
    ACTIONS(768), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(770), 20,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [115017] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1731), 1,
      sym_comment,
    ACTIONS(1221), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1223), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [115051] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1887), 1,
      sym_name,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1732), 1,
      sym_comment,
    STATE(2676), 1,
      sym_type,
    STATE(3101), 1,
      sym__fntype_gen,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [115107] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1385), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_LBRACE,
    ACTIONS(1389), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_typeof,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(1887), 1,
      sym_name,
    STATE(1116), 1,
      sym_paramtypelist,
    STATE(1733), 1,
      sym_comment,
    STATE(2677), 1,
      sym_type,
    STATE(3101), 1,
      sym__fntype_gen,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2666), 3,
      sym_string,
      sym_boolean,
      sym_nil,
    STATE(2665), 8,
      sym_singleton,
      sym_namedtype,
      sym_wraptype,
      sym_dyntype,
      sym_fntype,
      sym_tbtype,
      sym_bintype,
      sym_untype,
  [115163] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1734), 1,
      sym_comment,
    ACTIONS(1019), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1017), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [115197] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1735), 1,
      sym_comment,
    ACTIONS(1057), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(1055), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [115231] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1736), 1,
      sym_comment,
    ACTIONS(766), 8,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_AT_LBRACK,
    ACTIONS(764), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [115265] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1737), 1,
      sym_comment,
    ACTIONS(979), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(981), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [115298] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2387), 1,
      anon_sym_CARET,
    ACTIONS(2389), 1,
      anon_sym_COLON_COLON,
    STATE(1738), 1,
      sym_comment,
    ACTIONS(1347), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1349), 16,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [115335] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2383), 1,
      anon_sym_SLASH,
    ACTIONS(2385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2387), 1,
      anon_sym_CARET,
    ACTIONS(2389), 1,
      anon_sym_COLON_COLON,
    STATE(1739), 1,
      sym_comment,
    ACTIONS(2379), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1347), 3,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2381), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 10,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [115380] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2387), 1,
      anon_sym_CARET,
    ACTIONS(2389), 1,
      anon_sym_COLON_COLON,
    STATE(1740), 1,
      sym_comment,
    ACTIONS(1347), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1349), 16,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [115417] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2357), 1,
      anon_sym_LT,
    ACTIONS(2359), 1,
      anon_sym_DOT,
    STATE(1741), 1,
      sym_comment,
    ACTIONS(929), 2,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(931), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [115454] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(1742), 1,
      sym_comment,
    ACTIONS(943), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(945), 17,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [115489] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1743), 1,
      sym_comment,
    ACTIONS(1353), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1355), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [115522] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1744), 1,
      sym_comment,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(748), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(750), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [115557] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1745), 1,
      sym_comment,
    ACTIONS(955), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(957), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [115590] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1746), 1,
      sym_comment,
    ACTIONS(959), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(961), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [115623] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1091), 1,
      anon_sym_COMMA,
    STATE(1747), 1,
      sym_comment,
    STATE(1752), 1,
      aux_sym__explist_repeat1,
    ACTIONS(2430), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2428), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [115660] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1748), 1,
      sym_comment,
    ACTIONS(939), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(941), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [115693] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1749), 1,
      sym_comment,
    ACTIONS(760), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(762), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [115726] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1750), 1,
      sym_comment,
    ACTIONS(764), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(766), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [115759] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1751), 1,
      sym_comment,
    ACTIONS(768), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(770), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [115792] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2432), 1,
      anon_sym_COMMA,
    STATE(1752), 2,
      sym_comment,
      aux_sym__explist_repeat1,
    ACTIONS(1207), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1205), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [115827] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1753), 1,
      sym_comment,
    ACTIONS(955), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(957), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [115860] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1754), 1,
      sym_comment,
    ACTIONS(959), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(961), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [115893] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1755), 1,
      sym_comment,
    ACTIONS(1221), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1223), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [115926] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1756), 1,
      sym_comment,
    ACTIONS(764), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(766), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [115959] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1757), 1,
      sym_comment,
    ACTIONS(1225), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1227), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [115992] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1758), 1,
      sym_comment,
    ACTIONS(1229), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1231), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116025] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1191), 1,
      anon_sym_else,
    ACTIONS(2373), 1,
      anon_sym_or,
    ACTIONS(2375), 1,
      anon_sym_and,
    ACTIONS(2383), 1,
      anon_sym_SLASH,
    ACTIONS(2385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2387), 1,
      anon_sym_CARET,
    ACTIONS(2389), 1,
      anon_sym_COLON_COLON,
    STATE(1759), 1,
      sym_comment,
    ACTIONS(2371), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2379), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1193), 4,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
    ACTIONS(2377), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [116078] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1760), 1,
      sym_comment,
    ACTIONS(768), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(770), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [116111] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1761), 1,
      sym_comment,
    ACTIONS(1233), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1235), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116144] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1762), 1,
      sym_comment,
    ACTIONS(1237), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1239), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116177] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1763), 1,
      sym_comment,
    ACTIONS(1241), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1243), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116210] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1764), 1,
      sym_comment,
    ACTIONS(1245), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1247), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116243] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1765), 1,
      sym_comment,
    ACTIONS(1249), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1251), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116276] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1766), 1,
      sym_comment,
    ACTIONS(1253), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1255), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116309] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1767), 1,
      sym_comment,
    ACTIONS(1257), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1259), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116342] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1768), 1,
      sym_comment,
    ACTIONS(1263), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1265), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116375] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1769), 1,
      sym_comment,
    ACTIONS(1267), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1269), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116408] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1770), 1,
      sym_comment,
    ACTIONS(1271), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1273), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116441] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1771), 1,
      sym_comment,
    ACTIONS(1275), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1277), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116474] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1772), 1,
      sym_comment,
    ACTIONS(1279), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1281), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116507] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1773), 1,
      sym_comment,
    ACTIONS(1283), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1285), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116540] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1774), 1,
      sym_comment,
    ACTIONS(1287), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1289), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116573] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1775), 1,
      sym_comment,
    ACTIONS(1291), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1293), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116606] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1776), 1,
      sym_comment,
    ACTIONS(1295), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1297), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116639] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2435), 1,
      anon_sym_COMMA,
    STATE(1777), 1,
      sym_comment,
    STATE(2846), 1,
      aux_sym__explist_repeat1,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1089), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [116694] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1778), 1,
      sym_comment,
    ACTIONS(1299), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1301), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116727] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1779), 1,
      sym_comment,
    ACTIONS(1303), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1305), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116760] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1780), 1,
      sym_comment,
    ACTIONS(1307), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1309), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116793] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1781), 1,
      sym_comment,
    ACTIONS(1313), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1315), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116826] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1782), 1,
      sym_comment,
    ACTIONS(1317), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1319), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116859] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1783), 1,
      sym_comment,
    ACTIONS(1067), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1069), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116892] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1784), 1,
      sym_comment,
    ACTIONS(1331), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1333), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [116925] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1195), 1,
      anon_sym_else,
    ACTIONS(2373), 1,
      anon_sym_or,
    ACTIONS(2375), 1,
      anon_sym_and,
    ACTIONS(2383), 1,
      anon_sym_SLASH,
    ACTIONS(2385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2387), 1,
      anon_sym_CARET,
    ACTIONS(2389), 1,
      anon_sym_COLON_COLON,
    STATE(1785), 1,
      sym_comment,
    ACTIONS(2371), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2379), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1197), 4,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
    ACTIONS(2377), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [116978] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2437), 1,
      anon_sym_AMP,
    ACTIONS(2439), 1,
      anon_sym_PIPE,
    ACTIONS(2441), 1,
      anon_sym_QMARK,
    STATE(1786), 1,
      sym_comment,
    ACTIONS(969), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(971), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [117017] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1071), 1,
      anon_sym_COLON,
    STATE(1787), 1,
      sym_comment,
    STATE(2962), 1,
      sym__method_name,
    ACTIONS(1067), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1069), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [117054] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1788), 1,
      sym_comment,
    ACTIONS(979), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(981), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117087] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1789), 1,
      sym_comment,
    ACTIONS(983), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(985), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117120] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1790), 1,
      sym_comment,
    ACTIONS(987), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(989), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117153] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1791), 1,
      sym_comment,
    ACTIONS(991), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(993), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117186] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1792), 1,
      sym_comment,
    ACTIONS(1063), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1065), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117219] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1793), 1,
      sym_comment,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(748), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(750), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [117254] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2437), 1,
      anon_sym_AMP,
    ACTIONS(2439), 1,
      anon_sym_PIPE,
    ACTIONS(2441), 1,
      anon_sym_QMARK,
    STATE(1794), 1,
      sym_comment,
    ACTIONS(999), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1001), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [117293] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1795), 1,
      sym_comment,
    ACTIONS(1003), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1005), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117326] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2437), 1,
      anon_sym_AMP,
    ACTIONS(2439), 1,
      anon_sym_PIPE,
    ACTIONS(2441), 1,
      anon_sym_QMARK,
    STATE(1796), 1,
      sym_comment,
    ACTIONS(1013), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1015), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [117365] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1797), 1,
      sym_comment,
    ACTIONS(1013), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1015), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117398] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1798), 1,
      sym_comment,
    ACTIONS(1017), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1019), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117431] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1799), 1,
      sym_comment,
    ACTIONS(1021), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1023), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117464] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2437), 1,
      anon_sym_AMP,
    ACTIONS(2439), 1,
      anon_sym_PIPE,
    ACTIONS(2441), 1,
      anon_sym_QMARK,
    STATE(1800), 1,
      sym_comment,
    ACTIONS(1025), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1027), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [117503] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1801), 1,
      sym_comment,
    ACTIONS(1029), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1031), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117536] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2443), 1,
      anon_sym_LT,
    STATE(1802), 1,
      sym_comment,
    ACTIONS(1033), 3,
      anon_sym_else,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1035), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117571] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2441), 1,
      anon_sym_QMARK,
    STATE(1803), 1,
      sym_comment,
    ACTIONS(1039), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1041), 17,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
  [117606] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2437), 1,
      anon_sym_AMP,
    ACTIONS(2441), 1,
      anon_sym_QMARK,
    STATE(1804), 1,
      sym_comment,
    ACTIONS(1039), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1041), 16,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [117643] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2437), 1,
      anon_sym_AMP,
    ACTIONS(2439), 1,
      anon_sym_PIPE,
    ACTIONS(2441), 1,
      anon_sym_QMARK,
    STATE(1805), 1,
      sym_comment,
    ACTIONS(1043), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1045), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [117682] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1806), 1,
      sym_comment,
    ACTIONS(1043), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1045), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117715] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1807), 1,
      sym_comment,
    ACTIONS(1335), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1337), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [117748] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1808), 1,
      sym_comment,
    ACTIONS(1047), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1049), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117781] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1809), 1,
      sym_comment,
    ACTIONS(1051), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1053), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117814] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1810), 1,
      sym_comment,
    ACTIONS(1055), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1057), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117847] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2405), 1,
      anon_sym_LT,
    ACTIONS(2407), 1,
      anon_sym_DOT,
    STATE(1811), 1,
      sym_comment,
    ACTIONS(929), 2,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(931), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117884] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1812), 1,
      sym_comment,
    ACTIONS(1059), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1061), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117917] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(1813), 1,
      sym_comment,
    ACTIONS(943), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(945), 17,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [117952] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2387), 1,
      anon_sym_CARET,
    ACTIONS(2389), 1,
      anon_sym_COLON_COLON,
    STATE(1814), 1,
      sym_comment,
    ACTIONS(1339), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1341), 16,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [117989] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1071), 1,
      anon_sym_COLON,
    STATE(1815), 1,
      sym_comment,
    STATE(2962), 1,
      sym__method_name,
    ACTIONS(1067), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1069), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [118026] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1816), 1,
      sym_comment,
    ACTIONS(1201), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1203), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [118059] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1817), 1,
      sym_comment,
    ACTIONS(1343), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1345), 18,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [118092] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2383), 1,
      anon_sym_SLASH,
    ACTIONS(2385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2387), 1,
      anon_sym_CARET,
    ACTIONS(2389), 1,
      anon_sym_COLON_COLON,
    STATE(1818), 1,
      sym_comment,
    ACTIONS(2379), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1347), 3,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2381), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 10,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [118137] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2445), 1,
      anon_sym_AMP,
    ACTIONS(2447), 1,
      anon_sym_PIPE,
    ACTIONS(2449), 1,
      anon_sym_QMARK,
    STATE(1819), 1,
      sym_comment,
    ACTIONS(969), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(971), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [118176] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1820), 1,
      sym_comment,
    ACTIONS(983), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(985), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [118209] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1821), 1,
      sym_comment,
    ACTIONS(2453), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2451), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [118242] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1822), 1,
      sym_comment,
    ACTIONS(2423), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2421), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [118275] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1823), 1,
      sym_comment,
    ACTIONS(991), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(993), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [118308] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2445), 1,
      anon_sym_AMP,
    ACTIONS(2447), 1,
      anon_sym_PIPE,
    ACTIONS(2449), 1,
      anon_sym_QMARK,
    STATE(1824), 1,
      sym_comment,
    ACTIONS(999), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1001), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [118347] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1347), 1,
      anon_sym_else,
    ACTIONS(2375), 1,
      anon_sym_and,
    ACTIONS(2383), 1,
      anon_sym_SLASH,
    ACTIONS(2385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2387), 1,
      anon_sym_CARET,
    ACTIONS(2389), 1,
      anon_sym_COLON_COLON,
    STATE(1825), 1,
      sym_comment,
    ACTIONS(2371), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2379), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2377), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1349), 5,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
  [118398] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1826), 1,
      sym_comment,
    ACTIONS(1003), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1005), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [118431] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2445), 1,
      anon_sym_AMP,
    ACTIONS(2447), 1,
      anon_sym_PIPE,
    ACTIONS(2449), 1,
      anon_sym_QMARK,
    STATE(1827), 1,
      sym_comment,
    ACTIONS(1013), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1015), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [118470] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1828), 1,
      sym_comment,
    ACTIONS(1013), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1015), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [118503] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1829), 1,
      sym_comment,
    ACTIONS(1017), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1019), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [118536] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1830), 1,
      sym_comment,
    ACTIONS(1021), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1023), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [118569] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1831), 1,
      sym_comment,
    ACTIONS(1029), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1031), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [118602] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2455), 1,
      anon_sym_LT,
    STATE(1832), 1,
      sym_comment,
    ACTIONS(1033), 2,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1035), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [118637] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2449), 1,
      anon_sym_QMARK,
    STATE(1833), 1,
      sym_comment,
    ACTIONS(1039), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1041), 18,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
  [118672] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2445), 1,
      anon_sym_AMP,
    ACTIONS(2449), 1,
      anon_sym_QMARK,
    STATE(1834), 1,
      sym_comment,
    ACTIONS(1039), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1041), 17,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [118709] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2445), 1,
      anon_sym_AMP,
    ACTIONS(2447), 1,
      anon_sym_PIPE,
    ACTIONS(2449), 1,
      anon_sym_QMARK,
    STATE(1835), 1,
      sym_comment,
    ACTIONS(1043), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1045), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [118748] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1836), 1,
      sym_comment,
    ACTIONS(1043), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1045), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [118781] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1347), 1,
      anon_sym_else,
    ACTIONS(2383), 1,
      anon_sym_SLASH,
    ACTIONS(2385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2387), 1,
      anon_sym_CARET,
    ACTIONS(2389), 1,
      anon_sym_COLON_COLON,
    STATE(1837), 1,
      sym_comment,
    ACTIONS(2371), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2379), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2377), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1349), 6,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
  [118830] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1838), 1,
      sym_comment,
    ACTIONS(1047), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1049), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [118863] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1839), 1,
      sym_comment,
    ACTIONS(1051), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1053), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [118896] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1840), 1,
      sym_comment,
    ACTIONS(1055), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1057), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [118929] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1841), 1,
      sym_comment,
    ACTIONS(1059), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1061), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [118962] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1205), 1,
      anon_sym_else,
    ACTIONS(2373), 1,
      anon_sym_or,
    ACTIONS(2375), 1,
      anon_sym_and,
    ACTIONS(2383), 1,
      anon_sym_SLASH,
    ACTIONS(2385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2387), 1,
      anon_sym_CARET,
    ACTIONS(2389), 1,
      anon_sym_COLON_COLON,
    STATE(1842), 1,
      sym_comment,
    ACTIONS(2371), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2379), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1207), 4,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
    ACTIONS(2377), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [119015] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1843), 1,
      sym_comment,
    ACTIONS(987), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(989), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [119048] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1844), 1,
      sym_comment,
    ACTIONS(1063), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1065), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [119081] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1845), 1,
      sym_comment,
    ACTIONS(995), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(997), 19,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [119114] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2383), 1,
      anon_sym_SLASH,
    ACTIONS(2387), 1,
      anon_sym_CARET,
    ACTIONS(2389), 1,
      anon_sym_COLON_COLON,
    STATE(1846), 1,
      sym_comment,
    ACTIONS(1347), 3,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2381), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 13,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT_DOT,
  [119155] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2445), 1,
      anon_sym_AMP,
    ACTIONS(2447), 1,
      anon_sym_PIPE,
    ACTIONS(2449), 1,
      anon_sym_QMARK,
    STATE(1847), 1,
      sym_comment,
    ACTIONS(1025), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1027), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [119194] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1848), 1,
      sym_comment,
    ACTIONS(995), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(997), 18,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [119227] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2457), 1,
      anon_sym_AMP,
    ACTIONS(2459), 1,
      anon_sym_PIPE,
    ACTIONS(2461), 1,
      anon_sym_QMARK,
    STATE(1849), 1,
      sym_comment,
    ACTIONS(969), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(971), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [119265] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2457), 1,
      anon_sym_AMP,
    ACTIONS(2459), 1,
      anon_sym_PIPE,
    ACTIONS(2461), 1,
      anon_sym_QMARK,
    STATE(1850), 1,
      sym_comment,
    ACTIONS(1013), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1015), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [119303] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2463), 1,
      anon_sym_COLON,
    STATE(1851), 1,
      sym_comment,
    ACTIONS(2413), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2411), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [119337] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1852), 1,
      sym_comment,
    ACTIONS(1013), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1015), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [119369] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2465), 1,
      anon_sym_COMMA,
    ACTIONS(2469), 1,
      anon_sym_or,
    ACTIONS(2471), 1,
      anon_sym_and,
    ACTIONS(2479), 1,
      anon_sym_SLASH,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_CARET,
    ACTIONS(2485), 1,
      anon_sym_COLON_COLON,
    STATE(1853), 1,
      sym_comment,
    STATE(2869), 1,
      aux_sym__explist_repeat1,
    ACTIONS(1089), 2,
      anon_sym_SEMI,
      anon_sym_until,
    ACTIONS(2467), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2475), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2477), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2473), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [119423] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1071), 1,
      anon_sym_COLON,
    STATE(1854), 1,
      sym_comment,
    STATE(2962), 1,
      sym__method_name,
    ACTIONS(1067), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1069), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [119459] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(2489), 1,
      anon_sym_else,
    ACTIONS(2493), 1,
      anon_sym_or,
    ACTIONS(2495), 1,
      anon_sym_and,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    STATE(1855), 1,
      sym_comment,
    STATE(2877), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [119515] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(2493), 1,
      anon_sym_or,
    ACTIONS(2495), 1,
      anon_sym_and,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2511), 1,
      anon_sym_else,
    STATE(1856), 1,
      sym_comment,
    STATE(2872), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [119571] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2513), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_PIPE,
    ACTIONS(2517), 1,
      anon_sym_QMARK,
    STATE(1857), 1,
      sym_comment,
    ACTIONS(969), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(971), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [119609] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1858), 1,
      sym_comment,
    ACTIONS(979), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(981), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [119641] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1859), 1,
      sym_comment,
    ACTIONS(983), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(985), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [119673] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2519), 1,
      anon_sym_COMMA,
    STATE(1860), 2,
      sym_comment,
      aux_sym_bindinglist_repeat1,
    ACTIONS(2423), 4,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2421), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [119707] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2522), 1,
      anon_sym_COMMA,
    STATE(1861), 1,
      sym_comment,
    STATE(1899), 1,
      aux_sym_bindinglist_repeat1,
    ACTIONS(2399), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2397), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [119743] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(2493), 1,
      anon_sym_or,
    ACTIONS(2495), 1,
      anon_sym_and,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2524), 1,
      anon_sym_else,
    STATE(1862), 1,
      sym_comment,
    STATE(2897), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [119799] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1863), 1,
      sym_comment,
    ACTIONS(991), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(993), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [119831] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2513), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_PIPE,
    ACTIONS(2517), 1,
      anon_sym_QMARK,
    STATE(1864), 1,
      sym_comment,
    ACTIONS(999), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1001), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [119869] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1865), 1,
      sym_comment,
    ACTIONS(1003), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1005), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [119901] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2526), 1,
      anon_sym_COLON,
    STATE(1866), 1,
      sym_comment,
    ACTIONS(2413), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2411), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [119935] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2513), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_PIPE,
    ACTIONS(2517), 1,
      anon_sym_QMARK,
    STATE(1867), 1,
      sym_comment,
    ACTIONS(1013), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1015), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [119973] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1868), 1,
      sym_comment,
    ACTIONS(1013), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1015), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120005] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1869), 1,
      sym_comment,
    ACTIONS(1017), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1019), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120037] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(2493), 1,
      anon_sym_or,
    ACTIONS(2495), 1,
      anon_sym_and,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2528), 1,
      anon_sym_else,
    STATE(1870), 1,
      sym_comment,
    STATE(2878), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [120093] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1871), 1,
      sym_comment,
    ACTIONS(1021), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1023), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120125] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1872), 1,
      sym_comment,
    ACTIONS(1029), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1031), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120157] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2530), 1,
      anon_sym_LT,
    STATE(1873), 1,
      sym_comment,
    ACTIONS(1033), 2,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1035), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120191] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2517), 1,
      anon_sym_QMARK,
    STATE(1874), 1,
      sym_comment,
    ACTIONS(1039), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1041), 17,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
  [120225] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2513), 1,
      anon_sym_AMP,
    ACTIONS(2517), 1,
      anon_sym_QMARK,
    STATE(1875), 1,
      sym_comment,
    ACTIONS(1039), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1041), 16,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [120261] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2513), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_PIPE,
    ACTIONS(2517), 1,
      anon_sym_QMARK,
    STATE(1876), 1,
      sym_comment,
    ACTIONS(1043), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1045), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [120299] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1877), 1,
      sym_comment,
    ACTIONS(1043), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1045), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120331] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2532), 1,
      anon_sym_COMMA,
    STATE(1878), 1,
      sym_comment,
    STATE(1925), 1,
      aux_sym_bindinglist_repeat1,
    ACTIONS(2399), 4,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2397), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [120367] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1879), 1,
      sym_comment,
    ACTIONS(1047), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1049), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120399] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1880), 1,
      sym_comment,
    ACTIONS(1051), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1053), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120431] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1881), 1,
      sym_comment,
    ACTIONS(1055), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1057), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120463] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1882), 1,
      sym_comment,
    ACTIONS(1059), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1061), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120495] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1883), 1,
      sym_comment,
    ACTIONS(764), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(766), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120527] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1884), 1,
      sym_comment,
    ACTIONS(768), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(770), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120559] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1071), 1,
      anon_sym_COLON,
    STATE(1885), 1,
      sym_comment,
    STATE(2962), 1,
      sym__method_name,
    ACTIONS(1067), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1069), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [120595] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(2493), 1,
      anon_sym_or,
    ACTIONS(2495), 1,
      anon_sym_and,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2534), 1,
      anon_sym_else,
    STATE(1886), 1,
      sym_comment,
    STATE(2871), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [120651] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2536), 1,
      anon_sym_COMMA,
    STATE(1887), 2,
      sym_comment,
      aux_sym_bindinglist_repeat1,
    ACTIONS(2423), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2421), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [120685] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1888), 1,
      sym_comment,
    ACTIONS(768), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(770), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120717] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    STATE(1889), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1207), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [120767] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1890), 1,
      sym_comment,
    ACTIONS(1047), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1049), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120799] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(2493), 1,
      anon_sym_or,
    ACTIONS(2495), 1,
      anon_sym_and,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2539), 1,
      anon_sym_else,
    STATE(1891), 1,
      sym_comment,
    STATE(2888), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [120855] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1892), 1,
      sym_comment,
    ACTIONS(1051), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1053), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120887] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1893), 1,
      sym_comment,
    ACTIONS(1003), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1005), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120919] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1894), 1,
      sym_comment,
    ACTIONS(987), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(989), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [120951] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2541), 1,
      anon_sym_COMMA,
    STATE(1895), 1,
      sym_comment,
    STATE(1907), 1,
      aux_sym_bindinglist_repeat1,
    ACTIONS(2419), 4,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2417), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [120987] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1896), 1,
      sym_comment,
    ACTIONS(1063), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1065), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [121019] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1897), 1,
      sym_comment,
    ACTIONS(995), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(997), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [121051] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1898), 1,
      sym_comment,
    ACTIONS(1055), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1057), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [121083] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2522), 1,
      anon_sym_COMMA,
    STATE(1887), 1,
      aux_sym_bindinglist_repeat1,
    STATE(1899), 1,
      sym_comment,
    ACTIONS(2419), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2417), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [121119] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2543), 1,
      anon_sym_COLON,
    STATE(1900), 1,
      sym_comment,
    ACTIONS(2413), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2411), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [121153] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1901), 1,
      sym_comment,
    ACTIONS(1059), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1061), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [121185] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2549), 1,
      anon_sym_EQ,
    STATE(1902), 1,
      sym_comment,
    ACTIONS(2547), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2545), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [121219] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1903), 1,
      sym_comment,
    ACTIONS(955), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(957), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [121251] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(2493), 1,
      anon_sym_or,
    ACTIONS(2495), 1,
      anon_sym_and,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2551), 1,
      anon_sym_else,
    STATE(1904), 1,
      sym_comment,
    STATE(2894), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [121307] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2513), 1,
      anon_sym_AMP,
    ACTIONS(2515), 1,
      anon_sym_PIPE,
    ACTIONS(2517), 1,
      anon_sym_QMARK,
    STATE(1905), 1,
      sym_comment,
    ACTIONS(1025), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1027), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [121345] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1906), 1,
      sym_comment,
    ACTIONS(959), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(961), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [121377] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2553), 1,
      anon_sym_COMMA,
    STATE(1907), 2,
      sym_comment,
      aux_sym_bindinglist_repeat1,
    ACTIONS(2423), 4,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2421), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [121411] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2556), 1,
      anon_sym_COMMA,
    ACTIONS(2560), 1,
      anon_sym_or,
    ACTIONS(2562), 1,
      anon_sym_and,
    ACTIONS(2570), 1,
      anon_sym_SLASH,
    ACTIONS(2572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2574), 1,
      anon_sym_CARET,
    ACTIONS(2576), 1,
      anon_sym_COLON_COLON,
    STATE(1908), 1,
      sym_comment,
    STATE(2895), 1,
      aux_sym__explist_repeat1,
    ACTIONS(1089), 2,
      anon_sym_SEMI,
      anon_sym_end,
    ACTIONS(2558), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2568), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2564), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [121465] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1909), 1,
      sym_comment,
    ACTIONS(1017), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1019), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [121497] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2541), 1,
      anon_sym_COMMA,
    STATE(1895), 1,
      aux_sym_bindinglist_repeat1,
    STATE(1910), 1,
      sym_comment,
    ACTIONS(2399), 4,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2397), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [121533] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(2493), 1,
      anon_sym_or,
    ACTIONS(2495), 1,
      anon_sym_and,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2578), 1,
      anon_sym_else,
    STATE(1911), 1,
      sym_comment,
    STATE(2886), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [121589] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1912), 1,
      sym_comment,
    ACTIONS(1021), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1023), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [121621] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2457), 1,
      anon_sym_AMP,
    ACTIONS(2459), 1,
      anon_sym_PIPE,
    ACTIONS(2461), 1,
      anon_sym_QMARK,
    STATE(1913), 1,
      sym_comment,
    ACTIONS(1025), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1027), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [121659] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1914), 1,
      sym_comment,
    ACTIONS(1029), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1031), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [121691] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1915), 1,
      sym_comment,
    ACTIONS(764), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(766), 18,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [121723] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2580), 1,
      anon_sym_LT,
    STATE(1916), 1,
      sym_comment,
    ACTIONS(1033), 2,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1035), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [121757] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2457), 1,
      anon_sym_AMP,
    ACTIONS(2459), 1,
      anon_sym_PIPE,
    ACTIONS(2461), 1,
      anon_sym_QMARK,
    STATE(1917), 1,
      sym_comment,
    ACTIONS(999), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1001), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [121795] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1918), 1,
      sym_comment,
    ACTIONS(979), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(981), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [121827] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2461), 1,
      anon_sym_QMARK,
    STATE(1919), 1,
      sym_comment,
    ACTIONS(1039), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1041), 17,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
  [121861] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1920), 1,
      sym_comment,
    ACTIONS(983), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(985), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [121893] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(2493), 1,
      anon_sym_or,
    ACTIONS(2495), 1,
      anon_sym_and,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2582), 1,
      anon_sym_else,
    STATE(1921), 1,
      sym_comment,
    STATE(2881), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [121949] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2457), 1,
      anon_sym_AMP,
    ACTIONS(2461), 1,
      anon_sym_QMARK,
    STATE(1922), 1,
      sym_comment,
    ACTIONS(1039), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1041), 16,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [121985] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(2493), 1,
      anon_sym_or,
    ACTIONS(2495), 1,
      anon_sym_and,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2584), 1,
      anon_sym_else,
    STATE(1923), 1,
      sym_comment,
    STATE(2867), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [122041] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2457), 1,
      anon_sym_AMP,
    ACTIONS(2459), 1,
      anon_sym_PIPE,
    ACTIONS(2461), 1,
      anon_sym_QMARK,
    STATE(1924), 1,
      sym_comment,
    ACTIONS(1043), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1045), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [122079] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2532), 1,
      anon_sym_COMMA,
    STATE(1860), 1,
      aux_sym_bindinglist_repeat1,
    STATE(1925), 1,
      sym_comment,
    ACTIONS(2419), 4,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2417), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [122115] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1926), 1,
      sym_comment,
    ACTIONS(987), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(989), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [122147] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1927), 1,
      sym_comment,
    ACTIONS(991), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(993), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [122179] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(2493), 1,
      anon_sym_or,
    ACTIONS(2495), 1,
      anon_sym_and,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2586), 1,
      anon_sym_else,
    STATE(1928), 1,
      sym_comment,
    STATE(2870), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [122235] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1929), 1,
      sym_comment,
    ACTIONS(1063), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1065), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [122267] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1930), 1,
      sym_comment,
    ACTIONS(955), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(957), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [122299] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1931), 1,
      sym_comment,
    ACTIONS(959), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(961), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [122331] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1932), 1,
      sym_comment,
    ACTIONS(1043), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1045), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [122363] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1933), 1,
      sym_comment,
    ACTIONS(995), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(997), 18,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [122395] = 16,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(2493), 1,
      anon_sym_or,
    ACTIONS(2495), 1,
      anon_sym_and,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2588), 1,
      anon_sym_else,
    STATE(1934), 1,
      sym_comment,
    STATE(2900), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [122451] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2574), 1,
      anon_sym_CARET,
    ACTIONS(2576), 1,
      anon_sym_COLON_COLON,
    STATE(1935), 1,
      sym_comment,
    ACTIONS(1347), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1349), 15,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [122486] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1467), 1,
      anon_sym_COMMA,
    STATE(1936), 1,
      sym_comment,
    STATE(1959), 1,
      aux_sym__explist_repeat1,
    ACTIONS(2430), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2428), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [122521] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1937), 1,
      sym_comment,
    ACTIONS(2592), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2590), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [122552] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1938), 1,
      sym_comment,
    ACTIONS(2596), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2594), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [122583] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1939), 1,
      sym_comment,
    ACTIONS(2600), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2598), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [122614] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1940), 1,
      sym_comment,
    ACTIONS(1235), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1233), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [122645] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1941), 1,
      sym_comment,
    ACTIONS(2604), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2602), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [122676] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1942), 1,
      sym_comment,
    ACTIONS(1239), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1237), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [122707] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1943), 1,
      sym_comment,
    ACTIONS(1243), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1241), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [122738] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1944), 1,
      sym_comment,
    ACTIONS(1343), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1345), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [122769] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2570), 1,
      anon_sym_SLASH,
    ACTIONS(2572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2574), 1,
      anon_sym_CARET,
    ACTIONS(2576), 1,
      anon_sym_COLON_COLON,
    STATE(1945), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2568), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 9,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [122812] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1946), 1,
      sym_comment,
    ACTIONS(1247), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1245), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [122843] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1947), 1,
      sym_comment,
    ACTIONS(1251), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1249), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [122874] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2562), 1,
      anon_sym_and,
    ACTIONS(2570), 1,
      anon_sym_SLASH,
    ACTIONS(2572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2574), 1,
      anon_sym_CARET,
    ACTIONS(2576), 1,
      anon_sym_COLON_COLON,
    STATE(1948), 1,
      sym_comment,
    ACTIONS(2558), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2568), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 4,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
    ACTIONS(2564), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [122921] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2570), 1,
      anon_sym_SLASH,
    ACTIONS(2572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2574), 1,
      anon_sym_CARET,
    ACTIONS(2576), 1,
      anon_sym_COLON_COLON,
    STATE(1949), 1,
      sym_comment,
    ACTIONS(2558), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2568), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2564), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1349), 5,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
  [122966] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2570), 1,
      anon_sym_SLASH,
    ACTIONS(2574), 1,
      anon_sym_CARET,
    ACTIONS(2576), 1,
      anon_sym_COLON_COLON,
    STATE(1950), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2568), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 12,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT_DOT,
  [123005] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2574), 1,
      anon_sym_CARET,
    ACTIONS(2576), 1,
      anon_sym_COLON_COLON,
    STATE(1951), 1,
      sym_comment,
    ACTIONS(1347), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1349), 15,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [123040] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2570), 1,
      anon_sym_SLASH,
    ACTIONS(2572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2574), 1,
      anon_sym_CARET,
    ACTIONS(2576), 1,
      anon_sym_COLON_COLON,
    STATE(1952), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2568), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 9,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [123083] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1071), 1,
      anon_sym_COLON,
    STATE(1953), 1,
      sym_comment,
    STATE(2962), 1,
      sym__method_name,
    ACTIONS(1067), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1069), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [123118] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1954), 1,
      sym_comment,
    ACTIONS(1255), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1253), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123149] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1955), 1,
      sym_comment,
    ACTIONS(2453), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2451), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123180] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1956), 1,
      sym_comment,
    ACTIONS(1353), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1355), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [123211] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1957), 1,
      sym_comment,
    ACTIONS(2423), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2421), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123242] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1958), 1,
      sym_comment,
    ACTIONS(1263), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1265), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [123273] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2606), 1,
      anon_sym_COMMA,
    STATE(1959), 2,
      sym_comment,
      aux_sym__explist_repeat1,
    ACTIONS(1207), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1205), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123306] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1960), 1,
      sym_comment,
    ACTIONS(2611), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2609), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123337] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1961), 1,
      sym_comment,
    ACTIONS(2453), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2451), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123368] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1962), 1,
      sym_comment,
    ACTIONS(2423), 5,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2421), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123399] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1963), 1,
      sym_comment,
    ACTIONS(2615), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2613), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123430] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1964), 1,
      sym_comment,
    ACTIONS(1259), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1257), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123461] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1965), 1,
      sym_comment,
    ACTIONS(2619), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2617), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123492] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1966), 1,
      sym_comment,
    ACTIONS(2623), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2621), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123523] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1967), 1,
      sym_comment,
    ACTIONS(1265), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1263), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123554] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1968), 1,
      sym_comment,
    ACTIONS(1269), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1267), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123585] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1969), 1,
      sym_comment,
    ACTIONS(2627), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2625), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123616] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1970), 1,
      sym_comment,
    ACTIONS(2631), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2629), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123647] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1971), 1,
      sym_comment,
    ACTIONS(1273), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1271), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123678] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1972), 1,
      sym_comment,
    ACTIONS(1277), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1275), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123709] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1973), 1,
      sym_comment,
    ACTIONS(1281), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1279), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123740] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1974), 1,
      sym_comment,
    ACTIONS(1267), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1269), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [123771] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1975), 1,
      sym_comment,
    ACTIONS(1285), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1283), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123802] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1976), 1,
      sym_comment,
    ACTIONS(2635), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2633), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123833] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1977), 1,
      sym_comment,
    ACTIONS(2639), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2637), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123864] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1978), 1,
      sym_comment,
    ACTIONS(2643), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2641), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123895] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1979), 1,
      sym_comment,
    ACTIONS(2647), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2645), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123926] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1980), 1,
      sym_comment,
    ACTIONS(2651), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2649), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123957] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1981), 1,
      sym_comment,
    ACTIONS(2655), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2653), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [123988] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1982), 1,
      sym_comment,
    ACTIONS(2659), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2657), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124019] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1983), 1,
      sym_comment,
    ACTIONS(1289), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1287), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124050] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1984), 1,
      sym_comment,
    ACTIONS(2663), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2661), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124081] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1985), 1,
      sym_comment,
    ACTIONS(2667), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2665), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124112] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1986), 1,
      sym_comment,
    ACTIONS(939), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(941), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [124143] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1987), 1,
      sym_comment,
    ACTIONS(1271), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1273), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [124174] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1988), 1,
      sym_comment,
    ACTIONS(1237), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1239), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [124205] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1989), 1,
      sym_comment,
    ACTIONS(1293), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1291), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124236] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1990), 1,
      sym_comment,
    ACTIONS(1275), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1277), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [124267] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1991), 1,
      sym_comment,
    ACTIONS(2671), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2669), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124298] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1992), 1,
      sym_comment,
    ACTIONS(2675), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2673), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124329] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1993), 1,
      sym_comment,
    ACTIONS(2679), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2677), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124360] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1994), 1,
      sym_comment,
    ACTIONS(1297), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1295), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124391] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1995), 1,
      sym_comment,
    ACTIONS(2683), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2681), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124422] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2560), 1,
      anon_sym_or,
    ACTIONS(2562), 1,
      anon_sym_and,
    ACTIONS(2570), 1,
      anon_sym_SLASH,
    ACTIONS(2572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2574), 1,
      anon_sym_CARET,
    ACTIONS(2576), 1,
      anon_sym_COLON_COLON,
    STATE(1996), 1,
      sym_comment,
    ACTIONS(2558), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1193), 3,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
    ACTIONS(2568), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2564), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [124471] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1997), 1,
      sym_comment,
    ACTIONS(2687), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2685), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124502] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1998), 1,
      sym_comment,
    ACTIONS(2691), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2689), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124533] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(1999), 1,
      sym_comment,
    ACTIONS(1301), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1299), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124564] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2000), 1,
      sym_comment,
    ACTIONS(2695), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2693), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124595] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2560), 1,
      anon_sym_or,
    ACTIONS(2562), 1,
      anon_sym_and,
    ACTIONS(2570), 1,
      anon_sym_SLASH,
    ACTIONS(2572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2574), 1,
      anon_sym_CARET,
    ACTIONS(2576), 1,
      anon_sym_COLON_COLON,
    STATE(2001), 1,
      sym_comment,
    ACTIONS(2558), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1197), 3,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
    ACTIONS(2568), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2564), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [124644] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2002), 1,
      sym_comment,
    ACTIONS(1305), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1303), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124675] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2003), 1,
      sym_comment,
    ACTIONS(2699), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2697), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124706] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2004), 1,
      sym_comment,
    ACTIONS(2703), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2701), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124737] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2005), 1,
      sym_comment,
    ACTIONS(2707), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2705), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124768] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2006), 1,
      sym_comment,
    ACTIONS(1309), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1307), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124799] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2007), 1,
      sym_comment,
    ACTIONS(2711), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2709), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124830] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2008), 1,
      sym_comment,
    ACTIONS(2715), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2713), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124861] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2009), 1,
      sym_comment,
    ACTIONS(1201), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1203), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [124892] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2010), 1,
      sym_comment,
    ACTIONS(1067), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1069), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [124923] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2011), 1,
      sym_comment,
    ACTIONS(1319), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1317), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [124954] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2012), 1,
      sym_comment,
    ACTIONS(1279), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1281), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [124985] = 15,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1089), 1,
      anon_sym_do,
    ACTIONS(2717), 1,
      anon_sym_COMMA,
    ACTIONS(2721), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    STATE(2013), 1,
      sym_comment,
    STATE(2956), 1,
      aux_sym__explist_repeat1,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [125038] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2014), 1,
      sym_comment,
    ACTIONS(1229), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1231), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [125069] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    STATE(2015), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2739), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [125118] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2016), 1,
      sym_comment,
    ACTIONS(2453), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2451), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [125149] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2017), 1,
      sym_comment,
    ACTIONS(2423), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2421), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [125180] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2018), 1,
      sym_comment,
    ACTIONS(1283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1285), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [125211] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2019), 1,
      sym_comment,
    ACTIONS(1317), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1319), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [125242] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2020), 1,
      sym_comment,
    ACTIONS(2743), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2741), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [125273] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2021), 1,
      sym_comment,
    ACTIONS(1233), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1235), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [125304] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2022), 1,
      sym_comment,
    ACTIONS(1331), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1333), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [125335] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2023), 1,
      sym_comment,
    ACTIONS(1335), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1337), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [125366] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2483), 1,
      anon_sym_CARET,
    ACTIONS(2485), 1,
      anon_sym_COLON_COLON,
    STATE(2024), 1,
      sym_comment,
    ACTIONS(1339), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1341), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [125401] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2025), 1,
      sym_comment,
    ACTIONS(1225), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1227), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [125432] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2026), 1,
      sym_comment,
    ACTIONS(2119), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2117), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [125463] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2027), 1,
      sym_comment,
    ACTIONS(1287), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1289), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [125494] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2028), 1,
      sym_comment,
    ACTIONS(1343), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1345), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [125525] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2479), 1,
      anon_sym_SLASH,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_CARET,
    ACTIONS(2485), 1,
      anon_sym_COLON_COLON,
    STATE(2029), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2475), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2477), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [125568] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2471), 1,
      anon_sym_and,
    ACTIONS(2479), 1,
      anon_sym_SLASH,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_CARET,
    ACTIONS(2485), 1,
      anon_sym_COLON_COLON,
    STATE(2030), 1,
      sym_comment,
    ACTIONS(2467), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2475), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2477), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
    ACTIONS(2473), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [125615] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2479), 1,
      anon_sym_SLASH,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_CARET,
    ACTIONS(2485), 1,
      anon_sym_COLON_COLON,
    STATE(2031), 1,
      sym_comment,
    ACTIONS(2467), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2475), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2477), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2473), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1349), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
  [125660] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2479), 1,
      anon_sym_SLASH,
    ACTIONS(2483), 1,
      anon_sym_CARET,
    ACTIONS(2485), 1,
      anon_sym_COLON_COLON,
    STATE(2032), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2477), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT_DOT,
  [125699] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2483), 1,
      anon_sym_CARET,
    ACTIONS(2485), 1,
      anon_sym_COLON_COLON,
    STATE(2033), 1,
      sym_comment,
    ACTIONS(1347), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1349), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [125734] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2479), 1,
      anon_sym_SLASH,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_CARET,
    ACTIONS(2485), 1,
      anon_sym_COLON_COLON,
    STATE(2034), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2475), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2477), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [125777] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2483), 1,
      anon_sym_CARET,
    ACTIONS(2485), 1,
      anon_sym_COLON_COLON,
    STATE(2035), 1,
      sym_comment,
    ACTIONS(1347), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1349), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [125812] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2036), 1,
      sym_comment,
    ACTIONS(1245), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1247), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [125843] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2037), 1,
      sym_comment,
    ACTIONS(1291), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1293), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [125874] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2038), 1,
      sym_comment,
    ACTIONS(1353), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1355), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [125905] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1445), 1,
      anon_sym_COMMA,
    STATE(2039), 1,
      sym_comment,
    STATE(2049), 1,
      aux_sym__explist_repeat1,
    ACTIONS(2430), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2428), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [125940] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2040), 1,
      sym_comment,
    ACTIONS(1295), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1297), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [125971] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2747), 1,
      anon_sym_SEMI,
    STATE(2041), 1,
      sym_comment,
    ACTIONS(2749), 2,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2745), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [126004] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2042), 1,
      sym_comment,
    ACTIONS(1249), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1251), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126035] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2043), 1,
      sym_comment,
    ACTIONS(1253), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1255), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126066] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2044), 1,
      sym_comment,
    ACTIONS(1299), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1301), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126097] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2045), 1,
      sym_comment,
    ACTIONS(1221), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1223), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126128] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2046), 1,
      sym_comment,
    ACTIONS(1303), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1305), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126159] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2047), 1,
      sym_comment,
    ACTIONS(1201), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1203), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126190] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2048), 1,
      sym_comment,
    ACTIONS(1067), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1069), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126221] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2751), 1,
      anon_sym_COMMA,
    STATE(2049), 2,
      sym_comment,
      aux_sym__explist_repeat1,
    ACTIONS(1207), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1205), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [126254] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2050), 1,
      sym_comment,
    ACTIONS(1257), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1259), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126285] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2051), 1,
      sym_comment,
    ACTIONS(1225), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1227), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126316] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2052), 1,
      sym_comment,
    ACTIONS(1229), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1231), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126347] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2560), 1,
      anon_sym_or,
    ACTIONS(2562), 1,
      anon_sym_and,
    ACTIONS(2570), 1,
      anon_sym_SLASH,
    ACTIONS(2572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2574), 1,
      anon_sym_CARET,
    ACTIONS(2576), 1,
      anon_sym_COLON_COLON,
    STATE(2053), 1,
      sym_comment,
    ACTIONS(2558), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1207), 3,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
    ACTIONS(2568), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2564), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [126396] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2054), 1,
      sym_comment,
    ACTIONS(2756), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2754), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [126427] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2055), 1,
      sym_comment,
    ACTIONS(1307), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1309), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126458] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2056), 1,
      sym_comment,
    ACTIONS(1223), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1221), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [126489] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2057), 1,
      sym_comment,
    ACTIONS(1233), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1235), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126520] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2058), 1,
      sym_comment,
    ACTIONS(1237), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1239), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126551] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2059), 1,
      sym_comment,
    ACTIONS(1241), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1243), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126582] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2469), 1,
      anon_sym_or,
    ACTIONS(2471), 1,
      anon_sym_and,
    ACTIONS(2479), 1,
      anon_sym_SLASH,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_CARET,
    ACTIONS(2485), 1,
      anon_sym_COLON_COLON,
    STATE(2060), 1,
      sym_comment,
    ACTIONS(2467), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2475), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1193), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
    ACTIONS(2477), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2473), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [126631] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2061), 1,
      sym_comment,
    ACTIONS(1245), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1247), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126662] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2062), 1,
      sym_comment,
    ACTIONS(1249), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1251), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126693] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2063), 1,
      sym_comment,
    ACTIONS(1253), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1255), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126724] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2064), 1,
      sym_comment,
    ACTIONS(1257), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1259), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126755] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2065), 1,
      sym_comment,
    ACTIONS(1263), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1265), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126786] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2469), 1,
      anon_sym_or,
    ACTIONS(2471), 1,
      anon_sym_and,
    ACTIONS(2479), 1,
      anon_sym_SLASH,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_CARET,
    ACTIONS(2485), 1,
      anon_sym_COLON_COLON,
    STATE(2066), 1,
      sym_comment,
    ACTIONS(2467), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2475), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1197), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
    ACTIONS(2477), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2473), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [126835] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2067), 1,
      sym_comment,
    ACTIONS(1267), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1269), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126866] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2068), 1,
      sym_comment,
    ACTIONS(1271), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1273), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126897] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2069), 1,
      sym_comment,
    ACTIONS(1275), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1277), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126928] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2070), 1,
      sym_comment,
    ACTIONS(1279), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1281), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126959] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2071), 1,
      sym_comment,
    ACTIONS(1283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1285), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [126990] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2072), 1,
      sym_comment,
    ACTIONS(1287), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1289), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127021] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2073), 1,
      sym_comment,
    ACTIONS(1291), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1293), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127052] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2074), 1,
      sym_comment,
    ACTIONS(1295), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1297), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127083] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2075), 1,
      sym_comment,
    ACTIONS(1299), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1301), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127114] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2076), 1,
      sym_comment,
    ACTIONS(1303), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1305), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127145] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2077), 1,
      sym_comment,
    ACTIONS(1307), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1309), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127176] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2078), 1,
      sym_comment,
    ACTIONS(1313), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1315), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127207] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2079), 1,
      sym_comment,
    ACTIONS(1317), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1319), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127238] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2080), 1,
      sym_comment,
    ACTIONS(1313), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1315), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127269] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2081), 1,
      sym_comment,
    ACTIONS(939), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(941), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127300] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2082), 1,
      sym_comment,
    ACTIONS(1221), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1223), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127331] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1557), 1,
      anon_sym_COMMA,
    STATE(2083), 1,
      sym_comment,
    STATE(2086), 1,
      aux_sym__explist_repeat1,
    ACTIONS(2430), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2428), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [127366] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2084), 1,
      sym_comment,
    ACTIONS(760), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(762), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127397] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    STATE(2085), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2758), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [127446] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2760), 1,
      anon_sym_COMMA,
    STATE(2086), 2,
      sym_comment,
      aux_sym__explist_repeat1,
    ACTIONS(1207), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1205), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [127479] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    STATE(2087), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2763), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [127528] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2088), 1,
      sym_comment,
    ACTIONS(760), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(762), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127559] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2089), 1,
      sym_comment,
    ACTIONS(1227), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1225), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [127590] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2090), 1,
      sym_comment,
    ACTIONS(1331), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1333), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127621] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2091), 1,
      sym_comment,
    ACTIONS(1335), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1337), 17,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127652] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2574), 1,
      anon_sym_CARET,
    ACTIONS(2576), 1,
      anon_sym_COLON_COLON,
    STATE(2092), 1,
      sym_comment,
    ACTIONS(1339), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1341), 15,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [127687] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2093), 1,
      sym_comment,
    ACTIONS(1231), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1229), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [127718] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2094), 1,
      sym_comment,
    ACTIONS(1241), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1243), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127749] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1071), 1,
      anon_sym_COLON,
    STATE(2095), 1,
      sym_comment,
    STATE(2962), 1,
      sym__method_name,
    ACTIONS(1067), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1069), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127784] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2469), 1,
      anon_sym_or,
    ACTIONS(2471), 1,
      anon_sym_and,
    ACTIONS(2479), 1,
      anon_sym_SLASH,
    ACTIONS(2481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2483), 1,
      anon_sym_CARET,
    ACTIONS(2485), 1,
      anon_sym_COLON_COLON,
    STATE(2096), 1,
      sym_comment,
    ACTIONS(2467), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2475), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1207), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_until,
    ACTIONS(2477), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2473), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [127833] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2097), 1,
      sym_comment,
    ACTIONS(1315), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1313), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [127864] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2098), 1,
      sym_comment,
    ACTIONS(1225), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1227), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127894] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2099), 1,
      sym_comment,
    ACTIONS(1245), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1247), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127924] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2100), 1,
      sym_comment,
    ACTIONS(1249), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1251), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127954] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2101), 1,
      sym_comment,
    ACTIONS(1253), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1255), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [127984] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2102), 1,
      sym_comment,
    ACTIONS(1257), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1259), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128014] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2103), 1,
      sym_comment,
    ACTIONS(1263), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1265), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128044] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2104), 1,
      sym_comment,
    ACTIONS(1307), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1309), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128074] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    STATE(2105), 1,
      sym_comment,
    ACTIONS(1347), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1349), 14,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [128108] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2721), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2765), 1,
      anon_sym_do,
    ACTIONS(2767), 1,
      anon_sym_COMMA,
    STATE(2106), 1,
      sym_comment,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [128158] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2107), 1,
      sym_comment,
    ACTIONS(1253), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1255), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128188] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2108), 1,
      sym_comment,
    ACTIONS(1201), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1203), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128218] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2721), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2769), 1,
      anon_sym_do,
    ACTIONS(2771), 1,
      anon_sym_COMMA,
    STATE(2109), 1,
      sym_comment,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [128268] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2110), 1,
      sym_comment,
    ACTIONS(1313), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1315), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128298] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2111), 1,
      sym_comment,
    ACTIONS(1317), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1319), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128328] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2112), 1,
      sym_comment,
    ACTIONS(1267), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1269), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128358] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2113), 1,
      sym_comment,
    ACTIONS(1271), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1273), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128388] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2114), 1,
      sym_comment,
    ACTIONS(1275), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1277), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128418] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2115), 1,
      sym_comment,
    ACTIONS(1279), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1281), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128448] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2116), 1,
      sym_comment,
    ACTIONS(1353), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1355), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128478] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2117), 1,
      sym_comment,
    ACTIONS(1331), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1333), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128508] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2721), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2773), 1,
      anon_sym_do,
    ACTIONS(2775), 1,
      anon_sym_COMMA,
    STATE(2118), 1,
      sym_comment,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [128558] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    STATE(2119), 1,
      sym_comment,
    ACTIONS(1347), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1349), 13,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [128592] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2120), 1,
      sym_comment,
    ACTIONS(1303), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1305), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128622] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2121), 1,
      sym_comment,
    ACTIONS(1225), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1227), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128652] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2122), 1,
      sym_comment,
    ACTIONS(1279), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1281), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128682] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2123), 1,
      sym_comment,
    ACTIONS(1283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1285), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128712] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2124), 1,
      sym_comment,
    ACTIONS(1229), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1231), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128742] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2125), 1,
      sym_comment,
    ACTIONS(1287), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1289), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128772] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2126), 1,
      sym_comment,
    ACTIONS(1233), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1235), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128802] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2127), 1,
      sym_comment,
    ACTIONS(939), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(941), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128832] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2128), 1,
      sym_comment,
    ACTIONS(1291), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1293), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128862] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2129), 1,
      sym_comment,
    ACTIONS(1353), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1355), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128892] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2721), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2777), 1,
      anon_sym_do,
    ACTIONS(2779), 1,
      anon_sym_COMMA,
    STATE(2130), 1,
      sym_comment,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [128942] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2131), 1,
      sym_comment,
    ACTIONS(1331), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1333), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [128972] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2132), 1,
      sym_comment,
    ACTIONS(1067), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1069), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129002] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2133), 1,
      sym_comment,
    ACTIONS(1335), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1337), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129032] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2134), 1,
      sym_comment,
    ACTIONS(1295), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1297), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129062] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2135), 1,
      sym_comment,
    ACTIONS(1299), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1301), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129092] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2136), 1,
      sym_comment,
    ACTIONS(1303), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1305), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129122] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2137), 1,
      sym_comment,
    ACTIONS(1307), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1309), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129152] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    STATE(2138), 1,
      sym_comment,
    ACTIONS(1339), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1341), 14,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [129186] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2139), 1,
      sym_comment,
    ACTIONS(772), 2,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(700), 17,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [129216] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2140), 1,
      sym_comment,
    ACTIONS(939), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(941), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129246] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2141), 1,
      sym_comment,
    ACTIONS(1257), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1259), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129276] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2142), 1,
      sym_comment,
    ACTIONS(1313), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1315), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129306] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    STATE(2143), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 8,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [129348] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2144), 1,
      sym_comment,
    ACTIONS(1317), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1319), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129378] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      sym_comment,
    ACTIONS(1347), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1349), 14,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [129412] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    STATE(2146), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 11,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT_DOT,
  [129450] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    STATE(2147), 1,
      sym_comment,
    ACTIONS(1347), 3,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 10,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT_DOT,
  [129488] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2148), 1,
      sym_comment,
    ACTIONS(1283), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1285), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129518] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2149), 1,
      sym_comment,
    ACTIONS(1221), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1223), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129548] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2150), 1,
      sym_comment,
    ACTIONS(1221), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1223), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129578] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2151), 1,
      sym_comment,
    ACTIONS(760), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(762), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129608] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2781), 1,
      anon_sym_EQ,
    STATE(2152), 1,
      sym_comment,
    ACTIONS(2547), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2545), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [129640] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2153), 1,
      sym_comment,
    ACTIONS(1287), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1289), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129670] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2154), 1,
      sym_comment,
    ACTIONS(1263), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1265), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129700] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2155), 1,
      sym_comment,
    ACTIONS(1267), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1269), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129730] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2721), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    STATE(2156), 1,
      sym_comment,
    ACTIONS(1193), 2,
      anon_sym_do,
      anon_sym_COMMA,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [129778] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2157), 1,
      sym_comment,
    ACTIONS(1291), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1293), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129808] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    STATE(2158), 1,
      sym_comment,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1349), 3,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [129854] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2159), 1,
      sym_comment,
    ACTIONS(1249), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1251), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129884] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1191), 1,
      anon_sym_else,
    ACTIONS(1193), 1,
      anon_sym_elseif,
    ACTIONS(2493), 1,
      anon_sym_or,
    ACTIONS(2495), 1,
      anon_sym_and,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    STATE(2160), 1,
      sym_comment,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [129934] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2161), 1,
      sym_comment,
    ACTIONS(1335), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1337), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [129964] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    STATE(2162), 1,
      sym_comment,
    ACTIONS(1339), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1341), 13,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [129998] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1195), 1,
      anon_sym_else,
    ACTIONS(1197), 1,
      anon_sym_elseif,
    ACTIONS(2493), 1,
      anon_sym_or,
    ACTIONS(2495), 1,
      anon_sym_and,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    STATE(2163), 1,
      sym_comment,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [130048] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    STATE(2164), 1,
      sym_comment,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 4,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [130092] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2165), 1,
      sym_comment,
    ACTIONS(1271), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1273), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [130122] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2166), 1,
      sym_comment,
    ACTIONS(1201), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1203), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [130152] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2167), 1,
      sym_comment,
    ACTIONS(1275), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1277), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [130182] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2168), 1,
      sym_comment,
    ACTIONS(1343), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1345), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [130212] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2169), 1,
      sym_comment,
    ACTIONS(1237), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1239), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [130242] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2170), 1,
      sym_comment,
    ACTIONS(1233), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1235), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [130272] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    STATE(2171), 1,
      sym_comment,
    ACTIONS(1347), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1349), 13,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [130306] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2172), 1,
      sym_comment,
    ACTIONS(1237), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1239), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [130336] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    STATE(2173), 1,
      sym_comment,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1347), 3,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 7,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [130378] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    STATE(2174), 1,
      sym_comment,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1347), 3,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 7,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [130420] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2175), 1,
      sym_comment,
    ACTIONS(1241), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1243), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [130450] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1347), 1,
      anon_sym_else,
    ACTIONS(2495), 1,
      anon_sym_and,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    STATE(2176), 1,
      sym_comment,
    ACTIONS(1349), 2,
      anon_sym_elseif,
      anon_sym_or,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [130498] = 14,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2493), 1,
      anon_sym_or,
    ACTIONS(2495), 1,
      anon_sym_and,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2783), 1,
      anon_sym_elseif,
    ACTIONS(2785), 1,
      anon_sym_else,
    STATE(2177), 1,
      sym_comment,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [130548] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2178), 1,
      sym_comment,
    ACTIONS(1245), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1247), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [130578] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2721), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    STATE(2179), 1,
      sym_comment,
    ACTIONS(1207), 2,
      anon_sym_do,
      anon_sym_COMMA,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [130626] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2787), 1,
      anon_sym_EQ,
    STATE(2180), 1,
      sym_comment,
    ACTIONS(2547), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2545), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [130658] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2181), 1,
      sym_comment,
    ACTIONS(1295), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1297), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [130688] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2721), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    STATE(2182), 1,
      sym_comment,
    ACTIONS(1197), 2,
      anon_sym_do,
      anon_sym_COMMA,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [130736] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2789), 1,
      anon_sym_EQ,
    STATE(2183), 1,
      sym_comment,
    ACTIONS(2547), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2545), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [130768] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1347), 1,
      anon_sym_else,
    ACTIONS(2503), 1,
      anon_sym_SLASH,
    ACTIONS(2505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2507), 1,
      anon_sym_CARET,
    ACTIONS(2509), 1,
      anon_sym_COLON_COLON,
    STATE(2184), 1,
      sym_comment,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2499), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1349), 3,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [130814] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2185), 1,
      sym_comment,
    ACTIONS(1241), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1243), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [130844] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2186), 1,
      sym_comment,
    ACTIONS(1299), 4,
      anon_sym_else,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1301), 15,
      anon_sym_elseif,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [130874] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2187), 1,
      sym_comment,
    ACTIONS(1343), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1345), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [130904] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2188), 1,
      sym_comment,
    ACTIONS(1067), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1069), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [130934] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2189), 1,
      sym_comment,
    ACTIONS(760), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(762), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [130964] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    STATE(2190), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 8,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [131006] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2191), 1,
      sym_comment,
    ACTIONS(1229), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1231), 16,
      anon_sym_do,
      anon_sym_COMMA,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [131036] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2793), 1,
      anon_sym_and,
    ACTIONS(2801), 1,
      anon_sym_SLASH,
    ACTIONS(2803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2805), 1,
      anon_sym_CARET,
    ACTIONS(2807), 1,
      anon_sym_COLON_COLON,
    STATE(2192), 1,
      sym_comment,
    ACTIONS(1349), 2,
      sym_interp_brace_close,
      anon_sym_or,
    ACTIONS(2791), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2797), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2799), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2795), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [131081] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2193), 1,
      sym_comment,
    ACTIONS(1255), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1253), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131110] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2194), 1,
      sym_comment,
    ACTIONS(1259), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1257), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131139] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2195), 1,
      sym_comment,
    ACTIONS(1265), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1263), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131168] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1197), 1,
      anon_sym_then,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    STATE(2196), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [131215] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2197), 1,
      sym_comment,
    ACTIONS(2699), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2697), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131244] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2198), 1,
      sym_comment,
    ACTIONS(2703), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2701), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131273] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2199), 1,
      sym_comment,
    ACTIONS(1269), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1267), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131302] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2200), 1,
      sym_comment,
    ACTIONS(1273), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1271), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131331] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2201), 1,
      sym_comment,
    ACTIONS(1277), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1275), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131360] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2202), 1,
      sym_comment,
    ACTIONS(1281), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1279), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131389] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2203), 1,
      sym_comment,
    ACTIONS(2707), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2705), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131418] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2204), 1,
      sym_comment,
    ACTIONS(1285), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1283), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131447] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2205), 1,
      sym_comment,
    ACTIONS(1289), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1287), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131476] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2206), 1,
      sym_comment,
    ACTIONS(1293), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1291), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131505] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2207), 1,
      sym_comment,
    ACTIONS(2711), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2709), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131534] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2208), 1,
      sym_comment,
    ACTIONS(1297), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1295), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131563] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2209), 1,
      sym_comment,
    ACTIONS(1301), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1299), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131592] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2210), 1,
      sym_comment,
    ACTIONS(1305), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1303), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131621] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2211), 1,
      sym_comment,
    ACTIONS(1309), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1307), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131650] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2212), 1,
      sym_comment,
    ACTIONS(2715), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2713), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131679] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2213), 1,
      sym_comment,
    ACTIONS(1315), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1313), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131708] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2214), 1,
      sym_comment,
    ACTIONS(1319), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1317), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131737] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2215), 1,
      sym_comment,
    ACTIONS(2743), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2741), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131766] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2216), 1,
      sym_comment,
    ACTIONS(2119), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2117), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131795] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2829), 1,
      anon_sym_SEMI,
    STATE(2217), 1,
      sym_comment,
    ACTIONS(2749), 2,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2745), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131826] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2218), 1,
      sym_comment,
    ACTIONS(2647), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2645), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131855] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2219), 1,
      sym_comment,
    ACTIONS(2699), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2697), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131884] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2721), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2831), 1,
      anon_sym_do,
    STATE(2220), 1,
      sym_comment,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [131931] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2221), 1,
      sym_comment,
    ACTIONS(2703), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2701), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [131960] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2793), 1,
      anon_sym_and,
    ACTIONS(2801), 1,
      anon_sym_SLASH,
    ACTIONS(2803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2805), 1,
      anon_sym_CARET,
    ACTIONS(2807), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2833), 1,
      anon_sym_or,
    ACTIONS(2835), 1,
      sym_interp_brace_close,
    STATE(2222), 1,
      sym_comment,
    ACTIONS(2791), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2797), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2799), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2795), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [132007] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2121), 1,
      anon_sym_LBRACK,
    ACTIONS(2837), 1,
      anon_sym_DOT,
    STATE(2223), 1,
      sym_comment,
    STATE(2540), 1,
      sym_key,
    STATE(2541), 1,
      sym__key_named,
    ACTIONS(746), 14,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [132042] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2224), 1,
      sym_comment,
    ACTIONS(2651), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2649), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132071] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2225), 1,
      sym_comment,
    ACTIONS(2655), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2653), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132100] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2226), 1,
      sym_comment,
    ACTIONS(2756), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2754), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132129] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2227), 1,
      sym_comment,
    ACTIONS(2707), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2705), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132158] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1197), 1,
      sym_interp_brace_close,
    ACTIONS(2793), 1,
      anon_sym_and,
    ACTIONS(2801), 1,
      anon_sym_SLASH,
    ACTIONS(2803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2805), 1,
      anon_sym_CARET,
    ACTIONS(2807), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2833), 1,
      anon_sym_or,
    STATE(2228), 1,
      sym_comment,
    ACTIONS(2791), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2797), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2799), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2795), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [132205] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2839), 1,
      anon_sym_RPAREN,
    STATE(2229), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [132252] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2230), 1,
      sym_comment,
    ACTIONS(2659), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2657), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132281] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2841), 1,
      anon_sym_RBRACK,
    STATE(2231), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [132328] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2232), 1,
      sym_comment,
    ACTIONS(2711), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2709), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132357] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2843), 1,
      anon_sym_RPAREN,
    STATE(2233), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [132404] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2234), 1,
      sym_comment,
    ACTIONS(2119), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2117), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132433] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2235), 1,
      sym_comment,
    ACTIONS(2592), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2590), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132462] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2236), 1,
      sym_comment,
    ACTIONS(2596), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2594), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132491] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2237), 1,
      sym_comment,
    ACTIONS(2600), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2598), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132520] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2238), 1,
      sym_comment,
    ACTIONS(2604), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2602), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132549] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2239), 1,
      sym_comment,
    ACTIONS(1353), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1355), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [132578] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2845), 1,
      anon_sym_RPAREN,
    STATE(2240), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [132625] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2847), 1,
      anon_sym_RPAREN,
    STATE(2241), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [132672] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2849), 1,
      anon_sym_RBRACK,
    STATE(2242), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [132719] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2243), 1,
      sym_comment,
    ACTIONS(1223), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1221), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132748] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2244), 1,
      sym_comment,
    ACTIONS(2611), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2609), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132777] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2851), 1,
      anon_sym_RPAREN,
    STATE(2245), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [132824] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2246), 1,
      sym_comment,
    ACTIONS(1343), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1345), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [132853] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2247), 1,
      sym_comment,
    ACTIONS(2715), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2713), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132882] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2248), 1,
      sym_comment,
    ACTIONS(2615), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2613), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132911] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2249), 1,
      sym_comment,
    ACTIONS(2619), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2617), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132940] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2250), 1,
      sym_comment,
    ACTIONS(2623), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2621), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132969] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2251), 1,
      sym_comment,
    ACTIONS(2627), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2625), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [132998] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2252), 1,
      sym_comment,
    ACTIONS(2631), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2629), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133027] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2253), 1,
      sym_comment,
    ACTIONS(1221), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1223), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [133056] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2254), 1,
      sym_comment,
    ACTIONS(2743), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2741), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133085] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2255), 1,
      sym_comment,
    ACTIONS(2119), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2117), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133114] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2853), 1,
      anon_sym_RPAREN,
    STATE(2256), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [133161] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2257), 1,
      sym_comment,
    ACTIONS(2635), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2633), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133190] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2258), 1,
      sym_comment,
    ACTIONS(2639), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2637), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133219] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2855), 1,
      anon_sym_RBRACK,
    STATE(2259), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [133266] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2260), 1,
      sym_comment,
    ACTIONS(2643), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2641), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133295] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2261), 1,
      sym_comment,
    ACTIONS(2647), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2645), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133324] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2262), 1,
      sym_comment,
    ACTIONS(2651), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2649), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133353] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2263), 1,
      sym_comment,
    ACTIONS(2655), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2653), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133382] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2857), 1,
      anon_sym_SEMI,
    STATE(2264), 1,
      sym_comment,
    ACTIONS(2749), 2,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2745), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133413] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2265), 1,
      sym_comment,
    ACTIONS(2659), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2657), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133442] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2266), 1,
      sym_comment,
    ACTIONS(2663), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2661), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133471] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2267), 1,
      sym_comment,
    ACTIONS(2667), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2665), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133500] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2268), 1,
      sym_comment,
    ACTIONS(1225), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1227), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [133529] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2859), 1,
      anon_sym_RPAREN,
    STATE(2269), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [133576] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2270), 1,
      sym_comment,
    ACTIONS(1229), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1231), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [133605] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2861), 1,
      anon_sym_RBRACK,
    STATE(2271), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [133652] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2272), 1,
      sym_comment,
    ACTIONS(2671), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2669), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133681] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2273), 1,
      sym_comment,
    ACTIONS(2675), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2673), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133710] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2274), 1,
      sym_comment,
    ACTIONS(2679), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2677), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133739] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2275), 1,
      sym_comment,
    ACTIONS(2683), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2681), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [133768] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2276), 1,
      sym_comment,
    ACTIONS(1233), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1235), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [133797] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2863), 1,
      anon_sym_RPAREN,
    STATE(2277), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [133844] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2278), 1,
      sym_comment,
    ACTIONS(1237), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1239), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [133873] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2279), 1,
      sym_comment,
    ACTIONS(1241), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1243), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [133902] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2865), 1,
      anon_sym_RBRACK,
    STATE(2280), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [133949] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2281), 1,
      sym_comment,
    ACTIONS(1201), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1203), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [133978] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2282), 1,
      sym_comment,
    ACTIONS(1067), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1069), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134007] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2867), 1,
      anon_sym_SEMI,
    STATE(2283), 1,
      sym_comment,
    ACTIONS(2749), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2745), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [134038] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2284), 1,
      sym_comment,
    ACTIONS(2687), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2685), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [134067] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2869), 1,
      anon_sym_RPAREN,
    STATE(2285), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [134114] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2286), 1,
      sym_comment,
    ACTIONS(2691), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2689), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [134143] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2287), 1,
      sym_comment,
    ACTIONS(2695), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2693), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [134172] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2288), 1,
      sym_comment,
    ACTIONS(1245), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1247), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134201] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2289), 1,
      sym_comment,
    ACTIONS(1249), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1251), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134230] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2290), 1,
      sym_comment,
    ACTIONS(1253), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1255), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134259] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2291), 1,
      sym_comment,
    ACTIONS(1257), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1259), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134288] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2292), 1,
      sym_comment,
    ACTIONS(1263), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1265), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134317] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2293), 1,
      sym_comment,
    ACTIONS(2699), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2697), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [134346] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2294), 1,
      sym_comment,
    ACTIONS(2703), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2701), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [134375] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2295), 1,
      sym_comment,
    ACTIONS(1267), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1269), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134404] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2296), 1,
      sym_comment,
    ACTIONS(1271), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1273), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134433] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2297), 1,
      sym_comment,
    ACTIONS(1275), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1277), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134462] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2298), 1,
      sym_comment,
    ACTIONS(1279), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1281), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134491] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2871), 1,
      anon_sym_RPAREN,
    STATE(2299), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [134538] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2873), 1,
      anon_sym_RBRACK,
    STATE(2300), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [134585] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2301), 1,
      sym_comment,
    ACTIONS(2707), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2705), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [134614] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2302), 1,
      sym_comment,
    ACTIONS(1283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1285), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134643] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2303), 1,
      sym_comment,
    ACTIONS(1287), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1289), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134672] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2304), 1,
      sym_comment,
    ACTIONS(1291), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1293), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134701] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2305), 1,
      sym_comment,
    ACTIONS(2711), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2709), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [134730] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2306), 1,
      sym_comment,
    ACTIONS(1295), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1297), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134759] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2875), 1,
      anon_sym_RPAREN,
    STATE(2307), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [134806] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2308), 1,
      sym_comment,
    ACTIONS(1299), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1301), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134835] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2309), 1,
      sym_comment,
    ACTIONS(1303), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1305), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134864] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2310), 1,
      sym_comment,
    ACTIONS(1307), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1309), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134893] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2311), 1,
      sym_comment,
    ACTIONS(2715), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2713), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [134922] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2312), 1,
      sym_comment,
    ACTIONS(1313), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1315), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134951] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2313), 1,
      sym_comment,
    ACTIONS(1317), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1319), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [134980] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2314), 1,
      sym_comment,
    ACTIONS(2671), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2669), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [135009] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2315), 1,
      sym_comment,
    ACTIONS(2756), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2754), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [135038] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2877), 1,
      anon_sym_RPAREN,
    STATE(2316), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [135085] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2879), 1,
      anon_sym_RBRACK,
    STATE(2317), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [135132] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2318), 1,
      sym_comment,
    ACTIONS(2675), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2673), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [135161] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2319), 1,
      sym_comment,
    ACTIONS(939), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(941), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [135190] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2320), 1,
      sym_comment,
    ACTIONS(2592), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2590), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [135219] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2881), 1,
      anon_sym_RPAREN,
    STATE(2321), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [135266] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2322), 1,
      sym_comment,
    ACTIONS(2679), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2677), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [135295] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2323), 1,
      sym_comment,
    ACTIONS(760), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(762), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [135324] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2324), 1,
      sym_comment,
    ACTIONS(2596), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2594), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [135353] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2325), 1,
      sym_comment,
    ACTIONS(2683), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2681), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [135382] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2326), 1,
      sym_comment,
    ACTIONS(1331), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1333), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [135411] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2327), 1,
      sym_comment,
    ACTIONS(1335), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1337), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [135440] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2883), 1,
      anon_sym_RPAREN,
    STATE(2328), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [135487] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    STATE(2329), 1,
      sym_comment,
    ACTIONS(1339), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1341), 13,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [135520] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2885), 1,
      anon_sym_RBRACK,
    STATE(2330), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [135567] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2331), 1,
      sym_comment,
    ACTIONS(939), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(941), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [135596] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2332), 1,
      sym_comment,
    ACTIONS(2743), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2741), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [135625] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2887), 1,
      anon_sym_RPAREN,
    STATE(2333), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [135672] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2334), 1,
      sym_comment,
    ACTIONS(2600), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2598), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [135701] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2889), 1,
      anon_sym_RBRACK,
    STATE(2335), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [135748] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2801), 1,
      anon_sym_SLASH,
    ACTIONS(2803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2805), 1,
      anon_sym_CARET,
    ACTIONS(2807), 1,
      anon_sym_COLON_COLON,
    STATE(2336), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2797), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2799), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 7,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [135789] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2891), 1,
      anon_sym_RPAREN,
    STATE(2337), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [135836] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2893), 1,
      anon_sym_RBRACK,
    STATE(2338), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [135883] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2339), 1,
      sym_comment,
    ACTIONS(2592), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2590), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [135912] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2340), 1,
      sym_comment,
    ACTIONS(2596), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2594), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [135941] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2895), 1,
      anon_sym_RPAREN,
    STATE(2341), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [135988] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2897), 1,
      anon_sym_RPAREN,
    STATE(2342), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [136035] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2899), 1,
      anon_sym_RBRACK,
    STATE(2343), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [136082] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2344), 1,
      sym_comment,
    ACTIONS(2600), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2598), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [136111] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2345), 1,
      sym_comment,
    ACTIONS(2604), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2602), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [136140] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2901), 1,
      anon_sym_RPAREN,
    STATE(2346), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [136187] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2347), 1,
      sym_comment,
    ACTIONS(1343), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1345), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [136216] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2348), 1,
      sym_comment,
    ACTIONS(760), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(762), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [136245] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2349), 1,
      sym_comment,
    ACTIONS(1227), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1225), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [136274] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    STATE(2350), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 7,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [136315] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    STATE(2351), 1,
      sym_comment,
    ACTIONS(1349), 2,
      anon_sym_then,
      anon_sym_or,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [136360] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    STATE(2352), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1349), 3,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [136403] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    STATE(2353), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 10,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT_DOT,
  [136440] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    STATE(2354), 1,
      sym_comment,
    ACTIONS(1347), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1349), 13,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [136473] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    STATE(2355), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 7,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [136514] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    STATE(2356), 1,
      sym_comment,
    ACTIONS(1347), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1349), 13,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [136547] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2903), 1,
      anon_sym_RPAREN,
    STATE(2357), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [136594] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2358), 1,
      sym_comment,
    ACTIONS(1231), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1229), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [136623] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2905), 1,
      anon_sym_RBRACK,
    STATE(2359), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [136670] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1193), 1,
      sym_interp_brace_close,
    ACTIONS(2793), 1,
      anon_sym_and,
    ACTIONS(2801), 1,
      anon_sym_SLASH,
    ACTIONS(2803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2805), 1,
      anon_sym_CARET,
    ACTIONS(2807), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2833), 1,
      anon_sym_or,
    STATE(2360), 1,
      sym_comment,
    ACTIONS(2791), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2797), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2799), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2795), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [136717] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2361), 1,
      sym_comment,
    ACTIONS(1353), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1355), 15,
      anon_sym_then,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [136746] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2801), 1,
      anon_sym_SLASH,
    ACTIONS(2803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2805), 1,
      anon_sym_CARET,
    ACTIONS(2807), 1,
      anon_sym_COLON_COLON,
    STATE(2362), 1,
      sym_comment,
    ACTIONS(2791), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2797), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1349), 3,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(2799), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2795), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [136789] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2907), 1,
      anon_sym_RPAREN,
    STATE(2363), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [136836] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2364), 1,
      sym_comment,
    ACTIONS(2611), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2609), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [136865] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2801), 1,
      anon_sym_SLASH,
    ACTIONS(2805), 1,
      anon_sym_CARET,
    ACTIONS(2807), 1,
      anon_sym_COLON_COLON,
    STATE(2365), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2799), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 10,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT_DOT,
  [136902] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2805), 1,
      anon_sym_CARET,
    ACTIONS(2807), 1,
      anon_sym_COLON_COLON,
    STATE(2366), 1,
      sym_comment,
    ACTIONS(1347), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1349), 13,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [136935] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2367), 1,
      sym_comment,
    ACTIONS(2615), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2613), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [136964] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2368), 1,
      sym_comment,
    ACTIONS(2619), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2617), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [136993] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2909), 1,
      anon_sym_RPAREN,
    STATE(2369), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [137040] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2370), 1,
      sym_comment,
    ACTIONS(2623), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2621), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137069] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2911), 1,
      anon_sym_RBRACK,
    STATE(2371), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [137116] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2372), 1,
      sym_comment,
    ACTIONS(1251), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1249), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137145] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2373), 1,
      sym_comment,
    ACTIONS(1239), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1237), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137174] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2374), 1,
      sym_comment,
    ACTIONS(1221), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1223), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [137203] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2375), 1,
      sym_comment,
    ACTIONS(1243), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1241), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137232] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2913), 1,
      anon_sym_RPAREN,
    STATE(2376), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [137279] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2377), 1,
      sym_comment,
    ACTIONS(1247), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1245), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137308] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2378), 1,
      sym_comment,
    ACTIONS(1251), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1249), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137337] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2379), 1,
      sym_comment,
    ACTIONS(1225), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1227), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [137366] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2380), 1,
      sym_comment,
    ACTIONS(1229), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1231), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [137395] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2915), 1,
      anon_sym_RPAREN,
    STATE(2381), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [137442] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2917), 1,
      anon_sym_RBRACK,
    STATE(2382), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [137489] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2383), 1,
      sym_comment,
    ACTIONS(1255), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1253), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137518] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2384), 1,
      sym_comment,
    ACTIONS(1259), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1257), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137547] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2385), 1,
      sym_comment,
    ACTIONS(1265), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1263), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137576] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2386), 1,
      sym_comment,
    ACTIONS(1269), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1267), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137605] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2387), 1,
      sym_comment,
    ACTIONS(1273), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1271), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137634] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2919), 1,
      anon_sym_RPAREN,
    STATE(2388), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [137681] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2389), 1,
      sym_comment,
    ACTIONS(2627), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2625), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137710] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2390), 1,
      sym_comment,
    ACTIONS(1277), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1275), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137739] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2391), 1,
      sym_comment,
    ACTIONS(1281), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1279), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137768] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2392), 1,
      sym_comment,
    ACTIONS(1233), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1235), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [137797] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2393), 1,
      sym_comment,
    ACTIONS(1237), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1239), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [137826] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2394), 1,
      sym_comment,
    ACTIONS(1241), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1243), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [137855] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2395), 1,
      sym_comment,
    ACTIONS(1285), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1283), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137884] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2396), 1,
      sym_comment,
    ACTIONS(1289), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1287), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137913] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2397), 1,
      sym_comment,
    ACTIONS(1293), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1291), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137942] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2398), 1,
      sym_comment,
    ACTIONS(1297), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1295), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [137971] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2399), 1,
      sym_comment,
    ACTIONS(1301), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1299), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [138000] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2400), 1,
      sym_comment,
    ACTIONS(1245), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1247), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138029] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2401), 1,
      sym_comment,
    ACTIONS(1249), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1251), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138058] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2402), 1,
      sym_comment,
    ACTIONS(1253), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1255), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138087] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2403), 1,
      sym_comment,
    ACTIONS(1257), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1259), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138116] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2404), 1,
      sym_comment,
    ACTIONS(1263), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1265), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138145] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2405), 1,
      sym_comment,
    ACTIONS(1305), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1303), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [138174] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2406), 1,
      sym_comment,
    ACTIONS(1267), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1269), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138203] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2921), 1,
      anon_sym_RPAREN,
    STATE(2407), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [138250] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2408), 1,
      sym_comment,
    ACTIONS(1271), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1273), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138279] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2409), 1,
      sym_comment,
    ACTIONS(1275), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1277), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138308] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2410), 1,
      sym_comment,
    ACTIONS(1279), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1281), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138337] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2411), 1,
      sym_comment,
    ACTIONS(1309), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1307), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [138366] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2412), 1,
      sym_comment,
    ACTIONS(1283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1285), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138395] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2413), 1,
      sym_comment,
    ACTIONS(1287), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1289), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138424] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2414), 1,
      sym_comment,
    ACTIONS(1291), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1293), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138453] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2415), 1,
      sym_comment,
    ACTIONS(1295), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1297), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138482] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2416), 1,
      sym_comment,
    ACTIONS(1299), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1301), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138511] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2417), 1,
      sym_comment,
    ACTIONS(1303), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1305), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138540] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2418), 1,
      sym_comment,
    ACTIONS(1307), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1309), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138569] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2419), 1,
      sym_comment,
    ACTIONS(1313), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1315), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138598] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2420), 1,
      sym_comment,
    ACTIONS(1317), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1319), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [138627] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2421), 1,
      sym_comment,
    ACTIONS(1247), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1245), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [138656] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2923), 1,
      anon_sym_then,
    STATE(2422), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [138703] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2423), 1,
      sym_comment,
    ACTIONS(1315), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1313), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [138732] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2424), 1,
      sym_comment,
    ACTIONS(1319), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1317), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [138761] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2925), 1,
      anon_sym_RPAREN,
    STATE(2425), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [138808] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2426), 1,
      sym_comment,
    ACTIONS(2611), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2609), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [138837] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2427), 1,
      sym_comment,
    ACTIONS(2663), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2661), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [138866] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2428), 1,
      sym_comment,
    ACTIONS(2667), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2665), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [138895] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2429), 1,
      sym_comment,
    ACTIONS(2615), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2613), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [138924] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2927), 1,
      anon_sym_RPAREN,
    STATE(2430), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [138971] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2431), 1,
      sym_comment,
    ACTIONS(2619), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2617), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [139000] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2929), 1,
      anon_sym_COMMA,
    STATE(2432), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [139047] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2433), 1,
      sym_comment,
    ACTIONS(2623), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2621), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [139076] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2434), 1,
      sym_comment,
    ACTIONS(2631), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2629), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [139105] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2931), 1,
      anon_sym_RPAREN,
    STATE(2435), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [139152] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2436), 1,
      sym_comment,
    ACTIONS(2604), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2602), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [139181] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2933), 1,
      anon_sym_RPAREN,
    STATE(2437), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [139228] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2438), 1,
      sym_comment,
    ACTIONS(1223), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1221), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [139257] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2439), 1,
      sym_comment,
    ACTIONS(2756), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2754), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [139286] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2801), 1,
      anon_sym_SLASH,
    ACTIONS(2803), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2805), 1,
      anon_sym_CARET,
    ACTIONS(2807), 1,
      anon_sym_COLON_COLON,
    STATE(2440), 1,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2797), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2799), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1349), 7,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [139327] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2935), 1,
      anon_sym_then,
    STATE(2441), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [139374] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2721), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2937), 1,
      anon_sym_do,
    STATE(2442), 1,
      sym_comment,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [139421] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2939), 1,
      anon_sym_then,
    STATE(2443), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [139468] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2444), 1,
      sym_comment,
    ACTIONS(2627), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2625), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [139497] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2721), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2941), 1,
      anon_sym_do,
    STATE(2445), 1,
      sym_comment,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [139544] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2943), 1,
      anon_sym_then,
    STATE(2446), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [139591] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2721), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2945), 1,
      anon_sym_do,
    STATE(2447), 1,
      sym_comment,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [139638] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2805), 1,
      anon_sym_CARET,
    ACTIONS(2807), 1,
      anon_sym_COLON_COLON,
    STATE(2448), 1,
      sym_comment,
    ACTIONS(1347), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1349), 13,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [139671] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2449), 1,
      sym_comment,
    ACTIONS(2635), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2633), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [139700] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2721), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2947), 1,
      anon_sym_do,
    STATE(2450), 1,
      sym_comment,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [139747] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2949), 1,
      anon_sym_then,
    STATE(2451), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [139794] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2721), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2951), 1,
      anon_sym_do,
    STATE(2452), 1,
      sym_comment,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [139841] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2953), 1,
      anon_sym_then,
    STATE(2453), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [139888] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2454), 1,
      sym_comment,
    ACTIONS(2635), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2633), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [139917] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2455), 1,
      sym_comment,
    ACTIONS(2639), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2637), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [139946] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2456), 1,
      sym_comment,
    ACTIONS(2643), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2641), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [139975] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2457), 1,
      sym_comment,
    ACTIONS(2647), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2645), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140004] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2458), 1,
      sym_comment,
    ACTIONS(2651), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2649), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140033] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2721), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2955), 1,
      anon_sym_do,
    STATE(2459), 1,
      sym_comment,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [140080] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2460), 1,
      sym_comment,
    ACTIONS(2655), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2653), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140109] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2461), 1,
      sym_comment,
    ACTIONS(2659), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2657), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140138] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2462), 1,
      sym_comment,
    ACTIONS(2639), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2637), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140167] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2463), 1,
      sym_comment,
    ACTIONS(2663), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2661), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140196] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2464), 1,
      sym_comment,
    ACTIONS(2667), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2665), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140225] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2465), 1,
      sym_comment,
    ACTIONS(1227), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1225), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140254] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2466), 1,
      sym_comment,
    ACTIONS(1231), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1229), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140283] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2467), 1,
      sym_comment,
    ACTIONS(2687), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2685), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140312] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2468), 1,
      sym_comment,
    ACTIONS(2691), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2689), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140341] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2469), 1,
      sym_comment,
    ACTIONS(2695), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2693), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140370] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2470), 1,
      sym_comment,
    ACTIONS(2671), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2669), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140399] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2471), 1,
      sym_comment,
    ACTIONS(2675), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2673), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140428] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2472), 1,
      sym_comment,
    ACTIONS(2679), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2677), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140457] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2473), 1,
      sym_comment,
    ACTIONS(2683), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2681), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140486] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2474), 1,
      sym_comment,
    ACTIONS(1235), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1233), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140515] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2475), 1,
      sym_comment,
    ACTIONS(2643), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2641), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140544] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2476), 1,
      sym_comment,
    ACTIONS(2631), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2629), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140573] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2477), 1,
      sym_comment,
    ACTIONS(1239), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1237), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140602] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2957), 1,
      anon_sym_then,
    STATE(2478), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [140649] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2121), 1,
      anon_sym_LBRACK,
    ACTIONS(2837), 1,
      anon_sym_DOT,
    STATE(2479), 1,
      sym_comment,
    STATE(2535), 1,
      sym_key,
    STATE(2541), 1,
      sym__key_named,
    ACTIONS(691), 14,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [140684] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2480), 1,
      sym_comment,
    ACTIONS(1243), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1241), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140713] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2481), 1,
      sym_comment,
    ACTIONS(1223), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1221), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140742] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1193), 1,
      anon_sym_then,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    STATE(2482), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [140789] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2483), 1,
      sym_comment,
    ACTIONS(1227), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1225), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140818] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2484), 1,
      sym_comment,
    ACTIONS(1231), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1229), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140847] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2485), 1,
      sym_comment,
    ACTIONS(1235), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1233), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140876] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2486), 1,
      sym_comment,
    ACTIONS(1239), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1237), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140905] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2487), 1,
      sym_comment,
    ACTIONS(1243), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1241), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [140934] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2721), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_and,
    ACTIONS(2731), 1,
      anon_sym_SLASH,
    ACTIONS(2733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2959), 1,
      anon_sym_do,
    STATE(2488), 1,
      sym_comment,
    ACTIONS(2719), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2729), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [140981] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2489), 1,
      sym_comment,
    ACTIONS(1247), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1245), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141010] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2490), 1,
      sym_comment,
    ACTIONS(1251), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1249), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141039] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2491), 1,
      sym_comment,
    ACTIONS(1255), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1253), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141068] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2492), 1,
      sym_comment,
    ACTIONS(1259), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1257), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141097] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2493), 1,
      sym_comment,
    ACTIONS(1265), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1263), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141126] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2494), 1,
      sym_comment,
    ACTIONS(1269), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1267), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141155] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2495), 1,
      sym_comment,
    ACTIONS(1273), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1271), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141184] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2496), 1,
      sym_comment,
    ACTIONS(1277), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1275), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141213] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2497), 1,
      sym_comment,
    ACTIONS(1281), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1279), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141242] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2498), 1,
      sym_comment,
    ACTIONS(1285), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1283), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141271] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2499), 1,
      sym_comment,
    ACTIONS(1289), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1287), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141300] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2500), 1,
      sym_comment,
    ACTIONS(1293), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1291), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141329] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2501), 1,
      sym_comment,
    ACTIONS(1297), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1295), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141358] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2502), 1,
      sym_comment,
    ACTIONS(1301), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1299), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141387] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2961), 1,
      anon_sym_then,
    STATE(2503), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [141434] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2504), 1,
      sym_comment,
    ACTIONS(1305), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1303), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141463] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2505), 1,
      sym_comment,
    ACTIONS(1309), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1307), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141492] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2506), 1,
      sym_comment,
    ACTIONS(1315), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1313), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141521] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2507), 1,
      sym_comment,
    ACTIONS(1319), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1317), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [141550] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2963), 1,
      anon_sym_then,
    STATE(2508), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [141597] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2509), 1,
      sym_comment,
    ACTIONS(1201), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1203), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [141626] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2510), 1,
      sym_comment,
    ACTIONS(1067), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1069), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [141655] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2965), 1,
      anon_sym_then,
    STATE(2511), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [141702] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2967), 1,
      anon_sym_then,
    STATE(2512), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [141749] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2969), 1,
      anon_sym_then,
    STATE(2513), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [141796] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2971), 1,
      anon_sym_then,
    STATE(2514), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [141843] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2973), 1,
      anon_sym_then,
    STATE(2515), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [141890] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2975), 1,
      anon_sym_then,
    STATE(2516), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [141937] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2977), 1,
      anon_sym_then,
    STATE(2517), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [141984] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2979), 1,
      anon_sym_then,
    STATE(2518), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [142031] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2811), 1,
      anon_sym_or,
    ACTIONS(2813), 1,
      anon_sym_and,
    ACTIONS(2821), 1,
      anon_sym_SLASH,
    ACTIONS(2823), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2825), 1,
      anon_sym_CARET,
    ACTIONS(2827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2981), 1,
      anon_sym_then,
    STATE(2519), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2819), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2815), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [142078] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2520), 1,
      sym_comment,
    ACTIONS(2687), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2685), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [142107] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2983), 1,
      anon_sym_COMMA,
    STATE(2521), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [142154] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2985), 1,
      anon_sym_COMMA,
    STATE(2522), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [142201] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2987), 1,
      anon_sym_COMMA,
    STATE(2523), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [142248] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2325), 1,
      anon_sym_or,
    ACTIONS(2327), 1,
      anon_sym_and,
    ACTIONS(2335), 1,
      anon_sym_SLASH,
    ACTIONS(2337), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2339), 1,
      anon_sym_CARET,
    ACTIONS(2341), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2989), 1,
      anon_sym_RPAREN,
    STATE(2524), 1,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2333), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2329), 4,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [142295] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2525), 1,
      sym_comment,
    ACTIONS(2691), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2689), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [142324] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2526), 1,
      sym_comment,
    ACTIONS(1331), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1333), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [142353] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2527), 1,
      sym_comment,
    ACTIONS(1335), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1337), 15,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON,
  [142382] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2805), 1,
      anon_sym_CARET,
    ACTIONS(2807), 1,
      anon_sym_COLON_COLON,
    STATE(2528), 1,
      sym_comment,
    ACTIONS(1339), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(1341), 13,
      sym_interp_brace_close,
      anon_sym_or,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [142415] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2529), 1,
      sym_comment,
    ACTIONS(2695), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(2693), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [142444] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2530), 1,
      sym_comment,
    ACTIONS(1235), 3,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(1233), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [142473] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2531), 1,
      sym_comment,
    ACTIONS(772), 2,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(700), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_end,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [142501] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2532), 1,
      sym_comment,
    ACTIONS(772), 2,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(700), 15,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [142529] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2533), 1,
      sym_comment,
    ACTIONS(772), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT_LBRACK,
    ACTIONS(700), 14,
      anon_sym_return,
      anon_sym_local,
      anon_sym_function,
      anon_sym_for,
      anon_sym_do,
      anon_sym_if,
      anon_sym_repeat,
      anon_sym_while,
      anon_sym_break,
      sym_continue_stmt,
      anon_sym_export,
      anon_sym_type,
      sym_name,
      anon_sym_AT,
  [142557] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(750), 1,
      anon_sym_COLON,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(2993), 1,
      anon_sym_COMMA,
    STATE(786), 1,
      sym__assign,
    STATE(2534), 1,
      sym_comment,
    STATE(2921), 1,
      aux_sym__varlist_repeat1,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(2995), 8,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
  [142594] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(807), 1,
      anon_sym_DOT,
    STATE(2535), 1,
      sym_comment,
    ACTIONS(809), 15,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [142621] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(827), 1,
      anon_sym_DOT,
    STATE(2536), 1,
      sym_comment,
    ACTIONS(829), 15,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [142648] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(750), 1,
      anon_sym_COLON,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(2993), 1,
      anon_sym_COMMA,
    STATE(803), 1,
      sym__assign,
    STATE(2537), 1,
      sym_comment,
    STATE(2921), 1,
      aux_sym__varlist_repeat1,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(2995), 8,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
  [142685] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(897), 1,
      anon_sym_DOT,
    STATE(2538), 1,
      sym_comment,
    ACTIONS(899), 15,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [142712] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(750), 1,
      anon_sym_COLON,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(2993), 1,
      anon_sym_COMMA,
    STATE(867), 1,
      sym__assign,
    STATE(2539), 1,
      sym_comment,
    STATE(2921), 1,
      aux_sym__varlist_repeat1,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(2995), 8,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
  [142749] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(819), 1,
      anon_sym_DOT,
    STATE(2540), 1,
      sym_comment,
    ACTIONS(821), 15,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [142776] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(811), 1,
      anon_sym_DOT,
    STATE(2541), 1,
      sym_comment,
    ACTIONS(813), 15,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [142803] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(815), 1,
      anon_sym_DOT,
    STATE(2542), 1,
      sym_comment,
    ACTIONS(817), 15,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [142830] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(750), 1,
      anon_sym_COLON,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(2993), 1,
      anon_sym_COMMA,
    STATE(950), 1,
      sym__assign,
    STATE(2543), 1,
      sym_comment,
    STATE(2921), 1,
      aux_sym__varlist_repeat1,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(2995), 8,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
  [142867] = 13,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(2997), 1,
      sym_name,
    ACTIONS(2999), 1,
      anon_sym_LBRACE,
    ACTIONS(3001), 1,
      anon_sym_RBRACE,
    ACTIONS(3003), 1,
      sym_number,
    STATE(2544), 1,
      sym_comment,
    STATE(2997), 1,
      sym_litfield,
    STATE(3056), 1,
      sym_literal,
    STATE(3463), 1,
      sym__litfieldlist,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2996), 4,
      sym_string,
      sym_boolean,
      sym_nil,
      sym_littable,
  [142911] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2545), 1,
      sym_comment,
    ACTIONS(3005), 7,
      anon_sym_function,
      anon_sym_if,
      anon_sym_not,
      anon_sym_true,
      anon_sym_false,
      anon_sym_nil,
      sym_name,
    ACTIONS(3007), 8,
      sym__string_start,
      sym_interp_start,
      anon_sym_DASH,
      anon_sym_POUND,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      sym_number,
  [142937] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(2997), 1,
      sym_name,
    ACTIONS(2999), 1,
      anon_sym_LBRACE,
    ACTIONS(3003), 1,
      sym_number,
    ACTIONS(3009), 1,
      anon_sym_RBRACE,
    STATE(2546), 1,
      sym_comment,
    STATE(3056), 1,
      sym_literal,
    STATE(3096), 1,
      sym_litfield,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2996), 4,
      sym_string,
      sym_boolean,
      sym_nil,
      sym_littable,
  [142978] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(2997), 1,
      sym_name,
    ACTIONS(2999), 1,
      anon_sym_LBRACE,
    ACTIONS(3003), 1,
      sym_number,
    ACTIONS(3011), 1,
      anon_sym_RBRACE,
    STATE(2547), 1,
      sym_comment,
    STATE(3056), 1,
      sym_literal,
    STATE(3096), 1,
      sym_litfield,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2996), 4,
      sym_string,
      sym_boolean,
      sym_nil,
      sym_littable,
  [143019] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3017), 1,
      sym_interp_end,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    STATE(2548), 1,
      sym_comment,
    STATE(2555), 1,
      aux_sym_string_interp_repeat1,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143059] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(2999), 1,
      anon_sym_LBRACE,
    ACTIONS(3003), 1,
      sym_number,
    ACTIONS(3027), 1,
      anon_sym_RPAREN,
    ACTIONS(3031), 1,
      anon_sym_nil,
    STATE(2549), 1,
      sym_comment,
    STATE(2998), 1,
      sym_literal,
    STATE(3471), 1,
      sym__litlist,
    ACTIONS(3029), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2996), 4,
      sym_string,
      sym_boolean,
      sym_nil,
      sym_littable,
  [143097] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3033), 1,
      sym_interp_end,
    STATE(2550), 1,
      sym_comment,
    STATE(2559), 1,
      aux_sym_string_interp_repeat1,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143137] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3035), 1,
      sym_interp_end,
    STATE(2551), 1,
      sym_comment,
    STATE(2556), 1,
      aux_sym_string_interp_repeat1,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143177] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3037), 1,
      sym_interp_end,
    STATE(2552), 1,
      sym_comment,
    STATE(2559), 1,
      aux_sym_string_interp_repeat1,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143217] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3039), 1,
      sym_interp_end,
    STATE(2553), 1,
      sym_comment,
    STATE(2558), 1,
      aux_sym_string_interp_repeat1,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143257] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3041), 1,
      sym_interp_end,
    STATE(2554), 1,
      sym_comment,
    STATE(2574), 1,
      aux_sym_string_interp_repeat1,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143297] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3043), 1,
      sym_interp_end,
    STATE(2555), 1,
      sym_comment,
    STATE(2559), 1,
      aux_sym_string_interp_repeat1,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143337] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3045), 1,
      sym_interp_end,
    STATE(2556), 1,
      sym_comment,
    STATE(2559), 1,
      aux_sym_string_interp_repeat1,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143377] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3047), 1,
      sym_interp_end,
    STATE(2557), 1,
      sym_comment,
    STATE(2559), 1,
      aux_sym_string_interp_repeat1,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143417] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3049), 1,
      sym_interp_end,
    STATE(2558), 1,
      sym_comment,
    STATE(2559), 1,
      aux_sym_string_interp_repeat1,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143457] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3051), 1,
      sym_interp_content,
    ACTIONS(3054), 1,
      sym_interp_brace_open,
    ACTIONS(3057), 1,
      sym_interp_end,
    ACTIONS(3059), 1,
      sym_simple_escape,
    ACTIONS(3062), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3065), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3068), 1,
      sym__hex_byte_escape_sequence,
    STATE(2559), 2,
      sym_comment,
      aux_sym_string_interp_repeat1,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143495] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3071), 1,
      sym_interp_end,
    STATE(2560), 1,
      sym_comment,
    STATE(2563), 1,
      aux_sym_string_interp_repeat1,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143535] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3073), 1,
      sym_interp_end,
    STATE(2561), 1,
      sym_comment,
    STATE(2567), 1,
      aux_sym_string_interp_repeat1,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143575] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3075), 1,
      sym_interp_end,
    STATE(2562), 1,
      sym_comment,
    STATE(2570), 1,
      aux_sym_string_interp_repeat1,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143615] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3077), 1,
      sym_interp_end,
    STATE(2559), 1,
      aux_sym_string_interp_repeat1,
    STATE(2563), 1,
      sym_comment,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143655] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1401), 1,
      anon_sym_nil,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(2997), 1,
      sym_name,
    ACTIONS(2999), 1,
      anon_sym_LBRACE,
    ACTIONS(3003), 1,
      sym_number,
    STATE(2564), 1,
      sym_comment,
    STATE(3056), 1,
      sym_literal,
    STATE(3096), 1,
      sym_litfield,
    ACTIONS(1399), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2996), 4,
      sym_string,
      sym_boolean,
      sym_nil,
      sym_littable,
  [143693] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3079), 1,
      sym_interp_end,
    STATE(2550), 1,
      aux_sym_string_interp_repeat1,
    STATE(2565), 1,
      sym_comment,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143733] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3081), 1,
      sym_interp_end,
    STATE(2559), 1,
      aux_sym_string_interp_repeat1,
    STATE(2566), 1,
      sym_comment,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143773] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3083), 1,
      sym_interp_end,
    STATE(2559), 1,
      aux_sym_string_interp_repeat1,
    STATE(2567), 1,
      sym_comment,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143813] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3085), 1,
      sym_interp_end,
    STATE(2568), 1,
      sym_comment,
    STATE(2571), 1,
      aux_sym_string_interp_repeat1,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143853] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3087), 1,
      sym_interp_end,
    STATE(2566), 1,
      aux_sym_string_interp_repeat1,
    STATE(2569), 1,
      sym_comment,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143893] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3089), 1,
      sym_interp_end,
    STATE(2559), 1,
      aux_sym_string_interp_repeat1,
    STATE(2570), 1,
      sym_comment,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143933] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3091), 1,
      sym_interp_end,
    STATE(2559), 1,
      aux_sym_string_interp_repeat1,
    STATE(2571), 1,
      sym_comment,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [143973] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3093), 1,
      sym_interp_end,
    STATE(2552), 1,
      aux_sym_string_interp_repeat1,
    STATE(2572), 1,
      sym_comment,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144013] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3095), 1,
      sym_interp_end,
    STATE(2557), 1,
      aux_sym_string_interp_repeat1,
    STATE(2573), 1,
      sym_comment,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144053] = 12,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3013), 1,
      sym_interp_content,
    ACTIONS(3015), 1,
      sym_interp_brace_open,
    ACTIONS(3019), 1,
      sym_simple_escape,
    ACTIONS(3021), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3023), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3025), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3097), 1,
      sym_interp_end,
    STATE(2559), 1,
      aux_sym_string_interp_repeat1,
    STATE(2574), 1,
      sym_comment,
    STATE(2721), 2,
      sym_interp_exp,
      sym__escape_sequence,
    STATE(2699), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144093] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3099), 1,
      anon_sym_LT,
    ACTIONS(3101), 1,
      anon_sym_DOT,
    ACTIONS(3103), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2575), 1,
      sym_comment,
    ACTIONS(931), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [144120] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2576), 1,
      sym_comment,
    ACTIONS(3105), 5,
      anon_sym_typeof,
      anon_sym_true,
      anon_sym_false,
      anon_sym_nil,
      sym_name,
    ACTIONS(3107), 7,
      sym__string_start,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
  [144143] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3111), 1,
      sym__string_end,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    STATE(2577), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144179] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3121), 1,
      sym__string_end,
    STATE(2578), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144215] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3123), 1,
      sym__string_end,
    STATE(2579), 1,
      sym_comment,
    STATE(2580), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144251] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3125), 1,
      sym__string_end,
    STATE(2580), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144287] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3127), 1,
      sym__string_end,
    STATE(2581), 1,
      sym_comment,
    STATE(2584), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144323] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3129), 1,
      sym__string_end,
    STATE(2582), 1,
      sym_comment,
    STATE(2583), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144359] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3131), 1,
      sym__string_end,
    STATE(2583), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144395] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3133), 1,
      sym__string_end,
    STATE(2584), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144431] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3135), 1,
      sym__string_end,
    STATE(2577), 1,
      aux_sym_string_repeat1,
    STATE(2585), 1,
      sym_comment,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144467] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3137), 1,
      sym__string_end,
    STATE(2586), 1,
      sym_comment,
    STATE(2587), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144503] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3139), 1,
      sym__string_end,
    STATE(2587), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144539] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3141), 1,
      sym__string_end,
    STATE(2588), 1,
      sym_comment,
    STATE(2589), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144575] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3143), 1,
      sym__string_end,
    STATE(2589), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144611] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(2999), 1,
      anon_sym_LBRACE,
    ACTIONS(3003), 1,
      sym_number,
    ACTIONS(3031), 1,
      anon_sym_nil,
    STATE(2590), 1,
      sym_comment,
    STATE(3095), 1,
      sym_literal,
    ACTIONS(3029), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2996), 4,
      sym_string,
      sym_boolean,
      sym_nil,
      sym_littable,
  [144643] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3145), 1,
      sym__string_end,
    STATE(2591), 1,
      sym_comment,
    STATE(2592), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144679] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3147), 1,
      sym__string_end,
    STATE(2592), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144715] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3149), 1,
      sym__string_end,
    STATE(2593), 1,
      sym_comment,
    STATE(2594), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144751] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3151), 1,
      sym__string_end,
    STATE(2594), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144787] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3153), 1,
      sym__string_end,
    STATE(2595), 1,
      sym_comment,
    STATE(2596), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144823] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3155), 1,
      sym__string_end,
    STATE(2596), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144859] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3157), 1,
      sym__string_end,
    STATE(2597), 1,
      sym_comment,
    STATE(2598), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144895] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3159), 1,
      sym__string_end,
    STATE(2598), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144931] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3161), 1,
      sym__string_end,
    STATE(2599), 1,
      sym_comment,
    STATE(2600), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [144967] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3163), 1,
      sym__string_end,
    STATE(2600), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145003] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3165), 1,
      sym__string_end,
    STATE(2601), 1,
      sym_comment,
    STATE(2602), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145039] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3167), 1,
      sym__string_end,
    STATE(2602), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145075] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3169), 1,
      sym__string_end,
    STATE(2603), 1,
      sym_comment,
    STATE(2604), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145111] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3171), 1,
      sym__string_end,
    STATE(2604), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145147] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3173), 1,
      sym__string_end,
    STATE(2605), 1,
      sym_comment,
    STATE(2606), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145183] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3175), 1,
      sym__string_end,
    STATE(2606), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145219] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3177), 1,
      sym__string_end,
    STATE(2607), 1,
      sym_comment,
    STATE(2608), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145255] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3179), 1,
      sym__string_end,
    STATE(2608), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145291] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3181), 1,
      sym__string_end,
    STATE(2609), 1,
      sym_comment,
    STATE(2610), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145327] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3183), 1,
      sym__string_end,
    STATE(2610), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145363] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3185), 1,
      sym__string_end,
    STATE(2611), 1,
      sym_comment,
    STATE(2612), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145399] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3187), 1,
      sym__string_end,
    STATE(2612), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145435] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3189), 1,
      sym__string_end,
    STATE(2613), 1,
      sym_comment,
    STATE(2614), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145471] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3191), 1,
      sym__string_end,
    STATE(2614), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145507] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3193), 1,
      sym__string_end,
    STATE(2578), 1,
      aux_sym_string_repeat1,
    STATE(2615), 1,
      sym_comment,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145543] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3195), 1,
      sym__string_end,
    STATE(2616), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145579] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3197), 1,
      sym__string_end,
    STATE(2617), 1,
      sym_comment,
    STATE(2618), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145615] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3199), 1,
      sym__string_end,
    STATE(2618), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145651] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3201), 1,
      sym__string_end,
    STATE(2619), 1,
      sym_comment,
    STATE(2620), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145687] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3203), 1,
      sym__string_end,
    STATE(2620), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145723] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3205), 1,
      sym__string_end,
    STATE(2621), 1,
      sym_comment,
    STATE(2622), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145759] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3207), 1,
      sym__string_end,
    STATE(2622), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145795] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3209), 1,
      sym__string_end,
    STATE(2623), 1,
      sym_comment,
    STATE(2624), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145831] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3211), 1,
      sym__string_end,
    STATE(2624), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145867] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3213), 1,
      sym__string_end,
    STATE(2625), 1,
      sym_comment,
    STATE(2626), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145903] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3215), 1,
      sym__string_end,
    STATE(2626), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145939] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3217), 1,
      sym__string_end,
    STATE(2627), 1,
      sym_comment,
    STATE(2628), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [145975] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3219), 1,
      sym__string_end,
    STATE(2628), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146011] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3221), 1,
      sym__string_end,
    STATE(2629), 1,
      sym_comment,
    STATE(2630), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146047] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3223), 1,
      sym__string_end,
    STATE(2630), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146083] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3225), 1,
      sym__string_end,
    STATE(2631), 1,
      sym_comment,
    STATE(2640), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146119] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3227), 1,
      sym__string_end,
    STATE(2632), 1,
      sym_comment,
    STATE(2637), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146155] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3229), 1,
      sym__string_end,
    STATE(2633), 1,
      sym_comment,
    STATE(2635), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146191] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3231), 1,
      sym__string_end,
    STATE(2634), 1,
      sym_comment,
    STATE(2636), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146227] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3233), 1,
      sym__string_end,
    STATE(2635), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146263] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3235), 1,
      sym__string_end,
    STATE(2636), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146299] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3237), 1,
      sym__string_end,
    STATE(2637), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146335] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3239), 1,
      sym__string_end,
    STATE(2638), 1,
      sym_comment,
    STATE(2647), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146371] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3241), 1,
      sym__string_end,
    STATE(2639), 1,
      sym_comment,
    STATE(2641), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146407] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3243), 1,
      sym__string_end,
    STATE(2640), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146443] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3245), 1,
      sym__string_end,
    STATE(2641), 1,
      sym_comment,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146479] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3247), 1,
      sym__string_content,
    ACTIONS(3250), 1,
      sym__string_end,
    ACTIONS(3252), 1,
      sym_simple_escape,
    ACTIONS(3255), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3258), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3261), 1,
      sym__hex_byte_escape_sequence,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2642), 2,
      sym_comment,
      aux_sym_string_repeat1,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146513] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3264), 1,
      sym__string_end,
    STATE(2643), 1,
      sym_comment,
    STATE(2646), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146549] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3266), 1,
      sym__string_end,
    STATE(2644), 1,
      sym_comment,
    STATE(2648), 1,
      aux_sym_string_repeat1,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146585] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3099), 1,
      anon_sym_LT,
    ACTIONS(3268), 1,
      anon_sym_DOT,
    STATE(2645), 1,
      sym_comment,
    ACTIONS(931), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [146609] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3270), 1,
      sym__string_end,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2646), 1,
      sym_comment,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146645] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3272), 1,
      sym__string_end,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2647), 1,
      sym_comment,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146681] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3274), 1,
      sym__string_end,
    STATE(2642), 1,
      aux_sym_string_repeat1,
    STATE(2648), 1,
      sym_comment,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146717] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(2999), 1,
      anon_sym_LBRACE,
    ACTIONS(3003), 1,
      sym_number,
    ACTIONS(3031), 1,
      anon_sym_nil,
    STATE(2649), 1,
      sym_comment,
    STATE(3099), 1,
      sym_literal,
    ACTIONS(3029), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2996), 4,
      sym_string,
      sym_boolean,
      sym_nil,
      sym_littable,
  [146749] = 11,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3109), 1,
      sym__string_content,
    ACTIONS(3113), 1,
      sym_simple_escape,
    ACTIONS(3115), 1,
      sym__unicode_escape_sequence,
    ACTIONS(3117), 1,
      sym__dec_byte_escape_sequence,
    ACTIONS(3119), 1,
      sym__hex_byte_escape_sequence,
    ACTIONS(3276), 1,
      sym__string_end,
    STATE(2616), 1,
      aux_sym_string_repeat1,
    STATE(2650), 1,
      sym_comment,
    STATE(2837), 1,
      sym__escape_sequence,
    STATE(2813), 3,
      sym_unicode_escape,
      sym_dec_byte_escape,
      sym_hex_byte_escape,
  [146785] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2651), 1,
      sym_comment,
    ACTIONS(3278), 5,
      anon_sym_typeof,
      anon_sym_true,
      anon_sym_false,
      anon_sym_nil,
      sym_name,
    ACTIONS(3280), 5,
      sym__string_start,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
  [146806] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2652), 1,
      sym_comment,
    ACTIONS(989), 10,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [146825] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2653), 1,
      sym_comment,
    ACTIONS(3282), 5,
      anon_sym_typeof,
      anon_sym_true,
      anon_sym_false,
      anon_sym_nil,
      sym_name,
    ACTIONS(3284), 5,
      sym__string_start,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
  [146846] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(2654), 1,
      sym_comment,
    ACTIONS(945), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [146867] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3286), 1,
      anon_sym_LT,
    STATE(2655), 1,
      sym_comment,
    ACTIONS(1035), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [146888] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2656), 1,
      sym_comment,
    ACTIONS(1045), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [146906] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2657), 1,
      sym_comment,
    ACTIONS(1057), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [146924] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2658), 1,
      sym_comment,
    ACTIONS(766), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [146942] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1395), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3288), 1,
      sym_name,
    ACTIONS(3290), 1,
      anon_sym_LPAREN,
    STATE(2659), 1,
      sym_comment,
    STATE(2660), 1,
      sym_genpack,
    STATE(2685), 1,
      sym_variadic,
    STATE(3063), 1,
      sym_typepack,
    STATE(2661), 3,
      sym__typepack_wrap,
      sym__typepack_vrd,
      sym__typepack_gen,
  [146972] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2660), 1,
      sym_comment,
    ACTIONS(997), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [146990] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2661), 1,
      sym_comment,
    ACTIONS(1019), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147008] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2662), 1,
      sym_comment,
    ACTIONS(770), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147026] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3292), 1,
      anon_sym_LT,
    ACTIONS(3294), 1,
      anon_sym_DOT,
    ACTIONS(3296), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2663), 1,
      sym_comment,
    ACTIONS(931), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147050] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3298), 1,
      anon_sym_AMP,
    ACTIONS(3300), 1,
      anon_sym_PIPE,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(2664), 1,
      sym_comment,
    ACTIONS(971), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [147074] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2665), 1,
      sym_comment,
    ACTIONS(981), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147092] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2666), 1,
      sym_comment,
    ACTIONS(985), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147110] = 10,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(3304), 1,
      sym_name,
    STATE(2223), 1,
      sym__tbl_seq,
    STATE(2667), 1,
      sym_comment,
    STATE(2748), 1,
      sym__prefixexp,
    STATE(2749), 1,
      sym__tbl_method,
    STATE(2827), 1,
      sym_var,
    STATE(3049), 1,
      sym_prefixexp,
    STATE(2691), 2,
      sym_exp_wrap,
      sym_call_stmt,
  [147142] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2668), 1,
      sym_comment,
    ACTIONS(993), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147160] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3298), 1,
      anon_sym_AMP,
    ACTIONS(3300), 1,
      anon_sym_PIPE,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(2669), 1,
      sym_comment,
    ACTIONS(1001), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [147184] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2670), 1,
      sym_comment,
    ACTIONS(1005), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147202] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3298), 1,
      anon_sym_AMP,
    ACTIONS(3300), 1,
      anon_sym_PIPE,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(2671), 1,
      sym_comment,
    ACTIONS(1015), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [147226] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2672), 1,
      sym_comment,
    ACTIONS(1015), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147244] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(3306), 1,
      sym_name,
    ACTIONS(3308), 1,
      anon_sym_RBRACE,
    STATE(2673), 1,
      sym_comment,
    STATE(2891), 1,
      sym_readwrite,
    STATE(2957), 1,
      sym__tbtype_kv,
    ACTIONS(3310), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
  [147274] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2674), 1,
      sym_comment,
    ACTIONS(1023), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147292] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2675), 1,
      sym_comment,
    ACTIONS(1031), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147310] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(2676), 1,
      sym_comment,
    ACTIONS(1041), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
  [147330] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3298), 1,
      anon_sym_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(2677), 1,
      sym_comment,
    ACTIONS(1041), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_PIPE,
  [147352] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3298), 1,
      anon_sym_AMP,
    ACTIONS(3300), 1,
      anon_sym_PIPE,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(2678), 1,
      sym_comment,
    ACTIONS(1045), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [147376] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(3306), 1,
      sym_name,
    ACTIONS(3312), 1,
      anon_sym_RBRACE,
    STATE(2679), 1,
      sym_comment,
    STATE(2891), 1,
      sym_readwrite,
    STATE(2957), 1,
      sym__tbtype_kv,
    ACTIONS(3310), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
  [147406] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2680), 1,
      sym_comment,
    ACTIONS(1049), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147424] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2681), 1,
      sym_comment,
    ACTIONS(1053), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147442] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2682), 1,
      sym_comment,
    ACTIONS(1061), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147460] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3298), 1,
      anon_sym_AMP,
    ACTIONS(3300), 1,
      anon_sym_PIPE,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(2683), 1,
      sym_comment,
    ACTIONS(1027), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [147484] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3099), 1,
      anon_sym_LT,
    ACTIONS(3101), 1,
      anon_sym_DOT,
    ACTIONS(3103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3314), 1,
      anon_sym_COLON,
    STATE(2684), 1,
      sym_comment,
    ACTIONS(931), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147510] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2685), 1,
      sym_comment,
    ACTIONS(1065), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147528] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2686), 1,
      sym_comment,
    ACTIONS(957), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147546] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2687), 1,
      sym_comment,
    ACTIONS(961), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147564] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(3306), 1,
      sym_name,
    STATE(2688), 1,
      sym_comment,
    STATE(2891), 1,
      sym_readwrite,
    STATE(2957), 1,
      sym__tbtype_kv,
    ACTIONS(3310), 2,
      anon_sym_read,
      anon_sym_write,
    STATE(3033), 2,
      sym_indexertype,
      sym_proptype,
  [147591] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3099), 1,
      anon_sym_LT,
    ACTIONS(3268), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_COLON,
    STATE(2689), 1,
      sym_comment,
    ACTIONS(931), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147614] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3292), 1,
      anon_sym_LT,
    ACTIONS(3316), 1,
      anon_sym_DOT,
    STATE(2690), 1,
      sym_comment,
    ACTIONS(931), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [147635] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(750), 1,
      anon_sym_COLON,
    ACTIONS(2121), 1,
      anon_sym_LBRACK,
    ACTIONS(2123), 1,
      anon_sym_DOT,
    STATE(2541), 1,
      sym__key_named,
    STATE(2542), 1,
      sym_key,
    STATE(2691), 1,
      sym_comment,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [147662] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2692), 1,
      sym_comment,
    STATE(2917), 1,
      sym_genpack,
    STATE(2945), 1,
      sym_genericdef,
    STATE(2947), 1,
      sym_genpackdef,
    STATE(2995), 1,
      sym_generic,
    STATE(3132), 1,
      sym__type_stmt_genlist,
    STATE(3249), 1,
      sym__type_stmt_packlist,
  [147690] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3322), 1,
      anon_sym_RPAREN,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2693), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3416), 1,
      sym_paramlist,
  [147718] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3326), 1,
      anon_sym_COLON,
    ACTIONS(3328), 1,
      anon_sym_LT,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    ACTIONS(3332), 1,
      anon_sym_DOT,
    STATE(1970), 1,
      sym__fn_body,
    STATE(2694), 1,
      sym_comment,
    STATE(2745), 1,
      sym__key_named,
    STATE(3034), 1,
      sym__tbl_fn_member,
  [147746] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3334), 1,
      anon_sym_RPAREN,
    STATE(2695), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3520), 1,
      sym_paramlist,
  [147774] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3336), 1,
      anon_sym_RPAREN,
    STATE(2696), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3681), 1,
      sym_paramlist,
  [147802] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3338), 1,
      anon_sym_RPAREN,
    STATE(2697), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3528), 1,
      sym_paramlist,
  [147830] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2698), 1,
      sym_comment,
    ACTIONS(3340), 7,
      sym_interp_content,
      sym_interp_brace_open,
      sym_interp_end,
      sym_simple_escape,
      sym__unicode_escape_sequence,
      sym__dec_byte_escape_sequence,
      sym__hex_byte_escape_sequence,
  [147846] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2699), 1,
      sym_comment,
    ACTIONS(3342), 7,
      sym_interp_content,
      sym_interp_brace_open,
      sym_interp_end,
      sym_simple_escape,
      sym__unicode_escape_sequence,
      sym__dec_byte_escape_sequence,
      sym__hex_byte_escape_sequence,
  [147862] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3344), 1,
      anon_sym_RPAREN,
    STATE(2700), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3423), 1,
      sym_paramlist,
  [147890] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3346), 1,
      anon_sym_RPAREN,
    STATE(2701), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3535), 1,
      sym_paramlist,
  [147918] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3326), 1,
      anon_sym_COLON,
    ACTIONS(3332), 1,
      anon_sym_DOT,
    ACTIONS(3348), 1,
      anon_sym_LT,
    ACTIONS(3350), 1,
      anon_sym_LPAREN,
    STATE(2235), 1,
      sym__fn_body,
    STATE(2702), 1,
      sym_comment,
    STATE(2745), 1,
      sym__key_named,
    STATE(2939), 1,
      sym__tbl_fn_member,
  [147946] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3352), 1,
      anon_sym_RPAREN,
    STATE(2703), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3430), 1,
      sym_paramlist,
  [147974] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3354), 1,
      anon_sym_RPAREN,
    STATE(2704), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3438), 1,
      sym_paramlist,
  [148002] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3356), 1,
      anon_sym_RPAREN,
    STATE(2705), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3542), 1,
      sym_paramlist,
  [148030] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3326), 1,
      anon_sym_COLON,
    ACTIONS(3332), 1,
      anon_sym_DOT,
    ACTIONS(3358), 1,
      anon_sym_LT,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    STATE(2476), 1,
      sym__fn_body,
    STATE(2706), 1,
      sym_comment,
    STATE(2745), 1,
      sym__key_named,
    STATE(3001), 1,
      sym__tbl_fn_member,
  [148058] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3326), 1,
      anon_sym_COLON,
    ACTIONS(3332), 1,
      anon_sym_DOT,
    ACTIONS(3348), 1,
      anon_sym_LT,
    ACTIONS(3350), 1,
      anon_sym_LPAREN,
    STATE(2252), 1,
      sym__fn_body,
    STATE(2707), 1,
      sym_comment,
    STATE(2745), 1,
      sym__key_named,
    STATE(2951), 1,
      sym__tbl_fn_member,
  [148086] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3362), 1,
      anon_sym_RPAREN,
    STATE(2708), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3547), 1,
      sym_paramlist,
  [148114] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3364), 1,
      anon_sym_RPAREN,
    STATE(2709), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3445), 1,
      sym_paramlist,
  [148142] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3366), 1,
      anon_sym_RPAREN,
    STATE(2710), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3513), 1,
      sym_paramlist,
  [148170] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2711), 1,
      sym_comment,
    ACTIONS(3368), 7,
      sym_interp_content,
      sym_interp_brace_open,
      sym_interp_end,
      sym_simple_escape,
      sym__unicode_escape_sequence,
      sym__dec_byte_escape_sequence,
      sym__hex_byte_escape_sequence,
  [148186] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3326), 1,
      anon_sym_COLON,
    ACTIONS(3328), 1,
      anon_sym_LT,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    ACTIONS(3332), 1,
      anon_sym_DOT,
    STATE(1937), 1,
      sym__fn_body,
    STATE(2712), 1,
      sym_comment,
    STATE(2745), 1,
      sym__key_named,
    STATE(3020), 1,
      sym__tbl_fn_member,
  [148214] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3370), 1,
      anon_sym_RPAREN,
    STATE(2713), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3554), 1,
      sym_paramlist,
  [148242] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_RPAREN,
    STATE(2714), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3453), 1,
      sym_paramlist,
  [148270] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3374), 1,
      anon_sym_RPAREN,
    STATE(2715), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3374), 1,
      sym_paramlist,
  [148298] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3376), 1,
      anon_sym_RPAREN,
    STATE(2716), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3505), 1,
      sym_paramlist,
  [148326] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3378), 1,
      anon_sym_RPAREN,
    STATE(2717), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3722), 1,
      sym_paramlist,
  [148354] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3380), 1,
      anon_sym_RPAREN,
    STATE(2718), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3559), 1,
      sym_paramlist,
  [148382] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3382), 1,
      anon_sym_RPAREN,
    STATE(2719), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3396), 1,
      sym_paramlist,
  [148410] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3384), 1,
      anon_sym_RPAREN,
    STATE(2720), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3566), 1,
      sym_paramlist,
  [148438] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2721), 1,
      sym_comment,
    ACTIONS(3386), 7,
      sym_interp_content,
      sym_interp_brace_open,
      sym_interp_end,
      sym_simple_escape,
      sym__unicode_escape_sequence,
      sym__dec_byte_escape_sequence,
      sym__hex_byte_escape_sequence,
  [148454] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3388), 1,
      anon_sym_RPAREN,
    STATE(2722), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3468), 1,
      sym_paramlist,
  [148482] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3390), 1,
      anon_sym_RPAREN,
    STATE(2723), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3571), 1,
      sym_paramlist,
  [148510] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3392), 1,
      anon_sym_RPAREN,
    STATE(2724), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3408), 1,
      sym_paramlist,
  [148538] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3394), 1,
      anon_sym_RPAREN,
    STATE(2725), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3578), 1,
      sym_paramlist,
  [148566] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3396), 1,
      anon_sym_RPAREN,
    STATE(2726), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3475), 1,
      sym_paramlist,
  [148594] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3398), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3483), 1,
      sym_paramlist,
  [148622] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2728), 1,
      sym_comment,
    ACTIONS(3400), 7,
      sym_interp_content,
      sym_interp_brace_open,
      sym_interp_end,
      sym_simple_escape,
      sym__unicode_escape_sequence,
      sym__dec_byte_escape_sequence,
      sym__hex_byte_escape_sequence,
  [148638] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3402), 1,
      anon_sym_RPAREN,
    STATE(2729), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3402), 1,
      sym_paramlist,
  [148666] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3326), 1,
      anon_sym_COLON,
    ACTIONS(3332), 1,
      anon_sym_DOT,
    ACTIONS(3404), 1,
      anon_sym_LT,
    ACTIONS(3406), 1,
      anon_sym_LPAREN,
    STATE(2339), 1,
      sym__fn_body,
    STATE(2730), 1,
      sym_comment,
    STATE(2745), 1,
      sym__key_named,
    STATE(2944), 1,
      sym__tbl_fn_member,
  [148694] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3408), 1,
      anon_sym_RPAREN,
    STATE(2731), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3328), 1,
      sym_paramlist,
  [148722] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3099), 1,
      anon_sym_LT,
    ACTIONS(3268), 1,
      anon_sym_DOT,
    ACTIONS(3410), 1,
      anon_sym_COLON,
    STATE(2732), 1,
      sym_comment,
    ACTIONS(931), 4,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [148744] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3412), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3490), 1,
      sym_paramlist,
  [148772] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3414), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3340), 1,
      sym_paramlist,
  [148800] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3416), 1,
      anon_sym_LT,
    STATE(2735), 1,
      sym_comment,
    ACTIONS(1035), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [148818] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(2736), 1,
      sym_comment,
    ACTIONS(945), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [148836] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3326), 1,
      anon_sym_COLON,
    ACTIONS(3332), 1,
      anon_sym_DOT,
    ACTIONS(3358), 1,
      anon_sym_LT,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    STATE(2320), 1,
      sym__fn_body,
    STATE(2737), 1,
      sym_comment,
    STATE(2745), 1,
      sym__key_named,
    STATE(2964), 1,
      sym__tbl_fn_member,
  [148864] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2738), 1,
      sym_comment,
    STATE(2917), 1,
      sym_genpack,
    STATE(2945), 1,
      sym_genericdef,
    STATE(2947), 1,
      sym_genpackdef,
    STATE(2995), 1,
      sym_generic,
    STATE(3249), 1,
      sym__type_stmt_packlist,
    STATE(3601), 1,
      sym__type_stmt_genlist,
  [148892] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3326), 1,
      anon_sym_COLON,
    ACTIONS(3332), 1,
      anon_sym_DOT,
    ACTIONS(3404), 1,
      anon_sym_LT,
    ACTIONS(3406), 1,
      anon_sym_LPAREN,
    STATE(2434), 1,
      sym__fn_body,
    STATE(2739), 1,
      sym_comment,
    STATE(2745), 1,
      sym__key_named,
    STATE(2979), 1,
      sym__tbl_fn_member,
  [148920] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2740), 1,
      sym_comment,
    STATE(2917), 1,
      sym_genpack,
    STATE(2945), 1,
      sym_genericdef,
    STATE(2947), 1,
      sym_genpackdef,
    STATE(2995), 1,
      sym_generic,
    STATE(3249), 1,
      sym__type_stmt_packlist,
    STATE(3613), 1,
      sym__type_stmt_genlist,
  [148948] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3418), 1,
      anon_sym_RPAREN,
    STATE(2741), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3362), 1,
      sym_paramlist,
  [148976] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2742), 1,
      sym_comment,
    STATE(2917), 1,
      sym_genpack,
    STATE(2945), 1,
      sym_genericdef,
    STATE(2947), 1,
      sym_genpackdef,
    STATE(2995), 1,
      sym_generic,
    STATE(3249), 1,
      sym__type_stmt_packlist,
    STATE(3625), 1,
      sym__type_stmt_genlist,
  [149004] = 9,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3420), 1,
      anon_sym_RPAREN,
    STATE(2743), 1,
      sym_comment,
    STATE(2925), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3214), 1,
      sym__param_vararg,
    STATE(3498), 1,
      sym_paramlist,
  [149032] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2744), 1,
      sym_comment,
    ACTIONS(3422), 7,
      sym_interp_content,
      sym_interp_brace_open,
      sym_interp_end,
      sym_simple_escape,
      sym__unicode_escape_sequence,
      sym__dec_byte_escape_sequence,
      sym__hex_byte_escape_sequence,
  [149048] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3326), 1,
      anon_sym_COLON,
    ACTIONS(3332), 1,
      anon_sym_DOT,
    STATE(3040), 1,
      sym__tbl_fn_member,
    ACTIONS(3424), 2,
      anon_sym_LT,
      anon_sym_LPAREN,
    STATE(2745), 2,
      sym__key_named,
      sym_comment,
  [149069] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1403), 1,
      sym__string_start,
    ACTIONS(2999), 1,
      anon_sym_LBRACE,
    ACTIONS(3426), 1,
      anon_sym_LPAREN,
    STATE(2746), 1,
      sym_comment,
    STATE(3117), 1,
      sym_parattr_param,
    STATE(3113), 2,
      sym_string,
      sym_littable,
  [149092] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3428), 1,
      anon_sym_LBRACE,
    ACTIONS(3430), 1,
      anon_sym_LPAREN,
    ACTIONS(3432), 1,
      sym__string_start,
    STATE(1713), 1,
      sym_arglist,
    STATE(2747), 1,
      sym_comment,
    STATE(1712), 2,
      sym_table,
      sym_string,
  [149115] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3434), 1,
      anon_sym_LBRACE,
    ACTIONS(3436), 1,
      anon_sym_LPAREN,
    ACTIONS(3438), 1,
      sym__string_start,
    STATE(2748), 1,
      sym_comment,
    STATE(2822), 1,
      sym_arglist,
    STATE(2821), 2,
      sym_table,
      sym_string,
  [149138] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3434), 1,
      anon_sym_LBRACE,
    ACTIONS(3436), 1,
      anon_sym_LPAREN,
    ACTIONS(3438), 1,
      sym__string_start,
    STATE(2749), 1,
      sym_comment,
    STATE(2832), 1,
      sym_arglist,
    STATE(2821), 2,
      sym_table,
      sym_string,
  [149161] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2750), 1,
      sym_comment,
    ACTIONS(1023), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [149176] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3428), 1,
      anon_sym_LBRACE,
    ACTIONS(3430), 1,
      anon_sym_LPAREN,
    ACTIONS(3432), 1,
      sym__string_start,
    STATE(1714), 1,
      sym_arglist,
    STATE(2751), 1,
      sym_comment,
    STATE(1712), 2,
      sym_table,
      sym_string,
  [149199] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(55), 1,
      anon_sym_else,
    ACTIONS(3440), 1,
      anon_sym_end,
    ACTIONS(3442), 1,
      anon_sym_elseif,
    STATE(2752), 1,
      sym_comment,
    STATE(2781), 1,
      aux_sym_if_stmt_repeat1,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(3508), 1,
      sym_else_clause,
  [149224] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3444), 1,
      anon_sym_AMP,
    ACTIONS(3446), 1,
      anon_sym_PIPE,
    ACTIONS(3448), 1,
      anon_sym_QMARK,
    STATE(2753), 1,
      sym_comment,
    ACTIONS(1001), 3,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
  [149245] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2754), 1,
      sym_comment,
    ACTIONS(825), 6,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
  [149260] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2755), 1,
      sym_comment,
    ACTIONS(766), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [149275] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2756), 1,
      sym_comment,
    ACTIONS(1031), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [149290] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1205), 1,
      anon_sym_else,
    ACTIONS(3450), 1,
      anon_sym_COMMA,
    STATE(2757), 2,
      sym_comment,
      aux_sym__explist_repeat1,
    ACTIONS(1207), 3,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_elseif,
  [149309] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3453), 1,
      anon_sym_LBRACE,
    ACTIONS(3455), 1,
      anon_sym_LPAREN,
    ACTIONS(3457), 1,
      sym__string_start,
    STATE(1314), 1,
      sym_arglist,
    STATE(2758), 1,
      sym_comment,
    STATE(1312), 2,
      sym_table,
      sym_string,
  [149332] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2759), 1,
      sym_comment,
    ACTIONS(3422), 6,
      sym__string_content,
      sym__string_end,
      sym_simple_escape,
      sym__unicode_escape_sequence,
      sym__dec_byte_escape_sequence,
      sym__hex_byte_escape_sequence,
  [149347] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(55), 1,
      anon_sym_else,
    ACTIONS(3442), 1,
      anon_sym_elseif,
    ACTIONS(3459), 1,
      anon_sym_end,
    STATE(2760), 1,
      sym_comment,
    STATE(2849), 1,
      aux_sym_if_stmt_repeat1,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(3512), 1,
      sym_else_clause,
  [149372] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2761), 1,
      sym_comment,
    STATE(2917), 1,
      sym_genpack,
    STATE(2947), 1,
      sym_genpackdef,
    STATE(2995), 1,
      sym_generic,
    STATE(3043), 1,
      sym_genericdef,
    STATE(3144), 1,
      sym__type_stmt_packlist,
  [149397] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2762), 1,
      sym_comment,
    ACTIONS(941), 6,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
  [149412] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2763), 1,
      sym_comment,
    ACTIONS(923), 6,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
  [149427] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2764), 1,
      sym_comment,
    ACTIONS(1005), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [149442] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(55), 1,
      anon_sym_else,
    ACTIONS(3442), 1,
      anon_sym_elseif,
    ACTIONS(3461), 1,
      anon_sym_end,
    STATE(2765), 1,
      sym_comment,
    STATE(2849), 1,
      aux_sym_if_stmt_repeat1,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(3538), 1,
      sym_else_clause,
  [149467] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(55), 1,
      anon_sym_else,
    ACTIONS(3442), 1,
      anon_sym_elseif,
    ACTIONS(3463), 1,
      anon_sym_end,
    STATE(2766), 1,
      sym_comment,
    STATE(2784), 1,
      aux_sym_if_stmt_repeat1,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(3691), 1,
      sym_else_clause,
  [149492] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(55), 1,
      anon_sym_else,
    ACTIONS(3442), 1,
      anon_sym_elseif,
    ACTIONS(3465), 1,
      anon_sym_end,
    STATE(2767), 1,
      sym_comment,
    STATE(2849), 1,
      aux_sym_if_stmt_repeat1,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(3431), 1,
      sym_else_clause,
  [149517] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3467), 1,
      anon_sym_LBRACE,
    ACTIONS(3469), 1,
      anon_sym_LPAREN,
    ACTIONS(3471), 1,
      sym__string_start,
    STATE(1143), 1,
      sym_arglist,
    STATE(2768), 1,
      sym_comment,
    STATE(1141), 2,
      sym_table,
      sym_string,
  [149540] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2769), 1,
      sym_comment,
    ACTIONS(770), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [149555] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3467), 1,
      anon_sym_LBRACE,
    ACTIONS(3469), 1,
      anon_sym_LPAREN,
    ACTIONS(3471), 1,
      sym__string_start,
    STATE(1145), 1,
      sym_arglist,
    STATE(2770), 1,
      sym_comment,
    STATE(1141), 2,
      sym_table,
      sym_string,
  [149578] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2771), 1,
      sym_comment,
    ACTIONS(1049), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [149593] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3473), 1,
      anon_sym_LBRACE,
    ACTIONS(3475), 1,
      anon_sym_LPAREN,
    ACTIONS(3477), 1,
      sym__string_start,
    STATE(1427), 1,
      sym_arglist,
    STATE(2772), 1,
      sym_comment,
    STATE(1426), 2,
      sym_table,
      sym_string,
  [149616] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_LPAREN,
    ACTIONS(3483), 1,
      sym__string_start,
    STATE(1321), 1,
      sym_arglist,
    STATE(2773), 1,
      sym_comment,
    STATE(1320), 2,
      sym_table,
      sym_string,
  [149639] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_LPAREN,
    ACTIONS(3483), 1,
      sym__string_start,
    STATE(1322), 1,
      sym_arglist,
    STATE(2774), 1,
      sym_comment,
    STATE(1320), 2,
      sym_table,
      sym_string,
  [149662] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3485), 1,
      anon_sym_LBRACE,
    ACTIONS(3487), 1,
      anon_sym_LPAREN,
    ACTIONS(3489), 1,
      sym__string_start,
    STATE(1221), 1,
      sym_arglist,
    STATE(2775), 1,
      sym_comment,
    STATE(1203), 2,
      sym_table,
      sym_string,
  [149685] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3491), 1,
      anon_sym_LBRACE,
    ACTIONS(3493), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      sym__string_start,
    STATE(1248), 1,
      sym_arglist,
    STATE(2776), 1,
      sym_comment,
    STATE(1245), 2,
      sym_table,
      sym_string,
  [149708] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2777), 1,
      sym_comment,
    ACTIONS(1053), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [149723] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3491), 1,
      anon_sym_LBRACE,
    ACTIONS(3493), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      sym__string_start,
    STATE(1250), 1,
      sym_arglist,
    STATE(2778), 1,
      sym_comment,
    STATE(1245), 2,
      sym_table,
      sym_string,
  [149746] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3485), 1,
      anon_sym_LBRACE,
    ACTIONS(3487), 1,
      anon_sym_LPAREN,
    ACTIONS(3489), 1,
      sym__string_start,
    STATE(1190), 1,
      sym_arglist,
    STATE(2779), 1,
      sym_comment,
    STATE(1203), 2,
      sym_table,
      sym_string,
  [149769] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3497), 1,
      anon_sym_LBRACE,
    ACTIONS(3499), 1,
      anon_sym_LPAREN,
    ACTIONS(3501), 1,
      sym__string_start,
    STATE(1441), 1,
      sym_arglist,
    STATE(2780), 1,
      sym_comment,
    STATE(1440), 2,
      sym_table,
      sym_string,
  [149792] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(55), 1,
      anon_sym_else,
    ACTIONS(3442), 1,
      anon_sym_elseif,
    ACTIONS(3503), 1,
      anon_sym_end,
    STATE(2781), 1,
      sym_comment,
    STATE(2849), 1,
      aux_sym_if_stmt_repeat1,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(3586), 1,
      sym_else_clause,
  [149817] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3505), 1,
      anon_sym_LBRACE,
    ACTIONS(3507), 1,
      anon_sym_LPAREN,
    ACTIONS(3509), 1,
      sym__string_start,
    STATE(340), 1,
      sym_arglist,
    STATE(2782), 1,
      sym_comment,
    STATE(339), 2,
      sym_table,
      sym_string,
  [149840] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3497), 1,
      anon_sym_LBRACE,
    ACTIONS(3499), 1,
      anon_sym_LPAREN,
    ACTIONS(3501), 1,
      sym__string_start,
    STATE(1444), 1,
      sym_arglist,
    STATE(2783), 1,
      sym_comment,
    STATE(1440), 2,
      sym_table,
      sym_string,
  [149863] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(55), 1,
      anon_sym_else,
    ACTIONS(3442), 1,
      anon_sym_elseif,
    ACTIONS(3511), 1,
      anon_sym_end,
    STATE(2784), 1,
      sym_comment,
    STATE(2849), 1,
      aux_sym_if_stmt_repeat1,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(3245), 1,
      sym_else_clause,
  [149888] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3513), 1,
      anon_sym_LBRACE,
    ACTIONS(3515), 1,
      anon_sym_LPAREN,
    ACTIONS(3517), 1,
      sym__string_start,
    STATE(1587), 1,
      sym_arglist,
    STATE(2785), 1,
      sym_comment,
    STATE(1586), 2,
      sym_table,
      sym_string,
  [149911] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3505), 1,
      anon_sym_LBRACE,
    ACTIONS(3507), 1,
      anon_sym_LPAREN,
    ACTIONS(3509), 1,
      sym__string_start,
    STATE(264), 1,
      sym_arglist,
    STATE(2786), 1,
      sym_comment,
    STATE(339), 2,
      sym_table,
      sym_string,
  [149934] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(3519), 1,
      anon_sym_local,
    ACTIONS(3521), 1,
      anon_sym_function,
    STATE(2787), 1,
      sym_comment,
    STATE(2841), 1,
      aux_sym__attrlist,
    STATE(2882), 1,
      sym_attribute,
  [149959] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3473), 1,
      anon_sym_LBRACE,
    ACTIONS(3475), 1,
      anon_sym_LPAREN,
    ACTIONS(3477), 1,
      sym__string_start,
    STATE(1429), 1,
      sym_arglist,
    STATE(2788), 1,
      sym_comment,
    STATE(1426), 2,
      sym_table,
      sym_string,
  [149982] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2789), 1,
      sym_comment,
    ACTIONS(3340), 6,
      sym__string_content,
      sym__string_end,
      sym_simple_escape,
      sym__unicode_escape_sequence,
      sym__dec_byte_escape_sequence,
      sym__hex_byte_escape_sequence,
  [149997] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2790), 1,
      sym_comment,
    ACTIONS(1057), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [150012] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2791), 1,
      sym_comment,
    ACTIONS(957), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [150027] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2792), 1,
      sym_comment,
    ACTIONS(961), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [150042] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3523), 1,
      anon_sym_LBRACE,
    ACTIONS(3525), 1,
      anon_sym_LPAREN,
    ACTIONS(3527), 1,
      sym__string_start,
    STATE(1164), 1,
      sym_arglist,
    STATE(2793), 1,
      sym_comment,
    STATE(1165), 2,
      sym_table,
      sym_string,
  [150065] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3523), 1,
      anon_sym_LBRACE,
    ACTIONS(3525), 1,
      anon_sym_LPAREN,
    ACTIONS(3527), 1,
      sym__string_start,
    STATE(1172), 1,
      sym_arglist,
    STATE(2794), 1,
      sym_comment,
    STATE(1165), 2,
      sym_table,
      sym_string,
  [150088] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3448), 1,
      anon_sym_QMARK,
    STATE(2795), 1,
      sym_comment,
    ACTIONS(1041), 5,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
  [150105] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3529), 1,
      anon_sym_LBRACE,
    ACTIONS(3531), 1,
      anon_sym_LPAREN,
    ACTIONS(3533), 1,
      sym__string_start,
    STATE(292), 1,
      sym_arglist,
    STATE(2796), 1,
      sym_comment,
    STATE(263), 2,
      sym_table,
      sym_string,
  [150128] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3529), 1,
      anon_sym_LBRACE,
    ACTIONS(3531), 1,
      anon_sym_LPAREN,
    ACTIONS(3533), 1,
      sym__string_start,
    STATE(297), 1,
      sym_arglist,
    STATE(2797), 1,
      sym_comment,
    STATE(263), 2,
      sym_table,
      sym_string,
  [150151] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3444), 1,
      anon_sym_AMP,
    ACTIONS(3446), 1,
      anon_sym_PIPE,
    ACTIONS(3448), 1,
      anon_sym_QMARK,
    STATE(2798), 1,
      sym_comment,
    ACTIONS(1015), 3,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
  [150172] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3444), 1,
      anon_sym_AMP,
    ACTIONS(3448), 1,
      anon_sym_QMARK,
    STATE(2799), 1,
      sym_comment,
    ACTIONS(1041), 4,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [150191] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3444), 1,
      anon_sym_AMP,
    ACTIONS(3446), 1,
      anon_sym_PIPE,
    ACTIONS(3448), 1,
      anon_sym_QMARK,
    STATE(2800), 1,
      sym_comment,
    ACTIONS(971), 3,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
  [150212] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(55), 1,
      anon_sym_else,
    ACTIONS(3442), 1,
      anon_sym_elseif,
    ACTIONS(3535), 1,
      anon_sym_end,
    STATE(2801), 1,
      sym_comment,
    STATE(2810), 1,
      aux_sym_if_stmt_repeat1,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(3226), 1,
      sym_else_clause,
  [150237] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3444), 1,
      anon_sym_AMP,
    ACTIONS(3446), 1,
      anon_sym_PIPE,
    ACTIONS(3448), 1,
      anon_sym_QMARK,
    STATE(2802), 1,
      sym_comment,
    ACTIONS(1045), 3,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
  [150258] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2803), 1,
      sym_comment,
    ACTIONS(1045), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [150273] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(55), 1,
      anon_sym_else,
    ACTIONS(3442), 1,
      anon_sym_elseif,
    ACTIONS(3537), 1,
      anon_sym_end,
    STATE(2804), 1,
      sym_comment,
    STATE(2849), 1,
      aux_sym_if_stmt_repeat1,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(3236), 1,
      sym_else_clause,
  [150298] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2805), 1,
      sym_comment,
    ACTIONS(766), 6,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
  [150313] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3539), 1,
      anon_sym_LBRACE,
    ACTIONS(3541), 1,
      anon_sym_LPAREN,
    ACTIONS(3543), 1,
      sym__string_start,
    STATE(1616), 1,
      sym_arglist,
    STATE(2806), 1,
      sym_comment,
    STATE(1615), 2,
      sym_table,
      sym_string,
  [150336] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2807), 1,
      sym_comment,
    ACTIONS(981), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [150351] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2808), 1,
      sym_comment,
    ACTIONS(989), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [150366] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2809), 1,
      sym_comment,
    ACTIONS(985), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [150381] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(55), 1,
      anon_sym_else,
    ACTIONS(3442), 1,
      anon_sym_elseif,
    ACTIONS(3545), 1,
      anon_sym_end,
    STATE(2810), 1,
      sym_comment,
    STATE(2849), 1,
      aux_sym_if_stmt_repeat1,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(3279), 1,
      sym_else_clause,
  [150406] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2811), 1,
      sym_comment,
    ACTIONS(1065), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [150421] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2812), 1,
      sym_comment,
    STATE(2917), 1,
      sym_genpack,
    STATE(2947), 1,
      sym_genpackdef,
    STATE(2995), 1,
      sym_generic,
    STATE(3043), 1,
      sym_genericdef,
    STATE(3435), 1,
      sym__type_stmt_packlist,
  [150446] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2813), 1,
      sym_comment,
    ACTIONS(3342), 6,
      sym__string_content,
      sym__string_end,
      sym_simple_escape,
      sym__unicode_escape_sequence,
      sym__dec_byte_escape_sequence,
      sym__hex_byte_escape_sequence,
  [150461] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2814), 1,
      sym_comment,
    ACTIONS(997), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [150476] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(55), 1,
      anon_sym_else,
    ACTIONS(3442), 1,
      anon_sym_elseif,
    ACTIONS(3547), 1,
      anon_sym_end,
    STATE(2815), 1,
      sym_comment,
    STATE(2849), 1,
      aux_sym_if_stmt_repeat1,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(3391), 1,
      sym_else_clause,
  [150501] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(3549), 1,
      anon_sym_local,
    ACTIONS(3551), 1,
      anon_sym_function,
    STATE(2816), 1,
      sym_comment,
    STATE(2841), 1,
      aux_sym__attrlist,
    STATE(2882), 1,
      sym_attribute,
  [150526] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(55), 1,
      anon_sym_else,
    ACTIONS(3442), 1,
      anon_sym_elseif,
    ACTIONS(3553), 1,
      anon_sym_end,
    STATE(2815), 1,
      aux_sym_if_stmt_repeat1,
    STATE(2817), 1,
      sym_comment,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(3367), 1,
      sym_else_clause,
  [150551] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3555), 1,
      anon_sym_LBRACE,
    ACTIONS(3557), 1,
      anon_sym_LPAREN,
    ACTIONS(3559), 1,
      sym__string_start,
    STATE(265), 1,
      sym_arglist,
    STATE(2818), 1,
      sym_comment,
    STATE(320), 2,
      sym_table,
      sym_string,
  [150574] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3555), 1,
      anon_sym_LBRACE,
    ACTIONS(3557), 1,
      anon_sym_LPAREN,
    ACTIONS(3559), 1,
      sym__string_start,
    STATE(267), 1,
      sym_arglist,
    STATE(2819), 1,
      sym_comment,
    STATE(320), 2,
      sym_table,
      sym_string,
  [150597] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(3561), 1,
      anon_sym_local,
    ACTIONS(3563), 1,
      anon_sym_function,
    STATE(2820), 1,
      sym_comment,
    STATE(2841), 1,
      aux_sym__attrlist,
    STATE(2882), 1,
      sym_attribute,
  [150622] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2821), 1,
      sym_comment,
    ACTIONS(911), 6,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
  [150637] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2822), 1,
      sym_comment,
    ACTIONS(915), 6,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
  [150652] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2823), 1,
      sym_comment,
    ACTIONS(762), 6,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
  [150667] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3565), 1,
      anon_sym_LBRACE,
    ACTIONS(3567), 1,
      anon_sym_LPAREN,
    ACTIONS(3569), 1,
      sym__string_start,
    STATE(1394), 1,
      sym_arglist,
    STATE(2824), 1,
      sym_comment,
    STATE(1393), 2,
      sym_table,
      sym_string,
  [150690] = 8,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(35), 1,
      anon_sym_AT,
    ACTIONS(37), 1,
      anon_sym_AT_LBRACK,
    ACTIONS(3571), 1,
      anon_sym_local,
    ACTIONS(3573), 1,
      anon_sym_function,
    STATE(2825), 1,
      sym_comment,
    STATE(2841), 1,
      aux_sym__attrlist,
    STATE(2882), 1,
      sym_attribute,
  [150715] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3565), 1,
      anon_sym_LBRACE,
    ACTIONS(3567), 1,
      anon_sym_LPAREN,
    ACTIONS(3569), 1,
      sym__string_start,
    STATE(1395), 1,
      sym_arglist,
    STATE(2826), 1,
      sym_comment,
    STATE(1393), 2,
      sym_table,
      sym_string,
  [150738] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(750), 1,
      anon_sym_COLON,
    STATE(2827), 1,
      sym_comment,
    ACTIONS(3575), 2,
      anon_sym_EQ,
      anon_sym_COMMA,
    ACTIONS(752), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [150757] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2828), 1,
      sym_comment,
    ACTIONS(770), 6,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
  [150772] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2829), 1,
      sym_comment,
    ACTIONS(3368), 6,
      sym__string_content,
      sym__string_end,
      sym_simple_escape,
      sym__unicode_escape_sequence,
      sym__dec_byte_escape_sequence,
      sym__hex_byte_escape_sequence,
  [150787] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2830), 1,
      sym_comment,
    ACTIONS(927), 6,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
  [150802] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2831), 1,
      sym_comment,
    ACTIONS(1061), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [150817] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2832), 1,
      sym_comment,
    ACTIONS(919), 6,
      sym__string_start,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
  [150832] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3513), 1,
      anon_sym_LBRACE,
    ACTIONS(3515), 1,
      anon_sym_LPAREN,
    ACTIONS(3517), 1,
      sym__string_start,
    STATE(1595), 1,
      sym_arglist,
    STATE(2833), 1,
      sym_comment,
    STATE(1586), 2,
      sym_table,
      sym_string,
  [150855] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3577), 1,
      anon_sym_LBRACE,
    ACTIONS(3579), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      sym__string_start,
    STATE(253), 1,
      sym_arglist,
    STATE(2834), 1,
      sym_comment,
    STATE(252), 2,
      sym_table,
      sym_string,
  [150878] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3577), 1,
      anon_sym_LBRACE,
    ACTIONS(3579), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      sym__string_start,
    STATE(254), 1,
      sym_arglist,
    STATE(2835), 1,
      sym_comment,
    STATE(252), 2,
      sym_table,
      sym_string,
  [150901] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2836), 1,
      sym_comment,
    ACTIONS(1015), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [150916] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2837), 1,
      sym_comment,
    ACTIONS(3583), 6,
      sym__string_content,
      sym__string_end,
      sym_simple_escape,
      sym__unicode_escape_sequence,
      sym__dec_byte_escape_sequence,
      sym__hex_byte_escape_sequence,
  [150931] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2838), 1,
      sym_comment,
    ACTIONS(1019), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [150946] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3444), 1,
      anon_sym_AMP,
    ACTIONS(3446), 1,
      anon_sym_PIPE,
    ACTIONS(3448), 1,
      anon_sym_QMARK,
    STATE(2839), 1,
      sym_comment,
    ACTIONS(1027), 3,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
  [150967] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3539), 1,
      anon_sym_LBRACE,
    ACTIONS(3541), 1,
      anon_sym_LPAREN,
    ACTIONS(3543), 1,
      sym__string_start,
    STATE(1618), 1,
      sym_arglist,
    STATE(2840), 1,
      sym_comment,
    STATE(1615), 2,
      sym_table,
      sym_string,
  [150990] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3587), 1,
      anon_sym_AT,
    ACTIONS(3590), 1,
      anon_sym_AT_LBRACK,
    STATE(2882), 1,
      sym_attribute,
    ACTIONS(3585), 2,
      anon_sym_local,
      anon_sym_function,
    STATE(2841), 2,
      aux_sym__attrlist,
      sym_comment,
  [151011] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2369), 1,
      anon_sym_COMMA,
    ACTIONS(2428), 1,
      anon_sym_else,
    STATE(2757), 1,
      aux_sym__explist_repeat1,
    STATE(2842), 1,
      sym_comment,
    ACTIONS(2430), 3,
      anon_sym_SEMI,
      anon_sym_end,
      anon_sym_elseif,
  [151032] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2843), 1,
      sym_comment,
    ACTIONS(993), 6,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [151047] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3453), 1,
      anon_sym_LBRACE,
    ACTIONS(3455), 1,
      anon_sym_LPAREN,
    ACTIONS(3457), 1,
      sym__string_start,
    STATE(1313), 1,
      sym_arglist,
    STATE(2844), 1,
      sym_comment,
    STATE(1312), 2,
      sym_table,
      sym_string,
  [151070] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2845), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3546), 1,
      sym__genpack_list,
    STATE(3698), 1,
      sym__genlist,
  [151092] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2435), 1,
      anon_sym_COMMA,
    STATE(2846), 1,
      sym_comment,
    STATE(2852), 1,
      aux_sym__explist_repeat1,
    ACTIONS(2430), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [151110] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2847), 1,
      sym_comment,
    STATE(3087), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3338), 1,
      sym__param_vararg,
  [151132] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2848), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3546), 1,
      sym__genpack_list,
    STATE(3581), 1,
      sym__genlist,
  [151154] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3593), 1,
      anon_sym_end,
    ACTIONS(3595), 1,
      anon_sym_elseif,
    ACTIONS(3598), 1,
      anon_sym_else,
    STATE(2955), 1,
      sym_elseif_clause,
    STATE(2849), 2,
      sym_comment,
      aux_sym_if_stmt_repeat1,
  [151174] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2850), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3489), 1,
      sym__genlist,
    STATE(3546), 1,
      sym__genpack_list,
  [151196] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3324), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2851), 1,
      sym_comment,
    STATE(3087), 1,
      sym_param,
    STATE(3089), 1,
      sym_vararg,
    STATE(3137), 1,
      sym__param_vararg,
  [151218] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3600), 1,
      anon_sym_COMMA,
    STATE(2852), 2,
      sym_comment,
      aux_sym__explist_repeat1,
    ACTIONS(1207), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [151234] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2853), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3546), 1,
      sym__genpack_list,
    STATE(3664), 1,
      sym__genlist,
  [151256] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2854), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3546), 1,
      sym__genpack_list,
    STATE(3670), 1,
      sym__genlist,
  [151278] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2855), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3546), 1,
      sym__genpack_list,
    STATE(3676), 1,
      sym__genlist,
  [151300] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2856), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3546), 1,
      sym__genpack_list,
    STATE(3680), 1,
      sym__genlist,
  [151322] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2857), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3546), 1,
      sym__genpack_list,
    STATE(3682), 1,
      sym__genlist,
  [151344] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2858), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3546), 1,
      sym__genpack_list,
    STATE(3684), 1,
      sym__genlist,
  [151366] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2859), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3546), 1,
      sym__genpack_list,
    STATE(3686), 1,
      sym__genlist,
  [151388] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2860), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3546), 1,
      sym__genpack_list,
    STATE(3688), 1,
      sym__genlist,
  [151410] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2861), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3546), 1,
      sym__genpack_list,
    STATE(3690), 1,
      sym__genlist,
  [151432] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2862), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3546), 1,
      sym__genpack_list,
    STATE(3692), 1,
      sym__genlist,
  [151454] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2863), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3546), 1,
      sym__genpack_list,
    STATE(3694), 1,
      sym__genlist,
  [151476] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2864), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3546), 1,
      sym__genpack_list,
    STATE(3695), 1,
      sym__genlist,
  [151498] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2865), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3546), 1,
      sym__genpack_list,
    STATE(3696), 1,
      sym__genlist,
  [151520] = 7,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2866), 1,
      sym_comment,
    STATE(3002), 1,
      sym_generic,
    STATE(3014), 1,
      sym_genpack,
    STATE(3546), 1,
      sym__genpack_list,
    STATE(3697), 1,
      sym__genlist,
  [151542] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(3603), 1,
      anon_sym_else,
    STATE(2867), 1,
      sym_comment,
    STATE(2899), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
  [151561] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3605), 1,
      sym_name,
    ACTIONS(3607), 1,
      anon_sym_function,
    STATE(1660), 1,
      sym_binding,
    STATE(1902), 1,
      sym_bindinglist,
    STATE(2868), 1,
      sym_comment,
  [151580] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2465), 1,
      anon_sym_COMMA,
    STATE(2869), 1,
      sym_comment,
    STATE(2887), 1,
      aux_sym__explist_repeat1,
    ACTIONS(2430), 2,
      anon_sym_SEMI,
      anon_sym_until,
  [151597] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(3609), 1,
      anon_sym_else,
    STATE(2870), 1,
      sym_comment,
    STATE(2899), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
  [151616] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(3611), 1,
      anon_sym_else,
    STATE(2871), 1,
      sym_comment,
    STATE(2899), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
  [151635] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(3613), 1,
      anon_sym_else,
    STATE(2872), 1,
      sym_comment,
    STATE(2899), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
  [151654] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3308), 1,
      anon_sym_RBRACE,
    STATE(2873), 1,
      sym_comment,
    STATE(2876), 1,
      aux_sym_kvtypelist_repeat1,
    ACTIONS(3615), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [151671] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2874), 1,
      sym_comment,
    ACTIONS(899), 4,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_LPAREN,
      anon_sym_DOT,
  [151684] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3617), 1,
      anon_sym_COMMA,
    ACTIONS(1207), 2,
      anon_sym_SEMI,
      anon_sym_end,
    STATE(2875), 2,
      sym_comment,
      aux_sym__explist_repeat1,
  [151699] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3623), 1,
      anon_sym_RBRACE,
    ACTIONS(3620), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(2876), 2,
      sym_comment,
      aux_sym_kvtypelist_repeat1,
  [151714] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(3625), 1,
      anon_sym_else,
    STATE(2877), 1,
      sym_comment,
    STATE(2899), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
  [151733] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(3627), 1,
      anon_sym_else,
    STATE(2878), 1,
      sym_comment,
    STATE(2899), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
  [151752] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3632), 1,
      anon_sym_RBRACE,
    ACTIONS(3629), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(2879), 2,
      sym_comment,
      aux_sym__fieldlist_repeat1,
  [151767] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2880), 1,
      sym_comment,
    STATE(3014), 1,
      sym_genpack,
    STATE(3106), 1,
      sym_generic,
    STATE(3174), 1,
      sym__genpack_list,
  [151786] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(3634), 1,
      anon_sym_else,
    STATE(2881), 1,
      sym_comment,
    STATE(2899), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
  [151805] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3638), 1,
      anon_sym_AT,
    STATE(2882), 1,
      sym_comment,
    ACTIONS(3636), 3,
      anon_sym_local,
      anon_sym_function,
      anon_sym_AT_LBRACK,
  [151820] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2883), 1,
      sym_comment,
    ACTIONS(3640), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [151833] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3644), 1,
      anon_sym_RBRACE,
    STATE(2873), 1,
      aux_sym_kvtypelist_repeat1,
    STATE(2884), 1,
      sym_comment,
    ACTIONS(3642), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [151850] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3103), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2885), 1,
      sym_comment,
    ACTIONS(3646), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [151865] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(3648), 1,
      anon_sym_else,
    STATE(2886), 1,
      sym_comment,
    STATE(2899), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
  [151884] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3650), 1,
      anon_sym_COMMA,
    ACTIONS(1207), 2,
      anon_sym_SEMI,
      anon_sym_until,
    STATE(2887), 2,
      sym_comment,
      aux_sym__explist_repeat1,
  [151899] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(3653), 1,
      anon_sym_else,
    STATE(2888), 1,
      sym_comment,
    STATE(2899), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
  [151918] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3657), 1,
      anon_sym_RBRACE,
    STATE(2889), 1,
      sym_comment,
    STATE(2898), 1,
      aux_sym__fieldlist_repeat1,
    ACTIONS(3655), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [151935] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3659), 1,
      sym_name,
    ACTIONS(3661), 1,
      anon_sym_function,
    STATE(1861), 1,
      sym_binding,
    STATE(2180), 1,
      sym_bindinglist,
    STATE(2890), 1,
      sym_comment,
  [151954] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1409), 1,
      anon_sym_LBRACK,
    ACTIONS(3663), 1,
      sym_name,
    STATE(2891), 1,
      sym_comment,
    STATE(2929), 2,
      sym_indexertype,
      sym_proptype,
  [151971] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3665), 1,
      anon_sym_COLON,
    STATE(2892), 1,
      sym_comment,
    ACTIONS(2413), 3,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
  [151986] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2399), 1,
      anon_sym_in,
    ACTIONS(3667), 1,
      anon_sym_EQ,
    ACTIONS(3669), 1,
      anon_sym_COMMA,
    STATE(2893), 1,
      sym_comment,
    STATE(3012), 1,
      aux_sym_bindinglist_repeat1,
  [152005] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(3671), 1,
      anon_sym_else,
    STATE(2894), 1,
      sym_comment,
    STATE(2899), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
  [152024] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2556), 1,
      anon_sym_COMMA,
    STATE(2875), 1,
      aux_sym__explist_repeat1,
    STATE(2895), 1,
      sym_comment,
    ACTIONS(2430), 2,
      anon_sym_SEMI,
      anon_sym_end,
  [152041] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2896), 1,
      sym_comment,
    ACTIONS(3673), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [152054] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(3675), 1,
      anon_sym_else,
    STATE(2897), 1,
      sym_comment,
    STATE(2899), 1,
      aux_sym_ifexp_repeat1,
    STATE(3104), 1,
      sym__ifexp_elseif,
  [152073] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1187), 1,
      anon_sym_RBRACE,
    STATE(2879), 1,
      aux_sym__fieldlist_repeat1,
    STATE(2898), 1,
      sym_comment,
    ACTIONS(3677), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [152090] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3679), 1,
      anon_sym_elseif,
    ACTIONS(3682), 1,
      anon_sym_else,
    STATE(3104), 1,
      sym__ifexp_elseif,
    STATE(2899), 2,
      sym_comment,
      aux_sym_ifexp_repeat1,
  [152107] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2487), 1,
      anon_sym_elseif,
    ACTIONS(3684), 1,
      anon_sym_else,
    STATE(2899), 1,
      aux_sym_ifexp_repeat1,
    STATE(2900), 1,
      sym_comment,
    STATE(3104), 1,
      sym__ifexp_elseif,
  [152126] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3686), 1,
      anon_sym_SEMI,
    ACTIONS(3690), 1,
      anon_sym_else,
    STATE(2901), 1,
      sym_comment,
    ACTIONS(3688), 2,
      anon_sym_end,
      anon_sym_elseif,
  [152143] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3694), 1,
      anon_sym_AT,
    STATE(2902), 1,
      sym_comment,
    ACTIONS(3692), 3,
      anon_sym_local,
      anon_sym_function,
      anon_sym_AT_LBRACK,
  [152158] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3318), 1,
      sym_name,
    STATE(2903), 1,
      sym_comment,
    STATE(3014), 1,
      sym_genpack,
    STATE(3106), 1,
      sym_generic,
    STATE(3624), 1,
      sym__genpack_list,
  [152177] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3696), 1,
      sym_name,
    ACTIONS(3698), 1,
      anon_sym_function,
    STATE(1910), 1,
      sym_binding,
    STATE(2183), 1,
      sym_bindinglist,
    STATE(2904), 1,
      sym_comment,
  [152196] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3700), 1,
      sym_name,
    ACTIONS(3702), 1,
      anon_sym_function,
    STATE(1878), 1,
      sym_binding,
    STATE(2152), 1,
      sym_bindinglist,
    STATE(2905), 1,
      sym_comment,
  [152215] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2399), 1,
      anon_sym_in,
    ACTIONS(3669), 1,
      anon_sym_COMMA,
    ACTIONS(3704), 1,
      anon_sym_EQ,
    STATE(2906), 1,
      sym_comment,
    STATE(3012), 1,
      aux_sym_bindinglist_repeat1,
  [152234] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2399), 1,
      anon_sym_in,
    ACTIONS(3669), 1,
      anon_sym_COMMA,
    ACTIONS(3706), 1,
      anon_sym_EQ,
    STATE(2907), 1,
      sym_comment,
    STATE(3012), 1,
      aux_sym_bindinglist_repeat1,
  [152253] = 6,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2399), 1,
      anon_sym_in,
    ACTIONS(3669), 1,
      anon_sym_COMMA,
    ACTIONS(3708), 1,
      anon_sym_EQ,
    STATE(2908), 1,
      sym_comment,
    STATE(3012), 1,
      aux_sym_bindinglist_repeat1,
  [152272] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3712), 1,
      anon_sym_AT,
    STATE(2909), 1,
      sym_comment,
    ACTIONS(3710), 3,
      anon_sym_local,
      anon_sym_function,
      anon_sym_AT_LBRACK,
  [152287] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2423), 1,
      anon_sym_in,
    ACTIONS(3714), 1,
      anon_sym_COMMA,
    STATE(2910), 2,
      sym_comment,
      aux_sym_bindinglist_repeat1,
  [152301] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(3720), 1,
      anon_sym_RPAREN,
    STATE(2911), 1,
      sym_comment,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
  [152317] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3724), 1,
      anon_sym_LT,
    ACTIONS(3726), 1,
      anon_sym_LPAREN,
    STATE(1807), 1,
      sym__fn_body,
    STATE(2912), 1,
      sym_comment,
  [152333] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3328), 1,
      anon_sym_LT,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(2000), 1,
      sym__fn_body,
    STATE(2913), 1,
      sym_comment,
  [152349] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3728), 1,
      anon_sym_COMMA,
    ACTIONS(3730), 1,
      anon_sym_RPAREN,
    STATE(2914), 1,
      sym_comment,
    STATE(2938), 1,
      aux_sym__fntype_paramlist_repeat1,
  [152365] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3732), 1,
      anon_sym_COMMA,
    ACTIONS(3734), 1,
      anon_sym_RBRACK,
    STATE(2915), 1,
      sym_comment,
    STATE(2927), 1,
      aux_sym__parattrlist_repeat1,
  [152381] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2916), 1,
      sym_comment,
    ACTIONS(2453), 3,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_COMMA,
  [152393] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3736), 1,
      anon_sym_EQ,
    STATE(2917), 1,
      sym_comment,
    ACTIONS(3738), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [152407] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3740), 1,
      anon_sym_LT,
    ACTIONS(3742), 1,
      anon_sym_LPAREN,
    STATE(491), 1,
      sym__fn_body,
    STATE(2918), 1,
      sym_comment,
  [152423] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(3744), 1,
      anon_sym_RPAREN,
    STATE(2919), 1,
      sym_comment,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
  [152439] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3748), 1,
      anon_sym_LT,
    ACTIONS(3750), 1,
      anon_sym_LPAREN,
    STATE(2327), 1,
      sym__fn_body,
    STATE(2920), 1,
      sym_comment,
  [152455] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2993), 1,
      anon_sym_COMMA,
    ACTIONS(3752), 1,
      anon_sym_EQ,
    STATE(2921), 1,
      sym_comment,
    STATE(2985), 1,
      aux_sym__varlist_repeat1,
  [152471] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(3754), 1,
      anon_sym_RPAREN,
    STATE(2922), 1,
      sym_comment,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
  [152487] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(3758), 1,
      anon_sym_RPAREN,
    STATE(2923), 1,
      sym_comment,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
  [152503] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3009), 1,
      anon_sym_RBRACE,
    ACTIONS(3762), 1,
      anon_sym_COMMA,
    STATE(2924), 1,
      sym_comment,
    STATE(3024), 1,
      aux_sym__litfieldlist_repeat1,
  [152519] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3764), 1,
      anon_sym_COMMA,
    ACTIONS(3766), 1,
      anon_sym_RPAREN,
    STATE(2925), 1,
      sym_comment,
    STATE(3007), 1,
      aux_sym_paramlist_repeat1,
  [152535] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3768), 1,
      anon_sym_LT,
    ACTIONS(3770), 1,
      anon_sym_LPAREN,
    STATE(2023), 1,
      sym__fn_body,
    STATE(2926), 1,
      sym_comment,
  [152551] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3732), 1,
      anon_sym_COMMA,
    ACTIONS(3772), 1,
      anon_sym_RBRACK,
    STATE(2927), 1,
      sym_comment,
    STATE(2999), 1,
      aux_sym__parattrlist_repeat1,
  [152567] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3774), 1,
      sym_name,
    ACTIONS(3776), 1,
      anon_sym_function,
    STATE(2344), 1,
      sym__type_assign,
    STATE(2928), 1,
      sym_comment,
  [152583] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2929), 1,
      sym_comment,
    ACTIONS(3778), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [152595] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3780), 1,
      anon_sym_LT,
    ACTIONS(3782), 1,
      anon_sym_LPAREN,
    STATE(2133), 1,
      sym__fn_body,
    STATE(2930), 1,
      sym_comment,
  [152611] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(3784), 1,
      anon_sym_RPAREN,
    STATE(2931), 1,
      sym_comment,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
  [152627] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(3788), 1,
      anon_sym_RPAREN,
    STATE(2932), 1,
      sym_comment,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
  [152643] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3792), 1,
      sym_name,
    STATE(2933), 1,
      sym_comment,
    STATE(2995), 1,
      sym_generic,
    STATE(3043), 1,
      sym_genericdef,
  [152659] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3794), 1,
      anon_sym_COMMA,
    ACTIONS(3796), 1,
      anon_sym_RPAREN,
    STATE(2934), 1,
      sym_comment,
    STATE(3028), 1,
      aux_sym__litlist_repeat1,
  [152675] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3798), 1,
      sym_name,
    ACTIONS(3800), 1,
      anon_sym_function,
    STATE(2237), 1,
      sym__type_assign,
    STATE(2935), 1,
      sym_comment,
  [152691] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2936), 1,
      sym_comment,
    ACTIONS(3802), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [152703] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3348), 1,
      anon_sym_LT,
    ACTIONS(3350), 1,
      anon_sym_LPAREN,
    STATE(2244), 1,
      sym__fn_body,
    STATE(2937), 1,
      sym_comment,
  [152719] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3804), 1,
      anon_sym_COMMA,
    ACTIONS(3806), 1,
      anon_sym_RPAREN,
    STATE(2938), 1,
      sym_comment,
    STATE(2974), 1,
      aux_sym__fntype_paramlist_repeat1,
  [152735] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3348), 1,
      anon_sym_LT,
    ACTIONS(3350), 1,
      anon_sym_LPAREN,
    STATE(2249), 1,
      sym__fn_body,
    STATE(2939), 1,
      sym_comment,
  [152751] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3404), 1,
      anon_sym_LT,
    ACTIONS(3406), 1,
      anon_sym_LPAREN,
    STATE(2364), 1,
      sym__fn_body,
    STATE(2940), 1,
      sym_comment,
  [152767] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3358), 1,
      anon_sym_LT,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    STATE(2426), 1,
      sym__fn_body,
    STATE(2941), 1,
      sym_comment,
  [152783] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(3808), 1,
      anon_sym_RPAREN,
    STATE(2942), 1,
      sym_comment,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
  [152799] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(3812), 1,
      anon_sym_RPAREN,
    STATE(2943), 1,
      sym_comment,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
  [152815] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3404), 1,
      anon_sym_LT,
    ACTIONS(3406), 1,
      anon_sym_LPAREN,
    STATE(2368), 1,
      sym__fn_body,
    STATE(2944), 1,
      sym_comment,
  [152831] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3816), 1,
      anon_sym_COMMA,
    ACTIONS(3818), 1,
      anon_sym_GT,
    STATE(2945), 1,
      sym_comment,
    STATE(3008), 1,
      aux_sym__type_stmt_genlist_repeat1,
  [152847] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3820), 1,
      anon_sym_LT,
    ACTIONS(3822), 1,
      anon_sym_LPAREN,
    STATE(627), 1,
      sym__fn_body,
    STATE(2946), 1,
      sym_comment,
  [152863] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3824), 1,
      anon_sym_COMMA,
    ACTIONS(3826), 1,
      anon_sym_GT,
    STATE(2947), 1,
      sym_comment,
    STATE(3021), 1,
      aux_sym__type_stmt_packlist_repeat1,
  [152879] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3798), 1,
      sym_name,
    ACTIONS(3828), 1,
      anon_sym_function,
    STATE(2262), 1,
      sym__type_assign,
    STATE(2948), 1,
      sym_comment,
  [152895] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3348), 1,
      anon_sym_LT,
    ACTIONS(3350), 1,
      anon_sym_LPAREN,
    STATE(2263), 1,
      sym__fn_body,
    STATE(2949), 1,
      sym_comment,
  [152911] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3348), 1,
      anon_sym_LT,
    ACTIONS(3350), 1,
      anon_sym_LPAREN,
    STATE(2266), 1,
      sym__fn_body,
    STATE(2950), 1,
      sym_comment,
  [152927] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3348), 1,
      anon_sym_LT,
    ACTIONS(3350), 1,
      anon_sym_LPAREN,
    STATE(2267), 1,
      sym__fn_body,
    STATE(2951), 1,
      sym_comment,
  [152943] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3830), 1,
      anon_sym_COMMA,
    ACTIONS(3833), 1,
      anon_sym_GT,
    STATE(2952), 2,
      sym_comment,
      aux_sym__genlist_repeat1,
  [152957] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3835), 1,
      anon_sym_COMMA,
    ACTIONS(3838), 1,
      anon_sym_GT,
    STATE(2953), 2,
      sym_comment,
      aux_sym__genpack_list_repeat1,
  [152971] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2954), 1,
      sym_comment,
    ACTIONS(3840), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [152983] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3844), 1,
      anon_sym_else,
    STATE(2955), 1,
      sym_comment,
    ACTIONS(3842), 2,
      anon_sym_end,
      anon_sym_elseif,
  [152997] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2430), 1,
      anon_sym_do,
    ACTIONS(2717), 1,
      anon_sym_COMMA,
    STATE(2956), 1,
      sym_comment,
    STATE(2970), 1,
      aux_sym__explist_repeat1,
  [153013] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2957), 1,
      sym_comment,
    ACTIONS(3623), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [153025] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(513), 1,
      anon_sym_else,
    STATE(2958), 1,
      sym_comment,
    ACTIONS(754), 2,
      anon_sym_end,
      anon_sym_elseif,
  [153039] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(3846), 1,
      anon_sym_RPAREN,
    STATE(2959), 1,
      sym_comment,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
  [153055] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3850), 1,
      anon_sym_LT,
    ACTIONS(3852), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym__fn_body,
    STATE(2960), 1,
      sym_comment,
  [153071] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3348), 1,
      anon_sym_LT,
    ACTIONS(3350), 1,
      anon_sym_LPAREN,
    STATE(2287), 1,
      sym__fn_body,
    STATE(2961), 1,
      sym_comment,
  [153087] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2962), 1,
      sym_comment,
    ACTIONS(3854), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [153099] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2963), 1,
      sym_comment,
    ACTIONS(3856), 3,
      sym__string_start,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [153111] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3358), 1,
      anon_sym_LT,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    STATE(2431), 1,
      sym__fn_body,
    STATE(2964), 1,
      sym_comment,
  [153127] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3860), 1,
      anon_sym_else,
    STATE(2965), 1,
      sym_comment,
    ACTIONS(3858), 2,
      anon_sym_end,
      anon_sym_elseif,
  [153141] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3774), 1,
      sym_name,
    ACTIONS(3862), 1,
      anon_sym_function,
    STATE(2458), 1,
      sym__type_assign,
    STATE(2966), 1,
      sym_comment,
  [153157] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3404), 1,
      anon_sym_LT,
    ACTIONS(3406), 1,
      anon_sym_LPAREN,
    STATE(2460), 1,
      sym__fn_body,
    STATE(2967), 1,
      sym_comment,
  [153173] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3864), 1,
      anon_sym_COMMA,
    ACTIONS(3867), 1,
      anon_sym_RPAREN,
    STATE(2968), 2,
      sym_comment,
      aux_sym_typelist_repeat1,
  [153187] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3869), 1,
      sym_name,
    STATE(2915), 1,
      sym_parattr,
    STATE(2969), 1,
      sym_comment,
    STATE(3320), 1,
      sym__parattrlist,
  [153203] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1207), 1,
      anon_sym_do,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(2970), 2,
      sym_comment,
      aux_sym__explist_repeat1,
  [153217] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3874), 1,
      anon_sym_COMMA,
    ACTIONS(3877), 1,
      anon_sym_RPAREN,
    STATE(2971), 2,
      sym_comment,
      aux_sym_paramlist_repeat1,
  [153231] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3404), 1,
      anon_sym_LT,
    ACTIONS(3406), 1,
      anon_sym_LPAREN,
    STATE(2463), 1,
      sym__fn_body,
    STATE(2972), 1,
      sym_comment,
  [153247] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3879), 1,
      anon_sym_COMMA,
    ACTIONS(3881), 1,
      anon_sym_GT,
    STATE(2973), 1,
      sym_comment,
    STATE(2976), 1,
      aux_sym__typeparamlist_repeat1,
  [153263] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3883), 1,
      anon_sym_COMMA,
    ACTIONS(3886), 1,
      anon_sym_RPAREN,
    STATE(2974), 2,
      sym_comment,
      aux_sym__fntype_paramlist_repeat1,
  [153277] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3888), 1,
      anon_sym_LT,
    ACTIONS(3890), 1,
      anon_sym_LPAREN,
    STATE(1487), 1,
      sym__fn_body,
    STATE(2975), 1,
      sym_comment,
  [153293] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3879), 1,
      anon_sym_COMMA,
    ACTIONS(3892), 1,
      anon_sym_GT,
    STATE(2976), 1,
      sym_comment,
    STATE(3023), 1,
      aux_sym__typeparamlist_repeat1,
  [153309] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3894), 1,
      anon_sym_COMMA,
    ACTIONS(3896), 1,
      anon_sym_RPAREN,
    STATE(2968), 1,
      aux_sym_typelist_repeat1,
    STATE(2977), 1,
      sym_comment,
  [153325] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3358), 1,
      anon_sym_LT,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    STATE(2469), 1,
      sym__fn_body,
    STATE(2978), 1,
      sym_comment,
  [153341] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3404), 1,
      anon_sym_LT,
    ACTIONS(3406), 1,
      anon_sym_LPAREN,
    STATE(2464), 1,
      sym__fn_body,
    STATE(2979), 1,
      sym_comment,
  [153357] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(3898), 1,
      anon_sym_RPAREN,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
    STATE(2980), 1,
      sym_comment,
  [153373] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3902), 1,
      anon_sym_LT,
    ACTIONS(3904), 1,
      anon_sym_LPAREN,
    STATE(669), 1,
      sym__fn_body,
    STATE(2981), 1,
      sym_comment,
  [153389] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(3906), 1,
      anon_sym_RPAREN,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
    STATE(2982), 1,
      sym_comment,
  [153405] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3910), 1,
      sym_name,
    ACTIONS(3912), 1,
      anon_sym_function,
    STATE(2224), 1,
      sym__type_assign,
    STATE(2983), 1,
      sym_comment,
  [153421] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(3914), 1,
      anon_sym_RPAREN,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
    STATE(2984), 1,
      sym_comment,
  [153437] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3918), 1,
      anon_sym_COMMA,
    STATE(2985), 2,
      sym_comment,
      aux_sym__varlist_repeat1,
  [153451] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3921), 1,
      anon_sym_COMMA,
    ACTIONS(3923), 1,
      anon_sym_RPAREN,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
    STATE(2986), 1,
      sym_comment,
  [153467] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3925), 1,
      sym_name,
    STATE(2893), 1,
      sym_binding,
    STATE(2987), 1,
      sym_comment,
    STATE(3219), 1,
      sym_bindinglist,
  [153483] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3929), 1,
      anon_sym_else,
    STATE(2988), 1,
      sym_comment,
    ACTIONS(3927), 2,
      anon_sym_end,
      anon_sym_elseif,
  [153497] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(3931), 1,
      anon_sym_RPAREN,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
    STATE(2989), 1,
      sym_comment,
  [153513] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(3935), 1,
      anon_sym_RPAREN,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
    STATE(2990), 1,
      sym_comment,
  [153529] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3941), 1,
      anon_sym_else,
    STATE(2991), 1,
      sym_comment,
    ACTIONS(3939), 2,
      anon_sym_end,
      anon_sym_elseif,
  [153543] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3943), 1,
      anon_sym_COMMA,
    ACTIONS(3946), 1,
      anon_sym_GT,
    STATE(2992), 2,
      sym_comment,
      aux_sym__type_stmt_genlist_repeat1,
  [153557] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3948), 1,
      anon_sym_COMMA,
    ACTIONS(3951), 1,
      anon_sym_GT,
    STATE(2993), 2,
      sym_comment,
      aux_sym__type_stmt_packlist_repeat1,
  [153571] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3358), 1,
      anon_sym_LT,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    STATE(2225), 1,
      sym__fn_body,
    STATE(2994), 1,
      sym_comment,
  [153587] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3953), 1,
      anon_sym_EQ,
    STATE(2995), 1,
      sym_comment,
    ACTIONS(3955), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [153601] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(2996), 1,
      sym_comment,
    ACTIONS(3957), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [153613] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3959), 1,
      anon_sym_COMMA,
    ACTIONS(3961), 1,
      anon_sym_RBRACE,
    STATE(2924), 1,
      aux_sym__litfieldlist_repeat1,
    STATE(2997), 1,
      sym_comment,
  [153629] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3794), 1,
      anon_sym_COMMA,
    ACTIONS(3963), 1,
      anon_sym_RPAREN,
    STATE(2934), 1,
      aux_sym__litlist_repeat1,
    STATE(2998), 1,
      sym_comment,
  [153645] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3965), 1,
      anon_sym_COMMA,
    ACTIONS(3968), 1,
      anon_sym_RBRACK,
    STATE(2999), 2,
      sym_comment,
      aux_sym__parattrlist_repeat1,
  [153659] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3358), 1,
      anon_sym_LT,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    STATE(2427), 1,
      sym__fn_body,
    STATE(3000), 1,
      sym_comment,
  [153675] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3358), 1,
      anon_sym_LT,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    STATE(2428), 1,
      sym__fn_body,
    STATE(3001), 1,
      sym_comment,
  [153691] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3970), 1,
      anon_sym_COMMA,
    ACTIONS(3972), 1,
      anon_sym_GT,
    STATE(3002), 1,
      sym_comment,
    STATE(3004), 1,
      aux_sym__genlist_repeat1,
  [153707] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3974), 1,
      anon_sym_LT,
    ACTIONS(3976), 1,
      anon_sym_LPAREN,
    STATE(2091), 1,
      sym__fn_body,
    STATE(3003), 1,
      sym_comment,
  [153723] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3978), 1,
      anon_sym_COMMA,
    ACTIONS(3980), 1,
      anon_sym_GT,
    STATE(2952), 1,
      aux_sym__genlist_repeat1,
    STATE(3004), 1,
      sym_comment,
  [153739] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3005), 1,
      sym_comment,
    ACTIONS(3646), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [153751] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3982), 1,
      anon_sym_COMMA,
    ACTIONS(3984), 1,
      anon_sym_GT,
    STATE(2953), 1,
      aux_sym__genpack_list_repeat1,
    STATE(3006), 1,
      sym_comment,
  [153767] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3986), 1,
      anon_sym_COMMA,
    ACTIONS(3988), 1,
      anon_sym_RPAREN,
    STATE(2971), 1,
      aux_sym_paramlist_repeat1,
    STATE(3007), 1,
      sym_comment,
  [153783] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3990), 1,
      anon_sym_COMMA,
    ACTIONS(3992), 1,
      anon_sym_GT,
    STATE(2992), 1,
      aux_sym__type_stmt_genlist_repeat1,
    STATE(3008), 1,
      sym_comment,
  [153799] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(3994), 1,
      anon_sym_RPAREN,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
    STATE(3009), 1,
      sym_comment,
  [153815] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3998), 1,
      sym_name,
    ACTIONS(4000), 1,
      anon_sym_function,
    STATE(1939), 1,
      sym__type_assign,
    STATE(3010), 1,
      sym_comment,
  [153831] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4002), 1,
      anon_sym_LT,
    ACTIONS(4004), 1,
      anon_sym_LPAREN,
    STATE(666), 1,
      sym__fn_body,
    STATE(3011), 1,
      sym_comment,
  [153847] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(2419), 1,
      anon_sym_in,
    ACTIONS(3669), 1,
      anon_sym_COMMA,
    STATE(2910), 1,
      aux_sym_bindinglist_repeat1,
    STATE(3012), 1,
      sym_comment,
  [153863] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4008), 1,
      anon_sym_else,
    STATE(3013), 1,
      sym_comment,
    ACTIONS(4006), 2,
      anon_sym_end,
      anon_sym_elseif,
  [153877] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3982), 1,
      anon_sym_COMMA,
    ACTIONS(4010), 1,
      anon_sym_GT,
    STATE(3006), 1,
      aux_sym__genpack_list_repeat1,
    STATE(3014), 1,
      sym_comment,
  [153893] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3015), 1,
      sym_comment,
    ACTIONS(3632), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [153905] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3288), 1,
      sym_name,
    STATE(2917), 1,
      sym_genpack,
    STATE(3016), 1,
      sym_comment,
    STATE(3050), 1,
      sym_genpackdef,
  [153921] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(4012), 1,
      anon_sym_RPAREN,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
    STATE(3017), 1,
      sym_comment,
  [153937] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3328), 1,
      anon_sym_LT,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1960), 1,
      sym__fn_body,
    STATE(3018), 1,
      sym_comment,
  [153953] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4018), 1,
      anon_sym_else,
    STATE(3019), 1,
      sym_comment,
    ACTIONS(4016), 2,
      anon_sym_end,
      anon_sym_elseif,
  [153967] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3328), 1,
      anon_sym_LT,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1965), 1,
      sym__fn_body,
    STATE(3020), 1,
      sym_comment,
  [153983] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3824), 1,
      anon_sym_COMMA,
    ACTIONS(4020), 1,
      anon_sym_GT,
    STATE(2993), 1,
      aux_sym__type_stmt_packlist_repeat1,
    STATE(3021), 1,
      sym_comment,
  [153999] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3404), 1,
      anon_sym_LT,
    ACTIONS(3406), 1,
      anon_sym_LPAREN,
    STATE(2529), 1,
      sym__fn_body,
    STATE(3022), 1,
      sym_comment,
  [154015] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4022), 1,
      anon_sym_COMMA,
    ACTIONS(4025), 1,
      anon_sym_GT,
    STATE(3023), 2,
      sym_comment,
      aux_sym__typeparamlist_repeat1,
  [154029] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4027), 1,
      anon_sym_COMMA,
    ACTIONS(4030), 1,
      anon_sym_RBRACE,
    STATE(3024), 2,
      sym_comment,
      aux_sym__litfieldlist_repeat1,
  [154043] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(4032), 1,
      anon_sym_RPAREN,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
    STATE(3025), 1,
      sym_comment,
  [154059] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3910), 1,
      sym_name,
    ACTIONS(4036), 1,
      anon_sym_function,
    STATE(2334), 1,
      sym__type_assign,
    STATE(3026), 1,
      sym_comment,
  [154075] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4038), 1,
      anon_sym_LT,
    ACTIONS(4040), 1,
      anon_sym_LPAREN,
    STATE(2161), 1,
      sym__fn_body,
    STATE(3027), 1,
      sym_comment,
  [154091] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4042), 1,
      anon_sym_COMMA,
    ACTIONS(4045), 1,
      anon_sym_RPAREN,
    STATE(3028), 2,
      sym_comment,
      aux_sym__litlist_repeat1,
  [154105] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4047), 1,
      anon_sym_COLON,
    STATE(3029), 1,
      sym_comment,
    ACTIONS(4049), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [154119] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3998), 1,
      sym_name,
    ACTIONS(4051), 1,
      anon_sym_function,
    STATE(1980), 1,
      sym__type_assign,
    STATE(3030), 1,
      sym_comment,
  [154135] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3328), 1,
      anon_sym_LT,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1981), 1,
      sym__fn_body,
    STATE(3031), 1,
      sym_comment,
  [154151] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3328), 1,
      anon_sym_LT,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1984), 1,
      sym__fn_body,
    STATE(3032), 1,
      sym_comment,
  [154167] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3033), 1,
      sym_comment,
    ACTIONS(4053), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [154179] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3328), 1,
      anon_sym_LT,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1985), 1,
      sym__fn_body,
    STATE(3034), 1,
      sym_comment,
  [154195] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3925), 1,
      sym_name,
    STATE(2906), 1,
      sym_binding,
    STATE(3035), 1,
      sym_comment,
    STATE(3663), 1,
      sym_bindinglist,
  [154211] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3925), 1,
      sym_name,
    STATE(2907), 1,
      sym_binding,
    STATE(3036), 1,
      sym_comment,
    STATE(3669), 1,
      sym_bindinglist,
  [154227] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3925), 1,
      sym_name,
    STATE(2908), 1,
      sym_binding,
    STATE(3037), 1,
      sym_comment,
    STATE(3675), 1,
      sym_bindinglist,
  [154243] = 5,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
    ACTIONS(4055), 1,
      anon_sym_RPAREN,
    STATE(2977), 1,
      aux_sym_typelist_repeat1,
    STATE(3038), 1,
      sym_comment,
  [154259] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3039), 1,
      sym_comment,
    ACTIONS(4059), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [154270] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3040), 1,
      sym_comment,
    ACTIONS(4061), 2,
      anon_sym_LT,
      anon_sym_LPAREN,
  [154281] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3869), 1,
      sym_name,
    STATE(3041), 1,
      sym_comment,
    STATE(3062), 1,
      sym_parattr,
  [154294] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1113), 1,
      sym_paramtypelist,
    STATE(3042), 1,
      sym_comment,
  [154307] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3043), 1,
      sym_comment,
    ACTIONS(3946), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [154318] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1097), 1,
      sym_paramtypelist,
    STATE(3044), 1,
      sym_comment,
  [154331] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4065), 1,
      sym_name,
    STATE(1822), 1,
      sym_binding,
    STATE(3045), 1,
      sym_comment,
  [154344] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4069), 1,
      anon_sym_RPAREN,
    STATE(3046), 1,
      sym_comment,
  [154357] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1120), 1,
      sym_paramtypelist,
    STATE(3047), 1,
      sym_comment,
  [154370] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4072), 1,
      anon_sym_RPAREN,
    STATE(3048), 1,
      sym_comment,
  [154383] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4075), 1,
      anon_sym_COLON,
    STATE(2962), 1,
      sym__method_name,
    STATE(3049), 1,
      sym_comment,
  [154396] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3050), 1,
      sym_comment,
    ACTIONS(3951), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [154407] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1093), 1,
      sym_paramtypelist,
    STATE(3051), 1,
      sym_comment,
  [154420] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4077), 1,
      anon_sym_RPAREN,
    STATE(3052), 1,
      sym_comment,
  [154433] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1110), 1,
      sym_paramtypelist,
    STATE(3053), 1,
      sym_comment,
  [154446] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4080), 1,
      anon_sym_RPAREN,
    STATE(3054), 1,
      sym_comment,
  [154459] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3688), 1,
      ts_builtin_sym_end,
    ACTIONS(4083), 1,
      anon_sym_SEMI,
    STATE(3055), 1,
      sym_comment,
  [154472] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3056), 1,
      sym_comment,
    ACTIONS(4085), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [154483] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3057), 1,
      sym_comment,
    ACTIONS(4087), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [154494] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3058), 1,
      sym_comment,
    ACTIONS(4089), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [154505] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3059), 1,
      sym_comment,
    ACTIONS(4067), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [154516] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3060), 1,
      sym_comment,
    ACTIONS(4091), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [154527] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4093), 1,
      anon_sym_EQ,
    ACTIONS(4095), 1,
      anon_sym_LT,
    STATE(3061), 1,
      sym_comment,
  [154540] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3062), 1,
      sym_comment,
    ACTIONS(3968), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [154551] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3063), 1,
      sym_comment,
    ACTIONS(4097), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [154562] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3688), 1,
      anon_sym_end,
    ACTIONS(4099), 1,
      anon_sym_SEMI,
    STATE(3064), 1,
      sym_comment,
  [154575] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3065), 1,
      sym_comment,
    ACTIONS(3107), 2,
      anon_sym_LBRACK,
      sym_name,
  [154586] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1094), 1,
      sym_paramtypelist,
    STATE(3066), 1,
      sym_comment,
  [154599] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1091), 1,
      sym_paramtypelist,
    STATE(3067), 1,
      sym_comment,
  [154612] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4101), 1,
      anon_sym_RPAREN,
    STATE(3068), 1,
      sym_comment,
  [154625] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4104), 1,
      anon_sym_RPAREN,
    STATE(3069), 1,
      sym_comment,
  [154638] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1124), 1,
      sym_paramtypelist,
    STATE(3070), 1,
      sym_comment,
  [154651] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3288), 1,
      sym_name,
    STATE(3071), 1,
      sym_comment,
    STATE(3114), 1,
      sym_genpack,
  [154664] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1125), 1,
      sym_paramtypelist,
    STATE(3072), 1,
      sym_comment,
  [154677] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4107), 1,
      sym_name,
    STATE(2017), 1,
      sym_binding,
    STATE(3073), 1,
      sym_comment,
  [154690] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3074), 1,
      sym_comment,
    ACTIONS(2423), 2,
      anon_sym_in,
      anon_sym_COMMA,
  [154701] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3925), 1,
      sym_name,
    STATE(3074), 1,
      sym_binding,
    STATE(3075), 1,
      sym_comment,
  [154714] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4109), 1,
      sym__comment_content,
    ACTIONS(4111), 1,
      sym__comment_end,
    STATE(3076), 1,
      sym_comment,
  [154727] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3320), 1,
      sym_name,
    STATE(3077), 1,
      sym_comment,
    STATE(3087), 1,
      sym_param,
  [154740] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1109), 1,
      sym_paramtypelist,
    STATE(3078), 1,
      sym_comment,
  [154753] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4113), 1,
      anon_sym_RPAREN,
    STATE(3079), 1,
      sym_comment,
  [154766] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1095), 1,
      sym_paramtypelist,
    STATE(3080), 1,
      sym_comment,
  [154779] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4116), 1,
      anon_sym_RPAREN,
    STATE(3081), 1,
      sym_comment,
  [154792] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4119), 1,
      anon_sym_RPAREN,
    STATE(3082), 1,
      sym_comment,
  [154805] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4122), 1,
      anon_sym_RPAREN,
    STATE(3083), 1,
      sym_comment,
  [154818] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4125), 1,
      anon_sym_RPAREN,
    STATE(3084), 1,
      sym_comment,
  [154831] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4128), 1,
      sym_name,
    STATE(1962), 1,
      sym_binding,
    STATE(3085), 1,
      sym_comment,
  [154844] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1103), 1,
      sym_paramtypelist,
    STATE(3086), 1,
      sym_comment,
  [154857] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3087), 1,
      sym_comment,
    ACTIONS(3877), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [154868] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4130), 1,
      anon_sym_RPAREN,
    STATE(3088), 1,
      sym_comment,
  [154881] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4133), 1,
      anon_sym_COLON,
    ACTIONS(4135), 1,
      anon_sym_RPAREN,
    STATE(3089), 1,
      sym_comment,
  [154894] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1129), 1,
      sym_paramtypelist,
    STATE(3090), 1,
      sym_comment,
  [154907] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3091), 1,
      sym_comment,
    ACTIONS(4137), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [154918] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3092), 1,
      sym_comment,
    ACTIONS(945), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [154929] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    ACTIONS(4141), 1,
      anon_sym_LT,
    STATE(3093), 1,
      sym_comment,
  [154942] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3094), 1,
      sym_comment,
    ACTIONS(4143), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [154953] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3095), 1,
      sym_comment,
    ACTIONS(4145), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [154964] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3096), 1,
      sym_comment,
    ACTIONS(4030), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [154975] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3097), 1,
      sym_comment,
    ACTIONS(4147), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [154986] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3688), 1,
      anon_sym_until,
    ACTIONS(4149), 1,
      anon_sym_SEMI,
    STATE(3098), 1,
      sym_comment,
  [154999] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3099), 1,
      sym_comment,
    ACTIONS(4045), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [155010] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4151), 1,
      anon_sym_RPAREN,
    STATE(3100), 1,
      sym_comment,
  [155023] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1128), 1,
      sym_paramtypelist,
    STATE(3101), 1,
      sym_comment,
  [155036] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1114), 1,
      sym_paramtypelist,
    STATE(3102), 1,
      sym_comment,
  [155049] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4154), 1,
      anon_sym_EQ,
    ACTIONS(4156), 1,
      anon_sym_LT,
    STATE(3103), 1,
      sym_comment,
  [155062] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4158), 1,
      anon_sym_elseif,
    ACTIONS(4160), 1,
      anon_sym_else,
    STATE(3104), 1,
      sym_comment,
  [155075] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3105), 1,
      sym_comment,
    ACTIONS(4025), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [155086] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3106), 1,
      sym_comment,
    ACTIONS(3833), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [155097] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3792), 1,
      sym_name,
    STATE(3106), 1,
      sym_generic,
    STATE(3107), 1,
      sym_comment,
  [155110] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4162), 1,
      anon_sym_RPAREN,
    STATE(3108), 1,
      sym_comment,
  [155123] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1127), 1,
      sym_paramtypelist,
    STATE(3109), 1,
      sym_comment,
  [155136] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3110), 1,
      sym_comment,
    ACTIONS(4165), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [155147] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1118), 1,
      sym_paramtypelist,
    STATE(3111), 1,
      sym_comment,
  [155160] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
    STATE(1106), 1,
      sym_paramtypelist,
    STATE(3112), 1,
      sym_comment,
  [155173] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3113), 1,
      sym_comment,
    ACTIONS(4167), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [155184] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3114), 1,
      sym_comment,
    ACTIONS(3838), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [155195] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4169), 1,
      anon_sym_RPAREN,
    STATE(3115), 1,
      sym_comment,
  [155208] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4172), 1,
      anon_sym_RPAREN,
    STATE(3116), 1,
      sym_comment,
  [155221] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3117), 1,
      sym_comment,
    ACTIONS(4175), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [155232] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3118), 1,
      sym_comment,
    ACTIONS(4177), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [155243] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4179), 1,
      anon_sym_RPAREN,
    STATE(3119), 1,
      sym_comment,
  [155256] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4182), 1,
      sym_name,
    STATE(1957), 1,
      sym_binding,
    STATE(3120), 1,
      sym_comment,
  [155269] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3121), 1,
      sym_comment,
    ACTIONS(4184), 2,
      anon_sym_LT,
      anon_sym_LPAREN,
  [155280] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    ACTIONS(4186), 1,
      anon_sym_RPAREN,
    STATE(3122), 1,
      sym_comment,
  [155293] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    STATE(3123), 1,
      sym_comment,
    ACTIONS(1203), 2,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [155304] = 4,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4189), 1,
      anon_sym_EQ,
    ACTIONS(4191), 1,
      anon_sym_LT,
    STATE(3124), 1,
      sym_comment,
  [155317] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4193), 1,
      anon_sym_GT,
    STATE(3125), 1,
      sym_comment,
  [155327] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4195), 1,
      anon_sym_end,
    STATE(3126), 1,
      sym_comment,
  [155337] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4197), 1,
      anon_sym_end,
    STATE(3127), 1,
      sym_comment,
  [155347] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4199), 1,
      anon_sym_RPAREN,
    STATE(3128), 1,
      sym_comment,
  [155357] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4201), 1,
      anon_sym_GT,
    STATE(3129), 1,
      sym_comment,
  [155367] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4203), 1,
      anon_sym_GT,
    STATE(3130), 1,
      sym_comment,
  [155377] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4205), 1,
      anon_sym_end,
    STATE(3131), 1,
      sym_comment,
  [155387] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4207), 1,
      anon_sym_GT,
    STATE(3132), 1,
      sym_comment,
  [155397] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4209), 1,
      anon_sym_end,
    STATE(3133), 1,
      sym_comment,
  [155407] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4211), 1,
      anon_sym_end,
    STATE(3134), 1,
      sym_comment,
  [155417] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4213), 1,
      anon_sym_RBRACE,
    STATE(3135), 1,
      sym_comment,
  [155427] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4215), 1,
      anon_sym_RPAREN,
    STATE(3136), 1,
      sym_comment,
  [155437] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4217), 1,
      anon_sym_RPAREN,
    STATE(3137), 1,
      sym_comment,
  [155447] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4219), 1,
      anon_sym_end,
    STATE(3138), 1,
      sym_comment,
  [155457] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4221), 1,
      anon_sym_end,
    STATE(3139), 1,
      sym_comment,
  [155467] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4223), 1,
      anon_sym_end,
    STATE(3140), 1,
      sym_comment,
  [155477] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4225), 1,
      anon_sym_end,
    STATE(3141), 1,
      sym_comment,
  [155487] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4227), 1,
      anon_sym_RBRACE,
    STATE(3142), 1,
      sym_comment,
  [155497] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4229), 1,
      anon_sym_end,
    STATE(3143), 1,
      sym_comment,
  [155507] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4231), 1,
      anon_sym_GT,
    STATE(3144), 1,
      sym_comment,
  [155517] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4233), 1,
      sym_name,
    STATE(3145), 1,
      sym_comment,
  [155527] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4235), 1,
      sym_name,
    STATE(3146), 1,
      sym_comment,
  [155537] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4237), 1,
      anon_sym_end,
    STATE(3147), 1,
      sym_comment,
  [155547] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4239), 1,
      anon_sym_end,
    STATE(3148), 1,
      sym_comment,
  [155557] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4241), 1,
      anon_sym_end,
    STATE(3149), 1,
      sym_comment,
  [155567] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4243), 1,
      anon_sym_end,
    STATE(3150), 1,
      sym_comment,
  [155577] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4245), 1,
      anon_sym_GT,
    STATE(3151), 1,
      sym_comment,
  [155587] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4247), 1,
      anon_sym_RPAREN,
    STATE(3152), 1,
      sym_comment,
  [155597] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4249), 1,
      anon_sym_RBRACE,
    STATE(3153), 1,
      sym_comment,
  [155607] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4251), 1,
      anon_sym_end,
    STATE(3154), 1,
      sym_comment,
  [155617] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4253), 1,
      anon_sym_end,
    STATE(3155), 1,
      sym_comment,
  [155627] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4255), 1,
      anon_sym_end,
    STATE(3156), 1,
      sym_comment,
  [155637] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4257), 1,
      anon_sym_end,
    STATE(3157), 1,
      sym_comment,
  [155647] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4259), 1,
      anon_sym_end,
    STATE(3158), 1,
      sym_comment,
  [155657] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4261), 1,
      anon_sym_RPAREN,
    STATE(3159), 1,
      sym_comment,
  [155667] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4263), 1,
      anon_sym_end,
    STATE(3160), 1,
      sym_comment,
  [155677] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4265), 1,
      anon_sym_end,
    STATE(3161), 1,
      sym_comment,
  [155687] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4267), 1,
      anon_sym_GT,
    STATE(3162), 1,
      sym_comment,
  [155697] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4269), 1,
      anon_sym_end,
    STATE(3163), 1,
      sym_comment,
  [155707] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4271), 1,
      anon_sym_end,
    STATE(3164), 1,
      sym_comment,
  [155717] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4273), 1,
      anon_sym_end,
    STATE(3165), 1,
      sym_comment,
  [155727] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4275), 1,
      anon_sym_end,
    STATE(3166), 1,
      sym_comment,
  [155737] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4277), 1,
      anon_sym_end,
    STATE(3167), 1,
      sym_comment,
  [155747] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4279), 1,
      anon_sym_end,
    STATE(3168), 1,
      sym_comment,
  [155757] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4281), 1,
      anon_sym_end,
    STATE(3169), 1,
      sym_comment,
  [155767] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4283), 1,
      anon_sym_end,
    STATE(3170), 1,
      sym_comment,
  [155777] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4285), 1,
      anon_sym_end,
    STATE(3171), 1,
      sym_comment,
  [155787] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4287), 1,
      anon_sym_end,
    STATE(3172), 1,
      sym_comment,
  [155797] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(754), 1,
      anon_sym_until,
    STATE(3173), 1,
      sym_comment,
  [155807] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4289), 1,
      anon_sym_GT,
    STATE(3174), 1,
      sym_comment,
  [155817] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4291), 1,
      anon_sym_RPAREN,
    STATE(3175), 1,
      sym_comment,
  [155827] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4293), 1,
      anon_sym_RBRACE,
    STATE(3176), 1,
      sym_comment,
  [155837] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4295), 1,
      anon_sym_RPAREN,
    STATE(3177), 1,
      sym_comment,
  [155847] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4297), 1,
      anon_sym_end,
    STATE(3178), 1,
      sym_comment,
  [155857] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4299), 1,
      anon_sym_end,
    STATE(3179), 1,
      sym_comment,
  [155867] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4301), 1,
      sym_name,
    STATE(3180), 1,
      sym_comment,
  [155877] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4303), 1,
      anon_sym_RBRACE,
    STATE(3181), 1,
      sym_comment,
  [155887] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4305), 1,
      anon_sym_RPAREN,
    STATE(3182), 1,
      sym_comment,
  [155897] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4307), 1,
      anon_sym_RBRACE,
    STATE(3183), 1,
      sym_comment,
  [155907] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3103), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(3184), 1,
      sym_comment,
  [155917] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4309), 1,
      anon_sym_GT,
    STATE(3185), 1,
      sym_comment,
  [155927] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4311), 1,
      anon_sym_end,
    STATE(3186), 1,
      sym_comment,
  [155937] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4313), 1,
      anon_sym_end,
    STATE(3187), 1,
      sym_comment,
  [155947] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4315), 1,
      anon_sym_RBRACE,
    STATE(3188), 1,
      sym_comment,
  [155957] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4317), 1,
      anon_sym_end,
    STATE(3189), 1,
      sym_comment,
  [155967] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4319), 1,
      anon_sym_end,
    STATE(3190), 1,
      sym_comment,
  [155977] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4321), 1,
      sym_name,
    STATE(3191), 1,
      sym_comment,
  [155987] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4323), 1,
      anon_sym_end,
    STATE(3192), 1,
      sym_comment,
  [155997] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4325), 1,
      sym_name,
    STATE(3193), 1,
      sym_comment,
  [156007] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4327), 1,
      sym_name,
    STATE(3194), 1,
      sym_comment,
  [156017] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4329), 1,
      anon_sym_end,
    STATE(3195), 1,
      sym_comment,
  [156027] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4331), 1,
      sym_name,
    STATE(3196), 1,
      sym_comment,
  [156037] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4333), 1,
      anon_sym_GT,
    STATE(3197), 1,
      sym_comment,
  [156047] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4335), 1,
      anon_sym_RPAREN,
    STATE(3198), 1,
      sym_comment,
  [156057] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4337), 1,
      anon_sym_COLON,
    STATE(3199), 1,
      sym_comment,
  [156067] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4339), 1,
      anon_sym_end,
    STATE(3200), 1,
      sym_comment,
  [156077] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4341), 1,
      anon_sym_end,
    STATE(3201), 1,
      sym_comment,
  [156087] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4343), 1,
      ts_builtin_sym_end,
    STATE(3202), 1,
      sym_comment,
  [156097] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4345), 1,
      anon_sym_end,
    STATE(3203), 1,
      sym_comment,
  [156107] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4347), 1,
      anon_sym_end,
    STATE(3204), 1,
      sym_comment,
  [156117] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4349), 1,
      anon_sym_RPAREN,
    STATE(3205), 1,
      sym_comment,
  [156127] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4351), 1,
      anon_sym_end,
    STATE(3206), 1,
      sym_comment,
  [156137] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4353), 1,
      anon_sym_end,
    STATE(3207), 1,
      sym_comment,
  [156147] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4355), 1,
      anon_sym_GT,
    STATE(3208), 1,
      sym_comment,
  [156157] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4357), 1,
      sym_name,
    STATE(3209), 1,
      sym_comment,
  [156167] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4359), 1,
      anon_sym_do,
    STATE(3210), 1,
      sym_comment,
  [156177] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4361), 1,
      anon_sym_end,
    STATE(3211), 1,
      sym_comment,
  [156187] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4363), 1,
      anon_sym_end,
    STATE(3212), 1,
      sym_comment,
  [156197] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4365), 1,
      anon_sym_end,
    STATE(3213), 1,
      sym_comment,
  [156207] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4367), 1,
      anon_sym_RPAREN,
    STATE(3214), 1,
      sym_comment,
  [156217] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4369), 1,
      anon_sym_GT,
    STATE(3215), 1,
      sym_comment,
  [156227] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4371), 1,
      anon_sym_end,
    STATE(3216), 1,
      sym_comment,
  [156237] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4373), 1,
      anon_sym_end,
    STATE(3217), 1,
      sym_comment,
  [156247] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3410), 1,
      anon_sym_COLON,
    STATE(3218), 1,
      sym_comment,
  [156257] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4375), 1,
      anon_sym_in,
    STATE(3219), 1,
      sym_comment,
  [156267] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4377), 1,
      anon_sym_RPAREN,
    STATE(3220), 1,
      sym_comment,
  [156277] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4379), 1,
      anon_sym_RPAREN,
    STATE(3221), 1,
      sym_comment,
  [156287] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4381), 1,
      anon_sym_end,
    STATE(3222), 1,
      sym_comment,
  [156297] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4383), 1,
      anon_sym_end,
    STATE(3223), 1,
      sym_comment,
  [156307] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4385), 1,
      anon_sym_RBRACE,
    STATE(3224), 1,
      sym_comment,
  [156317] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4387), 1,
      anon_sym_end,
    STATE(3225), 1,
      sym_comment,
  [156327] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4389), 1,
      anon_sym_end,
    STATE(3226), 1,
      sym_comment,
  [156337] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4391), 1,
      anon_sym_RBRACE,
    STATE(3227), 1,
      sym_comment,
  [156347] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4393), 1,
      anon_sym_RPAREN,
    STATE(3228), 1,
      sym_comment,
  [156357] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4395), 1,
      anon_sym_RPAREN,
    STATE(3229), 1,
      sym_comment,
  [156367] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4397), 1,
      anon_sym_function,
    STATE(3230), 1,
      sym_comment,
  [156377] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4399), 1,
      anon_sym_RBRACE,
    STATE(3231), 1,
      sym_comment,
  [156387] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4401), 1,
      anon_sym_RPAREN,
    STATE(3232), 1,
      sym_comment,
  [156397] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4403), 1,
      sym_name,
    STATE(3233), 1,
      sym_comment,
  [156407] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4405), 1,
      sym_name,
    STATE(3234), 1,
      sym_comment,
  [156417] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4407), 1,
      anon_sym_end,
    STATE(3235), 1,
      sym_comment,
  [156427] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4409), 1,
      anon_sym_end,
    STATE(3236), 1,
      sym_comment,
  [156437] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4411), 1,
      anon_sym_GT,
    STATE(3237), 1,
      sym_comment,
  [156447] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4413), 1,
      anon_sym_RPAREN,
    STATE(3238), 1,
      sym_comment,
  [156457] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4415), 1,
      anon_sym_GT,
    STATE(3239), 1,
      sym_comment,
  [156467] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4417), 1,
      anon_sym_end,
    STATE(3240), 1,
      sym_comment,
  [156477] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4419), 1,
      anon_sym_end,
    STATE(3241), 1,
      sym_comment,
  [156487] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4421), 1,
      anon_sym_end,
    STATE(3242), 1,
      sym_comment,
  [156497] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4423), 1,
      anon_sym_RBRACE,
    STATE(3243), 1,
      sym_comment,
  [156507] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4425), 1,
      anon_sym_GT,
    STATE(3244), 1,
      sym_comment,
  [156517] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4427), 1,
      anon_sym_end,
    STATE(3245), 1,
      sym_comment,
  [156527] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4429), 1,
      anon_sym_RBRACE,
    STATE(3246), 1,
      sym_comment,
  [156537] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4431), 1,
      anon_sym_end,
    STATE(3247), 1,
      sym_comment,
  [156547] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4433), 1,
      sym_name,
    STATE(3248), 1,
      sym_comment,
  [156557] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3818), 1,
      anon_sym_GT,
    STATE(3249), 1,
      sym_comment,
  [156567] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4435), 1,
      anon_sym_end,
    STATE(3250), 1,
      sym_comment,
  [156577] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4437), 1,
      anon_sym_GT,
    STATE(3251), 1,
      sym_comment,
  [156587] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4439), 1,
      anon_sym_RPAREN,
    STATE(3252), 1,
      sym_comment,
  [156597] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4441), 1,
      anon_sym_GT,
    STATE(3253), 1,
      sym_comment,
  [156607] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4443), 1,
      anon_sym_end,
    STATE(3254), 1,
      sym_comment,
  [156617] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4445), 1,
      anon_sym_end,
    STATE(3255), 1,
      sym_comment,
  [156627] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4447), 1,
      anon_sym_end,
    STATE(3256), 1,
      sym_comment,
  [156637] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4449), 1,
      anon_sym_RBRACE,
    STATE(3257), 1,
      sym_comment,
  [156647] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4451), 1,
      anon_sym_RPAREN,
    STATE(3258), 1,
      sym_comment,
  [156657] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4453), 1,
      anon_sym_RPAREN,
    STATE(3259), 1,
      sym_comment,
  [156667] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4456), 1,
      anon_sym_end,
    STATE(3260), 1,
      sym_comment,
  [156677] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4458), 1,
      anon_sym_RBRACE,
    STATE(3261), 1,
      sym_comment,
  [156687] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4460), 1,
      anon_sym_end,
    STATE(3262), 1,
      sym_comment,
  [156697] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4462), 1,
      anon_sym_end,
    STATE(3263), 1,
      sym_comment,
  [156707] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4464), 1,
      anon_sym_RPAREN,
    STATE(3264), 1,
      sym_comment,
  [156717] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4466), 1,
      anon_sym_RBRACE,
    STATE(3265), 1,
      sym_comment,
  [156727] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4468), 1,
      sym_name,
    STATE(3266), 1,
      sym_comment,
  [156737] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4470), 1,
      anon_sym_RBRACE,
    STATE(3267), 1,
      sym_comment,
  [156747] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4472), 1,
      anon_sym_end,
    STATE(3268), 1,
      sym_comment,
  [156757] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4474), 1,
      anon_sym_RBRACE,
    STATE(3269), 1,
      sym_comment,
  [156767] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4476), 1,
      anon_sym_end,
    STATE(3270), 1,
      sym_comment,
  [156777] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4016), 1,
      anon_sym_until,
    STATE(3271), 1,
      sym_comment,
  [156787] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4478), 1,
      anon_sym_end,
    STATE(3272), 1,
      sym_comment,
  [156797] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4480), 1,
      anon_sym_RBRACE,
    STATE(3273), 1,
      sym_comment,
  [156807] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4482), 1,
      anon_sym_GT,
    STATE(3274), 1,
      sym_comment,
  [156817] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4484), 1,
      sym_name,
    STATE(3275), 1,
      sym_comment,
  [156827] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4486), 1,
      anon_sym_RPAREN,
    STATE(3276), 1,
      sym_comment,
  [156837] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4488), 1,
      anon_sym_RBRACE,
    STATE(3277), 1,
      sym_comment,
  [156847] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4490), 1,
      anon_sym_end,
    STATE(3278), 1,
      sym_comment,
  [156857] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4492), 1,
      anon_sym_end,
    STATE(3279), 1,
      sym_comment,
  [156867] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4494), 1,
      anon_sym_RPAREN,
    STATE(3280), 1,
      sym_comment,
  [156877] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4496), 1,
      anon_sym_RBRACE,
    STATE(3281), 1,
      sym_comment,
  [156887] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4498), 1,
      anon_sym_end,
    STATE(3282), 1,
      sym_comment,
  [156897] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4500), 1,
      anon_sym_end,
    STATE(3283), 1,
      sym_comment,
  [156907] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4502), 1,
      sym__comment_end,
    STATE(3284), 1,
      sym_comment,
  [156917] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4504), 1,
      anon_sym_RBRACE,
    STATE(3285), 1,
      sym_comment,
  [156927] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4506), 1,
      sym_name,
    STATE(3286), 1,
      sym_comment,
  [156937] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4508), 1,
      anon_sym_end,
    STATE(3287), 1,
      sym_comment,
  [156947] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4510), 1,
      anon_sym_LBRACE2,
    STATE(3288), 1,
      sym_comment,
  [156957] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4512), 1,
      anon_sym_RBRACE,
    STATE(3289), 1,
      sym_comment,
  [156967] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4514), 1,
      anon_sym_end,
    STATE(3290), 1,
      sym_comment,
  [156977] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4516), 1,
      anon_sym_end,
    STATE(3291), 1,
      sym_comment,
  [156987] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4518), 1,
      anon_sym_RBRACE,
    STATE(3292), 1,
      sym_comment,
  [156997] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4520), 1,
      anon_sym_RBRACE,
    STATE(3293), 1,
      sym_comment,
  [157007] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4522), 1,
      anon_sym_end,
    STATE(3294), 1,
      sym_comment,
  [157017] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4524), 1,
      anon_sym_end,
    STATE(3295), 1,
      sym_comment,
  [157027] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4526), 1,
      anon_sym_RPAREN,
    STATE(3296), 1,
      sym_comment,
  [157037] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4528), 1,
      anon_sym_RBRACE,
    STATE(3297), 1,
      sym_comment,
  [157047] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4530), 1,
      anon_sym_RBRACE,
    STATE(3298), 1,
      sym_comment,
  [157057] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4532), 1,
      anon_sym_end,
    STATE(3299), 1,
      sym_comment,
  [157067] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4534), 1,
      anon_sym_end,
    STATE(3300), 1,
      sym_comment,
  [157077] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4536), 1,
      anon_sym_end,
    STATE(3301), 1,
      sym_comment,
  [157087] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4538), 1,
      anon_sym_GT,
    STATE(3302), 1,
      sym_comment,
  [157097] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4540), 1,
      anon_sym_RPAREN,
    STATE(3303), 1,
      sym_comment,
  [157107] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4542), 1,
      anon_sym_RBRACE,
    STATE(3304), 1,
      sym_comment,
  [157117] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4544), 1,
      anon_sym_RPAREN,
    STATE(3305), 1,
      sym_comment,
  [157127] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4546), 1,
      anon_sym_end,
    STATE(3306), 1,
      sym_comment,
  [157137] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4548), 1,
      sym_name,
    STATE(3307), 1,
      sym_comment,
  [157147] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4550), 1,
      anon_sym_end,
    STATE(3308), 1,
      sym_comment,
  [157157] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4552), 1,
      anon_sym_end,
    STATE(3309), 1,
      sym_comment,
  [157167] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4554), 1,
      sym_name,
    STATE(3310), 1,
      sym_comment,
  [157177] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4556), 1,
      anon_sym_end,
    STATE(3311), 1,
      sym_comment,
  [157187] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4558), 1,
      aux_sym_type_stmt_token1,
    STATE(3312), 1,
      sym_comment,
  [157197] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4560), 1,
      anon_sym_end,
    STATE(3313), 1,
      sym_comment,
  [157207] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4562), 1,
      anon_sym_EQ,
    STATE(3314), 1,
      sym_comment,
  [157217] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4564), 1,
      anon_sym_end,
    STATE(3315), 1,
      sym_comment,
  [157227] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4566), 1,
      sym_name,
    STATE(3316), 1,
      sym_comment,
  [157237] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4568), 1,
      anon_sym_end,
    STATE(3317), 1,
      sym_comment,
  [157247] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4570), 1,
      anon_sym_until,
    STATE(3318), 1,
      sym_comment,
  [157257] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4572), 1,
      anon_sym_GT,
    STATE(3319), 1,
      sym_comment,
  [157267] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4574), 1,
      anon_sym_RBRACK,
    STATE(3320), 1,
      sym_comment,
  [157277] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4576), 1,
      sym_name,
    STATE(3321), 1,
      sym_comment,
  [157287] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4578), 1,
      anon_sym_GT,
    STATE(3322), 1,
      sym_comment,
  [157297] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4580), 1,
      aux_sym_type_stmt_token1,
    STATE(3323), 1,
      sym_comment,
  [157307] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4582), 1,
      sym_name,
    STATE(3324), 1,
      sym_comment,
  [157317] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4584), 1,
      anon_sym_end,
    STATE(3325), 1,
      sym_comment,
  [157327] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4586), 1,
      sym_name,
    STATE(3326), 1,
      sym_comment,
  [157337] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4588), 1,
      aux_sym_unicode_escape_token1,
    STATE(3327), 1,
      sym_comment,
  [157347] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4590), 1,
      anon_sym_RPAREN,
    STATE(3328), 1,
      sym_comment,
  [157357] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4592), 1,
      ts_builtin_sym_end,
    STATE(3329), 1,
      sym_comment,
  [157367] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4594), 1,
      anon_sym_RPAREN,
    STATE(3330), 1,
      sym_comment,
  [157377] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4596), 1,
      anon_sym_do,
    STATE(3331), 1,
      sym_comment,
  [157387] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4598), 1,
      anon_sym_RBRACE,
    STATE(3332), 1,
      sym_comment,
  [157397] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4600), 1,
      anon_sym_end,
    STATE(3333), 1,
      sym_comment,
  [157407] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4602), 1,
      anon_sym_end,
    STATE(3334), 1,
      sym_comment,
  [157417] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4604), 1,
      sym_name,
    STATE(3335), 1,
      sym_comment,
  [157427] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4606), 1,
      anon_sym_end,
    STATE(3336), 1,
      sym_comment,
  [157437] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4608), 1,
      anon_sym_end,
    STATE(3337), 1,
      sym_comment,
  [157447] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4610), 1,
      anon_sym_RPAREN,
    STATE(3338), 1,
      sym_comment,
  [157457] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4612), 1,
      anon_sym_EQ,
    STATE(3339), 1,
      sym_comment,
  [157467] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4614), 1,
      anon_sym_RPAREN,
    STATE(3340), 1,
      sym_comment,
  [157477] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4616), 1,
      anon_sym_end,
    STATE(3341), 1,
      sym_comment,
  [157487] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4618), 1,
      anon_sym_end,
    STATE(3342), 1,
      sym_comment,
  [157497] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4620), 1,
      anon_sym_end,
    STATE(3343), 1,
      sym_comment,
  [157507] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4622), 1,
      anon_sym_GT,
    STATE(3344), 1,
      sym_comment,
  [157517] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4624), 1,
      sym_name,
    STATE(3345), 1,
      sym_comment,
  [157527] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4626), 1,
      anon_sym_RPAREN,
    STATE(3346), 1,
      sym_comment,
  [157537] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4628), 1,
      aux_sym_type_stmt_token1,
    STATE(3347), 1,
      sym_comment,
  [157547] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4630), 1,
      sym_name,
    STATE(3348), 1,
      sym_comment,
  [157557] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4632), 1,
      anon_sym_EQ,
    STATE(3349), 1,
      sym_comment,
  [157567] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4634), 1,
      anon_sym_end,
    STATE(3350), 1,
      sym_comment,
  [157577] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4636), 1,
      sym_name,
    STATE(3351), 1,
      sym_comment,
  [157587] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4638), 1,
      anon_sym_end,
    STATE(3352), 1,
      sym_comment,
  [157597] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4640), 1,
      anon_sym_until,
    STATE(3353), 1,
      sym_comment,
  [157607] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4642), 1,
      anon_sym_end,
    STATE(3354), 1,
      sym_comment,
  [157617] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4644), 1,
      anon_sym_end,
    STATE(3355), 1,
      sym_comment,
  [157627] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4646), 1,
      sym_name,
    STATE(3356), 1,
      sym_comment,
  [157637] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4648), 1,
      anon_sym_end,
    STATE(3357), 1,
      sym_comment,
  [157647] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4650), 1,
      aux_sym_type_stmt_token1,
    STATE(3358), 1,
      sym_comment,
  [157657] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4652), 1,
      sym_name,
    STATE(3359), 1,
      sym_comment,
  [157667] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4654), 1,
      anon_sym_end,
    STATE(3360), 1,
      sym_comment,
  [157677] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4656), 1,
      sym_name,
    STATE(3361), 1,
      sym_comment,
  [157687] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4658), 1,
      anon_sym_RPAREN,
    STATE(3362), 1,
      sym_comment,
  [157697] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4660), 1,
      anon_sym_end,
    STATE(3363), 1,
      sym_comment,
  [157707] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4662), 1,
      anon_sym_RPAREN,
    STATE(3364), 1,
      sym_comment,
  [157717] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4664), 1,
      anon_sym_do,
    STATE(3365), 1,
      sym_comment,
  [157727] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4666), 1,
      anon_sym_end,
    STATE(3366), 1,
      sym_comment,
  [157737] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4668), 1,
      anon_sym_end,
    STATE(3367), 1,
      sym_comment,
  [157747] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4670), 1,
      anon_sym_end,
    STATE(3368), 1,
      sym_comment,
  [157757] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4672), 1,
      sym_name,
    STATE(3369), 1,
      sym_comment,
  [157767] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3858), 1,
      ts_builtin_sym_end,
    STATE(3370), 1,
      sym_comment,
  [157777] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4674), 1,
      anon_sym_end,
    STATE(3371), 1,
      sym_comment,
  [157787] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4676), 1,
      anon_sym_end,
    STATE(3372), 1,
      sym_comment,
  [157797] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4678), 1,
      anon_sym_EQ,
    STATE(3373), 1,
      sym_comment,
  [157807] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4680), 1,
      anon_sym_RPAREN,
    STATE(3374), 1,
      sym_comment,
  [157817] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4682), 1,
      anon_sym_end,
    STATE(3375), 1,
      sym_comment,
  [157827] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4684), 1,
      anon_sym_RPAREN,
    STATE(3376), 1,
      sym_comment,
  [157837] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4686), 1,
      anon_sym_end,
    STATE(3377), 1,
      sym_comment,
  [157847] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4688), 1,
      anon_sym_end,
    STATE(3378), 1,
      sym_comment,
  [157857] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4690), 1,
      sym_name,
    STATE(3379), 1,
      sym_comment,
  [157867] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4692), 1,
      sym_name,
    STATE(3380), 1,
      sym_comment,
  [157877] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4694), 1,
      aux_sym_type_stmt_token1,
    STATE(3381), 1,
      sym_comment,
  [157887] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4696), 1,
      anon_sym_end,
    STATE(3382), 1,
      sym_comment,
  [157897] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4698), 1,
      anon_sym_EQ,
    STATE(3383), 1,
      sym_comment,
  [157907] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4700), 1,
      anon_sym_end,
    STATE(3384), 1,
      sym_comment,
  [157917] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4702), 1,
      sym_name,
    STATE(3385), 1,
      sym_comment,
  [157927] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4704), 1,
      anon_sym_end,
    STATE(3386), 1,
      sym_comment,
  [157937] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4706), 1,
      anon_sym_until,
    STATE(3387), 1,
      sym_comment,
  [157947] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3939), 1,
      anon_sym_end,
    STATE(3388), 1,
      sym_comment,
  [157957] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4708), 1,
      anon_sym_end,
    STATE(3389), 1,
      sym_comment,
  [157967] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4710), 1,
      sym_name,
    STATE(3390), 1,
      sym_comment,
  [157977] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4712), 1,
      anon_sym_end,
    STATE(3391), 1,
      sym_comment,
  [157987] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4714), 1,
      aux_sym_type_stmt_token1,
    STATE(3392), 1,
      sym_comment,
  [157997] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4716), 1,
      sym_name,
    STATE(3393), 1,
      sym_comment,
  [158007] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4718), 1,
      anon_sym_end,
    STATE(3394), 1,
      sym_comment,
  [158017] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4720), 1,
      sym_name,
    STATE(3395), 1,
      sym_comment,
  [158027] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4722), 1,
      anon_sym_RPAREN,
    STATE(3396), 1,
      sym_comment,
  [158037] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4724), 1,
      sym_name,
    STATE(3397), 1,
      sym_comment,
  [158047] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4726), 1,
      anon_sym_end,
    STATE(3398), 1,
      sym_comment,
  [158057] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4728), 1,
      anon_sym_do,
    STATE(3399), 1,
      sym_comment,
  [158067] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4730), 1,
      anon_sym_end,
    STATE(3400), 1,
      sym_comment,
  [158077] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4732), 1,
      anon_sym_end,
    STATE(3401), 1,
      sym_comment,
  [158087] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4734), 1,
      anon_sym_RPAREN,
    STATE(3402), 1,
      sym_comment,
  [158097] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4736), 1,
      sym_name,
    STATE(3403), 1,
      sym_comment,
  [158107] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4738), 1,
      anon_sym_end,
    STATE(3404), 1,
      sym_comment,
  [158117] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4740), 1,
      anon_sym_RBRACE,
    STATE(3405), 1,
      sym_comment,
  [158127] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4742), 1,
      anon_sym_GT,
    STATE(3406), 1,
      sym_comment,
  [158137] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4744), 1,
      anon_sym_EQ,
    STATE(3407), 1,
      sym_comment,
  [158147] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4746), 1,
      anon_sym_RPAREN,
    STATE(3408), 1,
      sym_comment,
  [158157] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4748), 1,
      anon_sym_end,
    STATE(3409), 1,
      sym_comment,
  [158167] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4750), 1,
      anon_sym_end,
    STATE(3410), 1,
      sym_comment,
  [158177] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4752), 1,
      anon_sym_end,
    STATE(3411), 1,
      sym_comment,
  [158187] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4754), 1,
      sym_name,
    STATE(3412), 1,
      sym_comment,
  [158197] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4756), 1,
      aux_sym_attribute_token1,
    STATE(3413), 1,
      sym_comment,
  [158207] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4758), 1,
      anon_sym_RPAREN,
    STATE(3414), 1,
      sym_comment,
  [158217] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3939), 1,
      ts_builtin_sym_end,
    STATE(3415), 1,
      sym_comment,
  [158227] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4760), 1,
      anon_sym_RPAREN,
    STATE(3416), 1,
      sym_comment,
  [158237] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4762), 1,
      anon_sym_RBRACE2,
    STATE(3417), 1,
      sym_comment,
  [158247] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4764), 1,
      sym_name,
    STATE(3418), 1,
      sym_comment,
  [158257] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4766), 1,
      anon_sym_end,
    STATE(3419), 1,
      sym_comment,
  [158267] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3858), 1,
      anon_sym_end,
    STATE(3420), 1,
      sym_comment,
  [158277] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(754), 1,
      ts_builtin_sym_end,
    STATE(3421), 1,
      sym_comment,
  [158287] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4768), 1,
      anon_sym_RBRACE,
    STATE(3422), 1,
      sym_comment,
  [158297] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4770), 1,
      anon_sym_RPAREN,
    STATE(3423), 1,
      sym_comment,
  [158307] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4772), 1,
      sym_name,
    STATE(3424), 1,
      sym_comment,
  [158317] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4774), 1,
      anon_sym_RPAREN,
    STATE(3425), 1,
      sym_comment,
  [158327] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4776), 1,
      anon_sym_EQ,
    STATE(3426), 1,
      sym_comment,
  [158337] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4778), 1,
      anon_sym_RBRACE,
    STATE(3427), 1,
      sym_comment,
  [158347] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4006), 1,
      ts_builtin_sym_end,
    STATE(3428), 1,
      sym_comment,
  [158357] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4780), 1,
      anon_sym_RBRACE,
    STATE(3429), 1,
      sym_comment,
  [158367] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4782), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_comment,
  [158377] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4784), 1,
      anon_sym_end,
    STATE(3431), 1,
      sym_comment,
  [158387] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4786), 1,
      anon_sym_RPAREN,
    STATE(3432), 1,
      sym_comment,
  [158397] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4788), 1,
      anon_sym_end,
    STATE(3433), 1,
      sym_comment,
  [158407] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4790), 1,
      anon_sym_end,
    STATE(3434), 1,
      sym_comment,
  [158417] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4792), 1,
      anon_sym_GT,
    STATE(3435), 1,
      sym_comment,
  [158427] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4794), 1,
      anon_sym_end,
    STATE(3436), 1,
      sym_comment,
  [158437] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4796), 1,
      aux_sym_type_stmt_token1,
    STATE(3437), 1,
      sym_comment,
  [158447] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4798), 1,
      anon_sym_RPAREN,
    STATE(3438), 1,
      sym_comment,
  [158457] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4800), 1,
      anon_sym_end,
    STATE(3439), 1,
      sym_comment,
  [158467] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4802), 1,
      anon_sym_RBRACE,
    STATE(3440), 1,
      sym_comment,
  [158477] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4804), 1,
      anon_sym_end,
    STATE(3441), 1,
      sym_comment,
  [158487] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4806), 1,
      anon_sym_end,
    STATE(3442), 1,
      sym_comment,
  [158497] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4808), 1,
      sym_name,
    STATE(3443), 1,
      sym_comment,
  [158507] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4810), 1,
      sym_name,
    STATE(3444), 1,
      sym_comment,
  [158517] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4812), 1,
      anon_sym_RPAREN,
    STATE(3445), 1,
      sym_comment,
  [158527] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4814), 1,
      anon_sym_RBRACE,
    STATE(3446), 1,
      sym_comment,
  [158537] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4816), 1,
      anon_sym_RBRACE,
    STATE(3447), 1,
      sym_comment,
  [158547] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4818), 1,
      anon_sym_end,
    STATE(3448), 1,
      sym_comment,
  [158557] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4820), 1,
      anon_sym_RBRACE,
    STATE(3449), 1,
      sym_comment,
  [158567] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4822), 1,
      sym_name,
    STATE(3450), 1,
      sym_comment,
  [158577] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4824), 1,
      sym_name,
    STATE(3451), 1,
      sym_comment,
  [158587] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4826), 1,
      anon_sym_end,
    STATE(3452), 1,
      sym_comment,
  [158597] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4828), 1,
      anon_sym_RPAREN,
    STATE(3453), 1,
      sym_comment,
  [158607] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4830), 1,
      anon_sym_end,
    STATE(3454), 1,
      sym_comment,
  [158617] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4832), 1,
      anon_sym_end,
    STATE(3455), 1,
      sym_comment,
  [158627] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4834), 1,
      anon_sym_end,
    STATE(3456), 1,
      sym_comment,
  [158637] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4836), 1,
      anon_sym_end,
    STATE(3457), 1,
      sym_comment,
  [158647] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4838), 1,
      anon_sym_end,
    STATE(3458), 1,
      sym_comment,
  [158657] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4840), 1,
      anon_sym_GT,
    STATE(3459), 1,
      sym_comment,
  [158667] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4842), 1,
      anon_sym_end,
    STATE(3460), 1,
      sym_comment,
  [158677] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4844), 1,
      anon_sym_EQ,
    STATE(3461), 1,
      sym_comment,
  [158687] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4846), 1,
      sym_name,
    STATE(3462), 1,
      sym_comment,
  [158697] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4848), 1,
      anon_sym_RBRACE,
    STATE(3463), 1,
      sym_comment,
  [158707] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4850), 1,
      anon_sym_GT,
    STATE(3464), 1,
      sym_comment,
  [158717] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4852), 1,
      anon_sym_RPAREN,
    STATE(3465), 1,
      sym_comment,
  [158727] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4854), 1,
      anon_sym_RPAREN,
    STATE(3466), 1,
      sym_comment,
  [158737] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4856), 1,
      anon_sym_end,
    STATE(3467), 1,
      sym_comment,
  [158747] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4858), 1,
      anon_sym_RPAREN,
    STATE(3468), 1,
      sym_comment,
  [158757] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4860), 1,
      anon_sym_end,
    STATE(3469), 1,
      sym_comment,
  [158767] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4862), 1,
      anon_sym_end,
    STATE(3470), 1,
      sym_comment,
  [158777] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4864), 1,
      anon_sym_RPAREN,
    STATE(3471), 1,
      sym_comment,
  [158787] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4866), 1,
      anon_sym_end,
    STATE(3472), 1,
      sym_comment,
  [158797] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4868), 1,
      sym_name,
    STATE(3473), 1,
      sym_comment,
  [158807] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4870), 1,
      anon_sym_end,
    STATE(3474), 1,
      sym_comment,
  [158817] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4872), 1,
      anon_sym_RPAREN,
    STATE(3475), 1,
      sym_comment,
  [158827] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4874), 1,
      aux_sym_dec_byte_escape_token1,
    STATE(3476), 1,
      sym_comment,
  [158837] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4876), 1,
      anon_sym_end,
    STATE(3477), 1,
      sym_comment,
  [158847] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4878), 1,
      sym_name,
    STATE(3478), 1,
      sym_comment,
  [158857] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4880), 1,
      anon_sym_end,
    STATE(3479), 1,
      sym_comment,
  [158867] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4882), 1,
      sym_name,
    STATE(3480), 1,
      sym_comment,
  [158877] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4884), 1,
      anon_sym_end,
    STATE(3481), 1,
      sym_comment,
  [158887] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4886), 1,
      anon_sym_end,
    STATE(3482), 1,
      sym_comment,
  [158897] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4888), 1,
      anon_sym_RPAREN,
    STATE(3483), 1,
      sym_comment,
  [158907] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4890), 1,
      anon_sym_GT,
    STATE(3484), 1,
      sym_comment,
  [158917] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4892), 1,
      anon_sym_RBRACE2,
    STATE(3485), 1,
      sym_comment,
  [158927] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4894), 1,
      anon_sym_end,
    STATE(3486), 1,
      sym_comment,
  [158937] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4896), 1,
      anon_sym_end,
    STATE(3487), 1,
      sym_comment,
  [158947] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4898), 1,
      anon_sym_GT,
    STATE(3488), 1,
      sym_comment,
  [158957] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4900), 1,
      anon_sym_GT,
    STATE(3489), 1,
      sym_comment,
  [158967] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4902), 1,
      anon_sym_RPAREN,
    STATE(3490), 1,
      sym_comment,
  [158977] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4904), 1,
      anon_sym_end,
    STATE(3491), 1,
      sym_comment,
  [158987] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4906), 1,
      anon_sym_LPAREN,
    STATE(3492), 1,
      sym_comment,
  [158997] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4908), 1,
      aux_sym_hex_byte_escape_token1,
    STATE(3493), 1,
      sym_comment,
  [159007] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4910), 1,
      anon_sym_end,
    STATE(3494), 1,
      sym_comment,
  [159017] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4912), 1,
      anon_sym_end,
    STATE(3495), 1,
      sym_comment,
  [159027] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4914), 1,
      anon_sym_end,
    STATE(3496), 1,
      sym_comment,
  [159037] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4916), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      sym_comment,
  [159047] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4918), 1,
      anon_sym_RPAREN,
    STATE(3498), 1,
      sym_comment,
  [159057] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4920), 1,
      anon_sym_RBRACE,
    STATE(3499), 1,
      sym_comment,
  [159067] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4016), 1,
      anon_sym_end,
    STATE(3500), 1,
      sym_comment,
  [159077] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4922), 1,
      anon_sym_end,
    STATE(3501), 1,
      sym_comment,
  [159087] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4924), 1,
      anon_sym_end,
    STATE(3502), 1,
      sym_comment,
  [159097] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4926), 1,
      anon_sym_end,
    STATE(3503), 1,
      sym_comment,
  [159107] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4928), 1,
      anon_sym_end,
    STATE(3504), 1,
      sym_comment,
  [159117] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4930), 1,
      anon_sym_RPAREN,
    STATE(3505), 1,
      sym_comment,
  [159127] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4932), 1,
      anon_sym_end,
    STATE(3506), 1,
      sym_comment,
  [159137] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4006), 1,
      anon_sym_end,
    STATE(3507), 1,
      sym_comment,
  [159147] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4934), 1,
      anon_sym_end,
    STATE(3508), 1,
      sym_comment,
  [159157] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4936), 1,
      sym_name,
    STATE(3509), 1,
      sym_comment,
  [159167] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4938), 1,
      anon_sym_until,
    STATE(3510), 1,
      sym_comment,
  [159177] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4940), 1,
      anon_sym_end,
    STATE(3511), 1,
      sym_comment,
  [159187] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4942), 1,
      anon_sym_end,
    STATE(3512), 1,
      sym_comment,
  [159197] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4944), 1,
      anon_sym_RPAREN,
    STATE(3513), 1,
      sym_comment,
  [159207] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4946), 1,
      anon_sym_end,
    STATE(3514), 1,
      sym_comment,
  [159217] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4948), 1,
      aux_sym_type_stmt_token1,
    STATE(3515), 1,
      sym_comment,
  [159227] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4950), 1,
      anon_sym_EQ,
    STATE(3516), 1,
      sym_comment,
  [159237] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4952), 1,
      anon_sym_GT,
    STATE(3517), 1,
      sym_comment,
  [159247] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4954), 1,
      anon_sym_end,
    STATE(3518), 1,
      sym_comment,
  [159257] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4956), 1,
      anon_sym_end,
    STATE(3519), 1,
      sym_comment,
  [159267] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4958), 1,
      anon_sym_RPAREN,
    STATE(3520), 1,
      sym_comment,
  [159277] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4960), 1,
      anon_sym_LPAREN,
    STATE(3521), 1,
      sym_comment,
  [159287] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4962), 1,
      anon_sym_RBRACK,
    STATE(3522), 1,
      sym_comment,
  [159297] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4964), 1,
      sym_name,
    STATE(3523), 1,
      sym_comment,
  [159307] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4966), 1,
      anon_sym_end,
    STATE(3524), 1,
      sym_comment,
  [159317] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4968), 1,
      anon_sym_end,
    STATE(3525), 1,
      sym_comment,
  [159327] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4970), 1,
      anon_sym_RPAREN,
    STATE(3526), 1,
      sym_comment,
  [159337] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(754), 1,
      anon_sym_end,
    STATE(3527), 1,
      sym_comment,
  [159347] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4972), 1,
      anon_sym_RPAREN,
    STATE(3528), 1,
      sym_comment,
  [159357] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4974), 1,
      anon_sym_end,
    STATE(3529), 1,
      sym_comment,
  [159367] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3858), 1,
      anon_sym_until,
    STATE(3530), 1,
      sym_comment,
  [159377] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4976), 1,
      sym_name,
    STATE(3531), 1,
      sym_comment,
  [159387] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4978), 1,
      anon_sym_end,
    STATE(3532), 1,
      sym_comment,
  [159397] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4980), 1,
      anon_sym_end,
    STATE(3533), 1,
      sym_comment,
  [159407] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4982), 1,
      anon_sym_LPAREN,
    STATE(3534), 1,
      sym_comment,
  [159417] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4984), 1,
      anon_sym_RPAREN,
    STATE(3535), 1,
      sym_comment,
  [159427] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4986), 1,
      anon_sym_end,
    STATE(3536), 1,
      sym_comment,
  [159437] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(1167), 1,
      anon_sym_RBRACE,
    STATE(3537), 1,
      sym_comment,
  [159447] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4988), 1,
      anon_sym_end,
    STATE(3538), 1,
      sym_comment,
  [159457] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4990), 1,
      sym_name,
    STATE(3539), 1,
      sym_comment,
  [159467] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4992), 1,
      anon_sym_RPAREN,
    STATE(3540), 1,
      sym_comment,
  [159477] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4994), 1,
      aux_sym_type_stmt_token1,
    STATE(3541), 1,
      sym_comment,
  [159487] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4996), 1,
      anon_sym_RPAREN,
    STATE(3542), 1,
      sym_comment,
  [159497] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4998), 1,
      anon_sym_RBRACE,
    STATE(3543), 1,
      sym_comment,
  [159507] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5000), 1,
      anon_sym_RBRACE,
    STATE(3544), 1,
      sym_comment,
  [159517] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5002), 1,
      anon_sym_end,
    STATE(3545), 1,
      sym_comment,
  [159527] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3972), 1,
      anon_sym_GT,
    STATE(3546), 1,
      sym_comment,
  [159537] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5004), 1,
      anon_sym_RPAREN,
    STATE(3547), 1,
      sym_comment,
  [159547] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5006), 1,
      anon_sym_RPAREN,
    STATE(3548), 1,
      sym_comment,
  [159557] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5008), 1,
      sym_name,
    STATE(3549), 1,
      sym_comment,
  [159567] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5010), 1,
      anon_sym_end,
    STATE(3550), 1,
      sym_comment,
  [159577] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5012), 1,
      anon_sym_GT,
    STATE(3551), 1,
      sym_comment,
  [159587] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5014), 1,
      anon_sym_end,
    STATE(3552), 1,
      sym_comment,
  [159597] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5016), 1,
      anon_sym_RBRACE,
    STATE(3553), 1,
      sym_comment,
  [159607] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5018), 1,
      anon_sym_RPAREN,
    STATE(3554), 1,
      sym_comment,
  [159617] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5020), 1,
      anon_sym_EQ,
    STATE(3555), 1,
      sym_comment,
  [159627] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5022), 1,
      anon_sym_RBRACE,
    STATE(3556), 1,
      sym_comment,
  [159637] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5024), 1,
      anon_sym_end,
    STATE(3557), 1,
      sym_comment,
  [159647] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5026), 1,
      anon_sym_RBRACE,
    STATE(3558), 1,
      sym_comment,
  [159657] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5028), 1,
      anon_sym_RPAREN,
    STATE(3559), 1,
      sym_comment,
  [159667] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5030), 1,
      sym_name,
    STATE(3560), 1,
      sym_comment,
  [159677] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5032), 1,
      anon_sym_RPAREN,
    STATE(3561), 1,
      sym_comment,
  [159687] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5034), 1,
      anon_sym_end,
    STATE(3562), 1,
      sym_comment,
  [159697] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5036), 1,
      sym_name,
    STATE(3563), 1,
      sym_comment,
  [159707] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5038), 1,
      anon_sym_RPAREN,
    STATE(3564), 1,
      sym_comment,
  [159717] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5040), 1,
      anon_sym_end,
    STATE(3565), 1,
      sym_comment,
  [159727] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5042), 1,
      anon_sym_RPAREN,
    STATE(3566), 1,
      sym_comment,
  [159737] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5044), 1,
      anon_sym_GT,
    STATE(3567), 1,
      sym_comment,
  [159747] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5046), 1,
      anon_sym_RPAREN,
    STATE(3568), 1,
      sym_comment,
  [159757] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5048), 1,
      anon_sym_GT,
    STATE(3569), 1,
      sym_comment,
  [159767] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5050), 1,
      anon_sym_RPAREN,
    STATE(3570), 1,
      sym_comment,
  [159777] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5052), 1,
      anon_sym_RPAREN,
    STATE(3571), 1,
      sym_comment,
  [159787] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5054), 1,
      anon_sym_end,
    STATE(3572), 1,
      sym_comment,
  [159797] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5056), 1,
      aux_sym_unicode_escape_token1,
    STATE(3573), 1,
      sym_comment,
  [159807] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5058), 1,
      anon_sym_end,
    STATE(3574), 1,
      sym_comment,
  [159817] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5060), 1,
      anon_sym_end,
    STATE(3575), 1,
      sym_comment,
  [159827] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5062), 1,
      anon_sym_GT,
    STATE(3576), 1,
      sym_comment,
  [159837] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5064), 1,
      aux_sym_dec_byte_escape_token1,
    STATE(3577), 1,
      sym_comment,
  [159847] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5066), 1,
      anon_sym_RPAREN,
    STATE(3578), 1,
      sym_comment,
  [159857] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5068), 1,
      anon_sym_end,
    STATE(3579), 1,
      sym_comment,
  [159867] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5070), 1,
      anon_sym_RPAREN,
    STATE(3580), 1,
      sym_comment,
  [159877] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5072), 1,
      anon_sym_GT,
    STATE(3581), 1,
      sym_comment,
  [159887] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5074), 1,
      anon_sym_end,
    STATE(3582), 1,
      sym_comment,
  [159897] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5076), 1,
      anon_sym_end,
    STATE(3583), 1,
      sym_comment,
  [159907] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5078), 1,
      anon_sym_GT,
    STATE(3584), 1,
      sym_comment,
  [159917] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5080), 1,
      anon_sym_end,
    STATE(3585), 1,
      sym_comment,
  [159927] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5082), 1,
      anon_sym_end,
    STATE(3586), 1,
      sym_comment,
  [159937] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5084), 1,
      anon_sym_end,
    STATE(3587), 1,
      sym_comment,
  [159947] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5086), 1,
      anon_sym_end,
    STATE(3588), 1,
      sym_comment,
  [159957] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5088), 1,
      anon_sym_end,
    STATE(3589), 1,
      sym_comment,
  [159967] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5090), 1,
      anon_sym_RBRACE,
    STATE(3590), 1,
      sym_comment,
  [159977] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5092), 1,
      anon_sym_RPAREN,
    STATE(3591), 1,
      sym_comment,
  [159987] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5094), 1,
      anon_sym_end,
    STATE(3592), 1,
      sym_comment,
  [159997] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5096), 1,
      anon_sym_type,
    STATE(3593), 1,
      sym_comment,
  [160007] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5098), 1,
      anon_sym_function,
    STATE(3594), 1,
      sym_comment,
  [160017] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5100), 1,
      anon_sym_LBRACE2,
    STATE(3595), 1,
      sym_comment,
  [160027] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5102), 1,
      anon_sym_end,
    STATE(3596), 1,
      sym_comment,
  [160037] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5104), 1,
      anon_sym_RBRACE,
    STATE(3597), 1,
      sym_comment,
  [160047] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5106), 1,
      anon_sym_LPAREN,
    STATE(3598), 1,
      sym_comment,
  [160057] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5108), 1,
      anon_sym_LPAREN,
    STATE(3599), 1,
      sym_comment,
  [160067] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5110), 1,
      anon_sym_GT,
    STATE(3600), 1,
      sym_comment,
  [160077] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5112), 1,
      anon_sym_GT,
    STATE(3601), 1,
      sym_comment,
  [160087] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5114), 1,
      anon_sym_end,
    STATE(3602), 1,
      sym_comment,
  [160097] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5116), 1,
      sym_name,
    STATE(3603), 1,
      sym_comment,
  [160107] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5118), 1,
      anon_sym_type,
    STATE(3604), 1,
      sym_comment,
  [160117] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5120), 1,
      anon_sym_end,
    STATE(3605), 1,
      sym_comment,
  [160127] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5122), 1,
      anon_sym_type,
    STATE(3606), 1,
      sym_comment,
  [160137] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5124), 1,
      anon_sym_function,
    STATE(3607), 1,
      sym_comment,
  [160147] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5126), 1,
      anon_sym_end,
    STATE(3608), 1,
      sym_comment,
  [160157] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5128), 1,
      anon_sym_end,
    STATE(3609), 1,
      sym_comment,
  [160167] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5130), 1,
      anon_sym_LPAREN,
    STATE(3610), 1,
      sym_comment,
  [160177] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5132), 1,
      anon_sym_LPAREN,
    STATE(3611), 1,
      sym_comment,
  [160187] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5134), 1,
      anon_sym_end,
    STATE(3612), 1,
      sym_comment,
  [160197] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5136), 1,
      anon_sym_GT,
    STATE(3613), 1,
      sym_comment,
  [160207] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5138), 1,
      anon_sym_end,
    STATE(3614), 1,
      sym_comment,
  [160217] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5140), 1,
      anon_sym_end,
    STATE(3615), 1,
      sym_comment,
  [160227] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5142), 1,
      anon_sym_RPAREN,
    STATE(3616), 1,
      sym_comment,
  [160237] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5144), 1,
      anon_sym_end,
    STATE(3617), 1,
      sym_comment,
  [160247] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5146), 1,
      anon_sym_type,
    STATE(3618), 1,
      sym_comment,
  [160257] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5148), 1,
      anon_sym_function,
    STATE(3619), 1,
      sym_comment,
  [160267] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5150), 1,
      anon_sym_end,
    STATE(3620), 1,
      sym_comment,
  [160277] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5152), 1,
      anon_sym_GT,
    STATE(3621), 1,
      sym_comment,
  [160287] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5154), 1,
      anon_sym_LPAREN,
    STATE(3622), 1,
      sym_comment,
  [160297] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5156), 1,
      anon_sym_LPAREN,
    STATE(3623), 1,
      sym_comment,
  [160307] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5158), 1,
      anon_sym_GT,
    STATE(3624), 1,
      sym_comment,
  [160317] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5160), 1,
      anon_sym_GT,
    STATE(3625), 1,
      sym_comment,
  [160327] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5162), 1,
      anon_sym_RPAREN,
    STATE(3626), 1,
      sym_comment,
  [160337] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5164), 1,
      anon_sym_DASH_GT,
    STATE(3627), 1,
      sym_comment,
  [160347] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5166), 1,
      anon_sym_LPAREN,
    STATE(3628), 1,
      sym_comment,
  [160357] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5168), 1,
      anon_sym_LPAREN,
    STATE(3629), 1,
      sym_comment,
  [160367] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5170), 1,
      sym_name,
    STATE(3630), 1,
      sym_comment,
  [160377] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5172), 1,
      anon_sym_LPAREN,
    STATE(3631), 1,
      sym_comment,
  [160387] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5174), 1,
      anon_sym_LPAREN,
    STATE(3632), 1,
      sym_comment,
  [160397] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5176), 1,
      anon_sym_end,
    STATE(3633), 1,
      sym_comment,
  [160407] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5178), 1,
      anon_sym_LPAREN,
    STATE(3634), 1,
      sym_comment,
  [160417] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5180), 1,
      anon_sym_LPAREN,
    STATE(3635), 1,
      sym_comment,
  [160427] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5182), 1,
      anon_sym_end,
    STATE(3636), 1,
      sym_comment,
  [160437] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5184), 1,
      anon_sym_LPAREN,
    STATE(3637), 1,
      sym_comment,
  [160447] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5186), 1,
      anon_sym_LPAREN,
    STATE(3638), 1,
      sym_comment,
  [160457] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5188), 1,
      anon_sym_end,
    STATE(3639), 1,
      sym_comment,
  [160467] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5190), 1,
      anon_sym_LPAREN,
    STATE(3640), 1,
      sym_comment,
  [160477] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5192), 1,
      anon_sym_LPAREN,
    STATE(3641), 1,
      sym_comment,
  [160487] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5194), 1,
      anon_sym_RBRACE,
    STATE(3642), 1,
      sym_comment,
  [160497] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5196), 1,
      anon_sym_LPAREN,
    STATE(3643), 1,
      sym_comment,
  [160507] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5198), 1,
      anon_sym_LPAREN,
    STATE(3644), 1,
      sym_comment,
  [160517] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5200), 1,
      anon_sym_end,
    STATE(3645), 1,
      sym_comment,
  [160527] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    STATE(3646), 1,
      sym_comment,
  [160537] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5204), 1,
      anon_sym_LPAREN,
    STATE(3647), 1,
      sym_comment,
  [160547] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5206), 1,
      anon_sym_RPAREN,
    STATE(3648), 1,
      sym_comment,
  [160557] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5208), 1,
      anon_sym_LPAREN,
    STATE(3649), 1,
      sym_comment,
  [160567] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5210), 1,
      anon_sym_LPAREN,
    STATE(3650), 1,
      sym_comment,
  [160577] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5212), 1,
      anon_sym_LPAREN,
    STATE(3651), 1,
      sym_comment,
  [160587] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5214), 1,
      anon_sym_LPAREN,
    STATE(3652), 1,
      sym_comment,
  [160597] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5216), 1,
      anon_sym_LPAREN,
    STATE(3653), 1,
      sym_comment,
  [160607] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5218), 1,
      anon_sym_LPAREN,
    STATE(3654), 1,
      sym_comment,
  [160617] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5220), 1,
      anon_sym_LPAREN,
    STATE(3655), 1,
      sym_comment,
  [160627] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5222), 1,
      anon_sym_LPAREN,
    STATE(3656), 1,
      sym_comment,
  [160637] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5224), 1,
      anon_sym_LPAREN,
    STATE(3657), 1,
      sym_comment,
  [160647] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5226), 1,
      anon_sym_LPAREN,
    STATE(3658), 1,
      sym_comment,
  [160657] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5228), 1,
      anon_sym_LPAREN,
    STATE(3659), 1,
      sym_comment,
  [160667] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5230), 1,
      anon_sym_LPAREN,
    STATE(3660), 1,
      sym_comment,
  [160677] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5232), 1,
      aux_sym_type_stmt_token1,
    STATE(3661), 1,
      sym_comment,
  [160687] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5234), 1,
      aux_sym_hex_byte_escape_token1,
    STATE(3662), 1,
      sym_comment,
  [160697] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5236), 1,
      anon_sym_in,
    STATE(3663), 1,
      sym_comment,
  [160707] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5238), 1,
      anon_sym_GT,
    STATE(3664), 1,
      sym_comment,
  [160717] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5240), 1,
      anon_sym_end,
    STATE(3665), 1,
      sym_comment,
  [160727] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5242), 1,
      anon_sym_end,
    STATE(3666), 1,
      sym_comment,
  [160737] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5244), 1,
      aux_sym_type_stmt_token1,
    STATE(3667), 1,
      sym_comment,
  [160747] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5246), 1,
      anon_sym_RBRACE,
    STATE(3668), 1,
      sym_comment,
  [160757] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5248), 1,
      anon_sym_in,
    STATE(3669), 1,
      sym_comment,
  [160767] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5250), 1,
      anon_sym_GT,
    STATE(3670), 1,
      sym_comment,
  [160777] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5252), 1,
      anon_sym_end,
    STATE(3671), 1,
      sym_comment,
  [160787] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5254), 1,
      anon_sym_GT,
    STATE(3672), 1,
      sym_comment,
  [160797] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5256), 1,
      aux_sym_type_stmt_token1,
    STATE(3673), 1,
      sym_comment,
  [160807] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5258), 1,
      anon_sym_RBRACE,
    STATE(3674), 1,
      sym_comment,
  [160817] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5260), 1,
      anon_sym_in,
    STATE(3675), 1,
      sym_comment,
  [160827] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5262), 1,
      anon_sym_GT,
    STATE(3676), 1,
      sym_comment,
  [160837] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5264), 1,
      anon_sym_end,
    STATE(3677), 1,
      sym_comment,
  [160847] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5266), 1,
      anon_sym_RBRACE,
    STATE(3678), 1,
      sym_comment,
  [160857] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5268), 1,
      anon_sym_RBRACE,
    STATE(3679), 1,
      sym_comment,
  [160867] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5270), 1,
      anon_sym_GT,
    STATE(3680), 1,
      sym_comment,
  [160877] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5272), 1,
      anon_sym_RPAREN,
    STATE(3681), 1,
      sym_comment,
  [160887] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5274), 1,
      anon_sym_GT,
    STATE(3682), 1,
      sym_comment,
  [160897] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5276), 1,
      anon_sym_RBRACE,
    STATE(3683), 1,
      sym_comment,
  [160907] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5278), 1,
      anon_sym_GT,
    STATE(3684), 1,
      sym_comment,
  [160917] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5280), 1,
      anon_sym_end,
    STATE(3685), 1,
      sym_comment,
  [160927] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5282), 1,
      anon_sym_GT,
    STATE(3686), 1,
      sym_comment,
  [160937] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5284), 1,
      anon_sym_GT,
    STATE(3687), 1,
      sym_comment,
  [160947] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5286), 1,
      anon_sym_GT,
    STATE(3688), 1,
      sym_comment,
  [160957] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5288), 1,
      sym_name,
    STATE(3689), 1,
      sym_comment,
  [160967] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5290), 1,
      anon_sym_GT,
    STATE(3690), 1,
      sym_comment,
  [160977] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5292), 1,
      anon_sym_end,
    STATE(3691), 1,
      sym_comment,
  [160987] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5294), 1,
      anon_sym_GT,
    STATE(3692), 1,
      sym_comment,
  [160997] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(3939), 1,
      anon_sym_until,
    STATE(3693), 1,
      sym_comment,
  [161007] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5296), 1,
      anon_sym_GT,
    STATE(3694), 1,
      sym_comment,
  [161017] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5298), 1,
      anon_sym_GT,
    STATE(3695), 1,
      sym_comment,
  [161027] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5300), 1,
      anon_sym_GT,
    STATE(3696), 1,
      sym_comment,
  [161037] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5302), 1,
      anon_sym_GT,
    STATE(3697), 1,
      sym_comment,
  [161047] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5304), 1,
      anon_sym_GT,
    STATE(3698), 1,
      sym_comment,
  [161057] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5306), 1,
      anon_sym_end,
    STATE(3699), 1,
      sym_comment,
  [161067] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5308), 1,
      anon_sym_end,
    STATE(3700), 1,
      sym_comment,
  [161077] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5310), 1,
      anon_sym_end,
    STATE(3701), 1,
      sym_comment,
  [161087] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5312), 1,
      anon_sym_end,
    STATE(3702), 1,
      sym_comment,
  [161097] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(4006), 1,
      anon_sym_until,
    STATE(3703), 1,
      sym_comment,
  [161107] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5314), 1,
      anon_sym_end,
    STATE(3704), 1,
      sym_comment,
  [161117] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5316), 1,
      anon_sym_end,
    STATE(3705), 1,
      sym_comment,
  [161127] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5318), 1,
      anon_sym_GT,
    STATE(3706), 1,
      sym_comment,
  [161137] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(947), 1,
      anon_sym_DASH_GT,
    STATE(3707), 1,
      sym_comment,
  [161147] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5320), 1,
      anon_sym_RPAREN,
    STATE(3708), 1,
      sym_comment,
  [161157] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5322), 1,
      anon_sym_RBRACE,
    STATE(3709), 1,
      sym_comment,
  [161167] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5324), 1,
      anon_sym_end,
    STATE(3710), 1,
      sym_comment,
  [161177] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5326), 1,
      anon_sym_end,
    STATE(3711), 1,
      sym_comment,
  [161187] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5328), 1,
      anon_sym_end,
    STATE(3712), 1,
      sym_comment,
  [161197] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5330), 1,
      anon_sym_end,
    STATE(3713), 1,
      sym_comment,
  [161207] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5332), 1,
      anon_sym_end,
    STATE(3714), 1,
      sym_comment,
  [161217] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5334), 1,
      anon_sym_end,
    STATE(3715), 1,
      sym_comment,
  [161227] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5336), 1,
      anon_sym_end,
    STATE(3716), 1,
      sym_comment,
  [161237] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5338), 1,
      anon_sym_GT,
    STATE(3717), 1,
      sym_comment,
  [161247] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5340), 1,
      sym_name,
    STATE(3718), 1,
      sym_comment,
  [161257] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5342), 1,
      anon_sym_end,
    STATE(3719), 1,
      sym_comment,
  [161267] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5344), 1,
      anon_sym_end,
    STATE(3720), 1,
      sym_comment,
  [161277] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5346), 1,
      anon_sym_end,
    STATE(3721), 1,
      sym_comment,
  [161287] = 3,
    ACTIONS(3), 1,
      sym__comment_start,
    ACTIONS(5348), 1,
      anon_sym_RPAREN,
    STATE(3722), 1,
      sym_comment,
  [161297] = 1,
    ACTIONS(5350), 1,
      ts_builtin_sym_end,
  [161301] = 1,
    ACTIONS(5352), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 134,
  [SMALL_STATE(4)] = 268,
  [SMALL_STATE(5)] = 402,
  [SMALL_STATE(6)] = 536,
  [SMALL_STATE(7)] = 657,
  [SMALL_STATE(8)] = 779,
  [SMALL_STATE(9)] = 901,
  [SMALL_STATE(10)] = 1023,
  [SMALL_STATE(11)] = 1145,
  [SMALL_STATE(12)] = 1267,
  [SMALL_STATE(13)] = 1389,
  [SMALL_STATE(14)] = 1511,
  [SMALL_STATE(15)] = 1633,
  [SMALL_STATE(16)] = 1755,
  [SMALL_STATE(17)] = 1877,
  [SMALL_STATE(18)] = 1999,
  [SMALL_STATE(19)] = 2121,
  [SMALL_STATE(20)] = 2243,
  [SMALL_STATE(21)] = 2365,
  [SMALL_STATE(22)] = 2487,
  [SMALL_STATE(23)] = 2609,
  [SMALL_STATE(24)] = 2731,
  [SMALL_STATE(25)] = 2853,
  [SMALL_STATE(26)] = 2975,
  [SMALL_STATE(27)] = 3097,
  [SMALL_STATE(28)] = 3219,
  [SMALL_STATE(29)] = 3341,
  [SMALL_STATE(30)] = 3463,
  [SMALL_STATE(31)] = 3585,
  [SMALL_STATE(32)] = 3707,
  [SMALL_STATE(33)] = 3829,
  [SMALL_STATE(34)] = 3951,
  [SMALL_STATE(35)] = 4073,
  [SMALL_STATE(36)] = 4195,
  [SMALL_STATE(37)] = 4317,
  [SMALL_STATE(38)] = 4439,
  [SMALL_STATE(39)] = 4561,
  [SMALL_STATE(40)] = 4683,
  [SMALL_STATE(41)] = 4805,
  [SMALL_STATE(42)] = 4927,
  [SMALL_STATE(43)] = 5049,
  [SMALL_STATE(44)] = 5171,
  [SMALL_STATE(45)] = 5293,
  [SMALL_STATE(46)] = 5415,
  [SMALL_STATE(47)] = 5537,
  [SMALL_STATE(48)] = 5659,
  [SMALL_STATE(49)] = 5781,
  [SMALL_STATE(50)] = 5903,
  [SMALL_STATE(51)] = 6025,
  [SMALL_STATE(52)] = 6147,
  [SMALL_STATE(53)] = 6269,
  [SMALL_STATE(54)] = 6391,
  [SMALL_STATE(55)] = 6513,
  [SMALL_STATE(56)] = 6635,
  [SMALL_STATE(57)] = 6757,
  [SMALL_STATE(58)] = 6879,
  [SMALL_STATE(59)] = 7001,
  [SMALL_STATE(60)] = 7123,
  [SMALL_STATE(61)] = 7245,
  [SMALL_STATE(62)] = 7367,
  [SMALL_STATE(63)] = 7489,
  [SMALL_STATE(64)] = 7611,
  [SMALL_STATE(65)] = 7733,
  [SMALL_STATE(66)] = 7855,
  [SMALL_STATE(67)] = 7977,
  [SMALL_STATE(68)] = 8099,
  [SMALL_STATE(69)] = 8221,
  [SMALL_STATE(70)] = 8343,
  [SMALL_STATE(71)] = 8465,
  [SMALL_STATE(72)] = 8584,
  [SMALL_STATE(73)] = 8703,
  [SMALL_STATE(74)] = 8822,
  [SMALL_STATE(75)] = 8941,
  [SMALL_STATE(76)] = 9060,
  [SMALL_STATE(77)] = 9179,
  [SMALL_STATE(78)] = 9298,
  [SMALL_STATE(79)] = 9417,
  [SMALL_STATE(80)] = 9536,
  [SMALL_STATE(81)] = 9655,
  [SMALL_STATE(82)] = 9774,
  [SMALL_STATE(83)] = 9893,
  [SMALL_STATE(84)] = 10012,
  [SMALL_STATE(85)] = 10131,
  [SMALL_STATE(86)] = 10250,
  [SMALL_STATE(87)] = 10369,
  [SMALL_STATE(88)] = 10488,
  [SMALL_STATE(89)] = 10607,
  [SMALL_STATE(90)] = 10726,
  [SMALL_STATE(91)] = 10845,
  [SMALL_STATE(92)] = 10964,
  [SMALL_STATE(93)] = 11083,
  [SMALL_STATE(94)] = 11202,
  [SMALL_STATE(95)] = 11321,
  [SMALL_STATE(96)] = 11440,
  [SMALL_STATE(97)] = 11559,
  [SMALL_STATE(98)] = 11678,
  [SMALL_STATE(99)] = 11797,
  [SMALL_STATE(100)] = 11916,
  [SMALL_STATE(101)] = 12035,
  [SMALL_STATE(102)] = 12154,
  [SMALL_STATE(103)] = 12273,
  [SMALL_STATE(104)] = 12392,
  [SMALL_STATE(105)] = 12511,
  [SMALL_STATE(106)] = 12630,
  [SMALL_STATE(107)] = 12749,
  [SMALL_STATE(108)] = 12868,
  [SMALL_STATE(109)] = 12987,
  [SMALL_STATE(110)] = 13106,
  [SMALL_STATE(111)] = 13225,
  [SMALL_STATE(112)] = 13344,
  [SMALL_STATE(113)] = 13463,
  [SMALL_STATE(114)] = 13582,
  [SMALL_STATE(115)] = 13701,
  [SMALL_STATE(116)] = 13820,
  [SMALL_STATE(117)] = 13939,
  [SMALL_STATE(118)] = 14058,
  [SMALL_STATE(119)] = 14177,
  [SMALL_STATE(120)] = 14296,
  [SMALL_STATE(121)] = 14415,
  [SMALL_STATE(122)] = 14534,
  [SMALL_STATE(123)] = 14653,
  [SMALL_STATE(124)] = 14772,
  [SMALL_STATE(125)] = 14891,
  [SMALL_STATE(126)] = 15010,
  [SMALL_STATE(127)] = 15129,
  [SMALL_STATE(128)] = 15248,
  [SMALL_STATE(129)] = 15367,
  [SMALL_STATE(130)] = 15486,
  [SMALL_STATE(131)] = 15605,
  [SMALL_STATE(132)] = 15724,
  [SMALL_STATE(133)] = 15843,
  [SMALL_STATE(134)] = 15962,
  [SMALL_STATE(135)] = 16081,
  [SMALL_STATE(136)] = 16200,
  [SMALL_STATE(137)] = 16319,
  [SMALL_STATE(138)] = 16434,
  [SMALL_STATE(139)] = 16553,
  [SMALL_STATE(140)] = 16672,
  [SMALL_STATE(141)] = 16791,
  [SMALL_STATE(142)] = 16910,
  [SMALL_STATE(143)] = 17029,
  [SMALL_STATE(144)] = 17148,
  [SMALL_STATE(145)] = 17267,
  [SMALL_STATE(146)] = 17386,
  [SMALL_STATE(147)] = 17505,
  [SMALL_STATE(148)] = 17624,
  [SMALL_STATE(149)] = 17743,
  [SMALL_STATE(150)] = 17862,
  [SMALL_STATE(151)] = 17981,
  [SMALL_STATE(152)] = 18100,
  [SMALL_STATE(153)] = 18219,
  [SMALL_STATE(154)] = 18338,
  [SMALL_STATE(155)] = 18457,
  [SMALL_STATE(156)] = 18576,
  [SMALL_STATE(157)] = 18695,
  [SMALL_STATE(158)] = 18814,
  [SMALL_STATE(159)] = 18933,
  [SMALL_STATE(160)] = 19052,
  [SMALL_STATE(161)] = 19171,
  [SMALL_STATE(162)] = 19290,
  [SMALL_STATE(163)] = 19409,
  [SMALL_STATE(164)] = 19528,
  [SMALL_STATE(165)] = 19647,
  [SMALL_STATE(166)] = 19766,
  [SMALL_STATE(167)] = 19885,
  [SMALL_STATE(168)] = 20004,
  [SMALL_STATE(169)] = 20123,
  [SMALL_STATE(170)] = 20242,
  [SMALL_STATE(171)] = 20361,
  [SMALL_STATE(172)] = 20480,
  [SMALL_STATE(173)] = 20599,
  [SMALL_STATE(174)] = 20718,
  [SMALL_STATE(175)] = 20837,
  [SMALL_STATE(176)] = 20956,
  [SMALL_STATE(177)] = 21075,
  [SMALL_STATE(178)] = 21194,
  [SMALL_STATE(179)] = 21313,
  [SMALL_STATE(180)] = 21432,
  [SMALL_STATE(181)] = 21551,
  [SMALL_STATE(182)] = 21670,
  [SMALL_STATE(183)] = 21789,
  [SMALL_STATE(184)] = 21908,
  [SMALL_STATE(185)] = 22027,
  [SMALL_STATE(186)] = 22146,
  [SMALL_STATE(187)] = 22265,
  [SMALL_STATE(188)] = 22384,
  [SMALL_STATE(189)] = 22503,
  [SMALL_STATE(190)] = 22622,
  [SMALL_STATE(191)] = 22741,
  [SMALL_STATE(192)] = 22860,
  [SMALL_STATE(193)] = 22979,
  [SMALL_STATE(194)] = 23098,
  [SMALL_STATE(195)] = 23217,
  [SMALL_STATE(196)] = 23336,
  [SMALL_STATE(197)] = 23455,
  [SMALL_STATE(198)] = 23574,
  [SMALL_STATE(199)] = 23693,
  [SMALL_STATE(200)] = 23812,
  [SMALL_STATE(201)] = 23931,
  [SMALL_STATE(202)] = 24050,
  [SMALL_STATE(203)] = 24169,
  [SMALL_STATE(204)] = 24288,
  [SMALL_STATE(205)] = 24407,
  [SMALL_STATE(206)] = 24526,
  [SMALL_STATE(207)] = 24645,
  [SMALL_STATE(208)] = 24764,
  [SMALL_STATE(209)] = 24883,
  [SMALL_STATE(210)] = 25002,
  [SMALL_STATE(211)] = 25121,
  [SMALL_STATE(212)] = 25240,
  [SMALL_STATE(213)] = 25359,
  [SMALL_STATE(214)] = 25478,
  [SMALL_STATE(215)] = 25597,
  [SMALL_STATE(216)] = 25716,
  [SMALL_STATE(217)] = 25835,
  [SMALL_STATE(218)] = 25954,
  [SMALL_STATE(219)] = 26073,
  [SMALL_STATE(220)] = 26192,
  [SMALL_STATE(221)] = 26311,
  [SMALL_STATE(222)] = 26430,
  [SMALL_STATE(223)] = 26549,
  [SMALL_STATE(224)] = 26668,
  [SMALL_STATE(225)] = 26787,
  [SMALL_STATE(226)] = 26851,
  [SMALL_STATE(227)] = 26959,
  [SMALL_STATE(228)] = 27023,
  [SMALL_STATE(229)] = 27089,
  [SMALL_STATE(230)] = 27202,
  [SMALL_STATE(231)] = 27315,
  [SMALL_STATE(232)] = 27428,
  [SMALL_STATE(233)] = 27490,
  [SMALL_STATE(234)] = 27544,
  [SMALL_STATE(235)] = 27598,
  [SMALL_STATE(236)] = 27652,
  [SMALL_STATE(237)] = 27760,
  [SMALL_STATE(238)] = 27814,
  [SMALL_STATE(239)] = 27868,
  [SMALL_STATE(240)] = 27922,
  [SMALL_STATE(241)] = 27976,
  [SMALL_STATE(242)] = 28030,
  [SMALL_STATE(243)] = 28084,
  [SMALL_STATE(244)] = 28190,
  [SMALL_STATE(245)] = 28296,
  [SMALL_STATE(246)] = 28350,
  [SMALL_STATE(247)] = 28412,
  [SMALL_STATE(248)] = 28476,
  [SMALL_STATE(249)] = 28538,
  [SMALL_STATE(250)] = 28600,
  [SMALL_STATE(251)] = 28664,
  [SMALL_STATE(252)] = 28726,
  [SMALL_STATE(253)] = 28780,
  [SMALL_STATE(254)] = 28834,
  [SMALL_STATE(255)] = 28888,
  [SMALL_STATE(256)] = 28942,
  [SMALL_STATE(257)] = 28996,
  [SMALL_STATE(258)] = 29056,
  [SMALL_STATE(259)] = 29120,
  [SMALL_STATE(260)] = 29182,
  [SMALL_STATE(261)] = 29236,
  [SMALL_STATE(262)] = 29293,
  [SMALL_STATE(263)] = 29348,
  [SMALL_STATE(264)] = 29400,
  [SMALL_STATE(265)] = 29452,
  [SMALL_STATE(266)] = 29504,
  [SMALL_STATE(267)] = 29556,
  [SMALL_STATE(268)] = 29608,
  [SMALL_STATE(269)] = 29660,
  [SMALL_STATE(270)] = 29712,
  [SMALL_STATE(271)] = 29764,
  [SMALL_STATE(272)] = 29816,
  [SMALL_STATE(273)] = 29868,
  [SMALL_STATE(274)] = 29920,
  [SMALL_STATE(275)] = 29978,
  [SMALL_STATE(276)] = 30030,
  [SMALL_STATE(277)] = 30082,
  [SMALL_STATE(278)] = 30134,
  [SMALL_STATE(279)] = 30186,
  [SMALL_STATE(280)] = 30238,
  [SMALL_STATE(281)] = 30290,
  [SMALL_STATE(282)] = 30342,
  [SMALL_STATE(283)] = 30394,
  [SMALL_STATE(284)] = 30446,
  [SMALL_STATE(285)] = 30498,
  [SMALL_STATE(286)] = 30556,
  [SMALL_STATE(287)] = 30608,
  [SMALL_STATE(288)] = 30660,
  [SMALL_STATE(289)] = 30712,
  [SMALL_STATE(290)] = 30764,
  [SMALL_STATE(291)] = 30816,
  [SMALL_STATE(292)] = 30868,
  [SMALL_STATE(293)] = 30920,
  [SMALL_STATE(294)] = 30978,
  [SMALL_STATE(295)] = 31030,
  [SMALL_STATE(296)] = 31082,
  [SMALL_STATE(297)] = 31134,
  [SMALL_STATE(298)] = 31186,
  [SMALL_STATE(299)] = 31238,
  [SMALL_STATE(300)] = 31290,
  [SMALL_STATE(301)] = 31342,
  [SMALL_STATE(302)] = 31394,
  [SMALL_STATE(303)] = 31446,
  [SMALL_STATE(304)] = 31498,
  [SMALL_STATE(305)] = 31556,
  [SMALL_STATE(306)] = 31608,
  [SMALL_STATE(307)] = 31666,
  [SMALL_STATE(308)] = 31724,
  [SMALL_STATE(309)] = 31776,
  [SMALL_STATE(310)] = 31828,
  [SMALL_STATE(311)] = 31880,
  [SMALL_STATE(312)] = 31932,
  [SMALL_STATE(313)] = 31984,
  [SMALL_STATE(314)] = 32036,
  [SMALL_STATE(315)] = 32094,
  [SMALL_STATE(316)] = 32148,
  [SMALL_STATE(317)] = 32200,
  [SMALL_STATE(318)] = 32254,
  [SMALL_STATE(319)] = 32308,
  [SMALL_STATE(320)] = 32364,
  [SMALL_STATE(321)] = 32416,
  [SMALL_STATE(322)] = 32474,
  [SMALL_STATE(323)] = 32526,
  [SMALL_STATE(324)] = 32578,
  [SMALL_STATE(325)] = 32630,
  [SMALL_STATE(326)] = 32682,
  [SMALL_STATE(327)] = 32734,
  [SMALL_STATE(328)] = 32786,
  [SMALL_STATE(329)] = 32838,
  [SMALL_STATE(330)] = 32890,
  [SMALL_STATE(331)] = 32942,
  [SMALL_STATE(332)] = 32994,
  [SMALL_STATE(333)] = 33046,
  [SMALL_STATE(334)] = 33098,
  [SMALL_STATE(335)] = 33150,
  [SMALL_STATE(336)] = 33202,
  [SMALL_STATE(337)] = 33254,
  [SMALL_STATE(338)] = 33306,
  [SMALL_STATE(339)] = 33358,
  [SMALL_STATE(340)] = 33410,
  [SMALL_STATE(341)] = 33462,
  [SMALL_STATE(342)] = 33514,
  [SMALL_STATE(343)] = 33566,
  [SMALL_STATE(344)] = 33621,
  [SMALL_STATE(345)] = 33674,
  [SMALL_STATE(346)] = 33727,
  [SMALL_STATE(347)] = 33782,
  [SMALL_STATE(348)] = 33835,
  [SMALL_STATE(349)] = 33890,
  [SMALL_STATE(350)] = 33945,
  [SMALL_STATE(351)] = 33995,
  [SMALL_STATE(352)] = 34047,
  [SMALL_STATE(353)] = 34097,
  [SMALL_STATE(354)] = 34149,
  [SMALL_STATE(355)] = 34201,
  [SMALL_STATE(356)] = 34255,
  [SMALL_STATE(357)] = 34305,
  [SMALL_STATE(358)] = 34361,
  [SMALL_STATE(359)] = 34411,
  [SMALL_STATE(360)] = 34467,
  [SMALL_STATE(361)] = 34517,
  [SMALL_STATE(362)] = 34567,
  [SMALL_STATE(363)] = 34617,
  [SMALL_STATE(364)] = 34667,
  [SMALL_STATE(365)] = 34717,
  [SMALL_STATE(366)] = 34767,
  [SMALL_STATE(367)] = 34817,
  [SMALL_STATE(368)] = 34873,
  [SMALL_STATE(369)] = 34947,
  [SMALL_STATE(370)] = 35003,
  [SMALL_STATE(371)] = 35053,
  [SMALL_STATE(372)] = 35105,
  [SMALL_STATE(373)] = 35155,
  [SMALL_STATE(374)] = 35205,
  [SMALL_STATE(375)] = 35255,
  [SMALL_STATE(376)] = 35305,
  [SMALL_STATE(377)] = 35355,
  [SMALL_STATE(378)] = 35405,
  [SMALL_STATE(379)] = 35455,
  [SMALL_STATE(380)] = 35511,
  [SMALL_STATE(381)] = 35561,
  [SMALL_STATE(382)] = 35611,
  [SMALL_STATE(383)] = 35663,
  [SMALL_STATE(384)] = 35719,
  [SMALL_STATE(385)] = 35769,
  [SMALL_STATE(386)] = 35819,
  [SMALL_STATE(387)] = 35869,
  [SMALL_STATE(388)] = 35919,
  [SMALL_STATE(389)] = 35975,
  [SMALL_STATE(390)] = 36025,
  [SMALL_STATE(391)] = 36077,
  [SMALL_STATE(392)] = 36129,
  [SMALL_STATE(393)] = 36181,
  [SMALL_STATE(394)] = 36275,
  [SMALL_STATE(395)] = 36329,
  [SMALL_STATE(396)] = 36385,
  [SMALL_STATE(397)] = 36435,
  [SMALL_STATE(398)] = 36489,
  [SMALL_STATE(399)] = 36539,
  [SMALL_STATE(400)] = 36589,
  [SMALL_STATE(401)] = 36639,
  [SMALL_STATE(402)] = 36689,
  [SMALL_STATE(403)] = 36739,
  [SMALL_STATE(404)] = 36795,
  [SMALL_STATE(405)] = 36845,
  [SMALL_STATE(406)] = 36895,
  [SMALL_STATE(407)] = 36991,
  [SMALL_STATE(408)] = 37041,
  [SMALL_STATE(409)] = 37093,
  [SMALL_STATE(410)] = 37143,
  [SMALL_STATE(411)] = 37193,
  [SMALL_STATE(412)] = 37249,
  [SMALL_STATE(413)] = 37299,
  [SMALL_STATE(414)] = 37349,
  [SMALL_STATE(415)] = 37405,
  [SMALL_STATE(416)] = 37455,
  [SMALL_STATE(417)] = 37505,
  [SMALL_STATE(418)] = 37555,
  [SMALL_STATE(419)] = 37605,
  [SMALL_STATE(420)] = 37655,
  [SMALL_STATE(421)] = 37705,
  [SMALL_STATE(422)] = 37755,
  [SMALL_STATE(423)] = 37805,
  [SMALL_STATE(424)] = 37855,
  [SMALL_STATE(425)] = 37905,
  [SMALL_STATE(426)] = 37955,
  [SMALL_STATE(427)] = 38005,
  [SMALL_STATE(428)] = 38061,
  [SMALL_STATE(429)] = 38111,
  [SMALL_STATE(430)] = 38161,
  [SMALL_STATE(431)] = 38211,
  [SMALL_STATE(432)] = 38261,
  [SMALL_STATE(433)] = 38317,
  [SMALL_STATE(434)] = 38413,
  [SMALL_STATE(435)] = 38463,
  [SMALL_STATE(436)] = 38513,
  [SMALL_STATE(437)] = 38569,
  [SMALL_STATE(438)] = 38619,
  [SMALL_STATE(439)] = 38675,
  [SMALL_STATE(440)] = 38725,
  [SMALL_STATE(441)] = 38775,
  [SMALL_STATE(442)] = 38870,
  [SMALL_STATE(443)] = 38939,
  [SMALL_STATE(444)] = 39008,
  [SMALL_STATE(445)] = 39103,
  [SMALL_STATE(446)] = 39152,
  [SMALL_STATE(447)] = 39221,
  [SMALL_STATE(448)] = 39316,
  [SMALL_STATE(449)] = 39411,
  [SMALL_STATE(450)] = 39506,
  [SMALL_STATE(451)] = 39601,
  [SMALL_STATE(452)] = 39696,
  [SMALL_STATE(453)] = 39749,
  [SMALL_STATE(454)] = 39844,
  [SMALL_STATE(455)] = 39893,
  [SMALL_STATE(456)] = 39942,
  [SMALL_STATE(457)] = 39991,
  [SMALL_STATE(458)] = 40040,
  [SMALL_STATE(459)] = 40089,
  [SMALL_STATE(460)] = 40138,
  [SMALL_STATE(461)] = 40187,
  [SMALL_STATE(462)] = 40236,
  [SMALL_STATE(463)] = 40285,
  [SMALL_STATE(464)] = 40334,
  [SMALL_STATE(465)] = 40429,
  [SMALL_STATE(466)] = 40478,
  [SMALL_STATE(467)] = 40527,
  [SMALL_STATE(468)] = 40576,
  [SMALL_STATE(469)] = 40625,
  [SMALL_STATE(470)] = 40674,
  [SMALL_STATE(471)] = 40723,
  [SMALL_STATE(472)] = 40772,
  [SMALL_STATE(473)] = 40821,
  [SMALL_STATE(474)] = 40870,
  [SMALL_STATE(475)] = 40919,
  [SMALL_STATE(476)] = 40968,
  [SMALL_STATE(477)] = 41017,
  [SMALL_STATE(478)] = 41112,
  [SMALL_STATE(479)] = 41161,
  [SMALL_STATE(480)] = 41210,
  [SMALL_STATE(481)] = 41305,
  [SMALL_STATE(482)] = 41400,
  [SMALL_STATE(483)] = 41453,
  [SMALL_STATE(484)] = 41506,
  [SMALL_STATE(485)] = 41601,
  [SMALL_STATE(486)] = 41696,
  [SMALL_STATE(487)] = 41745,
  [SMALL_STATE(488)] = 41840,
  [SMALL_STATE(489)] = 41889,
  [SMALL_STATE(490)] = 41938,
  [SMALL_STATE(491)] = 41987,
  [SMALL_STATE(492)] = 42036,
  [SMALL_STATE(493)] = 42089,
  [SMALL_STATE(494)] = 42138,
  [SMALL_STATE(495)] = 42199,
  [SMALL_STATE(496)] = 42294,
  [SMALL_STATE(497)] = 42361,
  [SMALL_STATE(498)] = 42426,
  [SMALL_STATE(499)] = 42483,
  [SMALL_STATE(500)] = 42536,
  [SMALL_STATE(501)] = 42597,
  [SMALL_STATE(502)] = 42650,
  [SMALL_STATE(503)] = 42699,
  [SMALL_STATE(504)] = 42794,
  [SMALL_STATE(505)] = 42889,
  [SMALL_STATE(506)] = 42984,
  [SMALL_STATE(507)] = 43079,
  [SMALL_STATE(508)] = 43174,
  [SMALL_STATE(509)] = 43269,
  [SMALL_STATE(510)] = 43364,
  [SMALL_STATE(511)] = 43459,
  [SMALL_STATE(512)] = 43554,
  [SMALL_STATE(513)] = 43649,
  [SMALL_STATE(514)] = 43744,
  [SMALL_STATE(515)] = 43839,
  [SMALL_STATE(516)] = 43934,
  [SMALL_STATE(517)] = 44028,
  [SMALL_STATE(518)] = 44120,
  [SMALL_STATE(519)] = 44214,
  [SMALL_STATE(520)] = 44308,
  [SMALL_STATE(521)] = 44400,
  [SMALL_STATE(522)] = 44472,
  [SMALL_STATE(523)] = 44544,
  [SMALL_STATE(524)] = 44612,
  [SMALL_STATE(525)] = 44680,
  [SMALL_STATE(526)] = 44748,
  [SMALL_STATE(527)] = 44840,
  [SMALL_STATE(528)] = 44934,
  [SMALL_STATE(529)] = 45026,
  [SMALL_STATE(530)] = 45120,
  [SMALL_STATE(531)] = 45212,
  [SMALL_STATE(532)] = 45306,
  [SMALL_STATE(533)] = 45398,
  [SMALL_STATE(534)] = 45492,
  [SMALL_STATE(535)] = 45584,
  [SMALL_STATE(536)] = 45678,
  [SMALL_STATE(537)] = 45772,
  [SMALL_STATE(538)] = 45866,
  [SMALL_STATE(539)] = 45958,
  [SMALL_STATE(540)] = 46052,
  [SMALL_STATE(541)] = 46144,
  [SMALL_STATE(542)] = 46216,
  [SMALL_STATE(543)] = 46308,
  [SMALL_STATE(544)] = 46400,
  [SMALL_STATE(545)] = 46494,
  [SMALL_STATE(546)] = 46586,
  [SMALL_STATE(547)] = 46680,
  [SMALL_STATE(548)] = 46772,
  [SMALL_STATE(549)] = 46866,
  [SMALL_STATE(550)] = 46958,
  [SMALL_STATE(551)] = 47050,
  [SMALL_STATE(552)] = 47144,
  [SMALL_STATE(553)] = 47238,
  [SMALL_STATE(554)] = 47330,
  [SMALL_STATE(555)] = 47422,
  [SMALL_STATE(556)] = 47516,
  [SMALL_STATE(557)] = 47608,
  [SMALL_STATE(558)] = 47700,
  [SMALL_STATE(559)] = 47794,
  [SMALL_STATE(560)] = 47886,
  [SMALL_STATE(561)] = 47978,
  [SMALL_STATE(562)] = 48067,
  [SMALL_STATE(563)] = 48118,
  [SMALL_STATE(564)] = 48165,
  [SMALL_STATE(565)] = 48212,
  [SMALL_STATE(566)] = 48279,
  [SMALL_STATE(567)] = 48326,
  [SMALL_STATE(568)] = 48373,
  [SMALL_STATE(569)] = 48420,
  [SMALL_STATE(570)] = 48467,
  [SMALL_STATE(571)] = 48514,
  [SMALL_STATE(572)] = 48561,
  [SMALL_STATE(573)] = 48608,
  [SMALL_STATE(574)] = 48655,
  [SMALL_STATE(575)] = 48744,
  [SMALL_STATE(576)] = 48791,
  [SMALL_STATE(577)] = 48838,
  [SMALL_STATE(578)] = 48901,
  [SMALL_STATE(579)] = 48990,
  [SMALL_STATE(580)] = 49045,
  [SMALL_STATE(581)] = 49092,
  [SMALL_STATE(582)] = 49139,
  [SMALL_STATE(583)] = 49186,
  [SMALL_STATE(584)] = 49233,
  [SMALL_STATE(585)] = 49322,
  [SMALL_STATE(586)] = 49381,
  [SMALL_STATE(587)] = 49446,
  [SMALL_STATE(588)] = 49509,
  [SMALL_STATE(589)] = 49556,
  [SMALL_STATE(590)] = 49611,
  [SMALL_STATE(591)] = 49700,
  [SMALL_STATE(592)] = 49767,
  [SMALL_STATE(593)] = 49856,
  [SMALL_STATE(594)] = 49907,
  [SMALL_STATE(595)] = 49974,
  [SMALL_STATE(596)] = 50037,
  [SMALL_STATE(597)] = 50092,
  [SMALL_STATE(598)] = 50143,
  [SMALL_STATE(599)] = 50202,
  [SMALL_STATE(600)] = 50253,
  [SMALL_STATE(601)] = 50300,
  [SMALL_STATE(602)] = 50347,
  [SMALL_STATE(603)] = 50394,
  [SMALL_STATE(604)] = 50441,
  [SMALL_STATE(605)] = 50488,
  [SMALL_STATE(606)] = 50547,
  [SMALL_STATE(607)] = 50636,
  [SMALL_STATE(608)] = 50703,
  [SMALL_STATE(609)] = 50750,
  [SMALL_STATE(610)] = 50817,
  [SMALL_STATE(611)] = 50884,
  [SMALL_STATE(612)] = 50935,
  [SMALL_STATE(613)] = 50982,
  [SMALL_STATE(614)] = 51071,
  [SMALL_STATE(615)] = 51118,
  [SMALL_STATE(616)] = 51165,
  [SMALL_STATE(617)] = 51212,
  [SMALL_STATE(618)] = 51263,
  [SMALL_STATE(619)] = 51310,
  [SMALL_STATE(620)] = 51357,
  [SMALL_STATE(621)] = 51404,
  [SMALL_STATE(622)] = 51463,
  [SMALL_STATE(623)] = 51510,
  [SMALL_STATE(624)] = 51599,
  [SMALL_STATE(625)] = 51688,
  [SMALL_STATE(626)] = 51735,
  [SMALL_STATE(627)] = 51782,
  [SMALL_STATE(628)] = 51829,
  [SMALL_STATE(629)] = 51876,
  [SMALL_STATE(630)] = 51923,
  [SMALL_STATE(631)] = 51970,
  [SMALL_STATE(632)] = 52017,
  [SMALL_STATE(633)] = 52064,
  [SMALL_STATE(634)] = 52111,
  [SMALL_STATE(635)] = 52158,
  [SMALL_STATE(636)] = 52205,
  [SMALL_STATE(637)] = 52252,
  [SMALL_STATE(638)] = 52299,
  [SMALL_STATE(639)] = 52388,
  [SMALL_STATE(640)] = 52439,
  [SMALL_STATE(641)] = 52486,
  [SMALL_STATE(642)] = 52533,
  [SMALL_STATE(643)] = 52580,
  [SMALL_STATE(644)] = 52627,
  [SMALL_STATE(645)] = 52674,
  [SMALL_STATE(646)] = 52721,
  [SMALL_STATE(647)] = 52768,
  [SMALL_STATE(648)] = 52815,
  [SMALL_STATE(649)] = 52862,
  [SMALL_STATE(650)] = 52909,
  [SMALL_STATE(651)] = 52956,
  [SMALL_STATE(652)] = 53003,
  [SMALL_STATE(653)] = 53050,
  [SMALL_STATE(654)] = 53097,
  [SMALL_STATE(655)] = 53186,
  [SMALL_STATE(656)] = 53253,
  [SMALL_STATE(657)] = 53300,
  [SMALL_STATE(658)] = 53359,
  [SMALL_STATE(659)] = 53406,
  [SMALL_STATE(660)] = 53471,
  [SMALL_STATE(661)] = 53518,
  [SMALL_STATE(662)] = 53565,
  [SMALL_STATE(663)] = 53612,
  [SMALL_STATE(664)] = 53659,
  [SMALL_STATE(665)] = 53726,
  [SMALL_STATE(666)] = 53773,
  [SMALL_STATE(667)] = 53820,
  [SMALL_STATE(668)] = 53909,
  [SMALL_STATE(669)] = 53956,
  [SMALL_STATE(670)] = 54003,
  [SMALL_STATE(671)] = 54092,
  [SMALL_STATE(672)] = 54139,
  [SMALL_STATE(673)] = 54190,
  [SMALL_STATE(674)] = 54237,
  [SMALL_STATE(675)] = 54284,
  [SMALL_STATE(676)] = 54331,
  [SMALL_STATE(677)] = 54378,
  [SMALL_STATE(678)] = 54467,
  [SMALL_STATE(679)] = 54514,
  [SMALL_STATE(680)] = 54561,
  [SMALL_STATE(681)] = 54628,
  [SMALL_STATE(682)] = 54687,
  [SMALL_STATE(683)] = 54734,
  [SMALL_STATE(684)] = 54799,
  [SMALL_STATE(685)] = 54850,
  [SMALL_STATE(686)] = 54897,
  [SMALL_STATE(687)] = 54986,
  [SMALL_STATE(688)] = 55033,
  [SMALL_STATE(689)] = 55080,
  [SMALL_STATE(690)] = 55127,
  [SMALL_STATE(691)] = 55216,
  [SMALL_STATE(692)] = 55263,
  [SMALL_STATE(693)] = 55310,
  [SMALL_STATE(694)] = 55357,
  [SMALL_STATE(695)] = 55404,
  [SMALL_STATE(696)] = 55451,
  [SMALL_STATE(697)] = 55540,
  [SMALL_STATE(698)] = 55587,
  [SMALL_STATE(699)] = 55634,
  [SMALL_STATE(700)] = 55681,
  [SMALL_STATE(701)] = 55728,
  [SMALL_STATE(702)] = 55775,
  [SMALL_STATE(703)] = 55822,
  [SMALL_STATE(704)] = 55869,
  [SMALL_STATE(705)] = 55916,
  [SMALL_STATE(706)] = 55963,
  [SMALL_STATE(707)] = 56010,
  [SMALL_STATE(708)] = 56057,
  [SMALL_STATE(709)] = 56145,
  [SMALL_STATE(710)] = 56211,
  [SMALL_STATE(711)] = 56277,
  [SMALL_STATE(712)] = 56343,
  [SMALL_STATE(713)] = 56429,
  [SMALL_STATE(714)] = 56515,
  [SMALL_STATE(715)] = 56601,
  [SMALL_STATE(716)] = 56687,
  [SMALL_STATE(717)] = 56773,
  [SMALL_STATE(718)] = 56839,
  [SMALL_STATE(719)] = 56905,
  [SMALL_STATE(720)] = 56971,
  [SMALL_STATE(721)] = 57037,
  [SMALL_STATE(722)] = 57103,
  [SMALL_STATE(723)] = 57189,
  [SMALL_STATE(724)] = 57275,
  [SMALL_STATE(725)] = 57363,
  [SMALL_STATE(726)] = 57429,
  [SMALL_STATE(727)] = 57515,
  [SMALL_STATE(728)] = 57603,
  [SMALL_STATE(729)] = 57689,
  [SMALL_STATE(730)] = 57775,
  [SMALL_STATE(731)] = 57861,
  [SMALL_STATE(732)] = 57949,
  [SMALL_STATE(733)] = 58035,
  [SMALL_STATE(734)] = 58121,
  [SMALL_STATE(735)] = 58209,
  [SMALL_STATE(736)] = 58295,
  [SMALL_STATE(737)] = 58381,
  [SMALL_STATE(738)] = 58467,
  [SMALL_STATE(739)] = 58553,
  [SMALL_STATE(740)] = 58641,
  [SMALL_STATE(741)] = 58727,
  [SMALL_STATE(742)] = 58813,
  [SMALL_STATE(743)] = 58901,
  [SMALL_STATE(744)] = 58987,
  [SMALL_STATE(745)] = 59073,
  [SMALL_STATE(746)] = 59161,
  [SMALL_STATE(747)] = 59247,
  [SMALL_STATE(748)] = 59333,
  [SMALL_STATE(749)] = 59419,
  [SMALL_STATE(750)] = 59505,
  [SMALL_STATE(751)] = 59591,
  [SMALL_STATE(752)] = 59679,
  [SMALL_STATE(753)] = 59765,
  [SMALL_STATE(754)] = 59851,
  [SMALL_STATE(755)] = 59939,
  [SMALL_STATE(756)] = 60025,
  [SMALL_STATE(757)] = 60111,
  [SMALL_STATE(758)] = 60199,
  [SMALL_STATE(759)] = 60285,
  [SMALL_STATE(760)] = 60371,
  [SMALL_STATE(761)] = 60459,
  [SMALL_STATE(762)] = 60545,
  [SMALL_STATE(763)] = 60631,
  [SMALL_STATE(764)] = 60719,
  [SMALL_STATE(765)] = 60805,
  [SMALL_STATE(766)] = 60891,
  [SMALL_STATE(767)] = 60979,
  [SMALL_STATE(768)] = 61065,
  [SMALL_STATE(769)] = 61151,
  [SMALL_STATE(770)] = 61239,
  [SMALL_STATE(771)] = 61325,
  [SMALL_STATE(772)] = 61411,
  [SMALL_STATE(773)] = 61499,
  [SMALL_STATE(774)] = 61585,
  [SMALL_STATE(775)] = 61671,
  [SMALL_STATE(776)] = 61759,
  [SMALL_STATE(777)] = 61845,
  [SMALL_STATE(778)] = 61931,
  [SMALL_STATE(779)] = 62019,
  [SMALL_STATE(780)] = 62105,
  [SMALL_STATE(781)] = 62191,
  [SMALL_STATE(782)] = 62277,
  [SMALL_STATE(783)] = 62363,
  [SMALL_STATE(784)] = 62451,
  [SMALL_STATE(785)] = 62534,
  [SMALL_STATE(786)] = 62617,
  [SMALL_STATE(787)] = 62700,
  [SMALL_STATE(788)] = 62783,
  [SMALL_STATE(789)] = 62866,
  [SMALL_STATE(790)] = 62949,
  [SMALL_STATE(791)] = 63032,
  [SMALL_STATE(792)] = 63115,
  [SMALL_STATE(793)] = 63198,
  [SMALL_STATE(794)] = 63281,
  [SMALL_STATE(795)] = 63364,
  [SMALL_STATE(796)] = 63447,
  [SMALL_STATE(797)] = 63530,
  [SMALL_STATE(798)] = 63613,
  [SMALL_STATE(799)] = 63696,
  [SMALL_STATE(800)] = 63779,
  [SMALL_STATE(801)] = 63862,
  [SMALL_STATE(802)] = 63945,
  [SMALL_STATE(803)] = 64028,
  [SMALL_STATE(804)] = 64111,
  [SMALL_STATE(805)] = 64194,
  [SMALL_STATE(806)] = 64277,
  [SMALL_STATE(807)] = 64360,
  [SMALL_STATE(808)] = 64443,
  [SMALL_STATE(809)] = 64526,
  [SMALL_STATE(810)] = 64609,
  [SMALL_STATE(811)] = 64692,
  [SMALL_STATE(812)] = 64775,
  [SMALL_STATE(813)] = 64858,
  [SMALL_STATE(814)] = 64941,
  [SMALL_STATE(815)] = 65024,
  [SMALL_STATE(816)] = 65107,
  [SMALL_STATE(817)] = 65190,
  [SMALL_STATE(818)] = 65273,
  [SMALL_STATE(819)] = 65356,
  [SMALL_STATE(820)] = 65439,
  [SMALL_STATE(821)] = 65522,
  [SMALL_STATE(822)] = 65605,
  [SMALL_STATE(823)] = 65688,
  [SMALL_STATE(824)] = 65771,
  [SMALL_STATE(825)] = 65854,
  [SMALL_STATE(826)] = 65937,
  [SMALL_STATE(827)] = 66020,
  [SMALL_STATE(828)] = 66103,
  [SMALL_STATE(829)] = 66186,
  [SMALL_STATE(830)] = 66269,
  [SMALL_STATE(831)] = 66352,
  [SMALL_STATE(832)] = 66435,
  [SMALL_STATE(833)] = 66518,
  [SMALL_STATE(834)] = 66601,
  [SMALL_STATE(835)] = 66684,
  [SMALL_STATE(836)] = 66767,
  [SMALL_STATE(837)] = 66850,
  [SMALL_STATE(838)] = 66933,
  [SMALL_STATE(839)] = 67016,
  [SMALL_STATE(840)] = 67099,
  [SMALL_STATE(841)] = 67182,
  [SMALL_STATE(842)] = 67265,
  [SMALL_STATE(843)] = 67348,
  [SMALL_STATE(844)] = 67431,
  [SMALL_STATE(845)] = 67514,
  [SMALL_STATE(846)] = 67597,
  [SMALL_STATE(847)] = 67680,
  [SMALL_STATE(848)] = 67763,
  [SMALL_STATE(849)] = 67846,
  [SMALL_STATE(850)] = 67929,
  [SMALL_STATE(851)] = 68012,
  [SMALL_STATE(852)] = 68095,
  [SMALL_STATE(853)] = 68178,
  [SMALL_STATE(854)] = 68261,
  [SMALL_STATE(855)] = 68344,
  [SMALL_STATE(856)] = 68427,
  [SMALL_STATE(857)] = 68510,
  [SMALL_STATE(858)] = 68593,
  [SMALL_STATE(859)] = 68676,
  [SMALL_STATE(860)] = 68759,
  [SMALL_STATE(861)] = 68842,
  [SMALL_STATE(862)] = 68925,
  [SMALL_STATE(863)] = 69008,
  [SMALL_STATE(864)] = 69091,
  [SMALL_STATE(865)] = 69174,
  [SMALL_STATE(866)] = 69257,
  [SMALL_STATE(867)] = 69340,
  [SMALL_STATE(868)] = 69423,
  [SMALL_STATE(869)] = 69506,
  [SMALL_STATE(870)] = 69589,
  [SMALL_STATE(871)] = 69672,
  [SMALL_STATE(872)] = 69755,
  [SMALL_STATE(873)] = 69838,
  [SMALL_STATE(874)] = 69921,
  [SMALL_STATE(875)] = 70004,
  [SMALL_STATE(876)] = 70087,
  [SMALL_STATE(877)] = 70170,
  [SMALL_STATE(878)] = 70253,
  [SMALL_STATE(879)] = 70336,
  [SMALL_STATE(880)] = 70419,
  [SMALL_STATE(881)] = 70502,
  [SMALL_STATE(882)] = 70585,
  [SMALL_STATE(883)] = 70668,
  [SMALL_STATE(884)] = 70751,
  [SMALL_STATE(885)] = 70834,
  [SMALL_STATE(886)] = 70917,
  [SMALL_STATE(887)] = 71000,
  [SMALL_STATE(888)] = 71083,
  [SMALL_STATE(889)] = 71166,
  [SMALL_STATE(890)] = 71249,
  [SMALL_STATE(891)] = 71332,
  [SMALL_STATE(892)] = 71415,
  [SMALL_STATE(893)] = 71498,
  [SMALL_STATE(894)] = 71581,
  [SMALL_STATE(895)] = 71664,
  [SMALL_STATE(896)] = 71747,
  [SMALL_STATE(897)] = 71830,
  [SMALL_STATE(898)] = 71913,
  [SMALL_STATE(899)] = 71996,
  [SMALL_STATE(900)] = 72079,
  [SMALL_STATE(901)] = 72162,
  [SMALL_STATE(902)] = 72245,
  [SMALL_STATE(903)] = 72328,
  [SMALL_STATE(904)] = 72411,
  [SMALL_STATE(905)] = 72494,
  [SMALL_STATE(906)] = 72577,
  [SMALL_STATE(907)] = 72660,
  [SMALL_STATE(908)] = 72743,
  [SMALL_STATE(909)] = 72826,
  [SMALL_STATE(910)] = 72909,
  [SMALL_STATE(911)] = 72992,
  [SMALL_STATE(912)] = 73075,
  [SMALL_STATE(913)] = 73158,
  [SMALL_STATE(914)] = 73241,
  [SMALL_STATE(915)] = 73324,
  [SMALL_STATE(916)] = 73407,
  [SMALL_STATE(917)] = 73490,
  [SMALL_STATE(918)] = 73573,
  [SMALL_STATE(919)] = 73656,
  [SMALL_STATE(920)] = 73739,
  [SMALL_STATE(921)] = 73822,
  [SMALL_STATE(922)] = 73905,
  [SMALL_STATE(923)] = 73988,
  [SMALL_STATE(924)] = 74071,
  [SMALL_STATE(925)] = 74154,
  [SMALL_STATE(926)] = 74237,
  [SMALL_STATE(927)] = 74320,
  [SMALL_STATE(928)] = 74403,
  [SMALL_STATE(929)] = 74486,
  [SMALL_STATE(930)] = 74569,
  [SMALL_STATE(931)] = 74652,
  [SMALL_STATE(932)] = 74735,
  [SMALL_STATE(933)] = 74818,
  [SMALL_STATE(934)] = 74901,
  [SMALL_STATE(935)] = 74984,
  [SMALL_STATE(936)] = 75067,
  [SMALL_STATE(937)] = 75150,
  [SMALL_STATE(938)] = 75233,
  [SMALL_STATE(939)] = 75316,
  [SMALL_STATE(940)] = 75399,
  [SMALL_STATE(941)] = 75482,
  [SMALL_STATE(942)] = 75565,
  [SMALL_STATE(943)] = 75648,
  [SMALL_STATE(944)] = 75731,
  [SMALL_STATE(945)] = 75814,
  [SMALL_STATE(946)] = 75897,
  [SMALL_STATE(947)] = 75980,
  [SMALL_STATE(948)] = 76063,
  [SMALL_STATE(949)] = 76146,
  [SMALL_STATE(950)] = 76229,
  [SMALL_STATE(951)] = 76312,
  [SMALL_STATE(952)] = 76395,
  [SMALL_STATE(953)] = 76478,
  [SMALL_STATE(954)] = 76561,
  [SMALL_STATE(955)] = 76644,
  [SMALL_STATE(956)] = 76727,
  [SMALL_STATE(957)] = 76810,
  [SMALL_STATE(958)] = 76893,
  [SMALL_STATE(959)] = 76976,
  [SMALL_STATE(960)] = 77059,
  [SMALL_STATE(961)] = 77142,
  [SMALL_STATE(962)] = 77225,
  [SMALL_STATE(963)] = 77308,
  [SMALL_STATE(964)] = 77391,
  [SMALL_STATE(965)] = 77474,
  [SMALL_STATE(966)] = 77557,
  [SMALL_STATE(967)] = 77640,
  [SMALL_STATE(968)] = 77723,
  [SMALL_STATE(969)] = 77806,
  [SMALL_STATE(970)] = 77889,
  [SMALL_STATE(971)] = 77972,
  [SMALL_STATE(972)] = 78055,
  [SMALL_STATE(973)] = 78138,
  [SMALL_STATE(974)] = 78221,
  [SMALL_STATE(975)] = 78304,
  [SMALL_STATE(976)] = 78387,
  [SMALL_STATE(977)] = 78470,
  [SMALL_STATE(978)] = 78553,
  [SMALL_STATE(979)] = 78636,
  [SMALL_STATE(980)] = 78719,
  [SMALL_STATE(981)] = 78802,
  [SMALL_STATE(982)] = 78885,
  [SMALL_STATE(983)] = 78968,
  [SMALL_STATE(984)] = 79051,
  [SMALL_STATE(985)] = 79134,
  [SMALL_STATE(986)] = 79217,
  [SMALL_STATE(987)] = 79300,
  [SMALL_STATE(988)] = 79383,
  [SMALL_STATE(989)] = 79466,
  [SMALL_STATE(990)] = 79549,
  [SMALL_STATE(991)] = 79632,
  [SMALL_STATE(992)] = 79715,
  [SMALL_STATE(993)] = 79798,
  [SMALL_STATE(994)] = 79881,
  [SMALL_STATE(995)] = 79964,
  [SMALL_STATE(996)] = 80047,
  [SMALL_STATE(997)] = 80130,
  [SMALL_STATE(998)] = 80213,
  [SMALL_STATE(999)] = 80296,
  [SMALL_STATE(1000)] = 80379,
  [SMALL_STATE(1001)] = 80462,
  [SMALL_STATE(1002)] = 80545,
  [SMALL_STATE(1003)] = 80628,
  [SMALL_STATE(1004)] = 80711,
  [SMALL_STATE(1005)] = 80794,
  [SMALL_STATE(1006)] = 80877,
  [SMALL_STATE(1007)] = 80960,
  [SMALL_STATE(1008)] = 81043,
  [SMALL_STATE(1009)] = 81126,
  [SMALL_STATE(1010)] = 81209,
  [SMALL_STATE(1011)] = 81292,
  [SMALL_STATE(1012)] = 81375,
  [SMALL_STATE(1013)] = 81458,
  [SMALL_STATE(1014)] = 81541,
  [SMALL_STATE(1015)] = 81624,
  [SMALL_STATE(1016)] = 81707,
  [SMALL_STATE(1017)] = 81790,
  [SMALL_STATE(1018)] = 81873,
  [SMALL_STATE(1019)] = 81956,
  [SMALL_STATE(1020)] = 82039,
  [SMALL_STATE(1021)] = 82122,
  [SMALL_STATE(1022)] = 82202,
  [SMALL_STATE(1023)] = 82282,
  [SMALL_STATE(1024)] = 82362,
  [SMALL_STATE(1025)] = 82442,
  [SMALL_STATE(1026)] = 82522,
  [SMALL_STATE(1027)] = 82602,
  [SMALL_STATE(1028)] = 82682,
  [SMALL_STATE(1029)] = 82762,
  [SMALL_STATE(1030)] = 82842,
  [SMALL_STATE(1031)] = 82922,
  [SMALL_STATE(1032)] = 83002,
  [SMALL_STATE(1033)] = 83082,
  [SMALL_STATE(1034)] = 83162,
  [SMALL_STATE(1035)] = 83242,
  [SMALL_STATE(1036)] = 83322,
  [SMALL_STATE(1037)] = 83402,
  [SMALL_STATE(1038)] = 83482,
  [SMALL_STATE(1039)] = 83562,
  [SMALL_STATE(1040)] = 83642,
  [SMALL_STATE(1041)] = 83722,
  [SMALL_STATE(1042)] = 83802,
  [SMALL_STATE(1043)] = 83882,
  [SMALL_STATE(1044)] = 83962,
  [SMALL_STATE(1045)] = 84042,
  [SMALL_STATE(1046)] = 84122,
  [SMALL_STATE(1047)] = 84202,
  [SMALL_STATE(1048)] = 84282,
  [SMALL_STATE(1049)] = 84362,
  [SMALL_STATE(1050)] = 84442,
  [SMALL_STATE(1051)] = 84522,
  [SMALL_STATE(1052)] = 84602,
  [SMALL_STATE(1053)] = 84682,
  [SMALL_STATE(1054)] = 84764,
  [SMALL_STATE(1055)] = 84846,
  [SMALL_STATE(1056)] = 84926,
  [SMALL_STATE(1057)] = 85006,
  [SMALL_STATE(1058)] = 85086,
  [SMALL_STATE(1059)] = 85166,
  [SMALL_STATE(1060)] = 85246,
  [SMALL_STATE(1061)] = 85326,
  [SMALL_STATE(1062)] = 85406,
  [SMALL_STATE(1063)] = 85486,
  [SMALL_STATE(1064)] = 85566,
  [SMALL_STATE(1065)] = 85646,
  [SMALL_STATE(1066)] = 85726,
  [SMALL_STATE(1067)] = 85806,
  [SMALL_STATE(1068)] = 85886,
  [SMALL_STATE(1069)] = 85966,
  [SMALL_STATE(1070)] = 86046,
  [SMALL_STATE(1071)] = 86126,
  [SMALL_STATE(1072)] = 86206,
  [SMALL_STATE(1073)] = 86286,
  [SMALL_STATE(1074)] = 86366,
  [SMALL_STATE(1075)] = 86446,
  [SMALL_STATE(1076)] = 86526,
  [SMALL_STATE(1077)] = 86606,
  [SMALL_STATE(1078)] = 86686,
  [SMALL_STATE(1079)] = 86766,
  [SMALL_STATE(1080)] = 86846,
  [SMALL_STATE(1081)] = 86926,
  [SMALL_STATE(1082)] = 87006,
  [SMALL_STATE(1083)] = 87086,
  [SMALL_STATE(1084)] = 87166,
  [SMALL_STATE(1085)] = 87246,
  [SMALL_STATE(1086)] = 87326,
  [SMALL_STATE(1087)] = 87406,
  [SMALL_STATE(1088)] = 87484,
  [SMALL_STATE(1089)] = 87534,
  [SMALL_STATE(1090)] = 87584,
  [SMALL_STATE(1091)] = 87636,
  [SMALL_STATE(1092)] = 87709,
  [SMALL_STATE(1093)] = 87780,
  [SMALL_STATE(1094)] = 87853,
  [SMALL_STATE(1095)] = 87926,
  [SMALL_STATE(1096)] = 87999,
  [SMALL_STATE(1097)] = 88070,
  [SMALL_STATE(1098)] = 88143,
  [SMALL_STATE(1099)] = 88192,
  [SMALL_STATE(1100)] = 88263,
  [SMALL_STATE(1101)] = 88314,
  [SMALL_STATE(1102)] = 88363,
  [SMALL_STATE(1103)] = 88434,
  [SMALL_STATE(1104)] = 88507,
  [SMALL_STATE(1105)] = 88578,
  [SMALL_STATE(1106)] = 88649,
  [SMALL_STATE(1107)] = 88722,
  [SMALL_STATE(1108)] = 88793,
  [SMALL_STATE(1109)] = 88864,
  [SMALL_STATE(1110)] = 88937,
  [SMALL_STATE(1111)] = 89010,
  [SMALL_STATE(1112)] = 89081,
  [SMALL_STATE(1113)] = 89152,
  [SMALL_STATE(1114)] = 89225,
  [SMALL_STATE(1115)] = 89298,
  [SMALL_STATE(1116)] = 89369,
  [SMALL_STATE(1117)] = 89440,
  [SMALL_STATE(1118)] = 89511,
  [SMALL_STATE(1119)] = 89584,
  [SMALL_STATE(1120)] = 89655,
  [SMALL_STATE(1121)] = 89728,
  [SMALL_STATE(1122)] = 89799,
  [SMALL_STATE(1123)] = 89870,
  [SMALL_STATE(1124)] = 89941,
  [SMALL_STATE(1125)] = 90014,
  [SMALL_STATE(1126)] = 90087,
  [SMALL_STATE(1127)] = 90158,
  [SMALL_STATE(1128)] = 90231,
  [SMALL_STATE(1129)] = 90304,
  [SMALL_STATE(1130)] = 90377,
  [SMALL_STATE(1131)] = 90447,
  [SMALL_STATE(1132)] = 90487,
  [SMALL_STATE(1133)] = 90527,
  [SMALL_STATE(1134)] = 90567,
  [SMALL_STATE(1135)] = 90607,
  [SMALL_STATE(1136)] = 90647,
  [SMALL_STATE(1137)] = 90687,
  [SMALL_STATE(1138)] = 90727,
  [SMALL_STATE(1139)] = 90799,
  [SMALL_STATE(1140)] = 90839,
  [SMALL_STATE(1141)] = 90879,
  [SMALL_STATE(1142)] = 90919,
  [SMALL_STATE(1143)] = 90991,
  [SMALL_STATE(1144)] = 91031,
  [SMALL_STATE(1145)] = 91071,
  [SMALL_STATE(1146)] = 91111,
  [SMALL_STATE(1147)] = 91151,
  [SMALL_STATE(1148)] = 91191,
  [SMALL_STATE(1149)] = 91241,
  [SMALL_STATE(1150)] = 91281,
  [SMALL_STATE(1151)] = 91320,
  [SMALL_STATE(1152)] = 91359,
  [SMALL_STATE(1153)] = 91406,
  [SMALL_STATE(1154)] = 91445,
  [SMALL_STATE(1155)] = 91484,
  [SMALL_STATE(1156)] = 91529,
  [SMALL_STATE(1157)] = 91568,
  [SMALL_STATE(1158)] = 91607,
  [SMALL_STATE(1159)] = 91652,
  [SMALL_STATE(1160)] = 91691,
  [SMALL_STATE(1161)] = 91730,
  [SMALL_STATE(1162)] = 91777,
  [SMALL_STATE(1163)] = 91826,
  [SMALL_STATE(1164)] = 91873,
  [SMALL_STATE(1165)] = 91912,
  [SMALL_STATE(1166)] = 91951,
  [SMALL_STATE(1167)] = 91990,
  [SMALL_STATE(1168)] = 92029,
  [SMALL_STATE(1169)] = 92068,
  [SMALL_STATE(1170)] = 92115,
  [SMALL_STATE(1171)] = 92164,
  [SMALL_STATE(1172)] = 92203,
  [SMALL_STATE(1173)] = 92242,
  [SMALL_STATE(1174)] = 92281,
  [SMALL_STATE(1175)] = 92325,
  [SMALL_STATE(1176)] = 92365,
  [SMALL_STATE(1177)] = 92407,
  [SMALL_STATE(1178)] = 92453,
  [SMALL_STATE(1179)] = 92501,
  [SMALL_STATE(1180)] = 92551,
  [SMALL_STATE(1181)] = 92597,
  [SMALL_STATE(1182)] = 92645,
  [SMALL_STATE(1183)] = 92691,
  [SMALL_STATE(1184)] = 92733,
  [SMALL_STATE(1185)] = 92773,
  [SMALL_STATE(1186)] = 92839,
  [SMALL_STATE(1187)] = 92885,
  [SMALL_STATE(1188)] = 92932,
  [SMALL_STATE(1189)] = 92969,
  [SMALL_STATE(1190)] = 93012,
  [SMALL_STATE(1191)] = 93049,
  [SMALL_STATE(1192)] = 93086,
  [SMALL_STATE(1193)] = 93123,
  [SMALL_STATE(1194)] = 93160,
  [SMALL_STATE(1195)] = 93223,
  [SMALL_STATE(1196)] = 93260,
  [SMALL_STATE(1197)] = 93323,
  [SMALL_STATE(1198)] = 93362,
  [SMALL_STATE(1199)] = 93425,
  [SMALL_STATE(1200)] = 93464,
  [SMALL_STATE(1201)] = 93527,
  [SMALL_STATE(1202)] = 93590,
  [SMALL_STATE(1203)] = 93653,
  [SMALL_STATE(1204)] = 93690,
  [SMALL_STATE(1205)] = 93727,
  [SMALL_STATE(1206)] = 93790,
  [SMALL_STATE(1207)] = 93853,
  [SMALL_STATE(1208)] = 93892,
  [SMALL_STATE(1209)] = 93955,
  [SMALL_STATE(1210)] = 94018,
  [SMALL_STATE(1211)] = 94055,
  [SMALL_STATE(1212)] = 94092,
  [SMALL_STATE(1213)] = 94129,
  [SMALL_STATE(1214)] = 94192,
  [SMALL_STATE(1215)] = 94229,
  [SMALL_STATE(1216)] = 94292,
  [SMALL_STATE(1217)] = 94329,
  [SMALL_STATE(1218)] = 94366,
  [SMALL_STATE(1219)] = 94403,
  [SMALL_STATE(1220)] = 94440,
  [SMALL_STATE(1221)] = 94503,
  [SMALL_STATE(1222)] = 94540,
  [SMALL_STATE(1223)] = 94603,
  [SMALL_STATE(1224)] = 94646,
  [SMALL_STATE(1225)] = 94685,
  [SMALL_STATE(1226)] = 94722,
  [SMALL_STATE(1227)] = 94759,
  [SMALL_STATE(1228)] = 94796,
  [SMALL_STATE(1229)] = 94833,
  [SMALL_STATE(1230)] = 94896,
  [SMALL_STATE(1231)] = 94937,
  [SMALL_STATE(1232)] = 94974,
  [SMALL_STATE(1233)] = 95019,
  [SMALL_STATE(1234)] = 95064,
  [SMALL_STATE(1235)] = 95127,
  [SMALL_STATE(1236)] = 95172,
  [SMALL_STATE(1237)] = 95209,
  [SMALL_STATE(1238)] = 95272,
  [SMALL_STATE(1239)] = 95315,
  [SMALL_STATE(1240)] = 95362,
  [SMALL_STATE(1241)] = 95399,
  [SMALL_STATE(1242)] = 95436,
  [SMALL_STATE(1243)] = 95473,
  [SMALL_STATE(1244)] = 95510,
  [SMALL_STATE(1245)] = 95573,
  [SMALL_STATE(1246)] = 95610,
  [SMALL_STATE(1247)] = 95673,
  [SMALL_STATE(1248)] = 95710,
  [SMALL_STATE(1249)] = 95747,
  [SMALL_STATE(1250)] = 95790,
  [SMALL_STATE(1251)] = 95827,
  [SMALL_STATE(1252)] = 95864,
  [SMALL_STATE(1253)] = 95927,
  [SMALL_STATE(1254)] = 95964,
  [SMALL_STATE(1255)] = 96001,
  [SMALL_STATE(1256)] = 96044,
  [SMALL_STATE(1257)] = 96081,
  [SMALL_STATE(1258)] = 96118,
  [SMALL_STATE(1259)] = 96155,
  [SMALL_STATE(1260)] = 96192,
  [SMALL_STATE(1261)] = 96255,
  [SMALL_STATE(1262)] = 96318,
  [SMALL_STATE(1263)] = 96381,
  [SMALL_STATE(1264)] = 96418,
  [SMALL_STATE(1265)] = 96461,
  [SMALL_STATE(1266)] = 96524,
  [SMALL_STATE(1267)] = 96587,
  [SMALL_STATE(1268)] = 96624,
  [SMALL_STATE(1269)] = 96661,
  [SMALL_STATE(1270)] = 96704,
  [SMALL_STATE(1271)] = 96767,
  [SMALL_STATE(1272)] = 96830,
  [SMALL_STATE(1273)] = 96893,
  [SMALL_STATE(1274)] = 96930,
  [SMALL_STATE(1275)] = 96967,
  [SMALL_STATE(1276)] = 97030,
  [SMALL_STATE(1277)] = 97093,
  [SMALL_STATE(1278)] = 97130,
  [SMALL_STATE(1279)] = 97167,
  [SMALL_STATE(1280)] = 97204,
  [SMALL_STATE(1281)] = 97267,
  [SMALL_STATE(1282)] = 97304,
  [SMALL_STATE(1283)] = 97341,
  [SMALL_STATE(1284)] = 97380,
  [SMALL_STATE(1285)] = 97419,
  [SMALL_STATE(1286)] = 97460,
  [SMALL_STATE(1287)] = 97503,
  [SMALL_STATE(1288)] = 97540,
  [SMALL_STATE(1289)] = 97577,
  [SMALL_STATE(1290)] = 97614,
  [SMALL_STATE(1291)] = 97677,
  [SMALL_STATE(1292)] = 97740,
  [SMALL_STATE(1293)] = 97777,
  [SMALL_STATE(1294)] = 97822,
  [SMALL_STATE(1295)] = 97862,
  [SMALL_STATE(1296)] = 97902,
  [SMALL_STATE(1297)] = 97944,
  [SMALL_STATE(1298)] = 97984,
  [SMALL_STATE(1299)] = 98026,
  [SMALL_STATE(1300)] = 98062,
  [SMALL_STATE(1301)] = 98098,
  [SMALL_STATE(1302)] = 98134,
  [SMALL_STATE(1303)] = 98170,
  [SMALL_STATE(1304)] = 98206,
  [SMALL_STATE(1305)] = 98242,
  [SMALL_STATE(1306)] = 98290,
  [SMALL_STATE(1307)] = 98326,
  [SMALL_STATE(1308)] = 98362,
  [SMALL_STATE(1309)] = 98398,
  [SMALL_STATE(1310)] = 98434,
  [SMALL_STATE(1311)] = 98470,
  [SMALL_STATE(1312)] = 98518,
  [SMALL_STATE(1313)] = 98554,
  [SMALL_STATE(1314)] = 98590,
  [SMALL_STATE(1315)] = 98626,
  [SMALL_STATE(1316)] = 98662,
  [SMALL_STATE(1317)] = 98698,
  [SMALL_STATE(1318)] = 98738,
  [SMALL_STATE(1319)] = 98774,
  [SMALL_STATE(1320)] = 98810,
  [SMALL_STATE(1321)] = 98846,
  [SMALL_STATE(1322)] = 98882,
  [SMALL_STATE(1323)] = 98918,
  [SMALL_STATE(1324)] = 98954,
  [SMALL_STATE(1325)] = 98990,
  [SMALL_STATE(1326)] = 99032,
  [SMALL_STATE(1327)] = 99068,
  [SMALL_STATE(1328)] = 99104,
  [SMALL_STATE(1329)] = 99140,
  [SMALL_STATE(1330)] = 99176,
  [SMALL_STATE(1331)] = 99212,
  [SMALL_STATE(1332)] = 99248,
  [SMALL_STATE(1333)] = 99290,
  [SMALL_STATE(1334)] = 99326,
  [SMALL_STATE(1335)] = 99368,
  [SMALL_STATE(1336)] = 99404,
  [SMALL_STATE(1337)] = 99440,
  [SMALL_STATE(1338)] = 99476,
  [SMALL_STATE(1339)] = 99518,
  [SMALL_STATE(1340)] = 99554,
  [SMALL_STATE(1341)] = 99592,
  [SMALL_STATE(1342)] = 99630,
  [SMALL_STATE(1343)] = 99672,
  [SMALL_STATE(1344)] = 99708,
  [SMALL_STATE(1345)] = 99744,
  [SMALL_STATE(1346)] = 99780,
  [SMALL_STATE(1347)] = 99816,
  [SMALL_STATE(1348)] = 99852,
  [SMALL_STATE(1349)] = 99894,
  [SMALL_STATE(1350)] = 99930,
  [SMALL_STATE(1351)] = 99966,
  [SMALL_STATE(1352)] = 100002,
  [SMALL_STATE(1353)] = 100038,
  [SMALL_STATE(1354)] = 100074,
  [SMALL_STATE(1355)] = 100110,
  [SMALL_STATE(1356)] = 100152,
  [SMALL_STATE(1357)] = 100188,
  [SMALL_STATE(1358)] = 100230,
  [SMALL_STATE(1359)] = 100266,
  [SMALL_STATE(1360)] = 100302,
  [SMALL_STATE(1361)] = 100338,
  [SMALL_STATE(1362)] = 100380,
  [SMALL_STATE(1363)] = 100416,
  [SMALL_STATE(1364)] = 100454,
  [SMALL_STATE(1365)] = 100494,
  [SMALL_STATE(1366)] = 100536,
  [SMALL_STATE(1367)] = 100572,
  [SMALL_STATE(1368)] = 100608,
  [SMALL_STATE(1369)] = 100644,
  [SMALL_STATE(1370)] = 100680,
  [SMALL_STATE(1371)] = 100716,
  [SMALL_STATE(1372)] = 100752,
  [SMALL_STATE(1373)] = 100788,
  [SMALL_STATE(1374)] = 100824,
  [SMALL_STATE(1375)] = 100860,
  [SMALL_STATE(1376)] = 100908,
  [SMALL_STATE(1377)] = 100944,
  [SMALL_STATE(1378)] = 100980,
  [SMALL_STATE(1379)] = 101016,
  [SMALL_STATE(1380)] = 101052,
  [SMALL_STATE(1381)] = 101088,
  [SMALL_STATE(1382)] = 101124,
  [SMALL_STATE(1383)] = 101160,
  [SMALL_STATE(1384)] = 101196,
  [SMALL_STATE(1385)] = 101232,
  [SMALL_STATE(1386)] = 101268,
  [SMALL_STATE(1387)] = 101304,
  [SMALL_STATE(1388)] = 101340,
  [SMALL_STATE(1389)] = 101376,
  [SMALL_STATE(1390)] = 101412,
  [SMALL_STATE(1391)] = 101448,
  [SMALL_STATE(1392)] = 101484,
  [SMALL_STATE(1393)] = 101520,
  [SMALL_STATE(1394)] = 101556,
  [SMALL_STATE(1395)] = 101592,
  [SMALL_STATE(1396)] = 101628,
  [SMALL_STATE(1397)] = 101664,
  [SMALL_STATE(1398)] = 101700,
  [SMALL_STATE(1399)] = 101740,
  [SMALL_STATE(1400)] = 101775,
  [SMALL_STATE(1401)] = 101810,
  [SMALL_STATE(1402)] = 101845,
  [SMALL_STATE(1403)] = 101880,
  [SMALL_STATE(1404)] = 101915,
  [SMALL_STATE(1405)] = 101952,
  [SMALL_STATE(1406)] = 101989,
  [SMALL_STATE(1407)] = 102030,
  [SMALL_STATE(1408)] = 102065,
  [SMALL_STATE(1409)] = 102100,
  [SMALL_STATE(1410)] = 102135,
  [SMALL_STATE(1411)] = 102174,
  [SMALL_STATE(1412)] = 102209,
  [SMALL_STATE(1413)] = 102244,
  [SMALL_STATE(1414)] = 102281,
  [SMALL_STATE(1415)] = 102318,
  [SMALL_STATE(1416)] = 102353,
  [SMALL_STATE(1417)] = 102388,
  [SMALL_STATE(1418)] = 102423,
  [SMALL_STATE(1419)] = 102458,
  [SMALL_STATE(1420)] = 102493,
  [SMALL_STATE(1421)] = 102528,
  [SMALL_STATE(1422)] = 102563,
  [SMALL_STATE(1423)] = 102598,
  [SMALL_STATE(1424)] = 102635,
  [SMALL_STATE(1425)] = 102670,
  [SMALL_STATE(1426)] = 102707,
  [SMALL_STATE(1427)] = 102742,
  [SMALL_STATE(1428)] = 102777,
  [SMALL_STATE(1429)] = 102814,
  [SMALL_STATE(1430)] = 102849,
  [SMALL_STATE(1431)] = 102886,
  [SMALL_STATE(1432)] = 102925,
  [SMALL_STATE(1433)] = 102960,
  [SMALL_STATE(1434)] = 102995,
  [SMALL_STATE(1435)] = 103030,
  [SMALL_STATE(1436)] = 103065,
  [SMALL_STATE(1437)] = 103102,
  [SMALL_STATE(1438)] = 103137,
  [SMALL_STATE(1439)] = 103178,
  [SMALL_STATE(1440)] = 103215,
  [SMALL_STATE(1441)] = 103250,
  [SMALL_STATE(1442)] = 103285,
  [SMALL_STATE(1443)] = 103320,
  [SMALL_STATE(1444)] = 103359,
  [SMALL_STATE(1445)] = 103394,
  [SMALL_STATE(1446)] = 103429,
  [SMALL_STATE(1447)] = 103463,
  [SMALL_STATE(1448)] = 103497,
  [SMALL_STATE(1449)] = 103537,
  [SMALL_STATE(1450)] = 103571,
  [SMALL_STATE(1451)] = 103605,
  [SMALL_STATE(1452)] = 103639,
  [SMALL_STATE(1453)] = 103673,
  [SMALL_STATE(1454)] = 103707,
  [SMALL_STATE(1455)] = 103741,
  [SMALL_STATE(1456)] = 103781,
  [SMALL_STATE(1457)] = 103815,
  [SMALL_STATE(1458)] = 103855,
  [SMALL_STATE(1459)] = 103889,
  [SMALL_STATE(1460)] = 103923,
  [SMALL_STATE(1461)] = 103957,
  [SMALL_STATE(1462)] = 103997,
  [SMALL_STATE(1463)] = 104031,
  [SMALL_STATE(1464)] = 104067,
  [SMALL_STATE(1465)] = 104105,
  [SMALL_STATE(1466)] = 104145,
  [SMALL_STATE(1467)] = 104179,
  [SMALL_STATE(1468)] = 104213,
  [SMALL_STATE(1469)] = 104247,
  [SMALL_STATE(1470)] = 104281,
  [SMALL_STATE(1471)] = 104315,
  [SMALL_STATE(1472)] = 104349,
  [SMALL_STATE(1473)] = 104401,
  [SMALL_STATE(1474)] = 104457,
  [SMALL_STATE(1475)] = 104491,
  [SMALL_STATE(1476)] = 104531,
  [SMALL_STATE(1477)] = 104565,
  [SMALL_STATE(1478)] = 104601,
  [SMALL_STATE(1479)] = 104637,
  [SMALL_STATE(1480)] = 104675,
  [SMALL_STATE(1481)] = 104715,
  [SMALL_STATE(1482)] = 104749,
  [SMALL_STATE(1483)] = 104783,
  [SMALL_STATE(1484)] = 104817,
  [SMALL_STATE(1485)] = 104851,
  [SMALL_STATE(1486)] = 104885,
  [SMALL_STATE(1487)] = 104919,
  [SMALL_STATE(1488)] = 104953,
  [SMALL_STATE(1489)] = 104991,
  [SMALL_STATE(1490)] = 105025,
  [SMALL_STATE(1491)] = 105059,
  [SMALL_STATE(1492)] = 105093,
  [SMALL_STATE(1493)] = 105127,
  [SMALL_STATE(1494)] = 105161,
  [SMALL_STATE(1495)] = 105195,
  [SMALL_STATE(1496)] = 105247,
  [SMALL_STATE(1497)] = 105303,
  [SMALL_STATE(1498)] = 105337,
  [SMALL_STATE(1499)] = 105371,
  [SMALL_STATE(1500)] = 105405,
  [SMALL_STATE(1501)] = 105439,
  [SMALL_STATE(1502)] = 105473,
  [SMALL_STATE(1503)] = 105507,
  [SMALL_STATE(1504)] = 105541,
  [SMALL_STATE(1505)] = 105575,
  [SMALL_STATE(1506)] = 105609,
  [SMALL_STATE(1507)] = 105649,
  [SMALL_STATE(1508)] = 105683,
  [SMALL_STATE(1509)] = 105717,
  [SMALL_STATE(1510)] = 105751,
  [SMALL_STATE(1511)] = 105785,
  [SMALL_STATE(1512)] = 105819,
  [SMALL_STATE(1513)] = 105853,
  [SMALL_STATE(1514)] = 105887,
  [SMALL_STATE(1515)] = 105921,
  [SMALL_STATE(1516)] = 105977,
  [SMALL_STATE(1517)] = 106011,
  [SMALL_STATE(1518)] = 106051,
  [SMALL_STATE(1519)] = 106085,
  [SMALL_STATE(1520)] = 106119,
  [SMALL_STATE(1521)] = 106153,
  [SMALL_STATE(1522)] = 106187,
  [SMALL_STATE(1523)] = 106225,
  [SMALL_STATE(1524)] = 106261,
  [SMALL_STATE(1525)] = 106295,
  [SMALL_STATE(1526)] = 106329,
  [SMALL_STATE(1527)] = 106363,
  [SMALL_STATE(1528)] = 106419,
  [SMALL_STATE(1529)] = 106453,
  [SMALL_STATE(1530)] = 106487,
  [SMALL_STATE(1531)] = 106545,
  [SMALL_STATE(1532)] = 106579,
  [SMALL_STATE(1533)] = 106613,
  [SMALL_STATE(1534)] = 106669,
  [SMALL_STATE(1535)] = 106703,
  [SMALL_STATE(1536)] = 106743,
  [SMALL_STATE(1537)] = 106777,
  [SMALL_STATE(1538)] = 106817,
  [SMALL_STATE(1539)] = 106851,
  [SMALL_STATE(1540)] = 106885,
  [SMALL_STATE(1541)] = 106941,
  [SMALL_STATE(1542)] = 106997,
  [SMALL_STATE(1543)] = 107031,
  [SMALL_STATE(1544)] = 107071,
  [SMALL_STATE(1545)] = 107105,
  [SMALL_STATE(1546)] = 107139,
  [SMALL_STATE(1547)] = 107173,
  [SMALL_STATE(1548)] = 107207,
  [SMALL_STATE(1549)] = 107241,
  [SMALL_STATE(1550)] = 107281,
  [SMALL_STATE(1551)] = 107315,
  [SMALL_STATE(1552)] = 107349,
  [SMALL_STATE(1553)] = 107383,
  [SMALL_STATE(1554)] = 107417,
  [SMALL_STATE(1555)] = 107451,
  [SMALL_STATE(1556)] = 107491,
  [SMALL_STATE(1557)] = 107525,
  [SMALL_STATE(1558)] = 107559,
  [SMALL_STATE(1559)] = 107593,
  [SMALL_STATE(1560)] = 107649,
  [SMALL_STATE(1561)] = 107685,
  [SMALL_STATE(1562)] = 107723,
  [SMALL_STATE(1563)] = 107763,
  [SMALL_STATE(1564)] = 107797,
  [SMALL_STATE(1565)] = 107853,
  [SMALL_STATE(1566)] = 107887,
  [SMALL_STATE(1567)] = 107921,
  [SMALL_STATE(1568)] = 107961,
  [SMALL_STATE(1569)] = 107995,
  [SMALL_STATE(1570)] = 108029,
  [SMALL_STATE(1571)] = 108063,
  [SMALL_STATE(1572)] = 108103,
  [SMALL_STATE(1573)] = 108137,
  [SMALL_STATE(1574)] = 108177,
  [SMALL_STATE(1575)] = 108213,
  [SMALL_STATE(1576)] = 108251,
  [SMALL_STATE(1577)] = 108291,
  [SMALL_STATE(1578)] = 108325,
  [SMALL_STATE(1579)] = 108381,
  [SMALL_STATE(1580)] = 108415,
  [SMALL_STATE(1581)] = 108449,
  [SMALL_STATE(1582)] = 108483,
  [SMALL_STATE(1583)] = 108517,
  [SMALL_STATE(1584)] = 108551,
  [SMALL_STATE(1585)] = 108585,
  [SMALL_STATE(1586)] = 108619,
  [SMALL_STATE(1587)] = 108653,
  [SMALL_STATE(1588)] = 108687,
  [SMALL_STATE(1589)] = 108721,
  [SMALL_STATE(1590)] = 108755,
  [SMALL_STATE(1591)] = 108789,
  [SMALL_STATE(1592)] = 108823,
  [SMALL_STATE(1593)] = 108879,
  [SMALL_STATE(1594)] = 108913,
  [SMALL_STATE(1595)] = 108947,
  [SMALL_STATE(1596)] = 108981,
  [SMALL_STATE(1597)] = 109015,
  [SMALL_STATE(1598)] = 109055,
  [SMALL_STATE(1599)] = 109089,
  [SMALL_STATE(1600)] = 109123,
  [SMALL_STATE(1601)] = 109157,
  [SMALL_STATE(1602)] = 109191,
  [SMALL_STATE(1603)] = 109225,
  [SMALL_STATE(1604)] = 109259,
  [SMALL_STATE(1605)] = 109293,
  [SMALL_STATE(1606)] = 109327,
  [SMALL_STATE(1607)] = 109361,
  [SMALL_STATE(1608)] = 109395,
  [SMALL_STATE(1609)] = 109431,
  [SMALL_STATE(1610)] = 109471,
  [SMALL_STATE(1611)] = 109527,
  [SMALL_STATE(1612)] = 109583,
  [SMALL_STATE(1613)] = 109617,
  [SMALL_STATE(1614)] = 109657,
  [SMALL_STATE(1615)] = 109697,
  [SMALL_STATE(1616)] = 109731,
  [SMALL_STATE(1617)] = 109765,
  [SMALL_STATE(1618)] = 109799,
  [SMALL_STATE(1619)] = 109833,
  [SMALL_STATE(1620)] = 109867,
  [SMALL_STATE(1621)] = 109901,
  [SMALL_STATE(1622)] = 109957,
  [SMALL_STATE(1623)] = 109991,
  [SMALL_STATE(1624)] = 110047,
  [SMALL_STATE(1625)] = 110081,
  [SMALL_STATE(1626)] = 110137,
  [SMALL_STATE(1627)] = 110193,
  [SMALL_STATE(1628)] = 110249,
  [SMALL_STATE(1629)] = 110305,
  [SMALL_STATE(1630)] = 110345,
  [SMALL_STATE(1631)] = 110379,
  [SMALL_STATE(1632)] = 110413,
  [SMALL_STATE(1633)] = 110469,
  [SMALL_STATE(1634)] = 110525,
  [SMALL_STATE(1635)] = 110581,
  [SMALL_STATE(1636)] = 110615,
  [SMALL_STATE(1637)] = 110649,
  [SMALL_STATE(1638)] = 110705,
  [SMALL_STATE(1639)] = 110761,
  [SMALL_STATE(1640)] = 110817,
  [SMALL_STATE(1641)] = 110857,
  [SMALL_STATE(1642)] = 110913,
  [SMALL_STATE(1643)] = 110969,
  [SMALL_STATE(1644)] = 111025,
  [SMALL_STATE(1645)] = 111081,
  [SMALL_STATE(1646)] = 111137,
  [SMALL_STATE(1647)] = 111193,
  [SMALL_STATE(1648)] = 111249,
  [SMALL_STATE(1649)] = 111305,
  [SMALL_STATE(1650)] = 111339,
  [SMALL_STATE(1651)] = 111395,
  [SMALL_STATE(1652)] = 111451,
  [SMALL_STATE(1653)] = 111507,
  [SMALL_STATE(1654)] = 111553,
  [SMALL_STATE(1655)] = 111603,
  [SMALL_STATE(1656)] = 111659,
  [SMALL_STATE(1657)] = 111693,
  [SMALL_STATE(1658)] = 111727,
  [SMALL_STATE(1659)] = 111775,
  [SMALL_STATE(1660)] = 111809,
  [SMALL_STATE(1661)] = 111847,
  [SMALL_STATE(1662)] = 111903,
  [SMALL_STATE(1663)] = 111939,
  [SMALL_STATE(1664)] = 111975,
  [SMALL_STATE(1665)] = 112031,
  [SMALL_STATE(1666)] = 112087,
  [SMALL_STATE(1667)] = 112125,
  [SMALL_STATE(1668)] = 112165,
  [SMALL_STATE(1669)] = 112199,
  [SMALL_STATE(1670)] = 112233,
  [SMALL_STATE(1671)] = 112267,
  [SMALL_STATE(1672)] = 112323,
  [SMALL_STATE(1673)] = 112365,
  [SMALL_STATE(1674)] = 112399,
  [SMALL_STATE(1675)] = 112433,
  [SMALL_STATE(1676)] = 112471,
  [SMALL_STATE(1677)] = 112517,
  [SMALL_STATE(1678)] = 112555,
  [SMALL_STATE(1679)] = 112611,
  [SMALL_STATE(1680)] = 112667,
  [SMALL_STATE(1681)] = 112723,
  [SMALL_STATE(1682)] = 112779,
  [SMALL_STATE(1683)] = 112835,
  [SMALL_STATE(1684)] = 112869,
  [SMALL_STATE(1685)] = 112903,
  [SMALL_STATE(1686)] = 112937,
  [SMALL_STATE(1687)] = 112971,
  [SMALL_STATE(1688)] = 113005,
  [SMALL_STATE(1689)] = 113061,
  [SMALL_STATE(1690)] = 113095,
  [SMALL_STATE(1691)] = 113151,
  [SMALL_STATE(1692)] = 113207,
  [SMALL_STATE(1693)] = 113263,
  [SMALL_STATE(1694)] = 113319,
  [SMALL_STATE(1695)] = 113375,
  [SMALL_STATE(1696)] = 113431,
  [SMALL_STATE(1697)] = 113487,
  [SMALL_STATE(1698)] = 113543,
  [SMALL_STATE(1699)] = 113599,
  [SMALL_STATE(1700)] = 113639,
  [SMALL_STATE(1701)] = 113695,
  [SMALL_STATE(1702)] = 113751,
  [SMALL_STATE(1703)] = 113807,
  [SMALL_STATE(1704)] = 113863,
  [SMALL_STATE(1705)] = 113919,
  [SMALL_STATE(1706)] = 113975,
  [SMALL_STATE(1707)] = 114031,
  [SMALL_STATE(1708)] = 114087,
  [SMALL_STATE(1709)] = 114121,
  [SMALL_STATE(1710)] = 114155,
  [SMALL_STATE(1711)] = 114211,
  [SMALL_STATE(1712)] = 114247,
  [SMALL_STATE(1713)] = 114281,
  [SMALL_STATE(1714)] = 114315,
  [SMALL_STATE(1715)] = 114349,
  [SMALL_STATE(1716)] = 114405,
  [SMALL_STATE(1717)] = 114461,
  [SMALL_STATE(1718)] = 114517,
  [SMALL_STATE(1719)] = 114555,
  [SMALL_STATE(1720)] = 114591,
  [SMALL_STATE(1721)] = 114625,
  [SMALL_STATE(1722)] = 114663,
  [SMALL_STATE(1723)] = 114699,
  [SMALL_STATE(1724)] = 114733,
  [SMALL_STATE(1725)] = 114789,
  [SMALL_STATE(1726)] = 114845,
  [SMALL_STATE(1727)] = 114881,
  [SMALL_STATE(1728)] = 114915,
  [SMALL_STATE(1729)] = 114949,
  [SMALL_STATE(1730)] = 114983,
  [SMALL_STATE(1731)] = 115017,
  [SMALL_STATE(1732)] = 115051,
  [SMALL_STATE(1733)] = 115107,
  [SMALL_STATE(1734)] = 115163,
  [SMALL_STATE(1735)] = 115197,
  [SMALL_STATE(1736)] = 115231,
  [SMALL_STATE(1737)] = 115265,
  [SMALL_STATE(1738)] = 115298,
  [SMALL_STATE(1739)] = 115335,
  [SMALL_STATE(1740)] = 115380,
  [SMALL_STATE(1741)] = 115417,
  [SMALL_STATE(1742)] = 115454,
  [SMALL_STATE(1743)] = 115489,
  [SMALL_STATE(1744)] = 115522,
  [SMALL_STATE(1745)] = 115557,
  [SMALL_STATE(1746)] = 115590,
  [SMALL_STATE(1747)] = 115623,
  [SMALL_STATE(1748)] = 115660,
  [SMALL_STATE(1749)] = 115693,
  [SMALL_STATE(1750)] = 115726,
  [SMALL_STATE(1751)] = 115759,
  [SMALL_STATE(1752)] = 115792,
  [SMALL_STATE(1753)] = 115827,
  [SMALL_STATE(1754)] = 115860,
  [SMALL_STATE(1755)] = 115893,
  [SMALL_STATE(1756)] = 115926,
  [SMALL_STATE(1757)] = 115959,
  [SMALL_STATE(1758)] = 115992,
  [SMALL_STATE(1759)] = 116025,
  [SMALL_STATE(1760)] = 116078,
  [SMALL_STATE(1761)] = 116111,
  [SMALL_STATE(1762)] = 116144,
  [SMALL_STATE(1763)] = 116177,
  [SMALL_STATE(1764)] = 116210,
  [SMALL_STATE(1765)] = 116243,
  [SMALL_STATE(1766)] = 116276,
  [SMALL_STATE(1767)] = 116309,
  [SMALL_STATE(1768)] = 116342,
  [SMALL_STATE(1769)] = 116375,
  [SMALL_STATE(1770)] = 116408,
  [SMALL_STATE(1771)] = 116441,
  [SMALL_STATE(1772)] = 116474,
  [SMALL_STATE(1773)] = 116507,
  [SMALL_STATE(1774)] = 116540,
  [SMALL_STATE(1775)] = 116573,
  [SMALL_STATE(1776)] = 116606,
  [SMALL_STATE(1777)] = 116639,
  [SMALL_STATE(1778)] = 116694,
  [SMALL_STATE(1779)] = 116727,
  [SMALL_STATE(1780)] = 116760,
  [SMALL_STATE(1781)] = 116793,
  [SMALL_STATE(1782)] = 116826,
  [SMALL_STATE(1783)] = 116859,
  [SMALL_STATE(1784)] = 116892,
  [SMALL_STATE(1785)] = 116925,
  [SMALL_STATE(1786)] = 116978,
  [SMALL_STATE(1787)] = 117017,
  [SMALL_STATE(1788)] = 117054,
  [SMALL_STATE(1789)] = 117087,
  [SMALL_STATE(1790)] = 117120,
  [SMALL_STATE(1791)] = 117153,
  [SMALL_STATE(1792)] = 117186,
  [SMALL_STATE(1793)] = 117219,
  [SMALL_STATE(1794)] = 117254,
  [SMALL_STATE(1795)] = 117293,
  [SMALL_STATE(1796)] = 117326,
  [SMALL_STATE(1797)] = 117365,
  [SMALL_STATE(1798)] = 117398,
  [SMALL_STATE(1799)] = 117431,
  [SMALL_STATE(1800)] = 117464,
  [SMALL_STATE(1801)] = 117503,
  [SMALL_STATE(1802)] = 117536,
  [SMALL_STATE(1803)] = 117571,
  [SMALL_STATE(1804)] = 117606,
  [SMALL_STATE(1805)] = 117643,
  [SMALL_STATE(1806)] = 117682,
  [SMALL_STATE(1807)] = 117715,
  [SMALL_STATE(1808)] = 117748,
  [SMALL_STATE(1809)] = 117781,
  [SMALL_STATE(1810)] = 117814,
  [SMALL_STATE(1811)] = 117847,
  [SMALL_STATE(1812)] = 117884,
  [SMALL_STATE(1813)] = 117917,
  [SMALL_STATE(1814)] = 117952,
  [SMALL_STATE(1815)] = 117989,
  [SMALL_STATE(1816)] = 118026,
  [SMALL_STATE(1817)] = 118059,
  [SMALL_STATE(1818)] = 118092,
  [SMALL_STATE(1819)] = 118137,
  [SMALL_STATE(1820)] = 118176,
  [SMALL_STATE(1821)] = 118209,
  [SMALL_STATE(1822)] = 118242,
  [SMALL_STATE(1823)] = 118275,
  [SMALL_STATE(1824)] = 118308,
  [SMALL_STATE(1825)] = 118347,
  [SMALL_STATE(1826)] = 118398,
  [SMALL_STATE(1827)] = 118431,
  [SMALL_STATE(1828)] = 118470,
  [SMALL_STATE(1829)] = 118503,
  [SMALL_STATE(1830)] = 118536,
  [SMALL_STATE(1831)] = 118569,
  [SMALL_STATE(1832)] = 118602,
  [SMALL_STATE(1833)] = 118637,
  [SMALL_STATE(1834)] = 118672,
  [SMALL_STATE(1835)] = 118709,
  [SMALL_STATE(1836)] = 118748,
  [SMALL_STATE(1837)] = 118781,
  [SMALL_STATE(1838)] = 118830,
  [SMALL_STATE(1839)] = 118863,
  [SMALL_STATE(1840)] = 118896,
  [SMALL_STATE(1841)] = 118929,
  [SMALL_STATE(1842)] = 118962,
  [SMALL_STATE(1843)] = 119015,
  [SMALL_STATE(1844)] = 119048,
  [SMALL_STATE(1845)] = 119081,
  [SMALL_STATE(1846)] = 119114,
  [SMALL_STATE(1847)] = 119155,
  [SMALL_STATE(1848)] = 119194,
  [SMALL_STATE(1849)] = 119227,
  [SMALL_STATE(1850)] = 119265,
  [SMALL_STATE(1851)] = 119303,
  [SMALL_STATE(1852)] = 119337,
  [SMALL_STATE(1853)] = 119369,
  [SMALL_STATE(1854)] = 119423,
  [SMALL_STATE(1855)] = 119459,
  [SMALL_STATE(1856)] = 119515,
  [SMALL_STATE(1857)] = 119571,
  [SMALL_STATE(1858)] = 119609,
  [SMALL_STATE(1859)] = 119641,
  [SMALL_STATE(1860)] = 119673,
  [SMALL_STATE(1861)] = 119707,
  [SMALL_STATE(1862)] = 119743,
  [SMALL_STATE(1863)] = 119799,
  [SMALL_STATE(1864)] = 119831,
  [SMALL_STATE(1865)] = 119869,
  [SMALL_STATE(1866)] = 119901,
  [SMALL_STATE(1867)] = 119935,
  [SMALL_STATE(1868)] = 119973,
  [SMALL_STATE(1869)] = 120005,
  [SMALL_STATE(1870)] = 120037,
  [SMALL_STATE(1871)] = 120093,
  [SMALL_STATE(1872)] = 120125,
  [SMALL_STATE(1873)] = 120157,
  [SMALL_STATE(1874)] = 120191,
  [SMALL_STATE(1875)] = 120225,
  [SMALL_STATE(1876)] = 120261,
  [SMALL_STATE(1877)] = 120299,
  [SMALL_STATE(1878)] = 120331,
  [SMALL_STATE(1879)] = 120367,
  [SMALL_STATE(1880)] = 120399,
  [SMALL_STATE(1881)] = 120431,
  [SMALL_STATE(1882)] = 120463,
  [SMALL_STATE(1883)] = 120495,
  [SMALL_STATE(1884)] = 120527,
  [SMALL_STATE(1885)] = 120559,
  [SMALL_STATE(1886)] = 120595,
  [SMALL_STATE(1887)] = 120651,
  [SMALL_STATE(1888)] = 120685,
  [SMALL_STATE(1889)] = 120717,
  [SMALL_STATE(1890)] = 120767,
  [SMALL_STATE(1891)] = 120799,
  [SMALL_STATE(1892)] = 120855,
  [SMALL_STATE(1893)] = 120887,
  [SMALL_STATE(1894)] = 120919,
  [SMALL_STATE(1895)] = 120951,
  [SMALL_STATE(1896)] = 120987,
  [SMALL_STATE(1897)] = 121019,
  [SMALL_STATE(1898)] = 121051,
  [SMALL_STATE(1899)] = 121083,
  [SMALL_STATE(1900)] = 121119,
  [SMALL_STATE(1901)] = 121153,
  [SMALL_STATE(1902)] = 121185,
  [SMALL_STATE(1903)] = 121219,
  [SMALL_STATE(1904)] = 121251,
  [SMALL_STATE(1905)] = 121307,
  [SMALL_STATE(1906)] = 121345,
  [SMALL_STATE(1907)] = 121377,
  [SMALL_STATE(1908)] = 121411,
  [SMALL_STATE(1909)] = 121465,
  [SMALL_STATE(1910)] = 121497,
  [SMALL_STATE(1911)] = 121533,
  [SMALL_STATE(1912)] = 121589,
  [SMALL_STATE(1913)] = 121621,
  [SMALL_STATE(1914)] = 121659,
  [SMALL_STATE(1915)] = 121691,
  [SMALL_STATE(1916)] = 121723,
  [SMALL_STATE(1917)] = 121757,
  [SMALL_STATE(1918)] = 121795,
  [SMALL_STATE(1919)] = 121827,
  [SMALL_STATE(1920)] = 121861,
  [SMALL_STATE(1921)] = 121893,
  [SMALL_STATE(1922)] = 121949,
  [SMALL_STATE(1923)] = 121985,
  [SMALL_STATE(1924)] = 122041,
  [SMALL_STATE(1925)] = 122079,
  [SMALL_STATE(1926)] = 122115,
  [SMALL_STATE(1927)] = 122147,
  [SMALL_STATE(1928)] = 122179,
  [SMALL_STATE(1929)] = 122235,
  [SMALL_STATE(1930)] = 122267,
  [SMALL_STATE(1931)] = 122299,
  [SMALL_STATE(1932)] = 122331,
  [SMALL_STATE(1933)] = 122363,
  [SMALL_STATE(1934)] = 122395,
  [SMALL_STATE(1935)] = 122451,
  [SMALL_STATE(1936)] = 122486,
  [SMALL_STATE(1937)] = 122521,
  [SMALL_STATE(1938)] = 122552,
  [SMALL_STATE(1939)] = 122583,
  [SMALL_STATE(1940)] = 122614,
  [SMALL_STATE(1941)] = 122645,
  [SMALL_STATE(1942)] = 122676,
  [SMALL_STATE(1943)] = 122707,
  [SMALL_STATE(1944)] = 122738,
  [SMALL_STATE(1945)] = 122769,
  [SMALL_STATE(1946)] = 122812,
  [SMALL_STATE(1947)] = 122843,
  [SMALL_STATE(1948)] = 122874,
  [SMALL_STATE(1949)] = 122921,
  [SMALL_STATE(1950)] = 122966,
  [SMALL_STATE(1951)] = 123005,
  [SMALL_STATE(1952)] = 123040,
  [SMALL_STATE(1953)] = 123083,
  [SMALL_STATE(1954)] = 123118,
  [SMALL_STATE(1955)] = 123149,
  [SMALL_STATE(1956)] = 123180,
  [SMALL_STATE(1957)] = 123211,
  [SMALL_STATE(1958)] = 123242,
  [SMALL_STATE(1959)] = 123273,
  [SMALL_STATE(1960)] = 123306,
  [SMALL_STATE(1961)] = 123337,
  [SMALL_STATE(1962)] = 123368,
  [SMALL_STATE(1963)] = 123399,
  [SMALL_STATE(1964)] = 123430,
  [SMALL_STATE(1965)] = 123461,
  [SMALL_STATE(1966)] = 123492,
  [SMALL_STATE(1967)] = 123523,
  [SMALL_STATE(1968)] = 123554,
  [SMALL_STATE(1969)] = 123585,
  [SMALL_STATE(1970)] = 123616,
  [SMALL_STATE(1971)] = 123647,
  [SMALL_STATE(1972)] = 123678,
  [SMALL_STATE(1973)] = 123709,
  [SMALL_STATE(1974)] = 123740,
  [SMALL_STATE(1975)] = 123771,
  [SMALL_STATE(1976)] = 123802,
  [SMALL_STATE(1977)] = 123833,
  [SMALL_STATE(1978)] = 123864,
  [SMALL_STATE(1979)] = 123895,
  [SMALL_STATE(1980)] = 123926,
  [SMALL_STATE(1981)] = 123957,
  [SMALL_STATE(1982)] = 123988,
  [SMALL_STATE(1983)] = 124019,
  [SMALL_STATE(1984)] = 124050,
  [SMALL_STATE(1985)] = 124081,
  [SMALL_STATE(1986)] = 124112,
  [SMALL_STATE(1987)] = 124143,
  [SMALL_STATE(1988)] = 124174,
  [SMALL_STATE(1989)] = 124205,
  [SMALL_STATE(1990)] = 124236,
  [SMALL_STATE(1991)] = 124267,
  [SMALL_STATE(1992)] = 124298,
  [SMALL_STATE(1993)] = 124329,
  [SMALL_STATE(1994)] = 124360,
  [SMALL_STATE(1995)] = 124391,
  [SMALL_STATE(1996)] = 124422,
  [SMALL_STATE(1997)] = 124471,
  [SMALL_STATE(1998)] = 124502,
  [SMALL_STATE(1999)] = 124533,
  [SMALL_STATE(2000)] = 124564,
  [SMALL_STATE(2001)] = 124595,
  [SMALL_STATE(2002)] = 124644,
  [SMALL_STATE(2003)] = 124675,
  [SMALL_STATE(2004)] = 124706,
  [SMALL_STATE(2005)] = 124737,
  [SMALL_STATE(2006)] = 124768,
  [SMALL_STATE(2007)] = 124799,
  [SMALL_STATE(2008)] = 124830,
  [SMALL_STATE(2009)] = 124861,
  [SMALL_STATE(2010)] = 124892,
  [SMALL_STATE(2011)] = 124923,
  [SMALL_STATE(2012)] = 124954,
  [SMALL_STATE(2013)] = 124985,
  [SMALL_STATE(2014)] = 125038,
  [SMALL_STATE(2015)] = 125069,
  [SMALL_STATE(2016)] = 125118,
  [SMALL_STATE(2017)] = 125149,
  [SMALL_STATE(2018)] = 125180,
  [SMALL_STATE(2019)] = 125211,
  [SMALL_STATE(2020)] = 125242,
  [SMALL_STATE(2021)] = 125273,
  [SMALL_STATE(2022)] = 125304,
  [SMALL_STATE(2023)] = 125335,
  [SMALL_STATE(2024)] = 125366,
  [SMALL_STATE(2025)] = 125401,
  [SMALL_STATE(2026)] = 125432,
  [SMALL_STATE(2027)] = 125463,
  [SMALL_STATE(2028)] = 125494,
  [SMALL_STATE(2029)] = 125525,
  [SMALL_STATE(2030)] = 125568,
  [SMALL_STATE(2031)] = 125615,
  [SMALL_STATE(2032)] = 125660,
  [SMALL_STATE(2033)] = 125699,
  [SMALL_STATE(2034)] = 125734,
  [SMALL_STATE(2035)] = 125777,
  [SMALL_STATE(2036)] = 125812,
  [SMALL_STATE(2037)] = 125843,
  [SMALL_STATE(2038)] = 125874,
  [SMALL_STATE(2039)] = 125905,
  [SMALL_STATE(2040)] = 125940,
  [SMALL_STATE(2041)] = 125971,
  [SMALL_STATE(2042)] = 126004,
  [SMALL_STATE(2043)] = 126035,
  [SMALL_STATE(2044)] = 126066,
  [SMALL_STATE(2045)] = 126097,
  [SMALL_STATE(2046)] = 126128,
  [SMALL_STATE(2047)] = 126159,
  [SMALL_STATE(2048)] = 126190,
  [SMALL_STATE(2049)] = 126221,
  [SMALL_STATE(2050)] = 126254,
  [SMALL_STATE(2051)] = 126285,
  [SMALL_STATE(2052)] = 126316,
  [SMALL_STATE(2053)] = 126347,
  [SMALL_STATE(2054)] = 126396,
  [SMALL_STATE(2055)] = 126427,
  [SMALL_STATE(2056)] = 126458,
  [SMALL_STATE(2057)] = 126489,
  [SMALL_STATE(2058)] = 126520,
  [SMALL_STATE(2059)] = 126551,
  [SMALL_STATE(2060)] = 126582,
  [SMALL_STATE(2061)] = 126631,
  [SMALL_STATE(2062)] = 126662,
  [SMALL_STATE(2063)] = 126693,
  [SMALL_STATE(2064)] = 126724,
  [SMALL_STATE(2065)] = 126755,
  [SMALL_STATE(2066)] = 126786,
  [SMALL_STATE(2067)] = 126835,
  [SMALL_STATE(2068)] = 126866,
  [SMALL_STATE(2069)] = 126897,
  [SMALL_STATE(2070)] = 126928,
  [SMALL_STATE(2071)] = 126959,
  [SMALL_STATE(2072)] = 126990,
  [SMALL_STATE(2073)] = 127021,
  [SMALL_STATE(2074)] = 127052,
  [SMALL_STATE(2075)] = 127083,
  [SMALL_STATE(2076)] = 127114,
  [SMALL_STATE(2077)] = 127145,
  [SMALL_STATE(2078)] = 127176,
  [SMALL_STATE(2079)] = 127207,
  [SMALL_STATE(2080)] = 127238,
  [SMALL_STATE(2081)] = 127269,
  [SMALL_STATE(2082)] = 127300,
  [SMALL_STATE(2083)] = 127331,
  [SMALL_STATE(2084)] = 127366,
  [SMALL_STATE(2085)] = 127397,
  [SMALL_STATE(2086)] = 127446,
  [SMALL_STATE(2087)] = 127479,
  [SMALL_STATE(2088)] = 127528,
  [SMALL_STATE(2089)] = 127559,
  [SMALL_STATE(2090)] = 127590,
  [SMALL_STATE(2091)] = 127621,
  [SMALL_STATE(2092)] = 127652,
  [SMALL_STATE(2093)] = 127687,
  [SMALL_STATE(2094)] = 127718,
  [SMALL_STATE(2095)] = 127749,
  [SMALL_STATE(2096)] = 127784,
  [SMALL_STATE(2097)] = 127833,
  [SMALL_STATE(2098)] = 127864,
  [SMALL_STATE(2099)] = 127894,
  [SMALL_STATE(2100)] = 127924,
  [SMALL_STATE(2101)] = 127954,
  [SMALL_STATE(2102)] = 127984,
  [SMALL_STATE(2103)] = 128014,
  [SMALL_STATE(2104)] = 128044,
  [SMALL_STATE(2105)] = 128074,
  [SMALL_STATE(2106)] = 128108,
  [SMALL_STATE(2107)] = 128158,
  [SMALL_STATE(2108)] = 128188,
  [SMALL_STATE(2109)] = 128218,
  [SMALL_STATE(2110)] = 128268,
  [SMALL_STATE(2111)] = 128298,
  [SMALL_STATE(2112)] = 128328,
  [SMALL_STATE(2113)] = 128358,
  [SMALL_STATE(2114)] = 128388,
  [SMALL_STATE(2115)] = 128418,
  [SMALL_STATE(2116)] = 128448,
  [SMALL_STATE(2117)] = 128478,
  [SMALL_STATE(2118)] = 128508,
  [SMALL_STATE(2119)] = 128558,
  [SMALL_STATE(2120)] = 128592,
  [SMALL_STATE(2121)] = 128622,
  [SMALL_STATE(2122)] = 128652,
  [SMALL_STATE(2123)] = 128682,
  [SMALL_STATE(2124)] = 128712,
  [SMALL_STATE(2125)] = 128742,
  [SMALL_STATE(2126)] = 128772,
  [SMALL_STATE(2127)] = 128802,
  [SMALL_STATE(2128)] = 128832,
  [SMALL_STATE(2129)] = 128862,
  [SMALL_STATE(2130)] = 128892,
  [SMALL_STATE(2131)] = 128942,
  [SMALL_STATE(2132)] = 128972,
  [SMALL_STATE(2133)] = 129002,
  [SMALL_STATE(2134)] = 129032,
  [SMALL_STATE(2135)] = 129062,
  [SMALL_STATE(2136)] = 129092,
  [SMALL_STATE(2137)] = 129122,
  [SMALL_STATE(2138)] = 129152,
  [SMALL_STATE(2139)] = 129186,
  [SMALL_STATE(2140)] = 129216,
  [SMALL_STATE(2141)] = 129246,
  [SMALL_STATE(2142)] = 129276,
  [SMALL_STATE(2143)] = 129306,
  [SMALL_STATE(2144)] = 129348,
  [SMALL_STATE(2145)] = 129378,
  [SMALL_STATE(2146)] = 129412,
  [SMALL_STATE(2147)] = 129450,
  [SMALL_STATE(2148)] = 129488,
  [SMALL_STATE(2149)] = 129518,
  [SMALL_STATE(2150)] = 129548,
  [SMALL_STATE(2151)] = 129578,
  [SMALL_STATE(2152)] = 129608,
  [SMALL_STATE(2153)] = 129640,
  [SMALL_STATE(2154)] = 129670,
  [SMALL_STATE(2155)] = 129700,
  [SMALL_STATE(2156)] = 129730,
  [SMALL_STATE(2157)] = 129778,
  [SMALL_STATE(2158)] = 129808,
  [SMALL_STATE(2159)] = 129854,
  [SMALL_STATE(2160)] = 129884,
  [SMALL_STATE(2161)] = 129934,
  [SMALL_STATE(2162)] = 129964,
  [SMALL_STATE(2163)] = 129998,
  [SMALL_STATE(2164)] = 130048,
  [SMALL_STATE(2165)] = 130092,
  [SMALL_STATE(2166)] = 130122,
  [SMALL_STATE(2167)] = 130152,
  [SMALL_STATE(2168)] = 130182,
  [SMALL_STATE(2169)] = 130212,
  [SMALL_STATE(2170)] = 130242,
  [SMALL_STATE(2171)] = 130272,
  [SMALL_STATE(2172)] = 130306,
  [SMALL_STATE(2173)] = 130336,
  [SMALL_STATE(2174)] = 130378,
  [SMALL_STATE(2175)] = 130420,
  [SMALL_STATE(2176)] = 130450,
  [SMALL_STATE(2177)] = 130498,
  [SMALL_STATE(2178)] = 130548,
  [SMALL_STATE(2179)] = 130578,
  [SMALL_STATE(2180)] = 130626,
  [SMALL_STATE(2181)] = 130658,
  [SMALL_STATE(2182)] = 130688,
  [SMALL_STATE(2183)] = 130736,
  [SMALL_STATE(2184)] = 130768,
  [SMALL_STATE(2185)] = 130814,
  [SMALL_STATE(2186)] = 130844,
  [SMALL_STATE(2187)] = 130874,
  [SMALL_STATE(2188)] = 130904,
  [SMALL_STATE(2189)] = 130934,
  [SMALL_STATE(2190)] = 130964,
  [SMALL_STATE(2191)] = 131006,
  [SMALL_STATE(2192)] = 131036,
  [SMALL_STATE(2193)] = 131081,
  [SMALL_STATE(2194)] = 131110,
  [SMALL_STATE(2195)] = 131139,
  [SMALL_STATE(2196)] = 131168,
  [SMALL_STATE(2197)] = 131215,
  [SMALL_STATE(2198)] = 131244,
  [SMALL_STATE(2199)] = 131273,
  [SMALL_STATE(2200)] = 131302,
  [SMALL_STATE(2201)] = 131331,
  [SMALL_STATE(2202)] = 131360,
  [SMALL_STATE(2203)] = 131389,
  [SMALL_STATE(2204)] = 131418,
  [SMALL_STATE(2205)] = 131447,
  [SMALL_STATE(2206)] = 131476,
  [SMALL_STATE(2207)] = 131505,
  [SMALL_STATE(2208)] = 131534,
  [SMALL_STATE(2209)] = 131563,
  [SMALL_STATE(2210)] = 131592,
  [SMALL_STATE(2211)] = 131621,
  [SMALL_STATE(2212)] = 131650,
  [SMALL_STATE(2213)] = 131679,
  [SMALL_STATE(2214)] = 131708,
  [SMALL_STATE(2215)] = 131737,
  [SMALL_STATE(2216)] = 131766,
  [SMALL_STATE(2217)] = 131795,
  [SMALL_STATE(2218)] = 131826,
  [SMALL_STATE(2219)] = 131855,
  [SMALL_STATE(2220)] = 131884,
  [SMALL_STATE(2221)] = 131931,
  [SMALL_STATE(2222)] = 131960,
  [SMALL_STATE(2223)] = 132007,
  [SMALL_STATE(2224)] = 132042,
  [SMALL_STATE(2225)] = 132071,
  [SMALL_STATE(2226)] = 132100,
  [SMALL_STATE(2227)] = 132129,
  [SMALL_STATE(2228)] = 132158,
  [SMALL_STATE(2229)] = 132205,
  [SMALL_STATE(2230)] = 132252,
  [SMALL_STATE(2231)] = 132281,
  [SMALL_STATE(2232)] = 132328,
  [SMALL_STATE(2233)] = 132357,
  [SMALL_STATE(2234)] = 132404,
  [SMALL_STATE(2235)] = 132433,
  [SMALL_STATE(2236)] = 132462,
  [SMALL_STATE(2237)] = 132491,
  [SMALL_STATE(2238)] = 132520,
  [SMALL_STATE(2239)] = 132549,
  [SMALL_STATE(2240)] = 132578,
  [SMALL_STATE(2241)] = 132625,
  [SMALL_STATE(2242)] = 132672,
  [SMALL_STATE(2243)] = 132719,
  [SMALL_STATE(2244)] = 132748,
  [SMALL_STATE(2245)] = 132777,
  [SMALL_STATE(2246)] = 132824,
  [SMALL_STATE(2247)] = 132853,
  [SMALL_STATE(2248)] = 132882,
  [SMALL_STATE(2249)] = 132911,
  [SMALL_STATE(2250)] = 132940,
  [SMALL_STATE(2251)] = 132969,
  [SMALL_STATE(2252)] = 132998,
  [SMALL_STATE(2253)] = 133027,
  [SMALL_STATE(2254)] = 133056,
  [SMALL_STATE(2255)] = 133085,
  [SMALL_STATE(2256)] = 133114,
  [SMALL_STATE(2257)] = 133161,
  [SMALL_STATE(2258)] = 133190,
  [SMALL_STATE(2259)] = 133219,
  [SMALL_STATE(2260)] = 133266,
  [SMALL_STATE(2261)] = 133295,
  [SMALL_STATE(2262)] = 133324,
  [SMALL_STATE(2263)] = 133353,
  [SMALL_STATE(2264)] = 133382,
  [SMALL_STATE(2265)] = 133413,
  [SMALL_STATE(2266)] = 133442,
  [SMALL_STATE(2267)] = 133471,
  [SMALL_STATE(2268)] = 133500,
  [SMALL_STATE(2269)] = 133529,
  [SMALL_STATE(2270)] = 133576,
  [SMALL_STATE(2271)] = 133605,
  [SMALL_STATE(2272)] = 133652,
  [SMALL_STATE(2273)] = 133681,
  [SMALL_STATE(2274)] = 133710,
  [SMALL_STATE(2275)] = 133739,
  [SMALL_STATE(2276)] = 133768,
  [SMALL_STATE(2277)] = 133797,
  [SMALL_STATE(2278)] = 133844,
  [SMALL_STATE(2279)] = 133873,
  [SMALL_STATE(2280)] = 133902,
  [SMALL_STATE(2281)] = 133949,
  [SMALL_STATE(2282)] = 133978,
  [SMALL_STATE(2283)] = 134007,
  [SMALL_STATE(2284)] = 134038,
  [SMALL_STATE(2285)] = 134067,
  [SMALL_STATE(2286)] = 134114,
  [SMALL_STATE(2287)] = 134143,
  [SMALL_STATE(2288)] = 134172,
  [SMALL_STATE(2289)] = 134201,
  [SMALL_STATE(2290)] = 134230,
  [SMALL_STATE(2291)] = 134259,
  [SMALL_STATE(2292)] = 134288,
  [SMALL_STATE(2293)] = 134317,
  [SMALL_STATE(2294)] = 134346,
  [SMALL_STATE(2295)] = 134375,
  [SMALL_STATE(2296)] = 134404,
  [SMALL_STATE(2297)] = 134433,
  [SMALL_STATE(2298)] = 134462,
  [SMALL_STATE(2299)] = 134491,
  [SMALL_STATE(2300)] = 134538,
  [SMALL_STATE(2301)] = 134585,
  [SMALL_STATE(2302)] = 134614,
  [SMALL_STATE(2303)] = 134643,
  [SMALL_STATE(2304)] = 134672,
  [SMALL_STATE(2305)] = 134701,
  [SMALL_STATE(2306)] = 134730,
  [SMALL_STATE(2307)] = 134759,
  [SMALL_STATE(2308)] = 134806,
  [SMALL_STATE(2309)] = 134835,
  [SMALL_STATE(2310)] = 134864,
  [SMALL_STATE(2311)] = 134893,
  [SMALL_STATE(2312)] = 134922,
  [SMALL_STATE(2313)] = 134951,
  [SMALL_STATE(2314)] = 134980,
  [SMALL_STATE(2315)] = 135009,
  [SMALL_STATE(2316)] = 135038,
  [SMALL_STATE(2317)] = 135085,
  [SMALL_STATE(2318)] = 135132,
  [SMALL_STATE(2319)] = 135161,
  [SMALL_STATE(2320)] = 135190,
  [SMALL_STATE(2321)] = 135219,
  [SMALL_STATE(2322)] = 135266,
  [SMALL_STATE(2323)] = 135295,
  [SMALL_STATE(2324)] = 135324,
  [SMALL_STATE(2325)] = 135353,
  [SMALL_STATE(2326)] = 135382,
  [SMALL_STATE(2327)] = 135411,
  [SMALL_STATE(2328)] = 135440,
  [SMALL_STATE(2329)] = 135487,
  [SMALL_STATE(2330)] = 135520,
  [SMALL_STATE(2331)] = 135567,
  [SMALL_STATE(2332)] = 135596,
  [SMALL_STATE(2333)] = 135625,
  [SMALL_STATE(2334)] = 135672,
  [SMALL_STATE(2335)] = 135701,
  [SMALL_STATE(2336)] = 135748,
  [SMALL_STATE(2337)] = 135789,
  [SMALL_STATE(2338)] = 135836,
  [SMALL_STATE(2339)] = 135883,
  [SMALL_STATE(2340)] = 135912,
  [SMALL_STATE(2341)] = 135941,
  [SMALL_STATE(2342)] = 135988,
  [SMALL_STATE(2343)] = 136035,
  [SMALL_STATE(2344)] = 136082,
  [SMALL_STATE(2345)] = 136111,
  [SMALL_STATE(2346)] = 136140,
  [SMALL_STATE(2347)] = 136187,
  [SMALL_STATE(2348)] = 136216,
  [SMALL_STATE(2349)] = 136245,
  [SMALL_STATE(2350)] = 136274,
  [SMALL_STATE(2351)] = 136315,
  [SMALL_STATE(2352)] = 136360,
  [SMALL_STATE(2353)] = 136403,
  [SMALL_STATE(2354)] = 136440,
  [SMALL_STATE(2355)] = 136473,
  [SMALL_STATE(2356)] = 136514,
  [SMALL_STATE(2357)] = 136547,
  [SMALL_STATE(2358)] = 136594,
  [SMALL_STATE(2359)] = 136623,
  [SMALL_STATE(2360)] = 136670,
  [SMALL_STATE(2361)] = 136717,
  [SMALL_STATE(2362)] = 136746,
  [SMALL_STATE(2363)] = 136789,
  [SMALL_STATE(2364)] = 136836,
  [SMALL_STATE(2365)] = 136865,
  [SMALL_STATE(2366)] = 136902,
  [SMALL_STATE(2367)] = 136935,
  [SMALL_STATE(2368)] = 136964,
  [SMALL_STATE(2369)] = 136993,
  [SMALL_STATE(2370)] = 137040,
  [SMALL_STATE(2371)] = 137069,
  [SMALL_STATE(2372)] = 137116,
  [SMALL_STATE(2373)] = 137145,
  [SMALL_STATE(2374)] = 137174,
  [SMALL_STATE(2375)] = 137203,
  [SMALL_STATE(2376)] = 137232,
  [SMALL_STATE(2377)] = 137279,
  [SMALL_STATE(2378)] = 137308,
  [SMALL_STATE(2379)] = 137337,
  [SMALL_STATE(2380)] = 137366,
  [SMALL_STATE(2381)] = 137395,
  [SMALL_STATE(2382)] = 137442,
  [SMALL_STATE(2383)] = 137489,
  [SMALL_STATE(2384)] = 137518,
  [SMALL_STATE(2385)] = 137547,
  [SMALL_STATE(2386)] = 137576,
  [SMALL_STATE(2387)] = 137605,
  [SMALL_STATE(2388)] = 137634,
  [SMALL_STATE(2389)] = 137681,
  [SMALL_STATE(2390)] = 137710,
  [SMALL_STATE(2391)] = 137739,
  [SMALL_STATE(2392)] = 137768,
  [SMALL_STATE(2393)] = 137797,
  [SMALL_STATE(2394)] = 137826,
  [SMALL_STATE(2395)] = 137855,
  [SMALL_STATE(2396)] = 137884,
  [SMALL_STATE(2397)] = 137913,
  [SMALL_STATE(2398)] = 137942,
  [SMALL_STATE(2399)] = 137971,
  [SMALL_STATE(2400)] = 138000,
  [SMALL_STATE(2401)] = 138029,
  [SMALL_STATE(2402)] = 138058,
  [SMALL_STATE(2403)] = 138087,
  [SMALL_STATE(2404)] = 138116,
  [SMALL_STATE(2405)] = 138145,
  [SMALL_STATE(2406)] = 138174,
  [SMALL_STATE(2407)] = 138203,
  [SMALL_STATE(2408)] = 138250,
  [SMALL_STATE(2409)] = 138279,
  [SMALL_STATE(2410)] = 138308,
  [SMALL_STATE(2411)] = 138337,
  [SMALL_STATE(2412)] = 138366,
  [SMALL_STATE(2413)] = 138395,
  [SMALL_STATE(2414)] = 138424,
  [SMALL_STATE(2415)] = 138453,
  [SMALL_STATE(2416)] = 138482,
  [SMALL_STATE(2417)] = 138511,
  [SMALL_STATE(2418)] = 138540,
  [SMALL_STATE(2419)] = 138569,
  [SMALL_STATE(2420)] = 138598,
  [SMALL_STATE(2421)] = 138627,
  [SMALL_STATE(2422)] = 138656,
  [SMALL_STATE(2423)] = 138703,
  [SMALL_STATE(2424)] = 138732,
  [SMALL_STATE(2425)] = 138761,
  [SMALL_STATE(2426)] = 138808,
  [SMALL_STATE(2427)] = 138837,
  [SMALL_STATE(2428)] = 138866,
  [SMALL_STATE(2429)] = 138895,
  [SMALL_STATE(2430)] = 138924,
  [SMALL_STATE(2431)] = 138971,
  [SMALL_STATE(2432)] = 139000,
  [SMALL_STATE(2433)] = 139047,
  [SMALL_STATE(2434)] = 139076,
  [SMALL_STATE(2435)] = 139105,
  [SMALL_STATE(2436)] = 139152,
  [SMALL_STATE(2437)] = 139181,
  [SMALL_STATE(2438)] = 139228,
  [SMALL_STATE(2439)] = 139257,
  [SMALL_STATE(2440)] = 139286,
  [SMALL_STATE(2441)] = 139327,
  [SMALL_STATE(2442)] = 139374,
  [SMALL_STATE(2443)] = 139421,
  [SMALL_STATE(2444)] = 139468,
  [SMALL_STATE(2445)] = 139497,
  [SMALL_STATE(2446)] = 139544,
  [SMALL_STATE(2447)] = 139591,
  [SMALL_STATE(2448)] = 139638,
  [SMALL_STATE(2449)] = 139671,
  [SMALL_STATE(2450)] = 139700,
  [SMALL_STATE(2451)] = 139747,
  [SMALL_STATE(2452)] = 139794,
  [SMALL_STATE(2453)] = 139841,
  [SMALL_STATE(2454)] = 139888,
  [SMALL_STATE(2455)] = 139917,
  [SMALL_STATE(2456)] = 139946,
  [SMALL_STATE(2457)] = 139975,
  [SMALL_STATE(2458)] = 140004,
  [SMALL_STATE(2459)] = 140033,
  [SMALL_STATE(2460)] = 140080,
  [SMALL_STATE(2461)] = 140109,
  [SMALL_STATE(2462)] = 140138,
  [SMALL_STATE(2463)] = 140167,
  [SMALL_STATE(2464)] = 140196,
  [SMALL_STATE(2465)] = 140225,
  [SMALL_STATE(2466)] = 140254,
  [SMALL_STATE(2467)] = 140283,
  [SMALL_STATE(2468)] = 140312,
  [SMALL_STATE(2469)] = 140341,
  [SMALL_STATE(2470)] = 140370,
  [SMALL_STATE(2471)] = 140399,
  [SMALL_STATE(2472)] = 140428,
  [SMALL_STATE(2473)] = 140457,
  [SMALL_STATE(2474)] = 140486,
  [SMALL_STATE(2475)] = 140515,
  [SMALL_STATE(2476)] = 140544,
  [SMALL_STATE(2477)] = 140573,
  [SMALL_STATE(2478)] = 140602,
  [SMALL_STATE(2479)] = 140649,
  [SMALL_STATE(2480)] = 140684,
  [SMALL_STATE(2481)] = 140713,
  [SMALL_STATE(2482)] = 140742,
  [SMALL_STATE(2483)] = 140789,
  [SMALL_STATE(2484)] = 140818,
  [SMALL_STATE(2485)] = 140847,
  [SMALL_STATE(2486)] = 140876,
  [SMALL_STATE(2487)] = 140905,
  [SMALL_STATE(2488)] = 140934,
  [SMALL_STATE(2489)] = 140981,
  [SMALL_STATE(2490)] = 141010,
  [SMALL_STATE(2491)] = 141039,
  [SMALL_STATE(2492)] = 141068,
  [SMALL_STATE(2493)] = 141097,
  [SMALL_STATE(2494)] = 141126,
  [SMALL_STATE(2495)] = 141155,
  [SMALL_STATE(2496)] = 141184,
  [SMALL_STATE(2497)] = 141213,
  [SMALL_STATE(2498)] = 141242,
  [SMALL_STATE(2499)] = 141271,
  [SMALL_STATE(2500)] = 141300,
  [SMALL_STATE(2501)] = 141329,
  [SMALL_STATE(2502)] = 141358,
  [SMALL_STATE(2503)] = 141387,
  [SMALL_STATE(2504)] = 141434,
  [SMALL_STATE(2505)] = 141463,
  [SMALL_STATE(2506)] = 141492,
  [SMALL_STATE(2507)] = 141521,
  [SMALL_STATE(2508)] = 141550,
  [SMALL_STATE(2509)] = 141597,
  [SMALL_STATE(2510)] = 141626,
  [SMALL_STATE(2511)] = 141655,
  [SMALL_STATE(2512)] = 141702,
  [SMALL_STATE(2513)] = 141749,
  [SMALL_STATE(2514)] = 141796,
  [SMALL_STATE(2515)] = 141843,
  [SMALL_STATE(2516)] = 141890,
  [SMALL_STATE(2517)] = 141937,
  [SMALL_STATE(2518)] = 141984,
  [SMALL_STATE(2519)] = 142031,
  [SMALL_STATE(2520)] = 142078,
  [SMALL_STATE(2521)] = 142107,
  [SMALL_STATE(2522)] = 142154,
  [SMALL_STATE(2523)] = 142201,
  [SMALL_STATE(2524)] = 142248,
  [SMALL_STATE(2525)] = 142295,
  [SMALL_STATE(2526)] = 142324,
  [SMALL_STATE(2527)] = 142353,
  [SMALL_STATE(2528)] = 142382,
  [SMALL_STATE(2529)] = 142415,
  [SMALL_STATE(2530)] = 142444,
  [SMALL_STATE(2531)] = 142473,
  [SMALL_STATE(2532)] = 142501,
  [SMALL_STATE(2533)] = 142529,
  [SMALL_STATE(2534)] = 142557,
  [SMALL_STATE(2535)] = 142594,
  [SMALL_STATE(2536)] = 142621,
  [SMALL_STATE(2537)] = 142648,
  [SMALL_STATE(2538)] = 142685,
  [SMALL_STATE(2539)] = 142712,
  [SMALL_STATE(2540)] = 142749,
  [SMALL_STATE(2541)] = 142776,
  [SMALL_STATE(2542)] = 142803,
  [SMALL_STATE(2543)] = 142830,
  [SMALL_STATE(2544)] = 142867,
  [SMALL_STATE(2545)] = 142911,
  [SMALL_STATE(2546)] = 142937,
  [SMALL_STATE(2547)] = 142978,
  [SMALL_STATE(2548)] = 143019,
  [SMALL_STATE(2549)] = 143059,
  [SMALL_STATE(2550)] = 143097,
  [SMALL_STATE(2551)] = 143137,
  [SMALL_STATE(2552)] = 143177,
  [SMALL_STATE(2553)] = 143217,
  [SMALL_STATE(2554)] = 143257,
  [SMALL_STATE(2555)] = 143297,
  [SMALL_STATE(2556)] = 143337,
  [SMALL_STATE(2557)] = 143377,
  [SMALL_STATE(2558)] = 143417,
  [SMALL_STATE(2559)] = 143457,
  [SMALL_STATE(2560)] = 143495,
  [SMALL_STATE(2561)] = 143535,
  [SMALL_STATE(2562)] = 143575,
  [SMALL_STATE(2563)] = 143615,
  [SMALL_STATE(2564)] = 143655,
  [SMALL_STATE(2565)] = 143693,
  [SMALL_STATE(2566)] = 143733,
  [SMALL_STATE(2567)] = 143773,
  [SMALL_STATE(2568)] = 143813,
  [SMALL_STATE(2569)] = 143853,
  [SMALL_STATE(2570)] = 143893,
  [SMALL_STATE(2571)] = 143933,
  [SMALL_STATE(2572)] = 143973,
  [SMALL_STATE(2573)] = 144013,
  [SMALL_STATE(2574)] = 144053,
  [SMALL_STATE(2575)] = 144093,
  [SMALL_STATE(2576)] = 144120,
  [SMALL_STATE(2577)] = 144143,
  [SMALL_STATE(2578)] = 144179,
  [SMALL_STATE(2579)] = 144215,
  [SMALL_STATE(2580)] = 144251,
  [SMALL_STATE(2581)] = 144287,
  [SMALL_STATE(2582)] = 144323,
  [SMALL_STATE(2583)] = 144359,
  [SMALL_STATE(2584)] = 144395,
  [SMALL_STATE(2585)] = 144431,
  [SMALL_STATE(2586)] = 144467,
  [SMALL_STATE(2587)] = 144503,
  [SMALL_STATE(2588)] = 144539,
  [SMALL_STATE(2589)] = 144575,
  [SMALL_STATE(2590)] = 144611,
  [SMALL_STATE(2591)] = 144643,
  [SMALL_STATE(2592)] = 144679,
  [SMALL_STATE(2593)] = 144715,
  [SMALL_STATE(2594)] = 144751,
  [SMALL_STATE(2595)] = 144787,
  [SMALL_STATE(2596)] = 144823,
  [SMALL_STATE(2597)] = 144859,
  [SMALL_STATE(2598)] = 144895,
  [SMALL_STATE(2599)] = 144931,
  [SMALL_STATE(2600)] = 144967,
  [SMALL_STATE(2601)] = 145003,
  [SMALL_STATE(2602)] = 145039,
  [SMALL_STATE(2603)] = 145075,
  [SMALL_STATE(2604)] = 145111,
  [SMALL_STATE(2605)] = 145147,
  [SMALL_STATE(2606)] = 145183,
  [SMALL_STATE(2607)] = 145219,
  [SMALL_STATE(2608)] = 145255,
  [SMALL_STATE(2609)] = 145291,
  [SMALL_STATE(2610)] = 145327,
  [SMALL_STATE(2611)] = 145363,
  [SMALL_STATE(2612)] = 145399,
  [SMALL_STATE(2613)] = 145435,
  [SMALL_STATE(2614)] = 145471,
  [SMALL_STATE(2615)] = 145507,
  [SMALL_STATE(2616)] = 145543,
  [SMALL_STATE(2617)] = 145579,
  [SMALL_STATE(2618)] = 145615,
  [SMALL_STATE(2619)] = 145651,
  [SMALL_STATE(2620)] = 145687,
  [SMALL_STATE(2621)] = 145723,
  [SMALL_STATE(2622)] = 145759,
  [SMALL_STATE(2623)] = 145795,
  [SMALL_STATE(2624)] = 145831,
  [SMALL_STATE(2625)] = 145867,
  [SMALL_STATE(2626)] = 145903,
  [SMALL_STATE(2627)] = 145939,
  [SMALL_STATE(2628)] = 145975,
  [SMALL_STATE(2629)] = 146011,
  [SMALL_STATE(2630)] = 146047,
  [SMALL_STATE(2631)] = 146083,
  [SMALL_STATE(2632)] = 146119,
  [SMALL_STATE(2633)] = 146155,
  [SMALL_STATE(2634)] = 146191,
  [SMALL_STATE(2635)] = 146227,
  [SMALL_STATE(2636)] = 146263,
  [SMALL_STATE(2637)] = 146299,
  [SMALL_STATE(2638)] = 146335,
  [SMALL_STATE(2639)] = 146371,
  [SMALL_STATE(2640)] = 146407,
  [SMALL_STATE(2641)] = 146443,
  [SMALL_STATE(2642)] = 146479,
  [SMALL_STATE(2643)] = 146513,
  [SMALL_STATE(2644)] = 146549,
  [SMALL_STATE(2645)] = 146585,
  [SMALL_STATE(2646)] = 146609,
  [SMALL_STATE(2647)] = 146645,
  [SMALL_STATE(2648)] = 146681,
  [SMALL_STATE(2649)] = 146717,
  [SMALL_STATE(2650)] = 146749,
  [SMALL_STATE(2651)] = 146785,
  [SMALL_STATE(2652)] = 146806,
  [SMALL_STATE(2653)] = 146825,
  [SMALL_STATE(2654)] = 146846,
  [SMALL_STATE(2655)] = 146867,
  [SMALL_STATE(2656)] = 146888,
  [SMALL_STATE(2657)] = 146906,
  [SMALL_STATE(2658)] = 146924,
  [SMALL_STATE(2659)] = 146942,
  [SMALL_STATE(2660)] = 146972,
  [SMALL_STATE(2661)] = 146990,
  [SMALL_STATE(2662)] = 147008,
  [SMALL_STATE(2663)] = 147026,
  [SMALL_STATE(2664)] = 147050,
  [SMALL_STATE(2665)] = 147074,
  [SMALL_STATE(2666)] = 147092,
  [SMALL_STATE(2667)] = 147110,
  [SMALL_STATE(2668)] = 147142,
  [SMALL_STATE(2669)] = 147160,
  [SMALL_STATE(2670)] = 147184,
  [SMALL_STATE(2671)] = 147202,
  [SMALL_STATE(2672)] = 147226,
  [SMALL_STATE(2673)] = 147244,
  [SMALL_STATE(2674)] = 147274,
  [SMALL_STATE(2675)] = 147292,
  [SMALL_STATE(2676)] = 147310,
  [SMALL_STATE(2677)] = 147330,
  [SMALL_STATE(2678)] = 147352,
  [SMALL_STATE(2679)] = 147376,
  [SMALL_STATE(2680)] = 147406,
  [SMALL_STATE(2681)] = 147424,
  [SMALL_STATE(2682)] = 147442,
  [SMALL_STATE(2683)] = 147460,
  [SMALL_STATE(2684)] = 147484,
  [SMALL_STATE(2685)] = 147510,
  [SMALL_STATE(2686)] = 147528,
  [SMALL_STATE(2687)] = 147546,
  [SMALL_STATE(2688)] = 147564,
  [SMALL_STATE(2689)] = 147591,
  [SMALL_STATE(2690)] = 147614,
  [SMALL_STATE(2691)] = 147635,
  [SMALL_STATE(2692)] = 147662,
  [SMALL_STATE(2693)] = 147690,
  [SMALL_STATE(2694)] = 147718,
  [SMALL_STATE(2695)] = 147746,
  [SMALL_STATE(2696)] = 147774,
  [SMALL_STATE(2697)] = 147802,
  [SMALL_STATE(2698)] = 147830,
  [SMALL_STATE(2699)] = 147846,
  [SMALL_STATE(2700)] = 147862,
  [SMALL_STATE(2701)] = 147890,
  [SMALL_STATE(2702)] = 147918,
  [SMALL_STATE(2703)] = 147946,
  [SMALL_STATE(2704)] = 147974,
  [SMALL_STATE(2705)] = 148002,
  [SMALL_STATE(2706)] = 148030,
  [SMALL_STATE(2707)] = 148058,
  [SMALL_STATE(2708)] = 148086,
  [SMALL_STATE(2709)] = 148114,
  [SMALL_STATE(2710)] = 148142,
  [SMALL_STATE(2711)] = 148170,
  [SMALL_STATE(2712)] = 148186,
  [SMALL_STATE(2713)] = 148214,
  [SMALL_STATE(2714)] = 148242,
  [SMALL_STATE(2715)] = 148270,
  [SMALL_STATE(2716)] = 148298,
  [SMALL_STATE(2717)] = 148326,
  [SMALL_STATE(2718)] = 148354,
  [SMALL_STATE(2719)] = 148382,
  [SMALL_STATE(2720)] = 148410,
  [SMALL_STATE(2721)] = 148438,
  [SMALL_STATE(2722)] = 148454,
  [SMALL_STATE(2723)] = 148482,
  [SMALL_STATE(2724)] = 148510,
  [SMALL_STATE(2725)] = 148538,
  [SMALL_STATE(2726)] = 148566,
  [SMALL_STATE(2727)] = 148594,
  [SMALL_STATE(2728)] = 148622,
  [SMALL_STATE(2729)] = 148638,
  [SMALL_STATE(2730)] = 148666,
  [SMALL_STATE(2731)] = 148694,
  [SMALL_STATE(2732)] = 148722,
  [SMALL_STATE(2733)] = 148744,
  [SMALL_STATE(2734)] = 148772,
  [SMALL_STATE(2735)] = 148800,
  [SMALL_STATE(2736)] = 148818,
  [SMALL_STATE(2737)] = 148836,
  [SMALL_STATE(2738)] = 148864,
  [SMALL_STATE(2739)] = 148892,
  [SMALL_STATE(2740)] = 148920,
  [SMALL_STATE(2741)] = 148948,
  [SMALL_STATE(2742)] = 148976,
  [SMALL_STATE(2743)] = 149004,
  [SMALL_STATE(2744)] = 149032,
  [SMALL_STATE(2745)] = 149048,
  [SMALL_STATE(2746)] = 149069,
  [SMALL_STATE(2747)] = 149092,
  [SMALL_STATE(2748)] = 149115,
  [SMALL_STATE(2749)] = 149138,
  [SMALL_STATE(2750)] = 149161,
  [SMALL_STATE(2751)] = 149176,
  [SMALL_STATE(2752)] = 149199,
  [SMALL_STATE(2753)] = 149224,
  [SMALL_STATE(2754)] = 149245,
  [SMALL_STATE(2755)] = 149260,
  [SMALL_STATE(2756)] = 149275,
  [SMALL_STATE(2757)] = 149290,
  [SMALL_STATE(2758)] = 149309,
  [SMALL_STATE(2759)] = 149332,
  [SMALL_STATE(2760)] = 149347,
  [SMALL_STATE(2761)] = 149372,
  [SMALL_STATE(2762)] = 149397,
  [SMALL_STATE(2763)] = 149412,
  [SMALL_STATE(2764)] = 149427,
  [SMALL_STATE(2765)] = 149442,
  [SMALL_STATE(2766)] = 149467,
  [SMALL_STATE(2767)] = 149492,
  [SMALL_STATE(2768)] = 149517,
  [SMALL_STATE(2769)] = 149540,
  [SMALL_STATE(2770)] = 149555,
  [SMALL_STATE(2771)] = 149578,
  [SMALL_STATE(2772)] = 149593,
  [SMALL_STATE(2773)] = 149616,
  [SMALL_STATE(2774)] = 149639,
  [SMALL_STATE(2775)] = 149662,
  [SMALL_STATE(2776)] = 149685,
  [SMALL_STATE(2777)] = 149708,
  [SMALL_STATE(2778)] = 149723,
  [SMALL_STATE(2779)] = 149746,
  [SMALL_STATE(2780)] = 149769,
  [SMALL_STATE(2781)] = 149792,
  [SMALL_STATE(2782)] = 149817,
  [SMALL_STATE(2783)] = 149840,
  [SMALL_STATE(2784)] = 149863,
  [SMALL_STATE(2785)] = 149888,
  [SMALL_STATE(2786)] = 149911,
  [SMALL_STATE(2787)] = 149934,
  [SMALL_STATE(2788)] = 149959,
  [SMALL_STATE(2789)] = 149982,
  [SMALL_STATE(2790)] = 149997,
  [SMALL_STATE(2791)] = 150012,
  [SMALL_STATE(2792)] = 150027,
  [SMALL_STATE(2793)] = 150042,
  [SMALL_STATE(2794)] = 150065,
  [SMALL_STATE(2795)] = 150088,
  [SMALL_STATE(2796)] = 150105,
  [SMALL_STATE(2797)] = 150128,
  [SMALL_STATE(2798)] = 150151,
  [SMALL_STATE(2799)] = 150172,
  [SMALL_STATE(2800)] = 150191,
  [SMALL_STATE(2801)] = 150212,
  [SMALL_STATE(2802)] = 150237,
  [SMALL_STATE(2803)] = 150258,
  [SMALL_STATE(2804)] = 150273,
  [SMALL_STATE(2805)] = 150298,
  [SMALL_STATE(2806)] = 150313,
  [SMALL_STATE(2807)] = 150336,
  [SMALL_STATE(2808)] = 150351,
  [SMALL_STATE(2809)] = 150366,
  [SMALL_STATE(2810)] = 150381,
  [SMALL_STATE(2811)] = 150406,
  [SMALL_STATE(2812)] = 150421,
  [SMALL_STATE(2813)] = 150446,
  [SMALL_STATE(2814)] = 150461,
  [SMALL_STATE(2815)] = 150476,
  [SMALL_STATE(2816)] = 150501,
  [SMALL_STATE(2817)] = 150526,
  [SMALL_STATE(2818)] = 150551,
  [SMALL_STATE(2819)] = 150574,
  [SMALL_STATE(2820)] = 150597,
  [SMALL_STATE(2821)] = 150622,
  [SMALL_STATE(2822)] = 150637,
  [SMALL_STATE(2823)] = 150652,
  [SMALL_STATE(2824)] = 150667,
  [SMALL_STATE(2825)] = 150690,
  [SMALL_STATE(2826)] = 150715,
  [SMALL_STATE(2827)] = 150738,
  [SMALL_STATE(2828)] = 150757,
  [SMALL_STATE(2829)] = 150772,
  [SMALL_STATE(2830)] = 150787,
  [SMALL_STATE(2831)] = 150802,
  [SMALL_STATE(2832)] = 150817,
  [SMALL_STATE(2833)] = 150832,
  [SMALL_STATE(2834)] = 150855,
  [SMALL_STATE(2835)] = 150878,
  [SMALL_STATE(2836)] = 150901,
  [SMALL_STATE(2837)] = 150916,
  [SMALL_STATE(2838)] = 150931,
  [SMALL_STATE(2839)] = 150946,
  [SMALL_STATE(2840)] = 150967,
  [SMALL_STATE(2841)] = 150990,
  [SMALL_STATE(2842)] = 151011,
  [SMALL_STATE(2843)] = 151032,
  [SMALL_STATE(2844)] = 151047,
  [SMALL_STATE(2845)] = 151070,
  [SMALL_STATE(2846)] = 151092,
  [SMALL_STATE(2847)] = 151110,
  [SMALL_STATE(2848)] = 151132,
  [SMALL_STATE(2849)] = 151154,
  [SMALL_STATE(2850)] = 151174,
  [SMALL_STATE(2851)] = 151196,
  [SMALL_STATE(2852)] = 151218,
  [SMALL_STATE(2853)] = 151234,
  [SMALL_STATE(2854)] = 151256,
  [SMALL_STATE(2855)] = 151278,
  [SMALL_STATE(2856)] = 151300,
  [SMALL_STATE(2857)] = 151322,
  [SMALL_STATE(2858)] = 151344,
  [SMALL_STATE(2859)] = 151366,
  [SMALL_STATE(2860)] = 151388,
  [SMALL_STATE(2861)] = 151410,
  [SMALL_STATE(2862)] = 151432,
  [SMALL_STATE(2863)] = 151454,
  [SMALL_STATE(2864)] = 151476,
  [SMALL_STATE(2865)] = 151498,
  [SMALL_STATE(2866)] = 151520,
  [SMALL_STATE(2867)] = 151542,
  [SMALL_STATE(2868)] = 151561,
  [SMALL_STATE(2869)] = 151580,
  [SMALL_STATE(2870)] = 151597,
  [SMALL_STATE(2871)] = 151616,
  [SMALL_STATE(2872)] = 151635,
  [SMALL_STATE(2873)] = 151654,
  [SMALL_STATE(2874)] = 151671,
  [SMALL_STATE(2875)] = 151684,
  [SMALL_STATE(2876)] = 151699,
  [SMALL_STATE(2877)] = 151714,
  [SMALL_STATE(2878)] = 151733,
  [SMALL_STATE(2879)] = 151752,
  [SMALL_STATE(2880)] = 151767,
  [SMALL_STATE(2881)] = 151786,
  [SMALL_STATE(2882)] = 151805,
  [SMALL_STATE(2883)] = 151820,
  [SMALL_STATE(2884)] = 151833,
  [SMALL_STATE(2885)] = 151850,
  [SMALL_STATE(2886)] = 151865,
  [SMALL_STATE(2887)] = 151884,
  [SMALL_STATE(2888)] = 151899,
  [SMALL_STATE(2889)] = 151918,
  [SMALL_STATE(2890)] = 151935,
  [SMALL_STATE(2891)] = 151954,
  [SMALL_STATE(2892)] = 151971,
  [SMALL_STATE(2893)] = 151986,
  [SMALL_STATE(2894)] = 152005,
  [SMALL_STATE(2895)] = 152024,
  [SMALL_STATE(2896)] = 152041,
  [SMALL_STATE(2897)] = 152054,
  [SMALL_STATE(2898)] = 152073,
  [SMALL_STATE(2899)] = 152090,
  [SMALL_STATE(2900)] = 152107,
  [SMALL_STATE(2901)] = 152126,
  [SMALL_STATE(2902)] = 152143,
  [SMALL_STATE(2903)] = 152158,
  [SMALL_STATE(2904)] = 152177,
  [SMALL_STATE(2905)] = 152196,
  [SMALL_STATE(2906)] = 152215,
  [SMALL_STATE(2907)] = 152234,
  [SMALL_STATE(2908)] = 152253,
  [SMALL_STATE(2909)] = 152272,
  [SMALL_STATE(2910)] = 152287,
  [SMALL_STATE(2911)] = 152301,
  [SMALL_STATE(2912)] = 152317,
  [SMALL_STATE(2913)] = 152333,
  [SMALL_STATE(2914)] = 152349,
  [SMALL_STATE(2915)] = 152365,
  [SMALL_STATE(2916)] = 152381,
  [SMALL_STATE(2917)] = 152393,
  [SMALL_STATE(2918)] = 152407,
  [SMALL_STATE(2919)] = 152423,
  [SMALL_STATE(2920)] = 152439,
  [SMALL_STATE(2921)] = 152455,
  [SMALL_STATE(2922)] = 152471,
  [SMALL_STATE(2923)] = 152487,
  [SMALL_STATE(2924)] = 152503,
  [SMALL_STATE(2925)] = 152519,
  [SMALL_STATE(2926)] = 152535,
  [SMALL_STATE(2927)] = 152551,
  [SMALL_STATE(2928)] = 152567,
  [SMALL_STATE(2929)] = 152583,
  [SMALL_STATE(2930)] = 152595,
  [SMALL_STATE(2931)] = 152611,
  [SMALL_STATE(2932)] = 152627,
  [SMALL_STATE(2933)] = 152643,
  [SMALL_STATE(2934)] = 152659,
  [SMALL_STATE(2935)] = 152675,
  [SMALL_STATE(2936)] = 152691,
  [SMALL_STATE(2937)] = 152703,
  [SMALL_STATE(2938)] = 152719,
  [SMALL_STATE(2939)] = 152735,
  [SMALL_STATE(2940)] = 152751,
  [SMALL_STATE(2941)] = 152767,
  [SMALL_STATE(2942)] = 152783,
  [SMALL_STATE(2943)] = 152799,
  [SMALL_STATE(2944)] = 152815,
  [SMALL_STATE(2945)] = 152831,
  [SMALL_STATE(2946)] = 152847,
  [SMALL_STATE(2947)] = 152863,
  [SMALL_STATE(2948)] = 152879,
  [SMALL_STATE(2949)] = 152895,
  [SMALL_STATE(2950)] = 152911,
  [SMALL_STATE(2951)] = 152927,
  [SMALL_STATE(2952)] = 152943,
  [SMALL_STATE(2953)] = 152957,
  [SMALL_STATE(2954)] = 152971,
  [SMALL_STATE(2955)] = 152983,
  [SMALL_STATE(2956)] = 152997,
  [SMALL_STATE(2957)] = 153013,
  [SMALL_STATE(2958)] = 153025,
  [SMALL_STATE(2959)] = 153039,
  [SMALL_STATE(2960)] = 153055,
  [SMALL_STATE(2961)] = 153071,
  [SMALL_STATE(2962)] = 153087,
  [SMALL_STATE(2963)] = 153099,
  [SMALL_STATE(2964)] = 153111,
  [SMALL_STATE(2965)] = 153127,
  [SMALL_STATE(2966)] = 153141,
  [SMALL_STATE(2967)] = 153157,
  [SMALL_STATE(2968)] = 153173,
  [SMALL_STATE(2969)] = 153187,
  [SMALL_STATE(2970)] = 153203,
  [SMALL_STATE(2971)] = 153217,
  [SMALL_STATE(2972)] = 153231,
  [SMALL_STATE(2973)] = 153247,
  [SMALL_STATE(2974)] = 153263,
  [SMALL_STATE(2975)] = 153277,
  [SMALL_STATE(2976)] = 153293,
  [SMALL_STATE(2977)] = 153309,
  [SMALL_STATE(2978)] = 153325,
  [SMALL_STATE(2979)] = 153341,
  [SMALL_STATE(2980)] = 153357,
  [SMALL_STATE(2981)] = 153373,
  [SMALL_STATE(2982)] = 153389,
  [SMALL_STATE(2983)] = 153405,
  [SMALL_STATE(2984)] = 153421,
  [SMALL_STATE(2985)] = 153437,
  [SMALL_STATE(2986)] = 153451,
  [SMALL_STATE(2987)] = 153467,
  [SMALL_STATE(2988)] = 153483,
  [SMALL_STATE(2989)] = 153497,
  [SMALL_STATE(2990)] = 153513,
  [SMALL_STATE(2991)] = 153529,
  [SMALL_STATE(2992)] = 153543,
  [SMALL_STATE(2993)] = 153557,
  [SMALL_STATE(2994)] = 153571,
  [SMALL_STATE(2995)] = 153587,
  [SMALL_STATE(2996)] = 153601,
  [SMALL_STATE(2997)] = 153613,
  [SMALL_STATE(2998)] = 153629,
  [SMALL_STATE(2999)] = 153645,
  [SMALL_STATE(3000)] = 153659,
  [SMALL_STATE(3001)] = 153675,
  [SMALL_STATE(3002)] = 153691,
  [SMALL_STATE(3003)] = 153707,
  [SMALL_STATE(3004)] = 153723,
  [SMALL_STATE(3005)] = 153739,
  [SMALL_STATE(3006)] = 153751,
  [SMALL_STATE(3007)] = 153767,
  [SMALL_STATE(3008)] = 153783,
  [SMALL_STATE(3009)] = 153799,
  [SMALL_STATE(3010)] = 153815,
  [SMALL_STATE(3011)] = 153831,
  [SMALL_STATE(3012)] = 153847,
  [SMALL_STATE(3013)] = 153863,
  [SMALL_STATE(3014)] = 153877,
  [SMALL_STATE(3015)] = 153893,
  [SMALL_STATE(3016)] = 153905,
  [SMALL_STATE(3017)] = 153921,
  [SMALL_STATE(3018)] = 153937,
  [SMALL_STATE(3019)] = 153953,
  [SMALL_STATE(3020)] = 153967,
  [SMALL_STATE(3021)] = 153983,
  [SMALL_STATE(3022)] = 153999,
  [SMALL_STATE(3023)] = 154015,
  [SMALL_STATE(3024)] = 154029,
  [SMALL_STATE(3025)] = 154043,
  [SMALL_STATE(3026)] = 154059,
  [SMALL_STATE(3027)] = 154075,
  [SMALL_STATE(3028)] = 154091,
  [SMALL_STATE(3029)] = 154105,
  [SMALL_STATE(3030)] = 154119,
  [SMALL_STATE(3031)] = 154135,
  [SMALL_STATE(3032)] = 154151,
  [SMALL_STATE(3033)] = 154167,
  [SMALL_STATE(3034)] = 154179,
  [SMALL_STATE(3035)] = 154195,
  [SMALL_STATE(3036)] = 154211,
  [SMALL_STATE(3037)] = 154227,
  [SMALL_STATE(3038)] = 154243,
  [SMALL_STATE(3039)] = 154259,
  [SMALL_STATE(3040)] = 154270,
  [SMALL_STATE(3041)] = 154281,
  [SMALL_STATE(3042)] = 154294,
  [SMALL_STATE(3043)] = 154307,
  [SMALL_STATE(3044)] = 154318,
  [SMALL_STATE(3045)] = 154331,
  [SMALL_STATE(3046)] = 154344,
  [SMALL_STATE(3047)] = 154357,
  [SMALL_STATE(3048)] = 154370,
  [SMALL_STATE(3049)] = 154383,
  [SMALL_STATE(3050)] = 154396,
  [SMALL_STATE(3051)] = 154407,
  [SMALL_STATE(3052)] = 154420,
  [SMALL_STATE(3053)] = 154433,
  [SMALL_STATE(3054)] = 154446,
  [SMALL_STATE(3055)] = 154459,
  [SMALL_STATE(3056)] = 154472,
  [SMALL_STATE(3057)] = 154483,
  [SMALL_STATE(3058)] = 154494,
  [SMALL_STATE(3059)] = 154505,
  [SMALL_STATE(3060)] = 154516,
  [SMALL_STATE(3061)] = 154527,
  [SMALL_STATE(3062)] = 154540,
  [SMALL_STATE(3063)] = 154551,
  [SMALL_STATE(3064)] = 154562,
  [SMALL_STATE(3065)] = 154575,
  [SMALL_STATE(3066)] = 154586,
  [SMALL_STATE(3067)] = 154599,
  [SMALL_STATE(3068)] = 154612,
  [SMALL_STATE(3069)] = 154625,
  [SMALL_STATE(3070)] = 154638,
  [SMALL_STATE(3071)] = 154651,
  [SMALL_STATE(3072)] = 154664,
  [SMALL_STATE(3073)] = 154677,
  [SMALL_STATE(3074)] = 154690,
  [SMALL_STATE(3075)] = 154701,
  [SMALL_STATE(3076)] = 154714,
  [SMALL_STATE(3077)] = 154727,
  [SMALL_STATE(3078)] = 154740,
  [SMALL_STATE(3079)] = 154753,
  [SMALL_STATE(3080)] = 154766,
  [SMALL_STATE(3081)] = 154779,
  [SMALL_STATE(3082)] = 154792,
  [SMALL_STATE(3083)] = 154805,
  [SMALL_STATE(3084)] = 154818,
  [SMALL_STATE(3085)] = 154831,
  [SMALL_STATE(3086)] = 154844,
  [SMALL_STATE(3087)] = 154857,
  [SMALL_STATE(3088)] = 154868,
  [SMALL_STATE(3089)] = 154881,
  [SMALL_STATE(3090)] = 154894,
  [SMALL_STATE(3091)] = 154907,
  [SMALL_STATE(3092)] = 154918,
  [SMALL_STATE(3093)] = 154929,
  [SMALL_STATE(3094)] = 154942,
  [SMALL_STATE(3095)] = 154953,
  [SMALL_STATE(3096)] = 154964,
  [SMALL_STATE(3097)] = 154975,
  [SMALL_STATE(3098)] = 154986,
  [SMALL_STATE(3099)] = 154999,
  [SMALL_STATE(3100)] = 155010,
  [SMALL_STATE(3101)] = 155023,
  [SMALL_STATE(3102)] = 155036,
  [SMALL_STATE(3103)] = 155049,
  [SMALL_STATE(3104)] = 155062,
  [SMALL_STATE(3105)] = 155075,
  [SMALL_STATE(3106)] = 155086,
  [SMALL_STATE(3107)] = 155097,
  [SMALL_STATE(3108)] = 155110,
  [SMALL_STATE(3109)] = 155123,
  [SMALL_STATE(3110)] = 155136,
  [SMALL_STATE(3111)] = 155147,
  [SMALL_STATE(3112)] = 155160,
  [SMALL_STATE(3113)] = 155173,
  [SMALL_STATE(3114)] = 155184,
  [SMALL_STATE(3115)] = 155195,
  [SMALL_STATE(3116)] = 155208,
  [SMALL_STATE(3117)] = 155221,
  [SMALL_STATE(3118)] = 155232,
  [SMALL_STATE(3119)] = 155243,
  [SMALL_STATE(3120)] = 155256,
  [SMALL_STATE(3121)] = 155269,
  [SMALL_STATE(3122)] = 155280,
  [SMALL_STATE(3123)] = 155293,
  [SMALL_STATE(3124)] = 155304,
  [SMALL_STATE(3125)] = 155317,
  [SMALL_STATE(3126)] = 155327,
  [SMALL_STATE(3127)] = 155337,
  [SMALL_STATE(3128)] = 155347,
  [SMALL_STATE(3129)] = 155357,
  [SMALL_STATE(3130)] = 155367,
  [SMALL_STATE(3131)] = 155377,
  [SMALL_STATE(3132)] = 155387,
  [SMALL_STATE(3133)] = 155397,
  [SMALL_STATE(3134)] = 155407,
  [SMALL_STATE(3135)] = 155417,
  [SMALL_STATE(3136)] = 155427,
  [SMALL_STATE(3137)] = 155437,
  [SMALL_STATE(3138)] = 155447,
  [SMALL_STATE(3139)] = 155457,
  [SMALL_STATE(3140)] = 155467,
  [SMALL_STATE(3141)] = 155477,
  [SMALL_STATE(3142)] = 155487,
  [SMALL_STATE(3143)] = 155497,
  [SMALL_STATE(3144)] = 155507,
  [SMALL_STATE(3145)] = 155517,
  [SMALL_STATE(3146)] = 155527,
  [SMALL_STATE(3147)] = 155537,
  [SMALL_STATE(3148)] = 155547,
  [SMALL_STATE(3149)] = 155557,
  [SMALL_STATE(3150)] = 155567,
  [SMALL_STATE(3151)] = 155577,
  [SMALL_STATE(3152)] = 155587,
  [SMALL_STATE(3153)] = 155597,
  [SMALL_STATE(3154)] = 155607,
  [SMALL_STATE(3155)] = 155617,
  [SMALL_STATE(3156)] = 155627,
  [SMALL_STATE(3157)] = 155637,
  [SMALL_STATE(3158)] = 155647,
  [SMALL_STATE(3159)] = 155657,
  [SMALL_STATE(3160)] = 155667,
  [SMALL_STATE(3161)] = 155677,
  [SMALL_STATE(3162)] = 155687,
  [SMALL_STATE(3163)] = 155697,
  [SMALL_STATE(3164)] = 155707,
  [SMALL_STATE(3165)] = 155717,
  [SMALL_STATE(3166)] = 155727,
  [SMALL_STATE(3167)] = 155737,
  [SMALL_STATE(3168)] = 155747,
  [SMALL_STATE(3169)] = 155757,
  [SMALL_STATE(3170)] = 155767,
  [SMALL_STATE(3171)] = 155777,
  [SMALL_STATE(3172)] = 155787,
  [SMALL_STATE(3173)] = 155797,
  [SMALL_STATE(3174)] = 155807,
  [SMALL_STATE(3175)] = 155817,
  [SMALL_STATE(3176)] = 155827,
  [SMALL_STATE(3177)] = 155837,
  [SMALL_STATE(3178)] = 155847,
  [SMALL_STATE(3179)] = 155857,
  [SMALL_STATE(3180)] = 155867,
  [SMALL_STATE(3181)] = 155877,
  [SMALL_STATE(3182)] = 155887,
  [SMALL_STATE(3183)] = 155897,
  [SMALL_STATE(3184)] = 155907,
  [SMALL_STATE(3185)] = 155917,
  [SMALL_STATE(3186)] = 155927,
  [SMALL_STATE(3187)] = 155937,
  [SMALL_STATE(3188)] = 155947,
  [SMALL_STATE(3189)] = 155957,
  [SMALL_STATE(3190)] = 155967,
  [SMALL_STATE(3191)] = 155977,
  [SMALL_STATE(3192)] = 155987,
  [SMALL_STATE(3193)] = 155997,
  [SMALL_STATE(3194)] = 156007,
  [SMALL_STATE(3195)] = 156017,
  [SMALL_STATE(3196)] = 156027,
  [SMALL_STATE(3197)] = 156037,
  [SMALL_STATE(3198)] = 156047,
  [SMALL_STATE(3199)] = 156057,
  [SMALL_STATE(3200)] = 156067,
  [SMALL_STATE(3201)] = 156077,
  [SMALL_STATE(3202)] = 156087,
  [SMALL_STATE(3203)] = 156097,
  [SMALL_STATE(3204)] = 156107,
  [SMALL_STATE(3205)] = 156117,
  [SMALL_STATE(3206)] = 156127,
  [SMALL_STATE(3207)] = 156137,
  [SMALL_STATE(3208)] = 156147,
  [SMALL_STATE(3209)] = 156157,
  [SMALL_STATE(3210)] = 156167,
  [SMALL_STATE(3211)] = 156177,
  [SMALL_STATE(3212)] = 156187,
  [SMALL_STATE(3213)] = 156197,
  [SMALL_STATE(3214)] = 156207,
  [SMALL_STATE(3215)] = 156217,
  [SMALL_STATE(3216)] = 156227,
  [SMALL_STATE(3217)] = 156237,
  [SMALL_STATE(3218)] = 156247,
  [SMALL_STATE(3219)] = 156257,
  [SMALL_STATE(3220)] = 156267,
  [SMALL_STATE(3221)] = 156277,
  [SMALL_STATE(3222)] = 156287,
  [SMALL_STATE(3223)] = 156297,
  [SMALL_STATE(3224)] = 156307,
  [SMALL_STATE(3225)] = 156317,
  [SMALL_STATE(3226)] = 156327,
  [SMALL_STATE(3227)] = 156337,
  [SMALL_STATE(3228)] = 156347,
  [SMALL_STATE(3229)] = 156357,
  [SMALL_STATE(3230)] = 156367,
  [SMALL_STATE(3231)] = 156377,
  [SMALL_STATE(3232)] = 156387,
  [SMALL_STATE(3233)] = 156397,
  [SMALL_STATE(3234)] = 156407,
  [SMALL_STATE(3235)] = 156417,
  [SMALL_STATE(3236)] = 156427,
  [SMALL_STATE(3237)] = 156437,
  [SMALL_STATE(3238)] = 156447,
  [SMALL_STATE(3239)] = 156457,
  [SMALL_STATE(3240)] = 156467,
  [SMALL_STATE(3241)] = 156477,
  [SMALL_STATE(3242)] = 156487,
  [SMALL_STATE(3243)] = 156497,
  [SMALL_STATE(3244)] = 156507,
  [SMALL_STATE(3245)] = 156517,
  [SMALL_STATE(3246)] = 156527,
  [SMALL_STATE(3247)] = 156537,
  [SMALL_STATE(3248)] = 156547,
  [SMALL_STATE(3249)] = 156557,
  [SMALL_STATE(3250)] = 156567,
  [SMALL_STATE(3251)] = 156577,
  [SMALL_STATE(3252)] = 156587,
  [SMALL_STATE(3253)] = 156597,
  [SMALL_STATE(3254)] = 156607,
  [SMALL_STATE(3255)] = 156617,
  [SMALL_STATE(3256)] = 156627,
  [SMALL_STATE(3257)] = 156637,
  [SMALL_STATE(3258)] = 156647,
  [SMALL_STATE(3259)] = 156657,
  [SMALL_STATE(3260)] = 156667,
  [SMALL_STATE(3261)] = 156677,
  [SMALL_STATE(3262)] = 156687,
  [SMALL_STATE(3263)] = 156697,
  [SMALL_STATE(3264)] = 156707,
  [SMALL_STATE(3265)] = 156717,
  [SMALL_STATE(3266)] = 156727,
  [SMALL_STATE(3267)] = 156737,
  [SMALL_STATE(3268)] = 156747,
  [SMALL_STATE(3269)] = 156757,
  [SMALL_STATE(3270)] = 156767,
  [SMALL_STATE(3271)] = 156777,
  [SMALL_STATE(3272)] = 156787,
  [SMALL_STATE(3273)] = 156797,
  [SMALL_STATE(3274)] = 156807,
  [SMALL_STATE(3275)] = 156817,
  [SMALL_STATE(3276)] = 156827,
  [SMALL_STATE(3277)] = 156837,
  [SMALL_STATE(3278)] = 156847,
  [SMALL_STATE(3279)] = 156857,
  [SMALL_STATE(3280)] = 156867,
  [SMALL_STATE(3281)] = 156877,
  [SMALL_STATE(3282)] = 156887,
  [SMALL_STATE(3283)] = 156897,
  [SMALL_STATE(3284)] = 156907,
  [SMALL_STATE(3285)] = 156917,
  [SMALL_STATE(3286)] = 156927,
  [SMALL_STATE(3287)] = 156937,
  [SMALL_STATE(3288)] = 156947,
  [SMALL_STATE(3289)] = 156957,
  [SMALL_STATE(3290)] = 156967,
  [SMALL_STATE(3291)] = 156977,
  [SMALL_STATE(3292)] = 156987,
  [SMALL_STATE(3293)] = 156997,
  [SMALL_STATE(3294)] = 157007,
  [SMALL_STATE(3295)] = 157017,
  [SMALL_STATE(3296)] = 157027,
  [SMALL_STATE(3297)] = 157037,
  [SMALL_STATE(3298)] = 157047,
  [SMALL_STATE(3299)] = 157057,
  [SMALL_STATE(3300)] = 157067,
  [SMALL_STATE(3301)] = 157077,
  [SMALL_STATE(3302)] = 157087,
  [SMALL_STATE(3303)] = 157097,
  [SMALL_STATE(3304)] = 157107,
  [SMALL_STATE(3305)] = 157117,
  [SMALL_STATE(3306)] = 157127,
  [SMALL_STATE(3307)] = 157137,
  [SMALL_STATE(3308)] = 157147,
  [SMALL_STATE(3309)] = 157157,
  [SMALL_STATE(3310)] = 157167,
  [SMALL_STATE(3311)] = 157177,
  [SMALL_STATE(3312)] = 157187,
  [SMALL_STATE(3313)] = 157197,
  [SMALL_STATE(3314)] = 157207,
  [SMALL_STATE(3315)] = 157217,
  [SMALL_STATE(3316)] = 157227,
  [SMALL_STATE(3317)] = 157237,
  [SMALL_STATE(3318)] = 157247,
  [SMALL_STATE(3319)] = 157257,
  [SMALL_STATE(3320)] = 157267,
  [SMALL_STATE(3321)] = 157277,
  [SMALL_STATE(3322)] = 157287,
  [SMALL_STATE(3323)] = 157297,
  [SMALL_STATE(3324)] = 157307,
  [SMALL_STATE(3325)] = 157317,
  [SMALL_STATE(3326)] = 157327,
  [SMALL_STATE(3327)] = 157337,
  [SMALL_STATE(3328)] = 157347,
  [SMALL_STATE(3329)] = 157357,
  [SMALL_STATE(3330)] = 157367,
  [SMALL_STATE(3331)] = 157377,
  [SMALL_STATE(3332)] = 157387,
  [SMALL_STATE(3333)] = 157397,
  [SMALL_STATE(3334)] = 157407,
  [SMALL_STATE(3335)] = 157417,
  [SMALL_STATE(3336)] = 157427,
  [SMALL_STATE(3337)] = 157437,
  [SMALL_STATE(3338)] = 157447,
  [SMALL_STATE(3339)] = 157457,
  [SMALL_STATE(3340)] = 157467,
  [SMALL_STATE(3341)] = 157477,
  [SMALL_STATE(3342)] = 157487,
  [SMALL_STATE(3343)] = 157497,
  [SMALL_STATE(3344)] = 157507,
  [SMALL_STATE(3345)] = 157517,
  [SMALL_STATE(3346)] = 157527,
  [SMALL_STATE(3347)] = 157537,
  [SMALL_STATE(3348)] = 157547,
  [SMALL_STATE(3349)] = 157557,
  [SMALL_STATE(3350)] = 157567,
  [SMALL_STATE(3351)] = 157577,
  [SMALL_STATE(3352)] = 157587,
  [SMALL_STATE(3353)] = 157597,
  [SMALL_STATE(3354)] = 157607,
  [SMALL_STATE(3355)] = 157617,
  [SMALL_STATE(3356)] = 157627,
  [SMALL_STATE(3357)] = 157637,
  [SMALL_STATE(3358)] = 157647,
  [SMALL_STATE(3359)] = 157657,
  [SMALL_STATE(3360)] = 157667,
  [SMALL_STATE(3361)] = 157677,
  [SMALL_STATE(3362)] = 157687,
  [SMALL_STATE(3363)] = 157697,
  [SMALL_STATE(3364)] = 157707,
  [SMALL_STATE(3365)] = 157717,
  [SMALL_STATE(3366)] = 157727,
  [SMALL_STATE(3367)] = 157737,
  [SMALL_STATE(3368)] = 157747,
  [SMALL_STATE(3369)] = 157757,
  [SMALL_STATE(3370)] = 157767,
  [SMALL_STATE(3371)] = 157777,
  [SMALL_STATE(3372)] = 157787,
  [SMALL_STATE(3373)] = 157797,
  [SMALL_STATE(3374)] = 157807,
  [SMALL_STATE(3375)] = 157817,
  [SMALL_STATE(3376)] = 157827,
  [SMALL_STATE(3377)] = 157837,
  [SMALL_STATE(3378)] = 157847,
  [SMALL_STATE(3379)] = 157857,
  [SMALL_STATE(3380)] = 157867,
  [SMALL_STATE(3381)] = 157877,
  [SMALL_STATE(3382)] = 157887,
  [SMALL_STATE(3383)] = 157897,
  [SMALL_STATE(3384)] = 157907,
  [SMALL_STATE(3385)] = 157917,
  [SMALL_STATE(3386)] = 157927,
  [SMALL_STATE(3387)] = 157937,
  [SMALL_STATE(3388)] = 157947,
  [SMALL_STATE(3389)] = 157957,
  [SMALL_STATE(3390)] = 157967,
  [SMALL_STATE(3391)] = 157977,
  [SMALL_STATE(3392)] = 157987,
  [SMALL_STATE(3393)] = 157997,
  [SMALL_STATE(3394)] = 158007,
  [SMALL_STATE(3395)] = 158017,
  [SMALL_STATE(3396)] = 158027,
  [SMALL_STATE(3397)] = 158037,
  [SMALL_STATE(3398)] = 158047,
  [SMALL_STATE(3399)] = 158057,
  [SMALL_STATE(3400)] = 158067,
  [SMALL_STATE(3401)] = 158077,
  [SMALL_STATE(3402)] = 158087,
  [SMALL_STATE(3403)] = 158097,
  [SMALL_STATE(3404)] = 158107,
  [SMALL_STATE(3405)] = 158117,
  [SMALL_STATE(3406)] = 158127,
  [SMALL_STATE(3407)] = 158137,
  [SMALL_STATE(3408)] = 158147,
  [SMALL_STATE(3409)] = 158157,
  [SMALL_STATE(3410)] = 158167,
  [SMALL_STATE(3411)] = 158177,
  [SMALL_STATE(3412)] = 158187,
  [SMALL_STATE(3413)] = 158197,
  [SMALL_STATE(3414)] = 158207,
  [SMALL_STATE(3415)] = 158217,
  [SMALL_STATE(3416)] = 158227,
  [SMALL_STATE(3417)] = 158237,
  [SMALL_STATE(3418)] = 158247,
  [SMALL_STATE(3419)] = 158257,
  [SMALL_STATE(3420)] = 158267,
  [SMALL_STATE(3421)] = 158277,
  [SMALL_STATE(3422)] = 158287,
  [SMALL_STATE(3423)] = 158297,
  [SMALL_STATE(3424)] = 158307,
  [SMALL_STATE(3425)] = 158317,
  [SMALL_STATE(3426)] = 158327,
  [SMALL_STATE(3427)] = 158337,
  [SMALL_STATE(3428)] = 158347,
  [SMALL_STATE(3429)] = 158357,
  [SMALL_STATE(3430)] = 158367,
  [SMALL_STATE(3431)] = 158377,
  [SMALL_STATE(3432)] = 158387,
  [SMALL_STATE(3433)] = 158397,
  [SMALL_STATE(3434)] = 158407,
  [SMALL_STATE(3435)] = 158417,
  [SMALL_STATE(3436)] = 158427,
  [SMALL_STATE(3437)] = 158437,
  [SMALL_STATE(3438)] = 158447,
  [SMALL_STATE(3439)] = 158457,
  [SMALL_STATE(3440)] = 158467,
  [SMALL_STATE(3441)] = 158477,
  [SMALL_STATE(3442)] = 158487,
  [SMALL_STATE(3443)] = 158497,
  [SMALL_STATE(3444)] = 158507,
  [SMALL_STATE(3445)] = 158517,
  [SMALL_STATE(3446)] = 158527,
  [SMALL_STATE(3447)] = 158537,
  [SMALL_STATE(3448)] = 158547,
  [SMALL_STATE(3449)] = 158557,
  [SMALL_STATE(3450)] = 158567,
  [SMALL_STATE(3451)] = 158577,
  [SMALL_STATE(3452)] = 158587,
  [SMALL_STATE(3453)] = 158597,
  [SMALL_STATE(3454)] = 158607,
  [SMALL_STATE(3455)] = 158617,
  [SMALL_STATE(3456)] = 158627,
  [SMALL_STATE(3457)] = 158637,
  [SMALL_STATE(3458)] = 158647,
  [SMALL_STATE(3459)] = 158657,
  [SMALL_STATE(3460)] = 158667,
  [SMALL_STATE(3461)] = 158677,
  [SMALL_STATE(3462)] = 158687,
  [SMALL_STATE(3463)] = 158697,
  [SMALL_STATE(3464)] = 158707,
  [SMALL_STATE(3465)] = 158717,
  [SMALL_STATE(3466)] = 158727,
  [SMALL_STATE(3467)] = 158737,
  [SMALL_STATE(3468)] = 158747,
  [SMALL_STATE(3469)] = 158757,
  [SMALL_STATE(3470)] = 158767,
  [SMALL_STATE(3471)] = 158777,
  [SMALL_STATE(3472)] = 158787,
  [SMALL_STATE(3473)] = 158797,
  [SMALL_STATE(3474)] = 158807,
  [SMALL_STATE(3475)] = 158817,
  [SMALL_STATE(3476)] = 158827,
  [SMALL_STATE(3477)] = 158837,
  [SMALL_STATE(3478)] = 158847,
  [SMALL_STATE(3479)] = 158857,
  [SMALL_STATE(3480)] = 158867,
  [SMALL_STATE(3481)] = 158877,
  [SMALL_STATE(3482)] = 158887,
  [SMALL_STATE(3483)] = 158897,
  [SMALL_STATE(3484)] = 158907,
  [SMALL_STATE(3485)] = 158917,
  [SMALL_STATE(3486)] = 158927,
  [SMALL_STATE(3487)] = 158937,
  [SMALL_STATE(3488)] = 158947,
  [SMALL_STATE(3489)] = 158957,
  [SMALL_STATE(3490)] = 158967,
  [SMALL_STATE(3491)] = 158977,
  [SMALL_STATE(3492)] = 158987,
  [SMALL_STATE(3493)] = 158997,
  [SMALL_STATE(3494)] = 159007,
  [SMALL_STATE(3495)] = 159017,
  [SMALL_STATE(3496)] = 159027,
  [SMALL_STATE(3497)] = 159037,
  [SMALL_STATE(3498)] = 159047,
  [SMALL_STATE(3499)] = 159057,
  [SMALL_STATE(3500)] = 159067,
  [SMALL_STATE(3501)] = 159077,
  [SMALL_STATE(3502)] = 159087,
  [SMALL_STATE(3503)] = 159097,
  [SMALL_STATE(3504)] = 159107,
  [SMALL_STATE(3505)] = 159117,
  [SMALL_STATE(3506)] = 159127,
  [SMALL_STATE(3507)] = 159137,
  [SMALL_STATE(3508)] = 159147,
  [SMALL_STATE(3509)] = 159157,
  [SMALL_STATE(3510)] = 159167,
  [SMALL_STATE(3511)] = 159177,
  [SMALL_STATE(3512)] = 159187,
  [SMALL_STATE(3513)] = 159197,
  [SMALL_STATE(3514)] = 159207,
  [SMALL_STATE(3515)] = 159217,
  [SMALL_STATE(3516)] = 159227,
  [SMALL_STATE(3517)] = 159237,
  [SMALL_STATE(3518)] = 159247,
  [SMALL_STATE(3519)] = 159257,
  [SMALL_STATE(3520)] = 159267,
  [SMALL_STATE(3521)] = 159277,
  [SMALL_STATE(3522)] = 159287,
  [SMALL_STATE(3523)] = 159297,
  [SMALL_STATE(3524)] = 159307,
  [SMALL_STATE(3525)] = 159317,
  [SMALL_STATE(3526)] = 159327,
  [SMALL_STATE(3527)] = 159337,
  [SMALL_STATE(3528)] = 159347,
  [SMALL_STATE(3529)] = 159357,
  [SMALL_STATE(3530)] = 159367,
  [SMALL_STATE(3531)] = 159377,
  [SMALL_STATE(3532)] = 159387,
  [SMALL_STATE(3533)] = 159397,
  [SMALL_STATE(3534)] = 159407,
  [SMALL_STATE(3535)] = 159417,
  [SMALL_STATE(3536)] = 159427,
  [SMALL_STATE(3537)] = 159437,
  [SMALL_STATE(3538)] = 159447,
  [SMALL_STATE(3539)] = 159457,
  [SMALL_STATE(3540)] = 159467,
  [SMALL_STATE(3541)] = 159477,
  [SMALL_STATE(3542)] = 159487,
  [SMALL_STATE(3543)] = 159497,
  [SMALL_STATE(3544)] = 159507,
  [SMALL_STATE(3545)] = 159517,
  [SMALL_STATE(3546)] = 159527,
  [SMALL_STATE(3547)] = 159537,
  [SMALL_STATE(3548)] = 159547,
  [SMALL_STATE(3549)] = 159557,
  [SMALL_STATE(3550)] = 159567,
  [SMALL_STATE(3551)] = 159577,
  [SMALL_STATE(3552)] = 159587,
  [SMALL_STATE(3553)] = 159597,
  [SMALL_STATE(3554)] = 159607,
  [SMALL_STATE(3555)] = 159617,
  [SMALL_STATE(3556)] = 159627,
  [SMALL_STATE(3557)] = 159637,
  [SMALL_STATE(3558)] = 159647,
  [SMALL_STATE(3559)] = 159657,
  [SMALL_STATE(3560)] = 159667,
  [SMALL_STATE(3561)] = 159677,
  [SMALL_STATE(3562)] = 159687,
  [SMALL_STATE(3563)] = 159697,
  [SMALL_STATE(3564)] = 159707,
  [SMALL_STATE(3565)] = 159717,
  [SMALL_STATE(3566)] = 159727,
  [SMALL_STATE(3567)] = 159737,
  [SMALL_STATE(3568)] = 159747,
  [SMALL_STATE(3569)] = 159757,
  [SMALL_STATE(3570)] = 159767,
  [SMALL_STATE(3571)] = 159777,
  [SMALL_STATE(3572)] = 159787,
  [SMALL_STATE(3573)] = 159797,
  [SMALL_STATE(3574)] = 159807,
  [SMALL_STATE(3575)] = 159817,
  [SMALL_STATE(3576)] = 159827,
  [SMALL_STATE(3577)] = 159837,
  [SMALL_STATE(3578)] = 159847,
  [SMALL_STATE(3579)] = 159857,
  [SMALL_STATE(3580)] = 159867,
  [SMALL_STATE(3581)] = 159877,
  [SMALL_STATE(3582)] = 159887,
  [SMALL_STATE(3583)] = 159897,
  [SMALL_STATE(3584)] = 159907,
  [SMALL_STATE(3585)] = 159917,
  [SMALL_STATE(3586)] = 159927,
  [SMALL_STATE(3587)] = 159937,
  [SMALL_STATE(3588)] = 159947,
  [SMALL_STATE(3589)] = 159957,
  [SMALL_STATE(3590)] = 159967,
  [SMALL_STATE(3591)] = 159977,
  [SMALL_STATE(3592)] = 159987,
  [SMALL_STATE(3593)] = 159997,
  [SMALL_STATE(3594)] = 160007,
  [SMALL_STATE(3595)] = 160017,
  [SMALL_STATE(3596)] = 160027,
  [SMALL_STATE(3597)] = 160037,
  [SMALL_STATE(3598)] = 160047,
  [SMALL_STATE(3599)] = 160057,
  [SMALL_STATE(3600)] = 160067,
  [SMALL_STATE(3601)] = 160077,
  [SMALL_STATE(3602)] = 160087,
  [SMALL_STATE(3603)] = 160097,
  [SMALL_STATE(3604)] = 160107,
  [SMALL_STATE(3605)] = 160117,
  [SMALL_STATE(3606)] = 160127,
  [SMALL_STATE(3607)] = 160137,
  [SMALL_STATE(3608)] = 160147,
  [SMALL_STATE(3609)] = 160157,
  [SMALL_STATE(3610)] = 160167,
  [SMALL_STATE(3611)] = 160177,
  [SMALL_STATE(3612)] = 160187,
  [SMALL_STATE(3613)] = 160197,
  [SMALL_STATE(3614)] = 160207,
  [SMALL_STATE(3615)] = 160217,
  [SMALL_STATE(3616)] = 160227,
  [SMALL_STATE(3617)] = 160237,
  [SMALL_STATE(3618)] = 160247,
  [SMALL_STATE(3619)] = 160257,
  [SMALL_STATE(3620)] = 160267,
  [SMALL_STATE(3621)] = 160277,
  [SMALL_STATE(3622)] = 160287,
  [SMALL_STATE(3623)] = 160297,
  [SMALL_STATE(3624)] = 160307,
  [SMALL_STATE(3625)] = 160317,
  [SMALL_STATE(3626)] = 160327,
  [SMALL_STATE(3627)] = 160337,
  [SMALL_STATE(3628)] = 160347,
  [SMALL_STATE(3629)] = 160357,
  [SMALL_STATE(3630)] = 160367,
  [SMALL_STATE(3631)] = 160377,
  [SMALL_STATE(3632)] = 160387,
  [SMALL_STATE(3633)] = 160397,
  [SMALL_STATE(3634)] = 160407,
  [SMALL_STATE(3635)] = 160417,
  [SMALL_STATE(3636)] = 160427,
  [SMALL_STATE(3637)] = 160437,
  [SMALL_STATE(3638)] = 160447,
  [SMALL_STATE(3639)] = 160457,
  [SMALL_STATE(3640)] = 160467,
  [SMALL_STATE(3641)] = 160477,
  [SMALL_STATE(3642)] = 160487,
  [SMALL_STATE(3643)] = 160497,
  [SMALL_STATE(3644)] = 160507,
  [SMALL_STATE(3645)] = 160517,
  [SMALL_STATE(3646)] = 160527,
  [SMALL_STATE(3647)] = 160537,
  [SMALL_STATE(3648)] = 160547,
  [SMALL_STATE(3649)] = 160557,
  [SMALL_STATE(3650)] = 160567,
  [SMALL_STATE(3651)] = 160577,
  [SMALL_STATE(3652)] = 160587,
  [SMALL_STATE(3653)] = 160597,
  [SMALL_STATE(3654)] = 160607,
  [SMALL_STATE(3655)] = 160617,
  [SMALL_STATE(3656)] = 160627,
  [SMALL_STATE(3657)] = 160637,
  [SMALL_STATE(3658)] = 160647,
  [SMALL_STATE(3659)] = 160657,
  [SMALL_STATE(3660)] = 160667,
  [SMALL_STATE(3661)] = 160677,
  [SMALL_STATE(3662)] = 160687,
  [SMALL_STATE(3663)] = 160697,
  [SMALL_STATE(3664)] = 160707,
  [SMALL_STATE(3665)] = 160717,
  [SMALL_STATE(3666)] = 160727,
  [SMALL_STATE(3667)] = 160737,
  [SMALL_STATE(3668)] = 160747,
  [SMALL_STATE(3669)] = 160757,
  [SMALL_STATE(3670)] = 160767,
  [SMALL_STATE(3671)] = 160777,
  [SMALL_STATE(3672)] = 160787,
  [SMALL_STATE(3673)] = 160797,
  [SMALL_STATE(3674)] = 160807,
  [SMALL_STATE(3675)] = 160817,
  [SMALL_STATE(3676)] = 160827,
  [SMALL_STATE(3677)] = 160837,
  [SMALL_STATE(3678)] = 160847,
  [SMALL_STATE(3679)] = 160857,
  [SMALL_STATE(3680)] = 160867,
  [SMALL_STATE(3681)] = 160877,
  [SMALL_STATE(3682)] = 160887,
  [SMALL_STATE(3683)] = 160897,
  [SMALL_STATE(3684)] = 160907,
  [SMALL_STATE(3685)] = 160917,
  [SMALL_STATE(3686)] = 160927,
  [SMALL_STATE(3687)] = 160937,
  [SMALL_STATE(3688)] = 160947,
  [SMALL_STATE(3689)] = 160957,
  [SMALL_STATE(3690)] = 160967,
  [SMALL_STATE(3691)] = 160977,
  [SMALL_STATE(3692)] = 160987,
  [SMALL_STATE(3693)] = 160997,
  [SMALL_STATE(3694)] = 161007,
  [SMALL_STATE(3695)] = 161017,
  [SMALL_STATE(3696)] = 161027,
  [SMALL_STATE(3697)] = 161037,
  [SMALL_STATE(3698)] = 161047,
  [SMALL_STATE(3699)] = 161057,
  [SMALL_STATE(3700)] = 161067,
  [SMALL_STATE(3701)] = 161077,
  [SMALL_STATE(3702)] = 161087,
  [SMALL_STATE(3703)] = 161097,
  [SMALL_STATE(3704)] = 161107,
  [SMALL_STATE(3705)] = 161117,
  [SMALL_STATE(3706)] = 161127,
  [SMALL_STATE(3707)] = 161137,
  [SMALL_STATE(3708)] = 161147,
  [SMALL_STATE(3709)] = 161157,
  [SMALL_STATE(3710)] = 161167,
  [SMALL_STATE(3711)] = 161177,
  [SMALL_STATE(3712)] = 161187,
  [SMALL_STATE(3713)] = 161197,
  [SMALL_STATE(3714)] = 161207,
  [SMALL_STATE(3715)] = 161217,
  [SMALL_STATE(3716)] = 161227,
  [SMALL_STATE(3717)] = 161237,
  [SMALL_STATE(3718)] = 161247,
  [SMALL_STATE(3719)] = 161257,
  [SMALL_STATE(3720)] = 161267,
  [SMALL_STATE(3721)] = 161277,
  [SMALL_STATE(3722)] = 161287,
  [SMALL_STATE(3723)] = 161297,
  [SMALL_STATE(3724)] = 161301,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2479),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2890),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3541),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3515),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3413),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2868),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3379),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3037),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2433),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3673),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3381),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2370),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2250),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [75] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 3, 0, 33),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2904),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3310),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3035),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2255),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3661),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3312),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2438),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2466),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2421),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2200),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2270),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2481),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2484),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2489),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2495),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1987),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2377),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2387),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2374),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2380),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2400),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2408),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1946),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1971),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2905),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3345),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3036),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2215),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2216),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3667),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3347),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2315),
  [387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 1, 0, 0),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2389),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2439),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2474),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2477),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2314),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2195),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2197),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1727),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2207),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2226),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2251),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2444),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2272),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2276),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2278),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2291),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2292),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2302),
  [443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2303),
  [445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2310),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2232),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2485),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2486),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2492),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2493),
  [513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 1, 0, 0),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2498),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2499),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2504),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2505),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2373),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2395),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2396),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2405),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2411),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2392),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2393),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2403),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2404),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2412),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2413),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2417),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2418),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1768),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1967),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var, 1, 0, 1),
  [691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var, 1, 0, 1),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3549),
  [697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2479),
  [700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0),
  [702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2868),
  [705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3379),
  [708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3037),
  [711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(106),
  [714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1003),
  [717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(153),
  [720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1004),
  [723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2020),
  [726] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2026),
  [729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3673),
  [732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3381),
  [735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(833),
  [738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3413),
  [741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2969),
  [744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var, 1, 0, 2),
  [746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var, 1, 0, 2),
  [748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixexp, 1, 0, 0),
  [750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixexp, 1, 0, 0),
  [752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefixexp, 1, 0, 0),
  [754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 1, 0, 0),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3266),
  [760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 3, 0, 0),
  [762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 3, 0, 0),
  [764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 0),
  [766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 0),
  [770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0),
  [774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2890),
  [777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3397),
  [780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2987),
  [783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(76),
  [786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(864),
  [789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(206),
  [792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(793),
  [795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2332),
  [798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2234),
  [801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3541),
  [804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3515),
  [807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tbl_seq, 2, 0, 4),
  [809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tbl_seq, 2, 0, 4),
  [811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_key, 1, 0, 5),
  [813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key, 1, 0, 5),
  [815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tbl_seq, 2, 0, 0),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tbl_seq, 2, 0, 0),
  [819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tbl_seq, 2, 0, 2),
  [821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tbl_seq, 2, 0, 2),
  [823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_wrap, 3, 0, 0),
  [825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_wrap, 3, 0, 0),
  [827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_key, 3, 0, 36),
  [829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key, 3, 0, 36),
  [831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2904),
  [834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3310),
  [837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3035),
  [840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(73),
  [843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(993),
  [846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(223),
  [849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(994),
  [852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2254),
  [855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2255),
  [858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3661),
  [861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3312),
  [864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2905),
  [867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3345),
  [870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3036),
  [873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(89),
  [876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(998),
  [879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(72),
  [882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(999),
  [885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2215),
  [888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2216),
  [891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3667),
  [894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3347),
  [897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__key_named, 2, 0, 18),
  [899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_named, 2, 0, 18),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3418),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3630),
  [909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arglist, 1, 0, 0),
  [911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arglist, 1, 0, 0),
  [913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_stmt, 2, 0, 8),
  [915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_stmt, 2, 0, 8),
  [917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_stmt, 2, 0, 9),
  [919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_stmt, 2, 0, 9),
  [921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arglist, 2, 0, 0),
  [923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arglist, 2, 0, 0),
  [925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arglist, 3, 0, 0),
  [927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arglist, 3, 0, 0),
  [929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namedtype, 1, 0, 26),
  [931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namedtype, 1, 0, 26),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3248),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 2, 0, 0),
  [941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 2, 0, 0),
  [943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__typepack_wrap, 2, 0, 0),
  [945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__typepack_wrap, 2, 0, 0),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3603),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean, 1, 0, 0),
  [957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1, 0, 0),
  [959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nil, 1, 0, 0),
  [961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nil, 1, 0, 0),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3444),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__outertype, 1, 0, 0),
  [971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__outertype, 1, 0, 0),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 0),
  [981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_singleton, 1, 0, 0),
  [985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_singleton, 1, 0, 0),
  [987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_genpack, 2, 0, 37),
  [989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genpack, 2, 0, 37),
  [991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tbtype, 2, 0, 0),
  [993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tbtype, 2, 0, 0),
  [995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__typepack_gen, 1, 0, 0),
  [997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__typepack_gen, 1, 0, 0),
  [999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__outertype, 2, 0, 42),
  [1001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__outertype, 2, 0, 42),
  [1003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_untype, 2, 0, 43),
  [1005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_untype, 2, 0, 43),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3450),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fntype, 2, 0, 44),
  [1015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fntype, 2, 0, 44),
  [1017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typepack, 1, 0, 0),
  [1019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typepack, 1, 0, 0),
  [1021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tbtype, 3, 0, 59),
  [1023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tbtype, 3, 0, 59),
  [1025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variadic, 2, 0, 0),
  [1027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic, 2, 0, 0),
  [1029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_wraptype, 3, 1, 61),
  [1031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wraptype, 3, 1, 61),
  [1033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namedtype, 3, 0, 63),
  [1035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namedtype, 3, 0, 63),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [1039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bintype, 3, 0, 25),
  [1041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bintype, 3, 0, 25),
  [1043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fntype, 3, 0, 64),
  [1045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fntype, 3, 0, 64),
  [1047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dyntype, 4, 0, 0),
  [1049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dyntype, 4, 0, 0),
  [1051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namedtype, 4, 0, 26),
  [1053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namedtype, 4, 0, 26),
  [1055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__typepack_wrap, 3, 0, 0),
  [1057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__typepack_wrap, 3, 0, 0),
  [1059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namedtype, 6, 0, 63),
  [1061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namedtype, 6, 0, 63),
  [1063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__typepack_vrd, 1, 0, 0),
  [1065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__typepack_vrd, 1, 0, 0),
  [1067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp, 1, 0, 0),
  [1069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp, 1, 0, 0),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3194),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [1087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__explist, 1, 0, 0),
  [1089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__explist, 1, 0, 0),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2912),
  [1129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ret_stmt, 1, 0, 0),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2975),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fieldlist, 3, 0, 0),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3537),
  [1187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fieldlist, 2, 0, 0),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [1191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ifexp, 6, 0, 0),
  [1193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ifexp, 6, 0, 0),
  [1195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ifexp, 7, 0, 0),
  [1197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ifexp, 7, 0, 0),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [1201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vararg, 1, 0, 0),
  [1203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vararg, 1, 0, 0),
  [1205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__explist_repeat1, 2, 0, 0),
  [1207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__explist_repeat1, 2, 0, 0),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [1221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 3, 0, 0),
  [1223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 3, 0, 0),
  [1225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 4, 0, 55),
  [1227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 4, 0, 55),
  [1229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 4, 0, 0),
  [1231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 4, 0, 0),
  [1233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 5, 0, 69),
  [1235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 5, 0, 69),
  [1237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 5, 0, 70),
  [1239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 5, 0, 70),
  [1241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 5, 0, 71),
  [1243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 5, 0, 71),
  [1245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 6, 0, 0),
  [1247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 6, 0, 0),
  [1249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 6, 0, 81),
  [1251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 6, 0, 81),
  [1253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 6, 0, 82),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 6, 0, 82),
  [1257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 6, 0, 83),
  [1259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 6, 0, 83),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [1263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 6, 0, 84),
  [1265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 6, 0, 84),
  [1267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 7, 0, 87),
  [1269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 7, 0, 87),
  [1271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 7, 0, 0),
  [1273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 7, 0, 0),
  [1275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 7, 0, 88),
  [1277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 7, 0, 88),
  [1279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 7, 0, 89),
  [1281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 7, 0, 89),
  [1283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 8, 0, 92),
  [1285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 8, 0, 92),
  [1287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 8, 0, 93),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 8, 0, 93),
  [1291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 8, 0, 94),
  [1293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 8, 0, 94),
  [1295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 9, 0, 96),
  [1297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 9, 0, 96),
  [1299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 9, 0, 97),
  [1301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 9, 0, 97),
  [1303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 9, 0, 98),
  [1305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 9, 0, 98),
  [1307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 9, 0, 99),
  [1309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 9, 0, 99),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [1313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 10, 0, 101),
  [1315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 10, 0, 101),
  [1317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fn_body, 10, 0, 102),
  [1319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fn_body, 10, 0, 102),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [1331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_interp, 2, 0, 0),
  [1333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_interp, 2, 0, 0),
  [1335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_fn, 2, 0, 10),
  [1337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_fn, 2, 0, 10),
  [1339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unexp, 2, 0, 11),
  [1341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unexp, 2, 0, 11),
  [1343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_interp, 3, 0, 0),
  [1345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_interp, 3, 0, 0),
  [1347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binexp, 3, 0, 25),
  [1349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binexp, 3, 0, 25),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [1353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast, 3, 0, 27),
  [1355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast, 3, 0, 27),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2684),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [1397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3631),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2686),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2687),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [1405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2732),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2576),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [1421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [1423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [1427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [1449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [1459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [1489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_stmt, 3, 0, 16),
  [1491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_stmt, 3, 0, 16),
  [1493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_stmt, 3, 0, 22),
  [1495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_stmt, 3, 0, 22),
  [1497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_stmt, 4, 0, 35),
  [1499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_stmt, 4, 0, 35),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [1529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2926),
  [1535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [1539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1708),
  [1551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1709),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [1561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [1563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [1571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [1601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ret_stmt, 1, 0, 0),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [1609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [1617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [1623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [1641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [1645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [1653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [1655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2930),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [1669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [1675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [1683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [1685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2981),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [1691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [1701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [1703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [1705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [1709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [1711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3011),
  [1713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [1715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [1717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [1727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [1735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2918),
  [1739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [1743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [1755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2575),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2946),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [1771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [1775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [1789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [1791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2920),
  [1795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [1797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [1805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [1811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [1813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [1823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [1831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [1833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [1837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [1839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [1841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [1843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2960),
  [1847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [1849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [1853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [1855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [1857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [1859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [1867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [1879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3637),
  [1881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [1885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2645),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [1891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3412),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [1897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3651),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3660),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3628),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3534),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [1943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3646),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3424),
  [1949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3640),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [1967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3655),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [1977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3657),
  [1979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [1987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3649),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [1997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3598),
  [1999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1528),
  [2001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1699),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3622),
  [2015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [2023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3659),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [2031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3643),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1524),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [2055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3634),
  [2057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [2065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3610),
  [2067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2791),
  [2069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2792),
  [2071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [2073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [2081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3653),
  [2083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [2087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3286),
  [2089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3509),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [2097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3234),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [2103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3146),
  [2105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [2107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3191),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3380),
  [2117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [2119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [2121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [2127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3193),
  [2129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2689),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3539),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [2141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [2147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [2155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [2161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [2163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [2173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2690),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [2183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [2189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [2193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [2195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [2203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3531),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3443),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [2211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1721),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [2217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3480),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [2229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [2235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [2243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3689),
  [2245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [2247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [2251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [2253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [2255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [2257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [2259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [2261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [2269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [2271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3307),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [2277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [2279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3560),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [2291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [2301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [2303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3145),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [2311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [2313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3462),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [2323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [2337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [2343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [2349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [2357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [2359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3275),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [2371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [2381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [2383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [2389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [2391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [2397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bindinglist, 1, 0, 0),
  [2399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bindinglist, 1, 0, 0),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [2403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [2405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [2407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3718),
  [2409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [2411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binding, 1, 0, 1),
  [2413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binding, 1, 0, 1),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [2417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bindinglist, 2, 0, 0),
  [2419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bindinglist, 2, 0, 0),
  [2421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_bindinglist_repeat1, 2, 0, 0),
  [2423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bindinglist_repeat1, 2, 0, 0),
  [2425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bindinglist_repeat1, 2, 0, 0), SHIFT_REPEAT(3045),
  [2428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__explist, 2, 0, 0),
  [2430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__explist, 2, 0, 0),
  [2432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__explist_repeat1, 2, 0, 0), SHIFT_REPEAT(847),
  [2435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [2437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [2443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [2451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binding, 3, 0, 29),
  [2453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binding, 3, 0, 29),
  [2455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [2467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [2479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [2489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [2491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [2501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [2503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [2505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [2507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [2509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [2511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [2519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bindinglist_repeat1, 2, 0, 0), SHIFT_REPEAT(3085),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [2524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [2528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [2530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [2534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [2536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bindinglist_repeat1, 2, 0, 0), SHIFT_REPEAT(3073),
  [2539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [2545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_var_stmt, 2, 0, 0),
  [2547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_var_stmt, 2, 0, 0),
  [2549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [2551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [2553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bindinglist_repeat1, 2, 0, 0), SHIFT_REPEAT(3120),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [2558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [2570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [2578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [2580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [2582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [2584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [2586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [2588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [2590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn_stmt, 3, 0, 14),
  [2592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn_stmt, 3, 0, 14),
  [2594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_stmt, 3, 0, 15),
  [2596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_stmt, 3, 0, 15),
  [2598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_stmt, 3, 0, 17),
  [2600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_stmt, 3, 0, 17),
  [2602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assign_stmt, 3, 0, 20),
  [2604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assign_stmt, 3, 0, 20),
  [2606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__explist_repeat1, 2, 0, 0), SHIFT_REPEAT(797),
  [2609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_fn_stmt, 4, 0, 28),
  [2611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_fn_stmt, 4, 0, 28),
  [2613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_var_stmt, 4, 0, 30),
  [2615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_var_stmt, 4, 0, 30),
  [2617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn_stmt, 4, 0, 31),
  [2619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn_stmt, 4, 0, 31),
  [2621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_stmt, 4, 0, 33),
  [2623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_stmt, 4, 0, 33),
  [2625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_stmt, 4, 0, 33),
  [2627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_stmt, 4, 0, 33),
  [2629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn_stmt, 4, 0, 28),
  [2631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn_stmt, 4, 0, 28),
  [2633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_stmt, 5, 0, 45),
  [2635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_stmt, 5, 0, 45),
  [2637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_stmt, 5, 0, 46),
  [2639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_stmt, 5, 0, 46),
  [2641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_stmt, 5, 0, 47),
  [2643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_stmt, 5, 0, 47),
  [2645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_stmt, 5, 0, 49),
  [2647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_stmt, 5, 0, 49),
  [2649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_stmt, 5, 0, 50),
  [2651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_stmt, 5, 0, 50),
  [2653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_fn_stmt, 5, 0, 51),
  [2655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_fn_stmt, 5, 0, 51),
  [2657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_assign, 3, 0, 52),
  [2659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_assign, 3, 0, 52),
  [2661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_fn_stmt, 5, 0, 51),
  [2663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_fn_stmt, 5, 0, 51),
  [2665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn_stmt, 5, 0, 54),
  [2667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn_stmt, 5, 0, 54),
  [2669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_stmt, 6, 0, 65),
  [2671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_stmt, 6, 0, 65),
  [2673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_stmt, 6, 0, 66),
  [2675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_stmt, 6, 0, 66),
  [2677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_stmt, 6, 0, 67),
  [2679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_stmt, 6, 0, 67),
  [2681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_stmt, 6, 0, 68),
  [2683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_stmt, 6, 0, 68),
  [2685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_stmt, 7, 0, 76),
  [2687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_stmt, 7, 0, 76),
  [2689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_stmt, 7, 0, 77),
  [2691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_stmt, 7, 0, 77),
  [2693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_fn_stmt, 7, 0, 78),
  [2695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_fn_stmt, 7, 0, 78),
  [2697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_range_stmt, 8, 0, 85),
  [2699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_range_stmt, 8, 0, 85),
  [2701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_assign, 6, 0, 86),
  [2703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_assign, 6, 0, 86),
  [2705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_range_stmt, 9, 0, 91),
  [2707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_range_stmt, 9, 0, 91),
  [2709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_range_stmt, 10, 0, 95),
  [2711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_range_stmt, 10, 0, 95),
  [2713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_range_stmt, 11, 0, 100),
  [2715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_range_stmt, 11, 0, 100),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [2719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [2725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [2731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [2739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 5, 0, 73),
  [2741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_stmt, 1, 0, 0),
  [2743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_stmt, 1, 0, 0),
  [2745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 1, 0, 0),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [2749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 1, 0, 0),
  [2751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__explist_repeat1, 2, 0, 0), SHIFT_REPEAT(831),
  [2754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_stmt, 2, 0, 0),
  [2756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_stmt, 2, 0, 0),
  [2758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 1, 0, 12),
  [2760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__explist_repeat1, 2, 0, 0), SHIFT_REPEAT(820),
  [2763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 3, 0, 38),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ifexp_elseif, 4, 0, 0),
  [2785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ifexp_elseif, 4, 0, 0),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [2791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [2801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [2809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [2821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [2837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3523),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [2847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [2849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [2991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__varlist, 1, 0, 0),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [2997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3461),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [3005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assign, 1, 0, 0),
  [3007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assign, 1, 0, 0),
  [3009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__litfieldlist, 2, 0, 0),
  [3011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__litfieldlist, 3, 0, 0),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [3051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interp_repeat1, 2, 0, 0), SHIFT_REPEAT(2721),
  [3054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interp_repeat1, 2, 0, 0), SHIFT_REPEAT(882),
  [3057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_interp_repeat1, 2, 0, 0),
  [3059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interp_repeat1, 2, 0, 0), SHIFT_REPEAT(2699),
  [3062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interp_repeat1, 2, 0, 0), SHIFT_REPEAT(3595),
  [3065] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interp_repeat1, 2, 0, 0), SHIFT_REPEAT(3476),
  [3068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_interp_repeat1, 2, 0, 0), SHIFT_REPEAT(3493),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [3081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [3093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [3101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3180),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [3105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readwrite, 1, 0, 0),
  [3107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readwrite, 1, 0, 0),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [3203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [3221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [3231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [3239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [3241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [3243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [3245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [3247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2837),
  [3250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [3252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2813),
  [3255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3288),
  [3258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3577),
  [3261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3662),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [3278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paramtypelist, 3, 0, 0),
  [3280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paramtypelist, 3, 0, 0),
  [3282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paramtypelist, 4, 0, 61),
  [3284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paramtypelist, 4, 0, 61),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [3294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3209),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [3306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3218),
  [3308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kvtypelist, 2, 0, 0),
  [3310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3065),
  [3312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kvtypelist, 3, 0, 0),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [3320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [3340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unicode_escape, 4, 0, 0),
  [3342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__escape_sequence, 1, 0, 0),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [3368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dec_byte_escape, 2, 0, 0),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [3386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_interp_repeat1, 1, 0, 0),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [3400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interp_exp, 3, 0, 0),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [3422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hex_byte_escape, 2, 0, 0),
  [3424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tbl_fn_member, 1, 0, 13),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [3430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [3432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [3450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__explist_repeat1, 2, 0, 0), SHIFT_REPEAT(837),
  [3453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [3455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [3457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [3459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [3467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [3469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [3471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [3473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [3475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [3477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [3479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [3481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [3483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [3485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [3489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [3491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [3493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [3495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [3497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [3499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [3501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [3503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [3505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [3509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [3511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [3513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [3515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [3517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [3519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [3523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [3529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [3531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [3533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [3535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [3537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [3539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [3547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3594),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [3553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [3575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__varlist_repeat1, 2, 0, 0),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [3583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 1, 0, 0),
  [3585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__attrlist, 2, 0, 0),
  [3587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__attrlist, 2, 0, 0), SHIFT_REPEAT(3413),
  [3590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attrlist, 2, 0, 0), SHIFT_REPEAT(2969),
  [3593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_stmt_repeat1, 2, 0, 48),
  [3595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_stmt_repeat1, 2, 0, 48), SHIFT_REPEAT(834),
  [3598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_stmt_repeat1, 2, 0, 48),
  [3600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__explist_repeat1, 2, 0, 0), SHIFT_REPEAT(884),
  [3603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [3605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [3607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3385),
  [3609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [3611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [3613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [3617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__explist_repeat1, 2, 0, 0), SHIFT_REPEAT(906),
  [3620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_kvtypelist_repeat1, 2, 0, 0), SHIFT_REPEAT(2688),
  [3623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_kvtypelist_repeat1, 2, 0, 0),
  [3625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [3627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [3629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fieldlist_repeat1, 2, 0, 0), SHIFT_REPEAT(624),
  [3632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__fieldlist_repeat1, 2, 0, 0),
  [3634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [3636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__attrlist, 1, 0, 0),
  [3638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__attrlist, 1, 0, 0),
  [3640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_littable, 3, 0, 0),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [3644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kvtypelist, 1, 0, 0),
  [3646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic, 1, 0, 0),
  [3648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [3650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__explist_repeat1, 2, 0, 0), SHIFT_REPEAT(988),
  [3653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [3655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [3657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fieldlist, 1, 0, 0),
  [3659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [3661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [3671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [3673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_littable, 2, 0, 0),
  [3675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [3679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ifexp_repeat1, 2, 0, 0), SHIFT_REPEAT(870),
  [3682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_ifexp_repeat1, 2, 0, 0),
  [3684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [3688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ret_stmt, 2, 0, 3),
  [3690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ret_stmt, 2, 0, 3),
  [3692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 0),
  [3694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 3, 0, 0),
  [3696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [3698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3316),
  [3700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [3702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3351),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [3710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 6),
  [3712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 2, 0, 6),
  [3714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bindinglist_repeat1, 2, 0, 0), SHIFT_REPEAT(3075),
  [3717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1138),
  [3720] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1339),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [3730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fntype_paramlist, 1, 0, 41),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [3734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parattrlist, 1, 0, 0),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [3738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genpackdef, 1, 0, 0),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [3744] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(2756),
  [3748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [3752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__varlist, 2, 0, 0),
  [3754] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1462),
  [3758] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1476),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [3766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paramlist, 1, 0, 0),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [3772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parattrlist, 2, 0, 0),
  [3774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3124),
  [3776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3324),
  [3778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tbtype_kv, 2, 0, 0),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [3782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [3784] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(316),
  [3788] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1872),
  [3792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [3794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [3796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__litlist, 2, 0, 0),
  [3798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3093),
  [3800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3359),
  [3802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexertype, 5, 0, 90),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [3806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fntype_paramlist, 2, 0, 62),
  [3808] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1281),
  [3812] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(373),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [3818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_stmt_genlist, 1, 0, 0),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [3822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [3824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [3826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_stmt_packlist, 1, 0, 0),
  [3828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3369),
  [3830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__genlist_repeat1, 2, 0, 0), SHIFT_REPEAT(3107),
  [3833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__genlist_repeat1, 2, 0, 0),
  [3835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__genpack_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3071),
  [3838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__genpack_list_repeat1, 2, 0, 0),
  [3840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_proptype, 3, 0, 74),
  [3842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_stmt_repeat1, 1, 0, 34),
  [3844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_stmt_repeat1, 1, 0, 34),
  [3846] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1914),
  [3850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2861),
  [3852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [3854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tbl_method, 2, 0, 7),
  [3856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_name, 2, 0, 21),
  [3858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ret_stmt, 2, 0, 0),
  [3860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ret_stmt, 2, 0, 0),
  [3862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3335),
  [3864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_typelist_repeat1, 2, 0, 62), SHIFT_REPEAT(1270),
  [3867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_typelist_repeat1, 2, 0, 62),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [3871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__explist_repeat1, 2, 0, 0), SHIFT_REPEAT(812),
  [3874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_paramlist_repeat1, 2, 0, 0), SHIFT_REPEAT(3077),
  [3877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_paramlist_repeat1, 2, 0, 0),
  [3879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [3881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__typeparamlist, 1, 0, 0),
  [3883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fntype_paramlist_repeat1, 2, 0, 62), SHIFT_REPEAT(1185),
  [3886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__fntype_paramlist_repeat1, 2, 0, 62),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [3890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [3892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__typeparamlist, 2, 0, 0),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [3896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typelist, 2, 1, 62),
  [3898] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(389),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [3906] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1831),
  [3910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3061),
  [3912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3196),
  [3914] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1659),
  [3918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__varlist_repeat1, 2, 0, 0), SHIFT_REPEAT(2667),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [3923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2892),
  [3927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_clause, 4, 0, 45),
  [3929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 4, 0, 45),
  [3931] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1558),
  [3935] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(2675),
  [3939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 2, 0, 0),
  [3941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 2, 0, 0),
  [3943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_stmt_genlist_repeat1, 2, 0, 0), SHIFT_REPEAT(2933),
  [3946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_stmt_genlist_repeat1, 2, 0, 0),
  [3948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_stmt_packlist_repeat1, 2, 0, 0), SHIFT_REPEAT(3016),
  [3951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_stmt_packlist_repeat1, 2, 0, 0),
  [3953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [3955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genericdef, 1, 0, 53),
  [3957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1, 0, 0),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [3961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__litfieldlist, 1, 0, 0),
  [3963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__litlist, 1, 0, 0),
  [3965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parattrlist_repeat1, 2, 0, 0), SHIFT_REPEAT(3041),
  [3968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parattrlist_repeat1, 2, 0, 0),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [3972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__genlist, 1, 0, 0),
  [3974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [3976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [3980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__genlist, 2, 0, 0),
  [3982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [3984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__genpack_list, 2, 0, 0),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [3988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paramlist, 2, 0, 0),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [3992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_stmt_genlist, 2, 0, 0),
  [3994] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(398),
  [3998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3103),
  [4000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3393),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [4006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ret_stmt, 3, 0, 3),
  [4008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ret_stmt, 3, 0, 3),
  [4010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__genpack_list, 1, 0, 0),
  [4012] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1572),
  [4016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 1, 0, 0),
  [4018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 1, 0, 0),
  [4020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_stmt_packlist, 2, 0, 0),
  [4022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__typeparamlist_repeat1, 2, 0, 0), SHIFT_REPEAT(886),
  [4025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__typeparamlist_repeat1, 2, 0, 0),
  [4027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__litfieldlist_repeat1, 2, 0, 0), SHIFT_REPEAT(2564),
  [4030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__litfieldlist_repeat1, 2, 0, 0),
  [4032] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1801),
  [4036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3451),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [4042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__litlist_repeat1, 2, 0, 0), SHIFT_REPEAT(2649),
  [4045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__litlist_repeat1, 2, 0, 0),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [4049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_param, 1, 0, 23),
  [4051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3403),
  [4053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tbtype_kv, 1, 0, 0),
  [4055] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 41), REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1362),
  [4059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_param, 3, 0, 56),
  [4061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tbl_fn_member, 2, 0, 32),
  [4063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [4067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41),
  [4069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1572),
  [4072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1362),
  [4075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [4077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(316),
  [4080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1558),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [4085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_litfield, 1, 0, 0),
  [4087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeparam, 1, 0, 41),
  [4089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parattr_param, 2, 0, 0),
  [4091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genericdef, 3, 0, 79),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [4097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_genpackdef, 3, 0, 80),
  [4099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [4101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1281),
  [4104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(389),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [4113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1476),
  [4116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1801),
  [4119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(2756),
  [4122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(398),
  [4125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1831),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [4130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1659),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [4135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__param_vararg, 1, 0, 0),
  [4137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fntype_param, 3, 0, 75),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [4143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__fntype_paramlist_repeat1, 2, 0, 61),
  [4145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_litfield, 3, 0, 0),
  [4147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parattr_param, 3, 0, 0),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [4151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(373),
  [4154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [4158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ifexp_repeat1, 1, 0, 0),
  [4160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_ifexp_repeat1, 1, 0, 0),
  [4162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(2675),
  [4165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_typelist_repeat1, 2, 0, 61),
  [4167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parattr_param, 1, 0, 0),
  [4169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1462),
  [4172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1914),
  [4175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parattr, 2, 0, 19),
  [4177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeparam, 1, 0, 0),
  [4179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1339),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [4184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tbl_fn_member, 2, 0, 21),
  [4186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fntype_param, 1, 0, 41), SHIFT(1872),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [4195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [4217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paramlist, 4, 0, 72),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [4225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [4231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_stmt_genlist, 4, 0, 0),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [4285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [4289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__genlist, 3, 0, 0),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [4295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fntype_paramlist_vrd, 1, 0, 0),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [4313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [4315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [4319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [4321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [4323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [4325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [4327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [4329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [4331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [4335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [4337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [4343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 1, 0, 0),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [4347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [4357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [4359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [4361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [4367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paramlist, 1, 0, 24),
  [4369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [4377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [4381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [4383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [4385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [4391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [4393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [4395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [4397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [4401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typelist, 4, 1, 62),
  [4403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [4429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [4437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [4439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [4443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [4451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typelist, 1, 1, 0),
  [4453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__typelist_vrd, 1, 1, 0), REDUCE(sym__typepack_vrd, 1, 0, 0),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [4494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fntype_paramlist, 1, 0, 0),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [4514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [4528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [4532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [4544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [4588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [4592] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [4594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [4596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [4598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_type, 2, 0, 60),
  [4600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 15),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [4604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [4610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paramlist, 3, 0, 57),
  [4612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [4626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__param_vararg, 3, 0, 58),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [4646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [4662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fntype_paramlist, 3, 0, 41),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [4726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [4728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [4736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [4792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_stmt_genlist, 3, 0, 0),
  [4794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [4828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [4832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [4834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [4836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [4838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [4840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [4844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [4846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [4848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [4850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [4852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [4854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [4856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [4858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [4860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [4862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [4866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [4868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [4870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [4874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [4876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [4878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [4880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [4882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [4884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [4886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [4888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [4890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [4892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [4894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [4896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [4898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [4900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [4902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [4904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [4908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2744),
  [4910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [4912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [4914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [4916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [4920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fieldlist, 4, 0, 0),
  [4922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [4924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [4926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [4928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [4934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [4938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [4940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [4944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [4946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [4950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [4954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [4960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fntype_gen, 3, 0, 0),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [4968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [4972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [4984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [4988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [4992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typelist, 3, 1, 41),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3604),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [5000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [5006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [5022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [5024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [5026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [5030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [5032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [5034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [5038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__typelist_vrd, 1, 1, 0),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [5042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [5044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [5046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [5048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [5050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [5052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [5054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [5056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [5058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [5060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [5064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [5066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [5068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [5070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [5072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [5074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [5076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [5078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [5080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [5082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [5084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [5086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [5088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [5090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [5092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [5094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [5096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [5098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [5100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [5102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [5104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [5106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [5108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [5112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [5114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [5118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [5120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [5122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [5128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [5130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [5132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [5140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [5142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fntype_paramlist, 4, 0, 62),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [5146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [5148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [5150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [5152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [5154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [5158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__genlist, 4, 0, 0),
  [5160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [5162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [5164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [5166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [5170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [5172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [5174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [5176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [5182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [5186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [5188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [5190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [5196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [5198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [5200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [5204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [5206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [5208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [5212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [5216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [5218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [5224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [5228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [5230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [5232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [5236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [5246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_type, 1, 0, 39),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [5264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [5268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tbtype_content, 1, 0, 40),
  [5270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [5276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tbtype_content, 1, 0, 0),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [5290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [5294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [5304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [5306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [5310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [5312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [5314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [5316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [5318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [5320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [5322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [5324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [5326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [5328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [5330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [5332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [5334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [5336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [5338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [5340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [5342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [5344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [5348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [5350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 2, 0, 0),
  [5352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 3, 0, 0),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_true = 0,
  ts_external_token_or = 1,
  ts_external_token_not = 2,
  ts_external_token_then = 3,
  ts_external_token_break = 4,
  ts_external_token_nil = 5,
  ts_external_token_if = 6,
  ts_external_token_else = 7,
  ts_external_token_false = 8,
  ts_external_token_return = 9,
  ts_external_token_while = 10,
  ts_external_token_in = 11,
  ts_external_token_repeat = 12,
  ts_external_token_elseif = 13,
  ts_external_token_function = 14,
  ts_external_token_end = 15,
  ts_external_token_for = 16,
  ts_external_token_until = 17,
  ts_external_token_local = 18,
  ts_external_token_do = 19,
  ts_external_token_and = 20,
  ts_external_token__comment_start = 21,
  ts_external_token__comment_content = 22,
  ts_external_token__comment_end = 23,
  ts_external_token__string_start = 24,
  ts_external_token__string_content = 25,
  ts_external_token__string_end = 26,
  ts_external_token_interp_start = 27,
  ts_external_token_interp_content = 28,
  ts_external_token_interp_brace_open = 29,
  ts_external_token_interp_brace_close = 30,
  ts_external_token_interp_end = 31,
  ts_external_token_simple_escape = 32,
  ts_external_token__unicode_escape_sequence = 33,
  ts_external_token__dec_byte_escape_sequence = 34,
  ts_external_token__hex_byte_escape_sequence = 35,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_true] = anon_sym_true,
  [ts_external_token_or] = anon_sym_or,
  [ts_external_token_not] = anon_sym_not,
  [ts_external_token_then] = anon_sym_then,
  [ts_external_token_break] = anon_sym_break,
  [ts_external_token_nil] = anon_sym_nil,
  [ts_external_token_if] = anon_sym_if,
  [ts_external_token_else] = anon_sym_else,
  [ts_external_token_false] = anon_sym_false,
  [ts_external_token_return] = anon_sym_return,
  [ts_external_token_while] = anon_sym_while,
  [ts_external_token_in] = anon_sym_in,
  [ts_external_token_repeat] = anon_sym_repeat,
  [ts_external_token_elseif] = anon_sym_elseif,
  [ts_external_token_function] = anon_sym_function,
  [ts_external_token_end] = anon_sym_end,
  [ts_external_token_for] = anon_sym_for,
  [ts_external_token_until] = anon_sym_until,
  [ts_external_token_local] = anon_sym_local,
  [ts_external_token_do] = anon_sym_do,
  [ts_external_token_and] = anon_sym_and,
  [ts_external_token__comment_start] = sym__comment_start,
  [ts_external_token__comment_content] = sym__comment_content,
  [ts_external_token__comment_end] = sym__comment_end,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__string_end] = sym__string_end,
  [ts_external_token_interp_start] = sym_interp_start,
  [ts_external_token_interp_content] = sym_interp_content,
  [ts_external_token_interp_brace_open] = sym_interp_brace_open,
  [ts_external_token_interp_brace_close] = sym_interp_brace_close,
  [ts_external_token_interp_end] = sym_interp_end,
  [ts_external_token_simple_escape] = sym_simple_escape,
  [ts_external_token__unicode_escape_sequence] = sym__unicode_escape_sequence,
  [ts_external_token__dec_byte_escape_sequence] = sym__dec_byte_escape_sequence,
  [ts_external_token__hex_byte_escape_sequence] = sym__hex_byte_escape_sequence,
};

static const bool ts_external_scanner_states[53][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_true] = true,
    [ts_external_token_or] = true,
    [ts_external_token_not] = true,
    [ts_external_token_then] = true,
    [ts_external_token_break] = true,
    [ts_external_token_nil] = true,
    [ts_external_token_if] = true,
    [ts_external_token_else] = true,
    [ts_external_token_false] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_in] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_elseif] = true,
    [ts_external_token_function] = true,
    [ts_external_token_end] = true,
    [ts_external_token_for] = true,
    [ts_external_token_until] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__comment_content] = true,
    [ts_external_token__comment_end] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token_interp_start] = true,
    [ts_external_token_interp_content] = true,
    [ts_external_token_interp_brace_open] = true,
    [ts_external_token_interp_brace_close] = true,
    [ts_external_token_interp_end] = true,
    [ts_external_token_simple_escape] = true,
    [ts_external_token__unicode_escape_sequence] = true,
    [ts_external_token__dec_byte_escape_sequence] = true,
    [ts_external_token__hex_byte_escape_sequence] = true,
  },
  [2] = {
    [ts_external_token_break] = true,
    [ts_external_token_if] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_function] = true,
    [ts_external_token_for] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token__comment_start] = true,
  },
  [3] = {
    [ts_external_token_break] = true,
    [ts_external_token_if] = true,
    [ts_external_token_else] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_elseif] = true,
    [ts_external_token_function] = true,
    [ts_external_token_end] = true,
    [ts_external_token_for] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token__comment_start] = true,
  },
  [4] = {
    [ts_external_token_break] = true,
    [ts_external_token_if] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_function] = true,
    [ts_external_token_end] = true,
    [ts_external_token_for] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token__comment_start] = true,
  },
  [5] = {
    [ts_external_token_break] = true,
    [ts_external_token_if] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_function] = true,
    [ts_external_token_for] = true,
    [ts_external_token_until] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token__comment_start] = true,
  },
  [6] = {
    [ts_external_token_or] = true,
    [ts_external_token_break] = true,
    [ts_external_token_if] = true,
    [ts_external_token_else] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_elseif] = true,
    [ts_external_token_function] = true,
    [ts_external_token_end] = true,
    [ts_external_token_for] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [7] = {
    [ts_external_token_or] = true,
    [ts_external_token_break] = true,
    [ts_external_token_if] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_function] = true,
    [ts_external_token_for] = true,
    [ts_external_token_until] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [8] = {
    [ts_external_token_or] = true,
    [ts_external_token_break] = true,
    [ts_external_token_if] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_function] = true,
    [ts_external_token_for] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [9] = {
    [ts_external_token_or] = true,
    [ts_external_token_break] = true,
    [ts_external_token_if] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_function] = true,
    [ts_external_token_end] = true,
    [ts_external_token_for] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [10] = {
    [ts_external_token_or] = true,
    [ts_external_token_break] = true,
    [ts_external_token_if] = true,
    [ts_external_token_else] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_elseif] = true,
    [ts_external_token_function] = true,
    [ts_external_token_end] = true,
    [ts_external_token_for] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
  },
  [11] = {
    [ts_external_token_or] = true,
    [ts_external_token_break] = true,
    [ts_external_token_if] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_function] = true,
    [ts_external_token_for] = true,
    [ts_external_token_until] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
  },
  [12] = {
    [ts_external_token_or] = true,
    [ts_external_token_break] = true,
    [ts_external_token_if] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_function] = true,
    [ts_external_token_for] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
  },
  [13] = {
    [ts_external_token_or] = true,
    [ts_external_token_break] = true,
    [ts_external_token_if] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_function] = true,
    [ts_external_token_end] = true,
    [ts_external_token_for] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
  },
  [14] = {
    [ts_external_token_true] = true,
    [ts_external_token_not] = true,
    [ts_external_token_nil] = true,
    [ts_external_token_if] = true,
    [ts_external_token_else] = true,
    [ts_external_token_false] = true,
    [ts_external_token_elseif] = true,
    [ts_external_token_function] = true,
    [ts_external_token_end] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token_interp_start] = true,
  },
  [15] = {
    [ts_external_token_true] = true,
    [ts_external_token_not] = true,
    [ts_external_token_nil] = true,
    [ts_external_token_if] = true,
    [ts_external_token_false] = true,
    [ts_external_token_function] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token_interp_start] = true,
  },
  [16] = {
    [ts_external_token_true] = true,
    [ts_external_token_nil] = true,
    [ts_external_token_false] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [17] = {
    [ts_external_token_true] = true,
    [ts_external_token_not] = true,
    [ts_external_token_nil] = true,
    [ts_external_token_if] = true,
    [ts_external_token_false] = true,
    [ts_external_token_function] = true,
    [ts_external_token_end] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token_interp_start] = true,
  },
  [18] = {
    [ts_external_token_true] = true,
    [ts_external_token_not] = true,
    [ts_external_token_nil] = true,
    [ts_external_token_if] = true,
    [ts_external_token_false] = true,
    [ts_external_token_function] = true,
    [ts_external_token_until] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token_interp_start] = true,
  },
  [19] = {
    [ts_external_token_or] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [20] = {
    [ts_external_token_or] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elseif] = true,
    [ts_external_token_end] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [21] = {
    [ts_external_token_or] = true,
    [ts_external_token_until] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [22] = {
    [ts_external_token_or] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
  },
  [23] = {
    [ts_external_token_or] = true,
    [ts_external_token_end] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [24] = {
    [ts_external_token_or] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elseif] = true,
    [ts_external_token_end] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
  },
  [25] = {
    [ts_external_token_or] = true,
    [ts_external_token_do] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [26] = {
    [ts_external_token_break] = true,
    [ts_external_token_if] = true,
    [ts_external_token_else] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_elseif] = true,
    [ts_external_token_function] = true,
    [ts_external_token_end] = true,
    [ts_external_token_for] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [27] = {
    [ts_external_token_or] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elseif] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [28] = {
    [ts_external_token_or] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token_interp_brace_close] = true,
  },
  [29] = {
    [ts_external_token_or] = true,
    [ts_external_token_then] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [30] = {
    [ts_external_token_or] = true,
    [ts_external_token_end] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
  },
  [31] = {
    [ts_external_token_or] = true,
    [ts_external_token_until] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
  },
  [32] = {
    [ts_external_token_break] = true,
    [ts_external_token_if] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_function] = true,
    [ts_external_token_for] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [33] = {
    [ts_external_token_break] = true,
    [ts_external_token_if] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_function] = true,
    [ts_external_token_end] = true,
    [ts_external_token_for] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [34] = {
    [ts_external_token_break] = true,
    [ts_external_token_if] = true,
    [ts_external_token_return] = true,
    [ts_external_token_while] = true,
    [ts_external_token_repeat] = true,
    [ts_external_token_function] = true,
    [ts_external_token_for] = true,
    [ts_external_token_until] = true,
    [ts_external_token_local] = true,
    [ts_external_token_do] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [35] = {
    [ts_external_token_or] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elseif] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
  },
  [36] = {
    [ts_external_token_or] = true,
    [ts_external_token_do] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
  },
  [37] = {
    [ts_external_token_or] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
    [ts_external_token_interp_brace_close] = true,
  },
  [38] = {
    [ts_external_token_or] = true,
    [ts_external_token_then] = true,
    [ts_external_token_and] = true,
    [ts_external_token__comment_start] = true,
  },
  [39] = {
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [40] = {
    [ts_external_token__comment_start] = true,
    [ts_external_token_interp_content] = true,
    [ts_external_token_interp_brace_open] = true,
    [ts_external_token_interp_end] = true,
    [ts_external_token_simple_escape] = true,
    [ts_external_token__unicode_escape_sequence] = true,
    [ts_external_token__dec_byte_escape_sequence] = true,
    [ts_external_token__hex_byte_escape_sequence] = true,
  },
  [41] = {
    [ts_external_token__comment_start] = true,
  },
  [42] = {
    [ts_external_token__comment_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token_simple_escape] = true,
    [ts_external_token__unicode_escape_sequence] = true,
    [ts_external_token__dec_byte_escape_sequence] = true,
    [ts_external_token__hex_byte_escape_sequence] = true,
  },
  [43] = {
    [ts_external_token_in] = true,
    [ts_external_token__comment_start] = true,
  },
  [44] = {
    [ts_external_token_else] = true,
    [ts_external_token_elseif] = true,
    [ts_external_token_end] = true,
    [ts_external_token__comment_start] = true,
  },
  [45] = {
    [ts_external_token_function] = true,
    [ts_external_token_local] = true,
    [ts_external_token__comment_start] = true,
  },
  [46] = {
    [ts_external_token_else] = true,
    [ts_external_token_elseif] = true,
    [ts_external_token__comment_start] = true,
  },
  [47] = {
    [ts_external_token_function] = true,
    [ts_external_token__comment_start] = true,
  },
  [48] = {
    [ts_external_token_until] = true,
    [ts_external_token__comment_start] = true,
  },
  [49] = {
    [ts_external_token_end] = true,
    [ts_external_token__comment_start] = true,
  },
  [50] = {
    [ts_external_token_do] = true,
    [ts_external_token__comment_start] = true,
  },
  [51] = {
    [ts_external_token__comment_start] = true,
    [ts_external_token__comment_content] = true,
    [ts_external_token__comment_end] = true,
  },
  [52] = {
    [ts_external_token__comment_start] = true,
    [ts_external_token__comment_end] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_luau_external_scanner_create(void);
void tree_sitter_luau_external_scanner_destroy(void *);
bool tree_sitter_luau_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_luau_external_scanner_serialize(void *, char *);
void tree_sitter_luau_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_luau(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_name,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_luau_external_scanner_create,
      tree_sitter_luau_external_scanner_destroy,
      tree_sitter_luau_external_scanner_scan,
      tree_sitter_luau_external_scanner_serialize,
      tree_sitter_luau_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
